#include "stdafx.h"
#include "Reimpl/Interfaces.h"
#include "static_bases.gen.h"
#include "Misc/Config.h"
#include "GVRCompositor.gen.h"
// Single inst of BaseCompositor
static std::weak_ptr<BaseCompositor> _single_inst_Compositor;
static BaseCompositor *_single_inst_Compositor_unsafe = NULL;
std::shared_ptr<BaseCompositor> GetBaseCompositor() { return _single_inst_Compositor.lock(); };
BaseCompositor* GetUnsafeBaseCompositor() { return _single_inst_Compositor_unsafe; };
std::shared_ptr<BaseCompositor> GetCreateBaseCompositor() {
	std::shared_ptr<BaseCompositor> ret = _single_inst_Compositor.lock();
	if(!ret) {
		ret = std::shared_ptr<BaseCompositor>(new BaseCompositor(), [](BaseCompositor *obj){ _single_inst_Compositor_unsafe = NULL; delete obj; });
		_single_inst_Compositor = ret;
		_single_inst_Compositor_unsafe = ret.get();
	}
	return ret;
}
// Misc for CVRCompositor_009:
CVRCompositor_009::CVRCompositor_009() : base(GetCreateBaseCompositor()) {}
// Interface methods for CVRCompositor_009:
void CVRCompositor_009::SetTrackingSpace(vr::ETrackingUniverseOrigin eOrigin) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_009)");
	return base->SetTrackingSpace(eOrigin);
}
vr::ETrackingUniverseOrigin CVRCompositor_009::GetTrackingSpace() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_009)");
	return base->GetTrackingSpace();
}
vr::IVRCompositor_009::EVRCompositorError CVRCompositor_009::WaitGetPoses(vr::TrackedDevicePose_t* pRenderPoseArray, uint32_t unRenderPoseArrayCount, vr::TrackedDevicePose_t* pGamePoseArray, uint32_t unGamePoseArrayCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_009)");
	return (vr::IVRCompositor_009::EVRCompositorError) base->WaitGetPoses(pRenderPoseArray, unRenderPoseArrayCount, pGamePoseArray, unGamePoseArrayCount);
}
vr::IVRCompositor_009::EVRCompositorError CVRCompositor_009::GetLastPoses(vr::TrackedDevicePose_t* pRenderPoseArray, uint32_t unRenderPoseArrayCount, vr::TrackedDevicePose_t* pGamePoseArray, uint32_t unGamePoseArrayCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_009)");
	return (vr::IVRCompositor_009::EVRCompositorError) base->GetLastPoses(pRenderPoseArray, unRenderPoseArrayCount, pGamePoseArray, unGamePoseArrayCount);
}
vr::IVRCompositor_009::EVRCompositorError CVRCompositor_009::Submit(vr::EVREye eEye, const vr::Texture_t* pTexture, const vr::VRTextureBounds_t* pBounds, vr::EVRSubmitFlags nSubmitFlags) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_009)");
	return (vr::IVRCompositor_009::EVRCompositorError) base->Submit(eEye, pTexture, pBounds, nSubmitFlags);
}
void CVRCompositor_009::ClearLastSubmittedFrame() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_009)");
	return base->ClearLastSubmittedFrame();
}
void CVRCompositor_009::PostPresentHandoff() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_009)");
	return base->PostPresentHandoff();
}
bool CVRCompositor_009::GetFrameTiming(vr::IVRCompositor_009::Compositor_FrameTiming* pTiming, uint32_t unFramesAgo) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_009)");
	return base->GetFrameTiming((OOVR_Compositor_FrameTiming*) pTiming, unFramesAgo);
}
float CVRCompositor_009::GetFrameTimeRemaining() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_009)");
	return base->GetFrameTimeRemaining();
}
void CVRCompositor_009::FadeToColor(float fSeconds, float fRed, float fGreen, float fBlue, float fAlpha, bool bBackground) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_009)");
	return base->FadeToColor(fSeconds, fRed, fGreen, fBlue, fAlpha, bBackground);
}
void CVRCompositor_009::FadeGrid(float fSeconds, bool bFadeIn) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_009)");
	return base->FadeGrid(fSeconds, bFadeIn);
}
vr::IVRCompositor_009::EVRCompositorError CVRCompositor_009::SetSkyboxOverride(const vr::Texture_t* pTextures, uint32_t unTextureCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_009)");
	return (vr::IVRCompositor_009::EVRCompositorError) base->SetSkyboxOverride(pTextures, unTextureCount);
}
void CVRCompositor_009::ClearSkyboxOverride() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_009)");
	return base->ClearSkyboxOverride();
}
void CVRCompositor_009::CompositorBringToFront() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_009)");
	return base->CompositorBringToFront();
}
void CVRCompositor_009::CompositorGoToBack() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_009)");
	return base->CompositorGoToBack();
}
void CVRCompositor_009::CompositorQuit() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_009)");
	return base->CompositorQuit();
}
bool CVRCompositor_009::IsFullscreen() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_009)");
	return base->IsFullscreen();
}
uint32_t CVRCompositor_009::GetCurrentSceneFocusProcess() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_009)");
	return base->GetCurrentSceneFocusProcess();
}
uint32_t CVRCompositor_009::GetLastFrameRenderer() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_009)");
	return base->GetLastFrameRenderer();
}
bool CVRCompositor_009::CanRenderScene() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_009)");
	return base->CanRenderScene();
}
void CVRCompositor_009::ShowMirrorWindow() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_009)");
	return base->ShowMirrorWindow();
}
void CVRCompositor_009::HideMirrorWindow() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_009)");
	return base->HideMirrorWindow();
}
bool CVRCompositor_009::IsMirrorWindowVisible() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_009)");
	return base->IsMirrorWindowVisible();
}
void CVRCompositor_009::CompositorDumpImages() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_009)");
	return base->CompositorDumpImages();
}
// FnTable for CVRCompositor_009:
static CVRCompositor_009 *fntable_Compositor_009_instance = NULL;
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_009_impl_SetTrackingSpace(vr::ETrackingUniverseOrigin eOrigin) { return fntable_Compositor_009_instance->SetTrackingSpace(eOrigin); }
static vr::ETrackingUniverseOrigin OPENVR_FNTABLE_CALLTYPE fntable_Compositor_009_impl_GetTrackingSpace() { return fntable_Compositor_009_instance->GetTrackingSpace(); }
static vr::IVRCompositor_009::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_009_impl_WaitGetPoses(vr::TrackedDevicePose_t* pRenderPoseArray, uint32_t unRenderPoseArrayCount, vr::TrackedDevicePose_t* pGamePoseArray, uint32_t unGamePoseArrayCount) { return fntable_Compositor_009_instance->WaitGetPoses(pRenderPoseArray, unRenderPoseArrayCount, pGamePoseArray, unGamePoseArrayCount); }
static vr::IVRCompositor_009::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_009_impl_GetLastPoses(vr::TrackedDevicePose_t* pRenderPoseArray, uint32_t unRenderPoseArrayCount, vr::TrackedDevicePose_t* pGamePoseArray, uint32_t unGamePoseArrayCount) { return fntable_Compositor_009_instance->GetLastPoses(pRenderPoseArray, unRenderPoseArrayCount, pGamePoseArray, unGamePoseArrayCount); }
static vr::IVRCompositor_009::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_009_impl_Submit(vr::EVREye eEye, const vr::Texture_t* pTexture, const vr::VRTextureBounds_t* pBounds, vr::EVRSubmitFlags nSubmitFlags) { return fntable_Compositor_009_instance->Submit(eEye, pTexture, pBounds, nSubmitFlags); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_009_impl_ClearLastSubmittedFrame() { return fntable_Compositor_009_instance->ClearLastSubmittedFrame(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_009_impl_PostPresentHandoff() { return fntable_Compositor_009_instance->PostPresentHandoff(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_009_impl_GetFrameTiming(vr::IVRCompositor_009::Compositor_FrameTiming* pTiming, uint32_t unFramesAgo) { return fntable_Compositor_009_instance->GetFrameTiming(pTiming, unFramesAgo); }
static float OPENVR_FNTABLE_CALLTYPE fntable_Compositor_009_impl_GetFrameTimeRemaining() { return fntable_Compositor_009_instance->GetFrameTimeRemaining(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_009_impl_FadeToColor(float fSeconds, float fRed, float fGreen, float fBlue, float fAlpha, bool bBackground) { return fntable_Compositor_009_instance->FadeToColor(fSeconds, fRed, fGreen, fBlue, fAlpha, bBackground); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_009_impl_FadeGrid(float fSeconds, bool bFadeIn) { return fntable_Compositor_009_instance->FadeGrid(fSeconds, bFadeIn); }
static vr::IVRCompositor_009::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_009_impl_SetSkyboxOverride(const vr::Texture_t* pTextures, uint32_t unTextureCount) { return fntable_Compositor_009_instance->SetSkyboxOverride(pTextures, unTextureCount); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_009_impl_ClearSkyboxOverride() { return fntable_Compositor_009_instance->ClearSkyboxOverride(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_009_impl_CompositorBringToFront() { return fntable_Compositor_009_instance->CompositorBringToFront(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_009_impl_CompositorGoToBack() { return fntable_Compositor_009_instance->CompositorGoToBack(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_009_impl_CompositorQuit() { return fntable_Compositor_009_instance->CompositorQuit(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_009_impl_IsFullscreen() { return fntable_Compositor_009_instance->IsFullscreen(); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Compositor_009_impl_GetCurrentSceneFocusProcess() { return fntable_Compositor_009_instance->GetCurrentSceneFocusProcess(); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Compositor_009_impl_GetLastFrameRenderer() { return fntable_Compositor_009_instance->GetLastFrameRenderer(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_009_impl_CanRenderScene() { return fntable_Compositor_009_instance->CanRenderScene(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_009_impl_ShowMirrorWindow() { return fntable_Compositor_009_instance->ShowMirrorWindow(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_009_impl_HideMirrorWindow() { return fntable_Compositor_009_instance->HideMirrorWindow(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_009_impl_IsMirrorWindowVisible() { return fntable_Compositor_009_instance->IsMirrorWindowVisible(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_009_impl_CompositorDumpImages() { return fntable_Compositor_009_instance->CompositorDumpImages(); }
static void *fntable_Compositor_009_funcs[] = {
	(void*) fntable_Compositor_009_impl_SetTrackingSpace,
	(void*) fntable_Compositor_009_impl_GetTrackingSpace,
	(void*) fntable_Compositor_009_impl_WaitGetPoses,
	(void*) fntable_Compositor_009_impl_GetLastPoses,
	(void*) fntable_Compositor_009_impl_Submit,
	(void*) fntable_Compositor_009_impl_ClearLastSubmittedFrame,
	(void*) fntable_Compositor_009_impl_PostPresentHandoff,
	(void*) fntable_Compositor_009_impl_GetFrameTiming,
	(void*) fntable_Compositor_009_impl_GetFrameTimeRemaining,
	(void*) fntable_Compositor_009_impl_FadeToColor,
	(void*) fntable_Compositor_009_impl_FadeGrid,
	(void*) fntable_Compositor_009_impl_SetSkyboxOverride,
	(void*) fntable_Compositor_009_impl_ClearSkyboxOverride,
	(void*) fntable_Compositor_009_impl_CompositorBringToFront,
	(void*) fntable_Compositor_009_impl_CompositorGoToBack,
	(void*) fntable_Compositor_009_impl_CompositorQuit,
	(void*) fntable_Compositor_009_impl_IsFullscreen,
	(void*) fntable_Compositor_009_impl_GetCurrentSceneFocusProcess,
	(void*) fntable_Compositor_009_impl_GetLastFrameRenderer,
	(void*) fntable_Compositor_009_impl_CanRenderScene,
	(void*) fntable_Compositor_009_impl_ShowMirrorWindow,
	(void*) fntable_Compositor_009_impl_HideMirrorWindow,
	(void*) fntable_Compositor_009_impl_IsMirrorWindowVisible,
	(void*) fntable_Compositor_009_impl_CompositorDumpImages,
};
void** CVRCompositor_009::_GetStatFuncList() { fntable_Compositor_009_instance = this; return fntable_Compositor_009_funcs; }
void CVRCompositor_009::Delete() { delete this; }
// Misc for CVRCompositor_012:
CVRCompositor_012::CVRCompositor_012() : base(GetCreateBaseCompositor()) {}
// Interface methods for CVRCompositor_012:
void CVRCompositor_012::SetTrackingSpace(vr::ETrackingUniverseOrigin eOrigin) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_012)");
	return base->SetTrackingSpace(eOrigin);
}
vr::ETrackingUniverseOrigin CVRCompositor_012::GetTrackingSpace() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_012)");
	return base->GetTrackingSpace();
}
vr::IVRCompositor_012::EVRCompositorError CVRCompositor_012::WaitGetPoses(vr::TrackedDevicePose_t* pRenderPoseArray, uint32_t unRenderPoseArrayCount, vr::TrackedDevicePose_t* pGamePoseArray, uint32_t unGamePoseArrayCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_012)");
	return (vr::IVRCompositor_012::EVRCompositorError) base->WaitGetPoses(pRenderPoseArray, unRenderPoseArrayCount, pGamePoseArray, unGamePoseArrayCount);
}
vr::IVRCompositor_012::EVRCompositorError CVRCompositor_012::GetLastPoses(vr::TrackedDevicePose_t* pRenderPoseArray, uint32_t unRenderPoseArrayCount, vr::TrackedDevicePose_t* pGamePoseArray, uint32_t unGamePoseArrayCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_012)");
	return (vr::IVRCompositor_012::EVRCompositorError) base->GetLastPoses(pRenderPoseArray, unRenderPoseArrayCount, pGamePoseArray, unGamePoseArrayCount);
}
vr::IVRCompositor_012::EVRCompositorError CVRCompositor_012::GetLastPoseForTrackedDeviceIndex(vr::TrackedDeviceIndex_t unDeviceIndex, vr::TrackedDevicePose_t* pOutputPose, vr::TrackedDevicePose_t* pOutputGamePose) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_012)");
	return (vr::IVRCompositor_012::EVRCompositorError) base->GetLastPoseForTrackedDeviceIndex(unDeviceIndex, pOutputPose, pOutputGamePose);
}
vr::IVRCompositor_012::EVRCompositorError CVRCompositor_012::Submit(vr::EVREye eEye, const vr::Texture_t* pTexture, const vr::VRTextureBounds_t* pBounds, vr::EVRSubmitFlags nSubmitFlags) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_012)");
	return (vr::IVRCompositor_012::EVRCompositorError) base->Submit(eEye, pTexture, pBounds, nSubmitFlags);
}
void CVRCompositor_012::ClearLastSubmittedFrame() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_012)");
	return base->ClearLastSubmittedFrame();
}
void CVRCompositor_012::PostPresentHandoff() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_012)");
	return base->PostPresentHandoff();
}
bool CVRCompositor_012::GetFrameTiming(vr::IVRCompositor_012::Compositor_FrameTiming* pTiming, uint32_t unFramesAgo) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_012)");
	return base->GetFrameTiming((OOVR_Compositor_FrameTiming*) pTiming, unFramesAgo);
}
float CVRCompositor_012::GetFrameTimeRemaining() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_012)");
	return base->GetFrameTimeRemaining();
}
void CVRCompositor_012::FadeToColor(float fSeconds, float fRed, float fGreen, float fBlue, float fAlpha, bool bBackground) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_012)");
	return base->FadeToColor(fSeconds, fRed, fGreen, fBlue, fAlpha, bBackground);
}
void CVRCompositor_012::FadeGrid(float fSeconds, bool bFadeIn) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_012)");
	return base->FadeGrid(fSeconds, bFadeIn);
}
vr::IVRCompositor_012::EVRCompositorError CVRCompositor_012::SetSkyboxOverride(const vr::Texture_t* pTextures, uint32_t unTextureCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_012)");
	return (vr::IVRCompositor_012::EVRCompositorError) base->SetSkyboxOverride(pTextures, unTextureCount);
}
void CVRCompositor_012::ClearSkyboxOverride() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_012)");
	return base->ClearSkyboxOverride();
}
void CVRCompositor_012::CompositorBringToFront() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_012)");
	return base->CompositorBringToFront();
}
void CVRCompositor_012::CompositorGoToBack() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_012)");
	return base->CompositorGoToBack();
}
void CVRCompositor_012::CompositorQuit() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_012)");
	return base->CompositorQuit();
}
bool CVRCompositor_012::IsFullscreen() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_012)");
	return base->IsFullscreen();
}
uint32_t CVRCompositor_012::GetCurrentSceneFocusProcess() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_012)");
	return base->GetCurrentSceneFocusProcess();
}
uint32_t CVRCompositor_012::GetLastFrameRenderer() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_012)");
	return base->GetLastFrameRenderer();
}
bool CVRCompositor_012::CanRenderScene() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_012)");
	return base->CanRenderScene();
}
void CVRCompositor_012::ShowMirrorWindow() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_012)");
	return base->ShowMirrorWindow();
}
void CVRCompositor_012::HideMirrorWindow() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_012)");
	return base->HideMirrorWindow();
}
bool CVRCompositor_012::IsMirrorWindowVisible() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_012)");
	return base->IsMirrorWindowVisible();
}
void CVRCompositor_012::CompositorDumpImages() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_012)");
	return base->CompositorDumpImages();
}
bool CVRCompositor_012::ShouldAppRenderWithLowResources() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_012)");
	return base->ShouldAppRenderWithLowResources();
}
// FnTable for CVRCompositor_012:
static CVRCompositor_012 *fntable_Compositor_012_instance = NULL;
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_012_impl_SetTrackingSpace(vr::ETrackingUniverseOrigin eOrigin) { return fntable_Compositor_012_instance->SetTrackingSpace(eOrigin); }
static vr::ETrackingUniverseOrigin OPENVR_FNTABLE_CALLTYPE fntable_Compositor_012_impl_GetTrackingSpace() { return fntable_Compositor_012_instance->GetTrackingSpace(); }
static vr::IVRCompositor_012::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_012_impl_WaitGetPoses(vr::TrackedDevicePose_t* pRenderPoseArray, uint32_t unRenderPoseArrayCount, vr::TrackedDevicePose_t* pGamePoseArray, uint32_t unGamePoseArrayCount) { return fntable_Compositor_012_instance->WaitGetPoses(pRenderPoseArray, unRenderPoseArrayCount, pGamePoseArray, unGamePoseArrayCount); }
static vr::IVRCompositor_012::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_012_impl_GetLastPoses(vr::TrackedDevicePose_t* pRenderPoseArray, uint32_t unRenderPoseArrayCount, vr::TrackedDevicePose_t* pGamePoseArray, uint32_t unGamePoseArrayCount) { return fntable_Compositor_012_instance->GetLastPoses(pRenderPoseArray, unRenderPoseArrayCount, pGamePoseArray, unGamePoseArrayCount); }
static vr::IVRCompositor_012::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_012_impl_GetLastPoseForTrackedDeviceIndex(vr::TrackedDeviceIndex_t unDeviceIndex, vr::TrackedDevicePose_t* pOutputPose, vr::TrackedDevicePose_t* pOutputGamePose) { return fntable_Compositor_012_instance->GetLastPoseForTrackedDeviceIndex(unDeviceIndex, pOutputPose, pOutputGamePose); }
static vr::IVRCompositor_012::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_012_impl_Submit(vr::EVREye eEye, const vr::Texture_t* pTexture, const vr::VRTextureBounds_t* pBounds, vr::EVRSubmitFlags nSubmitFlags) { return fntable_Compositor_012_instance->Submit(eEye, pTexture, pBounds, nSubmitFlags); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_012_impl_ClearLastSubmittedFrame() { return fntable_Compositor_012_instance->ClearLastSubmittedFrame(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_012_impl_PostPresentHandoff() { return fntable_Compositor_012_instance->PostPresentHandoff(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_012_impl_GetFrameTiming(vr::IVRCompositor_012::Compositor_FrameTiming* pTiming, uint32_t unFramesAgo) { return fntable_Compositor_012_instance->GetFrameTiming(pTiming, unFramesAgo); }
static float OPENVR_FNTABLE_CALLTYPE fntable_Compositor_012_impl_GetFrameTimeRemaining() { return fntable_Compositor_012_instance->GetFrameTimeRemaining(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_012_impl_FadeToColor(float fSeconds, float fRed, float fGreen, float fBlue, float fAlpha, bool bBackground) { return fntable_Compositor_012_instance->FadeToColor(fSeconds, fRed, fGreen, fBlue, fAlpha, bBackground); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_012_impl_FadeGrid(float fSeconds, bool bFadeIn) { return fntable_Compositor_012_instance->FadeGrid(fSeconds, bFadeIn); }
static vr::IVRCompositor_012::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_012_impl_SetSkyboxOverride(const vr::Texture_t* pTextures, uint32_t unTextureCount) { return fntable_Compositor_012_instance->SetSkyboxOverride(pTextures, unTextureCount); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_012_impl_ClearSkyboxOverride() { return fntable_Compositor_012_instance->ClearSkyboxOverride(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_012_impl_CompositorBringToFront() { return fntable_Compositor_012_instance->CompositorBringToFront(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_012_impl_CompositorGoToBack() { return fntable_Compositor_012_instance->CompositorGoToBack(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_012_impl_CompositorQuit() { return fntable_Compositor_012_instance->CompositorQuit(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_012_impl_IsFullscreen() { return fntable_Compositor_012_instance->IsFullscreen(); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Compositor_012_impl_GetCurrentSceneFocusProcess() { return fntable_Compositor_012_instance->GetCurrentSceneFocusProcess(); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Compositor_012_impl_GetLastFrameRenderer() { return fntable_Compositor_012_instance->GetLastFrameRenderer(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_012_impl_CanRenderScene() { return fntable_Compositor_012_instance->CanRenderScene(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_012_impl_ShowMirrorWindow() { return fntable_Compositor_012_instance->ShowMirrorWindow(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_012_impl_HideMirrorWindow() { return fntable_Compositor_012_instance->HideMirrorWindow(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_012_impl_IsMirrorWindowVisible() { return fntable_Compositor_012_instance->IsMirrorWindowVisible(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_012_impl_CompositorDumpImages() { return fntable_Compositor_012_instance->CompositorDumpImages(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_012_impl_ShouldAppRenderWithLowResources() { return fntable_Compositor_012_instance->ShouldAppRenderWithLowResources(); }
static void *fntable_Compositor_012_funcs[] = {
	(void*) fntable_Compositor_012_impl_SetTrackingSpace,
	(void*) fntable_Compositor_012_impl_GetTrackingSpace,
	(void*) fntable_Compositor_012_impl_WaitGetPoses,
	(void*) fntable_Compositor_012_impl_GetLastPoses,
	(void*) fntable_Compositor_012_impl_GetLastPoseForTrackedDeviceIndex,
	(void*) fntable_Compositor_012_impl_Submit,
	(void*) fntable_Compositor_012_impl_ClearLastSubmittedFrame,
	(void*) fntable_Compositor_012_impl_PostPresentHandoff,
	(void*) fntable_Compositor_012_impl_GetFrameTiming,
	(void*) fntable_Compositor_012_impl_GetFrameTimeRemaining,
	(void*) fntable_Compositor_012_impl_FadeToColor,
	(void*) fntable_Compositor_012_impl_FadeGrid,
	(void*) fntable_Compositor_012_impl_SetSkyboxOverride,
	(void*) fntable_Compositor_012_impl_ClearSkyboxOverride,
	(void*) fntable_Compositor_012_impl_CompositorBringToFront,
	(void*) fntable_Compositor_012_impl_CompositorGoToBack,
	(void*) fntable_Compositor_012_impl_CompositorQuit,
	(void*) fntable_Compositor_012_impl_IsFullscreen,
	(void*) fntable_Compositor_012_impl_GetCurrentSceneFocusProcess,
	(void*) fntable_Compositor_012_impl_GetLastFrameRenderer,
	(void*) fntable_Compositor_012_impl_CanRenderScene,
	(void*) fntable_Compositor_012_impl_ShowMirrorWindow,
	(void*) fntable_Compositor_012_impl_HideMirrorWindow,
	(void*) fntable_Compositor_012_impl_IsMirrorWindowVisible,
	(void*) fntable_Compositor_012_impl_CompositorDumpImages,
	(void*) fntable_Compositor_012_impl_ShouldAppRenderWithLowResources,
};
void** CVRCompositor_012::_GetStatFuncList() { fntable_Compositor_012_instance = this; return fntable_Compositor_012_funcs; }
void CVRCompositor_012::Delete() { delete this; }
// Misc for CVRCompositor_013:
CVRCompositor_013::CVRCompositor_013() : base(GetCreateBaseCompositor()) {}
// Interface methods for CVRCompositor_013:
void CVRCompositor_013::SetTrackingSpace(vr::ETrackingUniverseOrigin eOrigin) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_013)");
	return base->SetTrackingSpace(eOrigin);
}
vr::ETrackingUniverseOrigin CVRCompositor_013::GetTrackingSpace() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_013)");
	return base->GetTrackingSpace();
}
vr::IVRCompositor_013::EVRCompositorError CVRCompositor_013::WaitGetPoses(vr::TrackedDevicePose_t* pRenderPoseArray, uint32_t unRenderPoseArrayCount, vr::TrackedDevicePose_t* pGamePoseArray, uint32_t unGamePoseArrayCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_013)");
	return (vr::IVRCompositor_013::EVRCompositorError) base->WaitGetPoses(pRenderPoseArray, unRenderPoseArrayCount, pGamePoseArray, unGamePoseArrayCount);
}
vr::IVRCompositor_013::EVRCompositorError CVRCompositor_013::GetLastPoses(vr::TrackedDevicePose_t* pRenderPoseArray, uint32_t unRenderPoseArrayCount, vr::TrackedDevicePose_t* pGamePoseArray, uint32_t unGamePoseArrayCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_013)");
	return (vr::IVRCompositor_013::EVRCompositorError) base->GetLastPoses(pRenderPoseArray, unRenderPoseArrayCount, pGamePoseArray, unGamePoseArrayCount);
}
vr::IVRCompositor_013::EVRCompositorError CVRCompositor_013::GetLastPoseForTrackedDeviceIndex(vr::TrackedDeviceIndex_t unDeviceIndex, vr::TrackedDevicePose_t* pOutputPose, vr::TrackedDevicePose_t* pOutputGamePose) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_013)");
	return (vr::IVRCompositor_013::EVRCompositorError) base->GetLastPoseForTrackedDeviceIndex(unDeviceIndex, pOutputPose, pOutputGamePose);
}
vr::IVRCompositor_013::EVRCompositorError CVRCompositor_013::Submit(vr::EVREye eEye, const vr::Texture_t* pTexture, const vr::VRTextureBounds_t* pBounds, vr::EVRSubmitFlags nSubmitFlags) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_013)");
	return (vr::IVRCompositor_013::EVRCompositorError) base->Submit(eEye, pTexture, pBounds, nSubmitFlags);
}
void CVRCompositor_013::ClearLastSubmittedFrame() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_013)");
	return base->ClearLastSubmittedFrame();
}
void CVRCompositor_013::PostPresentHandoff() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_013)");
	return base->PostPresentHandoff();
}
bool CVRCompositor_013::GetFrameTiming(vr::IVRCompositor_013::Compositor_FrameTiming* pTiming, uint32_t unFramesAgo) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_013)");
	return base->GetFrameTiming((OOVR_Compositor_FrameTiming*) pTiming, unFramesAgo);
}
float CVRCompositor_013::GetFrameTimeRemaining() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_013)");
	return base->GetFrameTimeRemaining();
}
void CVRCompositor_013::FadeToColor(float fSeconds, float fRed, float fGreen, float fBlue, float fAlpha, bool bBackground) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_013)");
	return base->FadeToColor(fSeconds, fRed, fGreen, fBlue, fAlpha, bBackground);
}
void CVRCompositor_013::FadeGrid(float fSeconds, bool bFadeIn) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_013)");
	return base->FadeGrid(fSeconds, bFadeIn);
}
vr::IVRCompositor_013::EVRCompositorError CVRCompositor_013::SetSkyboxOverride(const vr::Texture_t* pTextures, uint32_t unTextureCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_013)");
	return (vr::IVRCompositor_013::EVRCompositorError) base->SetSkyboxOverride(pTextures, unTextureCount);
}
void CVRCompositor_013::ClearSkyboxOverride() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_013)");
	return base->ClearSkyboxOverride();
}
void CVRCompositor_013::CompositorBringToFront() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_013)");
	return base->CompositorBringToFront();
}
void CVRCompositor_013::CompositorGoToBack() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_013)");
	return base->CompositorGoToBack();
}
void CVRCompositor_013::CompositorQuit() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_013)");
	return base->CompositorQuit();
}
bool CVRCompositor_013::IsFullscreen() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_013)");
	return base->IsFullscreen();
}
uint32_t CVRCompositor_013::GetCurrentSceneFocusProcess() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_013)");
	return base->GetCurrentSceneFocusProcess();
}
uint32_t CVRCompositor_013::GetLastFrameRenderer() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_013)");
	return base->GetLastFrameRenderer();
}
bool CVRCompositor_013::CanRenderScene() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_013)");
	return base->CanRenderScene();
}
void CVRCompositor_013::ShowMirrorWindow() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_013)");
	return base->ShowMirrorWindow();
}
void CVRCompositor_013::HideMirrorWindow() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_013)");
	return base->HideMirrorWindow();
}
bool CVRCompositor_013::IsMirrorWindowVisible() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_013)");
	return base->IsMirrorWindowVisible();
}
void CVRCompositor_013::CompositorDumpImages() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_013)");
	return base->CompositorDumpImages();
}
bool CVRCompositor_013::ShouldAppRenderWithLowResources() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_013)");
	return base->ShouldAppRenderWithLowResources();
}
void CVRCompositor_013::ForceInterleavedReprojectionOn(bool bOverride) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_013)");
	return base->ForceInterleavedReprojectionOn(bOverride);
}
// FnTable for CVRCompositor_013:
static CVRCompositor_013 *fntable_Compositor_013_instance = NULL;
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_013_impl_SetTrackingSpace(vr::ETrackingUniverseOrigin eOrigin) { return fntable_Compositor_013_instance->SetTrackingSpace(eOrigin); }
static vr::ETrackingUniverseOrigin OPENVR_FNTABLE_CALLTYPE fntable_Compositor_013_impl_GetTrackingSpace() { return fntable_Compositor_013_instance->GetTrackingSpace(); }
static vr::IVRCompositor_013::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_013_impl_WaitGetPoses(vr::TrackedDevicePose_t* pRenderPoseArray, uint32_t unRenderPoseArrayCount, vr::TrackedDevicePose_t* pGamePoseArray, uint32_t unGamePoseArrayCount) { return fntable_Compositor_013_instance->WaitGetPoses(pRenderPoseArray, unRenderPoseArrayCount, pGamePoseArray, unGamePoseArrayCount); }
static vr::IVRCompositor_013::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_013_impl_GetLastPoses(vr::TrackedDevicePose_t* pRenderPoseArray, uint32_t unRenderPoseArrayCount, vr::TrackedDevicePose_t* pGamePoseArray, uint32_t unGamePoseArrayCount) { return fntable_Compositor_013_instance->GetLastPoses(pRenderPoseArray, unRenderPoseArrayCount, pGamePoseArray, unGamePoseArrayCount); }
static vr::IVRCompositor_013::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_013_impl_GetLastPoseForTrackedDeviceIndex(vr::TrackedDeviceIndex_t unDeviceIndex, vr::TrackedDevicePose_t* pOutputPose, vr::TrackedDevicePose_t* pOutputGamePose) { return fntable_Compositor_013_instance->GetLastPoseForTrackedDeviceIndex(unDeviceIndex, pOutputPose, pOutputGamePose); }
static vr::IVRCompositor_013::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_013_impl_Submit(vr::EVREye eEye, const vr::Texture_t* pTexture, const vr::VRTextureBounds_t* pBounds, vr::EVRSubmitFlags nSubmitFlags) { return fntable_Compositor_013_instance->Submit(eEye, pTexture, pBounds, nSubmitFlags); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_013_impl_ClearLastSubmittedFrame() { return fntable_Compositor_013_instance->ClearLastSubmittedFrame(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_013_impl_PostPresentHandoff() { return fntable_Compositor_013_instance->PostPresentHandoff(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_013_impl_GetFrameTiming(vr::IVRCompositor_013::Compositor_FrameTiming* pTiming, uint32_t unFramesAgo) { return fntable_Compositor_013_instance->GetFrameTiming(pTiming, unFramesAgo); }
static float OPENVR_FNTABLE_CALLTYPE fntable_Compositor_013_impl_GetFrameTimeRemaining() { return fntable_Compositor_013_instance->GetFrameTimeRemaining(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_013_impl_FadeToColor(float fSeconds, float fRed, float fGreen, float fBlue, float fAlpha, bool bBackground) { return fntable_Compositor_013_instance->FadeToColor(fSeconds, fRed, fGreen, fBlue, fAlpha, bBackground); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_013_impl_FadeGrid(float fSeconds, bool bFadeIn) { return fntable_Compositor_013_instance->FadeGrid(fSeconds, bFadeIn); }
static vr::IVRCompositor_013::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_013_impl_SetSkyboxOverride(const vr::Texture_t* pTextures, uint32_t unTextureCount) { return fntable_Compositor_013_instance->SetSkyboxOverride(pTextures, unTextureCount); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_013_impl_ClearSkyboxOverride() { return fntable_Compositor_013_instance->ClearSkyboxOverride(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_013_impl_CompositorBringToFront() { return fntable_Compositor_013_instance->CompositorBringToFront(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_013_impl_CompositorGoToBack() { return fntable_Compositor_013_instance->CompositorGoToBack(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_013_impl_CompositorQuit() { return fntable_Compositor_013_instance->CompositorQuit(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_013_impl_IsFullscreen() { return fntable_Compositor_013_instance->IsFullscreen(); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Compositor_013_impl_GetCurrentSceneFocusProcess() { return fntable_Compositor_013_instance->GetCurrentSceneFocusProcess(); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Compositor_013_impl_GetLastFrameRenderer() { return fntable_Compositor_013_instance->GetLastFrameRenderer(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_013_impl_CanRenderScene() { return fntable_Compositor_013_instance->CanRenderScene(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_013_impl_ShowMirrorWindow() { return fntable_Compositor_013_instance->ShowMirrorWindow(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_013_impl_HideMirrorWindow() { return fntable_Compositor_013_instance->HideMirrorWindow(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_013_impl_IsMirrorWindowVisible() { return fntable_Compositor_013_instance->IsMirrorWindowVisible(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_013_impl_CompositorDumpImages() { return fntable_Compositor_013_instance->CompositorDumpImages(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_013_impl_ShouldAppRenderWithLowResources() { return fntable_Compositor_013_instance->ShouldAppRenderWithLowResources(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_013_impl_ForceInterleavedReprojectionOn(bool bOverride) { return fntable_Compositor_013_instance->ForceInterleavedReprojectionOn(bOverride); }
static void *fntable_Compositor_013_funcs[] = {
	(void*) fntable_Compositor_013_impl_SetTrackingSpace,
	(void*) fntable_Compositor_013_impl_GetTrackingSpace,
	(void*) fntable_Compositor_013_impl_WaitGetPoses,
	(void*) fntable_Compositor_013_impl_GetLastPoses,
	(void*) fntable_Compositor_013_impl_GetLastPoseForTrackedDeviceIndex,
	(void*) fntable_Compositor_013_impl_Submit,
	(void*) fntable_Compositor_013_impl_ClearLastSubmittedFrame,
	(void*) fntable_Compositor_013_impl_PostPresentHandoff,
	(void*) fntable_Compositor_013_impl_GetFrameTiming,
	(void*) fntable_Compositor_013_impl_GetFrameTimeRemaining,
	(void*) fntable_Compositor_013_impl_FadeToColor,
	(void*) fntable_Compositor_013_impl_FadeGrid,
	(void*) fntable_Compositor_013_impl_SetSkyboxOverride,
	(void*) fntable_Compositor_013_impl_ClearSkyboxOverride,
	(void*) fntable_Compositor_013_impl_CompositorBringToFront,
	(void*) fntable_Compositor_013_impl_CompositorGoToBack,
	(void*) fntable_Compositor_013_impl_CompositorQuit,
	(void*) fntable_Compositor_013_impl_IsFullscreen,
	(void*) fntable_Compositor_013_impl_GetCurrentSceneFocusProcess,
	(void*) fntable_Compositor_013_impl_GetLastFrameRenderer,
	(void*) fntable_Compositor_013_impl_CanRenderScene,
	(void*) fntable_Compositor_013_impl_ShowMirrorWindow,
	(void*) fntable_Compositor_013_impl_HideMirrorWindow,
	(void*) fntable_Compositor_013_impl_IsMirrorWindowVisible,
	(void*) fntable_Compositor_013_impl_CompositorDumpImages,
	(void*) fntable_Compositor_013_impl_ShouldAppRenderWithLowResources,
	(void*) fntable_Compositor_013_impl_ForceInterleavedReprojectionOn,
};
void** CVRCompositor_013::_GetStatFuncList() { fntable_Compositor_013_instance = this; return fntable_Compositor_013_funcs; }
void CVRCompositor_013::Delete() { delete this; }
// Misc for CVRCompositor_014:
CVRCompositor_014::CVRCompositor_014() : base(GetCreateBaseCompositor()) {}
// Interface methods for CVRCompositor_014:
void CVRCompositor_014::SetTrackingSpace(vr::ETrackingUniverseOrigin eOrigin) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_014)");
	return base->SetTrackingSpace(eOrigin);
}
vr::ETrackingUniverseOrigin CVRCompositor_014::GetTrackingSpace() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_014)");
	return base->GetTrackingSpace();
}
vr::IVRCompositor_014::EVRCompositorError CVRCompositor_014::WaitGetPoses(vr::TrackedDevicePose_t* pRenderPoseArray, uint32_t unRenderPoseArrayCount, vr::TrackedDevicePose_t* pGamePoseArray, uint32_t unGamePoseArrayCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_014)");
	return (vr::IVRCompositor_014::EVRCompositorError) base->WaitGetPoses(pRenderPoseArray, unRenderPoseArrayCount, pGamePoseArray, unGamePoseArrayCount);
}
vr::IVRCompositor_014::EVRCompositorError CVRCompositor_014::GetLastPoses(vr::TrackedDevicePose_t* pRenderPoseArray, uint32_t unRenderPoseArrayCount, vr::TrackedDevicePose_t* pGamePoseArray, uint32_t unGamePoseArrayCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_014)");
	return (vr::IVRCompositor_014::EVRCompositorError) base->GetLastPoses(pRenderPoseArray, unRenderPoseArrayCount, pGamePoseArray, unGamePoseArrayCount);
}
vr::IVRCompositor_014::EVRCompositorError CVRCompositor_014::GetLastPoseForTrackedDeviceIndex(vr::TrackedDeviceIndex_t unDeviceIndex, vr::TrackedDevicePose_t* pOutputPose, vr::TrackedDevicePose_t* pOutputGamePose) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_014)");
	return (vr::IVRCompositor_014::EVRCompositorError) base->GetLastPoseForTrackedDeviceIndex(unDeviceIndex, pOutputPose, pOutputGamePose);
}
vr::IVRCompositor_014::EVRCompositorError CVRCompositor_014::Submit(vr::EVREye eEye, const vr::Texture_t* pTexture, const vr::VRTextureBounds_t* pBounds, vr::EVRSubmitFlags nSubmitFlags) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_014)");
	return (vr::IVRCompositor_014::EVRCompositorError) base->Submit(eEye, pTexture, pBounds, nSubmitFlags);
}
void CVRCompositor_014::ClearLastSubmittedFrame() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_014)");
	return base->ClearLastSubmittedFrame();
}
void CVRCompositor_014::PostPresentHandoff() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_014)");
	return base->PostPresentHandoff();
}
bool CVRCompositor_014::GetFrameTiming(vr::IVRCompositor_014::Compositor_FrameTiming* pTiming, uint32_t unFramesAgo) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_014)");
	return base->GetFrameTiming((OOVR_Compositor_FrameTiming*) pTiming, unFramesAgo);
}
float CVRCompositor_014::GetFrameTimeRemaining() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_014)");
	return base->GetFrameTimeRemaining();
}
void CVRCompositor_014::FadeToColor(float fSeconds, float fRed, float fGreen, float fBlue, float fAlpha, bool bBackground) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_014)");
	return base->FadeToColor(fSeconds, fRed, fGreen, fBlue, fAlpha, bBackground);
}
void CVRCompositor_014::FadeGrid(float fSeconds, bool bFadeIn) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_014)");
	return base->FadeGrid(fSeconds, bFadeIn);
}
vr::IVRCompositor_014::EVRCompositorError CVRCompositor_014::SetSkyboxOverride(const vr::Texture_t* pTextures, uint32_t unTextureCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_014)");
	return (vr::IVRCompositor_014::EVRCompositorError) base->SetSkyboxOverride(pTextures, unTextureCount);
}
void CVRCompositor_014::ClearSkyboxOverride() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_014)");
	return base->ClearSkyboxOverride();
}
void CVRCompositor_014::CompositorBringToFront() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_014)");
	return base->CompositorBringToFront();
}
void CVRCompositor_014::CompositorGoToBack() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_014)");
	return base->CompositorGoToBack();
}
void CVRCompositor_014::CompositorQuit() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_014)");
	return base->CompositorQuit();
}
bool CVRCompositor_014::IsFullscreen() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_014)");
	return base->IsFullscreen();
}
uint32_t CVRCompositor_014::GetCurrentSceneFocusProcess() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_014)");
	return base->GetCurrentSceneFocusProcess();
}
uint32_t CVRCompositor_014::GetLastFrameRenderer() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_014)");
	return base->GetLastFrameRenderer();
}
bool CVRCompositor_014::CanRenderScene() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_014)");
	return base->CanRenderScene();
}
void CVRCompositor_014::ShowMirrorWindow() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_014)");
	return base->ShowMirrorWindow();
}
void CVRCompositor_014::HideMirrorWindow() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_014)");
	return base->HideMirrorWindow();
}
bool CVRCompositor_014::IsMirrorWindowVisible() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_014)");
	return base->IsMirrorWindowVisible();
}
void CVRCompositor_014::CompositorDumpImages() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_014)");
	return base->CompositorDumpImages();
}
bool CVRCompositor_014::ShouldAppRenderWithLowResources() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_014)");
	return base->ShouldAppRenderWithLowResources();
}
void CVRCompositor_014::ForceInterleavedReprojectionOn(bool bOverride) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_014)");
	return base->ForceInterleavedReprojectionOn(bOverride);
}
void CVRCompositor_014::ForceReconnectProcess() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_014)");
	return base->ForceReconnectProcess();
}
void CVRCompositor_014::SuspendRendering(bool bSuspend) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_014)");
	return base->SuspendRendering(bSuspend);
}
// FnTable for CVRCompositor_014:
static CVRCompositor_014 *fntable_Compositor_014_instance = NULL;
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_014_impl_SetTrackingSpace(vr::ETrackingUniverseOrigin eOrigin) { return fntable_Compositor_014_instance->SetTrackingSpace(eOrigin); }
static vr::ETrackingUniverseOrigin OPENVR_FNTABLE_CALLTYPE fntable_Compositor_014_impl_GetTrackingSpace() { return fntable_Compositor_014_instance->GetTrackingSpace(); }
static vr::IVRCompositor_014::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_014_impl_WaitGetPoses(vr::TrackedDevicePose_t* pRenderPoseArray, uint32_t unRenderPoseArrayCount, vr::TrackedDevicePose_t* pGamePoseArray, uint32_t unGamePoseArrayCount) { return fntable_Compositor_014_instance->WaitGetPoses(pRenderPoseArray, unRenderPoseArrayCount, pGamePoseArray, unGamePoseArrayCount); }
static vr::IVRCompositor_014::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_014_impl_GetLastPoses(vr::TrackedDevicePose_t* pRenderPoseArray, uint32_t unRenderPoseArrayCount, vr::TrackedDevicePose_t* pGamePoseArray, uint32_t unGamePoseArrayCount) { return fntable_Compositor_014_instance->GetLastPoses(pRenderPoseArray, unRenderPoseArrayCount, pGamePoseArray, unGamePoseArrayCount); }
static vr::IVRCompositor_014::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_014_impl_GetLastPoseForTrackedDeviceIndex(vr::TrackedDeviceIndex_t unDeviceIndex, vr::TrackedDevicePose_t* pOutputPose, vr::TrackedDevicePose_t* pOutputGamePose) { return fntable_Compositor_014_instance->GetLastPoseForTrackedDeviceIndex(unDeviceIndex, pOutputPose, pOutputGamePose); }
static vr::IVRCompositor_014::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_014_impl_Submit(vr::EVREye eEye, const vr::Texture_t* pTexture, const vr::VRTextureBounds_t* pBounds, vr::EVRSubmitFlags nSubmitFlags) { return fntable_Compositor_014_instance->Submit(eEye, pTexture, pBounds, nSubmitFlags); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_014_impl_ClearLastSubmittedFrame() { return fntable_Compositor_014_instance->ClearLastSubmittedFrame(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_014_impl_PostPresentHandoff() { return fntable_Compositor_014_instance->PostPresentHandoff(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_014_impl_GetFrameTiming(vr::IVRCompositor_014::Compositor_FrameTiming* pTiming, uint32_t unFramesAgo) { return fntable_Compositor_014_instance->GetFrameTiming(pTiming, unFramesAgo); }
static float OPENVR_FNTABLE_CALLTYPE fntable_Compositor_014_impl_GetFrameTimeRemaining() { return fntable_Compositor_014_instance->GetFrameTimeRemaining(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_014_impl_FadeToColor(float fSeconds, float fRed, float fGreen, float fBlue, float fAlpha, bool bBackground) { return fntable_Compositor_014_instance->FadeToColor(fSeconds, fRed, fGreen, fBlue, fAlpha, bBackground); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_014_impl_FadeGrid(float fSeconds, bool bFadeIn) { return fntable_Compositor_014_instance->FadeGrid(fSeconds, bFadeIn); }
static vr::IVRCompositor_014::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_014_impl_SetSkyboxOverride(const vr::Texture_t* pTextures, uint32_t unTextureCount) { return fntable_Compositor_014_instance->SetSkyboxOverride(pTextures, unTextureCount); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_014_impl_ClearSkyboxOverride() { return fntable_Compositor_014_instance->ClearSkyboxOverride(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_014_impl_CompositorBringToFront() { return fntable_Compositor_014_instance->CompositorBringToFront(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_014_impl_CompositorGoToBack() { return fntable_Compositor_014_instance->CompositorGoToBack(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_014_impl_CompositorQuit() { return fntable_Compositor_014_instance->CompositorQuit(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_014_impl_IsFullscreen() { return fntable_Compositor_014_instance->IsFullscreen(); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Compositor_014_impl_GetCurrentSceneFocusProcess() { return fntable_Compositor_014_instance->GetCurrentSceneFocusProcess(); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Compositor_014_impl_GetLastFrameRenderer() { return fntable_Compositor_014_instance->GetLastFrameRenderer(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_014_impl_CanRenderScene() { return fntable_Compositor_014_instance->CanRenderScene(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_014_impl_ShowMirrorWindow() { return fntable_Compositor_014_instance->ShowMirrorWindow(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_014_impl_HideMirrorWindow() { return fntable_Compositor_014_instance->HideMirrorWindow(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_014_impl_IsMirrorWindowVisible() { return fntable_Compositor_014_instance->IsMirrorWindowVisible(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_014_impl_CompositorDumpImages() { return fntable_Compositor_014_instance->CompositorDumpImages(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_014_impl_ShouldAppRenderWithLowResources() { return fntable_Compositor_014_instance->ShouldAppRenderWithLowResources(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_014_impl_ForceInterleavedReprojectionOn(bool bOverride) { return fntable_Compositor_014_instance->ForceInterleavedReprojectionOn(bOverride); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_014_impl_ForceReconnectProcess() { return fntable_Compositor_014_instance->ForceReconnectProcess(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_014_impl_SuspendRendering(bool bSuspend) { return fntable_Compositor_014_instance->SuspendRendering(bSuspend); }
static void *fntable_Compositor_014_funcs[] = {
	(void*) fntable_Compositor_014_impl_SetTrackingSpace,
	(void*) fntable_Compositor_014_impl_GetTrackingSpace,
	(void*) fntable_Compositor_014_impl_WaitGetPoses,
	(void*) fntable_Compositor_014_impl_GetLastPoses,
	(void*) fntable_Compositor_014_impl_GetLastPoseForTrackedDeviceIndex,
	(void*) fntable_Compositor_014_impl_Submit,
	(void*) fntable_Compositor_014_impl_ClearLastSubmittedFrame,
	(void*) fntable_Compositor_014_impl_PostPresentHandoff,
	(void*) fntable_Compositor_014_impl_GetFrameTiming,
	(void*) fntable_Compositor_014_impl_GetFrameTimeRemaining,
	(void*) fntable_Compositor_014_impl_FadeToColor,
	(void*) fntable_Compositor_014_impl_FadeGrid,
	(void*) fntable_Compositor_014_impl_SetSkyboxOverride,
	(void*) fntable_Compositor_014_impl_ClearSkyboxOverride,
	(void*) fntable_Compositor_014_impl_CompositorBringToFront,
	(void*) fntable_Compositor_014_impl_CompositorGoToBack,
	(void*) fntable_Compositor_014_impl_CompositorQuit,
	(void*) fntable_Compositor_014_impl_IsFullscreen,
	(void*) fntable_Compositor_014_impl_GetCurrentSceneFocusProcess,
	(void*) fntable_Compositor_014_impl_GetLastFrameRenderer,
	(void*) fntable_Compositor_014_impl_CanRenderScene,
	(void*) fntable_Compositor_014_impl_ShowMirrorWindow,
	(void*) fntable_Compositor_014_impl_HideMirrorWindow,
	(void*) fntable_Compositor_014_impl_IsMirrorWindowVisible,
	(void*) fntable_Compositor_014_impl_CompositorDumpImages,
	(void*) fntable_Compositor_014_impl_ShouldAppRenderWithLowResources,
	(void*) fntable_Compositor_014_impl_ForceInterleavedReprojectionOn,
	(void*) fntable_Compositor_014_impl_ForceReconnectProcess,
	(void*) fntable_Compositor_014_impl_SuspendRendering,
};
void** CVRCompositor_014::_GetStatFuncList() { fntable_Compositor_014_instance = this; return fntable_Compositor_014_funcs; }
void CVRCompositor_014::Delete() { delete this; }
// Misc for CVRCompositor_015:
CVRCompositor_015::CVRCompositor_015() : base(GetCreateBaseCompositor()) {}
// Interface methods for CVRCompositor_015:
void CVRCompositor_015::SetTrackingSpace(vr::ETrackingUniverseOrigin eOrigin) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_015)");
	return base->SetTrackingSpace(eOrigin);
}
vr::ETrackingUniverseOrigin CVRCompositor_015::GetTrackingSpace() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_015)");
	return base->GetTrackingSpace();
}
vr::IVRCompositor_015::EVRCompositorError CVRCompositor_015::WaitGetPoses(vr::TrackedDevicePose_t* pRenderPoseArray, uint32_t unRenderPoseArrayCount, vr::TrackedDevicePose_t* pGamePoseArray, uint32_t unGamePoseArrayCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_015)");
	return (vr::IVRCompositor_015::EVRCompositorError) base->WaitGetPoses(pRenderPoseArray, unRenderPoseArrayCount, pGamePoseArray, unGamePoseArrayCount);
}
vr::IVRCompositor_015::EVRCompositorError CVRCompositor_015::GetLastPoses(vr::TrackedDevicePose_t* pRenderPoseArray, uint32_t unRenderPoseArrayCount, vr::TrackedDevicePose_t* pGamePoseArray, uint32_t unGamePoseArrayCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_015)");
	return (vr::IVRCompositor_015::EVRCompositorError) base->GetLastPoses(pRenderPoseArray, unRenderPoseArrayCount, pGamePoseArray, unGamePoseArrayCount);
}
vr::IVRCompositor_015::EVRCompositorError CVRCompositor_015::GetLastPoseForTrackedDeviceIndex(vr::TrackedDeviceIndex_t unDeviceIndex, vr::TrackedDevicePose_t* pOutputPose, vr::TrackedDevicePose_t* pOutputGamePose) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_015)");
	return (vr::IVRCompositor_015::EVRCompositorError) base->GetLastPoseForTrackedDeviceIndex(unDeviceIndex, pOutputPose, pOutputGamePose);
}
vr::IVRCompositor_015::EVRCompositorError CVRCompositor_015::Submit(vr::EVREye eEye, const vr::Texture_t* pTexture, const vr::VRTextureBounds_t* pBounds, vr::EVRSubmitFlags nSubmitFlags) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_015)");
	return (vr::IVRCompositor_015::EVRCompositorError) base->Submit(eEye, pTexture, pBounds, nSubmitFlags);
}
void CVRCompositor_015::ClearLastSubmittedFrame() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_015)");
	return base->ClearLastSubmittedFrame();
}
void CVRCompositor_015::PostPresentHandoff() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_015)");
	return base->PostPresentHandoff();
}
bool CVRCompositor_015::GetFrameTiming(vr::IVRCompositor_015::Compositor_FrameTiming* pTiming, uint32_t unFramesAgo) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_015)");
	return base->GetFrameTiming((OOVR_Compositor_FrameTiming*) pTiming, unFramesAgo);
}
float CVRCompositor_015::GetFrameTimeRemaining() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_015)");
	return base->GetFrameTimeRemaining();
}
void CVRCompositor_015::GetCumulativeStats(vr::IVRCompositor_015::Compositor_CumulativeStats* pStats, uint32_t nStatsSizeInBytes) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_015)");
	return base->GetCumulativeStats((OOVR_Compositor_CumulativeStats*) pStats, nStatsSizeInBytes);
}
void CVRCompositor_015::FadeToColor(float fSeconds, float fRed, float fGreen, float fBlue, float fAlpha, bool bBackground) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_015)");
	return base->FadeToColor(fSeconds, fRed, fGreen, fBlue, fAlpha, bBackground);
}
void CVRCompositor_015::FadeGrid(float fSeconds, bool bFadeIn) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_015)");
	return base->FadeGrid(fSeconds, bFadeIn);
}
vr::IVRCompositor_015::EVRCompositorError CVRCompositor_015::SetSkyboxOverride(const vr::Texture_t* pTextures, uint32_t unTextureCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_015)");
	return (vr::IVRCompositor_015::EVRCompositorError) base->SetSkyboxOverride(pTextures, unTextureCount);
}
void CVRCompositor_015::ClearSkyboxOverride() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_015)");
	return base->ClearSkyboxOverride();
}
void CVRCompositor_015::CompositorBringToFront() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_015)");
	return base->CompositorBringToFront();
}
void CVRCompositor_015::CompositorGoToBack() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_015)");
	return base->CompositorGoToBack();
}
void CVRCompositor_015::CompositorQuit() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_015)");
	return base->CompositorQuit();
}
bool CVRCompositor_015::IsFullscreen() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_015)");
	return base->IsFullscreen();
}
uint32_t CVRCompositor_015::GetCurrentSceneFocusProcess() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_015)");
	return base->GetCurrentSceneFocusProcess();
}
uint32_t CVRCompositor_015::GetLastFrameRenderer() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_015)");
	return base->GetLastFrameRenderer();
}
bool CVRCompositor_015::CanRenderScene() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_015)");
	return base->CanRenderScene();
}
void CVRCompositor_015::ShowMirrorWindow() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_015)");
	return base->ShowMirrorWindow();
}
void CVRCompositor_015::HideMirrorWindow() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_015)");
	return base->HideMirrorWindow();
}
bool CVRCompositor_015::IsMirrorWindowVisible() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_015)");
	return base->IsMirrorWindowVisible();
}
void CVRCompositor_015::CompositorDumpImages() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_015)");
	return base->CompositorDumpImages();
}
bool CVRCompositor_015::ShouldAppRenderWithLowResources() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_015)");
	return base->ShouldAppRenderWithLowResources();
}
void CVRCompositor_015::ForceInterleavedReprojectionOn(bool bOverride) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_015)");
	return base->ForceInterleavedReprojectionOn(bOverride);
}
void CVRCompositor_015::ForceReconnectProcess() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_015)");
	return base->ForceReconnectProcess();
}
void CVRCompositor_015::SuspendRendering(bool bSuspend) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_015)");
	return base->SuspendRendering(bSuspend);
}
vr::IVRCompositor_015::EVRCompositorError CVRCompositor_015::GetMirrorTextureD3D11(vr::EVREye eEye, void* pD3D11DeviceOrResource, void** ppD3D11ShaderResourceView) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_015)");
	return (vr::IVRCompositor_015::EVRCompositorError) base->GetMirrorTextureD3D11(eEye, pD3D11DeviceOrResource, ppD3D11ShaderResourceView);
}
vr::IVRCompositor_015::EVRCompositorError CVRCompositor_015::GetMirrorTextureGL(vr::EVREye eEye, vr::glUInt_t* pglTextureId, vr::glSharedTextureHandle_t* pglSharedTextureHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_015)");
	return (vr::IVRCompositor_015::EVRCompositorError) base->GetMirrorTextureGL(eEye, pglTextureId, pglSharedTextureHandle);
}
bool CVRCompositor_015::ReleaseSharedGLTexture(vr::glUInt_t glTextureId, vr::glSharedTextureHandle_t glSharedTextureHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_015)");
	return base->ReleaseSharedGLTexture(glTextureId, glSharedTextureHandle);
}
void CVRCompositor_015::LockGLSharedTextureForAccess(vr::glSharedTextureHandle_t glSharedTextureHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_015)");
	return base->LockGLSharedTextureForAccess(glSharedTextureHandle);
}
void CVRCompositor_015::UnlockGLSharedTextureForAccess(vr::glSharedTextureHandle_t glSharedTextureHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_015)");
	return base->UnlockGLSharedTextureForAccess(glSharedTextureHandle);
}
// FnTable for CVRCompositor_015:
static CVRCompositor_015 *fntable_Compositor_015_instance = NULL;
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_015_impl_SetTrackingSpace(vr::ETrackingUniverseOrigin eOrigin) { return fntable_Compositor_015_instance->SetTrackingSpace(eOrigin); }
static vr::ETrackingUniverseOrigin OPENVR_FNTABLE_CALLTYPE fntable_Compositor_015_impl_GetTrackingSpace() { return fntable_Compositor_015_instance->GetTrackingSpace(); }
static vr::IVRCompositor_015::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_015_impl_WaitGetPoses(vr::TrackedDevicePose_t* pRenderPoseArray, uint32_t unRenderPoseArrayCount, vr::TrackedDevicePose_t* pGamePoseArray, uint32_t unGamePoseArrayCount) { return fntable_Compositor_015_instance->WaitGetPoses(pRenderPoseArray, unRenderPoseArrayCount, pGamePoseArray, unGamePoseArrayCount); }
static vr::IVRCompositor_015::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_015_impl_GetLastPoses(vr::TrackedDevicePose_t* pRenderPoseArray, uint32_t unRenderPoseArrayCount, vr::TrackedDevicePose_t* pGamePoseArray, uint32_t unGamePoseArrayCount) { return fntable_Compositor_015_instance->GetLastPoses(pRenderPoseArray, unRenderPoseArrayCount, pGamePoseArray, unGamePoseArrayCount); }
static vr::IVRCompositor_015::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_015_impl_GetLastPoseForTrackedDeviceIndex(vr::TrackedDeviceIndex_t unDeviceIndex, vr::TrackedDevicePose_t* pOutputPose, vr::TrackedDevicePose_t* pOutputGamePose) { return fntable_Compositor_015_instance->GetLastPoseForTrackedDeviceIndex(unDeviceIndex, pOutputPose, pOutputGamePose); }
static vr::IVRCompositor_015::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_015_impl_Submit(vr::EVREye eEye, const vr::Texture_t* pTexture, const vr::VRTextureBounds_t* pBounds, vr::EVRSubmitFlags nSubmitFlags) { return fntable_Compositor_015_instance->Submit(eEye, pTexture, pBounds, nSubmitFlags); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_015_impl_ClearLastSubmittedFrame() { return fntable_Compositor_015_instance->ClearLastSubmittedFrame(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_015_impl_PostPresentHandoff() { return fntable_Compositor_015_instance->PostPresentHandoff(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_015_impl_GetFrameTiming(vr::IVRCompositor_015::Compositor_FrameTiming* pTiming, uint32_t unFramesAgo) { return fntable_Compositor_015_instance->GetFrameTiming(pTiming, unFramesAgo); }
static float OPENVR_FNTABLE_CALLTYPE fntable_Compositor_015_impl_GetFrameTimeRemaining() { return fntable_Compositor_015_instance->GetFrameTimeRemaining(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_015_impl_GetCumulativeStats(vr::IVRCompositor_015::Compositor_CumulativeStats* pStats, uint32_t nStatsSizeInBytes) { return fntable_Compositor_015_instance->GetCumulativeStats(pStats, nStatsSizeInBytes); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_015_impl_FadeToColor(float fSeconds, float fRed, float fGreen, float fBlue, float fAlpha, bool bBackground) { return fntable_Compositor_015_instance->FadeToColor(fSeconds, fRed, fGreen, fBlue, fAlpha, bBackground); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_015_impl_FadeGrid(float fSeconds, bool bFadeIn) { return fntable_Compositor_015_instance->FadeGrid(fSeconds, bFadeIn); }
static vr::IVRCompositor_015::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_015_impl_SetSkyboxOverride(const vr::Texture_t* pTextures, uint32_t unTextureCount) { return fntable_Compositor_015_instance->SetSkyboxOverride(pTextures, unTextureCount); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_015_impl_ClearSkyboxOverride() { return fntable_Compositor_015_instance->ClearSkyboxOverride(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_015_impl_CompositorBringToFront() { return fntable_Compositor_015_instance->CompositorBringToFront(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_015_impl_CompositorGoToBack() { return fntable_Compositor_015_instance->CompositorGoToBack(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_015_impl_CompositorQuit() { return fntable_Compositor_015_instance->CompositorQuit(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_015_impl_IsFullscreen() { return fntable_Compositor_015_instance->IsFullscreen(); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Compositor_015_impl_GetCurrentSceneFocusProcess() { return fntable_Compositor_015_instance->GetCurrentSceneFocusProcess(); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Compositor_015_impl_GetLastFrameRenderer() { return fntable_Compositor_015_instance->GetLastFrameRenderer(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_015_impl_CanRenderScene() { return fntable_Compositor_015_instance->CanRenderScene(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_015_impl_ShowMirrorWindow() { return fntable_Compositor_015_instance->ShowMirrorWindow(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_015_impl_HideMirrorWindow() { return fntable_Compositor_015_instance->HideMirrorWindow(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_015_impl_IsMirrorWindowVisible() { return fntable_Compositor_015_instance->IsMirrorWindowVisible(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_015_impl_CompositorDumpImages() { return fntable_Compositor_015_instance->CompositorDumpImages(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_015_impl_ShouldAppRenderWithLowResources() { return fntable_Compositor_015_instance->ShouldAppRenderWithLowResources(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_015_impl_ForceInterleavedReprojectionOn(bool bOverride) { return fntable_Compositor_015_instance->ForceInterleavedReprojectionOn(bOverride); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_015_impl_ForceReconnectProcess() { return fntable_Compositor_015_instance->ForceReconnectProcess(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_015_impl_SuspendRendering(bool bSuspend) { return fntable_Compositor_015_instance->SuspendRendering(bSuspend); }
static vr::IVRCompositor_015::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_015_impl_RequestScreenshot(vr::EVRScreenshotType type, const char* pchDestinationFileName, const char* pchVRDestinationFileName) { return fntable_Compositor_015_instance->RequestScreenshot(type, pchDestinationFileName, pchVRDestinationFileName); }
static vr::EVRScreenshotType OPENVR_FNTABLE_CALLTYPE fntable_Compositor_015_impl_GetCurrentScreenshotType() { return fntable_Compositor_015_instance->GetCurrentScreenshotType(); }
static vr::IVRCompositor_015::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_015_impl_GetMirrorTextureD3D11(vr::EVREye eEye, void* pD3D11DeviceOrResource, void** ppD3D11ShaderResourceView) { return fntable_Compositor_015_instance->GetMirrorTextureD3D11(eEye, pD3D11DeviceOrResource, ppD3D11ShaderResourceView); }
static vr::IVRCompositor_015::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_015_impl_GetMirrorTextureGL(vr::EVREye eEye, vr::glUInt_t* pglTextureId, vr::glSharedTextureHandle_t* pglSharedTextureHandle) { return fntable_Compositor_015_instance->GetMirrorTextureGL(eEye, pglTextureId, pglSharedTextureHandle); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_015_impl_ReleaseSharedGLTexture(vr::glUInt_t glTextureId, vr::glSharedTextureHandle_t glSharedTextureHandle) { return fntable_Compositor_015_instance->ReleaseSharedGLTexture(glTextureId, glSharedTextureHandle); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_015_impl_LockGLSharedTextureForAccess(vr::glSharedTextureHandle_t glSharedTextureHandle) { return fntable_Compositor_015_instance->LockGLSharedTextureForAccess(glSharedTextureHandle); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_015_impl_UnlockGLSharedTextureForAccess(vr::glSharedTextureHandle_t glSharedTextureHandle) { return fntable_Compositor_015_instance->UnlockGLSharedTextureForAccess(glSharedTextureHandle); }
static void *fntable_Compositor_015_funcs[] = {
	(void*) fntable_Compositor_015_impl_SetTrackingSpace,
	(void*) fntable_Compositor_015_impl_GetTrackingSpace,
	(void*) fntable_Compositor_015_impl_WaitGetPoses,
	(void*) fntable_Compositor_015_impl_GetLastPoses,
	(void*) fntable_Compositor_015_impl_GetLastPoseForTrackedDeviceIndex,
	(void*) fntable_Compositor_015_impl_Submit,
	(void*) fntable_Compositor_015_impl_ClearLastSubmittedFrame,
	(void*) fntable_Compositor_015_impl_PostPresentHandoff,
	(void*) fntable_Compositor_015_impl_GetFrameTiming,
	(void*) fntable_Compositor_015_impl_GetFrameTimeRemaining,
	(void*) fntable_Compositor_015_impl_GetCumulativeStats,
	(void*) fntable_Compositor_015_impl_FadeToColor,
	(void*) fntable_Compositor_015_impl_FadeGrid,
	(void*) fntable_Compositor_015_impl_SetSkyboxOverride,
	(void*) fntable_Compositor_015_impl_ClearSkyboxOverride,
	(void*) fntable_Compositor_015_impl_CompositorBringToFront,
	(void*) fntable_Compositor_015_impl_CompositorGoToBack,
	(void*) fntable_Compositor_015_impl_CompositorQuit,
	(void*) fntable_Compositor_015_impl_IsFullscreen,
	(void*) fntable_Compositor_015_impl_GetCurrentSceneFocusProcess,
	(void*) fntable_Compositor_015_impl_GetLastFrameRenderer,
	(void*) fntable_Compositor_015_impl_CanRenderScene,
	(void*) fntable_Compositor_015_impl_ShowMirrorWindow,
	(void*) fntable_Compositor_015_impl_HideMirrorWindow,
	(void*) fntable_Compositor_015_impl_IsMirrorWindowVisible,
	(void*) fntable_Compositor_015_impl_CompositorDumpImages,
	(void*) fntable_Compositor_015_impl_ShouldAppRenderWithLowResources,
	(void*) fntable_Compositor_015_impl_ForceInterleavedReprojectionOn,
	(void*) fntable_Compositor_015_impl_ForceReconnectProcess,
	(void*) fntable_Compositor_015_impl_SuspendRendering,
	(void*) fntable_Compositor_015_impl_RequestScreenshot,
	(void*) fntable_Compositor_015_impl_GetCurrentScreenshotType,
	(void*) fntable_Compositor_015_impl_GetMirrorTextureD3D11,
	(void*) fntable_Compositor_015_impl_GetMirrorTextureGL,
	(void*) fntable_Compositor_015_impl_ReleaseSharedGLTexture,
	(void*) fntable_Compositor_015_impl_LockGLSharedTextureForAccess,
	(void*) fntable_Compositor_015_impl_UnlockGLSharedTextureForAccess,
};
void** CVRCompositor_015::_GetStatFuncList() { fntable_Compositor_015_instance = this; return fntable_Compositor_015_funcs; }
void CVRCompositor_015::Delete() { delete this; }
// Misc for CVRCompositor_016:
CVRCompositor_016::CVRCompositor_016() : base(GetCreateBaseCompositor()) {}
// Interface methods for CVRCompositor_016:
void CVRCompositor_016::SetTrackingSpace(vr::ETrackingUniverseOrigin eOrigin) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_016)");
	return base->SetTrackingSpace(eOrigin);
}
vr::ETrackingUniverseOrigin CVRCompositor_016::GetTrackingSpace() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_016)");
	return base->GetTrackingSpace();
}
vr::IVRCompositor_016::EVRCompositorError CVRCompositor_016::WaitGetPoses(vr::TrackedDevicePose_t* pRenderPoseArray, uint32_t unRenderPoseArrayCount, vr::TrackedDevicePose_t* pGamePoseArray, uint32_t unGamePoseArrayCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_016)");
	return (vr::IVRCompositor_016::EVRCompositorError) base->WaitGetPoses(pRenderPoseArray, unRenderPoseArrayCount, pGamePoseArray, unGamePoseArrayCount);
}
vr::IVRCompositor_016::EVRCompositorError CVRCompositor_016::GetLastPoses(vr::TrackedDevicePose_t* pRenderPoseArray, uint32_t unRenderPoseArrayCount, vr::TrackedDevicePose_t* pGamePoseArray, uint32_t unGamePoseArrayCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_016)");
	return (vr::IVRCompositor_016::EVRCompositorError) base->GetLastPoses(pRenderPoseArray, unRenderPoseArrayCount, pGamePoseArray, unGamePoseArrayCount);
}
vr::IVRCompositor_016::EVRCompositorError CVRCompositor_016::GetLastPoseForTrackedDeviceIndex(vr::TrackedDeviceIndex_t unDeviceIndex, vr::TrackedDevicePose_t* pOutputPose, vr::TrackedDevicePose_t* pOutputGamePose) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_016)");
	return (vr::IVRCompositor_016::EVRCompositorError) base->GetLastPoseForTrackedDeviceIndex(unDeviceIndex, pOutputPose, pOutputGamePose);
}
vr::IVRCompositor_016::EVRCompositorError CVRCompositor_016::Submit(vr::EVREye eEye, const vr::Texture_t* pTexture, const vr::VRTextureBounds_t* pBounds, vr::EVRSubmitFlags nSubmitFlags) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_016)");
	return (vr::IVRCompositor_016::EVRCompositorError) base->Submit(eEye, pTexture, pBounds, nSubmitFlags);
}
void CVRCompositor_016::ClearLastSubmittedFrame() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_016)");
	return base->ClearLastSubmittedFrame();
}
void CVRCompositor_016::PostPresentHandoff() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_016)");
	return base->PostPresentHandoff();
}
bool CVRCompositor_016::GetFrameTiming(vr::IVRCompositor_016::Compositor_FrameTiming* pTiming, uint32_t unFramesAgo) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_016)");
	return base->GetFrameTiming((OOVR_Compositor_FrameTiming*) pTiming, unFramesAgo);
}
float CVRCompositor_016::GetFrameTimeRemaining() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_016)");
	return base->GetFrameTimeRemaining();
}
void CVRCompositor_016::GetCumulativeStats(vr::IVRCompositor_016::Compositor_CumulativeStats* pStats, uint32_t nStatsSizeInBytes) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_016)");
	return base->GetCumulativeStats((OOVR_Compositor_CumulativeStats*) pStats, nStatsSizeInBytes);
}
void CVRCompositor_016::FadeToColor(float fSeconds, float fRed, float fGreen, float fBlue, float fAlpha, bool bBackground) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_016)");
	return base->FadeToColor(fSeconds, fRed, fGreen, fBlue, fAlpha, bBackground);
}
void CVRCompositor_016::FadeGrid(float fSeconds, bool bFadeIn) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_016)");
	return base->FadeGrid(fSeconds, bFadeIn);
}
vr::IVRCompositor_016::EVRCompositorError CVRCompositor_016::SetSkyboxOverride(const vr::Texture_t* pTextures, uint32_t unTextureCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_016)");
	return (vr::IVRCompositor_016::EVRCompositorError) base->SetSkyboxOverride(pTextures, unTextureCount);
}
void CVRCompositor_016::ClearSkyboxOverride() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_016)");
	return base->ClearSkyboxOverride();
}
void CVRCompositor_016::CompositorBringToFront() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_016)");
	return base->CompositorBringToFront();
}
void CVRCompositor_016::CompositorGoToBack() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_016)");
	return base->CompositorGoToBack();
}
void CVRCompositor_016::CompositorQuit() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_016)");
	return base->CompositorQuit();
}
bool CVRCompositor_016::IsFullscreen() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_016)");
	return base->IsFullscreen();
}
uint32_t CVRCompositor_016::GetCurrentSceneFocusProcess() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_016)");
	return base->GetCurrentSceneFocusProcess();
}
uint32_t CVRCompositor_016::GetLastFrameRenderer() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_016)");
	return base->GetLastFrameRenderer();
}
bool CVRCompositor_016::CanRenderScene() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_016)");
	return base->CanRenderScene();
}
void CVRCompositor_016::ShowMirrorWindow() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_016)");
	return base->ShowMirrorWindow();
}
void CVRCompositor_016::HideMirrorWindow() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_016)");
	return base->HideMirrorWindow();
}
bool CVRCompositor_016::IsMirrorWindowVisible() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_016)");
	return base->IsMirrorWindowVisible();
}
void CVRCompositor_016::CompositorDumpImages() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_016)");
	return base->CompositorDumpImages();
}
bool CVRCompositor_016::ShouldAppRenderWithLowResources() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_016)");
	return base->ShouldAppRenderWithLowResources();
}
void CVRCompositor_016::ForceInterleavedReprojectionOn(bool bOverride) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_016)");
	return base->ForceInterleavedReprojectionOn(bOverride);
}
void CVRCompositor_016::ForceReconnectProcess() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_016)");
	return base->ForceReconnectProcess();
}
void CVRCompositor_016::SuspendRendering(bool bSuspend) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_016)");
	return base->SuspendRendering(bSuspend);
}
vr::IVRCompositor_016::EVRCompositorError CVRCompositor_016::GetMirrorTextureD3D11(vr::EVREye eEye, void* pD3D11DeviceOrResource, void** ppD3D11ShaderResourceView) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_016)");
	return (vr::IVRCompositor_016::EVRCompositorError) base->GetMirrorTextureD3D11(eEye, pD3D11DeviceOrResource, ppD3D11ShaderResourceView);
}
vr::IVRCompositor_016::EVRCompositorError CVRCompositor_016::GetMirrorTextureGL(vr::EVREye eEye, vr::glUInt_t* pglTextureId, vr::glSharedTextureHandle_t* pglSharedTextureHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_016)");
	return (vr::IVRCompositor_016::EVRCompositorError) base->GetMirrorTextureGL(eEye, pglTextureId, pglSharedTextureHandle);
}
bool CVRCompositor_016::ReleaseSharedGLTexture(vr::glUInt_t glTextureId, vr::glSharedTextureHandle_t glSharedTextureHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_016)");
	return base->ReleaseSharedGLTexture(glTextureId, glSharedTextureHandle);
}
void CVRCompositor_016::LockGLSharedTextureForAccess(vr::glSharedTextureHandle_t glSharedTextureHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_016)");
	return base->LockGLSharedTextureForAccess(glSharedTextureHandle);
}
void CVRCompositor_016::UnlockGLSharedTextureForAccess(vr::glSharedTextureHandle_t glSharedTextureHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_016)");
	return base->UnlockGLSharedTextureForAccess(glSharedTextureHandle);
}
// FnTable for CVRCompositor_016:
static CVRCompositor_016 *fntable_Compositor_016_instance = NULL;
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_016_impl_SetTrackingSpace(vr::ETrackingUniverseOrigin eOrigin) { return fntable_Compositor_016_instance->SetTrackingSpace(eOrigin); }
static vr::ETrackingUniverseOrigin OPENVR_FNTABLE_CALLTYPE fntable_Compositor_016_impl_GetTrackingSpace() { return fntable_Compositor_016_instance->GetTrackingSpace(); }
static vr::IVRCompositor_016::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_016_impl_WaitGetPoses(vr::TrackedDevicePose_t* pRenderPoseArray, uint32_t unRenderPoseArrayCount, vr::TrackedDevicePose_t* pGamePoseArray, uint32_t unGamePoseArrayCount) { return fntable_Compositor_016_instance->WaitGetPoses(pRenderPoseArray, unRenderPoseArrayCount, pGamePoseArray, unGamePoseArrayCount); }
static vr::IVRCompositor_016::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_016_impl_GetLastPoses(vr::TrackedDevicePose_t* pRenderPoseArray, uint32_t unRenderPoseArrayCount, vr::TrackedDevicePose_t* pGamePoseArray, uint32_t unGamePoseArrayCount) { return fntable_Compositor_016_instance->GetLastPoses(pRenderPoseArray, unRenderPoseArrayCount, pGamePoseArray, unGamePoseArrayCount); }
static vr::IVRCompositor_016::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_016_impl_GetLastPoseForTrackedDeviceIndex(vr::TrackedDeviceIndex_t unDeviceIndex, vr::TrackedDevicePose_t* pOutputPose, vr::TrackedDevicePose_t* pOutputGamePose) { return fntable_Compositor_016_instance->GetLastPoseForTrackedDeviceIndex(unDeviceIndex, pOutputPose, pOutputGamePose); }
static vr::IVRCompositor_016::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_016_impl_Submit(vr::EVREye eEye, const vr::Texture_t* pTexture, const vr::VRTextureBounds_t* pBounds, vr::EVRSubmitFlags nSubmitFlags) { return fntable_Compositor_016_instance->Submit(eEye, pTexture, pBounds, nSubmitFlags); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_016_impl_ClearLastSubmittedFrame() { return fntable_Compositor_016_instance->ClearLastSubmittedFrame(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_016_impl_PostPresentHandoff() { return fntable_Compositor_016_instance->PostPresentHandoff(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_016_impl_GetFrameTiming(vr::IVRCompositor_016::Compositor_FrameTiming* pTiming, uint32_t unFramesAgo) { return fntable_Compositor_016_instance->GetFrameTiming(pTiming, unFramesAgo); }
static float OPENVR_FNTABLE_CALLTYPE fntable_Compositor_016_impl_GetFrameTimeRemaining() { return fntable_Compositor_016_instance->GetFrameTimeRemaining(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_016_impl_GetCumulativeStats(vr::IVRCompositor_016::Compositor_CumulativeStats* pStats, uint32_t nStatsSizeInBytes) { return fntable_Compositor_016_instance->GetCumulativeStats(pStats, nStatsSizeInBytes); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_016_impl_FadeToColor(float fSeconds, float fRed, float fGreen, float fBlue, float fAlpha, bool bBackground) { return fntable_Compositor_016_instance->FadeToColor(fSeconds, fRed, fGreen, fBlue, fAlpha, bBackground); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_016_impl_FadeGrid(float fSeconds, bool bFadeIn) { return fntable_Compositor_016_instance->FadeGrid(fSeconds, bFadeIn); }
static vr::IVRCompositor_016::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_016_impl_SetSkyboxOverride(const vr::Texture_t* pTextures, uint32_t unTextureCount) { return fntable_Compositor_016_instance->SetSkyboxOverride(pTextures, unTextureCount); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_016_impl_ClearSkyboxOverride() { return fntable_Compositor_016_instance->ClearSkyboxOverride(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_016_impl_CompositorBringToFront() { return fntable_Compositor_016_instance->CompositorBringToFront(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_016_impl_CompositorGoToBack() { return fntable_Compositor_016_instance->CompositorGoToBack(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_016_impl_CompositorQuit() { return fntable_Compositor_016_instance->CompositorQuit(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_016_impl_IsFullscreen() { return fntable_Compositor_016_instance->IsFullscreen(); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Compositor_016_impl_GetCurrentSceneFocusProcess() { return fntable_Compositor_016_instance->GetCurrentSceneFocusProcess(); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Compositor_016_impl_GetLastFrameRenderer() { return fntable_Compositor_016_instance->GetLastFrameRenderer(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_016_impl_CanRenderScene() { return fntable_Compositor_016_instance->CanRenderScene(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_016_impl_ShowMirrorWindow() { return fntable_Compositor_016_instance->ShowMirrorWindow(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_016_impl_HideMirrorWindow() { return fntable_Compositor_016_instance->HideMirrorWindow(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_016_impl_IsMirrorWindowVisible() { return fntable_Compositor_016_instance->IsMirrorWindowVisible(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_016_impl_CompositorDumpImages() { return fntable_Compositor_016_instance->CompositorDumpImages(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_016_impl_ShouldAppRenderWithLowResources() { return fntable_Compositor_016_instance->ShouldAppRenderWithLowResources(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_016_impl_ForceInterleavedReprojectionOn(bool bOverride) { return fntable_Compositor_016_instance->ForceInterleavedReprojectionOn(bOverride); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_016_impl_ForceReconnectProcess() { return fntable_Compositor_016_instance->ForceReconnectProcess(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_016_impl_SuspendRendering(bool bSuspend) { return fntable_Compositor_016_instance->SuspendRendering(bSuspend); }
static vr::IVRCompositor_016::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_016_impl_GetMirrorTextureD3D11(vr::EVREye eEye, void* pD3D11DeviceOrResource, void** ppD3D11ShaderResourceView) { return fntable_Compositor_016_instance->GetMirrorTextureD3D11(eEye, pD3D11DeviceOrResource, ppD3D11ShaderResourceView); }
static vr::IVRCompositor_016::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_016_impl_GetMirrorTextureGL(vr::EVREye eEye, vr::glUInt_t* pglTextureId, vr::glSharedTextureHandle_t* pglSharedTextureHandle) { return fntable_Compositor_016_instance->GetMirrorTextureGL(eEye, pglTextureId, pglSharedTextureHandle); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_016_impl_ReleaseSharedGLTexture(vr::glUInt_t glTextureId, vr::glSharedTextureHandle_t glSharedTextureHandle) { return fntable_Compositor_016_instance->ReleaseSharedGLTexture(glTextureId, glSharedTextureHandle); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_016_impl_LockGLSharedTextureForAccess(vr::glSharedTextureHandle_t glSharedTextureHandle) { return fntable_Compositor_016_instance->LockGLSharedTextureForAccess(glSharedTextureHandle); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_016_impl_UnlockGLSharedTextureForAccess(vr::glSharedTextureHandle_t glSharedTextureHandle) { return fntable_Compositor_016_instance->UnlockGLSharedTextureForAccess(glSharedTextureHandle); }
static void *fntable_Compositor_016_funcs[] = {
	(void*) fntable_Compositor_016_impl_SetTrackingSpace,
	(void*) fntable_Compositor_016_impl_GetTrackingSpace,
	(void*) fntable_Compositor_016_impl_WaitGetPoses,
	(void*) fntable_Compositor_016_impl_GetLastPoses,
	(void*) fntable_Compositor_016_impl_GetLastPoseForTrackedDeviceIndex,
	(void*) fntable_Compositor_016_impl_Submit,
	(void*) fntable_Compositor_016_impl_ClearLastSubmittedFrame,
	(void*) fntable_Compositor_016_impl_PostPresentHandoff,
	(void*) fntable_Compositor_016_impl_GetFrameTiming,
	(void*) fntable_Compositor_016_impl_GetFrameTimeRemaining,
	(void*) fntable_Compositor_016_impl_GetCumulativeStats,
	(void*) fntable_Compositor_016_impl_FadeToColor,
	(void*) fntable_Compositor_016_impl_FadeGrid,
	(void*) fntable_Compositor_016_impl_SetSkyboxOverride,
	(void*) fntable_Compositor_016_impl_ClearSkyboxOverride,
	(void*) fntable_Compositor_016_impl_CompositorBringToFront,
	(void*) fntable_Compositor_016_impl_CompositorGoToBack,
	(void*) fntable_Compositor_016_impl_CompositorQuit,
	(void*) fntable_Compositor_016_impl_IsFullscreen,
	(void*) fntable_Compositor_016_impl_GetCurrentSceneFocusProcess,
	(void*) fntable_Compositor_016_impl_GetLastFrameRenderer,
	(void*) fntable_Compositor_016_impl_CanRenderScene,
	(void*) fntable_Compositor_016_impl_ShowMirrorWindow,
	(void*) fntable_Compositor_016_impl_HideMirrorWindow,
	(void*) fntable_Compositor_016_impl_IsMirrorWindowVisible,
	(void*) fntable_Compositor_016_impl_CompositorDumpImages,
	(void*) fntable_Compositor_016_impl_ShouldAppRenderWithLowResources,
	(void*) fntable_Compositor_016_impl_ForceInterleavedReprojectionOn,
	(void*) fntable_Compositor_016_impl_ForceReconnectProcess,
	(void*) fntable_Compositor_016_impl_SuspendRendering,
	(void*) fntable_Compositor_016_impl_GetMirrorTextureD3D11,
	(void*) fntable_Compositor_016_impl_GetMirrorTextureGL,
	(void*) fntable_Compositor_016_impl_ReleaseSharedGLTexture,
	(void*) fntable_Compositor_016_impl_LockGLSharedTextureForAccess,
	(void*) fntable_Compositor_016_impl_UnlockGLSharedTextureForAccess,
};
void** CVRCompositor_016::_GetStatFuncList() { fntable_Compositor_016_instance = this; return fntable_Compositor_016_funcs; }
void CVRCompositor_016::Delete() { delete this; }
// Misc for CVRCompositor_017:
CVRCompositor_017::CVRCompositor_017() : base(GetCreateBaseCompositor()) {}
// Interface methods for CVRCompositor_017:
void CVRCompositor_017::SetTrackingSpace(vr::ETrackingUniverseOrigin eOrigin) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_017)");
	return base->SetTrackingSpace(eOrigin);
}
vr::ETrackingUniverseOrigin CVRCompositor_017::GetTrackingSpace() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_017)");
	return base->GetTrackingSpace();
}
vr::IVRCompositor_017::EVRCompositorError CVRCompositor_017::WaitGetPoses(vr::TrackedDevicePose_t* pRenderPoseArray, uint32_t unRenderPoseArrayCount, vr::TrackedDevicePose_t* pGamePoseArray, uint32_t unGamePoseArrayCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_017)");
	return (vr::IVRCompositor_017::EVRCompositorError) base->WaitGetPoses(pRenderPoseArray, unRenderPoseArrayCount, pGamePoseArray, unGamePoseArrayCount);
}
vr::IVRCompositor_017::EVRCompositorError CVRCompositor_017::GetLastPoses(vr::TrackedDevicePose_t* pRenderPoseArray, uint32_t unRenderPoseArrayCount, vr::TrackedDevicePose_t* pGamePoseArray, uint32_t unGamePoseArrayCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_017)");
	return (vr::IVRCompositor_017::EVRCompositorError) base->GetLastPoses(pRenderPoseArray, unRenderPoseArrayCount, pGamePoseArray, unGamePoseArrayCount);
}
vr::IVRCompositor_017::EVRCompositorError CVRCompositor_017::GetLastPoseForTrackedDeviceIndex(vr::TrackedDeviceIndex_t unDeviceIndex, vr::TrackedDevicePose_t* pOutputPose, vr::TrackedDevicePose_t* pOutputGamePose) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_017)");
	return (vr::IVRCompositor_017::EVRCompositorError) base->GetLastPoseForTrackedDeviceIndex(unDeviceIndex, pOutputPose, pOutputGamePose);
}
vr::IVRCompositor_017::EVRCompositorError CVRCompositor_017::Submit(vr::EVREye eEye, const vr::Texture_t* pTexture, const vr::VRTextureBounds_t* pBounds, vr::EVRSubmitFlags nSubmitFlags) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_017)");
	return (vr::IVRCompositor_017::EVRCompositorError) base->Submit(eEye, pTexture, pBounds, nSubmitFlags);
}
void CVRCompositor_017::ClearLastSubmittedFrame() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_017)");
	return base->ClearLastSubmittedFrame();
}
void CVRCompositor_017::PostPresentHandoff() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_017)");
	return base->PostPresentHandoff();
}
bool CVRCompositor_017::GetFrameTiming(vr::IVRCompositor_017::Compositor_FrameTiming* pTiming, uint32_t unFramesAgo) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_017)");
	return base->GetFrameTiming((OOVR_Compositor_FrameTiming*) pTiming, unFramesAgo);
}
uint32_t CVRCompositor_017::GetFrameTimings(vr::IVRCompositor_017::Compositor_FrameTiming* pTiming, uint32_t nFrames) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_017)");
	return base->GetFrameTimings((OOVR_Compositor_FrameTiming*) pTiming, nFrames);
}
float CVRCompositor_017::GetFrameTimeRemaining() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_017)");
	return base->GetFrameTimeRemaining();
}
void CVRCompositor_017::GetCumulativeStats(vr::IVRCompositor_017::Compositor_CumulativeStats* pStats, uint32_t nStatsSizeInBytes) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_017)");
	return base->GetCumulativeStats((OOVR_Compositor_CumulativeStats*) pStats, nStatsSizeInBytes);
}
void CVRCompositor_017::FadeToColor(float fSeconds, float fRed, float fGreen, float fBlue, float fAlpha, bool bBackground) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_017)");
	return base->FadeToColor(fSeconds, fRed, fGreen, fBlue, fAlpha, bBackground);
}
void CVRCompositor_017::FadeGrid(float fSeconds, bool bFadeIn) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_017)");
	return base->FadeGrid(fSeconds, bFadeIn);
}
vr::IVRCompositor_017::EVRCompositorError CVRCompositor_017::SetSkyboxOverride(const vr::Texture_t* pTextures, uint32_t unTextureCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_017)");
	return (vr::IVRCompositor_017::EVRCompositorError) base->SetSkyboxOverride(pTextures, unTextureCount);
}
void CVRCompositor_017::ClearSkyboxOverride() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_017)");
	return base->ClearSkyboxOverride();
}
void CVRCompositor_017::CompositorBringToFront() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_017)");
	return base->CompositorBringToFront();
}
void CVRCompositor_017::CompositorGoToBack() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_017)");
	return base->CompositorGoToBack();
}
void CVRCompositor_017::CompositorQuit() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_017)");
	return base->CompositorQuit();
}
bool CVRCompositor_017::IsFullscreen() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_017)");
	return base->IsFullscreen();
}
uint32_t CVRCompositor_017::GetCurrentSceneFocusProcess() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_017)");
	return base->GetCurrentSceneFocusProcess();
}
uint32_t CVRCompositor_017::GetLastFrameRenderer() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_017)");
	return base->GetLastFrameRenderer();
}
bool CVRCompositor_017::CanRenderScene() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_017)");
	return base->CanRenderScene();
}
void CVRCompositor_017::ShowMirrorWindow() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_017)");
	return base->ShowMirrorWindow();
}
void CVRCompositor_017::HideMirrorWindow() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_017)");
	return base->HideMirrorWindow();
}
bool CVRCompositor_017::IsMirrorWindowVisible() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_017)");
	return base->IsMirrorWindowVisible();
}
void CVRCompositor_017::CompositorDumpImages() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_017)");
	return base->CompositorDumpImages();
}
bool CVRCompositor_017::ShouldAppRenderWithLowResources() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_017)");
	return base->ShouldAppRenderWithLowResources();
}
void CVRCompositor_017::ForceInterleavedReprojectionOn(bool bOverride) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_017)");
	return base->ForceInterleavedReprojectionOn(bOverride);
}
void CVRCompositor_017::ForceReconnectProcess() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_017)");
	return base->ForceReconnectProcess();
}
void CVRCompositor_017::SuspendRendering(bool bSuspend) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_017)");
	return base->SuspendRendering(bSuspend);
}
vr::IVRCompositor_017::EVRCompositorError CVRCompositor_017::GetMirrorTextureD3D11(vr::EVREye eEye, void* pD3D11DeviceOrResource, void** ppD3D11ShaderResourceView) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_017)");
	return (vr::IVRCompositor_017::EVRCompositorError) base->GetMirrorTextureD3D11(eEye, pD3D11DeviceOrResource, ppD3D11ShaderResourceView);
}
vr::IVRCompositor_017::EVRCompositorError CVRCompositor_017::GetMirrorTextureGL(vr::EVREye eEye, vr::glUInt_t* pglTextureId, vr::glSharedTextureHandle_t* pglSharedTextureHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_017)");
	return (vr::IVRCompositor_017::EVRCompositorError) base->GetMirrorTextureGL(eEye, pglTextureId, pglSharedTextureHandle);
}
bool CVRCompositor_017::ReleaseSharedGLTexture(vr::glUInt_t glTextureId, vr::glSharedTextureHandle_t glSharedTextureHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_017)");
	return base->ReleaseSharedGLTexture(glTextureId, glSharedTextureHandle);
}
void CVRCompositor_017::LockGLSharedTextureForAccess(vr::glSharedTextureHandle_t glSharedTextureHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_017)");
	return base->LockGLSharedTextureForAccess(glSharedTextureHandle);
}
void CVRCompositor_017::UnlockGLSharedTextureForAccess(vr::glSharedTextureHandle_t glSharedTextureHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_017)");
	return base->UnlockGLSharedTextureForAccess(glSharedTextureHandle);
}
// FnTable for CVRCompositor_017:
static CVRCompositor_017 *fntable_Compositor_017_instance = NULL;
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_017_impl_SetTrackingSpace(vr::ETrackingUniverseOrigin eOrigin) { return fntable_Compositor_017_instance->SetTrackingSpace(eOrigin); }
static vr::ETrackingUniverseOrigin OPENVR_FNTABLE_CALLTYPE fntable_Compositor_017_impl_GetTrackingSpace() { return fntable_Compositor_017_instance->GetTrackingSpace(); }
static vr::IVRCompositor_017::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_017_impl_WaitGetPoses(vr::TrackedDevicePose_t* pRenderPoseArray, uint32_t unRenderPoseArrayCount, vr::TrackedDevicePose_t* pGamePoseArray, uint32_t unGamePoseArrayCount) { return fntable_Compositor_017_instance->WaitGetPoses(pRenderPoseArray, unRenderPoseArrayCount, pGamePoseArray, unGamePoseArrayCount); }
static vr::IVRCompositor_017::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_017_impl_GetLastPoses(vr::TrackedDevicePose_t* pRenderPoseArray, uint32_t unRenderPoseArrayCount, vr::TrackedDevicePose_t* pGamePoseArray, uint32_t unGamePoseArrayCount) { return fntable_Compositor_017_instance->GetLastPoses(pRenderPoseArray, unRenderPoseArrayCount, pGamePoseArray, unGamePoseArrayCount); }
static vr::IVRCompositor_017::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_017_impl_GetLastPoseForTrackedDeviceIndex(vr::TrackedDeviceIndex_t unDeviceIndex, vr::TrackedDevicePose_t* pOutputPose, vr::TrackedDevicePose_t* pOutputGamePose) { return fntable_Compositor_017_instance->GetLastPoseForTrackedDeviceIndex(unDeviceIndex, pOutputPose, pOutputGamePose); }
static vr::IVRCompositor_017::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_017_impl_Submit(vr::EVREye eEye, const vr::Texture_t* pTexture, const vr::VRTextureBounds_t* pBounds, vr::EVRSubmitFlags nSubmitFlags) { return fntable_Compositor_017_instance->Submit(eEye, pTexture, pBounds, nSubmitFlags); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_017_impl_ClearLastSubmittedFrame() { return fntable_Compositor_017_instance->ClearLastSubmittedFrame(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_017_impl_PostPresentHandoff() { return fntable_Compositor_017_instance->PostPresentHandoff(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_017_impl_GetFrameTiming(vr::IVRCompositor_017::Compositor_FrameTiming* pTiming, uint32_t unFramesAgo) { return fntable_Compositor_017_instance->GetFrameTiming(pTiming, unFramesAgo); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Compositor_017_impl_GetFrameTimings(vr::IVRCompositor_017::Compositor_FrameTiming* pTiming, uint32_t nFrames) { return fntable_Compositor_017_instance->GetFrameTimings(pTiming, nFrames); }
static float OPENVR_FNTABLE_CALLTYPE fntable_Compositor_017_impl_GetFrameTimeRemaining() { return fntable_Compositor_017_instance->GetFrameTimeRemaining(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_017_impl_GetCumulativeStats(vr::IVRCompositor_017::Compositor_CumulativeStats* pStats, uint32_t nStatsSizeInBytes) { return fntable_Compositor_017_instance->GetCumulativeStats(pStats, nStatsSizeInBytes); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_017_impl_FadeToColor(float fSeconds, float fRed, float fGreen, float fBlue, float fAlpha, bool bBackground) { return fntable_Compositor_017_instance->FadeToColor(fSeconds, fRed, fGreen, fBlue, fAlpha, bBackground); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_017_impl_FadeGrid(float fSeconds, bool bFadeIn) { return fntable_Compositor_017_instance->FadeGrid(fSeconds, bFadeIn); }
static vr::IVRCompositor_017::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_017_impl_SetSkyboxOverride(const vr::Texture_t* pTextures, uint32_t unTextureCount) { return fntable_Compositor_017_instance->SetSkyboxOverride(pTextures, unTextureCount); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_017_impl_ClearSkyboxOverride() { return fntable_Compositor_017_instance->ClearSkyboxOverride(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_017_impl_CompositorBringToFront() { return fntable_Compositor_017_instance->CompositorBringToFront(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_017_impl_CompositorGoToBack() { return fntable_Compositor_017_instance->CompositorGoToBack(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_017_impl_CompositorQuit() { return fntable_Compositor_017_instance->CompositorQuit(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_017_impl_IsFullscreen() { return fntable_Compositor_017_instance->IsFullscreen(); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Compositor_017_impl_GetCurrentSceneFocusProcess() { return fntable_Compositor_017_instance->GetCurrentSceneFocusProcess(); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Compositor_017_impl_GetLastFrameRenderer() { return fntable_Compositor_017_instance->GetLastFrameRenderer(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_017_impl_CanRenderScene() { return fntable_Compositor_017_instance->CanRenderScene(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_017_impl_ShowMirrorWindow() { return fntable_Compositor_017_instance->ShowMirrorWindow(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_017_impl_HideMirrorWindow() { return fntable_Compositor_017_instance->HideMirrorWindow(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_017_impl_IsMirrorWindowVisible() { return fntable_Compositor_017_instance->IsMirrorWindowVisible(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_017_impl_CompositorDumpImages() { return fntable_Compositor_017_instance->CompositorDumpImages(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_017_impl_ShouldAppRenderWithLowResources() { return fntable_Compositor_017_instance->ShouldAppRenderWithLowResources(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_017_impl_ForceInterleavedReprojectionOn(bool bOverride) { return fntable_Compositor_017_instance->ForceInterleavedReprojectionOn(bOverride); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_017_impl_ForceReconnectProcess() { return fntable_Compositor_017_instance->ForceReconnectProcess(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_017_impl_SuspendRendering(bool bSuspend) { return fntable_Compositor_017_instance->SuspendRendering(bSuspend); }
static vr::IVRCompositor_017::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_017_impl_GetMirrorTextureD3D11(vr::EVREye eEye, void* pD3D11DeviceOrResource, void** ppD3D11ShaderResourceView) { return fntable_Compositor_017_instance->GetMirrorTextureD3D11(eEye, pD3D11DeviceOrResource, ppD3D11ShaderResourceView); }
static vr::IVRCompositor_017::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_017_impl_GetMirrorTextureGL(vr::EVREye eEye, vr::glUInt_t* pglTextureId, vr::glSharedTextureHandle_t* pglSharedTextureHandle) { return fntable_Compositor_017_instance->GetMirrorTextureGL(eEye, pglTextureId, pglSharedTextureHandle); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_017_impl_ReleaseSharedGLTexture(vr::glUInt_t glTextureId, vr::glSharedTextureHandle_t glSharedTextureHandle) { return fntable_Compositor_017_instance->ReleaseSharedGLTexture(glTextureId, glSharedTextureHandle); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_017_impl_LockGLSharedTextureForAccess(vr::glSharedTextureHandle_t glSharedTextureHandle) { return fntable_Compositor_017_instance->LockGLSharedTextureForAccess(glSharedTextureHandle); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_017_impl_UnlockGLSharedTextureForAccess(vr::glSharedTextureHandle_t glSharedTextureHandle) { return fntable_Compositor_017_instance->UnlockGLSharedTextureForAccess(glSharedTextureHandle); }
static void *fntable_Compositor_017_funcs[] = {
	(void*) fntable_Compositor_017_impl_SetTrackingSpace,
	(void*) fntable_Compositor_017_impl_GetTrackingSpace,
	(void*) fntable_Compositor_017_impl_WaitGetPoses,
	(void*) fntable_Compositor_017_impl_GetLastPoses,
	(void*) fntable_Compositor_017_impl_GetLastPoseForTrackedDeviceIndex,
	(void*) fntable_Compositor_017_impl_Submit,
	(void*) fntable_Compositor_017_impl_ClearLastSubmittedFrame,
	(void*) fntable_Compositor_017_impl_PostPresentHandoff,
	(void*) fntable_Compositor_017_impl_GetFrameTiming,
	(void*) fntable_Compositor_017_impl_GetFrameTimings,
	(void*) fntable_Compositor_017_impl_GetFrameTimeRemaining,
	(void*) fntable_Compositor_017_impl_GetCumulativeStats,
	(void*) fntable_Compositor_017_impl_FadeToColor,
	(void*) fntable_Compositor_017_impl_FadeGrid,
	(void*) fntable_Compositor_017_impl_SetSkyboxOverride,
	(void*) fntable_Compositor_017_impl_ClearSkyboxOverride,
	(void*) fntable_Compositor_017_impl_CompositorBringToFront,
	(void*) fntable_Compositor_017_impl_CompositorGoToBack,
	(void*) fntable_Compositor_017_impl_CompositorQuit,
	(void*) fntable_Compositor_017_impl_IsFullscreen,
	(void*) fntable_Compositor_017_impl_GetCurrentSceneFocusProcess,
	(void*) fntable_Compositor_017_impl_GetLastFrameRenderer,
	(void*) fntable_Compositor_017_impl_CanRenderScene,
	(void*) fntable_Compositor_017_impl_ShowMirrorWindow,
	(void*) fntable_Compositor_017_impl_HideMirrorWindow,
	(void*) fntable_Compositor_017_impl_IsMirrorWindowVisible,
	(void*) fntable_Compositor_017_impl_CompositorDumpImages,
	(void*) fntable_Compositor_017_impl_ShouldAppRenderWithLowResources,
	(void*) fntable_Compositor_017_impl_ForceInterleavedReprojectionOn,
	(void*) fntable_Compositor_017_impl_ForceReconnectProcess,
	(void*) fntable_Compositor_017_impl_SuspendRendering,
	(void*) fntable_Compositor_017_impl_GetMirrorTextureD3D11,
	(void*) fntable_Compositor_017_impl_GetMirrorTextureGL,
	(void*) fntable_Compositor_017_impl_ReleaseSharedGLTexture,
	(void*) fntable_Compositor_017_impl_LockGLSharedTextureForAccess,
	(void*) fntable_Compositor_017_impl_UnlockGLSharedTextureForAccess,
};
void** CVRCompositor_017::_GetStatFuncList() { fntable_Compositor_017_instance = this; return fntable_Compositor_017_funcs; }
void CVRCompositor_017::Delete() { delete this; }
// Misc for CVRCompositor_018:
CVRCompositor_018::CVRCompositor_018() : base(GetCreateBaseCompositor()) {}
// Interface methods for CVRCompositor_018:
void CVRCompositor_018::SetTrackingSpace(vr::ETrackingUniverseOrigin eOrigin) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_018)");
	return base->SetTrackingSpace(eOrigin);
}
vr::ETrackingUniverseOrigin CVRCompositor_018::GetTrackingSpace() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_018)");
	return base->GetTrackingSpace();
}
vr::IVRCompositor_018::EVRCompositorError CVRCompositor_018::WaitGetPoses(vr::TrackedDevicePose_t* pRenderPoseArray, uint32_t unRenderPoseArrayCount, vr::TrackedDevicePose_t* pGamePoseArray, uint32_t unGamePoseArrayCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_018)");
	return (vr::IVRCompositor_018::EVRCompositorError) base->WaitGetPoses(pRenderPoseArray, unRenderPoseArrayCount, pGamePoseArray, unGamePoseArrayCount);
}
vr::IVRCompositor_018::EVRCompositorError CVRCompositor_018::GetLastPoses(vr::TrackedDevicePose_t* pRenderPoseArray, uint32_t unRenderPoseArrayCount, vr::TrackedDevicePose_t* pGamePoseArray, uint32_t unGamePoseArrayCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_018)");
	return (vr::IVRCompositor_018::EVRCompositorError) base->GetLastPoses(pRenderPoseArray, unRenderPoseArrayCount, pGamePoseArray, unGamePoseArrayCount);
}
vr::IVRCompositor_018::EVRCompositorError CVRCompositor_018::GetLastPoseForTrackedDeviceIndex(vr::TrackedDeviceIndex_t unDeviceIndex, vr::TrackedDevicePose_t* pOutputPose, vr::TrackedDevicePose_t* pOutputGamePose) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_018)");
	return (vr::IVRCompositor_018::EVRCompositorError) base->GetLastPoseForTrackedDeviceIndex(unDeviceIndex, pOutputPose, pOutputGamePose);
}
vr::IVRCompositor_018::EVRCompositorError CVRCompositor_018::Submit(vr::EVREye eEye, const vr::Texture_t* pTexture, const vr::VRTextureBounds_t* pBounds, vr::EVRSubmitFlags nSubmitFlags) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_018)");
	return (vr::IVRCompositor_018::EVRCompositorError) base->Submit(eEye, pTexture, pBounds, nSubmitFlags);
}
void CVRCompositor_018::ClearLastSubmittedFrame() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_018)");
	return base->ClearLastSubmittedFrame();
}
void CVRCompositor_018::PostPresentHandoff() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_018)");
	return base->PostPresentHandoff();
}
bool CVRCompositor_018::GetFrameTiming(vr::IVRCompositor_018::Compositor_FrameTiming* pTiming, uint32_t unFramesAgo) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_018)");
	return base->GetFrameTiming((OOVR_Compositor_FrameTiming*) pTiming, unFramesAgo);
}
uint32_t CVRCompositor_018::GetFrameTimings(vr::IVRCompositor_018::Compositor_FrameTiming* pTiming, uint32_t nFrames) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_018)");
	return base->GetFrameTimings((OOVR_Compositor_FrameTiming*) pTiming, nFrames);
}
float CVRCompositor_018::GetFrameTimeRemaining() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_018)");
	return base->GetFrameTimeRemaining();
}
void CVRCompositor_018::GetCumulativeStats(vr::IVRCompositor_018::Compositor_CumulativeStats* pStats, uint32_t nStatsSizeInBytes) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_018)");
	return base->GetCumulativeStats((OOVR_Compositor_CumulativeStats*) pStats, nStatsSizeInBytes);
}
void CVRCompositor_018::FadeToColor(float fSeconds, float fRed, float fGreen, float fBlue, float fAlpha, bool bBackground) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_018)");
	return base->FadeToColor(fSeconds, fRed, fGreen, fBlue, fAlpha, bBackground);
}
vr::HmdColor_t CVRCompositor_018::GetCurrentFadeColor(bool bBackground) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_018)");
	return base->GetCurrentFadeColor(bBackground);
}
void CVRCompositor_018::FadeGrid(float fSeconds, bool bFadeIn) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_018)");
	return base->FadeGrid(fSeconds, bFadeIn);
}
float CVRCompositor_018::GetCurrentGridAlpha() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_018)");
	return base->GetCurrentGridAlpha();
}
vr::IVRCompositor_018::EVRCompositorError CVRCompositor_018::SetSkyboxOverride(const vr::Texture_t* pTextures, uint32_t unTextureCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_018)");
	return (vr::IVRCompositor_018::EVRCompositorError) base->SetSkyboxOverride(pTextures, unTextureCount);
}
void CVRCompositor_018::ClearSkyboxOverride() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_018)");
	return base->ClearSkyboxOverride();
}
void CVRCompositor_018::CompositorBringToFront() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_018)");
	return base->CompositorBringToFront();
}
void CVRCompositor_018::CompositorGoToBack() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_018)");
	return base->CompositorGoToBack();
}
void CVRCompositor_018::CompositorQuit() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_018)");
	return base->CompositorQuit();
}
bool CVRCompositor_018::IsFullscreen() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_018)");
	return base->IsFullscreen();
}
uint32_t CVRCompositor_018::GetCurrentSceneFocusProcess() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_018)");
	return base->GetCurrentSceneFocusProcess();
}
uint32_t CVRCompositor_018::GetLastFrameRenderer() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_018)");
	return base->GetLastFrameRenderer();
}
bool CVRCompositor_018::CanRenderScene() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_018)");
	return base->CanRenderScene();
}
void CVRCompositor_018::ShowMirrorWindow() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_018)");
	return base->ShowMirrorWindow();
}
void CVRCompositor_018::HideMirrorWindow() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_018)");
	return base->HideMirrorWindow();
}
bool CVRCompositor_018::IsMirrorWindowVisible() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_018)");
	return base->IsMirrorWindowVisible();
}
void CVRCompositor_018::CompositorDumpImages() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_018)");
	return base->CompositorDumpImages();
}
bool CVRCompositor_018::ShouldAppRenderWithLowResources() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_018)");
	return base->ShouldAppRenderWithLowResources();
}
void CVRCompositor_018::ForceInterleavedReprojectionOn(bool bOverride) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_018)");
	return base->ForceInterleavedReprojectionOn(bOverride);
}
void CVRCompositor_018::ForceReconnectProcess() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_018)");
	return base->ForceReconnectProcess();
}
void CVRCompositor_018::SuspendRendering(bool bSuspend) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_018)");
	return base->SuspendRendering(bSuspend);
}
vr::IVRCompositor_018::EVRCompositorError CVRCompositor_018::GetMirrorTextureD3D11(vr::EVREye eEye, void* pD3D11DeviceOrResource, void** ppD3D11ShaderResourceView) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_018)");
	return (vr::IVRCompositor_018::EVRCompositorError) base->GetMirrorTextureD3D11(eEye, pD3D11DeviceOrResource, ppD3D11ShaderResourceView);
}
vr::IVRCompositor_018::EVRCompositorError CVRCompositor_018::GetMirrorTextureGL(vr::EVREye eEye, vr::glUInt_t* pglTextureId, vr::glSharedTextureHandle_t* pglSharedTextureHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_018)");
	return (vr::IVRCompositor_018::EVRCompositorError) base->GetMirrorTextureGL(eEye, pglTextureId, pglSharedTextureHandle);
}
bool CVRCompositor_018::ReleaseSharedGLTexture(vr::glUInt_t glTextureId, vr::glSharedTextureHandle_t glSharedTextureHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_018)");
	return base->ReleaseSharedGLTexture(glTextureId, glSharedTextureHandle);
}
void CVRCompositor_018::LockGLSharedTextureForAccess(vr::glSharedTextureHandle_t glSharedTextureHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_018)");
	return base->LockGLSharedTextureForAccess(glSharedTextureHandle);
}
void CVRCompositor_018::UnlockGLSharedTextureForAccess(vr::glSharedTextureHandle_t glSharedTextureHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_018)");
	return base->UnlockGLSharedTextureForAccess(glSharedTextureHandle);
}
// FnTable for CVRCompositor_018:
static CVRCompositor_018 *fntable_Compositor_018_instance = NULL;
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_018_impl_SetTrackingSpace(vr::ETrackingUniverseOrigin eOrigin) { return fntable_Compositor_018_instance->SetTrackingSpace(eOrigin); }
static vr::ETrackingUniverseOrigin OPENVR_FNTABLE_CALLTYPE fntable_Compositor_018_impl_GetTrackingSpace() { return fntable_Compositor_018_instance->GetTrackingSpace(); }
static vr::IVRCompositor_018::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_018_impl_WaitGetPoses(vr::TrackedDevicePose_t* pRenderPoseArray, uint32_t unRenderPoseArrayCount, vr::TrackedDevicePose_t* pGamePoseArray, uint32_t unGamePoseArrayCount) { return fntable_Compositor_018_instance->WaitGetPoses(pRenderPoseArray, unRenderPoseArrayCount, pGamePoseArray, unGamePoseArrayCount); }
static vr::IVRCompositor_018::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_018_impl_GetLastPoses(vr::TrackedDevicePose_t* pRenderPoseArray, uint32_t unRenderPoseArrayCount, vr::TrackedDevicePose_t* pGamePoseArray, uint32_t unGamePoseArrayCount) { return fntable_Compositor_018_instance->GetLastPoses(pRenderPoseArray, unRenderPoseArrayCount, pGamePoseArray, unGamePoseArrayCount); }
static vr::IVRCompositor_018::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_018_impl_GetLastPoseForTrackedDeviceIndex(vr::TrackedDeviceIndex_t unDeviceIndex, vr::TrackedDevicePose_t* pOutputPose, vr::TrackedDevicePose_t* pOutputGamePose) { return fntable_Compositor_018_instance->GetLastPoseForTrackedDeviceIndex(unDeviceIndex, pOutputPose, pOutputGamePose); }
static vr::IVRCompositor_018::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_018_impl_Submit(vr::EVREye eEye, const vr::Texture_t* pTexture, const vr::VRTextureBounds_t* pBounds, vr::EVRSubmitFlags nSubmitFlags) { return fntable_Compositor_018_instance->Submit(eEye, pTexture, pBounds, nSubmitFlags); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_018_impl_ClearLastSubmittedFrame() { return fntable_Compositor_018_instance->ClearLastSubmittedFrame(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_018_impl_PostPresentHandoff() { return fntable_Compositor_018_instance->PostPresentHandoff(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_018_impl_GetFrameTiming(vr::IVRCompositor_018::Compositor_FrameTiming* pTiming, uint32_t unFramesAgo) { return fntable_Compositor_018_instance->GetFrameTiming(pTiming, unFramesAgo); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Compositor_018_impl_GetFrameTimings(vr::IVRCompositor_018::Compositor_FrameTiming* pTiming, uint32_t nFrames) { return fntable_Compositor_018_instance->GetFrameTimings(pTiming, nFrames); }
static float OPENVR_FNTABLE_CALLTYPE fntable_Compositor_018_impl_GetFrameTimeRemaining() { return fntable_Compositor_018_instance->GetFrameTimeRemaining(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_018_impl_GetCumulativeStats(vr::IVRCompositor_018::Compositor_CumulativeStats* pStats, uint32_t nStatsSizeInBytes) { return fntable_Compositor_018_instance->GetCumulativeStats(pStats, nStatsSizeInBytes); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_018_impl_FadeToColor(float fSeconds, float fRed, float fGreen, float fBlue, float fAlpha, bool bBackground) { return fntable_Compositor_018_instance->FadeToColor(fSeconds, fRed, fGreen, fBlue, fAlpha, bBackground); }
static vr::HmdColor_t OPENVR_FNTABLE_CALLTYPE fntable_Compositor_018_impl_GetCurrentFadeColor(bool bBackground) { return fntable_Compositor_018_instance->GetCurrentFadeColor(bBackground); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_018_impl_FadeGrid(float fSeconds, bool bFadeIn) { return fntable_Compositor_018_instance->FadeGrid(fSeconds, bFadeIn); }
static float OPENVR_FNTABLE_CALLTYPE fntable_Compositor_018_impl_GetCurrentGridAlpha() { return fntable_Compositor_018_instance->GetCurrentGridAlpha(); }
static vr::IVRCompositor_018::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_018_impl_SetSkyboxOverride(const vr::Texture_t* pTextures, uint32_t unTextureCount) { return fntable_Compositor_018_instance->SetSkyboxOverride(pTextures, unTextureCount); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_018_impl_ClearSkyboxOverride() { return fntable_Compositor_018_instance->ClearSkyboxOverride(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_018_impl_CompositorBringToFront() { return fntable_Compositor_018_instance->CompositorBringToFront(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_018_impl_CompositorGoToBack() { return fntable_Compositor_018_instance->CompositorGoToBack(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_018_impl_CompositorQuit() { return fntable_Compositor_018_instance->CompositorQuit(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_018_impl_IsFullscreen() { return fntable_Compositor_018_instance->IsFullscreen(); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Compositor_018_impl_GetCurrentSceneFocusProcess() { return fntable_Compositor_018_instance->GetCurrentSceneFocusProcess(); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Compositor_018_impl_GetLastFrameRenderer() { return fntable_Compositor_018_instance->GetLastFrameRenderer(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_018_impl_CanRenderScene() { return fntable_Compositor_018_instance->CanRenderScene(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_018_impl_ShowMirrorWindow() { return fntable_Compositor_018_instance->ShowMirrorWindow(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_018_impl_HideMirrorWindow() { return fntable_Compositor_018_instance->HideMirrorWindow(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_018_impl_IsMirrorWindowVisible() { return fntable_Compositor_018_instance->IsMirrorWindowVisible(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_018_impl_CompositorDumpImages() { return fntable_Compositor_018_instance->CompositorDumpImages(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_018_impl_ShouldAppRenderWithLowResources() { return fntable_Compositor_018_instance->ShouldAppRenderWithLowResources(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_018_impl_ForceInterleavedReprojectionOn(bool bOverride) { return fntable_Compositor_018_instance->ForceInterleavedReprojectionOn(bOverride); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_018_impl_ForceReconnectProcess() { return fntable_Compositor_018_instance->ForceReconnectProcess(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_018_impl_SuspendRendering(bool bSuspend) { return fntable_Compositor_018_instance->SuspendRendering(bSuspend); }
static vr::IVRCompositor_018::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_018_impl_GetMirrorTextureD3D11(vr::EVREye eEye, void* pD3D11DeviceOrResource, void** ppD3D11ShaderResourceView) { return fntable_Compositor_018_instance->GetMirrorTextureD3D11(eEye, pD3D11DeviceOrResource, ppD3D11ShaderResourceView); }
static vr::IVRCompositor_018::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_018_impl_GetMirrorTextureGL(vr::EVREye eEye, vr::glUInt_t* pglTextureId, vr::glSharedTextureHandle_t* pglSharedTextureHandle) { return fntable_Compositor_018_instance->GetMirrorTextureGL(eEye, pglTextureId, pglSharedTextureHandle); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_018_impl_ReleaseSharedGLTexture(vr::glUInt_t glTextureId, vr::glSharedTextureHandle_t glSharedTextureHandle) { return fntable_Compositor_018_instance->ReleaseSharedGLTexture(glTextureId, glSharedTextureHandle); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_018_impl_LockGLSharedTextureForAccess(vr::glSharedTextureHandle_t glSharedTextureHandle) { return fntable_Compositor_018_instance->LockGLSharedTextureForAccess(glSharedTextureHandle); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_018_impl_UnlockGLSharedTextureForAccess(vr::glSharedTextureHandle_t glSharedTextureHandle) { return fntable_Compositor_018_instance->UnlockGLSharedTextureForAccess(glSharedTextureHandle); }
static void *fntable_Compositor_018_funcs[] = {
	(void*) fntable_Compositor_018_impl_SetTrackingSpace,
	(void*) fntable_Compositor_018_impl_GetTrackingSpace,
	(void*) fntable_Compositor_018_impl_WaitGetPoses,
	(void*) fntable_Compositor_018_impl_GetLastPoses,
	(void*) fntable_Compositor_018_impl_GetLastPoseForTrackedDeviceIndex,
	(void*) fntable_Compositor_018_impl_Submit,
	(void*) fntable_Compositor_018_impl_ClearLastSubmittedFrame,
	(void*) fntable_Compositor_018_impl_PostPresentHandoff,
	(void*) fntable_Compositor_018_impl_GetFrameTiming,
	(void*) fntable_Compositor_018_impl_GetFrameTimings,
	(void*) fntable_Compositor_018_impl_GetFrameTimeRemaining,
	(void*) fntable_Compositor_018_impl_GetCumulativeStats,
	(void*) fntable_Compositor_018_impl_FadeToColor,
	(void*) fntable_Compositor_018_impl_GetCurrentFadeColor,
	(void*) fntable_Compositor_018_impl_FadeGrid,
	(void*) fntable_Compositor_018_impl_GetCurrentGridAlpha,
	(void*) fntable_Compositor_018_impl_SetSkyboxOverride,
	(void*) fntable_Compositor_018_impl_ClearSkyboxOverride,
	(void*) fntable_Compositor_018_impl_CompositorBringToFront,
	(void*) fntable_Compositor_018_impl_CompositorGoToBack,
	(void*) fntable_Compositor_018_impl_CompositorQuit,
	(void*) fntable_Compositor_018_impl_IsFullscreen,
	(void*) fntable_Compositor_018_impl_GetCurrentSceneFocusProcess,
	(void*) fntable_Compositor_018_impl_GetLastFrameRenderer,
	(void*) fntable_Compositor_018_impl_CanRenderScene,
	(void*) fntable_Compositor_018_impl_ShowMirrorWindow,
	(void*) fntable_Compositor_018_impl_HideMirrorWindow,
	(void*) fntable_Compositor_018_impl_IsMirrorWindowVisible,
	(void*) fntable_Compositor_018_impl_CompositorDumpImages,
	(void*) fntable_Compositor_018_impl_ShouldAppRenderWithLowResources,
	(void*) fntable_Compositor_018_impl_ForceInterleavedReprojectionOn,
	(void*) fntable_Compositor_018_impl_ForceReconnectProcess,
	(void*) fntable_Compositor_018_impl_SuspendRendering,
	(void*) fntable_Compositor_018_impl_GetMirrorTextureD3D11,
	(void*) fntable_Compositor_018_impl_GetMirrorTextureGL,
	(void*) fntable_Compositor_018_impl_ReleaseSharedGLTexture,
	(void*) fntable_Compositor_018_impl_LockGLSharedTextureForAccess,
	(void*) fntable_Compositor_018_impl_UnlockGLSharedTextureForAccess,
};
void** CVRCompositor_018::_GetStatFuncList() { fntable_Compositor_018_instance = this; return fntable_Compositor_018_funcs; }
void CVRCompositor_018::Delete() { delete this; }
// Misc for CVRCompositor_019:
CVRCompositor_019::CVRCompositor_019() : base(GetCreateBaseCompositor()) {}
// Interface methods for CVRCompositor_019:
void CVRCompositor_019::SetTrackingSpace(vr::ETrackingUniverseOrigin eOrigin) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_019)");
	return base->SetTrackingSpace(eOrigin);
}
vr::ETrackingUniverseOrigin CVRCompositor_019::GetTrackingSpace() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_019)");
	return base->GetTrackingSpace();
}
vr::IVRCompositor_019::EVRCompositorError CVRCompositor_019::WaitGetPoses(vr::TrackedDevicePose_t* pRenderPoseArray, uint32_t unRenderPoseArrayCount, vr::TrackedDevicePose_t* pGamePoseArray, uint32_t unGamePoseArrayCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_019)");
	return (vr::IVRCompositor_019::EVRCompositorError) base->WaitGetPoses(pRenderPoseArray, unRenderPoseArrayCount, pGamePoseArray, unGamePoseArrayCount);
}
vr::IVRCompositor_019::EVRCompositorError CVRCompositor_019::GetLastPoses(vr::TrackedDevicePose_t* pRenderPoseArray, uint32_t unRenderPoseArrayCount, vr::TrackedDevicePose_t* pGamePoseArray, uint32_t unGamePoseArrayCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_019)");
	return (vr::IVRCompositor_019::EVRCompositorError) base->GetLastPoses(pRenderPoseArray, unRenderPoseArrayCount, pGamePoseArray, unGamePoseArrayCount);
}
vr::IVRCompositor_019::EVRCompositorError CVRCompositor_019::GetLastPoseForTrackedDeviceIndex(vr::TrackedDeviceIndex_t unDeviceIndex, vr::TrackedDevicePose_t* pOutputPose, vr::TrackedDevicePose_t* pOutputGamePose) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_019)");
	return (vr::IVRCompositor_019::EVRCompositorError) base->GetLastPoseForTrackedDeviceIndex(unDeviceIndex, pOutputPose, pOutputGamePose);
}
vr::IVRCompositor_019::EVRCompositorError CVRCompositor_019::Submit(vr::EVREye eEye, const vr::Texture_t* pTexture, const vr::VRTextureBounds_t* pBounds, vr::EVRSubmitFlags nSubmitFlags) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_019)");
	return (vr::IVRCompositor_019::EVRCompositorError) base->Submit(eEye, pTexture, pBounds, nSubmitFlags);
}
void CVRCompositor_019::ClearLastSubmittedFrame() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_019)");
	return base->ClearLastSubmittedFrame();
}
void CVRCompositor_019::PostPresentHandoff() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_019)");
	return base->PostPresentHandoff();
}
bool CVRCompositor_019::GetFrameTiming(vr::IVRCompositor_019::Compositor_FrameTiming* pTiming, uint32_t unFramesAgo) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_019)");
	return base->GetFrameTiming((OOVR_Compositor_FrameTiming*) pTiming, unFramesAgo);
}
uint32_t CVRCompositor_019::GetFrameTimings(vr::IVRCompositor_019::Compositor_FrameTiming* pTiming, uint32_t nFrames) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_019)");
	return base->GetFrameTimings((OOVR_Compositor_FrameTiming*) pTiming, nFrames);
}
float CVRCompositor_019::GetFrameTimeRemaining() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_019)");
	return base->GetFrameTimeRemaining();
}
void CVRCompositor_019::GetCumulativeStats(vr::IVRCompositor_019::Compositor_CumulativeStats* pStats, uint32_t nStatsSizeInBytes) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_019)");
	return base->GetCumulativeStats((OOVR_Compositor_CumulativeStats*) pStats, nStatsSizeInBytes);
}
void CVRCompositor_019::FadeToColor(float fSeconds, float fRed, float fGreen, float fBlue, float fAlpha, bool bBackground) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_019)");
	return base->FadeToColor(fSeconds, fRed, fGreen, fBlue, fAlpha, bBackground);
}
vr::HmdColor_t CVRCompositor_019::GetCurrentFadeColor(bool bBackground) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_019)");
	return base->GetCurrentFadeColor(bBackground);
}
void CVRCompositor_019::FadeGrid(float fSeconds, bool bFadeIn) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_019)");
	return base->FadeGrid(fSeconds, bFadeIn);
}
float CVRCompositor_019::GetCurrentGridAlpha() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_019)");
	return base->GetCurrentGridAlpha();
}
vr::IVRCompositor_019::EVRCompositorError CVRCompositor_019::SetSkyboxOverride(const vr::Texture_t* pTextures, uint32_t unTextureCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_019)");
	return (vr::IVRCompositor_019::EVRCompositorError) base->SetSkyboxOverride(pTextures, unTextureCount);
}
void CVRCompositor_019::ClearSkyboxOverride() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_019)");
	return base->ClearSkyboxOverride();
}
void CVRCompositor_019::CompositorBringToFront() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_019)");
	return base->CompositorBringToFront();
}
void CVRCompositor_019::CompositorGoToBack() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_019)");
	return base->CompositorGoToBack();
}
void CVRCompositor_019::CompositorQuit() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_019)");
	return base->CompositorQuit();
}
bool CVRCompositor_019::IsFullscreen() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_019)");
	return base->IsFullscreen();
}
uint32_t CVRCompositor_019::GetCurrentSceneFocusProcess() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_019)");
	return base->GetCurrentSceneFocusProcess();
}
uint32_t CVRCompositor_019::GetLastFrameRenderer() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_019)");
	return base->GetLastFrameRenderer();
}
bool CVRCompositor_019::CanRenderScene() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_019)");
	return base->CanRenderScene();
}
void CVRCompositor_019::ShowMirrorWindow() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_019)");
	return base->ShowMirrorWindow();
}
void CVRCompositor_019::HideMirrorWindow() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_019)");
	return base->HideMirrorWindow();
}
bool CVRCompositor_019::IsMirrorWindowVisible() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_019)");
	return base->IsMirrorWindowVisible();
}
void CVRCompositor_019::CompositorDumpImages() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_019)");
	return base->CompositorDumpImages();
}
bool CVRCompositor_019::ShouldAppRenderWithLowResources() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_019)");
	return base->ShouldAppRenderWithLowResources();
}
void CVRCompositor_019::ForceInterleavedReprojectionOn(bool bOverride) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_019)");
	return base->ForceInterleavedReprojectionOn(bOverride);
}
void CVRCompositor_019::ForceReconnectProcess() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_019)");
	return base->ForceReconnectProcess();
}
void CVRCompositor_019::SuspendRendering(bool bSuspend) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_019)");
	return base->SuspendRendering(bSuspend);
}
vr::IVRCompositor_019::EVRCompositorError CVRCompositor_019::GetMirrorTextureD3D11(vr::EVREye eEye, void* pD3D11DeviceOrResource, void** ppD3D11ShaderResourceView) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_019)");
	return (vr::IVRCompositor_019::EVRCompositorError) base->GetMirrorTextureD3D11(eEye, pD3D11DeviceOrResource, ppD3D11ShaderResourceView);
}
vr::IVRCompositor_019::EVRCompositorError CVRCompositor_019::GetMirrorTextureGL(vr::EVREye eEye, vr::glUInt_t* pglTextureId, vr::glSharedTextureHandle_t* pglSharedTextureHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_019)");
	return (vr::IVRCompositor_019::EVRCompositorError) base->GetMirrorTextureGL(eEye, pglTextureId, pglSharedTextureHandle);
}
bool CVRCompositor_019::ReleaseSharedGLTexture(vr::glUInt_t glTextureId, vr::glSharedTextureHandle_t glSharedTextureHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_019)");
	return base->ReleaseSharedGLTexture(glTextureId, glSharedTextureHandle);
}
void CVRCompositor_019::LockGLSharedTextureForAccess(vr::glSharedTextureHandle_t glSharedTextureHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_019)");
	return base->LockGLSharedTextureForAccess(glSharedTextureHandle);
}
void CVRCompositor_019::UnlockGLSharedTextureForAccess(vr::glSharedTextureHandle_t glSharedTextureHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_019)");
	return base->UnlockGLSharedTextureForAccess(glSharedTextureHandle);
}
uint32_t CVRCompositor_019::GetVulkanInstanceExtensionsRequired(char* pchValue, uint32_t unBufferSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_019)");
	return base->GetVulkanInstanceExtensionsRequired(pchValue, unBufferSize);
}
uint32_t CVRCompositor_019::GetVulkanDeviceExtensionsRequired(VkPhysicalDevice_T* pPhysicalDevice, char* pchValue, uint32_t unBufferSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_019)");
	return base->GetVulkanDeviceExtensionsRequired(pPhysicalDevice, pchValue, unBufferSize);
}
// FnTable for CVRCompositor_019:
static CVRCompositor_019 *fntable_Compositor_019_instance = NULL;
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_019_impl_SetTrackingSpace(vr::ETrackingUniverseOrigin eOrigin) { return fntable_Compositor_019_instance->SetTrackingSpace(eOrigin); }
static vr::ETrackingUniverseOrigin OPENVR_FNTABLE_CALLTYPE fntable_Compositor_019_impl_GetTrackingSpace() { return fntable_Compositor_019_instance->GetTrackingSpace(); }
static vr::IVRCompositor_019::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_019_impl_WaitGetPoses(vr::TrackedDevicePose_t* pRenderPoseArray, uint32_t unRenderPoseArrayCount, vr::TrackedDevicePose_t* pGamePoseArray, uint32_t unGamePoseArrayCount) { return fntable_Compositor_019_instance->WaitGetPoses(pRenderPoseArray, unRenderPoseArrayCount, pGamePoseArray, unGamePoseArrayCount); }
static vr::IVRCompositor_019::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_019_impl_GetLastPoses(vr::TrackedDevicePose_t* pRenderPoseArray, uint32_t unRenderPoseArrayCount, vr::TrackedDevicePose_t* pGamePoseArray, uint32_t unGamePoseArrayCount) { return fntable_Compositor_019_instance->GetLastPoses(pRenderPoseArray, unRenderPoseArrayCount, pGamePoseArray, unGamePoseArrayCount); }
static vr::IVRCompositor_019::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_019_impl_GetLastPoseForTrackedDeviceIndex(vr::TrackedDeviceIndex_t unDeviceIndex, vr::TrackedDevicePose_t* pOutputPose, vr::TrackedDevicePose_t* pOutputGamePose) { return fntable_Compositor_019_instance->GetLastPoseForTrackedDeviceIndex(unDeviceIndex, pOutputPose, pOutputGamePose); }
static vr::IVRCompositor_019::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_019_impl_Submit(vr::EVREye eEye, const vr::Texture_t* pTexture, const vr::VRTextureBounds_t* pBounds, vr::EVRSubmitFlags nSubmitFlags) { return fntable_Compositor_019_instance->Submit(eEye, pTexture, pBounds, nSubmitFlags); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_019_impl_ClearLastSubmittedFrame() { return fntable_Compositor_019_instance->ClearLastSubmittedFrame(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_019_impl_PostPresentHandoff() { return fntable_Compositor_019_instance->PostPresentHandoff(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_019_impl_GetFrameTiming(vr::IVRCompositor_019::Compositor_FrameTiming* pTiming, uint32_t unFramesAgo) { return fntable_Compositor_019_instance->GetFrameTiming(pTiming, unFramesAgo); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Compositor_019_impl_GetFrameTimings(vr::IVRCompositor_019::Compositor_FrameTiming* pTiming, uint32_t nFrames) { return fntable_Compositor_019_instance->GetFrameTimings(pTiming, nFrames); }
static float OPENVR_FNTABLE_CALLTYPE fntable_Compositor_019_impl_GetFrameTimeRemaining() { return fntable_Compositor_019_instance->GetFrameTimeRemaining(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_019_impl_GetCumulativeStats(vr::IVRCompositor_019::Compositor_CumulativeStats* pStats, uint32_t nStatsSizeInBytes) { return fntable_Compositor_019_instance->GetCumulativeStats(pStats, nStatsSizeInBytes); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_019_impl_FadeToColor(float fSeconds, float fRed, float fGreen, float fBlue, float fAlpha, bool bBackground) { return fntable_Compositor_019_instance->FadeToColor(fSeconds, fRed, fGreen, fBlue, fAlpha, bBackground); }
static vr::HmdColor_t OPENVR_FNTABLE_CALLTYPE fntable_Compositor_019_impl_GetCurrentFadeColor(bool bBackground) { return fntable_Compositor_019_instance->GetCurrentFadeColor(bBackground); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_019_impl_FadeGrid(float fSeconds, bool bFadeIn) { return fntable_Compositor_019_instance->FadeGrid(fSeconds, bFadeIn); }
static float OPENVR_FNTABLE_CALLTYPE fntable_Compositor_019_impl_GetCurrentGridAlpha() { return fntable_Compositor_019_instance->GetCurrentGridAlpha(); }
static vr::IVRCompositor_019::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_019_impl_SetSkyboxOverride(const vr::Texture_t* pTextures, uint32_t unTextureCount) { return fntable_Compositor_019_instance->SetSkyboxOverride(pTextures, unTextureCount); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_019_impl_ClearSkyboxOverride() { return fntable_Compositor_019_instance->ClearSkyboxOverride(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_019_impl_CompositorBringToFront() { return fntable_Compositor_019_instance->CompositorBringToFront(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_019_impl_CompositorGoToBack() { return fntable_Compositor_019_instance->CompositorGoToBack(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_019_impl_CompositorQuit() { return fntable_Compositor_019_instance->CompositorQuit(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_019_impl_IsFullscreen() { return fntable_Compositor_019_instance->IsFullscreen(); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Compositor_019_impl_GetCurrentSceneFocusProcess() { return fntable_Compositor_019_instance->GetCurrentSceneFocusProcess(); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Compositor_019_impl_GetLastFrameRenderer() { return fntable_Compositor_019_instance->GetLastFrameRenderer(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_019_impl_CanRenderScene() { return fntable_Compositor_019_instance->CanRenderScene(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_019_impl_ShowMirrorWindow() { return fntable_Compositor_019_instance->ShowMirrorWindow(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_019_impl_HideMirrorWindow() { return fntable_Compositor_019_instance->HideMirrorWindow(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_019_impl_IsMirrorWindowVisible() { return fntable_Compositor_019_instance->IsMirrorWindowVisible(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_019_impl_CompositorDumpImages() { return fntable_Compositor_019_instance->CompositorDumpImages(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_019_impl_ShouldAppRenderWithLowResources() { return fntable_Compositor_019_instance->ShouldAppRenderWithLowResources(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_019_impl_ForceInterleavedReprojectionOn(bool bOverride) { return fntable_Compositor_019_instance->ForceInterleavedReprojectionOn(bOverride); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_019_impl_ForceReconnectProcess() { return fntable_Compositor_019_instance->ForceReconnectProcess(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_019_impl_SuspendRendering(bool bSuspend) { return fntable_Compositor_019_instance->SuspendRendering(bSuspend); }
static vr::IVRCompositor_019::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_019_impl_GetMirrorTextureD3D11(vr::EVREye eEye, void* pD3D11DeviceOrResource, void** ppD3D11ShaderResourceView) { return fntable_Compositor_019_instance->GetMirrorTextureD3D11(eEye, pD3D11DeviceOrResource, ppD3D11ShaderResourceView); }
static vr::IVRCompositor_019::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_019_impl_GetMirrorTextureGL(vr::EVREye eEye, vr::glUInt_t* pglTextureId, vr::glSharedTextureHandle_t* pglSharedTextureHandle) { return fntable_Compositor_019_instance->GetMirrorTextureGL(eEye, pglTextureId, pglSharedTextureHandle); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_019_impl_ReleaseSharedGLTexture(vr::glUInt_t glTextureId, vr::glSharedTextureHandle_t glSharedTextureHandle) { return fntable_Compositor_019_instance->ReleaseSharedGLTexture(glTextureId, glSharedTextureHandle); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_019_impl_LockGLSharedTextureForAccess(vr::glSharedTextureHandle_t glSharedTextureHandle) { return fntable_Compositor_019_instance->LockGLSharedTextureForAccess(glSharedTextureHandle); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_019_impl_UnlockGLSharedTextureForAccess(vr::glSharedTextureHandle_t glSharedTextureHandle) { return fntable_Compositor_019_instance->UnlockGLSharedTextureForAccess(glSharedTextureHandle); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Compositor_019_impl_GetVulkanInstanceExtensionsRequired(char* pchValue, uint32_t unBufferSize) { return fntable_Compositor_019_instance->GetVulkanInstanceExtensionsRequired(pchValue, unBufferSize); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Compositor_019_impl_GetVulkanDeviceExtensionsRequired(VkPhysicalDevice_T* pPhysicalDevice, char* pchValue, uint32_t unBufferSize) { return fntable_Compositor_019_instance->GetVulkanDeviceExtensionsRequired(pPhysicalDevice, pchValue, unBufferSize); }
static void *fntable_Compositor_019_funcs[] = {
	(void*) fntable_Compositor_019_impl_SetTrackingSpace,
	(void*) fntable_Compositor_019_impl_GetTrackingSpace,
	(void*) fntable_Compositor_019_impl_WaitGetPoses,
	(void*) fntable_Compositor_019_impl_GetLastPoses,
	(void*) fntable_Compositor_019_impl_GetLastPoseForTrackedDeviceIndex,
	(void*) fntable_Compositor_019_impl_Submit,
	(void*) fntable_Compositor_019_impl_ClearLastSubmittedFrame,
	(void*) fntable_Compositor_019_impl_PostPresentHandoff,
	(void*) fntable_Compositor_019_impl_GetFrameTiming,
	(void*) fntable_Compositor_019_impl_GetFrameTimings,
	(void*) fntable_Compositor_019_impl_GetFrameTimeRemaining,
	(void*) fntable_Compositor_019_impl_GetCumulativeStats,
	(void*) fntable_Compositor_019_impl_FadeToColor,
	(void*) fntable_Compositor_019_impl_GetCurrentFadeColor,
	(void*) fntable_Compositor_019_impl_FadeGrid,
	(void*) fntable_Compositor_019_impl_GetCurrentGridAlpha,
	(void*) fntable_Compositor_019_impl_SetSkyboxOverride,
	(void*) fntable_Compositor_019_impl_ClearSkyboxOverride,
	(void*) fntable_Compositor_019_impl_CompositorBringToFront,
	(void*) fntable_Compositor_019_impl_CompositorGoToBack,
	(void*) fntable_Compositor_019_impl_CompositorQuit,
	(void*) fntable_Compositor_019_impl_IsFullscreen,
	(void*) fntable_Compositor_019_impl_GetCurrentSceneFocusProcess,
	(void*) fntable_Compositor_019_impl_GetLastFrameRenderer,
	(void*) fntable_Compositor_019_impl_CanRenderScene,
	(void*) fntable_Compositor_019_impl_ShowMirrorWindow,
	(void*) fntable_Compositor_019_impl_HideMirrorWindow,
	(void*) fntable_Compositor_019_impl_IsMirrorWindowVisible,
	(void*) fntable_Compositor_019_impl_CompositorDumpImages,
	(void*) fntable_Compositor_019_impl_ShouldAppRenderWithLowResources,
	(void*) fntable_Compositor_019_impl_ForceInterleavedReprojectionOn,
	(void*) fntable_Compositor_019_impl_ForceReconnectProcess,
	(void*) fntable_Compositor_019_impl_SuspendRendering,
	(void*) fntable_Compositor_019_impl_GetMirrorTextureD3D11,
	(void*) fntable_Compositor_019_impl_GetMirrorTextureGL,
	(void*) fntable_Compositor_019_impl_ReleaseSharedGLTexture,
	(void*) fntable_Compositor_019_impl_LockGLSharedTextureForAccess,
	(void*) fntable_Compositor_019_impl_UnlockGLSharedTextureForAccess,
	(void*) fntable_Compositor_019_impl_GetVulkanInstanceExtensionsRequired,
	(void*) fntable_Compositor_019_impl_GetVulkanDeviceExtensionsRequired,
};
void** CVRCompositor_019::_GetStatFuncList() { fntable_Compositor_019_instance = this; return fntable_Compositor_019_funcs; }
void CVRCompositor_019::Delete() { delete this; }
// Misc for CVRCompositor_020:
CVRCompositor_020::CVRCompositor_020() : base(GetCreateBaseCompositor()) {}
// Interface methods for CVRCompositor_020:
void CVRCompositor_020::SetTrackingSpace(vr::ETrackingUniverseOrigin eOrigin) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_020)");
	return base->SetTrackingSpace(eOrigin);
}
vr::ETrackingUniverseOrigin CVRCompositor_020::GetTrackingSpace() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_020)");
	return base->GetTrackingSpace();
}
vr::IVRCompositor_020::EVRCompositorError CVRCompositor_020::WaitGetPoses(vr::TrackedDevicePose_t* pRenderPoseArray, uint32_t unRenderPoseArrayCount, vr::TrackedDevicePose_t* pGamePoseArray, uint32_t unGamePoseArrayCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_020)");
	return (vr::IVRCompositor_020::EVRCompositorError) base->WaitGetPoses(pRenderPoseArray, unRenderPoseArrayCount, pGamePoseArray, unGamePoseArrayCount);
}
vr::IVRCompositor_020::EVRCompositorError CVRCompositor_020::GetLastPoses(vr::TrackedDevicePose_t* pRenderPoseArray, uint32_t unRenderPoseArrayCount, vr::TrackedDevicePose_t* pGamePoseArray, uint32_t unGamePoseArrayCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_020)");
	return (vr::IVRCompositor_020::EVRCompositorError) base->GetLastPoses(pRenderPoseArray, unRenderPoseArrayCount, pGamePoseArray, unGamePoseArrayCount);
}
vr::IVRCompositor_020::EVRCompositorError CVRCompositor_020::GetLastPoseForTrackedDeviceIndex(vr::TrackedDeviceIndex_t unDeviceIndex, vr::TrackedDevicePose_t* pOutputPose, vr::TrackedDevicePose_t* pOutputGamePose) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_020)");
	return (vr::IVRCompositor_020::EVRCompositorError) base->GetLastPoseForTrackedDeviceIndex(unDeviceIndex, pOutputPose, pOutputGamePose);
}
vr::IVRCompositor_020::EVRCompositorError CVRCompositor_020::Submit(vr::EVREye eEye, const vr::Texture_t* pTexture, const vr::VRTextureBounds_t* pBounds, vr::EVRSubmitFlags nSubmitFlags) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_020)");
	return (vr::IVRCompositor_020::EVRCompositorError) base->Submit(eEye, pTexture, pBounds, nSubmitFlags);
}
void CVRCompositor_020::ClearLastSubmittedFrame() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_020)");
	return base->ClearLastSubmittedFrame();
}
void CVRCompositor_020::PostPresentHandoff() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_020)");
	return base->PostPresentHandoff();
}
bool CVRCompositor_020::GetFrameTiming(vr::IVRCompositor_020::Compositor_FrameTiming* pTiming, uint32_t unFramesAgo) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_020)");
	return base->GetFrameTiming((OOVR_Compositor_FrameTiming*) pTiming, unFramesAgo);
}
uint32_t CVRCompositor_020::GetFrameTimings(vr::IVRCompositor_020::Compositor_FrameTiming* pTiming, uint32_t nFrames) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_020)");
	return base->GetFrameTimings((OOVR_Compositor_FrameTiming*) pTiming, nFrames);
}
float CVRCompositor_020::GetFrameTimeRemaining() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_020)");
	return base->GetFrameTimeRemaining();
}
void CVRCompositor_020::GetCumulativeStats(vr::IVRCompositor_020::Compositor_CumulativeStats* pStats, uint32_t nStatsSizeInBytes) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_020)");
	return base->GetCumulativeStats((OOVR_Compositor_CumulativeStats*) pStats, nStatsSizeInBytes);
}
void CVRCompositor_020::FadeToColor(float fSeconds, float fRed, float fGreen, float fBlue, float fAlpha, bool bBackground) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_020)");
	return base->FadeToColor(fSeconds, fRed, fGreen, fBlue, fAlpha, bBackground);
}
vr::HmdColor_t CVRCompositor_020::GetCurrentFadeColor(bool bBackground) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_020)");
	return base->GetCurrentFadeColor(bBackground);
}
void CVRCompositor_020::FadeGrid(float fSeconds, bool bFadeIn) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_020)");
	return base->FadeGrid(fSeconds, bFadeIn);
}
float CVRCompositor_020::GetCurrentGridAlpha() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_020)");
	return base->GetCurrentGridAlpha();
}
vr::IVRCompositor_020::EVRCompositorError CVRCompositor_020::SetSkyboxOverride(const vr::Texture_t* pTextures, uint32_t unTextureCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_020)");
	return (vr::IVRCompositor_020::EVRCompositorError) base->SetSkyboxOverride(pTextures, unTextureCount);
}
void CVRCompositor_020::ClearSkyboxOverride() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_020)");
	return base->ClearSkyboxOverride();
}
void CVRCompositor_020::CompositorBringToFront() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_020)");
	return base->CompositorBringToFront();
}
void CVRCompositor_020::CompositorGoToBack() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_020)");
	return base->CompositorGoToBack();
}
void CVRCompositor_020::CompositorQuit() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_020)");
	return base->CompositorQuit();
}
bool CVRCompositor_020::IsFullscreen() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_020)");
	return base->IsFullscreen();
}
uint32_t CVRCompositor_020::GetCurrentSceneFocusProcess() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_020)");
	return base->GetCurrentSceneFocusProcess();
}
uint32_t CVRCompositor_020::GetLastFrameRenderer() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_020)");
	return base->GetLastFrameRenderer();
}
bool CVRCompositor_020::CanRenderScene() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_020)");
	return base->CanRenderScene();
}
void CVRCompositor_020::ShowMirrorWindow() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_020)");
	return base->ShowMirrorWindow();
}
void CVRCompositor_020::HideMirrorWindow() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_020)");
	return base->HideMirrorWindow();
}
bool CVRCompositor_020::IsMirrorWindowVisible() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_020)");
	return base->IsMirrorWindowVisible();
}
void CVRCompositor_020::CompositorDumpImages() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_020)");
	return base->CompositorDumpImages();
}
bool CVRCompositor_020::ShouldAppRenderWithLowResources() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_020)");
	return base->ShouldAppRenderWithLowResources();
}
void CVRCompositor_020::ForceInterleavedReprojectionOn(bool bOverride) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_020)");
	return base->ForceInterleavedReprojectionOn(bOverride);
}
void CVRCompositor_020::ForceReconnectProcess() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_020)");
	return base->ForceReconnectProcess();
}
void CVRCompositor_020::SuspendRendering(bool bSuspend) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_020)");
	return base->SuspendRendering(bSuspend);
}
vr::IVRCompositor_020::EVRCompositorError CVRCompositor_020::GetMirrorTextureD3D11(vr::EVREye eEye, void* pD3D11DeviceOrResource, void** ppD3D11ShaderResourceView) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_020)");
	return (vr::IVRCompositor_020::EVRCompositorError) base->GetMirrorTextureD3D11(eEye, pD3D11DeviceOrResource, ppD3D11ShaderResourceView);
}
void CVRCompositor_020::ReleaseMirrorTextureD3D11(void* pD3D11ShaderResourceView) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_020)");
	return base->ReleaseMirrorTextureD3D11(pD3D11ShaderResourceView);
}
vr::IVRCompositor_020::EVRCompositorError CVRCompositor_020::GetMirrorTextureGL(vr::EVREye eEye, vr::glUInt_t* pglTextureId, vr::glSharedTextureHandle_t* pglSharedTextureHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_020)");
	return (vr::IVRCompositor_020::EVRCompositorError) base->GetMirrorTextureGL(eEye, pglTextureId, pglSharedTextureHandle);
}
bool CVRCompositor_020::ReleaseSharedGLTexture(vr::glUInt_t glTextureId, vr::glSharedTextureHandle_t glSharedTextureHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_020)");
	return base->ReleaseSharedGLTexture(glTextureId, glSharedTextureHandle);
}
void CVRCompositor_020::LockGLSharedTextureForAccess(vr::glSharedTextureHandle_t glSharedTextureHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_020)");
	return base->LockGLSharedTextureForAccess(glSharedTextureHandle);
}
void CVRCompositor_020::UnlockGLSharedTextureForAccess(vr::glSharedTextureHandle_t glSharedTextureHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_020)");
	return base->UnlockGLSharedTextureForAccess(glSharedTextureHandle);
}
uint32_t CVRCompositor_020::GetVulkanInstanceExtensionsRequired(char* pchValue, uint32_t unBufferSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_020)");
	return base->GetVulkanInstanceExtensionsRequired(pchValue, unBufferSize);
}
uint32_t CVRCompositor_020::GetVulkanDeviceExtensionsRequired(VkPhysicalDevice_T* pPhysicalDevice, char* pchValue, uint32_t unBufferSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_020)");
	return base->GetVulkanDeviceExtensionsRequired(pPhysicalDevice, pchValue, unBufferSize);
}
// FnTable for CVRCompositor_020:
static CVRCompositor_020 *fntable_Compositor_020_instance = NULL;
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_020_impl_SetTrackingSpace(vr::ETrackingUniverseOrigin eOrigin) { return fntable_Compositor_020_instance->SetTrackingSpace(eOrigin); }
static vr::ETrackingUniverseOrigin OPENVR_FNTABLE_CALLTYPE fntable_Compositor_020_impl_GetTrackingSpace() { return fntable_Compositor_020_instance->GetTrackingSpace(); }
static vr::IVRCompositor_020::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_020_impl_WaitGetPoses(vr::TrackedDevicePose_t* pRenderPoseArray, uint32_t unRenderPoseArrayCount, vr::TrackedDevicePose_t* pGamePoseArray, uint32_t unGamePoseArrayCount) { return fntable_Compositor_020_instance->WaitGetPoses(pRenderPoseArray, unRenderPoseArrayCount, pGamePoseArray, unGamePoseArrayCount); }
static vr::IVRCompositor_020::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_020_impl_GetLastPoses(vr::TrackedDevicePose_t* pRenderPoseArray, uint32_t unRenderPoseArrayCount, vr::TrackedDevicePose_t* pGamePoseArray, uint32_t unGamePoseArrayCount) { return fntable_Compositor_020_instance->GetLastPoses(pRenderPoseArray, unRenderPoseArrayCount, pGamePoseArray, unGamePoseArrayCount); }
static vr::IVRCompositor_020::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_020_impl_GetLastPoseForTrackedDeviceIndex(vr::TrackedDeviceIndex_t unDeviceIndex, vr::TrackedDevicePose_t* pOutputPose, vr::TrackedDevicePose_t* pOutputGamePose) { return fntable_Compositor_020_instance->GetLastPoseForTrackedDeviceIndex(unDeviceIndex, pOutputPose, pOutputGamePose); }
static vr::IVRCompositor_020::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_020_impl_Submit(vr::EVREye eEye, const vr::Texture_t* pTexture, const vr::VRTextureBounds_t* pBounds, vr::EVRSubmitFlags nSubmitFlags) { return fntable_Compositor_020_instance->Submit(eEye, pTexture, pBounds, nSubmitFlags); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_020_impl_ClearLastSubmittedFrame() { return fntable_Compositor_020_instance->ClearLastSubmittedFrame(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_020_impl_PostPresentHandoff() { return fntable_Compositor_020_instance->PostPresentHandoff(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_020_impl_GetFrameTiming(vr::IVRCompositor_020::Compositor_FrameTiming* pTiming, uint32_t unFramesAgo) { return fntable_Compositor_020_instance->GetFrameTiming(pTiming, unFramesAgo); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Compositor_020_impl_GetFrameTimings(vr::IVRCompositor_020::Compositor_FrameTiming* pTiming, uint32_t nFrames) { return fntable_Compositor_020_instance->GetFrameTimings(pTiming, nFrames); }
static float OPENVR_FNTABLE_CALLTYPE fntable_Compositor_020_impl_GetFrameTimeRemaining() { return fntable_Compositor_020_instance->GetFrameTimeRemaining(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_020_impl_GetCumulativeStats(vr::IVRCompositor_020::Compositor_CumulativeStats* pStats, uint32_t nStatsSizeInBytes) { return fntable_Compositor_020_instance->GetCumulativeStats(pStats, nStatsSizeInBytes); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_020_impl_FadeToColor(float fSeconds, float fRed, float fGreen, float fBlue, float fAlpha, bool bBackground) { return fntable_Compositor_020_instance->FadeToColor(fSeconds, fRed, fGreen, fBlue, fAlpha, bBackground); }
static vr::HmdColor_t OPENVR_FNTABLE_CALLTYPE fntable_Compositor_020_impl_GetCurrentFadeColor(bool bBackground) { return fntable_Compositor_020_instance->GetCurrentFadeColor(bBackground); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_020_impl_FadeGrid(float fSeconds, bool bFadeIn) { return fntable_Compositor_020_instance->FadeGrid(fSeconds, bFadeIn); }
static float OPENVR_FNTABLE_CALLTYPE fntable_Compositor_020_impl_GetCurrentGridAlpha() { return fntable_Compositor_020_instance->GetCurrentGridAlpha(); }
static vr::IVRCompositor_020::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_020_impl_SetSkyboxOverride(const vr::Texture_t* pTextures, uint32_t unTextureCount) { return fntable_Compositor_020_instance->SetSkyboxOverride(pTextures, unTextureCount); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_020_impl_ClearSkyboxOverride() { return fntable_Compositor_020_instance->ClearSkyboxOverride(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_020_impl_CompositorBringToFront() { return fntable_Compositor_020_instance->CompositorBringToFront(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_020_impl_CompositorGoToBack() { return fntable_Compositor_020_instance->CompositorGoToBack(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_020_impl_CompositorQuit() { return fntable_Compositor_020_instance->CompositorQuit(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_020_impl_IsFullscreen() { return fntable_Compositor_020_instance->IsFullscreen(); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Compositor_020_impl_GetCurrentSceneFocusProcess() { return fntable_Compositor_020_instance->GetCurrentSceneFocusProcess(); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Compositor_020_impl_GetLastFrameRenderer() { return fntable_Compositor_020_instance->GetLastFrameRenderer(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_020_impl_CanRenderScene() { return fntable_Compositor_020_instance->CanRenderScene(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_020_impl_ShowMirrorWindow() { return fntable_Compositor_020_instance->ShowMirrorWindow(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_020_impl_HideMirrorWindow() { return fntable_Compositor_020_instance->HideMirrorWindow(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_020_impl_IsMirrorWindowVisible() { return fntable_Compositor_020_instance->IsMirrorWindowVisible(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_020_impl_CompositorDumpImages() { return fntable_Compositor_020_instance->CompositorDumpImages(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_020_impl_ShouldAppRenderWithLowResources() { return fntable_Compositor_020_instance->ShouldAppRenderWithLowResources(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_020_impl_ForceInterleavedReprojectionOn(bool bOverride) { return fntable_Compositor_020_instance->ForceInterleavedReprojectionOn(bOverride); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_020_impl_ForceReconnectProcess() { return fntable_Compositor_020_instance->ForceReconnectProcess(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_020_impl_SuspendRendering(bool bSuspend) { return fntable_Compositor_020_instance->SuspendRendering(bSuspend); }
static vr::IVRCompositor_020::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_020_impl_GetMirrorTextureD3D11(vr::EVREye eEye, void* pD3D11DeviceOrResource, void** ppD3D11ShaderResourceView) { return fntable_Compositor_020_instance->GetMirrorTextureD3D11(eEye, pD3D11DeviceOrResource, ppD3D11ShaderResourceView); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_020_impl_ReleaseMirrorTextureD3D11(void* pD3D11ShaderResourceView) { return fntable_Compositor_020_instance->ReleaseMirrorTextureD3D11(pD3D11ShaderResourceView); }
static vr::IVRCompositor_020::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_020_impl_GetMirrorTextureGL(vr::EVREye eEye, vr::glUInt_t* pglTextureId, vr::glSharedTextureHandle_t* pglSharedTextureHandle) { return fntable_Compositor_020_instance->GetMirrorTextureGL(eEye, pglTextureId, pglSharedTextureHandle); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_020_impl_ReleaseSharedGLTexture(vr::glUInt_t glTextureId, vr::glSharedTextureHandle_t glSharedTextureHandle) { return fntable_Compositor_020_instance->ReleaseSharedGLTexture(glTextureId, glSharedTextureHandle); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_020_impl_LockGLSharedTextureForAccess(vr::glSharedTextureHandle_t glSharedTextureHandle) { return fntable_Compositor_020_instance->LockGLSharedTextureForAccess(glSharedTextureHandle); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_020_impl_UnlockGLSharedTextureForAccess(vr::glSharedTextureHandle_t glSharedTextureHandle) { return fntable_Compositor_020_instance->UnlockGLSharedTextureForAccess(glSharedTextureHandle); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Compositor_020_impl_GetVulkanInstanceExtensionsRequired(char* pchValue, uint32_t unBufferSize) { return fntable_Compositor_020_instance->GetVulkanInstanceExtensionsRequired(pchValue, unBufferSize); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Compositor_020_impl_GetVulkanDeviceExtensionsRequired(VkPhysicalDevice_T* pPhysicalDevice, char* pchValue, uint32_t unBufferSize) { return fntable_Compositor_020_instance->GetVulkanDeviceExtensionsRequired(pPhysicalDevice, pchValue, unBufferSize); }
static void *fntable_Compositor_020_funcs[] = {
	(void*) fntable_Compositor_020_impl_SetTrackingSpace,
	(void*) fntable_Compositor_020_impl_GetTrackingSpace,
	(void*) fntable_Compositor_020_impl_WaitGetPoses,
	(void*) fntable_Compositor_020_impl_GetLastPoses,
	(void*) fntable_Compositor_020_impl_GetLastPoseForTrackedDeviceIndex,
	(void*) fntable_Compositor_020_impl_Submit,
	(void*) fntable_Compositor_020_impl_ClearLastSubmittedFrame,
	(void*) fntable_Compositor_020_impl_PostPresentHandoff,
	(void*) fntable_Compositor_020_impl_GetFrameTiming,
	(void*) fntable_Compositor_020_impl_GetFrameTimings,
	(void*) fntable_Compositor_020_impl_GetFrameTimeRemaining,
	(void*) fntable_Compositor_020_impl_GetCumulativeStats,
	(void*) fntable_Compositor_020_impl_FadeToColor,
	(void*) fntable_Compositor_020_impl_GetCurrentFadeColor,
	(void*) fntable_Compositor_020_impl_FadeGrid,
	(void*) fntable_Compositor_020_impl_GetCurrentGridAlpha,
	(void*) fntable_Compositor_020_impl_SetSkyboxOverride,
	(void*) fntable_Compositor_020_impl_ClearSkyboxOverride,
	(void*) fntable_Compositor_020_impl_CompositorBringToFront,
	(void*) fntable_Compositor_020_impl_CompositorGoToBack,
	(void*) fntable_Compositor_020_impl_CompositorQuit,
	(void*) fntable_Compositor_020_impl_IsFullscreen,
	(void*) fntable_Compositor_020_impl_GetCurrentSceneFocusProcess,
	(void*) fntable_Compositor_020_impl_GetLastFrameRenderer,
	(void*) fntable_Compositor_020_impl_CanRenderScene,
	(void*) fntable_Compositor_020_impl_ShowMirrorWindow,
	(void*) fntable_Compositor_020_impl_HideMirrorWindow,
	(void*) fntable_Compositor_020_impl_IsMirrorWindowVisible,
	(void*) fntable_Compositor_020_impl_CompositorDumpImages,
	(void*) fntable_Compositor_020_impl_ShouldAppRenderWithLowResources,
	(void*) fntable_Compositor_020_impl_ForceInterleavedReprojectionOn,
	(void*) fntable_Compositor_020_impl_ForceReconnectProcess,
	(void*) fntable_Compositor_020_impl_SuspendRendering,
	(void*) fntable_Compositor_020_impl_GetMirrorTextureD3D11,
	(void*) fntable_Compositor_020_impl_ReleaseMirrorTextureD3D11,
	(void*) fntable_Compositor_020_impl_GetMirrorTextureGL,
	(void*) fntable_Compositor_020_impl_ReleaseSharedGLTexture,
	(void*) fntable_Compositor_020_impl_LockGLSharedTextureForAccess,
	(void*) fntable_Compositor_020_impl_UnlockGLSharedTextureForAccess,
	(void*) fntable_Compositor_020_impl_GetVulkanInstanceExtensionsRequired,
	(void*) fntable_Compositor_020_impl_GetVulkanDeviceExtensionsRequired,
};
void** CVRCompositor_020::_GetStatFuncList() { fntable_Compositor_020_instance = this; return fntable_Compositor_020_funcs; }
void CVRCompositor_020::Delete() { delete this; }
// Misc for CVRCompositor_021:
CVRCompositor_021::CVRCompositor_021() : base(GetCreateBaseCompositor()) {}
// Interface methods for CVRCompositor_021:
void CVRCompositor_021::SetTrackingSpace(vr::ETrackingUniverseOrigin eOrigin) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_021)");
	return base->SetTrackingSpace(eOrigin);
}
vr::ETrackingUniverseOrigin CVRCompositor_021::GetTrackingSpace() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_021)");
	return base->GetTrackingSpace();
}
vr::IVRCompositor_021::EVRCompositorError CVRCompositor_021::WaitGetPoses(vr::TrackedDevicePose_t* pRenderPoseArray, uint32_t unRenderPoseArrayCount, vr::TrackedDevicePose_t* pGamePoseArray, uint32_t unGamePoseArrayCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_021)");
	return (vr::IVRCompositor_021::EVRCompositorError) base->WaitGetPoses(pRenderPoseArray, unRenderPoseArrayCount, pGamePoseArray, unGamePoseArrayCount);
}
vr::IVRCompositor_021::EVRCompositorError CVRCompositor_021::GetLastPoses(vr::TrackedDevicePose_t* pRenderPoseArray, uint32_t unRenderPoseArrayCount, vr::TrackedDevicePose_t* pGamePoseArray, uint32_t unGamePoseArrayCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_021)");
	return (vr::IVRCompositor_021::EVRCompositorError) base->GetLastPoses(pRenderPoseArray, unRenderPoseArrayCount, pGamePoseArray, unGamePoseArrayCount);
}
vr::IVRCompositor_021::EVRCompositorError CVRCompositor_021::GetLastPoseForTrackedDeviceIndex(vr::TrackedDeviceIndex_t unDeviceIndex, vr::TrackedDevicePose_t* pOutputPose, vr::TrackedDevicePose_t* pOutputGamePose) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_021)");
	return (vr::IVRCompositor_021::EVRCompositorError) base->GetLastPoseForTrackedDeviceIndex(unDeviceIndex, pOutputPose, pOutputGamePose);
}
vr::IVRCompositor_021::EVRCompositorError CVRCompositor_021::Submit(vr::EVREye eEye, const vr::Texture_t* pTexture, const vr::VRTextureBounds_t* pBounds, vr::EVRSubmitFlags nSubmitFlags) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_021)");
	return (vr::IVRCompositor_021::EVRCompositorError) base->Submit(eEye, pTexture, pBounds, nSubmitFlags);
}
void CVRCompositor_021::ClearLastSubmittedFrame() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_021)");
	return base->ClearLastSubmittedFrame();
}
void CVRCompositor_021::PostPresentHandoff() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_021)");
	return base->PostPresentHandoff();
}
bool CVRCompositor_021::GetFrameTiming(vr::IVRCompositor_021::Compositor_FrameTiming* pTiming, uint32_t unFramesAgo) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_021)");
	return base->GetFrameTiming((OOVR_Compositor_FrameTiming*) pTiming, unFramesAgo);
}
uint32_t CVRCompositor_021::GetFrameTimings(vr::IVRCompositor_021::Compositor_FrameTiming* pTiming, uint32_t nFrames) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_021)");
	return base->GetFrameTimings((OOVR_Compositor_FrameTiming*) pTiming, nFrames);
}
float CVRCompositor_021::GetFrameTimeRemaining() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_021)");
	return base->GetFrameTimeRemaining();
}
void CVRCompositor_021::GetCumulativeStats(vr::IVRCompositor_021::Compositor_CumulativeStats* pStats, uint32_t nStatsSizeInBytes) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_021)");
	return base->GetCumulativeStats((OOVR_Compositor_CumulativeStats*) pStats, nStatsSizeInBytes);
}
void CVRCompositor_021::FadeToColor(float fSeconds, float fRed, float fGreen, float fBlue, float fAlpha, bool bBackground) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_021)");
	return base->FadeToColor(fSeconds, fRed, fGreen, fBlue, fAlpha, bBackground);
}
vr::HmdColor_t CVRCompositor_021::GetCurrentFadeColor(bool bBackground) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_021)");
	return base->GetCurrentFadeColor(bBackground);
}
void CVRCompositor_021::FadeGrid(float fSeconds, bool bFadeIn) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_021)");
	return base->FadeGrid(fSeconds, bFadeIn);
}
float CVRCompositor_021::GetCurrentGridAlpha() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_021)");
	return base->GetCurrentGridAlpha();
}
vr::IVRCompositor_021::EVRCompositorError CVRCompositor_021::SetSkyboxOverride(const vr::Texture_t* pTextures, uint32_t unTextureCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_021)");
	return (vr::IVRCompositor_021::EVRCompositorError) base->SetSkyboxOverride(pTextures, unTextureCount);
}
void CVRCompositor_021::ClearSkyboxOverride() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_021)");
	return base->ClearSkyboxOverride();
}
void CVRCompositor_021::CompositorBringToFront() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_021)");
	return base->CompositorBringToFront();
}
void CVRCompositor_021::CompositorGoToBack() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_021)");
	return base->CompositorGoToBack();
}
void CVRCompositor_021::CompositorQuit() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_021)");
	return base->CompositorQuit();
}
bool CVRCompositor_021::IsFullscreen() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_021)");
	return base->IsFullscreen();
}
uint32_t CVRCompositor_021::GetCurrentSceneFocusProcess() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_021)");
	return base->GetCurrentSceneFocusProcess();
}
uint32_t CVRCompositor_021::GetLastFrameRenderer() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_021)");
	return base->GetLastFrameRenderer();
}
bool CVRCompositor_021::CanRenderScene() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_021)");
	return base->CanRenderScene();
}
void CVRCompositor_021::ShowMirrorWindow() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_021)");
	return base->ShowMirrorWindow();
}
void CVRCompositor_021::HideMirrorWindow() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_021)");
	return base->HideMirrorWindow();
}
bool CVRCompositor_021::IsMirrorWindowVisible() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_021)");
	return base->IsMirrorWindowVisible();
}
void CVRCompositor_021::CompositorDumpImages() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_021)");
	return base->CompositorDumpImages();
}
bool CVRCompositor_021::ShouldAppRenderWithLowResources() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_021)");
	return base->ShouldAppRenderWithLowResources();
}
void CVRCompositor_021::ForceInterleavedReprojectionOn(bool bOverride) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_021)");
	return base->ForceInterleavedReprojectionOn(bOverride);
}
void CVRCompositor_021::ForceReconnectProcess() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_021)");
	return base->ForceReconnectProcess();
}
void CVRCompositor_021::SuspendRendering(bool bSuspend) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_021)");
	return base->SuspendRendering(bSuspend);
}
vr::IVRCompositor_021::EVRCompositorError CVRCompositor_021::GetMirrorTextureD3D11(vr::EVREye eEye, void* pD3D11DeviceOrResource, void** ppD3D11ShaderResourceView) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_021)");
	return (vr::IVRCompositor_021::EVRCompositorError) base->GetMirrorTextureD3D11(eEye, pD3D11DeviceOrResource, ppD3D11ShaderResourceView);
}
void CVRCompositor_021::ReleaseMirrorTextureD3D11(void* pD3D11ShaderResourceView) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_021)");
	return base->ReleaseMirrorTextureD3D11(pD3D11ShaderResourceView);
}
vr::IVRCompositor_021::EVRCompositorError CVRCompositor_021::GetMirrorTextureGL(vr::EVREye eEye, vr::glUInt_t* pglTextureId, vr::glSharedTextureHandle_t* pglSharedTextureHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_021)");
	return (vr::IVRCompositor_021::EVRCompositorError) base->GetMirrorTextureGL(eEye, pglTextureId, pglSharedTextureHandle);
}
bool CVRCompositor_021::ReleaseSharedGLTexture(vr::glUInt_t glTextureId, vr::glSharedTextureHandle_t glSharedTextureHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_021)");
	return base->ReleaseSharedGLTexture(glTextureId, glSharedTextureHandle);
}
void CVRCompositor_021::LockGLSharedTextureForAccess(vr::glSharedTextureHandle_t glSharedTextureHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_021)");
	return base->LockGLSharedTextureForAccess(glSharedTextureHandle);
}
void CVRCompositor_021::UnlockGLSharedTextureForAccess(vr::glSharedTextureHandle_t glSharedTextureHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_021)");
	return base->UnlockGLSharedTextureForAccess(glSharedTextureHandle);
}
uint32_t CVRCompositor_021::GetVulkanInstanceExtensionsRequired(char* pchValue, uint32_t unBufferSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_021)");
	return base->GetVulkanInstanceExtensionsRequired(pchValue, unBufferSize);
}
uint32_t CVRCompositor_021::GetVulkanDeviceExtensionsRequired(VkPhysicalDevice_T* pPhysicalDevice, char* pchValue, uint32_t unBufferSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_021)");
	return base->GetVulkanDeviceExtensionsRequired(pPhysicalDevice, pchValue, unBufferSize);
}
void CVRCompositor_021::SetExplicitTimingMode(bool bExplicitTimingMode) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_021)");
	return base->SetExplicitTimingMode(bExplicitTimingMode);
}
vr::IVRCompositor_021::EVRCompositorError CVRCompositor_021::SubmitExplicitTimingData() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_021)");
	return (vr::IVRCompositor_021::EVRCompositorError) base->SubmitExplicitTimingData();
}
// FnTable for CVRCompositor_021:
static CVRCompositor_021 *fntable_Compositor_021_instance = NULL;
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_021_impl_SetTrackingSpace(vr::ETrackingUniverseOrigin eOrigin) { return fntable_Compositor_021_instance->SetTrackingSpace(eOrigin); }
static vr::ETrackingUniverseOrigin OPENVR_FNTABLE_CALLTYPE fntable_Compositor_021_impl_GetTrackingSpace() { return fntable_Compositor_021_instance->GetTrackingSpace(); }
static vr::IVRCompositor_021::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_021_impl_WaitGetPoses(vr::TrackedDevicePose_t* pRenderPoseArray, uint32_t unRenderPoseArrayCount, vr::TrackedDevicePose_t* pGamePoseArray, uint32_t unGamePoseArrayCount) { return fntable_Compositor_021_instance->WaitGetPoses(pRenderPoseArray, unRenderPoseArrayCount, pGamePoseArray, unGamePoseArrayCount); }
static vr::IVRCompositor_021::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_021_impl_GetLastPoses(vr::TrackedDevicePose_t* pRenderPoseArray, uint32_t unRenderPoseArrayCount, vr::TrackedDevicePose_t* pGamePoseArray, uint32_t unGamePoseArrayCount) { return fntable_Compositor_021_instance->GetLastPoses(pRenderPoseArray, unRenderPoseArrayCount, pGamePoseArray, unGamePoseArrayCount); }
static vr::IVRCompositor_021::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_021_impl_GetLastPoseForTrackedDeviceIndex(vr::TrackedDeviceIndex_t unDeviceIndex, vr::TrackedDevicePose_t* pOutputPose, vr::TrackedDevicePose_t* pOutputGamePose) { return fntable_Compositor_021_instance->GetLastPoseForTrackedDeviceIndex(unDeviceIndex, pOutputPose, pOutputGamePose); }
static vr::IVRCompositor_021::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_021_impl_Submit(vr::EVREye eEye, const vr::Texture_t* pTexture, const vr::VRTextureBounds_t* pBounds, vr::EVRSubmitFlags nSubmitFlags) { return fntable_Compositor_021_instance->Submit(eEye, pTexture, pBounds, nSubmitFlags); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_021_impl_ClearLastSubmittedFrame() { return fntable_Compositor_021_instance->ClearLastSubmittedFrame(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_021_impl_PostPresentHandoff() { return fntable_Compositor_021_instance->PostPresentHandoff(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_021_impl_GetFrameTiming(vr::IVRCompositor_021::Compositor_FrameTiming* pTiming, uint32_t unFramesAgo) { return fntable_Compositor_021_instance->GetFrameTiming(pTiming, unFramesAgo); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Compositor_021_impl_GetFrameTimings(vr::IVRCompositor_021::Compositor_FrameTiming* pTiming, uint32_t nFrames) { return fntable_Compositor_021_instance->GetFrameTimings(pTiming, nFrames); }
static float OPENVR_FNTABLE_CALLTYPE fntable_Compositor_021_impl_GetFrameTimeRemaining() { return fntable_Compositor_021_instance->GetFrameTimeRemaining(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_021_impl_GetCumulativeStats(vr::IVRCompositor_021::Compositor_CumulativeStats* pStats, uint32_t nStatsSizeInBytes) { return fntable_Compositor_021_instance->GetCumulativeStats(pStats, nStatsSizeInBytes); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_021_impl_FadeToColor(float fSeconds, float fRed, float fGreen, float fBlue, float fAlpha, bool bBackground) { return fntable_Compositor_021_instance->FadeToColor(fSeconds, fRed, fGreen, fBlue, fAlpha, bBackground); }
static vr::HmdColor_t OPENVR_FNTABLE_CALLTYPE fntable_Compositor_021_impl_GetCurrentFadeColor(bool bBackground) { return fntable_Compositor_021_instance->GetCurrentFadeColor(bBackground); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_021_impl_FadeGrid(float fSeconds, bool bFadeIn) { return fntable_Compositor_021_instance->FadeGrid(fSeconds, bFadeIn); }
static float OPENVR_FNTABLE_CALLTYPE fntable_Compositor_021_impl_GetCurrentGridAlpha() { return fntable_Compositor_021_instance->GetCurrentGridAlpha(); }
static vr::IVRCompositor_021::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_021_impl_SetSkyboxOverride(const vr::Texture_t* pTextures, uint32_t unTextureCount) { return fntable_Compositor_021_instance->SetSkyboxOverride(pTextures, unTextureCount); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_021_impl_ClearSkyboxOverride() { return fntable_Compositor_021_instance->ClearSkyboxOverride(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_021_impl_CompositorBringToFront() { return fntable_Compositor_021_instance->CompositorBringToFront(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_021_impl_CompositorGoToBack() { return fntable_Compositor_021_instance->CompositorGoToBack(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_021_impl_CompositorQuit() { return fntable_Compositor_021_instance->CompositorQuit(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_021_impl_IsFullscreen() { return fntable_Compositor_021_instance->IsFullscreen(); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Compositor_021_impl_GetCurrentSceneFocusProcess() { return fntable_Compositor_021_instance->GetCurrentSceneFocusProcess(); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Compositor_021_impl_GetLastFrameRenderer() { return fntable_Compositor_021_instance->GetLastFrameRenderer(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_021_impl_CanRenderScene() { return fntable_Compositor_021_instance->CanRenderScene(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_021_impl_ShowMirrorWindow() { return fntable_Compositor_021_instance->ShowMirrorWindow(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_021_impl_HideMirrorWindow() { return fntable_Compositor_021_instance->HideMirrorWindow(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_021_impl_IsMirrorWindowVisible() { return fntable_Compositor_021_instance->IsMirrorWindowVisible(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_021_impl_CompositorDumpImages() { return fntable_Compositor_021_instance->CompositorDumpImages(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_021_impl_ShouldAppRenderWithLowResources() { return fntable_Compositor_021_instance->ShouldAppRenderWithLowResources(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_021_impl_ForceInterleavedReprojectionOn(bool bOverride) { return fntable_Compositor_021_instance->ForceInterleavedReprojectionOn(bOverride); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_021_impl_ForceReconnectProcess() { return fntable_Compositor_021_instance->ForceReconnectProcess(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_021_impl_SuspendRendering(bool bSuspend) { return fntable_Compositor_021_instance->SuspendRendering(bSuspend); }
static vr::IVRCompositor_021::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_021_impl_GetMirrorTextureD3D11(vr::EVREye eEye, void* pD3D11DeviceOrResource, void** ppD3D11ShaderResourceView) { return fntable_Compositor_021_instance->GetMirrorTextureD3D11(eEye, pD3D11DeviceOrResource, ppD3D11ShaderResourceView); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_021_impl_ReleaseMirrorTextureD3D11(void* pD3D11ShaderResourceView) { return fntable_Compositor_021_instance->ReleaseMirrorTextureD3D11(pD3D11ShaderResourceView); }
static vr::IVRCompositor_021::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_021_impl_GetMirrorTextureGL(vr::EVREye eEye, vr::glUInt_t* pglTextureId, vr::glSharedTextureHandle_t* pglSharedTextureHandle) { return fntable_Compositor_021_instance->GetMirrorTextureGL(eEye, pglTextureId, pglSharedTextureHandle); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_021_impl_ReleaseSharedGLTexture(vr::glUInt_t glTextureId, vr::glSharedTextureHandle_t glSharedTextureHandle) { return fntable_Compositor_021_instance->ReleaseSharedGLTexture(glTextureId, glSharedTextureHandle); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_021_impl_LockGLSharedTextureForAccess(vr::glSharedTextureHandle_t glSharedTextureHandle) { return fntable_Compositor_021_instance->LockGLSharedTextureForAccess(glSharedTextureHandle); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_021_impl_UnlockGLSharedTextureForAccess(vr::glSharedTextureHandle_t glSharedTextureHandle) { return fntable_Compositor_021_instance->UnlockGLSharedTextureForAccess(glSharedTextureHandle); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Compositor_021_impl_GetVulkanInstanceExtensionsRequired(char* pchValue, uint32_t unBufferSize) { return fntable_Compositor_021_instance->GetVulkanInstanceExtensionsRequired(pchValue, unBufferSize); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Compositor_021_impl_GetVulkanDeviceExtensionsRequired(VkPhysicalDevice_T* pPhysicalDevice, char* pchValue, uint32_t unBufferSize) { return fntable_Compositor_021_instance->GetVulkanDeviceExtensionsRequired(pPhysicalDevice, pchValue, unBufferSize); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_021_impl_SetExplicitTimingMode(bool bExplicitTimingMode) { return fntable_Compositor_021_instance->SetExplicitTimingMode(bExplicitTimingMode); }
static vr::IVRCompositor_021::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_021_impl_SubmitExplicitTimingData() { return fntable_Compositor_021_instance->SubmitExplicitTimingData(); }
static void *fntable_Compositor_021_funcs[] = {
	(void*) fntable_Compositor_021_impl_SetTrackingSpace,
	(void*) fntable_Compositor_021_impl_GetTrackingSpace,
	(void*) fntable_Compositor_021_impl_WaitGetPoses,
	(void*) fntable_Compositor_021_impl_GetLastPoses,
	(void*) fntable_Compositor_021_impl_GetLastPoseForTrackedDeviceIndex,
	(void*) fntable_Compositor_021_impl_Submit,
	(void*) fntable_Compositor_021_impl_ClearLastSubmittedFrame,
	(void*) fntable_Compositor_021_impl_PostPresentHandoff,
	(void*) fntable_Compositor_021_impl_GetFrameTiming,
	(void*) fntable_Compositor_021_impl_GetFrameTimings,
	(void*) fntable_Compositor_021_impl_GetFrameTimeRemaining,
	(void*) fntable_Compositor_021_impl_GetCumulativeStats,
	(void*) fntable_Compositor_021_impl_FadeToColor,
	(void*) fntable_Compositor_021_impl_GetCurrentFadeColor,
	(void*) fntable_Compositor_021_impl_FadeGrid,
	(void*) fntable_Compositor_021_impl_GetCurrentGridAlpha,
	(void*) fntable_Compositor_021_impl_SetSkyboxOverride,
	(void*) fntable_Compositor_021_impl_ClearSkyboxOverride,
	(void*) fntable_Compositor_021_impl_CompositorBringToFront,
	(void*) fntable_Compositor_021_impl_CompositorGoToBack,
	(void*) fntable_Compositor_021_impl_CompositorQuit,
	(void*) fntable_Compositor_021_impl_IsFullscreen,
	(void*) fntable_Compositor_021_impl_GetCurrentSceneFocusProcess,
	(void*) fntable_Compositor_021_impl_GetLastFrameRenderer,
	(void*) fntable_Compositor_021_impl_CanRenderScene,
	(void*) fntable_Compositor_021_impl_ShowMirrorWindow,
	(void*) fntable_Compositor_021_impl_HideMirrorWindow,
	(void*) fntable_Compositor_021_impl_IsMirrorWindowVisible,
	(void*) fntable_Compositor_021_impl_CompositorDumpImages,
	(void*) fntable_Compositor_021_impl_ShouldAppRenderWithLowResources,
	(void*) fntable_Compositor_021_impl_ForceInterleavedReprojectionOn,
	(void*) fntable_Compositor_021_impl_ForceReconnectProcess,
	(void*) fntable_Compositor_021_impl_SuspendRendering,
	(void*) fntable_Compositor_021_impl_GetMirrorTextureD3D11,
	(void*) fntable_Compositor_021_impl_ReleaseMirrorTextureD3D11,
	(void*) fntable_Compositor_021_impl_GetMirrorTextureGL,
	(void*) fntable_Compositor_021_impl_ReleaseSharedGLTexture,
	(void*) fntable_Compositor_021_impl_LockGLSharedTextureForAccess,
	(void*) fntable_Compositor_021_impl_UnlockGLSharedTextureForAccess,
	(void*) fntable_Compositor_021_impl_GetVulkanInstanceExtensionsRequired,
	(void*) fntable_Compositor_021_impl_GetVulkanDeviceExtensionsRequired,
	(void*) fntable_Compositor_021_impl_SetExplicitTimingMode,
	(void*) fntable_Compositor_021_impl_SubmitExplicitTimingData,
};
void** CVRCompositor_021::_GetStatFuncList() { fntable_Compositor_021_instance = this; return fntable_Compositor_021_funcs; }
void CVRCompositor_021::Delete() { delete this; }
// Misc for CVRCompositor_022:
CVRCompositor_022::CVRCompositor_022() : base(GetCreateBaseCompositor()) {}
// Interface methods for CVRCompositor_022:
void CVRCompositor_022::SetTrackingSpace(vr::ETrackingUniverseOrigin eOrigin) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_022)");
	return base->SetTrackingSpace(eOrigin);
}
vr::ETrackingUniverseOrigin CVRCompositor_022::GetTrackingSpace() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_022)");
	return base->GetTrackingSpace();
}
vr::IVRCompositor_022::EVRCompositorError CVRCompositor_022::WaitGetPoses(vr::TrackedDevicePose_t* pRenderPoseArray, uint32_t unRenderPoseArrayCount, vr::TrackedDevicePose_t* pGamePoseArray, uint32_t unGamePoseArrayCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_022)");
	return (vr::IVRCompositor_022::EVRCompositorError) base->WaitGetPoses(pRenderPoseArray, unRenderPoseArrayCount, pGamePoseArray, unGamePoseArrayCount);
}
vr::IVRCompositor_022::EVRCompositorError CVRCompositor_022::GetLastPoses(vr::TrackedDevicePose_t* pRenderPoseArray, uint32_t unRenderPoseArrayCount, vr::TrackedDevicePose_t* pGamePoseArray, uint32_t unGamePoseArrayCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_022)");
	return (vr::IVRCompositor_022::EVRCompositorError) base->GetLastPoses(pRenderPoseArray, unRenderPoseArrayCount, pGamePoseArray, unGamePoseArrayCount);
}
vr::IVRCompositor_022::EVRCompositorError CVRCompositor_022::GetLastPoseForTrackedDeviceIndex(vr::TrackedDeviceIndex_t unDeviceIndex, vr::TrackedDevicePose_t* pOutputPose, vr::TrackedDevicePose_t* pOutputGamePose) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_022)");
	return (vr::IVRCompositor_022::EVRCompositorError) base->GetLastPoseForTrackedDeviceIndex(unDeviceIndex, pOutputPose, pOutputGamePose);
}
vr::IVRCompositor_022::EVRCompositorError CVRCompositor_022::Submit(vr::EVREye eEye, const vr::Texture_t* pTexture, const vr::VRTextureBounds_t* pBounds, vr::EVRSubmitFlags nSubmitFlags) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_022)");
	return (vr::IVRCompositor_022::EVRCompositorError) base->Submit(eEye, pTexture, pBounds, nSubmitFlags);
}
void CVRCompositor_022::ClearLastSubmittedFrame() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_022)");
	return base->ClearLastSubmittedFrame();
}
void CVRCompositor_022::PostPresentHandoff() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_022)");
	return base->PostPresentHandoff();
}
bool CVRCompositor_022::GetFrameTiming(vr::Compositor_FrameTiming* pTiming, uint32_t unFramesAgo) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_022)");
	return base->GetFrameTiming(pTiming, unFramesAgo);
}
uint32_t CVRCompositor_022::GetFrameTimings(vr::Compositor_FrameTiming* pTiming, uint32_t nFrames) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_022)");
	return base->GetFrameTimings(pTiming, nFrames);
}
float CVRCompositor_022::GetFrameTimeRemaining() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_022)");
	return base->GetFrameTimeRemaining();
}
void CVRCompositor_022::GetCumulativeStats(vr::IVRCompositor_022::Compositor_CumulativeStats* pStats, uint32_t nStatsSizeInBytes) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_022)");
	return base->GetCumulativeStats((OOVR_Compositor_CumulativeStats*) pStats, nStatsSizeInBytes);
}
void CVRCompositor_022::FadeToColor(float fSeconds, float fRed, float fGreen, float fBlue, float fAlpha, bool bBackground) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_022)");
	return base->FadeToColor(fSeconds, fRed, fGreen, fBlue, fAlpha, bBackground);
}
vr::HmdColor_t CVRCompositor_022::GetCurrentFadeColor(bool bBackground) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_022)");
	return base->GetCurrentFadeColor(bBackground);
}
void CVRCompositor_022::FadeGrid(float fSeconds, bool bFadeIn) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_022)");
	return base->FadeGrid(fSeconds, bFadeIn);
}
float CVRCompositor_022::GetCurrentGridAlpha() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_022)");
	return base->GetCurrentGridAlpha();
}
vr::IVRCompositor_022::EVRCompositorError CVRCompositor_022::SetSkyboxOverride(const vr::Texture_t* pTextures, uint32_t unTextureCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_022)");
	return (vr::IVRCompositor_022::EVRCompositorError) base->SetSkyboxOverride(pTextures, unTextureCount);
}
void CVRCompositor_022::ClearSkyboxOverride() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_022)");
	return base->ClearSkyboxOverride();
}
void CVRCompositor_022::CompositorBringToFront() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_022)");
	return base->CompositorBringToFront();
}
void CVRCompositor_022::CompositorGoToBack() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_022)");
	return base->CompositorGoToBack();
}
void CVRCompositor_022::CompositorQuit() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_022)");
	return base->CompositorQuit();
}
bool CVRCompositor_022::IsFullscreen() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_022)");
	return base->IsFullscreen();
}
uint32_t CVRCompositor_022::GetCurrentSceneFocusProcess() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_022)");
	return base->GetCurrentSceneFocusProcess();
}
uint32_t CVRCompositor_022::GetLastFrameRenderer() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_022)");
	return base->GetLastFrameRenderer();
}
bool CVRCompositor_022::CanRenderScene() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_022)");
	return base->CanRenderScene();
}
void CVRCompositor_022::ShowMirrorWindow() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_022)");
	return base->ShowMirrorWindow();
}
void CVRCompositor_022::HideMirrorWindow() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_022)");
	return base->HideMirrorWindow();
}
bool CVRCompositor_022::IsMirrorWindowVisible() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_022)");
	return base->IsMirrorWindowVisible();
}
void CVRCompositor_022::CompositorDumpImages() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_022)");
	return base->CompositorDumpImages();
}
bool CVRCompositor_022::ShouldAppRenderWithLowResources() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_022)");
	return base->ShouldAppRenderWithLowResources();
}
void CVRCompositor_022::ForceInterleavedReprojectionOn(bool bOverride) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_022)");
	return base->ForceInterleavedReprojectionOn(bOverride);
}
void CVRCompositor_022::ForceReconnectProcess() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_022)");
	return base->ForceReconnectProcess();
}
void CVRCompositor_022::SuspendRendering(bool bSuspend) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_022)");
	return base->SuspendRendering(bSuspend);
}
vr::IVRCompositor_022::EVRCompositorError CVRCompositor_022::GetMirrorTextureD3D11(vr::EVREye eEye, void* pD3D11DeviceOrResource, void** ppD3D11ShaderResourceView) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_022)");
	return (vr::IVRCompositor_022::EVRCompositorError) base->GetMirrorTextureD3D11(eEye, pD3D11DeviceOrResource, ppD3D11ShaderResourceView);
}
void CVRCompositor_022::ReleaseMirrorTextureD3D11(void* pD3D11ShaderResourceView) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_022)");
	return base->ReleaseMirrorTextureD3D11(pD3D11ShaderResourceView);
}
vr::IVRCompositor_022::EVRCompositorError CVRCompositor_022::GetMirrorTextureGL(vr::EVREye eEye, vr::glUInt_t* pglTextureId, vr::glSharedTextureHandle_t* pglSharedTextureHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_022)");
	return (vr::IVRCompositor_022::EVRCompositorError) base->GetMirrorTextureGL(eEye, pglTextureId, pglSharedTextureHandle);
}
bool CVRCompositor_022::ReleaseSharedGLTexture(vr::glUInt_t glTextureId, vr::glSharedTextureHandle_t glSharedTextureHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_022)");
	return base->ReleaseSharedGLTexture(glTextureId, glSharedTextureHandle);
}
void CVRCompositor_022::LockGLSharedTextureForAccess(vr::glSharedTextureHandle_t glSharedTextureHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_022)");
	return base->LockGLSharedTextureForAccess(glSharedTextureHandle);
}
void CVRCompositor_022::UnlockGLSharedTextureForAccess(vr::glSharedTextureHandle_t glSharedTextureHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_022)");
	return base->UnlockGLSharedTextureForAccess(glSharedTextureHandle);
}
uint32_t CVRCompositor_022::GetVulkanInstanceExtensionsRequired(char* pchValue, uint32_t unBufferSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_022)");
	return base->GetVulkanInstanceExtensionsRequired(pchValue, unBufferSize);
}
uint32_t CVRCompositor_022::GetVulkanDeviceExtensionsRequired(VkPhysicalDevice_T* pPhysicalDevice, char* pchValue, uint32_t unBufferSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_022)");
	return base->GetVulkanDeviceExtensionsRequired(pPhysicalDevice, pchValue, unBufferSize);
}
void CVRCompositor_022::SetExplicitTimingMode(vr::IVRCompositor_022::EVRCompositorTimingMode eTimingMode) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_022)");
	return base->SetExplicitTimingMode((OOVR_EVRCompositorTimingMode) eTimingMode);
}
vr::IVRCompositor_022::EVRCompositorError CVRCompositor_022::SubmitExplicitTimingData() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_022)");
	return (vr::IVRCompositor_022::EVRCompositorError) base->SubmitExplicitTimingData();
}
bool CVRCompositor_022::IsMotionSmoothingEnabled() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_022)");
	return base->IsMotionSmoothingEnabled();
}
bool CVRCompositor_022::IsMotionSmoothingSupported() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_022)");
	return base->IsMotionSmoothingSupported();
}
bool CVRCompositor_022::IsCurrentSceneFocusAppLoading() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_022)");
	return base->IsCurrentSceneFocusAppLoading();
}
// FnTable for CVRCompositor_022:
static CVRCompositor_022 *fntable_Compositor_022_instance = NULL;
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_022_impl_SetTrackingSpace(vr::ETrackingUniverseOrigin eOrigin) { return fntable_Compositor_022_instance->SetTrackingSpace(eOrigin); }
static vr::ETrackingUniverseOrigin OPENVR_FNTABLE_CALLTYPE fntable_Compositor_022_impl_GetTrackingSpace() { return fntable_Compositor_022_instance->GetTrackingSpace(); }
static vr::IVRCompositor_022::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_022_impl_WaitGetPoses(vr::TrackedDevicePose_t* pRenderPoseArray, uint32_t unRenderPoseArrayCount, vr::TrackedDevicePose_t* pGamePoseArray, uint32_t unGamePoseArrayCount) { return fntable_Compositor_022_instance->WaitGetPoses(pRenderPoseArray, unRenderPoseArrayCount, pGamePoseArray, unGamePoseArrayCount); }
static vr::IVRCompositor_022::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_022_impl_GetLastPoses(vr::TrackedDevicePose_t* pRenderPoseArray, uint32_t unRenderPoseArrayCount, vr::TrackedDevicePose_t* pGamePoseArray, uint32_t unGamePoseArrayCount) { return fntable_Compositor_022_instance->GetLastPoses(pRenderPoseArray, unRenderPoseArrayCount, pGamePoseArray, unGamePoseArrayCount); }
static vr::IVRCompositor_022::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_022_impl_GetLastPoseForTrackedDeviceIndex(vr::TrackedDeviceIndex_t unDeviceIndex, vr::TrackedDevicePose_t* pOutputPose, vr::TrackedDevicePose_t* pOutputGamePose) { return fntable_Compositor_022_instance->GetLastPoseForTrackedDeviceIndex(unDeviceIndex, pOutputPose, pOutputGamePose); }
static vr::IVRCompositor_022::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_022_impl_Submit(vr::EVREye eEye, const vr::Texture_t* pTexture, const vr::VRTextureBounds_t* pBounds, vr::EVRSubmitFlags nSubmitFlags) { return fntable_Compositor_022_instance->Submit(eEye, pTexture, pBounds, nSubmitFlags); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_022_impl_ClearLastSubmittedFrame() { return fntable_Compositor_022_instance->ClearLastSubmittedFrame(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_022_impl_PostPresentHandoff() { return fntable_Compositor_022_instance->PostPresentHandoff(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_022_impl_GetFrameTiming(vr::Compositor_FrameTiming* pTiming, uint32_t unFramesAgo) { return fntable_Compositor_022_instance->GetFrameTiming(pTiming, unFramesAgo); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Compositor_022_impl_GetFrameTimings(vr::Compositor_FrameTiming* pTiming, uint32_t nFrames) { return fntable_Compositor_022_instance->GetFrameTimings(pTiming, nFrames); }
static float OPENVR_FNTABLE_CALLTYPE fntable_Compositor_022_impl_GetFrameTimeRemaining() { return fntable_Compositor_022_instance->GetFrameTimeRemaining(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_022_impl_GetCumulativeStats(vr::IVRCompositor_022::Compositor_CumulativeStats* pStats, uint32_t nStatsSizeInBytes) { return fntable_Compositor_022_instance->GetCumulativeStats(pStats, nStatsSizeInBytes); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_022_impl_FadeToColor(float fSeconds, float fRed, float fGreen, float fBlue, float fAlpha, bool bBackground) { return fntable_Compositor_022_instance->FadeToColor(fSeconds, fRed, fGreen, fBlue, fAlpha, bBackground); }
static vr::HmdColor_t OPENVR_FNTABLE_CALLTYPE fntable_Compositor_022_impl_GetCurrentFadeColor(bool bBackground) { return fntable_Compositor_022_instance->GetCurrentFadeColor(bBackground); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_022_impl_FadeGrid(float fSeconds, bool bFadeIn) { return fntable_Compositor_022_instance->FadeGrid(fSeconds, bFadeIn); }
static float OPENVR_FNTABLE_CALLTYPE fntable_Compositor_022_impl_GetCurrentGridAlpha() { return fntable_Compositor_022_instance->GetCurrentGridAlpha(); }
static vr::IVRCompositor_022::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_022_impl_SetSkyboxOverride(const vr::Texture_t* pTextures, uint32_t unTextureCount) { return fntable_Compositor_022_instance->SetSkyboxOverride(pTextures, unTextureCount); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_022_impl_ClearSkyboxOverride() { return fntable_Compositor_022_instance->ClearSkyboxOverride(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_022_impl_CompositorBringToFront() { return fntable_Compositor_022_instance->CompositorBringToFront(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_022_impl_CompositorGoToBack() { return fntable_Compositor_022_instance->CompositorGoToBack(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_022_impl_CompositorQuit() { return fntable_Compositor_022_instance->CompositorQuit(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_022_impl_IsFullscreen() { return fntable_Compositor_022_instance->IsFullscreen(); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Compositor_022_impl_GetCurrentSceneFocusProcess() { return fntable_Compositor_022_instance->GetCurrentSceneFocusProcess(); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Compositor_022_impl_GetLastFrameRenderer() { return fntable_Compositor_022_instance->GetLastFrameRenderer(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_022_impl_CanRenderScene() { return fntable_Compositor_022_instance->CanRenderScene(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_022_impl_ShowMirrorWindow() { return fntable_Compositor_022_instance->ShowMirrorWindow(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_022_impl_HideMirrorWindow() { return fntable_Compositor_022_instance->HideMirrorWindow(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_022_impl_IsMirrorWindowVisible() { return fntable_Compositor_022_instance->IsMirrorWindowVisible(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_022_impl_CompositorDumpImages() { return fntable_Compositor_022_instance->CompositorDumpImages(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_022_impl_ShouldAppRenderWithLowResources() { return fntable_Compositor_022_instance->ShouldAppRenderWithLowResources(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_022_impl_ForceInterleavedReprojectionOn(bool bOverride) { return fntable_Compositor_022_instance->ForceInterleavedReprojectionOn(bOverride); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_022_impl_ForceReconnectProcess() { return fntable_Compositor_022_instance->ForceReconnectProcess(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_022_impl_SuspendRendering(bool bSuspend) { return fntable_Compositor_022_instance->SuspendRendering(bSuspend); }
static vr::IVRCompositor_022::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_022_impl_GetMirrorTextureD3D11(vr::EVREye eEye, void* pD3D11DeviceOrResource, void** ppD3D11ShaderResourceView) { return fntable_Compositor_022_instance->GetMirrorTextureD3D11(eEye, pD3D11DeviceOrResource, ppD3D11ShaderResourceView); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_022_impl_ReleaseMirrorTextureD3D11(void* pD3D11ShaderResourceView) { return fntable_Compositor_022_instance->ReleaseMirrorTextureD3D11(pD3D11ShaderResourceView); }
static vr::IVRCompositor_022::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_022_impl_GetMirrorTextureGL(vr::EVREye eEye, vr::glUInt_t* pglTextureId, vr::glSharedTextureHandle_t* pglSharedTextureHandle) { return fntable_Compositor_022_instance->GetMirrorTextureGL(eEye, pglTextureId, pglSharedTextureHandle); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_022_impl_ReleaseSharedGLTexture(vr::glUInt_t glTextureId, vr::glSharedTextureHandle_t glSharedTextureHandle) { return fntable_Compositor_022_instance->ReleaseSharedGLTexture(glTextureId, glSharedTextureHandle); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_022_impl_LockGLSharedTextureForAccess(vr::glSharedTextureHandle_t glSharedTextureHandle) { return fntable_Compositor_022_instance->LockGLSharedTextureForAccess(glSharedTextureHandle); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_022_impl_UnlockGLSharedTextureForAccess(vr::glSharedTextureHandle_t glSharedTextureHandle) { return fntable_Compositor_022_instance->UnlockGLSharedTextureForAccess(glSharedTextureHandle); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Compositor_022_impl_GetVulkanInstanceExtensionsRequired(char* pchValue, uint32_t unBufferSize) { return fntable_Compositor_022_instance->GetVulkanInstanceExtensionsRequired(pchValue, unBufferSize); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Compositor_022_impl_GetVulkanDeviceExtensionsRequired(VkPhysicalDevice_T* pPhysicalDevice, char* pchValue, uint32_t unBufferSize) { return fntable_Compositor_022_instance->GetVulkanDeviceExtensionsRequired(pPhysicalDevice, pchValue, unBufferSize); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_022_impl_SetExplicitTimingMode(vr::IVRCompositor_022::EVRCompositorTimingMode eTimingMode) { return fntable_Compositor_022_instance->SetExplicitTimingMode(eTimingMode); }
static vr::IVRCompositor_022::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_022_impl_SubmitExplicitTimingData() { return fntable_Compositor_022_instance->SubmitExplicitTimingData(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_022_impl_IsMotionSmoothingEnabled() { return fntable_Compositor_022_instance->IsMotionSmoothingEnabled(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_022_impl_IsMotionSmoothingSupported() { return fntable_Compositor_022_instance->IsMotionSmoothingSupported(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_022_impl_IsCurrentSceneFocusAppLoading() { return fntable_Compositor_022_instance->IsCurrentSceneFocusAppLoading(); }
static void *fntable_Compositor_022_funcs[] = {
	(void*) fntable_Compositor_022_impl_SetTrackingSpace,
	(void*) fntable_Compositor_022_impl_GetTrackingSpace,
	(void*) fntable_Compositor_022_impl_WaitGetPoses,
	(void*) fntable_Compositor_022_impl_GetLastPoses,
	(void*) fntable_Compositor_022_impl_GetLastPoseForTrackedDeviceIndex,
	(void*) fntable_Compositor_022_impl_Submit,
	(void*) fntable_Compositor_022_impl_ClearLastSubmittedFrame,
	(void*) fntable_Compositor_022_impl_PostPresentHandoff,
	(void*) fntable_Compositor_022_impl_GetFrameTiming,
	(void*) fntable_Compositor_022_impl_GetFrameTimings,
	(void*) fntable_Compositor_022_impl_GetFrameTimeRemaining,
	(void*) fntable_Compositor_022_impl_GetCumulativeStats,
	(void*) fntable_Compositor_022_impl_FadeToColor,
	(void*) fntable_Compositor_022_impl_GetCurrentFadeColor,
	(void*) fntable_Compositor_022_impl_FadeGrid,
	(void*) fntable_Compositor_022_impl_GetCurrentGridAlpha,
	(void*) fntable_Compositor_022_impl_SetSkyboxOverride,
	(void*) fntable_Compositor_022_impl_ClearSkyboxOverride,
	(void*) fntable_Compositor_022_impl_CompositorBringToFront,
	(void*) fntable_Compositor_022_impl_CompositorGoToBack,
	(void*) fntable_Compositor_022_impl_CompositorQuit,
	(void*) fntable_Compositor_022_impl_IsFullscreen,
	(void*) fntable_Compositor_022_impl_GetCurrentSceneFocusProcess,
	(void*) fntable_Compositor_022_impl_GetLastFrameRenderer,
	(void*) fntable_Compositor_022_impl_CanRenderScene,
	(void*) fntable_Compositor_022_impl_ShowMirrorWindow,
	(void*) fntable_Compositor_022_impl_HideMirrorWindow,
	(void*) fntable_Compositor_022_impl_IsMirrorWindowVisible,
	(void*) fntable_Compositor_022_impl_CompositorDumpImages,
	(void*) fntable_Compositor_022_impl_ShouldAppRenderWithLowResources,
	(void*) fntable_Compositor_022_impl_ForceInterleavedReprojectionOn,
	(void*) fntable_Compositor_022_impl_ForceReconnectProcess,
	(void*) fntable_Compositor_022_impl_SuspendRendering,
	(void*) fntable_Compositor_022_impl_GetMirrorTextureD3D11,
	(void*) fntable_Compositor_022_impl_ReleaseMirrorTextureD3D11,
	(void*) fntable_Compositor_022_impl_GetMirrorTextureGL,
	(void*) fntable_Compositor_022_impl_ReleaseSharedGLTexture,
	(void*) fntable_Compositor_022_impl_LockGLSharedTextureForAccess,
	(void*) fntable_Compositor_022_impl_UnlockGLSharedTextureForAccess,
	(void*) fntable_Compositor_022_impl_GetVulkanInstanceExtensionsRequired,
	(void*) fntable_Compositor_022_impl_GetVulkanDeviceExtensionsRequired,
	(void*) fntable_Compositor_022_impl_SetExplicitTimingMode,
	(void*) fntable_Compositor_022_impl_SubmitExplicitTimingData,
	(void*) fntable_Compositor_022_impl_IsMotionSmoothingEnabled,
	(void*) fntable_Compositor_022_impl_IsMotionSmoothingSupported,
	(void*) fntable_Compositor_022_impl_IsCurrentSceneFocusAppLoading,
};
void** CVRCompositor_022::_GetStatFuncList() { fntable_Compositor_022_instance = this; return fntable_Compositor_022_funcs; }
void CVRCompositor_022::Delete() { delete this; }
// Misc for CVRCompositor_024:
CVRCompositor_024::CVRCompositor_024() : base(GetCreateBaseCompositor()) {}
// Interface methods for CVRCompositor_024:
void CVRCompositor_024::SetTrackingSpace(vr::ETrackingUniverseOrigin eOrigin) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_024)");
	return base->SetTrackingSpace(eOrigin);
}
vr::ETrackingUniverseOrigin CVRCompositor_024::GetTrackingSpace() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_024)");
	return base->GetTrackingSpace();
}
vr::IVRCompositor_024::EVRCompositorError CVRCompositor_024::WaitGetPoses(vr::TrackedDevicePose_t* pRenderPoseArray, uint32_t unRenderPoseArrayCount, vr::TrackedDevicePose_t* pGamePoseArray, uint32_t unGamePoseArrayCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_024)");
	return (vr::IVRCompositor_024::EVRCompositorError) base->WaitGetPoses(pRenderPoseArray, unRenderPoseArrayCount, pGamePoseArray, unGamePoseArrayCount);
}
vr::IVRCompositor_024::EVRCompositorError CVRCompositor_024::GetLastPoses(vr::TrackedDevicePose_t* pRenderPoseArray, uint32_t unRenderPoseArrayCount, vr::TrackedDevicePose_t* pGamePoseArray, uint32_t unGamePoseArrayCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_024)");
	return (vr::IVRCompositor_024::EVRCompositorError) base->GetLastPoses(pRenderPoseArray, unRenderPoseArrayCount, pGamePoseArray, unGamePoseArrayCount);
}
vr::IVRCompositor_024::EVRCompositorError CVRCompositor_024::GetLastPoseForTrackedDeviceIndex(vr::TrackedDeviceIndex_t unDeviceIndex, vr::TrackedDevicePose_t* pOutputPose, vr::TrackedDevicePose_t* pOutputGamePose) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_024)");
	return (vr::IVRCompositor_024::EVRCompositorError) base->GetLastPoseForTrackedDeviceIndex(unDeviceIndex, pOutputPose, pOutputGamePose);
}
vr::IVRCompositor_024::EVRCompositorError CVRCompositor_024::Submit(vr::EVREye eEye, const vr::Texture_t* pTexture, const vr::VRTextureBounds_t* pBounds, vr::EVRSubmitFlags nSubmitFlags) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_024)");
	return (vr::IVRCompositor_024::EVRCompositorError) base->Submit(eEye, pTexture, pBounds, nSubmitFlags);
}
void CVRCompositor_024::ClearLastSubmittedFrame() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_024)");
	return base->ClearLastSubmittedFrame();
}
void CVRCompositor_024::PostPresentHandoff() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_024)");
	return base->PostPresentHandoff();
}
bool CVRCompositor_024::GetFrameTiming(vr::Compositor_FrameTiming* pTiming, uint32_t unFramesAgo) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_024)");
	return base->GetFrameTiming(pTiming, unFramesAgo);
}
uint32_t CVRCompositor_024::GetFrameTimings(vr::Compositor_FrameTiming* pTiming, uint32_t nFrames) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_024)");
	return base->GetFrameTimings(pTiming, nFrames);
}
float CVRCompositor_024::GetFrameTimeRemaining() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_024)");
	return base->GetFrameTimeRemaining();
}
void CVRCompositor_024::GetCumulativeStats(vr::IVRCompositor_024::Compositor_CumulativeStats* pStats, uint32_t nStatsSizeInBytes) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_024)");
	return base->GetCumulativeStats((OOVR_Compositor_CumulativeStats*) pStats, nStatsSizeInBytes);
}
void CVRCompositor_024::FadeToColor(float fSeconds, float fRed, float fGreen, float fBlue, float fAlpha, bool bBackground) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_024)");
	return base->FadeToColor(fSeconds, fRed, fGreen, fBlue, fAlpha, bBackground);
}
vr::HmdColor_t CVRCompositor_024::GetCurrentFadeColor(bool bBackground) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_024)");
	return base->GetCurrentFadeColor(bBackground);
}
void CVRCompositor_024::FadeGrid(float fSeconds, bool bFadeIn) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_024)");
	return base->FadeGrid(fSeconds, bFadeIn);
}
float CVRCompositor_024::GetCurrentGridAlpha() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_024)");
	return base->GetCurrentGridAlpha();
}
vr::IVRCompositor_024::EVRCompositorError CVRCompositor_024::SetSkyboxOverride(const vr::Texture_t* pTextures, uint32_t unTextureCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_024)");
	return (vr::IVRCompositor_024::EVRCompositorError) base->SetSkyboxOverride(pTextures, unTextureCount);
}
void CVRCompositor_024::ClearSkyboxOverride() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_024)");
	return base->ClearSkyboxOverride();
}
void CVRCompositor_024::CompositorBringToFront() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_024)");
	return base->CompositorBringToFront();
}
void CVRCompositor_024::CompositorGoToBack() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_024)");
	return base->CompositorGoToBack();
}
void CVRCompositor_024::CompositorQuit() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_024)");
	return base->CompositorQuit();
}
bool CVRCompositor_024::IsFullscreen() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_024)");
	return base->IsFullscreen();
}
uint32_t CVRCompositor_024::GetCurrentSceneFocusProcess() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_024)");
	return base->GetCurrentSceneFocusProcess();
}
uint32_t CVRCompositor_024::GetLastFrameRenderer() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_024)");
	return base->GetLastFrameRenderer();
}
bool CVRCompositor_024::CanRenderScene() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_024)");
	return base->CanRenderScene();
}
void CVRCompositor_024::ShowMirrorWindow() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_024)");
	return base->ShowMirrorWindow();
}
void CVRCompositor_024::HideMirrorWindow() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_024)");
	return base->HideMirrorWindow();
}
bool CVRCompositor_024::IsMirrorWindowVisible() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_024)");
	return base->IsMirrorWindowVisible();
}
void CVRCompositor_024::CompositorDumpImages() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_024)");
	return base->CompositorDumpImages();
}
bool CVRCompositor_024::ShouldAppRenderWithLowResources() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_024)");
	return base->ShouldAppRenderWithLowResources();
}
void CVRCompositor_024::ForceInterleavedReprojectionOn(bool bOverride) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_024)");
	return base->ForceInterleavedReprojectionOn(bOverride);
}
void CVRCompositor_024::ForceReconnectProcess() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_024)");
	return base->ForceReconnectProcess();
}
void CVRCompositor_024::SuspendRendering(bool bSuspend) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_024)");
	return base->SuspendRendering(bSuspend);
}
vr::IVRCompositor_024::EVRCompositorError CVRCompositor_024::GetMirrorTextureD3D11(vr::EVREye eEye, void* pD3D11DeviceOrResource, void** ppD3D11ShaderResourceView) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_024)");
	return (vr::IVRCompositor_024::EVRCompositorError) base->GetMirrorTextureD3D11(eEye, pD3D11DeviceOrResource, ppD3D11ShaderResourceView);
}
void CVRCompositor_024::ReleaseMirrorTextureD3D11(void* pD3D11ShaderResourceView) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_024)");
	return base->ReleaseMirrorTextureD3D11(pD3D11ShaderResourceView);
}
vr::IVRCompositor_024::EVRCompositorError CVRCompositor_024::GetMirrorTextureGL(vr::EVREye eEye, vr::glUInt_t* pglTextureId, vr::glSharedTextureHandle_t* pglSharedTextureHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_024)");
	return (vr::IVRCompositor_024::EVRCompositorError) base->GetMirrorTextureGL(eEye, pglTextureId, pglSharedTextureHandle);
}
bool CVRCompositor_024::ReleaseSharedGLTexture(vr::glUInt_t glTextureId, vr::glSharedTextureHandle_t glSharedTextureHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_024)");
	return base->ReleaseSharedGLTexture(glTextureId, glSharedTextureHandle);
}
void CVRCompositor_024::LockGLSharedTextureForAccess(vr::glSharedTextureHandle_t glSharedTextureHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_024)");
	return base->LockGLSharedTextureForAccess(glSharedTextureHandle);
}
void CVRCompositor_024::UnlockGLSharedTextureForAccess(vr::glSharedTextureHandle_t glSharedTextureHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_024)");
	return base->UnlockGLSharedTextureForAccess(glSharedTextureHandle);
}
uint32_t CVRCompositor_024::GetVulkanInstanceExtensionsRequired(char* pchValue, uint32_t unBufferSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_024)");
	return base->GetVulkanInstanceExtensionsRequired(pchValue, unBufferSize);
}
uint32_t CVRCompositor_024::GetVulkanDeviceExtensionsRequired(VkPhysicalDevice_T* pPhysicalDevice, char* pchValue, uint32_t unBufferSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_024)");
	return base->GetVulkanDeviceExtensionsRequired(pPhysicalDevice, pchValue, unBufferSize);
}
void CVRCompositor_024::SetExplicitTimingMode(vr::IVRCompositor_024::EVRCompositorTimingMode eTimingMode) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_024)");
	return base->SetExplicitTimingMode((OOVR_EVRCompositorTimingMode) eTimingMode);
}
vr::IVRCompositor_024::EVRCompositorError CVRCompositor_024::SubmitExplicitTimingData() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_024)");
	return (vr::IVRCompositor_024::EVRCompositorError) base->SubmitExplicitTimingData();
}
bool CVRCompositor_024::IsMotionSmoothingEnabled() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_024)");
	return base->IsMotionSmoothingEnabled();
}
bool CVRCompositor_024::IsMotionSmoothingSupported() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_024)");
	return base->IsMotionSmoothingSupported();
}
bool CVRCompositor_024::IsCurrentSceneFocusAppLoading() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_024)");
	return base->IsCurrentSceneFocusAppLoading();
}
vr::IVRCompositor_024::EVRCompositorError CVRCompositor_024::SetStageOverride_Async(const char* pchRenderModelPath, const vr::HmdMatrix34_t* pTransform, const vr::IVRCompositor_024::Compositor_StageRenderSettings* pRenderSettings, uint32_t nSizeOfRenderSettings) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_024)");
	return (vr::IVRCompositor_024::EVRCompositorError) base->SetStageOverride_Async(pchRenderModelPath, pTransform, (const OOVR_Compositor_StageRenderSettings*) pRenderSettings, nSizeOfRenderSettings);
}
void CVRCompositor_024::ClearStageOverride() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_024)");
	return base->ClearStageOverride();
}
// FnTable for CVRCompositor_024:
static CVRCompositor_024 *fntable_Compositor_024_instance = NULL;
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_024_impl_SetTrackingSpace(vr::ETrackingUniverseOrigin eOrigin) { return fntable_Compositor_024_instance->SetTrackingSpace(eOrigin); }
static vr::ETrackingUniverseOrigin OPENVR_FNTABLE_CALLTYPE fntable_Compositor_024_impl_GetTrackingSpace() { return fntable_Compositor_024_instance->GetTrackingSpace(); }
static vr::IVRCompositor_024::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_024_impl_WaitGetPoses(vr::TrackedDevicePose_t* pRenderPoseArray, uint32_t unRenderPoseArrayCount, vr::TrackedDevicePose_t* pGamePoseArray, uint32_t unGamePoseArrayCount) { return fntable_Compositor_024_instance->WaitGetPoses(pRenderPoseArray, unRenderPoseArrayCount, pGamePoseArray, unGamePoseArrayCount); }
static vr::IVRCompositor_024::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_024_impl_GetLastPoses(vr::TrackedDevicePose_t* pRenderPoseArray, uint32_t unRenderPoseArrayCount, vr::TrackedDevicePose_t* pGamePoseArray, uint32_t unGamePoseArrayCount) { return fntable_Compositor_024_instance->GetLastPoses(pRenderPoseArray, unRenderPoseArrayCount, pGamePoseArray, unGamePoseArrayCount); }
static vr::IVRCompositor_024::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_024_impl_GetLastPoseForTrackedDeviceIndex(vr::TrackedDeviceIndex_t unDeviceIndex, vr::TrackedDevicePose_t* pOutputPose, vr::TrackedDevicePose_t* pOutputGamePose) { return fntable_Compositor_024_instance->GetLastPoseForTrackedDeviceIndex(unDeviceIndex, pOutputPose, pOutputGamePose); }
static vr::IVRCompositor_024::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_024_impl_Submit(vr::EVREye eEye, const vr::Texture_t* pTexture, const vr::VRTextureBounds_t* pBounds, vr::EVRSubmitFlags nSubmitFlags) { return fntable_Compositor_024_instance->Submit(eEye, pTexture, pBounds, nSubmitFlags); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_024_impl_ClearLastSubmittedFrame() { return fntable_Compositor_024_instance->ClearLastSubmittedFrame(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_024_impl_PostPresentHandoff() { return fntable_Compositor_024_instance->PostPresentHandoff(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_024_impl_GetFrameTiming(vr::Compositor_FrameTiming* pTiming, uint32_t unFramesAgo) { return fntable_Compositor_024_instance->GetFrameTiming(pTiming, unFramesAgo); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Compositor_024_impl_GetFrameTimings(vr::Compositor_FrameTiming* pTiming, uint32_t nFrames) { return fntable_Compositor_024_instance->GetFrameTimings(pTiming, nFrames); }
static float OPENVR_FNTABLE_CALLTYPE fntable_Compositor_024_impl_GetFrameTimeRemaining() { return fntable_Compositor_024_instance->GetFrameTimeRemaining(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_024_impl_GetCumulativeStats(vr::IVRCompositor_024::Compositor_CumulativeStats* pStats, uint32_t nStatsSizeInBytes) { return fntable_Compositor_024_instance->GetCumulativeStats(pStats, nStatsSizeInBytes); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_024_impl_FadeToColor(float fSeconds, float fRed, float fGreen, float fBlue, float fAlpha, bool bBackground) { return fntable_Compositor_024_instance->FadeToColor(fSeconds, fRed, fGreen, fBlue, fAlpha, bBackground); }
static vr::HmdColor_t OPENVR_FNTABLE_CALLTYPE fntable_Compositor_024_impl_GetCurrentFadeColor(bool bBackground) { return fntable_Compositor_024_instance->GetCurrentFadeColor(bBackground); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_024_impl_FadeGrid(float fSeconds, bool bFadeIn) { return fntable_Compositor_024_instance->FadeGrid(fSeconds, bFadeIn); }
static float OPENVR_FNTABLE_CALLTYPE fntable_Compositor_024_impl_GetCurrentGridAlpha() { return fntable_Compositor_024_instance->GetCurrentGridAlpha(); }
static vr::IVRCompositor_024::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_024_impl_SetSkyboxOverride(const vr::Texture_t* pTextures, uint32_t unTextureCount) { return fntable_Compositor_024_instance->SetSkyboxOverride(pTextures, unTextureCount); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_024_impl_ClearSkyboxOverride() { return fntable_Compositor_024_instance->ClearSkyboxOverride(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_024_impl_CompositorBringToFront() { return fntable_Compositor_024_instance->CompositorBringToFront(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_024_impl_CompositorGoToBack() { return fntable_Compositor_024_instance->CompositorGoToBack(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_024_impl_CompositorQuit() { return fntable_Compositor_024_instance->CompositorQuit(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_024_impl_IsFullscreen() { return fntable_Compositor_024_instance->IsFullscreen(); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Compositor_024_impl_GetCurrentSceneFocusProcess() { return fntable_Compositor_024_instance->GetCurrentSceneFocusProcess(); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Compositor_024_impl_GetLastFrameRenderer() { return fntable_Compositor_024_instance->GetLastFrameRenderer(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_024_impl_CanRenderScene() { return fntable_Compositor_024_instance->CanRenderScene(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_024_impl_ShowMirrorWindow() { return fntable_Compositor_024_instance->ShowMirrorWindow(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_024_impl_HideMirrorWindow() { return fntable_Compositor_024_instance->HideMirrorWindow(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_024_impl_IsMirrorWindowVisible() { return fntable_Compositor_024_instance->IsMirrorWindowVisible(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_024_impl_CompositorDumpImages() { return fntable_Compositor_024_instance->CompositorDumpImages(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_024_impl_ShouldAppRenderWithLowResources() { return fntable_Compositor_024_instance->ShouldAppRenderWithLowResources(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_024_impl_ForceInterleavedReprojectionOn(bool bOverride) { return fntable_Compositor_024_instance->ForceInterleavedReprojectionOn(bOverride); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_024_impl_ForceReconnectProcess() { return fntable_Compositor_024_instance->ForceReconnectProcess(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_024_impl_SuspendRendering(bool bSuspend) { return fntable_Compositor_024_instance->SuspendRendering(bSuspend); }
static vr::IVRCompositor_024::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_024_impl_GetMirrorTextureD3D11(vr::EVREye eEye, void* pD3D11DeviceOrResource, void** ppD3D11ShaderResourceView) { return fntable_Compositor_024_instance->GetMirrorTextureD3D11(eEye, pD3D11DeviceOrResource, ppD3D11ShaderResourceView); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_024_impl_ReleaseMirrorTextureD3D11(void* pD3D11ShaderResourceView) { return fntable_Compositor_024_instance->ReleaseMirrorTextureD3D11(pD3D11ShaderResourceView); }
static vr::IVRCompositor_024::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_024_impl_GetMirrorTextureGL(vr::EVREye eEye, vr::glUInt_t* pglTextureId, vr::glSharedTextureHandle_t* pglSharedTextureHandle) { return fntable_Compositor_024_instance->GetMirrorTextureGL(eEye, pglTextureId, pglSharedTextureHandle); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_024_impl_ReleaseSharedGLTexture(vr::glUInt_t glTextureId, vr::glSharedTextureHandle_t glSharedTextureHandle) { return fntable_Compositor_024_instance->ReleaseSharedGLTexture(glTextureId, glSharedTextureHandle); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_024_impl_LockGLSharedTextureForAccess(vr::glSharedTextureHandle_t glSharedTextureHandle) { return fntable_Compositor_024_instance->LockGLSharedTextureForAccess(glSharedTextureHandle); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_024_impl_UnlockGLSharedTextureForAccess(vr::glSharedTextureHandle_t glSharedTextureHandle) { return fntable_Compositor_024_instance->UnlockGLSharedTextureForAccess(glSharedTextureHandle); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Compositor_024_impl_GetVulkanInstanceExtensionsRequired(char* pchValue, uint32_t unBufferSize) { return fntable_Compositor_024_instance->GetVulkanInstanceExtensionsRequired(pchValue, unBufferSize); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Compositor_024_impl_GetVulkanDeviceExtensionsRequired(VkPhysicalDevice_T* pPhysicalDevice, char* pchValue, uint32_t unBufferSize) { return fntable_Compositor_024_instance->GetVulkanDeviceExtensionsRequired(pPhysicalDevice, pchValue, unBufferSize); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_024_impl_SetExplicitTimingMode(vr::IVRCompositor_024::EVRCompositorTimingMode eTimingMode) { return fntable_Compositor_024_instance->SetExplicitTimingMode(eTimingMode); }
static vr::IVRCompositor_024::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_024_impl_SubmitExplicitTimingData() { return fntable_Compositor_024_instance->SubmitExplicitTimingData(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_024_impl_IsMotionSmoothingEnabled() { return fntable_Compositor_024_instance->IsMotionSmoothingEnabled(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_024_impl_IsMotionSmoothingSupported() { return fntable_Compositor_024_instance->IsMotionSmoothingSupported(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_024_impl_IsCurrentSceneFocusAppLoading() { return fntable_Compositor_024_instance->IsCurrentSceneFocusAppLoading(); }
static vr::IVRCompositor_024::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_024_impl_SetStageOverride_Async(const char* pchRenderModelPath, const vr::HmdMatrix34_t* pTransform, const vr::IVRCompositor_024::Compositor_StageRenderSettings* pRenderSettings, uint32_t nSizeOfRenderSettings) { return fntable_Compositor_024_instance->SetStageOverride_Async(pchRenderModelPath, pTransform, pRenderSettings, nSizeOfRenderSettings); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_024_impl_ClearStageOverride() { return fntable_Compositor_024_instance->ClearStageOverride(); }
static void *fntable_Compositor_024_funcs[] = {
	(void*) fntable_Compositor_024_impl_SetTrackingSpace,
	(void*) fntable_Compositor_024_impl_GetTrackingSpace,
	(void*) fntable_Compositor_024_impl_WaitGetPoses,
	(void*) fntable_Compositor_024_impl_GetLastPoses,
	(void*) fntable_Compositor_024_impl_GetLastPoseForTrackedDeviceIndex,
	(void*) fntable_Compositor_024_impl_Submit,
	(void*) fntable_Compositor_024_impl_ClearLastSubmittedFrame,
	(void*) fntable_Compositor_024_impl_PostPresentHandoff,
	(void*) fntable_Compositor_024_impl_GetFrameTiming,
	(void*) fntable_Compositor_024_impl_GetFrameTimings,
	(void*) fntable_Compositor_024_impl_GetFrameTimeRemaining,
	(void*) fntable_Compositor_024_impl_GetCumulativeStats,
	(void*) fntable_Compositor_024_impl_FadeToColor,
	(void*) fntable_Compositor_024_impl_GetCurrentFadeColor,
	(void*) fntable_Compositor_024_impl_FadeGrid,
	(void*) fntable_Compositor_024_impl_GetCurrentGridAlpha,
	(void*) fntable_Compositor_024_impl_SetSkyboxOverride,
	(void*) fntable_Compositor_024_impl_ClearSkyboxOverride,
	(void*) fntable_Compositor_024_impl_CompositorBringToFront,
	(void*) fntable_Compositor_024_impl_CompositorGoToBack,
	(void*) fntable_Compositor_024_impl_CompositorQuit,
	(void*) fntable_Compositor_024_impl_IsFullscreen,
	(void*) fntable_Compositor_024_impl_GetCurrentSceneFocusProcess,
	(void*) fntable_Compositor_024_impl_GetLastFrameRenderer,
	(void*) fntable_Compositor_024_impl_CanRenderScene,
	(void*) fntable_Compositor_024_impl_ShowMirrorWindow,
	(void*) fntable_Compositor_024_impl_HideMirrorWindow,
	(void*) fntable_Compositor_024_impl_IsMirrorWindowVisible,
	(void*) fntable_Compositor_024_impl_CompositorDumpImages,
	(void*) fntable_Compositor_024_impl_ShouldAppRenderWithLowResources,
	(void*) fntable_Compositor_024_impl_ForceInterleavedReprojectionOn,
	(void*) fntable_Compositor_024_impl_ForceReconnectProcess,
	(void*) fntable_Compositor_024_impl_SuspendRendering,
	(void*) fntable_Compositor_024_impl_GetMirrorTextureD3D11,
	(void*) fntable_Compositor_024_impl_ReleaseMirrorTextureD3D11,
	(void*) fntable_Compositor_024_impl_GetMirrorTextureGL,
	(void*) fntable_Compositor_024_impl_ReleaseSharedGLTexture,
	(void*) fntable_Compositor_024_impl_LockGLSharedTextureForAccess,
	(void*) fntable_Compositor_024_impl_UnlockGLSharedTextureForAccess,
	(void*) fntable_Compositor_024_impl_GetVulkanInstanceExtensionsRequired,
	(void*) fntable_Compositor_024_impl_GetVulkanDeviceExtensionsRequired,
	(void*) fntable_Compositor_024_impl_SetExplicitTimingMode,
	(void*) fntable_Compositor_024_impl_SubmitExplicitTimingData,
	(void*) fntable_Compositor_024_impl_IsMotionSmoothingEnabled,
	(void*) fntable_Compositor_024_impl_IsMotionSmoothingSupported,
	(void*) fntable_Compositor_024_impl_IsCurrentSceneFocusAppLoading,
	(void*) fntable_Compositor_024_impl_SetStageOverride_Async,
	(void*) fntable_Compositor_024_impl_ClearStageOverride,
};
void** CVRCompositor_024::_GetStatFuncList() { fntable_Compositor_024_instance = this; return fntable_Compositor_024_funcs; }
void CVRCompositor_024::Delete() { delete this; }
// Misc for CVRCompositor_026:
CVRCompositor_026::CVRCompositor_026() : base(GetCreateBaseCompositor()) {}
// Interface methods for CVRCompositor_026:
void CVRCompositor_026::SetTrackingSpace(vr::ETrackingUniverseOrigin eOrigin) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_026)");
	return base->SetTrackingSpace(eOrigin);
}
vr::ETrackingUniverseOrigin CVRCompositor_026::GetTrackingSpace() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_026)");
	return base->GetTrackingSpace();
}
vr::IVRCompositor_026::EVRCompositorError CVRCompositor_026::WaitGetPoses(vr::TrackedDevicePose_t* pRenderPoseArray, uint32_t unRenderPoseArrayCount, vr::TrackedDevicePose_t* pGamePoseArray, uint32_t unGamePoseArrayCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_026)");
	return (vr::IVRCompositor_026::EVRCompositorError) base->WaitGetPoses(pRenderPoseArray, unRenderPoseArrayCount, pGamePoseArray, unGamePoseArrayCount);
}
vr::IVRCompositor_026::EVRCompositorError CVRCompositor_026::GetLastPoses(vr::TrackedDevicePose_t* pRenderPoseArray, uint32_t unRenderPoseArrayCount, vr::TrackedDevicePose_t* pGamePoseArray, uint32_t unGamePoseArrayCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_026)");
	return (vr::IVRCompositor_026::EVRCompositorError) base->GetLastPoses(pRenderPoseArray, unRenderPoseArrayCount, pGamePoseArray, unGamePoseArrayCount);
}
vr::IVRCompositor_026::EVRCompositorError CVRCompositor_026::GetLastPoseForTrackedDeviceIndex(vr::TrackedDeviceIndex_t unDeviceIndex, vr::TrackedDevicePose_t* pOutputPose, vr::TrackedDevicePose_t* pOutputGamePose) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_026)");
	return (vr::IVRCompositor_026::EVRCompositorError) base->GetLastPoseForTrackedDeviceIndex(unDeviceIndex, pOutputPose, pOutputGamePose);
}
vr::IVRCompositor_026::EVRCompositorError CVRCompositor_026::Submit(vr::EVREye eEye, const vr::Texture_t* pTexture, const vr::VRTextureBounds_t* pBounds, vr::EVRSubmitFlags nSubmitFlags) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_026)");
	return (vr::IVRCompositor_026::EVRCompositorError) base->Submit(eEye, pTexture, pBounds, nSubmitFlags);
}
void CVRCompositor_026::ClearLastSubmittedFrame() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_026)");
	return base->ClearLastSubmittedFrame();
}
void CVRCompositor_026::PostPresentHandoff() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_026)");
	return base->PostPresentHandoff();
}
bool CVRCompositor_026::GetFrameTiming(vr::Compositor_FrameTiming* pTiming, uint32_t unFramesAgo) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_026)");
	return base->GetFrameTiming(pTiming, unFramesAgo);
}
uint32_t CVRCompositor_026::GetFrameTimings(vr::Compositor_FrameTiming* pTiming, uint32_t nFrames) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_026)");
	return base->GetFrameTimings(pTiming, nFrames);
}
float CVRCompositor_026::GetFrameTimeRemaining() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_026)");
	return base->GetFrameTimeRemaining();
}
void CVRCompositor_026::GetCumulativeStats(vr::IVRCompositor_026::Compositor_CumulativeStats* pStats, uint32_t nStatsSizeInBytes) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_026)");
	return base->GetCumulativeStats((OOVR_Compositor_CumulativeStats*) pStats, nStatsSizeInBytes);
}
void CVRCompositor_026::FadeToColor(float fSeconds, float fRed, float fGreen, float fBlue, float fAlpha, bool bBackground) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_026)");
	return base->FadeToColor(fSeconds, fRed, fGreen, fBlue, fAlpha, bBackground);
}
vr::HmdColor_t CVRCompositor_026::GetCurrentFadeColor(bool bBackground) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_026)");
	return base->GetCurrentFadeColor(bBackground);
}
void CVRCompositor_026::FadeGrid(float fSeconds, bool bFadeIn) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_026)");
	return base->FadeGrid(fSeconds, bFadeIn);
}
float CVRCompositor_026::GetCurrentGridAlpha() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_026)");
	return base->GetCurrentGridAlpha();
}
vr::IVRCompositor_026::EVRCompositorError CVRCompositor_026::SetSkyboxOverride(const vr::Texture_t* pTextures, uint32_t unTextureCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_026)");
	return (vr::IVRCompositor_026::EVRCompositorError) base->SetSkyboxOverride(pTextures, unTextureCount);
}
void CVRCompositor_026::ClearSkyboxOverride() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_026)");
	return base->ClearSkyboxOverride();
}
void CVRCompositor_026::CompositorBringToFront() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_026)");
	return base->CompositorBringToFront();
}
void CVRCompositor_026::CompositorGoToBack() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_026)");
	return base->CompositorGoToBack();
}
void CVRCompositor_026::CompositorQuit() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_026)");
	return base->CompositorQuit();
}
bool CVRCompositor_026::IsFullscreen() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_026)");
	return base->IsFullscreen();
}
uint32_t CVRCompositor_026::GetCurrentSceneFocusProcess() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_026)");
	return base->GetCurrentSceneFocusProcess();
}
uint32_t CVRCompositor_026::GetLastFrameRenderer() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_026)");
	return base->GetLastFrameRenderer();
}
bool CVRCompositor_026::CanRenderScene() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_026)");
	return base->CanRenderScene();
}
void CVRCompositor_026::ShowMirrorWindow() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_026)");
	return base->ShowMirrorWindow();
}
void CVRCompositor_026::HideMirrorWindow() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_026)");
	return base->HideMirrorWindow();
}
bool CVRCompositor_026::IsMirrorWindowVisible() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_026)");
	return base->IsMirrorWindowVisible();
}
void CVRCompositor_026::CompositorDumpImages() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_026)");
	return base->CompositorDumpImages();
}
bool CVRCompositor_026::ShouldAppRenderWithLowResources() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_026)");
	return base->ShouldAppRenderWithLowResources();
}
void CVRCompositor_026::ForceInterleavedReprojectionOn(bool bOverride) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_026)");
	return base->ForceInterleavedReprojectionOn(bOverride);
}
void CVRCompositor_026::ForceReconnectProcess() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_026)");
	return base->ForceReconnectProcess();
}
void CVRCompositor_026::SuspendRendering(bool bSuspend) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_026)");
	return base->SuspendRendering(bSuspend);
}
vr::IVRCompositor_026::EVRCompositorError CVRCompositor_026::GetMirrorTextureD3D11(vr::EVREye eEye, void* pD3D11DeviceOrResource, void** ppD3D11ShaderResourceView) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_026)");
	return (vr::IVRCompositor_026::EVRCompositorError) base->GetMirrorTextureD3D11(eEye, pD3D11DeviceOrResource, ppD3D11ShaderResourceView);
}
void CVRCompositor_026::ReleaseMirrorTextureD3D11(void* pD3D11ShaderResourceView) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_026)");
	return base->ReleaseMirrorTextureD3D11(pD3D11ShaderResourceView);
}
vr::IVRCompositor_026::EVRCompositorError CVRCompositor_026::GetMirrorTextureGL(vr::EVREye eEye, vr::glUInt_t* pglTextureId, vr::glSharedTextureHandle_t* pglSharedTextureHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_026)");
	return (vr::IVRCompositor_026::EVRCompositorError) base->GetMirrorTextureGL(eEye, pglTextureId, pglSharedTextureHandle);
}
bool CVRCompositor_026::ReleaseSharedGLTexture(vr::glUInt_t glTextureId, vr::glSharedTextureHandle_t glSharedTextureHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_026)");
	return base->ReleaseSharedGLTexture(glTextureId, glSharedTextureHandle);
}
void CVRCompositor_026::LockGLSharedTextureForAccess(vr::glSharedTextureHandle_t glSharedTextureHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_026)");
	return base->LockGLSharedTextureForAccess(glSharedTextureHandle);
}
void CVRCompositor_026::UnlockGLSharedTextureForAccess(vr::glSharedTextureHandle_t glSharedTextureHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_026)");
	return base->UnlockGLSharedTextureForAccess(glSharedTextureHandle);
}
uint32_t CVRCompositor_026::GetVulkanInstanceExtensionsRequired(char* pchValue, uint32_t unBufferSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_026)");
	return base->GetVulkanInstanceExtensionsRequired(pchValue, unBufferSize);
}
uint32_t CVRCompositor_026::GetVulkanDeviceExtensionsRequired(VkPhysicalDevice_T* pPhysicalDevice, char* pchValue, uint32_t unBufferSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_026)");
	return base->GetVulkanDeviceExtensionsRequired(pPhysicalDevice, pchValue, unBufferSize);
}
void CVRCompositor_026::SetExplicitTimingMode(vr::IVRCompositor_026::EVRCompositorTimingMode eTimingMode) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_026)");
	return base->SetExplicitTimingMode((OOVR_EVRCompositorTimingMode) eTimingMode);
}
vr::IVRCompositor_026::EVRCompositorError CVRCompositor_026::SubmitExplicitTimingData() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_026)");
	return (vr::IVRCompositor_026::EVRCompositorError) base->SubmitExplicitTimingData();
}
bool CVRCompositor_026::IsMotionSmoothingEnabled() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_026)");
	return base->IsMotionSmoothingEnabled();
}
bool CVRCompositor_026::IsMotionSmoothingSupported() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_026)");
	return base->IsMotionSmoothingSupported();
}
bool CVRCompositor_026::IsCurrentSceneFocusAppLoading() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_026)");
	return base->IsCurrentSceneFocusAppLoading();
}
vr::IVRCompositor_026::EVRCompositorError CVRCompositor_026::SetStageOverride_Async(const char* pchRenderModelPath, const vr::HmdMatrix34_t* pTransform, const vr::IVRCompositor_026::Compositor_StageRenderSettings* pRenderSettings, uint32_t nSizeOfRenderSettings) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_026)");
	return (vr::IVRCompositor_026::EVRCompositorError) base->SetStageOverride_Async(pchRenderModelPath, pTransform, (const OOVR_Compositor_StageRenderSettings*) pRenderSettings, nSizeOfRenderSettings);
}
void CVRCompositor_026::ClearStageOverride() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_026)");
	return base->ClearStageOverride();
}
bool CVRCompositor_026::GetCompositorBenchmarkResults(vr::Compositor_BenchmarkResults* pBenchmarkResults, uint32_t nSizeOfBenchmarkResults) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_026)");
	return base->GetCompositorBenchmarkResults(pBenchmarkResults, nSizeOfBenchmarkResults);
}
vr::IVRCompositor_026::EVRCompositorError CVRCompositor_026::GetLastPosePredictionIDs(uint32_t* pRenderPosePredictionID, uint32_t* pGamePosePredictionID) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_026)");
	return (vr::IVRCompositor_026::EVRCompositorError) base->GetLastPosePredictionIDs(pRenderPosePredictionID, pGamePosePredictionID);
}
vr::IVRCompositor_026::EVRCompositorError CVRCompositor_026::GetPosesForFrame(uint32_t unPosePredictionID, vr::TrackedDevicePose_t* pPoseArray, uint32_t unPoseArrayCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_026)");
	return (vr::IVRCompositor_026::EVRCompositorError) base->GetPosesForFrame(unPosePredictionID, pPoseArray, unPoseArrayCount);
}
// FnTable for CVRCompositor_026:
static CVRCompositor_026 *fntable_Compositor_026_instance = NULL;
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_026_impl_SetTrackingSpace(vr::ETrackingUniverseOrigin eOrigin) { return fntable_Compositor_026_instance->SetTrackingSpace(eOrigin); }
static vr::ETrackingUniverseOrigin OPENVR_FNTABLE_CALLTYPE fntable_Compositor_026_impl_GetTrackingSpace() { return fntable_Compositor_026_instance->GetTrackingSpace(); }
static vr::IVRCompositor_026::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_026_impl_WaitGetPoses(vr::TrackedDevicePose_t* pRenderPoseArray, uint32_t unRenderPoseArrayCount, vr::TrackedDevicePose_t* pGamePoseArray, uint32_t unGamePoseArrayCount) { return fntable_Compositor_026_instance->WaitGetPoses(pRenderPoseArray, unRenderPoseArrayCount, pGamePoseArray, unGamePoseArrayCount); }
static vr::IVRCompositor_026::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_026_impl_GetLastPoses(vr::TrackedDevicePose_t* pRenderPoseArray, uint32_t unRenderPoseArrayCount, vr::TrackedDevicePose_t* pGamePoseArray, uint32_t unGamePoseArrayCount) { return fntable_Compositor_026_instance->GetLastPoses(pRenderPoseArray, unRenderPoseArrayCount, pGamePoseArray, unGamePoseArrayCount); }
static vr::IVRCompositor_026::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_026_impl_GetLastPoseForTrackedDeviceIndex(vr::TrackedDeviceIndex_t unDeviceIndex, vr::TrackedDevicePose_t* pOutputPose, vr::TrackedDevicePose_t* pOutputGamePose) { return fntable_Compositor_026_instance->GetLastPoseForTrackedDeviceIndex(unDeviceIndex, pOutputPose, pOutputGamePose); }
static vr::IVRCompositor_026::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_026_impl_Submit(vr::EVREye eEye, const vr::Texture_t* pTexture, const vr::VRTextureBounds_t* pBounds, vr::EVRSubmitFlags nSubmitFlags) { return fntable_Compositor_026_instance->Submit(eEye, pTexture, pBounds, nSubmitFlags); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_026_impl_ClearLastSubmittedFrame() { return fntable_Compositor_026_instance->ClearLastSubmittedFrame(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_026_impl_PostPresentHandoff() { return fntable_Compositor_026_instance->PostPresentHandoff(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_026_impl_GetFrameTiming(vr::Compositor_FrameTiming* pTiming, uint32_t unFramesAgo) { return fntable_Compositor_026_instance->GetFrameTiming(pTiming, unFramesAgo); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Compositor_026_impl_GetFrameTimings(vr::Compositor_FrameTiming* pTiming, uint32_t nFrames) { return fntable_Compositor_026_instance->GetFrameTimings(pTiming, nFrames); }
static float OPENVR_FNTABLE_CALLTYPE fntable_Compositor_026_impl_GetFrameTimeRemaining() { return fntable_Compositor_026_instance->GetFrameTimeRemaining(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_026_impl_GetCumulativeStats(vr::IVRCompositor_026::Compositor_CumulativeStats* pStats, uint32_t nStatsSizeInBytes) { return fntable_Compositor_026_instance->GetCumulativeStats(pStats, nStatsSizeInBytes); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_026_impl_FadeToColor(float fSeconds, float fRed, float fGreen, float fBlue, float fAlpha, bool bBackground) { return fntable_Compositor_026_instance->FadeToColor(fSeconds, fRed, fGreen, fBlue, fAlpha, bBackground); }
static vr::HmdColor_t OPENVR_FNTABLE_CALLTYPE fntable_Compositor_026_impl_GetCurrentFadeColor(bool bBackground) { return fntable_Compositor_026_instance->GetCurrentFadeColor(bBackground); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_026_impl_FadeGrid(float fSeconds, bool bFadeIn) { return fntable_Compositor_026_instance->FadeGrid(fSeconds, bFadeIn); }
static float OPENVR_FNTABLE_CALLTYPE fntable_Compositor_026_impl_GetCurrentGridAlpha() { return fntable_Compositor_026_instance->GetCurrentGridAlpha(); }
static vr::IVRCompositor_026::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_026_impl_SetSkyboxOverride(const vr::Texture_t* pTextures, uint32_t unTextureCount) { return fntable_Compositor_026_instance->SetSkyboxOverride(pTextures, unTextureCount); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_026_impl_ClearSkyboxOverride() { return fntable_Compositor_026_instance->ClearSkyboxOverride(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_026_impl_CompositorBringToFront() { return fntable_Compositor_026_instance->CompositorBringToFront(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_026_impl_CompositorGoToBack() { return fntable_Compositor_026_instance->CompositorGoToBack(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_026_impl_CompositorQuit() { return fntable_Compositor_026_instance->CompositorQuit(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_026_impl_IsFullscreen() { return fntable_Compositor_026_instance->IsFullscreen(); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Compositor_026_impl_GetCurrentSceneFocusProcess() { return fntable_Compositor_026_instance->GetCurrentSceneFocusProcess(); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Compositor_026_impl_GetLastFrameRenderer() { return fntable_Compositor_026_instance->GetLastFrameRenderer(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_026_impl_CanRenderScene() { return fntable_Compositor_026_instance->CanRenderScene(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_026_impl_ShowMirrorWindow() { return fntable_Compositor_026_instance->ShowMirrorWindow(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_026_impl_HideMirrorWindow() { return fntable_Compositor_026_instance->HideMirrorWindow(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_026_impl_IsMirrorWindowVisible() { return fntable_Compositor_026_instance->IsMirrorWindowVisible(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_026_impl_CompositorDumpImages() { return fntable_Compositor_026_instance->CompositorDumpImages(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_026_impl_ShouldAppRenderWithLowResources() { return fntable_Compositor_026_instance->ShouldAppRenderWithLowResources(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_026_impl_ForceInterleavedReprojectionOn(bool bOverride) { return fntable_Compositor_026_instance->ForceInterleavedReprojectionOn(bOverride); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_026_impl_ForceReconnectProcess() { return fntable_Compositor_026_instance->ForceReconnectProcess(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_026_impl_SuspendRendering(bool bSuspend) { return fntable_Compositor_026_instance->SuspendRendering(bSuspend); }
static vr::IVRCompositor_026::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_026_impl_GetMirrorTextureD3D11(vr::EVREye eEye, void* pD3D11DeviceOrResource, void** ppD3D11ShaderResourceView) { return fntable_Compositor_026_instance->GetMirrorTextureD3D11(eEye, pD3D11DeviceOrResource, ppD3D11ShaderResourceView); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_026_impl_ReleaseMirrorTextureD3D11(void* pD3D11ShaderResourceView) { return fntable_Compositor_026_instance->ReleaseMirrorTextureD3D11(pD3D11ShaderResourceView); }
static vr::IVRCompositor_026::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_026_impl_GetMirrorTextureGL(vr::EVREye eEye, vr::glUInt_t* pglTextureId, vr::glSharedTextureHandle_t* pglSharedTextureHandle) { return fntable_Compositor_026_instance->GetMirrorTextureGL(eEye, pglTextureId, pglSharedTextureHandle); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_026_impl_ReleaseSharedGLTexture(vr::glUInt_t glTextureId, vr::glSharedTextureHandle_t glSharedTextureHandle) { return fntable_Compositor_026_instance->ReleaseSharedGLTexture(glTextureId, glSharedTextureHandle); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_026_impl_LockGLSharedTextureForAccess(vr::glSharedTextureHandle_t glSharedTextureHandle) { return fntable_Compositor_026_instance->LockGLSharedTextureForAccess(glSharedTextureHandle); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_026_impl_UnlockGLSharedTextureForAccess(vr::glSharedTextureHandle_t glSharedTextureHandle) { return fntable_Compositor_026_instance->UnlockGLSharedTextureForAccess(glSharedTextureHandle); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Compositor_026_impl_GetVulkanInstanceExtensionsRequired(char* pchValue, uint32_t unBufferSize) { return fntable_Compositor_026_instance->GetVulkanInstanceExtensionsRequired(pchValue, unBufferSize); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Compositor_026_impl_GetVulkanDeviceExtensionsRequired(VkPhysicalDevice_T* pPhysicalDevice, char* pchValue, uint32_t unBufferSize) { return fntable_Compositor_026_instance->GetVulkanDeviceExtensionsRequired(pPhysicalDevice, pchValue, unBufferSize); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_026_impl_SetExplicitTimingMode(vr::IVRCompositor_026::EVRCompositorTimingMode eTimingMode) { return fntable_Compositor_026_instance->SetExplicitTimingMode(eTimingMode); }
static vr::IVRCompositor_026::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_026_impl_SubmitExplicitTimingData() { return fntable_Compositor_026_instance->SubmitExplicitTimingData(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_026_impl_IsMotionSmoothingEnabled() { return fntable_Compositor_026_instance->IsMotionSmoothingEnabled(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_026_impl_IsMotionSmoothingSupported() { return fntable_Compositor_026_instance->IsMotionSmoothingSupported(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_026_impl_IsCurrentSceneFocusAppLoading() { return fntable_Compositor_026_instance->IsCurrentSceneFocusAppLoading(); }
static vr::IVRCompositor_026::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_026_impl_SetStageOverride_Async(const char* pchRenderModelPath, const vr::HmdMatrix34_t* pTransform, const vr::IVRCompositor_026::Compositor_StageRenderSettings* pRenderSettings, uint32_t nSizeOfRenderSettings) { return fntable_Compositor_026_instance->SetStageOverride_Async(pchRenderModelPath, pTransform, pRenderSettings, nSizeOfRenderSettings); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_026_impl_ClearStageOverride() { return fntable_Compositor_026_instance->ClearStageOverride(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_026_impl_GetCompositorBenchmarkResults(vr::Compositor_BenchmarkResults* pBenchmarkResults, uint32_t nSizeOfBenchmarkResults) { return fntable_Compositor_026_instance->GetCompositorBenchmarkResults(pBenchmarkResults, nSizeOfBenchmarkResults); }
static vr::IVRCompositor_026::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_026_impl_GetLastPosePredictionIDs(uint32_t* pRenderPosePredictionID, uint32_t* pGamePosePredictionID) { return fntable_Compositor_026_instance->GetLastPosePredictionIDs(pRenderPosePredictionID, pGamePosePredictionID); }
static vr::IVRCompositor_026::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_026_impl_GetPosesForFrame(uint32_t unPosePredictionID, vr::TrackedDevicePose_t* pPoseArray, uint32_t unPoseArrayCount) { return fntable_Compositor_026_instance->GetPosesForFrame(unPosePredictionID, pPoseArray, unPoseArrayCount); }
static void *fntable_Compositor_026_funcs[] = {
	(void*) fntable_Compositor_026_impl_SetTrackingSpace,
	(void*) fntable_Compositor_026_impl_GetTrackingSpace,
	(void*) fntable_Compositor_026_impl_WaitGetPoses,
	(void*) fntable_Compositor_026_impl_GetLastPoses,
	(void*) fntable_Compositor_026_impl_GetLastPoseForTrackedDeviceIndex,
	(void*) fntable_Compositor_026_impl_Submit,
	(void*) fntable_Compositor_026_impl_ClearLastSubmittedFrame,
	(void*) fntable_Compositor_026_impl_PostPresentHandoff,
	(void*) fntable_Compositor_026_impl_GetFrameTiming,
	(void*) fntable_Compositor_026_impl_GetFrameTimings,
	(void*) fntable_Compositor_026_impl_GetFrameTimeRemaining,
	(void*) fntable_Compositor_026_impl_GetCumulativeStats,
	(void*) fntable_Compositor_026_impl_FadeToColor,
	(void*) fntable_Compositor_026_impl_GetCurrentFadeColor,
	(void*) fntable_Compositor_026_impl_FadeGrid,
	(void*) fntable_Compositor_026_impl_GetCurrentGridAlpha,
	(void*) fntable_Compositor_026_impl_SetSkyboxOverride,
	(void*) fntable_Compositor_026_impl_ClearSkyboxOverride,
	(void*) fntable_Compositor_026_impl_CompositorBringToFront,
	(void*) fntable_Compositor_026_impl_CompositorGoToBack,
	(void*) fntable_Compositor_026_impl_CompositorQuit,
	(void*) fntable_Compositor_026_impl_IsFullscreen,
	(void*) fntable_Compositor_026_impl_GetCurrentSceneFocusProcess,
	(void*) fntable_Compositor_026_impl_GetLastFrameRenderer,
	(void*) fntable_Compositor_026_impl_CanRenderScene,
	(void*) fntable_Compositor_026_impl_ShowMirrorWindow,
	(void*) fntable_Compositor_026_impl_HideMirrorWindow,
	(void*) fntable_Compositor_026_impl_IsMirrorWindowVisible,
	(void*) fntable_Compositor_026_impl_CompositorDumpImages,
	(void*) fntable_Compositor_026_impl_ShouldAppRenderWithLowResources,
	(void*) fntable_Compositor_026_impl_ForceInterleavedReprojectionOn,
	(void*) fntable_Compositor_026_impl_ForceReconnectProcess,
	(void*) fntable_Compositor_026_impl_SuspendRendering,
	(void*) fntable_Compositor_026_impl_GetMirrorTextureD3D11,
	(void*) fntable_Compositor_026_impl_ReleaseMirrorTextureD3D11,
	(void*) fntable_Compositor_026_impl_GetMirrorTextureGL,
	(void*) fntable_Compositor_026_impl_ReleaseSharedGLTexture,
	(void*) fntable_Compositor_026_impl_LockGLSharedTextureForAccess,
	(void*) fntable_Compositor_026_impl_UnlockGLSharedTextureForAccess,
	(void*) fntable_Compositor_026_impl_GetVulkanInstanceExtensionsRequired,
	(void*) fntable_Compositor_026_impl_GetVulkanDeviceExtensionsRequired,
	(void*) fntable_Compositor_026_impl_SetExplicitTimingMode,
	(void*) fntable_Compositor_026_impl_SubmitExplicitTimingData,
	(void*) fntable_Compositor_026_impl_IsMotionSmoothingEnabled,
	(void*) fntable_Compositor_026_impl_IsMotionSmoothingSupported,
	(void*) fntable_Compositor_026_impl_IsCurrentSceneFocusAppLoading,
	(void*) fntable_Compositor_026_impl_SetStageOverride_Async,
	(void*) fntable_Compositor_026_impl_ClearStageOverride,
	(void*) fntable_Compositor_026_impl_GetCompositorBenchmarkResults,
	(void*) fntable_Compositor_026_impl_GetLastPosePredictionIDs,
	(void*) fntable_Compositor_026_impl_GetPosesForFrame,
};
void** CVRCompositor_026::_GetStatFuncList() { fntable_Compositor_026_instance = this; return fntable_Compositor_026_funcs; }
void CVRCompositor_026::Delete() { delete this; }
// Misc for CVRCompositor_027:
CVRCompositor_027::CVRCompositor_027() : base(GetCreateBaseCompositor()) {}
// Interface methods for CVRCompositor_027:
void CVRCompositor_027::SetTrackingSpace(vr::ETrackingUniverseOrigin eOrigin) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_027)");
	return base->SetTrackingSpace(eOrigin);
}
vr::ETrackingUniverseOrigin CVRCompositor_027::GetTrackingSpace() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_027)");
	return base->GetTrackingSpace();
}
vr::IVRCompositor_027::EVRCompositorError CVRCompositor_027::WaitGetPoses(vr::TrackedDevicePose_t* pRenderPoseArray, uint32_t unRenderPoseArrayCount, vr::TrackedDevicePose_t* pGamePoseArray, uint32_t unGamePoseArrayCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_027)");
	return (vr::IVRCompositor_027::EVRCompositorError) base->WaitGetPoses(pRenderPoseArray, unRenderPoseArrayCount, pGamePoseArray, unGamePoseArrayCount);
}
vr::IVRCompositor_027::EVRCompositorError CVRCompositor_027::GetLastPoses(vr::TrackedDevicePose_t* pRenderPoseArray, uint32_t unRenderPoseArrayCount, vr::TrackedDevicePose_t* pGamePoseArray, uint32_t unGamePoseArrayCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_027)");
	return (vr::IVRCompositor_027::EVRCompositorError) base->GetLastPoses(pRenderPoseArray, unRenderPoseArrayCount, pGamePoseArray, unGamePoseArrayCount);
}
vr::IVRCompositor_027::EVRCompositorError CVRCompositor_027::GetLastPoseForTrackedDeviceIndex(vr::TrackedDeviceIndex_t unDeviceIndex, vr::TrackedDevicePose_t* pOutputPose, vr::TrackedDevicePose_t* pOutputGamePose) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_027)");
	return (vr::IVRCompositor_027::EVRCompositorError) base->GetLastPoseForTrackedDeviceIndex(unDeviceIndex, pOutputPose, pOutputGamePose);
}
vr::IVRCompositor_027::EVRCompositorError CVRCompositor_027::Submit(vr::EVREye eEye, const vr::Texture_t* pTexture, const vr::VRTextureBounds_t* pBounds, vr::EVRSubmitFlags nSubmitFlags) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_027)");
	return (vr::IVRCompositor_027::EVRCompositorError) base->Submit(eEye, pTexture, pBounds, nSubmitFlags);
}
void CVRCompositor_027::ClearLastSubmittedFrame() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_027)");
	return base->ClearLastSubmittedFrame();
}
void CVRCompositor_027::PostPresentHandoff() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_027)");
	return base->PostPresentHandoff();
}
bool CVRCompositor_027::GetFrameTiming(vr::Compositor_FrameTiming* pTiming, uint32_t unFramesAgo) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_027)");
	return base->GetFrameTiming(pTiming, unFramesAgo);
}
uint32_t CVRCompositor_027::GetFrameTimings(vr::Compositor_FrameTiming* pTiming, uint32_t nFrames) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_027)");
	return base->GetFrameTimings(pTiming, nFrames);
}
float CVRCompositor_027::GetFrameTimeRemaining() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_027)");
	return base->GetFrameTimeRemaining();
}
void CVRCompositor_027::GetCumulativeStats(vr::IVRCompositor_027::Compositor_CumulativeStats* pStats, uint32_t nStatsSizeInBytes) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_027)");
	return base->GetCumulativeStats((OOVR_Compositor_CumulativeStats*) pStats, nStatsSizeInBytes);
}
void CVRCompositor_027::FadeToColor(float fSeconds, float fRed, float fGreen, float fBlue, float fAlpha, bool bBackground) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_027)");
	return base->FadeToColor(fSeconds, fRed, fGreen, fBlue, fAlpha, bBackground);
}
vr::HmdColor_t CVRCompositor_027::GetCurrentFadeColor(bool bBackground) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_027)");
	return base->GetCurrentFadeColor(bBackground);
}
void CVRCompositor_027::FadeGrid(float fSeconds, bool bFadeGridIn) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_027)");
	return base->FadeGrid(fSeconds, bFadeGridIn);
}
float CVRCompositor_027::GetCurrentGridAlpha() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_027)");
	return base->GetCurrentGridAlpha();
}
vr::IVRCompositor_027::EVRCompositorError CVRCompositor_027::SetSkyboxOverride(const vr::Texture_t* pTextures, uint32_t unTextureCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_027)");
	return (vr::IVRCompositor_027::EVRCompositorError) base->SetSkyboxOverride(pTextures, unTextureCount);
}
void CVRCompositor_027::ClearSkyboxOverride() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_027)");
	return base->ClearSkyboxOverride();
}
void CVRCompositor_027::CompositorBringToFront() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_027)");
	return base->CompositorBringToFront();
}
void CVRCompositor_027::CompositorGoToBack() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_027)");
	return base->CompositorGoToBack();
}
void CVRCompositor_027::CompositorQuit() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_027)");
	return base->CompositorQuit();
}
bool CVRCompositor_027::IsFullscreen() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_027)");
	return base->IsFullscreen();
}
uint32_t CVRCompositor_027::GetCurrentSceneFocusProcess() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_027)");
	return base->GetCurrentSceneFocusProcess();
}
uint32_t CVRCompositor_027::GetLastFrameRenderer() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_027)");
	return base->GetLastFrameRenderer();
}
bool CVRCompositor_027::CanRenderScene() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_027)");
	return base->CanRenderScene();
}
void CVRCompositor_027::ShowMirrorWindow() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_027)");
	return base->ShowMirrorWindow();
}
void CVRCompositor_027::HideMirrorWindow() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_027)");
	return base->HideMirrorWindow();
}
bool CVRCompositor_027::IsMirrorWindowVisible() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_027)");
	return base->IsMirrorWindowVisible();
}
void CVRCompositor_027::CompositorDumpImages() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_027)");
	return base->CompositorDumpImages();
}
bool CVRCompositor_027::ShouldAppRenderWithLowResources() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_027)");
	return base->ShouldAppRenderWithLowResources();
}
void CVRCompositor_027::ForceInterleavedReprojectionOn(bool bOverride) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_027)");
	return base->ForceInterleavedReprojectionOn(bOverride);
}
void CVRCompositor_027::ForceReconnectProcess() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_027)");
	return base->ForceReconnectProcess();
}
void CVRCompositor_027::SuspendRendering(bool bSuspend) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_027)");
	return base->SuspendRendering(bSuspend);
}
vr::IVRCompositor_027::EVRCompositorError CVRCompositor_027::GetMirrorTextureD3D11(vr::EVREye eEye, void* pD3D11DeviceOrResource, void** ppD3D11ShaderResourceView) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_027)");
	return (vr::IVRCompositor_027::EVRCompositorError) base->GetMirrorTextureD3D11(eEye, pD3D11DeviceOrResource, ppD3D11ShaderResourceView);
}
void CVRCompositor_027::ReleaseMirrorTextureD3D11(void* pD3D11ShaderResourceView) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_027)");
	return base->ReleaseMirrorTextureD3D11(pD3D11ShaderResourceView);
}
vr::IVRCompositor_027::EVRCompositorError CVRCompositor_027::GetMirrorTextureGL(vr::EVREye eEye, vr::glUInt_t* pglTextureId, vr::glSharedTextureHandle_t* pglSharedTextureHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_027)");
	return (vr::IVRCompositor_027::EVRCompositorError) base->GetMirrorTextureGL(eEye, pglTextureId, pglSharedTextureHandle);
}
bool CVRCompositor_027::ReleaseSharedGLTexture(vr::glUInt_t glTextureId, vr::glSharedTextureHandle_t glSharedTextureHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_027)");
	return base->ReleaseSharedGLTexture(glTextureId, glSharedTextureHandle);
}
void CVRCompositor_027::LockGLSharedTextureForAccess(vr::glSharedTextureHandle_t glSharedTextureHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_027)");
	return base->LockGLSharedTextureForAccess(glSharedTextureHandle);
}
void CVRCompositor_027::UnlockGLSharedTextureForAccess(vr::glSharedTextureHandle_t glSharedTextureHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_027)");
	return base->UnlockGLSharedTextureForAccess(glSharedTextureHandle);
}
uint32_t CVRCompositor_027::GetVulkanInstanceExtensionsRequired(char* pchValue, uint32_t unBufferSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_027)");
	return base->GetVulkanInstanceExtensionsRequired(pchValue, unBufferSize);
}
uint32_t CVRCompositor_027::GetVulkanDeviceExtensionsRequired(VkPhysicalDevice_T* pPhysicalDevice, char* pchValue, uint32_t unBufferSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_027)");
	return base->GetVulkanDeviceExtensionsRequired(pPhysicalDevice, pchValue, unBufferSize);
}
void CVRCompositor_027::SetExplicitTimingMode(vr::IVRCompositor_027::EVRCompositorTimingMode eTimingMode) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_027)");
	return base->SetExplicitTimingMode((OOVR_EVRCompositorTimingMode) eTimingMode);
}
vr::IVRCompositor_027::EVRCompositorError CVRCompositor_027::SubmitExplicitTimingData() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_027)");
	return (vr::IVRCompositor_027::EVRCompositorError) base->SubmitExplicitTimingData();
}
bool CVRCompositor_027::IsMotionSmoothingEnabled() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_027)");
	return base->IsMotionSmoothingEnabled();
}
bool CVRCompositor_027::IsMotionSmoothingSupported() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_027)");
	return base->IsMotionSmoothingSupported();
}
bool CVRCompositor_027::IsCurrentSceneFocusAppLoading() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_027)");
	return base->IsCurrentSceneFocusAppLoading();
}
vr::IVRCompositor_027::EVRCompositorError CVRCompositor_027::SetStageOverride_Async(const char* pchRenderModelPath, const vr::HmdMatrix34_t* pTransform, const vr::IVRCompositor_027::Compositor_StageRenderSettings* pRenderSettings, uint32_t nSizeOfRenderSettings) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_027)");
	return (vr::IVRCompositor_027::EVRCompositorError) base->SetStageOverride_Async(pchRenderModelPath, pTransform, (const OOVR_Compositor_StageRenderSettings*) pRenderSettings, nSizeOfRenderSettings);
}
void CVRCompositor_027::ClearStageOverride() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_027)");
	return base->ClearStageOverride();
}
bool CVRCompositor_027::GetCompositorBenchmarkResults(vr::Compositor_BenchmarkResults* pBenchmarkResults, uint32_t nSizeOfBenchmarkResults) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_027)");
	return base->GetCompositorBenchmarkResults(pBenchmarkResults, nSizeOfBenchmarkResults);
}
vr::IVRCompositor_027::EVRCompositorError CVRCompositor_027::GetLastPosePredictionIDs(uint32_t* pRenderPosePredictionID, uint32_t* pGamePosePredictionID) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_027)");
	return (vr::IVRCompositor_027::EVRCompositorError) base->GetLastPosePredictionIDs(pRenderPosePredictionID, pGamePosePredictionID);
}
vr::IVRCompositor_027::EVRCompositorError CVRCompositor_027::GetPosesForFrame(uint32_t unPosePredictionID, vr::TrackedDevicePose_t* pPoseArray, uint32_t unPoseArrayCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_027)");
	return (vr::IVRCompositor_027::EVRCompositorError) base->GetPosesForFrame(unPosePredictionID, pPoseArray, unPoseArrayCount);
}
// FnTable for CVRCompositor_027:
static CVRCompositor_027 *fntable_Compositor_027_instance = NULL;
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_027_impl_SetTrackingSpace(vr::ETrackingUniverseOrigin eOrigin) { return fntable_Compositor_027_instance->SetTrackingSpace(eOrigin); }
static vr::ETrackingUniverseOrigin OPENVR_FNTABLE_CALLTYPE fntable_Compositor_027_impl_GetTrackingSpace() { return fntable_Compositor_027_instance->GetTrackingSpace(); }
static vr::IVRCompositor_027::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_027_impl_WaitGetPoses(vr::TrackedDevicePose_t* pRenderPoseArray, uint32_t unRenderPoseArrayCount, vr::TrackedDevicePose_t* pGamePoseArray, uint32_t unGamePoseArrayCount) { return fntable_Compositor_027_instance->WaitGetPoses(pRenderPoseArray, unRenderPoseArrayCount, pGamePoseArray, unGamePoseArrayCount); }
static vr::IVRCompositor_027::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_027_impl_GetLastPoses(vr::TrackedDevicePose_t* pRenderPoseArray, uint32_t unRenderPoseArrayCount, vr::TrackedDevicePose_t* pGamePoseArray, uint32_t unGamePoseArrayCount) { return fntable_Compositor_027_instance->GetLastPoses(pRenderPoseArray, unRenderPoseArrayCount, pGamePoseArray, unGamePoseArrayCount); }
static vr::IVRCompositor_027::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_027_impl_GetLastPoseForTrackedDeviceIndex(vr::TrackedDeviceIndex_t unDeviceIndex, vr::TrackedDevicePose_t* pOutputPose, vr::TrackedDevicePose_t* pOutputGamePose) { return fntable_Compositor_027_instance->GetLastPoseForTrackedDeviceIndex(unDeviceIndex, pOutputPose, pOutputGamePose); }
static vr::IVRCompositor_027::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_027_impl_Submit(vr::EVREye eEye, const vr::Texture_t* pTexture, const vr::VRTextureBounds_t* pBounds, vr::EVRSubmitFlags nSubmitFlags) { return fntable_Compositor_027_instance->Submit(eEye, pTexture, pBounds, nSubmitFlags); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_027_impl_ClearLastSubmittedFrame() { return fntable_Compositor_027_instance->ClearLastSubmittedFrame(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_027_impl_PostPresentHandoff() { return fntable_Compositor_027_instance->PostPresentHandoff(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_027_impl_GetFrameTiming(vr::Compositor_FrameTiming* pTiming, uint32_t unFramesAgo) { return fntable_Compositor_027_instance->GetFrameTiming(pTiming, unFramesAgo); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Compositor_027_impl_GetFrameTimings(vr::Compositor_FrameTiming* pTiming, uint32_t nFrames) { return fntable_Compositor_027_instance->GetFrameTimings(pTiming, nFrames); }
static float OPENVR_FNTABLE_CALLTYPE fntable_Compositor_027_impl_GetFrameTimeRemaining() { return fntable_Compositor_027_instance->GetFrameTimeRemaining(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_027_impl_GetCumulativeStats(vr::IVRCompositor_027::Compositor_CumulativeStats* pStats, uint32_t nStatsSizeInBytes) { return fntable_Compositor_027_instance->GetCumulativeStats(pStats, nStatsSizeInBytes); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_027_impl_FadeToColor(float fSeconds, float fRed, float fGreen, float fBlue, float fAlpha, bool bBackground) { return fntable_Compositor_027_instance->FadeToColor(fSeconds, fRed, fGreen, fBlue, fAlpha, bBackground); }
static vr::HmdColor_t OPENVR_FNTABLE_CALLTYPE fntable_Compositor_027_impl_GetCurrentFadeColor(bool bBackground) { return fntable_Compositor_027_instance->GetCurrentFadeColor(bBackground); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_027_impl_FadeGrid(float fSeconds, bool bFadeGridIn) { return fntable_Compositor_027_instance->FadeGrid(fSeconds, bFadeGridIn); }
static float OPENVR_FNTABLE_CALLTYPE fntable_Compositor_027_impl_GetCurrentGridAlpha() { return fntable_Compositor_027_instance->GetCurrentGridAlpha(); }
static vr::IVRCompositor_027::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_027_impl_SetSkyboxOverride(const vr::Texture_t* pTextures, uint32_t unTextureCount) { return fntable_Compositor_027_instance->SetSkyboxOverride(pTextures, unTextureCount); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_027_impl_ClearSkyboxOverride() { return fntable_Compositor_027_instance->ClearSkyboxOverride(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_027_impl_CompositorBringToFront() { return fntable_Compositor_027_instance->CompositorBringToFront(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_027_impl_CompositorGoToBack() { return fntable_Compositor_027_instance->CompositorGoToBack(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_027_impl_CompositorQuit() { return fntable_Compositor_027_instance->CompositorQuit(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_027_impl_IsFullscreen() { return fntable_Compositor_027_instance->IsFullscreen(); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Compositor_027_impl_GetCurrentSceneFocusProcess() { return fntable_Compositor_027_instance->GetCurrentSceneFocusProcess(); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Compositor_027_impl_GetLastFrameRenderer() { return fntable_Compositor_027_instance->GetLastFrameRenderer(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_027_impl_CanRenderScene() { return fntable_Compositor_027_instance->CanRenderScene(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_027_impl_ShowMirrorWindow() { return fntable_Compositor_027_instance->ShowMirrorWindow(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_027_impl_HideMirrorWindow() { return fntable_Compositor_027_instance->HideMirrorWindow(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_027_impl_IsMirrorWindowVisible() { return fntable_Compositor_027_instance->IsMirrorWindowVisible(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_027_impl_CompositorDumpImages() { return fntable_Compositor_027_instance->CompositorDumpImages(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_027_impl_ShouldAppRenderWithLowResources() { return fntable_Compositor_027_instance->ShouldAppRenderWithLowResources(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_027_impl_ForceInterleavedReprojectionOn(bool bOverride) { return fntable_Compositor_027_instance->ForceInterleavedReprojectionOn(bOverride); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_027_impl_ForceReconnectProcess() { return fntable_Compositor_027_instance->ForceReconnectProcess(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_027_impl_SuspendRendering(bool bSuspend) { return fntable_Compositor_027_instance->SuspendRendering(bSuspend); }
static vr::IVRCompositor_027::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_027_impl_GetMirrorTextureD3D11(vr::EVREye eEye, void* pD3D11DeviceOrResource, void** ppD3D11ShaderResourceView) { return fntable_Compositor_027_instance->GetMirrorTextureD3D11(eEye, pD3D11DeviceOrResource, ppD3D11ShaderResourceView); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_027_impl_ReleaseMirrorTextureD3D11(void* pD3D11ShaderResourceView) { return fntable_Compositor_027_instance->ReleaseMirrorTextureD3D11(pD3D11ShaderResourceView); }
static vr::IVRCompositor_027::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_027_impl_GetMirrorTextureGL(vr::EVREye eEye, vr::glUInt_t* pglTextureId, vr::glSharedTextureHandle_t* pglSharedTextureHandle) { return fntable_Compositor_027_instance->GetMirrorTextureGL(eEye, pglTextureId, pglSharedTextureHandle); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_027_impl_ReleaseSharedGLTexture(vr::glUInt_t glTextureId, vr::glSharedTextureHandle_t glSharedTextureHandle) { return fntable_Compositor_027_instance->ReleaseSharedGLTexture(glTextureId, glSharedTextureHandle); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_027_impl_LockGLSharedTextureForAccess(vr::glSharedTextureHandle_t glSharedTextureHandle) { return fntable_Compositor_027_instance->LockGLSharedTextureForAccess(glSharedTextureHandle); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_027_impl_UnlockGLSharedTextureForAccess(vr::glSharedTextureHandle_t glSharedTextureHandle) { return fntable_Compositor_027_instance->UnlockGLSharedTextureForAccess(glSharedTextureHandle); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Compositor_027_impl_GetVulkanInstanceExtensionsRequired(char* pchValue, uint32_t unBufferSize) { return fntable_Compositor_027_instance->GetVulkanInstanceExtensionsRequired(pchValue, unBufferSize); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Compositor_027_impl_GetVulkanDeviceExtensionsRequired(VkPhysicalDevice_T* pPhysicalDevice, char* pchValue, uint32_t unBufferSize) { return fntable_Compositor_027_instance->GetVulkanDeviceExtensionsRequired(pPhysicalDevice, pchValue, unBufferSize); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_027_impl_SetExplicitTimingMode(vr::IVRCompositor_027::EVRCompositorTimingMode eTimingMode) { return fntable_Compositor_027_instance->SetExplicitTimingMode(eTimingMode); }
static vr::IVRCompositor_027::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_027_impl_SubmitExplicitTimingData() { return fntable_Compositor_027_instance->SubmitExplicitTimingData(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_027_impl_IsMotionSmoothingEnabled() { return fntable_Compositor_027_instance->IsMotionSmoothingEnabled(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_027_impl_IsMotionSmoothingSupported() { return fntable_Compositor_027_instance->IsMotionSmoothingSupported(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_027_impl_IsCurrentSceneFocusAppLoading() { return fntable_Compositor_027_instance->IsCurrentSceneFocusAppLoading(); }
static vr::IVRCompositor_027::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_027_impl_SetStageOverride_Async(const char* pchRenderModelPath, const vr::HmdMatrix34_t* pTransform, const vr::IVRCompositor_027::Compositor_StageRenderSettings* pRenderSettings, uint32_t nSizeOfRenderSettings) { return fntable_Compositor_027_instance->SetStageOverride_Async(pchRenderModelPath, pTransform, pRenderSettings, nSizeOfRenderSettings); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_027_impl_ClearStageOverride() { return fntable_Compositor_027_instance->ClearStageOverride(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_027_impl_GetCompositorBenchmarkResults(vr::Compositor_BenchmarkResults* pBenchmarkResults, uint32_t nSizeOfBenchmarkResults) { return fntable_Compositor_027_instance->GetCompositorBenchmarkResults(pBenchmarkResults, nSizeOfBenchmarkResults); }
static vr::IVRCompositor_027::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_027_impl_GetLastPosePredictionIDs(uint32_t* pRenderPosePredictionID, uint32_t* pGamePosePredictionID) { return fntable_Compositor_027_instance->GetLastPosePredictionIDs(pRenderPosePredictionID, pGamePosePredictionID); }
static vr::IVRCompositor_027::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_027_impl_GetPosesForFrame(uint32_t unPosePredictionID, vr::TrackedDevicePose_t* pPoseArray, uint32_t unPoseArrayCount) { return fntable_Compositor_027_instance->GetPosesForFrame(unPosePredictionID, pPoseArray, unPoseArrayCount); }
static void *fntable_Compositor_027_funcs[] = {
	(void*) fntable_Compositor_027_impl_SetTrackingSpace,
	(void*) fntable_Compositor_027_impl_GetTrackingSpace,
	(void*) fntable_Compositor_027_impl_WaitGetPoses,
	(void*) fntable_Compositor_027_impl_GetLastPoses,
	(void*) fntable_Compositor_027_impl_GetLastPoseForTrackedDeviceIndex,
	(void*) fntable_Compositor_027_impl_Submit,
	(void*) fntable_Compositor_027_impl_ClearLastSubmittedFrame,
	(void*) fntable_Compositor_027_impl_PostPresentHandoff,
	(void*) fntable_Compositor_027_impl_GetFrameTiming,
	(void*) fntable_Compositor_027_impl_GetFrameTimings,
	(void*) fntable_Compositor_027_impl_GetFrameTimeRemaining,
	(void*) fntable_Compositor_027_impl_GetCumulativeStats,
	(void*) fntable_Compositor_027_impl_FadeToColor,
	(void*) fntable_Compositor_027_impl_GetCurrentFadeColor,
	(void*) fntable_Compositor_027_impl_FadeGrid,
	(void*) fntable_Compositor_027_impl_GetCurrentGridAlpha,
	(void*) fntable_Compositor_027_impl_SetSkyboxOverride,
	(void*) fntable_Compositor_027_impl_ClearSkyboxOverride,
	(void*) fntable_Compositor_027_impl_CompositorBringToFront,
	(void*) fntable_Compositor_027_impl_CompositorGoToBack,
	(void*) fntable_Compositor_027_impl_CompositorQuit,
	(void*) fntable_Compositor_027_impl_IsFullscreen,
	(void*) fntable_Compositor_027_impl_GetCurrentSceneFocusProcess,
	(void*) fntable_Compositor_027_impl_GetLastFrameRenderer,
	(void*) fntable_Compositor_027_impl_CanRenderScene,
	(void*) fntable_Compositor_027_impl_ShowMirrorWindow,
	(void*) fntable_Compositor_027_impl_HideMirrorWindow,
	(void*) fntable_Compositor_027_impl_IsMirrorWindowVisible,
	(void*) fntable_Compositor_027_impl_CompositorDumpImages,
	(void*) fntable_Compositor_027_impl_ShouldAppRenderWithLowResources,
	(void*) fntable_Compositor_027_impl_ForceInterleavedReprojectionOn,
	(void*) fntable_Compositor_027_impl_ForceReconnectProcess,
	(void*) fntable_Compositor_027_impl_SuspendRendering,
	(void*) fntable_Compositor_027_impl_GetMirrorTextureD3D11,
	(void*) fntable_Compositor_027_impl_ReleaseMirrorTextureD3D11,
	(void*) fntable_Compositor_027_impl_GetMirrorTextureGL,
	(void*) fntable_Compositor_027_impl_ReleaseSharedGLTexture,
	(void*) fntable_Compositor_027_impl_LockGLSharedTextureForAccess,
	(void*) fntable_Compositor_027_impl_UnlockGLSharedTextureForAccess,
	(void*) fntable_Compositor_027_impl_GetVulkanInstanceExtensionsRequired,
	(void*) fntable_Compositor_027_impl_GetVulkanDeviceExtensionsRequired,
	(void*) fntable_Compositor_027_impl_SetExplicitTimingMode,
	(void*) fntable_Compositor_027_impl_SubmitExplicitTimingData,
	(void*) fntable_Compositor_027_impl_IsMotionSmoothingEnabled,
	(void*) fntable_Compositor_027_impl_IsMotionSmoothingSupported,
	(void*) fntable_Compositor_027_impl_IsCurrentSceneFocusAppLoading,
	(void*) fntable_Compositor_027_impl_SetStageOverride_Async,
	(void*) fntable_Compositor_027_impl_ClearStageOverride,
	(void*) fntable_Compositor_027_impl_GetCompositorBenchmarkResults,
	(void*) fntable_Compositor_027_impl_GetLastPosePredictionIDs,
	(void*) fntable_Compositor_027_impl_GetPosesForFrame,
};
void** CVRCompositor_027::_GetStatFuncList() { fntable_Compositor_027_instance = this; return fntable_Compositor_027_funcs; }
void CVRCompositor_027::Delete() { delete this; }
// Misc for CVRCompositor_028:
CVRCompositor_028::CVRCompositor_028() : base(GetCreateBaseCompositor()) {}
// Interface methods for CVRCompositor_028:
void CVRCompositor_028::SetTrackingSpace(vr::ETrackingUniverseOrigin eOrigin) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_028)");
	return base->SetTrackingSpace(eOrigin);
}
vr::ETrackingUniverseOrigin CVRCompositor_028::GetTrackingSpace() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_028)");
	return base->GetTrackingSpace();
}
vr::IVRCompositor_028::EVRCompositorError CVRCompositor_028::WaitGetPoses(vr::TrackedDevicePose_t* pRenderPoseArray, uint32_t unRenderPoseArrayCount, vr::TrackedDevicePose_t* pGamePoseArray, uint32_t unGamePoseArrayCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_028)");
	return (vr::IVRCompositor_028::EVRCompositorError) base->WaitGetPoses(pRenderPoseArray, unRenderPoseArrayCount, pGamePoseArray, unGamePoseArrayCount);
}
vr::IVRCompositor_028::EVRCompositorError CVRCompositor_028::GetLastPoses(vr::TrackedDevicePose_t* pRenderPoseArray, uint32_t unRenderPoseArrayCount, vr::TrackedDevicePose_t* pGamePoseArray, uint32_t unGamePoseArrayCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_028)");
	return (vr::IVRCompositor_028::EVRCompositorError) base->GetLastPoses(pRenderPoseArray, unRenderPoseArrayCount, pGamePoseArray, unGamePoseArrayCount);
}
vr::IVRCompositor_028::EVRCompositorError CVRCompositor_028::GetLastPoseForTrackedDeviceIndex(vr::TrackedDeviceIndex_t unDeviceIndex, vr::TrackedDevicePose_t* pOutputPose, vr::TrackedDevicePose_t* pOutputGamePose) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_028)");
	return (vr::IVRCompositor_028::EVRCompositorError) base->GetLastPoseForTrackedDeviceIndex(unDeviceIndex, pOutputPose, pOutputGamePose);
}
vr::IVRCompositor_028::EVRCompositorError CVRCompositor_028::Submit(vr::EVREye eEye, const vr::Texture_t* pTexture, const vr::VRTextureBounds_t* pBounds, vr::EVRSubmitFlags nSubmitFlags) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_028)");
	return (vr::IVRCompositor_028::EVRCompositorError) base->Submit(eEye, pTexture, pBounds, nSubmitFlags);
}
vr::IVRCompositor_028::EVRCompositorError CVRCompositor_028::SubmitWithArrayIndex(vr::EVREye eEye, const vr::Texture_t* pTexture, uint32_t unTextureArrayIndex, const vr::VRTextureBounds_t* pBounds, vr::EVRSubmitFlags nSubmitFlags) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_028)");
	return (vr::IVRCompositor_028::EVRCompositorError) base->SubmitWithArrayIndex(eEye, pTexture, unTextureArrayIndex, pBounds, nSubmitFlags);
}
void CVRCompositor_028::ClearLastSubmittedFrame() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_028)");
	return base->ClearLastSubmittedFrame();
}
void CVRCompositor_028::PostPresentHandoff() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_028)");
	return base->PostPresentHandoff();
}
bool CVRCompositor_028::GetFrameTiming(vr::Compositor_FrameTiming* pTiming, uint32_t unFramesAgo) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_028)");
	return base->GetFrameTiming(pTiming, unFramesAgo);
}
uint32_t CVRCompositor_028::GetFrameTimings(vr::Compositor_FrameTiming* pTiming, uint32_t nFrames) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_028)");
	return base->GetFrameTimings(pTiming, nFrames);
}
float CVRCompositor_028::GetFrameTimeRemaining() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_028)");
	return base->GetFrameTimeRemaining();
}
void CVRCompositor_028::GetCumulativeStats(vr::IVRCompositor_028::Compositor_CumulativeStats* pStats, uint32_t nStatsSizeInBytes) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_028)");
	return base->GetCumulativeStats((OOVR_Compositor_CumulativeStats*) pStats, nStatsSizeInBytes);
}
void CVRCompositor_028::FadeToColor(float fSeconds, float fRed, float fGreen, float fBlue, float fAlpha, bool bBackground) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_028)");
	return base->FadeToColor(fSeconds, fRed, fGreen, fBlue, fAlpha, bBackground);
}
vr::HmdColor_t CVRCompositor_028::GetCurrentFadeColor(bool bBackground) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_028)");
	return base->GetCurrentFadeColor(bBackground);
}
void CVRCompositor_028::FadeGrid(float fSeconds, bool bFadeGridIn) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_028)");
	return base->FadeGrid(fSeconds, bFadeGridIn);
}
float CVRCompositor_028::GetCurrentGridAlpha() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_028)");
	return base->GetCurrentGridAlpha();
}
vr::IVRCompositor_028::EVRCompositorError CVRCompositor_028::SetSkyboxOverride(const vr::Texture_t* pTextures, uint32_t unTextureCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_028)");
	return (vr::IVRCompositor_028::EVRCompositorError) base->SetSkyboxOverride(pTextures, unTextureCount);
}
void CVRCompositor_028::ClearSkyboxOverride() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_028)");
	return base->ClearSkyboxOverride();
}
void CVRCompositor_028::CompositorBringToFront() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_028)");
	return base->CompositorBringToFront();
}
void CVRCompositor_028::CompositorGoToBack() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_028)");
	return base->CompositorGoToBack();
}
void CVRCompositor_028::CompositorQuit() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_028)");
	return base->CompositorQuit();
}
bool CVRCompositor_028::IsFullscreen() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_028)");
	return base->IsFullscreen();
}
uint32_t CVRCompositor_028::GetCurrentSceneFocusProcess() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_028)");
	return base->GetCurrentSceneFocusProcess();
}
uint32_t CVRCompositor_028::GetLastFrameRenderer() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_028)");
	return base->GetLastFrameRenderer();
}
bool CVRCompositor_028::CanRenderScene() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_028)");
	return base->CanRenderScene();
}
void CVRCompositor_028::ShowMirrorWindow() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_028)");
	return base->ShowMirrorWindow();
}
void CVRCompositor_028::HideMirrorWindow() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_028)");
	return base->HideMirrorWindow();
}
bool CVRCompositor_028::IsMirrorWindowVisible() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_028)");
	return base->IsMirrorWindowVisible();
}
void CVRCompositor_028::CompositorDumpImages() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_028)");
	return base->CompositorDumpImages();
}
bool CVRCompositor_028::ShouldAppRenderWithLowResources() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_028)");
	return base->ShouldAppRenderWithLowResources();
}
void CVRCompositor_028::ForceInterleavedReprojectionOn(bool bOverride) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_028)");
	return base->ForceInterleavedReprojectionOn(bOverride);
}
void CVRCompositor_028::ForceReconnectProcess() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_028)");
	return base->ForceReconnectProcess();
}
void CVRCompositor_028::SuspendRendering(bool bSuspend) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_028)");
	return base->SuspendRendering(bSuspend);
}
vr::IVRCompositor_028::EVRCompositorError CVRCompositor_028::GetMirrorTextureD3D11(vr::EVREye eEye, void* pD3D11DeviceOrResource, void** ppD3D11ShaderResourceView) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_028)");
	return (vr::IVRCompositor_028::EVRCompositorError) base->GetMirrorTextureD3D11(eEye, pD3D11DeviceOrResource, ppD3D11ShaderResourceView);
}
void CVRCompositor_028::ReleaseMirrorTextureD3D11(void* pD3D11ShaderResourceView) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_028)");
	return base->ReleaseMirrorTextureD3D11(pD3D11ShaderResourceView);
}
vr::IVRCompositor_028::EVRCompositorError CVRCompositor_028::GetMirrorTextureGL(vr::EVREye eEye, vr::glUInt_t* pglTextureId, vr::glSharedTextureHandle_t* pglSharedTextureHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_028)");
	return (vr::IVRCompositor_028::EVRCompositorError) base->GetMirrorTextureGL(eEye, pglTextureId, pglSharedTextureHandle);
}
bool CVRCompositor_028::ReleaseSharedGLTexture(vr::glUInt_t glTextureId, vr::glSharedTextureHandle_t glSharedTextureHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_028)");
	return base->ReleaseSharedGLTexture(glTextureId, glSharedTextureHandle);
}
void CVRCompositor_028::LockGLSharedTextureForAccess(vr::glSharedTextureHandle_t glSharedTextureHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_028)");
	return base->LockGLSharedTextureForAccess(glSharedTextureHandle);
}
void CVRCompositor_028::UnlockGLSharedTextureForAccess(vr::glSharedTextureHandle_t glSharedTextureHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_028)");
	return base->UnlockGLSharedTextureForAccess(glSharedTextureHandle);
}
uint32_t CVRCompositor_028::GetVulkanInstanceExtensionsRequired(char* pchValue, uint32_t unBufferSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_028)");
	return base->GetVulkanInstanceExtensionsRequired(pchValue, unBufferSize);
}
uint32_t CVRCompositor_028::GetVulkanDeviceExtensionsRequired(VkPhysicalDevice_T* pPhysicalDevice, char* pchValue, uint32_t unBufferSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_028)");
	return base->GetVulkanDeviceExtensionsRequired(pPhysicalDevice, pchValue, unBufferSize);
}
void CVRCompositor_028::SetExplicitTimingMode(vr::IVRCompositor_028::EVRCompositorTimingMode eTimingMode) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_028)");
	return base->SetExplicitTimingMode((OOVR_EVRCompositorTimingMode) eTimingMode);
}
vr::IVRCompositor_028::EVRCompositorError CVRCompositor_028::SubmitExplicitTimingData() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_028)");
	return (vr::IVRCompositor_028::EVRCompositorError) base->SubmitExplicitTimingData();
}
bool CVRCompositor_028::IsMotionSmoothingEnabled() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_028)");
	return base->IsMotionSmoothingEnabled();
}
bool CVRCompositor_028::IsMotionSmoothingSupported() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_028)");
	return base->IsMotionSmoothingSupported();
}
bool CVRCompositor_028::IsCurrentSceneFocusAppLoading() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_028)");
	return base->IsCurrentSceneFocusAppLoading();
}
vr::IVRCompositor_028::EVRCompositorError CVRCompositor_028::SetStageOverride_Async(const char* pchRenderModelPath, const vr::HmdMatrix34_t* pTransform, const vr::IVRCompositor_028::Compositor_StageRenderSettings* pRenderSettings, uint32_t nSizeOfRenderSettings) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_028)");
	return (vr::IVRCompositor_028::EVRCompositorError) base->SetStageOverride_Async(pchRenderModelPath, pTransform, (const OOVR_Compositor_StageRenderSettings*) pRenderSettings, nSizeOfRenderSettings);
}
void CVRCompositor_028::ClearStageOverride() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_028)");
	return base->ClearStageOverride();
}
bool CVRCompositor_028::GetCompositorBenchmarkResults(vr::Compositor_BenchmarkResults* pBenchmarkResults, uint32_t nSizeOfBenchmarkResults) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_028)");
	return base->GetCompositorBenchmarkResults(pBenchmarkResults, nSizeOfBenchmarkResults);
}
vr::IVRCompositor_028::EVRCompositorError CVRCompositor_028::GetLastPosePredictionIDs(uint32_t* pRenderPosePredictionID, uint32_t* pGamePosePredictionID) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_028)");
	return (vr::IVRCompositor_028::EVRCompositorError) base->GetLastPosePredictionIDs(pRenderPosePredictionID, pGamePosePredictionID);
}
vr::IVRCompositor_028::EVRCompositorError CVRCompositor_028::GetPosesForFrame(uint32_t unPosePredictionID, vr::TrackedDevicePose_t* pPoseArray, uint32_t unPoseArrayCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRCompositor_028)");
	return (vr::IVRCompositor_028::EVRCompositorError) base->GetPosesForFrame(unPosePredictionID, pPoseArray, unPoseArrayCount);
}
// FnTable for CVRCompositor_028:
static CVRCompositor_028 *fntable_Compositor_028_instance = NULL;
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_028_impl_SetTrackingSpace(vr::ETrackingUniverseOrigin eOrigin) { return fntable_Compositor_028_instance->SetTrackingSpace(eOrigin); }
static vr::ETrackingUniverseOrigin OPENVR_FNTABLE_CALLTYPE fntable_Compositor_028_impl_GetTrackingSpace() { return fntable_Compositor_028_instance->GetTrackingSpace(); }
static vr::IVRCompositor_028::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_028_impl_WaitGetPoses(vr::TrackedDevicePose_t* pRenderPoseArray, uint32_t unRenderPoseArrayCount, vr::TrackedDevicePose_t* pGamePoseArray, uint32_t unGamePoseArrayCount) { return fntable_Compositor_028_instance->WaitGetPoses(pRenderPoseArray, unRenderPoseArrayCount, pGamePoseArray, unGamePoseArrayCount); }
static vr::IVRCompositor_028::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_028_impl_GetLastPoses(vr::TrackedDevicePose_t* pRenderPoseArray, uint32_t unRenderPoseArrayCount, vr::TrackedDevicePose_t* pGamePoseArray, uint32_t unGamePoseArrayCount) { return fntable_Compositor_028_instance->GetLastPoses(pRenderPoseArray, unRenderPoseArrayCount, pGamePoseArray, unGamePoseArrayCount); }
static vr::IVRCompositor_028::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_028_impl_GetLastPoseForTrackedDeviceIndex(vr::TrackedDeviceIndex_t unDeviceIndex, vr::TrackedDevicePose_t* pOutputPose, vr::TrackedDevicePose_t* pOutputGamePose) { return fntable_Compositor_028_instance->GetLastPoseForTrackedDeviceIndex(unDeviceIndex, pOutputPose, pOutputGamePose); }
static vr::IVRCompositor_028::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_028_impl_Submit(vr::EVREye eEye, const vr::Texture_t* pTexture, const vr::VRTextureBounds_t* pBounds, vr::EVRSubmitFlags nSubmitFlags) { return fntable_Compositor_028_instance->Submit(eEye, pTexture, pBounds, nSubmitFlags); }
static vr::IVRCompositor_028::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_028_impl_SubmitWithArrayIndex(vr::EVREye eEye, const vr::Texture_t* pTexture, uint32_t unTextureArrayIndex, const vr::VRTextureBounds_t* pBounds, vr::EVRSubmitFlags nSubmitFlags) { return fntable_Compositor_028_instance->SubmitWithArrayIndex(eEye, pTexture, unTextureArrayIndex, pBounds, nSubmitFlags); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_028_impl_ClearLastSubmittedFrame() { return fntable_Compositor_028_instance->ClearLastSubmittedFrame(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_028_impl_PostPresentHandoff() { return fntable_Compositor_028_instance->PostPresentHandoff(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_028_impl_GetFrameTiming(vr::Compositor_FrameTiming* pTiming, uint32_t unFramesAgo) { return fntable_Compositor_028_instance->GetFrameTiming(pTiming, unFramesAgo); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Compositor_028_impl_GetFrameTimings(vr::Compositor_FrameTiming* pTiming, uint32_t nFrames) { return fntable_Compositor_028_instance->GetFrameTimings(pTiming, nFrames); }
static float OPENVR_FNTABLE_CALLTYPE fntable_Compositor_028_impl_GetFrameTimeRemaining() { return fntable_Compositor_028_instance->GetFrameTimeRemaining(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_028_impl_GetCumulativeStats(vr::IVRCompositor_028::Compositor_CumulativeStats* pStats, uint32_t nStatsSizeInBytes) { return fntable_Compositor_028_instance->GetCumulativeStats(pStats, nStatsSizeInBytes); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_028_impl_FadeToColor(float fSeconds, float fRed, float fGreen, float fBlue, float fAlpha, bool bBackground) { return fntable_Compositor_028_instance->FadeToColor(fSeconds, fRed, fGreen, fBlue, fAlpha, bBackground); }
static vr::HmdColor_t OPENVR_FNTABLE_CALLTYPE fntable_Compositor_028_impl_GetCurrentFadeColor(bool bBackground) { return fntable_Compositor_028_instance->GetCurrentFadeColor(bBackground); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_028_impl_FadeGrid(float fSeconds, bool bFadeGridIn) { return fntable_Compositor_028_instance->FadeGrid(fSeconds, bFadeGridIn); }
static float OPENVR_FNTABLE_CALLTYPE fntable_Compositor_028_impl_GetCurrentGridAlpha() { return fntable_Compositor_028_instance->GetCurrentGridAlpha(); }
static vr::IVRCompositor_028::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_028_impl_SetSkyboxOverride(const vr::Texture_t* pTextures, uint32_t unTextureCount) { return fntable_Compositor_028_instance->SetSkyboxOverride(pTextures, unTextureCount); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_028_impl_ClearSkyboxOverride() { return fntable_Compositor_028_instance->ClearSkyboxOverride(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_028_impl_CompositorBringToFront() { return fntable_Compositor_028_instance->CompositorBringToFront(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_028_impl_CompositorGoToBack() { return fntable_Compositor_028_instance->CompositorGoToBack(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_028_impl_CompositorQuit() { return fntable_Compositor_028_instance->CompositorQuit(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_028_impl_IsFullscreen() { return fntable_Compositor_028_instance->IsFullscreen(); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Compositor_028_impl_GetCurrentSceneFocusProcess() { return fntable_Compositor_028_instance->GetCurrentSceneFocusProcess(); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Compositor_028_impl_GetLastFrameRenderer() { return fntable_Compositor_028_instance->GetLastFrameRenderer(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_028_impl_CanRenderScene() { return fntable_Compositor_028_instance->CanRenderScene(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_028_impl_ShowMirrorWindow() { return fntable_Compositor_028_instance->ShowMirrorWindow(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_028_impl_HideMirrorWindow() { return fntable_Compositor_028_instance->HideMirrorWindow(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_028_impl_IsMirrorWindowVisible() { return fntable_Compositor_028_instance->IsMirrorWindowVisible(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_028_impl_CompositorDumpImages() { return fntable_Compositor_028_instance->CompositorDumpImages(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_028_impl_ShouldAppRenderWithLowResources() { return fntable_Compositor_028_instance->ShouldAppRenderWithLowResources(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_028_impl_ForceInterleavedReprojectionOn(bool bOverride) { return fntable_Compositor_028_instance->ForceInterleavedReprojectionOn(bOverride); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_028_impl_ForceReconnectProcess() { return fntable_Compositor_028_instance->ForceReconnectProcess(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_028_impl_SuspendRendering(bool bSuspend) { return fntable_Compositor_028_instance->SuspendRendering(bSuspend); }
static vr::IVRCompositor_028::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_028_impl_GetMirrorTextureD3D11(vr::EVREye eEye, void* pD3D11DeviceOrResource, void** ppD3D11ShaderResourceView) { return fntable_Compositor_028_instance->GetMirrorTextureD3D11(eEye, pD3D11DeviceOrResource, ppD3D11ShaderResourceView); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_028_impl_ReleaseMirrorTextureD3D11(void* pD3D11ShaderResourceView) { return fntable_Compositor_028_instance->ReleaseMirrorTextureD3D11(pD3D11ShaderResourceView); }
static vr::IVRCompositor_028::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_028_impl_GetMirrorTextureGL(vr::EVREye eEye, vr::glUInt_t* pglTextureId, vr::glSharedTextureHandle_t* pglSharedTextureHandle) { return fntable_Compositor_028_instance->GetMirrorTextureGL(eEye, pglTextureId, pglSharedTextureHandle); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_028_impl_ReleaseSharedGLTexture(vr::glUInt_t glTextureId, vr::glSharedTextureHandle_t glSharedTextureHandle) { return fntable_Compositor_028_instance->ReleaseSharedGLTexture(glTextureId, glSharedTextureHandle); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_028_impl_LockGLSharedTextureForAccess(vr::glSharedTextureHandle_t glSharedTextureHandle) { return fntable_Compositor_028_instance->LockGLSharedTextureForAccess(glSharedTextureHandle); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_028_impl_UnlockGLSharedTextureForAccess(vr::glSharedTextureHandle_t glSharedTextureHandle) { return fntable_Compositor_028_instance->UnlockGLSharedTextureForAccess(glSharedTextureHandle); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Compositor_028_impl_GetVulkanInstanceExtensionsRequired(char* pchValue, uint32_t unBufferSize) { return fntable_Compositor_028_instance->GetVulkanInstanceExtensionsRequired(pchValue, unBufferSize); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Compositor_028_impl_GetVulkanDeviceExtensionsRequired(VkPhysicalDevice_T* pPhysicalDevice, char* pchValue, uint32_t unBufferSize) { return fntable_Compositor_028_instance->GetVulkanDeviceExtensionsRequired(pPhysicalDevice, pchValue, unBufferSize); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_028_impl_SetExplicitTimingMode(vr::IVRCompositor_028::EVRCompositorTimingMode eTimingMode) { return fntable_Compositor_028_instance->SetExplicitTimingMode(eTimingMode); }
static vr::IVRCompositor_028::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_028_impl_SubmitExplicitTimingData() { return fntable_Compositor_028_instance->SubmitExplicitTimingData(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_028_impl_IsMotionSmoothingEnabled() { return fntable_Compositor_028_instance->IsMotionSmoothingEnabled(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_028_impl_IsMotionSmoothingSupported() { return fntable_Compositor_028_instance->IsMotionSmoothingSupported(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_028_impl_IsCurrentSceneFocusAppLoading() { return fntable_Compositor_028_instance->IsCurrentSceneFocusAppLoading(); }
static vr::IVRCompositor_028::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_028_impl_SetStageOverride_Async(const char* pchRenderModelPath, const vr::HmdMatrix34_t* pTransform, const vr::IVRCompositor_028::Compositor_StageRenderSettings* pRenderSettings, uint32_t nSizeOfRenderSettings) { return fntable_Compositor_028_instance->SetStageOverride_Async(pchRenderModelPath, pTransform, pRenderSettings, nSizeOfRenderSettings); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Compositor_028_impl_ClearStageOverride() { return fntable_Compositor_028_instance->ClearStageOverride(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Compositor_028_impl_GetCompositorBenchmarkResults(vr::Compositor_BenchmarkResults* pBenchmarkResults, uint32_t nSizeOfBenchmarkResults) { return fntable_Compositor_028_instance->GetCompositorBenchmarkResults(pBenchmarkResults, nSizeOfBenchmarkResults); }
static vr::IVRCompositor_028::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_028_impl_GetLastPosePredictionIDs(uint32_t* pRenderPosePredictionID, uint32_t* pGamePosePredictionID) { return fntable_Compositor_028_instance->GetLastPosePredictionIDs(pRenderPosePredictionID, pGamePosePredictionID); }
static vr::IVRCompositor_028::EVRCompositorError OPENVR_FNTABLE_CALLTYPE fntable_Compositor_028_impl_GetPosesForFrame(uint32_t unPosePredictionID, vr::TrackedDevicePose_t* pPoseArray, uint32_t unPoseArrayCount) { return fntable_Compositor_028_instance->GetPosesForFrame(unPosePredictionID, pPoseArray, unPoseArrayCount); }
static void *fntable_Compositor_028_funcs[] = {
	(void*) fntable_Compositor_028_impl_SetTrackingSpace,
	(void*) fntable_Compositor_028_impl_GetTrackingSpace,
	(void*) fntable_Compositor_028_impl_WaitGetPoses,
	(void*) fntable_Compositor_028_impl_GetLastPoses,
	(void*) fntable_Compositor_028_impl_GetLastPoseForTrackedDeviceIndex,
	(void*) fntable_Compositor_028_impl_Submit,
	(void*) fntable_Compositor_028_impl_SubmitWithArrayIndex,
	(void*) fntable_Compositor_028_impl_ClearLastSubmittedFrame,
	(void*) fntable_Compositor_028_impl_PostPresentHandoff,
	(void*) fntable_Compositor_028_impl_GetFrameTiming,
	(void*) fntable_Compositor_028_impl_GetFrameTimings,
	(void*) fntable_Compositor_028_impl_GetFrameTimeRemaining,
	(void*) fntable_Compositor_028_impl_GetCumulativeStats,
	(void*) fntable_Compositor_028_impl_FadeToColor,
	(void*) fntable_Compositor_028_impl_GetCurrentFadeColor,
	(void*) fntable_Compositor_028_impl_FadeGrid,
	(void*) fntable_Compositor_028_impl_GetCurrentGridAlpha,
	(void*) fntable_Compositor_028_impl_SetSkyboxOverride,
	(void*) fntable_Compositor_028_impl_ClearSkyboxOverride,
	(void*) fntable_Compositor_028_impl_CompositorBringToFront,
	(void*) fntable_Compositor_028_impl_CompositorGoToBack,
	(void*) fntable_Compositor_028_impl_CompositorQuit,
	(void*) fntable_Compositor_028_impl_IsFullscreen,
	(void*) fntable_Compositor_028_impl_GetCurrentSceneFocusProcess,
	(void*) fntable_Compositor_028_impl_GetLastFrameRenderer,
	(void*) fntable_Compositor_028_impl_CanRenderScene,
	(void*) fntable_Compositor_028_impl_ShowMirrorWindow,
	(void*) fntable_Compositor_028_impl_HideMirrorWindow,
	(void*) fntable_Compositor_028_impl_IsMirrorWindowVisible,
	(void*) fntable_Compositor_028_impl_CompositorDumpImages,
	(void*) fntable_Compositor_028_impl_ShouldAppRenderWithLowResources,
	(void*) fntable_Compositor_028_impl_ForceInterleavedReprojectionOn,
	(void*) fntable_Compositor_028_impl_ForceReconnectProcess,
	(void*) fntable_Compositor_028_impl_SuspendRendering,
	(void*) fntable_Compositor_028_impl_GetMirrorTextureD3D11,
	(void*) fntable_Compositor_028_impl_ReleaseMirrorTextureD3D11,
	(void*) fntable_Compositor_028_impl_GetMirrorTextureGL,
	(void*) fntable_Compositor_028_impl_ReleaseSharedGLTexture,
	(void*) fntable_Compositor_028_impl_LockGLSharedTextureForAccess,
	(void*) fntable_Compositor_028_impl_UnlockGLSharedTextureForAccess,
	(void*) fntable_Compositor_028_impl_GetVulkanInstanceExtensionsRequired,
	(void*) fntable_Compositor_028_impl_GetVulkanDeviceExtensionsRequired,
	(void*) fntable_Compositor_028_impl_SetExplicitTimingMode,
	(void*) fntable_Compositor_028_impl_SubmitExplicitTimingData,
	(void*) fntable_Compositor_028_impl_IsMotionSmoothingEnabled,
	(void*) fntable_Compositor_028_impl_IsMotionSmoothingSupported,
	(void*) fntable_Compositor_028_impl_IsCurrentSceneFocusAppLoading,
	(void*) fntable_Compositor_028_impl_SetStageOverride_Async,
	(void*) fntable_Compositor_028_impl_ClearStageOverride,
	(void*) fntable_Compositor_028_impl_GetCompositorBenchmarkResults,
	(void*) fntable_Compositor_028_impl_GetLastPosePredictionIDs,
	(void*) fntable_Compositor_028_impl_GetPosesForFrame,
};
void** CVRCompositor_028::_GetStatFuncList() { fntable_Compositor_028_instance = this; return fntable_Compositor_028_funcs; }
void CVRCompositor_028::Delete() { delete this; }
#include "GVRSystem.gen.h"
// Single inst of BaseSystem
static std::weak_ptr<BaseSystem> _single_inst_System;
static BaseSystem *_single_inst_System_unsafe = NULL;
std::shared_ptr<BaseSystem> GetBaseSystem() { return _single_inst_System.lock(); };
BaseSystem* GetUnsafeBaseSystem() { return _single_inst_System_unsafe; };
std::shared_ptr<BaseSystem> GetCreateBaseSystem() {
	std::shared_ptr<BaseSystem> ret = _single_inst_System.lock();
	if(!ret) {
		ret = std::shared_ptr<BaseSystem>(new BaseSystem(), [](BaseSystem *obj){ _single_inst_System_unsafe = NULL; delete obj; });
		_single_inst_System = ret;
		_single_inst_System_unsafe = ret.get();
	}
	return ret;
}
// Misc for CVRSystem_009:
CVRSystem_009::CVRSystem_009() : base(GetCreateBaseSystem()) {}
// Interface methods for CVRSystem_009:
void CVRSystem_009::GetRecommendedRenderTargetSize(uint32_t* pnWidth, uint32_t* pnHeight) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_009)");
	return base->GetRecommendedRenderTargetSize(pnWidth, pnHeight);
}
vr::HmdMatrix44_t CVRSystem_009::GetProjectionMatrix(vr::EVREye eEye, float fNearZ, float fFarZ, EGraphicsAPIConvention eProjType) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_009)");
	return base->GetProjectionMatrix(eEye, fNearZ, fFarZ, eProjType);
}
void CVRSystem_009::GetProjectionRaw(vr::EVREye eEye, float* pfLeft, float* pfRight, float* pfTop, float* pfBottom) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_009)");
	return base->GetProjectionRaw(eEye, pfLeft, pfRight, pfTop, pfBottom);
}
vr::DistortionCoordinates_t CVRSystem_009::ComputeDistortion(vr::EVREye eEye, float fU, float fV) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_009)");
	return base->ComputeDistortion(eEye, fU, fV);
}
vr::HmdMatrix34_t CVRSystem_009::GetEyeToHeadTransform(vr::EVREye eEye) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_009)");
	return base->GetEyeToHeadTransform(eEye);
}
bool CVRSystem_009::GetTimeSinceLastVsync(float* pfSecondsSinceLastVsync, uint64_t* pulFrameCounter) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_009)");
	return base->GetTimeSinceLastVsync(pfSecondsSinceLastVsync, pulFrameCounter);
}
int32_t CVRSystem_009::GetD3D9AdapterIndex() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_009)");
	return base->GetD3D9AdapterIndex();
}
void CVRSystem_009::GetDXGIOutputInfo(int32_t* pnAdapterIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_009)");
	return base->GetDXGIOutputInfo(pnAdapterIndex);
}
bool CVRSystem_009::IsDisplayOnDesktop() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_009)");
	return base->IsDisplayOnDesktop();
}
bool CVRSystem_009::SetDisplayVisibility(bool bIsVisibleOnDesktop) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_009)");
	return base->SetDisplayVisibility(bIsVisibleOnDesktop);
}
void CVRSystem_009::GetDeviceToAbsoluteTrackingPose(vr::ETrackingUniverseOrigin eOrigin, float fPredictedSecondsToPhotonsFromNow, vr::TrackedDevicePose_t* pTrackedDevicePoseArray, uint32_t unTrackedDevicePoseArrayCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_009)");
	return base->GetDeviceToAbsoluteTrackingPose(eOrigin, fPredictedSecondsToPhotonsFromNow, pTrackedDevicePoseArray, unTrackedDevicePoseArrayCount);
}
void CVRSystem_009::ResetSeatedZeroPose() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_009)");
	return base->ResetSeatedZeroPose();
}
vr::HmdMatrix34_t CVRSystem_009::GetSeatedZeroPoseToStandingAbsoluteTrackingPose() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_009)");
	return base->GetSeatedZeroPoseToStandingAbsoluteTrackingPose();
}
vr::HmdMatrix34_t CVRSystem_009::GetRawZeroPoseToStandingAbsoluteTrackingPose() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_009)");
	return base->GetRawZeroPoseToStandingAbsoluteTrackingPose();
}
uint32_t CVRSystem_009::GetSortedTrackedDeviceIndicesOfClass(vr::ETrackedDeviceClass eTrackedDeviceClass, vr::TrackedDeviceIndex_t* punTrackedDeviceIndexArray, uint32_t unTrackedDeviceIndexArrayCount, vr::TrackedDeviceIndex_t unRelativeToTrackedDeviceIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_009)");
	return base->GetSortedTrackedDeviceIndicesOfClass(eTrackedDeviceClass, punTrackedDeviceIndexArray, unTrackedDeviceIndexArrayCount, unRelativeToTrackedDeviceIndex);
}
vr::EDeviceActivityLevel CVRSystem_009::GetTrackedDeviceActivityLevel(vr::TrackedDeviceIndex_t unDeviceId) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_009)");
	return base->GetTrackedDeviceActivityLevel(unDeviceId);
}
void CVRSystem_009::ApplyTransform(vr::TrackedDevicePose_t* pOutputPose, const vr::TrackedDevicePose_t* pTrackedDevicePose, const vr::HmdMatrix34_t* pTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_009)");
	return base->ApplyTransform(pOutputPose, pTrackedDevicePose, pTransform);
}
vr::ETrackedDeviceClass CVRSystem_009::GetTrackedDeviceClass(vr::TrackedDeviceIndex_t unDeviceIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_009)");
	return base->GetTrackedDeviceClass(unDeviceIndex);
}
bool CVRSystem_009::IsTrackedDeviceConnected(vr::TrackedDeviceIndex_t unDeviceIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_009)");
	return base->IsTrackedDeviceConnected(unDeviceIndex);
}
bool CVRSystem_009::GetBoolTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_009)");
	return base->GetBoolTrackedDeviceProperty(unDeviceIndex, prop, pError);
}
float CVRSystem_009::GetFloatTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_009)");
	return base->GetFloatTrackedDeviceProperty(unDeviceIndex, prop, pError);
}
int32_t CVRSystem_009::GetInt32TrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_009)");
	return base->GetInt32TrackedDeviceProperty(unDeviceIndex, prop, pError);
}
uint64_t CVRSystem_009::GetUint64TrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_009)");
	return base->GetUint64TrackedDeviceProperty(unDeviceIndex, prop, pError);
}
vr::HmdMatrix34_t CVRSystem_009::GetMatrix34TrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_009)");
	return base->GetMatrix34TrackedDeviceProperty(unDeviceIndex, prop, pError);
}
uint32_t CVRSystem_009::GetStringTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, char* pchValue, uint32_t unBufferSize, vr::ETrackedPropertyError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_009)");
	return base->GetStringTrackedDeviceProperty(unDeviceIndex, prop, pchValue, unBufferSize, pError);
}
const char* CVRSystem_009::GetPropErrorNameFromEnum(vr::ETrackedPropertyError error) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_009)");
	return base->GetPropErrorNameFromEnum(error);
}
const char* CVRSystem_009::GetEventTypeNameFromEnum(vr::EVREventType eType) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_009)");
	return base->GetEventTypeNameFromEnum(eType);
}
vr::HiddenAreaMesh_t CVRSystem_009::GetHiddenAreaMesh(vr::EVREye eEye) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_009)");
	return base->GetHiddenAreaMesh(eEye);
}
void CVRSystem_009::TriggerHapticPulse(vr::TrackedDeviceIndex_t unControllerDeviceIndex, uint32_t unAxisId, unsigned short usDurationMicroSec) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_009)");
	return base->TriggerHapticPulse(unControllerDeviceIndex, unAxisId, usDurationMicroSec);
}
const char* CVRSystem_009::GetButtonIdNameFromEnum(vr::EVRButtonId eButtonId) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_009)");
	return base->GetButtonIdNameFromEnum(eButtonId);
}
const char* CVRSystem_009::GetControllerAxisTypeNameFromEnum(vr::EVRControllerAxisType eAxisType) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_009)");
	return base->GetControllerAxisTypeNameFromEnum(eAxisType);
}
bool CVRSystem_009::CaptureInputFocus() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_009)");
	return base->CaptureInputFocus();
}
void CVRSystem_009::ReleaseInputFocus() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_009)");
	return base->ReleaseInputFocus();
}
bool CVRSystem_009::IsInputFocusCapturedByAnotherProcess() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_009)");
	return base->IsInputFocusCapturedByAnotherProcess();
}
uint32_t CVRSystem_009::DriverDebugRequest(vr::TrackedDeviceIndex_t unDeviceIndex, const char* pchRequest, char* pchResponseBuffer, uint32_t unResponseBufferSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_009)");
	return base->DriverDebugRequest(unDeviceIndex, pchRequest, pchResponseBuffer, unResponseBufferSize);
}
vr::EVRFirmwareError CVRSystem_009::PerformFirmwareUpdate(vr::TrackedDeviceIndex_t unDeviceIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_009)");
	return base->PerformFirmwareUpdate(unDeviceIndex);
}
void CVRSystem_009::AcknowledgeQuit_Exiting() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_009)");
	return base->AcknowledgeQuit_Exiting();
}
void CVRSystem_009::AcknowledgeQuit_UserPrompt() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_009)");
	return base->AcknowledgeQuit_UserPrompt();
}
// FnTable for CVRSystem_009:
static CVRSystem_009 *fntable_System_009_instance = NULL;
static void OPENVR_FNTABLE_CALLTYPE fntable_System_009_impl_GetRecommendedRenderTargetSize(uint32_t* pnWidth, uint32_t* pnHeight) { return fntable_System_009_instance->GetRecommendedRenderTargetSize(pnWidth, pnHeight); }
static vr::HmdMatrix44_t OPENVR_FNTABLE_CALLTYPE fntable_System_009_impl_GetProjectionMatrix(vr::EVREye eEye, float fNearZ, float fFarZ, EGraphicsAPIConvention eProjType) { return fntable_System_009_instance->GetProjectionMatrix(eEye, fNearZ, fFarZ, eProjType); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_009_impl_GetProjectionRaw(vr::EVREye eEye, float* pfLeft, float* pfRight, float* pfTop, float* pfBottom) { return fntable_System_009_instance->GetProjectionRaw(eEye, pfLeft, pfRight, pfTop, pfBottom); }
static vr::DistortionCoordinates_t OPENVR_FNTABLE_CALLTYPE fntable_System_009_impl_ComputeDistortion(vr::EVREye eEye, float fU, float fV) { return fntable_System_009_instance->ComputeDistortion(eEye, fU, fV); }
static vr::HmdMatrix34_t OPENVR_FNTABLE_CALLTYPE fntable_System_009_impl_GetEyeToHeadTransform(vr::EVREye eEye) { return fntable_System_009_instance->GetEyeToHeadTransform(eEye); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_009_impl_GetTimeSinceLastVsync(float* pfSecondsSinceLastVsync, uint64_t* pulFrameCounter) { return fntable_System_009_instance->GetTimeSinceLastVsync(pfSecondsSinceLastVsync, pulFrameCounter); }
static int32_t OPENVR_FNTABLE_CALLTYPE fntable_System_009_impl_GetD3D9AdapterIndex() { return fntable_System_009_instance->GetD3D9AdapterIndex(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_009_impl_GetDXGIOutputInfo(int32_t* pnAdapterIndex) { return fntable_System_009_instance->GetDXGIOutputInfo(pnAdapterIndex); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_009_impl_IsDisplayOnDesktop() { return fntable_System_009_instance->IsDisplayOnDesktop(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_009_impl_SetDisplayVisibility(bool bIsVisibleOnDesktop) { return fntable_System_009_instance->SetDisplayVisibility(bIsVisibleOnDesktop); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_009_impl_GetDeviceToAbsoluteTrackingPose(vr::ETrackingUniverseOrigin eOrigin, float fPredictedSecondsToPhotonsFromNow, vr::TrackedDevicePose_t* pTrackedDevicePoseArray, uint32_t unTrackedDevicePoseArrayCount) { return fntable_System_009_instance->GetDeviceToAbsoluteTrackingPose(eOrigin, fPredictedSecondsToPhotonsFromNow, pTrackedDevicePoseArray, unTrackedDevicePoseArrayCount); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_009_impl_ResetSeatedZeroPose() { return fntable_System_009_instance->ResetSeatedZeroPose(); }
static vr::HmdMatrix34_t OPENVR_FNTABLE_CALLTYPE fntable_System_009_impl_GetSeatedZeroPoseToStandingAbsoluteTrackingPose() { return fntable_System_009_instance->GetSeatedZeroPoseToStandingAbsoluteTrackingPose(); }
static vr::HmdMatrix34_t OPENVR_FNTABLE_CALLTYPE fntable_System_009_impl_GetRawZeroPoseToStandingAbsoluteTrackingPose() { return fntable_System_009_instance->GetRawZeroPoseToStandingAbsoluteTrackingPose(); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_System_009_impl_GetSortedTrackedDeviceIndicesOfClass(vr::ETrackedDeviceClass eTrackedDeviceClass, vr::TrackedDeviceIndex_t* punTrackedDeviceIndexArray, uint32_t unTrackedDeviceIndexArrayCount, vr::TrackedDeviceIndex_t unRelativeToTrackedDeviceIndex) { return fntable_System_009_instance->GetSortedTrackedDeviceIndicesOfClass(eTrackedDeviceClass, punTrackedDeviceIndexArray, unTrackedDeviceIndexArrayCount, unRelativeToTrackedDeviceIndex); }
static vr::EDeviceActivityLevel OPENVR_FNTABLE_CALLTYPE fntable_System_009_impl_GetTrackedDeviceActivityLevel(vr::TrackedDeviceIndex_t unDeviceId) { return fntable_System_009_instance->GetTrackedDeviceActivityLevel(unDeviceId); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_009_impl_ApplyTransform(vr::TrackedDevicePose_t* pOutputPose, const vr::TrackedDevicePose_t* pTrackedDevicePose, const vr::HmdMatrix34_t* pTransform) { return fntable_System_009_instance->ApplyTransform(pOutputPose, pTrackedDevicePose, pTransform); }
static vr::ETrackedDeviceClass OPENVR_FNTABLE_CALLTYPE fntable_System_009_impl_GetTrackedDeviceClass(vr::TrackedDeviceIndex_t unDeviceIndex) { return fntable_System_009_instance->GetTrackedDeviceClass(unDeviceIndex); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_009_impl_IsTrackedDeviceConnected(vr::TrackedDeviceIndex_t unDeviceIndex) { return fntable_System_009_instance->IsTrackedDeviceConnected(unDeviceIndex); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_009_impl_GetBoolTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) { return fntable_System_009_instance->GetBoolTrackedDeviceProperty(unDeviceIndex, prop, pError); }
static float OPENVR_FNTABLE_CALLTYPE fntable_System_009_impl_GetFloatTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) { return fntable_System_009_instance->GetFloatTrackedDeviceProperty(unDeviceIndex, prop, pError); }
static int32_t OPENVR_FNTABLE_CALLTYPE fntable_System_009_impl_GetInt32TrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) { return fntable_System_009_instance->GetInt32TrackedDeviceProperty(unDeviceIndex, prop, pError); }
static uint64_t OPENVR_FNTABLE_CALLTYPE fntable_System_009_impl_GetUint64TrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) { return fntable_System_009_instance->GetUint64TrackedDeviceProperty(unDeviceIndex, prop, pError); }
static vr::HmdMatrix34_t OPENVR_FNTABLE_CALLTYPE fntable_System_009_impl_GetMatrix34TrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) { return fntable_System_009_instance->GetMatrix34TrackedDeviceProperty(unDeviceIndex, prop, pError); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_System_009_impl_GetStringTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, char* pchValue, uint32_t unBufferSize, vr::ETrackedPropertyError* pError) { return fntable_System_009_instance->GetStringTrackedDeviceProperty(unDeviceIndex, prop, pchValue, unBufferSize, pError); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_System_009_impl_GetPropErrorNameFromEnum(vr::ETrackedPropertyError error) { return fntable_System_009_instance->GetPropErrorNameFromEnum(error); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_009_impl_PollNextEvent(vr::VREvent_t* pEvent) { return fntable_System_009_instance->PollNextEvent(pEvent); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_009_impl_PollNextEventWithPose(vr::ETrackingUniverseOrigin eOrigin, vr::VREvent_t* pEvent, vr::TrackedDevicePose_t* pTrackedDevicePose) { return fntable_System_009_instance->PollNextEventWithPose(eOrigin, pEvent, pTrackedDevicePose); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_System_009_impl_GetEventTypeNameFromEnum(vr::EVREventType eType) { return fntable_System_009_instance->GetEventTypeNameFromEnum(eType); }
static vr::HiddenAreaMesh_t OPENVR_FNTABLE_CALLTYPE fntable_System_009_impl_GetHiddenAreaMesh(vr::EVREye eEye) { return fntable_System_009_instance->GetHiddenAreaMesh(eEye); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_009_impl_GetControllerState(vr::TrackedDeviceIndex_t unControllerDeviceIndex, vr::VRControllerState_t* pControllerState) { return fntable_System_009_instance->GetControllerState(unControllerDeviceIndex, pControllerState); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_009_impl_GetControllerStateWithPose(vr::ETrackingUniverseOrigin eOrigin, vr::TrackedDeviceIndex_t unControllerDeviceIndex, vr::VRControllerState_t* pControllerState, vr::TrackedDevicePose_t* pTrackedDevicePose) { return fntable_System_009_instance->GetControllerStateWithPose(eOrigin, unControllerDeviceIndex, pControllerState, pTrackedDevicePose); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_009_impl_TriggerHapticPulse(vr::TrackedDeviceIndex_t unControllerDeviceIndex, uint32_t unAxisId, unsigned short usDurationMicroSec) { return fntable_System_009_instance->TriggerHapticPulse(unControllerDeviceIndex, unAxisId, usDurationMicroSec); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_System_009_impl_GetButtonIdNameFromEnum(vr::EVRButtonId eButtonId) { return fntable_System_009_instance->GetButtonIdNameFromEnum(eButtonId); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_System_009_impl_GetControllerAxisTypeNameFromEnum(vr::EVRControllerAxisType eAxisType) { return fntable_System_009_instance->GetControllerAxisTypeNameFromEnum(eAxisType); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_009_impl_CaptureInputFocus() { return fntable_System_009_instance->CaptureInputFocus(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_009_impl_ReleaseInputFocus() { return fntable_System_009_instance->ReleaseInputFocus(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_009_impl_IsInputFocusCapturedByAnotherProcess() { return fntable_System_009_instance->IsInputFocusCapturedByAnotherProcess(); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_System_009_impl_DriverDebugRequest(vr::TrackedDeviceIndex_t unDeviceIndex, const char* pchRequest, char* pchResponseBuffer, uint32_t unResponseBufferSize) { return fntable_System_009_instance->DriverDebugRequest(unDeviceIndex, pchRequest, pchResponseBuffer, unResponseBufferSize); }
static vr::EVRFirmwareError OPENVR_FNTABLE_CALLTYPE fntable_System_009_impl_PerformFirmwareUpdate(vr::TrackedDeviceIndex_t unDeviceIndex) { return fntable_System_009_instance->PerformFirmwareUpdate(unDeviceIndex); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_009_impl_AcknowledgeQuit_Exiting() { return fntable_System_009_instance->AcknowledgeQuit_Exiting(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_009_impl_AcknowledgeQuit_UserPrompt() { return fntable_System_009_instance->AcknowledgeQuit_UserPrompt(); }
static void *fntable_System_009_funcs[] = {
	(void*) fntable_System_009_impl_GetRecommendedRenderTargetSize,
	(void*) fntable_System_009_impl_GetProjectionMatrix,
	(void*) fntable_System_009_impl_GetProjectionRaw,
	(void*) fntable_System_009_impl_ComputeDistortion,
	(void*) fntable_System_009_impl_GetEyeToHeadTransform,
	(void*) fntable_System_009_impl_GetTimeSinceLastVsync,
	(void*) fntable_System_009_impl_GetD3D9AdapterIndex,
	(void*) fntable_System_009_impl_GetDXGIOutputInfo,
	(void*) fntable_System_009_impl_IsDisplayOnDesktop,
	(void*) fntable_System_009_impl_SetDisplayVisibility,
	(void*) fntable_System_009_impl_GetDeviceToAbsoluteTrackingPose,
	(void*) fntable_System_009_impl_ResetSeatedZeroPose,
	(void*) fntable_System_009_impl_GetSeatedZeroPoseToStandingAbsoluteTrackingPose,
	(void*) fntable_System_009_impl_GetRawZeroPoseToStandingAbsoluteTrackingPose,
	(void*) fntable_System_009_impl_GetSortedTrackedDeviceIndicesOfClass,
	(void*) fntable_System_009_impl_GetTrackedDeviceActivityLevel,
	(void*) fntable_System_009_impl_ApplyTransform,
	(void*) fntable_System_009_impl_GetTrackedDeviceClass,
	(void*) fntable_System_009_impl_IsTrackedDeviceConnected,
	(void*) fntable_System_009_impl_GetBoolTrackedDeviceProperty,
	(void*) fntable_System_009_impl_GetFloatTrackedDeviceProperty,
	(void*) fntable_System_009_impl_GetInt32TrackedDeviceProperty,
	(void*) fntable_System_009_impl_GetUint64TrackedDeviceProperty,
	(void*) fntable_System_009_impl_GetMatrix34TrackedDeviceProperty,
	(void*) fntable_System_009_impl_GetStringTrackedDeviceProperty,
	(void*) fntable_System_009_impl_GetPropErrorNameFromEnum,
	(void*) fntable_System_009_impl_PollNextEvent,
	(void*) fntable_System_009_impl_PollNextEventWithPose,
	(void*) fntable_System_009_impl_GetEventTypeNameFromEnum,
	(void*) fntable_System_009_impl_GetHiddenAreaMesh,
	(void*) fntable_System_009_impl_GetControllerState,
	(void*) fntable_System_009_impl_GetControllerStateWithPose,
	(void*) fntable_System_009_impl_TriggerHapticPulse,
	(void*) fntable_System_009_impl_GetButtonIdNameFromEnum,
	(void*) fntable_System_009_impl_GetControllerAxisTypeNameFromEnum,
	(void*) fntable_System_009_impl_CaptureInputFocus,
	(void*) fntable_System_009_impl_ReleaseInputFocus,
	(void*) fntable_System_009_impl_IsInputFocusCapturedByAnotherProcess,
	(void*) fntable_System_009_impl_DriverDebugRequest,
	(void*) fntable_System_009_impl_PerformFirmwareUpdate,
	(void*) fntable_System_009_impl_AcknowledgeQuit_Exiting,
	(void*) fntable_System_009_impl_AcknowledgeQuit_UserPrompt,
};
void** CVRSystem_009::_GetStatFuncList() { fntable_System_009_instance = this; return fntable_System_009_funcs; }
void CVRSystem_009::Delete() { delete this; }
// Misc for CVRSystem_011:
CVRSystem_011::CVRSystem_011() : base(GetCreateBaseSystem()) {}
// Interface methods for CVRSystem_011:
void CVRSystem_011::GetRecommendedRenderTargetSize(uint32_t* pnWidth, uint32_t* pnHeight) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_011)");
	return base->GetRecommendedRenderTargetSize(pnWidth, pnHeight);
}
vr::HmdMatrix44_t CVRSystem_011::GetProjectionMatrix(vr::EVREye eEye, float fNearZ, float fFarZ, EGraphicsAPIConvention eProjType) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_011)");
	return base->GetProjectionMatrix(eEye, fNearZ, fFarZ, eProjType);
}
void CVRSystem_011::GetProjectionRaw(vr::EVREye eEye, float* pfLeft, float* pfRight, float* pfTop, float* pfBottom) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_011)");
	return base->GetProjectionRaw(eEye, pfLeft, pfRight, pfTop, pfBottom);
}
vr::DistortionCoordinates_t CVRSystem_011::ComputeDistortion(vr::EVREye eEye, float fU, float fV) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_011)");
	return base->ComputeDistortion(eEye, fU, fV);
}
vr::HmdMatrix34_t CVRSystem_011::GetEyeToHeadTransform(vr::EVREye eEye) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_011)");
	return base->GetEyeToHeadTransform(eEye);
}
bool CVRSystem_011::GetTimeSinceLastVsync(float* pfSecondsSinceLastVsync, uint64_t* pulFrameCounter) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_011)");
	return base->GetTimeSinceLastVsync(pfSecondsSinceLastVsync, pulFrameCounter);
}
int32_t CVRSystem_011::GetD3D9AdapterIndex() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_011)");
	return base->GetD3D9AdapterIndex();
}
void CVRSystem_011::GetDXGIOutputInfo(int32_t* pnAdapterIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_011)");
	return base->GetDXGIOutputInfo(pnAdapterIndex);
}
bool CVRSystem_011::IsDisplayOnDesktop() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_011)");
	return base->IsDisplayOnDesktop();
}
bool CVRSystem_011::SetDisplayVisibility(bool bIsVisibleOnDesktop) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_011)");
	return base->SetDisplayVisibility(bIsVisibleOnDesktop);
}
void CVRSystem_011::GetDeviceToAbsoluteTrackingPose(vr::ETrackingUniverseOrigin eOrigin, float fPredictedSecondsToPhotonsFromNow, vr::TrackedDevicePose_t* pTrackedDevicePoseArray, uint32_t unTrackedDevicePoseArrayCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_011)");
	return base->GetDeviceToAbsoluteTrackingPose(eOrigin, fPredictedSecondsToPhotonsFromNow, pTrackedDevicePoseArray, unTrackedDevicePoseArrayCount);
}
void CVRSystem_011::ResetSeatedZeroPose() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_011)");
	return base->ResetSeatedZeroPose();
}
vr::HmdMatrix34_t CVRSystem_011::GetSeatedZeroPoseToStandingAbsoluteTrackingPose() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_011)");
	return base->GetSeatedZeroPoseToStandingAbsoluteTrackingPose();
}
vr::HmdMatrix34_t CVRSystem_011::GetRawZeroPoseToStandingAbsoluteTrackingPose() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_011)");
	return base->GetRawZeroPoseToStandingAbsoluteTrackingPose();
}
uint32_t CVRSystem_011::GetSortedTrackedDeviceIndicesOfClass(vr::ETrackedDeviceClass eTrackedDeviceClass, vr::TrackedDeviceIndex_t* punTrackedDeviceIndexArray, uint32_t unTrackedDeviceIndexArrayCount, vr::TrackedDeviceIndex_t unRelativeToTrackedDeviceIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_011)");
	return base->GetSortedTrackedDeviceIndicesOfClass(eTrackedDeviceClass, punTrackedDeviceIndexArray, unTrackedDeviceIndexArrayCount, unRelativeToTrackedDeviceIndex);
}
vr::EDeviceActivityLevel CVRSystem_011::GetTrackedDeviceActivityLevel(vr::TrackedDeviceIndex_t unDeviceId) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_011)");
	return base->GetTrackedDeviceActivityLevel(unDeviceId);
}
void CVRSystem_011::ApplyTransform(vr::TrackedDevicePose_t* pOutputPose, const vr::TrackedDevicePose_t* pTrackedDevicePose, const vr::HmdMatrix34_t* pTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_011)");
	return base->ApplyTransform(pOutputPose, pTrackedDevicePose, pTransform);
}
vr::TrackedDeviceIndex_t CVRSystem_011::GetTrackedDeviceIndexForControllerRole(vr::ETrackedControllerRole unDeviceType) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_011)");
	return base->GetTrackedDeviceIndexForControllerRole(unDeviceType);
}
vr::ETrackedControllerRole CVRSystem_011::GetControllerRoleForTrackedDeviceIndex(vr::TrackedDeviceIndex_t unDeviceIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_011)");
	return base->GetControllerRoleForTrackedDeviceIndex(unDeviceIndex);
}
vr::ETrackedDeviceClass CVRSystem_011::GetTrackedDeviceClass(vr::TrackedDeviceIndex_t unDeviceIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_011)");
	return base->GetTrackedDeviceClass(unDeviceIndex);
}
bool CVRSystem_011::IsTrackedDeviceConnected(vr::TrackedDeviceIndex_t unDeviceIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_011)");
	return base->IsTrackedDeviceConnected(unDeviceIndex);
}
bool CVRSystem_011::GetBoolTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_011)");
	return base->GetBoolTrackedDeviceProperty(unDeviceIndex, prop, pError);
}
float CVRSystem_011::GetFloatTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_011)");
	return base->GetFloatTrackedDeviceProperty(unDeviceIndex, prop, pError);
}
int32_t CVRSystem_011::GetInt32TrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_011)");
	return base->GetInt32TrackedDeviceProperty(unDeviceIndex, prop, pError);
}
uint64_t CVRSystem_011::GetUint64TrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_011)");
	return base->GetUint64TrackedDeviceProperty(unDeviceIndex, prop, pError);
}
vr::HmdMatrix34_t CVRSystem_011::GetMatrix34TrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_011)");
	return base->GetMatrix34TrackedDeviceProperty(unDeviceIndex, prop, pError);
}
uint32_t CVRSystem_011::GetStringTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, char* pchValue, uint32_t unBufferSize, vr::ETrackedPropertyError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_011)");
	return base->GetStringTrackedDeviceProperty(unDeviceIndex, prop, pchValue, unBufferSize, pError);
}
const char* CVRSystem_011::GetPropErrorNameFromEnum(vr::ETrackedPropertyError error) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_011)");
	return base->GetPropErrorNameFromEnum(error);
}
bool CVRSystem_011::PollNextEvent(vr::VREvent_t* pEvent, uint32_t uncbVREvent) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_011)");
	return base->PollNextEvent(pEvent, uncbVREvent);
}
bool CVRSystem_011::PollNextEventWithPose(vr::ETrackingUniverseOrigin eOrigin, vr::VREvent_t* pEvent, uint32_t uncbVREvent, vr::TrackedDevicePose_t* pTrackedDevicePose) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_011)");
	return base->PollNextEventWithPose(eOrigin, pEvent, uncbVREvent, pTrackedDevicePose);
}
const char* CVRSystem_011::GetEventTypeNameFromEnum(vr::EVREventType eType) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_011)");
	return base->GetEventTypeNameFromEnum(eType);
}
vr::HiddenAreaMesh_t CVRSystem_011::GetHiddenAreaMesh(vr::EVREye eEye) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_011)");
	return base->GetHiddenAreaMesh(eEye);
}
void CVRSystem_011::TriggerHapticPulse(vr::TrackedDeviceIndex_t unControllerDeviceIndex, uint32_t unAxisId, unsigned short usDurationMicroSec) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_011)");
	return base->TriggerHapticPulse(unControllerDeviceIndex, unAxisId, usDurationMicroSec);
}
const char* CVRSystem_011::GetButtonIdNameFromEnum(vr::EVRButtonId eButtonId) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_011)");
	return base->GetButtonIdNameFromEnum(eButtonId);
}
const char* CVRSystem_011::GetControllerAxisTypeNameFromEnum(vr::EVRControllerAxisType eAxisType) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_011)");
	return base->GetControllerAxisTypeNameFromEnum(eAxisType);
}
bool CVRSystem_011::CaptureInputFocus() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_011)");
	return base->CaptureInputFocus();
}
void CVRSystem_011::ReleaseInputFocus() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_011)");
	return base->ReleaseInputFocus();
}
bool CVRSystem_011::IsInputFocusCapturedByAnotherProcess() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_011)");
	return base->IsInputFocusCapturedByAnotherProcess();
}
uint32_t CVRSystem_011::DriverDebugRequest(vr::TrackedDeviceIndex_t unDeviceIndex, const char* pchRequest, char* pchResponseBuffer, uint32_t unResponseBufferSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_011)");
	return base->DriverDebugRequest(unDeviceIndex, pchRequest, pchResponseBuffer, unResponseBufferSize);
}
vr::EVRFirmwareError CVRSystem_011::PerformFirmwareUpdate(vr::TrackedDeviceIndex_t unDeviceIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_011)");
	return base->PerformFirmwareUpdate(unDeviceIndex);
}
void CVRSystem_011::AcknowledgeQuit_Exiting() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_011)");
	return base->AcknowledgeQuit_Exiting();
}
void CVRSystem_011::AcknowledgeQuit_UserPrompt() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_011)");
	return base->AcknowledgeQuit_UserPrompt();
}
void CVRSystem_011::PerformanceTestEnableCapture(bool bEnable) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_011)");
	return base->PerformanceTestEnableCapture(bEnable);
}
void CVRSystem_011::PerformanceTestReportFidelityLevelChange(int nFidelityLevel) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_011)");
	return base->PerformanceTestReportFidelityLevelChange(nFidelityLevel);
}
// FnTable for CVRSystem_011:
static CVRSystem_011 *fntable_System_011_instance = NULL;
static void OPENVR_FNTABLE_CALLTYPE fntable_System_011_impl_GetRecommendedRenderTargetSize(uint32_t* pnWidth, uint32_t* pnHeight) { return fntable_System_011_instance->GetRecommendedRenderTargetSize(pnWidth, pnHeight); }
static vr::HmdMatrix44_t OPENVR_FNTABLE_CALLTYPE fntable_System_011_impl_GetProjectionMatrix(vr::EVREye eEye, float fNearZ, float fFarZ, EGraphicsAPIConvention eProjType) { return fntable_System_011_instance->GetProjectionMatrix(eEye, fNearZ, fFarZ, eProjType); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_011_impl_GetProjectionRaw(vr::EVREye eEye, float* pfLeft, float* pfRight, float* pfTop, float* pfBottom) { return fntable_System_011_instance->GetProjectionRaw(eEye, pfLeft, pfRight, pfTop, pfBottom); }
static vr::DistortionCoordinates_t OPENVR_FNTABLE_CALLTYPE fntable_System_011_impl_ComputeDistortion(vr::EVREye eEye, float fU, float fV) { return fntable_System_011_instance->ComputeDistortion(eEye, fU, fV); }
static vr::HmdMatrix34_t OPENVR_FNTABLE_CALLTYPE fntable_System_011_impl_GetEyeToHeadTransform(vr::EVREye eEye) { return fntable_System_011_instance->GetEyeToHeadTransform(eEye); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_011_impl_GetTimeSinceLastVsync(float* pfSecondsSinceLastVsync, uint64_t* pulFrameCounter) { return fntable_System_011_instance->GetTimeSinceLastVsync(pfSecondsSinceLastVsync, pulFrameCounter); }
static int32_t OPENVR_FNTABLE_CALLTYPE fntable_System_011_impl_GetD3D9AdapterIndex() { return fntable_System_011_instance->GetD3D9AdapterIndex(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_011_impl_GetDXGIOutputInfo(int32_t* pnAdapterIndex) { return fntable_System_011_instance->GetDXGIOutputInfo(pnAdapterIndex); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_011_impl_IsDisplayOnDesktop() { return fntable_System_011_instance->IsDisplayOnDesktop(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_011_impl_SetDisplayVisibility(bool bIsVisibleOnDesktop) { return fntable_System_011_instance->SetDisplayVisibility(bIsVisibleOnDesktop); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_011_impl_GetDeviceToAbsoluteTrackingPose(vr::ETrackingUniverseOrigin eOrigin, float fPredictedSecondsToPhotonsFromNow, vr::TrackedDevicePose_t* pTrackedDevicePoseArray, uint32_t unTrackedDevicePoseArrayCount) { return fntable_System_011_instance->GetDeviceToAbsoluteTrackingPose(eOrigin, fPredictedSecondsToPhotonsFromNow, pTrackedDevicePoseArray, unTrackedDevicePoseArrayCount); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_011_impl_ResetSeatedZeroPose() { return fntable_System_011_instance->ResetSeatedZeroPose(); }
static vr::HmdMatrix34_t OPENVR_FNTABLE_CALLTYPE fntable_System_011_impl_GetSeatedZeroPoseToStandingAbsoluteTrackingPose() { return fntable_System_011_instance->GetSeatedZeroPoseToStandingAbsoluteTrackingPose(); }
static vr::HmdMatrix34_t OPENVR_FNTABLE_CALLTYPE fntable_System_011_impl_GetRawZeroPoseToStandingAbsoluteTrackingPose() { return fntable_System_011_instance->GetRawZeroPoseToStandingAbsoluteTrackingPose(); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_System_011_impl_GetSortedTrackedDeviceIndicesOfClass(vr::ETrackedDeviceClass eTrackedDeviceClass, vr::TrackedDeviceIndex_t* punTrackedDeviceIndexArray, uint32_t unTrackedDeviceIndexArrayCount, vr::TrackedDeviceIndex_t unRelativeToTrackedDeviceIndex) { return fntable_System_011_instance->GetSortedTrackedDeviceIndicesOfClass(eTrackedDeviceClass, punTrackedDeviceIndexArray, unTrackedDeviceIndexArrayCount, unRelativeToTrackedDeviceIndex); }
static vr::EDeviceActivityLevel OPENVR_FNTABLE_CALLTYPE fntable_System_011_impl_GetTrackedDeviceActivityLevel(vr::TrackedDeviceIndex_t unDeviceId) { return fntable_System_011_instance->GetTrackedDeviceActivityLevel(unDeviceId); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_011_impl_ApplyTransform(vr::TrackedDevicePose_t* pOutputPose, const vr::TrackedDevicePose_t* pTrackedDevicePose, const vr::HmdMatrix34_t* pTransform) { return fntable_System_011_instance->ApplyTransform(pOutputPose, pTrackedDevicePose, pTransform); }
static vr::TrackedDeviceIndex_t OPENVR_FNTABLE_CALLTYPE fntable_System_011_impl_GetTrackedDeviceIndexForControllerRole(vr::ETrackedControllerRole unDeviceType) { return fntable_System_011_instance->GetTrackedDeviceIndexForControllerRole(unDeviceType); }
static vr::ETrackedControllerRole OPENVR_FNTABLE_CALLTYPE fntable_System_011_impl_GetControllerRoleForTrackedDeviceIndex(vr::TrackedDeviceIndex_t unDeviceIndex) { return fntable_System_011_instance->GetControllerRoleForTrackedDeviceIndex(unDeviceIndex); }
static vr::ETrackedDeviceClass OPENVR_FNTABLE_CALLTYPE fntable_System_011_impl_GetTrackedDeviceClass(vr::TrackedDeviceIndex_t unDeviceIndex) { return fntable_System_011_instance->GetTrackedDeviceClass(unDeviceIndex); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_011_impl_IsTrackedDeviceConnected(vr::TrackedDeviceIndex_t unDeviceIndex) { return fntable_System_011_instance->IsTrackedDeviceConnected(unDeviceIndex); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_011_impl_GetBoolTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) { return fntable_System_011_instance->GetBoolTrackedDeviceProperty(unDeviceIndex, prop, pError); }
static float OPENVR_FNTABLE_CALLTYPE fntable_System_011_impl_GetFloatTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) { return fntable_System_011_instance->GetFloatTrackedDeviceProperty(unDeviceIndex, prop, pError); }
static int32_t OPENVR_FNTABLE_CALLTYPE fntable_System_011_impl_GetInt32TrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) { return fntable_System_011_instance->GetInt32TrackedDeviceProperty(unDeviceIndex, prop, pError); }
static uint64_t OPENVR_FNTABLE_CALLTYPE fntable_System_011_impl_GetUint64TrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) { return fntable_System_011_instance->GetUint64TrackedDeviceProperty(unDeviceIndex, prop, pError); }
static vr::HmdMatrix34_t OPENVR_FNTABLE_CALLTYPE fntable_System_011_impl_GetMatrix34TrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) { return fntable_System_011_instance->GetMatrix34TrackedDeviceProperty(unDeviceIndex, prop, pError); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_System_011_impl_GetStringTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, char* pchValue, uint32_t unBufferSize, vr::ETrackedPropertyError* pError) { return fntable_System_011_instance->GetStringTrackedDeviceProperty(unDeviceIndex, prop, pchValue, unBufferSize, pError); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_System_011_impl_GetPropErrorNameFromEnum(vr::ETrackedPropertyError error) { return fntable_System_011_instance->GetPropErrorNameFromEnum(error); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_011_impl_PollNextEvent(vr::VREvent_t* pEvent, uint32_t uncbVREvent) { return fntable_System_011_instance->PollNextEvent(pEvent, uncbVREvent); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_011_impl_PollNextEventWithPose(vr::ETrackingUniverseOrigin eOrigin, vr::VREvent_t* pEvent, uint32_t uncbVREvent, vr::TrackedDevicePose_t* pTrackedDevicePose) { return fntable_System_011_instance->PollNextEventWithPose(eOrigin, pEvent, uncbVREvent, pTrackedDevicePose); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_System_011_impl_GetEventTypeNameFromEnum(vr::EVREventType eType) { return fntable_System_011_instance->GetEventTypeNameFromEnum(eType); }
static vr::HiddenAreaMesh_t OPENVR_FNTABLE_CALLTYPE fntable_System_011_impl_GetHiddenAreaMesh(vr::EVREye eEye) { return fntable_System_011_instance->GetHiddenAreaMesh(eEye); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_011_impl_GetControllerState(vr::TrackedDeviceIndex_t unControllerDeviceIndex, vr::VRControllerState_t* pControllerState) { return fntable_System_011_instance->GetControllerState(unControllerDeviceIndex, pControllerState); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_011_impl_GetControllerStateWithPose(vr::ETrackingUniverseOrigin eOrigin, vr::TrackedDeviceIndex_t unControllerDeviceIndex, vr::VRControllerState_t* pControllerState, vr::TrackedDevicePose_t* pTrackedDevicePose) { return fntable_System_011_instance->GetControllerStateWithPose(eOrigin, unControllerDeviceIndex, pControllerState, pTrackedDevicePose); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_011_impl_TriggerHapticPulse(vr::TrackedDeviceIndex_t unControllerDeviceIndex, uint32_t unAxisId, unsigned short usDurationMicroSec) { return fntable_System_011_instance->TriggerHapticPulse(unControllerDeviceIndex, unAxisId, usDurationMicroSec); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_System_011_impl_GetButtonIdNameFromEnum(vr::EVRButtonId eButtonId) { return fntable_System_011_instance->GetButtonIdNameFromEnum(eButtonId); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_System_011_impl_GetControllerAxisTypeNameFromEnum(vr::EVRControllerAxisType eAxisType) { return fntable_System_011_instance->GetControllerAxisTypeNameFromEnum(eAxisType); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_011_impl_CaptureInputFocus() { return fntable_System_011_instance->CaptureInputFocus(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_011_impl_ReleaseInputFocus() { return fntable_System_011_instance->ReleaseInputFocus(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_011_impl_IsInputFocusCapturedByAnotherProcess() { return fntable_System_011_instance->IsInputFocusCapturedByAnotherProcess(); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_System_011_impl_DriverDebugRequest(vr::TrackedDeviceIndex_t unDeviceIndex, const char* pchRequest, char* pchResponseBuffer, uint32_t unResponseBufferSize) { return fntable_System_011_instance->DriverDebugRequest(unDeviceIndex, pchRequest, pchResponseBuffer, unResponseBufferSize); }
static vr::EVRFirmwareError OPENVR_FNTABLE_CALLTYPE fntable_System_011_impl_PerformFirmwareUpdate(vr::TrackedDeviceIndex_t unDeviceIndex) { return fntable_System_011_instance->PerformFirmwareUpdate(unDeviceIndex); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_011_impl_AcknowledgeQuit_Exiting() { return fntable_System_011_instance->AcknowledgeQuit_Exiting(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_011_impl_AcknowledgeQuit_UserPrompt() { return fntable_System_011_instance->AcknowledgeQuit_UserPrompt(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_011_impl_PerformanceTestEnableCapture(bool bEnable) { return fntable_System_011_instance->PerformanceTestEnableCapture(bEnable); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_011_impl_PerformanceTestReportFidelityLevelChange(int nFidelityLevel) { return fntable_System_011_instance->PerformanceTestReportFidelityLevelChange(nFidelityLevel); }
static void *fntable_System_011_funcs[] = {
	(void*) fntable_System_011_impl_GetRecommendedRenderTargetSize,
	(void*) fntable_System_011_impl_GetProjectionMatrix,
	(void*) fntable_System_011_impl_GetProjectionRaw,
	(void*) fntable_System_011_impl_ComputeDistortion,
	(void*) fntable_System_011_impl_GetEyeToHeadTransform,
	(void*) fntable_System_011_impl_GetTimeSinceLastVsync,
	(void*) fntable_System_011_impl_GetD3D9AdapterIndex,
	(void*) fntable_System_011_impl_GetDXGIOutputInfo,
	(void*) fntable_System_011_impl_IsDisplayOnDesktop,
	(void*) fntable_System_011_impl_SetDisplayVisibility,
	(void*) fntable_System_011_impl_GetDeviceToAbsoluteTrackingPose,
	(void*) fntable_System_011_impl_ResetSeatedZeroPose,
	(void*) fntable_System_011_impl_GetSeatedZeroPoseToStandingAbsoluteTrackingPose,
	(void*) fntable_System_011_impl_GetRawZeroPoseToStandingAbsoluteTrackingPose,
	(void*) fntable_System_011_impl_GetSortedTrackedDeviceIndicesOfClass,
	(void*) fntable_System_011_impl_GetTrackedDeviceActivityLevel,
	(void*) fntable_System_011_impl_ApplyTransform,
	(void*) fntable_System_011_impl_GetTrackedDeviceIndexForControllerRole,
	(void*) fntable_System_011_impl_GetControllerRoleForTrackedDeviceIndex,
	(void*) fntable_System_011_impl_GetTrackedDeviceClass,
	(void*) fntable_System_011_impl_IsTrackedDeviceConnected,
	(void*) fntable_System_011_impl_GetBoolTrackedDeviceProperty,
	(void*) fntable_System_011_impl_GetFloatTrackedDeviceProperty,
	(void*) fntable_System_011_impl_GetInt32TrackedDeviceProperty,
	(void*) fntable_System_011_impl_GetUint64TrackedDeviceProperty,
	(void*) fntable_System_011_impl_GetMatrix34TrackedDeviceProperty,
	(void*) fntable_System_011_impl_GetStringTrackedDeviceProperty,
	(void*) fntable_System_011_impl_GetPropErrorNameFromEnum,
	(void*) fntable_System_011_impl_PollNextEvent,
	(void*) fntable_System_011_impl_PollNextEventWithPose,
	(void*) fntable_System_011_impl_GetEventTypeNameFromEnum,
	(void*) fntable_System_011_impl_GetHiddenAreaMesh,
	(void*) fntable_System_011_impl_GetControllerState,
	(void*) fntable_System_011_impl_GetControllerStateWithPose,
	(void*) fntable_System_011_impl_TriggerHapticPulse,
	(void*) fntable_System_011_impl_GetButtonIdNameFromEnum,
	(void*) fntable_System_011_impl_GetControllerAxisTypeNameFromEnum,
	(void*) fntable_System_011_impl_CaptureInputFocus,
	(void*) fntable_System_011_impl_ReleaseInputFocus,
	(void*) fntable_System_011_impl_IsInputFocusCapturedByAnotherProcess,
	(void*) fntable_System_011_impl_DriverDebugRequest,
	(void*) fntable_System_011_impl_PerformFirmwareUpdate,
	(void*) fntable_System_011_impl_AcknowledgeQuit_Exiting,
	(void*) fntable_System_011_impl_AcknowledgeQuit_UserPrompt,
	(void*) fntable_System_011_impl_PerformanceTestEnableCapture,
	(void*) fntable_System_011_impl_PerformanceTestReportFidelityLevelChange,
};
void** CVRSystem_011::_GetStatFuncList() { fntable_System_011_instance = this; return fntable_System_011_funcs; }
void CVRSystem_011::Delete() { delete this; }
// Misc for CVRSystem_012:
CVRSystem_012::CVRSystem_012() : base(GetCreateBaseSystem()) {}
// Interface methods for CVRSystem_012:
void CVRSystem_012::GetRecommendedRenderTargetSize(uint32_t* pnWidth, uint32_t* pnHeight) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_012)");
	return base->GetRecommendedRenderTargetSize(pnWidth, pnHeight);
}
vr::HmdMatrix44_t CVRSystem_012::GetProjectionMatrix(vr::EVREye eEye, float fNearZ, float fFarZ, EGraphicsAPIConvention eProjType) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_012)");
	return base->GetProjectionMatrix(eEye, fNearZ, fFarZ, eProjType);
}
void CVRSystem_012::GetProjectionRaw(vr::EVREye eEye, float* pfLeft, float* pfRight, float* pfTop, float* pfBottom) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_012)");
	return base->GetProjectionRaw(eEye, pfLeft, pfRight, pfTop, pfBottom);
}
vr::DistortionCoordinates_t CVRSystem_012::ComputeDistortion(vr::EVREye eEye, float fU, float fV) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_012)");
	return base->ComputeDistortion(eEye, fU, fV);
}
vr::HmdMatrix34_t CVRSystem_012::GetEyeToHeadTransform(vr::EVREye eEye) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_012)");
	return base->GetEyeToHeadTransform(eEye);
}
bool CVRSystem_012::GetTimeSinceLastVsync(float* pfSecondsSinceLastVsync, uint64_t* pulFrameCounter) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_012)");
	return base->GetTimeSinceLastVsync(pfSecondsSinceLastVsync, pulFrameCounter);
}
int32_t CVRSystem_012::GetD3D9AdapterIndex() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_012)");
	return base->GetD3D9AdapterIndex();
}
void CVRSystem_012::GetDXGIOutputInfo(int32_t* pnAdapterIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_012)");
	return base->GetDXGIOutputInfo(pnAdapterIndex);
}
bool CVRSystem_012::IsDisplayOnDesktop() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_012)");
	return base->IsDisplayOnDesktop();
}
bool CVRSystem_012::SetDisplayVisibility(bool bIsVisibleOnDesktop) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_012)");
	return base->SetDisplayVisibility(bIsVisibleOnDesktop);
}
void CVRSystem_012::GetDeviceToAbsoluteTrackingPose(vr::ETrackingUniverseOrigin eOrigin, float fPredictedSecondsToPhotonsFromNow, vr::TrackedDevicePose_t* pTrackedDevicePoseArray, uint32_t unTrackedDevicePoseArrayCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_012)");
	return base->GetDeviceToAbsoluteTrackingPose(eOrigin, fPredictedSecondsToPhotonsFromNow, pTrackedDevicePoseArray, unTrackedDevicePoseArrayCount);
}
void CVRSystem_012::ResetSeatedZeroPose() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_012)");
	return base->ResetSeatedZeroPose();
}
vr::HmdMatrix34_t CVRSystem_012::GetSeatedZeroPoseToStandingAbsoluteTrackingPose() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_012)");
	return base->GetSeatedZeroPoseToStandingAbsoluteTrackingPose();
}
vr::HmdMatrix34_t CVRSystem_012::GetRawZeroPoseToStandingAbsoluteTrackingPose() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_012)");
	return base->GetRawZeroPoseToStandingAbsoluteTrackingPose();
}
uint32_t CVRSystem_012::GetSortedTrackedDeviceIndicesOfClass(vr::ETrackedDeviceClass eTrackedDeviceClass, vr::TrackedDeviceIndex_t* punTrackedDeviceIndexArray, uint32_t unTrackedDeviceIndexArrayCount, vr::TrackedDeviceIndex_t unRelativeToTrackedDeviceIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_012)");
	return base->GetSortedTrackedDeviceIndicesOfClass(eTrackedDeviceClass, punTrackedDeviceIndexArray, unTrackedDeviceIndexArrayCount, unRelativeToTrackedDeviceIndex);
}
vr::EDeviceActivityLevel CVRSystem_012::GetTrackedDeviceActivityLevel(vr::TrackedDeviceIndex_t unDeviceId) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_012)");
	return base->GetTrackedDeviceActivityLevel(unDeviceId);
}
void CVRSystem_012::ApplyTransform(vr::TrackedDevicePose_t* pOutputPose, const vr::TrackedDevicePose_t* pTrackedDevicePose, const vr::HmdMatrix34_t* pTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_012)");
	return base->ApplyTransform(pOutputPose, pTrackedDevicePose, pTransform);
}
vr::TrackedDeviceIndex_t CVRSystem_012::GetTrackedDeviceIndexForControllerRole(vr::ETrackedControllerRole unDeviceType) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_012)");
	return base->GetTrackedDeviceIndexForControllerRole(unDeviceType);
}
vr::ETrackedControllerRole CVRSystem_012::GetControllerRoleForTrackedDeviceIndex(vr::TrackedDeviceIndex_t unDeviceIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_012)");
	return base->GetControllerRoleForTrackedDeviceIndex(unDeviceIndex);
}
vr::ETrackedDeviceClass CVRSystem_012::GetTrackedDeviceClass(vr::TrackedDeviceIndex_t unDeviceIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_012)");
	return base->GetTrackedDeviceClass(unDeviceIndex);
}
bool CVRSystem_012::IsTrackedDeviceConnected(vr::TrackedDeviceIndex_t unDeviceIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_012)");
	return base->IsTrackedDeviceConnected(unDeviceIndex);
}
bool CVRSystem_012::GetBoolTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_012)");
	return base->GetBoolTrackedDeviceProperty(unDeviceIndex, prop, pError);
}
float CVRSystem_012::GetFloatTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_012)");
	return base->GetFloatTrackedDeviceProperty(unDeviceIndex, prop, pError);
}
int32_t CVRSystem_012::GetInt32TrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_012)");
	return base->GetInt32TrackedDeviceProperty(unDeviceIndex, prop, pError);
}
uint64_t CVRSystem_012::GetUint64TrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_012)");
	return base->GetUint64TrackedDeviceProperty(unDeviceIndex, prop, pError);
}
vr::HmdMatrix34_t CVRSystem_012::GetMatrix34TrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_012)");
	return base->GetMatrix34TrackedDeviceProperty(unDeviceIndex, prop, pError);
}
uint32_t CVRSystem_012::GetStringTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, char* pchValue, uint32_t unBufferSize, vr::ETrackedPropertyError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_012)");
	return base->GetStringTrackedDeviceProperty(unDeviceIndex, prop, pchValue, unBufferSize, pError);
}
const char* CVRSystem_012::GetPropErrorNameFromEnum(vr::ETrackedPropertyError error) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_012)");
	return base->GetPropErrorNameFromEnum(error);
}
bool CVRSystem_012::PollNextEvent(vr::VREvent_t* pEvent, uint32_t uncbVREvent) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_012)");
	return base->PollNextEvent(pEvent, uncbVREvent);
}
bool CVRSystem_012::PollNextEventWithPose(vr::ETrackingUniverseOrigin eOrigin, vr::VREvent_t* pEvent, uint32_t uncbVREvent, vr::TrackedDevicePose_t* pTrackedDevicePose) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_012)");
	return base->PollNextEventWithPose(eOrigin, pEvent, uncbVREvent, pTrackedDevicePose);
}
const char* CVRSystem_012::GetEventTypeNameFromEnum(vr::EVREventType eType) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_012)");
	return base->GetEventTypeNameFromEnum(eType);
}
vr::HiddenAreaMesh_t CVRSystem_012::GetHiddenAreaMesh(vr::EVREye eEye) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_012)");
	return base->GetHiddenAreaMesh(eEye);
}
void CVRSystem_012::TriggerHapticPulse(vr::TrackedDeviceIndex_t unControllerDeviceIndex, uint32_t unAxisId, unsigned short usDurationMicroSec) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_012)");
	return base->TriggerHapticPulse(unControllerDeviceIndex, unAxisId, usDurationMicroSec);
}
const char* CVRSystem_012::GetButtonIdNameFromEnum(vr::EVRButtonId eButtonId) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_012)");
	return base->GetButtonIdNameFromEnum(eButtonId);
}
const char* CVRSystem_012::GetControllerAxisTypeNameFromEnum(vr::EVRControllerAxisType eAxisType) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_012)");
	return base->GetControllerAxisTypeNameFromEnum(eAxisType);
}
bool CVRSystem_012::CaptureInputFocus() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_012)");
	return base->CaptureInputFocus();
}
void CVRSystem_012::ReleaseInputFocus() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_012)");
	return base->ReleaseInputFocus();
}
bool CVRSystem_012::IsInputFocusCapturedByAnotherProcess() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_012)");
	return base->IsInputFocusCapturedByAnotherProcess();
}
uint32_t CVRSystem_012::DriverDebugRequest(vr::TrackedDeviceIndex_t unDeviceIndex, const char* pchRequest, char* pchResponseBuffer, uint32_t unResponseBufferSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_012)");
	return base->DriverDebugRequest(unDeviceIndex, pchRequest, pchResponseBuffer, unResponseBufferSize);
}
vr::EVRFirmwareError CVRSystem_012::PerformFirmwareUpdate(vr::TrackedDeviceIndex_t unDeviceIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_012)");
	return base->PerformFirmwareUpdate(unDeviceIndex);
}
void CVRSystem_012::AcknowledgeQuit_Exiting() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_012)");
	return base->AcknowledgeQuit_Exiting();
}
void CVRSystem_012::AcknowledgeQuit_UserPrompt() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_012)");
	return base->AcknowledgeQuit_UserPrompt();
}
// FnTable for CVRSystem_012:
static CVRSystem_012 *fntable_System_012_instance = NULL;
static void OPENVR_FNTABLE_CALLTYPE fntable_System_012_impl_GetRecommendedRenderTargetSize(uint32_t* pnWidth, uint32_t* pnHeight) { return fntable_System_012_instance->GetRecommendedRenderTargetSize(pnWidth, pnHeight); }
static vr::HmdMatrix44_t OPENVR_FNTABLE_CALLTYPE fntable_System_012_impl_GetProjectionMatrix(vr::EVREye eEye, float fNearZ, float fFarZ, EGraphicsAPIConvention eProjType) { return fntable_System_012_instance->GetProjectionMatrix(eEye, fNearZ, fFarZ, eProjType); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_012_impl_GetProjectionRaw(vr::EVREye eEye, float* pfLeft, float* pfRight, float* pfTop, float* pfBottom) { return fntable_System_012_instance->GetProjectionRaw(eEye, pfLeft, pfRight, pfTop, pfBottom); }
static vr::DistortionCoordinates_t OPENVR_FNTABLE_CALLTYPE fntable_System_012_impl_ComputeDistortion(vr::EVREye eEye, float fU, float fV) { return fntable_System_012_instance->ComputeDistortion(eEye, fU, fV); }
static vr::HmdMatrix34_t OPENVR_FNTABLE_CALLTYPE fntable_System_012_impl_GetEyeToHeadTransform(vr::EVREye eEye) { return fntable_System_012_instance->GetEyeToHeadTransform(eEye); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_012_impl_GetTimeSinceLastVsync(float* pfSecondsSinceLastVsync, uint64_t* pulFrameCounter) { return fntable_System_012_instance->GetTimeSinceLastVsync(pfSecondsSinceLastVsync, pulFrameCounter); }
static int32_t OPENVR_FNTABLE_CALLTYPE fntable_System_012_impl_GetD3D9AdapterIndex() { return fntable_System_012_instance->GetD3D9AdapterIndex(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_012_impl_GetDXGIOutputInfo(int32_t* pnAdapterIndex) { return fntable_System_012_instance->GetDXGIOutputInfo(pnAdapterIndex); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_012_impl_IsDisplayOnDesktop() { return fntable_System_012_instance->IsDisplayOnDesktop(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_012_impl_SetDisplayVisibility(bool bIsVisibleOnDesktop) { return fntable_System_012_instance->SetDisplayVisibility(bIsVisibleOnDesktop); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_012_impl_GetDeviceToAbsoluteTrackingPose(vr::ETrackingUniverseOrigin eOrigin, float fPredictedSecondsToPhotonsFromNow, vr::TrackedDevicePose_t* pTrackedDevicePoseArray, uint32_t unTrackedDevicePoseArrayCount) { return fntable_System_012_instance->GetDeviceToAbsoluteTrackingPose(eOrigin, fPredictedSecondsToPhotonsFromNow, pTrackedDevicePoseArray, unTrackedDevicePoseArrayCount); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_012_impl_ResetSeatedZeroPose() { return fntable_System_012_instance->ResetSeatedZeroPose(); }
static vr::HmdMatrix34_t OPENVR_FNTABLE_CALLTYPE fntable_System_012_impl_GetSeatedZeroPoseToStandingAbsoluteTrackingPose() { return fntable_System_012_instance->GetSeatedZeroPoseToStandingAbsoluteTrackingPose(); }
static vr::HmdMatrix34_t OPENVR_FNTABLE_CALLTYPE fntable_System_012_impl_GetRawZeroPoseToStandingAbsoluteTrackingPose() { return fntable_System_012_instance->GetRawZeroPoseToStandingAbsoluteTrackingPose(); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_System_012_impl_GetSortedTrackedDeviceIndicesOfClass(vr::ETrackedDeviceClass eTrackedDeviceClass, vr::TrackedDeviceIndex_t* punTrackedDeviceIndexArray, uint32_t unTrackedDeviceIndexArrayCount, vr::TrackedDeviceIndex_t unRelativeToTrackedDeviceIndex) { return fntable_System_012_instance->GetSortedTrackedDeviceIndicesOfClass(eTrackedDeviceClass, punTrackedDeviceIndexArray, unTrackedDeviceIndexArrayCount, unRelativeToTrackedDeviceIndex); }
static vr::EDeviceActivityLevel OPENVR_FNTABLE_CALLTYPE fntable_System_012_impl_GetTrackedDeviceActivityLevel(vr::TrackedDeviceIndex_t unDeviceId) { return fntable_System_012_instance->GetTrackedDeviceActivityLevel(unDeviceId); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_012_impl_ApplyTransform(vr::TrackedDevicePose_t* pOutputPose, const vr::TrackedDevicePose_t* pTrackedDevicePose, const vr::HmdMatrix34_t* pTransform) { return fntable_System_012_instance->ApplyTransform(pOutputPose, pTrackedDevicePose, pTransform); }
static vr::TrackedDeviceIndex_t OPENVR_FNTABLE_CALLTYPE fntable_System_012_impl_GetTrackedDeviceIndexForControllerRole(vr::ETrackedControllerRole unDeviceType) { return fntable_System_012_instance->GetTrackedDeviceIndexForControllerRole(unDeviceType); }
static vr::ETrackedControllerRole OPENVR_FNTABLE_CALLTYPE fntable_System_012_impl_GetControllerRoleForTrackedDeviceIndex(vr::TrackedDeviceIndex_t unDeviceIndex) { return fntable_System_012_instance->GetControllerRoleForTrackedDeviceIndex(unDeviceIndex); }
static vr::ETrackedDeviceClass OPENVR_FNTABLE_CALLTYPE fntable_System_012_impl_GetTrackedDeviceClass(vr::TrackedDeviceIndex_t unDeviceIndex) { return fntable_System_012_instance->GetTrackedDeviceClass(unDeviceIndex); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_012_impl_IsTrackedDeviceConnected(vr::TrackedDeviceIndex_t unDeviceIndex) { return fntable_System_012_instance->IsTrackedDeviceConnected(unDeviceIndex); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_012_impl_GetBoolTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) { return fntable_System_012_instance->GetBoolTrackedDeviceProperty(unDeviceIndex, prop, pError); }
static float OPENVR_FNTABLE_CALLTYPE fntable_System_012_impl_GetFloatTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) { return fntable_System_012_instance->GetFloatTrackedDeviceProperty(unDeviceIndex, prop, pError); }
static int32_t OPENVR_FNTABLE_CALLTYPE fntable_System_012_impl_GetInt32TrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) { return fntable_System_012_instance->GetInt32TrackedDeviceProperty(unDeviceIndex, prop, pError); }
static uint64_t OPENVR_FNTABLE_CALLTYPE fntable_System_012_impl_GetUint64TrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) { return fntable_System_012_instance->GetUint64TrackedDeviceProperty(unDeviceIndex, prop, pError); }
static vr::HmdMatrix34_t OPENVR_FNTABLE_CALLTYPE fntable_System_012_impl_GetMatrix34TrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) { return fntable_System_012_instance->GetMatrix34TrackedDeviceProperty(unDeviceIndex, prop, pError); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_System_012_impl_GetStringTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, char* pchValue, uint32_t unBufferSize, vr::ETrackedPropertyError* pError) { return fntable_System_012_instance->GetStringTrackedDeviceProperty(unDeviceIndex, prop, pchValue, unBufferSize, pError); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_System_012_impl_GetPropErrorNameFromEnum(vr::ETrackedPropertyError error) { return fntable_System_012_instance->GetPropErrorNameFromEnum(error); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_012_impl_PollNextEvent(vr::VREvent_t* pEvent, uint32_t uncbVREvent) { return fntable_System_012_instance->PollNextEvent(pEvent, uncbVREvent); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_012_impl_PollNextEventWithPose(vr::ETrackingUniverseOrigin eOrigin, vr::VREvent_t* pEvent, uint32_t uncbVREvent, vr::TrackedDevicePose_t* pTrackedDevicePose) { return fntable_System_012_instance->PollNextEventWithPose(eOrigin, pEvent, uncbVREvent, pTrackedDevicePose); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_System_012_impl_GetEventTypeNameFromEnum(vr::EVREventType eType) { return fntable_System_012_instance->GetEventTypeNameFromEnum(eType); }
static vr::HiddenAreaMesh_t OPENVR_FNTABLE_CALLTYPE fntable_System_012_impl_GetHiddenAreaMesh(vr::EVREye eEye) { return fntable_System_012_instance->GetHiddenAreaMesh(eEye); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_012_impl_GetControllerState(vr::TrackedDeviceIndex_t unControllerDeviceIndex, vr::VRControllerState_t* pControllerState) { return fntable_System_012_instance->GetControllerState(unControllerDeviceIndex, pControllerState); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_012_impl_GetControllerStateWithPose(vr::ETrackingUniverseOrigin eOrigin, vr::TrackedDeviceIndex_t unControllerDeviceIndex, vr::VRControllerState_t* pControllerState, vr::TrackedDevicePose_t* pTrackedDevicePose) { return fntable_System_012_instance->GetControllerStateWithPose(eOrigin, unControllerDeviceIndex, pControllerState, pTrackedDevicePose); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_012_impl_TriggerHapticPulse(vr::TrackedDeviceIndex_t unControllerDeviceIndex, uint32_t unAxisId, unsigned short usDurationMicroSec) { return fntable_System_012_instance->TriggerHapticPulse(unControllerDeviceIndex, unAxisId, usDurationMicroSec); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_System_012_impl_GetButtonIdNameFromEnum(vr::EVRButtonId eButtonId) { return fntable_System_012_instance->GetButtonIdNameFromEnum(eButtonId); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_System_012_impl_GetControllerAxisTypeNameFromEnum(vr::EVRControllerAxisType eAxisType) { return fntable_System_012_instance->GetControllerAxisTypeNameFromEnum(eAxisType); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_012_impl_CaptureInputFocus() { return fntable_System_012_instance->CaptureInputFocus(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_012_impl_ReleaseInputFocus() { return fntable_System_012_instance->ReleaseInputFocus(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_012_impl_IsInputFocusCapturedByAnotherProcess() { return fntable_System_012_instance->IsInputFocusCapturedByAnotherProcess(); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_System_012_impl_DriverDebugRequest(vr::TrackedDeviceIndex_t unDeviceIndex, const char* pchRequest, char* pchResponseBuffer, uint32_t unResponseBufferSize) { return fntable_System_012_instance->DriverDebugRequest(unDeviceIndex, pchRequest, pchResponseBuffer, unResponseBufferSize); }
static vr::EVRFirmwareError OPENVR_FNTABLE_CALLTYPE fntable_System_012_impl_PerformFirmwareUpdate(vr::TrackedDeviceIndex_t unDeviceIndex) { return fntable_System_012_instance->PerformFirmwareUpdate(unDeviceIndex); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_012_impl_AcknowledgeQuit_Exiting() { return fntable_System_012_instance->AcknowledgeQuit_Exiting(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_012_impl_AcknowledgeQuit_UserPrompt() { return fntable_System_012_instance->AcknowledgeQuit_UserPrompt(); }
static void *fntable_System_012_funcs[] = {
	(void*) fntable_System_012_impl_GetRecommendedRenderTargetSize,
	(void*) fntable_System_012_impl_GetProjectionMatrix,
	(void*) fntable_System_012_impl_GetProjectionRaw,
	(void*) fntable_System_012_impl_ComputeDistortion,
	(void*) fntable_System_012_impl_GetEyeToHeadTransform,
	(void*) fntable_System_012_impl_GetTimeSinceLastVsync,
	(void*) fntable_System_012_impl_GetD3D9AdapterIndex,
	(void*) fntable_System_012_impl_GetDXGIOutputInfo,
	(void*) fntable_System_012_impl_IsDisplayOnDesktop,
	(void*) fntable_System_012_impl_SetDisplayVisibility,
	(void*) fntable_System_012_impl_GetDeviceToAbsoluteTrackingPose,
	(void*) fntable_System_012_impl_ResetSeatedZeroPose,
	(void*) fntable_System_012_impl_GetSeatedZeroPoseToStandingAbsoluteTrackingPose,
	(void*) fntable_System_012_impl_GetRawZeroPoseToStandingAbsoluteTrackingPose,
	(void*) fntable_System_012_impl_GetSortedTrackedDeviceIndicesOfClass,
	(void*) fntable_System_012_impl_GetTrackedDeviceActivityLevel,
	(void*) fntable_System_012_impl_ApplyTransform,
	(void*) fntable_System_012_impl_GetTrackedDeviceIndexForControllerRole,
	(void*) fntable_System_012_impl_GetControllerRoleForTrackedDeviceIndex,
	(void*) fntable_System_012_impl_GetTrackedDeviceClass,
	(void*) fntable_System_012_impl_IsTrackedDeviceConnected,
	(void*) fntable_System_012_impl_GetBoolTrackedDeviceProperty,
	(void*) fntable_System_012_impl_GetFloatTrackedDeviceProperty,
	(void*) fntable_System_012_impl_GetInt32TrackedDeviceProperty,
	(void*) fntable_System_012_impl_GetUint64TrackedDeviceProperty,
	(void*) fntable_System_012_impl_GetMatrix34TrackedDeviceProperty,
	(void*) fntable_System_012_impl_GetStringTrackedDeviceProperty,
	(void*) fntable_System_012_impl_GetPropErrorNameFromEnum,
	(void*) fntable_System_012_impl_PollNextEvent,
	(void*) fntable_System_012_impl_PollNextEventWithPose,
	(void*) fntable_System_012_impl_GetEventTypeNameFromEnum,
	(void*) fntable_System_012_impl_GetHiddenAreaMesh,
	(void*) fntable_System_012_impl_GetControllerState,
	(void*) fntable_System_012_impl_GetControllerStateWithPose,
	(void*) fntable_System_012_impl_TriggerHapticPulse,
	(void*) fntable_System_012_impl_GetButtonIdNameFromEnum,
	(void*) fntable_System_012_impl_GetControllerAxisTypeNameFromEnum,
	(void*) fntable_System_012_impl_CaptureInputFocus,
	(void*) fntable_System_012_impl_ReleaseInputFocus,
	(void*) fntable_System_012_impl_IsInputFocusCapturedByAnotherProcess,
	(void*) fntable_System_012_impl_DriverDebugRequest,
	(void*) fntable_System_012_impl_PerformFirmwareUpdate,
	(void*) fntable_System_012_impl_AcknowledgeQuit_Exiting,
	(void*) fntable_System_012_impl_AcknowledgeQuit_UserPrompt,
};
void** CVRSystem_012::_GetStatFuncList() { fntable_System_012_instance = this; return fntable_System_012_funcs; }
void CVRSystem_012::Delete() { delete this; }
// Misc for CVRSystem_014:
CVRSystem_014::CVRSystem_014() : base(GetCreateBaseSystem()) {}
// Interface methods for CVRSystem_014:
void CVRSystem_014::GetRecommendedRenderTargetSize(uint32_t* pnWidth, uint32_t* pnHeight) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_014)");
	return base->GetRecommendedRenderTargetSize(pnWidth, pnHeight);
}
vr::HmdMatrix44_t CVRSystem_014::GetProjectionMatrix(vr::EVREye eEye, float fNearZ, float fFarZ, EGraphicsAPIConvention eProjType) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_014)");
	return base->GetProjectionMatrix(eEye, fNearZ, fFarZ, eProjType);
}
void CVRSystem_014::GetProjectionRaw(vr::EVREye eEye, float* pfLeft, float* pfRight, float* pfTop, float* pfBottom) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_014)");
	return base->GetProjectionRaw(eEye, pfLeft, pfRight, pfTop, pfBottom);
}
bool CVRSystem_014::ComputeDistortion(vr::EVREye eEye, float fU, float fV, vr::DistortionCoordinates_t* pDistortionCoordinates) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_014)");
	return base->ComputeDistortion(eEye, fU, fV, pDistortionCoordinates);
}
vr::HmdMatrix34_t CVRSystem_014::GetEyeToHeadTransform(vr::EVREye eEye) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_014)");
	return base->GetEyeToHeadTransform(eEye);
}
bool CVRSystem_014::GetTimeSinceLastVsync(float* pfSecondsSinceLastVsync, uint64_t* pulFrameCounter) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_014)");
	return base->GetTimeSinceLastVsync(pfSecondsSinceLastVsync, pulFrameCounter);
}
int32_t CVRSystem_014::GetD3D9AdapterIndex() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_014)");
	return base->GetD3D9AdapterIndex();
}
void CVRSystem_014::GetDXGIOutputInfo(int32_t* pnAdapterIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_014)");
	return base->GetDXGIOutputInfo(pnAdapterIndex);
}
bool CVRSystem_014::IsDisplayOnDesktop() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_014)");
	return base->IsDisplayOnDesktop();
}
bool CVRSystem_014::SetDisplayVisibility(bool bIsVisibleOnDesktop) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_014)");
	return base->SetDisplayVisibility(bIsVisibleOnDesktop);
}
void CVRSystem_014::GetDeviceToAbsoluteTrackingPose(vr::ETrackingUniverseOrigin eOrigin, float fPredictedSecondsToPhotonsFromNow, vr::TrackedDevicePose_t* pTrackedDevicePoseArray, uint32_t unTrackedDevicePoseArrayCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_014)");
	return base->GetDeviceToAbsoluteTrackingPose(eOrigin, fPredictedSecondsToPhotonsFromNow, pTrackedDevicePoseArray, unTrackedDevicePoseArrayCount);
}
void CVRSystem_014::ResetSeatedZeroPose() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_014)");
	return base->ResetSeatedZeroPose();
}
vr::HmdMatrix34_t CVRSystem_014::GetSeatedZeroPoseToStandingAbsoluteTrackingPose() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_014)");
	return base->GetSeatedZeroPoseToStandingAbsoluteTrackingPose();
}
vr::HmdMatrix34_t CVRSystem_014::GetRawZeroPoseToStandingAbsoluteTrackingPose() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_014)");
	return base->GetRawZeroPoseToStandingAbsoluteTrackingPose();
}
uint32_t CVRSystem_014::GetSortedTrackedDeviceIndicesOfClass(vr::ETrackedDeviceClass eTrackedDeviceClass, vr::TrackedDeviceIndex_t* punTrackedDeviceIndexArray, uint32_t unTrackedDeviceIndexArrayCount, vr::TrackedDeviceIndex_t unRelativeToTrackedDeviceIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_014)");
	return base->GetSortedTrackedDeviceIndicesOfClass(eTrackedDeviceClass, punTrackedDeviceIndexArray, unTrackedDeviceIndexArrayCount, unRelativeToTrackedDeviceIndex);
}
vr::EDeviceActivityLevel CVRSystem_014::GetTrackedDeviceActivityLevel(vr::TrackedDeviceIndex_t unDeviceId) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_014)");
	return base->GetTrackedDeviceActivityLevel(unDeviceId);
}
void CVRSystem_014::ApplyTransform(vr::TrackedDevicePose_t* pOutputPose, const vr::TrackedDevicePose_t* pTrackedDevicePose, const vr::HmdMatrix34_t* pTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_014)");
	return base->ApplyTransform(pOutputPose, pTrackedDevicePose, pTransform);
}
vr::TrackedDeviceIndex_t CVRSystem_014::GetTrackedDeviceIndexForControllerRole(vr::ETrackedControllerRole unDeviceType) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_014)");
	return base->GetTrackedDeviceIndexForControllerRole(unDeviceType);
}
vr::ETrackedControllerRole CVRSystem_014::GetControllerRoleForTrackedDeviceIndex(vr::TrackedDeviceIndex_t unDeviceIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_014)");
	return base->GetControllerRoleForTrackedDeviceIndex(unDeviceIndex);
}
vr::ETrackedDeviceClass CVRSystem_014::GetTrackedDeviceClass(vr::TrackedDeviceIndex_t unDeviceIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_014)");
	return base->GetTrackedDeviceClass(unDeviceIndex);
}
bool CVRSystem_014::IsTrackedDeviceConnected(vr::TrackedDeviceIndex_t unDeviceIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_014)");
	return base->IsTrackedDeviceConnected(unDeviceIndex);
}
bool CVRSystem_014::GetBoolTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_014)");
	return base->GetBoolTrackedDeviceProperty(unDeviceIndex, prop, pError);
}
float CVRSystem_014::GetFloatTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_014)");
	return base->GetFloatTrackedDeviceProperty(unDeviceIndex, prop, pError);
}
int32_t CVRSystem_014::GetInt32TrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_014)");
	return base->GetInt32TrackedDeviceProperty(unDeviceIndex, prop, pError);
}
uint64_t CVRSystem_014::GetUint64TrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_014)");
	return base->GetUint64TrackedDeviceProperty(unDeviceIndex, prop, pError);
}
vr::HmdMatrix34_t CVRSystem_014::GetMatrix34TrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_014)");
	return base->GetMatrix34TrackedDeviceProperty(unDeviceIndex, prop, pError);
}
uint32_t CVRSystem_014::GetStringTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, char* pchValue, uint32_t unBufferSize, vr::ETrackedPropertyError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_014)");
	return base->GetStringTrackedDeviceProperty(unDeviceIndex, prop, pchValue, unBufferSize, pError);
}
const char* CVRSystem_014::GetPropErrorNameFromEnum(vr::ETrackedPropertyError error) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_014)");
	return base->GetPropErrorNameFromEnum(error);
}
bool CVRSystem_014::PollNextEvent(vr::VREvent_t* pEvent, uint32_t uncbVREvent) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_014)");
	return base->PollNextEvent(pEvent, uncbVREvent);
}
bool CVRSystem_014::PollNextEventWithPose(vr::ETrackingUniverseOrigin eOrigin, vr::VREvent_t* pEvent, uint32_t uncbVREvent, vr::TrackedDevicePose_t* pTrackedDevicePose) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_014)");
	return base->PollNextEventWithPose(eOrigin, pEvent, uncbVREvent, pTrackedDevicePose);
}
const char* CVRSystem_014::GetEventTypeNameFromEnum(vr::EVREventType eType) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_014)");
	return base->GetEventTypeNameFromEnum(eType);
}
vr::HiddenAreaMesh_t CVRSystem_014::GetHiddenAreaMesh(vr::EVREye eEye, vr::EHiddenAreaMeshType type) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_014)");
	return base->GetHiddenAreaMesh(eEye, type);
}
bool CVRSystem_014::GetControllerState(vr::TrackedDeviceIndex_t unControllerDeviceIndex, vr::VRControllerState_t* pControllerState, uint32_t unControllerStateSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_014)");
	return base->GetControllerState(unControllerDeviceIndex, pControllerState, unControllerStateSize);
}
bool CVRSystem_014::GetControllerStateWithPose(vr::ETrackingUniverseOrigin eOrigin, vr::TrackedDeviceIndex_t unControllerDeviceIndex, vr::VRControllerState_t* pControllerState, uint32_t unControllerStateSize, vr::TrackedDevicePose_t* pTrackedDevicePose) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_014)");
	return base->GetControllerStateWithPose(eOrigin, unControllerDeviceIndex, pControllerState, unControllerStateSize, pTrackedDevicePose);
}
void CVRSystem_014::TriggerHapticPulse(vr::TrackedDeviceIndex_t unControllerDeviceIndex, uint32_t unAxisId, unsigned short usDurationMicroSec) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_014)");
	return base->TriggerHapticPulse(unControllerDeviceIndex, unAxisId, usDurationMicroSec);
}
const char* CVRSystem_014::GetButtonIdNameFromEnum(vr::EVRButtonId eButtonId) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_014)");
	return base->GetButtonIdNameFromEnum(eButtonId);
}
const char* CVRSystem_014::GetControllerAxisTypeNameFromEnum(vr::EVRControllerAxisType eAxisType) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_014)");
	return base->GetControllerAxisTypeNameFromEnum(eAxisType);
}
bool CVRSystem_014::CaptureInputFocus() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_014)");
	return base->CaptureInputFocus();
}
void CVRSystem_014::ReleaseInputFocus() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_014)");
	return base->ReleaseInputFocus();
}
bool CVRSystem_014::IsInputFocusCapturedByAnotherProcess() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_014)");
	return base->IsInputFocusCapturedByAnotherProcess();
}
uint32_t CVRSystem_014::DriverDebugRequest(vr::TrackedDeviceIndex_t unDeviceIndex, const char* pchRequest, char* pchResponseBuffer, uint32_t unResponseBufferSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_014)");
	return base->DriverDebugRequest(unDeviceIndex, pchRequest, pchResponseBuffer, unResponseBufferSize);
}
vr::EVRFirmwareError CVRSystem_014::PerformFirmwareUpdate(vr::TrackedDeviceIndex_t unDeviceIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_014)");
	return base->PerformFirmwareUpdate(unDeviceIndex);
}
void CVRSystem_014::AcknowledgeQuit_Exiting() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_014)");
	return base->AcknowledgeQuit_Exiting();
}
void CVRSystem_014::AcknowledgeQuit_UserPrompt() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_014)");
	return base->AcknowledgeQuit_UserPrompt();
}
// FnTable for CVRSystem_014:
static CVRSystem_014 *fntable_System_014_instance = NULL;
static void OPENVR_FNTABLE_CALLTYPE fntable_System_014_impl_GetRecommendedRenderTargetSize(uint32_t* pnWidth, uint32_t* pnHeight) { return fntable_System_014_instance->GetRecommendedRenderTargetSize(pnWidth, pnHeight); }
static vr::HmdMatrix44_t OPENVR_FNTABLE_CALLTYPE fntable_System_014_impl_GetProjectionMatrix(vr::EVREye eEye, float fNearZ, float fFarZ, EGraphicsAPIConvention eProjType) { return fntable_System_014_instance->GetProjectionMatrix(eEye, fNearZ, fFarZ, eProjType); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_014_impl_GetProjectionRaw(vr::EVREye eEye, float* pfLeft, float* pfRight, float* pfTop, float* pfBottom) { return fntable_System_014_instance->GetProjectionRaw(eEye, pfLeft, pfRight, pfTop, pfBottom); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_014_impl_ComputeDistortion(vr::EVREye eEye, float fU, float fV, vr::DistortionCoordinates_t* pDistortionCoordinates) { return fntable_System_014_instance->ComputeDistortion(eEye, fU, fV, pDistortionCoordinates); }
static vr::HmdMatrix34_t OPENVR_FNTABLE_CALLTYPE fntable_System_014_impl_GetEyeToHeadTransform(vr::EVREye eEye) { return fntable_System_014_instance->GetEyeToHeadTransform(eEye); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_014_impl_GetTimeSinceLastVsync(float* pfSecondsSinceLastVsync, uint64_t* pulFrameCounter) { return fntable_System_014_instance->GetTimeSinceLastVsync(pfSecondsSinceLastVsync, pulFrameCounter); }
static int32_t OPENVR_FNTABLE_CALLTYPE fntable_System_014_impl_GetD3D9AdapterIndex() { return fntable_System_014_instance->GetD3D9AdapterIndex(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_014_impl_GetDXGIOutputInfo(int32_t* pnAdapterIndex) { return fntable_System_014_instance->GetDXGIOutputInfo(pnAdapterIndex); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_014_impl_IsDisplayOnDesktop() { return fntable_System_014_instance->IsDisplayOnDesktop(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_014_impl_SetDisplayVisibility(bool bIsVisibleOnDesktop) { return fntable_System_014_instance->SetDisplayVisibility(bIsVisibleOnDesktop); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_014_impl_GetDeviceToAbsoluteTrackingPose(vr::ETrackingUniverseOrigin eOrigin, float fPredictedSecondsToPhotonsFromNow, vr::TrackedDevicePose_t* pTrackedDevicePoseArray, uint32_t unTrackedDevicePoseArrayCount) { return fntable_System_014_instance->GetDeviceToAbsoluteTrackingPose(eOrigin, fPredictedSecondsToPhotonsFromNow, pTrackedDevicePoseArray, unTrackedDevicePoseArrayCount); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_014_impl_ResetSeatedZeroPose() { return fntable_System_014_instance->ResetSeatedZeroPose(); }
static vr::HmdMatrix34_t OPENVR_FNTABLE_CALLTYPE fntable_System_014_impl_GetSeatedZeroPoseToStandingAbsoluteTrackingPose() { return fntable_System_014_instance->GetSeatedZeroPoseToStandingAbsoluteTrackingPose(); }
static vr::HmdMatrix34_t OPENVR_FNTABLE_CALLTYPE fntable_System_014_impl_GetRawZeroPoseToStandingAbsoluteTrackingPose() { return fntable_System_014_instance->GetRawZeroPoseToStandingAbsoluteTrackingPose(); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_System_014_impl_GetSortedTrackedDeviceIndicesOfClass(vr::ETrackedDeviceClass eTrackedDeviceClass, vr::TrackedDeviceIndex_t* punTrackedDeviceIndexArray, uint32_t unTrackedDeviceIndexArrayCount, vr::TrackedDeviceIndex_t unRelativeToTrackedDeviceIndex) { return fntable_System_014_instance->GetSortedTrackedDeviceIndicesOfClass(eTrackedDeviceClass, punTrackedDeviceIndexArray, unTrackedDeviceIndexArrayCount, unRelativeToTrackedDeviceIndex); }
static vr::EDeviceActivityLevel OPENVR_FNTABLE_CALLTYPE fntable_System_014_impl_GetTrackedDeviceActivityLevel(vr::TrackedDeviceIndex_t unDeviceId) { return fntable_System_014_instance->GetTrackedDeviceActivityLevel(unDeviceId); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_014_impl_ApplyTransform(vr::TrackedDevicePose_t* pOutputPose, const vr::TrackedDevicePose_t* pTrackedDevicePose, const vr::HmdMatrix34_t* pTransform) { return fntable_System_014_instance->ApplyTransform(pOutputPose, pTrackedDevicePose, pTransform); }
static vr::TrackedDeviceIndex_t OPENVR_FNTABLE_CALLTYPE fntable_System_014_impl_GetTrackedDeviceIndexForControllerRole(vr::ETrackedControllerRole unDeviceType) { return fntable_System_014_instance->GetTrackedDeviceIndexForControllerRole(unDeviceType); }
static vr::ETrackedControllerRole OPENVR_FNTABLE_CALLTYPE fntable_System_014_impl_GetControllerRoleForTrackedDeviceIndex(vr::TrackedDeviceIndex_t unDeviceIndex) { return fntable_System_014_instance->GetControllerRoleForTrackedDeviceIndex(unDeviceIndex); }
static vr::ETrackedDeviceClass OPENVR_FNTABLE_CALLTYPE fntable_System_014_impl_GetTrackedDeviceClass(vr::TrackedDeviceIndex_t unDeviceIndex) { return fntable_System_014_instance->GetTrackedDeviceClass(unDeviceIndex); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_014_impl_IsTrackedDeviceConnected(vr::TrackedDeviceIndex_t unDeviceIndex) { return fntable_System_014_instance->IsTrackedDeviceConnected(unDeviceIndex); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_014_impl_GetBoolTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) { return fntable_System_014_instance->GetBoolTrackedDeviceProperty(unDeviceIndex, prop, pError); }
static float OPENVR_FNTABLE_CALLTYPE fntable_System_014_impl_GetFloatTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) { return fntable_System_014_instance->GetFloatTrackedDeviceProperty(unDeviceIndex, prop, pError); }
static int32_t OPENVR_FNTABLE_CALLTYPE fntable_System_014_impl_GetInt32TrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) { return fntable_System_014_instance->GetInt32TrackedDeviceProperty(unDeviceIndex, prop, pError); }
static uint64_t OPENVR_FNTABLE_CALLTYPE fntable_System_014_impl_GetUint64TrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) { return fntable_System_014_instance->GetUint64TrackedDeviceProperty(unDeviceIndex, prop, pError); }
static vr::HmdMatrix34_t OPENVR_FNTABLE_CALLTYPE fntable_System_014_impl_GetMatrix34TrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) { return fntable_System_014_instance->GetMatrix34TrackedDeviceProperty(unDeviceIndex, prop, pError); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_System_014_impl_GetStringTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, char* pchValue, uint32_t unBufferSize, vr::ETrackedPropertyError* pError) { return fntable_System_014_instance->GetStringTrackedDeviceProperty(unDeviceIndex, prop, pchValue, unBufferSize, pError); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_System_014_impl_GetPropErrorNameFromEnum(vr::ETrackedPropertyError error) { return fntable_System_014_instance->GetPropErrorNameFromEnum(error); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_014_impl_PollNextEvent(vr::VREvent_t* pEvent, uint32_t uncbVREvent) { return fntable_System_014_instance->PollNextEvent(pEvent, uncbVREvent); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_014_impl_PollNextEventWithPose(vr::ETrackingUniverseOrigin eOrigin, vr::VREvent_t* pEvent, uint32_t uncbVREvent, vr::TrackedDevicePose_t* pTrackedDevicePose) { return fntable_System_014_instance->PollNextEventWithPose(eOrigin, pEvent, uncbVREvent, pTrackedDevicePose); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_System_014_impl_GetEventTypeNameFromEnum(vr::EVREventType eType) { return fntable_System_014_instance->GetEventTypeNameFromEnum(eType); }
static vr::HiddenAreaMesh_t OPENVR_FNTABLE_CALLTYPE fntable_System_014_impl_GetHiddenAreaMesh(vr::EVREye eEye, vr::EHiddenAreaMeshType type) { return fntable_System_014_instance->GetHiddenAreaMesh(eEye, type); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_014_impl_GetControllerState(vr::TrackedDeviceIndex_t unControllerDeviceIndex, vr::VRControllerState_t* pControllerState, uint32_t unControllerStateSize) { return fntable_System_014_instance->GetControllerState(unControllerDeviceIndex, pControllerState, unControllerStateSize); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_014_impl_GetControllerStateWithPose(vr::ETrackingUniverseOrigin eOrigin, vr::TrackedDeviceIndex_t unControllerDeviceIndex, vr::VRControllerState_t* pControllerState, uint32_t unControllerStateSize, vr::TrackedDevicePose_t* pTrackedDevicePose) { return fntable_System_014_instance->GetControllerStateWithPose(eOrigin, unControllerDeviceIndex, pControllerState, unControllerStateSize, pTrackedDevicePose); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_014_impl_TriggerHapticPulse(vr::TrackedDeviceIndex_t unControllerDeviceIndex, uint32_t unAxisId, unsigned short usDurationMicroSec) { return fntable_System_014_instance->TriggerHapticPulse(unControllerDeviceIndex, unAxisId, usDurationMicroSec); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_System_014_impl_GetButtonIdNameFromEnum(vr::EVRButtonId eButtonId) { return fntable_System_014_instance->GetButtonIdNameFromEnum(eButtonId); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_System_014_impl_GetControllerAxisTypeNameFromEnum(vr::EVRControllerAxisType eAxisType) { return fntable_System_014_instance->GetControllerAxisTypeNameFromEnum(eAxisType); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_014_impl_CaptureInputFocus() { return fntable_System_014_instance->CaptureInputFocus(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_014_impl_ReleaseInputFocus() { return fntable_System_014_instance->ReleaseInputFocus(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_014_impl_IsInputFocusCapturedByAnotherProcess() { return fntable_System_014_instance->IsInputFocusCapturedByAnotherProcess(); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_System_014_impl_DriverDebugRequest(vr::TrackedDeviceIndex_t unDeviceIndex, const char* pchRequest, char* pchResponseBuffer, uint32_t unResponseBufferSize) { return fntable_System_014_instance->DriverDebugRequest(unDeviceIndex, pchRequest, pchResponseBuffer, unResponseBufferSize); }
static vr::EVRFirmwareError OPENVR_FNTABLE_CALLTYPE fntable_System_014_impl_PerformFirmwareUpdate(vr::TrackedDeviceIndex_t unDeviceIndex) { return fntable_System_014_instance->PerformFirmwareUpdate(unDeviceIndex); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_014_impl_AcknowledgeQuit_Exiting() { return fntable_System_014_instance->AcknowledgeQuit_Exiting(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_014_impl_AcknowledgeQuit_UserPrompt() { return fntable_System_014_instance->AcknowledgeQuit_UserPrompt(); }
static void *fntable_System_014_funcs[] = {
	(void*) fntable_System_014_impl_GetRecommendedRenderTargetSize,
	(void*) fntable_System_014_impl_GetProjectionMatrix,
	(void*) fntable_System_014_impl_GetProjectionRaw,
	(void*) fntable_System_014_impl_ComputeDistortion,
	(void*) fntable_System_014_impl_GetEyeToHeadTransform,
	(void*) fntable_System_014_impl_GetTimeSinceLastVsync,
	(void*) fntable_System_014_impl_GetD3D9AdapterIndex,
	(void*) fntable_System_014_impl_GetDXGIOutputInfo,
	(void*) fntable_System_014_impl_IsDisplayOnDesktop,
	(void*) fntable_System_014_impl_SetDisplayVisibility,
	(void*) fntable_System_014_impl_GetDeviceToAbsoluteTrackingPose,
	(void*) fntable_System_014_impl_ResetSeatedZeroPose,
	(void*) fntable_System_014_impl_GetSeatedZeroPoseToStandingAbsoluteTrackingPose,
	(void*) fntable_System_014_impl_GetRawZeroPoseToStandingAbsoluteTrackingPose,
	(void*) fntable_System_014_impl_GetSortedTrackedDeviceIndicesOfClass,
	(void*) fntable_System_014_impl_GetTrackedDeviceActivityLevel,
	(void*) fntable_System_014_impl_ApplyTransform,
	(void*) fntable_System_014_impl_GetTrackedDeviceIndexForControllerRole,
	(void*) fntable_System_014_impl_GetControllerRoleForTrackedDeviceIndex,
	(void*) fntable_System_014_impl_GetTrackedDeviceClass,
	(void*) fntable_System_014_impl_IsTrackedDeviceConnected,
	(void*) fntable_System_014_impl_GetBoolTrackedDeviceProperty,
	(void*) fntable_System_014_impl_GetFloatTrackedDeviceProperty,
	(void*) fntable_System_014_impl_GetInt32TrackedDeviceProperty,
	(void*) fntable_System_014_impl_GetUint64TrackedDeviceProperty,
	(void*) fntable_System_014_impl_GetMatrix34TrackedDeviceProperty,
	(void*) fntable_System_014_impl_GetStringTrackedDeviceProperty,
	(void*) fntable_System_014_impl_GetPropErrorNameFromEnum,
	(void*) fntable_System_014_impl_PollNextEvent,
	(void*) fntable_System_014_impl_PollNextEventWithPose,
	(void*) fntable_System_014_impl_GetEventTypeNameFromEnum,
	(void*) fntable_System_014_impl_GetHiddenAreaMesh,
	(void*) fntable_System_014_impl_GetControllerState,
	(void*) fntable_System_014_impl_GetControllerStateWithPose,
	(void*) fntable_System_014_impl_TriggerHapticPulse,
	(void*) fntable_System_014_impl_GetButtonIdNameFromEnum,
	(void*) fntable_System_014_impl_GetControllerAxisTypeNameFromEnum,
	(void*) fntable_System_014_impl_CaptureInputFocus,
	(void*) fntable_System_014_impl_ReleaseInputFocus,
	(void*) fntable_System_014_impl_IsInputFocusCapturedByAnotherProcess,
	(void*) fntable_System_014_impl_DriverDebugRequest,
	(void*) fntable_System_014_impl_PerformFirmwareUpdate,
	(void*) fntable_System_014_impl_AcknowledgeQuit_Exiting,
	(void*) fntable_System_014_impl_AcknowledgeQuit_UserPrompt,
};
void** CVRSystem_014::_GetStatFuncList() { fntable_System_014_instance = this; return fntable_System_014_funcs; }
void CVRSystem_014::Delete() { delete this; }
// Misc for CVRSystem_015:
CVRSystem_015::CVRSystem_015() : base(GetCreateBaseSystem()) {}
// Interface methods for CVRSystem_015:
void CVRSystem_015::GetRecommendedRenderTargetSize(uint32_t* pnWidth, uint32_t* pnHeight) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_015)");
	return base->GetRecommendedRenderTargetSize(pnWidth, pnHeight);
}
vr::HmdMatrix44_t CVRSystem_015::GetProjectionMatrix(vr::EVREye eEye, float fNearZ, float fFarZ) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_015)");
	return base->GetProjectionMatrix(eEye, fNearZ, fFarZ);
}
void CVRSystem_015::GetProjectionRaw(vr::EVREye eEye, float* pfLeft, float* pfRight, float* pfTop, float* pfBottom) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_015)");
	return base->GetProjectionRaw(eEye, pfLeft, pfRight, pfTop, pfBottom);
}
bool CVRSystem_015::ComputeDistortion(vr::EVREye eEye, float fU, float fV, vr::DistortionCoordinates_t* pDistortionCoordinates) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_015)");
	return base->ComputeDistortion(eEye, fU, fV, pDistortionCoordinates);
}
vr::HmdMatrix34_t CVRSystem_015::GetEyeToHeadTransform(vr::EVREye eEye) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_015)");
	return base->GetEyeToHeadTransform(eEye);
}
bool CVRSystem_015::GetTimeSinceLastVsync(float* pfSecondsSinceLastVsync, uint64_t* pulFrameCounter) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_015)");
	return base->GetTimeSinceLastVsync(pfSecondsSinceLastVsync, pulFrameCounter);
}
int32_t CVRSystem_015::GetD3D9AdapterIndex() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_015)");
	return base->GetD3D9AdapterIndex();
}
void CVRSystem_015::GetDXGIOutputInfo(int32_t* pnAdapterIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_015)");
	return base->GetDXGIOutputInfo(pnAdapterIndex);
}
bool CVRSystem_015::IsDisplayOnDesktop() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_015)");
	return base->IsDisplayOnDesktop();
}
bool CVRSystem_015::SetDisplayVisibility(bool bIsVisibleOnDesktop) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_015)");
	return base->SetDisplayVisibility(bIsVisibleOnDesktop);
}
void CVRSystem_015::GetDeviceToAbsoluteTrackingPose(vr::ETrackingUniverseOrigin eOrigin, float fPredictedSecondsToPhotonsFromNow, vr::TrackedDevicePose_t* pTrackedDevicePoseArray, uint32_t unTrackedDevicePoseArrayCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_015)");
	return base->GetDeviceToAbsoluteTrackingPose(eOrigin, fPredictedSecondsToPhotonsFromNow, pTrackedDevicePoseArray, unTrackedDevicePoseArrayCount);
}
void CVRSystem_015::ResetSeatedZeroPose() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_015)");
	return base->ResetSeatedZeroPose();
}
vr::HmdMatrix34_t CVRSystem_015::GetSeatedZeroPoseToStandingAbsoluteTrackingPose() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_015)");
	return base->GetSeatedZeroPoseToStandingAbsoluteTrackingPose();
}
vr::HmdMatrix34_t CVRSystem_015::GetRawZeroPoseToStandingAbsoluteTrackingPose() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_015)");
	return base->GetRawZeroPoseToStandingAbsoluteTrackingPose();
}
uint32_t CVRSystem_015::GetSortedTrackedDeviceIndicesOfClass(vr::ETrackedDeviceClass eTrackedDeviceClass, vr::TrackedDeviceIndex_t* punTrackedDeviceIndexArray, uint32_t unTrackedDeviceIndexArrayCount, vr::TrackedDeviceIndex_t unRelativeToTrackedDeviceIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_015)");
	return base->GetSortedTrackedDeviceIndicesOfClass(eTrackedDeviceClass, punTrackedDeviceIndexArray, unTrackedDeviceIndexArrayCount, unRelativeToTrackedDeviceIndex);
}
vr::EDeviceActivityLevel CVRSystem_015::GetTrackedDeviceActivityLevel(vr::TrackedDeviceIndex_t unDeviceId) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_015)");
	return base->GetTrackedDeviceActivityLevel(unDeviceId);
}
void CVRSystem_015::ApplyTransform(vr::TrackedDevicePose_t* pOutputPose, const vr::TrackedDevicePose_t* pTrackedDevicePose, const vr::HmdMatrix34_t* pTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_015)");
	return base->ApplyTransform(pOutputPose, pTrackedDevicePose, pTransform);
}
vr::TrackedDeviceIndex_t CVRSystem_015::GetTrackedDeviceIndexForControllerRole(vr::ETrackedControllerRole unDeviceType) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_015)");
	return base->GetTrackedDeviceIndexForControllerRole(unDeviceType);
}
vr::ETrackedControllerRole CVRSystem_015::GetControllerRoleForTrackedDeviceIndex(vr::TrackedDeviceIndex_t unDeviceIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_015)");
	return base->GetControllerRoleForTrackedDeviceIndex(unDeviceIndex);
}
vr::ETrackedDeviceClass CVRSystem_015::GetTrackedDeviceClass(vr::TrackedDeviceIndex_t unDeviceIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_015)");
	return base->GetTrackedDeviceClass(unDeviceIndex);
}
bool CVRSystem_015::IsTrackedDeviceConnected(vr::TrackedDeviceIndex_t unDeviceIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_015)");
	return base->IsTrackedDeviceConnected(unDeviceIndex);
}
bool CVRSystem_015::GetBoolTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_015)");
	return base->GetBoolTrackedDeviceProperty(unDeviceIndex, prop, pError);
}
float CVRSystem_015::GetFloatTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_015)");
	return base->GetFloatTrackedDeviceProperty(unDeviceIndex, prop, pError);
}
int32_t CVRSystem_015::GetInt32TrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_015)");
	return base->GetInt32TrackedDeviceProperty(unDeviceIndex, prop, pError);
}
uint64_t CVRSystem_015::GetUint64TrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_015)");
	return base->GetUint64TrackedDeviceProperty(unDeviceIndex, prop, pError);
}
vr::HmdMatrix34_t CVRSystem_015::GetMatrix34TrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_015)");
	return base->GetMatrix34TrackedDeviceProperty(unDeviceIndex, prop, pError);
}
uint32_t CVRSystem_015::GetStringTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, char* pchValue, uint32_t unBufferSize, vr::ETrackedPropertyError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_015)");
	return base->GetStringTrackedDeviceProperty(unDeviceIndex, prop, pchValue, unBufferSize, pError);
}
const char* CVRSystem_015::GetPropErrorNameFromEnum(vr::ETrackedPropertyError error) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_015)");
	return base->GetPropErrorNameFromEnum(error);
}
bool CVRSystem_015::PollNextEvent(vr::VREvent_t* pEvent, uint32_t uncbVREvent) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_015)");
	return base->PollNextEvent(pEvent, uncbVREvent);
}
bool CVRSystem_015::PollNextEventWithPose(vr::ETrackingUniverseOrigin eOrigin, vr::VREvent_t* pEvent, uint32_t uncbVREvent, vr::TrackedDevicePose_t* pTrackedDevicePose) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_015)");
	return base->PollNextEventWithPose(eOrigin, pEvent, uncbVREvent, pTrackedDevicePose);
}
const char* CVRSystem_015::GetEventTypeNameFromEnum(vr::EVREventType eType) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_015)");
	return base->GetEventTypeNameFromEnum(eType);
}
vr::HiddenAreaMesh_t CVRSystem_015::GetHiddenAreaMesh(vr::EVREye eEye, vr::EHiddenAreaMeshType type) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_015)");
	return base->GetHiddenAreaMesh(eEye, type);
}
bool CVRSystem_015::GetControllerState(vr::TrackedDeviceIndex_t unControllerDeviceIndex, vr::VRControllerState_t* pControllerState, uint32_t unControllerStateSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_015)");
	return base->GetControllerState(unControllerDeviceIndex, pControllerState, unControllerStateSize);
}
bool CVRSystem_015::GetControllerStateWithPose(vr::ETrackingUniverseOrigin eOrigin, vr::TrackedDeviceIndex_t unControllerDeviceIndex, vr::VRControllerState_t* pControllerState, uint32_t unControllerStateSize, vr::TrackedDevicePose_t* pTrackedDevicePose) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_015)");
	return base->GetControllerStateWithPose(eOrigin, unControllerDeviceIndex, pControllerState, unControllerStateSize, pTrackedDevicePose);
}
void CVRSystem_015::TriggerHapticPulse(vr::TrackedDeviceIndex_t unControllerDeviceIndex, uint32_t unAxisId, unsigned short usDurationMicroSec) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_015)");
	return base->TriggerHapticPulse(unControllerDeviceIndex, unAxisId, usDurationMicroSec);
}
const char* CVRSystem_015::GetButtonIdNameFromEnum(vr::EVRButtonId eButtonId) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_015)");
	return base->GetButtonIdNameFromEnum(eButtonId);
}
const char* CVRSystem_015::GetControllerAxisTypeNameFromEnum(vr::EVRControllerAxisType eAxisType) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_015)");
	return base->GetControllerAxisTypeNameFromEnum(eAxisType);
}
bool CVRSystem_015::CaptureInputFocus() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_015)");
	return base->CaptureInputFocus();
}
void CVRSystem_015::ReleaseInputFocus() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_015)");
	return base->ReleaseInputFocus();
}
bool CVRSystem_015::IsInputFocusCapturedByAnotherProcess() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_015)");
	return base->IsInputFocusCapturedByAnotherProcess();
}
uint32_t CVRSystem_015::DriverDebugRequest(vr::TrackedDeviceIndex_t unDeviceIndex, const char* pchRequest, char* pchResponseBuffer, uint32_t unResponseBufferSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_015)");
	return base->DriverDebugRequest(unDeviceIndex, pchRequest, pchResponseBuffer, unResponseBufferSize);
}
vr::EVRFirmwareError CVRSystem_015::PerformFirmwareUpdate(vr::TrackedDeviceIndex_t unDeviceIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_015)");
	return base->PerformFirmwareUpdate(unDeviceIndex);
}
void CVRSystem_015::AcknowledgeQuit_Exiting() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_015)");
	return base->AcknowledgeQuit_Exiting();
}
void CVRSystem_015::AcknowledgeQuit_UserPrompt() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_015)");
	return base->AcknowledgeQuit_UserPrompt();
}
// FnTable for CVRSystem_015:
static CVRSystem_015 *fntable_System_015_instance = NULL;
static void OPENVR_FNTABLE_CALLTYPE fntable_System_015_impl_GetRecommendedRenderTargetSize(uint32_t* pnWidth, uint32_t* pnHeight) { return fntable_System_015_instance->GetRecommendedRenderTargetSize(pnWidth, pnHeight); }
static vr::HmdMatrix44_t OPENVR_FNTABLE_CALLTYPE fntable_System_015_impl_GetProjectionMatrix(vr::EVREye eEye, float fNearZ, float fFarZ) { return fntable_System_015_instance->GetProjectionMatrix(eEye, fNearZ, fFarZ); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_015_impl_GetProjectionRaw(vr::EVREye eEye, float* pfLeft, float* pfRight, float* pfTop, float* pfBottom) { return fntable_System_015_instance->GetProjectionRaw(eEye, pfLeft, pfRight, pfTop, pfBottom); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_015_impl_ComputeDistortion(vr::EVREye eEye, float fU, float fV, vr::DistortionCoordinates_t* pDistortionCoordinates) { return fntable_System_015_instance->ComputeDistortion(eEye, fU, fV, pDistortionCoordinates); }
static vr::HmdMatrix34_t OPENVR_FNTABLE_CALLTYPE fntable_System_015_impl_GetEyeToHeadTransform(vr::EVREye eEye) { return fntable_System_015_instance->GetEyeToHeadTransform(eEye); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_015_impl_GetTimeSinceLastVsync(float* pfSecondsSinceLastVsync, uint64_t* pulFrameCounter) { return fntable_System_015_instance->GetTimeSinceLastVsync(pfSecondsSinceLastVsync, pulFrameCounter); }
static int32_t OPENVR_FNTABLE_CALLTYPE fntable_System_015_impl_GetD3D9AdapterIndex() { return fntable_System_015_instance->GetD3D9AdapterIndex(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_015_impl_GetDXGIOutputInfo(int32_t* pnAdapterIndex) { return fntable_System_015_instance->GetDXGIOutputInfo(pnAdapterIndex); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_015_impl_IsDisplayOnDesktop() { return fntable_System_015_instance->IsDisplayOnDesktop(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_015_impl_SetDisplayVisibility(bool bIsVisibleOnDesktop) { return fntable_System_015_instance->SetDisplayVisibility(bIsVisibleOnDesktop); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_015_impl_GetDeviceToAbsoluteTrackingPose(vr::ETrackingUniverseOrigin eOrigin, float fPredictedSecondsToPhotonsFromNow, vr::TrackedDevicePose_t* pTrackedDevicePoseArray, uint32_t unTrackedDevicePoseArrayCount) { return fntable_System_015_instance->GetDeviceToAbsoluteTrackingPose(eOrigin, fPredictedSecondsToPhotonsFromNow, pTrackedDevicePoseArray, unTrackedDevicePoseArrayCount); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_015_impl_ResetSeatedZeroPose() { return fntable_System_015_instance->ResetSeatedZeroPose(); }
static vr::HmdMatrix34_t OPENVR_FNTABLE_CALLTYPE fntable_System_015_impl_GetSeatedZeroPoseToStandingAbsoluteTrackingPose() { return fntable_System_015_instance->GetSeatedZeroPoseToStandingAbsoluteTrackingPose(); }
static vr::HmdMatrix34_t OPENVR_FNTABLE_CALLTYPE fntable_System_015_impl_GetRawZeroPoseToStandingAbsoluteTrackingPose() { return fntable_System_015_instance->GetRawZeroPoseToStandingAbsoluteTrackingPose(); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_System_015_impl_GetSortedTrackedDeviceIndicesOfClass(vr::ETrackedDeviceClass eTrackedDeviceClass, vr::TrackedDeviceIndex_t* punTrackedDeviceIndexArray, uint32_t unTrackedDeviceIndexArrayCount, vr::TrackedDeviceIndex_t unRelativeToTrackedDeviceIndex) { return fntable_System_015_instance->GetSortedTrackedDeviceIndicesOfClass(eTrackedDeviceClass, punTrackedDeviceIndexArray, unTrackedDeviceIndexArrayCount, unRelativeToTrackedDeviceIndex); }
static vr::EDeviceActivityLevel OPENVR_FNTABLE_CALLTYPE fntable_System_015_impl_GetTrackedDeviceActivityLevel(vr::TrackedDeviceIndex_t unDeviceId) { return fntable_System_015_instance->GetTrackedDeviceActivityLevel(unDeviceId); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_015_impl_ApplyTransform(vr::TrackedDevicePose_t* pOutputPose, const vr::TrackedDevicePose_t* pTrackedDevicePose, const vr::HmdMatrix34_t* pTransform) { return fntable_System_015_instance->ApplyTransform(pOutputPose, pTrackedDevicePose, pTransform); }
static vr::TrackedDeviceIndex_t OPENVR_FNTABLE_CALLTYPE fntable_System_015_impl_GetTrackedDeviceIndexForControllerRole(vr::ETrackedControllerRole unDeviceType) { return fntable_System_015_instance->GetTrackedDeviceIndexForControllerRole(unDeviceType); }
static vr::ETrackedControllerRole OPENVR_FNTABLE_CALLTYPE fntable_System_015_impl_GetControllerRoleForTrackedDeviceIndex(vr::TrackedDeviceIndex_t unDeviceIndex) { return fntable_System_015_instance->GetControllerRoleForTrackedDeviceIndex(unDeviceIndex); }
static vr::ETrackedDeviceClass OPENVR_FNTABLE_CALLTYPE fntable_System_015_impl_GetTrackedDeviceClass(vr::TrackedDeviceIndex_t unDeviceIndex) { return fntable_System_015_instance->GetTrackedDeviceClass(unDeviceIndex); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_015_impl_IsTrackedDeviceConnected(vr::TrackedDeviceIndex_t unDeviceIndex) { return fntable_System_015_instance->IsTrackedDeviceConnected(unDeviceIndex); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_015_impl_GetBoolTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) { return fntable_System_015_instance->GetBoolTrackedDeviceProperty(unDeviceIndex, prop, pError); }
static float OPENVR_FNTABLE_CALLTYPE fntable_System_015_impl_GetFloatTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) { return fntable_System_015_instance->GetFloatTrackedDeviceProperty(unDeviceIndex, prop, pError); }
static int32_t OPENVR_FNTABLE_CALLTYPE fntable_System_015_impl_GetInt32TrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) { return fntable_System_015_instance->GetInt32TrackedDeviceProperty(unDeviceIndex, prop, pError); }
static uint64_t OPENVR_FNTABLE_CALLTYPE fntable_System_015_impl_GetUint64TrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) { return fntable_System_015_instance->GetUint64TrackedDeviceProperty(unDeviceIndex, prop, pError); }
static vr::HmdMatrix34_t OPENVR_FNTABLE_CALLTYPE fntable_System_015_impl_GetMatrix34TrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) { return fntable_System_015_instance->GetMatrix34TrackedDeviceProperty(unDeviceIndex, prop, pError); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_System_015_impl_GetStringTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, char* pchValue, uint32_t unBufferSize, vr::ETrackedPropertyError* pError) { return fntable_System_015_instance->GetStringTrackedDeviceProperty(unDeviceIndex, prop, pchValue, unBufferSize, pError); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_System_015_impl_GetPropErrorNameFromEnum(vr::ETrackedPropertyError error) { return fntable_System_015_instance->GetPropErrorNameFromEnum(error); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_015_impl_PollNextEvent(vr::VREvent_t* pEvent, uint32_t uncbVREvent) { return fntable_System_015_instance->PollNextEvent(pEvent, uncbVREvent); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_015_impl_PollNextEventWithPose(vr::ETrackingUniverseOrigin eOrigin, vr::VREvent_t* pEvent, uint32_t uncbVREvent, vr::TrackedDevicePose_t* pTrackedDevicePose) { return fntable_System_015_instance->PollNextEventWithPose(eOrigin, pEvent, uncbVREvent, pTrackedDevicePose); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_System_015_impl_GetEventTypeNameFromEnum(vr::EVREventType eType) { return fntable_System_015_instance->GetEventTypeNameFromEnum(eType); }
static vr::HiddenAreaMesh_t OPENVR_FNTABLE_CALLTYPE fntable_System_015_impl_GetHiddenAreaMesh(vr::EVREye eEye, vr::EHiddenAreaMeshType type) { return fntable_System_015_instance->GetHiddenAreaMesh(eEye, type); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_015_impl_GetControllerState(vr::TrackedDeviceIndex_t unControllerDeviceIndex, vr::VRControllerState_t* pControllerState, uint32_t unControllerStateSize) { return fntable_System_015_instance->GetControllerState(unControllerDeviceIndex, pControllerState, unControllerStateSize); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_015_impl_GetControllerStateWithPose(vr::ETrackingUniverseOrigin eOrigin, vr::TrackedDeviceIndex_t unControllerDeviceIndex, vr::VRControllerState_t* pControllerState, uint32_t unControllerStateSize, vr::TrackedDevicePose_t* pTrackedDevicePose) { return fntable_System_015_instance->GetControllerStateWithPose(eOrigin, unControllerDeviceIndex, pControllerState, unControllerStateSize, pTrackedDevicePose); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_015_impl_TriggerHapticPulse(vr::TrackedDeviceIndex_t unControllerDeviceIndex, uint32_t unAxisId, unsigned short usDurationMicroSec) { return fntable_System_015_instance->TriggerHapticPulse(unControllerDeviceIndex, unAxisId, usDurationMicroSec); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_System_015_impl_GetButtonIdNameFromEnum(vr::EVRButtonId eButtonId) { return fntable_System_015_instance->GetButtonIdNameFromEnum(eButtonId); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_System_015_impl_GetControllerAxisTypeNameFromEnum(vr::EVRControllerAxisType eAxisType) { return fntable_System_015_instance->GetControllerAxisTypeNameFromEnum(eAxisType); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_015_impl_CaptureInputFocus() { return fntable_System_015_instance->CaptureInputFocus(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_015_impl_ReleaseInputFocus() { return fntable_System_015_instance->ReleaseInputFocus(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_015_impl_IsInputFocusCapturedByAnotherProcess() { return fntable_System_015_instance->IsInputFocusCapturedByAnotherProcess(); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_System_015_impl_DriverDebugRequest(vr::TrackedDeviceIndex_t unDeviceIndex, const char* pchRequest, char* pchResponseBuffer, uint32_t unResponseBufferSize) { return fntable_System_015_instance->DriverDebugRequest(unDeviceIndex, pchRequest, pchResponseBuffer, unResponseBufferSize); }
static vr::EVRFirmwareError OPENVR_FNTABLE_CALLTYPE fntable_System_015_impl_PerformFirmwareUpdate(vr::TrackedDeviceIndex_t unDeviceIndex) { return fntable_System_015_instance->PerformFirmwareUpdate(unDeviceIndex); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_015_impl_AcknowledgeQuit_Exiting() { return fntable_System_015_instance->AcknowledgeQuit_Exiting(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_015_impl_AcknowledgeQuit_UserPrompt() { return fntable_System_015_instance->AcknowledgeQuit_UserPrompt(); }
static void *fntable_System_015_funcs[] = {
	(void*) fntable_System_015_impl_GetRecommendedRenderTargetSize,
	(void*) fntable_System_015_impl_GetProjectionMatrix,
	(void*) fntable_System_015_impl_GetProjectionRaw,
	(void*) fntable_System_015_impl_ComputeDistortion,
	(void*) fntable_System_015_impl_GetEyeToHeadTransform,
	(void*) fntable_System_015_impl_GetTimeSinceLastVsync,
	(void*) fntable_System_015_impl_GetD3D9AdapterIndex,
	(void*) fntable_System_015_impl_GetDXGIOutputInfo,
	(void*) fntable_System_015_impl_IsDisplayOnDesktop,
	(void*) fntable_System_015_impl_SetDisplayVisibility,
	(void*) fntable_System_015_impl_GetDeviceToAbsoluteTrackingPose,
	(void*) fntable_System_015_impl_ResetSeatedZeroPose,
	(void*) fntable_System_015_impl_GetSeatedZeroPoseToStandingAbsoluteTrackingPose,
	(void*) fntable_System_015_impl_GetRawZeroPoseToStandingAbsoluteTrackingPose,
	(void*) fntable_System_015_impl_GetSortedTrackedDeviceIndicesOfClass,
	(void*) fntable_System_015_impl_GetTrackedDeviceActivityLevel,
	(void*) fntable_System_015_impl_ApplyTransform,
	(void*) fntable_System_015_impl_GetTrackedDeviceIndexForControllerRole,
	(void*) fntable_System_015_impl_GetControllerRoleForTrackedDeviceIndex,
	(void*) fntable_System_015_impl_GetTrackedDeviceClass,
	(void*) fntable_System_015_impl_IsTrackedDeviceConnected,
	(void*) fntable_System_015_impl_GetBoolTrackedDeviceProperty,
	(void*) fntable_System_015_impl_GetFloatTrackedDeviceProperty,
	(void*) fntable_System_015_impl_GetInt32TrackedDeviceProperty,
	(void*) fntable_System_015_impl_GetUint64TrackedDeviceProperty,
	(void*) fntable_System_015_impl_GetMatrix34TrackedDeviceProperty,
	(void*) fntable_System_015_impl_GetStringTrackedDeviceProperty,
	(void*) fntable_System_015_impl_GetPropErrorNameFromEnum,
	(void*) fntable_System_015_impl_PollNextEvent,
	(void*) fntable_System_015_impl_PollNextEventWithPose,
	(void*) fntable_System_015_impl_GetEventTypeNameFromEnum,
	(void*) fntable_System_015_impl_GetHiddenAreaMesh,
	(void*) fntable_System_015_impl_GetControllerState,
	(void*) fntable_System_015_impl_GetControllerStateWithPose,
	(void*) fntable_System_015_impl_TriggerHapticPulse,
	(void*) fntable_System_015_impl_GetButtonIdNameFromEnum,
	(void*) fntable_System_015_impl_GetControllerAxisTypeNameFromEnum,
	(void*) fntable_System_015_impl_CaptureInputFocus,
	(void*) fntable_System_015_impl_ReleaseInputFocus,
	(void*) fntable_System_015_impl_IsInputFocusCapturedByAnotherProcess,
	(void*) fntable_System_015_impl_DriverDebugRequest,
	(void*) fntable_System_015_impl_PerformFirmwareUpdate,
	(void*) fntable_System_015_impl_AcknowledgeQuit_Exiting,
	(void*) fntable_System_015_impl_AcknowledgeQuit_UserPrompt,
};
void** CVRSystem_015::_GetStatFuncList() { fntable_System_015_instance = this; return fntable_System_015_funcs; }
void CVRSystem_015::Delete() { delete this; }
// Misc for CVRSystem_016:
CVRSystem_016::CVRSystem_016() : base(GetCreateBaseSystem()) {}
// Interface methods for CVRSystem_016:
void CVRSystem_016::GetRecommendedRenderTargetSize(uint32_t* pnWidth, uint32_t* pnHeight) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_016)");
	return base->GetRecommendedRenderTargetSize(pnWidth, pnHeight);
}
vr::HmdMatrix44_t CVRSystem_016::GetProjectionMatrix(vr::EVREye eEye, float fNearZ, float fFarZ) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_016)");
	return base->GetProjectionMatrix(eEye, fNearZ, fFarZ);
}
void CVRSystem_016::GetProjectionRaw(vr::EVREye eEye, float* pfLeft, float* pfRight, float* pfTop, float* pfBottom) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_016)");
	return base->GetProjectionRaw(eEye, pfLeft, pfRight, pfTop, pfBottom);
}
bool CVRSystem_016::ComputeDistortion(vr::EVREye eEye, float fU, float fV, vr::DistortionCoordinates_t* pDistortionCoordinates) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_016)");
	return base->ComputeDistortion(eEye, fU, fV, pDistortionCoordinates);
}
vr::HmdMatrix34_t CVRSystem_016::GetEyeToHeadTransform(vr::EVREye eEye) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_016)");
	return base->GetEyeToHeadTransform(eEye);
}
bool CVRSystem_016::GetTimeSinceLastVsync(float* pfSecondsSinceLastVsync, uint64_t* pulFrameCounter) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_016)");
	return base->GetTimeSinceLastVsync(pfSecondsSinceLastVsync, pulFrameCounter);
}
int32_t CVRSystem_016::GetD3D9AdapterIndex() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_016)");
	return base->GetD3D9AdapterIndex();
}
void CVRSystem_016::GetDXGIOutputInfo(int32_t* pnAdapterIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_016)");
	return base->GetDXGIOutputInfo(pnAdapterIndex);
}
void CVRSystem_016::GetOutputDevice(uint64_t* pnDevice, vr::ETextureType textureType) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_016)");
	return base->GetOutputDevice(pnDevice, textureType);
}
bool CVRSystem_016::IsDisplayOnDesktop() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_016)");
	return base->IsDisplayOnDesktop();
}
bool CVRSystem_016::SetDisplayVisibility(bool bIsVisibleOnDesktop) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_016)");
	return base->SetDisplayVisibility(bIsVisibleOnDesktop);
}
void CVRSystem_016::GetDeviceToAbsoluteTrackingPose(vr::ETrackingUniverseOrigin eOrigin, float fPredictedSecondsToPhotonsFromNow, vr::TrackedDevicePose_t* pTrackedDevicePoseArray, uint32_t unTrackedDevicePoseArrayCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_016)");
	return base->GetDeviceToAbsoluteTrackingPose(eOrigin, fPredictedSecondsToPhotonsFromNow, pTrackedDevicePoseArray, unTrackedDevicePoseArrayCount);
}
void CVRSystem_016::ResetSeatedZeroPose() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_016)");
	return base->ResetSeatedZeroPose();
}
vr::HmdMatrix34_t CVRSystem_016::GetSeatedZeroPoseToStandingAbsoluteTrackingPose() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_016)");
	return base->GetSeatedZeroPoseToStandingAbsoluteTrackingPose();
}
vr::HmdMatrix34_t CVRSystem_016::GetRawZeroPoseToStandingAbsoluteTrackingPose() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_016)");
	return base->GetRawZeroPoseToStandingAbsoluteTrackingPose();
}
uint32_t CVRSystem_016::GetSortedTrackedDeviceIndicesOfClass(vr::ETrackedDeviceClass eTrackedDeviceClass, vr::TrackedDeviceIndex_t* punTrackedDeviceIndexArray, uint32_t unTrackedDeviceIndexArrayCount, vr::TrackedDeviceIndex_t unRelativeToTrackedDeviceIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_016)");
	return base->GetSortedTrackedDeviceIndicesOfClass(eTrackedDeviceClass, punTrackedDeviceIndexArray, unTrackedDeviceIndexArrayCount, unRelativeToTrackedDeviceIndex);
}
vr::EDeviceActivityLevel CVRSystem_016::GetTrackedDeviceActivityLevel(vr::TrackedDeviceIndex_t unDeviceId) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_016)");
	return base->GetTrackedDeviceActivityLevel(unDeviceId);
}
void CVRSystem_016::ApplyTransform(vr::TrackedDevicePose_t* pOutputPose, const vr::TrackedDevicePose_t* pTrackedDevicePose, const vr::HmdMatrix34_t* pTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_016)");
	return base->ApplyTransform(pOutputPose, pTrackedDevicePose, pTransform);
}
vr::TrackedDeviceIndex_t CVRSystem_016::GetTrackedDeviceIndexForControllerRole(vr::ETrackedControllerRole unDeviceType) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_016)");
	return base->GetTrackedDeviceIndexForControllerRole(unDeviceType);
}
vr::ETrackedControllerRole CVRSystem_016::GetControllerRoleForTrackedDeviceIndex(vr::TrackedDeviceIndex_t unDeviceIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_016)");
	return base->GetControllerRoleForTrackedDeviceIndex(unDeviceIndex);
}
vr::ETrackedDeviceClass CVRSystem_016::GetTrackedDeviceClass(vr::TrackedDeviceIndex_t unDeviceIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_016)");
	return base->GetTrackedDeviceClass(unDeviceIndex);
}
bool CVRSystem_016::IsTrackedDeviceConnected(vr::TrackedDeviceIndex_t unDeviceIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_016)");
	return base->IsTrackedDeviceConnected(unDeviceIndex);
}
bool CVRSystem_016::GetBoolTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_016)");
	return base->GetBoolTrackedDeviceProperty(unDeviceIndex, prop, pError);
}
float CVRSystem_016::GetFloatTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_016)");
	return base->GetFloatTrackedDeviceProperty(unDeviceIndex, prop, pError);
}
int32_t CVRSystem_016::GetInt32TrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_016)");
	return base->GetInt32TrackedDeviceProperty(unDeviceIndex, prop, pError);
}
uint64_t CVRSystem_016::GetUint64TrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_016)");
	return base->GetUint64TrackedDeviceProperty(unDeviceIndex, prop, pError);
}
vr::HmdMatrix34_t CVRSystem_016::GetMatrix34TrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_016)");
	return base->GetMatrix34TrackedDeviceProperty(unDeviceIndex, prop, pError);
}
uint32_t CVRSystem_016::GetStringTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, char* pchValue, uint32_t unBufferSize, vr::ETrackedPropertyError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_016)");
	return base->GetStringTrackedDeviceProperty(unDeviceIndex, prop, pchValue, unBufferSize, pError);
}
const char* CVRSystem_016::GetPropErrorNameFromEnum(vr::ETrackedPropertyError error) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_016)");
	return base->GetPropErrorNameFromEnum(error);
}
bool CVRSystem_016::PollNextEvent(vr::VREvent_t* pEvent, uint32_t uncbVREvent) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_016)");
	return base->PollNextEvent(pEvent, uncbVREvent);
}
bool CVRSystem_016::PollNextEventWithPose(vr::ETrackingUniverseOrigin eOrigin, vr::VREvent_t* pEvent, uint32_t uncbVREvent, vr::TrackedDevicePose_t* pTrackedDevicePose) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_016)");
	return base->PollNextEventWithPose(eOrigin, pEvent, uncbVREvent, pTrackedDevicePose);
}
const char* CVRSystem_016::GetEventTypeNameFromEnum(vr::EVREventType eType) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_016)");
	return base->GetEventTypeNameFromEnum(eType);
}
vr::HiddenAreaMesh_t CVRSystem_016::GetHiddenAreaMesh(vr::EVREye eEye, vr::EHiddenAreaMeshType type) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_016)");
	return base->GetHiddenAreaMesh(eEye, type);
}
bool CVRSystem_016::GetControllerState(vr::TrackedDeviceIndex_t unControllerDeviceIndex, vr::VRControllerState_t* pControllerState, uint32_t unControllerStateSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_016)");
	return base->GetControllerState(unControllerDeviceIndex, pControllerState, unControllerStateSize);
}
bool CVRSystem_016::GetControllerStateWithPose(vr::ETrackingUniverseOrigin eOrigin, vr::TrackedDeviceIndex_t unControllerDeviceIndex, vr::VRControllerState_t* pControllerState, uint32_t unControllerStateSize, vr::TrackedDevicePose_t* pTrackedDevicePose) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_016)");
	return base->GetControllerStateWithPose(eOrigin, unControllerDeviceIndex, pControllerState, unControllerStateSize, pTrackedDevicePose);
}
void CVRSystem_016::TriggerHapticPulse(vr::TrackedDeviceIndex_t unControllerDeviceIndex, uint32_t unAxisId, unsigned short usDurationMicroSec) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_016)");
	return base->TriggerHapticPulse(unControllerDeviceIndex, unAxisId, usDurationMicroSec);
}
const char* CVRSystem_016::GetButtonIdNameFromEnum(vr::EVRButtonId eButtonId) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_016)");
	return base->GetButtonIdNameFromEnum(eButtonId);
}
const char* CVRSystem_016::GetControllerAxisTypeNameFromEnum(vr::EVRControllerAxisType eAxisType) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_016)");
	return base->GetControllerAxisTypeNameFromEnum(eAxisType);
}
bool CVRSystem_016::CaptureInputFocus() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_016)");
	return base->CaptureInputFocus();
}
void CVRSystem_016::ReleaseInputFocus() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_016)");
	return base->ReleaseInputFocus();
}
bool CVRSystem_016::IsInputFocusCapturedByAnotherProcess() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_016)");
	return base->IsInputFocusCapturedByAnotherProcess();
}
uint32_t CVRSystem_016::DriverDebugRequest(vr::TrackedDeviceIndex_t unDeviceIndex, const char* pchRequest, char* pchResponseBuffer, uint32_t unResponseBufferSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_016)");
	return base->DriverDebugRequest(unDeviceIndex, pchRequest, pchResponseBuffer, unResponseBufferSize);
}
vr::EVRFirmwareError CVRSystem_016::PerformFirmwareUpdate(vr::TrackedDeviceIndex_t unDeviceIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_016)");
	return base->PerformFirmwareUpdate(unDeviceIndex);
}
void CVRSystem_016::AcknowledgeQuit_Exiting() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_016)");
	return base->AcknowledgeQuit_Exiting();
}
void CVRSystem_016::AcknowledgeQuit_UserPrompt() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_016)");
	return base->AcknowledgeQuit_UserPrompt();
}
// FnTable for CVRSystem_016:
static CVRSystem_016 *fntable_System_016_instance = NULL;
static void OPENVR_FNTABLE_CALLTYPE fntable_System_016_impl_GetRecommendedRenderTargetSize(uint32_t* pnWidth, uint32_t* pnHeight) { return fntable_System_016_instance->GetRecommendedRenderTargetSize(pnWidth, pnHeight); }
static vr::HmdMatrix44_t OPENVR_FNTABLE_CALLTYPE fntable_System_016_impl_GetProjectionMatrix(vr::EVREye eEye, float fNearZ, float fFarZ) { return fntable_System_016_instance->GetProjectionMatrix(eEye, fNearZ, fFarZ); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_016_impl_GetProjectionRaw(vr::EVREye eEye, float* pfLeft, float* pfRight, float* pfTop, float* pfBottom) { return fntable_System_016_instance->GetProjectionRaw(eEye, pfLeft, pfRight, pfTop, pfBottom); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_016_impl_ComputeDistortion(vr::EVREye eEye, float fU, float fV, vr::DistortionCoordinates_t* pDistortionCoordinates) { return fntable_System_016_instance->ComputeDistortion(eEye, fU, fV, pDistortionCoordinates); }
static vr::HmdMatrix34_t OPENVR_FNTABLE_CALLTYPE fntable_System_016_impl_GetEyeToHeadTransform(vr::EVREye eEye) { return fntable_System_016_instance->GetEyeToHeadTransform(eEye); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_016_impl_GetTimeSinceLastVsync(float* pfSecondsSinceLastVsync, uint64_t* pulFrameCounter) { return fntable_System_016_instance->GetTimeSinceLastVsync(pfSecondsSinceLastVsync, pulFrameCounter); }
static int32_t OPENVR_FNTABLE_CALLTYPE fntable_System_016_impl_GetD3D9AdapterIndex() { return fntable_System_016_instance->GetD3D9AdapterIndex(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_016_impl_GetDXGIOutputInfo(int32_t* pnAdapterIndex) { return fntable_System_016_instance->GetDXGIOutputInfo(pnAdapterIndex); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_016_impl_GetOutputDevice(uint64_t* pnDevice, vr::ETextureType textureType) { return fntable_System_016_instance->GetOutputDevice(pnDevice, textureType); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_016_impl_IsDisplayOnDesktop() { return fntable_System_016_instance->IsDisplayOnDesktop(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_016_impl_SetDisplayVisibility(bool bIsVisibleOnDesktop) { return fntable_System_016_instance->SetDisplayVisibility(bIsVisibleOnDesktop); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_016_impl_GetDeviceToAbsoluteTrackingPose(vr::ETrackingUniverseOrigin eOrigin, float fPredictedSecondsToPhotonsFromNow, vr::TrackedDevicePose_t* pTrackedDevicePoseArray, uint32_t unTrackedDevicePoseArrayCount) { return fntable_System_016_instance->GetDeviceToAbsoluteTrackingPose(eOrigin, fPredictedSecondsToPhotonsFromNow, pTrackedDevicePoseArray, unTrackedDevicePoseArrayCount); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_016_impl_ResetSeatedZeroPose() { return fntable_System_016_instance->ResetSeatedZeroPose(); }
static vr::HmdMatrix34_t OPENVR_FNTABLE_CALLTYPE fntable_System_016_impl_GetSeatedZeroPoseToStandingAbsoluteTrackingPose() { return fntable_System_016_instance->GetSeatedZeroPoseToStandingAbsoluteTrackingPose(); }
static vr::HmdMatrix34_t OPENVR_FNTABLE_CALLTYPE fntable_System_016_impl_GetRawZeroPoseToStandingAbsoluteTrackingPose() { return fntable_System_016_instance->GetRawZeroPoseToStandingAbsoluteTrackingPose(); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_System_016_impl_GetSortedTrackedDeviceIndicesOfClass(vr::ETrackedDeviceClass eTrackedDeviceClass, vr::TrackedDeviceIndex_t* punTrackedDeviceIndexArray, uint32_t unTrackedDeviceIndexArrayCount, vr::TrackedDeviceIndex_t unRelativeToTrackedDeviceIndex) { return fntable_System_016_instance->GetSortedTrackedDeviceIndicesOfClass(eTrackedDeviceClass, punTrackedDeviceIndexArray, unTrackedDeviceIndexArrayCount, unRelativeToTrackedDeviceIndex); }
static vr::EDeviceActivityLevel OPENVR_FNTABLE_CALLTYPE fntable_System_016_impl_GetTrackedDeviceActivityLevel(vr::TrackedDeviceIndex_t unDeviceId) { return fntable_System_016_instance->GetTrackedDeviceActivityLevel(unDeviceId); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_016_impl_ApplyTransform(vr::TrackedDevicePose_t* pOutputPose, const vr::TrackedDevicePose_t* pTrackedDevicePose, const vr::HmdMatrix34_t* pTransform) { return fntable_System_016_instance->ApplyTransform(pOutputPose, pTrackedDevicePose, pTransform); }
static vr::TrackedDeviceIndex_t OPENVR_FNTABLE_CALLTYPE fntable_System_016_impl_GetTrackedDeviceIndexForControllerRole(vr::ETrackedControllerRole unDeviceType) { return fntable_System_016_instance->GetTrackedDeviceIndexForControllerRole(unDeviceType); }
static vr::ETrackedControllerRole OPENVR_FNTABLE_CALLTYPE fntable_System_016_impl_GetControllerRoleForTrackedDeviceIndex(vr::TrackedDeviceIndex_t unDeviceIndex) { return fntable_System_016_instance->GetControllerRoleForTrackedDeviceIndex(unDeviceIndex); }
static vr::ETrackedDeviceClass OPENVR_FNTABLE_CALLTYPE fntable_System_016_impl_GetTrackedDeviceClass(vr::TrackedDeviceIndex_t unDeviceIndex) { return fntable_System_016_instance->GetTrackedDeviceClass(unDeviceIndex); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_016_impl_IsTrackedDeviceConnected(vr::TrackedDeviceIndex_t unDeviceIndex) { return fntable_System_016_instance->IsTrackedDeviceConnected(unDeviceIndex); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_016_impl_GetBoolTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) { return fntable_System_016_instance->GetBoolTrackedDeviceProperty(unDeviceIndex, prop, pError); }
static float OPENVR_FNTABLE_CALLTYPE fntable_System_016_impl_GetFloatTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) { return fntable_System_016_instance->GetFloatTrackedDeviceProperty(unDeviceIndex, prop, pError); }
static int32_t OPENVR_FNTABLE_CALLTYPE fntable_System_016_impl_GetInt32TrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) { return fntable_System_016_instance->GetInt32TrackedDeviceProperty(unDeviceIndex, prop, pError); }
static uint64_t OPENVR_FNTABLE_CALLTYPE fntable_System_016_impl_GetUint64TrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) { return fntable_System_016_instance->GetUint64TrackedDeviceProperty(unDeviceIndex, prop, pError); }
static vr::HmdMatrix34_t OPENVR_FNTABLE_CALLTYPE fntable_System_016_impl_GetMatrix34TrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) { return fntable_System_016_instance->GetMatrix34TrackedDeviceProperty(unDeviceIndex, prop, pError); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_System_016_impl_GetStringTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, char* pchValue, uint32_t unBufferSize, vr::ETrackedPropertyError* pError) { return fntable_System_016_instance->GetStringTrackedDeviceProperty(unDeviceIndex, prop, pchValue, unBufferSize, pError); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_System_016_impl_GetPropErrorNameFromEnum(vr::ETrackedPropertyError error) { return fntable_System_016_instance->GetPropErrorNameFromEnum(error); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_016_impl_PollNextEvent(vr::VREvent_t* pEvent, uint32_t uncbVREvent) { return fntable_System_016_instance->PollNextEvent(pEvent, uncbVREvent); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_016_impl_PollNextEventWithPose(vr::ETrackingUniverseOrigin eOrigin, vr::VREvent_t* pEvent, uint32_t uncbVREvent, vr::TrackedDevicePose_t* pTrackedDevicePose) { return fntable_System_016_instance->PollNextEventWithPose(eOrigin, pEvent, uncbVREvent, pTrackedDevicePose); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_System_016_impl_GetEventTypeNameFromEnum(vr::EVREventType eType) { return fntable_System_016_instance->GetEventTypeNameFromEnum(eType); }
static vr::HiddenAreaMesh_t OPENVR_FNTABLE_CALLTYPE fntable_System_016_impl_GetHiddenAreaMesh(vr::EVREye eEye, vr::EHiddenAreaMeshType type) { return fntable_System_016_instance->GetHiddenAreaMesh(eEye, type); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_016_impl_GetControllerState(vr::TrackedDeviceIndex_t unControllerDeviceIndex, vr::VRControllerState_t* pControllerState, uint32_t unControllerStateSize) { return fntable_System_016_instance->GetControllerState(unControllerDeviceIndex, pControllerState, unControllerStateSize); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_016_impl_GetControllerStateWithPose(vr::ETrackingUniverseOrigin eOrigin, vr::TrackedDeviceIndex_t unControllerDeviceIndex, vr::VRControllerState_t* pControllerState, uint32_t unControllerStateSize, vr::TrackedDevicePose_t* pTrackedDevicePose) { return fntable_System_016_instance->GetControllerStateWithPose(eOrigin, unControllerDeviceIndex, pControllerState, unControllerStateSize, pTrackedDevicePose); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_016_impl_TriggerHapticPulse(vr::TrackedDeviceIndex_t unControllerDeviceIndex, uint32_t unAxisId, unsigned short usDurationMicroSec) { return fntable_System_016_instance->TriggerHapticPulse(unControllerDeviceIndex, unAxisId, usDurationMicroSec); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_System_016_impl_GetButtonIdNameFromEnum(vr::EVRButtonId eButtonId) { return fntable_System_016_instance->GetButtonIdNameFromEnum(eButtonId); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_System_016_impl_GetControllerAxisTypeNameFromEnum(vr::EVRControllerAxisType eAxisType) { return fntable_System_016_instance->GetControllerAxisTypeNameFromEnum(eAxisType); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_016_impl_CaptureInputFocus() { return fntable_System_016_instance->CaptureInputFocus(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_016_impl_ReleaseInputFocus() { return fntable_System_016_instance->ReleaseInputFocus(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_016_impl_IsInputFocusCapturedByAnotherProcess() { return fntable_System_016_instance->IsInputFocusCapturedByAnotherProcess(); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_System_016_impl_DriverDebugRequest(vr::TrackedDeviceIndex_t unDeviceIndex, const char* pchRequest, char* pchResponseBuffer, uint32_t unResponseBufferSize) { return fntable_System_016_instance->DriverDebugRequest(unDeviceIndex, pchRequest, pchResponseBuffer, unResponseBufferSize); }
static vr::EVRFirmwareError OPENVR_FNTABLE_CALLTYPE fntable_System_016_impl_PerformFirmwareUpdate(vr::TrackedDeviceIndex_t unDeviceIndex) { return fntable_System_016_instance->PerformFirmwareUpdate(unDeviceIndex); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_016_impl_AcknowledgeQuit_Exiting() { return fntable_System_016_instance->AcknowledgeQuit_Exiting(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_016_impl_AcknowledgeQuit_UserPrompt() { return fntable_System_016_instance->AcknowledgeQuit_UserPrompt(); }
static void *fntable_System_016_funcs[] = {
	(void*) fntable_System_016_impl_GetRecommendedRenderTargetSize,
	(void*) fntable_System_016_impl_GetProjectionMatrix,
	(void*) fntable_System_016_impl_GetProjectionRaw,
	(void*) fntable_System_016_impl_ComputeDistortion,
	(void*) fntable_System_016_impl_GetEyeToHeadTransform,
	(void*) fntable_System_016_impl_GetTimeSinceLastVsync,
	(void*) fntable_System_016_impl_GetD3D9AdapterIndex,
	(void*) fntable_System_016_impl_GetDXGIOutputInfo,
	(void*) fntable_System_016_impl_GetOutputDevice,
	(void*) fntable_System_016_impl_IsDisplayOnDesktop,
	(void*) fntable_System_016_impl_SetDisplayVisibility,
	(void*) fntable_System_016_impl_GetDeviceToAbsoluteTrackingPose,
	(void*) fntable_System_016_impl_ResetSeatedZeroPose,
	(void*) fntable_System_016_impl_GetSeatedZeroPoseToStandingAbsoluteTrackingPose,
	(void*) fntable_System_016_impl_GetRawZeroPoseToStandingAbsoluteTrackingPose,
	(void*) fntable_System_016_impl_GetSortedTrackedDeviceIndicesOfClass,
	(void*) fntable_System_016_impl_GetTrackedDeviceActivityLevel,
	(void*) fntable_System_016_impl_ApplyTransform,
	(void*) fntable_System_016_impl_GetTrackedDeviceIndexForControllerRole,
	(void*) fntable_System_016_impl_GetControllerRoleForTrackedDeviceIndex,
	(void*) fntable_System_016_impl_GetTrackedDeviceClass,
	(void*) fntable_System_016_impl_IsTrackedDeviceConnected,
	(void*) fntable_System_016_impl_GetBoolTrackedDeviceProperty,
	(void*) fntable_System_016_impl_GetFloatTrackedDeviceProperty,
	(void*) fntable_System_016_impl_GetInt32TrackedDeviceProperty,
	(void*) fntable_System_016_impl_GetUint64TrackedDeviceProperty,
	(void*) fntable_System_016_impl_GetMatrix34TrackedDeviceProperty,
	(void*) fntable_System_016_impl_GetStringTrackedDeviceProperty,
	(void*) fntable_System_016_impl_GetPropErrorNameFromEnum,
	(void*) fntable_System_016_impl_PollNextEvent,
	(void*) fntable_System_016_impl_PollNextEventWithPose,
	(void*) fntable_System_016_impl_GetEventTypeNameFromEnum,
	(void*) fntable_System_016_impl_GetHiddenAreaMesh,
	(void*) fntable_System_016_impl_GetControllerState,
	(void*) fntable_System_016_impl_GetControllerStateWithPose,
	(void*) fntable_System_016_impl_TriggerHapticPulse,
	(void*) fntable_System_016_impl_GetButtonIdNameFromEnum,
	(void*) fntable_System_016_impl_GetControllerAxisTypeNameFromEnum,
	(void*) fntable_System_016_impl_CaptureInputFocus,
	(void*) fntable_System_016_impl_ReleaseInputFocus,
	(void*) fntable_System_016_impl_IsInputFocusCapturedByAnotherProcess,
	(void*) fntable_System_016_impl_DriverDebugRequest,
	(void*) fntable_System_016_impl_PerformFirmwareUpdate,
	(void*) fntable_System_016_impl_AcknowledgeQuit_Exiting,
	(void*) fntable_System_016_impl_AcknowledgeQuit_UserPrompt,
};
void** CVRSystem_016::_GetStatFuncList() { fntable_System_016_instance = this; return fntable_System_016_funcs; }
void CVRSystem_016::Delete() { delete this; }
// Misc for CVRSystem_017:
CVRSystem_017::CVRSystem_017() : base(GetCreateBaseSystem()) {}
// Interface methods for CVRSystem_017:
void CVRSystem_017::GetRecommendedRenderTargetSize(uint32_t* pnWidth, uint32_t* pnHeight) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_017)");
	return base->GetRecommendedRenderTargetSize(pnWidth, pnHeight);
}
vr::HmdMatrix44_t CVRSystem_017::GetProjectionMatrix(vr::EVREye eEye, float fNearZ, float fFarZ) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_017)");
	return base->GetProjectionMatrix(eEye, fNearZ, fFarZ);
}
void CVRSystem_017::GetProjectionRaw(vr::EVREye eEye, float* pfLeft, float* pfRight, float* pfTop, float* pfBottom) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_017)");
	return base->GetProjectionRaw(eEye, pfLeft, pfRight, pfTop, pfBottom);
}
bool CVRSystem_017::ComputeDistortion(vr::EVREye eEye, float fU, float fV, vr::DistortionCoordinates_t* pDistortionCoordinates) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_017)");
	return base->ComputeDistortion(eEye, fU, fV, pDistortionCoordinates);
}
vr::HmdMatrix34_t CVRSystem_017::GetEyeToHeadTransform(vr::EVREye eEye) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_017)");
	return base->GetEyeToHeadTransform(eEye);
}
bool CVRSystem_017::GetTimeSinceLastVsync(float* pfSecondsSinceLastVsync, uint64_t* pulFrameCounter) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_017)");
	return base->GetTimeSinceLastVsync(pfSecondsSinceLastVsync, pulFrameCounter);
}
int32_t CVRSystem_017::GetD3D9AdapterIndex() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_017)");
	return base->GetD3D9AdapterIndex();
}
void CVRSystem_017::GetDXGIOutputInfo(int32_t* pnAdapterIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_017)");
	return base->GetDXGIOutputInfo(pnAdapterIndex);
}
void CVRSystem_017::GetOutputDevice(uint64_t* pnDevice, vr::ETextureType textureType, VkInstance_T* pInstance) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_017)");
	return base->GetOutputDevice(pnDevice, textureType, pInstance);
}
bool CVRSystem_017::IsDisplayOnDesktop() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_017)");
	return base->IsDisplayOnDesktop();
}
bool CVRSystem_017::SetDisplayVisibility(bool bIsVisibleOnDesktop) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_017)");
	return base->SetDisplayVisibility(bIsVisibleOnDesktop);
}
void CVRSystem_017::GetDeviceToAbsoluteTrackingPose(vr::ETrackingUniverseOrigin eOrigin, float fPredictedSecondsToPhotonsFromNow, vr::TrackedDevicePose_t* pTrackedDevicePoseArray, uint32_t unTrackedDevicePoseArrayCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_017)");
	return base->GetDeviceToAbsoluteTrackingPose(eOrigin, fPredictedSecondsToPhotonsFromNow, pTrackedDevicePoseArray, unTrackedDevicePoseArrayCount);
}
void CVRSystem_017::ResetSeatedZeroPose() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_017)");
	return base->ResetSeatedZeroPose();
}
vr::HmdMatrix34_t CVRSystem_017::GetSeatedZeroPoseToStandingAbsoluteTrackingPose() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_017)");
	return base->GetSeatedZeroPoseToStandingAbsoluteTrackingPose();
}
vr::HmdMatrix34_t CVRSystem_017::GetRawZeroPoseToStandingAbsoluteTrackingPose() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_017)");
	return base->GetRawZeroPoseToStandingAbsoluteTrackingPose();
}
uint32_t CVRSystem_017::GetSortedTrackedDeviceIndicesOfClass(vr::ETrackedDeviceClass eTrackedDeviceClass, vr::TrackedDeviceIndex_t* punTrackedDeviceIndexArray, uint32_t unTrackedDeviceIndexArrayCount, vr::TrackedDeviceIndex_t unRelativeToTrackedDeviceIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_017)");
	return base->GetSortedTrackedDeviceIndicesOfClass(eTrackedDeviceClass, punTrackedDeviceIndexArray, unTrackedDeviceIndexArrayCount, unRelativeToTrackedDeviceIndex);
}
vr::EDeviceActivityLevel CVRSystem_017::GetTrackedDeviceActivityLevel(vr::TrackedDeviceIndex_t unDeviceId) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_017)");
	return base->GetTrackedDeviceActivityLevel(unDeviceId);
}
void CVRSystem_017::ApplyTransform(vr::TrackedDevicePose_t* pOutputPose, const vr::TrackedDevicePose_t* pTrackedDevicePose, const vr::HmdMatrix34_t* pTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_017)");
	return base->ApplyTransform(pOutputPose, pTrackedDevicePose, pTransform);
}
vr::TrackedDeviceIndex_t CVRSystem_017::GetTrackedDeviceIndexForControllerRole(vr::ETrackedControllerRole unDeviceType) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_017)");
	return base->GetTrackedDeviceIndexForControllerRole(unDeviceType);
}
vr::ETrackedControllerRole CVRSystem_017::GetControllerRoleForTrackedDeviceIndex(vr::TrackedDeviceIndex_t unDeviceIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_017)");
	return base->GetControllerRoleForTrackedDeviceIndex(unDeviceIndex);
}
vr::ETrackedDeviceClass CVRSystem_017::GetTrackedDeviceClass(vr::TrackedDeviceIndex_t unDeviceIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_017)");
	return base->GetTrackedDeviceClass(unDeviceIndex);
}
bool CVRSystem_017::IsTrackedDeviceConnected(vr::TrackedDeviceIndex_t unDeviceIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_017)");
	return base->IsTrackedDeviceConnected(unDeviceIndex);
}
bool CVRSystem_017::GetBoolTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_017)");
	return base->GetBoolTrackedDeviceProperty(unDeviceIndex, prop, pError);
}
float CVRSystem_017::GetFloatTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_017)");
	return base->GetFloatTrackedDeviceProperty(unDeviceIndex, prop, pError);
}
int32_t CVRSystem_017::GetInt32TrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_017)");
	return base->GetInt32TrackedDeviceProperty(unDeviceIndex, prop, pError);
}
uint64_t CVRSystem_017::GetUint64TrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_017)");
	return base->GetUint64TrackedDeviceProperty(unDeviceIndex, prop, pError);
}
vr::HmdMatrix34_t CVRSystem_017::GetMatrix34TrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_017)");
	return base->GetMatrix34TrackedDeviceProperty(unDeviceIndex, prop, pError);
}
uint32_t CVRSystem_017::GetStringTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, char* pchValue, uint32_t unBufferSize, vr::ETrackedPropertyError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_017)");
	return base->GetStringTrackedDeviceProperty(unDeviceIndex, prop, pchValue, unBufferSize, pError);
}
const char* CVRSystem_017::GetPropErrorNameFromEnum(vr::ETrackedPropertyError error) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_017)");
	return base->GetPropErrorNameFromEnum(error);
}
bool CVRSystem_017::PollNextEvent(vr::VREvent_t* pEvent, uint32_t uncbVREvent) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_017)");
	return base->PollNextEvent(pEvent, uncbVREvent);
}
bool CVRSystem_017::PollNextEventWithPose(vr::ETrackingUniverseOrigin eOrigin, vr::VREvent_t* pEvent, uint32_t uncbVREvent, vr::TrackedDevicePose_t* pTrackedDevicePose) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_017)");
	return base->PollNextEventWithPose(eOrigin, pEvent, uncbVREvent, pTrackedDevicePose);
}
const char* CVRSystem_017::GetEventTypeNameFromEnum(vr::EVREventType eType) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_017)");
	return base->GetEventTypeNameFromEnum(eType);
}
vr::HiddenAreaMesh_t CVRSystem_017::GetHiddenAreaMesh(vr::EVREye eEye, vr::EHiddenAreaMeshType type) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_017)");
	return base->GetHiddenAreaMesh(eEye, type);
}
bool CVRSystem_017::GetControllerState(vr::TrackedDeviceIndex_t unControllerDeviceIndex, vr::VRControllerState_t* pControllerState, uint32_t unControllerStateSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_017)");
	return base->GetControllerState(unControllerDeviceIndex, pControllerState, unControllerStateSize);
}
bool CVRSystem_017::GetControllerStateWithPose(vr::ETrackingUniverseOrigin eOrigin, vr::TrackedDeviceIndex_t unControllerDeviceIndex, vr::VRControllerState_t* pControllerState, uint32_t unControllerStateSize, vr::TrackedDevicePose_t* pTrackedDevicePose) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_017)");
	return base->GetControllerStateWithPose(eOrigin, unControllerDeviceIndex, pControllerState, unControllerStateSize, pTrackedDevicePose);
}
void CVRSystem_017::TriggerHapticPulse(vr::TrackedDeviceIndex_t unControllerDeviceIndex, uint32_t unAxisId, unsigned short usDurationMicroSec) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_017)");
	return base->TriggerHapticPulse(unControllerDeviceIndex, unAxisId, usDurationMicroSec);
}
const char* CVRSystem_017::GetButtonIdNameFromEnum(vr::EVRButtonId eButtonId) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_017)");
	return base->GetButtonIdNameFromEnum(eButtonId);
}
const char* CVRSystem_017::GetControllerAxisTypeNameFromEnum(vr::EVRControllerAxisType eAxisType) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_017)");
	return base->GetControllerAxisTypeNameFromEnum(eAxisType);
}
bool CVRSystem_017::CaptureInputFocus() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_017)");
	return base->CaptureInputFocus();
}
void CVRSystem_017::ReleaseInputFocus() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_017)");
	return base->ReleaseInputFocus();
}
bool CVRSystem_017::IsInputFocusCapturedByAnotherProcess() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_017)");
	return base->IsInputFocusCapturedByAnotherProcess();
}
uint32_t CVRSystem_017::DriverDebugRequest(vr::TrackedDeviceIndex_t unDeviceIndex, const char* pchRequest, char* pchResponseBuffer, uint32_t unResponseBufferSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_017)");
	return base->DriverDebugRequest(unDeviceIndex, pchRequest, pchResponseBuffer, unResponseBufferSize);
}
vr::EVRFirmwareError CVRSystem_017::PerformFirmwareUpdate(vr::TrackedDeviceIndex_t unDeviceIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_017)");
	return base->PerformFirmwareUpdate(unDeviceIndex);
}
void CVRSystem_017::AcknowledgeQuit_Exiting() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_017)");
	return base->AcknowledgeQuit_Exiting();
}
void CVRSystem_017::AcknowledgeQuit_UserPrompt() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_017)");
	return base->AcknowledgeQuit_UserPrompt();
}
// FnTable for CVRSystem_017:
static CVRSystem_017 *fntable_System_017_instance = NULL;
static void OPENVR_FNTABLE_CALLTYPE fntable_System_017_impl_GetRecommendedRenderTargetSize(uint32_t* pnWidth, uint32_t* pnHeight) { return fntable_System_017_instance->GetRecommendedRenderTargetSize(pnWidth, pnHeight); }
static vr::HmdMatrix44_t OPENVR_FNTABLE_CALLTYPE fntable_System_017_impl_GetProjectionMatrix(vr::EVREye eEye, float fNearZ, float fFarZ) { return fntable_System_017_instance->GetProjectionMatrix(eEye, fNearZ, fFarZ); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_017_impl_GetProjectionRaw(vr::EVREye eEye, float* pfLeft, float* pfRight, float* pfTop, float* pfBottom) { return fntable_System_017_instance->GetProjectionRaw(eEye, pfLeft, pfRight, pfTop, pfBottom); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_017_impl_ComputeDistortion(vr::EVREye eEye, float fU, float fV, vr::DistortionCoordinates_t* pDistortionCoordinates) { return fntable_System_017_instance->ComputeDistortion(eEye, fU, fV, pDistortionCoordinates); }
static vr::HmdMatrix34_t OPENVR_FNTABLE_CALLTYPE fntable_System_017_impl_GetEyeToHeadTransform(vr::EVREye eEye) { return fntable_System_017_instance->GetEyeToHeadTransform(eEye); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_017_impl_GetTimeSinceLastVsync(float* pfSecondsSinceLastVsync, uint64_t* pulFrameCounter) { return fntable_System_017_instance->GetTimeSinceLastVsync(pfSecondsSinceLastVsync, pulFrameCounter); }
static int32_t OPENVR_FNTABLE_CALLTYPE fntable_System_017_impl_GetD3D9AdapterIndex() { return fntable_System_017_instance->GetD3D9AdapterIndex(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_017_impl_GetDXGIOutputInfo(int32_t* pnAdapterIndex) { return fntable_System_017_instance->GetDXGIOutputInfo(pnAdapterIndex); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_017_impl_GetOutputDevice(uint64_t* pnDevice, vr::ETextureType textureType, VkInstance_T* pInstance) { return fntable_System_017_instance->GetOutputDevice(pnDevice, textureType, pInstance); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_017_impl_IsDisplayOnDesktop() { return fntable_System_017_instance->IsDisplayOnDesktop(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_017_impl_SetDisplayVisibility(bool bIsVisibleOnDesktop) { return fntable_System_017_instance->SetDisplayVisibility(bIsVisibleOnDesktop); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_017_impl_GetDeviceToAbsoluteTrackingPose(vr::ETrackingUniverseOrigin eOrigin, float fPredictedSecondsToPhotonsFromNow, vr::TrackedDevicePose_t* pTrackedDevicePoseArray, uint32_t unTrackedDevicePoseArrayCount) { return fntable_System_017_instance->GetDeviceToAbsoluteTrackingPose(eOrigin, fPredictedSecondsToPhotonsFromNow, pTrackedDevicePoseArray, unTrackedDevicePoseArrayCount); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_017_impl_ResetSeatedZeroPose() { return fntable_System_017_instance->ResetSeatedZeroPose(); }
static vr::HmdMatrix34_t OPENVR_FNTABLE_CALLTYPE fntable_System_017_impl_GetSeatedZeroPoseToStandingAbsoluteTrackingPose() { return fntable_System_017_instance->GetSeatedZeroPoseToStandingAbsoluteTrackingPose(); }
static vr::HmdMatrix34_t OPENVR_FNTABLE_CALLTYPE fntable_System_017_impl_GetRawZeroPoseToStandingAbsoluteTrackingPose() { return fntable_System_017_instance->GetRawZeroPoseToStandingAbsoluteTrackingPose(); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_System_017_impl_GetSortedTrackedDeviceIndicesOfClass(vr::ETrackedDeviceClass eTrackedDeviceClass, vr::TrackedDeviceIndex_t* punTrackedDeviceIndexArray, uint32_t unTrackedDeviceIndexArrayCount, vr::TrackedDeviceIndex_t unRelativeToTrackedDeviceIndex) { return fntable_System_017_instance->GetSortedTrackedDeviceIndicesOfClass(eTrackedDeviceClass, punTrackedDeviceIndexArray, unTrackedDeviceIndexArrayCount, unRelativeToTrackedDeviceIndex); }
static vr::EDeviceActivityLevel OPENVR_FNTABLE_CALLTYPE fntable_System_017_impl_GetTrackedDeviceActivityLevel(vr::TrackedDeviceIndex_t unDeviceId) { return fntable_System_017_instance->GetTrackedDeviceActivityLevel(unDeviceId); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_017_impl_ApplyTransform(vr::TrackedDevicePose_t* pOutputPose, const vr::TrackedDevicePose_t* pTrackedDevicePose, const vr::HmdMatrix34_t* pTransform) { return fntable_System_017_instance->ApplyTransform(pOutputPose, pTrackedDevicePose, pTransform); }
static vr::TrackedDeviceIndex_t OPENVR_FNTABLE_CALLTYPE fntable_System_017_impl_GetTrackedDeviceIndexForControllerRole(vr::ETrackedControllerRole unDeviceType) { return fntable_System_017_instance->GetTrackedDeviceIndexForControllerRole(unDeviceType); }
static vr::ETrackedControllerRole OPENVR_FNTABLE_CALLTYPE fntable_System_017_impl_GetControllerRoleForTrackedDeviceIndex(vr::TrackedDeviceIndex_t unDeviceIndex) { return fntable_System_017_instance->GetControllerRoleForTrackedDeviceIndex(unDeviceIndex); }
static vr::ETrackedDeviceClass OPENVR_FNTABLE_CALLTYPE fntable_System_017_impl_GetTrackedDeviceClass(vr::TrackedDeviceIndex_t unDeviceIndex) { return fntable_System_017_instance->GetTrackedDeviceClass(unDeviceIndex); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_017_impl_IsTrackedDeviceConnected(vr::TrackedDeviceIndex_t unDeviceIndex) { return fntable_System_017_instance->IsTrackedDeviceConnected(unDeviceIndex); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_017_impl_GetBoolTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) { return fntable_System_017_instance->GetBoolTrackedDeviceProperty(unDeviceIndex, prop, pError); }
static float OPENVR_FNTABLE_CALLTYPE fntable_System_017_impl_GetFloatTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) { return fntable_System_017_instance->GetFloatTrackedDeviceProperty(unDeviceIndex, prop, pError); }
static int32_t OPENVR_FNTABLE_CALLTYPE fntable_System_017_impl_GetInt32TrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) { return fntable_System_017_instance->GetInt32TrackedDeviceProperty(unDeviceIndex, prop, pError); }
static uint64_t OPENVR_FNTABLE_CALLTYPE fntable_System_017_impl_GetUint64TrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) { return fntable_System_017_instance->GetUint64TrackedDeviceProperty(unDeviceIndex, prop, pError); }
static vr::HmdMatrix34_t OPENVR_FNTABLE_CALLTYPE fntable_System_017_impl_GetMatrix34TrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) { return fntable_System_017_instance->GetMatrix34TrackedDeviceProperty(unDeviceIndex, prop, pError); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_System_017_impl_GetStringTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, char* pchValue, uint32_t unBufferSize, vr::ETrackedPropertyError* pError) { return fntable_System_017_instance->GetStringTrackedDeviceProperty(unDeviceIndex, prop, pchValue, unBufferSize, pError); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_System_017_impl_GetPropErrorNameFromEnum(vr::ETrackedPropertyError error) { return fntable_System_017_instance->GetPropErrorNameFromEnum(error); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_017_impl_PollNextEvent(vr::VREvent_t* pEvent, uint32_t uncbVREvent) { return fntable_System_017_instance->PollNextEvent(pEvent, uncbVREvent); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_017_impl_PollNextEventWithPose(vr::ETrackingUniverseOrigin eOrigin, vr::VREvent_t* pEvent, uint32_t uncbVREvent, vr::TrackedDevicePose_t* pTrackedDevicePose) { return fntable_System_017_instance->PollNextEventWithPose(eOrigin, pEvent, uncbVREvent, pTrackedDevicePose); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_System_017_impl_GetEventTypeNameFromEnum(vr::EVREventType eType) { return fntable_System_017_instance->GetEventTypeNameFromEnum(eType); }
static vr::HiddenAreaMesh_t OPENVR_FNTABLE_CALLTYPE fntable_System_017_impl_GetHiddenAreaMesh(vr::EVREye eEye, vr::EHiddenAreaMeshType type) { return fntable_System_017_instance->GetHiddenAreaMesh(eEye, type); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_017_impl_GetControllerState(vr::TrackedDeviceIndex_t unControllerDeviceIndex, vr::VRControllerState_t* pControllerState, uint32_t unControllerStateSize) { return fntable_System_017_instance->GetControllerState(unControllerDeviceIndex, pControllerState, unControllerStateSize); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_017_impl_GetControllerStateWithPose(vr::ETrackingUniverseOrigin eOrigin, vr::TrackedDeviceIndex_t unControllerDeviceIndex, vr::VRControllerState_t* pControllerState, uint32_t unControllerStateSize, vr::TrackedDevicePose_t* pTrackedDevicePose) { return fntable_System_017_instance->GetControllerStateWithPose(eOrigin, unControllerDeviceIndex, pControllerState, unControllerStateSize, pTrackedDevicePose); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_017_impl_TriggerHapticPulse(vr::TrackedDeviceIndex_t unControllerDeviceIndex, uint32_t unAxisId, unsigned short usDurationMicroSec) { return fntable_System_017_instance->TriggerHapticPulse(unControllerDeviceIndex, unAxisId, usDurationMicroSec); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_System_017_impl_GetButtonIdNameFromEnum(vr::EVRButtonId eButtonId) { return fntable_System_017_instance->GetButtonIdNameFromEnum(eButtonId); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_System_017_impl_GetControllerAxisTypeNameFromEnum(vr::EVRControllerAxisType eAxisType) { return fntable_System_017_instance->GetControllerAxisTypeNameFromEnum(eAxisType); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_017_impl_CaptureInputFocus() { return fntable_System_017_instance->CaptureInputFocus(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_017_impl_ReleaseInputFocus() { return fntable_System_017_instance->ReleaseInputFocus(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_017_impl_IsInputFocusCapturedByAnotherProcess() { return fntable_System_017_instance->IsInputFocusCapturedByAnotherProcess(); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_System_017_impl_DriverDebugRequest(vr::TrackedDeviceIndex_t unDeviceIndex, const char* pchRequest, char* pchResponseBuffer, uint32_t unResponseBufferSize) { return fntable_System_017_instance->DriverDebugRequest(unDeviceIndex, pchRequest, pchResponseBuffer, unResponseBufferSize); }
static vr::EVRFirmwareError OPENVR_FNTABLE_CALLTYPE fntable_System_017_impl_PerformFirmwareUpdate(vr::TrackedDeviceIndex_t unDeviceIndex) { return fntable_System_017_instance->PerformFirmwareUpdate(unDeviceIndex); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_017_impl_AcknowledgeQuit_Exiting() { return fntable_System_017_instance->AcknowledgeQuit_Exiting(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_017_impl_AcknowledgeQuit_UserPrompt() { return fntable_System_017_instance->AcknowledgeQuit_UserPrompt(); }
static void *fntable_System_017_funcs[] = {
	(void*) fntable_System_017_impl_GetRecommendedRenderTargetSize,
	(void*) fntable_System_017_impl_GetProjectionMatrix,
	(void*) fntable_System_017_impl_GetProjectionRaw,
	(void*) fntable_System_017_impl_ComputeDistortion,
	(void*) fntable_System_017_impl_GetEyeToHeadTransform,
	(void*) fntable_System_017_impl_GetTimeSinceLastVsync,
	(void*) fntable_System_017_impl_GetD3D9AdapterIndex,
	(void*) fntable_System_017_impl_GetDXGIOutputInfo,
	(void*) fntable_System_017_impl_GetOutputDevice,
	(void*) fntable_System_017_impl_IsDisplayOnDesktop,
	(void*) fntable_System_017_impl_SetDisplayVisibility,
	(void*) fntable_System_017_impl_GetDeviceToAbsoluteTrackingPose,
	(void*) fntable_System_017_impl_ResetSeatedZeroPose,
	(void*) fntable_System_017_impl_GetSeatedZeroPoseToStandingAbsoluteTrackingPose,
	(void*) fntable_System_017_impl_GetRawZeroPoseToStandingAbsoluteTrackingPose,
	(void*) fntable_System_017_impl_GetSortedTrackedDeviceIndicesOfClass,
	(void*) fntable_System_017_impl_GetTrackedDeviceActivityLevel,
	(void*) fntable_System_017_impl_ApplyTransform,
	(void*) fntable_System_017_impl_GetTrackedDeviceIndexForControllerRole,
	(void*) fntable_System_017_impl_GetControllerRoleForTrackedDeviceIndex,
	(void*) fntable_System_017_impl_GetTrackedDeviceClass,
	(void*) fntable_System_017_impl_IsTrackedDeviceConnected,
	(void*) fntable_System_017_impl_GetBoolTrackedDeviceProperty,
	(void*) fntable_System_017_impl_GetFloatTrackedDeviceProperty,
	(void*) fntable_System_017_impl_GetInt32TrackedDeviceProperty,
	(void*) fntable_System_017_impl_GetUint64TrackedDeviceProperty,
	(void*) fntable_System_017_impl_GetMatrix34TrackedDeviceProperty,
	(void*) fntable_System_017_impl_GetStringTrackedDeviceProperty,
	(void*) fntable_System_017_impl_GetPropErrorNameFromEnum,
	(void*) fntable_System_017_impl_PollNextEvent,
	(void*) fntable_System_017_impl_PollNextEventWithPose,
	(void*) fntable_System_017_impl_GetEventTypeNameFromEnum,
	(void*) fntable_System_017_impl_GetHiddenAreaMesh,
	(void*) fntable_System_017_impl_GetControllerState,
	(void*) fntable_System_017_impl_GetControllerStateWithPose,
	(void*) fntable_System_017_impl_TriggerHapticPulse,
	(void*) fntable_System_017_impl_GetButtonIdNameFromEnum,
	(void*) fntable_System_017_impl_GetControllerAxisTypeNameFromEnum,
	(void*) fntable_System_017_impl_CaptureInputFocus,
	(void*) fntable_System_017_impl_ReleaseInputFocus,
	(void*) fntable_System_017_impl_IsInputFocusCapturedByAnotherProcess,
	(void*) fntable_System_017_impl_DriverDebugRequest,
	(void*) fntable_System_017_impl_PerformFirmwareUpdate,
	(void*) fntable_System_017_impl_AcknowledgeQuit_Exiting,
	(void*) fntable_System_017_impl_AcknowledgeQuit_UserPrompt,
};
void** CVRSystem_017::_GetStatFuncList() { fntable_System_017_instance = this; return fntable_System_017_funcs; }
void CVRSystem_017::Delete() { delete this; }
// Misc for CVRSystem_019:
CVRSystem_019::CVRSystem_019() : base(GetCreateBaseSystem()) {}
// Interface methods for CVRSystem_019:
void CVRSystem_019::GetRecommendedRenderTargetSize(uint32_t* pnWidth, uint32_t* pnHeight) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_019)");
	return base->GetRecommendedRenderTargetSize(pnWidth, pnHeight);
}
vr::HmdMatrix44_t CVRSystem_019::GetProjectionMatrix(vr::EVREye eEye, float fNearZ, float fFarZ) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_019)");
	return base->GetProjectionMatrix(eEye, fNearZ, fFarZ);
}
void CVRSystem_019::GetProjectionRaw(vr::EVREye eEye, float* pfLeft, float* pfRight, float* pfTop, float* pfBottom) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_019)");
	return base->GetProjectionRaw(eEye, pfLeft, pfRight, pfTop, pfBottom);
}
bool CVRSystem_019::ComputeDistortion(vr::EVREye eEye, float fU, float fV, vr::DistortionCoordinates_t* pDistortionCoordinates) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_019)");
	return base->ComputeDistortion(eEye, fU, fV, pDistortionCoordinates);
}
vr::HmdMatrix34_t CVRSystem_019::GetEyeToHeadTransform(vr::EVREye eEye) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_019)");
	return base->GetEyeToHeadTransform(eEye);
}
bool CVRSystem_019::GetTimeSinceLastVsync(float* pfSecondsSinceLastVsync, uint64_t* pulFrameCounter) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_019)");
	return base->GetTimeSinceLastVsync(pfSecondsSinceLastVsync, pulFrameCounter);
}
int32_t CVRSystem_019::GetD3D9AdapterIndex() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_019)");
	return base->GetD3D9AdapterIndex();
}
void CVRSystem_019::GetDXGIOutputInfo(int32_t* pnAdapterIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_019)");
	return base->GetDXGIOutputInfo(pnAdapterIndex);
}
void CVRSystem_019::GetOutputDevice(uint64_t* pnDevice, vr::ETextureType textureType, VkInstance_T* pInstance) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_019)");
	return base->GetOutputDevice(pnDevice, textureType, pInstance);
}
bool CVRSystem_019::IsDisplayOnDesktop() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_019)");
	return base->IsDisplayOnDesktop();
}
bool CVRSystem_019::SetDisplayVisibility(bool bIsVisibleOnDesktop) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_019)");
	return base->SetDisplayVisibility(bIsVisibleOnDesktop);
}
void CVRSystem_019::GetDeviceToAbsoluteTrackingPose(vr::ETrackingUniverseOrigin eOrigin, float fPredictedSecondsToPhotonsFromNow, vr::TrackedDevicePose_t* pTrackedDevicePoseArray, uint32_t unTrackedDevicePoseArrayCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_019)");
	return base->GetDeviceToAbsoluteTrackingPose(eOrigin, fPredictedSecondsToPhotonsFromNow, pTrackedDevicePoseArray, unTrackedDevicePoseArrayCount);
}
void CVRSystem_019::ResetSeatedZeroPose() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_019)");
	return base->ResetSeatedZeroPose();
}
vr::HmdMatrix34_t CVRSystem_019::GetSeatedZeroPoseToStandingAbsoluteTrackingPose() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_019)");
	return base->GetSeatedZeroPoseToStandingAbsoluteTrackingPose();
}
vr::HmdMatrix34_t CVRSystem_019::GetRawZeroPoseToStandingAbsoluteTrackingPose() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_019)");
	return base->GetRawZeroPoseToStandingAbsoluteTrackingPose();
}
uint32_t CVRSystem_019::GetSortedTrackedDeviceIndicesOfClass(vr::ETrackedDeviceClass eTrackedDeviceClass, vr::TrackedDeviceIndex_t* punTrackedDeviceIndexArray, uint32_t unTrackedDeviceIndexArrayCount, vr::TrackedDeviceIndex_t unRelativeToTrackedDeviceIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_019)");
	return base->GetSortedTrackedDeviceIndicesOfClass(eTrackedDeviceClass, punTrackedDeviceIndexArray, unTrackedDeviceIndexArrayCount, unRelativeToTrackedDeviceIndex);
}
vr::EDeviceActivityLevel CVRSystem_019::GetTrackedDeviceActivityLevel(vr::TrackedDeviceIndex_t unDeviceId) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_019)");
	return base->GetTrackedDeviceActivityLevel(unDeviceId);
}
void CVRSystem_019::ApplyTransform(vr::TrackedDevicePose_t* pOutputPose, const vr::TrackedDevicePose_t* pTrackedDevicePose, const vr::HmdMatrix34_t* pTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_019)");
	return base->ApplyTransform(pOutputPose, pTrackedDevicePose, pTransform);
}
vr::TrackedDeviceIndex_t CVRSystem_019::GetTrackedDeviceIndexForControllerRole(vr::ETrackedControllerRole unDeviceType) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_019)");
	return base->GetTrackedDeviceIndexForControllerRole(unDeviceType);
}
vr::ETrackedControllerRole CVRSystem_019::GetControllerRoleForTrackedDeviceIndex(vr::TrackedDeviceIndex_t unDeviceIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_019)");
	return base->GetControllerRoleForTrackedDeviceIndex(unDeviceIndex);
}
vr::ETrackedDeviceClass CVRSystem_019::GetTrackedDeviceClass(vr::TrackedDeviceIndex_t unDeviceIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_019)");
	return base->GetTrackedDeviceClass(unDeviceIndex);
}
bool CVRSystem_019::IsTrackedDeviceConnected(vr::TrackedDeviceIndex_t unDeviceIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_019)");
	return base->IsTrackedDeviceConnected(unDeviceIndex);
}
bool CVRSystem_019::GetBoolTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_019)");
	return base->GetBoolTrackedDeviceProperty(unDeviceIndex, prop, pError);
}
float CVRSystem_019::GetFloatTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_019)");
	return base->GetFloatTrackedDeviceProperty(unDeviceIndex, prop, pError);
}
int32_t CVRSystem_019::GetInt32TrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_019)");
	return base->GetInt32TrackedDeviceProperty(unDeviceIndex, prop, pError);
}
uint64_t CVRSystem_019::GetUint64TrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_019)");
	return base->GetUint64TrackedDeviceProperty(unDeviceIndex, prop, pError);
}
vr::HmdMatrix34_t CVRSystem_019::GetMatrix34TrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_019)");
	return base->GetMatrix34TrackedDeviceProperty(unDeviceIndex, prop, pError);
}
uint32_t CVRSystem_019::GetArrayTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::PropertyTypeTag_t propType, void* pBuffer, uint32_t unBufferSize, vr::ETrackedPropertyError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_019)");
	return base->GetArrayTrackedDeviceProperty(unDeviceIndex, prop, propType, pBuffer, unBufferSize, pError);
}
uint32_t CVRSystem_019::GetStringTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, char* pchValue, uint32_t unBufferSize, vr::ETrackedPropertyError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_019)");
	return base->GetStringTrackedDeviceProperty(unDeviceIndex, prop, pchValue, unBufferSize, pError);
}
const char* CVRSystem_019::GetPropErrorNameFromEnum(vr::ETrackedPropertyError error) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_019)");
	return base->GetPropErrorNameFromEnum(error);
}
bool CVRSystem_019::PollNextEvent(vr::VREvent_t* pEvent, uint32_t uncbVREvent) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_019)");
	return base->PollNextEvent(pEvent, uncbVREvent);
}
bool CVRSystem_019::PollNextEventWithPose(vr::ETrackingUniverseOrigin eOrigin, vr::VREvent_t* pEvent, uint32_t uncbVREvent, vr::TrackedDevicePose_t* pTrackedDevicePose) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_019)");
	return base->PollNextEventWithPose(eOrigin, pEvent, uncbVREvent, pTrackedDevicePose);
}
const char* CVRSystem_019::GetEventTypeNameFromEnum(vr::EVREventType eType) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_019)");
	return base->GetEventTypeNameFromEnum(eType);
}
vr::HiddenAreaMesh_t CVRSystem_019::GetHiddenAreaMesh(vr::EVREye eEye, vr::EHiddenAreaMeshType type) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_019)");
	return base->GetHiddenAreaMesh(eEye, type);
}
bool CVRSystem_019::GetControllerState(vr::TrackedDeviceIndex_t unControllerDeviceIndex, vr::VRControllerState_t* pControllerState, uint32_t unControllerStateSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_019)");
	return base->GetControllerState(unControllerDeviceIndex, pControllerState, unControllerStateSize);
}
bool CVRSystem_019::GetControllerStateWithPose(vr::ETrackingUniverseOrigin eOrigin, vr::TrackedDeviceIndex_t unControllerDeviceIndex, vr::VRControllerState_t* pControllerState, uint32_t unControllerStateSize, vr::TrackedDevicePose_t* pTrackedDevicePose) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_019)");
	return base->GetControllerStateWithPose(eOrigin, unControllerDeviceIndex, pControllerState, unControllerStateSize, pTrackedDevicePose);
}
void CVRSystem_019::TriggerHapticPulse(vr::TrackedDeviceIndex_t unControllerDeviceIndex, uint32_t unAxisId, unsigned short usDurationMicroSec) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_019)");
	return base->TriggerHapticPulse(unControllerDeviceIndex, unAxisId, usDurationMicroSec);
}
const char* CVRSystem_019::GetButtonIdNameFromEnum(vr::EVRButtonId eButtonId) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_019)");
	return base->GetButtonIdNameFromEnum(eButtonId);
}
const char* CVRSystem_019::GetControllerAxisTypeNameFromEnum(vr::EVRControllerAxisType eAxisType) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_019)");
	return base->GetControllerAxisTypeNameFromEnum(eAxisType);
}
bool CVRSystem_019::IsInputAvailable() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_019)");
	return base->IsInputAvailable();
}
bool CVRSystem_019::IsSteamVRDrawingControllers() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_019)");
	return base->IsSteamVRDrawingControllers();
}
bool CVRSystem_019::ShouldApplicationPause() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_019)");
	return base->ShouldApplicationPause();
}
bool CVRSystem_019::ShouldApplicationReduceRenderingWork() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_019)");
	return base->ShouldApplicationReduceRenderingWork();
}
uint32_t CVRSystem_019::DriverDebugRequest(vr::TrackedDeviceIndex_t unDeviceIndex, const char* pchRequest, char* pchResponseBuffer, uint32_t unResponseBufferSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_019)");
	return base->DriverDebugRequest(unDeviceIndex, pchRequest, pchResponseBuffer, unResponseBufferSize);
}
vr::EVRFirmwareError CVRSystem_019::PerformFirmwareUpdate(vr::TrackedDeviceIndex_t unDeviceIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_019)");
	return base->PerformFirmwareUpdate(unDeviceIndex);
}
void CVRSystem_019::AcknowledgeQuit_Exiting() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_019)");
	return base->AcknowledgeQuit_Exiting();
}
void CVRSystem_019::AcknowledgeQuit_UserPrompt() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_019)");
	return base->AcknowledgeQuit_UserPrompt();
}
// FnTable for CVRSystem_019:
static CVRSystem_019 *fntable_System_019_instance = NULL;
static void OPENVR_FNTABLE_CALLTYPE fntable_System_019_impl_GetRecommendedRenderTargetSize(uint32_t* pnWidth, uint32_t* pnHeight) { return fntable_System_019_instance->GetRecommendedRenderTargetSize(pnWidth, pnHeight); }
static vr::HmdMatrix44_t OPENVR_FNTABLE_CALLTYPE fntable_System_019_impl_GetProjectionMatrix(vr::EVREye eEye, float fNearZ, float fFarZ) { return fntable_System_019_instance->GetProjectionMatrix(eEye, fNearZ, fFarZ); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_019_impl_GetProjectionRaw(vr::EVREye eEye, float* pfLeft, float* pfRight, float* pfTop, float* pfBottom) { return fntable_System_019_instance->GetProjectionRaw(eEye, pfLeft, pfRight, pfTop, pfBottom); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_019_impl_ComputeDistortion(vr::EVREye eEye, float fU, float fV, vr::DistortionCoordinates_t* pDistortionCoordinates) { return fntable_System_019_instance->ComputeDistortion(eEye, fU, fV, pDistortionCoordinates); }
static vr::HmdMatrix34_t OPENVR_FNTABLE_CALLTYPE fntable_System_019_impl_GetEyeToHeadTransform(vr::EVREye eEye) { return fntable_System_019_instance->GetEyeToHeadTransform(eEye); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_019_impl_GetTimeSinceLastVsync(float* pfSecondsSinceLastVsync, uint64_t* pulFrameCounter) { return fntable_System_019_instance->GetTimeSinceLastVsync(pfSecondsSinceLastVsync, pulFrameCounter); }
static int32_t OPENVR_FNTABLE_CALLTYPE fntable_System_019_impl_GetD3D9AdapterIndex() { return fntable_System_019_instance->GetD3D9AdapterIndex(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_019_impl_GetDXGIOutputInfo(int32_t* pnAdapterIndex) { return fntable_System_019_instance->GetDXGIOutputInfo(pnAdapterIndex); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_019_impl_GetOutputDevice(uint64_t* pnDevice, vr::ETextureType textureType, VkInstance_T* pInstance) { return fntable_System_019_instance->GetOutputDevice(pnDevice, textureType, pInstance); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_019_impl_IsDisplayOnDesktop() { return fntable_System_019_instance->IsDisplayOnDesktop(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_019_impl_SetDisplayVisibility(bool bIsVisibleOnDesktop) { return fntable_System_019_instance->SetDisplayVisibility(bIsVisibleOnDesktop); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_019_impl_GetDeviceToAbsoluteTrackingPose(vr::ETrackingUniverseOrigin eOrigin, float fPredictedSecondsToPhotonsFromNow, vr::TrackedDevicePose_t* pTrackedDevicePoseArray, uint32_t unTrackedDevicePoseArrayCount) { return fntable_System_019_instance->GetDeviceToAbsoluteTrackingPose(eOrigin, fPredictedSecondsToPhotonsFromNow, pTrackedDevicePoseArray, unTrackedDevicePoseArrayCount); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_019_impl_ResetSeatedZeroPose() { return fntable_System_019_instance->ResetSeatedZeroPose(); }
static vr::HmdMatrix34_t OPENVR_FNTABLE_CALLTYPE fntable_System_019_impl_GetSeatedZeroPoseToStandingAbsoluteTrackingPose() { return fntable_System_019_instance->GetSeatedZeroPoseToStandingAbsoluteTrackingPose(); }
static vr::HmdMatrix34_t OPENVR_FNTABLE_CALLTYPE fntable_System_019_impl_GetRawZeroPoseToStandingAbsoluteTrackingPose() { return fntable_System_019_instance->GetRawZeroPoseToStandingAbsoluteTrackingPose(); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_System_019_impl_GetSortedTrackedDeviceIndicesOfClass(vr::ETrackedDeviceClass eTrackedDeviceClass, vr::TrackedDeviceIndex_t* punTrackedDeviceIndexArray, uint32_t unTrackedDeviceIndexArrayCount, vr::TrackedDeviceIndex_t unRelativeToTrackedDeviceIndex) { return fntable_System_019_instance->GetSortedTrackedDeviceIndicesOfClass(eTrackedDeviceClass, punTrackedDeviceIndexArray, unTrackedDeviceIndexArrayCount, unRelativeToTrackedDeviceIndex); }
static vr::EDeviceActivityLevel OPENVR_FNTABLE_CALLTYPE fntable_System_019_impl_GetTrackedDeviceActivityLevel(vr::TrackedDeviceIndex_t unDeviceId) { return fntable_System_019_instance->GetTrackedDeviceActivityLevel(unDeviceId); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_019_impl_ApplyTransform(vr::TrackedDevicePose_t* pOutputPose, const vr::TrackedDevicePose_t* pTrackedDevicePose, const vr::HmdMatrix34_t* pTransform) { return fntable_System_019_instance->ApplyTransform(pOutputPose, pTrackedDevicePose, pTransform); }
static vr::TrackedDeviceIndex_t OPENVR_FNTABLE_CALLTYPE fntable_System_019_impl_GetTrackedDeviceIndexForControllerRole(vr::ETrackedControllerRole unDeviceType) { return fntable_System_019_instance->GetTrackedDeviceIndexForControllerRole(unDeviceType); }
static vr::ETrackedControllerRole OPENVR_FNTABLE_CALLTYPE fntable_System_019_impl_GetControllerRoleForTrackedDeviceIndex(vr::TrackedDeviceIndex_t unDeviceIndex) { return fntable_System_019_instance->GetControllerRoleForTrackedDeviceIndex(unDeviceIndex); }
static vr::ETrackedDeviceClass OPENVR_FNTABLE_CALLTYPE fntable_System_019_impl_GetTrackedDeviceClass(vr::TrackedDeviceIndex_t unDeviceIndex) { return fntable_System_019_instance->GetTrackedDeviceClass(unDeviceIndex); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_019_impl_IsTrackedDeviceConnected(vr::TrackedDeviceIndex_t unDeviceIndex) { return fntable_System_019_instance->IsTrackedDeviceConnected(unDeviceIndex); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_019_impl_GetBoolTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) { return fntable_System_019_instance->GetBoolTrackedDeviceProperty(unDeviceIndex, prop, pError); }
static float OPENVR_FNTABLE_CALLTYPE fntable_System_019_impl_GetFloatTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) { return fntable_System_019_instance->GetFloatTrackedDeviceProperty(unDeviceIndex, prop, pError); }
static int32_t OPENVR_FNTABLE_CALLTYPE fntable_System_019_impl_GetInt32TrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) { return fntable_System_019_instance->GetInt32TrackedDeviceProperty(unDeviceIndex, prop, pError); }
static uint64_t OPENVR_FNTABLE_CALLTYPE fntable_System_019_impl_GetUint64TrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) { return fntable_System_019_instance->GetUint64TrackedDeviceProperty(unDeviceIndex, prop, pError); }
static vr::HmdMatrix34_t OPENVR_FNTABLE_CALLTYPE fntable_System_019_impl_GetMatrix34TrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) { return fntable_System_019_instance->GetMatrix34TrackedDeviceProperty(unDeviceIndex, prop, pError); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_System_019_impl_GetArrayTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::PropertyTypeTag_t propType, void* pBuffer, uint32_t unBufferSize, vr::ETrackedPropertyError* pError) { return fntable_System_019_instance->GetArrayTrackedDeviceProperty(unDeviceIndex, prop, propType, pBuffer, unBufferSize, pError); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_System_019_impl_GetStringTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, char* pchValue, uint32_t unBufferSize, vr::ETrackedPropertyError* pError) { return fntable_System_019_instance->GetStringTrackedDeviceProperty(unDeviceIndex, prop, pchValue, unBufferSize, pError); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_System_019_impl_GetPropErrorNameFromEnum(vr::ETrackedPropertyError error) { return fntable_System_019_instance->GetPropErrorNameFromEnum(error); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_019_impl_PollNextEvent(vr::VREvent_t* pEvent, uint32_t uncbVREvent) { return fntable_System_019_instance->PollNextEvent(pEvent, uncbVREvent); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_019_impl_PollNextEventWithPose(vr::ETrackingUniverseOrigin eOrigin, vr::VREvent_t* pEvent, uint32_t uncbVREvent, vr::TrackedDevicePose_t* pTrackedDevicePose) { return fntable_System_019_instance->PollNextEventWithPose(eOrigin, pEvent, uncbVREvent, pTrackedDevicePose); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_System_019_impl_GetEventTypeNameFromEnum(vr::EVREventType eType) { return fntable_System_019_instance->GetEventTypeNameFromEnum(eType); }
static vr::HiddenAreaMesh_t OPENVR_FNTABLE_CALLTYPE fntable_System_019_impl_GetHiddenAreaMesh(vr::EVREye eEye, vr::EHiddenAreaMeshType type) { return fntable_System_019_instance->GetHiddenAreaMesh(eEye, type); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_019_impl_GetControllerState(vr::TrackedDeviceIndex_t unControllerDeviceIndex, vr::VRControllerState_t* pControllerState, uint32_t unControllerStateSize) { return fntable_System_019_instance->GetControllerState(unControllerDeviceIndex, pControllerState, unControllerStateSize); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_019_impl_GetControllerStateWithPose(vr::ETrackingUniverseOrigin eOrigin, vr::TrackedDeviceIndex_t unControllerDeviceIndex, vr::VRControllerState_t* pControllerState, uint32_t unControllerStateSize, vr::TrackedDevicePose_t* pTrackedDevicePose) { return fntable_System_019_instance->GetControllerStateWithPose(eOrigin, unControllerDeviceIndex, pControllerState, unControllerStateSize, pTrackedDevicePose); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_019_impl_TriggerHapticPulse(vr::TrackedDeviceIndex_t unControllerDeviceIndex, uint32_t unAxisId, unsigned short usDurationMicroSec) { return fntable_System_019_instance->TriggerHapticPulse(unControllerDeviceIndex, unAxisId, usDurationMicroSec); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_System_019_impl_GetButtonIdNameFromEnum(vr::EVRButtonId eButtonId) { return fntable_System_019_instance->GetButtonIdNameFromEnum(eButtonId); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_System_019_impl_GetControllerAxisTypeNameFromEnum(vr::EVRControllerAxisType eAxisType) { return fntable_System_019_instance->GetControllerAxisTypeNameFromEnum(eAxisType); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_019_impl_IsInputAvailable() { return fntable_System_019_instance->IsInputAvailable(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_019_impl_IsSteamVRDrawingControllers() { return fntable_System_019_instance->IsSteamVRDrawingControllers(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_019_impl_ShouldApplicationPause() { return fntable_System_019_instance->ShouldApplicationPause(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_019_impl_ShouldApplicationReduceRenderingWork() { return fntable_System_019_instance->ShouldApplicationReduceRenderingWork(); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_System_019_impl_DriverDebugRequest(vr::TrackedDeviceIndex_t unDeviceIndex, const char* pchRequest, char* pchResponseBuffer, uint32_t unResponseBufferSize) { return fntable_System_019_instance->DriverDebugRequest(unDeviceIndex, pchRequest, pchResponseBuffer, unResponseBufferSize); }
static vr::EVRFirmwareError OPENVR_FNTABLE_CALLTYPE fntable_System_019_impl_PerformFirmwareUpdate(vr::TrackedDeviceIndex_t unDeviceIndex) { return fntable_System_019_instance->PerformFirmwareUpdate(unDeviceIndex); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_019_impl_AcknowledgeQuit_Exiting() { return fntable_System_019_instance->AcknowledgeQuit_Exiting(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_019_impl_AcknowledgeQuit_UserPrompt() { return fntable_System_019_instance->AcknowledgeQuit_UserPrompt(); }
static void *fntable_System_019_funcs[] = {
	(void*) fntable_System_019_impl_GetRecommendedRenderTargetSize,
	(void*) fntable_System_019_impl_GetProjectionMatrix,
	(void*) fntable_System_019_impl_GetProjectionRaw,
	(void*) fntable_System_019_impl_ComputeDistortion,
	(void*) fntable_System_019_impl_GetEyeToHeadTransform,
	(void*) fntable_System_019_impl_GetTimeSinceLastVsync,
	(void*) fntable_System_019_impl_GetD3D9AdapterIndex,
	(void*) fntable_System_019_impl_GetDXGIOutputInfo,
	(void*) fntable_System_019_impl_GetOutputDevice,
	(void*) fntable_System_019_impl_IsDisplayOnDesktop,
	(void*) fntable_System_019_impl_SetDisplayVisibility,
	(void*) fntable_System_019_impl_GetDeviceToAbsoluteTrackingPose,
	(void*) fntable_System_019_impl_ResetSeatedZeroPose,
	(void*) fntable_System_019_impl_GetSeatedZeroPoseToStandingAbsoluteTrackingPose,
	(void*) fntable_System_019_impl_GetRawZeroPoseToStandingAbsoluteTrackingPose,
	(void*) fntable_System_019_impl_GetSortedTrackedDeviceIndicesOfClass,
	(void*) fntable_System_019_impl_GetTrackedDeviceActivityLevel,
	(void*) fntable_System_019_impl_ApplyTransform,
	(void*) fntable_System_019_impl_GetTrackedDeviceIndexForControllerRole,
	(void*) fntable_System_019_impl_GetControllerRoleForTrackedDeviceIndex,
	(void*) fntable_System_019_impl_GetTrackedDeviceClass,
	(void*) fntable_System_019_impl_IsTrackedDeviceConnected,
	(void*) fntable_System_019_impl_GetBoolTrackedDeviceProperty,
	(void*) fntable_System_019_impl_GetFloatTrackedDeviceProperty,
	(void*) fntable_System_019_impl_GetInt32TrackedDeviceProperty,
	(void*) fntable_System_019_impl_GetUint64TrackedDeviceProperty,
	(void*) fntable_System_019_impl_GetMatrix34TrackedDeviceProperty,
	(void*) fntable_System_019_impl_GetArrayTrackedDeviceProperty,
	(void*) fntable_System_019_impl_GetStringTrackedDeviceProperty,
	(void*) fntable_System_019_impl_GetPropErrorNameFromEnum,
	(void*) fntable_System_019_impl_PollNextEvent,
	(void*) fntable_System_019_impl_PollNextEventWithPose,
	(void*) fntable_System_019_impl_GetEventTypeNameFromEnum,
	(void*) fntable_System_019_impl_GetHiddenAreaMesh,
	(void*) fntable_System_019_impl_GetControllerState,
	(void*) fntable_System_019_impl_GetControllerStateWithPose,
	(void*) fntable_System_019_impl_TriggerHapticPulse,
	(void*) fntable_System_019_impl_GetButtonIdNameFromEnum,
	(void*) fntable_System_019_impl_GetControllerAxisTypeNameFromEnum,
	(void*) fntable_System_019_impl_IsInputAvailable,
	(void*) fntable_System_019_impl_IsSteamVRDrawingControllers,
	(void*) fntable_System_019_impl_ShouldApplicationPause,
	(void*) fntable_System_019_impl_ShouldApplicationReduceRenderingWork,
	(void*) fntable_System_019_impl_DriverDebugRequest,
	(void*) fntable_System_019_impl_PerformFirmwareUpdate,
	(void*) fntable_System_019_impl_AcknowledgeQuit_Exiting,
	(void*) fntable_System_019_impl_AcknowledgeQuit_UserPrompt,
};
void** CVRSystem_019::_GetStatFuncList() { fntable_System_019_instance = this; return fntable_System_019_funcs; }
void CVRSystem_019::Delete() { delete this; }
// Misc for CVRSystem_020:
CVRSystem_020::CVRSystem_020() : base(GetCreateBaseSystem()) {}
// Interface methods for CVRSystem_020:
void CVRSystem_020::GetRecommendedRenderTargetSize(uint32_t* pnWidth, uint32_t* pnHeight) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_020)");
	return base->GetRecommendedRenderTargetSize(pnWidth, pnHeight);
}
vr::HmdMatrix44_t CVRSystem_020::GetProjectionMatrix(vr::EVREye eEye, float fNearZ, float fFarZ) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_020)");
	return base->GetProjectionMatrix(eEye, fNearZ, fFarZ);
}
void CVRSystem_020::GetProjectionRaw(vr::EVREye eEye, float* pfLeft, float* pfRight, float* pfTop, float* pfBottom) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_020)");
	return base->GetProjectionRaw(eEye, pfLeft, pfRight, pfTop, pfBottom);
}
bool CVRSystem_020::ComputeDistortion(vr::EVREye eEye, float fU, float fV, vr::DistortionCoordinates_t* pDistortionCoordinates) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_020)");
	return base->ComputeDistortion(eEye, fU, fV, pDistortionCoordinates);
}
vr::HmdMatrix34_t CVRSystem_020::GetEyeToHeadTransform(vr::EVREye eEye) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_020)");
	return base->GetEyeToHeadTransform(eEye);
}
bool CVRSystem_020::GetTimeSinceLastVsync(float* pfSecondsSinceLastVsync, uint64_t* pulFrameCounter) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_020)");
	return base->GetTimeSinceLastVsync(pfSecondsSinceLastVsync, pulFrameCounter);
}
int32_t CVRSystem_020::GetD3D9AdapterIndex() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_020)");
	return base->GetD3D9AdapterIndex();
}
void CVRSystem_020::GetDXGIOutputInfo(int32_t* pnAdapterIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_020)");
	return base->GetDXGIOutputInfo(pnAdapterIndex);
}
void CVRSystem_020::GetOutputDevice(uint64_t* pnDevice, vr::ETextureType textureType, VkInstance_T* pInstance) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_020)");
	return base->GetOutputDevice(pnDevice, textureType, pInstance);
}
bool CVRSystem_020::IsDisplayOnDesktop() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_020)");
	return base->IsDisplayOnDesktop();
}
bool CVRSystem_020::SetDisplayVisibility(bool bIsVisibleOnDesktop) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_020)");
	return base->SetDisplayVisibility(bIsVisibleOnDesktop);
}
void CVRSystem_020::GetDeviceToAbsoluteTrackingPose(vr::ETrackingUniverseOrigin eOrigin, float fPredictedSecondsToPhotonsFromNow, vr::TrackedDevicePose_t* pTrackedDevicePoseArray, uint32_t unTrackedDevicePoseArrayCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_020)");
	return base->GetDeviceToAbsoluteTrackingPose(eOrigin, fPredictedSecondsToPhotonsFromNow, pTrackedDevicePoseArray, unTrackedDevicePoseArrayCount);
}
void CVRSystem_020::ResetSeatedZeroPose() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_020)");
	return base->ResetSeatedZeroPose();
}
vr::HmdMatrix34_t CVRSystem_020::GetSeatedZeroPoseToStandingAbsoluteTrackingPose() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_020)");
	return base->GetSeatedZeroPoseToStandingAbsoluteTrackingPose();
}
vr::HmdMatrix34_t CVRSystem_020::GetRawZeroPoseToStandingAbsoluteTrackingPose() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_020)");
	return base->GetRawZeroPoseToStandingAbsoluteTrackingPose();
}
uint32_t CVRSystem_020::GetSortedTrackedDeviceIndicesOfClass(vr::ETrackedDeviceClass eTrackedDeviceClass, vr::TrackedDeviceIndex_t* punTrackedDeviceIndexArray, uint32_t unTrackedDeviceIndexArrayCount, vr::TrackedDeviceIndex_t unRelativeToTrackedDeviceIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_020)");
	return base->GetSortedTrackedDeviceIndicesOfClass(eTrackedDeviceClass, punTrackedDeviceIndexArray, unTrackedDeviceIndexArrayCount, unRelativeToTrackedDeviceIndex);
}
vr::EDeviceActivityLevel CVRSystem_020::GetTrackedDeviceActivityLevel(vr::TrackedDeviceIndex_t unDeviceId) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_020)");
	return base->GetTrackedDeviceActivityLevel(unDeviceId);
}
void CVRSystem_020::ApplyTransform(vr::TrackedDevicePose_t* pOutputPose, const vr::TrackedDevicePose_t* pTrackedDevicePose, const vr::HmdMatrix34_t* pTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_020)");
	return base->ApplyTransform(pOutputPose, pTrackedDevicePose, pTransform);
}
vr::TrackedDeviceIndex_t CVRSystem_020::GetTrackedDeviceIndexForControllerRole(vr::ETrackedControllerRole unDeviceType) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_020)");
	return base->GetTrackedDeviceIndexForControllerRole(unDeviceType);
}
vr::ETrackedControllerRole CVRSystem_020::GetControllerRoleForTrackedDeviceIndex(vr::TrackedDeviceIndex_t unDeviceIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_020)");
	return base->GetControllerRoleForTrackedDeviceIndex(unDeviceIndex);
}
vr::ETrackedDeviceClass CVRSystem_020::GetTrackedDeviceClass(vr::TrackedDeviceIndex_t unDeviceIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_020)");
	return base->GetTrackedDeviceClass(unDeviceIndex);
}
bool CVRSystem_020::IsTrackedDeviceConnected(vr::TrackedDeviceIndex_t unDeviceIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_020)");
	return base->IsTrackedDeviceConnected(unDeviceIndex);
}
bool CVRSystem_020::GetBoolTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_020)");
	return base->GetBoolTrackedDeviceProperty(unDeviceIndex, prop, pError);
}
float CVRSystem_020::GetFloatTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_020)");
	return base->GetFloatTrackedDeviceProperty(unDeviceIndex, prop, pError);
}
int32_t CVRSystem_020::GetInt32TrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_020)");
	return base->GetInt32TrackedDeviceProperty(unDeviceIndex, prop, pError);
}
uint64_t CVRSystem_020::GetUint64TrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_020)");
	return base->GetUint64TrackedDeviceProperty(unDeviceIndex, prop, pError);
}
vr::HmdMatrix34_t CVRSystem_020::GetMatrix34TrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_020)");
	return base->GetMatrix34TrackedDeviceProperty(unDeviceIndex, prop, pError);
}
uint32_t CVRSystem_020::GetArrayTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::PropertyTypeTag_t propType, void* pBuffer, uint32_t unBufferSize, vr::ETrackedPropertyError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_020)");
	return base->GetArrayTrackedDeviceProperty(unDeviceIndex, prop, propType, pBuffer, unBufferSize, pError);
}
uint32_t CVRSystem_020::GetStringTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, char* pchValue, uint32_t unBufferSize, vr::ETrackedPropertyError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_020)");
	return base->GetStringTrackedDeviceProperty(unDeviceIndex, prop, pchValue, unBufferSize, pError);
}
const char* CVRSystem_020::GetPropErrorNameFromEnum(vr::ETrackedPropertyError error) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_020)");
	return base->GetPropErrorNameFromEnum(error);
}
bool CVRSystem_020::PollNextEvent(vr::VREvent_t* pEvent, uint32_t uncbVREvent) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_020)");
	return base->PollNextEvent(pEvent, uncbVREvent);
}
bool CVRSystem_020::PollNextEventWithPose(vr::ETrackingUniverseOrigin eOrigin, vr::VREvent_t* pEvent, uint32_t uncbVREvent, vr::TrackedDevicePose_t* pTrackedDevicePose) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_020)");
	return base->PollNextEventWithPose(eOrigin, pEvent, uncbVREvent, pTrackedDevicePose);
}
const char* CVRSystem_020::GetEventTypeNameFromEnum(vr::EVREventType eType) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_020)");
	return base->GetEventTypeNameFromEnum(eType);
}
vr::HiddenAreaMesh_t CVRSystem_020::GetHiddenAreaMesh(vr::EVREye eEye, vr::EHiddenAreaMeshType type) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_020)");
	return base->GetHiddenAreaMesh(eEye, type);
}
bool CVRSystem_020::GetControllerState(vr::TrackedDeviceIndex_t unControllerDeviceIndex, vr::VRControllerState_t* pControllerState, uint32_t unControllerStateSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_020)");
	return base->GetControllerState(unControllerDeviceIndex, pControllerState, unControllerStateSize);
}
bool CVRSystem_020::GetControllerStateWithPose(vr::ETrackingUniverseOrigin eOrigin, vr::TrackedDeviceIndex_t unControllerDeviceIndex, vr::VRControllerState_t* pControllerState, uint32_t unControllerStateSize, vr::TrackedDevicePose_t* pTrackedDevicePose) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_020)");
	return base->GetControllerStateWithPose(eOrigin, unControllerDeviceIndex, pControllerState, unControllerStateSize, pTrackedDevicePose);
}
void CVRSystem_020::TriggerHapticPulse(vr::TrackedDeviceIndex_t unControllerDeviceIndex, uint32_t unAxisId, unsigned short usDurationMicroSec) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_020)");
	return base->TriggerHapticPulse(unControllerDeviceIndex, unAxisId, usDurationMicroSec);
}
const char* CVRSystem_020::GetButtonIdNameFromEnum(vr::EVRButtonId eButtonId) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_020)");
	return base->GetButtonIdNameFromEnum(eButtonId);
}
const char* CVRSystem_020::GetControllerAxisTypeNameFromEnum(vr::EVRControllerAxisType eAxisType) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_020)");
	return base->GetControllerAxisTypeNameFromEnum(eAxisType);
}
bool CVRSystem_020::IsInputAvailable() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_020)");
	return base->IsInputAvailable();
}
bool CVRSystem_020::IsSteamVRDrawingControllers() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_020)");
	return base->IsSteamVRDrawingControllers();
}
bool CVRSystem_020::ShouldApplicationPause() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_020)");
	return base->ShouldApplicationPause();
}
bool CVRSystem_020::ShouldApplicationReduceRenderingWork() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_020)");
	return base->ShouldApplicationReduceRenderingWork();
}
vr::EVRFirmwareError CVRSystem_020::PerformFirmwareUpdate(vr::TrackedDeviceIndex_t unDeviceIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_020)");
	return base->PerformFirmwareUpdate(unDeviceIndex);
}
void CVRSystem_020::AcknowledgeQuit_Exiting() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_020)");
	return base->AcknowledgeQuit_Exiting();
}
void CVRSystem_020::AcknowledgeQuit_UserPrompt() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_020)");
	return base->AcknowledgeQuit_UserPrompt();
}
uint32_t CVRSystem_020::GetAppContainerFilePaths(char* pchBuffer, uint32_t unBufferSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_020)");
	return base->GetAppContainerFilePaths(pchBuffer, unBufferSize);
}
const char* CVRSystem_020::GetRuntimeVersion() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_020)");
	return base->GetRuntimeVersion();
}
// FnTable for CVRSystem_020:
static CVRSystem_020 *fntable_System_020_instance = NULL;
static void OPENVR_FNTABLE_CALLTYPE fntable_System_020_impl_GetRecommendedRenderTargetSize(uint32_t* pnWidth, uint32_t* pnHeight) { return fntable_System_020_instance->GetRecommendedRenderTargetSize(pnWidth, pnHeight); }
static vr::HmdMatrix44_t OPENVR_FNTABLE_CALLTYPE fntable_System_020_impl_GetProjectionMatrix(vr::EVREye eEye, float fNearZ, float fFarZ) { return fntable_System_020_instance->GetProjectionMatrix(eEye, fNearZ, fFarZ); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_020_impl_GetProjectionRaw(vr::EVREye eEye, float* pfLeft, float* pfRight, float* pfTop, float* pfBottom) { return fntable_System_020_instance->GetProjectionRaw(eEye, pfLeft, pfRight, pfTop, pfBottom); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_020_impl_ComputeDistortion(vr::EVREye eEye, float fU, float fV, vr::DistortionCoordinates_t* pDistortionCoordinates) { return fntable_System_020_instance->ComputeDistortion(eEye, fU, fV, pDistortionCoordinates); }
static vr::HmdMatrix34_t OPENVR_FNTABLE_CALLTYPE fntable_System_020_impl_GetEyeToHeadTransform(vr::EVREye eEye) { return fntable_System_020_instance->GetEyeToHeadTransform(eEye); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_020_impl_GetTimeSinceLastVsync(float* pfSecondsSinceLastVsync, uint64_t* pulFrameCounter) { return fntable_System_020_instance->GetTimeSinceLastVsync(pfSecondsSinceLastVsync, pulFrameCounter); }
static int32_t OPENVR_FNTABLE_CALLTYPE fntable_System_020_impl_GetD3D9AdapterIndex() { return fntable_System_020_instance->GetD3D9AdapterIndex(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_020_impl_GetDXGIOutputInfo(int32_t* pnAdapterIndex) { return fntable_System_020_instance->GetDXGIOutputInfo(pnAdapterIndex); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_020_impl_GetOutputDevice(uint64_t* pnDevice, vr::ETextureType textureType, VkInstance_T* pInstance) { return fntable_System_020_instance->GetOutputDevice(pnDevice, textureType, pInstance); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_020_impl_IsDisplayOnDesktop() { return fntable_System_020_instance->IsDisplayOnDesktop(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_020_impl_SetDisplayVisibility(bool bIsVisibleOnDesktop) { return fntable_System_020_instance->SetDisplayVisibility(bIsVisibleOnDesktop); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_020_impl_GetDeviceToAbsoluteTrackingPose(vr::ETrackingUniverseOrigin eOrigin, float fPredictedSecondsToPhotonsFromNow, vr::TrackedDevicePose_t* pTrackedDevicePoseArray, uint32_t unTrackedDevicePoseArrayCount) { return fntable_System_020_instance->GetDeviceToAbsoluteTrackingPose(eOrigin, fPredictedSecondsToPhotonsFromNow, pTrackedDevicePoseArray, unTrackedDevicePoseArrayCount); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_020_impl_ResetSeatedZeroPose() { return fntable_System_020_instance->ResetSeatedZeroPose(); }
static vr::HmdMatrix34_t OPENVR_FNTABLE_CALLTYPE fntable_System_020_impl_GetSeatedZeroPoseToStandingAbsoluteTrackingPose() { return fntable_System_020_instance->GetSeatedZeroPoseToStandingAbsoluteTrackingPose(); }
static vr::HmdMatrix34_t OPENVR_FNTABLE_CALLTYPE fntable_System_020_impl_GetRawZeroPoseToStandingAbsoluteTrackingPose() { return fntable_System_020_instance->GetRawZeroPoseToStandingAbsoluteTrackingPose(); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_System_020_impl_GetSortedTrackedDeviceIndicesOfClass(vr::ETrackedDeviceClass eTrackedDeviceClass, vr::TrackedDeviceIndex_t* punTrackedDeviceIndexArray, uint32_t unTrackedDeviceIndexArrayCount, vr::TrackedDeviceIndex_t unRelativeToTrackedDeviceIndex) { return fntable_System_020_instance->GetSortedTrackedDeviceIndicesOfClass(eTrackedDeviceClass, punTrackedDeviceIndexArray, unTrackedDeviceIndexArrayCount, unRelativeToTrackedDeviceIndex); }
static vr::EDeviceActivityLevel OPENVR_FNTABLE_CALLTYPE fntable_System_020_impl_GetTrackedDeviceActivityLevel(vr::TrackedDeviceIndex_t unDeviceId) { return fntable_System_020_instance->GetTrackedDeviceActivityLevel(unDeviceId); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_020_impl_ApplyTransform(vr::TrackedDevicePose_t* pOutputPose, const vr::TrackedDevicePose_t* pTrackedDevicePose, const vr::HmdMatrix34_t* pTransform) { return fntable_System_020_instance->ApplyTransform(pOutputPose, pTrackedDevicePose, pTransform); }
static vr::TrackedDeviceIndex_t OPENVR_FNTABLE_CALLTYPE fntable_System_020_impl_GetTrackedDeviceIndexForControllerRole(vr::ETrackedControllerRole unDeviceType) { return fntable_System_020_instance->GetTrackedDeviceIndexForControllerRole(unDeviceType); }
static vr::ETrackedControllerRole OPENVR_FNTABLE_CALLTYPE fntable_System_020_impl_GetControllerRoleForTrackedDeviceIndex(vr::TrackedDeviceIndex_t unDeviceIndex) { return fntable_System_020_instance->GetControllerRoleForTrackedDeviceIndex(unDeviceIndex); }
static vr::ETrackedDeviceClass OPENVR_FNTABLE_CALLTYPE fntable_System_020_impl_GetTrackedDeviceClass(vr::TrackedDeviceIndex_t unDeviceIndex) { return fntable_System_020_instance->GetTrackedDeviceClass(unDeviceIndex); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_020_impl_IsTrackedDeviceConnected(vr::TrackedDeviceIndex_t unDeviceIndex) { return fntable_System_020_instance->IsTrackedDeviceConnected(unDeviceIndex); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_020_impl_GetBoolTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) { return fntable_System_020_instance->GetBoolTrackedDeviceProperty(unDeviceIndex, prop, pError); }
static float OPENVR_FNTABLE_CALLTYPE fntable_System_020_impl_GetFloatTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) { return fntable_System_020_instance->GetFloatTrackedDeviceProperty(unDeviceIndex, prop, pError); }
static int32_t OPENVR_FNTABLE_CALLTYPE fntable_System_020_impl_GetInt32TrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) { return fntable_System_020_instance->GetInt32TrackedDeviceProperty(unDeviceIndex, prop, pError); }
static uint64_t OPENVR_FNTABLE_CALLTYPE fntable_System_020_impl_GetUint64TrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) { return fntable_System_020_instance->GetUint64TrackedDeviceProperty(unDeviceIndex, prop, pError); }
static vr::HmdMatrix34_t OPENVR_FNTABLE_CALLTYPE fntable_System_020_impl_GetMatrix34TrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) { return fntable_System_020_instance->GetMatrix34TrackedDeviceProperty(unDeviceIndex, prop, pError); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_System_020_impl_GetArrayTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::PropertyTypeTag_t propType, void* pBuffer, uint32_t unBufferSize, vr::ETrackedPropertyError* pError) { return fntable_System_020_instance->GetArrayTrackedDeviceProperty(unDeviceIndex, prop, propType, pBuffer, unBufferSize, pError); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_System_020_impl_GetStringTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, char* pchValue, uint32_t unBufferSize, vr::ETrackedPropertyError* pError) { return fntable_System_020_instance->GetStringTrackedDeviceProperty(unDeviceIndex, prop, pchValue, unBufferSize, pError); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_System_020_impl_GetPropErrorNameFromEnum(vr::ETrackedPropertyError error) { return fntable_System_020_instance->GetPropErrorNameFromEnum(error); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_020_impl_PollNextEvent(vr::VREvent_t* pEvent, uint32_t uncbVREvent) { return fntable_System_020_instance->PollNextEvent(pEvent, uncbVREvent); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_020_impl_PollNextEventWithPose(vr::ETrackingUniverseOrigin eOrigin, vr::VREvent_t* pEvent, uint32_t uncbVREvent, vr::TrackedDevicePose_t* pTrackedDevicePose) { return fntable_System_020_instance->PollNextEventWithPose(eOrigin, pEvent, uncbVREvent, pTrackedDevicePose); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_System_020_impl_GetEventTypeNameFromEnum(vr::EVREventType eType) { return fntable_System_020_instance->GetEventTypeNameFromEnum(eType); }
static vr::HiddenAreaMesh_t OPENVR_FNTABLE_CALLTYPE fntable_System_020_impl_GetHiddenAreaMesh(vr::EVREye eEye, vr::EHiddenAreaMeshType type) { return fntable_System_020_instance->GetHiddenAreaMesh(eEye, type); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_020_impl_GetControllerState(vr::TrackedDeviceIndex_t unControllerDeviceIndex, vr::VRControllerState_t* pControllerState, uint32_t unControllerStateSize) { return fntable_System_020_instance->GetControllerState(unControllerDeviceIndex, pControllerState, unControllerStateSize); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_020_impl_GetControllerStateWithPose(vr::ETrackingUniverseOrigin eOrigin, vr::TrackedDeviceIndex_t unControllerDeviceIndex, vr::VRControllerState_t* pControllerState, uint32_t unControllerStateSize, vr::TrackedDevicePose_t* pTrackedDevicePose) { return fntable_System_020_instance->GetControllerStateWithPose(eOrigin, unControllerDeviceIndex, pControllerState, unControllerStateSize, pTrackedDevicePose); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_020_impl_TriggerHapticPulse(vr::TrackedDeviceIndex_t unControllerDeviceIndex, uint32_t unAxisId, unsigned short usDurationMicroSec) { return fntable_System_020_instance->TriggerHapticPulse(unControllerDeviceIndex, unAxisId, usDurationMicroSec); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_System_020_impl_GetButtonIdNameFromEnum(vr::EVRButtonId eButtonId) { return fntable_System_020_instance->GetButtonIdNameFromEnum(eButtonId); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_System_020_impl_GetControllerAxisTypeNameFromEnum(vr::EVRControllerAxisType eAxisType) { return fntable_System_020_instance->GetControllerAxisTypeNameFromEnum(eAxisType); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_020_impl_IsInputAvailable() { return fntable_System_020_instance->IsInputAvailable(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_020_impl_IsSteamVRDrawingControllers() { return fntable_System_020_instance->IsSteamVRDrawingControllers(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_020_impl_ShouldApplicationPause() { return fntable_System_020_instance->ShouldApplicationPause(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_020_impl_ShouldApplicationReduceRenderingWork() { return fntable_System_020_instance->ShouldApplicationReduceRenderingWork(); }
static vr::EVRFirmwareError OPENVR_FNTABLE_CALLTYPE fntable_System_020_impl_PerformFirmwareUpdate(vr::TrackedDeviceIndex_t unDeviceIndex) { return fntable_System_020_instance->PerformFirmwareUpdate(unDeviceIndex); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_020_impl_AcknowledgeQuit_Exiting() { return fntable_System_020_instance->AcknowledgeQuit_Exiting(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_020_impl_AcknowledgeQuit_UserPrompt() { return fntable_System_020_instance->AcknowledgeQuit_UserPrompt(); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_System_020_impl_GetAppContainerFilePaths(char* pchBuffer, uint32_t unBufferSize) { return fntable_System_020_instance->GetAppContainerFilePaths(pchBuffer, unBufferSize); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_System_020_impl_GetRuntimeVersion() { return fntable_System_020_instance->GetRuntimeVersion(); }
static void *fntable_System_020_funcs[] = {
	(void*) fntable_System_020_impl_GetRecommendedRenderTargetSize,
	(void*) fntable_System_020_impl_GetProjectionMatrix,
	(void*) fntable_System_020_impl_GetProjectionRaw,
	(void*) fntable_System_020_impl_ComputeDistortion,
	(void*) fntable_System_020_impl_GetEyeToHeadTransform,
	(void*) fntable_System_020_impl_GetTimeSinceLastVsync,
	(void*) fntable_System_020_impl_GetD3D9AdapterIndex,
	(void*) fntable_System_020_impl_GetDXGIOutputInfo,
	(void*) fntable_System_020_impl_GetOutputDevice,
	(void*) fntable_System_020_impl_IsDisplayOnDesktop,
	(void*) fntable_System_020_impl_SetDisplayVisibility,
	(void*) fntable_System_020_impl_GetDeviceToAbsoluteTrackingPose,
	(void*) fntable_System_020_impl_ResetSeatedZeroPose,
	(void*) fntable_System_020_impl_GetSeatedZeroPoseToStandingAbsoluteTrackingPose,
	(void*) fntable_System_020_impl_GetRawZeroPoseToStandingAbsoluteTrackingPose,
	(void*) fntable_System_020_impl_GetSortedTrackedDeviceIndicesOfClass,
	(void*) fntable_System_020_impl_GetTrackedDeviceActivityLevel,
	(void*) fntable_System_020_impl_ApplyTransform,
	(void*) fntable_System_020_impl_GetTrackedDeviceIndexForControllerRole,
	(void*) fntable_System_020_impl_GetControllerRoleForTrackedDeviceIndex,
	(void*) fntable_System_020_impl_GetTrackedDeviceClass,
	(void*) fntable_System_020_impl_IsTrackedDeviceConnected,
	(void*) fntable_System_020_impl_GetBoolTrackedDeviceProperty,
	(void*) fntable_System_020_impl_GetFloatTrackedDeviceProperty,
	(void*) fntable_System_020_impl_GetInt32TrackedDeviceProperty,
	(void*) fntable_System_020_impl_GetUint64TrackedDeviceProperty,
	(void*) fntable_System_020_impl_GetMatrix34TrackedDeviceProperty,
	(void*) fntable_System_020_impl_GetArrayTrackedDeviceProperty,
	(void*) fntable_System_020_impl_GetStringTrackedDeviceProperty,
	(void*) fntable_System_020_impl_GetPropErrorNameFromEnum,
	(void*) fntable_System_020_impl_PollNextEvent,
	(void*) fntable_System_020_impl_PollNextEventWithPose,
	(void*) fntable_System_020_impl_GetEventTypeNameFromEnum,
	(void*) fntable_System_020_impl_GetHiddenAreaMesh,
	(void*) fntable_System_020_impl_GetControllerState,
	(void*) fntable_System_020_impl_GetControllerStateWithPose,
	(void*) fntable_System_020_impl_TriggerHapticPulse,
	(void*) fntable_System_020_impl_GetButtonIdNameFromEnum,
	(void*) fntable_System_020_impl_GetControllerAxisTypeNameFromEnum,
	(void*) fntable_System_020_impl_IsInputAvailable,
	(void*) fntable_System_020_impl_IsSteamVRDrawingControllers,
	(void*) fntable_System_020_impl_ShouldApplicationPause,
	(void*) fntable_System_020_impl_ShouldApplicationReduceRenderingWork,
	(void*) fntable_System_020_impl_PerformFirmwareUpdate,
	(void*) fntable_System_020_impl_AcknowledgeQuit_Exiting,
	(void*) fntable_System_020_impl_AcknowledgeQuit_UserPrompt,
	(void*) fntable_System_020_impl_GetAppContainerFilePaths,
	(void*) fntable_System_020_impl_GetRuntimeVersion,
};
void** CVRSystem_020::_GetStatFuncList() { fntable_System_020_instance = this; return fntable_System_020_funcs; }
void CVRSystem_020::Delete() { delete this; }
// Misc for CVRSystem_021:
CVRSystem_021::CVRSystem_021() : base(GetCreateBaseSystem()) {}
// Interface methods for CVRSystem_021:
void CVRSystem_021::GetRecommendedRenderTargetSize(uint32_t* pnWidth, uint32_t* pnHeight) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_021)");
	return base->GetRecommendedRenderTargetSize(pnWidth, pnHeight);
}
vr::HmdMatrix44_t CVRSystem_021::GetProjectionMatrix(vr::EVREye eEye, float fNearZ, float fFarZ) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_021)");
	return base->GetProjectionMatrix(eEye, fNearZ, fFarZ);
}
void CVRSystem_021::GetProjectionRaw(vr::EVREye eEye, float* pfLeft, float* pfRight, float* pfTop, float* pfBottom) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_021)");
	return base->GetProjectionRaw(eEye, pfLeft, pfRight, pfTop, pfBottom);
}
bool CVRSystem_021::ComputeDistortion(vr::EVREye eEye, float fU, float fV, vr::DistortionCoordinates_t* pDistortionCoordinates) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_021)");
	return base->ComputeDistortion(eEye, fU, fV, pDistortionCoordinates);
}
vr::HmdMatrix34_t CVRSystem_021::GetEyeToHeadTransform(vr::EVREye eEye) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_021)");
	return base->GetEyeToHeadTransform(eEye);
}
bool CVRSystem_021::GetTimeSinceLastVsync(float* pfSecondsSinceLastVsync, uint64_t* pulFrameCounter) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_021)");
	return base->GetTimeSinceLastVsync(pfSecondsSinceLastVsync, pulFrameCounter);
}
int32_t CVRSystem_021::GetD3D9AdapterIndex() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_021)");
	return base->GetD3D9AdapterIndex();
}
void CVRSystem_021::GetDXGIOutputInfo(int32_t* pnAdapterIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_021)");
	return base->GetDXGIOutputInfo(pnAdapterIndex);
}
void CVRSystem_021::GetOutputDevice(uint64_t* pnDevice, vr::ETextureType textureType, VkInstance_T* pInstance) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_021)");
	return base->GetOutputDevice(pnDevice, textureType, pInstance);
}
bool CVRSystem_021::IsDisplayOnDesktop() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_021)");
	return base->IsDisplayOnDesktop();
}
bool CVRSystem_021::SetDisplayVisibility(bool bIsVisibleOnDesktop) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_021)");
	return base->SetDisplayVisibility(bIsVisibleOnDesktop);
}
void CVRSystem_021::GetDeviceToAbsoluteTrackingPose(vr::ETrackingUniverseOrigin eOrigin, float fPredictedSecondsToPhotonsFromNow, vr::TrackedDevicePose_t* pTrackedDevicePoseArray, uint32_t unTrackedDevicePoseArrayCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_021)");
	return base->GetDeviceToAbsoluteTrackingPose(eOrigin, fPredictedSecondsToPhotonsFromNow, pTrackedDevicePoseArray, unTrackedDevicePoseArrayCount);
}
void CVRSystem_021::ResetSeatedZeroPose() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_021)");
	return base->ResetSeatedZeroPose();
}
vr::HmdMatrix34_t CVRSystem_021::GetSeatedZeroPoseToStandingAbsoluteTrackingPose() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_021)");
	return base->GetSeatedZeroPoseToStandingAbsoluteTrackingPose();
}
vr::HmdMatrix34_t CVRSystem_021::GetRawZeroPoseToStandingAbsoluteTrackingPose() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_021)");
	return base->GetRawZeroPoseToStandingAbsoluteTrackingPose();
}
uint32_t CVRSystem_021::GetSortedTrackedDeviceIndicesOfClass(vr::ETrackedDeviceClass eTrackedDeviceClass, vr::TrackedDeviceIndex_t* punTrackedDeviceIndexArray, uint32_t unTrackedDeviceIndexArrayCount, vr::TrackedDeviceIndex_t unRelativeToTrackedDeviceIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_021)");
	return base->GetSortedTrackedDeviceIndicesOfClass(eTrackedDeviceClass, punTrackedDeviceIndexArray, unTrackedDeviceIndexArrayCount, unRelativeToTrackedDeviceIndex);
}
vr::EDeviceActivityLevel CVRSystem_021::GetTrackedDeviceActivityLevel(vr::TrackedDeviceIndex_t unDeviceId) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_021)");
	return base->GetTrackedDeviceActivityLevel(unDeviceId);
}
void CVRSystem_021::ApplyTransform(vr::TrackedDevicePose_t* pOutputPose, const vr::TrackedDevicePose_t* pTrackedDevicePose, const vr::HmdMatrix34_t* pTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_021)");
	return base->ApplyTransform(pOutputPose, pTrackedDevicePose, pTransform);
}
vr::TrackedDeviceIndex_t CVRSystem_021::GetTrackedDeviceIndexForControllerRole(vr::ETrackedControllerRole unDeviceType) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_021)");
	return base->GetTrackedDeviceIndexForControllerRole(unDeviceType);
}
vr::ETrackedControllerRole CVRSystem_021::GetControllerRoleForTrackedDeviceIndex(vr::TrackedDeviceIndex_t unDeviceIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_021)");
	return base->GetControllerRoleForTrackedDeviceIndex(unDeviceIndex);
}
vr::ETrackedDeviceClass CVRSystem_021::GetTrackedDeviceClass(vr::TrackedDeviceIndex_t unDeviceIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_021)");
	return base->GetTrackedDeviceClass(unDeviceIndex);
}
bool CVRSystem_021::IsTrackedDeviceConnected(vr::TrackedDeviceIndex_t unDeviceIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_021)");
	return base->IsTrackedDeviceConnected(unDeviceIndex);
}
bool CVRSystem_021::GetBoolTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_021)");
	return base->GetBoolTrackedDeviceProperty(unDeviceIndex, prop, pError);
}
float CVRSystem_021::GetFloatTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_021)");
	return base->GetFloatTrackedDeviceProperty(unDeviceIndex, prop, pError);
}
int32_t CVRSystem_021::GetInt32TrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_021)");
	return base->GetInt32TrackedDeviceProperty(unDeviceIndex, prop, pError);
}
uint64_t CVRSystem_021::GetUint64TrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_021)");
	return base->GetUint64TrackedDeviceProperty(unDeviceIndex, prop, pError);
}
vr::HmdMatrix34_t CVRSystem_021::GetMatrix34TrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_021)");
	return base->GetMatrix34TrackedDeviceProperty(unDeviceIndex, prop, pError);
}
uint32_t CVRSystem_021::GetArrayTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::PropertyTypeTag_t propType, void* pBuffer, uint32_t unBufferSize, vr::ETrackedPropertyError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_021)");
	return base->GetArrayTrackedDeviceProperty(unDeviceIndex, prop, propType, pBuffer, unBufferSize, pError);
}
uint32_t CVRSystem_021::GetStringTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, char* pchValue, uint32_t unBufferSize, vr::ETrackedPropertyError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_021)");
	return base->GetStringTrackedDeviceProperty(unDeviceIndex, prop, pchValue, unBufferSize, pError);
}
const char* CVRSystem_021::GetPropErrorNameFromEnum(vr::ETrackedPropertyError error) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_021)");
	return base->GetPropErrorNameFromEnum(error);
}
bool CVRSystem_021::PollNextEvent(vr::VREvent_t* pEvent, uint32_t uncbVREvent) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_021)");
	return base->PollNextEvent(pEvent, uncbVREvent);
}
bool CVRSystem_021::PollNextEventWithPose(vr::ETrackingUniverseOrigin eOrigin, vr::VREvent_t* pEvent, uint32_t uncbVREvent, vr::TrackedDevicePose_t* pTrackedDevicePose) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_021)");
	return base->PollNextEventWithPose(eOrigin, pEvent, uncbVREvent, pTrackedDevicePose);
}
const char* CVRSystem_021::GetEventTypeNameFromEnum(vr::EVREventType eType) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_021)");
	return base->GetEventTypeNameFromEnum(eType);
}
vr::HiddenAreaMesh_t CVRSystem_021::GetHiddenAreaMesh(vr::EVREye eEye, vr::EHiddenAreaMeshType type) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_021)");
	return base->GetHiddenAreaMesh(eEye, type);
}
bool CVRSystem_021::GetControllerState(vr::TrackedDeviceIndex_t unControllerDeviceIndex, vr::VRControllerState_t* pControllerState, uint32_t unControllerStateSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_021)");
	return base->GetControllerState(unControllerDeviceIndex, pControllerState, unControllerStateSize);
}
bool CVRSystem_021::GetControllerStateWithPose(vr::ETrackingUniverseOrigin eOrigin, vr::TrackedDeviceIndex_t unControllerDeviceIndex, vr::VRControllerState_t* pControllerState, uint32_t unControllerStateSize, vr::TrackedDevicePose_t* pTrackedDevicePose) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_021)");
	return base->GetControllerStateWithPose(eOrigin, unControllerDeviceIndex, pControllerState, unControllerStateSize, pTrackedDevicePose);
}
void CVRSystem_021::TriggerHapticPulse(vr::TrackedDeviceIndex_t unControllerDeviceIndex, uint32_t unAxisId, unsigned short usDurationMicroSec) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_021)");
	return base->TriggerHapticPulse(unControllerDeviceIndex, unAxisId, usDurationMicroSec);
}
const char* CVRSystem_021::GetButtonIdNameFromEnum(vr::EVRButtonId eButtonId) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_021)");
	return base->GetButtonIdNameFromEnum(eButtonId);
}
const char* CVRSystem_021::GetControllerAxisTypeNameFromEnum(vr::EVRControllerAxisType eAxisType) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_021)");
	return base->GetControllerAxisTypeNameFromEnum(eAxisType);
}
bool CVRSystem_021::IsInputAvailable() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_021)");
	return base->IsInputAvailable();
}
bool CVRSystem_021::IsSteamVRDrawingControllers() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_021)");
	return base->IsSteamVRDrawingControllers();
}
bool CVRSystem_021::ShouldApplicationPause() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_021)");
	return base->ShouldApplicationPause();
}
bool CVRSystem_021::ShouldApplicationReduceRenderingWork() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_021)");
	return base->ShouldApplicationReduceRenderingWork();
}
vr::EVRFirmwareError CVRSystem_021::PerformFirmwareUpdate(vr::TrackedDeviceIndex_t unDeviceIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_021)");
	return base->PerformFirmwareUpdate(unDeviceIndex);
}
void CVRSystem_021::AcknowledgeQuit_Exiting() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_021)");
	return base->AcknowledgeQuit_Exiting();
}
uint32_t CVRSystem_021::GetAppContainerFilePaths(char* pchBuffer, uint32_t unBufferSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_021)");
	return base->GetAppContainerFilePaths(pchBuffer, unBufferSize);
}
const char* CVRSystem_021::GetRuntimeVersion() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_021)");
	return base->GetRuntimeVersion();
}
// FnTable for CVRSystem_021:
static CVRSystem_021 *fntable_System_021_instance = NULL;
static void OPENVR_FNTABLE_CALLTYPE fntable_System_021_impl_GetRecommendedRenderTargetSize(uint32_t* pnWidth, uint32_t* pnHeight) { return fntable_System_021_instance->GetRecommendedRenderTargetSize(pnWidth, pnHeight); }
static vr::HmdMatrix44_t OPENVR_FNTABLE_CALLTYPE fntable_System_021_impl_GetProjectionMatrix(vr::EVREye eEye, float fNearZ, float fFarZ) { return fntable_System_021_instance->GetProjectionMatrix(eEye, fNearZ, fFarZ); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_021_impl_GetProjectionRaw(vr::EVREye eEye, float* pfLeft, float* pfRight, float* pfTop, float* pfBottom) { return fntable_System_021_instance->GetProjectionRaw(eEye, pfLeft, pfRight, pfTop, pfBottom); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_021_impl_ComputeDistortion(vr::EVREye eEye, float fU, float fV, vr::DistortionCoordinates_t* pDistortionCoordinates) { return fntable_System_021_instance->ComputeDistortion(eEye, fU, fV, pDistortionCoordinates); }
static vr::HmdMatrix34_t OPENVR_FNTABLE_CALLTYPE fntable_System_021_impl_GetEyeToHeadTransform(vr::EVREye eEye) { return fntable_System_021_instance->GetEyeToHeadTransform(eEye); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_021_impl_GetTimeSinceLastVsync(float* pfSecondsSinceLastVsync, uint64_t* pulFrameCounter) { return fntable_System_021_instance->GetTimeSinceLastVsync(pfSecondsSinceLastVsync, pulFrameCounter); }
static int32_t OPENVR_FNTABLE_CALLTYPE fntable_System_021_impl_GetD3D9AdapterIndex() { return fntable_System_021_instance->GetD3D9AdapterIndex(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_021_impl_GetDXGIOutputInfo(int32_t* pnAdapterIndex) { return fntable_System_021_instance->GetDXGIOutputInfo(pnAdapterIndex); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_021_impl_GetOutputDevice(uint64_t* pnDevice, vr::ETextureType textureType, VkInstance_T* pInstance) { return fntable_System_021_instance->GetOutputDevice(pnDevice, textureType, pInstance); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_021_impl_IsDisplayOnDesktop() { return fntable_System_021_instance->IsDisplayOnDesktop(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_021_impl_SetDisplayVisibility(bool bIsVisibleOnDesktop) { return fntable_System_021_instance->SetDisplayVisibility(bIsVisibleOnDesktop); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_021_impl_GetDeviceToAbsoluteTrackingPose(vr::ETrackingUniverseOrigin eOrigin, float fPredictedSecondsToPhotonsFromNow, vr::TrackedDevicePose_t* pTrackedDevicePoseArray, uint32_t unTrackedDevicePoseArrayCount) { return fntable_System_021_instance->GetDeviceToAbsoluteTrackingPose(eOrigin, fPredictedSecondsToPhotonsFromNow, pTrackedDevicePoseArray, unTrackedDevicePoseArrayCount); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_021_impl_ResetSeatedZeroPose() { return fntable_System_021_instance->ResetSeatedZeroPose(); }
static vr::HmdMatrix34_t OPENVR_FNTABLE_CALLTYPE fntable_System_021_impl_GetSeatedZeroPoseToStandingAbsoluteTrackingPose() { return fntable_System_021_instance->GetSeatedZeroPoseToStandingAbsoluteTrackingPose(); }
static vr::HmdMatrix34_t OPENVR_FNTABLE_CALLTYPE fntable_System_021_impl_GetRawZeroPoseToStandingAbsoluteTrackingPose() { return fntable_System_021_instance->GetRawZeroPoseToStandingAbsoluteTrackingPose(); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_System_021_impl_GetSortedTrackedDeviceIndicesOfClass(vr::ETrackedDeviceClass eTrackedDeviceClass, vr::TrackedDeviceIndex_t* punTrackedDeviceIndexArray, uint32_t unTrackedDeviceIndexArrayCount, vr::TrackedDeviceIndex_t unRelativeToTrackedDeviceIndex) { return fntable_System_021_instance->GetSortedTrackedDeviceIndicesOfClass(eTrackedDeviceClass, punTrackedDeviceIndexArray, unTrackedDeviceIndexArrayCount, unRelativeToTrackedDeviceIndex); }
static vr::EDeviceActivityLevel OPENVR_FNTABLE_CALLTYPE fntable_System_021_impl_GetTrackedDeviceActivityLevel(vr::TrackedDeviceIndex_t unDeviceId) { return fntable_System_021_instance->GetTrackedDeviceActivityLevel(unDeviceId); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_021_impl_ApplyTransform(vr::TrackedDevicePose_t* pOutputPose, const vr::TrackedDevicePose_t* pTrackedDevicePose, const vr::HmdMatrix34_t* pTransform) { return fntable_System_021_instance->ApplyTransform(pOutputPose, pTrackedDevicePose, pTransform); }
static vr::TrackedDeviceIndex_t OPENVR_FNTABLE_CALLTYPE fntable_System_021_impl_GetTrackedDeviceIndexForControllerRole(vr::ETrackedControllerRole unDeviceType) { return fntable_System_021_instance->GetTrackedDeviceIndexForControllerRole(unDeviceType); }
static vr::ETrackedControllerRole OPENVR_FNTABLE_CALLTYPE fntable_System_021_impl_GetControllerRoleForTrackedDeviceIndex(vr::TrackedDeviceIndex_t unDeviceIndex) { return fntable_System_021_instance->GetControllerRoleForTrackedDeviceIndex(unDeviceIndex); }
static vr::ETrackedDeviceClass OPENVR_FNTABLE_CALLTYPE fntable_System_021_impl_GetTrackedDeviceClass(vr::TrackedDeviceIndex_t unDeviceIndex) { return fntable_System_021_instance->GetTrackedDeviceClass(unDeviceIndex); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_021_impl_IsTrackedDeviceConnected(vr::TrackedDeviceIndex_t unDeviceIndex) { return fntable_System_021_instance->IsTrackedDeviceConnected(unDeviceIndex); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_021_impl_GetBoolTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) { return fntable_System_021_instance->GetBoolTrackedDeviceProperty(unDeviceIndex, prop, pError); }
static float OPENVR_FNTABLE_CALLTYPE fntable_System_021_impl_GetFloatTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) { return fntable_System_021_instance->GetFloatTrackedDeviceProperty(unDeviceIndex, prop, pError); }
static int32_t OPENVR_FNTABLE_CALLTYPE fntable_System_021_impl_GetInt32TrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) { return fntable_System_021_instance->GetInt32TrackedDeviceProperty(unDeviceIndex, prop, pError); }
static uint64_t OPENVR_FNTABLE_CALLTYPE fntable_System_021_impl_GetUint64TrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) { return fntable_System_021_instance->GetUint64TrackedDeviceProperty(unDeviceIndex, prop, pError); }
static vr::HmdMatrix34_t OPENVR_FNTABLE_CALLTYPE fntable_System_021_impl_GetMatrix34TrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) { return fntable_System_021_instance->GetMatrix34TrackedDeviceProperty(unDeviceIndex, prop, pError); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_System_021_impl_GetArrayTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::PropertyTypeTag_t propType, void* pBuffer, uint32_t unBufferSize, vr::ETrackedPropertyError* pError) { return fntable_System_021_instance->GetArrayTrackedDeviceProperty(unDeviceIndex, prop, propType, pBuffer, unBufferSize, pError); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_System_021_impl_GetStringTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, char* pchValue, uint32_t unBufferSize, vr::ETrackedPropertyError* pError) { return fntable_System_021_instance->GetStringTrackedDeviceProperty(unDeviceIndex, prop, pchValue, unBufferSize, pError); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_System_021_impl_GetPropErrorNameFromEnum(vr::ETrackedPropertyError error) { return fntable_System_021_instance->GetPropErrorNameFromEnum(error); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_021_impl_PollNextEvent(vr::VREvent_t* pEvent, uint32_t uncbVREvent) { return fntable_System_021_instance->PollNextEvent(pEvent, uncbVREvent); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_021_impl_PollNextEventWithPose(vr::ETrackingUniverseOrigin eOrigin, vr::VREvent_t* pEvent, uint32_t uncbVREvent, vr::TrackedDevicePose_t* pTrackedDevicePose) { return fntable_System_021_instance->PollNextEventWithPose(eOrigin, pEvent, uncbVREvent, pTrackedDevicePose); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_System_021_impl_GetEventTypeNameFromEnum(vr::EVREventType eType) { return fntable_System_021_instance->GetEventTypeNameFromEnum(eType); }
static vr::HiddenAreaMesh_t OPENVR_FNTABLE_CALLTYPE fntable_System_021_impl_GetHiddenAreaMesh(vr::EVREye eEye, vr::EHiddenAreaMeshType type) { return fntable_System_021_instance->GetHiddenAreaMesh(eEye, type); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_021_impl_GetControllerState(vr::TrackedDeviceIndex_t unControllerDeviceIndex, vr::VRControllerState_t* pControllerState, uint32_t unControllerStateSize) { return fntable_System_021_instance->GetControllerState(unControllerDeviceIndex, pControllerState, unControllerStateSize); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_021_impl_GetControllerStateWithPose(vr::ETrackingUniverseOrigin eOrigin, vr::TrackedDeviceIndex_t unControllerDeviceIndex, vr::VRControllerState_t* pControllerState, uint32_t unControllerStateSize, vr::TrackedDevicePose_t* pTrackedDevicePose) { return fntable_System_021_instance->GetControllerStateWithPose(eOrigin, unControllerDeviceIndex, pControllerState, unControllerStateSize, pTrackedDevicePose); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_021_impl_TriggerHapticPulse(vr::TrackedDeviceIndex_t unControllerDeviceIndex, uint32_t unAxisId, unsigned short usDurationMicroSec) { return fntable_System_021_instance->TriggerHapticPulse(unControllerDeviceIndex, unAxisId, usDurationMicroSec); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_System_021_impl_GetButtonIdNameFromEnum(vr::EVRButtonId eButtonId) { return fntable_System_021_instance->GetButtonIdNameFromEnum(eButtonId); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_System_021_impl_GetControllerAxisTypeNameFromEnum(vr::EVRControllerAxisType eAxisType) { return fntable_System_021_instance->GetControllerAxisTypeNameFromEnum(eAxisType); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_021_impl_IsInputAvailable() { return fntable_System_021_instance->IsInputAvailable(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_021_impl_IsSteamVRDrawingControllers() { return fntable_System_021_instance->IsSteamVRDrawingControllers(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_021_impl_ShouldApplicationPause() { return fntable_System_021_instance->ShouldApplicationPause(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_021_impl_ShouldApplicationReduceRenderingWork() { return fntable_System_021_instance->ShouldApplicationReduceRenderingWork(); }
static vr::EVRFirmwareError OPENVR_FNTABLE_CALLTYPE fntable_System_021_impl_PerformFirmwareUpdate(vr::TrackedDeviceIndex_t unDeviceIndex) { return fntable_System_021_instance->PerformFirmwareUpdate(unDeviceIndex); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_021_impl_AcknowledgeQuit_Exiting() { return fntable_System_021_instance->AcknowledgeQuit_Exiting(); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_System_021_impl_GetAppContainerFilePaths(char* pchBuffer, uint32_t unBufferSize) { return fntable_System_021_instance->GetAppContainerFilePaths(pchBuffer, unBufferSize); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_System_021_impl_GetRuntimeVersion() { return fntable_System_021_instance->GetRuntimeVersion(); }
static void *fntable_System_021_funcs[] = {
	(void*) fntable_System_021_impl_GetRecommendedRenderTargetSize,
	(void*) fntable_System_021_impl_GetProjectionMatrix,
	(void*) fntable_System_021_impl_GetProjectionRaw,
	(void*) fntable_System_021_impl_ComputeDistortion,
	(void*) fntable_System_021_impl_GetEyeToHeadTransform,
	(void*) fntable_System_021_impl_GetTimeSinceLastVsync,
	(void*) fntable_System_021_impl_GetD3D9AdapterIndex,
	(void*) fntable_System_021_impl_GetDXGIOutputInfo,
	(void*) fntable_System_021_impl_GetOutputDevice,
	(void*) fntable_System_021_impl_IsDisplayOnDesktop,
	(void*) fntable_System_021_impl_SetDisplayVisibility,
	(void*) fntable_System_021_impl_GetDeviceToAbsoluteTrackingPose,
	(void*) fntable_System_021_impl_ResetSeatedZeroPose,
	(void*) fntable_System_021_impl_GetSeatedZeroPoseToStandingAbsoluteTrackingPose,
	(void*) fntable_System_021_impl_GetRawZeroPoseToStandingAbsoluteTrackingPose,
	(void*) fntable_System_021_impl_GetSortedTrackedDeviceIndicesOfClass,
	(void*) fntable_System_021_impl_GetTrackedDeviceActivityLevel,
	(void*) fntable_System_021_impl_ApplyTransform,
	(void*) fntable_System_021_impl_GetTrackedDeviceIndexForControllerRole,
	(void*) fntable_System_021_impl_GetControllerRoleForTrackedDeviceIndex,
	(void*) fntable_System_021_impl_GetTrackedDeviceClass,
	(void*) fntable_System_021_impl_IsTrackedDeviceConnected,
	(void*) fntable_System_021_impl_GetBoolTrackedDeviceProperty,
	(void*) fntable_System_021_impl_GetFloatTrackedDeviceProperty,
	(void*) fntable_System_021_impl_GetInt32TrackedDeviceProperty,
	(void*) fntable_System_021_impl_GetUint64TrackedDeviceProperty,
	(void*) fntable_System_021_impl_GetMatrix34TrackedDeviceProperty,
	(void*) fntable_System_021_impl_GetArrayTrackedDeviceProperty,
	(void*) fntable_System_021_impl_GetStringTrackedDeviceProperty,
	(void*) fntable_System_021_impl_GetPropErrorNameFromEnum,
	(void*) fntable_System_021_impl_PollNextEvent,
	(void*) fntable_System_021_impl_PollNextEventWithPose,
	(void*) fntable_System_021_impl_GetEventTypeNameFromEnum,
	(void*) fntable_System_021_impl_GetHiddenAreaMesh,
	(void*) fntable_System_021_impl_GetControllerState,
	(void*) fntable_System_021_impl_GetControllerStateWithPose,
	(void*) fntable_System_021_impl_TriggerHapticPulse,
	(void*) fntable_System_021_impl_GetButtonIdNameFromEnum,
	(void*) fntable_System_021_impl_GetControllerAxisTypeNameFromEnum,
	(void*) fntable_System_021_impl_IsInputAvailable,
	(void*) fntable_System_021_impl_IsSteamVRDrawingControllers,
	(void*) fntable_System_021_impl_ShouldApplicationPause,
	(void*) fntable_System_021_impl_ShouldApplicationReduceRenderingWork,
	(void*) fntable_System_021_impl_PerformFirmwareUpdate,
	(void*) fntable_System_021_impl_AcknowledgeQuit_Exiting,
	(void*) fntable_System_021_impl_GetAppContainerFilePaths,
	(void*) fntable_System_021_impl_GetRuntimeVersion,
};
void** CVRSystem_021::_GetStatFuncList() { fntable_System_021_instance = this; return fntable_System_021_funcs; }
void CVRSystem_021::Delete() { delete this; }
// Misc for CVRSystem_022:
CVRSystem_022::CVRSystem_022() : base(GetCreateBaseSystem()) {}
// Interface methods for CVRSystem_022:
void CVRSystem_022::GetRecommendedRenderTargetSize(uint32_t* pnWidth, uint32_t* pnHeight) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_022)");
	return base->GetRecommendedRenderTargetSize(pnWidth, pnHeight);
}
vr::HmdMatrix44_t CVRSystem_022::GetProjectionMatrix(vr::EVREye eEye, float fNearZ, float fFarZ) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_022)");
	return base->GetProjectionMatrix(eEye, fNearZ, fFarZ);
}
void CVRSystem_022::GetProjectionRaw(vr::EVREye eEye, float* pfLeft, float* pfRight, float* pfTop, float* pfBottom) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_022)");
	return base->GetProjectionRaw(eEye, pfLeft, pfRight, pfTop, pfBottom);
}
bool CVRSystem_022::ComputeDistortion(vr::EVREye eEye, float fU, float fV, vr::DistortionCoordinates_t* pDistortionCoordinates) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_022)");
	return base->ComputeDistortion(eEye, fU, fV, pDistortionCoordinates);
}
vr::HmdMatrix34_t CVRSystem_022::GetEyeToHeadTransform(vr::EVREye eEye) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_022)");
	return base->GetEyeToHeadTransform(eEye);
}
bool CVRSystem_022::GetTimeSinceLastVsync(float* pfSecondsSinceLastVsync, uint64_t* pulFrameCounter) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_022)");
	return base->GetTimeSinceLastVsync(pfSecondsSinceLastVsync, pulFrameCounter);
}
int32_t CVRSystem_022::GetD3D9AdapterIndex() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_022)");
	return base->GetD3D9AdapterIndex();
}
void CVRSystem_022::GetDXGIOutputInfo(int32_t* pnAdapterIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_022)");
	return base->GetDXGIOutputInfo(pnAdapterIndex);
}
void CVRSystem_022::GetOutputDevice(uint64_t* pnDevice, vr::ETextureType textureType, VkInstance_T* pInstance) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_022)");
	return base->GetOutputDevice(pnDevice, textureType, pInstance);
}
bool CVRSystem_022::IsDisplayOnDesktop() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_022)");
	return base->IsDisplayOnDesktop();
}
bool CVRSystem_022::SetDisplayVisibility(bool bIsVisibleOnDesktop) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_022)");
	return base->SetDisplayVisibility(bIsVisibleOnDesktop);
}
void CVRSystem_022::GetDeviceToAbsoluteTrackingPose(vr::ETrackingUniverseOrigin eOrigin, float fPredictedSecondsToPhotonsFromNow, vr::TrackedDevicePose_t* pTrackedDevicePoseArray, uint32_t unTrackedDevicePoseArrayCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_022)");
	return base->GetDeviceToAbsoluteTrackingPose(eOrigin, fPredictedSecondsToPhotonsFromNow, pTrackedDevicePoseArray, unTrackedDevicePoseArrayCount);
}
vr::HmdMatrix34_t CVRSystem_022::GetSeatedZeroPoseToStandingAbsoluteTrackingPose() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_022)");
	return base->GetSeatedZeroPoseToStandingAbsoluteTrackingPose();
}
vr::HmdMatrix34_t CVRSystem_022::GetRawZeroPoseToStandingAbsoluteTrackingPose() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_022)");
	return base->GetRawZeroPoseToStandingAbsoluteTrackingPose();
}
uint32_t CVRSystem_022::GetSortedTrackedDeviceIndicesOfClass(vr::ETrackedDeviceClass eTrackedDeviceClass, vr::TrackedDeviceIndex_t* punTrackedDeviceIndexArray, uint32_t unTrackedDeviceIndexArrayCount, vr::TrackedDeviceIndex_t unRelativeToTrackedDeviceIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_022)");
	return base->GetSortedTrackedDeviceIndicesOfClass(eTrackedDeviceClass, punTrackedDeviceIndexArray, unTrackedDeviceIndexArrayCount, unRelativeToTrackedDeviceIndex);
}
vr::EDeviceActivityLevel CVRSystem_022::GetTrackedDeviceActivityLevel(vr::TrackedDeviceIndex_t unDeviceId) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_022)");
	return base->GetTrackedDeviceActivityLevel(unDeviceId);
}
void CVRSystem_022::ApplyTransform(vr::TrackedDevicePose_t* pOutputPose, const vr::TrackedDevicePose_t* pTrackedDevicePose, const vr::HmdMatrix34_t* pTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_022)");
	return base->ApplyTransform(pOutputPose, pTrackedDevicePose, pTransform);
}
vr::TrackedDeviceIndex_t CVRSystem_022::GetTrackedDeviceIndexForControllerRole(vr::ETrackedControllerRole unDeviceType) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_022)");
	return base->GetTrackedDeviceIndexForControllerRole(unDeviceType);
}
vr::ETrackedControllerRole CVRSystem_022::GetControllerRoleForTrackedDeviceIndex(vr::TrackedDeviceIndex_t unDeviceIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_022)");
	return base->GetControllerRoleForTrackedDeviceIndex(unDeviceIndex);
}
vr::ETrackedDeviceClass CVRSystem_022::GetTrackedDeviceClass(vr::TrackedDeviceIndex_t unDeviceIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_022)");
	return base->GetTrackedDeviceClass(unDeviceIndex);
}
bool CVRSystem_022::IsTrackedDeviceConnected(vr::TrackedDeviceIndex_t unDeviceIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_022)");
	return base->IsTrackedDeviceConnected(unDeviceIndex);
}
bool CVRSystem_022::GetBoolTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_022)");
	return base->GetBoolTrackedDeviceProperty(unDeviceIndex, prop, pError);
}
float CVRSystem_022::GetFloatTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_022)");
	return base->GetFloatTrackedDeviceProperty(unDeviceIndex, prop, pError);
}
int32_t CVRSystem_022::GetInt32TrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_022)");
	return base->GetInt32TrackedDeviceProperty(unDeviceIndex, prop, pError);
}
uint64_t CVRSystem_022::GetUint64TrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_022)");
	return base->GetUint64TrackedDeviceProperty(unDeviceIndex, prop, pError);
}
vr::HmdMatrix34_t CVRSystem_022::GetMatrix34TrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_022)");
	return base->GetMatrix34TrackedDeviceProperty(unDeviceIndex, prop, pError);
}
uint32_t CVRSystem_022::GetArrayTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::PropertyTypeTag_t propType, void* pBuffer, uint32_t unBufferSize, vr::ETrackedPropertyError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_022)");
	return base->GetArrayTrackedDeviceProperty(unDeviceIndex, prop, propType, pBuffer, unBufferSize, pError);
}
uint32_t CVRSystem_022::GetStringTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, char* pchValue, uint32_t unBufferSize, vr::ETrackedPropertyError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_022)");
	return base->GetStringTrackedDeviceProperty(unDeviceIndex, prop, pchValue, unBufferSize, pError);
}
const char* CVRSystem_022::GetPropErrorNameFromEnum(vr::ETrackedPropertyError error) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_022)");
	return base->GetPropErrorNameFromEnum(error);
}
bool CVRSystem_022::PollNextEvent(vr::VREvent_t* pEvent, uint32_t uncbVREvent) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_022)");
	return base->PollNextEvent(pEvent, uncbVREvent);
}
bool CVRSystem_022::PollNextEventWithPose(vr::ETrackingUniverseOrigin eOrigin, vr::VREvent_t* pEvent, uint32_t uncbVREvent, vr::TrackedDevicePose_t* pTrackedDevicePose) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_022)");
	return base->PollNextEventWithPose(eOrigin, pEvent, uncbVREvent, pTrackedDevicePose);
}
const char* CVRSystem_022::GetEventTypeNameFromEnum(vr::EVREventType eType) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_022)");
	return base->GetEventTypeNameFromEnum(eType);
}
vr::HiddenAreaMesh_t CVRSystem_022::GetHiddenAreaMesh(vr::EVREye eEye, vr::EHiddenAreaMeshType type) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_022)");
	return base->GetHiddenAreaMesh(eEye, type);
}
bool CVRSystem_022::GetControllerState(vr::TrackedDeviceIndex_t unControllerDeviceIndex, vr::VRControllerState_t* pControllerState, uint32_t unControllerStateSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_022)");
	return base->GetControllerState(unControllerDeviceIndex, pControllerState, unControllerStateSize);
}
bool CVRSystem_022::GetControllerStateWithPose(vr::ETrackingUniverseOrigin eOrigin, vr::TrackedDeviceIndex_t unControllerDeviceIndex, vr::VRControllerState_t* pControllerState, uint32_t unControllerStateSize, vr::TrackedDevicePose_t* pTrackedDevicePose) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_022)");
	return base->GetControllerStateWithPose(eOrigin, unControllerDeviceIndex, pControllerState, unControllerStateSize, pTrackedDevicePose);
}
void CVRSystem_022::TriggerHapticPulse(vr::TrackedDeviceIndex_t unControllerDeviceIndex, uint32_t unAxisId, unsigned short usDurationMicroSec) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_022)");
	return base->TriggerHapticPulse(unControllerDeviceIndex, unAxisId, usDurationMicroSec);
}
const char* CVRSystem_022::GetButtonIdNameFromEnum(vr::EVRButtonId eButtonId) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_022)");
	return base->GetButtonIdNameFromEnum(eButtonId);
}
const char* CVRSystem_022::GetControllerAxisTypeNameFromEnum(vr::EVRControllerAxisType eAxisType) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_022)");
	return base->GetControllerAxisTypeNameFromEnum(eAxisType);
}
bool CVRSystem_022::IsInputAvailable() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_022)");
	return base->IsInputAvailable();
}
bool CVRSystem_022::IsSteamVRDrawingControllers() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_022)");
	return base->IsSteamVRDrawingControllers();
}
bool CVRSystem_022::ShouldApplicationPause() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_022)");
	return base->ShouldApplicationPause();
}
bool CVRSystem_022::ShouldApplicationReduceRenderingWork() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_022)");
	return base->ShouldApplicationReduceRenderingWork();
}
vr::EVRFirmwareError CVRSystem_022::PerformFirmwareUpdate(vr::TrackedDeviceIndex_t unDeviceIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_022)");
	return base->PerformFirmwareUpdate(unDeviceIndex);
}
void CVRSystem_022::AcknowledgeQuit_Exiting() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_022)");
	return base->AcknowledgeQuit_Exiting();
}
uint32_t CVRSystem_022::GetAppContainerFilePaths(char* pchBuffer, uint32_t unBufferSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_022)");
	return base->GetAppContainerFilePaths(pchBuffer, unBufferSize);
}
const char* CVRSystem_022::GetRuntimeVersion() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSystem_022)");
	return base->GetRuntimeVersion();
}
// FnTable for CVRSystem_022:
static CVRSystem_022 *fntable_System_022_instance = NULL;
static void OPENVR_FNTABLE_CALLTYPE fntable_System_022_impl_GetRecommendedRenderTargetSize(uint32_t* pnWidth, uint32_t* pnHeight) { return fntable_System_022_instance->GetRecommendedRenderTargetSize(pnWidth, pnHeight); }
static vr::HmdMatrix44_t OPENVR_FNTABLE_CALLTYPE fntable_System_022_impl_GetProjectionMatrix(vr::EVREye eEye, float fNearZ, float fFarZ) { return fntable_System_022_instance->GetProjectionMatrix(eEye, fNearZ, fFarZ); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_022_impl_GetProjectionRaw(vr::EVREye eEye, float* pfLeft, float* pfRight, float* pfTop, float* pfBottom) { return fntable_System_022_instance->GetProjectionRaw(eEye, pfLeft, pfRight, pfTop, pfBottom); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_022_impl_ComputeDistortion(vr::EVREye eEye, float fU, float fV, vr::DistortionCoordinates_t* pDistortionCoordinates) { return fntable_System_022_instance->ComputeDistortion(eEye, fU, fV, pDistortionCoordinates); }
static vr::HmdMatrix34_t OPENVR_FNTABLE_CALLTYPE fntable_System_022_impl_GetEyeToHeadTransform(vr::EVREye eEye) { return fntable_System_022_instance->GetEyeToHeadTransform(eEye); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_022_impl_GetTimeSinceLastVsync(float* pfSecondsSinceLastVsync, uint64_t* pulFrameCounter) { return fntable_System_022_instance->GetTimeSinceLastVsync(pfSecondsSinceLastVsync, pulFrameCounter); }
static int32_t OPENVR_FNTABLE_CALLTYPE fntable_System_022_impl_GetD3D9AdapterIndex() { return fntable_System_022_instance->GetD3D9AdapterIndex(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_022_impl_GetDXGIOutputInfo(int32_t* pnAdapterIndex) { return fntable_System_022_instance->GetDXGIOutputInfo(pnAdapterIndex); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_022_impl_GetOutputDevice(uint64_t* pnDevice, vr::ETextureType textureType, VkInstance_T* pInstance) { return fntable_System_022_instance->GetOutputDevice(pnDevice, textureType, pInstance); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_022_impl_IsDisplayOnDesktop() { return fntable_System_022_instance->IsDisplayOnDesktop(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_022_impl_SetDisplayVisibility(bool bIsVisibleOnDesktop) { return fntable_System_022_instance->SetDisplayVisibility(bIsVisibleOnDesktop); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_022_impl_GetDeviceToAbsoluteTrackingPose(vr::ETrackingUniverseOrigin eOrigin, float fPredictedSecondsToPhotonsFromNow, vr::TrackedDevicePose_t* pTrackedDevicePoseArray, uint32_t unTrackedDevicePoseArrayCount) { return fntable_System_022_instance->GetDeviceToAbsoluteTrackingPose(eOrigin, fPredictedSecondsToPhotonsFromNow, pTrackedDevicePoseArray, unTrackedDevicePoseArrayCount); }
static vr::HmdMatrix34_t OPENVR_FNTABLE_CALLTYPE fntable_System_022_impl_GetSeatedZeroPoseToStandingAbsoluteTrackingPose() { return fntable_System_022_instance->GetSeatedZeroPoseToStandingAbsoluteTrackingPose(); }
static vr::HmdMatrix34_t OPENVR_FNTABLE_CALLTYPE fntable_System_022_impl_GetRawZeroPoseToStandingAbsoluteTrackingPose() { return fntable_System_022_instance->GetRawZeroPoseToStandingAbsoluteTrackingPose(); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_System_022_impl_GetSortedTrackedDeviceIndicesOfClass(vr::ETrackedDeviceClass eTrackedDeviceClass, vr::TrackedDeviceIndex_t* punTrackedDeviceIndexArray, uint32_t unTrackedDeviceIndexArrayCount, vr::TrackedDeviceIndex_t unRelativeToTrackedDeviceIndex) { return fntable_System_022_instance->GetSortedTrackedDeviceIndicesOfClass(eTrackedDeviceClass, punTrackedDeviceIndexArray, unTrackedDeviceIndexArrayCount, unRelativeToTrackedDeviceIndex); }
static vr::EDeviceActivityLevel OPENVR_FNTABLE_CALLTYPE fntable_System_022_impl_GetTrackedDeviceActivityLevel(vr::TrackedDeviceIndex_t unDeviceId) { return fntable_System_022_instance->GetTrackedDeviceActivityLevel(unDeviceId); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_022_impl_ApplyTransform(vr::TrackedDevicePose_t* pOutputPose, const vr::TrackedDevicePose_t* pTrackedDevicePose, const vr::HmdMatrix34_t* pTransform) { return fntable_System_022_instance->ApplyTransform(pOutputPose, pTrackedDevicePose, pTransform); }
static vr::TrackedDeviceIndex_t OPENVR_FNTABLE_CALLTYPE fntable_System_022_impl_GetTrackedDeviceIndexForControllerRole(vr::ETrackedControllerRole unDeviceType) { return fntable_System_022_instance->GetTrackedDeviceIndexForControllerRole(unDeviceType); }
static vr::ETrackedControllerRole OPENVR_FNTABLE_CALLTYPE fntable_System_022_impl_GetControllerRoleForTrackedDeviceIndex(vr::TrackedDeviceIndex_t unDeviceIndex) { return fntable_System_022_instance->GetControllerRoleForTrackedDeviceIndex(unDeviceIndex); }
static vr::ETrackedDeviceClass OPENVR_FNTABLE_CALLTYPE fntable_System_022_impl_GetTrackedDeviceClass(vr::TrackedDeviceIndex_t unDeviceIndex) { return fntable_System_022_instance->GetTrackedDeviceClass(unDeviceIndex); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_022_impl_IsTrackedDeviceConnected(vr::TrackedDeviceIndex_t unDeviceIndex) { return fntable_System_022_instance->IsTrackedDeviceConnected(unDeviceIndex); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_022_impl_GetBoolTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) { return fntable_System_022_instance->GetBoolTrackedDeviceProperty(unDeviceIndex, prop, pError); }
static float OPENVR_FNTABLE_CALLTYPE fntable_System_022_impl_GetFloatTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) { return fntable_System_022_instance->GetFloatTrackedDeviceProperty(unDeviceIndex, prop, pError); }
static int32_t OPENVR_FNTABLE_CALLTYPE fntable_System_022_impl_GetInt32TrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) { return fntable_System_022_instance->GetInt32TrackedDeviceProperty(unDeviceIndex, prop, pError); }
static uint64_t OPENVR_FNTABLE_CALLTYPE fntable_System_022_impl_GetUint64TrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) { return fntable_System_022_instance->GetUint64TrackedDeviceProperty(unDeviceIndex, prop, pError); }
static vr::HmdMatrix34_t OPENVR_FNTABLE_CALLTYPE fntable_System_022_impl_GetMatrix34TrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::ETrackedPropertyError* pError) { return fntable_System_022_instance->GetMatrix34TrackedDeviceProperty(unDeviceIndex, prop, pError); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_System_022_impl_GetArrayTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, vr::PropertyTypeTag_t propType, void* pBuffer, uint32_t unBufferSize, vr::ETrackedPropertyError* pError) { return fntable_System_022_instance->GetArrayTrackedDeviceProperty(unDeviceIndex, prop, propType, pBuffer, unBufferSize, pError); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_System_022_impl_GetStringTrackedDeviceProperty(vr::TrackedDeviceIndex_t unDeviceIndex, vr::ETrackedDeviceProperty prop, char* pchValue, uint32_t unBufferSize, vr::ETrackedPropertyError* pError) { return fntable_System_022_instance->GetStringTrackedDeviceProperty(unDeviceIndex, prop, pchValue, unBufferSize, pError); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_System_022_impl_GetPropErrorNameFromEnum(vr::ETrackedPropertyError error) { return fntable_System_022_instance->GetPropErrorNameFromEnum(error); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_022_impl_PollNextEvent(vr::VREvent_t* pEvent, uint32_t uncbVREvent) { return fntable_System_022_instance->PollNextEvent(pEvent, uncbVREvent); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_022_impl_PollNextEventWithPose(vr::ETrackingUniverseOrigin eOrigin, vr::VREvent_t* pEvent, uint32_t uncbVREvent, vr::TrackedDevicePose_t* pTrackedDevicePose) { return fntable_System_022_instance->PollNextEventWithPose(eOrigin, pEvent, uncbVREvent, pTrackedDevicePose); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_System_022_impl_GetEventTypeNameFromEnum(vr::EVREventType eType) { return fntable_System_022_instance->GetEventTypeNameFromEnum(eType); }
static vr::HiddenAreaMesh_t OPENVR_FNTABLE_CALLTYPE fntable_System_022_impl_GetHiddenAreaMesh(vr::EVREye eEye, vr::EHiddenAreaMeshType type) { return fntable_System_022_instance->GetHiddenAreaMesh(eEye, type); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_022_impl_GetControllerState(vr::TrackedDeviceIndex_t unControllerDeviceIndex, vr::VRControllerState_t* pControllerState, uint32_t unControllerStateSize) { return fntable_System_022_instance->GetControllerState(unControllerDeviceIndex, pControllerState, unControllerStateSize); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_022_impl_GetControllerStateWithPose(vr::ETrackingUniverseOrigin eOrigin, vr::TrackedDeviceIndex_t unControllerDeviceIndex, vr::VRControllerState_t* pControllerState, uint32_t unControllerStateSize, vr::TrackedDevicePose_t* pTrackedDevicePose) { return fntable_System_022_instance->GetControllerStateWithPose(eOrigin, unControllerDeviceIndex, pControllerState, unControllerStateSize, pTrackedDevicePose); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_022_impl_TriggerHapticPulse(vr::TrackedDeviceIndex_t unControllerDeviceIndex, uint32_t unAxisId, unsigned short usDurationMicroSec) { return fntable_System_022_instance->TriggerHapticPulse(unControllerDeviceIndex, unAxisId, usDurationMicroSec); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_System_022_impl_GetButtonIdNameFromEnum(vr::EVRButtonId eButtonId) { return fntable_System_022_instance->GetButtonIdNameFromEnum(eButtonId); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_System_022_impl_GetControllerAxisTypeNameFromEnum(vr::EVRControllerAxisType eAxisType) { return fntable_System_022_instance->GetControllerAxisTypeNameFromEnum(eAxisType); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_022_impl_IsInputAvailable() { return fntable_System_022_instance->IsInputAvailable(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_022_impl_IsSteamVRDrawingControllers() { return fntable_System_022_instance->IsSteamVRDrawingControllers(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_022_impl_ShouldApplicationPause() { return fntable_System_022_instance->ShouldApplicationPause(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_System_022_impl_ShouldApplicationReduceRenderingWork() { return fntable_System_022_instance->ShouldApplicationReduceRenderingWork(); }
static vr::EVRFirmwareError OPENVR_FNTABLE_CALLTYPE fntable_System_022_impl_PerformFirmwareUpdate(vr::TrackedDeviceIndex_t unDeviceIndex) { return fntable_System_022_instance->PerformFirmwareUpdate(unDeviceIndex); }
static void OPENVR_FNTABLE_CALLTYPE fntable_System_022_impl_AcknowledgeQuit_Exiting() { return fntable_System_022_instance->AcknowledgeQuit_Exiting(); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_System_022_impl_GetAppContainerFilePaths(char* pchBuffer, uint32_t unBufferSize) { return fntable_System_022_instance->GetAppContainerFilePaths(pchBuffer, unBufferSize); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_System_022_impl_GetRuntimeVersion() { return fntable_System_022_instance->GetRuntimeVersion(); }
static void *fntable_System_022_funcs[] = {
	(void*) fntable_System_022_impl_GetRecommendedRenderTargetSize,
	(void*) fntable_System_022_impl_GetProjectionMatrix,
	(void*) fntable_System_022_impl_GetProjectionRaw,
	(void*) fntable_System_022_impl_ComputeDistortion,
	(void*) fntable_System_022_impl_GetEyeToHeadTransform,
	(void*) fntable_System_022_impl_GetTimeSinceLastVsync,
	(void*) fntable_System_022_impl_GetD3D9AdapterIndex,
	(void*) fntable_System_022_impl_GetDXGIOutputInfo,
	(void*) fntable_System_022_impl_GetOutputDevice,
	(void*) fntable_System_022_impl_IsDisplayOnDesktop,
	(void*) fntable_System_022_impl_SetDisplayVisibility,
	(void*) fntable_System_022_impl_GetDeviceToAbsoluteTrackingPose,
	(void*) fntable_System_022_impl_GetSeatedZeroPoseToStandingAbsoluteTrackingPose,
	(void*) fntable_System_022_impl_GetRawZeroPoseToStandingAbsoluteTrackingPose,
	(void*) fntable_System_022_impl_GetSortedTrackedDeviceIndicesOfClass,
	(void*) fntable_System_022_impl_GetTrackedDeviceActivityLevel,
	(void*) fntable_System_022_impl_ApplyTransform,
	(void*) fntable_System_022_impl_GetTrackedDeviceIndexForControllerRole,
	(void*) fntable_System_022_impl_GetControllerRoleForTrackedDeviceIndex,
	(void*) fntable_System_022_impl_GetTrackedDeviceClass,
	(void*) fntable_System_022_impl_IsTrackedDeviceConnected,
	(void*) fntable_System_022_impl_GetBoolTrackedDeviceProperty,
	(void*) fntable_System_022_impl_GetFloatTrackedDeviceProperty,
	(void*) fntable_System_022_impl_GetInt32TrackedDeviceProperty,
	(void*) fntable_System_022_impl_GetUint64TrackedDeviceProperty,
	(void*) fntable_System_022_impl_GetMatrix34TrackedDeviceProperty,
	(void*) fntable_System_022_impl_GetArrayTrackedDeviceProperty,
	(void*) fntable_System_022_impl_GetStringTrackedDeviceProperty,
	(void*) fntable_System_022_impl_GetPropErrorNameFromEnum,
	(void*) fntable_System_022_impl_PollNextEvent,
	(void*) fntable_System_022_impl_PollNextEventWithPose,
	(void*) fntable_System_022_impl_GetEventTypeNameFromEnum,
	(void*) fntable_System_022_impl_GetHiddenAreaMesh,
	(void*) fntable_System_022_impl_GetControllerState,
	(void*) fntable_System_022_impl_GetControllerStateWithPose,
	(void*) fntable_System_022_impl_TriggerHapticPulse,
	(void*) fntable_System_022_impl_GetButtonIdNameFromEnum,
	(void*) fntable_System_022_impl_GetControllerAxisTypeNameFromEnum,
	(void*) fntable_System_022_impl_IsInputAvailable,
	(void*) fntable_System_022_impl_IsSteamVRDrawingControllers,
	(void*) fntable_System_022_impl_ShouldApplicationPause,
	(void*) fntable_System_022_impl_ShouldApplicationReduceRenderingWork,
	(void*) fntable_System_022_impl_PerformFirmwareUpdate,
	(void*) fntable_System_022_impl_AcknowledgeQuit_Exiting,
	(void*) fntable_System_022_impl_GetAppContainerFilePaths,
	(void*) fntable_System_022_impl_GetRuntimeVersion,
};
void** CVRSystem_022::_GetStatFuncList() { fntable_System_022_instance = this; return fntable_System_022_funcs; }
void CVRSystem_022::Delete() { delete this; }
#include "GVRChaperone.gen.h"
// Single inst of BaseChaperone
static std::weak_ptr<BaseChaperone> _single_inst_Chaperone;
static BaseChaperone *_single_inst_Chaperone_unsafe = NULL;
std::shared_ptr<BaseChaperone> GetBaseChaperone() { return _single_inst_Chaperone.lock(); };
BaseChaperone* GetUnsafeBaseChaperone() { return _single_inst_Chaperone_unsafe; };
std::shared_ptr<BaseChaperone> GetCreateBaseChaperone() {
	std::shared_ptr<BaseChaperone> ret = _single_inst_Chaperone.lock();
	if(!ret) {
		ret = std::shared_ptr<BaseChaperone>(new BaseChaperone(), [](BaseChaperone *obj){ _single_inst_Chaperone_unsafe = NULL; delete obj; });
		_single_inst_Chaperone = ret;
		_single_inst_Chaperone_unsafe = ret.get();
	}
	return ret;
}
// Misc for CVRChaperone_003:
CVRChaperone_003::CVRChaperone_003() : base(GetCreateBaseChaperone()) {}
// Interface methods for CVRChaperone_003:
vr::IVRChaperone_003::ChaperoneCalibrationState CVRChaperone_003::GetCalibrationState() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRChaperone_003)");
	return (vr::IVRChaperone_003::ChaperoneCalibrationState) base->GetCalibrationState();
}
bool CVRChaperone_003::GetPlayAreaSize(float* pSizeX, float* pSizeZ) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRChaperone_003)");
	return base->GetPlayAreaSize(pSizeX, pSizeZ);
}
bool CVRChaperone_003::GetPlayAreaRect(vr::HmdQuad_t* rect) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRChaperone_003)");
	return base->GetPlayAreaRect(rect);
}
void CVRChaperone_003::ReloadInfo() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRChaperone_003)");
	return base->ReloadInfo();
}
void CVRChaperone_003::SetSceneColor(vr::HmdColor_t color) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRChaperone_003)");
	return base->SetSceneColor(color);
}
void CVRChaperone_003::GetBoundsColor(vr::HmdColor_t* pOutputColorArray, int nNumOutputColors, float flCollisionBoundsFadeDistance, vr::HmdColor_t* pOutputCameraColor) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRChaperone_003)");
	return base->GetBoundsColor(pOutputColorArray, nNumOutputColors, flCollisionBoundsFadeDistance, pOutputCameraColor);
}
bool CVRChaperone_003::AreBoundsVisible() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRChaperone_003)");
	return base->AreBoundsVisible();
}
void CVRChaperone_003::ForceBoundsVisible(bool bForce) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRChaperone_003)");
	return base->ForceBoundsVisible(bForce);
}
// FnTable for CVRChaperone_003:
static CVRChaperone_003 *fntable_Chaperone_003_instance = NULL;
static vr::IVRChaperone_003::ChaperoneCalibrationState OPENVR_FNTABLE_CALLTYPE fntable_Chaperone_003_impl_GetCalibrationState() { return fntable_Chaperone_003_instance->GetCalibrationState(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Chaperone_003_impl_GetPlayAreaSize(float* pSizeX, float* pSizeZ) { return fntable_Chaperone_003_instance->GetPlayAreaSize(pSizeX, pSizeZ); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Chaperone_003_impl_GetPlayAreaRect(vr::HmdQuad_t* rect) { return fntable_Chaperone_003_instance->GetPlayAreaRect(rect); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Chaperone_003_impl_ReloadInfo() { return fntable_Chaperone_003_instance->ReloadInfo(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Chaperone_003_impl_SetSceneColor(vr::HmdColor_t color) { return fntable_Chaperone_003_instance->SetSceneColor(color); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Chaperone_003_impl_GetBoundsColor(vr::HmdColor_t* pOutputColorArray, int nNumOutputColors, float flCollisionBoundsFadeDistance, vr::HmdColor_t* pOutputCameraColor) { return fntable_Chaperone_003_instance->GetBoundsColor(pOutputColorArray, nNumOutputColors, flCollisionBoundsFadeDistance, pOutputCameraColor); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Chaperone_003_impl_AreBoundsVisible() { return fntable_Chaperone_003_instance->AreBoundsVisible(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Chaperone_003_impl_ForceBoundsVisible(bool bForce) { return fntable_Chaperone_003_instance->ForceBoundsVisible(bForce); }
static void *fntable_Chaperone_003_funcs[] = {
	(void*) fntable_Chaperone_003_impl_GetCalibrationState,
	(void*) fntable_Chaperone_003_impl_GetPlayAreaSize,
	(void*) fntable_Chaperone_003_impl_GetPlayAreaRect,
	(void*) fntable_Chaperone_003_impl_ReloadInfo,
	(void*) fntable_Chaperone_003_impl_SetSceneColor,
	(void*) fntable_Chaperone_003_impl_GetBoundsColor,
	(void*) fntable_Chaperone_003_impl_AreBoundsVisible,
	(void*) fntable_Chaperone_003_impl_ForceBoundsVisible,
};
void** CVRChaperone_003::_GetStatFuncList() { fntable_Chaperone_003_instance = this; return fntable_Chaperone_003_funcs; }
void CVRChaperone_003::Delete() { delete this; }
// Misc for CVRChaperone_004:
CVRChaperone_004::CVRChaperone_004() : base(GetCreateBaseChaperone()) {}
// Interface methods for CVRChaperone_004:
vr::IVRChaperone_004::ChaperoneCalibrationState CVRChaperone_004::GetCalibrationState() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRChaperone_004)");
	return (vr::IVRChaperone_004::ChaperoneCalibrationState) base->GetCalibrationState();
}
bool CVRChaperone_004::GetPlayAreaSize(float* pSizeX, float* pSizeZ) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRChaperone_004)");
	return base->GetPlayAreaSize(pSizeX, pSizeZ);
}
bool CVRChaperone_004::GetPlayAreaRect(vr::HmdQuad_t* rect) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRChaperone_004)");
	return base->GetPlayAreaRect(rect);
}
void CVRChaperone_004::ReloadInfo() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRChaperone_004)");
	return base->ReloadInfo();
}
void CVRChaperone_004::SetSceneColor(vr::HmdColor_t color) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRChaperone_004)");
	return base->SetSceneColor(color);
}
void CVRChaperone_004::GetBoundsColor(vr::HmdColor_t* pOutputColorArray, int nNumOutputColors, float flCollisionBoundsFadeDistance, vr::HmdColor_t* pOutputCameraColor) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRChaperone_004)");
	return base->GetBoundsColor(pOutputColorArray, nNumOutputColors, flCollisionBoundsFadeDistance, pOutputCameraColor);
}
bool CVRChaperone_004::AreBoundsVisible() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRChaperone_004)");
	return base->AreBoundsVisible();
}
void CVRChaperone_004::ForceBoundsVisible(bool bForce) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRChaperone_004)");
	return base->ForceBoundsVisible(bForce);
}
void CVRChaperone_004::ResetZeroPose(vr::ETrackingUniverseOrigin eTrackingUniverseOrigin) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRChaperone_004)");
	return base->ResetZeroPose(eTrackingUniverseOrigin);
}
// FnTable for CVRChaperone_004:
static CVRChaperone_004 *fntable_Chaperone_004_instance = NULL;
static vr::IVRChaperone_004::ChaperoneCalibrationState OPENVR_FNTABLE_CALLTYPE fntable_Chaperone_004_impl_GetCalibrationState() { return fntable_Chaperone_004_instance->GetCalibrationState(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Chaperone_004_impl_GetPlayAreaSize(float* pSizeX, float* pSizeZ) { return fntable_Chaperone_004_instance->GetPlayAreaSize(pSizeX, pSizeZ); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Chaperone_004_impl_GetPlayAreaRect(vr::HmdQuad_t* rect) { return fntable_Chaperone_004_instance->GetPlayAreaRect(rect); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Chaperone_004_impl_ReloadInfo() { return fntable_Chaperone_004_instance->ReloadInfo(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Chaperone_004_impl_SetSceneColor(vr::HmdColor_t color) { return fntable_Chaperone_004_instance->SetSceneColor(color); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Chaperone_004_impl_GetBoundsColor(vr::HmdColor_t* pOutputColorArray, int nNumOutputColors, float flCollisionBoundsFadeDistance, vr::HmdColor_t* pOutputCameraColor) { return fntable_Chaperone_004_instance->GetBoundsColor(pOutputColorArray, nNumOutputColors, flCollisionBoundsFadeDistance, pOutputCameraColor); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Chaperone_004_impl_AreBoundsVisible() { return fntable_Chaperone_004_instance->AreBoundsVisible(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Chaperone_004_impl_ForceBoundsVisible(bool bForce) { return fntable_Chaperone_004_instance->ForceBoundsVisible(bForce); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Chaperone_004_impl_ResetZeroPose(vr::ETrackingUniverseOrigin eTrackingUniverseOrigin) { return fntable_Chaperone_004_instance->ResetZeroPose(eTrackingUniverseOrigin); }
static void *fntable_Chaperone_004_funcs[] = {
	(void*) fntable_Chaperone_004_impl_GetCalibrationState,
	(void*) fntable_Chaperone_004_impl_GetPlayAreaSize,
	(void*) fntable_Chaperone_004_impl_GetPlayAreaRect,
	(void*) fntable_Chaperone_004_impl_ReloadInfo,
	(void*) fntable_Chaperone_004_impl_SetSceneColor,
	(void*) fntable_Chaperone_004_impl_GetBoundsColor,
	(void*) fntable_Chaperone_004_impl_AreBoundsVisible,
	(void*) fntable_Chaperone_004_impl_ForceBoundsVisible,
	(void*) fntable_Chaperone_004_impl_ResetZeroPose,
};
void** CVRChaperone_004::_GetStatFuncList() { fntable_Chaperone_004_instance = this; return fntable_Chaperone_004_funcs; }
void CVRChaperone_004::Delete() { delete this; }
#include "GVROverlay.gen.h"
// Single inst of BaseOverlay
static std::weak_ptr<BaseOverlay> _single_inst_Overlay;
static BaseOverlay *_single_inst_Overlay_unsafe = NULL;
std::shared_ptr<BaseOverlay> GetBaseOverlay() { return _single_inst_Overlay.lock(); };
BaseOverlay* GetUnsafeBaseOverlay() { return _single_inst_Overlay_unsafe; };
std::shared_ptr<BaseOverlay> GetCreateBaseOverlay() {
	std::shared_ptr<BaseOverlay> ret = _single_inst_Overlay.lock();
	if(!ret) {
		ret = std::shared_ptr<BaseOverlay>(new BaseOverlay(), [](BaseOverlay *obj){ _single_inst_Overlay_unsafe = NULL; delete obj; });
		_single_inst_Overlay = ret;
		_single_inst_Overlay_unsafe = ret.get();
	}
	return ret;
}
// Misc for CVROverlay_007:
CVROverlay_007::CVROverlay_007() : base(GetCreateBaseOverlay()) {}
// Interface methods for CVROverlay_007:
vr::EVROverlayError CVROverlay_007::FindOverlay(const char* pchOverlayKey, vr::VROverlayHandle_t* pOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_007)");
	return base->FindOverlay(pchOverlayKey, pOverlayHandle);
}
vr::EVROverlayError CVROverlay_007::CreateOverlay(const char* pchOverlayKey, const char* pchOverlayFriendlyName, vr::VROverlayHandle_t* pOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_007)");
	return base->CreateOverlay(pchOverlayKey, pchOverlayFriendlyName, pOverlayHandle);
}
vr::EVROverlayError CVROverlay_007::DestroyOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_007)");
	return base->DestroyOverlay(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_007::SetHighQualityOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_007)");
	return base->SetHighQualityOverlay(ulOverlayHandle);
}
vr::VROverlayHandle_t CVROverlay_007::GetHighQualityOverlay() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_007)");
	return base->GetHighQualityOverlay();
}
uint32_t CVROverlay_007::GetOverlayKey(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::EVROverlayError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_007)");
	return base->GetOverlayKey(ulOverlayHandle, pchValue, unBufferSize, pError);
}
uint32_t CVROverlay_007::GetOverlayName(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::EVROverlayError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_007)");
	return base->GetOverlayName(ulOverlayHandle, pchValue, unBufferSize, pError);
}
vr::EVROverlayError CVROverlay_007::GetOverlayImageData(vr::VROverlayHandle_t ulOverlayHandle, void* pvBuffer, uint32_t unBufferSize, uint32_t* punWidth, uint32_t* punHeight) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_007)");
	return base->GetOverlayImageData(ulOverlayHandle, pvBuffer, unBufferSize, punWidth, punHeight);
}
const char* CVROverlay_007::GetOverlayErrorNameFromEnum(vr::EVROverlayError error) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_007)");
	return base->GetOverlayErrorNameFromEnum(error);
}
vr::EVROverlayError CVROverlay_007::SetOverlayFlag(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_007::VROverlayFlags eOverlayFlag, bool bEnabled) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_007)");
	return base->SetOverlayFlag(ulOverlayHandle, (OOVR_VROverlayFlags) eOverlayFlag, bEnabled);
}
vr::EVROverlayError CVROverlay_007::GetOverlayFlag(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_007::VROverlayFlags eOverlayFlag, bool* pbEnabled) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_007)");
	return base->GetOverlayFlag(ulOverlayHandle, (OOVR_VROverlayFlags) eOverlayFlag, pbEnabled);
}
vr::EVROverlayError CVROverlay_007::SetOverlayColor(vr::VROverlayHandle_t ulOverlayHandle, float fRed, float fGreen, float fBlue) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_007)");
	return base->SetOverlayColor(ulOverlayHandle, fRed, fGreen, fBlue);
}
vr::EVROverlayError CVROverlay_007::GetOverlayColor(vr::VROverlayHandle_t ulOverlayHandle, float* pfRed, float* pfGreen, float* pfBlue) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_007)");
	return base->GetOverlayColor(ulOverlayHandle, pfRed, pfGreen, pfBlue);
}
vr::EVROverlayError CVROverlay_007::SetOverlayAlpha(vr::VROverlayHandle_t ulOverlayHandle, float fAlpha) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_007)");
	return base->SetOverlayAlpha(ulOverlayHandle, fAlpha);
}
vr::EVROverlayError CVROverlay_007::GetOverlayAlpha(vr::VROverlayHandle_t ulOverlayHandle, float* pfAlpha) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_007)");
	return base->GetOverlayAlpha(ulOverlayHandle, pfAlpha);
}
vr::EVROverlayError CVROverlay_007::SetOverlayWidthInMeters(vr::VROverlayHandle_t ulOverlayHandle, float fWidthInMeters) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_007)");
	return base->SetOverlayWidthInMeters(ulOverlayHandle, fWidthInMeters);
}
vr::EVROverlayError CVROverlay_007::GetOverlayWidthInMeters(vr::VROverlayHandle_t ulOverlayHandle, float* pfWidthInMeters) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_007)");
	return base->GetOverlayWidthInMeters(ulOverlayHandle, pfWidthInMeters);
}
vr::EVROverlayError CVROverlay_007::SetOverlayAutoCurveDistanceRangeInMeters(vr::VROverlayHandle_t ulOverlayHandle, float fMinDistanceInMeters, float fMaxDistanceInMeters) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_007)");
	return base->SetOverlayAutoCurveDistanceRangeInMeters(ulOverlayHandle, fMinDistanceInMeters, fMaxDistanceInMeters);
}
vr::EVROverlayError CVROverlay_007::GetOverlayAutoCurveDistanceRangeInMeters(vr::VROverlayHandle_t ulOverlayHandle, float* pfMinDistanceInMeters, float* pfMaxDistanceInMeters) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_007)");
	return base->GetOverlayAutoCurveDistanceRangeInMeters(ulOverlayHandle, pfMinDistanceInMeters, pfMaxDistanceInMeters);
}
vr::EVROverlayError CVROverlay_007::SetOverlayTextureColorSpace(vr::VROverlayHandle_t ulOverlayHandle, vr::EColorSpace eTextureColorSpace) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_007)");
	return base->SetOverlayTextureColorSpace(ulOverlayHandle, eTextureColorSpace);
}
vr::EVROverlayError CVROverlay_007::GetOverlayTextureColorSpace(vr::VROverlayHandle_t ulOverlayHandle, vr::EColorSpace* peTextureColorSpace) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_007)");
	return base->GetOverlayTextureColorSpace(ulOverlayHandle, peTextureColorSpace);
}
vr::EVROverlayError CVROverlay_007::SetOverlayTextureBounds(vr::VROverlayHandle_t ulOverlayHandle, const vr::VRTextureBounds_t* pOverlayTextureBounds) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_007)");
	return base->SetOverlayTextureBounds(ulOverlayHandle, pOverlayTextureBounds);
}
vr::EVROverlayError CVROverlay_007::GetOverlayTextureBounds(vr::VROverlayHandle_t ulOverlayHandle, vr::VRTextureBounds_t* pOverlayTextureBounds) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_007)");
	return base->GetOverlayTextureBounds(ulOverlayHandle, pOverlayTextureBounds);
}
vr::EVROverlayError CVROverlay_007::GetOverlayTransformType(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_007::VROverlayTransformType* peTransformType) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_007)");
	return base->GetOverlayTransformType(ulOverlayHandle, (OOVR_VROverlayTransformType*) peTransformType);
}
vr::EVROverlayError CVROverlay_007::SetOverlayTransformAbsolute(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin eTrackingOrigin, const vr::HmdMatrix34_t* pmatTrackingOriginToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_007)");
	return base->SetOverlayTransformAbsolute(ulOverlayHandle, eTrackingOrigin, pmatTrackingOriginToOverlayTransform);
}
vr::EVROverlayError CVROverlay_007::GetOverlayTransformAbsolute(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin* peTrackingOrigin, vr::HmdMatrix34_t* pmatTrackingOriginToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_007)");
	return base->GetOverlayTransformAbsolute(ulOverlayHandle, peTrackingOrigin, pmatTrackingOriginToOverlayTransform);
}
vr::EVROverlayError CVROverlay_007::SetOverlayTransformTrackedDeviceRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unTrackedDevice, const vr::HmdMatrix34_t* pmatTrackedDeviceToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_007)");
	return base->SetOverlayTransformTrackedDeviceRelative(ulOverlayHandle, unTrackedDevice, pmatTrackedDeviceToOverlayTransform);
}
vr::EVROverlayError CVROverlay_007::GetOverlayTransformTrackedDeviceRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t* punTrackedDevice, vr::HmdMatrix34_t* pmatTrackedDeviceToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_007)");
	return base->GetOverlayTransformTrackedDeviceRelative(ulOverlayHandle, punTrackedDevice, pmatTrackedDeviceToOverlayTransform);
}
vr::EVROverlayError CVROverlay_007::ShowOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_007)");
	return base->ShowOverlay(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_007::HideOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_007)");
	return base->HideOverlay(ulOverlayHandle);
}
bool CVROverlay_007::IsOverlayVisible(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_007)");
	return base->IsOverlayVisible(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_007::GetOverlayInputMethod(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_007::VROverlayInputMethod* peInputMethod) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_007)");
	return base->GetOverlayInputMethod(ulOverlayHandle, (OOVR_VROverlayInputMethod*) peInputMethod);
}
vr::EVROverlayError CVROverlay_007::SetOverlayInputMethod(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_007::VROverlayInputMethod eInputMethod) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_007)");
	return base->SetOverlayInputMethod(ulOverlayHandle, (OOVR_VROverlayInputMethod) eInputMethod);
}
vr::EVROverlayError CVROverlay_007::GetOverlayMouseScale(vr::VROverlayHandle_t ulOverlayHandle, vr::HmdVector2_t* pvecMouseScale) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_007)");
	return base->GetOverlayMouseScale(ulOverlayHandle, pvecMouseScale);
}
vr::EVROverlayError CVROverlay_007::SetOverlayMouseScale(vr::VROverlayHandle_t ulOverlayHandle, const vr::HmdVector2_t* pvecMouseScale) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_007)");
	return base->SetOverlayMouseScale(ulOverlayHandle, pvecMouseScale);
}
bool CVROverlay_007::ComputeOverlayIntersection(vr::VROverlayHandle_t ulOverlayHandle, const vr::IVROverlay_007::VROverlayIntersectionParams_t* pParams, vr::IVROverlay_007::VROverlayIntersectionResults_t* pResults) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_007)");
	return base->ComputeOverlayIntersection(ulOverlayHandle, (const OOVR_VROverlayIntersectionParams_t*) pParams, (OOVR_VROverlayIntersectionResults_t*) pResults);
}
bool CVROverlay_007::HandleControllerOverlayInteractionAsMouse(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unControllerDeviceIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_007)");
	return base->HandleControllerOverlayInteractionAsMouse(ulOverlayHandle, unControllerDeviceIndex);
}
bool CVROverlay_007::IsHoverTargetOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_007)");
	return base->IsHoverTargetOverlay(ulOverlayHandle);
}
vr::VROverlayHandle_t CVROverlay_007::GetGamepadFocusOverlay() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_007)");
	return base->GetGamepadFocusOverlay();
}
vr::EVROverlayError CVROverlay_007::SetGamepadFocusOverlay(vr::VROverlayHandle_t ulNewFocusOverlay) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_007)");
	return base->SetGamepadFocusOverlay(ulNewFocusOverlay);
}
vr::EVROverlayError CVROverlay_007::SetOverlayNeighbor(vr::IVROverlay_007::EOverlayDirection eDirection, vr::VROverlayHandle_t ulFrom, vr::VROverlayHandle_t ulTo) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_007)");
	return base->SetOverlayNeighbor((OOVR_EOverlayDirection) eDirection, ulFrom, ulTo);
}
vr::EVROverlayError CVROverlay_007::MoveGamepadFocusToNeighbor(vr::IVROverlay_007::EOverlayDirection eDirection, vr::VROverlayHandle_t ulFrom) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_007)");
	return base->MoveGamepadFocusToNeighbor((OOVR_EOverlayDirection) eDirection, ulFrom);
}
vr::EVROverlayError CVROverlay_007::SetOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle, const vr::Texture_t* pTexture) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_007)");
	return base->SetOverlayTexture(ulOverlayHandle, pTexture);
}
vr::EVROverlayError CVROverlay_007::ClearOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_007)");
	return base->ClearOverlayTexture(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_007::SetOverlayRaw(vr::VROverlayHandle_t ulOverlayHandle, void* pvBuffer, uint32_t unWidth, uint32_t unHeight, uint32_t unDepth) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_007)");
	return base->SetOverlayRaw(ulOverlayHandle, pvBuffer, unWidth, unHeight, unDepth);
}
vr::EVROverlayError CVROverlay_007::SetOverlayFromFile(vr::VROverlayHandle_t ulOverlayHandle, const char* pchFilePath) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_007)");
	return base->SetOverlayFromFile(ulOverlayHandle, pchFilePath);
}
vr::EVROverlayError CVROverlay_007::CreateDashboardOverlay(const char* pchOverlayKey, const char* pchOverlayFriendlyName, vr::VROverlayHandle_t* pMainHandle, vr::VROverlayHandle_t* pThumbnailHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_007)");
	return base->CreateDashboardOverlay(pchOverlayKey, pchOverlayFriendlyName, pMainHandle, pThumbnailHandle);
}
bool CVROverlay_007::IsDashboardVisible() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_007)");
	return base->IsDashboardVisible();
}
bool CVROverlay_007::IsActiveDashboardOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_007)");
	return base->IsActiveDashboardOverlay(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_007::SetDashboardOverlaySceneProcess(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unProcessId) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_007)");
	return base->SetDashboardOverlaySceneProcess(ulOverlayHandle, unProcessId);
}
vr::EVROverlayError CVROverlay_007::GetDashboardOverlaySceneProcess(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* punProcessId) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_007)");
	return base->GetDashboardOverlaySceneProcess(ulOverlayHandle, punProcessId);
}
void CVROverlay_007::ShowDashboard(const char* pchOverlayToShow) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_007)");
	return base->ShowDashboard(pchOverlayToShow);
}
vr::EVROverlayError CVROverlay_007::ShowKeyboard(vr::IVROverlay_007::EGamepadTextInputMode eInputMode, vr::IVROverlay_007::EGamepadTextInputLineMode eLineInputMode, const char* pchDescription, uint32_t unCharMax, const char* pchExistingText, bool bUseMinimalMode, uint64_t uUserValue) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_007)");
	return base->ShowKeyboard((OOVR_EGamepadTextInputMode) eInputMode, (OOVR_EGamepadTextInputLineMode) eLineInputMode, pchDescription, unCharMax, pchExistingText, bUseMinimalMode, uUserValue);
}
vr::EVROverlayError CVROverlay_007::ShowKeyboardForOverlay(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_007::EGamepadTextInputMode eInputMode, vr::IVROverlay_007::EGamepadTextInputLineMode eLineInputMode, const char* pchDescription, uint32_t unCharMax, const char* pchExistingText, bool bUseMinimalMode, uint64_t uUserValue) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_007)");
	return base->ShowKeyboardForOverlay(ulOverlayHandle, (OOVR_EGamepadTextInputMode) eInputMode, (OOVR_EGamepadTextInputLineMode) eLineInputMode, pchDescription, unCharMax, pchExistingText, bUseMinimalMode, uUserValue);
}
uint32_t CVROverlay_007::GetKeyboardText(char* pchText, uint32_t cchText) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_007)");
	return base->GetKeyboardText(pchText, cchText);
}
void CVROverlay_007::HideKeyboard() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_007)");
	return base->HideKeyboard();
}
// FnTable for CVROverlay_007:
static CVROverlay_007 *fntable_Overlay_007_instance = NULL;
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_007_impl_FindOverlay(const char* pchOverlayKey, vr::VROverlayHandle_t* pOverlayHandle) { return fntable_Overlay_007_instance->FindOverlay(pchOverlayKey, pOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_007_impl_CreateOverlay(const char* pchOverlayKey, const char* pchOverlayFriendlyName, vr::VROverlayHandle_t* pOverlayHandle) { return fntable_Overlay_007_instance->CreateOverlay(pchOverlayKey, pchOverlayFriendlyName, pOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_007_impl_DestroyOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_007_instance->DestroyOverlay(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_007_impl_SetHighQualityOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_007_instance->SetHighQualityOverlay(ulOverlayHandle); }
static vr::VROverlayHandle_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_007_impl_GetHighQualityOverlay() { return fntable_Overlay_007_instance->GetHighQualityOverlay(); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_007_impl_GetOverlayKey(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::EVROverlayError* pError) { return fntable_Overlay_007_instance->GetOverlayKey(ulOverlayHandle, pchValue, unBufferSize, pError); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_007_impl_GetOverlayName(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::EVROverlayError* pError) { return fntable_Overlay_007_instance->GetOverlayName(ulOverlayHandle, pchValue, unBufferSize, pError); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_007_impl_GetOverlayImageData(vr::VROverlayHandle_t ulOverlayHandle, void* pvBuffer, uint32_t unBufferSize, uint32_t* punWidth, uint32_t* punHeight) { return fntable_Overlay_007_instance->GetOverlayImageData(ulOverlayHandle, pvBuffer, unBufferSize, punWidth, punHeight); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_Overlay_007_impl_GetOverlayErrorNameFromEnum(vr::EVROverlayError error) { return fntable_Overlay_007_instance->GetOverlayErrorNameFromEnum(error); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_007_impl_SetOverlayFlag(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_007::VROverlayFlags eOverlayFlag, bool bEnabled) { return fntable_Overlay_007_instance->SetOverlayFlag(ulOverlayHandle, eOverlayFlag, bEnabled); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_007_impl_GetOverlayFlag(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_007::VROverlayFlags eOverlayFlag, bool* pbEnabled) { return fntable_Overlay_007_instance->GetOverlayFlag(ulOverlayHandle, eOverlayFlag, pbEnabled); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_007_impl_SetOverlayColor(vr::VROverlayHandle_t ulOverlayHandle, float fRed, float fGreen, float fBlue) { return fntable_Overlay_007_instance->SetOverlayColor(ulOverlayHandle, fRed, fGreen, fBlue); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_007_impl_GetOverlayColor(vr::VROverlayHandle_t ulOverlayHandle, float* pfRed, float* pfGreen, float* pfBlue) { return fntable_Overlay_007_instance->GetOverlayColor(ulOverlayHandle, pfRed, pfGreen, pfBlue); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_007_impl_SetOverlayAlpha(vr::VROverlayHandle_t ulOverlayHandle, float fAlpha) { return fntable_Overlay_007_instance->SetOverlayAlpha(ulOverlayHandle, fAlpha); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_007_impl_GetOverlayAlpha(vr::VROverlayHandle_t ulOverlayHandle, float* pfAlpha) { return fntable_Overlay_007_instance->GetOverlayAlpha(ulOverlayHandle, pfAlpha); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_007_impl_SetOverlayWidthInMeters(vr::VROverlayHandle_t ulOverlayHandle, float fWidthInMeters) { return fntable_Overlay_007_instance->SetOverlayWidthInMeters(ulOverlayHandle, fWidthInMeters); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_007_impl_GetOverlayWidthInMeters(vr::VROverlayHandle_t ulOverlayHandle, float* pfWidthInMeters) { return fntable_Overlay_007_instance->GetOverlayWidthInMeters(ulOverlayHandle, pfWidthInMeters); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_007_impl_SetOverlayAutoCurveDistanceRangeInMeters(vr::VROverlayHandle_t ulOverlayHandle, float fMinDistanceInMeters, float fMaxDistanceInMeters) { return fntable_Overlay_007_instance->SetOverlayAutoCurveDistanceRangeInMeters(ulOverlayHandle, fMinDistanceInMeters, fMaxDistanceInMeters); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_007_impl_GetOverlayAutoCurveDistanceRangeInMeters(vr::VROverlayHandle_t ulOverlayHandle, float* pfMinDistanceInMeters, float* pfMaxDistanceInMeters) { return fntable_Overlay_007_instance->GetOverlayAutoCurveDistanceRangeInMeters(ulOverlayHandle, pfMinDistanceInMeters, pfMaxDistanceInMeters); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_007_impl_SetOverlayTextureColorSpace(vr::VROverlayHandle_t ulOverlayHandle, vr::EColorSpace eTextureColorSpace) { return fntable_Overlay_007_instance->SetOverlayTextureColorSpace(ulOverlayHandle, eTextureColorSpace); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_007_impl_GetOverlayTextureColorSpace(vr::VROverlayHandle_t ulOverlayHandle, vr::EColorSpace* peTextureColorSpace) { return fntable_Overlay_007_instance->GetOverlayTextureColorSpace(ulOverlayHandle, peTextureColorSpace); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_007_impl_SetOverlayTextureBounds(vr::VROverlayHandle_t ulOverlayHandle, const vr::VRTextureBounds_t* pOverlayTextureBounds) { return fntable_Overlay_007_instance->SetOverlayTextureBounds(ulOverlayHandle, pOverlayTextureBounds); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_007_impl_GetOverlayTextureBounds(vr::VROverlayHandle_t ulOverlayHandle, vr::VRTextureBounds_t* pOverlayTextureBounds) { return fntable_Overlay_007_instance->GetOverlayTextureBounds(ulOverlayHandle, pOverlayTextureBounds); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_007_impl_GetOverlayTransformType(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_007::VROverlayTransformType* peTransformType) { return fntable_Overlay_007_instance->GetOverlayTransformType(ulOverlayHandle, peTransformType); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_007_impl_SetOverlayTransformAbsolute(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin eTrackingOrigin, const vr::HmdMatrix34_t* pmatTrackingOriginToOverlayTransform) { return fntable_Overlay_007_instance->SetOverlayTransformAbsolute(ulOverlayHandle, eTrackingOrigin, pmatTrackingOriginToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_007_impl_GetOverlayTransformAbsolute(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin* peTrackingOrigin, vr::HmdMatrix34_t* pmatTrackingOriginToOverlayTransform) { return fntable_Overlay_007_instance->GetOverlayTransformAbsolute(ulOverlayHandle, peTrackingOrigin, pmatTrackingOriginToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_007_impl_SetOverlayTransformTrackedDeviceRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unTrackedDevice, const vr::HmdMatrix34_t* pmatTrackedDeviceToOverlayTransform) { return fntable_Overlay_007_instance->SetOverlayTransformTrackedDeviceRelative(ulOverlayHandle, unTrackedDevice, pmatTrackedDeviceToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_007_impl_GetOverlayTransformTrackedDeviceRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t* punTrackedDevice, vr::HmdMatrix34_t* pmatTrackedDeviceToOverlayTransform) { return fntable_Overlay_007_instance->GetOverlayTransformTrackedDeviceRelative(ulOverlayHandle, punTrackedDevice, pmatTrackedDeviceToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_007_impl_ShowOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_007_instance->ShowOverlay(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_007_impl_HideOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_007_instance->HideOverlay(ulOverlayHandle); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_007_impl_IsOverlayVisible(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_007_instance->IsOverlayVisible(ulOverlayHandle); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_007_impl_PollNextOverlayEvent(vr::VROverlayHandle_t ulOverlayHandle, vr::VREvent_t* pEvent) { return fntable_Overlay_007_instance->PollNextOverlayEvent(ulOverlayHandle, pEvent); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_007_impl_GetOverlayInputMethod(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_007::VROverlayInputMethod* peInputMethod) { return fntable_Overlay_007_instance->GetOverlayInputMethod(ulOverlayHandle, peInputMethod); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_007_impl_SetOverlayInputMethod(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_007::VROverlayInputMethod eInputMethod) { return fntable_Overlay_007_instance->SetOverlayInputMethod(ulOverlayHandle, eInputMethod); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_007_impl_GetOverlayMouseScale(vr::VROverlayHandle_t ulOverlayHandle, vr::HmdVector2_t* pvecMouseScale) { return fntable_Overlay_007_instance->GetOverlayMouseScale(ulOverlayHandle, pvecMouseScale); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_007_impl_SetOverlayMouseScale(vr::VROverlayHandle_t ulOverlayHandle, const vr::HmdVector2_t* pvecMouseScale) { return fntable_Overlay_007_instance->SetOverlayMouseScale(ulOverlayHandle, pvecMouseScale); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_007_impl_ComputeOverlayIntersection(vr::VROverlayHandle_t ulOverlayHandle, const vr::IVROverlay_007::VROverlayIntersectionParams_t* pParams, vr::IVROverlay_007::VROverlayIntersectionResults_t* pResults) { return fntable_Overlay_007_instance->ComputeOverlayIntersection(ulOverlayHandle, pParams, pResults); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_007_impl_HandleControllerOverlayInteractionAsMouse(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unControllerDeviceIndex) { return fntable_Overlay_007_instance->HandleControllerOverlayInteractionAsMouse(ulOverlayHandle, unControllerDeviceIndex); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_007_impl_IsHoverTargetOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_007_instance->IsHoverTargetOverlay(ulOverlayHandle); }
static vr::VROverlayHandle_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_007_impl_GetGamepadFocusOverlay() { return fntable_Overlay_007_instance->GetGamepadFocusOverlay(); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_007_impl_SetGamepadFocusOverlay(vr::VROverlayHandle_t ulNewFocusOverlay) { return fntable_Overlay_007_instance->SetGamepadFocusOverlay(ulNewFocusOverlay); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_007_impl_SetOverlayNeighbor(vr::IVROverlay_007::EOverlayDirection eDirection, vr::VROverlayHandle_t ulFrom, vr::VROverlayHandle_t ulTo) { return fntable_Overlay_007_instance->SetOverlayNeighbor(eDirection, ulFrom, ulTo); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_007_impl_MoveGamepadFocusToNeighbor(vr::IVROverlay_007::EOverlayDirection eDirection, vr::VROverlayHandle_t ulFrom) { return fntable_Overlay_007_instance->MoveGamepadFocusToNeighbor(eDirection, ulFrom); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_007_impl_SetOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle, const vr::Texture_t* pTexture) { return fntable_Overlay_007_instance->SetOverlayTexture(ulOverlayHandle, pTexture); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_007_impl_ClearOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_007_instance->ClearOverlayTexture(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_007_impl_SetOverlayRaw(vr::VROverlayHandle_t ulOverlayHandle, void* pvBuffer, uint32_t unWidth, uint32_t unHeight, uint32_t unDepth) { return fntable_Overlay_007_instance->SetOverlayRaw(ulOverlayHandle, pvBuffer, unWidth, unHeight, unDepth); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_007_impl_SetOverlayFromFile(vr::VROverlayHandle_t ulOverlayHandle, const char* pchFilePath) { return fntable_Overlay_007_instance->SetOverlayFromFile(ulOverlayHandle, pchFilePath); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_007_impl_CreateDashboardOverlay(const char* pchOverlayKey, const char* pchOverlayFriendlyName, vr::VROverlayHandle_t* pMainHandle, vr::VROverlayHandle_t* pThumbnailHandle) { return fntable_Overlay_007_instance->CreateDashboardOverlay(pchOverlayKey, pchOverlayFriendlyName, pMainHandle, pThumbnailHandle); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_007_impl_IsDashboardVisible() { return fntable_Overlay_007_instance->IsDashboardVisible(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_007_impl_IsActiveDashboardOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_007_instance->IsActiveDashboardOverlay(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_007_impl_SetDashboardOverlaySceneProcess(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unProcessId) { return fntable_Overlay_007_instance->SetDashboardOverlaySceneProcess(ulOverlayHandle, unProcessId); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_007_impl_GetDashboardOverlaySceneProcess(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* punProcessId) { return fntable_Overlay_007_instance->GetDashboardOverlaySceneProcess(ulOverlayHandle, punProcessId); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_007_impl_ShowDashboard(const char* pchOverlayToShow) { return fntable_Overlay_007_instance->ShowDashboard(pchOverlayToShow); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_007_impl_ShowKeyboard(vr::IVROverlay_007::EGamepadTextInputMode eInputMode, vr::IVROverlay_007::EGamepadTextInputLineMode eLineInputMode, const char* pchDescription, uint32_t unCharMax, const char* pchExistingText, bool bUseMinimalMode, uint64_t uUserValue) { return fntable_Overlay_007_instance->ShowKeyboard(eInputMode, eLineInputMode, pchDescription, unCharMax, pchExistingText, bUseMinimalMode, uUserValue); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_007_impl_ShowKeyboardForOverlay(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_007::EGamepadTextInputMode eInputMode, vr::IVROverlay_007::EGamepadTextInputLineMode eLineInputMode, const char* pchDescription, uint32_t unCharMax, const char* pchExistingText, bool bUseMinimalMode, uint64_t uUserValue) { return fntable_Overlay_007_instance->ShowKeyboardForOverlay(ulOverlayHandle, eInputMode, eLineInputMode, pchDescription, unCharMax, pchExistingText, bUseMinimalMode, uUserValue); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_007_impl_GetKeyboardText(char* pchText, uint32_t cchText) { return fntable_Overlay_007_instance->GetKeyboardText(pchText, cchText); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_007_impl_HideKeyboard() { return fntable_Overlay_007_instance->HideKeyboard(); }
static void *fntable_Overlay_007_funcs[] = {
	(void*) fntable_Overlay_007_impl_FindOverlay,
	(void*) fntable_Overlay_007_impl_CreateOverlay,
	(void*) fntable_Overlay_007_impl_DestroyOverlay,
	(void*) fntable_Overlay_007_impl_SetHighQualityOverlay,
	(void*) fntable_Overlay_007_impl_GetHighQualityOverlay,
	(void*) fntable_Overlay_007_impl_GetOverlayKey,
	(void*) fntable_Overlay_007_impl_GetOverlayName,
	(void*) fntable_Overlay_007_impl_GetOverlayImageData,
	(void*) fntable_Overlay_007_impl_GetOverlayErrorNameFromEnum,
	(void*) fntable_Overlay_007_impl_SetOverlayFlag,
	(void*) fntable_Overlay_007_impl_GetOverlayFlag,
	(void*) fntable_Overlay_007_impl_SetOverlayColor,
	(void*) fntable_Overlay_007_impl_GetOverlayColor,
	(void*) fntable_Overlay_007_impl_SetOverlayAlpha,
	(void*) fntable_Overlay_007_impl_GetOverlayAlpha,
	(void*) fntable_Overlay_007_impl_SetOverlayWidthInMeters,
	(void*) fntable_Overlay_007_impl_GetOverlayWidthInMeters,
	(void*) fntable_Overlay_007_impl_SetOverlayAutoCurveDistanceRangeInMeters,
	(void*) fntable_Overlay_007_impl_GetOverlayAutoCurveDistanceRangeInMeters,
	(void*) fntable_Overlay_007_impl_SetOverlayTextureColorSpace,
	(void*) fntable_Overlay_007_impl_GetOverlayTextureColorSpace,
	(void*) fntable_Overlay_007_impl_SetOverlayTextureBounds,
	(void*) fntable_Overlay_007_impl_GetOverlayTextureBounds,
	(void*) fntable_Overlay_007_impl_GetOverlayTransformType,
	(void*) fntable_Overlay_007_impl_SetOverlayTransformAbsolute,
	(void*) fntable_Overlay_007_impl_GetOverlayTransformAbsolute,
	(void*) fntable_Overlay_007_impl_SetOverlayTransformTrackedDeviceRelative,
	(void*) fntable_Overlay_007_impl_GetOverlayTransformTrackedDeviceRelative,
	(void*) fntable_Overlay_007_impl_ShowOverlay,
	(void*) fntable_Overlay_007_impl_HideOverlay,
	(void*) fntable_Overlay_007_impl_IsOverlayVisible,
	(void*) fntable_Overlay_007_impl_PollNextOverlayEvent,
	(void*) fntable_Overlay_007_impl_GetOverlayInputMethod,
	(void*) fntable_Overlay_007_impl_SetOverlayInputMethod,
	(void*) fntable_Overlay_007_impl_GetOverlayMouseScale,
	(void*) fntable_Overlay_007_impl_SetOverlayMouseScale,
	(void*) fntable_Overlay_007_impl_ComputeOverlayIntersection,
	(void*) fntable_Overlay_007_impl_HandleControllerOverlayInteractionAsMouse,
	(void*) fntable_Overlay_007_impl_IsHoverTargetOverlay,
	(void*) fntable_Overlay_007_impl_GetGamepadFocusOverlay,
	(void*) fntable_Overlay_007_impl_SetGamepadFocusOverlay,
	(void*) fntable_Overlay_007_impl_SetOverlayNeighbor,
	(void*) fntable_Overlay_007_impl_MoveGamepadFocusToNeighbor,
	(void*) fntable_Overlay_007_impl_SetOverlayTexture,
	(void*) fntable_Overlay_007_impl_ClearOverlayTexture,
	(void*) fntable_Overlay_007_impl_SetOverlayRaw,
	(void*) fntable_Overlay_007_impl_SetOverlayFromFile,
	(void*) fntable_Overlay_007_impl_CreateDashboardOverlay,
	(void*) fntable_Overlay_007_impl_IsDashboardVisible,
	(void*) fntable_Overlay_007_impl_IsActiveDashboardOverlay,
	(void*) fntable_Overlay_007_impl_SetDashboardOverlaySceneProcess,
	(void*) fntable_Overlay_007_impl_GetDashboardOverlaySceneProcess,
	(void*) fntable_Overlay_007_impl_ShowDashboard,
	(void*) fntable_Overlay_007_impl_ShowKeyboard,
	(void*) fntable_Overlay_007_impl_ShowKeyboardForOverlay,
	(void*) fntable_Overlay_007_impl_GetKeyboardText,
	(void*) fntable_Overlay_007_impl_HideKeyboard,
};
void** CVROverlay_007::_GetStatFuncList() { fntable_Overlay_007_instance = this; return fntable_Overlay_007_funcs; }
void CVROverlay_007::Delete() { delete this; }
// Misc for CVROverlay_010:
CVROverlay_010::CVROverlay_010() : base(GetCreateBaseOverlay()) {}
// Interface methods for CVROverlay_010:
vr::EVROverlayError CVROverlay_010::FindOverlay(const char* pchOverlayKey, vr::VROverlayHandle_t* pOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_010)");
	return base->FindOverlay(pchOverlayKey, pOverlayHandle);
}
vr::EVROverlayError CVROverlay_010::CreateOverlay(const char* pchOverlayKey, const char* pchOverlayFriendlyName, vr::VROverlayHandle_t* pOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_010)");
	return base->CreateOverlay(pchOverlayKey, pchOverlayFriendlyName, pOverlayHandle);
}
vr::EVROverlayError CVROverlay_010::DestroyOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_010)");
	return base->DestroyOverlay(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_010::SetHighQualityOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_010)");
	return base->SetHighQualityOverlay(ulOverlayHandle);
}
vr::VROverlayHandle_t CVROverlay_010::GetHighQualityOverlay() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_010)");
	return base->GetHighQualityOverlay();
}
uint32_t CVROverlay_010::GetOverlayKey(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::EVROverlayError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_010)");
	return base->GetOverlayKey(ulOverlayHandle, pchValue, unBufferSize, pError);
}
uint32_t CVROverlay_010::GetOverlayName(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::EVROverlayError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_010)");
	return base->GetOverlayName(ulOverlayHandle, pchValue, unBufferSize, pError);
}
vr::EVROverlayError CVROverlay_010::GetOverlayImageData(vr::VROverlayHandle_t ulOverlayHandle, void* pvBuffer, uint32_t unBufferSize, uint32_t* punWidth, uint32_t* punHeight) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_010)");
	return base->GetOverlayImageData(ulOverlayHandle, pvBuffer, unBufferSize, punWidth, punHeight);
}
const char* CVROverlay_010::GetOverlayErrorNameFromEnum(vr::EVROverlayError error) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_010)");
	return base->GetOverlayErrorNameFromEnum(error);
}
vr::EVROverlayError CVROverlay_010::SetOverlayFlag(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_010::VROverlayFlags eOverlayFlag, bool bEnabled) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_010)");
	return base->SetOverlayFlag(ulOverlayHandle, (OOVR_VROverlayFlags) eOverlayFlag, bEnabled);
}
vr::EVROverlayError CVROverlay_010::GetOverlayFlag(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_010::VROverlayFlags eOverlayFlag, bool* pbEnabled) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_010)");
	return base->GetOverlayFlag(ulOverlayHandle, (OOVR_VROverlayFlags) eOverlayFlag, pbEnabled);
}
vr::EVROverlayError CVROverlay_010::SetOverlayColor(vr::VROverlayHandle_t ulOverlayHandle, float fRed, float fGreen, float fBlue) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_010)");
	return base->SetOverlayColor(ulOverlayHandle, fRed, fGreen, fBlue);
}
vr::EVROverlayError CVROverlay_010::GetOverlayColor(vr::VROverlayHandle_t ulOverlayHandle, float* pfRed, float* pfGreen, float* pfBlue) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_010)");
	return base->GetOverlayColor(ulOverlayHandle, pfRed, pfGreen, pfBlue);
}
vr::EVROverlayError CVROverlay_010::SetOverlayAlpha(vr::VROverlayHandle_t ulOverlayHandle, float fAlpha) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_010)");
	return base->SetOverlayAlpha(ulOverlayHandle, fAlpha);
}
vr::EVROverlayError CVROverlay_010::GetOverlayAlpha(vr::VROverlayHandle_t ulOverlayHandle, float* pfAlpha) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_010)");
	return base->GetOverlayAlpha(ulOverlayHandle, pfAlpha);
}
vr::EVROverlayError CVROverlay_010::SetOverlayWidthInMeters(vr::VROverlayHandle_t ulOverlayHandle, float fWidthInMeters) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_010)");
	return base->SetOverlayWidthInMeters(ulOverlayHandle, fWidthInMeters);
}
vr::EVROverlayError CVROverlay_010::GetOverlayWidthInMeters(vr::VROverlayHandle_t ulOverlayHandle, float* pfWidthInMeters) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_010)");
	return base->GetOverlayWidthInMeters(ulOverlayHandle, pfWidthInMeters);
}
vr::EVROverlayError CVROverlay_010::SetOverlayAutoCurveDistanceRangeInMeters(vr::VROverlayHandle_t ulOverlayHandle, float fMinDistanceInMeters, float fMaxDistanceInMeters) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_010)");
	return base->SetOverlayAutoCurveDistanceRangeInMeters(ulOverlayHandle, fMinDistanceInMeters, fMaxDistanceInMeters);
}
vr::EVROverlayError CVROverlay_010::GetOverlayAutoCurveDistanceRangeInMeters(vr::VROverlayHandle_t ulOverlayHandle, float* pfMinDistanceInMeters, float* pfMaxDistanceInMeters) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_010)");
	return base->GetOverlayAutoCurveDistanceRangeInMeters(ulOverlayHandle, pfMinDistanceInMeters, pfMaxDistanceInMeters);
}
vr::EVROverlayError CVROverlay_010::SetOverlayTextureColorSpace(vr::VROverlayHandle_t ulOverlayHandle, vr::EColorSpace eTextureColorSpace) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_010)");
	return base->SetOverlayTextureColorSpace(ulOverlayHandle, eTextureColorSpace);
}
vr::EVROverlayError CVROverlay_010::GetOverlayTextureColorSpace(vr::VROverlayHandle_t ulOverlayHandle, vr::EColorSpace* peTextureColorSpace) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_010)");
	return base->GetOverlayTextureColorSpace(ulOverlayHandle, peTextureColorSpace);
}
vr::EVROverlayError CVROverlay_010::SetOverlayTextureBounds(vr::VROverlayHandle_t ulOverlayHandle, const vr::VRTextureBounds_t* pOverlayTextureBounds) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_010)");
	return base->SetOverlayTextureBounds(ulOverlayHandle, pOverlayTextureBounds);
}
vr::EVROverlayError CVROverlay_010::GetOverlayTextureBounds(vr::VROverlayHandle_t ulOverlayHandle, vr::VRTextureBounds_t* pOverlayTextureBounds) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_010)");
	return base->GetOverlayTextureBounds(ulOverlayHandle, pOverlayTextureBounds);
}
vr::EVROverlayError CVROverlay_010::GetOverlayTransformType(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_010::VROverlayTransformType* peTransformType) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_010)");
	return base->GetOverlayTransformType(ulOverlayHandle, (OOVR_VROverlayTransformType*) peTransformType);
}
vr::EVROverlayError CVROverlay_010::SetOverlayTransformAbsolute(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin eTrackingOrigin, const vr::HmdMatrix34_t* pmatTrackingOriginToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_010)");
	return base->SetOverlayTransformAbsolute(ulOverlayHandle, eTrackingOrigin, pmatTrackingOriginToOverlayTransform);
}
vr::EVROverlayError CVROverlay_010::GetOverlayTransformAbsolute(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin* peTrackingOrigin, vr::HmdMatrix34_t* pmatTrackingOriginToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_010)");
	return base->GetOverlayTransformAbsolute(ulOverlayHandle, peTrackingOrigin, pmatTrackingOriginToOverlayTransform);
}
vr::EVROverlayError CVROverlay_010::SetOverlayTransformTrackedDeviceRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unTrackedDevice, const vr::HmdMatrix34_t* pmatTrackedDeviceToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_010)");
	return base->SetOverlayTransformTrackedDeviceRelative(ulOverlayHandle, unTrackedDevice, pmatTrackedDeviceToOverlayTransform);
}
vr::EVROverlayError CVROverlay_010::GetOverlayTransformTrackedDeviceRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t* punTrackedDevice, vr::HmdMatrix34_t* pmatTrackedDeviceToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_010)");
	return base->GetOverlayTransformTrackedDeviceRelative(ulOverlayHandle, punTrackedDevice, pmatTrackedDeviceToOverlayTransform);
}
vr::EVROverlayError CVROverlay_010::SetOverlayTransformTrackedDeviceComponent(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unDeviceIndex, const char* pchComponentName) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_010)");
	return base->SetOverlayTransformTrackedDeviceComponent(ulOverlayHandle, unDeviceIndex, pchComponentName);
}
vr::EVROverlayError CVROverlay_010::GetOverlayTransformTrackedDeviceComponent(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t* punDeviceIndex, char* pchComponentName, uint32_t unComponentNameSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_010)");
	return base->GetOverlayTransformTrackedDeviceComponent(ulOverlayHandle, punDeviceIndex, pchComponentName, unComponentNameSize);
}
vr::EVROverlayError CVROverlay_010::ShowOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_010)");
	return base->ShowOverlay(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_010::HideOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_010)");
	return base->HideOverlay(ulOverlayHandle);
}
bool CVROverlay_010::IsOverlayVisible(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_010)");
	return base->IsOverlayVisible(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_010::GetTransformForOverlayCoordinates(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin eTrackingOrigin, vr::HmdVector2_t coordinatesInOverlay, vr::HmdMatrix34_t* pmatTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_010)");
	return base->GetTransformForOverlayCoordinates(ulOverlayHandle, eTrackingOrigin, coordinatesInOverlay, pmatTransform);
}
bool CVROverlay_010::PollNextOverlayEvent(vr::VROverlayHandle_t ulOverlayHandle, vr::VREvent_t* pEvent, uint32_t uncbVREvent) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_010)");
	return base->PollNextOverlayEvent(ulOverlayHandle, pEvent, uncbVREvent);
}
vr::EVROverlayError CVROverlay_010::GetOverlayInputMethod(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_010::VROverlayInputMethod* peInputMethod) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_010)");
	return base->GetOverlayInputMethod(ulOverlayHandle, (OOVR_VROverlayInputMethod*) peInputMethod);
}
vr::EVROverlayError CVROverlay_010::SetOverlayInputMethod(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_010::VROverlayInputMethod eInputMethod) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_010)");
	return base->SetOverlayInputMethod(ulOverlayHandle, (OOVR_VROverlayInputMethod) eInputMethod);
}
vr::EVROverlayError CVROverlay_010::GetOverlayMouseScale(vr::VROverlayHandle_t ulOverlayHandle, vr::HmdVector2_t* pvecMouseScale) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_010)");
	return base->GetOverlayMouseScale(ulOverlayHandle, pvecMouseScale);
}
vr::EVROverlayError CVROverlay_010::SetOverlayMouseScale(vr::VROverlayHandle_t ulOverlayHandle, const vr::HmdVector2_t* pvecMouseScale) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_010)");
	return base->SetOverlayMouseScale(ulOverlayHandle, pvecMouseScale);
}
bool CVROverlay_010::ComputeOverlayIntersection(vr::VROverlayHandle_t ulOverlayHandle, const vr::IVROverlay_010::VROverlayIntersectionParams_t* pParams, vr::IVROverlay_010::VROverlayIntersectionResults_t* pResults) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_010)");
	return base->ComputeOverlayIntersection(ulOverlayHandle, (const OOVR_VROverlayIntersectionParams_t*) pParams, (OOVR_VROverlayIntersectionResults_t*) pResults);
}
bool CVROverlay_010::HandleControllerOverlayInteractionAsMouse(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unControllerDeviceIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_010)");
	return base->HandleControllerOverlayInteractionAsMouse(ulOverlayHandle, unControllerDeviceIndex);
}
bool CVROverlay_010::IsHoverTargetOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_010)");
	return base->IsHoverTargetOverlay(ulOverlayHandle);
}
vr::VROverlayHandle_t CVROverlay_010::GetGamepadFocusOverlay() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_010)");
	return base->GetGamepadFocusOverlay();
}
vr::EVROverlayError CVROverlay_010::SetGamepadFocusOverlay(vr::VROverlayHandle_t ulNewFocusOverlay) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_010)");
	return base->SetGamepadFocusOverlay(ulNewFocusOverlay);
}
vr::EVROverlayError CVROverlay_010::SetOverlayNeighbor(vr::IVROverlay_010::EOverlayDirection eDirection, vr::VROverlayHandle_t ulFrom, vr::VROverlayHandle_t ulTo) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_010)");
	return base->SetOverlayNeighbor((OOVR_EOverlayDirection) eDirection, ulFrom, ulTo);
}
vr::EVROverlayError CVROverlay_010::MoveGamepadFocusToNeighbor(vr::IVROverlay_010::EOverlayDirection eDirection, vr::VROverlayHandle_t ulFrom) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_010)");
	return base->MoveGamepadFocusToNeighbor((OOVR_EOverlayDirection) eDirection, ulFrom);
}
vr::EVROverlayError CVROverlay_010::SetOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle, const vr::Texture_t* pTexture) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_010)");
	return base->SetOverlayTexture(ulOverlayHandle, pTexture);
}
vr::EVROverlayError CVROverlay_010::ClearOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_010)");
	return base->ClearOverlayTexture(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_010::SetOverlayRaw(vr::VROverlayHandle_t ulOverlayHandle, void* pvBuffer, uint32_t unWidth, uint32_t unHeight, uint32_t unDepth) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_010)");
	return base->SetOverlayRaw(ulOverlayHandle, pvBuffer, unWidth, unHeight, unDepth);
}
vr::EVROverlayError CVROverlay_010::SetOverlayFromFile(vr::VROverlayHandle_t ulOverlayHandle, const char* pchFilePath) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_010)");
	return base->SetOverlayFromFile(ulOverlayHandle, pchFilePath);
}
vr::EVROverlayError CVROverlay_010::CreateDashboardOverlay(const char* pchOverlayKey, const char* pchOverlayFriendlyName, vr::VROverlayHandle_t* pMainHandle, vr::VROverlayHandle_t* pThumbnailHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_010)");
	return base->CreateDashboardOverlay(pchOverlayKey, pchOverlayFriendlyName, pMainHandle, pThumbnailHandle);
}
bool CVROverlay_010::IsDashboardVisible() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_010)");
	return base->IsDashboardVisible();
}
bool CVROverlay_010::IsActiveDashboardOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_010)");
	return base->IsActiveDashboardOverlay(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_010::SetDashboardOverlaySceneProcess(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unProcessId) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_010)");
	return base->SetDashboardOverlaySceneProcess(ulOverlayHandle, unProcessId);
}
vr::EVROverlayError CVROverlay_010::GetDashboardOverlaySceneProcess(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* punProcessId) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_010)");
	return base->GetDashboardOverlaySceneProcess(ulOverlayHandle, punProcessId);
}
void CVROverlay_010::ShowDashboard(const char* pchOverlayToShow) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_010)");
	return base->ShowDashboard(pchOverlayToShow);
}
vr::TrackedDeviceIndex_t CVROverlay_010::GetPrimaryDashboardDevice() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_010)");
	return base->GetPrimaryDashboardDevice();
}
vr::EVROverlayError CVROverlay_010::ShowKeyboard(vr::IVROverlay_010::EGamepadTextInputMode eInputMode, vr::IVROverlay_010::EGamepadTextInputLineMode eLineInputMode, const char* pchDescription, uint32_t unCharMax, const char* pchExistingText, bool bUseMinimalMode, uint64_t uUserValue) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_010)");
	return base->ShowKeyboard((OOVR_EGamepadTextInputMode) eInputMode, (OOVR_EGamepadTextInputLineMode) eLineInputMode, pchDescription, unCharMax, pchExistingText, bUseMinimalMode, uUserValue);
}
vr::EVROverlayError CVROverlay_010::ShowKeyboardForOverlay(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_010::EGamepadTextInputMode eInputMode, vr::IVROverlay_010::EGamepadTextInputLineMode eLineInputMode, const char* pchDescription, uint32_t unCharMax, const char* pchExistingText, bool bUseMinimalMode, uint64_t uUserValue) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_010)");
	return base->ShowKeyboardForOverlay(ulOverlayHandle, (OOVR_EGamepadTextInputMode) eInputMode, (OOVR_EGamepadTextInputLineMode) eLineInputMode, pchDescription, unCharMax, pchExistingText, bUseMinimalMode, uUserValue);
}
uint32_t CVROverlay_010::GetKeyboardText(char* pchText, uint32_t cchText) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_010)");
	return base->GetKeyboardText(pchText, cchText);
}
void CVROverlay_010::HideKeyboard() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_010)");
	return base->HideKeyboard();
}
void CVROverlay_010::SetKeyboardTransformAbsolute(vr::ETrackingUniverseOrigin eTrackingOrigin, const vr::HmdMatrix34_t* pmatTrackingOriginToKeyboardTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_010)");
	return base->SetKeyboardTransformAbsolute(eTrackingOrigin, pmatTrackingOriginToKeyboardTransform);
}
void CVROverlay_010::SetKeyboardPositionForOverlay(vr::VROverlayHandle_t ulOverlayHandle, vr::HmdRect2_t avoidRect) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_010)");
	return base->SetKeyboardPositionForOverlay(ulOverlayHandle, avoidRect);
}
// FnTable for CVROverlay_010:
static CVROverlay_010 *fntable_Overlay_010_instance = NULL;
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_010_impl_FindOverlay(const char* pchOverlayKey, vr::VROverlayHandle_t* pOverlayHandle) { return fntable_Overlay_010_instance->FindOverlay(pchOverlayKey, pOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_010_impl_CreateOverlay(const char* pchOverlayKey, const char* pchOverlayFriendlyName, vr::VROverlayHandle_t* pOverlayHandle) { return fntable_Overlay_010_instance->CreateOverlay(pchOverlayKey, pchOverlayFriendlyName, pOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_010_impl_DestroyOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_010_instance->DestroyOverlay(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_010_impl_SetHighQualityOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_010_instance->SetHighQualityOverlay(ulOverlayHandle); }
static vr::VROverlayHandle_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_010_impl_GetHighQualityOverlay() { return fntable_Overlay_010_instance->GetHighQualityOverlay(); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_010_impl_GetOverlayKey(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::EVROverlayError* pError) { return fntable_Overlay_010_instance->GetOverlayKey(ulOverlayHandle, pchValue, unBufferSize, pError); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_010_impl_GetOverlayName(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::EVROverlayError* pError) { return fntable_Overlay_010_instance->GetOverlayName(ulOverlayHandle, pchValue, unBufferSize, pError); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_010_impl_GetOverlayImageData(vr::VROverlayHandle_t ulOverlayHandle, void* pvBuffer, uint32_t unBufferSize, uint32_t* punWidth, uint32_t* punHeight) { return fntable_Overlay_010_instance->GetOverlayImageData(ulOverlayHandle, pvBuffer, unBufferSize, punWidth, punHeight); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_Overlay_010_impl_GetOverlayErrorNameFromEnum(vr::EVROverlayError error) { return fntable_Overlay_010_instance->GetOverlayErrorNameFromEnum(error); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_010_impl_SetOverlayFlag(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_010::VROverlayFlags eOverlayFlag, bool bEnabled) { return fntable_Overlay_010_instance->SetOverlayFlag(ulOverlayHandle, eOverlayFlag, bEnabled); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_010_impl_GetOverlayFlag(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_010::VROverlayFlags eOverlayFlag, bool* pbEnabled) { return fntable_Overlay_010_instance->GetOverlayFlag(ulOverlayHandle, eOverlayFlag, pbEnabled); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_010_impl_SetOverlayColor(vr::VROverlayHandle_t ulOverlayHandle, float fRed, float fGreen, float fBlue) { return fntable_Overlay_010_instance->SetOverlayColor(ulOverlayHandle, fRed, fGreen, fBlue); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_010_impl_GetOverlayColor(vr::VROverlayHandle_t ulOverlayHandle, float* pfRed, float* pfGreen, float* pfBlue) { return fntable_Overlay_010_instance->GetOverlayColor(ulOverlayHandle, pfRed, pfGreen, pfBlue); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_010_impl_SetOverlayAlpha(vr::VROverlayHandle_t ulOverlayHandle, float fAlpha) { return fntable_Overlay_010_instance->SetOverlayAlpha(ulOverlayHandle, fAlpha); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_010_impl_GetOverlayAlpha(vr::VROverlayHandle_t ulOverlayHandle, float* pfAlpha) { return fntable_Overlay_010_instance->GetOverlayAlpha(ulOverlayHandle, pfAlpha); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_010_impl_SetOverlayWidthInMeters(vr::VROverlayHandle_t ulOverlayHandle, float fWidthInMeters) { return fntable_Overlay_010_instance->SetOverlayWidthInMeters(ulOverlayHandle, fWidthInMeters); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_010_impl_GetOverlayWidthInMeters(vr::VROverlayHandle_t ulOverlayHandle, float* pfWidthInMeters) { return fntable_Overlay_010_instance->GetOverlayWidthInMeters(ulOverlayHandle, pfWidthInMeters); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_010_impl_SetOverlayAutoCurveDistanceRangeInMeters(vr::VROverlayHandle_t ulOverlayHandle, float fMinDistanceInMeters, float fMaxDistanceInMeters) { return fntable_Overlay_010_instance->SetOverlayAutoCurveDistanceRangeInMeters(ulOverlayHandle, fMinDistanceInMeters, fMaxDistanceInMeters); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_010_impl_GetOverlayAutoCurveDistanceRangeInMeters(vr::VROverlayHandle_t ulOverlayHandle, float* pfMinDistanceInMeters, float* pfMaxDistanceInMeters) { return fntable_Overlay_010_instance->GetOverlayAutoCurveDistanceRangeInMeters(ulOverlayHandle, pfMinDistanceInMeters, pfMaxDistanceInMeters); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_010_impl_SetOverlayTextureColorSpace(vr::VROverlayHandle_t ulOverlayHandle, vr::EColorSpace eTextureColorSpace) { return fntable_Overlay_010_instance->SetOverlayTextureColorSpace(ulOverlayHandle, eTextureColorSpace); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_010_impl_GetOverlayTextureColorSpace(vr::VROverlayHandle_t ulOverlayHandle, vr::EColorSpace* peTextureColorSpace) { return fntable_Overlay_010_instance->GetOverlayTextureColorSpace(ulOverlayHandle, peTextureColorSpace); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_010_impl_SetOverlayTextureBounds(vr::VROverlayHandle_t ulOverlayHandle, const vr::VRTextureBounds_t* pOverlayTextureBounds) { return fntable_Overlay_010_instance->SetOverlayTextureBounds(ulOverlayHandle, pOverlayTextureBounds); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_010_impl_GetOverlayTextureBounds(vr::VROverlayHandle_t ulOverlayHandle, vr::VRTextureBounds_t* pOverlayTextureBounds) { return fntable_Overlay_010_instance->GetOverlayTextureBounds(ulOverlayHandle, pOverlayTextureBounds); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_010_impl_GetOverlayTransformType(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_010::VROverlayTransformType* peTransformType) { return fntable_Overlay_010_instance->GetOverlayTransformType(ulOverlayHandle, peTransformType); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_010_impl_SetOverlayTransformAbsolute(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin eTrackingOrigin, const vr::HmdMatrix34_t* pmatTrackingOriginToOverlayTransform) { return fntable_Overlay_010_instance->SetOverlayTransformAbsolute(ulOverlayHandle, eTrackingOrigin, pmatTrackingOriginToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_010_impl_GetOverlayTransformAbsolute(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin* peTrackingOrigin, vr::HmdMatrix34_t* pmatTrackingOriginToOverlayTransform) { return fntable_Overlay_010_instance->GetOverlayTransformAbsolute(ulOverlayHandle, peTrackingOrigin, pmatTrackingOriginToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_010_impl_SetOverlayTransformTrackedDeviceRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unTrackedDevice, const vr::HmdMatrix34_t* pmatTrackedDeviceToOverlayTransform) { return fntable_Overlay_010_instance->SetOverlayTransformTrackedDeviceRelative(ulOverlayHandle, unTrackedDevice, pmatTrackedDeviceToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_010_impl_GetOverlayTransformTrackedDeviceRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t* punTrackedDevice, vr::HmdMatrix34_t* pmatTrackedDeviceToOverlayTransform) { return fntable_Overlay_010_instance->GetOverlayTransformTrackedDeviceRelative(ulOverlayHandle, punTrackedDevice, pmatTrackedDeviceToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_010_impl_SetOverlayTransformTrackedDeviceComponent(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unDeviceIndex, const char* pchComponentName) { return fntable_Overlay_010_instance->SetOverlayTransformTrackedDeviceComponent(ulOverlayHandle, unDeviceIndex, pchComponentName); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_010_impl_GetOverlayTransformTrackedDeviceComponent(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t* punDeviceIndex, char* pchComponentName, uint32_t unComponentNameSize) { return fntable_Overlay_010_instance->GetOverlayTransformTrackedDeviceComponent(ulOverlayHandle, punDeviceIndex, pchComponentName, unComponentNameSize); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_010_impl_ShowOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_010_instance->ShowOverlay(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_010_impl_HideOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_010_instance->HideOverlay(ulOverlayHandle); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_010_impl_IsOverlayVisible(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_010_instance->IsOverlayVisible(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_010_impl_GetTransformForOverlayCoordinates(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin eTrackingOrigin, vr::HmdVector2_t coordinatesInOverlay, vr::HmdMatrix34_t* pmatTransform) { return fntable_Overlay_010_instance->GetTransformForOverlayCoordinates(ulOverlayHandle, eTrackingOrigin, coordinatesInOverlay, pmatTransform); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_010_impl_PollNextOverlayEvent(vr::VROverlayHandle_t ulOverlayHandle, vr::VREvent_t* pEvent, uint32_t uncbVREvent) { return fntable_Overlay_010_instance->PollNextOverlayEvent(ulOverlayHandle, pEvent, uncbVREvent); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_010_impl_GetOverlayInputMethod(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_010::VROverlayInputMethod* peInputMethod) { return fntable_Overlay_010_instance->GetOverlayInputMethod(ulOverlayHandle, peInputMethod); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_010_impl_SetOverlayInputMethod(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_010::VROverlayInputMethod eInputMethod) { return fntable_Overlay_010_instance->SetOverlayInputMethod(ulOverlayHandle, eInputMethod); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_010_impl_GetOverlayMouseScale(vr::VROverlayHandle_t ulOverlayHandle, vr::HmdVector2_t* pvecMouseScale) { return fntable_Overlay_010_instance->GetOverlayMouseScale(ulOverlayHandle, pvecMouseScale); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_010_impl_SetOverlayMouseScale(vr::VROverlayHandle_t ulOverlayHandle, const vr::HmdVector2_t* pvecMouseScale) { return fntable_Overlay_010_instance->SetOverlayMouseScale(ulOverlayHandle, pvecMouseScale); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_010_impl_ComputeOverlayIntersection(vr::VROverlayHandle_t ulOverlayHandle, const vr::IVROverlay_010::VROverlayIntersectionParams_t* pParams, vr::IVROverlay_010::VROverlayIntersectionResults_t* pResults) { return fntable_Overlay_010_instance->ComputeOverlayIntersection(ulOverlayHandle, pParams, pResults); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_010_impl_HandleControllerOverlayInteractionAsMouse(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unControllerDeviceIndex) { return fntable_Overlay_010_instance->HandleControllerOverlayInteractionAsMouse(ulOverlayHandle, unControllerDeviceIndex); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_010_impl_IsHoverTargetOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_010_instance->IsHoverTargetOverlay(ulOverlayHandle); }
static vr::VROverlayHandle_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_010_impl_GetGamepadFocusOverlay() { return fntable_Overlay_010_instance->GetGamepadFocusOverlay(); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_010_impl_SetGamepadFocusOverlay(vr::VROverlayHandle_t ulNewFocusOverlay) { return fntable_Overlay_010_instance->SetGamepadFocusOverlay(ulNewFocusOverlay); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_010_impl_SetOverlayNeighbor(vr::IVROverlay_010::EOverlayDirection eDirection, vr::VROverlayHandle_t ulFrom, vr::VROverlayHandle_t ulTo) { return fntable_Overlay_010_instance->SetOverlayNeighbor(eDirection, ulFrom, ulTo); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_010_impl_MoveGamepadFocusToNeighbor(vr::IVROverlay_010::EOverlayDirection eDirection, vr::VROverlayHandle_t ulFrom) { return fntable_Overlay_010_instance->MoveGamepadFocusToNeighbor(eDirection, ulFrom); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_010_impl_SetOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle, const vr::Texture_t* pTexture) { return fntable_Overlay_010_instance->SetOverlayTexture(ulOverlayHandle, pTexture); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_010_impl_ClearOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_010_instance->ClearOverlayTexture(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_010_impl_SetOverlayRaw(vr::VROverlayHandle_t ulOverlayHandle, void* pvBuffer, uint32_t unWidth, uint32_t unHeight, uint32_t unDepth) { return fntable_Overlay_010_instance->SetOverlayRaw(ulOverlayHandle, pvBuffer, unWidth, unHeight, unDepth); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_010_impl_SetOverlayFromFile(vr::VROverlayHandle_t ulOverlayHandle, const char* pchFilePath) { return fntable_Overlay_010_instance->SetOverlayFromFile(ulOverlayHandle, pchFilePath); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_010_impl_CreateDashboardOverlay(const char* pchOverlayKey, const char* pchOverlayFriendlyName, vr::VROverlayHandle_t* pMainHandle, vr::VROverlayHandle_t* pThumbnailHandle) { return fntable_Overlay_010_instance->CreateDashboardOverlay(pchOverlayKey, pchOverlayFriendlyName, pMainHandle, pThumbnailHandle); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_010_impl_IsDashboardVisible() { return fntable_Overlay_010_instance->IsDashboardVisible(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_010_impl_IsActiveDashboardOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_010_instance->IsActiveDashboardOverlay(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_010_impl_SetDashboardOverlaySceneProcess(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unProcessId) { return fntable_Overlay_010_instance->SetDashboardOverlaySceneProcess(ulOverlayHandle, unProcessId); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_010_impl_GetDashboardOverlaySceneProcess(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* punProcessId) { return fntable_Overlay_010_instance->GetDashboardOverlaySceneProcess(ulOverlayHandle, punProcessId); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_010_impl_ShowDashboard(const char* pchOverlayToShow) { return fntable_Overlay_010_instance->ShowDashboard(pchOverlayToShow); }
static vr::TrackedDeviceIndex_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_010_impl_GetPrimaryDashboardDevice() { return fntable_Overlay_010_instance->GetPrimaryDashboardDevice(); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_010_impl_ShowKeyboard(vr::IVROverlay_010::EGamepadTextInputMode eInputMode, vr::IVROverlay_010::EGamepadTextInputLineMode eLineInputMode, const char* pchDescription, uint32_t unCharMax, const char* pchExistingText, bool bUseMinimalMode, uint64_t uUserValue) { return fntable_Overlay_010_instance->ShowKeyboard(eInputMode, eLineInputMode, pchDescription, unCharMax, pchExistingText, bUseMinimalMode, uUserValue); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_010_impl_ShowKeyboardForOverlay(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_010::EGamepadTextInputMode eInputMode, vr::IVROverlay_010::EGamepadTextInputLineMode eLineInputMode, const char* pchDescription, uint32_t unCharMax, const char* pchExistingText, bool bUseMinimalMode, uint64_t uUserValue) { return fntable_Overlay_010_instance->ShowKeyboardForOverlay(ulOverlayHandle, eInputMode, eLineInputMode, pchDescription, unCharMax, pchExistingText, bUseMinimalMode, uUserValue); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_010_impl_GetKeyboardText(char* pchText, uint32_t cchText) { return fntable_Overlay_010_instance->GetKeyboardText(pchText, cchText); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_010_impl_HideKeyboard() { return fntable_Overlay_010_instance->HideKeyboard(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_010_impl_SetKeyboardTransformAbsolute(vr::ETrackingUniverseOrigin eTrackingOrigin, const vr::HmdMatrix34_t* pmatTrackingOriginToKeyboardTransform) { return fntable_Overlay_010_instance->SetKeyboardTransformAbsolute(eTrackingOrigin, pmatTrackingOriginToKeyboardTransform); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_010_impl_SetKeyboardPositionForOverlay(vr::VROverlayHandle_t ulOverlayHandle, vr::HmdRect2_t avoidRect) { return fntable_Overlay_010_instance->SetKeyboardPositionForOverlay(ulOverlayHandle, avoidRect); }
static void *fntable_Overlay_010_funcs[] = {
	(void*) fntable_Overlay_010_impl_FindOverlay,
	(void*) fntable_Overlay_010_impl_CreateOverlay,
	(void*) fntable_Overlay_010_impl_DestroyOverlay,
	(void*) fntable_Overlay_010_impl_SetHighQualityOverlay,
	(void*) fntable_Overlay_010_impl_GetHighQualityOverlay,
	(void*) fntable_Overlay_010_impl_GetOverlayKey,
	(void*) fntable_Overlay_010_impl_GetOverlayName,
	(void*) fntable_Overlay_010_impl_GetOverlayImageData,
	(void*) fntable_Overlay_010_impl_GetOverlayErrorNameFromEnum,
	(void*) fntable_Overlay_010_impl_SetOverlayFlag,
	(void*) fntable_Overlay_010_impl_GetOverlayFlag,
	(void*) fntable_Overlay_010_impl_SetOverlayColor,
	(void*) fntable_Overlay_010_impl_GetOverlayColor,
	(void*) fntable_Overlay_010_impl_SetOverlayAlpha,
	(void*) fntable_Overlay_010_impl_GetOverlayAlpha,
	(void*) fntable_Overlay_010_impl_SetOverlayWidthInMeters,
	(void*) fntable_Overlay_010_impl_GetOverlayWidthInMeters,
	(void*) fntable_Overlay_010_impl_SetOverlayAutoCurveDistanceRangeInMeters,
	(void*) fntable_Overlay_010_impl_GetOverlayAutoCurveDistanceRangeInMeters,
	(void*) fntable_Overlay_010_impl_SetOverlayTextureColorSpace,
	(void*) fntable_Overlay_010_impl_GetOverlayTextureColorSpace,
	(void*) fntable_Overlay_010_impl_SetOverlayTextureBounds,
	(void*) fntable_Overlay_010_impl_GetOverlayTextureBounds,
	(void*) fntable_Overlay_010_impl_GetOverlayTransformType,
	(void*) fntable_Overlay_010_impl_SetOverlayTransformAbsolute,
	(void*) fntable_Overlay_010_impl_GetOverlayTransformAbsolute,
	(void*) fntable_Overlay_010_impl_SetOverlayTransformTrackedDeviceRelative,
	(void*) fntable_Overlay_010_impl_GetOverlayTransformTrackedDeviceRelative,
	(void*) fntable_Overlay_010_impl_SetOverlayTransformTrackedDeviceComponent,
	(void*) fntable_Overlay_010_impl_GetOverlayTransformTrackedDeviceComponent,
	(void*) fntable_Overlay_010_impl_ShowOverlay,
	(void*) fntable_Overlay_010_impl_HideOverlay,
	(void*) fntable_Overlay_010_impl_IsOverlayVisible,
	(void*) fntable_Overlay_010_impl_GetTransformForOverlayCoordinates,
	(void*) fntable_Overlay_010_impl_PollNextOverlayEvent,
	(void*) fntable_Overlay_010_impl_GetOverlayInputMethod,
	(void*) fntable_Overlay_010_impl_SetOverlayInputMethod,
	(void*) fntable_Overlay_010_impl_GetOverlayMouseScale,
	(void*) fntable_Overlay_010_impl_SetOverlayMouseScale,
	(void*) fntable_Overlay_010_impl_ComputeOverlayIntersection,
	(void*) fntable_Overlay_010_impl_HandleControllerOverlayInteractionAsMouse,
	(void*) fntable_Overlay_010_impl_IsHoverTargetOverlay,
	(void*) fntable_Overlay_010_impl_GetGamepadFocusOverlay,
	(void*) fntable_Overlay_010_impl_SetGamepadFocusOverlay,
	(void*) fntable_Overlay_010_impl_SetOverlayNeighbor,
	(void*) fntable_Overlay_010_impl_MoveGamepadFocusToNeighbor,
	(void*) fntable_Overlay_010_impl_SetOverlayTexture,
	(void*) fntable_Overlay_010_impl_ClearOverlayTexture,
	(void*) fntable_Overlay_010_impl_SetOverlayRaw,
	(void*) fntable_Overlay_010_impl_SetOverlayFromFile,
	(void*) fntable_Overlay_010_impl_CreateDashboardOverlay,
	(void*) fntable_Overlay_010_impl_IsDashboardVisible,
	(void*) fntable_Overlay_010_impl_IsActiveDashboardOverlay,
	(void*) fntable_Overlay_010_impl_SetDashboardOverlaySceneProcess,
	(void*) fntable_Overlay_010_impl_GetDashboardOverlaySceneProcess,
	(void*) fntable_Overlay_010_impl_ShowDashboard,
	(void*) fntable_Overlay_010_impl_GetPrimaryDashboardDevice,
	(void*) fntable_Overlay_010_impl_ShowKeyboard,
	(void*) fntable_Overlay_010_impl_ShowKeyboardForOverlay,
	(void*) fntable_Overlay_010_impl_GetKeyboardText,
	(void*) fntable_Overlay_010_impl_HideKeyboard,
	(void*) fntable_Overlay_010_impl_SetKeyboardTransformAbsolute,
	(void*) fntable_Overlay_010_impl_SetKeyboardPositionForOverlay,
};
void** CVROverlay_010::_GetStatFuncList() { fntable_Overlay_010_instance = this; return fntable_Overlay_010_funcs; }
void CVROverlay_010::Delete() { delete this; }
// Misc for CVROverlay_011:
CVROverlay_011::CVROverlay_011() : base(GetCreateBaseOverlay()) {}
// Interface methods for CVROverlay_011:
vr::EVROverlayError CVROverlay_011::FindOverlay(const char* pchOverlayKey, vr::VROverlayHandle_t* pOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_011)");
	return base->FindOverlay(pchOverlayKey, pOverlayHandle);
}
vr::EVROverlayError CVROverlay_011::CreateOverlay(const char* pchOverlayKey, const char* pchOverlayFriendlyName, vr::VROverlayHandle_t* pOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_011)");
	return base->CreateOverlay(pchOverlayKey, pchOverlayFriendlyName, pOverlayHandle);
}
vr::EVROverlayError CVROverlay_011::DestroyOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_011)");
	return base->DestroyOverlay(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_011::SetHighQualityOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_011)");
	return base->SetHighQualityOverlay(ulOverlayHandle);
}
vr::VROverlayHandle_t CVROverlay_011::GetHighQualityOverlay() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_011)");
	return base->GetHighQualityOverlay();
}
uint32_t CVROverlay_011::GetOverlayKey(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::EVROverlayError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_011)");
	return base->GetOverlayKey(ulOverlayHandle, pchValue, unBufferSize, pError);
}
uint32_t CVROverlay_011::GetOverlayName(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::EVROverlayError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_011)");
	return base->GetOverlayName(ulOverlayHandle, pchValue, unBufferSize, pError);
}
vr::EVROverlayError CVROverlay_011::GetOverlayImageData(vr::VROverlayHandle_t ulOverlayHandle, void* pvBuffer, uint32_t unBufferSize, uint32_t* punWidth, uint32_t* punHeight) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_011)");
	return base->GetOverlayImageData(ulOverlayHandle, pvBuffer, unBufferSize, punWidth, punHeight);
}
const char* CVROverlay_011::GetOverlayErrorNameFromEnum(vr::EVROverlayError error) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_011)");
	return base->GetOverlayErrorNameFromEnum(error);
}
vr::EVROverlayError CVROverlay_011::SetOverlayRenderingPid(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unPID) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_011)");
	return base->SetOverlayRenderingPid(ulOverlayHandle, unPID);
}
uint32_t CVROverlay_011::GetOverlayRenderingPid(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_011)");
	return base->GetOverlayRenderingPid(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_011::SetOverlayFlag(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_011::VROverlayFlags eOverlayFlag, bool bEnabled) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_011)");
	return base->SetOverlayFlag(ulOverlayHandle, (OOVR_VROverlayFlags) eOverlayFlag, bEnabled);
}
vr::EVROverlayError CVROverlay_011::GetOverlayFlag(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_011::VROverlayFlags eOverlayFlag, bool* pbEnabled) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_011)");
	return base->GetOverlayFlag(ulOverlayHandle, (OOVR_VROverlayFlags) eOverlayFlag, pbEnabled);
}
vr::EVROverlayError CVROverlay_011::SetOverlayColor(vr::VROverlayHandle_t ulOverlayHandle, float fRed, float fGreen, float fBlue) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_011)");
	return base->SetOverlayColor(ulOverlayHandle, fRed, fGreen, fBlue);
}
vr::EVROverlayError CVROverlay_011::GetOverlayColor(vr::VROverlayHandle_t ulOverlayHandle, float* pfRed, float* pfGreen, float* pfBlue) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_011)");
	return base->GetOverlayColor(ulOverlayHandle, pfRed, pfGreen, pfBlue);
}
vr::EVROverlayError CVROverlay_011::SetOverlayAlpha(vr::VROverlayHandle_t ulOverlayHandle, float fAlpha) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_011)");
	return base->SetOverlayAlpha(ulOverlayHandle, fAlpha);
}
vr::EVROverlayError CVROverlay_011::GetOverlayAlpha(vr::VROverlayHandle_t ulOverlayHandle, float* pfAlpha) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_011)");
	return base->GetOverlayAlpha(ulOverlayHandle, pfAlpha);
}
vr::EVROverlayError CVROverlay_011::SetOverlayWidthInMeters(vr::VROverlayHandle_t ulOverlayHandle, float fWidthInMeters) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_011)");
	return base->SetOverlayWidthInMeters(ulOverlayHandle, fWidthInMeters);
}
vr::EVROverlayError CVROverlay_011::GetOverlayWidthInMeters(vr::VROverlayHandle_t ulOverlayHandle, float* pfWidthInMeters) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_011)");
	return base->GetOverlayWidthInMeters(ulOverlayHandle, pfWidthInMeters);
}
vr::EVROverlayError CVROverlay_011::SetOverlayAutoCurveDistanceRangeInMeters(vr::VROverlayHandle_t ulOverlayHandle, float fMinDistanceInMeters, float fMaxDistanceInMeters) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_011)");
	return base->SetOverlayAutoCurveDistanceRangeInMeters(ulOverlayHandle, fMinDistanceInMeters, fMaxDistanceInMeters);
}
vr::EVROverlayError CVROverlay_011::GetOverlayAutoCurveDistanceRangeInMeters(vr::VROverlayHandle_t ulOverlayHandle, float* pfMinDistanceInMeters, float* pfMaxDistanceInMeters) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_011)");
	return base->GetOverlayAutoCurveDistanceRangeInMeters(ulOverlayHandle, pfMinDistanceInMeters, pfMaxDistanceInMeters);
}
vr::EVROverlayError CVROverlay_011::SetOverlayTextureColorSpace(vr::VROverlayHandle_t ulOverlayHandle, vr::EColorSpace eTextureColorSpace) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_011)");
	return base->SetOverlayTextureColorSpace(ulOverlayHandle, eTextureColorSpace);
}
vr::EVROverlayError CVROverlay_011::GetOverlayTextureColorSpace(vr::VROverlayHandle_t ulOverlayHandle, vr::EColorSpace* peTextureColorSpace) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_011)");
	return base->GetOverlayTextureColorSpace(ulOverlayHandle, peTextureColorSpace);
}
vr::EVROverlayError CVROverlay_011::SetOverlayTextureBounds(vr::VROverlayHandle_t ulOverlayHandle, const vr::VRTextureBounds_t* pOverlayTextureBounds) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_011)");
	return base->SetOverlayTextureBounds(ulOverlayHandle, pOverlayTextureBounds);
}
vr::EVROverlayError CVROverlay_011::GetOverlayTextureBounds(vr::VROverlayHandle_t ulOverlayHandle, vr::VRTextureBounds_t* pOverlayTextureBounds) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_011)");
	return base->GetOverlayTextureBounds(ulOverlayHandle, pOverlayTextureBounds);
}
vr::EVROverlayError CVROverlay_011::GetOverlayTransformType(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_011::VROverlayTransformType* peTransformType) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_011)");
	return base->GetOverlayTransformType(ulOverlayHandle, (OOVR_VROverlayTransformType*) peTransformType);
}
vr::EVROverlayError CVROverlay_011::SetOverlayTransformAbsolute(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin eTrackingOrigin, const vr::HmdMatrix34_t* pmatTrackingOriginToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_011)");
	return base->SetOverlayTransformAbsolute(ulOverlayHandle, eTrackingOrigin, pmatTrackingOriginToOverlayTransform);
}
vr::EVROverlayError CVROverlay_011::GetOverlayTransformAbsolute(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin* peTrackingOrigin, vr::HmdMatrix34_t* pmatTrackingOriginToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_011)");
	return base->GetOverlayTransformAbsolute(ulOverlayHandle, peTrackingOrigin, pmatTrackingOriginToOverlayTransform);
}
vr::EVROverlayError CVROverlay_011::SetOverlayTransformTrackedDeviceRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unTrackedDevice, const vr::HmdMatrix34_t* pmatTrackedDeviceToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_011)");
	return base->SetOverlayTransformTrackedDeviceRelative(ulOverlayHandle, unTrackedDevice, pmatTrackedDeviceToOverlayTransform);
}
vr::EVROverlayError CVROverlay_011::GetOverlayTransformTrackedDeviceRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t* punTrackedDevice, vr::HmdMatrix34_t* pmatTrackedDeviceToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_011)");
	return base->GetOverlayTransformTrackedDeviceRelative(ulOverlayHandle, punTrackedDevice, pmatTrackedDeviceToOverlayTransform);
}
vr::EVROverlayError CVROverlay_011::SetOverlayTransformTrackedDeviceComponent(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unDeviceIndex, const char* pchComponentName) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_011)");
	return base->SetOverlayTransformTrackedDeviceComponent(ulOverlayHandle, unDeviceIndex, pchComponentName);
}
vr::EVROverlayError CVROverlay_011::GetOverlayTransformTrackedDeviceComponent(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t* punDeviceIndex, char* pchComponentName, uint32_t unComponentNameSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_011)");
	return base->GetOverlayTransformTrackedDeviceComponent(ulOverlayHandle, punDeviceIndex, pchComponentName, unComponentNameSize);
}
vr::EVROverlayError CVROverlay_011::ShowOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_011)");
	return base->ShowOverlay(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_011::HideOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_011)");
	return base->HideOverlay(ulOverlayHandle);
}
bool CVROverlay_011::IsOverlayVisible(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_011)");
	return base->IsOverlayVisible(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_011::GetTransformForOverlayCoordinates(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin eTrackingOrigin, vr::HmdVector2_t coordinatesInOverlay, vr::HmdMatrix34_t* pmatTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_011)");
	return base->GetTransformForOverlayCoordinates(ulOverlayHandle, eTrackingOrigin, coordinatesInOverlay, pmatTransform);
}
bool CVROverlay_011::PollNextOverlayEvent(vr::VROverlayHandle_t ulOverlayHandle, vr::VREvent_t* pEvent, uint32_t uncbVREvent) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_011)");
	return base->PollNextOverlayEvent(ulOverlayHandle, pEvent, uncbVREvent);
}
vr::EVROverlayError CVROverlay_011::GetOverlayInputMethod(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_011::VROverlayInputMethod* peInputMethod) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_011)");
	return base->GetOverlayInputMethod(ulOverlayHandle, (OOVR_VROverlayInputMethod*) peInputMethod);
}
vr::EVROverlayError CVROverlay_011::SetOverlayInputMethod(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_011::VROverlayInputMethod eInputMethod) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_011)");
	return base->SetOverlayInputMethod(ulOverlayHandle, (OOVR_VROverlayInputMethod) eInputMethod);
}
vr::EVROverlayError CVROverlay_011::GetOverlayMouseScale(vr::VROverlayHandle_t ulOverlayHandle, vr::HmdVector2_t* pvecMouseScale) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_011)");
	return base->GetOverlayMouseScale(ulOverlayHandle, pvecMouseScale);
}
vr::EVROverlayError CVROverlay_011::SetOverlayMouseScale(vr::VROverlayHandle_t ulOverlayHandle, const vr::HmdVector2_t* pvecMouseScale) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_011)");
	return base->SetOverlayMouseScale(ulOverlayHandle, pvecMouseScale);
}
bool CVROverlay_011::ComputeOverlayIntersection(vr::VROverlayHandle_t ulOverlayHandle, const vr::IVROverlay_011::VROverlayIntersectionParams_t* pParams, vr::IVROverlay_011::VROverlayIntersectionResults_t* pResults) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_011)");
	return base->ComputeOverlayIntersection(ulOverlayHandle, (const OOVR_VROverlayIntersectionParams_t*) pParams, (OOVR_VROverlayIntersectionResults_t*) pResults);
}
bool CVROverlay_011::HandleControllerOverlayInteractionAsMouse(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unControllerDeviceIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_011)");
	return base->HandleControllerOverlayInteractionAsMouse(ulOverlayHandle, unControllerDeviceIndex);
}
bool CVROverlay_011::IsHoverTargetOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_011)");
	return base->IsHoverTargetOverlay(ulOverlayHandle);
}
vr::VROverlayHandle_t CVROverlay_011::GetGamepadFocusOverlay() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_011)");
	return base->GetGamepadFocusOverlay();
}
vr::EVROverlayError CVROverlay_011::SetGamepadFocusOverlay(vr::VROverlayHandle_t ulNewFocusOverlay) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_011)");
	return base->SetGamepadFocusOverlay(ulNewFocusOverlay);
}
vr::EVROverlayError CVROverlay_011::SetOverlayNeighbor(vr::IVROverlay_011::EOverlayDirection eDirection, vr::VROverlayHandle_t ulFrom, vr::VROverlayHandle_t ulTo) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_011)");
	return base->SetOverlayNeighbor((OOVR_EOverlayDirection) eDirection, ulFrom, ulTo);
}
vr::EVROverlayError CVROverlay_011::MoveGamepadFocusToNeighbor(vr::IVROverlay_011::EOverlayDirection eDirection, vr::VROverlayHandle_t ulFrom) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_011)");
	return base->MoveGamepadFocusToNeighbor((OOVR_EOverlayDirection) eDirection, ulFrom);
}
vr::EVROverlayError CVROverlay_011::SetOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle, const vr::Texture_t* pTexture) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_011)");
	return base->SetOverlayTexture(ulOverlayHandle, pTexture);
}
vr::EVROverlayError CVROverlay_011::ClearOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_011)");
	return base->ClearOverlayTexture(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_011::SetOverlayRaw(vr::VROverlayHandle_t ulOverlayHandle, void* pvBuffer, uint32_t unWidth, uint32_t unHeight, uint32_t unDepth) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_011)");
	return base->SetOverlayRaw(ulOverlayHandle, pvBuffer, unWidth, unHeight, unDepth);
}
vr::EVROverlayError CVROverlay_011::SetOverlayFromFile(vr::VROverlayHandle_t ulOverlayHandle, const char* pchFilePath) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_011)");
	return base->SetOverlayFromFile(ulOverlayHandle, pchFilePath);
}
vr::EVROverlayError CVROverlay_011::ReleaseNativeOverlayHandle(vr::VROverlayHandle_t ulOverlayHandle, void* pNativeTextureHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_011)");
	return base->ReleaseNativeOverlayHandle(ulOverlayHandle, pNativeTextureHandle);
}
vr::EVROverlayError CVROverlay_011::CreateDashboardOverlay(const char* pchOverlayKey, const char* pchOverlayFriendlyName, vr::VROverlayHandle_t* pMainHandle, vr::VROverlayHandle_t* pThumbnailHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_011)");
	return base->CreateDashboardOverlay(pchOverlayKey, pchOverlayFriendlyName, pMainHandle, pThumbnailHandle);
}
bool CVROverlay_011::IsDashboardVisible() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_011)");
	return base->IsDashboardVisible();
}
bool CVROverlay_011::IsActiveDashboardOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_011)");
	return base->IsActiveDashboardOverlay(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_011::SetDashboardOverlaySceneProcess(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unProcessId) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_011)");
	return base->SetDashboardOverlaySceneProcess(ulOverlayHandle, unProcessId);
}
vr::EVROverlayError CVROverlay_011::GetDashboardOverlaySceneProcess(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* punProcessId) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_011)");
	return base->GetDashboardOverlaySceneProcess(ulOverlayHandle, punProcessId);
}
void CVROverlay_011::ShowDashboard(const char* pchOverlayToShow) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_011)");
	return base->ShowDashboard(pchOverlayToShow);
}
vr::TrackedDeviceIndex_t CVROverlay_011::GetPrimaryDashboardDevice() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_011)");
	return base->GetPrimaryDashboardDevice();
}
vr::EVROverlayError CVROverlay_011::ShowKeyboard(vr::IVROverlay_011::EGamepadTextInputMode eInputMode, vr::IVROverlay_011::EGamepadTextInputLineMode eLineInputMode, const char* pchDescription, uint32_t unCharMax, const char* pchExistingText, bool bUseMinimalMode, uint64_t uUserValue) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_011)");
	return base->ShowKeyboard((OOVR_EGamepadTextInputMode) eInputMode, (OOVR_EGamepadTextInputLineMode) eLineInputMode, pchDescription, unCharMax, pchExistingText, bUseMinimalMode, uUserValue);
}
vr::EVROverlayError CVROverlay_011::ShowKeyboardForOverlay(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_011::EGamepadTextInputMode eInputMode, vr::IVROverlay_011::EGamepadTextInputLineMode eLineInputMode, const char* pchDescription, uint32_t unCharMax, const char* pchExistingText, bool bUseMinimalMode, uint64_t uUserValue) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_011)");
	return base->ShowKeyboardForOverlay(ulOverlayHandle, (OOVR_EGamepadTextInputMode) eInputMode, (OOVR_EGamepadTextInputLineMode) eLineInputMode, pchDescription, unCharMax, pchExistingText, bUseMinimalMode, uUserValue);
}
uint32_t CVROverlay_011::GetKeyboardText(char* pchText, uint32_t cchText) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_011)");
	return base->GetKeyboardText(pchText, cchText);
}
void CVROverlay_011::HideKeyboard() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_011)");
	return base->HideKeyboard();
}
void CVROverlay_011::SetKeyboardTransformAbsolute(vr::ETrackingUniverseOrigin eTrackingOrigin, const vr::HmdMatrix34_t* pmatTrackingOriginToKeyboardTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_011)");
	return base->SetKeyboardTransformAbsolute(eTrackingOrigin, pmatTrackingOriginToKeyboardTransform);
}
void CVROverlay_011::SetKeyboardPositionForOverlay(vr::VROverlayHandle_t ulOverlayHandle, vr::HmdRect2_t avoidRect) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_011)");
	return base->SetKeyboardPositionForOverlay(ulOverlayHandle, avoidRect);
}
// FnTable for CVROverlay_011:
static CVROverlay_011 *fntable_Overlay_011_instance = NULL;
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_011_impl_FindOverlay(const char* pchOverlayKey, vr::VROverlayHandle_t* pOverlayHandle) { return fntable_Overlay_011_instance->FindOverlay(pchOverlayKey, pOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_011_impl_CreateOverlay(const char* pchOverlayKey, const char* pchOverlayFriendlyName, vr::VROverlayHandle_t* pOverlayHandle) { return fntable_Overlay_011_instance->CreateOverlay(pchOverlayKey, pchOverlayFriendlyName, pOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_011_impl_DestroyOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_011_instance->DestroyOverlay(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_011_impl_SetHighQualityOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_011_instance->SetHighQualityOverlay(ulOverlayHandle); }
static vr::VROverlayHandle_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_011_impl_GetHighQualityOverlay() { return fntable_Overlay_011_instance->GetHighQualityOverlay(); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_011_impl_GetOverlayKey(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::EVROverlayError* pError) { return fntable_Overlay_011_instance->GetOverlayKey(ulOverlayHandle, pchValue, unBufferSize, pError); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_011_impl_GetOverlayName(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::EVROverlayError* pError) { return fntable_Overlay_011_instance->GetOverlayName(ulOverlayHandle, pchValue, unBufferSize, pError); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_011_impl_GetOverlayImageData(vr::VROverlayHandle_t ulOverlayHandle, void* pvBuffer, uint32_t unBufferSize, uint32_t* punWidth, uint32_t* punHeight) { return fntable_Overlay_011_instance->GetOverlayImageData(ulOverlayHandle, pvBuffer, unBufferSize, punWidth, punHeight); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_Overlay_011_impl_GetOverlayErrorNameFromEnum(vr::EVROverlayError error) { return fntable_Overlay_011_instance->GetOverlayErrorNameFromEnum(error); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_011_impl_SetOverlayRenderingPid(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unPID) { return fntable_Overlay_011_instance->SetOverlayRenderingPid(ulOverlayHandle, unPID); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_011_impl_GetOverlayRenderingPid(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_011_instance->GetOverlayRenderingPid(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_011_impl_SetOverlayFlag(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_011::VROverlayFlags eOverlayFlag, bool bEnabled) { return fntable_Overlay_011_instance->SetOverlayFlag(ulOverlayHandle, eOverlayFlag, bEnabled); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_011_impl_GetOverlayFlag(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_011::VROverlayFlags eOverlayFlag, bool* pbEnabled) { return fntable_Overlay_011_instance->GetOverlayFlag(ulOverlayHandle, eOverlayFlag, pbEnabled); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_011_impl_SetOverlayColor(vr::VROverlayHandle_t ulOverlayHandle, float fRed, float fGreen, float fBlue) { return fntable_Overlay_011_instance->SetOverlayColor(ulOverlayHandle, fRed, fGreen, fBlue); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_011_impl_GetOverlayColor(vr::VROverlayHandle_t ulOverlayHandle, float* pfRed, float* pfGreen, float* pfBlue) { return fntable_Overlay_011_instance->GetOverlayColor(ulOverlayHandle, pfRed, pfGreen, pfBlue); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_011_impl_SetOverlayAlpha(vr::VROverlayHandle_t ulOverlayHandle, float fAlpha) { return fntable_Overlay_011_instance->SetOverlayAlpha(ulOverlayHandle, fAlpha); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_011_impl_GetOverlayAlpha(vr::VROverlayHandle_t ulOverlayHandle, float* pfAlpha) { return fntable_Overlay_011_instance->GetOverlayAlpha(ulOverlayHandle, pfAlpha); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_011_impl_SetOverlayWidthInMeters(vr::VROverlayHandle_t ulOverlayHandle, float fWidthInMeters) { return fntable_Overlay_011_instance->SetOverlayWidthInMeters(ulOverlayHandle, fWidthInMeters); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_011_impl_GetOverlayWidthInMeters(vr::VROverlayHandle_t ulOverlayHandle, float* pfWidthInMeters) { return fntable_Overlay_011_instance->GetOverlayWidthInMeters(ulOverlayHandle, pfWidthInMeters); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_011_impl_SetOverlayAutoCurveDistanceRangeInMeters(vr::VROverlayHandle_t ulOverlayHandle, float fMinDistanceInMeters, float fMaxDistanceInMeters) { return fntable_Overlay_011_instance->SetOverlayAutoCurveDistanceRangeInMeters(ulOverlayHandle, fMinDistanceInMeters, fMaxDistanceInMeters); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_011_impl_GetOverlayAutoCurveDistanceRangeInMeters(vr::VROverlayHandle_t ulOverlayHandle, float* pfMinDistanceInMeters, float* pfMaxDistanceInMeters) { return fntable_Overlay_011_instance->GetOverlayAutoCurveDistanceRangeInMeters(ulOverlayHandle, pfMinDistanceInMeters, pfMaxDistanceInMeters); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_011_impl_SetOverlayTextureColorSpace(vr::VROverlayHandle_t ulOverlayHandle, vr::EColorSpace eTextureColorSpace) { return fntable_Overlay_011_instance->SetOverlayTextureColorSpace(ulOverlayHandle, eTextureColorSpace); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_011_impl_GetOverlayTextureColorSpace(vr::VROverlayHandle_t ulOverlayHandle, vr::EColorSpace* peTextureColorSpace) { return fntable_Overlay_011_instance->GetOverlayTextureColorSpace(ulOverlayHandle, peTextureColorSpace); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_011_impl_SetOverlayTextureBounds(vr::VROverlayHandle_t ulOverlayHandle, const vr::VRTextureBounds_t* pOverlayTextureBounds) { return fntable_Overlay_011_instance->SetOverlayTextureBounds(ulOverlayHandle, pOverlayTextureBounds); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_011_impl_GetOverlayTextureBounds(vr::VROverlayHandle_t ulOverlayHandle, vr::VRTextureBounds_t* pOverlayTextureBounds) { return fntable_Overlay_011_instance->GetOverlayTextureBounds(ulOverlayHandle, pOverlayTextureBounds); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_011_impl_GetOverlayTransformType(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_011::VROverlayTransformType* peTransformType) { return fntable_Overlay_011_instance->GetOverlayTransformType(ulOverlayHandle, peTransformType); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_011_impl_SetOverlayTransformAbsolute(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin eTrackingOrigin, const vr::HmdMatrix34_t* pmatTrackingOriginToOverlayTransform) { return fntable_Overlay_011_instance->SetOverlayTransformAbsolute(ulOverlayHandle, eTrackingOrigin, pmatTrackingOriginToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_011_impl_GetOverlayTransformAbsolute(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin* peTrackingOrigin, vr::HmdMatrix34_t* pmatTrackingOriginToOverlayTransform) { return fntable_Overlay_011_instance->GetOverlayTransformAbsolute(ulOverlayHandle, peTrackingOrigin, pmatTrackingOriginToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_011_impl_SetOverlayTransformTrackedDeviceRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unTrackedDevice, const vr::HmdMatrix34_t* pmatTrackedDeviceToOverlayTransform) { return fntable_Overlay_011_instance->SetOverlayTransformTrackedDeviceRelative(ulOverlayHandle, unTrackedDevice, pmatTrackedDeviceToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_011_impl_GetOverlayTransformTrackedDeviceRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t* punTrackedDevice, vr::HmdMatrix34_t* pmatTrackedDeviceToOverlayTransform) { return fntable_Overlay_011_instance->GetOverlayTransformTrackedDeviceRelative(ulOverlayHandle, punTrackedDevice, pmatTrackedDeviceToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_011_impl_SetOverlayTransformTrackedDeviceComponent(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unDeviceIndex, const char* pchComponentName) { return fntable_Overlay_011_instance->SetOverlayTransformTrackedDeviceComponent(ulOverlayHandle, unDeviceIndex, pchComponentName); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_011_impl_GetOverlayTransformTrackedDeviceComponent(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t* punDeviceIndex, char* pchComponentName, uint32_t unComponentNameSize) { return fntable_Overlay_011_instance->GetOverlayTransformTrackedDeviceComponent(ulOverlayHandle, punDeviceIndex, pchComponentName, unComponentNameSize); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_011_impl_ShowOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_011_instance->ShowOverlay(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_011_impl_HideOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_011_instance->HideOverlay(ulOverlayHandle); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_011_impl_IsOverlayVisible(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_011_instance->IsOverlayVisible(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_011_impl_GetTransformForOverlayCoordinates(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin eTrackingOrigin, vr::HmdVector2_t coordinatesInOverlay, vr::HmdMatrix34_t* pmatTransform) { return fntable_Overlay_011_instance->GetTransformForOverlayCoordinates(ulOverlayHandle, eTrackingOrigin, coordinatesInOverlay, pmatTransform); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_011_impl_PollNextOverlayEvent(vr::VROverlayHandle_t ulOverlayHandle, vr::VREvent_t* pEvent, uint32_t uncbVREvent) { return fntable_Overlay_011_instance->PollNextOverlayEvent(ulOverlayHandle, pEvent, uncbVREvent); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_011_impl_GetOverlayInputMethod(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_011::VROverlayInputMethod* peInputMethod) { return fntable_Overlay_011_instance->GetOverlayInputMethod(ulOverlayHandle, peInputMethod); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_011_impl_SetOverlayInputMethod(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_011::VROverlayInputMethod eInputMethod) { return fntable_Overlay_011_instance->SetOverlayInputMethod(ulOverlayHandle, eInputMethod); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_011_impl_GetOverlayMouseScale(vr::VROverlayHandle_t ulOverlayHandle, vr::HmdVector2_t* pvecMouseScale) { return fntable_Overlay_011_instance->GetOverlayMouseScale(ulOverlayHandle, pvecMouseScale); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_011_impl_SetOverlayMouseScale(vr::VROverlayHandle_t ulOverlayHandle, const vr::HmdVector2_t* pvecMouseScale) { return fntable_Overlay_011_instance->SetOverlayMouseScale(ulOverlayHandle, pvecMouseScale); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_011_impl_ComputeOverlayIntersection(vr::VROverlayHandle_t ulOverlayHandle, const vr::IVROverlay_011::VROverlayIntersectionParams_t* pParams, vr::IVROverlay_011::VROverlayIntersectionResults_t* pResults) { return fntable_Overlay_011_instance->ComputeOverlayIntersection(ulOverlayHandle, pParams, pResults); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_011_impl_HandleControllerOverlayInteractionAsMouse(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unControllerDeviceIndex) { return fntable_Overlay_011_instance->HandleControllerOverlayInteractionAsMouse(ulOverlayHandle, unControllerDeviceIndex); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_011_impl_IsHoverTargetOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_011_instance->IsHoverTargetOverlay(ulOverlayHandle); }
static vr::VROverlayHandle_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_011_impl_GetGamepadFocusOverlay() { return fntable_Overlay_011_instance->GetGamepadFocusOverlay(); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_011_impl_SetGamepadFocusOverlay(vr::VROverlayHandle_t ulNewFocusOverlay) { return fntable_Overlay_011_instance->SetGamepadFocusOverlay(ulNewFocusOverlay); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_011_impl_SetOverlayNeighbor(vr::IVROverlay_011::EOverlayDirection eDirection, vr::VROverlayHandle_t ulFrom, vr::VROverlayHandle_t ulTo) { return fntable_Overlay_011_instance->SetOverlayNeighbor(eDirection, ulFrom, ulTo); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_011_impl_MoveGamepadFocusToNeighbor(vr::IVROverlay_011::EOverlayDirection eDirection, vr::VROverlayHandle_t ulFrom) { return fntable_Overlay_011_instance->MoveGamepadFocusToNeighbor(eDirection, ulFrom); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_011_impl_SetOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle, const vr::Texture_t* pTexture) { return fntable_Overlay_011_instance->SetOverlayTexture(ulOverlayHandle, pTexture); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_011_impl_ClearOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_011_instance->ClearOverlayTexture(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_011_impl_SetOverlayRaw(vr::VROverlayHandle_t ulOverlayHandle, void* pvBuffer, uint32_t unWidth, uint32_t unHeight, uint32_t unDepth) { return fntable_Overlay_011_instance->SetOverlayRaw(ulOverlayHandle, pvBuffer, unWidth, unHeight, unDepth); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_011_impl_SetOverlayFromFile(vr::VROverlayHandle_t ulOverlayHandle, const char* pchFilePath) { return fntable_Overlay_011_instance->SetOverlayFromFile(ulOverlayHandle, pchFilePath); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_011_impl_GetOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle, void** pNativeTextureHandle, void* pNativeTextureRef, uint32_t* pWidth, uint32_t* pHeight, uint32_t* pNativeFormat, EGraphicsAPIConvention* pAPI, vr::EColorSpace* pColorSpace) { return fntable_Overlay_011_instance->GetOverlayTexture(ulOverlayHandle, pNativeTextureHandle, pNativeTextureRef, pWidth, pHeight, pNativeFormat, pAPI, pColorSpace); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_011_impl_ReleaseNativeOverlayHandle(vr::VROverlayHandle_t ulOverlayHandle, void* pNativeTextureHandle) { return fntable_Overlay_011_instance->ReleaseNativeOverlayHandle(ulOverlayHandle, pNativeTextureHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_011_impl_CreateDashboardOverlay(const char* pchOverlayKey, const char* pchOverlayFriendlyName, vr::VROverlayHandle_t* pMainHandle, vr::VROverlayHandle_t* pThumbnailHandle) { return fntable_Overlay_011_instance->CreateDashboardOverlay(pchOverlayKey, pchOverlayFriendlyName, pMainHandle, pThumbnailHandle); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_011_impl_IsDashboardVisible() { return fntable_Overlay_011_instance->IsDashboardVisible(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_011_impl_IsActiveDashboardOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_011_instance->IsActiveDashboardOverlay(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_011_impl_SetDashboardOverlaySceneProcess(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unProcessId) { return fntable_Overlay_011_instance->SetDashboardOverlaySceneProcess(ulOverlayHandle, unProcessId); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_011_impl_GetDashboardOverlaySceneProcess(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* punProcessId) { return fntable_Overlay_011_instance->GetDashboardOverlaySceneProcess(ulOverlayHandle, punProcessId); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_011_impl_ShowDashboard(const char* pchOverlayToShow) { return fntable_Overlay_011_instance->ShowDashboard(pchOverlayToShow); }
static vr::TrackedDeviceIndex_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_011_impl_GetPrimaryDashboardDevice() { return fntable_Overlay_011_instance->GetPrimaryDashboardDevice(); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_011_impl_ShowKeyboard(vr::IVROverlay_011::EGamepadTextInputMode eInputMode, vr::IVROverlay_011::EGamepadTextInputLineMode eLineInputMode, const char* pchDescription, uint32_t unCharMax, const char* pchExistingText, bool bUseMinimalMode, uint64_t uUserValue) { return fntable_Overlay_011_instance->ShowKeyboard(eInputMode, eLineInputMode, pchDescription, unCharMax, pchExistingText, bUseMinimalMode, uUserValue); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_011_impl_ShowKeyboardForOverlay(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_011::EGamepadTextInputMode eInputMode, vr::IVROverlay_011::EGamepadTextInputLineMode eLineInputMode, const char* pchDescription, uint32_t unCharMax, const char* pchExistingText, bool bUseMinimalMode, uint64_t uUserValue) { return fntable_Overlay_011_instance->ShowKeyboardForOverlay(ulOverlayHandle, eInputMode, eLineInputMode, pchDescription, unCharMax, pchExistingText, bUseMinimalMode, uUserValue); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_011_impl_GetKeyboardText(char* pchText, uint32_t cchText) { return fntable_Overlay_011_instance->GetKeyboardText(pchText, cchText); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_011_impl_HideKeyboard() { return fntable_Overlay_011_instance->HideKeyboard(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_011_impl_SetKeyboardTransformAbsolute(vr::ETrackingUniverseOrigin eTrackingOrigin, const vr::HmdMatrix34_t* pmatTrackingOriginToKeyboardTransform) { return fntable_Overlay_011_instance->SetKeyboardTransformAbsolute(eTrackingOrigin, pmatTrackingOriginToKeyboardTransform); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_011_impl_SetKeyboardPositionForOverlay(vr::VROverlayHandle_t ulOverlayHandle, vr::HmdRect2_t avoidRect) { return fntable_Overlay_011_instance->SetKeyboardPositionForOverlay(ulOverlayHandle, avoidRect); }
static void *fntable_Overlay_011_funcs[] = {
	(void*) fntable_Overlay_011_impl_FindOverlay,
	(void*) fntable_Overlay_011_impl_CreateOverlay,
	(void*) fntable_Overlay_011_impl_DestroyOverlay,
	(void*) fntable_Overlay_011_impl_SetHighQualityOverlay,
	(void*) fntable_Overlay_011_impl_GetHighQualityOverlay,
	(void*) fntable_Overlay_011_impl_GetOverlayKey,
	(void*) fntable_Overlay_011_impl_GetOverlayName,
	(void*) fntable_Overlay_011_impl_GetOverlayImageData,
	(void*) fntable_Overlay_011_impl_GetOverlayErrorNameFromEnum,
	(void*) fntable_Overlay_011_impl_SetOverlayRenderingPid,
	(void*) fntable_Overlay_011_impl_GetOverlayRenderingPid,
	(void*) fntable_Overlay_011_impl_SetOverlayFlag,
	(void*) fntable_Overlay_011_impl_GetOverlayFlag,
	(void*) fntable_Overlay_011_impl_SetOverlayColor,
	(void*) fntable_Overlay_011_impl_GetOverlayColor,
	(void*) fntable_Overlay_011_impl_SetOverlayAlpha,
	(void*) fntable_Overlay_011_impl_GetOverlayAlpha,
	(void*) fntable_Overlay_011_impl_SetOverlayWidthInMeters,
	(void*) fntable_Overlay_011_impl_GetOverlayWidthInMeters,
	(void*) fntable_Overlay_011_impl_SetOverlayAutoCurveDistanceRangeInMeters,
	(void*) fntable_Overlay_011_impl_GetOverlayAutoCurveDistanceRangeInMeters,
	(void*) fntable_Overlay_011_impl_SetOverlayTextureColorSpace,
	(void*) fntable_Overlay_011_impl_GetOverlayTextureColorSpace,
	(void*) fntable_Overlay_011_impl_SetOverlayTextureBounds,
	(void*) fntable_Overlay_011_impl_GetOverlayTextureBounds,
	(void*) fntable_Overlay_011_impl_GetOverlayTransformType,
	(void*) fntable_Overlay_011_impl_SetOverlayTransformAbsolute,
	(void*) fntable_Overlay_011_impl_GetOverlayTransformAbsolute,
	(void*) fntable_Overlay_011_impl_SetOverlayTransformTrackedDeviceRelative,
	(void*) fntable_Overlay_011_impl_GetOverlayTransformTrackedDeviceRelative,
	(void*) fntable_Overlay_011_impl_SetOverlayTransformTrackedDeviceComponent,
	(void*) fntable_Overlay_011_impl_GetOverlayTransformTrackedDeviceComponent,
	(void*) fntable_Overlay_011_impl_ShowOverlay,
	(void*) fntable_Overlay_011_impl_HideOverlay,
	(void*) fntable_Overlay_011_impl_IsOverlayVisible,
	(void*) fntable_Overlay_011_impl_GetTransformForOverlayCoordinates,
	(void*) fntable_Overlay_011_impl_PollNextOverlayEvent,
	(void*) fntable_Overlay_011_impl_GetOverlayInputMethod,
	(void*) fntable_Overlay_011_impl_SetOverlayInputMethod,
	(void*) fntable_Overlay_011_impl_GetOverlayMouseScale,
	(void*) fntable_Overlay_011_impl_SetOverlayMouseScale,
	(void*) fntable_Overlay_011_impl_ComputeOverlayIntersection,
	(void*) fntable_Overlay_011_impl_HandleControllerOverlayInteractionAsMouse,
	(void*) fntable_Overlay_011_impl_IsHoverTargetOverlay,
	(void*) fntable_Overlay_011_impl_GetGamepadFocusOverlay,
	(void*) fntable_Overlay_011_impl_SetGamepadFocusOverlay,
	(void*) fntable_Overlay_011_impl_SetOverlayNeighbor,
	(void*) fntable_Overlay_011_impl_MoveGamepadFocusToNeighbor,
	(void*) fntable_Overlay_011_impl_SetOverlayTexture,
	(void*) fntable_Overlay_011_impl_ClearOverlayTexture,
	(void*) fntable_Overlay_011_impl_SetOverlayRaw,
	(void*) fntable_Overlay_011_impl_SetOverlayFromFile,
	(void*) fntable_Overlay_011_impl_GetOverlayTexture,
	(void*) fntable_Overlay_011_impl_ReleaseNativeOverlayHandle,
	(void*) fntable_Overlay_011_impl_CreateDashboardOverlay,
	(void*) fntable_Overlay_011_impl_IsDashboardVisible,
	(void*) fntable_Overlay_011_impl_IsActiveDashboardOverlay,
	(void*) fntable_Overlay_011_impl_SetDashboardOverlaySceneProcess,
	(void*) fntable_Overlay_011_impl_GetDashboardOverlaySceneProcess,
	(void*) fntable_Overlay_011_impl_ShowDashboard,
	(void*) fntable_Overlay_011_impl_GetPrimaryDashboardDevice,
	(void*) fntable_Overlay_011_impl_ShowKeyboard,
	(void*) fntable_Overlay_011_impl_ShowKeyboardForOverlay,
	(void*) fntable_Overlay_011_impl_GetKeyboardText,
	(void*) fntable_Overlay_011_impl_HideKeyboard,
	(void*) fntable_Overlay_011_impl_SetKeyboardTransformAbsolute,
	(void*) fntable_Overlay_011_impl_SetKeyboardPositionForOverlay,
};
void** CVROverlay_011::_GetStatFuncList() { fntable_Overlay_011_instance = this; return fntable_Overlay_011_funcs; }
void CVROverlay_011::Delete() { delete this; }
// Misc for CVROverlay_013:
CVROverlay_013::CVROverlay_013() : base(GetCreateBaseOverlay()) {}
// Interface methods for CVROverlay_013:
vr::EVROverlayError CVROverlay_013::FindOverlay(const char* pchOverlayKey, vr::VROverlayHandle_t* pOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_013)");
	return base->FindOverlay(pchOverlayKey, pOverlayHandle);
}
vr::EVROverlayError CVROverlay_013::CreateOverlay(const char* pchOverlayKey, const char* pchOverlayFriendlyName, vr::VROverlayHandle_t* pOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_013)");
	return base->CreateOverlay(pchOverlayKey, pchOverlayFriendlyName, pOverlayHandle);
}
vr::EVROverlayError CVROverlay_013::DestroyOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_013)");
	return base->DestroyOverlay(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_013::SetHighQualityOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_013)");
	return base->SetHighQualityOverlay(ulOverlayHandle);
}
vr::VROverlayHandle_t CVROverlay_013::GetHighQualityOverlay() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_013)");
	return base->GetHighQualityOverlay();
}
uint32_t CVROverlay_013::GetOverlayKey(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::EVROverlayError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_013)");
	return base->GetOverlayKey(ulOverlayHandle, pchValue, unBufferSize, pError);
}
uint32_t CVROverlay_013::GetOverlayName(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::EVROverlayError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_013)");
	return base->GetOverlayName(ulOverlayHandle, pchValue, unBufferSize, pError);
}
vr::EVROverlayError CVROverlay_013::GetOverlayImageData(vr::VROverlayHandle_t ulOverlayHandle, void* pvBuffer, uint32_t unBufferSize, uint32_t* punWidth, uint32_t* punHeight) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_013)");
	return base->GetOverlayImageData(ulOverlayHandle, pvBuffer, unBufferSize, punWidth, punHeight);
}
const char* CVROverlay_013::GetOverlayErrorNameFromEnum(vr::EVROverlayError error) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_013)");
	return base->GetOverlayErrorNameFromEnum(error);
}
vr::EVROverlayError CVROverlay_013::SetOverlayRenderingPid(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unPID) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_013)");
	return base->SetOverlayRenderingPid(ulOverlayHandle, unPID);
}
uint32_t CVROverlay_013::GetOverlayRenderingPid(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_013)");
	return base->GetOverlayRenderingPid(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_013::SetOverlayFlag(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_013::VROverlayFlags eOverlayFlag, bool bEnabled) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_013)");
	return base->SetOverlayFlag(ulOverlayHandle, (OOVR_VROverlayFlags) eOverlayFlag, bEnabled);
}
vr::EVROverlayError CVROverlay_013::GetOverlayFlag(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_013::VROverlayFlags eOverlayFlag, bool* pbEnabled) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_013)");
	return base->GetOverlayFlag(ulOverlayHandle, (OOVR_VROverlayFlags) eOverlayFlag, pbEnabled);
}
vr::EVROverlayError CVROverlay_013::SetOverlayColor(vr::VROverlayHandle_t ulOverlayHandle, float fRed, float fGreen, float fBlue) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_013)");
	return base->SetOverlayColor(ulOverlayHandle, fRed, fGreen, fBlue);
}
vr::EVROverlayError CVROverlay_013::GetOverlayColor(vr::VROverlayHandle_t ulOverlayHandle, float* pfRed, float* pfGreen, float* pfBlue) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_013)");
	return base->GetOverlayColor(ulOverlayHandle, pfRed, pfGreen, pfBlue);
}
vr::EVROverlayError CVROverlay_013::SetOverlayAlpha(vr::VROverlayHandle_t ulOverlayHandle, float fAlpha) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_013)");
	return base->SetOverlayAlpha(ulOverlayHandle, fAlpha);
}
vr::EVROverlayError CVROverlay_013::GetOverlayAlpha(vr::VROverlayHandle_t ulOverlayHandle, float* pfAlpha) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_013)");
	return base->GetOverlayAlpha(ulOverlayHandle, pfAlpha);
}
vr::EVROverlayError CVROverlay_013::SetOverlayTexelAspect(vr::VROverlayHandle_t ulOverlayHandle, float fTexelAspect) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_013)");
	return base->SetOverlayTexelAspect(ulOverlayHandle, fTexelAspect);
}
vr::EVROverlayError CVROverlay_013::GetOverlayTexelAspect(vr::VROverlayHandle_t ulOverlayHandle, float* pfTexelAspect) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_013)");
	return base->GetOverlayTexelAspect(ulOverlayHandle, pfTexelAspect);
}
vr::EVROverlayError CVROverlay_013::SetOverlaySortOrder(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unSortOrder) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_013)");
	return base->SetOverlaySortOrder(ulOverlayHandle, unSortOrder);
}
vr::EVROverlayError CVROverlay_013::GetOverlaySortOrder(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* punSortOrder) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_013)");
	return base->GetOverlaySortOrder(ulOverlayHandle, punSortOrder);
}
vr::EVROverlayError CVROverlay_013::SetOverlayWidthInMeters(vr::VROverlayHandle_t ulOverlayHandle, float fWidthInMeters) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_013)");
	return base->SetOverlayWidthInMeters(ulOverlayHandle, fWidthInMeters);
}
vr::EVROverlayError CVROverlay_013::GetOverlayWidthInMeters(vr::VROverlayHandle_t ulOverlayHandle, float* pfWidthInMeters) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_013)");
	return base->GetOverlayWidthInMeters(ulOverlayHandle, pfWidthInMeters);
}
vr::EVROverlayError CVROverlay_013::SetOverlayAutoCurveDistanceRangeInMeters(vr::VROverlayHandle_t ulOverlayHandle, float fMinDistanceInMeters, float fMaxDistanceInMeters) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_013)");
	return base->SetOverlayAutoCurveDistanceRangeInMeters(ulOverlayHandle, fMinDistanceInMeters, fMaxDistanceInMeters);
}
vr::EVROverlayError CVROverlay_013::GetOverlayAutoCurveDistanceRangeInMeters(vr::VROverlayHandle_t ulOverlayHandle, float* pfMinDistanceInMeters, float* pfMaxDistanceInMeters) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_013)");
	return base->GetOverlayAutoCurveDistanceRangeInMeters(ulOverlayHandle, pfMinDistanceInMeters, pfMaxDistanceInMeters);
}
vr::EVROverlayError CVROverlay_013::SetOverlayTextureColorSpace(vr::VROverlayHandle_t ulOverlayHandle, vr::EColorSpace eTextureColorSpace) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_013)");
	return base->SetOverlayTextureColorSpace(ulOverlayHandle, eTextureColorSpace);
}
vr::EVROverlayError CVROverlay_013::GetOverlayTextureColorSpace(vr::VROverlayHandle_t ulOverlayHandle, vr::EColorSpace* peTextureColorSpace) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_013)");
	return base->GetOverlayTextureColorSpace(ulOverlayHandle, peTextureColorSpace);
}
vr::EVROverlayError CVROverlay_013::SetOverlayTextureBounds(vr::VROverlayHandle_t ulOverlayHandle, const vr::VRTextureBounds_t* pOverlayTextureBounds) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_013)");
	return base->SetOverlayTextureBounds(ulOverlayHandle, pOverlayTextureBounds);
}
vr::EVROverlayError CVROverlay_013::GetOverlayTextureBounds(vr::VROverlayHandle_t ulOverlayHandle, vr::VRTextureBounds_t* pOverlayTextureBounds) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_013)");
	return base->GetOverlayTextureBounds(ulOverlayHandle, pOverlayTextureBounds);
}
vr::EVROverlayError CVROverlay_013::GetOverlayTransformType(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_013::VROverlayTransformType* peTransformType) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_013)");
	return base->GetOverlayTransformType(ulOverlayHandle, (OOVR_VROverlayTransformType*) peTransformType);
}
vr::EVROverlayError CVROverlay_013::SetOverlayTransformAbsolute(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin eTrackingOrigin, const vr::HmdMatrix34_t* pmatTrackingOriginToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_013)");
	return base->SetOverlayTransformAbsolute(ulOverlayHandle, eTrackingOrigin, pmatTrackingOriginToOverlayTransform);
}
vr::EVROverlayError CVROverlay_013::GetOverlayTransformAbsolute(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin* peTrackingOrigin, vr::HmdMatrix34_t* pmatTrackingOriginToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_013)");
	return base->GetOverlayTransformAbsolute(ulOverlayHandle, peTrackingOrigin, pmatTrackingOriginToOverlayTransform);
}
vr::EVROverlayError CVROverlay_013::SetOverlayTransformTrackedDeviceRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unTrackedDevice, const vr::HmdMatrix34_t* pmatTrackedDeviceToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_013)");
	return base->SetOverlayTransformTrackedDeviceRelative(ulOverlayHandle, unTrackedDevice, pmatTrackedDeviceToOverlayTransform);
}
vr::EVROverlayError CVROverlay_013::GetOverlayTransformTrackedDeviceRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t* punTrackedDevice, vr::HmdMatrix34_t* pmatTrackedDeviceToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_013)");
	return base->GetOverlayTransformTrackedDeviceRelative(ulOverlayHandle, punTrackedDevice, pmatTrackedDeviceToOverlayTransform);
}
vr::EVROverlayError CVROverlay_013::SetOverlayTransformTrackedDeviceComponent(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unDeviceIndex, const char* pchComponentName) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_013)");
	return base->SetOverlayTransformTrackedDeviceComponent(ulOverlayHandle, unDeviceIndex, pchComponentName);
}
vr::EVROverlayError CVROverlay_013::GetOverlayTransformTrackedDeviceComponent(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t* punDeviceIndex, char* pchComponentName, uint32_t unComponentNameSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_013)");
	return base->GetOverlayTransformTrackedDeviceComponent(ulOverlayHandle, punDeviceIndex, pchComponentName, unComponentNameSize);
}
vr::EVROverlayError CVROverlay_013::ShowOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_013)");
	return base->ShowOverlay(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_013::HideOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_013)");
	return base->HideOverlay(ulOverlayHandle);
}
bool CVROverlay_013::IsOverlayVisible(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_013)");
	return base->IsOverlayVisible(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_013::GetTransformForOverlayCoordinates(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin eTrackingOrigin, vr::HmdVector2_t coordinatesInOverlay, vr::HmdMatrix34_t* pmatTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_013)");
	return base->GetTransformForOverlayCoordinates(ulOverlayHandle, eTrackingOrigin, coordinatesInOverlay, pmatTransform);
}
bool CVROverlay_013::PollNextOverlayEvent(vr::VROverlayHandle_t ulOverlayHandle, vr::VREvent_t* pEvent, uint32_t uncbVREvent) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_013)");
	return base->PollNextOverlayEvent(ulOverlayHandle, pEvent, uncbVREvent);
}
vr::EVROverlayError CVROverlay_013::GetOverlayInputMethod(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_013::VROverlayInputMethod* peInputMethod) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_013)");
	return base->GetOverlayInputMethod(ulOverlayHandle, (OOVR_VROverlayInputMethod*) peInputMethod);
}
vr::EVROverlayError CVROverlay_013::SetOverlayInputMethod(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_013::VROverlayInputMethod eInputMethod) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_013)");
	return base->SetOverlayInputMethod(ulOverlayHandle, (OOVR_VROverlayInputMethod) eInputMethod);
}
vr::EVROverlayError CVROverlay_013::GetOverlayMouseScale(vr::VROverlayHandle_t ulOverlayHandle, vr::HmdVector2_t* pvecMouseScale) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_013)");
	return base->GetOverlayMouseScale(ulOverlayHandle, pvecMouseScale);
}
vr::EVROverlayError CVROverlay_013::SetOverlayMouseScale(vr::VROverlayHandle_t ulOverlayHandle, const vr::HmdVector2_t* pvecMouseScale) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_013)");
	return base->SetOverlayMouseScale(ulOverlayHandle, pvecMouseScale);
}
bool CVROverlay_013::ComputeOverlayIntersection(vr::VROverlayHandle_t ulOverlayHandle, const vr::IVROverlay_013::VROverlayIntersectionParams_t* pParams, vr::IVROverlay_013::VROverlayIntersectionResults_t* pResults) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_013)");
	return base->ComputeOverlayIntersection(ulOverlayHandle, (const OOVR_VROverlayIntersectionParams_t*) pParams, (OOVR_VROverlayIntersectionResults_t*) pResults);
}
bool CVROverlay_013::HandleControllerOverlayInteractionAsMouse(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unControllerDeviceIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_013)");
	return base->HandleControllerOverlayInteractionAsMouse(ulOverlayHandle, unControllerDeviceIndex);
}
bool CVROverlay_013::IsHoverTargetOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_013)");
	return base->IsHoverTargetOverlay(ulOverlayHandle);
}
vr::VROverlayHandle_t CVROverlay_013::GetGamepadFocusOverlay() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_013)");
	return base->GetGamepadFocusOverlay();
}
vr::EVROverlayError CVROverlay_013::SetGamepadFocusOverlay(vr::VROverlayHandle_t ulNewFocusOverlay) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_013)");
	return base->SetGamepadFocusOverlay(ulNewFocusOverlay);
}
vr::EVROverlayError CVROverlay_013::SetOverlayNeighbor(vr::IVROverlay_013::EOverlayDirection eDirection, vr::VROverlayHandle_t ulFrom, vr::VROverlayHandle_t ulTo) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_013)");
	return base->SetOverlayNeighbor((OOVR_EOverlayDirection) eDirection, ulFrom, ulTo);
}
vr::EVROverlayError CVROverlay_013::MoveGamepadFocusToNeighbor(vr::IVROverlay_013::EOverlayDirection eDirection, vr::VROverlayHandle_t ulFrom) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_013)");
	return base->MoveGamepadFocusToNeighbor((OOVR_EOverlayDirection) eDirection, ulFrom);
}
vr::EVROverlayError CVROverlay_013::SetOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle, const vr::Texture_t* pTexture) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_013)");
	return base->SetOverlayTexture(ulOverlayHandle, pTexture);
}
vr::EVROverlayError CVROverlay_013::ClearOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_013)");
	return base->ClearOverlayTexture(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_013::SetOverlayRaw(vr::VROverlayHandle_t ulOverlayHandle, void* pvBuffer, uint32_t unWidth, uint32_t unHeight, uint32_t unDepth) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_013)");
	return base->SetOverlayRaw(ulOverlayHandle, pvBuffer, unWidth, unHeight, unDepth);
}
vr::EVROverlayError CVROverlay_013::SetOverlayFromFile(vr::VROverlayHandle_t ulOverlayHandle, const char* pchFilePath) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_013)");
	return base->SetOverlayFromFile(ulOverlayHandle, pchFilePath);
}
vr::EVROverlayError CVROverlay_013::ReleaseNativeOverlayHandle(vr::VROverlayHandle_t ulOverlayHandle, void* pNativeTextureHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_013)");
	return base->ReleaseNativeOverlayHandle(ulOverlayHandle, pNativeTextureHandle);
}
vr::EVROverlayError CVROverlay_013::GetOverlayTextureSize(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* pWidth, uint32_t* pHeight) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_013)");
	return base->GetOverlayTextureSize(ulOverlayHandle, pWidth, pHeight);
}
vr::EVROverlayError CVROverlay_013::CreateDashboardOverlay(const char* pchOverlayKey, const char* pchOverlayFriendlyName, vr::VROverlayHandle_t* pMainHandle, vr::VROverlayHandle_t* pThumbnailHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_013)");
	return base->CreateDashboardOverlay(pchOverlayKey, pchOverlayFriendlyName, pMainHandle, pThumbnailHandle);
}
bool CVROverlay_013::IsDashboardVisible() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_013)");
	return base->IsDashboardVisible();
}
bool CVROverlay_013::IsActiveDashboardOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_013)");
	return base->IsActiveDashboardOverlay(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_013::SetDashboardOverlaySceneProcess(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unProcessId) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_013)");
	return base->SetDashboardOverlaySceneProcess(ulOverlayHandle, unProcessId);
}
vr::EVROverlayError CVROverlay_013::GetDashboardOverlaySceneProcess(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* punProcessId) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_013)");
	return base->GetDashboardOverlaySceneProcess(ulOverlayHandle, punProcessId);
}
void CVROverlay_013::ShowDashboard(const char* pchOverlayToShow) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_013)");
	return base->ShowDashboard(pchOverlayToShow);
}
vr::TrackedDeviceIndex_t CVROverlay_013::GetPrimaryDashboardDevice() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_013)");
	return base->GetPrimaryDashboardDevice();
}
vr::EVROverlayError CVROverlay_013::ShowKeyboard(vr::IVROverlay_013::EGamepadTextInputMode eInputMode, vr::IVROverlay_013::EGamepadTextInputLineMode eLineInputMode, const char* pchDescription, uint32_t unCharMax, const char* pchExistingText, bool bUseMinimalMode, uint64_t uUserValue) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_013)");
	return base->ShowKeyboard((OOVR_EGamepadTextInputMode) eInputMode, (OOVR_EGamepadTextInputLineMode) eLineInputMode, pchDescription, unCharMax, pchExistingText, bUseMinimalMode, uUserValue);
}
vr::EVROverlayError CVROverlay_013::ShowKeyboardForOverlay(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_013::EGamepadTextInputMode eInputMode, vr::IVROverlay_013::EGamepadTextInputLineMode eLineInputMode, const char* pchDescription, uint32_t unCharMax, const char* pchExistingText, bool bUseMinimalMode, uint64_t uUserValue) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_013)");
	return base->ShowKeyboardForOverlay(ulOverlayHandle, (OOVR_EGamepadTextInputMode) eInputMode, (OOVR_EGamepadTextInputLineMode) eLineInputMode, pchDescription, unCharMax, pchExistingText, bUseMinimalMode, uUserValue);
}
uint32_t CVROverlay_013::GetKeyboardText(char* pchText, uint32_t cchText) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_013)");
	return base->GetKeyboardText(pchText, cchText);
}
void CVROverlay_013::HideKeyboard() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_013)");
	return base->HideKeyboard();
}
void CVROverlay_013::SetKeyboardTransformAbsolute(vr::ETrackingUniverseOrigin eTrackingOrigin, const vr::HmdMatrix34_t* pmatTrackingOriginToKeyboardTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_013)");
	return base->SetKeyboardTransformAbsolute(eTrackingOrigin, pmatTrackingOriginToKeyboardTransform);
}
void CVROverlay_013::SetKeyboardPositionForOverlay(vr::VROverlayHandle_t ulOverlayHandle, vr::HmdRect2_t avoidRect) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_013)");
	return base->SetKeyboardPositionForOverlay(ulOverlayHandle, avoidRect);
}
vr::EVROverlayError CVROverlay_013::SetOverlayIntersectionMask(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_013::VROverlayIntersectionMaskPrimitive_t* pMaskPrimitives, uint32_t unNumMaskPrimitives, uint32_t unPrimitiveSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_013)");
	return base->SetOverlayIntersectionMask(ulOverlayHandle, (OOVR_VROverlayIntersectionMaskPrimitive_t*) pMaskPrimitives, unNumMaskPrimitives, unPrimitiveSize);
}
// FnTable for CVROverlay_013:
static CVROverlay_013 *fntable_Overlay_013_instance = NULL;
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_FindOverlay(const char* pchOverlayKey, vr::VROverlayHandle_t* pOverlayHandle) { return fntable_Overlay_013_instance->FindOverlay(pchOverlayKey, pOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_CreateOverlay(const char* pchOverlayKey, const char* pchOverlayFriendlyName, vr::VROverlayHandle_t* pOverlayHandle) { return fntable_Overlay_013_instance->CreateOverlay(pchOverlayKey, pchOverlayFriendlyName, pOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_DestroyOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_013_instance->DestroyOverlay(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_SetHighQualityOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_013_instance->SetHighQualityOverlay(ulOverlayHandle); }
static vr::VROverlayHandle_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_GetHighQualityOverlay() { return fntable_Overlay_013_instance->GetHighQualityOverlay(); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_GetOverlayKey(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::EVROverlayError* pError) { return fntable_Overlay_013_instance->GetOverlayKey(ulOverlayHandle, pchValue, unBufferSize, pError); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_GetOverlayName(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::EVROverlayError* pError) { return fntable_Overlay_013_instance->GetOverlayName(ulOverlayHandle, pchValue, unBufferSize, pError); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_GetOverlayImageData(vr::VROverlayHandle_t ulOverlayHandle, void* pvBuffer, uint32_t unBufferSize, uint32_t* punWidth, uint32_t* punHeight) { return fntable_Overlay_013_instance->GetOverlayImageData(ulOverlayHandle, pvBuffer, unBufferSize, punWidth, punHeight); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_GetOverlayErrorNameFromEnum(vr::EVROverlayError error) { return fntable_Overlay_013_instance->GetOverlayErrorNameFromEnum(error); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_SetOverlayRenderingPid(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unPID) { return fntable_Overlay_013_instance->SetOverlayRenderingPid(ulOverlayHandle, unPID); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_GetOverlayRenderingPid(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_013_instance->GetOverlayRenderingPid(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_SetOverlayFlag(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_013::VROverlayFlags eOverlayFlag, bool bEnabled) { return fntable_Overlay_013_instance->SetOverlayFlag(ulOverlayHandle, eOverlayFlag, bEnabled); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_GetOverlayFlag(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_013::VROverlayFlags eOverlayFlag, bool* pbEnabled) { return fntable_Overlay_013_instance->GetOverlayFlag(ulOverlayHandle, eOverlayFlag, pbEnabled); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_SetOverlayColor(vr::VROverlayHandle_t ulOverlayHandle, float fRed, float fGreen, float fBlue) { return fntable_Overlay_013_instance->SetOverlayColor(ulOverlayHandle, fRed, fGreen, fBlue); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_GetOverlayColor(vr::VROverlayHandle_t ulOverlayHandle, float* pfRed, float* pfGreen, float* pfBlue) { return fntable_Overlay_013_instance->GetOverlayColor(ulOverlayHandle, pfRed, pfGreen, pfBlue); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_SetOverlayAlpha(vr::VROverlayHandle_t ulOverlayHandle, float fAlpha) { return fntable_Overlay_013_instance->SetOverlayAlpha(ulOverlayHandle, fAlpha); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_GetOverlayAlpha(vr::VROverlayHandle_t ulOverlayHandle, float* pfAlpha) { return fntable_Overlay_013_instance->GetOverlayAlpha(ulOverlayHandle, pfAlpha); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_SetOverlayTexelAspect(vr::VROverlayHandle_t ulOverlayHandle, float fTexelAspect) { return fntable_Overlay_013_instance->SetOverlayTexelAspect(ulOverlayHandle, fTexelAspect); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_GetOverlayTexelAspect(vr::VROverlayHandle_t ulOverlayHandle, float* pfTexelAspect) { return fntable_Overlay_013_instance->GetOverlayTexelAspect(ulOverlayHandle, pfTexelAspect); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_SetOverlaySortOrder(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unSortOrder) { return fntable_Overlay_013_instance->SetOverlaySortOrder(ulOverlayHandle, unSortOrder); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_GetOverlaySortOrder(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* punSortOrder) { return fntable_Overlay_013_instance->GetOverlaySortOrder(ulOverlayHandle, punSortOrder); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_SetOverlayWidthInMeters(vr::VROverlayHandle_t ulOverlayHandle, float fWidthInMeters) { return fntable_Overlay_013_instance->SetOverlayWidthInMeters(ulOverlayHandle, fWidthInMeters); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_GetOverlayWidthInMeters(vr::VROverlayHandle_t ulOverlayHandle, float* pfWidthInMeters) { return fntable_Overlay_013_instance->GetOverlayWidthInMeters(ulOverlayHandle, pfWidthInMeters); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_SetOverlayAutoCurveDistanceRangeInMeters(vr::VROverlayHandle_t ulOverlayHandle, float fMinDistanceInMeters, float fMaxDistanceInMeters) { return fntable_Overlay_013_instance->SetOverlayAutoCurveDistanceRangeInMeters(ulOverlayHandle, fMinDistanceInMeters, fMaxDistanceInMeters); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_GetOverlayAutoCurveDistanceRangeInMeters(vr::VROverlayHandle_t ulOverlayHandle, float* pfMinDistanceInMeters, float* pfMaxDistanceInMeters) { return fntable_Overlay_013_instance->GetOverlayAutoCurveDistanceRangeInMeters(ulOverlayHandle, pfMinDistanceInMeters, pfMaxDistanceInMeters); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_SetOverlayTextureColorSpace(vr::VROverlayHandle_t ulOverlayHandle, vr::EColorSpace eTextureColorSpace) { return fntable_Overlay_013_instance->SetOverlayTextureColorSpace(ulOverlayHandle, eTextureColorSpace); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_GetOverlayTextureColorSpace(vr::VROverlayHandle_t ulOverlayHandle, vr::EColorSpace* peTextureColorSpace) { return fntable_Overlay_013_instance->GetOverlayTextureColorSpace(ulOverlayHandle, peTextureColorSpace); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_SetOverlayTextureBounds(vr::VROverlayHandle_t ulOverlayHandle, const vr::VRTextureBounds_t* pOverlayTextureBounds) { return fntable_Overlay_013_instance->SetOverlayTextureBounds(ulOverlayHandle, pOverlayTextureBounds); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_GetOverlayTextureBounds(vr::VROverlayHandle_t ulOverlayHandle, vr::VRTextureBounds_t* pOverlayTextureBounds) { return fntable_Overlay_013_instance->GetOverlayTextureBounds(ulOverlayHandle, pOverlayTextureBounds); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_GetOverlayTransformType(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_013::VROverlayTransformType* peTransformType) { return fntable_Overlay_013_instance->GetOverlayTransformType(ulOverlayHandle, peTransformType); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_SetOverlayTransformAbsolute(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin eTrackingOrigin, const vr::HmdMatrix34_t* pmatTrackingOriginToOverlayTransform) { return fntable_Overlay_013_instance->SetOverlayTransformAbsolute(ulOverlayHandle, eTrackingOrigin, pmatTrackingOriginToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_GetOverlayTransformAbsolute(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin* peTrackingOrigin, vr::HmdMatrix34_t* pmatTrackingOriginToOverlayTransform) { return fntable_Overlay_013_instance->GetOverlayTransformAbsolute(ulOverlayHandle, peTrackingOrigin, pmatTrackingOriginToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_SetOverlayTransformTrackedDeviceRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unTrackedDevice, const vr::HmdMatrix34_t* pmatTrackedDeviceToOverlayTransform) { return fntable_Overlay_013_instance->SetOverlayTransformTrackedDeviceRelative(ulOverlayHandle, unTrackedDevice, pmatTrackedDeviceToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_GetOverlayTransformTrackedDeviceRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t* punTrackedDevice, vr::HmdMatrix34_t* pmatTrackedDeviceToOverlayTransform) { return fntable_Overlay_013_instance->GetOverlayTransformTrackedDeviceRelative(ulOverlayHandle, punTrackedDevice, pmatTrackedDeviceToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_SetOverlayTransformTrackedDeviceComponent(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unDeviceIndex, const char* pchComponentName) { return fntable_Overlay_013_instance->SetOverlayTransformTrackedDeviceComponent(ulOverlayHandle, unDeviceIndex, pchComponentName); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_GetOverlayTransformTrackedDeviceComponent(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t* punDeviceIndex, char* pchComponentName, uint32_t unComponentNameSize) { return fntable_Overlay_013_instance->GetOverlayTransformTrackedDeviceComponent(ulOverlayHandle, punDeviceIndex, pchComponentName, unComponentNameSize); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_ShowOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_013_instance->ShowOverlay(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_HideOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_013_instance->HideOverlay(ulOverlayHandle); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_IsOverlayVisible(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_013_instance->IsOverlayVisible(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_GetTransformForOverlayCoordinates(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin eTrackingOrigin, vr::HmdVector2_t coordinatesInOverlay, vr::HmdMatrix34_t* pmatTransform) { return fntable_Overlay_013_instance->GetTransformForOverlayCoordinates(ulOverlayHandle, eTrackingOrigin, coordinatesInOverlay, pmatTransform); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_PollNextOverlayEvent(vr::VROverlayHandle_t ulOverlayHandle, vr::VREvent_t* pEvent, uint32_t uncbVREvent) { return fntable_Overlay_013_instance->PollNextOverlayEvent(ulOverlayHandle, pEvent, uncbVREvent); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_GetOverlayInputMethod(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_013::VROverlayInputMethod* peInputMethod) { return fntable_Overlay_013_instance->GetOverlayInputMethod(ulOverlayHandle, peInputMethod); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_SetOverlayInputMethod(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_013::VROverlayInputMethod eInputMethod) { return fntable_Overlay_013_instance->SetOverlayInputMethod(ulOverlayHandle, eInputMethod); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_GetOverlayMouseScale(vr::VROverlayHandle_t ulOverlayHandle, vr::HmdVector2_t* pvecMouseScale) { return fntable_Overlay_013_instance->GetOverlayMouseScale(ulOverlayHandle, pvecMouseScale); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_SetOverlayMouseScale(vr::VROverlayHandle_t ulOverlayHandle, const vr::HmdVector2_t* pvecMouseScale) { return fntable_Overlay_013_instance->SetOverlayMouseScale(ulOverlayHandle, pvecMouseScale); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_ComputeOverlayIntersection(vr::VROverlayHandle_t ulOverlayHandle, const vr::IVROverlay_013::VROverlayIntersectionParams_t* pParams, vr::IVROverlay_013::VROverlayIntersectionResults_t* pResults) { return fntable_Overlay_013_instance->ComputeOverlayIntersection(ulOverlayHandle, pParams, pResults); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_HandleControllerOverlayInteractionAsMouse(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unControllerDeviceIndex) { return fntable_Overlay_013_instance->HandleControllerOverlayInteractionAsMouse(ulOverlayHandle, unControllerDeviceIndex); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_IsHoverTargetOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_013_instance->IsHoverTargetOverlay(ulOverlayHandle); }
static vr::VROverlayHandle_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_GetGamepadFocusOverlay() { return fntable_Overlay_013_instance->GetGamepadFocusOverlay(); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_SetGamepadFocusOverlay(vr::VROverlayHandle_t ulNewFocusOverlay) { return fntable_Overlay_013_instance->SetGamepadFocusOverlay(ulNewFocusOverlay); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_SetOverlayNeighbor(vr::IVROverlay_013::EOverlayDirection eDirection, vr::VROverlayHandle_t ulFrom, vr::VROverlayHandle_t ulTo) { return fntable_Overlay_013_instance->SetOverlayNeighbor(eDirection, ulFrom, ulTo); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_MoveGamepadFocusToNeighbor(vr::IVROverlay_013::EOverlayDirection eDirection, vr::VROverlayHandle_t ulFrom) { return fntable_Overlay_013_instance->MoveGamepadFocusToNeighbor(eDirection, ulFrom); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_SetOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle, const vr::Texture_t* pTexture) { return fntable_Overlay_013_instance->SetOverlayTexture(ulOverlayHandle, pTexture); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_ClearOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_013_instance->ClearOverlayTexture(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_SetOverlayRaw(vr::VROverlayHandle_t ulOverlayHandle, void* pvBuffer, uint32_t unWidth, uint32_t unHeight, uint32_t unDepth) { return fntable_Overlay_013_instance->SetOverlayRaw(ulOverlayHandle, pvBuffer, unWidth, unHeight, unDepth); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_SetOverlayFromFile(vr::VROverlayHandle_t ulOverlayHandle, const char* pchFilePath) { return fntable_Overlay_013_instance->SetOverlayFromFile(ulOverlayHandle, pchFilePath); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_GetOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle, void** pNativeTextureHandle, void* pNativeTextureRef, uint32_t* pWidth, uint32_t* pHeight, uint32_t* pNativeFormat, EGraphicsAPIConvention* pAPI, vr::EColorSpace* pColorSpace) { return fntable_Overlay_013_instance->GetOverlayTexture(ulOverlayHandle, pNativeTextureHandle, pNativeTextureRef, pWidth, pHeight, pNativeFormat, pAPI, pColorSpace); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_ReleaseNativeOverlayHandle(vr::VROverlayHandle_t ulOverlayHandle, void* pNativeTextureHandle) { return fntable_Overlay_013_instance->ReleaseNativeOverlayHandle(ulOverlayHandle, pNativeTextureHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_GetOverlayTextureSize(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* pWidth, uint32_t* pHeight) { return fntable_Overlay_013_instance->GetOverlayTextureSize(ulOverlayHandle, pWidth, pHeight); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_CreateDashboardOverlay(const char* pchOverlayKey, const char* pchOverlayFriendlyName, vr::VROverlayHandle_t* pMainHandle, vr::VROverlayHandle_t* pThumbnailHandle) { return fntable_Overlay_013_instance->CreateDashboardOverlay(pchOverlayKey, pchOverlayFriendlyName, pMainHandle, pThumbnailHandle); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_IsDashboardVisible() { return fntable_Overlay_013_instance->IsDashboardVisible(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_IsActiveDashboardOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_013_instance->IsActiveDashboardOverlay(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_SetDashboardOverlaySceneProcess(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unProcessId) { return fntable_Overlay_013_instance->SetDashboardOverlaySceneProcess(ulOverlayHandle, unProcessId); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_GetDashboardOverlaySceneProcess(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* punProcessId) { return fntable_Overlay_013_instance->GetDashboardOverlaySceneProcess(ulOverlayHandle, punProcessId); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_ShowDashboard(const char* pchOverlayToShow) { return fntable_Overlay_013_instance->ShowDashboard(pchOverlayToShow); }
static vr::TrackedDeviceIndex_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_GetPrimaryDashboardDevice() { return fntable_Overlay_013_instance->GetPrimaryDashboardDevice(); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_ShowKeyboard(vr::IVROverlay_013::EGamepadTextInputMode eInputMode, vr::IVROverlay_013::EGamepadTextInputLineMode eLineInputMode, const char* pchDescription, uint32_t unCharMax, const char* pchExistingText, bool bUseMinimalMode, uint64_t uUserValue) { return fntable_Overlay_013_instance->ShowKeyboard(eInputMode, eLineInputMode, pchDescription, unCharMax, pchExistingText, bUseMinimalMode, uUserValue); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_ShowKeyboardForOverlay(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_013::EGamepadTextInputMode eInputMode, vr::IVROverlay_013::EGamepadTextInputLineMode eLineInputMode, const char* pchDescription, uint32_t unCharMax, const char* pchExistingText, bool bUseMinimalMode, uint64_t uUserValue) { return fntable_Overlay_013_instance->ShowKeyboardForOverlay(ulOverlayHandle, eInputMode, eLineInputMode, pchDescription, unCharMax, pchExistingText, bUseMinimalMode, uUserValue); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_GetKeyboardText(char* pchText, uint32_t cchText) { return fntable_Overlay_013_instance->GetKeyboardText(pchText, cchText); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_HideKeyboard() { return fntable_Overlay_013_instance->HideKeyboard(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_SetKeyboardTransformAbsolute(vr::ETrackingUniverseOrigin eTrackingOrigin, const vr::HmdMatrix34_t* pmatTrackingOriginToKeyboardTransform) { return fntable_Overlay_013_instance->SetKeyboardTransformAbsolute(eTrackingOrigin, pmatTrackingOriginToKeyboardTransform); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_SetKeyboardPositionForOverlay(vr::VROverlayHandle_t ulOverlayHandle, vr::HmdRect2_t avoidRect) { return fntable_Overlay_013_instance->SetKeyboardPositionForOverlay(ulOverlayHandle, avoidRect); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_013_impl_SetOverlayIntersectionMask(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_013::VROverlayIntersectionMaskPrimitive_t* pMaskPrimitives, uint32_t unNumMaskPrimitives, uint32_t unPrimitiveSize) { return fntable_Overlay_013_instance->SetOverlayIntersectionMask(ulOverlayHandle, pMaskPrimitives, unNumMaskPrimitives, unPrimitiveSize); }
static void *fntable_Overlay_013_funcs[] = {
	(void*) fntable_Overlay_013_impl_FindOverlay,
	(void*) fntable_Overlay_013_impl_CreateOverlay,
	(void*) fntable_Overlay_013_impl_DestroyOverlay,
	(void*) fntable_Overlay_013_impl_SetHighQualityOverlay,
	(void*) fntable_Overlay_013_impl_GetHighQualityOverlay,
	(void*) fntable_Overlay_013_impl_GetOverlayKey,
	(void*) fntable_Overlay_013_impl_GetOverlayName,
	(void*) fntable_Overlay_013_impl_GetOverlayImageData,
	(void*) fntable_Overlay_013_impl_GetOverlayErrorNameFromEnum,
	(void*) fntable_Overlay_013_impl_SetOverlayRenderingPid,
	(void*) fntable_Overlay_013_impl_GetOverlayRenderingPid,
	(void*) fntable_Overlay_013_impl_SetOverlayFlag,
	(void*) fntable_Overlay_013_impl_GetOverlayFlag,
	(void*) fntable_Overlay_013_impl_SetOverlayColor,
	(void*) fntable_Overlay_013_impl_GetOverlayColor,
	(void*) fntable_Overlay_013_impl_SetOverlayAlpha,
	(void*) fntable_Overlay_013_impl_GetOverlayAlpha,
	(void*) fntable_Overlay_013_impl_SetOverlayTexelAspect,
	(void*) fntable_Overlay_013_impl_GetOverlayTexelAspect,
	(void*) fntable_Overlay_013_impl_SetOverlaySortOrder,
	(void*) fntable_Overlay_013_impl_GetOverlaySortOrder,
	(void*) fntable_Overlay_013_impl_SetOverlayWidthInMeters,
	(void*) fntable_Overlay_013_impl_GetOverlayWidthInMeters,
	(void*) fntable_Overlay_013_impl_SetOverlayAutoCurveDistanceRangeInMeters,
	(void*) fntable_Overlay_013_impl_GetOverlayAutoCurveDistanceRangeInMeters,
	(void*) fntable_Overlay_013_impl_SetOverlayTextureColorSpace,
	(void*) fntable_Overlay_013_impl_GetOverlayTextureColorSpace,
	(void*) fntable_Overlay_013_impl_SetOverlayTextureBounds,
	(void*) fntable_Overlay_013_impl_GetOverlayTextureBounds,
	(void*) fntable_Overlay_013_impl_GetOverlayTransformType,
	(void*) fntable_Overlay_013_impl_SetOverlayTransformAbsolute,
	(void*) fntable_Overlay_013_impl_GetOverlayTransformAbsolute,
	(void*) fntable_Overlay_013_impl_SetOverlayTransformTrackedDeviceRelative,
	(void*) fntable_Overlay_013_impl_GetOverlayTransformTrackedDeviceRelative,
	(void*) fntable_Overlay_013_impl_SetOverlayTransformTrackedDeviceComponent,
	(void*) fntable_Overlay_013_impl_GetOverlayTransformTrackedDeviceComponent,
	(void*) fntable_Overlay_013_impl_ShowOverlay,
	(void*) fntable_Overlay_013_impl_HideOverlay,
	(void*) fntable_Overlay_013_impl_IsOverlayVisible,
	(void*) fntable_Overlay_013_impl_GetTransformForOverlayCoordinates,
	(void*) fntable_Overlay_013_impl_PollNextOverlayEvent,
	(void*) fntable_Overlay_013_impl_GetOverlayInputMethod,
	(void*) fntable_Overlay_013_impl_SetOverlayInputMethod,
	(void*) fntable_Overlay_013_impl_GetOverlayMouseScale,
	(void*) fntable_Overlay_013_impl_SetOverlayMouseScale,
	(void*) fntable_Overlay_013_impl_ComputeOverlayIntersection,
	(void*) fntable_Overlay_013_impl_HandleControllerOverlayInteractionAsMouse,
	(void*) fntable_Overlay_013_impl_IsHoverTargetOverlay,
	(void*) fntable_Overlay_013_impl_GetGamepadFocusOverlay,
	(void*) fntable_Overlay_013_impl_SetGamepadFocusOverlay,
	(void*) fntable_Overlay_013_impl_SetOverlayNeighbor,
	(void*) fntable_Overlay_013_impl_MoveGamepadFocusToNeighbor,
	(void*) fntable_Overlay_013_impl_SetOverlayTexture,
	(void*) fntable_Overlay_013_impl_ClearOverlayTexture,
	(void*) fntable_Overlay_013_impl_SetOverlayRaw,
	(void*) fntable_Overlay_013_impl_SetOverlayFromFile,
	(void*) fntable_Overlay_013_impl_GetOverlayTexture,
	(void*) fntable_Overlay_013_impl_ReleaseNativeOverlayHandle,
	(void*) fntable_Overlay_013_impl_GetOverlayTextureSize,
	(void*) fntable_Overlay_013_impl_CreateDashboardOverlay,
	(void*) fntable_Overlay_013_impl_IsDashboardVisible,
	(void*) fntable_Overlay_013_impl_IsActiveDashboardOverlay,
	(void*) fntable_Overlay_013_impl_SetDashboardOverlaySceneProcess,
	(void*) fntable_Overlay_013_impl_GetDashboardOverlaySceneProcess,
	(void*) fntable_Overlay_013_impl_ShowDashboard,
	(void*) fntable_Overlay_013_impl_GetPrimaryDashboardDevice,
	(void*) fntable_Overlay_013_impl_ShowKeyboard,
	(void*) fntable_Overlay_013_impl_ShowKeyboardForOverlay,
	(void*) fntable_Overlay_013_impl_GetKeyboardText,
	(void*) fntable_Overlay_013_impl_HideKeyboard,
	(void*) fntable_Overlay_013_impl_SetKeyboardTransformAbsolute,
	(void*) fntable_Overlay_013_impl_SetKeyboardPositionForOverlay,
	(void*) fntable_Overlay_013_impl_SetOverlayIntersectionMask,
};
void** CVROverlay_013::_GetStatFuncList() { fntable_Overlay_013_instance = this; return fntable_Overlay_013_funcs; }
void CVROverlay_013::Delete() { delete this; }
// Misc for CVROverlay_014:
CVROverlay_014::CVROverlay_014() : base(GetCreateBaseOverlay()) {}
// Interface methods for CVROverlay_014:
vr::EVROverlayError CVROverlay_014::FindOverlay(const char* pchOverlayKey, vr::VROverlayHandle_t* pOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->FindOverlay(pchOverlayKey, pOverlayHandle);
}
vr::EVROverlayError CVROverlay_014::CreateOverlay(const char* pchOverlayKey, const char* pchOverlayFriendlyName, vr::VROverlayHandle_t* pOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->CreateOverlay(pchOverlayKey, pchOverlayFriendlyName, pOverlayHandle);
}
vr::EVROverlayError CVROverlay_014::DestroyOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->DestroyOverlay(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_014::SetHighQualityOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->SetHighQualityOverlay(ulOverlayHandle);
}
vr::VROverlayHandle_t CVROverlay_014::GetHighQualityOverlay() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->GetHighQualityOverlay();
}
uint32_t CVROverlay_014::GetOverlayKey(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::EVROverlayError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->GetOverlayKey(ulOverlayHandle, pchValue, unBufferSize, pError);
}
uint32_t CVROverlay_014::GetOverlayName(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::EVROverlayError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->GetOverlayName(ulOverlayHandle, pchValue, unBufferSize, pError);
}
vr::EVROverlayError CVROverlay_014::GetOverlayImageData(vr::VROverlayHandle_t ulOverlayHandle, void* pvBuffer, uint32_t unBufferSize, uint32_t* punWidth, uint32_t* punHeight) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->GetOverlayImageData(ulOverlayHandle, pvBuffer, unBufferSize, punWidth, punHeight);
}
const char* CVROverlay_014::GetOverlayErrorNameFromEnum(vr::EVROverlayError error) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->GetOverlayErrorNameFromEnum(error);
}
vr::EVROverlayError CVROverlay_014::SetOverlayRenderingPid(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unPID) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->SetOverlayRenderingPid(ulOverlayHandle, unPID);
}
uint32_t CVROverlay_014::GetOverlayRenderingPid(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->GetOverlayRenderingPid(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_014::SetOverlayFlag(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_014::VROverlayFlags eOverlayFlag, bool bEnabled) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->SetOverlayFlag(ulOverlayHandle, (OOVR_VROverlayFlags) eOverlayFlag, bEnabled);
}
vr::EVROverlayError CVROverlay_014::GetOverlayFlag(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_014::VROverlayFlags eOverlayFlag, bool* pbEnabled) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->GetOverlayFlag(ulOverlayHandle, (OOVR_VROverlayFlags) eOverlayFlag, pbEnabled);
}
vr::EVROverlayError CVROverlay_014::SetOverlayColor(vr::VROverlayHandle_t ulOverlayHandle, float fRed, float fGreen, float fBlue) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->SetOverlayColor(ulOverlayHandle, fRed, fGreen, fBlue);
}
vr::EVROverlayError CVROverlay_014::GetOverlayColor(vr::VROverlayHandle_t ulOverlayHandle, float* pfRed, float* pfGreen, float* pfBlue) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->GetOverlayColor(ulOverlayHandle, pfRed, pfGreen, pfBlue);
}
vr::EVROverlayError CVROverlay_014::SetOverlayAlpha(vr::VROverlayHandle_t ulOverlayHandle, float fAlpha) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->SetOverlayAlpha(ulOverlayHandle, fAlpha);
}
vr::EVROverlayError CVROverlay_014::GetOverlayAlpha(vr::VROverlayHandle_t ulOverlayHandle, float* pfAlpha) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->GetOverlayAlpha(ulOverlayHandle, pfAlpha);
}
vr::EVROverlayError CVROverlay_014::SetOverlayTexelAspect(vr::VROverlayHandle_t ulOverlayHandle, float fTexelAspect) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->SetOverlayTexelAspect(ulOverlayHandle, fTexelAspect);
}
vr::EVROverlayError CVROverlay_014::GetOverlayTexelAspect(vr::VROverlayHandle_t ulOverlayHandle, float* pfTexelAspect) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->GetOverlayTexelAspect(ulOverlayHandle, pfTexelAspect);
}
vr::EVROverlayError CVROverlay_014::SetOverlaySortOrder(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unSortOrder) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->SetOverlaySortOrder(ulOverlayHandle, unSortOrder);
}
vr::EVROverlayError CVROverlay_014::GetOverlaySortOrder(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* punSortOrder) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->GetOverlaySortOrder(ulOverlayHandle, punSortOrder);
}
vr::EVROverlayError CVROverlay_014::SetOverlayWidthInMeters(vr::VROverlayHandle_t ulOverlayHandle, float fWidthInMeters) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->SetOverlayWidthInMeters(ulOverlayHandle, fWidthInMeters);
}
vr::EVROverlayError CVROverlay_014::GetOverlayWidthInMeters(vr::VROverlayHandle_t ulOverlayHandle, float* pfWidthInMeters) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->GetOverlayWidthInMeters(ulOverlayHandle, pfWidthInMeters);
}
vr::EVROverlayError CVROverlay_014::SetOverlayAutoCurveDistanceRangeInMeters(vr::VROverlayHandle_t ulOverlayHandle, float fMinDistanceInMeters, float fMaxDistanceInMeters) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->SetOverlayAutoCurveDistanceRangeInMeters(ulOverlayHandle, fMinDistanceInMeters, fMaxDistanceInMeters);
}
vr::EVROverlayError CVROverlay_014::GetOverlayAutoCurveDistanceRangeInMeters(vr::VROverlayHandle_t ulOverlayHandle, float* pfMinDistanceInMeters, float* pfMaxDistanceInMeters) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->GetOverlayAutoCurveDistanceRangeInMeters(ulOverlayHandle, pfMinDistanceInMeters, pfMaxDistanceInMeters);
}
vr::EVROverlayError CVROverlay_014::SetOverlayTextureColorSpace(vr::VROverlayHandle_t ulOverlayHandle, vr::EColorSpace eTextureColorSpace) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->SetOverlayTextureColorSpace(ulOverlayHandle, eTextureColorSpace);
}
vr::EVROverlayError CVROverlay_014::GetOverlayTextureColorSpace(vr::VROverlayHandle_t ulOverlayHandle, vr::EColorSpace* peTextureColorSpace) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->GetOverlayTextureColorSpace(ulOverlayHandle, peTextureColorSpace);
}
vr::EVROverlayError CVROverlay_014::SetOverlayTextureBounds(vr::VROverlayHandle_t ulOverlayHandle, const vr::VRTextureBounds_t* pOverlayTextureBounds) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->SetOverlayTextureBounds(ulOverlayHandle, pOverlayTextureBounds);
}
vr::EVROverlayError CVROverlay_014::GetOverlayTextureBounds(vr::VROverlayHandle_t ulOverlayHandle, vr::VRTextureBounds_t* pOverlayTextureBounds) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->GetOverlayTextureBounds(ulOverlayHandle, pOverlayTextureBounds);
}
vr::EVROverlayError CVROverlay_014::GetOverlayTransformType(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_014::VROverlayTransformType* peTransformType) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->GetOverlayTransformType(ulOverlayHandle, (OOVR_VROverlayTransformType*) peTransformType);
}
vr::EVROverlayError CVROverlay_014::SetOverlayTransformAbsolute(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin eTrackingOrigin, const vr::HmdMatrix34_t* pmatTrackingOriginToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->SetOverlayTransformAbsolute(ulOverlayHandle, eTrackingOrigin, pmatTrackingOriginToOverlayTransform);
}
vr::EVROverlayError CVROverlay_014::GetOverlayTransformAbsolute(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin* peTrackingOrigin, vr::HmdMatrix34_t* pmatTrackingOriginToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->GetOverlayTransformAbsolute(ulOverlayHandle, peTrackingOrigin, pmatTrackingOriginToOverlayTransform);
}
vr::EVROverlayError CVROverlay_014::SetOverlayTransformTrackedDeviceRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unTrackedDevice, const vr::HmdMatrix34_t* pmatTrackedDeviceToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->SetOverlayTransformTrackedDeviceRelative(ulOverlayHandle, unTrackedDevice, pmatTrackedDeviceToOverlayTransform);
}
vr::EVROverlayError CVROverlay_014::GetOverlayTransformTrackedDeviceRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t* punTrackedDevice, vr::HmdMatrix34_t* pmatTrackedDeviceToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->GetOverlayTransformTrackedDeviceRelative(ulOverlayHandle, punTrackedDevice, pmatTrackedDeviceToOverlayTransform);
}
vr::EVROverlayError CVROverlay_014::SetOverlayTransformTrackedDeviceComponent(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unDeviceIndex, const char* pchComponentName) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->SetOverlayTransformTrackedDeviceComponent(ulOverlayHandle, unDeviceIndex, pchComponentName);
}
vr::EVROverlayError CVROverlay_014::GetOverlayTransformTrackedDeviceComponent(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t* punDeviceIndex, char* pchComponentName, uint32_t unComponentNameSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->GetOverlayTransformTrackedDeviceComponent(ulOverlayHandle, punDeviceIndex, pchComponentName, unComponentNameSize);
}
vr::EVROverlayError CVROverlay_014::ShowOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->ShowOverlay(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_014::HideOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->HideOverlay(ulOverlayHandle);
}
bool CVROverlay_014::IsOverlayVisible(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->IsOverlayVisible(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_014::GetTransformForOverlayCoordinates(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin eTrackingOrigin, vr::HmdVector2_t coordinatesInOverlay, vr::HmdMatrix34_t* pmatTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->GetTransformForOverlayCoordinates(ulOverlayHandle, eTrackingOrigin, coordinatesInOverlay, pmatTransform);
}
bool CVROverlay_014::PollNextOverlayEvent(vr::VROverlayHandle_t ulOverlayHandle, vr::VREvent_t* pEvent, uint32_t uncbVREvent) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->PollNextOverlayEvent(ulOverlayHandle, pEvent, uncbVREvent);
}
vr::EVROverlayError CVROverlay_014::GetOverlayInputMethod(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_014::VROverlayInputMethod* peInputMethod) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->GetOverlayInputMethod(ulOverlayHandle, (OOVR_VROverlayInputMethod*) peInputMethod);
}
vr::EVROverlayError CVROverlay_014::SetOverlayInputMethod(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_014::VROverlayInputMethod eInputMethod) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->SetOverlayInputMethod(ulOverlayHandle, (OOVR_VROverlayInputMethod) eInputMethod);
}
vr::EVROverlayError CVROverlay_014::GetOverlayMouseScale(vr::VROverlayHandle_t ulOverlayHandle, vr::HmdVector2_t* pvecMouseScale) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->GetOverlayMouseScale(ulOverlayHandle, pvecMouseScale);
}
vr::EVROverlayError CVROverlay_014::SetOverlayMouseScale(vr::VROverlayHandle_t ulOverlayHandle, const vr::HmdVector2_t* pvecMouseScale) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->SetOverlayMouseScale(ulOverlayHandle, pvecMouseScale);
}
bool CVROverlay_014::ComputeOverlayIntersection(vr::VROverlayHandle_t ulOverlayHandle, const vr::IVROverlay_014::VROverlayIntersectionParams_t* pParams, vr::IVROverlay_014::VROverlayIntersectionResults_t* pResults) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->ComputeOverlayIntersection(ulOverlayHandle, (const OOVR_VROverlayIntersectionParams_t*) pParams, (OOVR_VROverlayIntersectionResults_t*) pResults);
}
bool CVROverlay_014::HandleControllerOverlayInteractionAsMouse(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unControllerDeviceIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->HandleControllerOverlayInteractionAsMouse(ulOverlayHandle, unControllerDeviceIndex);
}
bool CVROverlay_014::IsHoverTargetOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->IsHoverTargetOverlay(ulOverlayHandle);
}
vr::VROverlayHandle_t CVROverlay_014::GetGamepadFocusOverlay() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->GetGamepadFocusOverlay();
}
vr::EVROverlayError CVROverlay_014::SetGamepadFocusOverlay(vr::VROverlayHandle_t ulNewFocusOverlay) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->SetGamepadFocusOverlay(ulNewFocusOverlay);
}
vr::EVROverlayError CVROverlay_014::SetOverlayNeighbor(vr::IVROverlay_014::EOverlayDirection eDirection, vr::VROverlayHandle_t ulFrom, vr::VROverlayHandle_t ulTo) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->SetOverlayNeighbor((OOVR_EOverlayDirection) eDirection, ulFrom, ulTo);
}
vr::EVROverlayError CVROverlay_014::MoveGamepadFocusToNeighbor(vr::IVROverlay_014::EOverlayDirection eDirection, vr::VROverlayHandle_t ulFrom) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->MoveGamepadFocusToNeighbor((OOVR_EOverlayDirection) eDirection, ulFrom);
}
vr::EVROverlayError CVROverlay_014::SetOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle, const vr::Texture_t* pTexture) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->SetOverlayTexture(ulOverlayHandle, pTexture);
}
vr::EVROverlayError CVROverlay_014::ClearOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->ClearOverlayTexture(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_014::SetOverlayRaw(vr::VROverlayHandle_t ulOverlayHandle, void* pvBuffer, uint32_t unWidth, uint32_t unHeight, uint32_t unDepth) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->SetOverlayRaw(ulOverlayHandle, pvBuffer, unWidth, unHeight, unDepth);
}
vr::EVROverlayError CVROverlay_014::SetOverlayFromFile(vr::VROverlayHandle_t ulOverlayHandle, const char* pchFilePath) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->SetOverlayFromFile(ulOverlayHandle, pchFilePath);
}
vr::EVROverlayError CVROverlay_014::GetOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle, void** pNativeTextureHandle, void* pNativeTextureRef, uint32_t* pWidth, uint32_t* pHeight, uint32_t* pNativeFormat, vr::ETextureType* pAPIType, vr::EColorSpace* pColorSpace, vr::VRTextureBounds_t* pTextureBounds) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->GetOverlayTexture(ulOverlayHandle, pNativeTextureHandle, pNativeTextureRef, pWidth, pHeight, pNativeFormat, pAPIType, pColorSpace, pTextureBounds);
}
vr::EVROverlayError CVROverlay_014::ReleaseNativeOverlayHandle(vr::VROverlayHandle_t ulOverlayHandle, void* pNativeTextureHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->ReleaseNativeOverlayHandle(ulOverlayHandle, pNativeTextureHandle);
}
vr::EVROverlayError CVROverlay_014::GetOverlayTextureSize(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* pWidth, uint32_t* pHeight) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->GetOverlayTextureSize(ulOverlayHandle, pWidth, pHeight);
}
vr::EVROverlayError CVROverlay_014::CreateDashboardOverlay(const char* pchOverlayKey, const char* pchOverlayFriendlyName, vr::VROverlayHandle_t* pMainHandle, vr::VROverlayHandle_t* pThumbnailHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->CreateDashboardOverlay(pchOverlayKey, pchOverlayFriendlyName, pMainHandle, pThumbnailHandle);
}
bool CVROverlay_014::IsDashboardVisible() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->IsDashboardVisible();
}
bool CVROverlay_014::IsActiveDashboardOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->IsActiveDashboardOverlay(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_014::SetDashboardOverlaySceneProcess(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unProcessId) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->SetDashboardOverlaySceneProcess(ulOverlayHandle, unProcessId);
}
vr::EVROverlayError CVROverlay_014::GetDashboardOverlaySceneProcess(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* punProcessId) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->GetDashboardOverlaySceneProcess(ulOverlayHandle, punProcessId);
}
void CVROverlay_014::ShowDashboard(const char* pchOverlayToShow) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->ShowDashboard(pchOverlayToShow);
}
vr::TrackedDeviceIndex_t CVROverlay_014::GetPrimaryDashboardDevice() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->GetPrimaryDashboardDevice();
}
vr::EVROverlayError CVROverlay_014::ShowKeyboard(vr::IVROverlay_014::EGamepadTextInputMode eInputMode, vr::IVROverlay_014::EGamepadTextInputLineMode eLineInputMode, const char* pchDescription, uint32_t unCharMax, const char* pchExistingText, bool bUseMinimalMode, uint64_t uUserValue) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->ShowKeyboard((OOVR_EGamepadTextInputMode) eInputMode, (OOVR_EGamepadTextInputLineMode) eLineInputMode, pchDescription, unCharMax, pchExistingText, bUseMinimalMode, uUserValue);
}
vr::EVROverlayError CVROverlay_014::ShowKeyboardForOverlay(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_014::EGamepadTextInputMode eInputMode, vr::IVROverlay_014::EGamepadTextInputLineMode eLineInputMode, const char* pchDescription, uint32_t unCharMax, const char* pchExistingText, bool bUseMinimalMode, uint64_t uUserValue) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->ShowKeyboardForOverlay(ulOverlayHandle, (OOVR_EGamepadTextInputMode) eInputMode, (OOVR_EGamepadTextInputLineMode) eLineInputMode, pchDescription, unCharMax, pchExistingText, bUseMinimalMode, uUserValue);
}
uint32_t CVROverlay_014::GetKeyboardText(char* pchText, uint32_t cchText) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->GetKeyboardText(pchText, cchText);
}
void CVROverlay_014::HideKeyboard() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->HideKeyboard();
}
void CVROverlay_014::SetKeyboardTransformAbsolute(vr::ETrackingUniverseOrigin eTrackingOrigin, const vr::HmdMatrix34_t* pmatTrackingOriginToKeyboardTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->SetKeyboardTransformAbsolute(eTrackingOrigin, pmatTrackingOriginToKeyboardTransform);
}
void CVROverlay_014::SetKeyboardPositionForOverlay(vr::VROverlayHandle_t ulOverlayHandle, vr::HmdRect2_t avoidRect) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->SetKeyboardPositionForOverlay(ulOverlayHandle, avoidRect);
}
vr::EVROverlayError CVROverlay_014::SetOverlayIntersectionMask(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_014::VROverlayIntersectionMaskPrimitive_t* pMaskPrimitives, uint32_t unNumMaskPrimitives, uint32_t unPrimitiveSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->SetOverlayIntersectionMask(ulOverlayHandle, (OOVR_VROverlayIntersectionMaskPrimitive_t*) pMaskPrimitives, unNumMaskPrimitives, unPrimitiveSize);
}
vr::EVROverlayError CVROverlay_014::GetOverlayFlags(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* pFlags) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return base->GetOverlayFlags(ulOverlayHandle, pFlags);
}
vr::IVROverlay_014::VRMessageOverlayResponse CVROverlay_014::ShowMessageOverlay(const char* pchText, const char* pchCaption, const char* pchButton0Text, const char* pchButton1Text, const char* pchButton2Text, const char* pchButton3Text) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_014)");
	return (vr::IVROverlay_014::VRMessageOverlayResponse) base->ShowMessageOverlay(pchText, pchCaption, pchButton0Text, pchButton1Text, pchButton2Text, pchButton3Text);
}
// FnTable for CVROverlay_014:
static CVROverlay_014 *fntable_Overlay_014_instance = NULL;
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_FindOverlay(const char* pchOverlayKey, vr::VROverlayHandle_t* pOverlayHandle) { return fntable_Overlay_014_instance->FindOverlay(pchOverlayKey, pOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_CreateOverlay(const char* pchOverlayKey, const char* pchOverlayFriendlyName, vr::VROverlayHandle_t* pOverlayHandle) { return fntable_Overlay_014_instance->CreateOverlay(pchOverlayKey, pchOverlayFriendlyName, pOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_DestroyOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_014_instance->DestroyOverlay(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_SetHighQualityOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_014_instance->SetHighQualityOverlay(ulOverlayHandle); }
static vr::VROverlayHandle_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_GetHighQualityOverlay() { return fntable_Overlay_014_instance->GetHighQualityOverlay(); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_GetOverlayKey(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::EVROverlayError* pError) { return fntable_Overlay_014_instance->GetOverlayKey(ulOverlayHandle, pchValue, unBufferSize, pError); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_GetOverlayName(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::EVROverlayError* pError) { return fntable_Overlay_014_instance->GetOverlayName(ulOverlayHandle, pchValue, unBufferSize, pError); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_GetOverlayImageData(vr::VROverlayHandle_t ulOverlayHandle, void* pvBuffer, uint32_t unBufferSize, uint32_t* punWidth, uint32_t* punHeight) { return fntable_Overlay_014_instance->GetOverlayImageData(ulOverlayHandle, pvBuffer, unBufferSize, punWidth, punHeight); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_GetOverlayErrorNameFromEnum(vr::EVROverlayError error) { return fntable_Overlay_014_instance->GetOverlayErrorNameFromEnum(error); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_SetOverlayRenderingPid(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unPID) { return fntable_Overlay_014_instance->SetOverlayRenderingPid(ulOverlayHandle, unPID); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_GetOverlayRenderingPid(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_014_instance->GetOverlayRenderingPid(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_SetOverlayFlag(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_014::VROverlayFlags eOverlayFlag, bool bEnabled) { return fntable_Overlay_014_instance->SetOverlayFlag(ulOverlayHandle, eOverlayFlag, bEnabled); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_GetOverlayFlag(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_014::VROverlayFlags eOverlayFlag, bool* pbEnabled) { return fntable_Overlay_014_instance->GetOverlayFlag(ulOverlayHandle, eOverlayFlag, pbEnabled); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_SetOverlayColor(vr::VROverlayHandle_t ulOverlayHandle, float fRed, float fGreen, float fBlue) { return fntable_Overlay_014_instance->SetOverlayColor(ulOverlayHandle, fRed, fGreen, fBlue); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_GetOverlayColor(vr::VROverlayHandle_t ulOverlayHandle, float* pfRed, float* pfGreen, float* pfBlue) { return fntable_Overlay_014_instance->GetOverlayColor(ulOverlayHandle, pfRed, pfGreen, pfBlue); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_SetOverlayAlpha(vr::VROverlayHandle_t ulOverlayHandle, float fAlpha) { return fntable_Overlay_014_instance->SetOverlayAlpha(ulOverlayHandle, fAlpha); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_GetOverlayAlpha(vr::VROverlayHandle_t ulOverlayHandle, float* pfAlpha) { return fntable_Overlay_014_instance->GetOverlayAlpha(ulOverlayHandle, pfAlpha); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_SetOverlayTexelAspect(vr::VROverlayHandle_t ulOverlayHandle, float fTexelAspect) { return fntable_Overlay_014_instance->SetOverlayTexelAspect(ulOverlayHandle, fTexelAspect); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_GetOverlayTexelAspect(vr::VROverlayHandle_t ulOverlayHandle, float* pfTexelAspect) { return fntable_Overlay_014_instance->GetOverlayTexelAspect(ulOverlayHandle, pfTexelAspect); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_SetOverlaySortOrder(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unSortOrder) { return fntable_Overlay_014_instance->SetOverlaySortOrder(ulOverlayHandle, unSortOrder); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_GetOverlaySortOrder(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* punSortOrder) { return fntable_Overlay_014_instance->GetOverlaySortOrder(ulOverlayHandle, punSortOrder); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_SetOverlayWidthInMeters(vr::VROverlayHandle_t ulOverlayHandle, float fWidthInMeters) { return fntable_Overlay_014_instance->SetOverlayWidthInMeters(ulOverlayHandle, fWidthInMeters); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_GetOverlayWidthInMeters(vr::VROverlayHandle_t ulOverlayHandle, float* pfWidthInMeters) { return fntable_Overlay_014_instance->GetOverlayWidthInMeters(ulOverlayHandle, pfWidthInMeters); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_SetOverlayAutoCurveDistanceRangeInMeters(vr::VROverlayHandle_t ulOverlayHandle, float fMinDistanceInMeters, float fMaxDistanceInMeters) { return fntable_Overlay_014_instance->SetOverlayAutoCurveDistanceRangeInMeters(ulOverlayHandle, fMinDistanceInMeters, fMaxDistanceInMeters); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_GetOverlayAutoCurveDistanceRangeInMeters(vr::VROverlayHandle_t ulOverlayHandle, float* pfMinDistanceInMeters, float* pfMaxDistanceInMeters) { return fntable_Overlay_014_instance->GetOverlayAutoCurveDistanceRangeInMeters(ulOverlayHandle, pfMinDistanceInMeters, pfMaxDistanceInMeters); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_SetOverlayTextureColorSpace(vr::VROverlayHandle_t ulOverlayHandle, vr::EColorSpace eTextureColorSpace) { return fntable_Overlay_014_instance->SetOverlayTextureColorSpace(ulOverlayHandle, eTextureColorSpace); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_GetOverlayTextureColorSpace(vr::VROverlayHandle_t ulOverlayHandle, vr::EColorSpace* peTextureColorSpace) { return fntable_Overlay_014_instance->GetOverlayTextureColorSpace(ulOverlayHandle, peTextureColorSpace); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_SetOverlayTextureBounds(vr::VROverlayHandle_t ulOverlayHandle, const vr::VRTextureBounds_t* pOverlayTextureBounds) { return fntable_Overlay_014_instance->SetOverlayTextureBounds(ulOverlayHandle, pOverlayTextureBounds); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_GetOverlayTextureBounds(vr::VROverlayHandle_t ulOverlayHandle, vr::VRTextureBounds_t* pOverlayTextureBounds) { return fntable_Overlay_014_instance->GetOverlayTextureBounds(ulOverlayHandle, pOverlayTextureBounds); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_GetOverlayTransformType(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_014::VROverlayTransformType* peTransformType) { return fntable_Overlay_014_instance->GetOverlayTransformType(ulOverlayHandle, peTransformType); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_SetOverlayTransformAbsolute(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin eTrackingOrigin, const vr::HmdMatrix34_t* pmatTrackingOriginToOverlayTransform) { return fntable_Overlay_014_instance->SetOverlayTransformAbsolute(ulOverlayHandle, eTrackingOrigin, pmatTrackingOriginToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_GetOverlayTransformAbsolute(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin* peTrackingOrigin, vr::HmdMatrix34_t* pmatTrackingOriginToOverlayTransform) { return fntable_Overlay_014_instance->GetOverlayTransformAbsolute(ulOverlayHandle, peTrackingOrigin, pmatTrackingOriginToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_SetOverlayTransformTrackedDeviceRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unTrackedDevice, const vr::HmdMatrix34_t* pmatTrackedDeviceToOverlayTransform) { return fntable_Overlay_014_instance->SetOverlayTransformTrackedDeviceRelative(ulOverlayHandle, unTrackedDevice, pmatTrackedDeviceToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_GetOverlayTransformTrackedDeviceRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t* punTrackedDevice, vr::HmdMatrix34_t* pmatTrackedDeviceToOverlayTransform) { return fntable_Overlay_014_instance->GetOverlayTransformTrackedDeviceRelative(ulOverlayHandle, punTrackedDevice, pmatTrackedDeviceToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_SetOverlayTransformTrackedDeviceComponent(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unDeviceIndex, const char* pchComponentName) { return fntable_Overlay_014_instance->SetOverlayTransformTrackedDeviceComponent(ulOverlayHandle, unDeviceIndex, pchComponentName); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_GetOverlayTransformTrackedDeviceComponent(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t* punDeviceIndex, char* pchComponentName, uint32_t unComponentNameSize) { return fntable_Overlay_014_instance->GetOverlayTransformTrackedDeviceComponent(ulOverlayHandle, punDeviceIndex, pchComponentName, unComponentNameSize); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_ShowOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_014_instance->ShowOverlay(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_HideOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_014_instance->HideOverlay(ulOverlayHandle); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_IsOverlayVisible(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_014_instance->IsOverlayVisible(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_GetTransformForOverlayCoordinates(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin eTrackingOrigin, vr::HmdVector2_t coordinatesInOverlay, vr::HmdMatrix34_t* pmatTransform) { return fntable_Overlay_014_instance->GetTransformForOverlayCoordinates(ulOverlayHandle, eTrackingOrigin, coordinatesInOverlay, pmatTransform); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_PollNextOverlayEvent(vr::VROverlayHandle_t ulOverlayHandle, vr::VREvent_t* pEvent, uint32_t uncbVREvent) { return fntable_Overlay_014_instance->PollNextOverlayEvent(ulOverlayHandle, pEvent, uncbVREvent); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_GetOverlayInputMethod(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_014::VROverlayInputMethod* peInputMethod) { return fntable_Overlay_014_instance->GetOverlayInputMethod(ulOverlayHandle, peInputMethod); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_SetOverlayInputMethod(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_014::VROverlayInputMethod eInputMethod) { return fntable_Overlay_014_instance->SetOverlayInputMethod(ulOverlayHandle, eInputMethod); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_GetOverlayMouseScale(vr::VROverlayHandle_t ulOverlayHandle, vr::HmdVector2_t* pvecMouseScale) { return fntable_Overlay_014_instance->GetOverlayMouseScale(ulOverlayHandle, pvecMouseScale); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_SetOverlayMouseScale(vr::VROverlayHandle_t ulOverlayHandle, const vr::HmdVector2_t* pvecMouseScale) { return fntable_Overlay_014_instance->SetOverlayMouseScale(ulOverlayHandle, pvecMouseScale); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_ComputeOverlayIntersection(vr::VROverlayHandle_t ulOverlayHandle, const vr::IVROverlay_014::VROverlayIntersectionParams_t* pParams, vr::IVROverlay_014::VROverlayIntersectionResults_t* pResults) { return fntable_Overlay_014_instance->ComputeOverlayIntersection(ulOverlayHandle, pParams, pResults); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_HandleControllerOverlayInteractionAsMouse(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unControllerDeviceIndex) { return fntable_Overlay_014_instance->HandleControllerOverlayInteractionAsMouse(ulOverlayHandle, unControllerDeviceIndex); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_IsHoverTargetOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_014_instance->IsHoverTargetOverlay(ulOverlayHandle); }
static vr::VROverlayHandle_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_GetGamepadFocusOverlay() { return fntable_Overlay_014_instance->GetGamepadFocusOverlay(); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_SetGamepadFocusOverlay(vr::VROverlayHandle_t ulNewFocusOverlay) { return fntable_Overlay_014_instance->SetGamepadFocusOverlay(ulNewFocusOverlay); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_SetOverlayNeighbor(vr::IVROverlay_014::EOverlayDirection eDirection, vr::VROverlayHandle_t ulFrom, vr::VROverlayHandle_t ulTo) { return fntable_Overlay_014_instance->SetOverlayNeighbor(eDirection, ulFrom, ulTo); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_MoveGamepadFocusToNeighbor(vr::IVROverlay_014::EOverlayDirection eDirection, vr::VROverlayHandle_t ulFrom) { return fntable_Overlay_014_instance->MoveGamepadFocusToNeighbor(eDirection, ulFrom); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_SetOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle, const vr::Texture_t* pTexture) { return fntable_Overlay_014_instance->SetOverlayTexture(ulOverlayHandle, pTexture); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_ClearOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_014_instance->ClearOverlayTexture(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_SetOverlayRaw(vr::VROverlayHandle_t ulOverlayHandle, void* pvBuffer, uint32_t unWidth, uint32_t unHeight, uint32_t unDepth) { return fntable_Overlay_014_instance->SetOverlayRaw(ulOverlayHandle, pvBuffer, unWidth, unHeight, unDepth); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_SetOverlayFromFile(vr::VROverlayHandle_t ulOverlayHandle, const char* pchFilePath) { return fntable_Overlay_014_instance->SetOverlayFromFile(ulOverlayHandle, pchFilePath); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_GetOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle, void** pNativeTextureHandle, void* pNativeTextureRef, uint32_t* pWidth, uint32_t* pHeight, uint32_t* pNativeFormat, vr::ETextureType* pAPIType, vr::EColorSpace* pColorSpace, vr::VRTextureBounds_t* pTextureBounds) { return fntable_Overlay_014_instance->GetOverlayTexture(ulOverlayHandle, pNativeTextureHandle, pNativeTextureRef, pWidth, pHeight, pNativeFormat, pAPIType, pColorSpace, pTextureBounds); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_ReleaseNativeOverlayHandle(vr::VROverlayHandle_t ulOverlayHandle, void* pNativeTextureHandle) { return fntable_Overlay_014_instance->ReleaseNativeOverlayHandle(ulOverlayHandle, pNativeTextureHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_GetOverlayTextureSize(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* pWidth, uint32_t* pHeight) { return fntable_Overlay_014_instance->GetOverlayTextureSize(ulOverlayHandle, pWidth, pHeight); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_CreateDashboardOverlay(const char* pchOverlayKey, const char* pchOverlayFriendlyName, vr::VROverlayHandle_t* pMainHandle, vr::VROverlayHandle_t* pThumbnailHandle) { return fntable_Overlay_014_instance->CreateDashboardOverlay(pchOverlayKey, pchOverlayFriendlyName, pMainHandle, pThumbnailHandle); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_IsDashboardVisible() { return fntable_Overlay_014_instance->IsDashboardVisible(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_IsActiveDashboardOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_014_instance->IsActiveDashboardOverlay(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_SetDashboardOverlaySceneProcess(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unProcessId) { return fntable_Overlay_014_instance->SetDashboardOverlaySceneProcess(ulOverlayHandle, unProcessId); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_GetDashboardOverlaySceneProcess(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* punProcessId) { return fntable_Overlay_014_instance->GetDashboardOverlaySceneProcess(ulOverlayHandle, punProcessId); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_ShowDashboard(const char* pchOverlayToShow) { return fntable_Overlay_014_instance->ShowDashboard(pchOverlayToShow); }
static vr::TrackedDeviceIndex_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_GetPrimaryDashboardDevice() { return fntable_Overlay_014_instance->GetPrimaryDashboardDevice(); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_ShowKeyboard(vr::IVROverlay_014::EGamepadTextInputMode eInputMode, vr::IVROverlay_014::EGamepadTextInputLineMode eLineInputMode, const char* pchDescription, uint32_t unCharMax, const char* pchExistingText, bool bUseMinimalMode, uint64_t uUserValue) { return fntable_Overlay_014_instance->ShowKeyboard(eInputMode, eLineInputMode, pchDescription, unCharMax, pchExistingText, bUseMinimalMode, uUserValue); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_ShowKeyboardForOverlay(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_014::EGamepadTextInputMode eInputMode, vr::IVROverlay_014::EGamepadTextInputLineMode eLineInputMode, const char* pchDescription, uint32_t unCharMax, const char* pchExistingText, bool bUseMinimalMode, uint64_t uUserValue) { return fntable_Overlay_014_instance->ShowKeyboardForOverlay(ulOverlayHandle, eInputMode, eLineInputMode, pchDescription, unCharMax, pchExistingText, bUseMinimalMode, uUserValue); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_GetKeyboardText(char* pchText, uint32_t cchText) { return fntable_Overlay_014_instance->GetKeyboardText(pchText, cchText); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_HideKeyboard() { return fntable_Overlay_014_instance->HideKeyboard(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_SetKeyboardTransformAbsolute(vr::ETrackingUniverseOrigin eTrackingOrigin, const vr::HmdMatrix34_t* pmatTrackingOriginToKeyboardTransform) { return fntable_Overlay_014_instance->SetKeyboardTransformAbsolute(eTrackingOrigin, pmatTrackingOriginToKeyboardTransform); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_SetKeyboardPositionForOverlay(vr::VROverlayHandle_t ulOverlayHandle, vr::HmdRect2_t avoidRect) { return fntable_Overlay_014_instance->SetKeyboardPositionForOverlay(ulOverlayHandle, avoidRect); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_SetOverlayIntersectionMask(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_014::VROverlayIntersectionMaskPrimitive_t* pMaskPrimitives, uint32_t unNumMaskPrimitives, uint32_t unPrimitiveSize) { return fntable_Overlay_014_instance->SetOverlayIntersectionMask(ulOverlayHandle, pMaskPrimitives, unNumMaskPrimitives, unPrimitiveSize); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_GetOverlayFlags(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* pFlags) { return fntable_Overlay_014_instance->GetOverlayFlags(ulOverlayHandle, pFlags); }
static vr::IVROverlay_014::VRMessageOverlayResponse OPENVR_FNTABLE_CALLTYPE fntable_Overlay_014_impl_ShowMessageOverlay(const char* pchText, const char* pchCaption, const char* pchButton0Text, const char* pchButton1Text, const char* pchButton2Text, const char* pchButton3Text) { return fntable_Overlay_014_instance->ShowMessageOverlay(pchText, pchCaption, pchButton0Text, pchButton1Text, pchButton2Text, pchButton3Text); }
static void *fntable_Overlay_014_funcs[] = {
	(void*) fntable_Overlay_014_impl_FindOverlay,
	(void*) fntable_Overlay_014_impl_CreateOverlay,
	(void*) fntable_Overlay_014_impl_DestroyOverlay,
	(void*) fntable_Overlay_014_impl_SetHighQualityOverlay,
	(void*) fntable_Overlay_014_impl_GetHighQualityOverlay,
	(void*) fntable_Overlay_014_impl_GetOverlayKey,
	(void*) fntable_Overlay_014_impl_GetOverlayName,
	(void*) fntable_Overlay_014_impl_GetOverlayImageData,
	(void*) fntable_Overlay_014_impl_GetOverlayErrorNameFromEnum,
	(void*) fntable_Overlay_014_impl_SetOverlayRenderingPid,
	(void*) fntable_Overlay_014_impl_GetOverlayRenderingPid,
	(void*) fntable_Overlay_014_impl_SetOverlayFlag,
	(void*) fntable_Overlay_014_impl_GetOverlayFlag,
	(void*) fntable_Overlay_014_impl_SetOverlayColor,
	(void*) fntable_Overlay_014_impl_GetOverlayColor,
	(void*) fntable_Overlay_014_impl_SetOverlayAlpha,
	(void*) fntable_Overlay_014_impl_GetOverlayAlpha,
	(void*) fntable_Overlay_014_impl_SetOverlayTexelAspect,
	(void*) fntable_Overlay_014_impl_GetOverlayTexelAspect,
	(void*) fntable_Overlay_014_impl_SetOverlaySortOrder,
	(void*) fntable_Overlay_014_impl_GetOverlaySortOrder,
	(void*) fntable_Overlay_014_impl_SetOverlayWidthInMeters,
	(void*) fntable_Overlay_014_impl_GetOverlayWidthInMeters,
	(void*) fntable_Overlay_014_impl_SetOverlayAutoCurveDistanceRangeInMeters,
	(void*) fntable_Overlay_014_impl_GetOverlayAutoCurveDistanceRangeInMeters,
	(void*) fntable_Overlay_014_impl_SetOverlayTextureColorSpace,
	(void*) fntable_Overlay_014_impl_GetOverlayTextureColorSpace,
	(void*) fntable_Overlay_014_impl_SetOverlayTextureBounds,
	(void*) fntable_Overlay_014_impl_GetOverlayTextureBounds,
	(void*) fntable_Overlay_014_impl_GetOverlayTransformType,
	(void*) fntable_Overlay_014_impl_SetOverlayTransformAbsolute,
	(void*) fntable_Overlay_014_impl_GetOverlayTransformAbsolute,
	(void*) fntable_Overlay_014_impl_SetOverlayTransformTrackedDeviceRelative,
	(void*) fntable_Overlay_014_impl_GetOverlayTransformTrackedDeviceRelative,
	(void*) fntable_Overlay_014_impl_SetOverlayTransformTrackedDeviceComponent,
	(void*) fntable_Overlay_014_impl_GetOverlayTransformTrackedDeviceComponent,
	(void*) fntable_Overlay_014_impl_ShowOverlay,
	(void*) fntable_Overlay_014_impl_HideOverlay,
	(void*) fntable_Overlay_014_impl_IsOverlayVisible,
	(void*) fntable_Overlay_014_impl_GetTransformForOverlayCoordinates,
	(void*) fntable_Overlay_014_impl_PollNextOverlayEvent,
	(void*) fntable_Overlay_014_impl_GetOverlayInputMethod,
	(void*) fntable_Overlay_014_impl_SetOverlayInputMethod,
	(void*) fntable_Overlay_014_impl_GetOverlayMouseScale,
	(void*) fntable_Overlay_014_impl_SetOverlayMouseScale,
	(void*) fntable_Overlay_014_impl_ComputeOverlayIntersection,
	(void*) fntable_Overlay_014_impl_HandleControllerOverlayInteractionAsMouse,
	(void*) fntable_Overlay_014_impl_IsHoverTargetOverlay,
	(void*) fntable_Overlay_014_impl_GetGamepadFocusOverlay,
	(void*) fntable_Overlay_014_impl_SetGamepadFocusOverlay,
	(void*) fntable_Overlay_014_impl_SetOverlayNeighbor,
	(void*) fntable_Overlay_014_impl_MoveGamepadFocusToNeighbor,
	(void*) fntable_Overlay_014_impl_SetOverlayTexture,
	(void*) fntable_Overlay_014_impl_ClearOverlayTexture,
	(void*) fntable_Overlay_014_impl_SetOverlayRaw,
	(void*) fntable_Overlay_014_impl_SetOverlayFromFile,
	(void*) fntable_Overlay_014_impl_GetOverlayTexture,
	(void*) fntable_Overlay_014_impl_ReleaseNativeOverlayHandle,
	(void*) fntable_Overlay_014_impl_GetOverlayTextureSize,
	(void*) fntable_Overlay_014_impl_CreateDashboardOverlay,
	(void*) fntable_Overlay_014_impl_IsDashboardVisible,
	(void*) fntable_Overlay_014_impl_IsActiveDashboardOverlay,
	(void*) fntable_Overlay_014_impl_SetDashboardOverlaySceneProcess,
	(void*) fntable_Overlay_014_impl_GetDashboardOverlaySceneProcess,
	(void*) fntable_Overlay_014_impl_ShowDashboard,
	(void*) fntable_Overlay_014_impl_GetPrimaryDashboardDevice,
	(void*) fntable_Overlay_014_impl_ShowKeyboard,
	(void*) fntable_Overlay_014_impl_ShowKeyboardForOverlay,
	(void*) fntable_Overlay_014_impl_GetKeyboardText,
	(void*) fntable_Overlay_014_impl_HideKeyboard,
	(void*) fntable_Overlay_014_impl_SetKeyboardTransformAbsolute,
	(void*) fntable_Overlay_014_impl_SetKeyboardPositionForOverlay,
	(void*) fntable_Overlay_014_impl_SetOverlayIntersectionMask,
	(void*) fntable_Overlay_014_impl_GetOverlayFlags,
	(void*) fntable_Overlay_014_impl_ShowMessageOverlay,
};
void** CVROverlay_014::_GetStatFuncList() { fntable_Overlay_014_instance = this; return fntable_Overlay_014_funcs; }
void CVROverlay_014::Delete() { delete this; }
// Misc for CVROverlay_016:
CVROverlay_016::CVROverlay_016() : base(GetCreateBaseOverlay()) {}
// Interface methods for CVROverlay_016:
vr::EVROverlayError CVROverlay_016::FindOverlay(const char* pchOverlayKey, vr::VROverlayHandle_t* pOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->FindOverlay(pchOverlayKey, pOverlayHandle);
}
vr::EVROverlayError CVROverlay_016::CreateOverlay(const char* pchOverlayKey, const char* pchOverlayName, vr::VROverlayHandle_t* pOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->CreateOverlay(pchOverlayKey, pchOverlayName, pOverlayHandle);
}
vr::EVROverlayError CVROverlay_016::DestroyOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->DestroyOverlay(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_016::SetHighQualityOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->SetHighQualityOverlay(ulOverlayHandle);
}
vr::VROverlayHandle_t CVROverlay_016::GetHighQualityOverlay() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->GetHighQualityOverlay();
}
uint32_t CVROverlay_016::GetOverlayKey(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::EVROverlayError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->GetOverlayKey(ulOverlayHandle, pchValue, unBufferSize, pError);
}
uint32_t CVROverlay_016::GetOverlayName(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::EVROverlayError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->GetOverlayName(ulOverlayHandle, pchValue, unBufferSize, pError);
}
vr::EVROverlayError CVROverlay_016::SetOverlayName(vr::VROverlayHandle_t ulOverlayHandle, const char* pchName) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->SetOverlayName(ulOverlayHandle, pchName);
}
vr::EVROverlayError CVROverlay_016::GetOverlayImageData(vr::VROverlayHandle_t ulOverlayHandle, void* pvBuffer, uint32_t unBufferSize, uint32_t* punWidth, uint32_t* punHeight) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->GetOverlayImageData(ulOverlayHandle, pvBuffer, unBufferSize, punWidth, punHeight);
}
const char* CVROverlay_016::GetOverlayErrorNameFromEnum(vr::EVROverlayError error) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->GetOverlayErrorNameFromEnum(error);
}
vr::EVROverlayError CVROverlay_016::SetOverlayRenderingPid(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unPID) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->SetOverlayRenderingPid(ulOverlayHandle, unPID);
}
uint32_t CVROverlay_016::GetOverlayRenderingPid(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->GetOverlayRenderingPid(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_016::SetOverlayFlag(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_016::VROverlayFlags eOverlayFlag, bool bEnabled) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->SetOverlayFlag(ulOverlayHandle, (OOVR_VROverlayFlags) eOverlayFlag, bEnabled);
}
vr::EVROverlayError CVROverlay_016::GetOverlayFlag(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_016::VROverlayFlags eOverlayFlag, bool* pbEnabled) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->GetOverlayFlag(ulOverlayHandle, (OOVR_VROverlayFlags) eOverlayFlag, pbEnabled);
}
vr::EVROverlayError CVROverlay_016::SetOverlayColor(vr::VROverlayHandle_t ulOverlayHandle, float fRed, float fGreen, float fBlue) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->SetOverlayColor(ulOverlayHandle, fRed, fGreen, fBlue);
}
vr::EVROverlayError CVROverlay_016::GetOverlayColor(vr::VROverlayHandle_t ulOverlayHandle, float* pfRed, float* pfGreen, float* pfBlue) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->GetOverlayColor(ulOverlayHandle, pfRed, pfGreen, pfBlue);
}
vr::EVROverlayError CVROverlay_016::SetOverlayAlpha(vr::VROverlayHandle_t ulOverlayHandle, float fAlpha) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->SetOverlayAlpha(ulOverlayHandle, fAlpha);
}
vr::EVROverlayError CVROverlay_016::GetOverlayAlpha(vr::VROverlayHandle_t ulOverlayHandle, float* pfAlpha) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->GetOverlayAlpha(ulOverlayHandle, pfAlpha);
}
vr::EVROverlayError CVROverlay_016::SetOverlayTexelAspect(vr::VROverlayHandle_t ulOverlayHandle, float fTexelAspect) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->SetOverlayTexelAspect(ulOverlayHandle, fTexelAspect);
}
vr::EVROverlayError CVROverlay_016::GetOverlayTexelAspect(vr::VROverlayHandle_t ulOverlayHandle, float* pfTexelAspect) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->GetOverlayTexelAspect(ulOverlayHandle, pfTexelAspect);
}
vr::EVROverlayError CVROverlay_016::SetOverlaySortOrder(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unSortOrder) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->SetOverlaySortOrder(ulOverlayHandle, unSortOrder);
}
vr::EVROverlayError CVROverlay_016::GetOverlaySortOrder(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* punSortOrder) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->GetOverlaySortOrder(ulOverlayHandle, punSortOrder);
}
vr::EVROverlayError CVROverlay_016::SetOverlayWidthInMeters(vr::VROverlayHandle_t ulOverlayHandle, float fWidthInMeters) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->SetOverlayWidthInMeters(ulOverlayHandle, fWidthInMeters);
}
vr::EVROverlayError CVROverlay_016::GetOverlayWidthInMeters(vr::VROverlayHandle_t ulOverlayHandle, float* pfWidthInMeters) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->GetOverlayWidthInMeters(ulOverlayHandle, pfWidthInMeters);
}
vr::EVROverlayError CVROverlay_016::SetOverlayAutoCurveDistanceRangeInMeters(vr::VROverlayHandle_t ulOverlayHandle, float fMinDistanceInMeters, float fMaxDistanceInMeters) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->SetOverlayAutoCurveDistanceRangeInMeters(ulOverlayHandle, fMinDistanceInMeters, fMaxDistanceInMeters);
}
vr::EVROverlayError CVROverlay_016::GetOverlayAutoCurveDistanceRangeInMeters(vr::VROverlayHandle_t ulOverlayHandle, float* pfMinDistanceInMeters, float* pfMaxDistanceInMeters) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->GetOverlayAutoCurveDistanceRangeInMeters(ulOverlayHandle, pfMinDistanceInMeters, pfMaxDistanceInMeters);
}
vr::EVROverlayError CVROverlay_016::SetOverlayTextureColorSpace(vr::VROverlayHandle_t ulOverlayHandle, vr::EColorSpace eTextureColorSpace) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->SetOverlayTextureColorSpace(ulOverlayHandle, eTextureColorSpace);
}
vr::EVROverlayError CVROverlay_016::GetOverlayTextureColorSpace(vr::VROverlayHandle_t ulOverlayHandle, vr::EColorSpace* peTextureColorSpace) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->GetOverlayTextureColorSpace(ulOverlayHandle, peTextureColorSpace);
}
vr::EVROverlayError CVROverlay_016::SetOverlayTextureBounds(vr::VROverlayHandle_t ulOverlayHandle, const vr::VRTextureBounds_t* pOverlayTextureBounds) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->SetOverlayTextureBounds(ulOverlayHandle, pOverlayTextureBounds);
}
vr::EVROverlayError CVROverlay_016::GetOverlayTextureBounds(vr::VROverlayHandle_t ulOverlayHandle, vr::VRTextureBounds_t* pOverlayTextureBounds) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->GetOverlayTextureBounds(ulOverlayHandle, pOverlayTextureBounds);
}
uint32_t CVROverlay_016::GetOverlayRenderModel(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::HmdColor_t* pColor, vr::EVROverlayError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->GetOverlayRenderModel(ulOverlayHandle, pchValue, unBufferSize, pColor, pError);
}
vr::EVROverlayError CVROverlay_016::SetOverlayRenderModel(vr::VROverlayHandle_t ulOverlayHandle, const char* pchRenderModel, const vr::HmdColor_t* pColor) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->SetOverlayRenderModel(ulOverlayHandle, pchRenderModel, pColor);
}
vr::EVROverlayError CVROverlay_016::GetOverlayTransformType(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_016::VROverlayTransformType* peTransformType) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->GetOverlayTransformType(ulOverlayHandle, (OOVR_VROverlayTransformType*) peTransformType);
}
vr::EVROverlayError CVROverlay_016::SetOverlayTransformAbsolute(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin eTrackingOrigin, const vr::HmdMatrix34_t* pmatTrackingOriginToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->SetOverlayTransformAbsolute(ulOverlayHandle, eTrackingOrigin, pmatTrackingOriginToOverlayTransform);
}
vr::EVROverlayError CVROverlay_016::GetOverlayTransformAbsolute(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin* peTrackingOrigin, vr::HmdMatrix34_t* pmatTrackingOriginToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->GetOverlayTransformAbsolute(ulOverlayHandle, peTrackingOrigin, pmatTrackingOriginToOverlayTransform);
}
vr::EVROverlayError CVROverlay_016::SetOverlayTransformTrackedDeviceRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unTrackedDevice, const vr::HmdMatrix34_t* pmatTrackedDeviceToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->SetOverlayTransformTrackedDeviceRelative(ulOverlayHandle, unTrackedDevice, pmatTrackedDeviceToOverlayTransform);
}
vr::EVROverlayError CVROverlay_016::GetOverlayTransformTrackedDeviceRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t* punTrackedDevice, vr::HmdMatrix34_t* pmatTrackedDeviceToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->GetOverlayTransformTrackedDeviceRelative(ulOverlayHandle, punTrackedDevice, pmatTrackedDeviceToOverlayTransform);
}
vr::EVROverlayError CVROverlay_016::SetOverlayTransformTrackedDeviceComponent(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unDeviceIndex, const char* pchComponentName) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->SetOverlayTransformTrackedDeviceComponent(ulOverlayHandle, unDeviceIndex, pchComponentName);
}
vr::EVROverlayError CVROverlay_016::GetOverlayTransformTrackedDeviceComponent(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t* punDeviceIndex, char* pchComponentName, uint32_t unComponentNameSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->GetOverlayTransformTrackedDeviceComponent(ulOverlayHandle, punDeviceIndex, pchComponentName, unComponentNameSize);
}
vr::EVROverlayError CVROverlay_016::GetOverlayTransformOverlayRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::VROverlayHandle_t* ulOverlayHandleParent, vr::HmdMatrix34_t* pmatParentOverlayToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->GetOverlayTransformOverlayRelative(ulOverlayHandle, ulOverlayHandleParent, pmatParentOverlayToOverlayTransform);
}
vr::EVROverlayError CVROverlay_016::SetOverlayTransformOverlayRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::VROverlayHandle_t ulOverlayHandleParent, const vr::HmdMatrix34_t* pmatParentOverlayToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->SetOverlayTransformOverlayRelative(ulOverlayHandle, ulOverlayHandleParent, pmatParentOverlayToOverlayTransform);
}
vr::EVROverlayError CVROverlay_016::ShowOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->ShowOverlay(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_016::HideOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->HideOverlay(ulOverlayHandle);
}
bool CVROverlay_016::IsOverlayVisible(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->IsOverlayVisible(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_016::GetTransformForOverlayCoordinates(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin eTrackingOrigin, vr::HmdVector2_t coordinatesInOverlay, vr::HmdMatrix34_t* pmatTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->GetTransformForOverlayCoordinates(ulOverlayHandle, eTrackingOrigin, coordinatesInOverlay, pmatTransform);
}
bool CVROverlay_016::PollNextOverlayEvent(vr::VROverlayHandle_t ulOverlayHandle, vr::VREvent_t* pEvent, uint32_t uncbVREvent) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->PollNextOverlayEvent(ulOverlayHandle, pEvent, uncbVREvent);
}
vr::EVROverlayError CVROverlay_016::GetOverlayInputMethod(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_016::VROverlayInputMethod* peInputMethod) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->GetOverlayInputMethod(ulOverlayHandle, (OOVR_VROverlayInputMethod*) peInputMethod);
}
vr::EVROverlayError CVROverlay_016::SetOverlayInputMethod(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_016::VROverlayInputMethod eInputMethod) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->SetOverlayInputMethod(ulOverlayHandle, (OOVR_VROverlayInputMethod) eInputMethod);
}
vr::EVROverlayError CVROverlay_016::GetOverlayMouseScale(vr::VROverlayHandle_t ulOverlayHandle, vr::HmdVector2_t* pvecMouseScale) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->GetOverlayMouseScale(ulOverlayHandle, pvecMouseScale);
}
vr::EVROverlayError CVROverlay_016::SetOverlayMouseScale(vr::VROverlayHandle_t ulOverlayHandle, const vr::HmdVector2_t* pvecMouseScale) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->SetOverlayMouseScale(ulOverlayHandle, pvecMouseScale);
}
bool CVROverlay_016::ComputeOverlayIntersection(vr::VROverlayHandle_t ulOverlayHandle, const vr::IVROverlay_016::VROverlayIntersectionParams_t* pParams, vr::IVROverlay_016::VROverlayIntersectionResults_t* pResults) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->ComputeOverlayIntersection(ulOverlayHandle, (const OOVR_VROverlayIntersectionParams_t*) pParams, (OOVR_VROverlayIntersectionResults_t*) pResults);
}
bool CVROverlay_016::HandleControllerOverlayInteractionAsMouse(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unControllerDeviceIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->HandleControllerOverlayInteractionAsMouse(ulOverlayHandle, unControllerDeviceIndex);
}
bool CVROverlay_016::IsHoverTargetOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->IsHoverTargetOverlay(ulOverlayHandle);
}
vr::VROverlayHandle_t CVROverlay_016::GetGamepadFocusOverlay() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->GetGamepadFocusOverlay();
}
vr::EVROverlayError CVROverlay_016::SetGamepadFocusOverlay(vr::VROverlayHandle_t ulNewFocusOverlay) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->SetGamepadFocusOverlay(ulNewFocusOverlay);
}
vr::EVROverlayError CVROverlay_016::SetOverlayNeighbor(vr::IVROverlay_016::EOverlayDirection eDirection, vr::VROverlayHandle_t ulFrom, vr::VROverlayHandle_t ulTo) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->SetOverlayNeighbor((OOVR_EOverlayDirection) eDirection, ulFrom, ulTo);
}
vr::EVROverlayError CVROverlay_016::MoveGamepadFocusToNeighbor(vr::IVROverlay_016::EOverlayDirection eDirection, vr::VROverlayHandle_t ulFrom) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->MoveGamepadFocusToNeighbor((OOVR_EOverlayDirection) eDirection, ulFrom);
}
vr::EVROverlayError CVROverlay_016::SetOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle, const vr::Texture_t* pTexture) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->SetOverlayTexture(ulOverlayHandle, pTexture);
}
vr::EVROverlayError CVROverlay_016::ClearOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->ClearOverlayTexture(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_016::SetOverlayRaw(vr::VROverlayHandle_t ulOverlayHandle, void* pvBuffer, uint32_t unWidth, uint32_t unHeight, uint32_t unDepth) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->SetOverlayRaw(ulOverlayHandle, pvBuffer, unWidth, unHeight, unDepth);
}
vr::EVROverlayError CVROverlay_016::SetOverlayFromFile(vr::VROverlayHandle_t ulOverlayHandle, const char* pchFilePath) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->SetOverlayFromFile(ulOverlayHandle, pchFilePath);
}
vr::EVROverlayError CVROverlay_016::GetOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle, void** pNativeTextureHandle, void* pNativeTextureRef, uint32_t* pWidth, uint32_t* pHeight, uint32_t* pNativeFormat, vr::ETextureType* pAPIType, vr::EColorSpace* pColorSpace, vr::VRTextureBounds_t* pTextureBounds) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->GetOverlayTexture(ulOverlayHandle, pNativeTextureHandle, pNativeTextureRef, pWidth, pHeight, pNativeFormat, pAPIType, pColorSpace, pTextureBounds);
}
vr::EVROverlayError CVROverlay_016::ReleaseNativeOverlayHandle(vr::VROverlayHandle_t ulOverlayHandle, void* pNativeTextureHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->ReleaseNativeOverlayHandle(ulOverlayHandle, pNativeTextureHandle);
}
vr::EVROverlayError CVROverlay_016::GetOverlayTextureSize(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* pWidth, uint32_t* pHeight) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->GetOverlayTextureSize(ulOverlayHandle, pWidth, pHeight);
}
vr::EVROverlayError CVROverlay_016::CreateDashboardOverlay(const char* pchOverlayKey, const char* pchOverlayFriendlyName, vr::VROverlayHandle_t* pMainHandle, vr::VROverlayHandle_t* pThumbnailHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->CreateDashboardOverlay(pchOverlayKey, pchOverlayFriendlyName, pMainHandle, pThumbnailHandle);
}
bool CVROverlay_016::IsDashboardVisible() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->IsDashboardVisible();
}
bool CVROverlay_016::IsActiveDashboardOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->IsActiveDashboardOverlay(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_016::SetDashboardOverlaySceneProcess(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unProcessId) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->SetDashboardOverlaySceneProcess(ulOverlayHandle, unProcessId);
}
vr::EVROverlayError CVROverlay_016::GetDashboardOverlaySceneProcess(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* punProcessId) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->GetDashboardOverlaySceneProcess(ulOverlayHandle, punProcessId);
}
void CVROverlay_016::ShowDashboard(const char* pchOverlayToShow) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->ShowDashboard(pchOverlayToShow);
}
vr::TrackedDeviceIndex_t CVROverlay_016::GetPrimaryDashboardDevice() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->GetPrimaryDashboardDevice();
}
vr::EVROverlayError CVROverlay_016::ShowKeyboard(vr::IVROverlay_016::EGamepadTextInputMode eInputMode, vr::IVROverlay_016::EGamepadTextInputLineMode eLineInputMode, const char* pchDescription, uint32_t unCharMax, const char* pchExistingText, bool bUseMinimalMode, uint64_t uUserValue) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->ShowKeyboard((OOVR_EGamepadTextInputMode) eInputMode, (OOVR_EGamepadTextInputLineMode) eLineInputMode, pchDescription, unCharMax, pchExistingText, bUseMinimalMode, uUserValue);
}
vr::EVROverlayError CVROverlay_016::ShowKeyboardForOverlay(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_016::EGamepadTextInputMode eInputMode, vr::IVROverlay_016::EGamepadTextInputLineMode eLineInputMode, const char* pchDescription, uint32_t unCharMax, const char* pchExistingText, bool bUseMinimalMode, uint64_t uUserValue) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->ShowKeyboardForOverlay(ulOverlayHandle, (OOVR_EGamepadTextInputMode) eInputMode, (OOVR_EGamepadTextInputLineMode) eLineInputMode, pchDescription, unCharMax, pchExistingText, bUseMinimalMode, uUserValue);
}
uint32_t CVROverlay_016::GetKeyboardText(char* pchText, uint32_t cchText) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->GetKeyboardText(pchText, cchText);
}
void CVROverlay_016::HideKeyboard() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->HideKeyboard();
}
void CVROverlay_016::SetKeyboardTransformAbsolute(vr::ETrackingUniverseOrigin eTrackingOrigin, const vr::HmdMatrix34_t* pmatTrackingOriginToKeyboardTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->SetKeyboardTransformAbsolute(eTrackingOrigin, pmatTrackingOriginToKeyboardTransform);
}
void CVROverlay_016::SetKeyboardPositionForOverlay(vr::VROverlayHandle_t ulOverlayHandle, vr::HmdRect2_t avoidRect) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->SetKeyboardPositionForOverlay(ulOverlayHandle, avoidRect);
}
vr::EVROverlayError CVROverlay_016::SetOverlayIntersectionMask(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_016::VROverlayIntersectionMaskPrimitive_t* pMaskPrimitives, uint32_t unNumMaskPrimitives, uint32_t unPrimitiveSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->SetOverlayIntersectionMask(ulOverlayHandle, (OOVR_VROverlayIntersectionMaskPrimitive_t*) pMaskPrimitives, unNumMaskPrimitives, unPrimitiveSize);
}
vr::EVROverlayError CVROverlay_016::GetOverlayFlags(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* pFlags) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->GetOverlayFlags(ulOverlayHandle, pFlags);
}
vr::IVROverlay_016::VRMessageOverlayResponse CVROverlay_016::ShowMessageOverlay(const char* pchText, const char* pchCaption, const char* pchButton0Text, const char* pchButton1Text, const char* pchButton2Text, const char* pchButton3Text) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return (vr::IVROverlay_016::VRMessageOverlayResponse) base->ShowMessageOverlay(pchText, pchCaption, pchButton0Text, pchButton1Text, pchButton2Text, pchButton3Text);
}
void CVROverlay_016::CloseMessageOverlay() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_016)");
	return base->CloseMessageOverlay();
}
// FnTable for CVROverlay_016:
static CVROverlay_016 *fntable_Overlay_016_instance = NULL;
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_FindOverlay(const char* pchOverlayKey, vr::VROverlayHandle_t* pOverlayHandle) { return fntable_Overlay_016_instance->FindOverlay(pchOverlayKey, pOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_CreateOverlay(const char* pchOverlayKey, const char* pchOverlayName, vr::VROverlayHandle_t* pOverlayHandle) { return fntable_Overlay_016_instance->CreateOverlay(pchOverlayKey, pchOverlayName, pOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_DestroyOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_016_instance->DestroyOverlay(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_SetHighQualityOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_016_instance->SetHighQualityOverlay(ulOverlayHandle); }
static vr::VROverlayHandle_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_GetHighQualityOverlay() { return fntable_Overlay_016_instance->GetHighQualityOverlay(); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_GetOverlayKey(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::EVROverlayError* pError) { return fntable_Overlay_016_instance->GetOverlayKey(ulOverlayHandle, pchValue, unBufferSize, pError); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_GetOverlayName(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::EVROverlayError* pError) { return fntable_Overlay_016_instance->GetOverlayName(ulOverlayHandle, pchValue, unBufferSize, pError); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_SetOverlayName(vr::VROverlayHandle_t ulOverlayHandle, const char* pchName) { return fntable_Overlay_016_instance->SetOverlayName(ulOverlayHandle, pchName); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_GetOverlayImageData(vr::VROverlayHandle_t ulOverlayHandle, void* pvBuffer, uint32_t unBufferSize, uint32_t* punWidth, uint32_t* punHeight) { return fntable_Overlay_016_instance->GetOverlayImageData(ulOverlayHandle, pvBuffer, unBufferSize, punWidth, punHeight); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_GetOverlayErrorNameFromEnum(vr::EVROverlayError error) { return fntable_Overlay_016_instance->GetOverlayErrorNameFromEnum(error); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_SetOverlayRenderingPid(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unPID) { return fntable_Overlay_016_instance->SetOverlayRenderingPid(ulOverlayHandle, unPID); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_GetOverlayRenderingPid(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_016_instance->GetOverlayRenderingPid(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_SetOverlayFlag(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_016::VROverlayFlags eOverlayFlag, bool bEnabled) { return fntable_Overlay_016_instance->SetOverlayFlag(ulOverlayHandle, eOverlayFlag, bEnabled); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_GetOverlayFlag(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_016::VROverlayFlags eOverlayFlag, bool* pbEnabled) { return fntable_Overlay_016_instance->GetOverlayFlag(ulOverlayHandle, eOverlayFlag, pbEnabled); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_SetOverlayColor(vr::VROverlayHandle_t ulOverlayHandle, float fRed, float fGreen, float fBlue) { return fntable_Overlay_016_instance->SetOverlayColor(ulOverlayHandle, fRed, fGreen, fBlue); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_GetOverlayColor(vr::VROverlayHandle_t ulOverlayHandle, float* pfRed, float* pfGreen, float* pfBlue) { return fntable_Overlay_016_instance->GetOverlayColor(ulOverlayHandle, pfRed, pfGreen, pfBlue); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_SetOverlayAlpha(vr::VROverlayHandle_t ulOverlayHandle, float fAlpha) { return fntable_Overlay_016_instance->SetOverlayAlpha(ulOverlayHandle, fAlpha); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_GetOverlayAlpha(vr::VROverlayHandle_t ulOverlayHandle, float* pfAlpha) { return fntable_Overlay_016_instance->GetOverlayAlpha(ulOverlayHandle, pfAlpha); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_SetOverlayTexelAspect(vr::VROverlayHandle_t ulOverlayHandle, float fTexelAspect) { return fntable_Overlay_016_instance->SetOverlayTexelAspect(ulOverlayHandle, fTexelAspect); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_GetOverlayTexelAspect(vr::VROverlayHandle_t ulOverlayHandle, float* pfTexelAspect) { return fntable_Overlay_016_instance->GetOverlayTexelAspect(ulOverlayHandle, pfTexelAspect); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_SetOverlaySortOrder(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unSortOrder) { return fntable_Overlay_016_instance->SetOverlaySortOrder(ulOverlayHandle, unSortOrder); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_GetOverlaySortOrder(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* punSortOrder) { return fntable_Overlay_016_instance->GetOverlaySortOrder(ulOverlayHandle, punSortOrder); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_SetOverlayWidthInMeters(vr::VROverlayHandle_t ulOverlayHandle, float fWidthInMeters) { return fntable_Overlay_016_instance->SetOverlayWidthInMeters(ulOverlayHandle, fWidthInMeters); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_GetOverlayWidthInMeters(vr::VROverlayHandle_t ulOverlayHandle, float* pfWidthInMeters) { return fntable_Overlay_016_instance->GetOverlayWidthInMeters(ulOverlayHandle, pfWidthInMeters); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_SetOverlayAutoCurveDistanceRangeInMeters(vr::VROverlayHandle_t ulOverlayHandle, float fMinDistanceInMeters, float fMaxDistanceInMeters) { return fntable_Overlay_016_instance->SetOverlayAutoCurveDistanceRangeInMeters(ulOverlayHandle, fMinDistanceInMeters, fMaxDistanceInMeters); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_GetOverlayAutoCurveDistanceRangeInMeters(vr::VROverlayHandle_t ulOverlayHandle, float* pfMinDistanceInMeters, float* pfMaxDistanceInMeters) { return fntable_Overlay_016_instance->GetOverlayAutoCurveDistanceRangeInMeters(ulOverlayHandle, pfMinDistanceInMeters, pfMaxDistanceInMeters); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_SetOverlayTextureColorSpace(vr::VROverlayHandle_t ulOverlayHandle, vr::EColorSpace eTextureColorSpace) { return fntable_Overlay_016_instance->SetOverlayTextureColorSpace(ulOverlayHandle, eTextureColorSpace); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_GetOverlayTextureColorSpace(vr::VROverlayHandle_t ulOverlayHandle, vr::EColorSpace* peTextureColorSpace) { return fntable_Overlay_016_instance->GetOverlayTextureColorSpace(ulOverlayHandle, peTextureColorSpace); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_SetOverlayTextureBounds(vr::VROverlayHandle_t ulOverlayHandle, const vr::VRTextureBounds_t* pOverlayTextureBounds) { return fntable_Overlay_016_instance->SetOverlayTextureBounds(ulOverlayHandle, pOverlayTextureBounds); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_GetOverlayTextureBounds(vr::VROverlayHandle_t ulOverlayHandle, vr::VRTextureBounds_t* pOverlayTextureBounds) { return fntable_Overlay_016_instance->GetOverlayTextureBounds(ulOverlayHandle, pOverlayTextureBounds); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_GetOverlayRenderModel(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::HmdColor_t* pColor, vr::EVROverlayError* pError) { return fntable_Overlay_016_instance->GetOverlayRenderModel(ulOverlayHandle, pchValue, unBufferSize, pColor, pError); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_SetOverlayRenderModel(vr::VROverlayHandle_t ulOverlayHandle, const char* pchRenderModel, const vr::HmdColor_t* pColor) { return fntable_Overlay_016_instance->SetOverlayRenderModel(ulOverlayHandle, pchRenderModel, pColor); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_GetOverlayTransformType(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_016::VROverlayTransformType* peTransformType) { return fntable_Overlay_016_instance->GetOverlayTransformType(ulOverlayHandle, peTransformType); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_SetOverlayTransformAbsolute(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin eTrackingOrigin, const vr::HmdMatrix34_t* pmatTrackingOriginToOverlayTransform) { return fntable_Overlay_016_instance->SetOverlayTransformAbsolute(ulOverlayHandle, eTrackingOrigin, pmatTrackingOriginToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_GetOverlayTransformAbsolute(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin* peTrackingOrigin, vr::HmdMatrix34_t* pmatTrackingOriginToOverlayTransform) { return fntable_Overlay_016_instance->GetOverlayTransformAbsolute(ulOverlayHandle, peTrackingOrigin, pmatTrackingOriginToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_SetOverlayTransformTrackedDeviceRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unTrackedDevice, const vr::HmdMatrix34_t* pmatTrackedDeviceToOverlayTransform) { return fntable_Overlay_016_instance->SetOverlayTransformTrackedDeviceRelative(ulOverlayHandle, unTrackedDevice, pmatTrackedDeviceToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_GetOverlayTransformTrackedDeviceRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t* punTrackedDevice, vr::HmdMatrix34_t* pmatTrackedDeviceToOverlayTransform) { return fntable_Overlay_016_instance->GetOverlayTransformTrackedDeviceRelative(ulOverlayHandle, punTrackedDevice, pmatTrackedDeviceToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_SetOverlayTransformTrackedDeviceComponent(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unDeviceIndex, const char* pchComponentName) { return fntable_Overlay_016_instance->SetOverlayTransformTrackedDeviceComponent(ulOverlayHandle, unDeviceIndex, pchComponentName); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_GetOverlayTransformTrackedDeviceComponent(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t* punDeviceIndex, char* pchComponentName, uint32_t unComponentNameSize) { return fntable_Overlay_016_instance->GetOverlayTransformTrackedDeviceComponent(ulOverlayHandle, punDeviceIndex, pchComponentName, unComponentNameSize); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_GetOverlayTransformOverlayRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::VROverlayHandle_t* ulOverlayHandleParent, vr::HmdMatrix34_t* pmatParentOverlayToOverlayTransform) { return fntable_Overlay_016_instance->GetOverlayTransformOverlayRelative(ulOverlayHandle, ulOverlayHandleParent, pmatParentOverlayToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_SetOverlayTransformOverlayRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::VROverlayHandle_t ulOverlayHandleParent, const vr::HmdMatrix34_t* pmatParentOverlayToOverlayTransform) { return fntable_Overlay_016_instance->SetOverlayTransformOverlayRelative(ulOverlayHandle, ulOverlayHandleParent, pmatParentOverlayToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_ShowOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_016_instance->ShowOverlay(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_HideOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_016_instance->HideOverlay(ulOverlayHandle); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_IsOverlayVisible(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_016_instance->IsOverlayVisible(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_GetTransformForOverlayCoordinates(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin eTrackingOrigin, vr::HmdVector2_t coordinatesInOverlay, vr::HmdMatrix34_t* pmatTransform) { return fntable_Overlay_016_instance->GetTransformForOverlayCoordinates(ulOverlayHandle, eTrackingOrigin, coordinatesInOverlay, pmatTransform); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_PollNextOverlayEvent(vr::VROverlayHandle_t ulOverlayHandle, vr::VREvent_t* pEvent, uint32_t uncbVREvent) { return fntable_Overlay_016_instance->PollNextOverlayEvent(ulOverlayHandle, pEvent, uncbVREvent); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_GetOverlayInputMethod(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_016::VROverlayInputMethod* peInputMethod) { return fntable_Overlay_016_instance->GetOverlayInputMethod(ulOverlayHandle, peInputMethod); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_SetOverlayInputMethod(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_016::VROverlayInputMethod eInputMethod) { return fntable_Overlay_016_instance->SetOverlayInputMethod(ulOverlayHandle, eInputMethod); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_GetOverlayMouseScale(vr::VROverlayHandle_t ulOverlayHandle, vr::HmdVector2_t* pvecMouseScale) { return fntable_Overlay_016_instance->GetOverlayMouseScale(ulOverlayHandle, pvecMouseScale); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_SetOverlayMouseScale(vr::VROverlayHandle_t ulOverlayHandle, const vr::HmdVector2_t* pvecMouseScale) { return fntable_Overlay_016_instance->SetOverlayMouseScale(ulOverlayHandle, pvecMouseScale); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_ComputeOverlayIntersection(vr::VROverlayHandle_t ulOverlayHandle, const vr::IVROverlay_016::VROverlayIntersectionParams_t* pParams, vr::IVROverlay_016::VROverlayIntersectionResults_t* pResults) { return fntable_Overlay_016_instance->ComputeOverlayIntersection(ulOverlayHandle, pParams, pResults); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_HandleControllerOverlayInteractionAsMouse(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unControllerDeviceIndex) { return fntable_Overlay_016_instance->HandleControllerOverlayInteractionAsMouse(ulOverlayHandle, unControllerDeviceIndex); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_IsHoverTargetOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_016_instance->IsHoverTargetOverlay(ulOverlayHandle); }
static vr::VROverlayHandle_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_GetGamepadFocusOverlay() { return fntable_Overlay_016_instance->GetGamepadFocusOverlay(); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_SetGamepadFocusOverlay(vr::VROverlayHandle_t ulNewFocusOverlay) { return fntable_Overlay_016_instance->SetGamepadFocusOverlay(ulNewFocusOverlay); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_SetOverlayNeighbor(vr::IVROverlay_016::EOverlayDirection eDirection, vr::VROverlayHandle_t ulFrom, vr::VROverlayHandle_t ulTo) { return fntable_Overlay_016_instance->SetOverlayNeighbor(eDirection, ulFrom, ulTo); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_MoveGamepadFocusToNeighbor(vr::IVROverlay_016::EOverlayDirection eDirection, vr::VROverlayHandle_t ulFrom) { return fntable_Overlay_016_instance->MoveGamepadFocusToNeighbor(eDirection, ulFrom); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_SetOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle, const vr::Texture_t* pTexture) { return fntable_Overlay_016_instance->SetOverlayTexture(ulOverlayHandle, pTexture); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_ClearOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_016_instance->ClearOverlayTexture(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_SetOverlayRaw(vr::VROverlayHandle_t ulOverlayHandle, void* pvBuffer, uint32_t unWidth, uint32_t unHeight, uint32_t unDepth) { return fntable_Overlay_016_instance->SetOverlayRaw(ulOverlayHandle, pvBuffer, unWidth, unHeight, unDepth); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_SetOverlayFromFile(vr::VROverlayHandle_t ulOverlayHandle, const char* pchFilePath) { return fntable_Overlay_016_instance->SetOverlayFromFile(ulOverlayHandle, pchFilePath); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_GetOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle, void** pNativeTextureHandle, void* pNativeTextureRef, uint32_t* pWidth, uint32_t* pHeight, uint32_t* pNativeFormat, vr::ETextureType* pAPIType, vr::EColorSpace* pColorSpace, vr::VRTextureBounds_t* pTextureBounds) { return fntable_Overlay_016_instance->GetOverlayTexture(ulOverlayHandle, pNativeTextureHandle, pNativeTextureRef, pWidth, pHeight, pNativeFormat, pAPIType, pColorSpace, pTextureBounds); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_ReleaseNativeOverlayHandle(vr::VROverlayHandle_t ulOverlayHandle, void* pNativeTextureHandle) { return fntable_Overlay_016_instance->ReleaseNativeOverlayHandle(ulOverlayHandle, pNativeTextureHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_GetOverlayTextureSize(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* pWidth, uint32_t* pHeight) { return fntable_Overlay_016_instance->GetOverlayTextureSize(ulOverlayHandle, pWidth, pHeight); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_CreateDashboardOverlay(const char* pchOverlayKey, const char* pchOverlayFriendlyName, vr::VROverlayHandle_t* pMainHandle, vr::VROverlayHandle_t* pThumbnailHandle) { return fntable_Overlay_016_instance->CreateDashboardOverlay(pchOverlayKey, pchOverlayFriendlyName, pMainHandle, pThumbnailHandle); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_IsDashboardVisible() { return fntable_Overlay_016_instance->IsDashboardVisible(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_IsActiveDashboardOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_016_instance->IsActiveDashboardOverlay(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_SetDashboardOverlaySceneProcess(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unProcessId) { return fntable_Overlay_016_instance->SetDashboardOverlaySceneProcess(ulOverlayHandle, unProcessId); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_GetDashboardOverlaySceneProcess(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* punProcessId) { return fntable_Overlay_016_instance->GetDashboardOverlaySceneProcess(ulOverlayHandle, punProcessId); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_ShowDashboard(const char* pchOverlayToShow) { return fntable_Overlay_016_instance->ShowDashboard(pchOverlayToShow); }
static vr::TrackedDeviceIndex_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_GetPrimaryDashboardDevice() { return fntable_Overlay_016_instance->GetPrimaryDashboardDevice(); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_ShowKeyboard(vr::IVROverlay_016::EGamepadTextInputMode eInputMode, vr::IVROverlay_016::EGamepadTextInputLineMode eLineInputMode, const char* pchDescription, uint32_t unCharMax, const char* pchExistingText, bool bUseMinimalMode, uint64_t uUserValue) { return fntable_Overlay_016_instance->ShowKeyboard(eInputMode, eLineInputMode, pchDescription, unCharMax, pchExistingText, bUseMinimalMode, uUserValue); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_ShowKeyboardForOverlay(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_016::EGamepadTextInputMode eInputMode, vr::IVROverlay_016::EGamepadTextInputLineMode eLineInputMode, const char* pchDescription, uint32_t unCharMax, const char* pchExistingText, bool bUseMinimalMode, uint64_t uUserValue) { return fntable_Overlay_016_instance->ShowKeyboardForOverlay(ulOverlayHandle, eInputMode, eLineInputMode, pchDescription, unCharMax, pchExistingText, bUseMinimalMode, uUserValue); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_GetKeyboardText(char* pchText, uint32_t cchText) { return fntable_Overlay_016_instance->GetKeyboardText(pchText, cchText); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_HideKeyboard() { return fntable_Overlay_016_instance->HideKeyboard(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_SetKeyboardTransformAbsolute(vr::ETrackingUniverseOrigin eTrackingOrigin, const vr::HmdMatrix34_t* pmatTrackingOriginToKeyboardTransform) { return fntable_Overlay_016_instance->SetKeyboardTransformAbsolute(eTrackingOrigin, pmatTrackingOriginToKeyboardTransform); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_SetKeyboardPositionForOverlay(vr::VROverlayHandle_t ulOverlayHandle, vr::HmdRect2_t avoidRect) { return fntable_Overlay_016_instance->SetKeyboardPositionForOverlay(ulOverlayHandle, avoidRect); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_SetOverlayIntersectionMask(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_016::VROverlayIntersectionMaskPrimitive_t* pMaskPrimitives, uint32_t unNumMaskPrimitives, uint32_t unPrimitiveSize) { return fntable_Overlay_016_instance->SetOverlayIntersectionMask(ulOverlayHandle, pMaskPrimitives, unNumMaskPrimitives, unPrimitiveSize); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_GetOverlayFlags(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* pFlags) { return fntable_Overlay_016_instance->GetOverlayFlags(ulOverlayHandle, pFlags); }
static vr::IVROverlay_016::VRMessageOverlayResponse OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_ShowMessageOverlay(const char* pchText, const char* pchCaption, const char* pchButton0Text, const char* pchButton1Text, const char* pchButton2Text, const char* pchButton3Text) { return fntable_Overlay_016_instance->ShowMessageOverlay(pchText, pchCaption, pchButton0Text, pchButton1Text, pchButton2Text, pchButton3Text); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_016_impl_CloseMessageOverlay() { return fntable_Overlay_016_instance->CloseMessageOverlay(); }
static void *fntable_Overlay_016_funcs[] = {
	(void*) fntable_Overlay_016_impl_FindOverlay,
	(void*) fntable_Overlay_016_impl_CreateOverlay,
	(void*) fntable_Overlay_016_impl_DestroyOverlay,
	(void*) fntable_Overlay_016_impl_SetHighQualityOverlay,
	(void*) fntable_Overlay_016_impl_GetHighQualityOverlay,
	(void*) fntable_Overlay_016_impl_GetOverlayKey,
	(void*) fntable_Overlay_016_impl_GetOverlayName,
	(void*) fntable_Overlay_016_impl_SetOverlayName,
	(void*) fntable_Overlay_016_impl_GetOverlayImageData,
	(void*) fntable_Overlay_016_impl_GetOverlayErrorNameFromEnum,
	(void*) fntable_Overlay_016_impl_SetOverlayRenderingPid,
	(void*) fntable_Overlay_016_impl_GetOverlayRenderingPid,
	(void*) fntable_Overlay_016_impl_SetOverlayFlag,
	(void*) fntable_Overlay_016_impl_GetOverlayFlag,
	(void*) fntable_Overlay_016_impl_SetOverlayColor,
	(void*) fntable_Overlay_016_impl_GetOverlayColor,
	(void*) fntable_Overlay_016_impl_SetOverlayAlpha,
	(void*) fntable_Overlay_016_impl_GetOverlayAlpha,
	(void*) fntable_Overlay_016_impl_SetOverlayTexelAspect,
	(void*) fntable_Overlay_016_impl_GetOverlayTexelAspect,
	(void*) fntable_Overlay_016_impl_SetOverlaySortOrder,
	(void*) fntable_Overlay_016_impl_GetOverlaySortOrder,
	(void*) fntable_Overlay_016_impl_SetOverlayWidthInMeters,
	(void*) fntable_Overlay_016_impl_GetOverlayWidthInMeters,
	(void*) fntable_Overlay_016_impl_SetOverlayAutoCurveDistanceRangeInMeters,
	(void*) fntable_Overlay_016_impl_GetOverlayAutoCurveDistanceRangeInMeters,
	(void*) fntable_Overlay_016_impl_SetOverlayTextureColorSpace,
	(void*) fntable_Overlay_016_impl_GetOverlayTextureColorSpace,
	(void*) fntable_Overlay_016_impl_SetOverlayTextureBounds,
	(void*) fntable_Overlay_016_impl_GetOverlayTextureBounds,
	(void*) fntable_Overlay_016_impl_GetOverlayRenderModel,
	(void*) fntable_Overlay_016_impl_SetOverlayRenderModel,
	(void*) fntable_Overlay_016_impl_GetOverlayTransformType,
	(void*) fntable_Overlay_016_impl_SetOverlayTransformAbsolute,
	(void*) fntable_Overlay_016_impl_GetOverlayTransformAbsolute,
	(void*) fntable_Overlay_016_impl_SetOverlayTransformTrackedDeviceRelative,
	(void*) fntable_Overlay_016_impl_GetOverlayTransformTrackedDeviceRelative,
	(void*) fntable_Overlay_016_impl_SetOverlayTransformTrackedDeviceComponent,
	(void*) fntable_Overlay_016_impl_GetOverlayTransformTrackedDeviceComponent,
	(void*) fntable_Overlay_016_impl_GetOverlayTransformOverlayRelative,
	(void*) fntable_Overlay_016_impl_SetOverlayTransformOverlayRelative,
	(void*) fntable_Overlay_016_impl_ShowOverlay,
	(void*) fntable_Overlay_016_impl_HideOverlay,
	(void*) fntable_Overlay_016_impl_IsOverlayVisible,
	(void*) fntable_Overlay_016_impl_GetTransformForOverlayCoordinates,
	(void*) fntable_Overlay_016_impl_PollNextOverlayEvent,
	(void*) fntable_Overlay_016_impl_GetOverlayInputMethod,
	(void*) fntable_Overlay_016_impl_SetOverlayInputMethod,
	(void*) fntable_Overlay_016_impl_GetOverlayMouseScale,
	(void*) fntable_Overlay_016_impl_SetOverlayMouseScale,
	(void*) fntable_Overlay_016_impl_ComputeOverlayIntersection,
	(void*) fntable_Overlay_016_impl_HandleControllerOverlayInteractionAsMouse,
	(void*) fntable_Overlay_016_impl_IsHoverTargetOverlay,
	(void*) fntable_Overlay_016_impl_GetGamepadFocusOverlay,
	(void*) fntable_Overlay_016_impl_SetGamepadFocusOverlay,
	(void*) fntable_Overlay_016_impl_SetOverlayNeighbor,
	(void*) fntable_Overlay_016_impl_MoveGamepadFocusToNeighbor,
	(void*) fntable_Overlay_016_impl_SetOverlayTexture,
	(void*) fntable_Overlay_016_impl_ClearOverlayTexture,
	(void*) fntable_Overlay_016_impl_SetOverlayRaw,
	(void*) fntable_Overlay_016_impl_SetOverlayFromFile,
	(void*) fntable_Overlay_016_impl_GetOverlayTexture,
	(void*) fntable_Overlay_016_impl_ReleaseNativeOverlayHandle,
	(void*) fntable_Overlay_016_impl_GetOverlayTextureSize,
	(void*) fntable_Overlay_016_impl_CreateDashboardOverlay,
	(void*) fntable_Overlay_016_impl_IsDashboardVisible,
	(void*) fntable_Overlay_016_impl_IsActiveDashboardOverlay,
	(void*) fntable_Overlay_016_impl_SetDashboardOverlaySceneProcess,
	(void*) fntable_Overlay_016_impl_GetDashboardOverlaySceneProcess,
	(void*) fntable_Overlay_016_impl_ShowDashboard,
	(void*) fntable_Overlay_016_impl_GetPrimaryDashboardDevice,
	(void*) fntable_Overlay_016_impl_ShowKeyboard,
	(void*) fntable_Overlay_016_impl_ShowKeyboardForOverlay,
	(void*) fntable_Overlay_016_impl_GetKeyboardText,
	(void*) fntable_Overlay_016_impl_HideKeyboard,
	(void*) fntable_Overlay_016_impl_SetKeyboardTransformAbsolute,
	(void*) fntable_Overlay_016_impl_SetKeyboardPositionForOverlay,
	(void*) fntable_Overlay_016_impl_SetOverlayIntersectionMask,
	(void*) fntable_Overlay_016_impl_GetOverlayFlags,
	(void*) fntable_Overlay_016_impl_ShowMessageOverlay,
	(void*) fntable_Overlay_016_impl_CloseMessageOverlay,
};
void** CVROverlay_016::_GetStatFuncList() { fntable_Overlay_016_instance = this; return fntable_Overlay_016_funcs; }
void CVROverlay_016::Delete() { delete this; }
// Misc for CVROverlay_017:
CVROverlay_017::CVROverlay_017() : base(GetCreateBaseOverlay()) {}
// Interface methods for CVROverlay_017:
vr::EVROverlayError CVROverlay_017::FindOverlay(const char* pchOverlayKey, vr::VROverlayHandle_t* pOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->FindOverlay(pchOverlayKey, pOverlayHandle);
}
vr::EVROverlayError CVROverlay_017::CreateOverlay(const char* pchOverlayKey, const char* pchOverlayName, vr::VROverlayHandle_t* pOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->CreateOverlay(pchOverlayKey, pchOverlayName, pOverlayHandle);
}
vr::EVROverlayError CVROverlay_017::DestroyOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->DestroyOverlay(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_017::SetHighQualityOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->SetHighQualityOverlay(ulOverlayHandle);
}
vr::VROverlayHandle_t CVROverlay_017::GetHighQualityOverlay() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->GetHighQualityOverlay();
}
uint32_t CVROverlay_017::GetOverlayKey(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::EVROverlayError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->GetOverlayKey(ulOverlayHandle, pchValue, unBufferSize, pError);
}
uint32_t CVROverlay_017::GetOverlayName(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::EVROverlayError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->GetOverlayName(ulOverlayHandle, pchValue, unBufferSize, pError);
}
vr::EVROverlayError CVROverlay_017::SetOverlayName(vr::VROverlayHandle_t ulOverlayHandle, const char* pchName) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->SetOverlayName(ulOverlayHandle, pchName);
}
vr::EVROverlayError CVROverlay_017::GetOverlayImageData(vr::VROverlayHandle_t ulOverlayHandle, void* pvBuffer, uint32_t unBufferSize, uint32_t* punWidth, uint32_t* punHeight) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->GetOverlayImageData(ulOverlayHandle, pvBuffer, unBufferSize, punWidth, punHeight);
}
const char* CVROverlay_017::GetOverlayErrorNameFromEnum(vr::EVROverlayError error) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->GetOverlayErrorNameFromEnum(error);
}
vr::EVROverlayError CVROverlay_017::SetOverlayRenderingPid(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unPID) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->SetOverlayRenderingPid(ulOverlayHandle, unPID);
}
uint32_t CVROverlay_017::GetOverlayRenderingPid(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->GetOverlayRenderingPid(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_017::SetOverlayFlag(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_017::VROverlayFlags eOverlayFlag, bool bEnabled) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->SetOverlayFlag(ulOverlayHandle, (OOVR_VROverlayFlags) eOverlayFlag, bEnabled);
}
vr::EVROverlayError CVROverlay_017::GetOverlayFlag(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_017::VROverlayFlags eOverlayFlag, bool* pbEnabled) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->GetOverlayFlag(ulOverlayHandle, (OOVR_VROverlayFlags) eOverlayFlag, pbEnabled);
}
vr::EVROverlayError CVROverlay_017::SetOverlayColor(vr::VROverlayHandle_t ulOverlayHandle, float fRed, float fGreen, float fBlue) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->SetOverlayColor(ulOverlayHandle, fRed, fGreen, fBlue);
}
vr::EVROverlayError CVROverlay_017::GetOverlayColor(vr::VROverlayHandle_t ulOverlayHandle, float* pfRed, float* pfGreen, float* pfBlue) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->GetOverlayColor(ulOverlayHandle, pfRed, pfGreen, pfBlue);
}
vr::EVROverlayError CVROverlay_017::SetOverlayAlpha(vr::VROverlayHandle_t ulOverlayHandle, float fAlpha) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->SetOverlayAlpha(ulOverlayHandle, fAlpha);
}
vr::EVROverlayError CVROverlay_017::GetOverlayAlpha(vr::VROverlayHandle_t ulOverlayHandle, float* pfAlpha) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->GetOverlayAlpha(ulOverlayHandle, pfAlpha);
}
vr::EVROverlayError CVROverlay_017::SetOverlayTexelAspect(vr::VROverlayHandle_t ulOverlayHandle, float fTexelAspect) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->SetOverlayTexelAspect(ulOverlayHandle, fTexelAspect);
}
vr::EVROverlayError CVROverlay_017::GetOverlayTexelAspect(vr::VROverlayHandle_t ulOverlayHandle, float* pfTexelAspect) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->GetOverlayTexelAspect(ulOverlayHandle, pfTexelAspect);
}
vr::EVROverlayError CVROverlay_017::SetOverlaySortOrder(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unSortOrder) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->SetOverlaySortOrder(ulOverlayHandle, unSortOrder);
}
vr::EVROverlayError CVROverlay_017::GetOverlaySortOrder(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* punSortOrder) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->GetOverlaySortOrder(ulOverlayHandle, punSortOrder);
}
vr::EVROverlayError CVROverlay_017::SetOverlayWidthInMeters(vr::VROverlayHandle_t ulOverlayHandle, float fWidthInMeters) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->SetOverlayWidthInMeters(ulOverlayHandle, fWidthInMeters);
}
vr::EVROverlayError CVROverlay_017::GetOverlayWidthInMeters(vr::VROverlayHandle_t ulOverlayHandle, float* pfWidthInMeters) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->GetOverlayWidthInMeters(ulOverlayHandle, pfWidthInMeters);
}
vr::EVROverlayError CVROverlay_017::SetOverlayAutoCurveDistanceRangeInMeters(vr::VROverlayHandle_t ulOverlayHandle, float fMinDistanceInMeters, float fMaxDistanceInMeters) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->SetOverlayAutoCurveDistanceRangeInMeters(ulOverlayHandle, fMinDistanceInMeters, fMaxDistanceInMeters);
}
vr::EVROverlayError CVROverlay_017::GetOverlayAutoCurveDistanceRangeInMeters(vr::VROverlayHandle_t ulOverlayHandle, float* pfMinDistanceInMeters, float* pfMaxDistanceInMeters) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->GetOverlayAutoCurveDistanceRangeInMeters(ulOverlayHandle, pfMinDistanceInMeters, pfMaxDistanceInMeters);
}
vr::EVROverlayError CVROverlay_017::SetOverlayTextureColorSpace(vr::VROverlayHandle_t ulOverlayHandle, vr::EColorSpace eTextureColorSpace) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->SetOverlayTextureColorSpace(ulOverlayHandle, eTextureColorSpace);
}
vr::EVROverlayError CVROverlay_017::GetOverlayTextureColorSpace(vr::VROverlayHandle_t ulOverlayHandle, vr::EColorSpace* peTextureColorSpace) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->GetOverlayTextureColorSpace(ulOverlayHandle, peTextureColorSpace);
}
vr::EVROverlayError CVROverlay_017::SetOverlayTextureBounds(vr::VROverlayHandle_t ulOverlayHandle, const vr::VRTextureBounds_t* pOverlayTextureBounds) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->SetOverlayTextureBounds(ulOverlayHandle, pOverlayTextureBounds);
}
vr::EVROverlayError CVROverlay_017::GetOverlayTextureBounds(vr::VROverlayHandle_t ulOverlayHandle, vr::VRTextureBounds_t* pOverlayTextureBounds) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->GetOverlayTextureBounds(ulOverlayHandle, pOverlayTextureBounds);
}
uint32_t CVROverlay_017::GetOverlayRenderModel(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::HmdColor_t* pColor, vr::EVROverlayError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->GetOverlayRenderModel(ulOverlayHandle, pchValue, unBufferSize, pColor, pError);
}
vr::EVROverlayError CVROverlay_017::SetOverlayRenderModel(vr::VROverlayHandle_t ulOverlayHandle, const char* pchRenderModel, const vr::HmdColor_t* pColor) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->SetOverlayRenderModel(ulOverlayHandle, pchRenderModel, pColor);
}
vr::EVROverlayError CVROverlay_017::GetOverlayTransformType(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_017::VROverlayTransformType* peTransformType) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->GetOverlayTransformType(ulOverlayHandle, (OOVR_VROverlayTransformType*) peTransformType);
}
vr::EVROverlayError CVROverlay_017::SetOverlayTransformAbsolute(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin eTrackingOrigin, const vr::HmdMatrix34_t* pmatTrackingOriginToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->SetOverlayTransformAbsolute(ulOverlayHandle, eTrackingOrigin, pmatTrackingOriginToOverlayTransform);
}
vr::EVROverlayError CVROverlay_017::GetOverlayTransformAbsolute(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin* peTrackingOrigin, vr::HmdMatrix34_t* pmatTrackingOriginToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->GetOverlayTransformAbsolute(ulOverlayHandle, peTrackingOrigin, pmatTrackingOriginToOverlayTransform);
}
vr::EVROverlayError CVROverlay_017::SetOverlayTransformTrackedDeviceRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unTrackedDevice, const vr::HmdMatrix34_t* pmatTrackedDeviceToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->SetOverlayTransformTrackedDeviceRelative(ulOverlayHandle, unTrackedDevice, pmatTrackedDeviceToOverlayTransform);
}
vr::EVROverlayError CVROverlay_017::GetOverlayTransformTrackedDeviceRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t* punTrackedDevice, vr::HmdMatrix34_t* pmatTrackedDeviceToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->GetOverlayTransformTrackedDeviceRelative(ulOverlayHandle, punTrackedDevice, pmatTrackedDeviceToOverlayTransform);
}
vr::EVROverlayError CVROverlay_017::SetOverlayTransformTrackedDeviceComponent(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unDeviceIndex, const char* pchComponentName) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->SetOverlayTransformTrackedDeviceComponent(ulOverlayHandle, unDeviceIndex, pchComponentName);
}
vr::EVROverlayError CVROverlay_017::GetOverlayTransformTrackedDeviceComponent(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t* punDeviceIndex, char* pchComponentName, uint32_t unComponentNameSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->GetOverlayTransformTrackedDeviceComponent(ulOverlayHandle, punDeviceIndex, pchComponentName, unComponentNameSize);
}
vr::EVROverlayError CVROverlay_017::GetOverlayTransformOverlayRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::VROverlayHandle_t* ulOverlayHandleParent, vr::HmdMatrix34_t* pmatParentOverlayToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->GetOverlayTransformOverlayRelative(ulOverlayHandle, ulOverlayHandleParent, pmatParentOverlayToOverlayTransform);
}
vr::EVROverlayError CVROverlay_017::SetOverlayTransformOverlayRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::VROverlayHandle_t ulOverlayHandleParent, const vr::HmdMatrix34_t* pmatParentOverlayToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->SetOverlayTransformOverlayRelative(ulOverlayHandle, ulOverlayHandleParent, pmatParentOverlayToOverlayTransform);
}
vr::EVROverlayError CVROverlay_017::ShowOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->ShowOverlay(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_017::HideOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->HideOverlay(ulOverlayHandle);
}
bool CVROverlay_017::IsOverlayVisible(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->IsOverlayVisible(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_017::GetTransformForOverlayCoordinates(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin eTrackingOrigin, vr::HmdVector2_t coordinatesInOverlay, vr::HmdMatrix34_t* pmatTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->GetTransformForOverlayCoordinates(ulOverlayHandle, eTrackingOrigin, coordinatesInOverlay, pmatTransform);
}
bool CVROverlay_017::PollNextOverlayEvent(vr::VROverlayHandle_t ulOverlayHandle, vr::VREvent_t* pEvent, uint32_t uncbVREvent) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->PollNextOverlayEvent(ulOverlayHandle, pEvent, uncbVREvent);
}
vr::EVROverlayError CVROverlay_017::GetOverlayInputMethod(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_017::VROverlayInputMethod* peInputMethod) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->GetOverlayInputMethod(ulOverlayHandle, (OOVR_VROverlayInputMethod*) peInputMethod);
}
vr::EVROverlayError CVROverlay_017::SetOverlayInputMethod(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_017::VROverlayInputMethod eInputMethod) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->SetOverlayInputMethod(ulOverlayHandle, (OOVR_VROverlayInputMethod) eInputMethod);
}
vr::EVROverlayError CVROverlay_017::GetOverlayMouseScale(vr::VROverlayHandle_t ulOverlayHandle, vr::HmdVector2_t* pvecMouseScale) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->GetOverlayMouseScale(ulOverlayHandle, pvecMouseScale);
}
vr::EVROverlayError CVROverlay_017::SetOverlayMouseScale(vr::VROverlayHandle_t ulOverlayHandle, const vr::HmdVector2_t* pvecMouseScale) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->SetOverlayMouseScale(ulOverlayHandle, pvecMouseScale);
}
bool CVROverlay_017::ComputeOverlayIntersection(vr::VROverlayHandle_t ulOverlayHandle, const vr::IVROverlay_017::VROverlayIntersectionParams_t* pParams, vr::IVROverlay_017::VROverlayIntersectionResults_t* pResults) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->ComputeOverlayIntersection(ulOverlayHandle, (const OOVR_VROverlayIntersectionParams_t*) pParams, (OOVR_VROverlayIntersectionResults_t*) pResults);
}
bool CVROverlay_017::HandleControllerOverlayInteractionAsMouse(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unControllerDeviceIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->HandleControllerOverlayInteractionAsMouse(ulOverlayHandle, unControllerDeviceIndex);
}
bool CVROverlay_017::IsHoverTargetOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->IsHoverTargetOverlay(ulOverlayHandle);
}
vr::VROverlayHandle_t CVROverlay_017::GetGamepadFocusOverlay() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->GetGamepadFocusOverlay();
}
vr::EVROverlayError CVROverlay_017::SetGamepadFocusOverlay(vr::VROverlayHandle_t ulNewFocusOverlay) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->SetGamepadFocusOverlay(ulNewFocusOverlay);
}
vr::EVROverlayError CVROverlay_017::SetOverlayNeighbor(vr::IVROverlay_017::EOverlayDirection eDirection, vr::VROverlayHandle_t ulFrom, vr::VROverlayHandle_t ulTo) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->SetOverlayNeighbor((OOVR_EOverlayDirection) eDirection, ulFrom, ulTo);
}
vr::EVROverlayError CVROverlay_017::MoveGamepadFocusToNeighbor(vr::IVROverlay_017::EOverlayDirection eDirection, vr::VROverlayHandle_t ulFrom) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->MoveGamepadFocusToNeighbor((OOVR_EOverlayDirection) eDirection, ulFrom);
}
vr::EVROverlayError CVROverlay_017::SetOverlayDualAnalogTransform(vr::VROverlayHandle_t ulOverlay, EDualAnalogWhich eWhich, const vr::HmdVector2_t& vCenter, float fRadius) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->SetOverlayDualAnalogTransform(ulOverlay, eWhich, vCenter, fRadius);
}
vr::EVROverlayError CVROverlay_017::GetOverlayDualAnalogTransform(vr::VROverlayHandle_t ulOverlay, EDualAnalogWhich eWhich, vr::HmdVector2_t* pvCenter, float* pfRadius) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->GetOverlayDualAnalogTransform(ulOverlay, eWhich, pvCenter, pfRadius);
}
vr::EVROverlayError CVROverlay_017::SetOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle, const vr::Texture_t* pTexture) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->SetOverlayTexture(ulOverlayHandle, pTexture);
}
vr::EVROverlayError CVROverlay_017::ClearOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->ClearOverlayTexture(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_017::SetOverlayRaw(vr::VROverlayHandle_t ulOverlayHandle, void* pvBuffer, uint32_t unWidth, uint32_t unHeight, uint32_t unDepth) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->SetOverlayRaw(ulOverlayHandle, pvBuffer, unWidth, unHeight, unDepth);
}
vr::EVROverlayError CVROverlay_017::SetOverlayFromFile(vr::VROverlayHandle_t ulOverlayHandle, const char* pchFilePath) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->SetOverlayFromFile(ulOverlayHandle, pchFilePath);
}
vr::EVROverlayError CVROverlay_017::GetOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle, void** pNativeTextureHandle, void* pNativeTextureRef, uint32_t* pWidth, uint32_t* pHeight, uint32_t* pNativeFormat, vr::ETextureType* pAPIType, vr::EColorSpace* pColorSpace, vr::VRTextureBounds_t* pTextureBounds) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->GetOverlayTexture(ulOverlayHandle, pNativeTextureHandle, pNativeTextureRef, pWidth, pHeight, pNativeFormat, pAPIType, pColorSpace, pTextureBounds);
}
vr::EVROverlayError CVROverlay_017::ReleaseNativeOverlayHandle(vr::VROverlayHandle_t ulOverlayHandle, void* pNativeTextureHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->ReleaseNativeOverlayHandle(ulOverlayHandle, pNativeTextureHandle);
}
vr::EVROverlayError CVROverlay_017::GetOverlayTextureSize(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* pWidth, uint32_t* pHeight) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->GetOverlayTextureSize(ulOverlayHandle, pWidth, pHeight);
}
vr::EVROverlayError CVROverlay_017::CreateDashboardOverlay(const char* pchOverlayKey, const char* pchOverlayFriendlyName, vr::VROverlayHandle_t* pMainHandle, vr::VROverlayHandle_t* pThumbnailHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->CreateDashboardOverlay(pchOverlayKey, pchOverlayFriendlyName, pMainHandle, pThumbnailHandle);
}
bool CVROverlay_017::IsDashboardVisible() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->IsDashboardVisible();
}
bool CVROverlay_017::IsActiveDashboardOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->IsActiveDashboardOverlay(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_017::SetDashboardOverlaySceneProcess(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unProcessId) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->SetDashboardOverlaySceneProcess(ulOverlayHandle, unProcessId);
}
vr::EVROverlayError CVROverlay_017::GetDashboardOverlaySceneProcess(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* punProcessId) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->GetDashboardOverlaySceneProcess(ulOverlayHandle, punProcessId);
}
void CVROverlay_017::ShowDashboard(const char* pchOverlayToShow) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->ShowDashboard(pchOverlayToShow);
}
vr::TrackedDeviceIndex_t CVROverlay_017::GetPrimaryDashboardDevice() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->GetPrimaryDashboardDevice();
}
vr::EVROverlayError CVROverlay_017::ShowKeyboard(vr::IVROverlay_017::EGamepadTextInputMode eInputMode, vr::IVROverlay_017::EGamepadTextInputLineMode eLineInputMode, const char* pchDescription, uint32_t unCharMax, const char* pchExistingText, bool bUseMinimalMode, uint64_t uUserValue) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->ShowKeyboard((OOVR_EGamepadTextInputMode) eInputMode, (OOVR_EGamepadTextInputLineMode) eLineInputMode, pchDescription, unCharMax, pchExistingText, bUseMinimalMode, uUserValue);
}
vr::EVROverlayError CVROverlay_017::ShowKeyboardForOverlay(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_017::EGamepadTextInputMode eInputMode, vr::IVROverlay_017::EGamepadTextInputLineMode eLineInputMode, const char* pchDescription, uint32_t unCharMax, const char* pchExistingText, bool bUseMinimalMode, uint64_t uUserValue) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->ShowKeyboardForOverlay(ulOverlayHandle, (OOVR_EGamepadTextInputMode) eInputMode, (OOVR_EGamepadTextInputLineMode) eLineInputMode, pchDescription, unCharMax, pchExistingText, bUseMinimalMode, uUserValue);
}
uint32_t CVROverlay_017::GetKeyboardText(char* pchText, uint32_t cchText) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->GetKeyboardText(pchText, cchText);
}
void CVROverlay_017::HideKeyboard() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->HideKeyboard();
}
void CVROverlay_017::SetKeyboardTransformAbsolute(vr::ETrackingUniverseOrigin eTrackingOrigin, const vr::HmdMatrix34_t* pmatTrackingOriginToKeyboardTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->SetKeyboardTransformAbsolute(eTrackingOrigin, pmatTrackingOriginToKeyboardTransform);
}
void CVROverlay_017::SetKeyboardPositionForOverlay(vr::VROverlayHandle_t ulOverlayHandle, vr::HmdRect2_t avoidRect) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->SetKeyboardPositionForOverlay(ulOverlayHandle, avoidRect);
}
vr::EVROverlayError CVROverlay_017::SetOverlayIntersectionMask(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_017::VROverlayIntersectionMaskPrimitive_t* pMaskPrimitives, uint32_t unNumMaskPrimitives, uint32_t unPrimitiveSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->SetOverlayIntersectionMask(ulOverlayHandle, (OOVR_VROverlayIntersectionMaskPrimitive_t*) pMaskPrimitives, unNumMaskPrimitives, unPrimitiveSize);
}
vr::EVROverlayError CVROverlay_017::GetOverlayFlags(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* pFlags) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->GetOverlayFlags(ulOverlayHandle, pFlags);
}
vr::IVROverlay_017::VRMessageOverlayResponse CVROverlay_017::ShowMessageOverlay(const char* pchText, const char* pchCaption, const char* pchButton0Text, const char* pchButton1Text, const char* pchButton2Text, const char* pchButton3Text) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return (vr::IVROverlay_017::VRMessageOverlayResponse) base->ShowMessageOverlay(pchText, pchCaption, pchButton0Text, pchButton1Text, pchButton2Text, pchButton3Text);
}
void CVROverlay_017::CloseMessageOverlay() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_017)");
	return base->CloseMessageOverlay();
}
// FnTable for CVROverlay_017:
static CVROverlay_017 *fntable_Overlay_017_instance = NULL;
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_FindOverlay(const char* pchOverlayKey, vr::VROverlayHandle_t* pOverlayHandle) { return fntable_Overlay_017_instance->FindOverlay(pchOverlayKey, pOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_CreateOverlay(const char* pchOverlayKey, const char* pchOverlayName, vr::VROverlayHandle_t* pOverlayHandle) { return fntable_Overlay_017_instance->CreateOverlay(pchOverlayKey, pchOverlayName, pOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_DestroyOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_017_instance->DestroyOverlay(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_SetHighQualityOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_017_instance->SetHighQualityOverlay(ulOverlayHandle); }
static vr::VROverlayHandle_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_GetHighQualityOverlay() { return fntable_Overlay_017_instance->GetHighQualityOverlay(); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_GetOverlayKey(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::EVROverlayError* pError) { return fntable_Overlay_017_instance->GetOverlayKey(ulOverlayHandle, pchValue, unBufferSize, pError); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_GetOverlayName(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::EVROverlayError* pError) { return fntable_Overlay_017_instance->GetOverlayName(ulOverlayHandle, pchValue, unBufferSize, pError); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_SetOverlayName(vr::VROverlayHandle_t ulOverlayHandle, const char* pchName) { return fntable_Overlay_017_instance->SetOverlayName(ulOverlayHandle, pchName); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_GetOverlayImageData(vr::VROverlayHandle_t ulOverlayHandle, void* pvBuffer, uint32_t unBufferSize, uint32_t* punWidth, uint32_t* punHeight) { return fntable_Overlay_017_instance->GetOverlayImageData(ulOverlayHandle, pvBuffer, unBufferSize, punWidth, punHeight); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_GetOverlayErrorNameFromEnum(vr::EVROverlayError error) { return fntable_Overlay_017_instance->GetOverlayErrorNameFromEnum(error); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_SetOverlayRenderingPid(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unPID) { return fntable_Overlay_017_instance->SetOverlayRenderingPid(ulOverlayHandle, unPID); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_GetOverlayRenderingPid(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_017_instance->GetOverlayRenderingPid(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_SetOverlayFlag(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_017::VROverlayFlags eOverlayFlag, bool bEnabled) { return fntable_Overlay_017_instance->SetOverlayFlag(ulOverlayHandle, eOverlayFlag, bEnabled); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_GetOverlayFlag(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_017::VROverlayFlags eOverlayFlag, bool* pbEnabled) { return fntable_Overlay_017_instance->GetOverlayFlag(ulOverlayHandle, eOverlayFlag, pbEnabled); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_SetOverlayColor(vr::VROverlayHandle_t ulOverlayHandle, float fRed, float fGreen, float fBlue) { return fntable_Overlay_017_instance->SetOverlayColor(ulOverlayHandle, fRed, fGreen, fBlue); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_GetOverlayColor(vr::VROverlayHandle_t ulOverlayHandle, float* pfRed, float* pfGreen, float* pfBlue) { return fntable_Overlay_017_instance->GetOverlayColor(ulOverlayHandle, pfRed, pfGreen, pfBlue); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_SetOverlayAlpha(vr::VROverlayHandle_t ulOverlayHandle, float fAlpha) { return fntable_Overlay_017_instance->SetOverlayAlpha(ulOverlayHandle, fAlpha); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_GetOverlayAlpha(vr::VROverlayHandle_t ulOverlayHandle, float* pfAlpha) { return fntable_Overlay_017_instance->GetOverlayAlpha(ulOverlayHandle, pfAlpha); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_SetOverlayTexelAspect(vr::VROverlayHandle_t ulOverlayHandle, float fTexelAspect) { return fntable_Overlay_017_instance->SetOverlayTexelAspect(ulOverlayHandle, fTexelAspect); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_GetOverlayTexelAspect(vr::VROverlayHandle_t ulOverlayHandle, float* pfTexelAspect) { return fntable_Overlay_017_instance->GetOverlayTexelAspect(ulOverlayHandle, pfTexelAspect); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_SetOverlaySortOrder(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unSortOrder) { return fntable_Overlay_017_instance->SetOverlaySortOrder(ulOverlayHandle, unSortOrder); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_GetOverlaySortOrder(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* punSortOrder) { return fntable_Overlay_017_instance->GetOverlaySortOrder(ulOverlayHandle, punSortOrder); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_SetOverlayWidthInMeters(vr::VROverlayHandle_t ulOverlayHandle, float fWidthInMeters) { return fntable_Overlay_017_instance->SetOverlayWidthInMeters(ulOverlayHandle, fWidthInMeters); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_GetOverlayWidthInMeters(vr::VROverlayHandle_t ulOverlayHandle, float* pfWidthInMeters) { return fntable_Overlay_017_instance->GetOverlayWidthInMeters(ulOverlayHandle, pfWidthInMeters); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_SetOverlayAutoCurveDistanceRangeInMeters(vr::VROverlayHandle_t ulOverlayHandle, float fMinDistanceInMeters, float fMaxDistanceInMeters) { return fntable_Overlay_017_instance->SetOverlayAutoCurveDistanceRangeInMeters(ulOverlayHandle, fMinDistanceInMeters, fMaxDistanceInMeters); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_GetOverlayAutoCurveDistanceRangeInMeters(vr::VROverlayHandle_t ulOverlayHandle, float* pfMinDistanceInMeters, float* pfMaxDistanceInMeters) { return fntable_Overlay_017_instance->GetOverlayAutoCurveDistanceRangeInMeters(ulOverlayHandle, pfMinDistanceInMeters, pfMaxDistanceInMeters); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_SetOverlayTextureColorSpace(vr::VROverlayHandle_t ulOverlayHandle, vr::EColorSpace eTextureColorSpace) { return fntable_Overlay_017_instance->SetOverlayTextureColorSpace(ulOverlayHandle, eTextureColorSpace); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_GetOverlayTextureColorSpace(vr::VROverlayHandle_t ulOverlayHandle, vr::EColorSpace* peTextureColorSpace) { return fntable_Overlay_017_instance->GetOverlayTextureColorSpace(ulOverlayHandle, peTextureColorSpace); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_SetOverlayTextureBounds(vr::VROverlayHandle_t ulOverlayHandle, const vr::VRTextureBounds_t* pOverlayTextureBounds) { return fntable_Overlay_017_instance->SetOverlayTextureBounds(ulOverlayHandle, pOverlayTextureBounds); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_GetOverlayTextureBounds(vr::VROverlayHandle_t ulOverlayHandle, vr::VRTextureBounds_t* pOverlayTextureBounds) { return fntable_Overlay_017_instance->GetOverlayTextureBounds(ulOverlayHandle, pOverlayTextureBounds); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_GetOverlayRenderModel(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::HmdColor_t* pColor, vr::EVROverlayError* pError) { return fntable_Overlay_017_instance->GetOverlayRenderModel(ulOverlayHandle, pchValue, unBufferSize, pColor, pError); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_SetOverlayRenderModel(vr::VROverlayHandle_t ulOverlayHandle, const char* pchRenderModel, const vr::HmdColor_t* pColor) { return fntable_Overlay_017_instance->SetOverlayRenderModel(ulOverlayHandle, pchRenderModel, pColor); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_GetOverlayTransformType(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_017::VROverlayTransformType* peTransformType) { return fntable_Overlay_017_instance->GetOverlayTransformType(ulOverlayHandle, peTransformType); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_SetOverlayTransformAbsolute(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin eTrackingOrigin, const vr::HmdMatrix34_t* pmatTrackingOriginToOverlayTransform) { return fntable_Overlay_017_instance->SetOverlayTransformAbsolute(ulOverlayHandle, eTrackingOrigin, pmatTrackingOriginToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_GetOverlayTransformAbsolute(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin* peTrackingOrigin, vr::HmdMatrix34_t* pmatTrackingOriginToOverlayTransform) { return fntable_Overlay_017_instance->GetOverlayTransformAbsolute(ulOverlayHandle, peTrackingOrigin, pmatTrackingOriginToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_SetOverlayTransformTrackedDeviceRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unTrackedDevice, const vr::HmdMatrix34_t* pmatTrackedDeviceToOverlayTransform) { return fntable_Overlay_017_instance->SetOverlayTransformTrackedDeviceRelative(ulOverlayHandle, unTrackedDevice, pmatTrackedDeviceToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_GetOverlayTransformTrackedDeviceRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t* punTrackedDevice, vr::HmdMatrix34_t* pmatTrackedDeviceToOverlayTransform) { return fntable_Overlay_017_instance->GetOverlayTransformTrackedDeviceRelative(ulOverlayHandle, punTrackedDevice, pmatTrackedDeviceToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_SetOverlayTransformTrackedDeviceComponent(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unDeviceIndex, const char* pchComponentName) { return fntable_Overlay_017_instance->SetOverlayTransformTrackedDeviceComponent(ulOverlayHandle, unDeviceIndex, pchComponentName); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_GetOverlayTransformTrackedDeviceComponent(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t* punDeviceIndex, char* pchComponentName, uint32_t unComponentNameSize) { return fntable_Overlay_017_instance->GetOverlayTransformTrackedDeviceComponent(ulOverlayHandle, punDeviceIndex, pchComponentName, unComponentNameSize); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_GetOverlayTransformOverlayRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::VROverlayHandle_t* ulOverlayHandleParent, vr::HmdMatrix34_t* pmatParentOverlayToOverlayTransform) { return fntable_Overlay_017_instance->GetOverlayTransformOverlayRelative(ulOverlayHandle, ulOverlayHandleParent, pmatParentOverlayToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_SetOverlayTransformOverlayRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::VROverlayHandle_t ulOverlayHandleParent, const vr::HmdMatrix34_t* pmatParentOverlayToOverlayTransform) { return fntable_Overlay_017_instance->SetOverlayTransformOverlayRelative(ulOverlayHandle, ulOverlayHandleParent, pmatParentOverlayToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_ShowOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_017_instance->ShowOverlay(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_HideOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_017_instance->HideOverlay(ulOverlayHandle); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_IsOverlayVisible(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_017_instance->IsOverlayVisible(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_GetTransformForOverlayCoordinates(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin eTrackingOrigin, vr::HmdVector2_t coordinatesInOverlay, vr::HmdMatrix34_t* pmatTransform) { return fntable_Overlay_017_instance->GetTransformForOverlayCoordinates(ulOverlayHandle, eTrackingOrigin, coordinatesInOverlay, pmatTransform); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_PollNextOverlayEvent(vr::VROverlayHandle_t ulOverlayHandle, vr::VREvent_t* pEvent, uint32_t uncbVREvent) { return fntable_Overlay_017_instance->PollNextOverlayEvent(ulOverlayHandle, pEvent, uncbVREvent); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_GetOverlayInputMethod(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_017::VROverlayInputMethod* peInputMethod) { return fntable_Overlay_017_instance->GetOverlayInputMethod(ulOverlayHandle, peInputMethod); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_SetOverlayInputMethod(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_017::VROverlayInputMethod eInputMethod) { return fntable_Overlay_017_instance->SetOverlayInputMethod(ulOverlayHandle, eInputMethod); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_GetOverlayMouseScale(vr::VROverlayHandle_t ulOverlayHandle, vr::HmdVector2_t* pvecMouseScale) { return fntable_Overlay_017_instance->GetOverlayMouseScale(ulOverlayHandle, pvecMouseScale); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_SetOverlayMouseScale(vr::VROverlayHandle_t ulOverlayHandle, const vr::HmdVector2_t* pvecMouseScale) { return fntable_Overlay_017_instance->SetOverlayMouseScale(ulOverlayHandle, pvecMouseScale); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_ComputeOverlayIntersection(vr::VROverlayHandle_t ulOverlayHandle, const vr::IVROverlay_017::VROverlayIntersectionParams_t* pParams, vr::IVROverlay_017::VROverlayIntersectionResults_t* pResults) { return fntable_Overlay_017_instance->ComputeOverlayIntersection(ulOverlayHandle, pParams, pResults); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_HandleControllerOverlayInteractionAsMouse(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unControllerDeviceIndex) { return fntable_Overlay_017_instance->HandleControllerOverlayInteractionAsMouse(ulOverlayHandle, unControllerDeviceIndex); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_IsHoverTargetOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_017_instance->IsHoverTargetOverlay(ulOverlayHandle); }
static vr::VROverlayHandle_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_GetGamepadFocusOverlay() { return fntable_Overlay_017_instance->GetGamepadFocusOverlay(); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_SetGamepadFocusOverlay(vr::VROverlayHandle_t ulNewFocusOverlay) { return fntable_Overlay_017_instance->SetGamepadFocusOverlay(ulNewFocusOverlay); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_SetOverlayNeighbor(vr::IVROverlay_017::EOverlayDirection eDirection, vr::VROverlayHandle_t ulFrom, vr::VROverlayHandle_t ulTo) { return fntable_Overlay_017_instance->SetOverlayNeighbor(eDirection, ulFrom, ulTo); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_MoveGamepadFocusToNeighbor(vr::IVROverlay_017::EOverlayDirection eDirection, vr::VROverlayHandle_t ulFrom) { return fntable_Overlay_017_instance->MoveGamepadFocusToNeighbor(eDirection, ulFrom); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_SetOverlayDualAnalogTransform(vr::VROverlayHandle_t ulOverlay, EDualAnalogWhich eWhich, const vr::HmdVector2_t& vCenter, float fRadius) { return fntable_Overlay_017_instance->SetOverlayDualAnalogTransform(ulOverlay, eWhich, vCenter, fRadius); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_GetOverlayDualAnalogTransform(vr::VROverlayHandle_t ulOverlay, EDualAnalogWhich eWhich, vr::HmdVector2_t* pvCenter, float* pfRadius) { return fntable_Overlay_017_instance->GetOverlayDualAnalogTransform(ulOverlay, eWhich, pvCenter, pfRadius); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_SetOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle, const vr::Texture_t* pTexture) { return fntable_Overlay_017_instance->SetOverlayTexture(ulOverlayHandle, pTexture); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_ClearOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_017_instance->ClearOverlayTexture(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_SetOverlayRaw(vr::VROverlayHandle_t ulOverlayHandle, void* pvBuffer, uint32_t unWidth, uint32_t unHeight, uint32_t unDepth) { return fntable_Overlay_017_instance->SetOverlayRaw(ulOverlayHandle, pvBuffer, unWidth, unHeight, unDepth); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_SetOverlayFromFile(vr::VROverlayHandle_t ulOverlayHandle, const char* pchFilePath) { return fntable_Overlay_017_instance->SetOverlayFromFile(ulOverlayHandle, pchFilePath); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_GetOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle, void** pNativeTextureHandle, void* pNativeTextureRef, uint32_t* pWidth, uint32_t* pHeight, uint32_t* pNativeFormat, vr::ETextureType* pAPIType, vr::EColorSpace* pColorSpace, vr::VRTextureBounds_t* pTextureBounds) { return fntable_Overlay_017_instance->GetOverlayTexture(ulOverlayHandle, pNativeTextureHandle, pNativeTextureRef, pWidth, pHeight, pNativeFormat, pAPIType, pColorSpace, pTextureBounds); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_ReleaseNativeOverlayHandle(vr::VROverlayHandle_t ulOverlayHandle, void* pNativeTextureHandle) { return fntable_Overlay_017_instance->ReleaseNativeOverlayHandle(ulOverlayHandle, pNativeTextureHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_GetOverlayTextureSize(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* pWidth, uint32_t* pHeight) { return fntable_Overlay_017_instance->GetOverlayTextureSize(ulOverlayHandle, pWidth, pHeight); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_CreateDashboardOverlay(const char* pchOverlayKey, const char* pchOverlayFriendlyName, vr::VROverlayHandle_t* pMainHandle, vr::VROverlayHandle_t* pThumbnailHandle) { return fntable_Overlay_017_instance->CreateDashboardOverlay(pchOverlayKey, pchOverlayFriendlyName, pMainHandle, pThumbnailHandle); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_IsDashboardVisible() { return fntable_Overlay_017_instance->IsDashboardVisible(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_IsActiveDashboardOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_017_instance->IsActiveDashboardOverlay(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_SetDashboardOverlaySceneProcess(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unProcessId) { return fntable_Overlay_017_instance->SetDashboardOverlaySceneProcess(ulOverlayHandle, unProcessId); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_GetDashboardOverlaySceneProcess(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* punProcessId) { return fntable_Overlay_017_instance->GetDashboardOverlaySceneProcess(ulOverlayHandle, punProcessId); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_ShowDashboard(const char* pchOverlayToShow) { return fntable_Overlay_017_instance->ShowDashboard(pchOverlayToShow); }
static vr::TrackedDeviceIndex_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_GetPrimaryDashboardDevice() { return fntable_Overlay_017_instance->GetPrimaryDashboardDevice(); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_ShowKeyboard(vr::IVROverlay_017::EGamepadTextInputMode eInputMode, vr::IVROverlay_017::EGamepadTextInputLineMode eLineInputMode, const char* pchDescription, uint32_t unCharMax, const char* pchExistingText, bool bUseMinimalMode, uint64_t uUserValue) { return fntable_Overlay_017_instance->ShowKeyboard(eInputMode, eLineInputMode, pchDescription, unCharMax, pchExistingText, bUseMinimalMode, uUserValue); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_ShowKeyboardForOverlay(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_017::EGamepadTextInputMode eInputMode, vr::IVROverlay_017::EGamepadTextInputLineMode eLineInputMode, const char* pchDescription, uint32_t unCharMax, const char* pchExistingText, bool bUseMinimalMode, uint64_t uUserValue) { return fntable_Overlay_017_instance->ShowKeyboardForOverlay(ulOverlayHandle, eInputMode, eLineInputMode, pchDescription, unCharMax, pchExistingText, bUseMinimalMode, uUserValue); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_GetKeyboardText(char* pchText, uint32_t cchText) { return fntable_Overlay_017_instance->GetKeyboardText(pchText, cchText); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_HideKeyboard() { return fntable_Overlay_017_instance->HideKeyboard(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_SetKeyboardTransformAbsolute(vr::ETrackingUniverseOrigin eTrackingOrigin, const vr::HmdMatrix34_t* pmatTrackingOriginToKeyboardTransform) { return fntable_Overlay_017_instance->SetKeyboardTransformAbsolute(eTrackingOrigin, pmatTrackingOriginToKeyboardTransform); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_SetKeyboardPositionForOverlay(vr::VROverlayHandle_t ulOverlayHandle, vr::HmdRect2_t avoidRect) { return fntable_Overlay_017_instance->SetKeyboardPositionForOverlay(ulOverlayHandle, avoidRect); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_SetOverlayIntersectionMask(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_017::VROverlayIntersectionMaskPrimitive_t* pMaskPrimitives, uint32_t unNumMaskPrimitives, uint32_t unPrimitiveSize) { return fntable_Overlay_017_instance->SetOverlayIntersectionMask(ulOverlayHandle, pMaskPrimitives, unNumMaskPrimitives, unPrimitiveSize); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_GetOverlayFlags(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* pFlags) { return fntable_Overlay_017_instance->GetOverlayFlags(ulOverlayHandle, pFlags); }
static vr::IVROverlay_017::VRMessageOverlayResponse OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_ShowMessageOverlay(const char* pchText, const char* pchCaption, const char* pchButton0Text, const char* pchButton1Text, const char* pchButton2Text, const char* pchButton3Text) { return fntable_Overlay_017_instance->ShowMessageOverlay(pchText, pchCaption, pchButton0Text, pchButton1Text, pchButton2Text, pchButton3Text); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_017_impl_CloseMessageOverlay() { return fntable_Overlay_017_instance->CloseMessageOverlay(); }
static void *fntable_Overlay_017_funcs[] = {
	(void*) fntable_Overlay_017_impl_FindOverlay,
	(void*) fntable_Overlay_017_impl_CreateOverlay,
	(void*) fntable_Overlay_017_impl_DestroyOverlay,
	(void*) fntable_Overlay_017_impl_SetHighQualityOverlay,
	(void*) fntable_Overlay_017_impl_GetHighQualityOverlay,
	(void*) fntable_Overlay_017_impl_GetOverlayKey,
	(void*) fntable_Overlay_017_impl_GetOverlayName,
	(void*) fntable_Overlay_017_impl_SetOverlayName,
	(void*) fntable_Overlay_017_impl_GetOverlayImageData,
	(void*) fntable_Overlay_017_impl_GetOverlayErrorNameFromEnum,
	(void*) fntable_Overlay_017_impl_SetOverlayRenderingPid,
	(void*) fntable_Overlay_017_impl_GetOverlayRenderingPid,
	(void*) fntable_Overlay_017_impl_SetOverlayFlag,
	(void*) fntable_Overlay_017_impl_GetOverlayFlag,
	(void*) fntable_Overlay_017_impl_SetOverlayColor,
	(void*) fntable_Overlay_017_impl_GetOverlayColor,
	(void*) fntable_Overlay_017_impl_SetOverlayAlpha,
	(void*) fntable_Overlay_017_impl_GetOverlayAlpha,
	(void*) fntable_Overlay_017_impl_SetOverlayTexelAspect,
	(void*) fntable_Overlay_017_impl_GetOverlayTexelAspect,
	(void*) fntable_Overlay_017_impl_SetOverlaySortOrder,
	(void*) fntable_Overlay_017_impl_GetOverlaySortOrder,
	(void*) fntable_Overlay_017_impl_SetOverlayWidthInMeters,
	(void*) fntable_Overlay_017_impl_GetOverlayWidthInMeters,
	(void*) fntable_Overlay_017_impl_SetOverlayAutoCurveDistanceRangeInMeters,
	(void*) fntable_Overlay_017_impl_GetOverlayAutoCurveDistanceRangeInMeters,
	(void*) fntable_Overlay_017_impl_SetOverlayTextureColorSpace,
	(void*) fntable_Overlay_017_impl_GetOverlayTextureColorSpace,
	(void*) fntable_Overlay_017_impl_SetOverlayTextureBounds,
	(void*) fntable_Overlay_017_impl_GetOverlayTextureBounds,
	(void*) fntable_Overlay_017_impl_GetOverlayRenderModel,
	(void*) fntable_Overlay_017_impl_SetOverlayRenderModel,
	(void*) fntable_Overlay_017_impl_GetOverlayTransformType,
	(void*) fntable_Overlay_017_impl_SetOverlayTransformAbsolute,
	(void*) fntable_Overlay_017_impl_GetOverlayTransformAbsolute,
	(void*) fntable_Overlay_017_impl_SetOverlayTransformTrackedDeviceRelative,
	(void*) fntable_Overlay_017_impl_GetOverlayTransformTrackedDeviceRelative,
	(void*) fntable_Overlay_017_impl_SetOverlayTransformTrackedDeviceComponent,
	(void*) fntable_Overlay_017_impl_GetOverlayTransformTrackedDeviceComponent,
	(void*) fntable_Overlay_017_impl_GetOverlayTransformOverlayRelative,
	(void*) fntable_Overlay_017_impl_SetOverlayTransformOverlayRelative,
	(void*) fntable_Overlay_017_impl_ShowOverlay,
	(void*) fntable_Overlay_017_impl_HideOverlay,
	(void*) fntable_Overlay_017_impl_IsOverlayVisible,
	(void*) fntable_Overlay_017_impl_GetTransformForOverlayCoordinates,
	(void*) fntable_Overlay_017_impl_PollNextOverlayEvent,
	(void*) fntable_Overlay_017_impl_GetOverlayInputMethod,
	(void*) fntable_Overlay_017_impl_SetOverlayInputMethod,
	(void*) fntable_Overlay_017_impl_GetOverlayMouseScale,
	(void*) fntable_Overlay_017_impl_SetOverlayMouseScale,
	(void*) fntable_Overlay_017_impl_ComputeOverlayIntersection,
	(void*) fntable_Overlay_017_impl_HandleControllerOverlayInteractionAsMouse,
	(void*) fntable_Overlay_017_impl_IsHoverTargetOverlay,
	(void*) fntable_Overlay_017_impl_GetGamepadFocusOverlay,
	(void*) fntable_Overlay_017_impl_SetGamepadFocusOverlay,
	(void*) fntable_Overlay_017_impl_SetOverlayNeighbor,
	(void*) fntable_Overlay_017_impl_MoveGamepadFocusToNeighbor,
	(void*) fntable_Overlay_017_impl_SetOverlayDualAnalogTransform,
	(void*) fntable_Overlay_017_impl_GetOverlayDualAnalogTransform,
	(void*) fntable_Overlay_017_impl_SetOverlayTexture,
	(void*) fntable_Overlay_017_impl_ClearOverlayTexture,
	(void*) fntable_Overlay_017_impl_SetOverlayRaw,
	(void*) fntable_Overlay_017_impl_SetOverlayFromFile,
	(void*) fntable_Overlay_017_impl_GetOverlayTexture,
	(void*) fntable_Overlay_017_impl_ReleaseNativeOverlayHandle,
	(void*) fntable_Overlay_017_impl_GetOverlayTextureSize,
	(void*) fntable_Overlay_017_impl_CreateDashboardOverlay,
	(void*) fntable_Overlay_017_impl_IsDashboardVisible,
	(void*) fntable_Overlay_017_impl_IsActiveDashboardOverlay,
	(void*) fntable_Overlay_017_impl_SetDashboardOverlaySceneProcess,
	(void*) fntable_Overlay_017_impl_GetDashboardOverlaySceneProcess,
	(void*) fntable_Overlay_017_impl_ShowDashboard,
	(void*) fntable_Overlay_017_impl_GetPrimaryDashboardDevice,
	(void*) fntable_Overlay_017_impl_ShowKeyboard,
	(void*) fntable_Overlay_017_impl_ShowKeyboardForOverlay,
	(void*) fntable_Overlay_017_impl_GetKeyboardText,
	(void*) fntable_Overlay_017_impl_HideKeyboard,
	(void*) fntable_Overlay_017_impl_SetKeyboardTransformAbsolute,
	(void*) fntable_Overlay_017_impl_SetKeyboardPositionForOverlay,
	(void*) fntable_Overlay_017_impl_SetOverlayIntersectionMask,
	(void*) fntable_Overlay_017_impl_GetOverlayFlags,
	(void*) fntable_Overlay_017_impl_ShowMessageOverlay,
	(void*) fntable_Overlay_017_impl_CloseMessageOverlay,
};
void** CVROverlay_017::_GetStatFuncList() { fntable_Overlay_017_instance = this; return fntable_Overlay_017_funcs; }
void CVROverlay_017::Delete() { delete this; }
// Misc for CVROverlay_018:
CVROverlay_018::CVROverlay_018() : base(GetCreateBaseOverlay()) {}
// Interface methods for CVROverlay_018:
vr::EVROverlayError CVROverlay_018::FindOverlay(const char* pchOverlayKey, vr::VROverlayHandle_t* pOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->FindOverlay(pchOverlayKey, pOverlayHandle);
}
vr::EVROverlayError CVROverlay_018::CreateOverlay(const char* pchOverlayKey, const char* pchOverlayName, vr::VROverlayHandle_t* pOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->CreateOverlay(pchOverlayKey, pchOverlayName, pOverlayHandle);
}
vr::EVROverlayError CVROverlay_018::DestroyOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->DestroyOverlay(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_018::SetHighQualityOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->SetHighQualityOverlay(ulOverlayHandle);
}
vr::VROverlayHandle_t CVROverlay_018::GetHighQualityOverlay() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->GetHighQualityOverlay();
}
uint32_t CVROverlay_018::GetOverlayKey(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::EVROverlayError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->GetOverlayKey(ulOverlayHandle, pchValue, unBufferSize, pError);
}
uint32_t CVROverlay_018::GetOverlayName(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::EVROverlayError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->GetOverlayName(ulOverlayHandle, pchValue, unBufferSize, pError);
}
vr::EVROverlayError CVROverlay_018::SetOverlayName(vr::VROverlayHandle_t ulOverlayHandle, const char* pchName) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->SetOverlayName(ulOverlayHandle, pchName);
}
vr::EVROverlayError CVROverlay_018::GetOverlayImageData(vr::VROverlayHandle_t ulOverlayHandle, void* pvBuffer, uint32_t unBufferSize, uint32_t* punWidth, uint32_t* punHeight) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->GetOverlayImageData(ulOverlayHandle, pvBuffer, unBufferSize, punWidth, punHeight);
}
const char* CVROverlay_018::GetOverlayErrorNameFromEnum(vr::EVROverlayError error) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->GetOverlayErrorNameFromEnum(error);
}
vr::EVROverlayError CVROverlay_018::SetOverlayRenderingPid(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unPID) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->SetOverlayRenderingPid(ulOverlayHandle, unPID);
}
uint32_t CVROverlay_018::GetOverlayRenderingPid(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->GetOverlayRenderingPid(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_018::SetOverlayFlag(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_018::VROverlayFlags eOverlayFlag, bool bEnabled) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->SetOverlayFlag(ulOverlayHandle, (OOVR_VROverlayFlags) eOverlayFlag, bEnabled);
}
vr::EVROverlayError CVROverlay_018::GetOverlayFlag(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_018::VROverlayFlags eOverlayFlag, bool* pbEnabled) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->GetOverlayFlag(ulOverlayHandle, (OOVR_VROverlayFlags) eOverlayFlag, pbEnabled);
}
vr::EVROverlayError CVROverlay_018::SetOverlayColor(vr::VROverlayHandle_t ulOverlayHandle, float fRed, float fGreen, float fBlue) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->SetOverlayColor(ulOverlayHandle, fRed, fGreen, fBlue);
}
vr::EVROverlayError CVROverlay_018::GetOverlayColor(vr::VROverlayHandle_t ulOverlayHandle, float* pfRed, float* pfGreen, float* pfBlue) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->GetOverlayColor(ulOverlayHandle, pfRed, pfGreen, pfBlue);
}
vr::EVROverlayError CVROverlay_018::SetOverlayAlpha(vr::VROverlayHandle_t ulOverlayHandle, float fAlpha) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->SetOverlayAlpha(ulOverlayHandle, fAlpha);
}
vr::EVROverlayError CVROverlay_018::GetOverlayAlpha(vr::VROverlayHandle_t ulOverlayHandle, float* pfAlpha) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->GetOverlayAlpha(ulOverlayHandle, pfAlpha);
}
vr::EVROverlayError CVROverlay_018::SetOverlayTexelAspect(vr::VROverlayHandle_t ulOverlayHandle, float fTexelAspect) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->SetOverlayTexelAspect(ulOverlayHandle, fTexelAspect);
}
vr::EVROverlayError CVROverlay_018::GetOverlayTexelAspect(vr::VROverlayHandle_t ulOverlayHandle, float* pfTexelAspect) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->GetOverlayTexelAspect(ulOverlayHandle, pfTexelAspect);
}
vr::EVROverlayError CVROverlay_018::SetOverlaySortOrder(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unSortOrder) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->SetOverlaySortOrder(ulOverlayHandle, unSortOrder);
}
vr::EVROverlayError CVROverlay_018::GetOverlaySortOrder(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* punSortOrder) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->GetOverlaySortOrder(ulOverlayHandle, punSortOrder);
}
vr::EVROverlayError CVROverlay_018::SetOverlayWidthInMeters(vr::VROverlayHandle_t ulOverlayHandle, float fWidthInMeters) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->SetOverlayWidthInMeters(ulOverlayHandle, fWidthInMeters);
}
vr::EVROverlayError CVROverlay_018::GetOverlayWidthInMeters(vr::VROverlayHandle_t ulOverlayHandle, float* pfWidthInMeters) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->GetOverlayWidthInMeters(ulOverlayHandle, pfWidthInMeters);
}
vr::EVROverlayError CVROverlay_018::SetOverlayAutoCurveDistanceRangeInMeters(vr::VROverlayHandle_t ulOverlayHandle, float fMinDistanceInMeters, float fMaxDistanceInMeters) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->SetOverlayAutoCurveDistanceRangeInMeters(ulOverlayHandle, fMinDistanceInMeters, fMaxDistanceInMeters);
}
vr::EVROverlayError CVROverlay_018::GetOverlayAutoCurveDistanceRangeInMeters(vr::VROverlayHandle_t ulOverlayHandle, float* pfMinDistanceInMeters, float* pfMaxDistanceInMeters) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->GetOverlayAutoCurveDistanceRangeInMeters(ulOverlayHandle, pfMinDistanceInMeters, pfMaxDistanceInMeters);
}
vr::EVROverlayError CVROverlay_018::SetOverlayTextureColorSpace(vr::VROverlayHandle_t ulOverlayHandle, vr::EColorSpace eTextureColorSpace) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->SetOverlayTextureColorSpace(ulOverlayHandle, eTextureColorSpace);
}
vr::EVROverlayError CVROverlay_018::GetOverlayTextureColorSpace(vr::VROverlayHandle_t ulOverlayHandle, vr::EColorSpace* peTextureColorSpace) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->GetOverlayTextureColorSpace(ulOverlayHandle, peTextureColorSpace);
}
vr::EVROverlayError CVROverlay_018::SetOverlayTextureBounds(vr::VROverlayHandle_t ulOverlayHandle, const vr::VRTextureBounds_t* pOverlayTextureBounds) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->SetOverlayTextureBounds(ulOverlayHandle, pOverlayTextureBounds);
}
vr::EVROverlayError CVROverlay_018::GetOverlayTextureBounds(vr::VROverlayHandle_t ulOverlayHandle, vr::VRTextureBounds_t* pOverlayTextureBounds) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->GetOverlayTextureBounds(ulOverlayHandle, pOverlayTextureBounds);
}
uint32_t CVROverlay_018::GetOverlayRenderModel(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::HmdColor_t* pColor, vr::EVROverlayError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->GetOverlayRenderModel(ulOverlayHandle, pchValue, unBufferSize, pColor, pError);
}
vr::EVROverlayError CVROverlay_018::SetOverlayRenderModel(vr::VROverlayHandle_t ulOverlayHandle, const char* pchRenderModel, const vr::HmdColor_t* pColor) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->SetOverlayRenderModel(ulOverlayHandle, pchRenderModel, pColor);
}
vr::EVROverlayError CVROverlay_018::GetOverlayTransformType(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_018::VROverlayTransformType* peTransformType) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->GetOverlayTransformType(ulOverlayHandle, (OOVR_VROverlayTransformType*) peTransformType);
}
vr::EVROverlayError CVROverlay_018::SetOverlayTransformAbsolute(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin eTrackingOrigin, const vr::HmdMatrix34_t* pmatTrackingOriginToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->SetOverlayTransformAbsolute(ulOverlayHandle, eTrackingOrigin, pmatTrackingOriginToOverlayTransform);
}
vr::EVROverlayError CVROverlay_018::GetOverlayTransformAbsolute(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin* peTrackingOrigin, vr::HmdMatrix34_t* pmatTrackingOriginToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->GetOverlayTransformAbsolute(ulOverlayHandle, peTrackingOrigin, pmatTrackingOriginToOverlayTransform);
}
vr::EVROverlayError CVROverlay_018::SetOverlayTransformTrackedDeviceRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unTrackedDevice, const vr::HmdMatrix34_t* pmatTrackedDeviceToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->SetOverlayTransformTrackedDeviceRelative(ulOverlayHandle, unTrackedDevice, pmatTrackedDeviceToOverlayTransform);
}
vr::EVROverlayError CVROverlay_018::GetOverlayTransformTrackedDeviceRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t* punTrackedDevice, vr::HmdMatrix34_t* pmatTrackedDeviceToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->GetOverlayTransformTrackedDeviceRelative(ulOverlayHandle, punTrackedDevice, pmatTrackedDeviceToOverlayTransform);
}
vr::EVROverlayError CVROverlay_018::SetOverlayTransformTrackedDeviceComponent(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unDeviceIndex, const char* pchComponentName) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->SetOverlayTransformTrackedDeviceComponent(ulOverlayHandle, unDeviceIndex, pchComponentName);
}
vr::EVROverlayError CVROverlay_018::GetOverlayTransformTrackedDeviceComponent(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t* punDeviceIndex, char* pchComponentName, uint32_t unComponentNameSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->GetOverlayTransformTrackedDeviceComponent(ulOverlayHandle, punDeviceIndex, pchComponentName, unComponentNameSize);
}
vr::EVROverlayError CVROverlay_018::GetOverlayTransformOverlayRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::VROverlayHandle_t* ulOverlayHandleParent, vr::HmdMatrix34_t* pmatParentOverlayToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->GetOverlayTransformOverlayRelative(ulOverlayHandle, ulOverlayHandleParent, pmatParentOverlayToOverlayTransform);
}
vr::EVROverlayError CVROverlay_018::SetOverlayTransformOverlayRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::VROverlayHandle_t ulOverlayHandleParent, const vr::HmdMatrix34_t* pmatParentOverlayToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->SetOverlayTransformOverlayRelative(ulOverlayHandle, ulOverlayHandleParent, pmatParentOverlayToOverlayTransform);
}
vr::EVROverlayError CVROverlay_018::ShowOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->ShowOverlay(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_018::HideOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->HideOverlay(ulOverlayHandle);
}
bool CVROverlay_018::IsOverlayVisible(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->IsOverlayVisible(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_018::GetTransformForOverlayCoordinates(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin eTrackingOrigin, vr::HmdVector2_t coordinatesInOverlay, vr::HmdMatrix34_t* pmatTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->GetTransformForOverlayCoordinates(ulOverlayHandle, eTrackingOrigin, coordinatesInOverlay, pmatTransform);
}
bool CVROverlay_018::PollNextOverlayEvent(vr::VROverlayHandle_t ulOverlayHandle, vr::VREvent_t* pEvent, uint32_t uncbVREvent) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->PollNextOverlayEvent(ulOverlayHandle, pEvent, uncbVREvent);
}
vr::EVROverlayError CVROverlay_018::GetOverlayInputMethod(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_018::VROverlayInputMethod* peInputMethod) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->GetOverlayInputMethod(ulOverlayHandle, (OOVR_VROverlayInputMethod*) peInputMethod);
}
vr::EVROverlayError CVROverlay_018::SetOverlayInputMethod(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_018::VROverlayInputMethod eInputMethod) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->SetOverlayInputMethod(ulOverlayHandle, (OOVR_VROverlayInputMethod) eInputMethod);
}
vr::EVROverlayError CVROverlay_018::GetOverlayMouseScale(vr::VROverlayHandle_t ulOverlayHandle, vr::HmdVector2_t* pvecMouseScale) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->GetOverlayMouseScale(ulOverlayHandle, pvecMouseScale);
}
vr::EVROverlayError CVROverlay_018::SetOverlayMouseScale(vr::VROverlayHandle_t ulOverlayHandle, const vr::HmdVector2_t* pvecMouseScale) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->SetOverlayMouseScale(ulOverlayHandle, pvecMouseScale);
}
bool CVROverlay_018::ComputeOverlayIntersection(vr::VROverlayHandle_t ulOverlayHandle, const vr::IVROverlay_018::VROverlayIntersectionParams_t* pParams, vr::IVROverlay_018::VROverlayIntersectionResults_t* pResults) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->ComputeOverlayIntersection(ulOverlayHandle, (const OOVR_VROverlayIntersectionParams_t*) pParams, (OOVR_VROverlayIntersectionResults_t*) pResults);
}
bool CVROverlay_018::IsHoverTargetOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->IsHoverTargetOverlay(ulOverlayHandle);
}
vr::VROverlayHandle_t CVROverlay_018::GetGamepadFocusOverlay() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->GetGamepadFocusOverlay();
}
vr::EVROverlayError CVROverlay_018::SetGamepadFocusOverlay(vr::VROverlayHandle_t ulNewFocusOverlay) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->SetGamepadFocusOverlay(ulNewFocusOverlay);
}
vr::EVROverlayError CVROverlay_018::SetOverlayNeighbor(vr::IVROverlay_018::EOverlayDirection eDirection, vr::VROverlayHandle_t ulFrom, vr::VROverlayHandle_t ulTo) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->SetOverlayNeighbor((OOVR_EOverlayDirection) eDirection, ulFrom, ulTo);
}
vr::EVROverlayError CVROverlay_018::MoveGamepadFocusToNeighbor(vr::IVROverlay_018::EOverlayDirection eDirection, vr::VROverlayHandle_t ulFrom) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->MoveGamepadFocusToNeighbor((OOVR_EOverlayDirection) eDirection, ulFrom);
}
vr::EVROverlayError CVROverlay_018::SetOverlayDualAnalogTransform(vr::VROverlayHandle_t ulOverlay, EDualAnalogWhich eWhich, const vr::HmdVector2_t& vCenter, float fRadius) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->SetOverlayDualAnalogTransform(ulOverlay, eWhich, vCenter, fRadius);
}
vr::EVROverlayError CVROverlay_018::GetOverlayDualAnalogTransform(vr::VROverlayHandle_t ulOverlay, EDualAnalogWhich eWhich, vr::HmdVector2_t* pvCenter, float* pfRadius) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->GetOverlayDualAnalogTransform(ulOverlay, eWhich, pvCenter, pfRadius);
}
vr::EVROverlayError CVROverlay_018::SetOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle, const vr::Texture_t* pTexture) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->SetOverlayTexture(ulOverlayHandle, pTexture);
}
vr::EVROverlayError CVROverlay_018::ClearOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->ClearOverlayTexture(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_018::SetOverlayRaw(vr::VROverlayHandle_t ulOverlayHandle, void* pvBuffer, uint32_t unWidth, uint32_t unHeight, uint32_t unDepth) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->SetOverlayRaw(ulOverlayHandle, pvBuffer, unWidth, unHeight, unDepth);
}
vr::EVROverlayError CVROverlay_018::SetOverlayFromFile(vr::VROverlayHandle_t ulOverlayHandle, const char* pchFilePath) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->SetOverlayFromFile(ulOverlayHandle, pchFilePath);
}
vr::EVROverlayError CVROverlay_018::GetOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle, void** pNativeTextureHandle, void* pNativeTextureRef, uint32_t* pWidth, uint32_t* pHeight, uint32_t* pNativeFormat, vr::ETextureType* pAPIType, vr::EColorSpace* pColorSpace, vr::VRTextureBounds_t* pTextureBounds) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->GetOverlayTexture(ulOverlayHandle, pNativeTextureHandle, pNativeTextureRef, pWidth, pHeight, pNativeFormat, pAPIType, pColorSpace, pTextureBounds);
}
vr::EVROverlayError CVROverlay_018::ReleaseNativeOverlayHandle(vr::VROverlayHandle_t ulOverlayHandle, void* pNativeTextureHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->ReleaseNativeOverlayHandle(ulOverlayHandle, pNativeTextureHandle);
}
vr::EVROverlayError CVROverlay_018::GetOverlayTextureSize(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* pWidth, uint32_t* pHeight) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->GetOverlayTextureSize(ulOverlayHandle, pWidth, pHeight);
}
vr::EVROverlayError CVROverlay_018::CreateDashboardOverlay(const char* pchOverlayKey, const char* pchOverlayFriendlyName, vr::VROverlayHandle_t* pMainHandle, vr::VROverlayHandle_t* pThumbnailHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->CreateDashboardOverlay(pchOverlayKey, pchOverlayFriendlyName, pMainHandle, pThumbnailHandle);
}
bool CVROverlay_018::IsDashboardVisible() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->IsDashboardVisible();
}
bool CVROverlay_018::IsActiveDashboardOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->IsActiveDashboardOverlay(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_018::SetDashboardOverlaySceneProcess(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unProcessId) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->SetDashboardOverlaySceneProcess(ulOverlayHandle, unProcessId);
}
vr::EVROverlayError CVROverlay_018::GetDashboardOverlaySceneProcess(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* punProcessId) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->GetDashboardOverlaySceneProcess(ulOverlayHandle, punProcessId);
}
void CVROverlay_018::ShowDashboard(const char* pchOverlayToShow) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->ShowDashboard(pchOverlayToShow);
}
vr::TrackedDeviceIndex_t CVROverlay_018::GetPrimaryDashboardDevice() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->GetPrimaryDashboardDevice();
}
vr::EVROverlayError CVROverlay_018::ShowKeyboard(vr::IVROverlay_018::EGamepadTextInputMode eInputMode, vr::IVROverlay_018::EGamepadTextInputLineMode eLineInputMode, const char* pchDescription, uint32_t unCharMax, const char* pchExistingText, bool bUseMinimalMode, uint64_t uUserValue) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->ShowKeyboard((OOVR_EGamepadTextInputMode) eInputMode, (OOVR_EGamepadTextInputLineMode) eLineInputMode, pchDescription, unCharMax, pchExistingText, bUseMinimalMode, uUserValue);
}
vr::EVROverlayError CVROverlay_018::ShowKeyboardForOverlay(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_018::EGamepadTextInputMode eInputMode, vr::IVROverlay_018::EGamepadTextInputLineMode eLineInputMode, const char* pchDescription, uint32_t unCharMax, const char* pchExistingText, bool bUseMinimalMode, uint64_t uUserValue) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->ShowKeyboardForOverlay(ulOverlayHandle, (OOVR_EGamepadTextInputMode) eInputMode, (OOVR_EGamepadTextInputLineMode) eLineInputMode, pchDescription, unCharMax, pchExistingText, bUseMinimalMode, uUserValue);
}
uint32_t CVROverlay_018::GetKeyboardText(char* pchText, uint32_t cchText) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->GetKeyboardText(pchText, cchText);
}
void CVROverlay_018::HideKeyboard() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->HideKeyboard();
}
void CVROverlay_018::SetKeyboardTransformAbsolute(vr::ETrackingUniverseOrigin eTrackingOrigin, const vr::HmdMatrix34_t* pmatTrackingOriginToKeyboardTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->SetKeyboardTransformAbsolute(eTrackingOrigin, pmatTrackingOriginToKeyboardTransform);
}
void CVROverlay_018::SetKeyboardPositionForOverlay(vr::VROverlayHandle_t ulOverlayHandle, vr::HmdRect2_t avoidRect) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->SetKeyboardPositionForOverlay(ulOverlayHandle, avoidRect);
}
vr::EVROverlayError CVROverlay_018::SetOverlayIntersectionMask(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_018::VROverlayIntersectionMaskPrimitive_t* pMaskPrimitives, uint32_t unNumMaskPrimitives, uint32_t unPrimitiveSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->SetOverlayIntersectionMask(ulOverlayHandle, (OOVR_VROverlayIntersectionMaskPrimitive_t*) pMaskPrimitives, unNumMaskPrimitives, unPrimitiveSize);
}
vr::EVROverlayError CVROverlay_018::GetOverlayFlags(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* pFlags) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->GetOverlayFlags(ulOverlayHandle, pFlags);
}
vr::IVROverlay_018::VRMessageOverlayResponse CVROverlay_018::ShowMessageOverlay(const char* pchText, const char* pchCaption, const char* pchButton0Text, const char* pchButton1Text, const char* pchButton2Text, const char* pchButton3Text) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return (vr::IVROverlay_018::VRMessageOverlayResponse) base->ShowMessageOverlay(pchText, pchCaption, pchButton0Text, pchButton1Text, pchButton2Text, pchButton3Text);
}
void CVROverlay_018::CloseMessageOverlay() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_018)");
	return base->CloseMessageOverlay();
}
// FnTable for CVROverlay_018:
static CVROverlay_018 *fntable_Overlay_018_instance = NULL;
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_FindOverlay(const char* pchOverlayKey, vr::VROverlayHandle_t* pOverlayHandle) { return fntable_Overlay_018_instance->FindOverlay(pchOverlayKey, pOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_CreateOverlay(const char* pchOverlayKey, const char* pchOverlayName, vr::VROverlayHandle_t* pOverlayHandle) { return fntable_Overlay_018_instance->CreateOverlay(pchOverlayKey, pchOverlayName, pOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_DestroyOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_018_instance->DestroyOverlay(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_SetHighQualityOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_018_instance->SetHighQualityOverlay(ulOverlayHandle); }
static vr::VROverlayHandle_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_GetHighQualityOverlay() { return fntable_Overlay_018_instance->GetHighQualityOverlay(); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_GetOverlayKey(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::EVROverlayError* pError) { return fntable_Overlay_018_instance->GetOverlayKey(ulOverlayHandle, pchValue, unBufferSize, pError); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_GetOverlayName(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::EVROverlayError* pError) { return fntable_Overlay_018_instance->GetOverlayName(ulOverlayHandle, pchValue, unBufferSize, pError); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_SetOverlayName(vr::VROverlayHandle_t ulOverlayHandle, const char* pchName) { return fntable_Overlay_018_instance->SetOverlayName(ulOverlayHandle, pchName); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_GetOverlayImageData(vr::VROverlayHandle_t ulOverlayHandle, void* pvBuffer, uint32_t unBufferSize, uint32_t* punWidth, uint32_t* punHeight) { return fntable_Overlay_018_instance->GetOverlayImageData(ulOverlayHandle, pvBuffer, unBufferSize, punWidth, punHeight); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_GetOverlayErrorNameFromEnum(vr::EVROverlayError error) { return fntable_Overlay_018_instance->GetOverlayErrorNameFromEnum(error); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_SetOverlayRenderingPid(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unPID) { return fntable_Overlay_018_instance->SetOverlayRenderingPid(ulOverlayHandle, unPID); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_GetOverlayRenderingPid(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_018_instance->GetOverlayRenderingPid(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_SetOverlayFlag(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_018::VROverlayFlags eOverlayFlag, bool bEnabled) { return fntable_Overlay_018_instance->SetOverlayFlag(ulOverlayHandle, eOverlayFlag, bEnabled); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_GetOverlayFlag(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_018::VROverlayFlags eOverlayFlag, bool* pbEnabled) { return fntable_Overlay_018_instance->GetOverlayFlag(ulOverlayHandle, eOverlayFlag, pbEnabled); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_SetOverlayColor(vr::VROverlayHandle_t ulOverlayHandle, float fRed, float fGreen, float fBlue) { return fntable_Overlay_018_instance->SetOverlayColor(ulOverlayHandle, fRed, fGreen, fBlue); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_GetOverlayColor(vr::VROverlayHandle_t ulOverlayHandle, float* pfRed, float* pfGreen, float* pfBlue) { return fntable_Overlay_018_instance->GetOverlayColor(ulOverlayHandle, pfRed, pfGreen, pfBlue); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_SetOverlayAlpha(vr::VROverlayHandle_t ulOverlayHandle, float fAlpha) { return fntable_Overlay_018_instance->SetOverlayAlpha(ulOverlayHandle, fAlpha); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_GetOverlayAlpha(vr::VROverlayHandle_t ulOverlayHandle, float* pfAlpha) { return fntable_Overlay_018_instance->GetOverlayAlpha(ulOverlayHandle, pfAlpha); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_SetOverlayTexelAspect(vr::VROverlayHandle_t ulOverlayHandle, float fTexelAspect) { return fntable_Overlay_018_instance->SetOverlayTexelAspect(ulOverlayHandle, fTexelAspect); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_GetOverlayTexelAspect(vr::VROverlayHandle_t ulOverlayHandle, float* pfTexelAspect) { return fntable_Overlay_018_instance->GetOverlayTexelAspect(ulOverlayHandle, pfTexelAspect); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_SetOverlaySortOrder(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unSortOrder) { return fntable_Overlay_018_instance->SetOverlaySortOrder(ulOverlayHandle, unSortOrder); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_GetOverlaySortOrder(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* punSortOrder) { return fntable_Overlay_018_instance->GetOverlaySortOrder(ulOverlayHandle, punSortOrder); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_SetOverlayWidthInMeters(vr::VROverlayHandle_t ulOverlayHandle, float fWidthInMeters) { return fntable_Overlay_018_instance->SetOverlayWidthInMeters(ulOverlayHandle, fWidthInMeters); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_GetOverlayWidthInMeters(vr::VROverlayHandle_t ulOverlayHandle, float* pfWidthInMeters) { return fntable_Overlay_018_instance->GetOverlayWidthInMeters(ulOverlayHandle, pfWidthInMeters); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_SetOverlayAutoCurveDistanceRangeInMeters(vr::VROverlayHandle_t ulOverlayHandle, float fMinDistanceInMeters, float fMaxDistanceInMeters) { return fntable_Overlay_018_instance->SetOverlayAutoCurveDistanceRangeInMeters(ulOverlayHandle, fMinDistanceInMeters, fMaxDistanceInMeters); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_GetOverlayAutoCurveDistanceRangeInMeters(vr::VROverlayHandle_t ulOverlayHandle, float* pfMinDistanceInMeters, float* pfMaxDistanceInMeters) { return fntable_Overlay_018_instance->GetOverlayAutoCurveDistanceRangeInMeters(ulOverlayHandle, pfMinDistanceInMeters, pfMaxDistanceInMeters); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_SetOverlayTextureColorSpace(vr::VROverlayHandle_t ulOverlayHandle, vr::EColorSpace eTextureColorSpace) { return fntable_Overlay_018_instance->SetOverlayTextureColorSpace(ulOverlayHandle, eTextureColorSpace); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_GetOverlayTextureColorSpace(vr::VROverlayHandle_t ulOverlayHandle, vr::EColorSpace* peTextureColorSpace) { return fntable_Overlay_018_instance->GetOverlayTextureColorSpace(ulOverlayHandle, peTextureColorSpace); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_SetOverlayTextureBounds(vr::VROverlayHandle_t ulOverlayHandle, const vr::VRTextureBounds_t* pOverlayTextureBounds) { return fntable_Overlay_018_instance->SetOverlayTextureBounds(ulOverlayHandle, pOverlayTextureBounds); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_GetOverlayTextureBounds(vr::VROverlayHandle_t ulOverlayHandle, vr::VRTextureBounds_t* pOverlayTextureBounds) { return fntable_Overlay_018_instance->GetOverlayTextureBounds(ulOverlayHandle, pOverlayTextureBounds); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_GetOverlayRenderModel(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::HmdColor_t* pColor, vr::EVROverlayError* pError) { return fntable_Overlay_018_instance->GetOverlayRenderModel(ulOverlayHandle, pchValue, unBufferSize, pColor, pError); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_SetOverlayRenderModel(vr::VROverlayHandle_t ulOverlayHandle, const char* pchRenderModel, const vr::HmdColor_t* pColor) { return fntable_Overlay_018_instance->SetOverlayRenderModel(ulOverlayHandle, pchRenderModel, pColor); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_GetOverlayTransformType(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_018::VROverlayTransformType* peTransformType) { return fntable_Overlay_018_instance->GetOverlayTransformType(ulOverlayHandle, peTransformType); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_SetOverlayTransformAbsolute(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin eTrackingOrigin, const vr::HmdMatrix34_t* pmatTrackingOriginToOverlayTransform) { return fntable_Overlay_018_instance->SetOverlayTransformAbsolute(ulOverlayHandle, eTrackingOrigin, pmatTrackingOriginToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_GetOverlayTransformAbsolute(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin* peTrackingOrigin, vr::HmdMatrix34_t* pmatTrackingOriginToOverlayTransform) { return fntable_Overlay_018_instance->GetOverlayTransformAbsolute(ulOverlayHandle, peTrackingOrigin, pmatTrackingOriginToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_SetOverlayTransformTrackedDeviceRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unTrackedDevice, const vr::HmdMatrix34_t* pmatTrackedDeviceToOverlayTransform) { return fntable_Overlay_018_instance->SetOverlayTransformTrackedDeviceRelative(ulOverlayHandle, unTrackedDevice, pmatTrackedDeviceToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_GetOverlayTransformTrackedDeviceRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t* punTrackedDevice, vr::HmdMatrix34_t* pmatTrackedDeviceToOverlayTransform) { return fntable_Overlay_018_instance->GetOverlayTransformTrackedDeviceRelative(ulOverlayHandle, punTrackedDevice, pmatTrackedDeviceToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_SetOverlayTransformTrackedDeviceComponent(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unDeviceIndex, const char* pchComponentName) { return fntable_Overlay_018_instance->SetOverlayTransformTrackedDeviceComponent(ulOverlayHandle, unDeviceIndex, pchComponentName); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_GetOverlayTransformTrackedDeviceComponent(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t* punDeviceIndex, char* pchComponentName, uint32_t unComponentNameSize) { return fntable_Overlay_018_instance->GetOverlayTransformTrackedDeviceComponent(ulOverlayHandle, punDeviceIndex, pchComponentName, unComponentNameSize); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_GetOverlayTransformOverlayRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::VROverlayHandle_t* ulOverlayHandleParent, vr::HmdMatrix34_t* pmatParentOverlayToOverlayTransform) { return fntable_Overlay_018_instance->GetOverlayTransformOverlayRelative(ulOverlayHandle, ulOverlayHandleParent, pmatParentOverlayToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_SetOverlayTransformOverlayRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::VROverlayHandle_t ulOverlayHandleParent, const vr::HmdMatrix34_t* pmatParentOverlayToOverlayTransform) { return fntable_Overlay_018_instance->SetOverlayTransformOverlayRelative(ulOverlayHandle, ulOverlayHandleParent, pmatParentOverlayToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_ShowOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_018_instance->ShowOverlay(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_HideOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_018_instance->HideOverlay(ulOverlayHandle); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_IsOverlayVisible(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_018_instance->IsOverlayVisible(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_GetTransformForOverlayCoordinates(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin eTrackingOrigin, vr::HmdVector2_t coordinatesInOverlay, vr::HmdMatrix34_t* pmatTransform) { return fntable_Overlay_018_instance->GetTransformForOverlayCoordinates(ulOverlayHandle, eTrackingOrigin, coordinatesInOverlay, pmatTransform); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_PollNextOverlayEvent(vr::VROverlayHandle_t ulOverlayHandle, vr::VREvent_t* pEvent, uint32_t uncbVREvent) { return fntable_Overlay_018_instance->PollNextOverlayEvent(ulOverlayHandle, pEvent, uncbVREvent); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_GetOverlayInputMethod(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_018::VROverlayInputMethod* peInputMethod) { return fntable_Overlay_018_instance->GetOverlayInputMethod(ulOverlayHandle, peInputMethod); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_SetOverlayInputMethod(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_018::VROverlayInputMethod eInputMethod) { return fntable_Overlay_018_instance->SetOverlayInputMethod(ulOverlayHandle, eInputMethod); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_GetOverlayMouseScale(vr::VROverlayHandle_t ulOverlayHandle, vr::HmdVector2_t* pvecMouseScale) { return fntable_Overlay_018_instance->GetOverlayMouseScale(ulOverlayHandle, pvecMouseScale); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_SetOverlayMouseScale(vr::VROverlayHandle_t ulOverlayHandle, const vr::HmdVector2_t* pvecMouseScale) { return fntable_Overlay_018_instance->SetOverlayMouseScale(ulOverlayHandle, pvecMouseScale); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_ComputeOverlayIntersection(vr::VROverlayHandle_t ulOverlayHandle, const vr::IVROverlay_018::VROverlayIntersectionParams_t* pParams, vr::IVROverlay_018::VROverlayIntersectionResults_t* pResults) { return fntable_Overlay_018_instance->ComputeOverlayIntersection(ulOverlayHandle, pParams, pResults); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_IsHoverTargetOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_018_instance->IsHoverTargetOverlay(ulOverlayHandle); }
static vr::VROverlayHandle_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_GetGamepadFocusOverlay() { return fntable_Overlay_018_instance->GetGamepadFocusOverlay(); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_SetGamepadFocusOverlay(vr::VROverlayHandle_t ulNewFocusOverlay) { return fntable_Overlay_018_instance->SetGamepadFocusOverlay(ulNewFocusOverlay); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_SetOverlayNeighbor(vr::IVROverlay_018::EOverlayDirection eDirection, vr::VROverlayHandle_t ulFrom, vr::VROverlayHandle_t ulTo) { return fntable_Overlay_018_instance->SetOverlayNeighbor(eDirection, ulFrom, ulTo); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_MoveGamepadFocusToNeighbor(vr::IVROverlay_018::EOverlayDirection eDirection, vr::VROverlayHandle_t ulFrom) { return fntable_Overlay_018_instance->MoveGamepadFocusToNeighbor(eDirection, ulFrom); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_SetOverlayDualAnalogTransform(vr::VROverlayHandle_t ulOverlay, EDualAnalogWhich eWhich, const vr::HmdVector2_t& vCenter, float fRadius) { return fntable_Overlay_018_instance->SetOverlayDualAnalogTransform(ulOverlay, eWhich, vCenter, fRadius); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_GetOverlayDualAnalogTransform(vr::VROverlayHandle_t ulOverlay, EDualAnalogWhich eWhich, vr::HmdVector2_t* pvCenter, float* pfRadius) { return fntable_Overlay_018_instance->GetOverlayDualAnalogTransform(ulOverlay, eWhich, pvCenter, pfRadius); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_SetOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle, const vr::Texture_t* pTexture) { return fntable_Overlay_018_instance->SetOverlayTexture(ulOverlayHandle, pTexture); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_ClearOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_018_instance->ClearOverlayTexture(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_SetOverlayRaw(vr::VROverlayHandle_t ulOverlayHandle, void* pvBuffer, uint32_t unWidth, uint32_t unHeight, uint32_t unDepth) { return fntable_Overlay_018_instance->SetOverlayRaw(ulOverlayHandle, pvBuffer, unWidth, unHeight, unDepth); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_SetOverlayFromFile(vr::VROverlayHandle_t ulOverlayHandle, const char* pchFilePath) { return fntable_Overlay_018_instance->SetOverlayFromFile(ulOverlayHandle, pchFilePath); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_GetOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle, void** pNativeTextureHandle, void* pNativeTextureRef, uint32_t* pWidth, uint32_t* pHeight, uint32_t* pNativeFormat, vr::ETextureType* pAPIType, vr::EColorSpace* pColorSpace, vr::VRTextureBounds_t* pTextureBounds) { return fntable_Overlay_018_instance->GetOverlayTexture(ulOverlayHandle, pNativeTextureHandle, pNativeTextureRef, pWidth, pHeight, pNativeFormat, pAPIType, pColorSpace, pTextureBounds); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_ReleaseNativeOverlayHandle(vr::VROverlayHandle_t ulOverlayHandle, void* pNativeTextureHandle) { return fntable_Overlay_018_instance->ReleaseNativeOverlayHandle(ulOverlayHandle, pNativeTextureHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_GetOverlayTextureSize(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* pWidth, uint32_t* pHeight) { return fntable_Overlay_018_instance->GetOverlayTextureSize(ulOverlayHandle, pWidth, pHeight); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_CreateDashboardOverlay(const char* pchOverlayKey, const char* pchOverlayFriendlyName, vr::VROverlayHandle_t* pMainHandle, vr::VROverlayHandle_t* pThumbnailHandle) { return fntable_Overlay_018_instance->CreateDashboardOverlay(pchOverlayKey, pchOverlayFriendlyName, pMainHandle, pThumbnailHandle); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_IsDashboardVisible() { return fntable_Overlay_018_instance->IsDashboardVisible(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_IsActiveDashboardOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_018_instance->IsActiveDashboardOverlay(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_SetDashboardOverlaySceneProcess(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unProcessId) { return fntable_Overlay_018_instance->SetDashboardOverlaySceneProcess(ulOverlayHandle, unProcessId); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_GetDashboardOverlaySceneProcess(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* punProcessId) { return fntable_Overlay_018_instance->GetDashboardOverlaySceneProcess(ulOverlayHandle, punProcessId); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_ShowDashboard(const char* pchOverlayToShow) { return fntable_Overlay_018_instance->ShowDashboard(pchOverlayToShow); }
static vr::TrackedDeviceIndex_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_GetPrimaryDashboardDevice() { return fntable_Overlay_018_instance->GetPrimaryDashboardDevice(); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_ShowKeyboard(vr::IVROverlay_018::EGamepadTextInputMode eInputMode, vr::IVROverlay_018::EGamepadTextInputLineMode eLineInputMode, const char* pchDescription, uint32_t unCharMax, const char* pchExistingText, bool bUseMinimalMode, uint64_t uUserValue) { return fntable_Overlay_018_instance->ShowKeyboard(eInputMode, eLineInputMode, pchDescription, unCharMax, pchExistingText, bUseMinimalMode, uUserValue); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_ShowKeyboardForOverlay(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_018::EGamepadTextInputMode eInputMode, vr::IVROverlay_018::EGamepadTextInputLineMode eLineInputMode, const char* pchDescription, uint32_t unCharMax, const char* pchExistingText, bool bUseMinimalMode, uint64_t uUserValue) { return fntable_Overlay_018_instance->ShowKeyboardForOverlay(ulOverlayHandle, eInputMode, eLineInputMode, pchDescription, unCharMax, pchExistingText, bUseMinimalMode, uUserValue); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_GetKeyboardText(char* pchText, uint32_t cchText) { return fntable_Overlay_018_instance->GetKeyboardText(pchText, cchText); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_HideKeyboard() { return fntable_Overlay_018_instance->HideKeyboard(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_SetKeyboardTransformAbsolute(vr::ETrackingUniverseOrigin eTrackingOrigin, const vr::HmdMatrix34_t* pmatTrackingOriginToKeyboardTransform) { return fntable_Overlay_018_instance->SetKeyboardTransformAbsolute(eTrackingOrigin, pmatTrackingOriginToKeyboardTransform); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_SetKeyboardPositionForOverlay(vr::VROverlayHandle_t ulOverlayHandle, vr::HmdRect2_t avoidRect) { return fntable_Overlay_018_instance->SetKeyboardPositionForOverlay(ulOverlayHandle, avoidRect); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_SetOverlayIntersectionMask(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_018::VROverlayIntersectionMaskPrimitive_t* pMaskPrimitives, uint32_t unNumMaskPrimitives, uint32_t unPrimitiveSize) { return fntable_Overlay_018_instance->SetOverlayIntersectionMask(ulOverlayHandle, pMaskPrimitives, unNumMaskPrimitives, unPrimitiveSize); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_GetOverlayFlags(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* pFlags) { return fntable_Overlay_018_instance->GetOverlayFlags(ulOverlayHandle, pFlags); }
static vr::IVROverlay_018::VRMessageOverlayResponse OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_ShowMessageOverlay(const char* pchText, const char* pchCaption, const char* pchButton0Text, const char* pchButton1Text, const char* pchButton2Text, const char* pchButton3Text) { return fntable_Overlay_018_instance->ShowMessageOverlay(pchText, pchCaption, pchButton0Text, pchButton1Text, pchButton2Text, pchButton3Text); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_018_impl_CloseMessageOverlay() { return fntable_Overlay_018_instance->CloseMessageOverlay(); }
static void *fntable_Overlay_018_funcs[] = {
	(void*) fntable_Overlay_018_impl_FindOverlay,
	(void*) fntable_Overlay_018_impl_CreateOverlay,
	(void*) fntable_Overlay_018_impl_DestroyOverlay,
	(void*) fntable_Overlay_018_impl_SetHighQualityOverlay,
	(void*) fntable_Overlay_018_impl_GetHighQualityOverlay,
	(void*) fntable_Overlay_018_impl_GetOverlayKey,
	(void*) fntable_Overlay_018_impl_GetOverlayName,
	(void*) fntable_Overlay_018_impl_SetOverlayName,
	(void*) fntable_Overlay_018_impl_GetOverlayImageData,
	(void*) fntable_Overlay_018_impl_GetOverlayErrorNameFromEnum,
	(void*) fntable_Overlay_018_impl_SetOverlayRenderingPid,
	(void*) fntable_Overlay_018_impl_GetOverlayRenderingPid,
	(void*) fntable_Overlay_018_impl_SetOverlayFlag,
	(void*) fntable_Overlay_018_impl_GetOverlayFlag,
	(void*) fntable_Overlay_018_impl_SetOverlayColor,
	(void*) fntable_Overlay_018_impl_GetOverlayColor,
	(void*) fntable_Overlay_018_impl_SetOverlayAlpha,
	(void*) fntable_Overlay_018_impl_GetOverlayAlpha,
	(void*) fntable_Overlay_018_impl_SetOverlayTexelAspect,
	(void*) fntable_Overlay_018_impl_GetOverlayTexelAspect,
	(void*) fntable_Overlay_018_impl_SetOverlaySortOrder,
	(void*) fntable_Overlay_018_impl_GetOverlaySortOrder,
	(void*) fntable_Overlay_018_impl_SetOverlayWidthInMeters,
	(void*) fntable_Overlay_018_impl_GetOverlayWidthInMeters,
	(void*) fntable_Overlay_018_impl_SetOverlayAutoCurveDistanceRangeInMeters,
	(void*) fntable_Overlay_018_impl_GetOverlayAutoCurveDistanceRangeInMeters,
	(void*) fntable_Overlay_018_impl_SetOverlayTextureColorSpace,
	(void*) fntable_Overlay_018_impl_GetOverlayTextureColorSpace,
	(void*) fntable_Overlay_018_impl_SetOverlayTextureBounds,
	(void*) fntable_Overlay_018_impl_GetOverlayTextureBounds,
	(void*) fntable_Overlay_018_impl_GetOverlayRenderModel,
	(void*) fntable_Overlay_018_impl_SetOverlayRenderModel,
	(void*) fntable_Overlay_018_impl_GetOverlayTransformType,
	(void*) fntable_Overlay_018_impl_SetOverlayTransformAbsolute,
	(void*) fntable_Overlay_018_impl_GetOverlayTransformAbsolute,
	(void*) fntable_Overlay_018_impl_SetOverlayTransformTrackedDeviceRelative,
	(void*) fntable_Overlay_018_impl_GetOverlayTransformTrackedDeviceRelative,
	(void*) fntable_Overlay_018_impl_SetOverlayTransformTrackedDeviceComponent,
	(void*) fntable_Overlay_018_impl_GetOverlayTransformTrackedDeviceComponent,
	(void*) fntable_Overlay_018_impl_GetOverlayTransformOverlayRelative,
	(void*) fntable_Overlay_018_impl_SetOverlayTransformOverlayRelative,
	(void*) fntable_Overlay_018_impl_ShowOverlay,
	(void*) fntable_Overlay_018_impl_HideOverlay,
	(void*) fntable_Overlay_018_impl_IsOverlayVisible,
	(void*) fntable_Overlay_018_impl_GetTransformForOverlayCoordinates,
	(void*) fntable_Overlay_018_impl_PollNextOverlayEvent,
	(void*) fntable_Overlay_018_impl_GetOverlayInputMethod,
	(void*) fntable_Overlay_018_impl_SetOverlayInputMethod,
	(void*) fntable_Overlay_018_impl_GetOverlayMouseScale,
	(void*) fntable_Overlay_018_impl_SetOverlayMouseScale,
	(void*) fntable_Overlay_018_impl_ComputeOverlayIntersection,
	(void*) fntable_Overlay_018_impl_IsHoverTargetOverlay,
	(void*) fntable_Overlay_018_impl_GetGamepadFocusOverlay,
	(void*) fntable_Overlay_018_impl_SetGamepadFocusOverlay,
	(void*) fntable_Overlay_018_impl_SetOverlayNeighbor,
	(void*) fntable_Overlay_018_impl_MoveGamepadFocusToNeighbor,
	(void*) fntable_Overlay_018_impl_SetOverlayDualAnalogTransform,
	(void*) fntable_Overlay_018_impl_GetOverlayDualAnalogTransform,
	(void*) fntable_Overlay_018_impl_SetOverlayTexture,
	(void*) fntable_Overlay_018_impl_ClearOverlayTexture,
	(void*) fntable_Overlay_018_impl_SetOverlayRaw,
	(void*) fntable_Overlay_018_impl_SetOverlayFromFile,
	(void*) fntable_Overlay_018_impl_GetOverlayTexture,
	(void*) fntable_Overlay_018_impl_ReleaseNativeOverlayHandle,
	(void*) fntable_Overlay_018_impl_GetOverlayTextureSize,
	(void*) fntable_Overlay_018_impl_CreateDashboardOverlay,
	(void*) fntable_Overlay_018_impl_IsDashboardVisible,
	(void*) fntable_Overlay_018_impl_IsActiveDashboardOverlay,
	(void*) fntable_Overlay_018_impl_SetDashboardOverlaySceneProcess,
	(void*) fntable_Overlay_018_impl_GetDashboardOverlaySceneProcess,
	(void*) fntable_Overlay_018_impl_ShowDashboard,
	(void*) fntable_Overlay_018_impl_GetPrimaryDashboardDevice,
	(void*) fntable_Overlay_018_impl_ShowKeyboard,
	(void*) fntable_Overlay_018_impl_ShowKeyboardForOverlay,
	(void*) fntable_Overlay_018_impl_GetKeyboardText,
	(void*) fntable_Overlay_018_impl_HideKeyboard,
	(void*) fntable_Overlay_018_impl_SetKeyboardTransformAbsolute,
	(void*) fntable_Overlay_018_impl_SetKeyboardPositionForOverlay,
	(void*) fntable_Overlay_018_impl_SetOverlayIntersectionMask,
	(void*) fntable_Overlay_018_impl_GetOverlayFlags,
	(void*) fntable_Overlay_018_impl_ShowMessageOverlay,
	(void*) fntable_Overlay_018_impl_CloseMessageOverlay,
};
void** CVROverlay_018::_GetStatFuncList() { fntable_Overlay_018_instance = this; return fntable_Overlay_018_funcs; }
void CVROverlay_018::Delete() { delete this; }
// Misc for CVROverlay_019:
CVROverlay_019::CVROverlay_019() : base(GetCreateBaseOverlay()) {}
// Interface methods for CVROverlay_019:
vr::EVROverlayError CVROverlay_019::FindOverlay(const char* pchOverlayKey, vr::VROverlayHandle_t* pOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->FindOverlay(pchOverlayKey, pOverlayHandle);
}
vr::EVROverlayError CVROverlay_019::CreateOverlay(const char* pchOverlayKey, const char* pchOverlayName, vr::VROverlayHandle_t* pOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->CreateOverlay(pchOverlayKey, pchOverlayName, pOverlayHandle);
}
vr::EVROverlayError CVROverlay_019::DestroyOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->DestroyOverlay(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_019::SetHighQualityOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->SetHighQualityOverlay(ulOverlayHandle);
}
vr::VROverlayHandle_t CVROverlay_019::GetHighQualityOverlay() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->GetHighQualityOverlay();
}
uint32_t CVROverlay_019::GetOverlayKey(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::EVROverlayError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->GetOverlayKey(ulOverlayHandle, pchValue, unBufferSize, pError);
}
uint32_t CVROverlay_019::GetOverlayName(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::EVROverlayError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->GetOverlayName(ulOverlayHandle, pchValue, unBufferSize, pError);
}
vr::EVROverlayError CVROverlay_019::SetOverlayName(vr::VROverlayHandle_t ulOverlayHandle, const char* pchName) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->SetOverlayName(ulOverlayHandle, pchName);
}
vr::EVROverlayError CVROverlay_019::GetOverlayImageData(vr::VROverlayHandle_t ulOverlayHandle, void* pvBuffer, uint32_t unBufferSize, uint32_t* punWidth, uint32_t* punHeight) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->GetOverlayImageData(ulOverlayHandle, pvBuffer, unBufferSize, punWidth, punHeight);
}
const char* CVROverlay_019::GetOverlayErrorNameFromEnum(vr::EVROverlayError error) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->GetOverlayErrorNameFromEnum(error);
}
vr::EVROverlayError CVROverlay_019::SetOverlayRenderingPid(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unPID) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->SetOverlayRenderingPid(ulOverlayHandle, unPID);
}
uint32_t CVROverlay_019::GetOverlayRenderingPid(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->GetOverlayRenderingPid(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_019::SetOverlayFlag(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_019::VROverlayFlags eOverlayFlag, bool bEnabled) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->SetOverlayFlag(ulOverlayHandle, (OOVR_VROverlayFlags) eOverlayFlag, bEnabled);
}
vr::EVROverlayError CVROverlay_019::GetOverlayFlag(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_019::VROverlayFlags eOverlayFlag, bool* pbEnabled) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->GetOverlayFlag(ulOverlayHandle, (OOVR_VROverlayFlags) eOverlayFlag, pbEnabled);
}
vr::EVROverlayError CVROverlay_019::SetOverlayColor(vr::VROverlayHandle_t ulOverlayHandle, float fRed, float fGreen, float fBlue) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->SetOverlayColor(ulOverlayHandle, fRed, fGreen, fBlue);
}
vr::EVROverlayError CVROverlay_019::GetOverlayColor(vr::VROverlayHandle_t ulOverlayHandle, float* pfRed, float* pfGreen, float* pfBlue) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->GetOverlayColor(ulOverlayHandle, pfRed, pfGreen, pfBlue);
}
vr::EVROverlayError CVROverlay_019::SetOverlayAlpha(vr::VROverlayHandle_t ulOverlayHandle, float fAlpha) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->SetOverlayAlpha(ulOverlayHandle, fAlpha);
}
vr::EVROverlayError CVROverlay_019::GetOverlayAlpha(vr::VROverlayHandle_t ulOverlayHandle, float* pfAlpha) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->GetOverlayAlpha(ulOverlayHandle, pfAlpha);
}
vr::EVROverlayError CVROverlay_019::SetOverlayTexelAspect(vr::VROverlayHandle_t ulOverlayHandle, float fTexelAspect) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->SetOverlayTexelAspect(ulOverlayHandle, fTexelAspect);
}
vr::EVROverlayError CVROverlay_019::GetOverlayTexelAspect(vr::VROverlayHandle_t ulOverlayHandle, float* pfTexelAspect) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->GetOverlayTexelAspect(ulOverlayHandle, pfTexelAspect);
}
vr::EVROverlayError CVROverlay_019::SetOverlaySortOrder(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unSortOrder) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->SetOverlaySortOrder(ulOverlayHandle, unSortOrder);
}
vr::EVROverlayError CVROverlay_019::GetOverlaySortOrder(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* punSortOrder) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->GetOverlaySortOrder(ulOverlayHandle, punSortOrder);
}
vr::EVROverlayError CVROverlay_019::SetOverlayWidthInMeters(vr::VROverlayHandle_t ulOverlayHandle, float fWidthInMeters) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->SetOverlayWidthInMeters(ulOverlayHandle, fWidthInMeters);
}
vr::EVROverlayError CVROverlay_019::GetOverlayWidthInMeters(vr::VROverlayHandle_t ulOverlayHandle, float* pfWidthInMeters) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->GetOverlayWidthInMeters(ulOverlayHandle, pfWidthInMeters);
}
vr::EVROverlayError CVROverlay_019::SetOverlayAutoCurveDistanceRangeInMeters(vr::VROverlayHandle_t ulOverlayHandle, float fMinDistanceInMeters, float fMaxDistanceInMeters) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->SetOverlayAutoCurveDistanceRangeInMeters(ulOverlayHandle, fMinDistanceInMeters, fMaxDistanceInMeters);
}
vr::EVROverlayError CVROverlay_019::GetOverlayAutoCurveDistanceRangeInMeters(vr::VROverlayHandle_t ulOverlayHandle, float* pfMinDistanceInMeters, float* pfMaxDistanceInMeters) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->GetOverlayAutoCurveDistanceRangeInMeters(ulOverlayHandle, pfMinDistanceInMeters, pfMaxDistanceInMeters);
}
vr::EVROverlayError CVROverlay_019::SetOverlayTextureColorSpace(vr::VROverlayHandle_t ulOverlayHandle, vr::EColorSpace eTextureColorSpace) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->SetOverlayTextureColorSpace(ulOverlayHandle, eTextureColorSpace);
}
vr::EVROverlayError CVROverlay_019::GetOverlayTextureColorSpace(vr::VROverlayHandle_t ulOverlayHandle, vr::EColorSpace* peTextureColorSpace) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->GetOverlayTextureColorSpace(ulOverlayHandle, peTextureColorSpace);
}
vr::EVROverlayError CVROverlay_019::SetOverlayTextureBounds(vr::VROverlayHandle_t ulOverlayHandle, const vr::VRTextureBounds_t* pOverlayTextureBounds) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->SetOverlayTextureBounds(ulOverlayHandle, pOverlayTextureBounds);
}
vr::EVROverlayError CVROverlay_019::GetOverlayTextureBounds(vr::VROverlayHandle_t ulOverlayHandle, vr::VRTextureBounds_t* pOverlayTextureBounds) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->GetOverlayTextureBounds(ulOverlayHandle, pOverlayTextureBounds);
}
uint32_t CVROverlay_019::GetOverlayRenderModel(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::HmdColor_t* pColor, vr::EVROverlayError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->GetOverlayRenderModel(ulOverlayHandle, pchValue, unBufferSize, pColor, pError);
}
vr::EVROverlayError CVROverlay_019::SetOverlayRenderModel(vr::VROverlayHandle_t ulOverlayHandle, const char* pchRenderModel, const vr::HmdColor_t* pColor) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->SetOverlayRenderModel(ulOverlayHandle, pchRenderModel, pColor);
}
vr::EVROverlayError CVROverlay_019::GetOverlayTransformType(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_019::VROverlayTransformType* peTransformType) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->GetOverlayTransformType(ulOverlayHandle, (OOVR_VROverlayTransformType*) peTransformType);
}
vr::EVROverlayError CVROverlay_019::SetOverlayTransformAbsolute(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin eTrackingOrigin, const vr::HmdMatrix34_t* pmatTrackingOriginToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->SetOverlayTransformAbsolute(ulOverlayHandle, eTrackingOrigin, pmatTrackingOriginToOverlayTransform);
}
vr::EVROverlayError CVROverlay_019::GetOverlayTransformAbsolute(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin* peTrackingOrigin, vr::HmdMatrix34_t* pmatTrackingOriginToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->GetOverlayTransformAbsolute(ulOverlayHandle, peTrackingOrigin, pmatTrackingOriginToOverlayTransform);
}
vr::EVROverlayError CVROverlay_019::SetOverlayTransformTrackedDeviceRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unTrackedDevice, const vr::HmdMatrix34_t* pmatTrackedDeviceToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->SetOverlayTransformTrackedDeviceRelative(ulOverlayHandle, unTrackedDevice, pmatTrackedDeviceToOverlayTransform);
}
vr::EVROverlayError CVROverlay_019::GetOverlayTransformTrackedDeviceRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t* punTrackedDevice, vr::HmdMatrix34_t* pmatTrackedDeviceToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->GetOverlayTransformTrackedDeviceRelative(ulOverlayHandle, punTrackedDevice, pmatTrackedDeviceToOverlayTransform);
}
vr::EVROverlayError CVROverlay_019::SetOverlayTransformTrackedDeviceComponent(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unDeviceIndex, const char* pchComponentName) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->SetOverlayTransformTrackedDeviceComponent(ulOverlayHandle, unDeviceIndex, pchComponentName);
}
vr::EVROverlayError CVROverlay_019::GetOverlayTransformTrackedDeviceComponent(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t* punDeviceIndex, char* pchComponentName, uint32_t unComponentNameSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->GetOverlayTransformTrackedDeviceComponent(ulOverlayHandle, punDeviceIndex, pchComponentName, unComponentNameSize);
}
vr::EVROverlayError CVROverlay_019::GetOverlayTransformOverlayRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::VROverlayHandle_t* ulOverlayHandleParent, vr::HmdMatrix34_t* pmatParentOverlayToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->GetOverlayTransformOverlayRelative(ulOverlayHandle, ulOverlayHandleParent, pmatParentOverlayToOverlayTransform);
}
vr::EVROverlayError CVROverlay_019::SetOverlayTransformOverlayRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::VROverlayHandle_t ulOverlayHandleParent, const vr::HmdMatrix34_t* pmatParentOverlayToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->SetOverlayTransformOverlayRelative(ulOverlayHandle, ulOverlayHandleParent, pmatParentOverlayToOverlayTransform);
}
vr::EVROverlayError CVROverlay_019::ShowOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->ShowOverlay(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_019::HideOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->HideOverlay(ulOverlayHandle);
}
bool CVROverlay_019::IsOverlayVisible(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->IsOverlayVisible(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_019::GetTransformForOverlayCoordinates(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin eTrackingOrigin, vr::HmdVector2_t coordinatesInOverlay, vr::HmdMatrix34_t* pmatTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->GetTransformForOverlayCoordinates(ulOverlayHandle, eTrackingOrigin, coordinatesInOverlay, pmatTransform);
}
bool CVROverlay_019::PollNextOverlayEvent(vr::VROverlayHandle_t ulOverlayHandle, vr::VREvent_t* pEvent, uint32_t uncbVREvent) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->PollNextOverlayEvent(ulOverlayHandle, pEvent, uncbVREvent);
}
vr::EVROverlayError CVROverlay_019::GetOverlayInputMethod(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_019::VROverlayInputMethod* peInputMethod) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->GetOverlayInputMethod(ulOverlayHandle, (OOVR_VROverlayInputMethod*) peInputMethod);
}
vr::EVROverlayError CVROverlay_019::SetOverlayInputMethod(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_019::VROverlayInputMethod eInputMethod) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->SetOverlayInputMethod(ulOverlayHandle, (OOVR_VROverlayInputMethod) eInputMethod);
}
vr::EVROverlayError CVROverlay_019::GetOverlayMouseScale(vr::VROverlayHandle_t ulOverlayHandle, vr::HmdVector2_t* pvecMouseScale) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->GetOverlayMouseScale(ulOverlayHandle, pvecMouseScale);
}
vr::EVROverlayError CVROverlay_019::SetOverlayMouseScale(vr::VROverlayHandle_t ulOverlayHandle, const vr::HmdVector2_t* pvecMouseScale) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->SetOverlayMouseScale(ulOverlayHandle, pvecMouseScale);
}
bool CVROverlay_019::ComputeOverlayIntersection(vr::VROverlayHandle_t ulOverlayHandle, const vr::IVROverlay_019::VROverlayIntersectionParams_t* pParams, vr::IVROverlay_019::VROverlayIntersectionResults_t* pResults) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->ComputeOverlayIntersection(ulOverlayHandle, (const OOVR_VROverlayIntersectionParams_t*) pParams, (OOVR_VROverlayIntersectionResults_t*) pResults);
}
bool CVROverlay_019::IsHoverTargetOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->IsHoverTargetOverlay(ulOverlayHandle);
}
vr::VROverlayHandle_t CVROverlay_019::GetGamepadFocusOverlay() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->GetGamepadFocusOverlay();
}
vr::EVROverlayError CVROverlay_019::SetGamepadFocusOverlay(vr::VROverlayHandle_t ulNewFocusOverlay) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->SetGamepadFocusOverlay(ulNewFocusOverlay);
}
vr::EVROverlayError CVROverlay_019::SetOverlayNeighbor(vr::IVROverlay_019::EOverlayDirection eDirection, vr::VROverlayHandle_t ulFrom, vr::VROverlayHandle_t ulTo) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->SetOverlayNeighbor((OOVR_EOverlayDirection) eDirection, ulFrom, ulTo);
}
vr::EVROverlayError CVROverlay_019::MoveGamepadFocusToNeighbor(vr::IVROverlay_019::EOverlayDirection eDirection, vr::VROverlayHandle_t ulFrom) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->MoveGamepadFocusToNeighbor((OOVR_EOverlayDirection) eDirection, ulFrom);
}
vr::EVROverlayError CVROverlay_019::SetOverlayDualAnalogTransform(vr::VROverlayHandle_t ulOverlay, EDualAnalogWhich eWhich, const vr::HmdVector2_t* pvCenter, float fRadius) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->SetOverlayDualAnalogTransform(ulOverlay, eWhich, pvCenter, fRadius);
}
vr::EVROverlayError CVROverlay_019::GetOverlayDualAnalogTransform(vr::VROverlayHandle_t ulOverlay, EDualAnalogWhich eWhich, vr::HmdVector2_t* pvCenter, float* pfRadius) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->GetOverlayDualAnalogTransform(ulOverlay, eWhich, pvCenter, pfRadius);
}
vr::EVROverlayError CVROverlay_019::SetOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle, const vr::Texture_t* pTexture) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->SetOverlayTexture(ulOverlayHandle, pTexture);
}
vr::EVROverlayError CVROverlay_019::ClearOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->ClearOverlayTexture(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_019::SetOverlayRaw(vr::VROverlayHandle_t ulOverlayHandle, void* pvBuffer, uint32_t unWidth, uint32_t unHeight, uint32_t unDepth) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->SetOverlayRaw(ulOverlayHandle, pvBuffer, unWidth, unHeight, unDepth);
}
vr::EVROverlayError CVROverlay_019::SetOverlayFromFile(vr::VROverlayHandle_t ulOverlayHandle, const char* pchFilePath) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->SetOverlayFromFile(ulOverlayHandle, pchFilePath);
}
vr::EVROverlayError CVROverlay_019::GetOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle, void** pNativeTextureHandle, void* pNativeTextureRef, uint32_t* pWidth, uint32_t* pHeight, uint32_t* pNativeFormat, vr::ETextureType* pAPIType, vr::EColorSpace* pColorSpace, vr::VRTextureBounds_t* pTextureBounds) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->GetOverlayTexture(ulOverlayHandle, pNativeTextureHandle, pNativeTextureRef, pWidth, pHeight, pNativeFormat, pAPIType, pColorSpace, pTextureBounds);
}
vr::EVROverlayError CVROverlay_019::ReleaseNativeOverlayHandle(vr::VROverlayHandle_t ulOverlayHandle, void* pNativeTextureHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->ReleaseNativeOverlayHandle(ulOverlayHandle, pNativeTextureHandle);
}
vr::EVROverlayError CVROverlay_019::GetOverlayTextureSize(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* pWidth, uint32_t* pHeight) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->GetOverlayTextureSize(ulOverlayHandle, pWidth, pHeight);
}
vr::EVROverlayError CVROverlay_019::CreateDashboardOverlay(const char* pchOverlayKey, const char* pchOverlayFriendlyName, vr::VROverlayHandle_t* pMainHandle, vr::VROverlayHandle_t* pThumbnailHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->CreateDashboardOverlay(pchOverlayKey, pchOverlayFriendlyName, pMainHandle, pThumbnailHandle);
}
bool CVROverlay_019::IsDashboardVisible() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->IsDashboardVisible();
}
bool CVROverlay_019::IsActiveDashboardOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->IsActiveDashboardOverlay(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_019::SetDashboardOverlaySceneProcess(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unProcessId) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->SetDashboardOverlaySceneProcess(ulOverlayHandle, unProcessId);
}
vr::EVROverlayError CVROverlay_019::GetDashboardOverlaySceneProcess(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* punProcessId) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->GetDashboardOverlaySceneProcess(ulOverlayHandle, punProcessId);
}
void CVROverlay_019::ShowDashboard(const char* pchOverlayToShow) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->ShowDashboard(pchOverlayToShow);
}
vr::TrackedDeviceIndex_t CVROverlay_019::GetPrimaryDashboardDevice() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->GetPrimaryDashboardDevice();
}
vr::EVROverlayError CVROverlay_019::ShowKeyboard(vr::IVROverlay_019::EGamepadTextInputMode eInputMode, vr::IVROverlay_019::EGamepadTextInputLineMode eLineInputMode, const char* pchDescription, uint32_t unCharMax, const char* pchExistingText, bool bUseMinimalMode, uint64_t uUserValue) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->ShowKeyboard((OOVR_EGamepadTextInputMode) eInputMode, (OOVR_EGamepadTextInputLineMode) eLineInputMode, pchDescription, unCharMax, pchExistingText, bUseMinimalMode, uUserValue);
}
vr::EVROverlayError CVROverlay_019::ShowKeyboardForOverlay(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_019::EGamepadTextInputMode eInputMode, vr::IVROverlay_019::EGamepadTextInputLineMode eLineInputMode, const char* pchDescription, uint32_t unCharMax, const char* pchExistingText, bool bUseMinimalMode, uint64_t uUserValue) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->ShowKeyboardForOverlay(ulOverlayHandle, (OOVR_EGamepadTextInputMode) eInputMode, (OOVR_EGamepadTextInputLineMode) eLineInputMode, pchDescription, unCharMax, pchExistingText, bUseMinimalMode, uUserValue);
}
uint32_t CVROverlay_019::GetKeyboardText(char* pchText, uint32_t cchText) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->GetKeyboardText(pchText, cchText);
}
void CVROverlay_019::HideKeyboard() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->HideKeyboard();
}
void CVROverlay_019::SetKeyboardTransformAbsolute(vr::ETrackingUniverseOrigin eTrackingOrigin, const vr::HmdMatrix34_t* pmatTrackingOriginToKeyboardTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->SetKeyboardTransformAbsolute(eTrackingOrigin, pmatTrackingOriginToKeyboardTransform);
}
void CVROverlay_019::SetKeyboardPositionForOverlay(vr::VROverlayHandle_t ulOverlayHandle, vr::HmdRect2_t avoidRect) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->SetKeyboardPositionForOverlay(ulOverlayHandle, avoidRect);
}
vr::EVROverlayError CVROverlay_019::SetOverlayIntersectionMask(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_019::VROverlayIntersectionMaskPrimitive_t* pMaskPrimitives, uint32_t unNumMaskPrimitives, uint32_t unPrimitiveSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->SetOverlayIntersectionMask(ulOverlayHandle, (OOVR_VROverlayIntersectionMaskPrimitive_t*) pMaskPrimitives, unNumMaskPrimitives, unPrimitiveSize);
}
vr::EVROverlayError CVROverlay_019::GetOverlayFlags(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* pFlags) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->GetOverlayFlags(ulOverlayHandle, pFlags);
}
vr::IVROverlay_019::VRMessageOverlayResponse CVROverlay_019::ShowMessageOverlay(const char* pchText, const char* pchCaption, const char* pchButton0Text, const char* pchButton1Text, const char* pchButton2Text, const char* pchButton3Text) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return (vr::IVROverlay_019::VRMessageOverlayResponse) base->ShowMessageOverlay(pchText, pchCaption, pchButton0Text, pchButton1Text, pchButton2Text, pchButton3Text);
}
void CVROverlay_019::CloseMessageOverlay() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_019)");
	return base->CloseMessageOverlay();
}
// FnTable for CVROverlay_019:
static CVROverlay_019 *fntable_Overlay_019_instance = NULL;
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_FindOverlay(const char* pchOverlayKey, vr::VROverlayHandle_t* pOverlayHandle) { return fntable_Overlay_019_instance->FindOverlay(pchOverlayKey, pOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_CreateOverlay(const char* pchOverlayKey, const char* pchOverlayName, vr::VROverlayHandle_t* pOverlayHandle) { return fntable_Overlay_019_instance->CreateOverlay(pchOverlayKey, pchOverlayName, pOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_DestroyOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_019_instance->DestroyOverlay(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_SetHighQualityOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_019_instance->SetHighQualityOverlay(ulOverlayHandle); }
static vr::VROverlayHandle_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_GetHighQualityOverlay() { return fntable_Overlay_019_instance->GetHighQualityOverlay(); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_GetOverlayKey(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::EVROverlayError* pError) { return fntable_Overlay_019_instance->GetOverlayKey(ulOverlayHandle, pchValue, unBufferSize, pError); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_GetOverlayName(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::EVROverlayError* pError) { return fntable_Overlay_019_instance->GetOverlayName(ulOverlayHandle, pchValue, unBufferSize, pError); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_SetOverlayName(vr::VROverlayHandle_t ulOverlayHandle, const char* pchName) { return fntable_Overlay_019_instance->SetOverlayName(ulOverlayHandle, pchName); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_GetOverlayImageData(vr::VROverlayHandle_t ulOverlayHandle, void* pvBuffer, uint32_t unBufferSize, uint32_t* punWidth, uint32_t* punHeight) { return fntable_Overlay_019_instance->GetOverlayImageData(ulOverlayHandle, pvBuffer, unBufferSize, punWidth, punHeight); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_GetOverlayErrorNameFromEnum(vr::EVROverlayError error) { return fntable_Overlay_019_instance->GetOverlayErrorNameFromEnum(error); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_SetOverlayRenderingPid(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unPID) { return fntable_Overlay_019_instance->SetOverlayRenderingPid(ulOverlayHandle, unPID); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_GetOverlayRenderingPid(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_019_instance->GetOverlayRenderingPid(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_SetOverlayFlag(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_019::VROverlayFlags eOverlayFlag, bool bEnabled) { return fntable_Overlay_019_instance->SetOverlayFlag(ulOverlayHandle, eOverlayFlag, bEnabled); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_GetOverlayFlag(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_019::VROverlayFlags eOverlayFlag, bool* pbEnabled) { return fntable_Overlay_019_instance->GetOverlayFlag(ulOverlayHandle, eOverlayFlag, pbEnabled); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_SetOverlayColor(vr::VROverlayHandle_t ulOverlayHandle, float fRed, float fGreen, float fBlue) { return fntable_Overlay_019_instance->SetOverlayColor(ulOverlayHandle, fRed, fGreen, fBlue); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_GetOverlayColor(vr::VROverlayHandle_t ulOverlayHandle, float* pfRed, float* pfGreen, float* pfBlue) { return fntable_Overlay_019_instance->GetOverlayColor(ulOverlayHandle, pfRed, pfGreen, pfBlue); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_SetOverlayAlpha(vr::VROverlayHandle_t ulOverlayHandle, float fAlpha) { return fntable_Overlay_019_instance->SetOverlayAlpha(ulOverlayHandle, fAlpha); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_GetOverlayAlpha(vr::VROverlayHandle_t ulOverlayHandle, float* pfAlpha) { return fntable_Overlay_019_instance->GetOverlayAlpha(ulOverlayHandle, pfAlpha); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_SetOverlayTexelAspect(vr::VROverlayHandle_t ulOverlayHandle, float fTexelAspect) { return fntable_Overlay_019_instance->SetOverlayTexelAspect(ulOverlayHandle, fTexelAspect); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_GetOverlayTexelAspect(vr::VROverlayHandle_t ulOverlayHandle, float* pfTexelAspect) { return fntable_Overlay_019_instance->GetOverlayTexelAspect(ulOverlayHandle, pfTexelAspect); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_SetOverlaySortOrder(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unSortOrder) { return fntable_Overlay_019_instance->SetOverlaySortOrder(ulOverlayHandle, unSortOrder); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_GetOverlaySortOrder(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* punSortOrder) { return fntable_Overlay_019_instance->GetOverlaySortOrder(ulOverlayHandle, punSortOrder); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_SetOverlayWidthInMeters(vr::VROverlayHandle_t ulOverlayHandle, float fWidthInMeters) { return fntable_Overlay_019_instance->SetOverlayWidthInMeters(ulOverlayHandle, fWidthInMeters); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_GetOverlayWidthInMeters(vr::VROverlayHandle_t ulOverlayHandle, float* pfWidthInMeters) { return fntable_Overlay_019_instance->GetOverlayWidthInMeters(ulOverlayHandle, pfWidthInMeters); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_SetOverlayAutoCurveDistanceRangeInMeters(vr::VROverlayHandle_t ulOverlayHandle, float fMinDistanceInMeters, float fMaxDistanceInMeters) { return fntable_Overlay_019_instance->SetOverlayAutoCurveDistanceRangeInMeters(ulOverlayHandle, fMinDistanceInMeters, fMaxDistanceInMeters); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_GetOverlayAutoCurveDistanceRangeInMeters(vr::VROverlayHandle_t ulOverlayHandle, float* pfMinDistanceInMeters, float* pfMaxDistanceInMeters) { return fntable_Overlay_019_instance->GetOverlayAutoCurveDistanceRangeInMeters(ulOverlayHandle, pfMinDistanceInMeters, pfMaxDistanceInMeters); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_SetOverlayTextureColorSpace(vr::VROverlayHandle_t ulOverlayHandle, vr::EColorSpace eTextureColorSpace) { return fntable_Overlay_019_instance->SetOverlayTextureColorSpace(ulOverlayHandle, eTextureColorSpace); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_GetOverlayTextureColorSpace(vr::VROverlayHandle_t ulOverlayHandle, vr::EColorSpace* peTextureColorSpace) { return fntable_Overlay_019_instance->GetOverlayTextureColorSpace(ulOverlayHandle, peTextureColorSpace); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_SetOverlayTextureBounds(vr::VROverlayHandle_t ulOverlayHandle, const vr::VRTextureBounds_t* pOverlayTextureBounds) { return fntable_Overlay_019_instance->SetOverlayTextureBounds(ulOverlayHandle, pOverlayTextureBounds); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_GetOverlayTextureBounds(vr::VROverlayHandle_t ulOverlayHandle, vr::VRTextureBounds_t* pOverlayTextureBounds) { return fntable_Overlay_019_instance->GetOverlayTextureBounds(ulOverlayHandle, pOverlayTextureBounds); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_GetOverlayRenderModel(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::HmdColor_t* pColor, vr::EVROverlayError* pError) { return fntable_Overlay_019_instance->GetOverlayRenderModel(ulOverlayHandle, pchValue, unBufferSize, pColor, pError); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_SetOverlayRenderModel(vr::VROverlayHandle_t ulOverlayHandle, const char* pchRenderModel, const vr::HmdColor_t* pColor) { return fntable_Overlay_019_instance->SetOverlayRenderModel(ulOverlayHandle, pchRenderModel, pColor); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_GetOverlayTransformType(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_019::VROverlayTransformType* peTransformType) { return fntable_Overlay_019_instance->GetOverlayTransformType(ulOverlayHandle, peTransformType); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_SetOverlayTransformAbsolute(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin eTrackingOrigin, const vr::HmdMatrix34_t* pmatTrackingOriginToOverlayTransform) { return fntable_Overlay_019_instance->SetOverlayTransformAbsolute(ulOverlayHandle, eTrackingOrigin, pmatTrackingOriginToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_GetOverlayTransformAbsolute(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin* peTrackingOrigin, vr::HmdMatrix34_t* pmatTrackingOriginToOverlayTransform) { return fntable_Overlay_019_instance->GetOverlayTransformAbsolute(ulOverlayHandle, peTrackingOrigin, pmatTrackingOriginToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_SetOverlayTransformTrackedDeviceRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unTrackedDevice, const vr::HmdMatrix34_t* pmatTrackedDeviceToOverlayTransform) { return fntable_Overlay_019_instance->SetOverlayTransformTrackedDeviceRelative(ulOverlayHandle, unTrackedDevice, pmatTrackedDeviceToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_GetOverlayTransformTrackedDeviceRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t* punTrackedDevice, vr::HmdMatrix34_t* pmatTrackedDeviceToOverlayTransform) { return fntable_Overlay_019_instance->GetOverlayTransformTrackedDeviceRelative(ulOverlayHandle, punTrackedDevice, pmatTrackedDeviceToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_SetOverlayTransformTrackedDeviceComponent(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unDeviceIndex, const char* pchComponentName) { return fntable_Overlay_019_instance->SetOverlayTransformTrackedDeviceComponent(ulOverlayHandle, unDeviceIndex, pchComponentName); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_GetOverlayTransformTrackedDeviceComponent(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t* punDeviceIndex, char* pchComponentName, uint32_t unComponentNameSize) { return fntable_Overlay_019_instance->GetOverlayTransformTrackedDeviceComponent(ulOverlayHandle, punDeviceIndex, pchComponentName, unComponentNameSize); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_GetOverlayTransformOverlayRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::VROverlayHandle_t* ulOverlayHandleParent, vr::HmdMatrix34_t* pmatParentOverlayToOverlayTransform) { return fntable_Overlay_019_instance->GetOverlayTransformOverlayRelative(ulOverlayHandle, ulOverlayHandleParent, pmatParentOverlayToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_SetOverlayTransformOverlayRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::VROverlayHandle_t ulOverlayHandleParent, const vr::HmdMatrix34_t* pmatParentOverlayToOverlayTransform) { return fntable_Overlay_019_instance->SetOverlayTransformOverlayRelative(ulOverlayHandle, ulOverlayHandleParent, pmatParentOverlayToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_ShowOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_019_instance->ShowOverlay(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_HideOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_019_instance->HideOverlay(ulOverlayHandle); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_IsOverlayVisible(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_019_instance->IsOverlayVisible(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_GetTransformForOverlayCoordinates(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin eTrackingOrigin, vr::HmdVector2_t coordinatesInOverlay, vr::HmdMatrix34_t* pmatTransform) { return fntable_Overlay_019_instance->GetTransformForOverlayCoordinates(ulOverlayHandle, eTrackingOrigin, coordinatesInOverlay, pmatTransform); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_PollNextOverlayEvent(vr::VROverlayHandle_t ulOverlayHandle, vr::VREvent_t* pEvent, uint32_t uncbVREvent) { return fntable_Overlay_019_instance->PollNextOverlayEvent(ulOverlayHandle, pEvent, uncbVREvent); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_GetOverlayInputMethod(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_019::VROverlayInputMethod* peInputMethod) { return fntable_Overlay_019_instance->GetOverlayInputMethod(ulOverlayHandle, peInputMethod); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_SetOverlayInputMethod(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_019::VROverlayInputMethod eInputMethod) { return fntable_Overlay_019_instance->SetOverlayInputMethod(ulOverlayHandle, eInputMethod); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_GetOverlayMouseScale(vr::VROverlayHandle_t ulOverlayHandle, vr::HmdVector2_t* pvecMouseScale) { return fntable_Overlay_019_instance->GetOverlayMouseScale(ulOverlayHandle, pvecMouseScale); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_SetOverlayMouseScale(vr::VROverlayHandle_t ulOverlayHandle, const vr::HmdVector2_t* pvecMouseScale) { return fntable_Overlay_019_instance->SetOverlayMouseScale(ulOverlayHandle, pvecMouseScale); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_ComputeOverlayIntersection(vr::VROverlayHandle_t ulOverlayHandle, const vr::IVROverlay_019::VROverlayIntersectionParams_t* pParams, vr::IVROverlay_019::VROverlayIntersectionResults_t* pResults) { return fntable_Overlay_019_instance->ComputeOverlayIntersection(ulOverlayHandle, pParams, pResults); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_IsHoverTargetOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_019_instance->IsHoverTargetOverlay(ulOverlayHandle); }
static vr::VROverlayHandle_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_GetGamepadFocusOverlay() { return fntable_Overlay_019_instance->GetGamepadFocusOverlay(); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_SetGamepadFocusOverlay(vr::VROverlayHandle_t ulNewFocusOverlay) { return fntable_Overlay_019_instance->SetGamepadFocusOverlay(ulNewFocusOverlay); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_SetOverlayNeighbor(vr::IVROverlay_019::EOverlayDirection eDirection, vr::VROverlayHandle_t ulFrom, vr::VROverlayHandle_t ulTo) { return fntable_Overlay_019_instance->SetOverlayNeighbor(eDirection, ulFrom, ulTo); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_MoveGamepadFocusToNeighbor(vr::IVROverlay_019::EOverlayDirection eDirection, vr::VROverlayHandle_t ulFrom) { return fntable_Overlay_019_instance->MoveGamepadFocusToNeighbor(eDirection, ulFrom); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_SetOverlayDualAnalogTransform(vr::VROverlayHandle_t ulOverlay, EDualAnalogWhich eWhich, const vr::HmdVector2_t* pvCenter, float fRadius) { return fntable_Overlay_019_instance->SetOverlayDualAnalogTransform(ulOverlay, eWhich, pvCenter, fRadius); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_GetOverlayDualAnalogTransform(vr::VROverlayHandle_t ulOverlay, EDualAnalogWhich eWhich, vr::HmdVector2_t* pvCenter, float* pfRadius) { return fntable_Overlay_019_instance->GetOverlayDualAnalogTransform(ulOverlay, eWhich, pvCenter, pfRadius); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_SetOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle, const vr::Texture_t* pTexture) { return fntable_Overlay_019_instance->SetOverlayTexture(ulOverlayHandle, pTexture); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_ClearOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_019_instance->ClearOverlayTexture(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_SetOverlayRaw(vr::VROverlayHandle_t ulOverlayHandle, void* pvBuffer, uint32_t unWidth, uint32_t unHeight, uint32_t unDepth) { return fntable_Overlay_019_instance->SetOverlayRaw(ulOverlayHandle, pvBuffer, unWidth, unHeight, unDepth); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_SetOverlayFromFile(vr::VROverlayHandle_t ulOverlayHandle, const char* pchFilePath) { return fntable_Overlay_019_instance->SetOverlayFromFile(ulOverlayHandle, pchFilePath); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_GetOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle, void** pNativeTextureHandle, void* pNativeTextureRef, uint32_t* pWidth, uint32_t* pHeight, uint32_t* pNativeFormat, vr::ETextureType* pAPIType, vr::EColorSpace* pColorSpace, vr::VRTextureBounds_t* pTextureBounds) { return fntable_Overlay_019_instance->GetOverlayTexture(ulOverlayHandle, pNativeTextureHandle, pNativeTextureRef, pWidth, pHeight, pNativeFormat, pAPIType, pColorSpace, pTextureBounds); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_ReleaseNativeOverlayHandle(vr::VROverlayHandle_t ulOverlayHandle, void* pNativeTextureHandle) { return fntable_Overlay_019_instance->ReleaseNativeOverlayHandle(ulOverlayHandle, pNativeTextureHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_GetOverlayTextureSize(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* pWidth, uint32_t* pHeight) { return fntable_Overlay_019_instance->GetOverlayTextureSize(ulOverlayHandle, pWidth, pHeight); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_CreateDashboardOverlay(const char* pchOverlayKey, const char* pchOverlayFriendlyName, vr::VROverlayHandle_t* pMainHandle, vr::VROverlayHandle_t* pThumbnailHandle) { return fntable_Overlay_019_instance->CreateDashboardOverlay(pchOverlayKey, pchOverlayFriendlyName, pMainHandle, pThumbnailHandle); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_IsDashboardVisible() { return fntable_Overlay_019_instance->IsDashboardVisible(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_IsActiveDashboardOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_019_instance->IsActiveDashboardOverlay(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_SetDashboardOverlaySceneProcess(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unProcessId) { return fntable_Overlay_019_instance->SetDashboardOverlaySceneProcess(ulOverlayHandle, unProcessId); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_GetDashboardOverlaySceneProcess(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* punProcessId) { return fntable_Overlay_019_instance->GetDashboardOverlaySceneProcess(ulOverlayHandle, punProcessId); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_ShowDashboard(const char* pchOverlayToShow) { return fntable_Overlay_019_instance->ShowDashboard(pchOverlayToShow); }
static vr::TrackedDeviceIndex_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_GetPrimaryDashboardDevice() { return fntable_Overlay_019_instance->GetPrimaryDashboardDevice(); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_ShowKeyboard(vr::IVROverlay_019::EGamepadTextInputMode eInputMode, vr::IVROverlay_019::EGamepadTextInputLineMode eLineInputMode, const char* pchDescription, uint32_t unCharMax, const char* pchExistingText, bool bUseMinimalMode, uint64_t uUserValue) { return fntable_Overlay_019_instance->ShowKeyboard(eInputMode, eLineInputMode, pchDescription, unCharMax, pchExistingText, bUseMinimalMode, uUserValue); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_ShowKeyboardForOverlay(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_019::EGamepadTextInputMode eInputMode, vr::IVROverlay_019::EGamepadTextInputLineMode eLineInputMode, const char* pchDescription, uint32_t unCharMax, const char* pchExistingText, bool bUseMinimalMode, uint64_t uUserValue) { return fntable_Overlay_019_instance->ShowKeyboardForOverlay(ulOverlayHandle, eInputMode, eLineInputMode, pchDescription, unCharMax, pchExistingText, bUseMinimalMode, uUserValue); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_GetKeyboardText(char* pchText, uint32_t cchText) { return fntable_Overlay_019_instance->GetKeyboardText(pchText, cchText); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_HideKeyboard() { return fntable_Overlay_019_instance->HideKeyboard(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_SetKeyboardTransformAbsolute(vr::ETrackingUniverseOrigin eTrackingOrigin, const vr::HmdMatrix34_t* pmatTrackingOriginToKeyboardTransform) { return fntable_Overlay_019_instance->SetKeyboardTransformAbsolute(eTrackingOrigin, pmatTrackingOriginToKeyboardTransform); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_SetKeyboardPositionForOverlay(vr::VROverlayHandle_t ulOverlayHandle, vr::HmdRect2_t avoidRect) { return fntable_Overlay_019_instance->SetKeyboardPositionForOverlay(ulOverlayHandle, avoidRect); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_SetOverlayIntersectionMask(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_019::VROverlayIntersectionMaskPrimitive_t* pMaskPrimitives, uint32_t unNumMaskPrimitives, uint32_t unPrimitiveSize) { return fntable_Overlay_019_instance->SetOverlayIntersectionMask(ulOverlayHandle, pMaskPrimitives, unNumMaskPrimitives, unPrimitiveSize); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_GetOverlayFlags(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* pFlags) { return fntable_Overlay_019_instance->GetOverlayFlags(ulOverlayHandle, pFlags); }
static vr::IVROverlay_019::VRMessageOverlayResponse OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_ShowMessageOverlay(const char* pchText, const char* pchCaption, const char* pchButton0Text, const char* pchButton1Text, const char* pchButton2Text, const char* pchButton3Text) { return fntable_Overlay_019_instance->ShowMessageOverlay(pchText, pchCaption, pchButton0Text, pchButton1Text, pchButton2Text, pchButton3Text); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_019_impl_CloseMessageOverlay() { return fntable_Overlay_019_instance->CloseMessageOverlay(); }
static void *fntable_Overlay_019_funcs[] = {
	(void*) fntable_Overlay_019_impl_FindOverlay,
	(void*) fntable_Overlay_019_impl_CreateOverlay,
	(void*) fntable_Overlay_019_impl_DestroyOverlay,
	(void*) fntable_Overlay_019_impl_SetHighQualityOverlay,
	(void*) fntable_Overlay_019_impl_GetHighQualityOverlay,
	(void*) fntable_Overlay_019_impl_GetOverlayKey,
	(void*) fntable_Overlay_019_impl_GetOverlayName,
	(void*) fntable_Overlay_019_impl_SetOverlayName,
	(void*) fntable_Overlay_019_impl_GetOverlayImageData,
	(void*) fntable_Overlay_019_impl_GetOverlayErrorNameFromEnum,
	(void*) fntable_Overlay_019_impl_SetOverlayRenderingPid,
	(void*) fntable_Overlay_019_impl_GetOverlayRenderingPid,
	(void*) fntable_Overlay_019_impl_SetOverlayFlag,
	(void*) fntable_Overlay_019_impl_GetOverlayFlag,
	(void*) fntable_Overlay_019_impl_SetOverlayColor,
	(void*) fntable_Overlay_019_impl_GetOverlayColor,
	(void*) fntable_Overlay_019_impl_SetOverlayAlpha,
	(void*) fntable_Overlay_019_impl_GetOverlayAlpha,
	(void*) fntable_Overlay_019_impl_SetOverlayTexelAspect,
	(void*) fntable_Overlay_019_impl_GetOverlayTexelAspect,
	(void*) fntable_Overlay_019_impl_SetOverlaySortOrder,
	(void*) fntable_Overlay_019_impl_GetOverlaySortOrder,
	(void*) fntable_Overlay_019_impl_SetOverlayWidthInMeters,
	(void*) fntable_Overlay_019_impl_GetOverlayWidthInMeters,
	(void*) fntable_Overlay_019_impl_SetOverlayAutoCurveDistanceRangeInMeters,
	(void*) fntable_Overlay_019_impl_GetOverlayAutoCurveDistanceRangeInMeters,
	(void*) fntable_Overlay_019_impl_SetOverlayTextureColorSpace,
	(void*) fntable_Overlay_019_impl_GetOverlayTextureColorSpace,
	(void*) fntable_Overlay_019_impl_SetOverlayTextureBounds,
	(void*) fntable_Overlay_019_impl_GetOverlayTextureBounds,
	(void*) fntable_Overlay_019_impl_GetOverlayRenderModel,
	(void*) fntable_Overlay_019_impl_SetOverlayRenderModel,
	(void*) fntable_Overlay_019_impl_GetOverlayTransformType,
	(void*) fntable_Overlay_019_impl_SetOverlayTransformAbsolute,
	(void*) fntable_Overlay_019_impl_GetOverlayTransformAbsolute,
	(void*) fntable_Overlay_019_impl_SetOverlayTransformTrackedDeviceRelative,
	(void*) fntable_Overlay_019_impl_GetOverlayTransformTrackedDeviceRelative,
	(void*) fntable_Overlay_019_impl_SetOverlayTransformTrackedDeviceComponent,
	(void*) fntable_Overlay_019_impl_GetOverlayTransformTrackedDeviceComponent,
	(void*) fntable_Overlay_019_impl_GetOverlayTransformOverlayRelative,
	(void*) fntable_Overlay_019_impl_SetOverlayTransformOverlayRelative,
	(void*) fntable_Overlay_019_impl_ShowOverlay,
	(void*) fntable_Overlay_019_impl_HideOverlay,
	(void*) fntable_Overlay_019_impl_IsOverlayVisible,
	(void*) fntable_Overlay_019_impl_GetTransformForOverlayCoordinates,
	(void*) fntable_Overlay_019_impl_PollNextOverlayEvent,
	(void*) fntable_Overlay_019_impl_GetOverlayInputMethod,
	(void*) fntable_Overlay_019_impl_SetOverlayInputMethod,
	(void*) fntable_Overlay_019_impl_GetOverlayMouseScale,
	(void*) fntable_Overlay_019_impl_SetOverlayMouseScale,
	(void*) fntable_Overlay_019_impl_ComputeOverlayIntersection,
	(void*) fntable_Overlay_019_impl_IsHoverTargetOverlay,
	(void*) fntable_Overlay_019_impl_GetGamepadFocusOverlay,
	(void*) fntable_Overlay_019_impl_SetGamepadFocusOverlay,
	(void*) fntable_Overlay_019_impl_SetOverlayNeighbor,
	(void*) fntable_Overlay_019_impl_MoveGamepadFocusToNeighbor,
	(void*) fntable_Overlay_019_impl_SetOverlayDualAnalogTransform,
	(void*) fntable_Overlay_019_impl_GetOverlayDualAnalogTransform,
	(void*) fntable_Overlay_019_impl_SetOverlayTexture,
	(void*) fntable_Overlay_019_impl_ClearOverlayTexture,
	(void*) fntable_Overlay_019_impl_SetOverlayRaw,
	(void*) fntable_Overlay_019_impl_SetOverlayFromFile,
	(void*) fntable_Overlay_019_impl_GetOverlayTexture,
	(void*) fntable_Overlay_019_impl_ReleaseNativeOverlayHandle,
	(void*) fntable_Overlay_019_impl_GetOverlayTextureSize,
	(void*) fntable_Overlay_019_impl_CreateDashboardOverlay,
	(void*) fntable_Overlay_019_impl_IsDashboardVisible,
	(void*) fntable_Overlay_019_impl_IsActiveDashboardOverlay,
	(void*) fntable_Overlay_019_impl_SetDashboardOverlaySceneProcess,
	(void*) fntable_Overlay_019_impl_GetDashboardOverlaySceneProcess,
	(void*) fntable_Overlay_019_impl_ShowDashboard,
	(void*) fntable_Overlay_019_impl_GetPrimaryDashboardDevice,
	(void*) fntable_Overlay_019_impl_ShowKeyboard,
	(void*) fntable_Overlay_019_impl_ShowKeyboardForOverlay,
	(void*) fntable_Overlay_019_impl_GetKeyboardText,
	(void*) fntable_Overlay_019_impl_HideKeyboard,
	(void*) fntable_Overlay_019_impl_SetKeyboardTransformAbsolute,
	(void*) fntable_Overlay_019_impl_SetKeyboardPositionForOverlay,
	(void*) fntable_Overlay_019_impl_SetOverlayIntersectionMask,
	(void*) fntable_Overlay_019_impl_GetOverlayFlags,
	(void*) fntable_Overlay_019_impl_ShowMessageOverlay,
	(void*) fntable_Overlay_019_impl_CloseMessageOverlay,
};
void** CVROverlay_019::_GetStatFuncList() { fntable_Overlay_019_instance = this; return fntable_Overlay_019_funcs; }
void CVROverlay_019::Delete() { delete this; }
// Misc for CVROverlay_020:
CVROverlay_020::CVROverlay_020() : base(GetCreateBaseOverlay()) {}
// Interface methods for CVROverlay_020:
vr::EVROverlayError CVROverlay_020::FindOverlay(const char* pchOverlayKey, vr::VROverlayHandle_t* pOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->FindOverlay(pchOverlayKey, pOverlayHandle);
}
vr::EVROverlayError CVROverlay_020::CreateOverlay(const char* pchOverlayKey, const char* pchOverlayName, vr::VROverlayHandle_t* pOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->CreateOverlay(pchOverlayKey, pchOverlayName, pOverlayHandle);
}
vr::EVROverlayError CVROverlay_020::DestroyOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->DestroyOverlay(ulOverlayHandle);
}
uint32_t CVROverlay_020::GetOverlayKey(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::EVROverlayError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->GetOverlayKey(ulOverlayHandle, pchValue, unBufferSize, pError);
}
uint32_t CVROverlay_020::GetOverlayName(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::EVROverlayError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->GetOverlayName(ulOverlayHandle, pchValue, unBufferSize, pError);
}
vr::EVROverlayError CVROverlay_020::SetOverlayName(vr::VROverlayHandle_t ulOverlayHandle, const char* pchName) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->SetOverlayName(ulOverlayHandle, pchName);
}
vr::EVROverlayError CVROverlay_020::GetOverlayImageData(vr::VROverlayHandle_t ulOverlayHandle, void* pvBuffer, uint32_t unBufferSize, uint32_t* punWidth, uint32_t* punHeight) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->GetOverlayImageData(ulOverlayHandle, pvBuffer, unBufferSize, punWidth, punHeight);
}
const char* CVROverlay_020::GetOverlayErrorNameFromEnum(vr::EVROverlayError error) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->GetOverlayErrorNameFromEnum(error);
}
vr::EVROverlayError CVROverlay_020::SetOverlayRenderingPid(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unPID) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->SetOverlayRenderingPid(ulOverlayHandle, unPID);
}
uint32_t CVROverlay_020::GetOverlayRenderingPid(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->GetOverlayRenderingPid(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_020::SetOverlayFlag(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_020::VROverlayFlags eOverlayFlag, bool bEnabled) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->SetOverlayFlag(ulOverlayHandle, (OOVR_VROverlayFlags) eOverlayFlag, bEnabled);
}
vr::EVROverlayError CVROverlay_020::GetOverlayFlag(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_020::VROverlayFlags eOverlayFlag, bool* pbEnabled) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->GetOverlayFlag(ulOverlayHandle, (OOVR_VROverlayFlags) eOverlayFlag, pbEnabled);
}
vr::EVROverlayError CVROverlay_020::SetOverlayColor(vr::VROverlayHandle_t ulOverlayHandle, float fRed, float fGreen, float fBlue) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->SetOverlayColor(ulOverlayHandle, fRed, fGreen, fBlue);
}
vr::EVROverlayError CVROverlay_020::GetOverlayColor(vr::VROverlayHandle_t ulOverlayHandle, float* pfRed, float* pfGreen, float* pfBlue) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->GetOverlayColor(ulOverlayHandle, pfRed, pfGreen, pfBlue);
}
vr::EVROverlayError CVROverlay_020::SetOverlayAlpha(vr::VROverlayHandle_t ulOverlayHandle, float fAlpha) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->SetOverlayAlpha(ulOverlayHandle, fAlpha);
}
vr::EVROverlayError CVROverlay_020::GetOverlayAlpha(vr::VROverlayHandle_t ulOverlayHandle, float* pfAlpha) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->GetOverlayAlpha(ulOverlayHandle, pfAlpha);
}
vr::EVROverlayError CVROverlay_020::SetOverlayTexelAspect(vr::VROverlayHandle_t ulOverlayHandle, float fTexelAspect) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->SetOverlayTexelAspect(ulOverlayHandle, fTexelAspect);
}
vr::EVROverlayError CVROverlay_020::GetOverlayTexelAspect(vr::VROverlayHandle_t ulOverlayHandle, float* pfTexelAspect) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->GetOverlayTexelAspect(ulOverlayHandle, pfTexelAspect);
}
vr::EVROverlayError CVROverlay_020::SetOverlaySortOrder(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unSortOrder) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->SetOverlaySortOrder(ulOverlayHandle, unSortOrder);
}
vr::EVROverlayError CVROverlay_020::GetOverlaySortOrder(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* punSortOrder) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->GetOverlaySortOrder(ulOverlayHandle, punSortOrder);
}
vr::EVROverlayError CVROverlay_020::SetOverlayWidthInMeters(vr::VROverlayHandle_t ulOverlayHandle, float fWidthInMeters) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->SetOverlayWidthInMeters(ulOverlayHandle, fWidthInMeters);
}
vr::EVROverlayError CVROverlay_020::GetOverlayWidthInMeters(vr::VROverlayHandle_t ulOverlayHandle, float* pfWidthInMeters) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->GetOverlayWidthInMeters(ulOverlayHandle, pfWidthInMeters);
}
vr::EVROverlayError CVROverlay_020::SetOverlayAutoCurveDistanceRangeInMeters(vr::VROverlayHandle_t ulOverlayHandle, float fMinDistanceInMeters, float fMaxDistanceInMeters) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->SetOverlayAutoCurveDistanceRangeInMeters(ulOverlayHandle, fMinDistanceInMeters, fMaxDistanceInMeters);
}
vr::EVROverlayError CVROverlay_020::GetOverlayAutoCurveDistanceRangeInMeters(vr::VROverlayHandle_t ulOverlayHandle, float* pfMinDistanceInMeters, float* pfMaxDistanceInMeters) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->GetOverlayAutoCurveDistanceRangeInMeters(ulOverlayHandle, pfMinDistanceInMeters, pfMaxDistanceInMeters);
}
vr::EVROverlayError CVROverlay_020::SetOverlayTextureColorSpace(vr::VROverlayHandle_t ulOverlayHandle, vr::EColorSpace eTextureColorSpace) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->SetOverlayTextureColorSpace(ulOverlayHandle, eTextureColorSpace);
}
vr::EVROverlayError CVROverlay_020::GetOverlayTextureColorSpace(vr::VROverlayHandle_t ulOverlayHandle, vr::EColorSpace* peTextureColorSpace) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->GetOverlayTextureColorSpace(ulOverlayHandle, peTextureColorSpace);
}
vr::EVROverlayError CVROverlay_020::SetOverlayTextureBounds(vr::VROverlayHandle_t ulOverlayHandle, const vr::VRTextureBounds_t* pOverlayTextureBounds) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->SetOverlayTextureBounds(ulOverlayHandle, pOverlayTextureBounds);
}
vr::EVROverlayError CVROverlay_020::GetOverlayTextureBounds(vr::VROverlayHandle_t ulOverlayHandle, vr::VRTextureBounds_t* pOverlayTextureBounds) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->GetOverlayTextureBounds(ulOverlayHandle, pOverlayTextureBounds);
}
uint32_t CVROverlay_020::GetOverlayRenderModel(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::HmdColor_t* pColor, vr::EVROverlayError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->GetOverlayRenderModel(ulOverlayHandle, pchValue, unBufferSize, pColor, pError);
}
vr::EVROverlayError CVROverlay_020::SetOverlayRenderModel(vr::VROverlayHandle_t ulOverlayHandle, const char* pchRenderModel, const vr::HmdColor_t* pColor) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->SetOverlayRenderModel(ulOverlayHandle, pchRenderModel, pColor);
}
vr::EVROverlayError CVROverlay_020::GetOverlayTransformType(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_020::VROverlayTransformType* peTransformType) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->GetOverlayTransformType(ulOverlayHandle, (OOVR_VROverlayTransformType*) peTransformType);
}
vr::EVROverlayError CVROverlay_020::SetOverlayTransformAbsolute(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin eTrackingOrigin, const vr::HmdMatrix34_t* pmatTrackingOriginToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->SetOverlayTransformAbsolute(ulOverlayHandle, eTrackingOrigin, pmatTrackingOriginToOverlayTransform);
}
vr::EVROverlayError CVROverlay_020::GetOverlayTransformAbsolute(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin* peTrackingOrigin, vr::HmdMatrix34_t* pmatTrackingOriginToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->GetOverlayTransformAbsolute(ulOverlayHandle, peTrackingOrigin, pmatTrackingOriginToOverlayTransform);
}
vr::EVROverlayError CVROverlay_020::SetOverlayTransformTrackedDeviceRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unTrackedDevice, const vr::HmdMatrix34_t* pmatTrackedDeviceToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->SetOverlayTransformTrackedDeviceRelative(ulOverlayHandle, unTrackedDevice, pmatTrackedDeviceToOverlayTransform);
}
vr::EVROverlayError CVROverlay_020::GetOverlayTransformTrackedDeviceRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t* punTrackedDevice, vr::HmdMatrix34_t* pmatTrackedDeviceToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->GetOverlayTransformTrackedDeviceRelative(ulOverlayHandle, punTrackedDevice, pmatTrackedDeviceToOverlayTransform);
}
vr::EVROverlayError CVROverlay_020::SetOverlayTransformTrackedDeviceComponent(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unDeviceIndex, const char* pchComponentName) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->SetOverlayTransformTrackedDeviceComponent(ulOverlayHandle, unDeviceIndex, pchComponentName);
}
vr::EVROverlayError CVROverlay_020::GetOverlayTransformTrackedDeviceComponent(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t* punDeviceIndex, char* pchComponentName, uint32_t unComponentNameSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->GetOverlayTransformTrackedDeviceComponent(ulOverlayHandle, punDeviceIndex, pchComponentName, unComponentNameSize);
}
vr::EVROverlayError CVROverlay_020::GetOverlayTransformOverlayRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::VROverlayHandle_t* ulOverlayHandleParent, vr::HmdMatrix34_t* pmatParentOverlayToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->GetOverlayTransformOverlayRelative(ulOverlayHandle, ulOverlayHandleParent, pmatParentOverlayToOverlayTransform);
}
vr::EVROverlayError CVROverlay_020::SetOverlayTransformOverlayRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::VROverlayHandle_t ulOverlayHandleParent, const vr::HmdMatrix34_t* pmatParentOverlayToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->SetOverlayTransformOverlayRelative(ulOverlayHandle, ulOverlayHandleParent, pmatParentOverlayToOverlayTransform);
}
vr::EVROverlayError CVROverlay_020::ShowOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->ShowOverlay(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_020::HideOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->HideOverlay(ulOverlayHandle);
}
bool CVROverlay_020::IsOverlayVisible(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->IsOverlayVisible(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_020::GetTransformForOverlayCoordinates(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin eTrackingOrigin, vr::HmdVector2_t coordinatesInOverlay, vr::HmdMatrix34_t* pmatTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->GetTransformForOverlayCoordinates(ulOverlayHandle, eTrackingOrigin, coordinatesInOverlay, pmatTransform);
}
bool CVROverlay_020::PollNextOverlayEvent(vr::VROverlayHandle_t ulOverlayHandle, vr::VREvent_t* pEvent, uint32_t uncbVREvent) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->PollNextOverlayEvent(ulOverlayHandle, pEvent, uncbVREvent);
}
vr::EVROverlayError CVROverlay_020::GetOverlayInputMethod(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_020::VROverlayInputMethod* peInputMethod) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->GetOverlayInputMethod(ulOverlayHandle, (OOVR_VROverlayInputMethod*) peInputMethod);
}
vr::EVROverlayError CVROverlay_020::SetOverlayInputMethod(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_020::VROverlayInputMethod eInputMethod) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->SetOverlayInputMethod(ulOverlayHandle, (OOVR_VROverlayInputMethod) eInputMethod);
}
vr::EVROverlayError CVROverlay_020::GetOverlayMouseScale(vr::VROverlayHandle_t ulOverlayHandle, vr::HmdVector2_t* pvecMouseScale) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->GetOverlayMouseScale(ulOverlayHandle, pvecMouseScale);
}
vr::EVROverlayError CVROverlay_020::SetOverlayMouseScale(vr::VROverlayHandle_t ulOverlayHandle, const vr::HmdVector2_t* pvecMouseScale) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->SetOverlayMouseScale(ulOverlayHandle, pvecMouseScale);
}
bool CVROverlay_020::ComputeOverlayIntersection(vr::VROverlayHandle_t ulOverlayHandle, const vr::IVROverlay_020::VROverlayIntersectionParams_t* pParams, vr::IVROverlay_020::VROverlayIntersectionResults_t* pResults) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->ComputeOverlayIntersection(ulOverlayHandle, (const OOVR_VROverlayIntersectionParams_t*) pParams, (OOVR_VROverlayIntersectionResults_t*) pResults);
}
bool CVROverlay_020::IsHoverTargetOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->IsHoverTargetOverlay(ulOverlayHandle);
}
vr::VROverlayHandle_t CVROverlay_020::GetGamepadFocusOverlay() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->GetGamepadFocusOverlay();
}
vr::EVROverlayError CVROverlay_020::SetGamepadFocusOverlay(vr::VROverlayHandle_t ulNewFocusOverlay) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->SetGamepadFocusOverlay(ulNewFocusOverlay);
}
vr::EVROverlayError CVROverlay_020::SetOverlayNeighbor(vr::IVROverlay_020::EOverlayDirection eDirection, vr::VROverlayHandle_t ulFrom, vr::VROverlayHandle_t ulTo) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->SetOverlayNeighbor((OOVR_EOverlayDirection) eDirection, ulFrom, ulTo);
}
vr::EVROverlayError CVROverlay_020::MoveGamepadFocusToNeighbor(vr::IVROverlay_020::EOverlayDirection eDirection, vr::VROverlayHandle_t ulFrom) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->MoveGamepadFocusToNeighbor((OOVR_EOverlayDirection) eDirection, ulFrom);
}
vr::EVROverlayError CVROverlay_020::SetOverlayDualAnalogTransform(vr::VROverlayHandle_t ulOverlay, EDualAnalogWhich eWhich, const vr::HmdVector2_t* pvCenter, float fRadius) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->SetOverlayDualAnalogTransform(ulOverlay, eWhich, pvCenter, fRadius);
}
vr::EVROverlayError CVROverlay_020::GetOverlayDualAnalogTransform(vr::VROverlayHandle_t ulOverlay, EDualAnalogWhich eWhich, vr::HmdVector2_t* pvCenter, float* pfRadius) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->GetOverlayDualAnalogTransform(ulOverlay, eWhich, pvCenter, pfRadius);
}
vr::EVROverlayError CVROverlay_020::SetOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle, const vr::Texture_t* pTexture) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->SetOverlayTexture(ulOverlayHandle, pTexture);
}
vr::EVROverlayError CVROverlay_020::ClearOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->ClearOverlayTexture(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_020::SetOverlayRaw(vr::VROverlayHandle_t ulOverlayHandle, void* pvBuffer, uint32_t unWidth, uint32_t unHeight, uint32_t unDepth) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->SetOverlayRaw(ulOverlayHandle, pvBuffer, unWidth, unHeight, unDepth);
}
vr::EVROverlayError CVROverlay_020::SetOverlayFromFile(vr::VROverlayHandle_t ulOverlayHandle, const char* pchFilePath) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->SetOverlayFromFile(ulOverlayHandle, pchFilePath);
}
vr::EVROverlayError CVROverlay_020::GetOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle, void** pNativeTextureHandle, void* pNativeTextureRef, uint32_t* pWidth, uint32_t* pHeight, uint32_t* pNativeFormat, vr::ETextureType* pAPIType, vr::EColorSpace* pColorSpace, vr::VRTextureBounds_t* pTextureBounds) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->GetOverlayTexture(ulOverlayHandle, pNativeTextureHandle, pNativeTextureRef, pWidth, pHeight, pNativeFormat, pAPIType, pColorSpace, pTextureBounds);
}
vr::EVROverlayError CVROverlay_020::ReleaseNativeOverlayHandle(vr::VROverlayHandle_t ulOverlayHandle, void* pNativeTextureHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->ReleaseNativeOverlayHandle(ulOverlayHandle, pNativeTextureHandle);
}
vr::EVROverlayError CVROverlay_020::GetOverlayTextureSize(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* pWidth, uint32_t* pHeight) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->GetOverlayTextureSize(ulOverlayHandle, pWidth, pHeight);
}
vr::EVROverlayError CVROverlay_020::CreateDashboardOverlay(const char* pchOverlayKey, const char* pchOverlayFriendlyName, vr::VROverlayHandle_t* pMainHandle, vr::VROverlayHandle_t* pThumbnailHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->CreateDashboardOverlay(pchOverlayKey, pchOverlayFriendlyName, pMainHandle, pThumbnailHandle);
}
bool CVROverlay_020::IsDashboardVisible() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->IsDashboardVisible();
}
bool CVROverlay_020::IsActiveDashboardOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->IsActiveDashboardOverlay(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_020::SetDashboardOverlaySceneProcess(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unProcessId) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->SetDashboardOverlaySceneProcess(ulOverlayHandle, unProcessId);
}
vr::EVROverlayError CVROverlay_020::GetDashboardOverlaySceneProcess(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* punProcessId) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->GetDashboardOverlaySceneProcess(ulOverlayHandle, punProcessId);
}
void CVROverlay_020::ShowDashboard(const char* pchOverlayToShow) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->ShowDashboard(pchOverlayToShow);
}
vr::TrackedDeviceIndex_t CVROverlay_020::GetPrimaryDashboardDevice() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->GetPrimaryDashboardDevice();
}
vr::EVROverlayError CVROverlay_020::ShowKeyboard(vr::IVROverlay_020::EGamepadTextInputMode eInputMode, vr::IVROverlay_020::EGamepadTextInputLineMode eLineInputMode, const char* pchDescription, uint32_t unCharMax, const char* pchExistingText, bool bUseMinimalMode, uint64_t uUserValue) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->ShowKeyboard((OOVR_EGamepadTextInputMode) eInputMode, (OOVR_EGamepadTextInputLineMode) eLineInputMode, pchDescription, unCharMax, pchExistingText, bUseMinimalMode, uUserValue);
}
vr::EVROverlayError CVROverlay_020::ShowKeyboardForOverlay(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_020::EGamepadTextInputMode eInputMode, vr::IVROverlay_020::EGamepadTextInputLineMode eLineInputMode, const char* pchDescription, uint32_t unCharMax, const char* pchExistingText, bool bUseMinimalMode, uint64_t uUserValue) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->ShowKeyboardForOverlay(ulOverlayHandle, (OOVR_EGamepadTextInputMode) eInputMode, (OOVR_EGamepadTextInputLineMode) eLineInputMode, pchDescription, unCharMax, pchExistingText, bUseMinimalMode, uUserValue);
}
uint32_t CVROverlay_020::GetKeyboardText(char* pchText, uint32_t cchText) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->GetKeyboardText(pchText, cchText);
}
void CVROverlay_020::HideKeyboard() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->HideKeyboard();
}
void CVROverlay_020::SetKeyboardTransformAbsolute(vr::ETrackingUniverseOrigin eTrackingOrigin, const vr::HmdMatrix34_t* pmatTrackingOriginToKeyboardTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->SetKeyboardTransformAbsolute(eTrackingOrigin, pmatTrackingOriginToKeyboardTransform);
}
void CVROverlay_020::SetKeyboardPositionForOverlay(vr::VROverlayHandle_t ulOverlayHandle, vr::HmdRect2_t avoidRect) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->SetKeyboardPositionForOverlay(ulOverlayHandle, avoidRect);
}
vr::EVROverlayError CVROverlay_020::SetOverlayIntersectionMask(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_020::VROverlayIntersectionMaskPrimitive_t* pMaskPrimitives, uint32_t unNumMaskPrimitives, uint32_t unPrimitiveSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->SetOverlayIntersectionMask(ulOverlayHandle, (OOVR_VROverlayIntersectionMaskPrimitive_t*) pMaskPrimitives, unNumMaskPrimitives, unPrimitiveSize);
}
vr::EVROverlayError CVROverlay_020::GetOverlayFlags(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* pFlags) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->GetOverlayFlags(ulOverlayHandle, pFlags);
}
vr::IVROverlay_020::VRMessageOverlayResponse CVROverlay_020::ShowMessageOverlay(const char* pchText, const char* pchCaption, const char* pchButton0Text, const char* pchButton1Text, const char* pchButton2Text, const char* pchButton3Text) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return (vr::IVROverlay_020::VRMessageOverlayResponse) base->ShowMessageOverlay(pchText, pchCaption, pchButton0Text, pchButton1Text, pchButton2Text, pchButton3Text);
}
void CVROverlay_020::CloseMessageOverlay() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_020)");
	return base->CloseMessageOverlay();
}
// FnTable for CVROverlay_020:
static CVROverlay_020 *fntable_Overlay_020_instance = NULL;
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_FindOverlay(const char* pchOverlayKey, vr::VROverlayHandle_t* pOverlayHandle) { return fntable_Overlay_020_instance->FindOverlay(pchOverlayKey, pOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_CreateOverlay(const char* pchOverlayKey, const char* pchOverlayName, vr::VROverlayHandle_t* pOverlayHandle) { return fntable_Overlay_020_instance->CreateOverlay(pchOverlayKey, pchOverlayName, pOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_DestroyOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_020_instance->DestroyOverlay(ulOverlayHandle); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_GetOverlayKey(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::EVROverlayError* pError) { return fntable_Overlay_020_instance->GetOverlayKey(ulOverlayHandle, pchValue, unBufferSize, pError); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_GetOverlayName(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::EVROverlayError* pError) { return fntable_Overlay_020_instance->GetOverlayName(ulOverlayHandle, pchValue, unBufferSize, pError); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_SetOverlayName(vr::VROverlayHandle_t ulOverlayHandle, const char* pchName) { return fntable_Overlay_020_instance->SetOverlayName(ulOverlayHandle, pchName); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_GetOverlayImageData(vr::VROverlayHandle_t ulOverlayHandle, void* pvBuffer, uint32_t unBufferSize, uint32_t* punWidth, uint32_t* punHeight) { return fntable_Overlay_020_instance->GetOverlayImageData(ulOverlayHandle, pvBuffer, unBufferSize, punWidth, punHeight); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_GetOverlayErrorNameFromEnum(vr::EVROverlayError error) { return fntable_Overlay_020_instance->GetOverlayErrorNameFromEnum(error); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_SetOverlayRenderingPid(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unPID) { return fntable_Overlay_020_instance->SetOverlayRenderingPid(ulOverlayHandle, unPID); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_GetOverlayRenderingPid(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_020_instance->GetOverlayRenderingPid(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_SetOverlayFlag(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_020::VROverlayFlags eOverlayFlag, bool bEnabled) { return fntable_Overlay_020_instance->SetOverlayFlag(ulOverlayHandle, eOverlayFlag, bEnabled); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_GetOverlayFlag(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_020::VROverlayFlags eOverlayFlag, bool* pbEnabled) { return fntable_Overlay_020_instance->GetOverlayFlag(ulOverlayHandle, eOverlayFlag, pbEnabled); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_SetOverlayColor(vr::VROverlayHandle_t ulOverlayHandle, float fRed, float fGreen, float fBlue) { return fntable_Overlay_020_instance->SetOverlayColor(ulOverlayHandle, fRed, fGreen, fBlue); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_GetOverlayColor(vr::VROverlayHandle_t ulOverlayHandle, float* pfRed, float* pfGreen, float* pfBlue) { return fntable_Overlay_020_instance->GetOverlayColor(ulOverlayHandle, pfRed, pfGreen, pfBlue); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_SetOverlayAlpha(vr::VROverlayHandle_t ulOverlayHandle, float fAlpha) { return fntable_Overlay_020_instance->SetOverlayAlpha(ulOverlayHandle, fAlpha); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_GetOverlayAlpha(vr::VROverlayHandle_t ulOverlayHandle, float* pfAlpha) { return fntable_Overlay_020_instance->GetOverlayAlpha(ulOverlayHandle, pfAlpha); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_SetOverlayTexelAspect(vr::VROverlayHandle_t ulOverlayHandle, float fTexelAspect) { return fntable_Overlay_020_instance->SetOverlayTexelAspect(ulOverlayHandle, fTexelAspect); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_GetOverlayTexelAspect(vr::VROverlayHandle_t ulOverlayHandle, float* pfTexelAspect) { return fntable_Overlay_020_instance->GetOverlayTexelAspect(ulOverlayHandle, pfTexelAspect); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_SetOverlaySortOrder(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unSortOrder) { return fntable_Overlay_020_instance->SetOverlaySortOrder(ulOverlayHandle, unSortOrder); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_GetOverlaySortOrder(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* punSortOrder) { return fntable_Overlay_020_instance->GetOverlaySortOrder(ulOverlayHandle, punSortOrder); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_SetOverlayWidthInMeters(vr::VROverlayHandle_t ulOverlayHandle, float fWidthInMeters) { return fntable_Overlay_020_instance->SetOverlayWidthInMeters(ulOverlayHandle, fWidthInMeters); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_GetOverlayWidthInMeters(vr::VROverlayHandle_t ulOverlayHandle, float* pfWidthInMeters) { return fntable_Overlay_020_instance->GetOverlayWidthInMeters(ulOverlayHandle, pfWidthInMeters); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_SetOverlayAutoCurveDistanceRangeInMeters(vr::VROverlayHandle_t ulOverlayHandle, float fMinDistanceInMeters, float fMaxDistanceInMeters) { return fntable_Overlay_020_instance->SetOverlayAutoCurveDistanceRangeInMeters(ulOverlayHandle, fMinDistanceInMeters, fMaxDistanceInMeters); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_GetOverlayAutoCurveDistanceRangeInMeters(vr::VROverlayHandle_t ulOverlayHandle, float* pfMinDistanceInMeters, float* pfMaxDistanceInMeters) { return fntable_Overlay_020_instance->GetOverlayAutoCurveDistanceRangeInMeters(ulOverlayHandle, pfMinDistanceInMeters, pfMaxDistanceInMeters); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_SetOverlayTextureColorSpace(vr::VROverlayHandle_t ulOverlayHandle, vr::EColorSpace eTextureColorSpace) { return fntable_Overlay_020_instance->SetOverlayTextureColorSpace(ulOverlayHandle, eTextureColorSpace); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_GetOverlayTextureColorSpace(vr::VROverlayHandle_t ulOverlayHandle, vr::EColorSpace* peTextureColorSpace) { return fntable_Overlay_020_instance->GetOverlayTextureColorSpace(ulOverlayHandle, peTextureColorSpace); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_SetOverlayTextureBounds(vr::VROverlayHandle_t ulOverlayHandle, const vr::VRTextureBounds_t* pOverlayTextureBounds) { return fntable_Overlay_020_instance->SetOverlayTextureBounds(ulOverlayHandle, pOverlayTextureBounds); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_GetOverlayTextureBounds(vr::VROverlayHandle_t ulOverlayHandle, vr::VRTextureBounds_t* pOverlayTextureBounds) { return fntable_Overlay_020_instance->GetOverlayTextureBounds(ulOverlayHandle, pOverlayTextureBounds); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_GetOverlayRenderModel(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::HmdColor_t* pColor, vr::EVROverlayError* pError) { return fntable_Overlay_020_instance->GetOverlayRenderModel(ulOverlayHandle, pchValue, unBufferSize, pColor, pError); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_SetOverlayRenderModel(vr::VROverlayHandle_t ulOverlayHandle, const char* pchRenderModel, const vr::HmdColor_t* pColor) { return fntable_Overlay_020_instance->SetOverlayRenderModel(ulOverlayHandle, pchRenderModel, pColor); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_GetOverlayTransformType(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_020::VROverlayTransformType* peTransformType) { return fntable_Overlay_020_instance->GetOverlayTransformType(ulOverlayHandle, peTransformType); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_SetOverlayTransformAbsolute(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin eTrackingOrigin, const vr::HmdMatrix34_t* pmatTrackingOriginToOverlayTransform) { return fntable_Overlay_020_instance->SetOverlayTransformAbsolute(ulOverlayHandle, eTrackingOrigin, pmatTrackingOriginToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_GetOverlayTransformAbsolute(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin* peTrackingOrigin, vr::HmdMatrix34_t* pmatTrackingOriginToOverlayTransform) { return fntable_Overlay_020_instance->GetOverlayTransformAbsolute(ulOverlayHandle, peTrackingOrigin, pmatTrackingOriginToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_SetOverlayTransformTrackedDeviceRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unTrackedDevice, const vr::HmdMatrix34_t* pmatTrackedDeviceToOverlayTransform) { return fntable_Overlay_020_instance->SetOverlayTransformTrackedDeviceRelative(ulOverlayHandle, unTrackedDevice, pmatTrackedDeviceToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_GetOverlayTransformTrackedDeviceRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t* punTrackedDevice, vr::HmdMatrix34_t* pmatTrackedDeviceToOverlayTransform) { return fntable_Overlay_020_instance->GetOverlayTransformTrackedDeviceRelative(ulOverlayHandle, punTrackedDevice, pmatTrackedDeviceToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_SetOverlayTransformTrackedDeviceComponent(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unDeviceIndex, const char* pchComponentName) { return fntable_Overlay_020_instance->SetOverlayTransformTrackedDeviceComponent(ulOverlayHandle, unDeviceIndex, pchComponentName); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_GetOverlayTransformTrackedDeviceComponent(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t* punDeviceIndex, char* pchComponentName, uint32_t unComponentNameSize) { return fntable_Overlay_020_instance->GetOverlayTransformTrackedDeviceComponent(ulOverlayHandle, punDeviceIndex, pchComponentName, unComponentNameSize); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_GetOverlayTransformOverlayRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::VROverlayHandle_t* ulOverlayHandleParent, vr::HmdMatrix34_t* pmatParentOverlayToOverlayTransform) { return fntable_Overlay_020_instance->GetOverlayTransformOverlayRelative(ulOverlayHandle, ulOverlayHandleParent, pmatParentOverlayToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_SetOverlayTransformOverlayRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::VROverlayHandle_t ulOverlayHandleParent, const vr::HmdMatrix34_t* pmatParentOverlayToOverlayTransform) { return fntable_Overlay_020_instance->SetOverlayTransformOverlayRelative(ulOverlayHandle, ulOverlayHandleParent, pmatParentOverlayToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_ShowOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_020_instance->ShowOverlay(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_HideOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_020_instance->HideOverlay(ulOverlayHandle); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_IsOverlayVisible(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_020_instance->IsOverlayVisible(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_GetTransformForOverlayCoordinates(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin eTrackingOrigin, vr::HmdVector2_t coordinatesInOverlay, vr::HmdMatrix34_t* pmatTransform) { return fntable_Overlay_020_instance->GetTransformForOverlayCoordinates(ulOverlayHandle, eTrackingOrigin, coordinatesInOverlay, pmatTransform); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_PollNextOverlayEvent(vr::VROverlayHandle_t ulOverlayHandle, vr::VREvent_t* pEvent, uint32_t uncbVREvent) { return fntable_Overlay_020_instance->PollNextOverlayEvent(ulOverlayHandle, pEvent, uncbVREvent); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_GetOverlayInputMethod(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_020::VROverlayInputMethod* peInputMethod) { return fntable_Overlay_020_instance->GetOverlayInputMethod(ulOverlayHandle, peInputMethod); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_SetOverlayInputMethod(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_020::VROverlayInputMethod eInputMethod) { return fntable_Overlay_020_instance->SetOverlayInputMethod(ulOverlayHandle, eInputMethod); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_GetOverlayMouseScale(vr::VROverlayHandle_t ulOverlayHandle, vr::HmdVector2_t* pvecMouseScale) { return fntable_Overlay_020_instance->GetOverlayMouseScale(ulOverlayHandle, pvecMouseScale); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_SetOverlayMouseScale(vr::VROverlayHandle_t ulOverlayHandle, const vr::HmdVector2_t* pvecMouseScale) { return fntable_Overlay_020_instance->SetOverlayMouseScale(ulOverlayHandle, pvecMouseScale); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_ComputeOverlayIntersection(vr::VROverlayHandle_t ulOverlayHandle, const vr::IVROverlay_020::VROverlayIntersectionParams_t* pParams, vr::IVROverlay_020::VROverlayIntersectionResults_t* pResults) { return fntable_Overlay_020_instance->ComputeOverlayIntersection(ulOverlayHandle, pParams, pResults); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_IsHoverTargetOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_020_instance->IsHoverTargetOverlay(ulOverlayHandle); }
static vr::VROverlayHandle_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_GetGamepadFocusOverlay() { return fntable_Overlay_020_instance->GetGamepadFocusOverlay(); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_SetGamepadFocusOverlay(vr::VROverlayHandle_t ulNewFocusOverlay) { return fntable_Overlay_020_instance->SetGamepadFocusOverlay(ulNewFocusOverlay); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_SetOverlayNeighbor(vr::IVROverlay_020::EOverlayDirection eDirection, vr::VROverlayHandle_t ulFrom, vr::VROverlayHandle_t ulTo) { return fntable_Overlay_020_instance->SetOverlayNeighbor(eDirection, ulFrom, ulTo); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_MoveGamepadFocusToNeighbor(vr::IVROverlay_020::EOverlayDirection eDirection, vr::VROverlayHandle_t ulFrom) { return fntable_Overlay_020_instance->MoveGamepadFocusToNeighbor(eDirection, ulFrom); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_SetOverlayDualAnalogTransform(vr::VROverlayHandle_t ulOverlay, EDualAnalogWhich eWhich, const vr::HmdVector2_t* pvCenter, float fRadius) { return fntable_Overlay_020_instance->SetOverlayDualAnalogTransform(ulOverlay, eWhich, pvCenter, fRadius); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_GetOverlayDualAnalogTransform(vr::VROverlayHandle_t ulOverlay, EDualAnalogWhich eWhich, vr::HmdVector2_t* pvCenter, float* pfRadius) { return fntable_Overlay_020_instance->GetOverlayDualAnalogTransform(ulOverlay, eWhich, pvCenter, pfRadius); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_SetOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle, const vr::Texture_t* pTexture) { return fntable_Overlay_020_instance->SetOverlayTexture(ulOverlayHandle, pTexture); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_ClearOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_020_instance->ClearOverlayTexture(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_SetOverlayRaw(vr::VROverlayHandle_t ulOverlayHandle, void* pvBuffer, uint32_t unWidth, uint32_t unHeight, uint32_t unDepth) { return fntable_Overlay_020_instance->SetOverlayRaw(ulOverlayHandle, pvBuffer, unWidth, unHeight, unDepth); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_SetOverlayFromFile(vr::VROverlayHandle_t ulOverlayHandle, const char* pchFilePath) { return fntable_Overlay_020_instance->SetOverlayFromFile(ulOverlayHandle, pchFilePath); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_GetOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle, void** pNativeTextureHandle, void* pNativeTextureRef, uint32_t* pWidth, uint32_t* pHeight, uint32_t* pNativeFormat, vr::ETextureType* pAPIType, vr::EColorSpace* pColorSpace, vr::VRTextureBounds_t* pTextureBounds) { return fntable_Overlay_020_instance->GetOverlayTexture(ulOverlayHandle, pNativeTextureHandle, pNativeTextureRef, pWidth, pHeight, pNativeFormat, pAPIType, pColorSpace, pTextureBounds); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_ReleaseNativeOverlayHandle(vr::VROverlayHandle_t ulOverlayHandle, void* pNativeTextureHandle) { return fntable_Overlay_020_instance->ReleaseNativeOverlayHandle(ulOverlayHandle, pNativeTextureHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_GetOverlayTextureSize(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* pWidth, uint32_t* pHeight) { return fntable_Overlay_020_instance->GetOverlayTextureSize(ulOverlayHandle, pWidth, pHeight); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_CreateDashboardOverlay(const char* pchOverlayKey, const char* pchOverlayFriendlyName, vr::VROverlayHandle_t* pMainHandle, vr::VROverlayHandle_t* pThumbnailHandle) { return fntable_Overlay_020_instance->CreateDashboardOverlay(pchOverlayKey, pchOverlayFriendlyName, pMainHandle, pThumbnailHandle); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_IsDashboardVisible() { return fntable_Overlay_020_instance->IsDashboardVisible(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_IsActiveDashboardOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_020_instance->IsActiveDashboardOverlay(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_SetDashboardOverlaySceneProcess(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unProcessId) { return fntable_Overlay_020_instance->SetDashboardOverlaySceneProcess(ulOverlayHandle, unProcessId); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_GetDashboardOverlaySceneProcess(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* punProcessId) { return fntable_Overlay_020_instance->GetDashboardOverlaySceneProcess(ulOverlayHandle, punProcessId); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_ShowDashboard(const char* pchOverlayToShow) { return fntable_Overlay_020_instance->ShowDashboard(pchOverlayToShow); }
static vr::TrackedDeviceIndex_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_GetPrimaryDashboardDevice() { return fntable_Overlay_020_instance->GetPrimaryDashboardDevice(); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_ShowKeyboard(vr::IVROverlay_020::EGamepadTextInputMode eInputMode, vr::IVROverlay_020::EGamepadTextInputLineMode eLineInputMode, const char* pchDescription, uint32_t unCharMax, const char* pchExistingText, bool bUseMinimalMode, uint64_t uUserValue) { return fntable_Overlay_020_instance->ShowKeyboard(eInputMode, eLineInputMode, pchDescription, unCharMax, pchExistingText, bUseMinimalMode, uUserValue); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_ShowKeyboardForOverlay(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_020::EGamepadTextInputMode eInputMode, vr::IVROverlay_020::EGamepadTextInputLineMode eLineInputMode, const char* pchDescription, uint32_t unCharMax, const char* pchExistingText, bool bUseMinimalMode, uint64_t uUserValue) { return fntable_Overlay_020_instance->ShowKeyboardForOverlay(ulOverlayHandle, eInputMode, eLineInputMode, pchDescription, unCharMax, pchExistingText, bUseMinimalMode, uUserValue); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_GetKeyboardText(char* pchText, uint32_t cchText) { return fntable_Overlay_020_instance->GetKeyboardText(pchText, cchText); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_HideKeyboard() { return fntable_Overlay_020_instance->HideKeyboard(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_SetKeyboardTransformAbsolute(vr::ETrackingUniverseOrigin eTrackingOrigin, const vr::HmdMatrix34_t* pmatTrackingOriginToKeyboardTransform) { return fntable_Overlay_020_instance->SetKeyboardTransformAbsolute(eTrackingOrigin, pmatTrackingOriginToKeyboardTransform); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_SetKeyboardPositionForOverlay(vr::VROverlayHandle_t ulOverlayHandle, vr::HmdRect2_t avoidRect) { return fntable_Overlay_020_instance->SetKeyboardPositionForOverlay(ulOverlayHandle, avoidRect); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_SetOverlayIntersectionMask(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_020::VROverlayIntersectionMaskPrimitive_t* pMaskPrimitives, uint32_t unNumMaskPrimitives, uint32_t unPrimitiveSize) { return fntable_Overlay_020_instance->SetOverlayIntersectionMask(ulOverlayHandle, pMaskPrimitives, unNumMaskPrimitives, unPrimitiveSize); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_GetOverlayFlags(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* pFlags) { return fntable_Overlay_020_instance->GetOverlayFlags(ulOverlayHandle, pFlags); }
static vr::IVROverlay_020::VRMessageOverlayResponse OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_ShowMessageOverlay(const char* pchText, const char* pchCaption, const char* pchButton0Text, const char* pchButton1Text, const char* pchButton2Text, const char* pchButton3Text) { return fntable_Overlay_020_instance->ShowMessageOverlay(pchText, pchCaption, pchButton0Text, pchButton1Text, pchButton2Text, pchButton3Text); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_020_impl_CloseMessageOverlay() { return fntable_Overlay_020_instance->CloseMessageOverlay(); }
static void *fntable_Overlay_020_funcs[] = {
	(void*) fntable_Overlay_020_impl_FindOverlay,
	(void*) fntable_Overlay_020_impl_CreateOverlay,
	(void*) fntable_Overlay_020_impl_DestroyOverlay,
	(void*) fntable_Overlay_020_impl_GetOverlayKey,
	(void*) fntable_Overlay_020_impl_GetOverlayName,
	(void*) fntable_Overlay_020_impl_SetOverlayName,
	(void*) fntable_Overlay_020_impl_GetOverlayImageData,
	(void*) fntable_Overlay_020_impl_GetOverlayErrorNameFromEnum,
	(void*) fntable_Overlay_020_impl_SetOverlayRenderingPid,
	(void*) fntable_Overlay_020_impl_GetOverlayRenderingPid,
	(void*) fntable_Overlay_020_impl_SetOverlayFlag,
	(void*) fntable_Overlay_020_impl_GetOverlayFlag,
	(void*) fntable_Overlay_020_impl_SetOverlayColor,
	(void*) fntable_Overlay_020_impl_GetOverlayColor,
	(void*) fntable_Overlay_020_impl_SetOverlayAlpha,
	(void*) fntable_Overlay_020_impl_GetOverlayAlpha,
	(void*) fntable_Overlay_020_impl_SetOverlayTexelAspect,
	(void*) fntable_Overlay_020_impl_GetOverlayTexelAspect,
	(void*) fntable_Overlay_020_impl_SetOverlaySortOrder,
	(void*) fntable_Overlay_020_impl_GetOverlaySortOrder,
	(void*) fntable_Overlay_020_impl_SetOverlayWidthInMeters,
	(void*) fntable_Overlay_020_impl_GetOverlayWidthInMeters,
	(void*) fntable_Overlay_020_impl_SetOverlayAutoCurveDistanceRangeInMeters,
	(void*) fntable_Overlay_020_impl_GetOverlayAutoCurveDistanceRangeInMeters,
	(void*) fntable_Overlay_020_impl_SetOverlayTextureColorSpace,
	(void*) fntable_Overlay_020_impl_GetOverlayTextureColorSpace,
	(void*) fntable_Overlay_020_impl_SetOverlayTextureBounds,
	(void*) fntable_Overlay_020_impl_GetOverlayTextureBounds,
	(void*) fntable_Overlay_020_impl_GetOverlayRenderModel,
	(void*) fntable_Overlay_020_impl_SetOverlayRenderModel,
	(void*) fntable_Overlay_020_impl_GetOverlayTransformType,
	(void*) fntable_Overlay_020_impl_SetOverlayTransformAbsolute,
	(void*) fntable_Overlay_020_impl_GetOverlayTransformAbsolute,
	(void*) fntable_Overlay_020_impl_SetOverlayTransformTrackedDeviceRelative,
	(void*) fntable_Overlay_020_impl_GetOverlayTransformTrackedDeviceRelative,
	(void*) fntable_Overlay_020_impl_SetOverlayTransformTrackedDeviceComponent,
	(void*) fntable_Overlay_020_impl_GetOverlayTransformTrackedDeviceComponent,
	(void*) fntable_Overlay_020_impl_GetOverlayTransformOverlayRelative,
	(void*) fntable_Overlay_020_impl_SetOverlayTransformOverlayRelative,
	(void*) fntable_Overlay_020_impl_ShowOverlay,
	(void*) fntable_Overlay_020_impl_HideOverlay,
	(void*) fntable_Overlay_020_impl_IsOverlayVisible,
	(void*) fntable_Overlay_020_impl_GetTransformForOverlayCoordinates,
	(void*) fntable_Overlay_020_impl_PollNextOverlayEvent,
	(void*) fntable_Overlay_020_impl_GetOverlayInputMethod,
	(void*) fntable_Overlay_020_impl_SetOverlayInputMethod,
	(void*) fntable_Overlay_020_impl_GetOverlayMouseScale,
	(void*) fntable_Overlay_020_impl_SetOverlayMouseScale,
	(void*) fntable_Overlay_020_impl_ComputeOverlayIntersection,
	(void*) fntable_Overlay_020_impl_IsHoverTargetOverlay,
	(void*) fntable_Overlay_020_impl_GetGamepadFocusOverlay,
	(void*) fntable_Overlay_020_impl_SetGamepadFocusOverlay,
	(void*) fntable_Overlay_020_impl_SetOverlayNeighbor,
	(void*) fntable_Overlay_020_impl_MoveGamepadFocusToNeighbor,
	(void*) fntable_Overlay_020_impl_SetOverlayDualAnalogTransform,
	(void*) fntable_Overlay_020_impl_GetOverlayDualAnalogTransform,
	(void*) fntable_Overlay_020_impl_SetOverlayTexture,
	(void*) fntable_Overlay_020_impl_ClearOverlayTexture,
	(void*) fntable_Overlay_020_impl_SetOverlayRaw,
	(void*) fntable_Overlay_020_impl_SetOverlayFromFile,
	(void*) fntable_Overlay_020_impl_GetOverlayTexture,
	(void*) fntable_Overlay_020_impl_ReleaseNativeOverlayHandle,
	(void*) fntable_Overlay_020_impl_GetOverlayTextureSize,
	(void*) fntable_Overlay_020_impl_CreateDashboardOverlay,
	(void*) fntable_Overlay_020_impl_IsDashboardVisible,
	(void*) fntable_Overlay_020_impl_IsActiveDashboardOverlay,
	(void*) fntable_Overlay_020_impl_SetDashboardOverlaySceneProcess,
	(void*) fntable_Overlay_020_impl_GetDashboardOverlaySceneProcess,
	(void*) fntable_Overlay_020_impl_ShowDashboard,
	(void*) fntable_Overlay_020_impl_GetPrimaryDashboardDevice,
	(void*) fntable_Overlay_020_impl_ShowKeyboard,
	(void*) fntable_Overlay_020_impl_ShowKeyboardForOverlay,
	(void*) fntable_Overlay_020_impl_GetKeyboardText,
	(void*) fntable_Overlay_020_impl_HideKeyboard,
	(void*) fntable_Overlay_020_impl_SetKeyboardTransformAbsolute,
	(void*) fntable_Overlay_020_impl_SetKeyboardPositionForOverlay,
	(void*) fntable_Overlay_020_impl_SetOverlayIntersectionMask,
	(void*) fntable_Overlay_020_impl_GetOverlayFlags,
	(void*) fntable_Overlay_020_impl_ShowMessageOverlay,
	(void*) fntable_Overlay_020_impl_CloseMessageOverlay,
};
void** CVROverlay_020::_GetStatFuncList() { fntable_Overlay_020_instance = this; return fntable_Overlay_020_funcs; }
void CVROverlay_020::Delete() { delete this; }
// Misc for CVROverlay_021:
CVROverlay_021::CVROverlay_021() : base(GetCreateBaseOverlay()) {}
// Interface methods for CVROverlay_021:
vr::EVROverlayError CVROverlay_021::FindOverlay(const char* pchOverlayKey, vr::VROverlayHandle_t* pOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->FindOverlay(pchOverlayKey, pOverlayHandle);
}
vr::EVROverlayError CVROverlay_021::CreateOverlay(const char* pchOverlayKey, const char* pchOverlayName, vr::VROverlayHandle_t* pOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->CreateOverlay(pchOverlayKey, pchOverlayName, pOverlayHandle);
}
vr::EVROverlayError CVROverlay_021::DestroyOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->DestroyOverlay(ulOverlayHandle);
}
uint32_t CVROverlay_021::GetOverlayKey(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::EVROverlayError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->GetOverlayKey(ulOverlayHandle, pchValue, unBufferSize, pError);
}
uint32_t CVROverlay_021::GetOverlayName(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::EVROverlayError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->GetOverlayName(ulOverlayHandle, pchValue, unBufferSize, pError);
}
vr::EVROverlayError CVROverlay_021::SetOverlayName(vr::VROverlayHandle_t ulOverlayHandle, const char* pchName) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->SetOverlayName(ulOverlayHandle, pchName);
}
vr::EVROverlayError CVROverlay_021::GetOverlayImageData(vr::VROverlayHandle_t ulOverlayHandle, void* pvBuffer, uint32_t unBufferSize, uint32_t* punWidth, uint32_t* punHeight) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->GetOverlayImageData(ulOverlayHandle, pvBuffer, unBufferSize, punWidth, punHeight);
}
const char* CVROverlay_021::GetOverlayErrorNameFromEnum(vr::EVROverlayError error) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->GetOverlayErrorNameFromEnum(error);
}
vr::EVROverlayError CVROverlay_021::SetOverlayRenderingPid(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unPID) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->SetOverlayRenderingPid(ulOverlayHandle, unPID);
}
uint32_t CVROverlay_021::GetOverlayRenderingPid(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->GetOverlayRenderingPid(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_021::SetOverlayFlag(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_021::VROverlayFlags eOverlayFlag, bool bEnabled) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->SetOverlayFlag(ulOverlayHandle, (OOVR_VROverlayFlags) eOverlayFlag, bEnabled);
}
vr::EVROverlayError CVROverlay_021::GetOverlayFlag(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_021::VROverlayFlags eOverlayFlag, bool* pbEnabled) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->GetOverlayFlag(ulOverlayHandle, (OOVR_VROverlayFlags) eOverlayFlag, pbEnabled);
}
vr::EVROverlayError CVROverlay_021::SetOverlayColor(vr::VROverlayHandle_t ulOverlayHandle, float fRed, float fGreen, float fBlue) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->SetOverlayColor(ulOverlayHandle, fRed, fGreen, fBlue);
}
vr::EVROverlayError CVROverlay_021::GetOverlayColor(vr::VROverlayHandle_t ulOverlayHandle, float* pfRed, float* pfGreen, float* pfBlue) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->GetOverlayColor(ulOverlayHandle, pfRed, pfGreen, pfBlue);
}
vr::EVROverlayError CVROverlay_021::SetOverlayAlpha(vr::VROverlayHandle_t ulOverlayHandle, float fAlpha) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->SetOverlayAlpha(ulOverlayHandle, fAlpha);
}
vr::EVROverlayError CVROverlay_021::GetOverlayAlpha(vr::VROverlayHandle_t ulOverlayHandle, float* pfAlpha) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->GetOverlayAlpha(ulOverlayHandle, pfAlpha);
}
vr::EVROverlayError CVROverlay_021::SetOverlayTexelAspect(vr::VROverlayHandle_t ulOverlayHandle, float fTexelAspect) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->SetOverlayTexelAspect(ulOverlayHandle, fTexelAspect);
}
vr::EVROverlayError CVROverlay_021::GetOverlayTexelAspect(vr::VROverlayHandle_t ulOverlayHandle, float* pfTexelAspect) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->GetOverlayTexelAspect(ulOverlayHandle, pfTexelAspect);
}
vr::EVROverlayError CVROverlay_021::SetOverlaySortOrder(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unSortOrder) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->SetOverlaySortOrder(ulOverlayHandle, unSortOrder);
}
vr::EVROverlayError CVROverlay_021::GetOverlaySortOrder(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* punSortOrder) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->GetOverlaySortOrder(ulOverlayHandle, punSortOrder);
}
vr::EVROverlayError CVROverlay_021::SetOverlayWidthInMeters(vr::VROverlayHandle_t ulOverlayHandle, float fWidthInMeters) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->SetOverlayWidthInMeters(ulOverlayHandle, fWidthInMeters);
}
vr::EVROverlayError CVROverlay_021::GetOverlayWidthInMeters(vr::VROverlayHandle_t ulOverlayHandle, float* pfWidthInMeters) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->GetOverlayWidthInMeters(ulOverlayHandle, pfWidthInMeters);
}
vr::EVROverlayError CVROverlay_021::SetOverlayCurvature(vr::VROverlayHandle_t ulOverlayHandle, float fCurvature) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->SetOverlayCurvature(ulOverlayHandle, fCurvature);
}
vr::EVROverlayError CVROverlay_021::GetOverlayCurvature(vr::VROverlayHandle_t ulOverlayHandle, float* pfCurvature) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->GetOverlayCurvature(ulOverlayHandle, pfCurvature);
}
vr::EVROverlayError CVROverlay_021::SetOverlayTextureColorSpace(vr::VROverlayHandle_t ulOverlayHandle, vr::EColorSpace eTextureColorSpace) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->SetOverlayTextureColorSpace(ulOverlayHandle, eTextureColorSpace);
}
vr::EVROverlayError CVROverlay_021::GetOverlayTextureColorSpace(vr::VROverlayHandle_t ulOverlayHandle, vr::EColorSpace* peTextureColorSpace) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->GetOverlayTextureColorSpace(ulOverlayHandle, peTextureColorSpace);
}
vr::EVROverlayError CVROverlay_021::SetOverlayTextureBounds(vr::VROverlayHandle_t ulOverlayHandle, const vr::VRTextureBounds_t* pOverlayTextureBounds) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->SetOverlayTextureBounds(ulOverlayHandle, pOverlayTextureBounds);
}
vr::EVROverlayError CVROverlay_021::GetOverlayTextureBounds(vr::VROverlayHandle_t ulOverlayHandle, vr::VRTextureBounds_t* pOverlayTextureBounds) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->GetOverlayTextureBounds(ulOverlayHandle, pOverlayTextureBounds);
}
uint32_t CVROverlay_021::GetOverlayRenderModel(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::HmdColor_t* pColor, vr::EVROverlayError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->GetOverlayRenderModel(ulOverlayHandle, pchValue, unBufferSize, pColor, pError);
}
vr::EVROverlayError CVROverlay_021::SetOverlayRenderModel(vr::VROverlayHandle_t ulOverlayHandle, const char* pchRenderModel, const vr::HmdColor_t* pColor) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->SetOverlayRenderModel(ulOverlayHandle, pchRenderModel, pColor);
}
vr::EVROverlayError CVROverlay_021::GetOverlayTransformType(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_021::VROverlayTransformType* peTransformType) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->GetOverlayTransformType(ulOverlayHandle, (OOVR_VROverlayTransformType*) peTransformType);
}
vr::EVROverlayError CVROverlay_021::SetOverlayTransformAbsolute(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin eTrackingOrigin, const vr::HmdMatrix34_t* pmatTrackingOriginToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->SetOverlayTransformAbsolute(ulOverlayHandle, eTrackingOrigin, pmatTrackingOriginToOverlayTransform);
}
vr::EVROverlayError CVROverlay_021::GetOverlayTransformAbsolute(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin* peTrackingOrigin, vr::HmdMatrix34_t* pmatTrackingOriginToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->GetOverlayTransformAbsolute(ulOverlayHandle, peTrackingOrigin, pmatTrackingOriginToOverlayTransform);
}
vr::EVROverlayError CVROverlay_021::SetOverlayTransformTrackedDeviceRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unTrackedDevice, const vr::HmdMatrix34_t* pmatTrackedDeviceToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->SetOverlayTransformTrackedDeviceRelative(ulOverlayHandle, unTrackedDevice, pmatTrackedDeviceToOverlayTransform);
}
vr::EVROverlayError CVROverlay_021::GetOverlayTransformTrackedDeviceRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t* punTrackedDevice, vr::HmdMatrix34_t* pmatTrackedDeviceToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->GetOverlayTransformTrackedDeviceRelative(ulOverlayHandle, punTrackedDevice, pmatTrackedDeviceToOverlayTransform);
}
vr::EVROverlayError CVROverlay_021::SetOverlayTransformTrackedDeviceComponent(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unDeviceIndex, const char* pchComponentName) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->SetOverlayTransformTrackedDeviceComponent(ulOverlayHandle, unDeviceIndex, pchComponentName);
}
vr::EVROverlayError CVROverlay_021::GetOverlayTransformTrackedDeviceComponent(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t* punDeviceIndex, char* pchComponentName, uint32_t unComponentNameSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->GetOverlayTransformTrackedDeviceComponent(ulOverlayHandle, punDeviceIndex, pchComponentName, unComponentNameSize);
}
vr::EVROverlayError CVROverlay_021::GetOverlayTransformOverlayRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::VROverlayHandle_t* ulOverlayHandleParent, vr::HmdMatrix34_t* pmatParentOverlayToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->GetOverlayTransformOverlayRelative(ulOverlayHandle, ulOverlayHandleParent, pmatParentOverlayToOverlayTransform);
}
vr::EVROverlayError CVROverlay_021::SetOverlayTransformOverlayRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::VROverlayHandle_t ulOverlayHandleParent, const vr::HmdMatrix34_t* pmatParentOverlayToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->SetOverlayTransformOverlayRelative(ulOverlayHandle, ulOverlayHandleParent, pmatParentOverlayToOverlayTransform);
}
vr::EVROverlayError CVROverlay_021::ShowOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->ShowOverlay(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_021::HideOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->HideOverlay(ulOverlayHandle);
}
bool CVROverlay_021::IsOverlayVisible(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->IsOverlayVisible(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_021::GetTransformForOverlayCoordinates(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin eTrackingOrigin, vr::HmdVector2_t coordinatesInOverlay, vr::HmdMatrix34_t* pmatTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->GetTransformForOverlayCoordinates(ulOverlayHandle, eTrackingOrigin, coordinatesInOverlay, pmatTransform);
}
bool CVROverlay_021::PollNextOverlayEvent(vr::VROverlayHandle_t ulOverlayHandle, vr::VREvent_t* pEvent, uint32_t uncbVREvent) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->PollNextOverlayEvent(ulOverlayHandle, pEvent, uncbVREvent);
}
vr::EVROverlayError CVROverlay_021::GetOverlayInputMethod(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_021::VROverlayInputMethod* peInputMethod) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->GetOverlayInputMethod(ulOverlayHandle, (OOVR_VROverlayInputMethod*) peInputMethod);
}
vr::EVROverlayError CVROverlay_021::SetOverlayInputMethod(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_021::VROverlayInputMethod eInputMethod) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->SetOverlayInputMethod(ulOverlayHandle, (OOVR_VROverlayInputMethod) eInputMethod);
}
vr::EVROverlayError CVROverlay_021::GetOverlayMouseScale(vr::VROverlayHandle_t ulOverlayHandle, vr::HmdVector2_t* pvecMouseScale) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->GetOverlayMouseScale(ulOverlayHandle, pvecMouseScale);
}
vr::EVROverlayError CVROverlay_021::SetOverlayMouseScale(vr::VROverlayHandle_t ulOverlayHandle, const vr::HmdVector2_t* pvecMouseScale) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->SetOverlayMouseScale(ulOverlayHandle, pvecMouseScale);
}
bool CVROverlay_021::ComputeOverlayIntersection(vr::VROverlayHandle_t ulOverlayHandle, const vr::IVROverlay_021::VROverlayIntersectionParams_t* pParams, vr::IVROverlay_021::VROverlayIntersectionResults_t* pResults) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->ComputeOverlayIntersection(ulOverlayHandle, (const OOVR_VROverlayIntersectionParams_t*) pParams, (OOVR_VROverlayIntersectionResults_t*) pResults);
}
bool CVROverlay_021::IsHoverTargetOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->IsHoverTargetOverlay(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_021::SetOverlayDualAnalogTransform(vr::VROverlayHandle_t ulOverlay, EDualAnalogWhich eWhich, const vr::HmdVector2_t* pvCenter, float fRadius) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->SetOverlayDualAnalogTransform(ulOverlay, eWhich, pvCenter, fRadius);
}
vr::EVROverlayError CVROverlay_021::GetOverlayDualAnalogTransform(vr::VROverlayHandle_t ulOverlay, EDualAnalogWhich eWhich, vr::HmdVector2_t* pvCenter, float* pfRadius) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->GetOverlayDualAnalogTransform(ulOverlay, eWhich, pvCenter, pfRadius);
}
vr::EVROverlayError CVROverlay_021::SetOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle, const vr::Texture_t* pTexture) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->SetOverlayTexture(ulOverlayHandle, pTexture);
}
vr::EVROverlayError CVROverlay_021::ClearOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->ClearOverlayTexture(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_021::SetOverlayRaw(vr::VROverlayHandle_t ulOverlayHandle, void* pvBuffer, uint32_t unWidth, uint32_t unHeight, uint32_t unDepth) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->SetOverlayRaw(ulOverlayHandle, pvBuffer, unWidth, unHeight, unDepth);
}
vr::EVROverlayError CVROverlay_021::SetOverlayFromFile(vr::VROverlayHandle_t ulOverlayHandle, const char* pchFilePath) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->SetOverlayFromFile(ulOverlayHandle, pchFilePath);
}
vr::EVROverlayError CVROverlay_021::GetOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle, void** pNativeTextureHandle, void* pNativeTextureRef, uint32_t* pWidth, uint32_t* pHeight, uint32_t* pNativeFormat, vr::ETextureType* pAPIType, vr::EColorSpace* pColorSpace, vr::VRTextureBounds_t* pTextureBounds) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->GetOverlayTexture(ulOverlayHandle, pNativeTextureHandle, pNativeTextureRef, pWidth, pHeight, pNativeFormat, pAPIType, pColorSpace, pTextureBounds);
}
vr::EVROverlayError CVROverlay_021::ReleaseNativeOverlayHandle(vr::VROverlayHandle_t ulOverlayHandle, void* pNativeTextureHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->ReleaseNativeOverlayHandle(ulOverlayHandle, pNativeTextureHandle);
}
vr::EVROverlayError CVROverlay_021::GetOverlayTextureSize(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* pWidth, uint32_t* pHeight) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->GetOverlayTextureSize(ulOverlayHandle, pWidth, pHeight);
}
vr::EVROverlayError CVROverlay_021::CreateDashboardOverlay(const char* pchOverlayKey, const char* pchOverlayFriendlyName, vr::VROverlayHandle_t* pMainHandle, vr::VROverlayHandle_t* pThumbnailHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->CreateDashboardOverlay(pchOverlayKey, pchOverlayFriendlyName, pMainHandle, pThumbnailHandle);
}
bool CVROverlay_021::IsDashboardVisible() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->IsDashboardVisible();
}
bool CVROverlay_021::IsActiveDashboardOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->IsActiveDashboardOverlay(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_021::SetDashboardOverlaySceneProcess(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unProcessId) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->SetDashboardOverlaySceneProcess(ulOverlayHandle, unProcessId);
}
vr::EVROverlayError CVROverlay_021::GetDashboardOverlaySceneProcess(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* punProcessId) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->GetDashboardOverlaySceneProcess(ulOverlayHandle, punProcessId);
}
void CVROverlay_021::ShowDashboard(const char* pchOverlayToShow) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->ShowDashboard(pchOverlayToShow);
}
vr::TrackedDeviceIndex_t CVROverlay_021::GetPrimaryDashboardDevice() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->GetPrimaryDashboardDevice();
}
vr::EVROverlayError CVROverlay_021::ShowKeyboard(vr::IVROverlay_021::EGamepadTextInputMode eInputMode, vr::IVROverlay_021::EGamepadTextInputLineMode eLineInputMode, const char* pchDescription, uint32_t unCharMax, const char* pchExistingText, bool bUseMinimalMode, uint64_t uUserValue) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->ShowKeyboard((OOVR_EGamepadTextInputMode) eInputMode, (OOVR_EGamepadTextInputLineMode) eLineInputMode, pchDescription, unCharMax, pchExistingText, bUseMinimalMode, uUserValue);
}
vr::EVROverlayError CVROverlay_021::ShowKeyboardForOverlay(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_021::EGamepadTextInputMode eInputMode, vr::IVROverlay_021::EGamepadTextInputLineMode eLineInputMode, const char* pchDescription, uint32_t unCharMax, const char* pchExistingText, bool bUseMinimalMode, uint64_t uUserValue) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->ShowKeyboardForOverlay(ulOverlayHandle, (OOVR_EGamepadTextInputMode) eInputMode, (OOVR_EGamepadTextInputLineMode) eLineInputMode, pchDescription, unCharMax, pchExistingText, bUseMinimalMode, uUserValue);
}
uint32_t CVROverlay_021::GetKeyboardText(char* pchText, uint32_t cchText) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->GetKeyboardText(pchText, cchText);
}
void CVROverlay_021::HideKeyboard() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->HideKeyboard();
}
void CVROverlay_021::SetKeyboardTransformAbsolute(vr::ETrackingUniverseOrigin eTrackingOrigin, const vr::HmdMatrix34_t* pmatTrackingOriginToKeyboardTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->SetKeyboardTransformAbsolute(eTrackingOrigin, pmatTrackingOriginToKeyboardTransform);
}
void CVROverlay_021::SetKeyboardPositionForOverlay(vr::VROverlayHandle_t ulOverlayHandle, vr::HmdRect2_t avoidRect) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->SetKeyboardPositionForOverlay(ulOverlayHandle, avoidRect);
}
vr::EVROverlayError CVROverlay_021::SetOverlayIntersectionMask(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_021::VROverlayIntersectionMaskPrimitive_t* pMaskPrimitives, uint32_t unNumMaskPrimitives, uint32_t unPrimitiveSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->SetOverlayIntersectionMask(ulOverlayHandle, (OOVR_VROverlayIntersectionMaskPrimitive_t*) pMaskPrimitives, unNumMaskPrimitives, unPrimitiveSize);
}
vr::EVROverlayError CVROverlay_021::GetOverlayFlags(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* pFlags) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->GetOverlayFlags(ulOverlayHandle, pFlags);
}
vr::IVROverlay_021::VRMessageOverlayResponse CVROverlay_021::ShowMessageOverlay(const char* pchText, const char* pchCaption, const char* pchButton0Text, const char* pchButton1Text, const char* pchButton2Text, const char* pchButton3Text) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return (vr::IVROverlay_021::VRMessageOverlayResponse) base->ShowMessageOverlay(pchText, pchCaption, pchButton0Text, pchButton1Text, pchButton2Text, pchButton3Text);
}
void CVROverlay_021::CloseMessageOverlay() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_021)");
	return base->CloseMessageOverlay();
}
// FnTable for CVROverlay_021:
static CVROverlay_021 *fntable_Overlay_021_instance = NULL;
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_FindOverlay(const char* pchOverlayKey, vr::VROverlayHandle_t* pOverlayHandle) { return fntable_Overlay_021_instance->FindOverlay(pchOverlayKey, pOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_CreateOverlay(const char* pchOverlayKey, const char* pchOverlayName, vr::VROverlayHandle_t* pOverlayHandle) { return fntable_Overlay_021_instance->CreateOverlay(pchOverlayKey, pchOverlayName, pOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_DestroyOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_021_instance->DestroyOverlay(ulOverlayHandle); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_GetOverlayKey(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::EVROverlayError* pError) { return fntable_Overlay_021_instance->GetOverlayKey(ulOverlayHandle, pchValue, unBufferSize, pError); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_GetOverlayName(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::EVROverlayError* pError) { return fntable_Overlay_021_instance->GetOverlayName(ulOverlayHandle, pchValue, unBufferSize, pError); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_SetOverlayName(vr::VROverlayHandle_t ulOverlayHandle, const char* pchName) { return fntable_Overlay_021_instance->SetOverlayName(ulOverlayHandle, pchName); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_GetOverlayImageData(vr::VROverlayHandle_t ulOverlayHandle, void* pvBuffer, uint32_t unBufferSize, uint32_t* punWidth, uint32_t* punHeight) { return fntable_Overlay_021_instance->GetOverlayImageData(ulOverlayHandle, pvBuffer, unBufferSize, punWidth, punHeight); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_GetOverlayErrorNameFromEnum(vr::EVROverlayError error) { return fntable_Overlay_021_instance->GetOverlayErrorNameFromEnum(error); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_SetOverlayRenderingPid(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unPID) { return fntable_Overlay_021_instance->SetOverlayRenderingPid(ulOverlayHandle, unPID); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_GetOverlayRenderingPid(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_021_instance->GetOverlayRenderingPid(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_SetOverlayFlag(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_021::VROverlayFlags eOverlayFlag, bool bEnabled) { return fntable_Overlay_021_instance->SetOverlayFlag(ulOverlayHandle, eOverlayFlag, bEnabled); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_GetOverlayFlag(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_021::VROverlayFlags eOverlayFlag, bool* pbEnabled) { return fntable_Overlay_021_instance->GetOverlayFlag(ulOverlayHandle, eOverlayFlag, pbEnabled); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_SetOverlayColor(vr::VROverlayHandle_t ulOverlayHandle, float fRed, float fGreen, float fBlue) { return fntable_Overlay_021_instance->SetOverlayColor(ulOverlayHandle, fRed, fGreen, fBlue); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_GetOverlayColor(vr::VROverlayHandle_t ulOverlayHandle, float* pfRed, float* pfGreen, float* pfBlue) { return fntable_Overlay_021_instance->GetOverlayColor(ulOverlayHandle, pfRed, pfGreen, pfBlue); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_SetOverlayAlpha(vr::VROverlayHandle_t ulOverlayHandle, float fAlpha) { return fntable_Overlay_021_instance->SetOverlayAlpha(ulOverlayHandle, fAlpha); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_GetOverlayAlpha(vr::VROverlayHandle_t ulOverlayHandle, float* pfAlpha) { return fntable_Overlay_021_instance->GetOverlayAlpha(ulOverlayHandle, pfAlpha); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_SetOverlayTexelAspect(vr::VROverlayHandle_t ulOverlayHandle, float fTexelAspect) { return fntable_Overlay_021_instance->SetOverlayTexelAspect(ulOverlayHandle, fTexelAspect); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_GetOverlayTexelAspect(vr::VROverlayHandle_t ulOverlayHandle, float* pfTexelAspect) { return fntable_Overlay_021_instance->GetOverlayTexelAspect(ulOverlayHandle, pfTexelAspect); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_SetOverlaySortOrder(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unSortOrder) { return fntable_Overlay_021_instance->SetOverlaySortOrder(ulOverlayHandle, unSortOrder); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_GetOverlaySortOrder(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* punSortOrder) { return fntable_Overlay_021_instance->GetOverlaySortOrder(ulOverlayHandle, punSortOrder); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_SetOverlayWidthInMeters(vr::VROverlayHandle_t ulOverlayHandle, float fWidthInMeters) { return fntable_Overlay_021_instance->SetOverlayWidthInMeters(ulOverlayHandle, fWidthInMeters); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_GetOverlayWidthInMeters(vr::VROverlayHandle_t ulOverlayHandle, float* pfWidthInMeters) { return fntable_Overlay_021_instance->GetOverlayWidthInMeters(ulOverlayHandle, pfWidthInMeters); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_SetOverlayCurvature(vr::VROverlayHandle_t ulOverlayHandle, float fCurvature) { return fntable_Overlay_021_instance->SetOverlayCurvature(ulOverlayHandle, fCurvature); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_GetOverlayCurvature(vr::VROverlayHandle_t ulOverlayHandle, float* pfCurvature) { return fntable_Overlay_021_instance->GetOverlayCurvature(ulOverlayHandle, pfCurvature); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_SetOverlayTextureColorSpace(vr::VROverlayHandle_t ulOverlayHandle, vr::EColorSpace eTextureColorSpace) { return fntable_Overlay_021_instance->SetOverlayTextureColorSpace(ulOverlayHandle, eTextureColorSpace); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_GetOverlayTextureColorSpace(vr::VROverlayHandle_t ulOverlayHandle, vr::EColorSpace* peTextureColorSpace) { return fntable_Overlay_021_instance->GetOverlayTextureColorSpace(ulOverlayHandle, peTextureColorSpace); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_SetOverlayTextureBounds(vr::VROverlayHandle_t ulOverlayHandle, const vr::VRTextureBounds_t* pOverlayTextureBounds) { return fntable_Overlay_021_instance->SetOverlayTextureBounds(ulOverlayHandle, pOverlayTextureBounds); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_GetOverlayTextureBounds(vr::VROverlayHandle_t ulOverlayHandle, vr::VRTextureBounds_t* pOverlayTextureBounds) { return fntable_Overlay_021_instance->GetOverlayTextureBounds(ulOverlayHandle, pOverlayTextureBounds); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_GetOverlayRenderModel(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::HmdColor_t* pColor, vr::EVROverlayError* pError) { return fntable_Overlay_021_instance->GetOverlayRenderModel(ulOverlayHandle, pchValue, unBufferSize, pColor, pError); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_SetOverlayRenderModel(vr::VROverlayHandle_t ulOverlayHandle, const char* pchRenderModel, const vr::HmdColor_t* pColor) { return fntable_Overlay_021_instance->SetOverlayRenderModel(ulOverlayHandle, pchRenderModel, pColor); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_GetOverlayTransformType(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_021::VROverlayTransformType* peTransformType) { return fntable_Overlay_021_instance->GetOverlayTransformType(ulOverlayHandle, peTransformType); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_SetOverlayTransformAbsolute(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin eTrackingOrigin, const vr::HmdMatrix34_t* pmatTrackingOriginToOverlayTransform) { return fntable_Overlay_021_instance->SetOverlayTransformAbsolute(ulOverlayHandle, eTrackingOrigin, pmatTrackingOriginToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_GetOverlayTransformAbsolute(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin* peTrackingOrigin, vr::HmdMatrix34_t* pmatTrackingOriginToOverlayTransform) { return fntable_Overlay_021_instance->GetOverlayTransformAbsolute(ulOverlayHandle, peTrackingOrigin, pmatTrackingOriginToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_SetOverlayTransformTrackedDeviceRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unTrackedDevice, const vr::HmdMatrix34_t* pmatTrackedDeviceToOverlayTransform) { return fntable_Overlay_021_instance->SetOverlayTransformTrackedDeviceRelative(ulOverlayHandle, unTrackedDevice, pmatTrackedDeviceToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_GetOverlayTransformTrackedDeviceRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t* punTrackedDevice, vr::HmdMatrix34_t* pmatTrackedDeviceToOverlayTransform) { return fntable_Overlay_021_instance->GetOverlayTransformTrackedDeviceRelative(ulOverlayHandle, punTrackedDevice, pmatTrackedDeviceToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_SetOverlayTransformTrackedDeviceComponent(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unDeviceIndex, const char* pchComponentName) { return fntable_Overlay_021_instance->SetOverlayTransformTrackedDeviceComponent(ulOverlayHandle, unDeviceIndex, pchComponentName); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_GetOverlayTransformTrackedDeviceComponent(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t* punDeviceIndex, char* pchComponentName, uint32_t unComponentNameSize) { return fntable_Overlay_021_instance->GetOverlayTransformTrackedDeviceComponent(ulOverlayHandle, punDeviceIndex, pchComponentName, unComponentNameSize); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_GetOverlayTransformOverlayRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::VROverlayHandle_t* ulOverlayHandleParent, vr::HmdMatrix34_t* pmatParentOverlayToOverlayTransform) { return fntable_Overlay_021_instance->GetOverlayTransformOverlayRelative(ulOverlayHandle, ulOverlayHandleParent, pmatParentOverlayToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_SetOverlayTransformOverlayRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::VROverlayHandle_t ulOverlayHandleParent, const vr::HmdMatrix34_t* pmatParentOverlayToOverlayTransform) { return fntable_Overlay_021_instance->SetOverlayTransformOverlayRelative(ulOverlayHandle, ulOverlayHandleParent, pmatParentOverlayToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_ShowOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_021_instance->ShowOverlay(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_HideOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_021_instance->HideOverlay(ulOverlayHandle); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_IsOverlayVisible(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_021_instance->IsOverlayVisible(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_GetTransformForOverlayCoordinates(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin eTrackingOrigin, vr::HmdVector2_t coordinatesInOverlay, vr::HmdMatrix34_t* pmatTransform) { return fntable_Overlay_021_instance->GetTransformForOverlayCoordinates(ulOverlayHandle, eTrackingOrigin, coordinatesInOverlay, pmatTransform); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_PollNextOverlayEvent(vr::VROverlayHandle_t ulOverlayHandle, vr::VREvent_t* pEvent, uint32_t uncbVREvent) { return fntable_Overlay_021_instance->PollNextOverlayEvent(ulOverlayHandle, pEvent, uncbVREvent); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_GetOverlayInputMethod(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_021::VROverlayInputMethod* peInputMethod) { return fntable_Overlay_021_instance->GetOverlayInputMethod(ulOverlayHandle, peInputMethod); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_SetOverlayInputMethod(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_021::VROverlayInputMethod eInputMethod) { return fntable_Overlay_021_instance->SetOverlayInputMethod(ulOverlayHandle, eInputMethod); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_GetOverlayMouseScale(vr::VROverlayHandle_t ulOverlayHandle, vr::HmdVector2_t* pvecMouseScale) { return fntable_Overlay_021_instance->GetOverlayMouseScale(ulOverlayHandle, pvecMouseScale); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_SetOverlayMouseScale(vr::VROverlayHandle_t ulOverlayHandle, const vr::HmdVector2_t* pvecMouseScale) { return fntable_Overlay_021_instance->SetOverlayMouseScale(ulOverlayHandle, pvecMouseScale); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_ComputeOverlayIntersection(vr::VROverlayHandle_t ulOverlayHandle, const vr::IVROverlay_021::VROverlayIntersectionParams_t* pParams, vr::IVROverlay_021::VROverlayIntersectionResults_t* pResults) { return fntable_Overlay_021_instance->ComputeOverlayIntersection(ulOverlayHandle, pParams, pResults); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_IsHoverTargetOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_021_instance->IsHoverTargetOverlay(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_SetOverlayDualAnalogTransform(vr::VROverlayHandle_t ulOverlay, EDualAnalogWhich eWhich, const vr::HmdVector2_t* pvCenter, float fRadius) { return fntable_Overlay_021_instance->SetOverlayDualAnalogTransform(ulOverlay, eWhich, pvCenter, fRadius); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_GetOverlayDualAnalogTransform(vr::VROverlayHandle_t ulOverlay, EDualAnalogWhich eWhich, vr::HmdVector2_t* pvCenter, float* pfRadius) { return fntable_Overlay_021_instance->GetOverlayDualAnalogTransform(ulOverlay, eWhich, pvCenter, pfRadius); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_SetOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle, const vr::Texture_t* pTexture) { return fntable_Overlay_021_instance->SetOverlayTexture(ulOverlayHandle, pTexture); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_ClearOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_021_instance->ClearOverlayTexture(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_SetOverlayRaw(vr::VROverlayHandle_t ulOverlayHandle, void* pvBuffer, uint32_t unWidth, uint32_t unHeight, uint32_t unDepth) { return fntable_Overlay_021_instance->SetOverlayRaw(ulOverlayHandle, pvBuffer, unWidth, unHeight, unDepth); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_SetOverlayFromFile(vr::VROverlayHandle_t ulOverlayHandle, const char* pchFilePath) { return fntable_Overlay_021_instance->SetOverlayFromFile(ulOverlayHandle, pchFilePath); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_GetOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle, void** pNativeTextureHandle, void* pNativeTextureRef, uint32_t* pWidth, uint32_t* pHeight, uint32_t* pNativeFormat, vr::ETextureType* pAPIType, vr::EColorSpace* pColorSpace, vr::VRTextureBounds_t* pTextureBounds) { return fntable_Overlay_021_instance->GetOverlayTexture(ulOverlayHandle, pNativeTextureHandle, pNativeTextureRef, pWidth, pHeight, pNativeFormat, pAPIType, pColorSpace, pTextureBounds); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_ReleaseNativeOverlayHandle(vr::VROverlayHandle_t ulOverlayHandle, void* pNativeTextureHandle) { return fntable_Overlay_021_instance->ReleaseNativeOverlayHandle(ulOverlayHandle, pNativeTextureHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_GetOverlayTextureSize(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* pWidth, uint32_t* pHeight) { return fntable_Overlay_021_instance->GetOverlayTextureSize(ulOverlayHandle, pWidth, pHeight); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_CreateDashboardOverlay(const char* pchOverlayKey, const char* pchOverlayFriendlyName, vr::VROverlayHandle_t* pMainHandle, vr::VROverlayHandle_t* pThumbnailHandle) { return fntable_Overlay_021_instance->CreateDashboardOverlay(pchOverlayKey, pchOverlayFriendlyName, pMainHandle, pThumbnailHandle); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_IsDashboardVisible() { return fntable_Overlay_021_instance->IsDashboardVisible(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_IsActiveDashboardOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_021_instance->IsActiveDashboardOverlay(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_SetDashboardOverlaySceneProcess(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unProcessId) { return fntable_Overlay_021_instance->SetDashboardOverlaySceneProcess(ulOverlayHandle, unProcessId); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_GetDashboardOverlaySceneProcess(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* punProcessId) { return fntable_Overlay_021_instance->GetDashboardOverlaySceneProcess(ulOverlayHandle, punProcessId); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_ShowDashboard(const char* pchOverlayToShow) { return fntable_Overlay_021_instance->ShowDashboard(pchOverlayToShow); }
static vr::TrackedDeviceIndex_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_GetPrimaryDashboardDevice() { return fntable_Overlay_021_instance->GetPrimaryDashboardDevice(); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_ShowKeyboard(vr::IVROverlay_021::EGamepadTextInputMode eInputMode, vr::IVROverlay_021::EGamepadTextInputLineMode eLineInputMode, const char* pchDescription, uint32_t unCharMax, const char* pchExistingText, bool bUseMinimalMode, uint64_t uUserValue) { return fntable_Overlay_021_instance->ShowKeyboard(eInputMode, eLineInputMode, pchDescription, unCharMax, pchExistingText, bUseMinimalMode, uUserValue); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_ShowKeyboardForOverlay(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_021::EGamepadTextInputMode eInputMode, vr::IVROverlay_021::EGamepadTextInputLineMode eLineInputMode, const char* pchDescription, uint32_t unCharMax, const char* pchExistingText, bool bUseMinimalMode, uint64_t uUserValue) { return fntable_Overlay_021_instance->ShowKeyboardForOverlay(ulOverlayHandle, eInputMode, eLineInputMode, pchDescription, unCharMax, pchExistingText, bUseMinimalMode, uUserValue); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_GetKeyboardText(char* pchText, uint32_t cchText) { return fntable_Overlay_021_instance->GetKeyboardText(pchText, cchText); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_HideKeyboard() { return fntable_Overlay_021_instance->HideKeyboard(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_SetKeyboardTransformAbsolute(vr::ETrackingUniverseOrigin eTrackingOrigin, const vr::HmdMatrix34_t* pmatTrackingOriginToKeyboardTransform) { return fntable_Overlay_021_instance->SetKeyboardTransformAbsolute(eTrackingOrigin, pmatTrackingOriginToKeyboardTransform); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_SetKeyboardPositionForOverlay(vr::VROverlayHandle_t ulOverlayHandle, vr::HmdRect2_t avoidRect) { return fntable_Overlay_021_instance->SetKeyboardPositionForOverlay(ulOverlayHandle, avoidRect); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_SetOverlayIntersectionMask(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_021::VROverlayIntersectionMaskPrimitive_t* pMaskPrimitives, uint32_t unNumMaskPrimitives, uint32_t unPrimitiveSize) { return fntable_Overlay_021_instance->SetOverlayIntersectionMask(ulOverlayHandle, pMaskPrimitives, unNumMaskPrimitives, unPrimitiveSize); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_GetOverlayFlags(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* pFlags) { return fntable_Overlay_021_instance->GetOverlayFlags(ulOverlayHandle, pFlags); }
static vr::IVROverlay_021::VRMessageOverlayResponse OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_ShowMessageOverlay(const char* pchText, const char* pchCaption, const char* pchButton0Text, const char* pchButton1Text, const char* pchButton2Text, const char* pchButton3Text) { return fntable_Overlay_021_instance->ShowMessageOverlay(pchText, pchCaption, pchButton0Text, pchButton1Text, pchButton2Text, pchButton3Text); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_021_impl_CloseMessageOverlay() { return fntable_Overlay_021_instance->CloseMessageOverlay(); }
static void *fntable_Overlay_021_funcs[] = {
	(void*) fntable_Overlay_021_impl_FindOverlay,
	(void*) fntable_Overlay_021_impl_CreateOverlay,
	(void*) fntable_Overlay_021_impl_DestroyOverlay,
	(void*) fntable_Overlay_021_impl_GetOverlayKey,
	(void*) fntable_Overlay_021_impl_GetOverlayName,
	(void*) fntable_Overlay_021_impl_SetOverlayName,
	(void*) fntable_Overlay_021_impl_GetOverlayImageData,
	(void*) fntable_Overlay_021_impl_GetOverlayErrorNameFromEnum,
	(void*) fntable_Overlay_021_impl_SetOverlayRenderingPid,
	(void*) fntable_Overlay_021_impl_GetOverlayRenderingPid,
	(void*) fntable_Overlay_021_impl_SetOverlayFlag,
	(void*) fntable_Overlay_021_impl_GetOverlayFlag,
	(void*) fntable_Overlay_021_impl_SetOverlayColor,
	(void*) fntable_Overlay_021_impl_GetOverlayColor,
	(void*) fntable_Overlay_021_impl_SetOverlayAlpha,
	(void*) fntable_Overlay_021_impl_GetOverlayAlpha,
	(void*) fntable_Overlay_021_impl_SetOverlayTexelAspect,
	(void*) fntable_Overlay_021_impl_GetOverlayTexelAspect,
	(void*) fntable_Overlay_021_impl_SetOverlaySortOrder,
	(void*) fntable_Overlay_021_impl_GetOverlaySortOrder,
	(void*) fntable_Overlay_021_impl_SetOverlayWidthInMeters,
	(void*) fntable_Overlay_021_impl_GetOverlayWidthInMeters,
	(void*) fntable_Overlay_021_impl_SetOverlayCurvature,
	(void*) fntable_Overlay_021_impl_GetOverlayCurvature,
	(void*) fntable_Overlay_021_impl_SetOverlayTextureColorSpace,
	(void*) fntable_Overlay_021_impl_GetOverlayTextureColorSpace,
	(void*) fntable_Overlay_021_impl_SetOverlayTextureBounds,
	(void*) fntable_Overlay_021_impl_GetOverlayTextureBounds,
	(void*) fntable_Overlay_021_impl_GetOverlayRenderModel,
	(void*) fntable_Overlay_021_impl_SetOverlayRenderModel,
	(void*) fntable_Overlay_021_impl_GetOverlayTransformType,
	(void*) fntable_Overlay_021_impl_SetOverlayTransformAbsolute,
	(void*) fntable_Overlay_021_impl_GetOverlayTransformAbsolute,
	(void*) fntable_Overlay_021_impl_SetOverlayTransformTrackedDeviceRelative,
	(void*) fntable_Overlay_021_impl_GetOverlayTransformTrackedDeviceRelative,
	(void*) fntable_Overlay_021_impl_SetOverlayTransformTrackedDeviceComponent,
	(void*) fntable_Overlay_021_impl_GetOverlayTransformTrackedDeviceComponent,
	(void*) fntable_Overlay_021_impl_GetOverlayTransformOverlayRelative,
	(void*) fntable_Overlay_021_impl_SetOverlayTransformOverlayRelative,
	(void*) fntable_Overlay_021_impl_ShowOverlay,
	(void*) fntable_Overlay_021_impl_HideOverlay,
	(void*) fntable_Overlay_021_impl_IsOverlayVisible,
	(void*) fntable_Overlay_021_impl_GetTransformForOverlayCoordinates,
	(void*) fntable_Overlay_021_impl_PollNextOverlayEvent,
	(void*) fntable_Overlay_021_impl_GetOverlayInputMethod,
	(void*) fntable_Overlay_021_impl_SetOverlayInputMethod,
	(void*) fntable_Overlay_021_impl_GetOverlayMouseScale,
	(void*) fntable_Overlay_021_impl_SetOverlayMouseScale,
	(void*) fntable_Overlay_021_impl_ComputeOverlayIntersection,
	(void*) fntable_Overlay_021_impl_IsHoverTargetOverlay,
	(void*) fntable_Overlay_021_impl_SetOverlayDualAnalogTransform,
	(void*) fntable_Overlay_021_impl_GetOverlayDualAnalogTransform,
	(void*) fntable_Overlay_021_impl_SetOverlayTexture,
	(void*) fntable_Overlay_021_impl_ClearOverlayTexture,
	(void*) fntable_Overlay_021_impl_SetOverlayRaw,
	(void*) fntable_Overlay_021_impl_SetOverlayFromFile,
	(void*) fntable_Overlay_021_impl_GetOverlayTexture,
	(void*) fntable_Overlay_021_impl_ReleaseNativeOverlayHandle,
	(void*) fntable_Overlay_021_impl_GetOverlayTextureSize,
	(void*) fntable_Overlay_021_impl_CreateDashboardOverlay,
	(void*) fntable_Overlay_021_impl_IsDashboardVisible,
	(void*) fntable_Overlay_021_impl_IsActiveDashboardOverlay,
	(void*) fntable_Overlay_021_impl_SetDashboardOverlaySceneProcess,
	(void*) fntable_Overlay_021_impl_GetDashboardOverlaySceneProcess,
	(void*) fntable_Overlay_021_impl_ShowDashboard,
	(void*) fntable_Overlay_021_impl_GetPrimaryDashboardDevice,
	(void*) fntable_Overlay_021_impl_ShowKeyboard,
	(void*) fntable_Overlay_021_impl_ShowKeyboardForOverlay,
	(void*) fntable_Overlay_021_impl_GetKeyboardText,
	(void*) fntable_Overlay_021_impl_HideKeyboard,
	(void*) fntable_Overlay_021_impl_SetKeyboardTransformAbsolute,
	(void*) fntable_Overlay_021_impl_SetKeyboardPositionForOverlay,
	(void*) fntable_Overlay_021_impl_SetOverlayIntersectionMask,
	(void*) fntable_Overlay_021_impl_GetOverlayFlags,
	(void*) fntable_Overlay_021_impl_ShowMessageOverlay,
	(void*) fntable_Overlay_021_impl_CloseMessageOverlay,
};
void** CVROverlay_021::_GetStatFuncList() { fntable_Overlay_021_instance = this; return fntable_Overlay_021_funcs; }
void CVROverlay_021::Delete() { delete this; }
// Misc for CVROverlay_022:
CVROverlay_022::CVROverlay_022() : base(GetCreateBaseOverlay()) {}
// Interface methods for CVROverlay_022:
vr::EVROverlayError CVROverlay_022::FindOverlay(const char* pchOverlayKey, vr::VROverlayHandle_t* pOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->FindOverlay(pchOverlayKey, pOverlayHandle);
}
vr::EVROverlayError CVROverlay_022::CreateOverlay(const char* pchOverlayKey, const char* pchOverlayName, vr::VROverlayHandle_t* pOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->CreateOverlay(pchOverlayKey, pchOverlayName, pOverlayHandle);
}
vr::EVROverlayError CVROverlay_022::DestroyOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->DestroyOverlay(ulOverlayHandle);
}
uint32_t CVROverlay_022::GetOverlayKey(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::EVROverlayError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->GetOverlayKey(ulOverlayHandle, pchValue, unBufferSize, pError);
}
uint32_t CVROverlay_022::GetOverlayName(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::EVROverlayError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->GetOverlayName(ulOverlayHandle, pchValue, unBufferSize, pError);
}
vr::EVROverlayError CVROverlay_022::SetOverlayName(vr::VROverlayHandle_t ulOverlayHandle, const char* pchName) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->SetOverlayName(ulOverlayHandle, pchName);
}
vr::EVROverlayError CVROverlay_022::GetOverlayImageData(vr::VROverlayHandle_t ulOverlayHandle, void* pvBuffer, uint32_t unBufferSize, uint32_t* punWidth, uint32_t* punHeight) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->GetOverlayImageData(ulOverlayHandle, pvBuffer, unBufferSize, punWidth, punHeight);
}
const char* CVROverlay_022::GetOverlayErrorNameFromEnum(vr::EVROverlayError error) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->GetOverlayErrorNameFromEnum(error);
}
vr::EVROverlayError CVROverlay_022::SetOverlayRenderingPid(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unPID) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->SetOverlayRenderingPid(ulOverlayHandle, unPID);
}
uint32_t CVROverlay_022::GetOverlayRenderingPid(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->GetOverlayRenderingPid(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_022::SetOverlayFlag(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_022::VROverlayFlags eOverlayFlag, bool bEnabled) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->SetOverlayFlag(ulOverlayHandle, (OOVR_VROverlayFlags) eOverlayFlag, bEnabled);
}
vr::EVROverlayError CVROverlay_022::GetOverlayFlag(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_022::VROverlayFlags eOverlayFlag, bool* pbEnabled) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->GetOverlayFlag(ulOverlayHandle, (OOVR_VROverlayFlags) eOverlayFlag, pbEnabled);
}
vr::EVROverlayError CVROverlay_022::GetOverlayFlags(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* pFlags) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->GetOverlayFlags(ulOverlayHandle, pFlags);
}
vr::EVROverlayError CVROverlay_022::SetOverlayColor(vr::VROverlayHandle_t ulOverlayHandle, float fRed, float fGreen, float fBlue) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->SetOverlayColor(ulOverlayHandle, fRed, fGreen, fBlue);
}
vr::EVROverlayError CVROverlay_022::GetOverlayColor(vr::VROverlayHandle_t ulOverlayHandle, float* pfRed, float* pfGreen, float* pfBlue) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->GetOverlayColor(ulOverlayHandle, pfRed, pfGreen, pfBlue);
}
vr::EVROverlayError CVROverlay_022::SetOverlayAlpha(vr::VROverlayHandle_t ulOverlayHandle, float fAlpha) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->SetOverlayAlpha(ulOverlayHandle, fAlpha);
}
vr::EVROverlayError CVROverlay_022::GetOverlayAlpha(vr::VROverlayHandle_t ulOverlayHandle, float* pfAlpha) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->GetOverlayAlpha(ulOverlayHandle, pfAlpha);
}
vr::EVROverlayError CVROverlay_022::SetOverlayTexelAspect(vr::VROverlayHandle_t ulOverlayHandle, float fTexelAspect) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->SetOverlayTexelAspect(ulOverlayHandle, fTexelAspect);
}
vr::EVROverlayError CVROverlay_022::GetOverlayTexelAspect(vr::VROverlayHandle_t ulOverlayHandle, float* pfTexelAspect) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->GetOverlayTexelAspect(ulOverlayHandle, pfTexelAspect);
}
vr::EVROverlayError CVROverlay_022::SetOverlaySortOrder(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unSortOrder) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->SetOverlaySortOrder(ulOverlayHandle, unSortOrder);
}
vr::EVROverlayError CVROverlay_022::GetOverlaySortOrder(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* punSortOrder) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->GetOverlaySortOrder(ulOverlayHandle, punSortOrder);
}
vr::EVROverlayError CVROverlay_022::SetOverlayWidthInMeters(vr::VROverlayHandle_t ulOverlayHandle, float fWidthInMeters) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->SetOverlayWidthInMeters(ulOverlayHandle, fWidthInMeters);
}
vr::EVROverlayError CVROverlay_022::GetOverlayWidthInMeters(vr::VROverlayHandle_t ulOverlayHandle, float* pfWidthInMeters) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->GetOverlayWidthInMeters(ulOverlayHandle, pfWidthInMeters);
}
vr::EVROverlayError CVROverlay_022::SetOverlayCurvature(vr::VROverlayHandle_t ulOverlayHandle, float fCurvature) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->SetOverlayCurvature(ulOverlayHandle, fCurvature);
}
vr::EVROverlayError CVROverlay_022::GetOverlayCurvature(vr::VROverlayHandle_t ulOverlayHandle, float* pfCurvature) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->GetOverlayCurvature(ulOverlayHandle, pfCurvature);
}
vr::EVROverlayError CVROverlay_022::SetOverlayTextureColorSpace(vr::VROverlayHandle_t ulOverlayHandle, vr::EColorSpace eTextureColorSpace) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->SetOverlayTextureColorSpace(ulOverlayHandle, eTextureColorSpace);
}
vr::EVROverlayError CVROverlay_022::GetOverlayTextureColorSpace(vr::VROverlayHandle_t ulOverlayHandle, vr::EColorSpace* peTextureColorSpace) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->GetOverlayTextureColorSpace(ulOverlayHandle, peTextureColorSpace);
}
vr::EVROverlayError CVROverlay_022::SetOverlayTextureBounds(vr::VROverlayHandle_t ulOverlayHandle, const vr::VRTextureBounds_t* pOverlayTextureBounds) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->SetOverlayTextureBounds(ulOverlayHandle, pOverlayTextureBounds);
}
vr::EVROverlayError CVROverlay_022::GetOverlayTextureBounds(vr::VROverlayHandle_t ulOverlayHandle, vr::VRTextureBounds_t* pOverlayTextureBounds) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->GetOverlayTextureBounds(ulOverlayHandle, pOverlayTextureBounds);
}
uint32_t CVROverlay_022::GetOverlayRenderModel(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::HmdColor_t* pColor, vr::EVROverlayError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->GetOverlayRenderModel(ulOverlayHandle, pchValue, unBufferSize, pColor, pError);
}
vr::EVROverlayError CVROverlay_022::SetOverlayRenderModel(vr::VROverlayHandle_t ulOverlayHandle, const char* pchRenderModel, const vr::HmdColor_t* pColor) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->SetOverlayRenderModel(ulOverlayHandle, pchRenderModel, pColor);
}
vr::EVROverlayError CVROverlay_022::GetOverlayTransformType(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_022::VROverlayTransformType* peTransformType) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->GetOverlayTransformType(ulOverlayHandle, (OOVR_VROverlayTransformType*) peTransformType);
}
vr::EVROverlayError CVROverlay_022::SetOverlayTransformAbsolute(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin eTrackingOrigin, const vr::HmdMatrix34_t* pmatTrackingOriginToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->SetOverlayTransformAbsolute(ulOverlayHandle, eTrackingOrigin, pmatTrackingOriginToOverlayTransform);
}
vr::EVROverlayError CVROverlay_022::GetOverlayTransformAbsolute(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin* peTrackingOrigin, vr::HmdMatrix34_t* pmatTrackingOriginToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->GetOverlayTransformAbsolute(ulOverlayHandle, peTrackingOrigin, pmatTrackingOriginToOverlayTransform);
}
vr::EVROverlayError CVROverlay_022::SetOverlayTransformTrackedDeviceRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unTrackedDevice, const vr::HmdMatrix34_t* pmatTrackedDeviceToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->SetOverlayTransformTrackedDeviceRelative(ulOverlayHandle, unTrackedDevice, pmatTrackedDeviceToOverlayTransform);
}
vr::EVROverlayError CVROverlay_022::GetOverlayTransformTrackedDeviceRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t* punTrackedDevice, vr::HmdMatrix34_t* pmatTrackedDeviceToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->GetOverlayTransformTrackedDeviceRelative(ulOverlayHandle, punTrackedDevice, pmatTrackedDeviceToOverlayTransform);
}
vr::EVROverlayError CVROverlay_022::SetOverlayTransformTrackedDeviceComponent(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unDeviceIndex, const char* pchComponentName) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->SetOverlayTransformTrackedDeviceComponent(ulOverlayHandle, unDeviceIndex, pchComponentName);
}
vr::EVROverlayError CVROverlay_022::GetOverlayTransformTrackedDeviceComponent(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t* punDeviceIndex, char* pchComponentName, uint32_t unComponentNameSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->GetOverlayTransformTrackedDeviceComponent(ulOverlayHandle, punDeviceIndex, pchComponentName, unComponentNameSize);
}
vr::EVROverlayError CVROverlay_022::GetOverlayTransformOverlayRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::VROverlayHandle_t* ulOverlayHandleParent, vr::HmdMatrix34_t* pmatParentOverlayToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->GetOverlayTransformOverlayRelative(ulOverlayHandle, ulOverlayHandleParent, pmatParentOverlayToOverlayTransform);
}
vr::EVROverlayError CVROverlay_022::SetOverlayTransformOverlayRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::VROverlayHandle_t ulOverlayHandleParent, const vr::HmdMatrix34_t* pmatParentOverlayToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->SetOverlayTransformOverlayRelative(ulOverlayHandle, ulOverlayHandleParent, pmatParentOverlayToOverlayTransform);
}
vr::EVROverlayError CVROverlay_022::SetOverlayTransformCursor(vr::VROverlayHandle_t ulCursorOverlayHandle, const vr::HmdVector2_t* pvHotspot) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->SetOverlayTransformCursor(ulCursorOverlayHandle, pvHotspot);
}
vr::EVROverlayError CVROverlay_022::GetOverlayTransformCursor(vr::VROverlayHandle_t ulOverlayHandle, vr::HmdVector2_t* pvHotspot) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->GetOverlayTransformCursor(ulOverlayHandle, pvHotspot);
}
vr::EVROverlayError CVROverlay_022::ShowOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->ShowOverlay(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_022::HideOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->HideOverlay(ulOverlayHandle);
}
bool CVROverlay_022::IsOverlayVisible(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->IsOverlayVisible(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_022::GetTransformForOverlayCoordinates(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin eTrackingOrigin, vr::HmdVector2_t coordinatesInOverlay, vr::HmdMatrix34_t* pmatTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->GetTransformForOverlayCoordinates(ulOverlayHandle, eTrackingOrigin, coordinatesInOverlay, pmatTransform);
}
bool CVROverlay_022::PollNextOverlayEvent(vr::VROverlayHandle_t ulOverlayHandle, vr::VREvent_t* pEvent, uint32_t uncbVREvent) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->PollNextOverlayEvent(ulOverlayHandle, pEvent, uncbVREvent);
}
vr::EVROverlayError CVROverlay_022::GetOverlayInputMethod(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_022::VROverlayInputMethod* peInputMethod) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->GetOverlayInputMethod(ulOverlayHandle, (OOVR_VROverlayInputMethod*) peInputMethod);
}
vr::EVROverlayError CVROverlay_022::SetOverlayInputMethod(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_022::VROverlayInputMethod eInputMethod) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->SetOverlayInputMethod(ulOverlayHandle, (OOVR_VROverlayInputMethod) eInputMethod);
}
vr::EVROverlayError CVROverlay_022::GetOverlayMouseScale(vr::VROverlayHandle_t ulOverlayHandle, vr::HmdVector2_t* pvecMouseScale) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->GetOverlayMouseScale(ulOverlayHandle, pvecMouseScale);
}
vr::EVROverlayError CVROverlay_022::SetOverlayMouseScale(vr::VROverlayHandle_t ulOverlayHandle, const vr::HmdVector2_t* pvecMouseScale) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->SetOverlayMouseScale(ulOverlayHandle, pvecMouseScale);
}
bool CVROverlay_022::ComputeOverlayIntersection(vr::VROverlayHandle_t ulOverlayHandle, const vr::IVROverlay_022::VROverlayIntersectionParams_t* pParams, vr::IVROverlay_022::VROverlayIntersectionResults_t* pResults) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->ComputeOverlayIntersection(ulOverlayHandle, (const OOVR_VROverlayIntersectionParams_t*) pParams, (OOVR_VROverlayIntersectionResults_t*) pResults);
}
bool CVROverlay_022::IsHoverTargetOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->IsHoverTargetOverlay(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_022::SetOverlayDualAnalogTransform(vr::VROverlayHandle_t ulOverlay, EDualAnalogWhich eWhich, const vr::HmdVector2_t* pvCenter, float fRadius) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->SetOverlayDualAnalogTransform(ulOverlay, eWhich, pvCenter, fRadius);
}
vr::EVROverlayError CVROverlay_022::GetOverlayDualAnalogTransform(vr::VROverlayHandle_t ulOverlay, EDualAnalogWhich eWhich, vr::HmdVector2_t* pvCenter, float* pfRadius) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->GetOverlayDualAnalogTransform(ulOverlay, eWhich, pvCenter, pfRadius);
}
vr::EVROverlayError CVROverlay_022::SetOverlayIntersectionMask(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_022::VROverlayIntersectionMaskPrimitive_t* pMaskPrimitives, uint32_t unNumMaskPrimitives, uint32_t unPrimitiveSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->SetOverlayIntersectionMask(ulOverlayHandle, (OOVR_VROverlayIntersectionMaskPrimitive_t*) pMaskPrimitives, unNumMaskPrimitives, unPrimitiveSize);
}
vr::EVROverlayError CVROverlay_022::TriggerLaserMouseHapticVibration(vr::VROverlayHandle_t ulOverlayHandle, float fDurationSeconds, float fFrequency, float fAmplitude) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->TriggerLaserMouseHapticVibration(ulOverlayHandle, fDurationSeconds, fFrequency, fAmplitude);
}
vr::EVROverlayError CVROverlay_022::SetOverlayCursor(vr::VROverlayHandle_t ulOverlayHandle, vr::VROverlayHandle_t ulCursorHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->SetOverlayCursor(ulOverlayHandle, ulCursorHandle);
}
vr::EVROverlayError CVROverlay_022::SetOverlayCursorPositionOverride(vr::VROverlayHandle_t ulOverlayHandle, const vr::HmdVector2_t* pvCursor) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->SetOverlayCursorPositionOverride(ulOverlayHandle, pvCursor);
}
vr::EVROverlayError CVROverlay_022::ClearOverlayCursorPositionOverride(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->ClearOverlayCursorPositionOverride(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_022::SetOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle, const vr::Texture_t* pTexture) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->SetOverlayTexture(ulOverlayHandle, pTexture);
}
vr::EVROverlayError CVROverlay_022::ClearOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->ClearOverlayTexture(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_022::SetOverlayRaw(vr::VROverlayHandle_t ulOverlayHandle, void* pvBuffer, uint32_t unWidth, uint32_t unHeight, uint32_t unBytesPerPixel) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->SetOverlayRaw(ulOverlayHandle, pvBuffer, unWidth, unHeight, unBytesPerPixel);
}
vr::EVROverlayError CVROverlay_022::SetOverlayFromFile(vr::VROverlayHandle_t ulOverlayHandle, const char* pchFilePath) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->SetOverlayFromFile(ulOverlayHandle, pchFilePath);
}
vr::EVROverlayError CVROverlay_022::GetOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle, void** pNativeTextureHandle, void* pNativeTextureRef, uint32_t* pWidth, uint32_t* pHeight, uint32_t* pNativeFormat, vr::ETextureType* pAPIType, vr::EColorSpace* pColorSpace, vr::VRTextureBounds_t* pTextureBounds) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->GetOverlayTexture(ulOverlayHandle, pNativeTextureHandle, pNativeTextureRef, pWidth, pHeight, pNativeFormat, pAPIType, pColorSpace, pTextureBounds);
}
vr::EVROverlayError CVROverlay_022::ReleaseNativeOverlayHandle(vr::VROverlayHandle_t ulOverlayHandle, void* pNativeTextureHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->ReleaseNativeOverlayHandle(ulOverlayHandle, pNativeTextureHandle);
}
vr::EVROverlayError CVROverlay_022::GetOverlayTextureSize(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* pWidth, uint32_t* pHeight) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->GetOverlayTextureSize(ulOverlayHandle, pWidth, pHeight);
}
vr::EVROverlayError CVROverlay_022::CreateDashboardOverlay(const char* pchOverlayKey, const char* pchOverlayFriendlyName, vr::VROverlayHandle_t* pMainHandle, vr::VROverlayHandle_t* pThumbnailHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->CreateDashboardOverlay(pchOverlayKey, pchOverlayFriendlyName, pMainHandle, pThumbnailHandle);
}
bool CVROverlay_022::IsDashboardVisible() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->IsDashboardVisible();
}
bool CVROverlay_022::IsActiveDashboardOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->IsActiveDashboardOverlay(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_022::SetDashboardOverlaySceneProcess(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unProcessId) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->SetDashboardOverlaySceneProcess(ulOverlayHandle, unProcessId);
}
vr::EVROverlayError CVROverlay_022::GetDashboardOverlaySceneProcess(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* punProcessId) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->GetDashboardOverlaySceneProcess(ulOverlayHandle, punProcessId);
}
void CVROverlay_022::ShowDashboard(const char* pchOverlayToShow) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->ShowDashboard(pchOverlayToShow);
}
vr::TrackedDeviceIndex_t CVROverlay_022::GetPrimaryDashboardDevice() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->GetPrimaryDashboardDevice();
}
vr::EVROverlayError CVROverlay_022::ShowKeyboard(vr::IVROverlay_022::EGamepadTextInputMode eInputMode, vr::IVROverlay_022::EGamepadTextInputLineMode eLineInputMode, const char* pchDescription, uint32_t unCharMax, const char* pchExistingText, bool bUseMinimalMode, uint64_t uUserValue) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->ShowKeyboard((OOVR_EGamepadTextInputMode) eInputMode, (OOVR_EGamepadTextInputLineMode) eLineInputMode, pchDescription, unCharMax, pchExistingText, bUseMinimalMode, uUserValue);
}
vr::EVROverlayError CVROverlay_022::ShowKeyboardForOverlay(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_022::EGamepadTextInputMode eInputMode, vr::IVROverlay_022::EGamepadTextInputLineMode eLineInputMode, const char* pchDescription, uint32_t unCharMax, const char* pchExistingText, bool bUseMinimalMode, uint64_t uUserValue) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->ShowKeyboardForOverlay(ulOverlayHandle, (OOVR_EGamepadTextInputMode) eInputMode, (OOVR_EGamepadTextInputLineMode) eLineInputMode, pchDescription, unCharMax, pchExistingText, bUseMinimalMode, uUserValue);
}
uint32_t CVROverlay_022::GetKeyboardText(char* pchText, uint32_t cchText) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->GetKeyboardText(pchText, cchText);
}
void CVROverlay_022::HideKeyboard() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->HideKeyboard();
}
void CVROverlay_022::SetKeyboardTransformAbsolute(vr::ETrackingUniverseOrigin eTrackingOrigin, const vr::HmdMatrix34_t* pmatTrackingOriginToKeyboardTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->SetKeyboardTransformAbsolute(eTrackingOrigin, pmatTrackingOriginToKeyboardTransform);
}
void CVROverlay_022::SetKeyboardPositionForOverlay(vr::VROverlayHandle_t ulOverlayHandle, vr::HmdRect2_t avoidRect) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->SetKeyboardPositionForOverlay(ulOverlayHandle, avoidRect);
}
vr::IVROverlay_022::VRMessageOverlayResponse CVROverlay_022::ShowMessageOverlay(const char* pchText, const char* pchCaption, const char* pchButton0Text, const char* pchButton1Text, const char* pchButton2Text, const char* pchButton3Text) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return (vr::IVROverlay_022::VRMessageOverlayResponse) base->ShowMessageOverlay(pchText, pchCaption, pchButton0Text, pchButton1Text, pchButton2Text, pchButton3Text);
}
void CVROverlay_022::CloseMessageOverlay() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_022)");
	return base->CloseMessageOverlay();
}
// FnTable for CVROverlay_022:
static CVROverlay_022 *fntable_Overlay_022_instance = NULL;
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_FindOverlay(const char* pchOverlayKey, vr::VROverlayHandle_t* pOverlayHandle) { return fntable_Overlay_022_instance->FindOverlay(pchOverlayKey, pOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_CreateOverlay(const char* pchOverlayKey, const char* pchOverlayName, vr::VROverlayHandle_t* pOverlayHandle) { return fntable_Overlay_022_instance->CreateOverlay(pchOverlayKey, pchOverlayName, pOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_DestroyOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_022_instance->DestroyOverlay(ulOverlayHandle); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_GetOverlayKey(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::EVROverlayError* pError) { return fntable_Overlay_022_instance->GetOverlayKey(ulOverlayHandle, pchValue, unBufferSize, pError); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_GetOverlayName(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::EVROverlayError* pError) { return fntable_Overlay_022_instance->GetOverlayName(ulOverlayHandle, pchValue, unBufferSize, pError); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_SetOverlayName(vr::VROverlayHandle_t ulOverlayHandle, const char* pchName) { return fntable_Overlay_022_instance->SetOverlayName(ulOverlayHandle, pchName); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_GetOverlayImageData(vr::VROverlayHandle_t ulOverlayHandle, void* pvBuffer, uint32_t unBufferSize, uint32_t* punWidth, uint32_t* punHeight) { return fntable_Overlay_022_instance->GetOverlayImageData(ulOverlayHandle, pvBuffer, unBufferSize, punWidth, punHeight); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_GetOverlayErrorNameFromEnum(vr::EVROverlayError error) { return fntable_Overlay_022_instance->GetOverlayErrorNameFromEnum(error); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_SetOverlayRenderingPid(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unPID) { return fntable_Overlay_022_instance->SetOverlayRenderingPid(ulOverlayHandle, unPID); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_GetOverlayRenderingPid(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_022_instance->GetOverlayRenderingPid(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_SetOverlayFlag(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_022::VROverlayFlags eOverlayFlag, bool bEnabled) { return fntable_Overlay_022_instance->SetOverlayFlag(ulOverlayHandle, eOverlayFlag, bEnabled); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_GetOverlayFlag(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_022::VROverlayFlags eOverlayFlag, bool* pbEnabled) { return fntable_Overlay_022_instance->GetOverlayFlag(ulOverlayHandle, eOverlayFlag, pbEnabled); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_GetOverlayFlags(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* pFlags) { return fntable_Overlay_022_instance->GetOverlayFlags(ulOverlayHandle, pFlags); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_SetOverlayColor(vr::VROverlayHandle_t ulOverlayHandle, float fRed, float fGreen, float fBlue) { return fntable_Overlay_022_instance->SetOverlayColor(ulOverlayHandle, fRed, fGreen, fBlue); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_GetOverlayColor(vr::VROverlayHandle_t ulOverlayHandle, float* pfRed, float* pfGreen, float* pfBlue) { return fntable_Overlay_022_instance->GetOverlayColor(ulOverlayHandle, pfRed, pfGreen, pfBlue); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_SetOverlayAlpha(vr::VROverlayHandle_t ulOverlayHandle, float fAlpha) { return fntable_Overlay_022_instance->SetOverlayAlpha(ulOverlayHandle, fAlpha); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_GetOverlayAlpha(vr::VROverlayHandle_t ulOverlayHandle, float* pfAlpha) { return fntable_Overlay_022_instance->GetOverlayAlpha(ulOverlayHandle, pfAlpha); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_SetOverlayTexelAspect(vr::VROverlayHandle_t ulOverlayHandle, float fTexelAspect) { return fntable_Overlay_022_instance->SetOverlayTexelAspect(ulOverlayHandle, fTexelAspect); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_GetOverlayTexelAspect(vr::VROverlayHandle_t ulOverlayHandle, float* pfTexelAspect) { return fntable_Overlay_022_instance->GetOverlayTexelAspect(ulOverlayHandle, pfTexelAspect); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_SetOverlaySortOrder(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unSortOrder) { return fntable_Overlay_022_instance->SetOverlaySortOrder(ulOverlayHandle, unSortOrder); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_GetOverlaySortOrder(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* punSortOrder) { return fntable_Overlay_022_instance->GetOverlaySortOrder(ulOverlayHandle, punSortOrder); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_SetOverlayWidthInMeters(vr::VROverlayHandle_t ulOverlayHandle, float fWidthInMeters) { return fntable_Overlay_022_instance->SetOverlayWidthInMeters(ulOverlayHandle, fWidthInMeters); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_GetOverlayWidthInMeters(vr::VROverlayHandle_t ulOverlayHandle, float* pfWidthInMeters) { return fntable_Overlay_022_instance->GetOverlayWidthInMeters(ulOverlayHandle, pfWidthInMeters); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_SetOverlayCurvature(vr::VROverlayHandle_t ulOverlayHandle, float fCurvature) { return fntable_Overlay_022_instance->SetOverlayCurvature(ulOverlayHandle, fCurvature); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_GetOverlayCurvature(vr::VROverlayHandle_t ulOverlayHandle, float* pfCurvature) { return fntable_Overlay_022_instance->GetOverlayCurvature(ulOverlayHandle, pfCurvature); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_SetOverlayTextureColorSpace(vr::VROverlayHandle_t ulOverlayHandle, vr::EColorSpace eTextureColorSpace) { return fntable_Overlay_022_instance->SetOverlayTextureColorSpace(ulOverlayHandle, eTextureColorSpace); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_GetOverlayTextureColorSpace(vr::VROverlayHandle_t ulOverlayHandle, vr::EColorSpace* peTextureColorSpace) { return fntable_Overlay_022_instance->GetOverlayTextureColorSpace(ulOverlayHandle, peTextureColorSpace); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_SetOverlayTextureBounds(vr::VROverlayHandle_t ulOverlayHandle, const vr::VRTextureBounds_t* pOverlayTextureBounds) { return fntable_Overlay_022_instance->SetOverlayTextureBounds(ulOverlayHandle, pOverlayTextureBounds); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_GetOverlayTextureBounds(vr::VROverlayHandle_t ulOverlayHandle, vr::VRTextureBounds_t* pOverlayTextureBounds) { return fntable_Overlay_022_instance->GetOverlayTextureBounds(ulOverlayHandle, pOverlayTextureBounds); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_GetOverlayRenderModel(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::HmdColor_t* pColor, vr::EVROverlayError* pError) { return fntable_Overlay_022_instance->GetOverlayRenderModel(ulOverlayHandle, pchValue, unBufferSize, pColor, pError); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_SetOverlayRenderModel(vr::VROverlayHandle_t ulOverlayHandle, const char* pchRenderModel, const vr::HmdColor_t* pColor) { return fntable_Overlay_022_instance->SetOverlayRenderModel(ulOverlayHandle, pchRenderModel, pColor); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_GetOverlayTransformType(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_022::VROverlayTransformType* peTransformType) { return fntable_Overlay_022_instance->GetOverlayTransformType(ulOverlayHandle, peTransformType); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_SetOverlayTransformAbsolute(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin eTrackingOrigin, const vr::HmdMatrix34_t* pmatTrackingOriginToOverlayTransform) { return fntable_Overlay_022_instance->SetOverlayTransformAbsolute(ulOverlayHandle, eTrackingOrigin, pmatTrackingOriginToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_GetOverlayTransformAbsolute(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin* peTrackingOrigin, vr::HmdMatrix34_t* pmatTrackingOriginToOverlayTransform) { return fntable_Overlay_022_instance->GetOverlayTransformAbsolute(ulOverlayHandle, peTrackingOrigin, pmatTrackingOriginToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_SetOverlayTransformTrackedDeviceRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unTrackedDevice, const vr::HmdMatrix34_t* pmatTrackedDeviceToOverlayTransform) { return fntable_Overlay_022_instance->SetOverlayTransformTrackedDeviceRelative(ulOverlayHandle, unTrackedDevice, pmatTrackedDeviceToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_GetOverlayTransformTrackedDeviceRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t* punTrackedDevice, vr::HmdMatrix34_t* pmatTrackedDeviceToOverlayTransform) { return fntable_Overlay_022_instance->GetOverlayTransformTrackedDeviceRelative(ulOverlayHandle, punTrackedDevice, pmatTrackedDeviceToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_SetOverlayTransformTrackedDeviceComponent(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unDeviceIndex, const char* pchComponentName) { return fntable_Overlay_022_instance->SetOverlayTransformTrackedDeviceComponent(ulOverlayHandle, unDeviceIndex, pchComponentName); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_GetOverlayTransformTrackedDeviceComponent(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t* punDeviceIndex, char* pchComponentName, uint32_t unComponentNameSize) { return fntable_Overlay_022_instance->GetOverlayTransformTrackedDeviceComponent(ulOverlayHandle, punDeviceIndex, pchComponentName, unComponentNameSize); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_GetOverlayTransformOverlayRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::VROverlayHandle_t* ulOverlayHandleParent, vr::HmdMatrix34_t* pmatParentOverlayToOverlayTransform) { return fntable_Overlay_022_instance->GetOverlayTransformOverlayRelative(ulOverlayHandle, ulOverlayHandleParent, pmatParentOverlayToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_SetOverlayTransformOverlayRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::VROverlayHandle_t ulOverlayHandleParent, const vr::HmdMatrix34_t* pmatParentOverlayToOverlayTransform) { return fntable_Overlay_022_instance->SetOverlayTransformOverlayRelative(ulOverlayHandle, ulOverlayHandleParent, pmatParentOverlayToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_SetOverlayTransformCursor(vr::VROverlayHandle_t ulCursorOverlayHandle, const vr::HmdVector2_t* pvHotspot) { return fntable_Overlay_022_instance->SetOverlayTransformCursor(ulCursorOverlayHandle, pvHotspot); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_GetOverlayTransformCursor(vr::VROverlayHandle_t ulOverlayHandle, vr::HmdVector2_t* pvHotspot) { return fntable_Overlay_022_instance->GetOverlayTransformCursor(ulOverlayHandle, pvHotspot); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_ShowOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_022_instance->ShowOverlay(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_HideOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_022_instance->HideOverlay(ulOverlayHandle); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_IsOverlayVisible(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_022_instance->IsOverlayVisible(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_GetTransformForOverlayCoordinates(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin eTrackingOrigin, vr::HmdVector2_t coordinatesInOverlay, vr::HmdMatrix34_t* pmatTransform) { return fntable_Overlay_022_instance->GetTransformForOverlayCoordinates(ulOverlayHandle, eTrackingOrigin, coordinatesInOverlay, pmatTransform); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_PollNextOverlayEvent(vr::VROverlayHandle_t ulOverlayHandle, vr::VREvent_t* pEvent, uint32_t uncbVREvent) { return fntable_Overlay_022_instance->PollNextOverlayEvent(ulOverlayHandle, pEvent, uncbVREvent); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_GetOverlayInputMethod(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_022::VROverlayInputMethod* peInputMethod) { return fntable_Overlay_022_instance->GetOverlayInputMethod(ulOverlayHandle, peInputMethod); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_SetOverlayInputMethod(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_022::VROverlayInputMethod eInputMethod) { return fntable_Overlay_022_instance->SetOverlayInputMethod(ulOverlayHandle, eInputMethod); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_GetOverlayMouseScale(vr::VROverlayHandle_t ulOverlayHandle, vr::HmdVector2_t* pvecMouseScale) { return fntable_Overlay_022_instance->GetOverlayMouseScale(ulOverlayHandle, pvecMouseScale); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_SetOverlayMouseScale(vr::VROverlayHandle_t ulOverlayHandle, const vr::HmdVector2_t* pvecMouseScale) { return fntable_Overlay_022_instance->SetOverlayMouseScale(ulOverlayHandle, pvecMouseScale); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_ComputeOverlayIntersection(vr::VROverlayHandle_t ulOverlayHandle, const vr::IVROverlay_022::VROverlayIntersectionParams_t* pParams, vr::IVROverlay_022::VROverlayIntersectionResults_t* pResults) { return fntable_Overlay_022_instance->ComputeOverlayIntersection(ulOverlayHandle, pParams, pResults); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_IsHoverTargetOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_022_instance->IsHoverTargetOverlay(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_SetOverlayDualAnalogTransform(vr::VROverlayHandle_t ulOverlay, EDualAnalogWhich eWhich, const vr::HmdVector2_t* pvCenter, float fRadius) { return fntable_Overlay_022_instance->SetOverlayDualAnalogTransform(ulOverlay, eWhich, pvCenter, fRadius); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_GetOverlayDualAnalogTransform(vr::VROverlayHandle_t ulOverlay, EDualAnalogWhich eWhich, vr::HmdVector2_t* pvCenter, float* pfRadius) { return fntable_Overlay_022_instance->GetOverlayDualAnalogTransform(ulOverlay, eWhich, pvCenter, pfRadius); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_SetOverlayIntersectionMask(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_022::VROverlayIntersectionMaskPrimitive_t* pMaskPrimitives, uint32_t unNumMaskPrimitives, uint32_t unPrimitiveSize) { return fntable_Overlay_022_instance->SetOverlayIntersectionMask(ulOverlayHandle, pMaskPrimitives, unNumMaskPrimitives, unPrimitiveSize); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_TriggerLaserMouseHapticVibration(vr::VROverlayHandle_t ulOverlayHandle, float fDurationSeconds, float fFrequency, float fAmplitude) { return fntable_Overlay_022_instance->TriggerLaserMouseHapticVibration(ulOverlayHandle, fDurationSeconds, fFrequency, fAmplitude); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_SetOverlayCursor(vr::VROverlayHandle_t ulOverlayHandle, vr::VROverlayHandle_t ulCursorHandle) { return fntable_Overlay_022_instance->SetOverlayCursor(ulOverlayHandle, ulCursorHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_SetOverlayCursorPositionOverride(vr::VROverlayHandle_t ulOverlayHandle, const vr::HmdVector2_t* pvCursor) { return fntable_Overlay_022_instance->SetOverlayCursorPositionOverride(ulOverlayHandle, pvCursor); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_ClearOverlayCursorPositionOverride(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_022_instance->ClearOverlayCursorPositionOverride(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_SetOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle, const vr::Texture_t* pTexture) { return fntable_Overlay_022_instance->SetOverlayTexture(ulOverlayHandle, pTexture); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_ClearOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_022_instance->ClearOverlayTexture(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_SetOverlayRaw(vr::VROverlayHandle_t ulOverlayHandle, void* pvBuffer, uint32_t unWidth, uint32_t unHeight, uint32_t unBytesPerPixel) { return fntable_Overlay_022_instance->SetOverlayRaw(ulOverlayHandle, pvBuffer, unWidth, unHeight, unBytesPerPixel); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_SetOverlayFromFile(vr::VROverlayHandle_t ulOverlayHandle, const char* pchFilePath) { return fntable_Overlay_022_instance->SetOverlayFromFile(ulOverlayHandle, pchFilePath); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_GetOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle, void** pNativeTextureHandle, void* pNativeTextureRef, uint32_t* pWidth, uint32_t* pHeight, uint32_t* pNativeFormat, vr::ETextureType* pAPIType, vr::EColorSpace* pColorSpace, vr::VRTextureBounds_t* pTextureBounds) { return fntable_Overlay_022_instance->GetOverlayTexture(ulOverlayHandle, pNativeTextureHandle, pNativeTextureRef, pWidth, pHeight, pNativeFormat, pAPIType, pColorSpace, pTextureBounds); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_ReleaseNativeOverlayHandle(vr::VROverlayHandle_t ulOverlayHandle, void* pNativeTextureHandle) { return fntable_Overlay_022_instance->ReleaseNativeOverlayHandle(ulOverlayHandle, pNativeTextureHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_GetOverlayTextureSize(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* pWidth, uint32_t* pHeight) { return fntable_Overlay_022_instance->GetOverlayTextureSize(ulOverlayHandle, pWidth, pHeight); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_CreateDashboardOverlay(const char* pchOverlayKey, const char* pchOverlayFriendlyName, vr::VROverlayHandle_t* pMainHandle, vr::VROverlayHandle_t* pThumbnailHandle) { return fntable_Overlay_022_instance->CreateDashboardOverlay(pchOverlayKey, pchOverlayFriendlyName, pMainHandle, pThumbnailHandle); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_IsDashboardVisible() { return fntable_Overlay_022_instance->IsDashboardVisible(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_IsActiveDashboardOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_022_instance->IsActiveDashboardOverlay(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_SetDashboardOverlaySceneProcess(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unProcessId) { return fntable_Overlay_022_instance->SetDashboardOverlaySceneProcess(ulOverlayHandle, unProcessId); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_GetDashboardOverlaySceneProcess(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* punProcessId) { return fntable_Overlay_022_instance->GetDashboardOverlaySceneProcess(ulOverlayHandle, punProcessId); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_ShowDashboard(const char* pchOverlayToShow) { return fntable_Overlay_022_instance->ShowDashboard(pchOverlayToShow); }
static vr::TrackedDeviceIndex_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_GetPrimaryDashboardDevice() { return fntable_Overlay_022_instance->GetPrimaryDashboardDevice(); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_ShowKeyboard(vr::IVROverlay_022::EGamepadTextInputMode eInputMode, vr::IVROverlay_022::EGamepadTextInputLineMode eLineInputMode, const char* pchDescription, uint32_t unCharMax, const char* pchExistingText, bool bUseMinimalMode, uint64_t uUserValue) { return fntable_Overlay_022_instance->ShowKeyboard(eInputMode, eLineInputMode, pchDescription, unCharMax, pchExistingText, bUseMinimalMode, uUserValue); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_ShowKeyboardForOverlay(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_022::EGamepadTextInputMode eInputMode, vr::IVROverlay_022::EGamepadTextInputLineMode eLineInputMode, const char* pchDescription, uint32_t unCharMax, const char* pchExistingText, bool bUseMinimalMode, uint64_t uUserValue) { return fntable_Overlay_022_instance->ShowKeyboardForOverlay(ulOverlayHandle, eInputMode, eLineInputMode, pchDescription, unCharMax, pchExistingText, bUseMinimalMode, uUserValue); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_GetKeyboardText(char* pchText, uint32_t cchText) { return fntable_Overlay_022_instance->GetKeyboardText(pchText, cchText); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_HideKeyboard() { return fntable_Overlay_022_instance->HideKeyboard(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_SetKeyboardTransformAbsolute(vr::ETrackingUniverseOrigin eTrackingOrigin, const vr::HmdMatrix34_t* pmatTrackingOriginToKeyboardTransform) { return fntable_Overlay_022_instance->SetKeyboardTransformAbsolute(eTrackingOrigin, pmatTrackingOriginToKeyboardTransform); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_SetKeyboardPositionForOverlay(vr::VROverlayHandle_t ulOverlayHandle, vr::HmdRect2_t avoidRect) { return fntable_Overlay_022_instance->SetKeyboardPositionForOverlay(ulOverlayHandle, avoidRect); }
static vr::IVROverlay_022::VRMessageOverlayResponse OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_ShowMessageOverlay(const char* pchText, const char* pchCaption, const char* pchButton0Text, const char* pchButton1Text, const char* pchButton2Text, const char* pchButton3Text) { return fntable_Overlay_022_instance->ShowMessageOverlay(pchText, pchCaption, pchButton0Text, pchButton1Text, pchButton2Text, pchButton3Text); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_022_impl_CloseMessageOverlay() { return fntable_Overlay_022_instance->CloseMessageOverlay(); }
static void *fntable_Overlay_022_funcs[] = {
	(void*) fntable_Overlay_022_impl_FindOverlay,
	(void*) fntable_Overlay_022_impl_CreateOverlay,
	(void*) fntable_Overlay_022_impl_DestroyOverlay,
	(void*) fntable_Overlay_022_impl_GetOverlayKey,
	(void*) fntable_Overlay_022_impl_GetOverlayName,
	(void*) fntable_Overlay_022_impl_SetOverlayName,
	(void*) fntable_Overlay_022_impl_GetOverlayImageData,
	(void*) fntable_Overlay_022_impl_GetOverlayErrorNameFromEnum,
	(void*) fntable_Overlay_022_impl_SetOverlayRenderingPid,
	(void*) fntable_Overlay_022_impl_GetOverlayRenderingPid,
	(void*) fntable_Overlay_022_impl_SetOverlayFlag,
	(void*) fntable_Overlay_022_impl_GetOverlayFlag,
	(void*) fntable_Overlay_022_impl_GetOverlayFlags,
	(void*) fntable_Overlay_022_impl_SetOverlayColor,
	(void*) fntable_Overlay_022_impl_GetOverlayColor,
	(void*) fntable_Overlay_022_impl_SetOverlayAlpha,
	(void*) fntable_Overlay_022_impl_GetOverlayAlpha,
	(void*) fntable_Overlay_022_impl_SetOverlayTexelAspect,
	(void*) fntable_Overlay_022_impl_GetOverlayTexelAspect,
	(void*) fntable_Overlay_022_impl_SetOverlaySortOrder,
	(void*) fntable_Overlay_022_impl_GetOverlaySortOrder,
	(void*) fntable_Overlay_022_impl_SetOverlayWidthInMeters,
	(void*) fntable_Overlay_022_impl_GetOverlayWidthInMeters,
	(void*) fntable_Overlay_022_impl_SetOverlayCurvature,
	(void*) fntable_Overlay_022_impl_GetOverlayCurvature,
	(void*) fntable_Overlay_022_impl_SetOverlayTextureColorSpace,
	(void*) fntable_Overlay_022_impl_GetOverlayTextureColorSpace,
	(void*) fntable_Overlay_022_impl_SetOverlayTextureBounds,
	(void*) fntable_Overlay_022_impl_GetOverlayTextureBounds,
	(void*) fntable_Overlay_022_impl_GetOverlayRenderModel,
	(void*) fntable_Overlay_022_impl_SetOverlayRenderModel,
	(void*) fntable_Overlay_022_impl_GetOverlayTransformType,
	(void*) fntable_Overlay_022_impl_SetOverlayTransformAbsolute,
	(void*) fntable_Overlay_022_impl_GetOverlayTransformAbsolute,
	(void*) fntable_Overlay_022_impl_SetOverlayTransformTrackedDeviceRelative,
	(void*) fntable_Overlay_022_impl_GetOverlayTransformTrackedDeviceRelative,
	(void*) fntable_Overlay_022_impl_SetOverlayTransformTrackedDeviceComponent,
	(void*) fntable_Overlay_022_impl_GetOverlayTransformTrackedDeviceComponent,
	(void*) fntable_Overlay_022_impl_GetOverlayTransformOverlayRelative,
	(void*) fntable_Overlay_022_impl_SetOverlayTransformOverlayRelative,
	(void*) fntable_Overlay_022_impl_SetOverlayTransformCursor,
	(void*) fntable_Overlay_022_impl_GetOverlayTransformCursor,
	(void*) fntable_Overlay_022_impl_ShowOverlay,
	(void*) fntable_Overlay_022_impl_HideOverlay,
	(void*) fntable_Overlay_022_impl_IsOverlayVisible,
	(void*) fntable_Overlay_022_impl_GetTransformForOverlayCoordinates,
	(void*) fntable_Overlay_022_impl_PollNextOverlayEvent,
	(void*) fntable_Overlay_022_impl_GetOverlayInputMethod,
	(void*) fntable_Overlay_022_impl_SetOverlayInputMethod,
	(void*) fntable_Overlay_022_impl_GetOverlayMouseScale,
	(void*) fntable_Overlay_022_impl_SetOverlayMouseScale,
	(void*) fntable_Overlay_022_impl_ComputeOverlayIntersection,
	(void*) fntable_Overlay_022_impl_IsHoverTargetOverlay,
	(void*) fntable_Overlay_022_impl_SetOverlayDualAnalogTransform,
	(void*) fntable_Overlay_022_impl_GetOverlayDualAnalogTransform,
	(void*) fntable_Overlay_022_impl_SetOverlayIntersectionMask,
	(void*) fntable_Overlay_022_impl_TriggerLaserMouseHapticVibration,
	(void*) fntable_Overlay_022_impl_SetOverlayCursor,
	(void*) fntable_Overlay_022_impl_SetOverlayCursorPositionOverride,
	(void*) fntable_Overlay_022_impl_ClearOverlayCursorPositionOverride,
	(void*) fntable_Overlay_022_impl_SetOverlayTexture,
	(void*) fntable_Overlay_022_impl_ClearOverlayTexture,
	(void*) fntable_Overlay_022_impl_SetOverlayRaw,
	(void*) fntable_Overlay_022_impl_SetOverlayFromFile,
	(void*) fntable_Overlay_022_impl_GetOverlayTexture,
	(void*) fntable_Overlay_022_impl_ReleaseNativeOverlayHandle,
	(void*) fntable_Overlay_022_impl_GetOverlayTextureSize,
	(void*) fntable_Overlay_022_impl_CreateDashboardOverlay,
	(void*) fntable_Overlay_022_impl_IsDashboardVisible,
	(void*) fntable_Overlay_022_impl_IsActiveDashboardOverlay,
	(void*) fntable_Overlay_022_impl_SetDashboardOverlaySceneProcess,
	(void*) fntable_Overlay_022_impl_GetDashboardOverlaySceneProcess,
	(void*) fntable_Overlay_022_impl_ShowDashboard,
	(void*) fntable_Overlay_022_impl_GetPrimaryDashboardDevice,
	(void*) fntable_Overlay_022_impl_ShowKeyboard,
	(void*) fntable_Overlay_022_impl_ShowKeyboardForOverlay,
	(void*) fntable_Overlay_022_impl_GetKeyboardText,
	(void*) fntable_Overlay_022_impl_HideKeyboard,
	(void*) fntable_Overlay_022_impl_SetKeyboardTransformAbsolute,
	(void*) fntable_Overlay_022_impl_SetKeyboardPositionForOverlay,
	(void*) fntable_Overlay_022_impl_ShowMessageOverlay,
	(void*) fntable_Overlay_022_impl_CloseMessageOverlay,
};
void** CVROverlay_022::_GetStatFuncList() { fntable_Overlay_022_instance = this; return fntable_Overlay_022_funcs; }
void CVROverlay_022::Delete() { delete this; }
// Misc for CVROverlay_024:
CVROverlay_024::CVROverlay_024() : base(GetCreateBaseOverlay()) {}
// Interface methods for CVROverlay_024:
vr::EVROverlayError CVROverlay_024::FindOverlay(const char* pchOverlayKey, vr::VROverlayHandle_t* pOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->FindOverlay(pchOverlayKey, pOverlayHandle);
}
vr::EVROverlayError CVROverlay_024::CreateOverlay(const char* pchOverlayKey, const char* pchOverlayName, vr::VROverlayHandle_t* pOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->CreateOverlay(pchOverlayKey, pchOverlayName, pOverlayHandle);
}
vr::EVROverlayError CVROverlay_024::DestroyOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->DestroyOverlay(ulOverlayHandle);
}
uint32_t CVROverlay_024::GetOverlayKey(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::EVROverlayError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->GetOverlayKey(ulOverlayHandle, pchValue, unBufferSize, pError);
}
uint32_t CVROverlay_024::GetOverlayName(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::EVROverlayError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->GetOverlayName(ulOverlayHandle, pchValue, unBufferSize, pError);
}
vr::EVROverlayError CVROverlay_024::SetOverlayName(vr::VROverlayHandle_t ulOverlayHandle, const char* pchName) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->SetOverlayName(ulOverlayHandle, pchName);
}
vr::EVROverlayError CVROverlay_024::GetOverlayImageData(vr::VROverlayHandle_t ulOverlayHandle, void* pvBuffer, uint32_t unBufferSize, uint32_t* punWidth, uint32_t* punHeight) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->GetOverlayImageData(ulOverlayHandle, pvBuffer, unBufferSize, punWidth, punHeight);
}
const char* CVROverlay_024::GetOverlayErrorNameFromEnum(vr::EVROverlayError error) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->GetOverlayErrorNameFromEnum(error);
}
vr::EVROverlayError CVROverlay_024::SetOverlayRenderingPid(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unPID) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->SetOverlayRenderingPid(ulOverlayHandle, unPID);
}
uint32_t CVROverlay_024::GetOverlayRenderingPid(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->GetOverlayRenderingPid(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_024::SetOverlayFlag(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_024::VROverlayFlags eOverlayFlag, bool bEnabled) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->SetOverlayFlag(ulOverlayHandle, (OOVR_VROverlayFlags) eOverlayFlag, bEnabled);
}
vr::EVROverlayError CVROverlay_024::GetOverlayFlag(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_024::VROverlayFlags eOverlayFlag, bool* pbEnabled) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->GetOverlayFlag(ulOverlayHandle, (OOVR_VROverlayFlags) eOverlayFlag, pbEnabled);
}
vr::EVROverlayError CVROverlay_024::GetOverlayFlags(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* pFlags) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->GetOverlayFlags(ulOverlayHandle, pFlags);
}
vr::EVROverlayError CVROverlay_024::SetOverlayColor(vr::VROverlayHandle_t ulOverlayHandle, float fRed, float fGreen, float fBlue) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->SetOverlayColor(ulOverlayHandle, fRed, fGreen, fBlue);
}
vr::EVROverlayError CVROverlay_024::GetOverlayColor(vr::VROverlayHandle_t ulOverlayHandle, float* pfRed, float* pfGreen, float* pfBlue) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->GetOverlayColor(ulOverlayHandle, pfRed, pfGreen, pfBlue);
}
vr::EVROverlayError CVROverlay_024::SetOverlayAlpha(vr::VROverlayHandle_t ulOverlayHandle, float fAlpha) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->SetOverlayAlpha(ulOverlayHandle, fAlpha);
}
vr::EVROverlayError CVROverlay_024::GetOverlayAlpha(vr::VROverlayHandle_t ulOverlayHandle, float* pfAlpha) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->GetOverlayAlpha(ulOverlayHandle, pfAlpha);
}
vr::EVROverlayError CVROverlay_024::SetOverlayTexelAspect(vr::VROverlayHandle_t ulOverlayHandle, float fTexelAspect) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->SetOverlayTexelAspect(ulOverlayHandle, fTexelAspect);
}
vr::EVROverlayError CVROverlay_024::GetOverlayTexelAspect(vr::VROverlayHandle_t ulOverlayHandle, float* pfTexelAspect) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->GetOverlayTexelAspect(ulOverlayHandle, pfTexelAspect);
}
vr::EVROverlayError CVROverlay_024::SetOverlaySortOrder(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unSortOrder) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->SetOverlaySortOrder(ulOverlayHandle, unSortOrder);
}
vr::EVROverlayError CVROverlay_024::GetOverlaySortOrder(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* punSortOrder) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->GetOverlaySortOrder(ulOverlayHandle, punSortOrder);
}
vr::EVROverlayError CVROverlay_024::SetOverlayWidthInMeters(vr::VROverlayHandle_t ulOverlayHandle, float fWidthInMeters) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->SetOverlayWidthInMeters(ulOverlayHandle, fWidthInMeters);
}
vr::EVROverlayError CVROverlay_024::GetOverlayWidthInMeters(vr::VROverlayHandle_t ulOverlayHandle, float* pfWidthInMeters) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->GetOverlayWidthInMeters(ulOverlayHandle, pfWidthInMeters);
}
vr::EVROverlayError CVROverlay_024::SetOverlayCurvature(vr::VROverlayHandle_t ulOverlayHandle, float fCurvature) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->SetOverlayCurvature(ulOverlayHandle, fCurvature);
}
vr::EVROverlayError CVROverlay_024::GetOverlayCurvature(vr::VROverlayHandle_t ulOverlayHandle, float* pfCurvature) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->GetOverlayCurvature(ulOverlayHandle, pfCurvature);
}
vr::EVROverlayError CVROverlay_024::SetOverlayTextureColorSpace(vr::VROverlayHandle_t ulOverlayHandle, vr::EColorSpace eTextureColorSpace) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->SetOverlayTextureColorSpace(ulOverlayHandle, eTextureColorSpace);
}
vr::EVROverlayError CVROverlay_024::GetOverlayTextureColorSpace(vr::VROverlayHandle_t ulOverlayHandle, vr::EColorSpace* peTextureColorSpace) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->GetOverlayTextureColorSpace(ulOverlayHandle, peTextureColorSpace);
}
vr::EVROverlayError CVROverlay_024::SetOverlayTextureBounds(vr::VROverlayHandle_t ulOverlayHandle, const vr::VRTextureBounds_t* pOverlayTextureBounds) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->SetOverlayTextureBounds(ulOverlayHandle, pOverlayTextureBounds);
}
vr::EVROverlayError CVROverlay_024::GetOverlayTextureBounds(vr::VROverlayHandle_t ulOverlayHandle, vr::VRTextureBounds_t* pOverlayTextureBounds) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->GetOverlayTextureBounds(ulOverlayHandle, pOverlayTextureBounds);
}
vr::EVROverlayError CVROverlay_024::GetOverlayTransformType(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_024::VROverlayTransformType* peTransformType) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->GetOverlayTransformType(ulOverlayHandle, (OOVR_VROverlayTransformType*) peTransformType);
}
vr::EVROverlayError CVROverlay_024::SetOverlayTransformAbsolute(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin eTrackingOrigin, const vr::HmdMatrix34_t* pmatTrackingOriginToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->SetOverlayTransformAbsolute(ulOverlayHandle, eTrackingOrigin, pmatTrackingOriginToOverlayTransform);
}
vr::EVROverlayError CVROverlay_024::GetOverlayTransformAbsolute(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin* peTrackingOrigin, vr::HmdMatrix34_t* pmatTrackingOriginToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->GetOverlayTransformAbsolute(ulOverlayHandle, peTrackingOrigin, pmatTrackingOriginToOverlayTransform);
}
vr::EVROverlayError CVROverlay_024::SetOverlayTransformTrackedDeviceRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unTrackedDevice, const vr::HmdMatrix34_t* pmatTrackedDeviceToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->SetOverlayTransformTrackedDeviceRelative(ulOverlayHandle, unTrackedDevice, pmatTrackedDeviceToOverlayTransform);
}
vr::EVROverlayError CVROverlay_024::GetOverlayTransformTrackedDeviceRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t* punTrackedDevice, vr::HmdMatrix34_t* pmatTrackedDeviceToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->GetOverlayTransformTrackedDeviceRelative(ulOverlayHandle, punTrackedDevice, pmatTrackedDeviceToOverlayTransform);
}
vr::EVROverlayError CVROverlay_024::SetOverlayTransformTrackedDeviceComponent(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unDeviceIndex, const char* pchComponentName) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->SetOverlayTransformTrackedDeviceComponent(ulOverlayHandle, unDeviceIndex, pchComponentName);
}
vr::EVROverlayError CVROverlay_024::GetOverlayTransformTrackedDeviceComponent(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t* punDeviceIndex, char* pchComponentName, uint32_t unComponentNameSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->GetOverlayTransformTrackedDeviceComponent(ulOverlayHandle, punDeviceIndex, pchComponentName, unComponentNameSize);
}
vr::EVROverlayError CVROverlay_024::GetOverlayTransformOverlayRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::VROverlayHandle_t* ulOverlayHandleParent, vr::HmdMatrix34_t* pmatParentOverlayToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->GetOverlayTransformOverlayRelative(ulOverlayHandle, ulOverlayHandleParent, pmatParentOverlayToOverlayTransform);
}
vr::EVROverlayError CVROverlay_024::SetOverlayTransformOverlayRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::VROverlayHandle_t ulOverlayHandleParent, const vr::HmdMatrix34_t* pmatParentOverlayToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->SetOverlayTransformOverlayRelative(ulOverlayHandle, ulOverlayHandleParent, pmatParentOverlayToOverlayTransform);
}
vr::EVROverlayError CVROverlay_024::SetOverlayTransformCursor(vr::VROverlayHandle_t ulCursorOverlayHandle, const vr::HmdVector2_t* pvHotspot) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->SetOverlayTransformCursor(ulCursorOverlayHandle, pvHotspot);
}
vr::EVROverlayError CVROverlay_024::GetOverlayTransformCursor(vr::VROverlayHandle_t ulOverlayHandle, vr::HmdVector2_t* pvHotspot) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->GetOverlayTransformCursor(ulOverlayHandle, pvHotspot);
}
vr::EVROverlayError CVROverlay_024::ShowOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->ShowOverlay(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_024::HideOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->HideOverlay(ulOverlayHandle);
}
bool CVROverlay_024::IsOverlayVisible(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->IsOverlayVisible(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_024::GetTransformForOverlayCoordinates(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin eTrackingOrigin, vr::HmdVector2_t coordinatesInOverlay, vr::HmdMatrix34_t* pmatTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->GetTransformForOverlayCoordinates(ulOverlayHandle, eTrackingOrigin, coordinatesInOverlay, pmatTransform);
}
bool CVROverlay_024::PollNextOverlayEvent(vr::VROverlayHandle_t ulOverlayHandle, vr::VREvent_t* pEvent, uint32_t uncbVREvent) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->PollNextOverlayEvent(ulOverlayHandle, pEvent, uncbVREvent);
}
vr::EVROverlayError CVROverlay_024::GetOverlayInputMethod(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_024::VROverlayInputMethod* peInputMethod) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->GetOverlayInputMethod(ulOverlayHandle, (OOVR_VROverlayInputMethod*) peInputMethod);
}
vr::EVROverlayError CVROverlay_024::SetOverlayInputMethod(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_024::VROverlayInputMethod eInputMethod) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->SetOverlayInputMethod(ulOverlayHandle, (OOVR_VROverlayInputMethod) eInputMethod);
}
vr::EVROverlayError CVROverlay_024::GetOverlayMouseScale(vr::VROverlayHandle_t ulOverlayHandle, vr::HmdVector2_t* pvecMouseScale) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->GetOverlayMouseScale(ulOverlayHandle, pvecMouseScale);
}
vr::EVROverlayError CVROverlay_024::SetOverlayMouseScale(vr::VROverlayHandle_t ulOverlayHandle, const vr::HmdVector2_t* pvecMouseScale) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->SetOverlayMouseScale(ulOverlayHandle, pvecMouseScale);
}
bool CVROverlay_024::ComputeOverlayIntersection(vr::VROverlayHandle_t ulOverlayHandle, const vr::IVROverlay_024::VROverlayIntersectionParams_t* pParams, vr::IVROverlay_024::VROverlayIntersectionResults_t* pResults) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->ComputeOverlayIntersection(ulOverlayHandle, (const OOVR_VROverlayIntersectionParams_t*) pParams, (OOVR_VROverlayIntersectionResults_t*) pResults);
}
bool CVROverlay_024::IsHoverTargetOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->IsHoverTargetOverlay(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_024::SetOverlayIntersectionMask(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_024::VROverlayIntersectionMaskPrimitive_t* pMaskPrimitives, uint32_t unNumMaskPrimitives, uint32_t unPrimitiveSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->SetOverlayIntersectionMask(ulOverlayHandle, (OOVR_VROverlayIntersectionMaskPrimitive_t*) pMaskPrimitives, unNumMaskPrimitives, unPrimitiveSize);
}
vr::EVROverlayError CVROverlay_024::TriggerLaserMouseHapticVibration(vr::VROverlayHandle_t ulOverlayHandle, float fDurationSeconds, float fFrequency, float fAmplitude) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->TriggerLaserMouseHapticVibration(ulOverlayHandle, fDurationSeconds, fFrequency, fAmplitude);
}
vr::EVROverlayError CVROverlay_024::SetOverlayCursor(vr::VROverlayHandle_t ulOverlayHandle, vr::VROverlayHandle_t ulCursorHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->SetOverlayCursor(ulOverlayHandle, ulCursorHandle);
}
vr::EVROverlayError CVROverlay_024::SetOverlayCursorPositionOverride(vr::VROverlayHandle_t ulOverlayHandle, const vr::HmdVector2_t* pvCursor) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->SetOverlayCursorPositionOverride(ulOverlayHandle, pvCursor);
}
vr::EVROverlayError CVROverlay_024::ClearOverlayCursorPositionOverride(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->ClearOverlayCursorPositionOverride(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_024::SetOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle, const vr::Texture_t* pTexture) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->SetOverlayTexture(ulOverlayHandle, pTexture);
}
vr::EVROverlayError CVROverlay_024::ClearOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->ClearOverlayTexture(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_024::SetOverlayRaw(vr::VROverlayHandle_t ulOverlayHandle, void* pvBuffer, uint32_t unWidth, uint32_t unHeight, uint32_t unBytesPerPixel) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->SetOverlayRaw(ulOverlayHandle, pvBuffer, unWidth, unHeight, unBytesPerPixel);
}
vr::EVROverlayError CVROverlay_024::SetOverlayFromFile(vr::VROverlayHandle_t ulOverlayHandle, const char* pchFilePath) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->SetOverlayFromFile(ulOverlayHandle, pchFilePath);
}
vr::EVROverlayError CVROverlay_024::GetOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle, void** pNativeTextureHandle, void* pNativeTextureRef, uint32_t* pWidth, uint32_t* pHeight, uint32_t* pNativeFormat, vr::ETextureType* pAPIType, vr::EColorSpace* pColorSpace, vr::VRTextureBounds_t* pTextureBounds) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->GetOverlayTexture(ulOverlayHandle, pNativeTextureHandle, pNativeTextureRef, pWidth, pHeight, pNativeFormat, pAPIType, pColorSpace, pTextureBounds);
}
vr::EVROverlayError CVROverlay_024::ReleaseNativeOverlayHandle(vr::VROverlayHandle_t ulOverlayHandle, void* pNativeTextureHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->ReleaseNativeOverlayHandle(ulOverlayHandle, pNativeTextureHandle);
}
vr::EVROverlayError CVROverlay_024::GetOverlayTextureSize(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* pWidth, uint32_t* pHeight) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->GetOverlayTextureSize(ulOverlayHandle, pWidth, pHeight);
}
vr::EVROverlayError CVROverlay_024::CreateDashboardOverlay(const char* pchOverlayKey, const char* pchOverlayFriendlyName, vr::VROverlayHandle_t* pMainHandle, vr::VROverlayHandle_t* pThumbnailHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->CreateDashboardOverlay(pchOverlayKey, pchOverlayFriendlyName, pMainHandle, pThumbnailHandle);
}
bool CVROverlay_024::IsDashboardVisible() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->IsDashboardVisible();
}
bool CVROverlay_024::IsActiveDashboardOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->IsActiveDashboardOverlay(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_024::SetDashboardOverlaySceneProcess(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unProcessId) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->SetDashboardOverlaySceneProcess(ulOverlayHandle, unProcessId);
}
vr::EVROverlayError CVROverlay_024::GetDashboardOverlaySceneProcess(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* punProcessId) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->GetDashboardOverlaySceneProcess(ulOverlayHandle, punProcessId);
}
void CVROverlay_024::ShowDashboard(const char* pchOverlayToShow) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->ShowDashboard(pchOverlayToShow);
}
vr::TrackedDeviceIndex_t CVROverlay_024::GetPrimaryDashboardDevice() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->GetPrimaryDashboardDevice();
}
vr::EVROverlayError CVROverlay_024::ShowKeyboard(vr::IVROverlay_024::EGamepadTextInputMode eInputMode, vr::IVROverlay_024::EGamepadTextInputLineMode eLineInputMode, uint32_t unFlags, const char* pchDescription, uint32_t unCharMax, const char* pchExistingText, uint64_t uUserValue) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->ShowKeyboard((OOVR_EGamepadTextInputMode) eInputMode, (OOVR_EGamepadTextInputLineMode) eLineInputMode, unFlags, pchDescription, unCharMax, pchExistingText, uUserValue);
}
vr::EVROverlayError CVROverlay_024::ShowKeyboardForOverlay(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_024::EGamepadTextInputMode eInputMode, vr::IVROverlay_024::EGamepadTextInputLineMode eLineInputMode, uint32_t unFlags, const char* pchDescription, uint32_t unCharMax, const char* pchExistingText, uint64_t uUserValue) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->ShowKeyboardForOverlay(ulOverlayHandle, (OOVR_EGamepadTextInputMode) eInputMode, (OOVR_EGamepadTextInputLineMode) eLineInputMode, unFlags, pchDescription, unCharMax, pchExistingText, uUserValue);
}
uint32_t CVROverlay_024::GetKeyboardText(char* pchText, uint32_t cchText) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->GetKeyboardText(pchText, cchText);
}
void CVROverlay_024::HideKeyboard() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->HideKeyboard();
}
void CVROverlay_024::SetKeyboardTransformAbsolute(vr::ETrackingUniverseOrigin eTrackingOrigin, const vr::HmdMatrix34_t* pmatTrackingOriginToKeyboardTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->SetKeyboardTransformAbsolute(eTrackingOrigin, pmatTrackingOriginToKeyboardTransform);
}
void CVROverlay_024::SetKeyboardPositionForOverlay(vr::VROverlayHandle_t ulOverlayHandle, vr::HmdRect2_t avoidRect) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->SetKeyboardPositionForOverlay(ulOverlayHandle, avoidRect);
}
vr::IVROverlay_024::VRMessageOverlayResponse CVROverlay_024::ShowMessageOverlay(const char* pchText, const char* pchCaption, const char* pchButton0Text, const char* pchButton1Text, const char* pchButton2Text, const char* pchButton3Text) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return (vr::IVROverlay_024::VRMessageOverlayResponse) base->ShowMessageOverlay(pchText, pchCaption, pchButton0Text, pchButton1Text, pchButton2Text, pchButton3Text);
}
void CVROverlay_024::CloseMessageOverlay() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_024)");
	return base->CloseMessageOverlay();
}
// FnTable for CVROverlay_024:
static CVROverlay_024 *fntable_Overlay_024_instance = NULL;
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_FindOverlay(const char* pchOverlayKey, vr::VROverlayHandle_t* pOverlayHandle) { return fntable_Overlay_024_instance->FindOverlay(pchOverlayKey, pOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_CreateOverlay(const char* pchOverlayKey, const char* pchOverlayName, vr::VROverlayHandle_t* pOverlayHandle) { return fntable_Overlay_024_instance->CreateOverlay(pchOverlayKey, pchOverlayName, pOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_DestroyOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_024_instance->DestroyOverlay(ulOverlayHandle); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_GetOverlayKey(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::EVROverlayError* pError) { return fntable_Overlay_024_instance->GetOverlayKey(ulOverlayHandle, pchValue, unBufferSize, pError); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_GetOverlayName(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::EVROverlayError* pError) { return fntable_Overlay_024_instance->GetOverlayName(ulOverlayHandle, pchValue, unBufferSize, pError); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_SetOverlayName(vr::VROverlayHandle_t ulOverlayHandle, const char* pchName) { return fntable_Overlay_024_instance->SetOverlayName(ulOverlayHandle, pchName); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_GetOverlayImageData(vr::VROverlayHandle_t ulOverlayHandle, void* pvBuffer, uint32_t unBufferSize, uint32_t* punWidth, uint32_t* punHeight) { return fntable_Overlay_024_instance->GetOverlayImageData(ulOverlayHandle, pvBuffer, unBufferSize, punWidth, punHeight); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_GetOverlayErrorNameFromEnum(vr::EVROverlayError error) { return fntable_Overlay_024_instance->GetOverlayErrorNameFromEnum(error); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_SetOverlayRenderingPid(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unPID) { return fntable_Overlay_024_instance->SetOverlayRenderingPid(ulOverlayHandle, unPID); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_GetOverlayRenderingPid(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_024_instance->GetOverlayRenderingPid(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_SetOverlayFlag(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_024::VROverlayFlags eOverlayFlag, bool bEnabled) { return fntable_Overlay_024_instance->SetOverlayFlag(ulOverlayHandle, eOverlayFlag, bEnabled); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_GetOverlayFlag(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_024::VROverlayFlags eOverlayFlag, bool* pbEnabled) { return fntable_Overlay_024_instance->GetOverlayFlag(ulOverlayHandle, eOverlayFlag, pbEnabled); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_GetOverlayFlags(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* pFlags) { return fntable_Overlay_024_instance->GetOverlayFlags(ulOverlayHandle, pFlags); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_SetOverlayColor(vr::VROverlayHandle_t ulOverlayHandle, float fRed, float fGreen, float fBlue) { return fntable_Overlay_024_instance->SetOverlayColor(ulOverlayHandle, fRed, fGreen, fBlue); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_GetOverlayColor(vr::VROverlayHandle_t ulOverlayHandle, float* pfRed, float* pfGreen, float* pfBlue) { return fntable_Overlay_024_instance->GetOverlayColor(ulOverlayHandle, pfRed, pfGreen, pfBlue); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_SetOverlayAlpha(vr::VROverlayHandle_t ulOverlayHandle, float fAlpha) { return fntable_Overlay_024_instance->SetOverlayAlpha(ulOverlayHandle, fAlpha); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_GetOverlayAlpha(vr::VROverlayHandle_t ulOverlayHandle, float* pfAlpha) { return fntable_Overlay_024_instance->GetOverlayAlpha(ulOverlayHandle, pfAlpha); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_SetOverlayTexelAspect(vr::VROverlayHandle_t ulOverlayHandle, float fTexelAspect) { return fntable_Overlay_024_instance->SetOverlayTexelAspect(ulOverlayHandle, fTexelAspect); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_GetOverlayTexelAspect(vr::VROverlayHandle_t ulOverlayHandle, float* pfTexelAspect) { return fntable_Overlay_024_instance->GetOverlayTexelAspect(ulOverlayHandle, pfTexelAspect); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_SetOverlaySortOrder(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unSortOrder) { return fntable_Overlay_024_instance->SetOverlaySortOrder(ulOverlayHandle, unSortOrder); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_GetOverlaySortOrder(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* punSortOrder) { return fntable_Overlay_024_instance->GetOverlaySortOrder(ulOverlayHandle, punSortOrder); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_SetOverlayWidthInMeters(vr::VROverlayHandle_t ulOverlayHandle, float fWidthInMeters) { return fntable_Overlay_024_instance->SetOverlayWidthInMeters(ulOverlayHandle, fWidthInMeters); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_GetOverlayWidthInMeters(vr::VROverlayHandle_t ulOverlayHandle, float* pfWidthInMeters) { return fntable_Overlay_024_instance->GetOverlayWidthInMeters(ulOverlayHandle, pfWidthInMeters); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_SetOverlayCurvature(vr::VROverlayHandle_t ulOverlayHandle, float fCurvature) { return fntable_Overlay_024_instance->SetOverlayCurvature(ulOverlayHandle, fCurvature); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_GetOverlayCurvature(vr::VROverlayHandle_t ulOverlayHandle, float* pfCurvature) { return fntable_Overlay_024_instance->GetOverlayCurvature(ulOverlayHandle, pfCurvature); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_SetOverlayTextureColorSpace(vr::VROverlayHandle_t ulOverlayHandle, vr::EColorSpace eTextureColorSpace) { return fntable_Overlay_024_instance->SetOverlayTextureColorSpace(ulOverlayHandle, eTextureColorSpace); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_GetOverlayTextureColorSpace(vr::VROverlayHandle_t ulOverlayHandle, vr::EColorSpace* peTextureColorSpace) { return fntable_Overlay_024_instance->GetOverlayTextureColorSpace(ulOverlayHandle, peTextureColorSpace); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_SetOverlayTextureBounds(vr::VROverlayHandle_t ulOverlayHandle, const vr::VRTextureBounds_t* pOverlayTextureBounds) { return fntable_Overlay_024_instance->SetOverlayTextureBounds(ulOverlayHandle, pOverlayTextureBounds); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_GetOverlayTextureBounds(vr::VROverlayHandle_t ulOverlayHandle, vr::VRTextureBounds_t* pOverlayTextureBounds) { return fntable_Overlay_024_instance->GetOverlayTextureBounds(ulOverlayHandle, pOverlayTextureBounds); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_GetOverlayTransformType(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_024::VROverlayTransformType* peTransformType) { return fntable_Overlay_024_instance->GetOverlayTransformType(ulOverlayHandle, peTransformType); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_SetOverlayTransformAbsolute(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin eTrackingOrigin, const vr::HmdMatrix34_t* pmatTrackingOriginToOverlayTransform) { return fntable_Overlay_024_instance->SetOverlayTransformAbsolute(ulOverlayHandle, eTrackingOrigin, pmatTrackingOriginToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_GetOverlayTransformAbsolute(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin* peTrackingOrigin, vr::HmdMatrix34_t* pmatTrackingOriginToOverlayTransform) { return fntable_Overlay_024_instance->GetOverlayTransformAbsolute(ulOverlayHandle, peTrackingOrigin, pmatTrackingOriginToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_SetOverlayTransformTrackedDeviceRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unTrackedDevice, const vr::HmdMatrix34_t* pmatTrackedDeviceToOverlayTransform) { return fntable_Overlay_024_instance->SetOverlayTransformTrackedDeviceRelative(ulOverlayHandle, unTrackedDevice, pmatTrackedDeviceToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_GetOverlayTransformTrackedDeviceRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t* punTrackedDevice, vr::HmdMatrix34_t* pmatTrackedDeviceToOverlayTransform) { return fntable_Overlay_024_instance->GetOverlayTransformTrackedDeviceRelative(ulOverlayHandle, punTrackedDevice, pmatTrackedDeviceToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_SetOverlayTransformTrackedDeviceComponent(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unDeviceIndex, const char* pchComponentName) { return fntable_Overlay_024_instance->SetOverlayTransformTrackedDeviceComponent(ulOverlayHandle, unDeviceIndex, pchComponentName); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_GetOverlayTransformTrackedDeviceComponent(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t* punDeviceIndex, char* pchComponentName, uint32_t unComponentNameSize) { return fntable_Overlay_024_instance->GetOverlayTransformTrackedDeviceComponent(ulOverlayHandle, punDeviceIndex, pchComponentName, unComponentNameSize); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_GetOverlayTransformOverlayRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::VROverlayHandle_t* ulOverlayHandleParent, vr::HmdMatrix34_t* pmatParentOverlayToOverlayTransform) { return fntable_Overlay_024_instance->GetOverlayTransformOverlayRelative(ulOverlayHandle, ulOverlayHandleParent, pmatParentOverlayToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_SetOverlayTransformOverlayRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::VROverlayHandle_t ulOverlayHandleParent, const vr::HmdMatrix34_t* pmatParentOverlayToOverlayTransform) { return fntable_Overlay_024_instance->SetOverlayTransformOverlayRelative(ulOverlayHandle, ulOverlayHandleParent, pmatParentOverlayToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_SetOverlayTransformCursor(vr::VROverlayHandle_t ulCursorOverlayHandle, const vr::HmdVector2_t* pvHotspot) { return fntable_Overlay_024_instance->SetOverlayTransformCursor(ulCursorOverlayHandle, pvHotspot); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_GetOverlayTransformCursor(vr::VROverlayHandle_t ulOverlayHandle, vr::HmdVector2_t* pvHotspot) { return fntable_Overlay_024_instance->GetOverlayTransformCursor(ulOverlayHandle, pvHotspot); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_ShowOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_024_instance->ShowOverlay(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_HideOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_024_instance->HideOverlay(ulOverlayHandle); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_IsOverlayVisible(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_024_instance->IsOverlayVisible(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_GetTransformForOverlayCoordinates(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin eTrackingOrigin, vr::HmdVector2_t coordinatesInOverlay, vr::HmdMatrix34_t* pmatTransform) { return fntable_Overlay_024_instance->GetTransformForOverlayCoordinates(ulOverlayHandle, eTrackingOrigin, coordinatesInOverlay, pmatTransform); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_PollNextOverlayEvent(vr::VROverlayHandle_t ulOverlayHandle, vr::VREvent_t* pEvent, uint32_t uncbVREvent) { return fntable_Overlay_024_instance->PollNextOverlayEvent(ulOverlayHandle, pEvent, uncbVREvent); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_GetOverlayInputMethod(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_024::VROverlayInputMethod* peInputMethod) { return fntable_Overlay_024_instance->GetOverlayInputMethod(ulOverlayHandle, peInputMethod); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_SetOverlayInputMethod(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_024::VROverlayInputMethod eInputMethod) { return fntable_Overlay_024_instance->SetOverlayInputMethod(ulOverlayHandle, eInputMethod); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_GetOverlayMouseScale(vr::VROverlayHandle_t ulOverlayHandle, vr::HmdVector2_t* pvecMouseScale) { return fntable_Overlay_024_instance->GetOverlayMouseScale(ulOverlayHandle, pvecMouseScale); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_SetOverlayMouseScale(vr::VROverlayHandle_t ulOverlayHandle, const vr::HmdVector2_t* pvecMouseScale) { return fntable_Overlay_024_instance->SetOverlayMouseScale(ulOverlayHandle, pvecMouseScale); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_ComputeOverlayIntersection(vr::VROverlayHandle_t ulOverlayHandle, const vr::IVROverlay_024::VROverlayIntersectionParams_t* pParams, vr::IVROverlay_024::VROverlayIntersectionResults_t* pResults) { return fntable_Overlay_024_instance->ComputeOverlayIntersection(ulOverlayHandle, pParams, pResults); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_IsHoverTargetOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_024_instance->IsHoverTargetOverlay(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_SetOverlayIntersectionMask(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_024::VROverlayIntersectionMaskPrimitive_t* pMaskPrimitives, uint32_t unNumMaskPrimitives, uint32_t unPrimitiveSize) { return fntable_Overlay_024_instance->SetOverlayIntersectionMask(ulOverlayHandle, pMaskPrimitives, unNumMaskPrimitives, unPrimitiveSize); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_TriggerLaserMouseHapticVibration(vr::VROverlayHandle_t ulOverlayHandle, float fDurationSeconds, float fFrequency, float fAmplitude) { return fntable_Overlay_024_instance->TriggerLaserMouseHapticVibration(ulOverlayHandle, fDurationSeconds, fFrequency, fAmplitude); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_SetOverlayCursor(vr::VROverlayHandle_t ulOverlayHandle, vr::VROverlayHandle_t ulCursorHandle) { return fntable_Overlay_024_instance->SetOverlayCursor(ulOverlayHandle, ulCursorHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_SetOverlayCursorPositionOverride(vr::VROverlayHandle_t ulOverlayHandle, const vr::HmdVector2_t* pvCursor) { return fntable_Overlay_024_instance->SetOverlayCursorPositionOverride(ulOverlayHandle, pvCursor); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_ClearOverlayCursorPositionOverride(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_024_instance->ClearOverlayCursorPositionOverride(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_SetOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle, const vr::Texture_t* pTexture) { return fntable_Overlay_024_instance->SetOverlayTexture(ulOverlayHandle, pTexture); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_ClearOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_024_instance->ClearOverlayTexture(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_SetOverlayRaw(vr::VROverlayHandle_t ulOverlayHandle, void* pvBuffer, uint32_t unWidth, uint32_t unHeight, uint32_t unBytesPerPixel) { return fntable_Overlay_024_instance->SetOverlayRaw(ulOverlayHandle, pvBuffer, unWidth, unHeight, unBytesPerPixel); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_SetOverlayFromFile(vr::VROverlayHandle_t ulOverlayHandle, const char* pchFilePath) { return fntable_Overlay_024_instance->SetOverlayFromFile(ulOverlayHandle, pchFilePath); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_GetOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle, void** pNativeTextureHandle, void* pNativeTextureRef, uint32_t* pWidth, uint32_t* pHeight, uint32_t* pNativeFormat, vr::ETextureType* pAPIType, vr::EColorSpace* pColorSpace, vr::VRTextureBounds_t* pTextureBounds) { return fntable_Overlay_024_instance->GetOverlayTexture(ulOverlayHandle, pNativeTextureHandle, pNativeTextureRef, pWidth, pHeight, pNativeFormat, pAPIType, pColorSpace, pTextureBounds); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_ReleaseNativeOverlayHandle(vr::VROverlayHandle_t ulOverlayHandle, void* pNativeTextureHandle) { return fntable_Overlay_024_instance->ReleaseNativeOverlayHandle(ulOverlayHandle, pNativeTextureHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_GetOverlayTextureSize(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* pWidth, uint32_t* pHeight) { return fntable_Overlay_024_instance->GetOverlayTextureSize(ulOverlayHandle, pWidth, pHeight); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_CreateDashboardOverlay(const char* pchOverlayKey, const char* pchOverlayFriendlyName, vr::VROverlayHandle_t* pMainHandle, vr::VROverlayHandle_t* pThumbnailHandle) { return fntable_Overlay_024_instance->CreateDashboardOverlay(pchOverlayKey, pchOverlayFriendlyName, pMainHandle, pThumbnailHandle); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_IsDashboardVisible() { return fntable_Overlay_024_instance->IsDashboardVisible(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_IsActiveDashboardOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_024_instance->IsActiveDashboardOverlay(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_SetDashboardOverlaySceneProcess(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unProcessId) { return fntable_Overlay_024_instance->SetDashboardOverlaySceneProcess(ulOverlayHandle, unProcessId); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_GetDashboardOverlaySceneProcess(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* punProcessId) { return fntable_Overlay_024_instance->GetDashboardOverlaySceneProcess(ulOverlayHandle, punProcessId); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_ShowDashboard(const char* pchOverlayToShow) { return fntable_Overlay_024_instance->ShowDashboard(pchOverlayToShow); }
static vr::TrackedDeviceIndex_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_GetPrimaryDashboardDevice() { return fntable_Overlay_024_instance->GetPrimaryDashboardDevice(); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_ShowKeyboard(vr::IVROverlay_024::EGamepadTextInputMode eInputMode, vr::IVROverlay_024::EGamepadTextInputLineMode eLineInputMode, uint32_t unFlags, const char* pchDescription, uint32_t unCharMax, const char* pchExistingText, uint64_t uUserValue) { return fntable_Overlay_024_instance->ShowKeyboard(eInputMode, eLineInputMode, unFlags, pchDescription, unCharMax, pchExistingText, uUserValue); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_ShowKeyboardForOverlay(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_024::EGamepadTextInputMode eInputMode, vr::IVROverlay_024::EGamepadTextInputLineMode eLineInputMode, uint32_t unFlags, const char* pchDescription, uint32_t unCharMax, const char* pchExistingText, uint64_t uUserValue) { return fntable_Overlay_024_instance->ShowKeyboardForOverlay(ulOverlayHandle, eInputMode, eLineInputMode, unFlags, pchDescription, unCharMax, pchExistingText, uUserValue); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_GetKeyboardText(char* pchText, uint32_t cchText) { return fntable_Overlay_024_instance->GetKeyboardText(pchText, cchText); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_HideKeyboard() { return fntable_Overlay_024_instance->HideKeyboard(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_SetKeyboardTransformAbsolute(vr::ETrackingUniverseOrigin eTrackingOrigin, const vr::HmdMatrix34_t* pmatTrackingOriginToKeyboardTransform) { return fntable_Overlay_024_instance->SetKeyboardTransformAbsolute(eTrackingOrigin, pmatTrackingOriginToKeyboardTransform); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_SetKeyboardPositionForOverlay(vr::VROverlayHandle_t ulOverlayHandle, vr::HmdRect2_t avoidRect) { return fntable_Overlay_024_instance->SetKeyboardPositionForOverlay(ulOverlayHandle, avoidRect); }
static vr::IVROverlay_024::VRMessageOverlayResponse OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_ShowMessageOverlay(const char* pchText, const char* pchCaption, const char* pchButton0Text, const char* pchButton1Text, const char* pchButton2Text, const char* pchButton3Text) { return fntable_Overlay_024_instance->ShowMessageOverlay(pchText, pchCaption, pchButton0Text, pchButton1Text, pchButton2Text, pchButton3Text); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_024_impl_CloseMessageOverlay() { return fntable_Overlay_024_instance->CloseMessageOverlay(); }
static void *fntable_Overlay_024_funcs[] = {
	(void*) fntable_Overlay_024_impl_FindOverlay,
	(void*) fntable_Overlay_024_impl_CreateOverlay,
	(void*) fntable_Overlay_024_impl_DestroyOverlay,
	(void*) fntable_Overlay_024_impl_GetOverlayKey,
	(void*) fntable_Overlay_024_impl_GetOverlayName,
	(void*) fntable_Overlay_024_impl_SetOverlayName,
	(void*) fntable_Overlay_024_impl_GetOverlayImageData,
	(void*) fntable_Overlay_024_impl_GetOverlayErrorNameFromEnum,
	(void*) fntable_Overlay_024_impl_SetOverlayRenderingPid,
	(void*) fntable_Overlay_024_impl_GetOverlayRenderingPid,
	(void*) fntable_Overlay_024_impl_SetOverlayFlag,
	(void*) fntable_Overlay_024_impl_GetOverlayFlag,
	(void*) fntable_Overlay_024_impl_GetOverlayFlags,
	(void*) fntable_Overlay_024_impl_SetOverlayColor,
	(void*) fntable_Overlay_024_impl_GetOverlayColor,
	(void*) fntable_Overlay_024_impl_SetOverlayAlpha,
	(void*) fntable_Overlay_024_impl_GetOverlayAlpha,
	(void*) fntable_Overlay_024_impl_SetOverlayTexelAspect,
	(void*) fntable_Overlay_024_impl_GetOverlayTexelAspect,
	(void*) fntable_Overlay_024_impl_SetOverlaySortOrder,
	(void*) fntable_Overlay_024_impl_GetOverlaySortOrder,
	(void*) fntable_Overlay_024_impl_SetOverlayWidthInMeters,
	(void*) fntable_Overlay_024_impl_GetOverlayWidthInMeters,
	(void*) fntable_Overlay_024_impl_SetOverlayCurvature,
	(void*) fntable_Overlay_024_impl_GetOverlayCurvature,
	(void*) fntable_Overlay_024_impl_SetOverlayTextureColorSpace,
	(void*) fntable_Overlay_024_impl_GetOverlayTextureColorSpace,
	(void*) fntable_Overlay_024_impl_SetOverlayTextureBounds,
	(void*) fntable_Overlay_024_impl_GetOverlayTextureBounds,
	(void*) fntable_Overlay_024_impl_GetOverlayTransformType,
	(void*) fntable_Overlay_024_impl_SetOverlayTransformAbsolute,
	(void*) fntable_Overlay_024_impl_GetOverlayTransformAbsolute,
	(void*) fntable_Overlay_024_impl_SetOverlayTransformTrackedDeviceRelative,
	(void*) fntable_Overlay_024_impl_GetOverlayTransformTrackedDeviceRelative,
	(void*) fntable_Overlay_024_impl_SetOverlayTransformTrackedDeviceComponent,
	(void*) fntable_Overlay_024_impl_GetOverlayTransformTrackedDeviceComponent,
	(void*) fntable_Overlay_024_impl_GetOverlayTransformOverlayRelative,
	(void*) fntable_Overlay_024_impl_SetOverlayTransformOverlayRelative,
	(void*) fntable_Overlay_024_impl_SetOverlayTransformCursor,
	(void*) fntable_Overlay_024_impl_GetOverlayTransformCursor,
	(void*) fntable_Overlay_024_impl_ShowOverlay,
	(void*) fntable_Overlay_024_impl_HideOverlay,
	(void*) fntable_Overlay_024_impl_IsOverlayVisible,
	(void*) fntable_Overlay_024_impl_GetTransformForOverlayCoordinates,
	(void*) fntable_Overlay_024_impl_PollNextOverlayEvent,
	(void*) fntable_Overlay_024_impl_GetOverlayInputMethod,
	(void*) fntable_Overlay_024_impl_SetOverlayInputMethod,
	(void*) fntable_Overlay_024_impl_GetOverlayMouseScale,
	(void*) fntable_Overlay_024_impl_SetOverlayMouseScale,
	(void*) fntable_Overlay_024_impl_ComputeOverlayIntersection,
	(void*) fntable_Overlay_024_impl_IsHoverTargetOverlay,
	(void*) fntable_Overlay_024_impl_SetOverlayIntersectionMask,
	(void*) fntable_Overlay_024_impl_TriggerLaserMouseHapticVibration,
	(void*) fntable_Overlay_024_impl_SetOverlayCursor,
	(void*) fntable_Overlay_024_impl_SetOverlayCursorPositionOverride,
	(void*) fntable_Overlay_024_impl_ClearOverlayCursorPositionOverride,
	(void*) fntable_Overlay_024_impl_SetOverlayTexture,
	(void*) fntable_Overlay_024_impl_ClearOverlayTexture,
	(void*) fntable_Overlay_024_impl_SetOverlayRaw,
	(void*) fntable_Overlay_024_impl_SetOverlayFromFile,
	(void*) fntable_Overlay_024_impl_GetOverlayTexture,
	(void*) fntable_Overlay_024_impl_ReleaseNativeOverlayHandle,
	(void*) fntable_Overlay_024_impl_GetOverlayTextureSize,
	(void*) fntable_Overlay_024_impl_CreateDashboardOverlay,
	(void*) fntable_Overlay_024_impl_IsDashboardVisible,
	(void*) fntable_Overlay_024_impl_IsActiveDashboardOverlay,
	(void*) fntable_Overlay_024_impl_SetDashboardOverlaySceneProcess,
	(void*) fntable_Overlay_024_impl_GetDashboardOverlaySceneProcess,
	(void*) fntable_Overlay_024_impl_ShowDashboard,
	(void*) fntable_Overlay_024_impl_GetPrimaryDashboardDevice,
	(void*) fntable_Overlay_024_impl_ShowKeyboard,
	(void*) fntable_Overlay_024_impl_ShowKeyboardForOverlay,
	(void*) fntable_Overlay_024_impl_GetKeyboardText,
	(void*) fntable_Overlay_024_impl_HideKeyboard,
	(void*) fntable_Overlay_024_impl_SetKeyboardTransformAbsolute,
	(void*) fntable_Overlay_024_impl_SetKeyboardPositionForOverlay,
	(void*) fntable_Overlay_024_impl_ShowMessageOverlay,
	(void*) fntable_Overlay_024_impl_CloseMessageOverlay,
};
void** CVROverlay_024::_GetStatFuncList() { fntable_Overlay_024_instance = this; return fntable_Overlay_024_funcs; }
void CVROverlay_024::Delete() { delete this; }
// Misc for CVROverlay_025:
CVROverlay_025::CVROverlay_025() : base(GetCreateBaseOverlay()) {}
// Interface methods for CVROverlay_025:
vr::EVROverlayError CVROverlay_025::FindOverlay(const char* pchOverlayKey, vr::VROverlayHandle_t* pOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->FindOverlay(pchOverlayKey, pOverlayHandle);
}
vr::EVROverlayError CVROverlay_025::CreateOverlay(const char* pchOverlayKey, const char* pchOverlayName, vr::VROverlayHandle_t* pOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->CreateOverlay(pchOverlayKey, pchOverlayName, pOverlayHandle);
}
vr::EVROverlayError CVROverlay_025::DestroyOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->DestroyOverlay(ulOverlayHandle);
}
uint32_t CVROverlay_025::GetOverlayKey(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::EVROverlayError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->GetOverlayKey(ulOverlayHandle, pchValue, unBufferSize, pError);
}
uint32_t CVROverlay_025::GetOverlayName(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::EVROverlayError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->GetOverlayName(ulOverlayHandle, pchValue, unBufferSize, pError);
}
vr::EVROverlayError CVROverlay_025::SetOverlayName(vr::VROverlayHandle_t ulOverlayHandle, const char* pchName) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->SetOverlayName(ulOverlayHandle, pchName);
}
vr::EVROverlayError CVROverlay_025::GetOverlayImageData(vr::VROverlayHandle_t ulOverlayHandle, void* pvBuffer, uint32_t unBufferSize, uint32_t* punWidth, uint32_t* punHeight) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->GetOverlayImageData(ulOverlayHandle, pvBuffer, unBufferSize, punWidth, punHeight);
}
const char* CVROverlay_025::GetOverlayErrorNameFromEnum(vr::EVROverlayError error) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->GetOverlayErrorNameFromEnum(error);
}
vr::EVROverlayError CVROverlay_025::SetOverlayRenderingPid(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unPID) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->SetOverlayRenderingPid(ulOverlayHandle, unPID);
}
uint32_t CVROverlay_025::GetOverlayRenderingPid(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->GetOverlayRenderingPid(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_025::SetOverlayFlag(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_025::VROverlayFlags eOverlayFlag, bool bEnabled) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->SetOverlayFlag(ulOverlayHandle, (OOVR_VROverlayFlags) eOverlayFlag, bEnabled);
}
vr::EVROverlayError CVROverlay_025::GetOverlayFlag(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_025::VROverlayFlags eOverlayFlag, bool* pbEnabled) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->GetOverlayFlag(ulOverlayHandle, (OOVR_VROverlayFlags) eOverlayFlag, pbEnabled);
}
vr::EVROverlayError CVROverlay_025::GetOverlayFlags(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* pFlags) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->GetOverlayFlags(ulOverlayHandle, pFlags);
}
vr::EVROverlayError CVROverlay_025::SetOverlayColor(vr::VROverlayHandle_t ulOverlayHandle, float fRed, float fGreen, float fBlue) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->SetOverlayColor(ulOverlayHandle, fRed, fGreen, fBlue);
}
vr::EVROverlayError CVROverlay_025::GetOverlayColor(vr::VROverlayHandle_t ulOverlayHandle, float* pfRed, float* pfGreen, float* pfBlue) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->GetOverlayColor(ulOverlayHandle, pfRed, pfGreen, pfBlue);
}
vr::EVROverlayError CVROverlay_025::SetOverlayAlpha(vr::VROverlayHandle_t ulOverlayHandle, float fAlpha) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->SetOverlayAlpha(ulOverlayHandle, fAlpha);
}
vr::EVROverlayError CVROverlay_025::GetOverlayAlpha(vr::VROverlayHandle_t ulOverlayHandle, float* pfAlpha) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->GetOverlayAlpha(ulOverlayHandle, pfAlpha);
}
vr::EVROverlayError CVROverlay_025::SetOverlayTexelAspect(vr::VROverlayHandle_t ulOverlayHandle, float fTexelAspect) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->SetOverlayTexelAspect(ulOverlayHandle, fTexelAspect);
}
vr::EVROverlayError CVROverlay_025::GetOverlayTexelAspect(vr::VROverlayHandle_t ulOverlayHandle, float* pfTexelAspect) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->GetOverlayTexelAspect(ulOverlayHandle, pfTexelAspect);
}
vr::EVROverlayError CVROverlay_025::SetOverlaySortOrder(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unSortOrder) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->SetOverlaySortOrder(ulOverlayHandle, unSortOrder);
}
vr::EVROverlayError CVROverlay_025::GetOverlaySortOrder(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* punSortOrder) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->GetOverlaySortOrder(ulOverlayHandle, punSortOrder);
}
vr::EVROverlayError CVROverlay_025::SetOverlayWidthInMeters(vr::VROverlayHandle_t ulOverlayHandle, float fWidthInMeters) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->SetOverlayWidthInMeters(ulOverlayHandle, fWidthInMeters);
}
vr::EVROverlayError CVROverlay_025::GetOverlayWidthInMeters(vr::VROverlayHandle_t ulOverlayHandle, float* pfWidthInMeters) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->GetOverlayWidthInMeters(ulOverlayHandle, pfWidthInMeters);
}
vr::EVROverlayError CVROverlay_025::SetOverlayCurvature(vr::VROverlayHandle_t ulOverlayHandle, float fCurvature) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->SetOverlayCurvature(ulOverlayHandle, fCurvature);
}
vr::EVROverlayError CVROverlay_025::GetOverlayCurvature(vr::VROverlayHandle_t ulOverlayHandle, float* pfCurvature) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->GetOverlayCurvature(ulOverlayHandle, pfCurvature);
}
vr::EVROverlayError CVROverlay_025::SetOverlayTextureColorSpace(vr::VROverlayHandle_t ulOverlayHandle, vr::EColorSpace eTextureColorSpace) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->SetOverlayTextureColorSpace(ulOverlayHandle, eTextureColorSpace);
}
vr::EVROverlayError CVROverlay_025::GetOverlayTextureColorSpace(vr::VROverlayHandle_t ulOverlayHandle, vr::EColorSpace* peTextureColorSpace) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->GetOverlayTextureColorSpace(ulOverlayHandle, peTextureColorSpace);
}
vr::EVROverlayError CVROverlay_025::SetOverlayTextureBounds(vr::VROverlayHandle_t ulOverlayHandle, const vr::VRTextureBounds_t* pOverlayTextureBounds) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->SetOverlayTextureBounds(ulOverlayHandle, pOverlayTextureBounds);
}
vr::EVROverlayError CVROverlay_025::GetOverlayTextureBounds(vr::VROverlayHandle_t ulOverlayHandle, vr::VRTextureBounds_t* pOverlayTextureBounds) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->GetOverlayTextureBounds(ulOverlayHandle, pOverlayTextureBounds);
}
vr::EVROverlayError CVROverlay_025::GetOverlayTransformType(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_025::VROverlayTransformType* peTransformType) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->GetOverlayTransformType(ulOverlayHandle, (OOVR_VROverlayTransformType*) peTransformType);
}
vr::EVROverlayError CVROverlay_025::SetOverlayTransformAbsolute(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin eTrackingOrigin, const vr::HmdMatrix34_t* pmatTrackingOriginToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->SetOverlayTransformAbsolute(ulOverlayHandle, eTrackingOrigin, pmatTrackingOriginToOverlayTransform);
}
vr::EVROverlayError CVROverlay_025::GetOverlayTransformAbsolute(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin* peTrackingOrigin, vr::HmdMatrix34_t* pmatTrackingOriginToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->GetOverlayTransformAbsolute(ulOverlayHandle, peTrackingOrigin, pmatTrackingOriginToOverlayTransform);
}
vr::EVROverlayError CVROverlay_025::SetOverlayTransformTrackedDeviceRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unTrackedDevice, const vr::HmdMatrix34_t* pmatTrackedDeviceToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->SetOverlayTransformTrackedDeviceRelative(ulOverlayHandle, unTrackedDevice, pmatTrackedDeviceToOverlayTransform);
}
vr::EVROverlayError CVROverlay_025::GetOverlayTransformTrackedDeviceRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t* punTrackedDevice, vr::HmdMatrix34_t* pmatTrackedDeviceToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->GetOverlayTransformTrackedDeviceRelative(ulOverlayHandle, punTrackedDevice, pmatTrackedDeviceToOverlayTransform);
}
vr::EVROverlayError CVROverlay_025::SetOverlayTransformTrackedDeviceComponent(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unDeviceIndex, const char* pchComponentName) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->SetOverlayTransformTrackedDeviceComponent(ulOverlayHandle, unDeviceIndex, pchComponentName);
}
vr::EVROverlayError CVROverlay_025::GetOverlayTransformTrackedDeviceComponent(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t* punDeviceIndex, char* pchComponentName, uint32_t unComponentNameSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->GetOverlayTransformTrackedDeviceComponent(ulOverlayHandle, punDeviceIndex, pchComponentName, unComponentNameSize);
}
vr::EVROverlayError CVROverlay_025::GetOverlayTransformOverlayRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::VROverlayHandle_t* ulOverlayHandleParent, vr::HmdMatrix34_t* pmatParentOverlayToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->GetOverlayTransformOverlayRelative(ulOverlayHandle, ulOverlayHandleParent, pmatParentOverlayToOverlayTransform);
}
vr::EVROverlayError CVROverlay_025::SetOverlayTransformOverlayRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::VROverlayHandle_t ulOverlayHandleParent, const vr::HmdMatrix34_t* pmatParentOverlayToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->SetOverlayTransformOverlayRelative(ulOverlayHandle, ulOverlayHandleParent, pmatParentOverlayToOverlayTransform);
}
vr::EVROverlayError CVROverlay_025::SetOverlayTransformCursor(vr::VROverlayHandle_t ulCursorOverlayHandle, const vr::HmdVector2_t* pvHotspot) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->SetOverlayTransformCursor(ulCursorOverlayHandle, pvHotspot);
}
vr::EVROverlayError CVROverlay_025::GetOverlayTransformCursor(vr::VROverlayHandle_t ulOverlayHandle, vr::HmdVector2_t* pvHotspot) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->GetOverlayTransformCursor(ulOverlayHandle, pvHotspot);
}
vr::EVROverlayError CVROverlay_025::SetOverlayTransformProjection(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin eTrackingOrigin, const vr::HmdMatrix34_t* pmatTrackingOriginToOverlayTransform, const vr::IVROverlay_025::VROverlayProjection_t* pProjection, vr::EVREye eEye) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->SetOverlayTransformProjection(ulOverlayHandle, eTrackingOrigin, pmatTrackingOriginToOverlayTransform, (const OOVR_VROverlayProjection_t*) pProjection, eEye);
}
vr::EVROverlayError CVROverlay_025::ShowOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->ShowOverlay(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_025::HideOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->HideOverlay(ulOverlayHandle);
}
bool CVROverlay_025::IsOverlayVisible(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->IsOverlayVisible(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_025::GetTransformForOverlayCoordinates(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin eTrackingOrigin, vr::HmdVector2_t coordinatesInOverlay, vr::HmdMatrix34_t* pmatTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->GetTransformForOverlayCoordinates(ulOverlayHandle, eTrackingOrigin, coordinatesInOverlay, pmatTransform);
}
bool CVROverlay_025::PollNextOverlayEvent(vr::VROverlayHandle_t ulOverlayHandle, vr::VREvent_t* pEvent, uint32_t uncbVREvent) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->PollNextOverlayEvent(ulOverlayHandle, pEvent, uncbVREvent);
}
vr::EVROverlayError CVROverlay_025::GetOverlayInputMethod(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_025::VROverlayInputMethod* peInputMethod) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->GetOverlayInputMethod(ulOverlayHandle, (OOVR_VROverlayInputMethod*) peInputMethod);
}
vr::EVROverlayError CVROverlay_025::SetOverlayInputMethod(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_025::VROverlayInputMethod eInputMethod) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->SetOverlayInputMethod(ulOverlayHandle, (OOVR_VROverlayInputMethod) eInputMethod);
}
vr::EVROverlayError CVROverlay_025::GetOverlayMouseScale(vr::VROverlayHandle_t ulOverlayHandle, vr::HmdVector2_t* pvecMouseScale) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->GetOverlayMouseScale(ulOverlayHandle, pvecMouseScale);
}
vr::EVROverlayError CVROverlay_025::SetOverlayMouseScale(vr::VROverlayHandle_t ulOverlayHandle, const vr::HmdVector2_t* pvecMouseScale) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->SetOverlayMouseScale(ulOverlayHandle, pvecMouseScale);
}
bool CVROverlay_025::ComputeOverlayIntersection(vr::VROverlayHandle_t ulOverlayHandle, const vr::IVROverlay_025::VROverlayIntersectionParams_t* pParams, vr::IVROverlay_025::VROverlayIntersectionResults_t* pResults) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->ComputeOverlayIntersection(ulOverlayHandle, (const OOVR_VROverlayIntersectionParams_t*) pParams, (OOVR_VROverlayIntersectionResults_t*) pResults);
}
bool CVROverlay_025::IsHoverTargetOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->IsHoverTargetOverlay(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_025::SetOverlayIntersectionMask(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_025::VROverlayIntersectionMaskPrimitive_t* pMaskPrimitives, uint32_t unNumMaskPrimitives, uint32_t unPrimitiveSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->SetOverlayIntersectionMask(ulOverlayHandle, (OOVR_VROverlayIntersectionMaskPrimitive_t*) pMaskPrimitives, unNumMaskPrimitives, unPrimitiveSize);
}
vr::EVROverlayError CVROverlay_025::TriggerLaserMouseHapticVibration(vr::VROverlayHandle_t ulOverlayHandle, float fDurationSeconds, float fFrequency, float fAmplitude) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->TriggerLaserMouseHapticVibration(ulOverlayHandle, fDurationSeconds, fFrequency, fAmplitude);
}
vr::EVROverlayError CVROverlay_025::SetOverlayCursor(vr::VROverlayHandle_t ulOverlayHandle, vr::VROverlayHandle_t ulCursorHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->SetOverlayCursor(ulOverlayHandle, ulCursorHandle);
}
vr::EVROverlayError CVROverlay_025::SetOverlayCursorPositionOverride(vr::VROverlayHandle_t ulOverlayHandle, const vr::HmdVector2_t* pvCursor) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->SetOverlayCursorPositionOverride(ulOverlayHandle, pvCursor);
}
vr::EVROverlayError CVROverlay_025::ClearOverlayCursorPositionOverride(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->ClearOverlayCursorPositionOverride(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_025::SetOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle, const vr::Texture_t* pTexture) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->SetOverlayTexture(ulOverlayHandle, pTexture);
}
vr::EVROverlayError CVROverlay_025::ClearOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->ClearOverlayTexture(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_025::SetOverlayRaw(vr::VROverlayHandle_t ulOverlayHandle, void* pvBuffer, uint32_t unWidth, uint32_t unHeight, uint32_t unBytesPerPixel) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->SetOverlayRaw(ulOverlayHandle, pvBuffer, unWidth, unHeight, unBytesPerPixel);
}
vr::EVROverlayError CVROverlay_025::SetOverlayFromFile(vr::VROverlayHandle_t ulOverlayHandle, const char* pchFilePath) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->SetOverlayFromFile(ulOverlayHandle, pchFilePath);
}
vr::EVROverlayError CVROverlay_025::GetOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle, void** pNativeTextureHandle, void* pNativeTextureRef, uint32_t* pWidth, uint32_t* pHeight, uint32_t* pNativeFormat, vr::ETextureType* pAPIType, vr::EColorSpace* pColorSpace, vr::VRTextureBounds_t* pTextureBounds) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->GetOverlayTexture(ulOverlayHandle, pNativeTextureHandle, pNativeTextureRef, pWidth, pHeight, pNativeFormat, pAPIType, pColorSpace, pTextureBounds);
}
vr::EVROverlayError CVROverlay_025::ReleaseNativeOverlayHandle(vr::VROverlayHandle_t ulOverlayHandle, void* pNativeTextureHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->ReleaseNativeOverlayHandle(ulOverlayHandle, pNativeTextureHandle);
}
vr::EVROverlayError CVROverlay_025::GetOverlayTextureSize(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* pWidth, uint32_t* pHeight) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->GetOverlayTextureSize(ulOverlayHandle, pWidth, pHeight);
}
vr::EVROverlayError CVROverlay_025::CreateDashboardOverlay(const char* pchOverlayKey, const char* pchOverlayFriendlyName, vr::VROverlayHandle_t* pMainHandle, vr::VROverlayHandle_t* pThumbnailHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->CreateDashboardOverlay(pchOverlayKey, pchOverlayFriendlyName, pMainHandle, pThumbnailHandle);
}
bool CVROverlay_025::IsDashboardVisible() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->IsDashboardVisible();
}
bool CVROverlay_025::IsActiveDashboardOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->IsActiveDashboardOverlay(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_025::SetDashboardOverlaySceneProcess(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unProcessId) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->SetDashboardOverlaySceneProcess(ulOverlayHandle, unProcessId);
}
vr::EVROverlayError CVROverlay_025::GetDashboardOverlaySceneProcess(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* punProcessId) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->GetDashboardOverlaySceneProcess(ulOverlayHandle, punProcessId);
}
void CVROverlay_025::ShowDashboard(const char* pchOverlayToShow) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->ShowDashboard(pchOverlayToShow);
}
vr::TrackedDeviceIndex_t CVROverlay_025::GetPrimaryDashboardDevice() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->GetPrimaryDashboardDevice();
}
vr::EVROverlayError CVROverlay_025::ShowKeyboard(vr::IVROverlay_025::EGamepadTextInputMode eInputMode, vr::IVROverlay_025::EGamepadTextInputLineMode eLineInputMode, uint32_t unFlags, const char* pchDescription, uint32_t unCharMax, const char* pchExistingText, uint64_t uUserValue) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->ShowKeyboard((OOVR_EGamepadTextInputMode) eInputMode, (OOVR_EGamepadTextInputLineMode) eLineInputMode, unFlags, pchDescription, unCharMax, pchExistingText, uUserValue);
}
vr::EVROverlayError CVROverlay_025::ShowKeyboardForOverlay(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_025::EGamepadTextInputMode eInputMode, vr::IVROverlay_025::EGamepadTextInputLineMode eLineInputMode, uint32_t unFlags, const char* pchDescription, uint32_t unCharMax, const char* pchExistingText, uint64_t uUserValue) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->ShowKeyboardForOverlay(ulOverlayHandle, (OOVR_EGamepadTextInputMode) eInputMode, (OOVR_EGamepadTextInputLineMode) eLineInputMode, unFlags, pchDescription, unCharMax, pchExistingText, uUserValue);
}
uint32_t CVROverlay_025::GetKeyboardText(char* pchText, uint32_t cchText) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->GetKeyboardText(pchText, cchText);
}
void CVROverlay_025::HideKeyboard() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->HideKeyboard();
}
void CVROverlay_025::SetKeyboardTransformAbsolute(vr::ETrackingUniverseOrigin eTrackingOrigin, const vr::HmdMatrix34_t* pmatTrackingOriginToKeyboardTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->SetKeyboardTransformAbsolute(eTrackingOrigin, pmatTrackingOriginToKeyboardTransform);
}
void CVROverlay_025::SetKeyboardPositionForOverlay(vr::VROverlayHandle_t ulOverlayHandle, vr::HmdRect2_t avoidRect) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->SetKeyboardPositionForOverlay(ulOverlayHandle, avoidRect);
}
vr::IVROverlay_025::VRMessageOverlayResponse CVROverlay_025::ShowMessageOverlay(const char* pchText, const char* pchCaption, const char* pchButton0Text, const char* pchButton1Text, const char* pchButton2Text, const char* pchButton3Text) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return (vr::IVROverlay_025::VRMessageOverlayResponse) base->ShowMessageOverlay(pchText, pchCaption, pchButton0Text, pchButton1Text, pchButton2Text, pchButton3Text);
}
void CVROverlay_025::CloseMessageOverlay() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_025)");
	return base->CloseMessageOverlay();
}
// FnTable for CVROverlay_025:
static CVROverlay_025 *fntable_Overlay_025_instance = NULL;
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_FindOverlay(const char* pchOverlayKey, vr::VROverlayHandle_t* pOverlayHandle) { return fntable_Overlay_025_instance->FindOverlay(pchOverlayKey, pOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_CreateOverlay(const char* pchOverlayKey, const char* pchOverlayName, vr::VROverlayHandle_t* pOverlayHandle) { return fntable_Overlay_025_instance->CreateOverlay(pchOverlayKey, pchOverlayName, pOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_DestroyOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_025_instance->DestroyOverlay(ulOverlayHandle); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_GetOverlayKey(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::EVROverlayError* pError) { return fntable_Overlay_025_instance->GetOverlayKey(ulOverlayHandle, pchValue, unBufferSize, pError); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_GetOverlayName(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::EVROverlayError* pError) { return fntable_Overlay_025_instance->GetOverlayName(ulOverlayHandle, pchValue, unBufferSize, pError); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_SetOverlayName(vr::VROverlayHandle_t ulOverlayHandle, const char* pchName) { return fntable_Overlay_025_instance->SetOverlayName(ulOverlayHandle, pchName); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_GetOverlayImageData(vr::VROverlayHandle_t ulOverlayHandle, void* pvBuffer, uint32_t unBufferSize, uint32_t* punWidth, uint32_t* punHeight) { return fntable_Overlay_025_instance->GetOverlayImageData(ulOverlayHandle, pvBuffer, unBufferSize, punWidth, punHeight); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_GetOverlayErrorNameFromEnum(vr::EVROverlayError error) { return fntable_Overlay_025_instance->GetOverlayErrorNameFromEnum(error); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_SetOverlayRenderingPid(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unPID) { return fntable_Overlay_025_instance->SetOverlayRenderingPid(ulOverlayHandle, unPID); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_GetOverlayRenderingPid(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_025_instance->GetOverlayRenderingPid(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_SetOverlayFlag(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_025::VROverlayFlags eOverlayFlag, bool bEnabled) { return fntable_Overlay_025_instance->SetOverlayFlag(ulOverlayHandle, eOverlayFlag, bEnabled); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_GetOverlayFlag(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_025::VROverlayFlags eOverlayFlag, bool* pbEnabled) { return fntable_Overlay_025_instance->GetOverlayFlag(ulOverlayHandle, eOverlayFlag, pbEnabled); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_GetOverlayFlags(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* pFlags) { return fntable_Overlay_025_instance->GetOverlayFlags(ulOverlayHandle, pFlags); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_SetOverlayColor(vr::VROverlayHandle_t ulOverlayHandle, float fRed, float fGreen, float fBlue) { return fntable_Overlay_025_instance->SetOverlayColor(ulOverlayHandle, fRed, fGreen, fBlue); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_GetOverlayColor(vr::VROverlayHandle_t ulOverlayHandle, float* pfRed, float* pfGreen, float* pfBlue) { return fntable_Overlay_025_instance->GetOverlayColor(ulOverlayHandle, pfRed, pfGreen, pfBlue); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_SetOverlayAlpha(vr::VROverlayHandle_t ulOverlayHandle, float fAlpha) { return fntable_Overlay_025_instance->SetOverlayAlpha(ulOverlayHandle, fAlpha); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_GetOverlayAlpha(vr::VROverlayHandle_t ulOverlayHandle, float* pfAlpha) { return fntable_Overlay_025_instance->GetOverlayAlpha(ulOverlayHandle, pfAlpha); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_SetOverlayTexelAspect(vr::VROverlayHandle_t ulOverlayHandle, float fTexelAspect) { return fntable_Overlay_025_instance->SetOverlayTexelAspect(ulOverlayHandle, fTexelAspect); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_GetOverlayTexelAspect(vr::VROverlayHandle_t ulOverlayHandle, float* pfTexelAspect) { return fntable_Overlay_025_instance->GetOverlayTexelAspect(ulOverlayHandle, pfTexelAspect); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_SetOverlaySortOrder(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unSortOrder) { return fntable_Overlay_025_instance->SetOverlaySortOrder(ulOverlayHandle, unSortOrder); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_GetOverlaySortOrder(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* punSortOrder) { return fntable_Overlay_025_instance->GetOverlaySortOrder(ulOverlayHandle, punSortOrder); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_SetOverlayWidthInMeters(vr::VROverlayHandle_t ulOverlayHandle, float fWidthInMeters) { return fntable_Overlay_025_instance->SetOverlayWidthInMeters(ulOverlayHandle, fWidthInMeters); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_GetOverlayWidthInMeters(vr::VROverlayHandle_t ulOverlayHandle, float* pfWidthInMeters) { return fntable_Overlay_025_instance->GetOverlayWidthInMeters(ulOverlayHandle, pfWidthInMeters); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_SetOverlayCurvature(vr::VROverlayHandle_t ulOverlayHandle, float fCurvature) { return fntable_Overlay_025_instance->SetOverlayCurvature(ulOverlayHandle, fCurvature); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_GetOverlayCurvature(vr::VROverlayHandle_t ulOverlayHandle, float* pfCurvature) { return fntable_Overlay_025_instance->GetOverlayCurvature(ulOverlayHandle, pfCurvature); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_SetOverlayTextureColorSpace(vr::VROverlayHandle_t ulOverlayHandle, vr::EColorSpace eTextureColorSpace) { return fntable_Overlay_025_instance->SetOverlayTextureColorSpace(ulOverlayHandle, eTextureColorSpace); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_GetOverlayTextureColorSpace(vr::VROverlayHandle_t ulOverlayHandle, vr::EColorSpace* peTextureColorSpace) { return fntable_Overlay_025_instance->GetOverlayTextureColorSpace(ulOverlayHandle, peTextureColorSpace); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_SetOverlayTextureBounds(vr::VROverlayHandle_t ulOverlayHandle, const vr::VRTextureBounds_t* pOverlayTextureBounds) { return fntable_Overlay_025_instance->SetOverlayTextureBounds(ulOverlayHandle, pOverlayTextureBounds); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_GetOverlayTextureBounds(vr::VROverlayHandle_t ulOverlayHandle, vr::VRTextureBounds_t* pOverlayTextureBounds) { return fntable_Overlay_025_instance->GetOverlayTextureBounds(ulOverlayHandle, pOverlayTextureBounds); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_GetOverlayTransformType(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_025::VROverlayTransformType* peTransformType) { return fntable_Overlay_025_instance->GetOverlayTransformType(ulOverlayHandle, peTransformType); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_SetOverlayTransformAbsolute(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin eTrackingOrigin, const vr::HmdMatrix34_t* pmatTrackingOriginToOverlayTransform) { return fntable_Overlay_025_instance->SetOverlayTransformAbsolute(ulOverlayHandle, eTrackingOrigin, pmatTrackingOriginToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_GetOverlayTransformAbsolute(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin* peTrackingOrigin, vr::HmdMatrix34_t* pmatTrackingOriginToOverlayTransform) { return fntable_Overlay_025_instance->GetOverlayTransformAbsolute(ulOverlayHandle, peTrackingOrigin, pmatTrackingOriginToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_SetOverlayTransformTrackedDeviceRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unTrackedDevice, const vr::HmdMatrix34_t* pmatTrackedDeviceToOverlayTransform) { return fntable_Overlay_025_instance->SetOverlayTransformTrackedDeviceRelative(ulOverlayHandle, unTrackedDevice, pmatTrackedDeviceToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_GetOverlayTransformTrackedDeviceRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t* punTrackedDevice, vr::HmdMatrix34_t* pmatTrackedDeviceToOverlayTransform) { return fntable_Overlay_025_instance->GetOverlayTransformTrackedDeviceRelative(ulOverlayHandle, punTrackedDevice, pmatTrackedDeviceToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_SetOverlayTransformTrackedDeviceComponent(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unDeviceIndex, const char* pchComponentName) { return fntable_Overlay_025_instance->SetOverlayTransformTrackedDeviceComponent(ulOverlayHandle, unDeviceIndex, pchComponentName); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_GetOverlayTransformTrackedDeviceComponent(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t* punDeviceIndex, char* pchComponentName, uint32_t unComponentNameSize) { return fntable_Overlay_025_instance->GetOverlayTransformTrackedDeviceComponent(ulOverlayHandle, punDeviceIndex, pchComponentName, unComponentNameSize); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_GetOverlayTransformOverlayRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::VROverlayHandle_t* ulOverlayHandleParent, vr::HmdMatrix34_t* pmatParentOverlayToOverlayTransform) { return fntable_Overlay_025_instance->GetOverlayTransformOverlayRelative(ulOverlayHandle, ulOverlayHandleParent, pmatParentOverlayToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_SetOverlayTransformOverlayRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::VROverlayHandle_t ulOverlayHandleParent, const vr::HmdMatrix34_t* pmatParentOverlayToOverlayTransform) { return fntable_Overlay_025_instance->SetOverlayTransformOverlayRelative(ulOverlayHandle, ulOverlayHandleParent, pmatParentOverlayToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_SetOverlayTransformCursor(vr::VROverlayHandle_t ulCursorOverlayHandle, const vr::HmdVector2_t* pvHotspot) { return fntable_Overlay_025_instance->SetOverlayTransformCursor(ulCursorOverlayHandle, pvHotspot); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_GetOverlayTransformCursor(vr::VROverlayHandle_t ulOverlayHandle, vr::HmdVector2_t* pvHotspot) { return fntable_Overlay_025_instance->GetOverlayTransformCursor(ulOverlayHandle, pvHotspot); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_SetOverlayTransformProjection(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin eTrackingOrigin, const vr::HmdMatrix34_t* pmatTrackingOriginToOverlayTransform, const vr::IVROverlay_025::VROverlayProjection_t* pProjection, vr::EVREye eEye) { return fntable_Overlay_025_instance->SetOverlayTransformProjection(ulOverlayHandle, eTrackingOrigin, pmatTrackingOriginToOverlayTransform, pProjection, eEye); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_ShowOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_025_instance->ShowOverlay(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_HideOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_025_instance->HideOverlay(ulOverlayHandle); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_IsOverlayVisible(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_025_instance->IsOverlayVisible(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_GetTransformForOverlayCoordinates(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin eTrackingOrigin, vr::HmdVector2_t coordinatesInOverlay, vr::HmdMatrix34_t* pmatTransform) { return fntable_Overlay_025_instance->GetTransformForOverlayCoordinates(ulOverlayHandle, eTrackingOrigin, coordinatesInOverlay, pmatTransform); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_PollNextOverlayEvent(vr::VROverlayHandle_t ulOverlayHandle, vr::VREvent_t* pEvent, uint32_t uncbVREvent) { return fntable_Overlay_025_instance->PollNextOverlayEvent(ulOverlayHandle, pEvent, uncbVREvent); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_GetOverlayInputMethod(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_025::VROverlayInputMethod* peInputMethod) { return fntable_Overlay_025_instance->GetOverlayInputMethod(ulOverlayHandle, peInputMethod); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_SetOverlayInputMethod(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_025::VROverlayInputMethod eInputMethod) { return fntable_Overlay_025_instance->SetOverlayInputMethod(ulOverlayHandle, eInputMethod); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_GetOverlayMouseScale(vr::VROverlayHandle_t ulOverlayHandle, vr::HmdVector2_t* pvecMouseScale) { return fntable_Overlay_025_instance->GetOverlayMouseScale(ulOverlayHandle, pvecMouseScale); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_SetOverlayMouseScale(vr::VROverlayHandle_t ulOverlayHandle, const vr::HmdVector2_t* pvecMouseScale) { return fntable_Overlay_025_instance->SetOverlayMouseScale(ulOverlayHandle, pvecMouseScale); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_ComputeOverlayIntersection(vr::VROverlayHandle_t ulOverlayHandle, const vr::IVROverlay_025::VROverlayIntersectionParams_t* pParams, vr::IVROverlay_025::VROverlayIntersectionResults_t* pResults) { return fntable_Overlay_025_instance->ComputeOverlayIntersection(ulOverlayHandle, pParams, pResults); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_IsHoverTargetOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_025_instance->IsHoverTargetOverlay(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_SetOverlayIntersectionMask(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_025::VROverlayIntersectionMaskPrimitive_t* pMaskPrimitives, uint32_t unNumMaskPrimitives, uint32_t unPrimitiveSize) { return fntable_Overlay_025_instance->SetOverlayIntersectionMask(ulOverlayHandle, pMaskPrimitives, unNumMaskPrimitives, unPrimitiveSize); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_TriggerLaserMouseHapticVibration(vr::VROverlayHandle_t ulOverlayHandle, float fDurationSeconds, float fFrequency, float fAmplitude) { return fntable_Overlay_025_instance->TriggerLaserMouseHapticVibration(ulOverlayHandle, fDurationSeconds, fFrequency, fAmplitude); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_SetOverlayCursor(vr::VROverlayHandle_t ulOverlayHandle, vr::VROverlayHandle_t ulCursorHandle) { return fntable_Overlay_025_instance->SetOverlayCursor(ulOverlayHandle, ulCursorHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_SetOverlayCursorPositionOverride(vr::VROverlayHandle_t ulOverlayHandle, const vr::HmdVector2_t* pvCursor) { return fntable_Overlay_025_instance->SetOverlayCursorPositionOverride(ulOverlayHandle, pvCursor); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_ClearOverlayCursorPositionOverride(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_025_instance->ClearOverlayCursorPositionOverride(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_SetOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle, const vr::Texture_t* pTexture) { return fntable_Overlay_025_instance->SetOverlayTexture(ulOverlayHandle, pTexture); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_ClearOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_025_instance->ClearOverlayTexture(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_SetOverlayRaw(vr::VROverlayHandle_t ulOverlayHandle, void* pvBuffer, uint32_t unWidth, uint32_t unHeight, uint32_t unBytesPerPixel) { return fntable_Overlay_025_instance->SetOverlayRaw(ulOverlayHandle, pvBuffer, unWidth, unHeight, unBytesPerPixel); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_SetOverlayFromFile(vr::VROverlayHandle_t ulOverlayHandle, const char* pchFilePath) { return fntable_Overlay_025_instance->SetOverlayFromFile(ulOverlayHandle, pchFilePath); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_GetOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle, void** pNativeTextureHandle, void* pNativeTextureRef, uint32_t* pWidth, uint32_t* pHeight, uint32_t* pNativeFormat, vr::ETextureType* pAPIType, vr::EColorSpace* pColorSpace, vr::VRTextureBounds_t* pTextureBounds) { return fntable_Overlay_025_instance->GetOverlayTexture(ulOverlayHandle, pNativeTextureHandle, pNativeTextureRef, pWidth, pHeight, pNativeFormat, pAPIType, pColorSpace, pTextureBounds); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_ReleaseNativeOverlayHandle(vr::VROverlayHandle_t ulOverlayHandle, void* pNativeTextureHandle) { return fntable_Overlay_025_instance->ReleaseNativeOverlayHandle(ulOverlayHandle, pNativeTextureHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_GetOverlayTextureSize(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* pWidth, uint32_t* pHeight) { return fntable_Overlay_025_instance->GetOverlayTextureSize(ulOverlayHandle, pWidth, pHeight); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_CreateDashboardOverlay(const char* pchOverlayKey, const char* pchOverlayFriendlyName, vr::VROverlayHandle_t* pMainHandle, vr::VROverlayHandle_t* pThumbnailHandle) { return fntable_Overlay_025_instance->CreateDashboardOverlay(pchOverlayKey, pchOverlayFriendlyName, pMainHandle, pThumbnailHandle); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_IsDashboardVisible() { return fntable_Overlay_025_instance->IsDashboardVisible(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_IsActiveDashboardOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_025_instance->IsActiveDashboardOverlay(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_SetDashboardOverlaySceneProcess(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unProcessId) { return fntable_Overlay_025_instance->SetDashboardOverlaySceneProcess(ulOverlayHandle, unProcessId); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_GetDashboardOverlaySceneProcess(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* punProcessId) { return fntable_Overlay_025_instance->GetDashboardOverlaySceneProcess(ulOverlayHandle, punProcessId); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_ShowDashboard(const char* pchOverlayToShow) { return fntable_Overlay_025_instance->ShowDashboard(pchOverlayToShow); }
static vr::TrackedDeviceIndex_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_GetPrimaryDashboardDevice() { return fntable_Overlay_025_instance->GetPrimaryDashboardDevice(); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_ShowKeyboard(vr::IVROverlay_025::EGamepadTextInputMode eInputMode, vr::IVROverlay_025::EGamepadTextInputLineMode eLineInputMode, uint32_t unFlags, const char* pchDescription, uint32_t unCharMax, const char* pchExistingText, uint64_t uUserValue) { return fntable_Overlay_025_instance->ShowKeyboard(eInputMode, eLineInputMode, unFlags, pchDescription, unCharMax, pchExistingText, uUserValue); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_ShowKeyboardForOverlay(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_025::EGamepadTextInputMode eInputMode, vr::IVROverlay_025::EGamepadTextInputLineMode eLineInputMode, uint32_t unFlags, const char* pchDescription, uint32_t unCharMax, const char* pchExistingText, uint64_t uUserValue) { return fntable_Overlay_025_instance->ShowKeyboardForOverlay(ulOverlayHandle, eInputMode, eLineInputMode, unFlags, pchDescription, unCharMax, pchExistingText, uUserValue); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_GetKeyboardText(char* pchText, uint32_t cchText) { return fntable_Overlay_025_instance->GetKeyboardText(pchText, cchText); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_HideKeyboard() { return fntable_Overlay_025_instance->HideKeyboard(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_SetKeyboardTransformAbsolute(vr::ETrackingUniverseOrigin eTrackingOrigin, const vr::HmdMatrix34_t* pmatTrackingOriginToKeyboardTransform) { return fntable_Overlay_025_instance->SetKeyboardTransformAbsolute(eTrackingOrigin, pmatTrackingOriginToKeyboardTransform); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_SetKeyboardPositionForOverlay(vr::VROverlayHandle_t ulOverlayHandle, vr::HmdRect2_t avoidRect) { return fntable_Overlay_025_instance->SetKeyboardPositionForOverlay(ulOverlayHandle, avoidRect); }
static vr::IVROverlay_025::VRMessageOverlayResponse OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_ShowMessageOverlay(const char* pchText, const char* pchCaption, const char* pchButton0Text, const char* pchButton1Text, const char* pchButton2Text, const char* pchButton3Text) { return fntable_Overlay_025_instance->ShowMessageOverlay(pchText, pchCaption, pchButton0Text, pchButton1Text, pchButton2Text, pchButton3Text); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_025_impl_CloseMessageOverlay() { return fntable_Overlay_025_instance->CloseMessageOverlay(); }
static void *fntable_Overlay_025_funcs[] = {
	(void*) fntable_Overlay_025_impl_FindOverlay,
	(void*) fntable_Overlay_025_impl_CreateOverlay,
	(void*) fntable_Overlay_025_impl_DestroyOverlay,
	(void*) fntable_Overlay_025_impl_GetOverlayKey,
	(void*) fntable_Overlay_025_impl_GetOverlayName,
	(void*) fntable_Overlay_025_impl_SetOverlayName,
	(void*) fntable_Overlay_025_impl_GetOverlayImageData,
	(void*) fntable_Overlay_025_impl_GetOverlayErrorNameFromEnum,
	(void*) fntable_Overlay_025_impl_SetOverlayRenderingPid,
	(void*) fntable_Overlay_025_impl_GetOverlayRenderingPid,
	(void*) fntable_Overlay_025_impl_SetOverlayFlag,
	(void*) fntable_Overlay_025_impl_GetOverlayFlag,
	(void*) fntable_Overlay_025_impl_GetOverlayFlags,
	(void*) fntable_Overlay_025_impl_SetOverlayColor,
	(void*) fntable_Overlay_025_impl_GetOverlayColor,
	(void*) fntable_Overlay_025_impl_SetOverlayAlpha,
	(void*) fntable_Overlay_025_impl_GetOverlayAlpha,
	(void*) fntable_Overlay_025_impl_SetOverlayTexelAspect,
	(void*) fntable_Overlay_025_impl_GetOverlayTexelAspect,
	(void*) fntable_Overlay_025_impl_SetOverlaySortOrder,
	(void*) fntable_Overlay_025_impl_GetOverlaySortOrder,
	(void*) fntable_Overlay_025_impl_SetOverlayWidthInMeters,
	(void*) fntable_Overlay_025_impl_GetOverlayWidthInMeters,
	(void*) fntable_Overlay_025_impl_SetOverlayCurvature,
	(void*) fntable_Overlay_025_impl_GetOverlayCurvature,
	(void*) fntable_Overlay_025_impl_SetOverlayTextureColorSpace,
	(void*) fntable_Overlay_025_impl_GetOverlayTextureColorSpace,
	(void*) fntable_Overlay_025_impl_SetOverlayTextureBounds,
	(void*) fntable_Overlay_025_impl_GetOverlayTextureBounds,
	(void*) fntable_Overlay_025_impl_GetOverlayTransformType,
	(void*) fntable_Overlay_025_impl_SetOverlayTransformAbsolute,
	(void*) fntable_Overlay_025_impl_GetOverlayTransformAbsolute,
	(void*) fntable_Overlay_025_impl_SetOverlayTransformTrackedDeviceRelative,
	(void*) fntable_Overlay_025_impl_GetOverlayTransformTrackedDeviceRelative,
	(void*) fntable_Overlay_025_impl_SetOverlayTransformTrackedDeviceComponent,
	(void*) fntable_Overlay_025_impl_GetOverlayTransformTrackedDeviceComponent,
	(void*) fntable_Overlay_025_impl_GetOverlayTransformOverlayRelative,
	(void*) fntable_Overlay_025_impl_SetOverlayTransformOverlayRelative,
	(void*) fntable_Overlay_025_impl_SetOverlayTransformCursor,
	(void*) fntable_Overlay_025_impl_GetOverlayTransformCursor,
	(void*) fntable_Overlay_025_impl_SetOverlayTransformProjection,
	(void*) fntable_Overlay_025_impl_ShowOverlay,
	(void*) fntable_Overlay_025_impl_HideOverlay,
	(void*) fntable_Overlay_025_impl_IsOverlayVisible,
	(void*) fntable_Overlay_025_impl_GetTransformForOverlayCoordinates,
	(void*) fntable_Overlay_025_impl_PollNextOverlayEvent,
	(void*) fntable_Overlay_025_impl_GetOverlayInputMethod,
	(void*) fntable_Overlay_025_impl_SetOverlayInputMethod,
	(void*) fntable_Overlay_025_impl_GetOverlayMouseScale,
	(void*) fntable_Overlay_025_impl_SetOverlayMouseScale,
	(void*) fntable_Overlay_025_impl_ComputeOverlayIntersection,
	(void*) fntable_Overlay_025_impl_IsHoverTargetOverlay,
	(void*) fntable_Overlay_025_impl_SetOverlayIntersectionMask,
	(void*) fntable_Overlay_025_impl_TriggerLaserMouseHapticVibration,
	(void*) fntable_Overlay_025_impl_SetOverlayCursor,
	(void*) fntable_Overlay_025_impl_SetOverlayCursorPositionOverride,
	(void*) fntable_Overlay_025_impl_ClearOverlayCursorPositionOverride,
	(void*) fntable_Overlay_025_impl_SetOverlayTexture,
	(void*) fntable_Overlay_025_impl_ClearOverlayTexture,
	(void*) fntable_Overlay_025_impl_SetOverlayRaw,
	(void*) fntable_Overlay_025_impl_SetOverlayFromFile,
	(void*) fntable_Overlay_025_impl_GetOverlayTexture,
	(void*) fntable_Overlay_025_impl_ReleaseNativeOverlayHandle,
	(void*) fntable_Overlay_025_impl_GetOverlayTextureSize,
	(void*) fntable_Overlay_025_impl_CreateDashboardOverlay,
	(void*) fntable_Overlay_025_impl_IsDashboardVisible,
	(void*) fntable_Overlay_025_impl_IsActiveDashboardOverlay,
	(void*) fntable_Overlay_025_impl_SetDashboardOverlaySceneProcess,
	(void*) fntable_Overlay_025_impl_GetDashboardOverlaySceneProcess,
	(void*) fntable_Overlay_025_impl_ShowDashboard,
	(void*) fntable_Overlay_025_impl_GetPrimaryDashboardDevice,
	(void*) fntable_Overlay_025_impl_ShowKeyboard,
	(void*) fntable_Overlay_025_impl_ShowKeyboardForOverlay,
	(void*) fntable_Overlay_025_impl_GetKeyboardText,
	(void*) fntable_Overlay_025_impl_HideKeyboard,
	(void*) fntable_Overlay_025_impl_SetKeyboardTransformAbsolute,
	(void*) fntable_Overlay_025_impl_SetKeyboardPositionForOverlay,
	(void*) fntable_Overlay_025_impl_ShowMessageOverlay,
	(void*) fntable_Overlay_025_impl_CloseMessageOverlay,
};
void** CVROverlay_025::_GetStatFuncList() { fntable_Overlay_025_instance = this; return fntable_Overlay_025_funcs; }
void CVROverlay_025::Delete() { delete this; }
// Misc for CVROverlay_026:
CVROverlay_026::CVROverlay_026() : base(GetCreateBaseOverlay()) {}
// Interface methods for CVROverlay_026:
vr::EVROverlayError CVROverlay_026::FindOverlay(const char* pchOverlayKey, vr::VROverlayHandle_t* pOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->FindOverlay(pchOverlayKey, pOverlayHandle);
}
vr::EVROverlayError CVROverlay_026::CreateOverlay(const char* pchOverlayKey, const char* pchOverlayName, vr::VROverlayHandle_t* pOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->CreateOverlay(pchOverlayKey, pchOverlayName, pOverlayHandle);
}
vr::EVROverlayError CVROverlay_026::DestroyOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->DestroyOverlay(ulOverlayHandle);
}
uint32_t CVROverlay_026::GetOverlayKey(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::EVROverlayError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->GetOverlayKey(ulOverlayHandle, pchValue, unBufferSize, pError);
}
uint32_t CVROverlay_026::GetOverlayName(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::EVROverlayError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->GetOverlayName(ulOverlayHandle, pchValue, unBufferSize, pError);
}
vr::EVROverlayError CVROverlay_026::SetOverlayName(vr::VROverlayHandle_t ulOverlayHandle, const char* pchName) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->SetOverlayName(ulOverlayHandle, pchName);
}
vr::EVROverlayError CVROverlay_026::GetOverlayImageData(vr::VROverlayHandle_t ulOverlayHandle, void* pvBuffer, uint32_t unBufferSize, uint32_t* punWidth, uint32_t* punHeight) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->GetOverlayImageData(ulOverlayHandle, pvBuffer, unBufferSize, punWidth, punHeight);
}
const char* CVROverlay_026::GetOverlayErrorNameFromEnum(vr::EVROverlayError error) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->GetOverlayErrorNameFromEnum(error);
}
vr::EVROverlayError CVROverlay_026::SetOverlayRenderingPid(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unPID) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->SetOverlayRenderingPid(ulOverlayHandle, unPID);
}
uint32_t CVROverlay_026::GetOverlayRenderingPid(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->GetOverlayRenderingPid(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_026::SetOverlayFlag(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_026::VROverlayFlags eOverlayFlag, bool bEnabled) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->SetOverlayFlag(ulOverlayHandle, (OOVR_VROverlayFlags) eOverlayFlag, bEnabled);
}
vr::EVROverlayError CVROverlay_026::GetOverlayFlag(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_026::VROverlayFlags eOverlayFlag, bool* pbEnabled) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->GetOverlayFlag(ulOverlayHandle, (OOVR_VROverlayFlags) eOverlayFlag, pbEnabled);
}
vr::EVROverlayError CVROverlay_026::GetOverlayFlags(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* pFlags) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->GetOverlayFlags(ulOverlayHandle, pFlags);
}
vr::EVROverlayError CVROverlay_026::SetOverlayColor(vr::VROverlayHandle_t ulOverlayHandle, float fRed, float fGreen, float fBlue) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->SetOverlayColor(ulOverlayHandle, fRed, fGreen, fBlue);
}
vr::EVROverlayError CVROverlay_026::GetOverlayColor(vr::VROverlayHandle_t ulOverlayHandle, float* pfRed, float* pfGreen, float* pfBlue) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->GetOverlayColor(ulOverlayHandle, pfRed, pfGreen, pfBlue);
}
vr::EVROverlayError CVROverlay_026::SetOverlayAlpha(vr::VROverlayHandle_t ulOverlayHandle, float fAlpha) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->SetOverlayAlpha(ulOverlayHandle, fAlpha);
}
vr::EVROverlayError CVROverlay_026::GetOverlayAlpha(vr::VROverlayHandle_t ulOverlayHandle, float* pfAlpha) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->GetOverlayAlpha(ulOverlayHandle, pfAlpha);
}
vr::EVROverlayError CVROverlay_026::SetOverlayTexelAspect(vr::VROverlayHandle_t ulOverlayHandle, float fTexelAspect) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->SetOverlayTexelAspect(ulOverlayHandle, fTexelAspect);
}
vr::EVROverlayError CVROverlay_026::GetOverlayTexelAspect(vr::VROverlayHandle_t ulOverlayHandle, float* pfTexelAspect) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->GetOverlayTexelAspect(ulOverlayHandle, pfTexelAspect);
}
vr::EVROverlayError CVROverlay_026::SetOverlaySortOrder(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unSortOrder) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->SetOverlaySortOrder(ulOverlayHandle, unSortOrder);
}
vr::EVROverlayError CVROverlay_026::GetOverlaySortOrder(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* punSortOrder) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->GetOverlaySortOrder(ulOverlayHandle, punSortOrder);
}
vr::EVROverlayError CVROverlay_026::SetOverlayWidthInMeters(vr::VROverlayHandle_t ulOverlayHandle, float fWidthInMeters) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->SetOverlayWidthInMeters(ulOverlayHandle, fWidthInMeters);
}
vr::EVROverlayError CVROverlay_026::GetOverlayWidthInMeters(vr::VROverlayHandle_t ulOverlayHandle, float* pfWidthInMeters) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->GetOverlayWidthInMeters(ulOverlayHandle, pfWidthInMeters);
}
vr::EVROverlayError CVROverlay_026::SetOverlayCurvature(vr::VROverlayHandle_t ulOverlayHandle, float fCurvature) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->SetOverlayCurvature(ulOverlayHandle, fCurvature);
}
vr::EVROverlayError CVROverlay_026::GetOverlayCurvature(vr::VROverlayHandle_t ulOverlayHandle, float* pfCurvature) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->GetOverlayCurvature(ulOverlayHandle, pfCurvature);
}
vr::EVROverlayError CVROverlay_026::SetOverlayPreCurvePitch(vr::VROverlayHandle_t ulOverlayHandle, float fRadians) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->SetOverlayPreCurvePitch(ulOverlayHandle, fRadians);
}
vr::EVROverlayError CVROverlay_026::GetOverlayPreCurvePitch(vr::VROverlayHandle_t ulOverlayHandle, float* pfRadians) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->GetOverlayPreCurvePitch(ulOverlayHandle, pfRadians);
}
vr::EVROverlayError CVROverlay_026::SetOverlayTextureColorSpace(vr::VROverlayHandle_t ulOverlayHandle, vr::EColorSpace eTextureColorSpace) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->SetOverlayTextureColorSpace(ulOverlayHandle, eTextureColorSpace);
}
vr::EVROverlayError CVROverlay_026::GetOverlayTextureColorSpace(vr::VROverlayHandle_t ulOverlayHandle, vr::EColorSpace* peTextureColorSpace) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->GetOverlayTextureColorSpace(ulOverlayHandle, peTextureColorSpace);
}
vr::EVROverlayError CVROverlay_026::SetOverlayTextureBounds(vr::VROverlayHandle_t ulOverlayHandle, const vr::VRTextureBounds_t* pOverlayTextureBounds) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->SetOverlayTextureBounds(ulOverlayHandle, pOverlayTextureBounds);
}
vr::EVROverlayError CVROverlay_026::GetOverlayTextureBounds(vr::VROverlayHandle_t ulOverlayHandle, vr::VRTextureBounds_t* pOverlayTextureBounds) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->GetOverlayTextureBounds(ulOverlayHandle, pOverlayTextureBounds);
}
vr::EVROverlayError CVROverlay_026::GetOverlayTransformType(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_026::VROverlayTransformType* peTransformType) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->GetOverlayTransformType(ulOverlayHandle, (OOVR_VROverlayTransformType*) peTransformType);
}
vr::EVROverlayError CVROverlay_026::SetOverlayTransformAbsolute(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin eTrackingOrigin, const vr::HmdMatrix34_t* pmatTrackingOriginToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->SetOverlayTransformAbsolute(ulOverlayHandle, eTrackingOrigin, pmatTrackingOriginToOverlayTransform);
}
vr::EVROverlayError CVROverlay_026::GetOverlayTransformAbsolute(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin* peTrackingOrigin, vr::HmdMatrix34_t* pmatTrackingOriginToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->GetOverlayTransformAbsolute(ulOverlayHandle, peTrackingOrigin, pmatTrackingOriginToOverlayTransform);
}
vr::EVROverlayError CVROverlay_026::SetOverlayTransformTrackedDeviceRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unTrackedDevice, const vr::HmdMatrix34_t* pmatTrackedDeviceToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->SetOverlayTransformTrackedDeviceRelative(ulOverlayHandle, unTrackedDevice, pmatTrackedDeviceToOverlayTransform);
}
vr::EVROverlayError CVROverlay_026::GetOverlayTransformTrackedDeviceRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t* punTrackedDevice, vr::HmdMatrix34_t* pmatTrackedDeviceToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->GetOverlayTransformTrackedDeviceRelative(ulOverlayHandle, punTrackedDevice, pmatTrackedDeviceToOverlayTransform);
}
vr::EVROverlayError CVROverlay_026::SetOverlayTransformTrackedDeviceComponent(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unDeviceIndex, const char* pchComponentName) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->SetOverlayTransformTrackedDeviceComponent(ulOverlayHandle, unDeviceIndex, pchComponentName);
}
vr::EVROverlayError CVROverlay_026::GetOverlayTransformTrackedDeviceComponent(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t* punDeviceIndex, char* pchComponentName, uint32_t unComponentNameSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->GetOverlayTransformTrackedDeviceComponent(ulOverlayHandle, punDeviceIndex, pchComponentName, unComponentNameSize);
}
vr::EVROverlayError CVROverlay_026::GetOverlayTransformOverlayRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::VROverlayHandle_t* ulOverlayHandleParent, vr::HmdMatrix34_t* pmatParentOverlayToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->GetOverlayTransformOverlayRelative(ulOverlayHandle, ulOverlayHandleParent, pmatParentOverlayToOverlayTransform);
}
vr::EVROverlayError CVROverlay_026::SetOverlayTransformOverlayRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::VROverlayHandle_t ulOverlayHandleParent, const vr::HmdMatrix34_t* pmatParentOverlayToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->SetOverlayTransformOverlayRelative(ulOverlayHandle, ulOverlayHandleParent, pmatParentOverlayToOverlayTransform);
}
vr::EVROverlayError CVROverlay_026::SetOverlayTransformCursor(vr::VROverlayHandle_t ulCursorOverlayHandle, const vr::HmdVector2_t* pvHotspot) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->SetOverlayTransformCursor(ulCursorOverlayHandle, pvHotspot);
}
vr::EVROverlayError CVROverlay_026::GetOverlayTransformCursor(vr::VROverlayHandle_t ulOverlayHandle, vr::HmdVector2_t* pvHotspot) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->GetOverlayTransformCursor(ulOverlayHandle, pvHotspot);
}
vr::EVROverlayError CVROverlay_026::SetOverlayTransformProjection(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin eTrackingOrigin, const vr::HmdMatrix34_t* pmatTrackingOriginToOverlayTransform, const vr::IVROverlay_026::VROverlayProjection_t* pProjection, vr::EVREye eEye) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->SetOverlayTransformProjection(ulOverlayHandle, eTrackingOrigin, pmatTrackingOriginToOverlayTransform, (const OOVR_VROverlayProjection_t*) pProjection, eEye);
}
vr::EVROverlayError CVROverlay_026::ShowOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->ShowOverlay(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_026::HideOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->HideOverlay(ulOverlayHandle);
}
bool CVROverlay_026::IsOverlayVisible(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->IsOverlayVisible(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_026::GetTransformForOverlayCoordinates(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin eTrackingOrigin, vr::HmdVector2_t coordinatesInOverlay, vr::HmdMatrix34_t* pmatTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->GetTransformForOverlayCoordinates(ulOverlayHandle, eTrackingOrigin, coordinatesInOverlay, pmatTransform);
}
vr::EVROverlayError CVROverlay_026::WaitFrameSync(uint32_t nTimeoutMs) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->WaitFrameSync(nTimeoutMs);
}
bool CVROverlay_026::PollNextOverlayEvent(vr::VROverlayHandle_t ulOverlayHandle, vr::VREvent_t* pEvent, uint32_t uncbVREvent) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->PollNextOverlayEvent(ulOverlayHandle, pEvent, uncbVREvent);
}
vr::EVROverlayError CVROverlay_026::GetOverlayInputMethod(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_026::VROverlayInputMethod* peInputMethod) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->GetOverlayInputMethod(ulOverlayHandle, (OOVR_VROverlayInputMethod*) peInputMethod);
}
vr::EVROverlayError CVROverlay_026::SetOverlayInputMethod(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_026::VROverlayInputMethod eInputMethod) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->SetOverlayInputMethod(ulOverlayHandle, (OOVR_VROverlayInputMethod) eInputMethod);
}
vr::EVROverlayError CVROverlay_026::GetOverlayMouseScale(vr::VROverlayHandle_t ulOverlayHandle, vr::HmdVector2_t* pvecMouseScale) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->GetOverlayMouseScale(ulOverlayHandle, pvecMouseScale);
}
vr::EVROverlayError CVROverlay_026::SetOverlayMouseScale(vr::VROverlayHandle_t ulOverlayHandle, const vr::HmdVector2_t* pvecMouseScale) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->SetOverlayMouseScale(ulOverlayHandle, pvecMouseScale);
}
bool CVROverlay_026::ComputeOverlayIntersection(vr::VROverlayHandle_t ulOverlayHandle, const vr::IVROverlay_026::VROverlayIntersectionParams_t* pParams, vr::IVROverlay_026::VROverlayIntersectionResults_t* pResults) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->ComputeOverlayIntersection(ulOverlayHandle, (const OOVR_VROverlayIntersectionParams_t*) pParams, (OOVR_VROverlayIntersectionResults_t*) pResults);
}
bool CVROverlay_026::IsHoverTargetOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->IsHoverTargetOverlay(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_026::SetOverlayIntersectionMask(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_026::VROverlayIntersectionMaskPrimitive_t* pMaskPrimitives, uint32_t unNumMaskPrimitives, uint32_t unPrimitiveSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->SetOverlayIntersectionMask(ulOverlayHandle, (OOVR_VROverlayIntersectionMaskPrimitive_t*) pMaskPrimitives, unNumMaskPrimitives, unPrimitiveSize);
}
vr::EVROverlayError CVROverlay_026::TriggerLaserMouseHapticVibration(vr::VROverlayHandle_t ulOverlayHandle, float fDurationSeconds, float fFrequency, float fAmplitude) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->TriggerLaserMouseHapticVibration(ulOverlayHandle, fDurationSeconds, fFrequency, fAmplitude);
}
vr::EVROverlayError CVROverlay_026::SetOverlayCursor(vr::VROverlayHandle_t ulOverlayHandle, vr::VROverlayHandle_t ulCursorHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->SetOverlayCursor(ulOverlayHandle, ulCursorHandle);
}
vr::EVROverlayError CVROverlay_026::SetOverlayCursorPositionOverride(vr::VROverlayHandle_t ulOverlayHandle, const vr::HmdVector2_t* pvCursor) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->SetOverlayCursorPositionOverride(ulOverlayHandle, pvCursor);
}
vr::EVROverlayError CVROverlay_026::ClearOverlayCursorPositionOverride(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->ClearOverlayCursorPositionOverride(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_026::SetOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle, const vr::Texture_t* pTexture) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->SetOverlayTexture(ulOverlayHandle, pTexture);
}
vr::EVROverlayError CVROverlay_026::ClearOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->ClearOverlayTexture(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_026::SetOverlayRaw(vr::VROverlayHandle_t ulOverlayHandle, void* pvBuffer, uint32_t unWidth, uint32_t unHeight, uint32_t unBytesPerPixel) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->SetOverlayRaw(ulOverlayHandle, pvBuffer, unWidth, unHeight, unBytesPerPixel);
}
vr::EVROverlayError CVROverlay_026::SetOverlayFromFile(vr::VROverlayHandle_t ulOverlayHandle, const char* pchFilePath) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->SetOverlayFromFile(ulOverlayHandle, pchFilePath);
}
vr::EVROverlayError CVROverlay_026::GetOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle, void** pNativeTextureHandle, void* pNativeTextureRef, uint32_t* pWidth, uint32_t* pHeight, uint32_t* pNativeFormat, vr::ETextureType* pAPIType, vr::EColorSpace* pColorSpace, vr::VRTextureBounds_t* pTextureBounds) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->GetOverlayTexture(ulOverlayHandle, pNativeTextureHandle, pNativeTextureRef, pWidth, pHeight, pNativeFormat, pAPIType, pColorSpace, pTextureBounds);
}
vr::EVROverlayError CVROverlay_026::ReleaseNativeOverlayHandle(vr::VROverlayHandle_t ulOverlayHandle, void* pNativeTextureHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->ReleaseNativeOverlayHandle(ulOverlayHandle, pNativeTextureHandle);
}
vr::EVROverlayError CVROverlay_026::GetOverlayTextureSize(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* pWidth, uint32_t* pHeight) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->GetOverlayTextureSize(ulOverlayHandle, pWidth, pHeight);
}
vr::EVROverlayError CVROverlay_026::CreateDashboardOverlay(const char* pchOverlayKey, const char* pchOverlayFriendlyName, vr::VROverlayHandle_t* pMainHandle, vr::VROverlayHandle_t* pThumbnailHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->CreateDashboardOverlay(pchOverlayKey, pchOverlayFriendlyName, pMainHandle, pThumbnailHandle);
}
bool CVROverlay_026::IsDashboardVisible() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->IsDashboardVisible();
}
bool CVROverlay_026::IsActiveDashboardOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->IsActiveDashboardOverlay(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_026::SetDashboardOverlaySceneProcess(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unProcessId) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->SetDashboardOverlaySceneProcess(ulOverlayHandle, unProcessId);
}
vr::EVROverlayError CVROverlay_026::GetDashboardOverlaySceneProcess(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* punProcessId) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->GetDashboardOverlaySceneProcess(ulOverlayHandle, punProcessId);
}
void CVROverlay_026::ShowDashboard(const char* pchOverlayToShow) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->ShowDashboard(pchOverlayToShow);
}
vr::TrackedDeviceIndex_t CVROverlay_026::GetPrimaryDashboardDevice() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->GetPrimaryDashboardDevice();
}
vr::EVROverlayError CVROverlay_026::ShowKeyboard(vr::IVROverlay_026::EGamepadTextInputMode eInputMode, vr::IVROverlay_026::EGamepadTextInputLineMode eLineInputMode, uint32_t unFlags, const char* pchDescription, uint32_t unCharMax, const char* pchExistingText, uint64_t uUserValue) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->ShowKeyboard((OOVR_EGamepadTextInputMode) eInputMode, (OOVR_EGamepadTextInputLineMode) eLineInputMode, unFlags, pchDescription, unCharMax, pchExistingText, uUserValue);
}
vr::EVROverlayError CVROverlay_026::ShowKeyboardForOverlay(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_026::EGamepadTextInputMode eInputMode, vr::IVROverlay_026::EGamepadTextInputLineMode eLineInputMode, uint32_t unFlags, const char* pchDescription, uint32_t unCharMax, const char* pchExistingText, uint64_t uUserValue) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->ShowKeyboardForOverlay(ulOverlayHandle, (OOVR_EGamepadTextInputMode) eInputMode, (OOVR_EGamepadTextInputLineMode) eLineInputMode, unFlags, pchDescription, unCharMax, pchExistingText, uUserValue);
}
uint32_t CVROverlay_026::GetKeyboardText(char* pchText, uint32_t cchText) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->GetKeyboardText(pchText, cchText);
}
void CVROverlay_026::HideKeyboard() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->HideKeyboard();
}
void CVROverlay_026::SetKeyboardTransformAbsolute(vr::ETrackingUniverseOrigin eTrackingOrigin, const vr::HmdMatrix34_t* pmatTrackingOriginToKeyboardTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->SetKeyboardTransformAbsolute(eTrackingOrigin, pmatTrackingOriginToKeyboardTransform);
}
void CVROverlay_026::SetKeyboardPositionForOverlay(vr::VROverlayHandle_t ulOverlayHandle, vr::HmdRect2_t avoidRect) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->SetKeyboardPositionForOverlay(ulOverlayHandle, avoidRect);
}
vr::IVROverlay_026::VRMessageOverlayResponse CVROverlay_026::ShowMessageOverlay(const char* pchText, const char* pchCaption, const char* pchButton0Text, const char* pchButton1Text, const char* pchButton2Text, const char* pchButton3Text) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return (vr::IVROverlay_026::VRMessageOverlayResponse) base->ShowMessageOverlay(pchText, pchCaption, pchButton0Text, pchButton1Text, pchButton2Text, pchButton3Text);
}
void CVROverlay_026::CloseMessageOverlay() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_026)");
	return base->CloseMessageOverlay();
}
// FnTable for CVROverlay_026:
static CVROverlay_026 *fntable_Overlay_026_instance = NULL;
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_FindOverlay(const char* pchOverlayKey, vr::VROverlayHandle_t* pOverlayHandle) { return fntable_Overlay_026_instance->FindOverlay(pchOverlayKey, pOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_CreateOverlay(const char* pchOverlayKey, const char* pchOverlayName, vr::VROverlayHandle_t* pOverlayHandle) { return fntable_Overlay_026_instance->CreateOverlay(pchOverlayKey, pchOverlayName, pOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_DestroyOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_026_instance->DestroyOverlay(ulOverlayHandle); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_GetOverlayKey(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::EVROverlayError* pError) { return fntable_Overlay_026_instance->GetOverlayKey(ulOverlayHandle, pchValue, unBufferSize, pError); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_GetOverlayName(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::EVROverlayError* pError) { return fntable_Overlay_026_instance->GetOverlayName(ulOverlayHandle, pchValue, unBufferSize, pError); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_SetOverlayName(vr::VROverlayHandle_t ulOverlayHandle, const char* pchName) { return fntable_Overlay_026_instance->SetOverlayName(ulOverlayHandle, pchName); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_GetOverlayImageData(vr::VROverlayHandle_t ulOverlayHandle, void* pvBuffer, uint32_t unBufferSize, uint32_t* punWidth, uint32_t* punHeight) { return fntable_Overlay_026_instance->GetOverlayImageData(ulOverlayHandle, pvBuffer, unBufferSize, punWidth, punHeight); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_GetOverlayErrorNameFromEnum(vr::EVROverlayError error) { return fntable_Overlay_026_instance->GetOverlayErrorNameFromEnum(error); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_SetOverlayRenderingPid(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unPID) { return fntable_Overlay_026_instance->SetOverlayRenderingPid(ulOverlayHandle, unPID); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_GetOverlayRenderingPid(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_026_instance->GetOverlayRenderingPid(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_SetOverlayFlag(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_026::VROverlayFlags eOverlayFlag, bool bEnabled) { return fntable_Overlay_026_instance->SetOverlayFlag(ulOverlayHandle, eOverlayFlag, bEnabled); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_GetOverlayFlag(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_026::VROverlayFlags eOverlayFlag, bool* pbEnabled) { return fntable_Overlay_026_instance->GetOverlayFlag(ulOverlayHandle, eOverlayFlag, pbEnabled); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_GetOverlayFlags(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* pFlags) { return fntable_Overlay_026_instance->GetOverlayFlags(ulOverlayHandle, pFlags); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_SetOverlayColor(vr::VROverlayHandle_t ulOverlayHandle, float fRed, float fGreen, float fBlue) { return fntable_Overlay_026_instance->SetOverlayColor(ulOverlayHandle, fRed, fGreen, fBlue); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_GetOverlayColor(vr::VROverlayHandle_t ulOverlayHandle, float* pfRed, float* pfGreen, float* pfBlue) { return fntable_Overlay_026_instance->GetOverlayColor(ulOverlayHandle, pfRed, pfGreen, pfBlue); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_SetOverlayAlpha(vr::VROverlayHandle_t ulOverlayHandle, float fAlpha) { return fntable_Overlay_026_instance->SetOverlayAlpha(ulOverlayHandle, fAlpha); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_GetOverlayAlpha(vr::VROverlayHandle_t ulOverlayHandle, float* pfAlpha) { return fntable_Overlay_026_instance->GetOverlayAlpha(ulOverlayHandle, pfAlpha); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_SetOverlayTexelAspect(vr::VROverlayHandle_t ulOverlayHandle, float fTexelAspect) { return fntable_Overlay_026_instance->SetOverlayTexelAspect(ulOverlayHandle, fTexelAspect); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_GetOverlayTexelAspect(vr::VROverlayHandle_t ulOverlayHandle, float* pfTexelAspect) { return fntable_Overlay_026_instance->GetOverlayTexelAspect(ulOverlayHandle, pfTexelAspect); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_SetOverlaySortOrder(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unSortOrder) { return fntable_Overlay_026_instance->SetOverlaySortOrder(ulOverlayHandle, unSortOrder); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_GetOverlaySortOrder(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* punSortOrder) { return fntable_Overlay_026_instance->GetOverlaySortOrder(ulOverlayHandle, punSortOrder); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_SetOverlayWidthInMeters(vr::VROverlayHandle_t ulOverlayHandle, float fWidthInMeters) { return fntable_Overlay_026_instance->SetOverlayWidthInMeters(ulOverlayHandle, fWidthInMeters); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_GetOverlayWidthInMeters(vr::VROverlayHandle_t ulOverlayHandle, float* pfWidthInMeters) { return fntable_Overlay_026_instance->GetOverlayWidthInMeters(ulOverlayHandle, pfWidthInMeters); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_SetOverlayCurvature(vr::VROverlayHandle_t ulOverlayHandle, float fCurvature) { return fntable_Overlay_026_instance->SetOverlayCurvature(ulOverlayHandle, fCurvature); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_GetOverlayCurvature(vr::VROverlayHandle_t ulOverlayHandle, float* pfCurvature) { return fntable_Overlay_026_instance->GetOverlayCurvature(ulOverlayHandle, pfCurvature); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_SetOverlayPreCurvePitch(vr::VROverlayHandle_t ulOverlayHandle, float fRadians) { return fntable_Overlay_026_instance->SetOverlayPreCurvePitch(ulOverlayHandle, fRadians); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_GetOverlayPreCurvePitch(vr::VROverlayHandle_t ulOverlayHandle, float* pfRadians) { return fntable_Overlay_026_instance->GetOverlayPreCurvePitch(ulOverlayHandle, pfRadians); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_SetOverlayTextureColorSpace(vr::VROverlayHandle_t ulOverlayHandle, vr::EColorSpace eTextureColorSpace) { return fntable_Overlay_026_instance->SetOverlayTextureColorSpace(ulOverlayHandle, eTextureColorSpace); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_GetOverlayTextureColorSpace(vr::VROverlayHandle_t ulOverlayHandle, vr::EColorSpace* peTextureColorSpace) { return fntable_Overlay_026_instance->GetOverlayTextureColorSpace(ulOverlayHandle, peTextureColorSpace); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_SetOverlayTextureBounds(vr::VROverlayHandle_t ulOverlayHandle, const vr::VRTextureBounds_t* pOverlayTextureBounds) { return fntable_Overlay_026_instance->SetOverlayTextureBounds(ulOverlayHandle, pOverlayTextureBounds); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_GetOverlayTextureBounds(vr::VROverlayHandle_t ulOverlayHandle, vr::VRTextureBounds_t* pOverlayTextureBounds) { return fntable_Overlay_026_instance->GetOverlayTextureBounds(ulOverlayHandle, pOverlayTextureBounds); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_GetOverlayTransformType(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_026::VROverlayTransformType* peTransformType) { return fntable_Overlay_026_instance->GetOverlayTransformType(ulOverlayHandle, peTransformType); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_SetOverlayTransformAbsolute(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin eTrackingOrigin, const vr::HmdMatrix34_t* pmatTrackingOriginToOverlayTransform) { return fntable_Overlay_026_instance->SetOverlayTransformAbsolute(ulOverlayHandle, eTrackingOrigin, pmatTrackingOriginToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_GetOverlayTransformAbsolute(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin* peTrackingOrigin, vr::HmdMatrix34_t* pmatTrackingOriginToOverlayTransform) { return fntable_Overlay_026_instance->GetOverlayTransformAbsolute(ulOverlayHandle, peTrackingOrigin, pmatTrackingOriginToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_SetOverlayTransformTrackedDeviceRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unTrackedDevice, const vr::HmdMatrix34_t* pmatTrackedDeviceToOverlayTransform) { return fntable_Overlay_026_instance->SetOverlayTransformTrackedDeviceRelative(ulOverlayHandle, unTrackedDevice, pmatTrackedDeviceToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_GetOverlayTransformTrackedDeviceRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t* punTrackedDevice, vr::HmdMatrix34_t* pmatTrackedDeviceToOverlayTransform) { return fntable_Overlay_026_instance->GetOverlayTransformTrackedDeviceRelative(ulOverlayHandle, punTrackedDevice, pmatTrackedDeviceToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_SetOverlayTransformTrackedDeviceComponent(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unDeviceIndex, const char* pchComponentName) { return fntable_Overlay_026_instance->SetOverlayTransformTrackedDeviceComponent(ulOverlayHandle, unDeviceIndex, pchComponentName); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_GetOverlayTransformTrackedDeviceComponent(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t* punDeviceIndex, char* pchComponentName, uint32_t unComponentNameSize) { return fntable_Overlay_026_instance->GetOverlayTransformTrackedDeviceComponent(ulOverlayHandle, punDeviceIndex, pchComponentName, unComponentNameSize); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_GetOverlayTransformOverlayRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::VROverlayHandle_t* ulOverlayHandleParent, vr::HmdMatrix34_t* pmatParentOverlayToOverlayTransform) { return fntable_Overlay_026_instance->GetOverlayTransformOverlayRelative(ulOverlayHandle, ulOverlayHandleParent, pmatParentOverlayToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_SetOverlayTransformOverlayRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::VROverlayHandle_t ulOverlayHandleParent, const vr::HmdMatrix34_t* pmatParentOverlayToOverlayTransform) { return fntable_Overlay_026_instance->SetOverlayTransformOverlayRelative(ulOverlayHandle, ulOverlayHandleParent, pmatParentOverlayToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_SetOverlayTransformCursor(vr::VROverlayHandle_t ulCursorOverlayHandle, const vr::HmdVector2_t* pvHotspot) { return fntable_Overlay_026_instance->SetOverlayTransformCursor(ulCursorOverlayHandle, pvHotspot); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_GetOverlayTransformCursor(vr::VROverlayHandle_t ulOverlayHandle, vr::HmdVector2_t* pvHotspot) { return fntable_Overlay_026_instance->GetOverlayTransformCursor(ulOverlayHandle, pvHotspot); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_SetOverlayTransformProjection(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin eTrackingOrigin, const vr::HmdMatrix34_t* pmatTrackingOriginToOverlayTransform, const vr::IVROverlay_026::VROverlayProjection_t* pProjection, vr::EVREye eEye) { return fntable_Overlay_026_instance->SetOverlayTransformProjection(ulOverlayHandle, eTrackingOrigin, pmatTrackingOriginToOverlayTransform, pProjection, eEye); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_ShowOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_026_instance->ShowOverlay(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_HideOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_026_instance->HideOverlay(ulOverlayHandle); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_IsOverlayVisible(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_026_instance->IsOverlayVisible(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_GetTransformForOverlayCoordinates(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin eTrackingOrigin, vr::HmdVector2_t coordinatesInOverlay, vr::HmdMatrix34_t* pmatTransform) { return fntable_Overlay_026_instance->GetTransformForOverlayCoordinates(ulOverlayHandle, eTrackingOrigin, coordinatesInOverlay, pmatTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_WaitFrameSync(uint32_t nTimeoutMs) { return fntable_Overlay_026_instance->WaitFrameSync(nTimeoutMs); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_PollNextOverlayEvent(vr::VROverlayHandle_t ulOverlayHandle, vr::VREvent_t* pEvent, uint32_t uncbVREvent) { return fntable_Overlay_026_instance->PollNextOverlayEvent(ulOverlayHandle, pEvent, uncbVREvent); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_GetOverlayInputMethod(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_026::VROverlayInputMethod* peInputMethod) { return fntable_Overlay_026_instance->GetOverlayInputMethod(ulOverlayHandle, peInputMethod); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_SetOverlayInputMethod(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_026::VROverlayInputMethod eInputMethod) { return fntable_Overlay_026_instance->SetOverlayInputMethod(ulOverlayHandle, eInputMethod); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_GetOverlayMouseScale(vr::VROverlayHandle_t ulOverlayHandle, vr::HmdVector2_t* pvecMouseScale) { return fntable_Overlay_026_instance->GetOverlayMouseScale(ulOverlayHandle, pvecMouseScale); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_SetOverlayMouseScale(vr::VROverlayHandle_t ulOverlayHandle, const vr::HmdVector2_t* pvecMouseScale) { return fntable_Overlay_026_instance->SetOverlayMouseScale(ulOverlayHandle, pvecMouseScale); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_ComputeOverlayIntersection(vr::VROverlayHandle_t ulOverlayHandle, const vr::IVROverlay_026::VROverlayIntersectionParams_t* pParams, vr::IVROverlay_026::VROverlayIntersectionResults_t* pResults) { return fntable_Overlay_026_instance->ComputeOverlayIntersection(ulOverlayHandle, pParams, pResults); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_IsHoverTargetOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_026_instance->IsHoverTargetOverlay(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_SetOverlayIntersectionMask(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_026::VROverlayIntersectionMaskPrimitive_t* pMaskPrimitives, uint32_t unNumMaskPrimitives, uint32_t unPrimitiveSize) { return fntable_Overlay_026_instance->SetOverlayIntersectionMask(ulOverlayHandle, pMaskPrimitives, unNumMaskPrimitives, unPrimitiveSize); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_TriggerLaserMouseHapticVibration(vr::VROverlayHandle_t ulOverlayHandle, float fDurationSeconds, float fFrequency, float fAmplitude) { return fntable_Overlay_026_instance->TriggerLaserMouseHapticVibration(ulOverlayHandle, fDurationSeconds, fFrequency, fAmplitude); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_SetOverlayCursor(vr::VROverlayHandle_t ulOverlayHandle, vr::VROverlayHandle_t ulCursorHandle) { return fntable_Overlay_026_instance->SetOverlayCursor(ulOverlayHandle, ulCursorHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_SetOverlayCursorPositionOverride(vr::VROverlayHandle_t ulOverlayHandle, const vr::HmdVector2_t* pvCursor) { return fntable_Overlay_026_instance->SetOverlayCursorPositionOverride(ulOverlayHandle, pvCursor); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_ClearOverlayCursorPositionOverride(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_026_instance->ClearOverlayCursorPositionOverride(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_SetOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle, const vr::Texture_t* pTexture) { return fntable_Overlay_026_instance->SetOverlayTexture(ulOverlayHandle, pTexture); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_ClearOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_026_instance->ClearOverlayTexture(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_SetOverlayRaw(vr::VROverlayHandle_t ulOverlayHandle, void* pvBuffer, uint32_t unWidth, uint32_t unHeight, uint32_t unBytesPerPixel) { return fntable_Overlay_026_instance->SetOverlayRaw(ulOverlayHandle, pvBuffer, unWidth, unHeight, unBytesPerPixel); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_SetOverlayFromFile(vr::VROverlayHandle_t ulOverlayHandle, const char* pchFilePath) { return fntable_Overlay_026_instance->SetOverlayFromFile(ulOverlayHandle, pchFilePath); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_GetOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle, void** pNativeTextureHandle, void* pNativeTextureRef, uint32_t* pWidth, uint32_t* pHeight, uint32_t* pNativeFormat, vr::ETextureType* pAPIType, vr::EColorSpace* pColorSpace, vr::VRTextureBounds_t* pTextureBounds) { return fntable_Overlay_026_instance->GetOverlayTexture(ulOverlayHandle, pNativeTextureHandle, pNativeTextureRef, pWidth, pHeight, pNativeFormat, pAPIType, pColorSpace, pTextureBounds); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_ReleaseNativeOverlayHandle(vr::VROverlayHandle_t ulOverlayHandle, void* pNativeTextureHandle) { return fntable_Overlay_026_instance->ReleaseNativeOverlayHandle(ulOverlayHandle, pNativeTextureHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_GetOverlayTextureSize(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* pWidth, uint32_t* pHeight) { return fntable_Overlay_026_instance->GetOverlayTextureSize(ulOverlayHandle, pWidth, pHeight); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_CreateDashboardOverlay(const char* pchOverlayKey, const char* pchOverlayFriendlyName, vr::VROverlayHandle_t* pMainHandle, vr::VROverlayHandle_t* pThumbnailHandle) { return fntable_Overlay_026_instance->CreateDashboardOverlay(pchOverlayKey, pchOverlayFriendlyName, pMainHandle, pThumbnailHandle); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_IsDashboardVisible() { return fntable_Overlay_026_instance->IsDashboardVisible(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_IsActiveDashboardOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_026_instance->IsActiveDashboardOverlay(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_SetDashboardOverlaySceneProcess(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unProcessId) { return fntable_Overlay_026_instance->SetDashboardOverlaySceneProcess(ulOverlayHandle, unProcessId); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_GetDashboardOverlaySceneProcess(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* punProcessId) { return fntable_Overlay_026_instance->GetDashboardOverlaySceneProcess(ulOverlayHandle, punProcessId); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_ShowDashboard(const char* pchOverlayToShow) { return fntable_Overlay_026_instance->ShowDashboard(pchOverlayToShow); }
static vr::TrackedDeviceIndex_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_GetPrimaryDashboardDevice() { return fntable_Overlay_026_instance->GetPrimaryDashboardDevice(); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_ShowKeyboard(vr::IVROverlay_026::EGamepadTextInputMode eInputMode, vr::IVROverlay_026::EGamepadTextInputLineMode eLineInputMode, uint32_t unFlags, const char* pchDescription, uint32_t unCharMax, const char* pchExistingText, uint64_t uUserValue) { return fntable_Overlay_026_instance->ShowKeyboard(eInputMode, eLineInputMode, unFlags, pchDescription, unCharMax, pchExistingText, uUserValue); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_ShowKeyboardForOverlay(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_026::EGamepadTextInputMode eInputMode, vr::IVROverlay_026::EGamepadTextInputLineMode eLineInputMode, uint32_t unFlags, const char* pchDescription, uint32_t unCharMax, const char* pchExistingText, uint64_t uUserValue) { return fntable_Overlay_026_instance->ShowKeyboardForOverlay(ulOverlayHandle, eInputMode, eLineInputMode, unFlags, pchDescription, unCharMax, pchExistingText, uUserValue); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_GetKeyboardText(char* pchText, uint32_t cchText) { return fntable_Overlay_026_instance->GetKeyboardText(pchText, cchText); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_HideKeyboard() { return fntable_Overlay_026_instance->HideKeyboard(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_SetKeyboardTransformAbsolute(vr::ETrackingUniverseOrigin eTrackingOrigin, const vr::HmdMatrix34_t* pmatTrackingOriginToKeyboardTransform) { return fntable_Overlay_026_instance->SetKeyboardTransformAbsolute(eTrackingOrigin, pmatTrackingOriginToKeyboardTransform); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_SetKeyboardPositionForOverlay(vr::VROverlayHandle_t ulOverlayHandle, vr::HmdRect2_t avoidRect) { return fntable_Overlay_026_instance->SetKeyboardPositionForOverlay(ulOverlayHandle, avoidRect); }
static vr::IVROverlay_026::VRMessageOverlayResponse OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_ShowMessageOverlay(const char* pchText, const char* pchCaption, const char* pchButton0Text, const char* pchButton1Text, const char* pchButton2Text, const char* pchButton3Text) { return fntable_Overlay_026_instance->ShowMessageOverlay(pchText, pchCaption, pchButton0Text, pchButton1Text, pchButton2Text, pchButton3Text); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_026_impl_CloseMessageOverlay() { return fntable_Overlay_026_instance->CloseMessageOverlay(); }
static void *fntable_Overlay_026_funcs[] = {
	(void*) fntable_Overlay_026_impl_FindOverlay,
	(void*) fntable_Overlay_026_impl_CreateOverlay,
	(void*) fntable_Overlay_026_impl_DestroyOverlay,
	(void*) fntable_Overlay_026_impl_GetOverlayKey,
	(void*) fntable_Overlay_026_impl_GetOverlayName,
	(void*) fntable_Overlay_026_impl_SetOverlayName,
	(void*) fntable_Overlay_026_impl_GetOverlayImageData,
	(void*) fntable_Overlay_026_impl_GetOverlayErrorNameFromEnum,
	(void*) fntable_Overlay_026_impl_SetOverlayRenderingPid,
	(void*) fntable_Overlay_026_impl_GetOverlayRenderingPid,
	(void*) fntable_Overlay_026_impl_SetOverlayFlag,
	(void*) fntable_Overlay_026_impl_GetOverlayFlag,
	(void*) fntable_Overlay_026_impl_GetOverlayFlags,
	(void*) fntable_Overlay_026_impl_SetOverlayColor,
	(void*) fntable_Overlay_026_impl_GetOverlayColor,
	(void*) fntable_Overlay_026_impl_SetOverlayAlpha,
	(void*) fntable_Overlay_026_impl_GetOverlayAlpha,
	(void*) fntable_Overlay_026_impl_SetOverlayTexelAspect,
	(void*) fntable_Overlay_026_impl_GetOverlayTexelAspect,
	(void*) fntable_Overlay_026_impl_SetOverlaySortOrder,
	(void*) fntable_Overlay_026_impl_GetOverlaySortOrder,
	(void*) fntable_Overlay_026_impl_SetOverlayWidthInMeters,
	(void*) fntable_Overlay_026_impl_GetOverlayWidthInMeters,
	(void*) fntable_Overlay_026_impl_SetOverlayCurvature,
	(void*) fntable_Overlay_026_impl_GetOverlayCurvature,
	(void*) fntable_Overlay_026_impl_SetOverlayPreCurvePitch,
	(void*) fntable_Overlay_026_impl_GetOverlayPreCurvePitch,
	(void*) fntable_Overlay_026_impl_SetOverlayTextureColorSpace,
	(void*) fntable_Overlay_026_impl_GetOverlayTextureColorSpace,
	(void*) fntable_Overlay_026_impl_SetOverlayTextureBounds,
	(void*) fntable_Overlay_026_impl_GetOverlayTextureBounds,
	(void*) fntable_Overlay_026_impl_GetOverlayTransformType,
	(void*) fntable_Overlay_026_impl_SetOverlayTransformAbsolute,
	(void*) fntable_Overlay_026_impl_GetOverlayTransformAbsolute,
	(void*) fntable_Overlay_026_impl_SetOverlayTransformTrackedDeviceRelative,
	(void*) fntable_Overlay_026_impl_GetOverlayTransformTrackedDeviceRelative,
	(void*) fntable_Overlay_026_impl_SetOverlayTransformTrackedDeviceComponent,
	(void*) fntable_Overlay_026_impl_GetOverlayTransformTrackedDeviceComponent,
	(void*) fntable_Overlay_026_impl_GetOverlayTransformOverlayRelative,
	(void*) fntable_Overlay_026_impl_SetOverlayTransformOverlayRelative,
	(void*) fntable_Overlay_026_impl_SetOverlayTransformCursor,
	(void*) fntable_Overlay_026_impl_GetOverlayTransformCursor,
	(void*) fntable_Overlay_026_impl_SetOverlayTransformProjection,
	(void*) fntable_Overlay_026_impl_ShowOverlay,
	(void*) fntable_Overlay_026_impl_HideOverlay,
	(void*) fntable_Overlay_026_impl_IsOverlayVisible,
	(void*) fntable_Overlay_026_impl_GetTransformForOverlayCoordinates,
	(void*) fntable_Overlay_026_impl_WaitFrameSync,
	(void*) fntable_Overlay_026_impl_PollNextOverlayEvent,
	(void*) fntable_Overlay_026_impl_GetOverlayInputMethod,
	(void*) fntable_Overlay_026_impl_SetOverlayInputMethod,
	(void*) fntable_Overlay_026_impl_GetOverlayMouseScale,
	(void*) fntable_Overlay_026_impl_SetOverlayMouseScale,
	(void*) fntable_Overlay_026_impl_ComputeOverlayIntersection,
	(void*) fntable_Overlay_026_impl_IsHoverTargetOverlay,
	(void*) fntable_Overlay_026_impl_SetOverlayIntersectionMask,
	(void*) fntable_Overlay_026_impl_TriggerLaserMouseHapticVibration,
	(void*) fntable_Overlay_026_impl_SetOverlayCursor,
	(void*) fntable_Overlay_026_impl_SetOverlayCursorPositionOverride,
	(void*) fntable_Overlay_026_impl_ClearOverlayCursorPositionOverride,
	(void*) fntable_Overlay_026_impl_SetOverlayTexture,
	(void*) fntable_Overlay_026_impl_ClearOverlayTexture,
	(void*) fntable_Overlay_026_impl_SetOverlayRaw,
	(void*) fntable_Overlay_026_impl_SetOverlayFromFile,
	(void*) fntable_Overlay_026_impl_GetOverlayTexture,
	(void*) fntable_Overlay_026_impl_ReleaseNativeOverlayHandle,
	(void*) fntable_Overlay_026_impl_GetOverlayTextureSize,
	(void*) fntable_Overlay_026_impl_CreateDashboardOverlay,
	(void*) fntable_Overlay_026_impl_IsDashboardVisible,
	(void*) fntable_Overlay_026_impl_IsActiveDashboardOverlay,
	(void*) fntable_Overlay_026_impl_SetDashboardOverlaySceneProcess,
	(void*) fntable_Overlay_026_impl_GetDashboardOverlaySceneProcess,
	(void*) fntable_Overlay_026_impl_ShowDashboard,
	(void*) fntable_Overlay_026_impl_GetPrimaryDashboardDevice,
	(void*) fntable_Overlay_026_impl_ShowKeyboard,
	(void*) fntable_Overlay_026_impl_ShowKeyboardForOverlay,
	(void*) fntable_Overlay_026_impl_GetKeyboardText,
	(void*) fntable_Overlay_026_impl_HideKeyboard,
	(void*) fntable_Overlay_026_impl_SetKeyboardTransformAbsolute,
	(void*) fntable_Overlay_026_impl_SetKeyboardPositionForOverlay,
	(void*) fntable_Overlay_026_impl_ShowMessageOverlay,
	(void*) fntable_Overlay_026_impl_CloseMessageOverlay,
};
void** CVROverlay_026::_GetStatFuncList() { fntable_Overlay_026_instance = this; return fntable_Overlay_026_funcs; }
void CVROverlay_026::Delete() { delete this; }
// Misc for CVROverlay_027:
CVROverlay_027::CVROverlay_027() : base(GetCreateBaseOverlay()) {}
// Interface methods for CVROverlay_027:
vr::EVROverlayError CVROverlay_027::FindOverlay(const char* pchOverlayKey, vr::VROverlayHandle_t* pOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->FindOverlay(pchOverlayKey, pOverlayHandle);
}
vr::EVROverlayError CVROverlay_027::CreateOverlay(const char* pchOverlayKey, const char* pchOverlayName, vr::VROverlayHandle_t* pOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->CreateOverlay(pchOverlayKey, pchOverlayName, pOverlayHandle);
}
vr::EVROverlayError CVROverlay_027::DestroyOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->DestroyOverlay(ulOverlayHandle);
}
uint32_t CVROverlay_027::GetOverlayKey(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::EVROverlayError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->GetOverlayKey(ulOverlayHandle, pchValue, unBufferSize, pError);
}
uint32_t CVROverlay_027::GetOverlayName(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::EVROverlayError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->GetOverlayName(ulOverlayHandle, pchValue, unBufferSize, pError);
}
vr::EVROverlayError CVROverlay_027::SetOverlayName(vr::VROverlayHandle_t ulOverlayHandle, const char* pchName) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->SetOverlayName(ulOverlayHandle, pchName);
}
vr::EVROverlayError CVROverlay_027::GetOverlayImageData(vr::VROverlayHandle_t ulOverlayHandle, void* pvBuffer, uint32_t unBufferSize, uint32_t* punWidth, uint32_t* punHeight) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->GetOverlayImageData(ulOverlayHandle, pvBuffer, unBufferSize, punWidth, punHeight);
}
const char* CVROverlay_027::GetOverlayErrorNameFromEnum(vr::EVROverlayError error) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->GetOverlayErrorNameFromEnum(error);
}
vr::EVROverlayError CVROverlay_027::SetOverlayRenderingPid(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unPID) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->SetOverlayRenderingPid(ulOverlayHandle, unPID);
}
uint32_t CVROverlay_027::GetOverlayRenderingPid(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->GetOverlayRenderingPid(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_027::SetOverlayFlag(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_027::VROverlayFlags eOverlayFlag, bool bEnabled) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->SetOverlayFlag(ulOverlayHandle, (OOVR_VROverlayFlags) eOverlayFlag, bEnabled);
}
vr::EVROverlayError CVROverlay_027::GetOverlayFlag(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_027::VROverlayFlags eOverlayFlag, bool* pbEnabled) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->GetOverlayFlag(ulOverlayHandle, (OOVR_VROverlayFlags) eOverlayFlag, pbEnabled);
}
vr::EVROverlayError CVROverlay_027::GetOverlayFlags(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* pFlags) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->GetOverlayFlags(ulOverlayHandle, pFlags);
}
vr::EVROverlayError CVROverlay_027::SetOverlayColor(vr::VROverlayHandle_t ulOverlayHandle, float fRed, float fGreen, float fBlue) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->SetOverlayColor(ulOverlayHandle, fRed, fGreen, fBlue);
}
vr::EVROverlayError CVROverlay_027::GetOverlayColor(vr::VROverlayHandle_t ulOverlayHandle, float* pfRed, float* pfGreen, float* pfBlue) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->GetOverlayColor(ulOverlayHandle, pfRed, pfGreen, pfBlue);
}
vr::EVROverlayError CVROverlay_027::SetOverlayAlpha(vr::VROverlayHandle_t ulOverlayHandle, float fAlpha) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->SetOverlayAlpha(ulOverlayHandle, fAlpha);
}
vr::EVROverlayError CVROverlay_027::GetOverlayAlpha(vr::VROverlayHandle_t ulOverlayHandle, float* pfAlpha) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->GetOverlayAlpha(ulOverlayHandle, pfAlpha);
}
vr::EVROverlayError CVROverlay_027::SetOverlayTexelAspect(vr::VROverlayHandle_t ulOverlayHandle, float fTexelAspect) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->SetOverlayTexelAspect(ulOverlayHandle, fTexelAspect);
}
vr::EVROverlayError CVROverlay_027::GetOverlayTexelAspect(vr::VROverlayHandle_t ulOverlayHandle, float* pfTexelAspect) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->GetOverlayTexelAspect(ulOverlayHandle, pfTexelAspect);
}
vr::EVROverlayError CVROverlay_027::SetOverlaySortOrder(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unSortOrder) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->SetOverlaySortOrder(ulOverlayHandle, unSortOrder);
}
vr::EVROverlayError CVROverlay_027::GetOverlaySortOrder(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* punSortOrder) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->GetOverlaySortOrder(ulOverlayHandle, punSortOrder);
}
vr::EVROverlayError CVROverlay_027::SetOverlayWidthInMeters(vr::VROverlayHandle_t ulOverlayHandle, float fWidthInMeters) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->SetOverlayWidthInMeters(ulOverlayHandle, fWidthInMeters);
}
vr::EVROverlayError CVROverlay_027::GetOverlayWidthInMeters(vr::VROverlayHandle_t ulOverlayHandle, float* pfWidthInMeters) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->GetOverlayWidthInMeters(ulOverlayHandle, pfWidthInMeters);
}
vr::EVROverlayError CVROverlay_027::SetOverlayCurvature(vr::VROverlayHandle_t ulOverlayHandle, float fCurvature) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->SetOverlayCurvature(ulOverlayHandle, fCurvature);
}
vr::EVROverlayError CVROverlay_027::GetOverlayCurvature(vr::VROverlayHandle_t ulOverlayHandle, float* pfCurvature) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->GetOverlayCurvature(ulOverlayHandle, pfCurvature);
}
vr::EVROverlayError CVROverlay_027::SetOverlayPreCurvePitch(vr::VROverlayHandle_t ulOverlayHandle, float fRadians) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->SetOverlayPreCurvePitch(ulOverlayHandle, fRadians);
}
vr::EVROverlayError CVROverlay_027::GetOverlayPreCurvePitch(vr::VROverlayHandle_t ulOverlayHandle, float* pfRadians) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->GetOverlayPreCurvePitch(ulOverlayHandle, pfRadians);
}
vr::EVROverlayError CVROverlay_027::SetOverlayTextureColorSpace(vr::VROverlayHandle_t ulOverlayHandle, vr::EColorSpace eTextureColorSpace) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->SetOverlayTextureColorSpace(ulOverlayHandle, eTextureColorSpace);
}
vr::EVROverlayError CVROverlay_027::GetOverlayTextureColorSpace(vr::VROverlayHandle_t ulOverlayHandle, vr::EColorSpace* peTextureColorSpace) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->GetOverlayTextureColorSpace(ulOverlayHandle, peTextureColorSpace);
}
vr::EVROverlayError CVROverlay_027::SetOverlayTextureBounds(vr::VROverlayHandle_t ulOverlayHandle, const vr::VRTextureBounds_t* pOverlayTextureBounds) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->SetOverlayTextureBounds(ulOverlayHandle, pOverlayTextureBounds);
}
vr::EVROverlayError CVROverlay_027::GetOverlayTextureBounds(vr::VROverlayHandle_t ulOverlayHandle, vr::VRTextureBounds_t* pOverlayTextureBounds) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->GetOverlayTextureBounds(ulOverlayHandle, pOverlayTextureBounds);
}
vr::EVROverlayError CVROverlay_027::GetOverlayTransformType(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_027::VROverlayTransformType* peTransformType) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->GetOverlayTransformType(ulOverlayHandle, (OOVR_VROverlayTransformType*) peTransformType);
}
vr::EVROverlayError CVROverlay_027::SetOverlayTransformAbsolute(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin eTrackingOrigin, const vr::HmdMatrix34_t* pmatTrackingOriginToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->SetOverlayTransformAbsolute(ulOverlayHandle, eTrackingOrigin, pmatTrackingOriginToOverlayTransform);
}
vr::EVROverlayError CVROverlay_027::GetOverlayTransformAbsolute(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin* peTrackingOrigin, vr::HmdMatrix34_t* pmatTrackingOriginToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->GetOverlayTransformAbsolute(ulOverlayHandle, peTrackingOrigin, pmatTrackingOriginToOverlayTransform);
}
vr::EVROverlayError CVROverlay_027::SetOverlayTransformTrackedDeviceRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unTrackedDevice, const vr::HmdMatrix34_t* pmatTrackedDeviceToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->SetOverlayTransformTrackedDeviceRelative(ulOverlayHandle, unTrackedDevice, pmatTrackedDeviceToOverlayTransform);
}
vr::EVROverlayError CVROverlay_027::GetOverlayTransformTrackedDeviceRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t* punTrackedDevice, vr::HmdMatrix34_t* pmatTrackedDeviceToOverlayTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->GetOverlayTransformTrackedDeviceRelative(ulOverlayHandle, punTrackedDevice, pmatTrackedDeviceToOverlayTransform);
}
vr::EVROverlayError CVROverlay_027::SetOverlayTransformTrackedDeviceComponent(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unDeviceIndex, const char* pchComponentName) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->SetOverlayTransformTrackedDeviceComponent(ulOverlayHandle, unDeviceIndex, pchComponentName);
}
vr::EVROverlayError CVROverlay_027::GetOverlayTransformTrackedDeviceComponent(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t* punDeviceIndex, char* pchComponentName, uint32_t unComponentNameSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->GetOverlayTransformTrackedDeviceComponent(ulOverlayHandle, punDeviceIndex, pchComponentName, unComponentNameSize);
}
vr::EVROverlayError CVROverlay_027::SetOverlayTransformCursor(vr::VROverlayHandle_t ulCursorOverlayHandle, const vr::HmdVector2_t* pvHotspot) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->SetOverlayTransformCursor(ulCursorOverlayHandle, pvHotspot);
}
vr::EVROverlayError CVROverlay_027::GetOverlayTransformCursor(vr::VROverlayHandle_t ulOverlayHandle, vr::HmdVector2_t* pvHotspot) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->GetOverlayTransformCursor(ulOverlayHandle, pvHotspot);
}
vr::EVROverlayError CVROverlay_027::SetOverlayTransformProjection(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin eTrackingOrigin, const vr::HmdMatrix34_t* pmatTrackingOriginToOverlayTransform, const vr::IVROverlay_027::VROverlayProjection_t* pProjection, vr::EVREye eEye) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->SetOverlayTransformProjection(ulOverlayHandle, eTrackingOrigin, pmatTrackingOriginToOverlayTransform, (const OOVR_VROverlayProjection_t*) pProjection, eEye);
}
vr::EVROverlayError CVROverlay_027::ShowOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->ShowOverlay(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_027::HideOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->HideOverlay(ulOverlayHandle);
}
bool CVROverlay_027::IsOverlayVisible(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->IsOverlayVisible(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_027::GetTransformForOverlayCoordinates(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin eTrackingOrigin, vr::HmdVector2_t coordinatesInOverlay, vr::HmdMatrix34_t* pmatTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->GetTransformForOverlayCoordinates(ulOverlayHandle, eTrackingOrigin, coordinatesInOverlay, pmatTransform);
}
vr::EVROverlayError CVROverlay_027::WaitFrameSync(uint32_t nTimeoutMs) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->WaitFrameSync(nTimeoutMs);
}
bool CVROverlay_027::PollNextOverlayEvent(vr::VROverlayHandle_t ulOverlayHandle, vr::VREvent_t* pEvent, uint32_t uncbVREvent) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->PollNextOverlayEvent(ulOverlayHandle, pEvent, uncbVREvent);
}
vr::EVROverlayError CVROverlay_027::GetOverlayInputMethod(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_027::VROverlayInputMethod* peInputMethod) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->GetOverlayInputMethod(ulOverlayHandle, (OOVR_VROverlayInputMethod*) peInputMethod);
}
vr::EVROverlayError CVROverlay_027::SetOverlayInputMethod(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_027::VROverlayInputMethod eInputMethod) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->SetOverlayInputMethod(ulOverlayHandle, (OOVR_VROverlayInputMethod) eInputMethod);
}
vr::EVROverlayError CVROverlay_027::GetOverlayMouseScale(vr::VROverlayHandle_t ulOverlayHandle, vr::HmdVector2_t* pvecMouseScale) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->GetOverlayMouseScale(ulOverlayHandle, pvecMouseScale);
}
vr::EVROverlayError CVROverlay_027::SetOverlayMouseScale(vr::VROverlayHandle_t ulOverlayHandle, const vr::HmdVector2_t* pvecMouseScale) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->SetOverlayMouseScale(ulOverlayHandle, pvecMouseScale);
}
bool CVROverlay_027::ComputeOverlayIntersection(vr::VROverlayHandle_t ulOverlayHandle, const vr::IVROverlay_027::VROverlayIntersectionParams_t* pParams, vr::IVROverlay_027::VROverlayIntersectionResults_t* pResults) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->ComputeOverlayIntersection(ulOverlayHandle, (const OOVR_VROverlayIntersectionParams_t*) pParams, (OOVR_VROverlayIntersectionResults_t*) pResults);
}
bool CVROverlay_027::IsHoverTargetOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->IsHoverTargetOverlay(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_027::SetOverlayIntersectionMask(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_027::VROverlayIntersectionMaskPrimitive_t* pMaskPrimitives, uint32_t unNumMaskPrimitives, uint32_t unPrimitiveSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->SetOverlayIntersectionMask(ulOverlayHandle, (OOVR_VROverlayIntersectionMaskPrimitive_t*) pMaskPrimitives, unNumMaskPrimitives, unPrimitiveSize);
}
vr::EVROverlayError CVROverlay_027::TriggerLaserMouseHapticVibration(vr::VROverlayHandle_t ulOverlayHandle, float fDurationSeconds, float fFrequency, float fAmplitude) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->TriggerLaserMouseHapticVibration(ulOverlayHandle, fDurationSeconds, fFrequency, fAmplitude);
}
vr::EVROverlayError CVROverlay_027::SetOverlayCursor(vr::VROverlayHandle_t ulOverlayHandle, vr::VROverlayHandle_t ulCursorHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->SetOverlayCursor(ulOverlayHandle, ulCursorHandle);
}
vr::EVROverlayError CVROverlay_027::SetOverlayCursorPositionOverride(vr::VROverlayHandle_t ulOverlayHandle, const vr::HmdVector2_t* pvCursor) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->SetOverlayCursorPositionOverride(ulOverlayHandle, pvCursor);
}
vr::EVROverlayError CVROverlay_027::ClearOverlayCursorPositionOverride(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->ClearOverlayCursorPositionOverride(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_027::SetOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle, const vr::Texture_t* pTexture) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->SetOverlayTexture(ulOverlayHandle, pTexture);
}
vr::EVROverlayError CVROverlay_027::ClearOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->ClearOverlayTexture(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_027::SetOverlayRaw(vr::VROverlayHandle_t ulOverlayHandle, void* pvBuffer, uint32_t unWidth, uint32_t unHeight, uint32_t unBytesPerPixel) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->SetOverlayRaw(ulOverlayHandle, pvBuffer, unWidth, unHeight, unBytesPerPixel);
}
vr::EVROverlayError CVROverlay_027::SetOverlayFromFile(vr::VROverlayHandle_t ulOverlayHandle, const char* pchFilePath) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->SetOverlayFromFile(ulOverlayHandle, pchFilePath);
}
vr::EVROverlayError CVROverlay_027::GetOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle, void** pNativeTextureHandle, void* pNativeTextureRef, uint32_t* pWidth, uint32_t* pHeight, uint32_t* pNativeFormat, vr::ETextureType* pAPIType, vr::EColorSpace* pColorSpace, vr::VRTextureBounds_t* pTextureBounds) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->GetOverlayTexture(ulOverlayHandle, pNativeTextureHandle, pNativeTextureRef, pWidth, pHeight, pNativeFormat, pAPIType, pColorSpace, pTextureBounds);
}
vr::EVROverlayError CVROverlay_027::ReleaseNativeOverlayHandle(vr::VROverlayHandle_t ulOverlayHandle, void* pNativeTextureHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->ReleaseNativeOverlayHandle(ulOverlayHandle, pNativeTextureHandle);
}
vr::EVROverlayError CVROverlay_027::GetOverlayTextureSize(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* pWidth, uint32_t* pHeight) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->GetOverlayTextureSize(ulOverlayHandle, pWidth, pHeight);
}
vr::EVROverlayError CVROverlay_027::CreateDashboardOverlay(const char* pchOverlayKey, const char* pchOverlayFriendlyName, vr::VROverlayHandle_t* pMainHandle, vr::VROverlayHandle_t* pThumbnailHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->CreateDashboardOverlay(pchOverlayKey, pchOverlayFriendlyName, pMainHandle, pThumbnailHandle);
}
bool CVROverlay_027::IsDashboardVisible() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->IsDashboardVisible();
}
bool CVROverlay_027::IsActiveDashboardOverlay(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->IsActiveDashboardOverlay(ulOverlayHandle);
}
vr::EVROverlayError CVROverlay_027::SetDashboardOverlaySceneProcess(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unProcessId) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->SetDashboardOverlaySceneProcess(ulOverlayHandle, unProcessId);
}
vr::EVROverlayError CVROverlay_027::GetDashboardOverlaySceneProcess(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* punProcessId) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->GetDashboardOverlaySceneProcess(ulOverlayHandle, punProcessId);
}
void CVROverlay_027::ShowDashboard(const char* pchOverlayToShow) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->ShowDashboard(pchOverlayToShow);
}
vr::TrackedDeviceIndex_t CVROverlay_027::GetPrimaryDashboardDevice() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->GetPrimaryDashboardDevice();
}
vr::EVROverlayError CVROverlay_027::ShowKeyboard(vr::IVROverlay_027::EGamepadTextInputMode eInputMode, vr::IVROverlay_027::EGamepadTextInputLineMode eLineInputMode, uint32_t unFlags, const char* pchDescription, uint32_t unCharMax, const char* pchExistingText, uint64_t uUserValue) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->ShowKeyboard((OOVR_EGamepadTextInputMode) eInputMode, (OOVR_EGamepadTextInputLineMode) eLineInputMode, unFlags, pchDescription, unCharMax, pchExistingText, uUserValue);
}
vr::EVROverlayError CVROverlay_027::ShowKeyboardForOverlay(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_027::EGamepadTextInputMode eInputMode, vr::IVROverlay_027::EGamepadTextInputLineMode eLineInputMode, uint32_t unFlags, const char* pchDescription, uint32_t unCharMax, const char* pchExistingText, uint64_t uUserValue) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->ShowKeyboardForOverlay(ulOverlayHandle, (OOVR_EGamepadTextInputMode) eInputMode, (OOVR_EGamepadTextInputLineMode) eLineInputMode, unFlags, pchDescription, unCharMax, pchExistingText, uUserValue);
}
uint32_t CVROverlay_027::GetKeyboardText(char* pchText, uint32_t cchText) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->GetKeyboardText(pchText, cchText);
}
void CVROverlay_027::HideKeyboard() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->HideKeyboard();
}
void CVROverlay_027::SetKeyboardTransformAbsolute(vr::ETrackingUniverseOrigin eTrackingOrigin, const vr::HmdMatrix34_t* pmatTrackingOriginToKeyboardTransform) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->SetKeyboardTransformAbsolute(eTrackingOrigin, pmatTrackingOriginToKeyboardTransform);
}
void CVROverlay_027::SetKeyboardPositionForOverlay(vr::VROverlayHandle_t ulOverlayHandle, vr::HmdRect2_t avoidRect) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->SetKeyboardPositionForOverlay(ulOverlayHandle, avoidRect);
}
vr::IVROverlay_027::VRMessageOverlayResponse CVROverlay_027::ShowMessageOverlay(const char* pchText, const char* pchCaption, const char* pchButton0Text, const char* pchButton1Text, const char* pchButton2Text, const char* pchButton3Text) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return (vr::IVROverlay_027::VRMessageOverlayResponse) base->ShowMessageOverlay(pchText, pchCaption, pchButton0Text, pchButton1Text, pchButton2Text, pchButton3Text);
}
void CVROverlay_027::CloseMessageOverlay() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlay_027)");
	return base->CloseMessageOverlay();
}
// FnTable for CVROverlay_027:
static CVROverlay_027 *fntable_Overlay_027_instance = NULL;
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_FindOverlay(const char* pchOverlayKey, vr::VROverlayHandle_t* pOverlayHandle) { return fntable_Overlay_027_instance->FindOverlay(pchOverlayKey, pOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_CreateOverlay(const char* pchOverlayKey, const char* pchOverlayName, vr::VROverlayHandle_t* pOverlayHandle) { return fntable_Overlay_027_instance->CreateOverlay(pchOverlayKey, pchOverlayName, pOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_DestroyOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_027_instance->DestroyOverlay(ulOverlayHandle); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_GetOverlayKey(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::EVROverlayError* pError) { return fntable_Overlay_027_instance->GetOverlayKey(ulOverlayHandle, pchValue, unBufferSize, pError); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_GetOverlayName(vr::VROverlayHandle_t ulOverlayHandle, char* pchValue, uint32_t unBufferSize, vr::EVROverlayError* pError) { return fntable_Overlay_027_instance->GetOverlayName(ulOverlayHandle, pchValue, unBufferSize, pError); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_SetOverlayName(vr::VROverlayHandle_t ulOverlayHandle, const char* pchName) { return fntable_Overlay_027_instance->SetOverlayName(ulOverlayHandle, pchName); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_GetOverlayImageData(vr::VROverlayHandle_t ulOverlayHandle, void* pvBuffer, uint32_t unBufferSize, uint32_t* punWidth, uint32_t* punHeight) { return fntable_Overlay_027_instance->GetOverlayImageData(ulOverlayHandle, pvBuffer, unBufferSize, punWidth, punHeight); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_GetOverlayErrorNameFromEnum(vr::EVROverlayError error) { return fntable_Overlay_027_instance->GetOverlayErrorNameFromEnum(error); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_SetOverlayRenderingPid(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unPID) { return fntable_Overlay_027_instance->SetOverlayRenderingPid(ulOverlayHandle, unPID); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_GetOverlayRenderingPid(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_027_instance->GetOverlayRenderingPid(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_SetOverlayFlag(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_027::VROverlayFlags eOverlayFlag, bool bEnabled) { return fntable_Overlay_027_instance->SetOverlayFlag(ulOverlayHandle, eOverlayFlag, bEnabled); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_GetOverlayFlag(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_027::VROverlayFlags eOverlayFlag, bool* pbEnabled) { return fntable_Overlay_027_instance->GetOverlayFlag(ulOverlayHandle, eOverlayFlag, pbEnabled); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_GetOverlayFlags(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* pFlags) { return fntable_Overlay_027_instance->GetOverlayFlags(ulOverlayHandle, pFlags); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_SetOverlayColor(vr::VROverlayHandle_t ulOverlayHandle, float fRed, float fGreen, float fBlue) { return fntable_Overlay_027_instance->SetOverlayColor(ulOverlayHandle, fRed, fGreen, fBlue); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_GetOverlayColor(vr::VROverlayHandle_t ulOverlayHandle, float* pfRed, float* pfGreen, float* pfBlue) { return fntable_Overlay_027_instance->GetOverlayColor(ulOverlayHandle, pfRed, pfGreen, pfBlue); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_SetOverlayAlpha(vr::VROverlayHandle_t ulOverlayHandle, float fAlpha) { return fntable_Overlay_027_instance->SetOverlayAlpha(ulOverlayHandle, fAlpha); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_GetOverlayAlpha(vr::VROverlayHandle_t ulOverlayHandle, float* pfAlpha) { return fntable_Overlay_027_instance->GetOverlayAlpha(ulOverlayHandle, pfAlpha); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_SetOverlayTexelAspect(vr::VROverlayHandle_t ulOverlayHandle, float fTexelAspect) { return fntable_Overlay_027_instance->SetOverlayTexelAspect(ulOverlayHandle, fTexelAspect); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_GetOverlayTexelAspect(vr::VROverlayHandle_t ulOverlayHandle, float* pfTexelAspect) { return fntable_Overlay_027_instance->GetOverlayTexelAspect(ulOverlayHandle, pfTexelAspect); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_SetOverlaySortOrder(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unSortOrder) { return fntable_Overlay_027_instance->SetOverlaySortOrder(ulOverlayHandle, unSortOrder); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_GetOverlaySortOrder(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* punSortOrder) { return fntable_Overlay_027_instance->GetOverlaySortOrder(ulOverlayHandle, punSortOrder); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_SetOverlayWidthInMeters(vr::VROverlayHandle_t ulOverlayHandle, float fWidthInMeters) { return fntable_Overlay_027_instance->SetOverlayWidthInMeters(ulOverlayHandle, fWidthInMeters); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_GetOverlayWidthInMeters(vr::VROverlayHandle_t ulOverlayHandle, float* pfWidthInMeters) { return fntable_Overlay_027_instance->GetOverlayWidthInMeters(ulOverlayHandle, pfWidthInMeters); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_SetOverlayCurvature(vr::VROverlayHandle_t ulOverlayHandle, float fCurvature) { return fntable_Overlay_027_instance->SetOverlayCurvature(ulOverlayHandle, fCurvature); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_GetOverlayCurvature(vr::VROverlayHandle_t ulOverlayHandle, float* pfCurvature) { return fntable_Overlay_027_instance->GetOverlayCurvature(ulOverlayHandle, pfCurvature); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_SetOverlayPreCurvePitch(vr::VROverlayHandle_t ulOverlayHandle, float fRadians) { return fntable_Overlay_027_instance->SetOverlayPreCurvePitch(ulOverlayHandle, fRadians); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_GetOverlayPreCurvePitch(vr::VROverlayHandle_t ulOverlayHandle, float* pfRadians) { return fntable_Overlay_027_instance->GetOverlayPreCurvePitch(ulOverlayHandle, pfRadians); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_SetOverlayTextureColorSpace(vr::VROverlayHandle_t ulOverlayHandle, vr::EColorSpace eTextureColorSpace) { return fntable_Overlay_027_instance->SetOverlayTextureColorSpace(ulOverlayHandle, eTextureColorSpace); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_GetOverlayTextureColorSpace(vr::VROverlayHandle_t ulOverlayHandle, vr::EColorSpace* peTextureColorSpace) { return fntable_Overlay_027_instance->GetOverlayTextureColorSpace(ulOverlayHandle, peTextureColorSpace); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_SetOverlayTextureBounds(vr::VROverlayHandle_t ulOverlayHandle, const vr::VRTextureBounds_t* pOverlayTextureBounds) { return fntable_Overlay_027_instance->SetOverlayTextureBounds(ulOverlayHandle, pOverlayTextureBounds); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_GetOverlayTextureBounds(vr::VROverlayHandle_t ulOverlayHandle, vr::VRTextureBounds_t* pOverlayTextureBounds) { return fntable_Overlay_027_instance->GetOverlayTextureBounds(ulOverlayHandle, pOverlayTextureBounds); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_GetOverlayTransformType(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_027::VROverlayTransformType* peTransformType) { return fntable_Overlay_027_instance->GetOverlayTransformType(ulOverlayHandle, peTransformType); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_SetOverlayTransformAbsolute(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin eTrackingOrigin, const vr::HmdMatrix34_t* pmatTrackingOriginToOverlayTransform) { return fntable_Overlay_027_instance->SetOverlayTransformAbsolute(ulOverlayHandle, eTrackingOrigin, pmatTrackingOriginToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_GetOverlayTransformAbsolute(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin* peTrackingOrigin, vr::HmdMatrix34_t* pmatTrackingOriginToOverlayTransform) { return fntable_Overlay_027_instance->GetOverlayTransformAbsolute(ulOverlayHandle, peTrackingOrigin, pmatTrackingOriginToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_SetOverlayTransformTrackedDeviceRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unTrackedDevice, const vr::HmdMatrix34_t* pmatTrackedDeviceToOverlayTransform) { return fntable_Overlay_027_instance->SetOverlayTransformTrackedDeviceRelative(ulOverlayHandle, unTrackedDevice, pmatTrackedDeviceToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_GetOverlayTransformTrackedDeviceRelative(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t* punTrackedDevice, vr::HmdMatrix34_t* pmatTrackedDeviceToOverlayTransform) { return fntable_Overlay_027_instance->GetOverlayTransformTrackedDeviceRelative(ulOverlayHandle, punTrackedDevice, pmatTrackedDeviceToOverlayTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_SetOverlayTransformTrackedDeviceComponent(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t unDeviceIndex, const char* pchComponentName) { return fntable_Overlay_027_instance->SetOverlayTransformTrackedDeviceComponent(ulOverlayHandle, unDeviceIndex, pchComponentName); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_GetOverlayTransformTrackedDeviceComponent(vr::VROverlayHandle_t ulOverlayHandle, vr::TrackedDeviceIndex_t* punDeviceIndex, char* pchComponentName, uint32_t unComponentNameSize) { return fntable_Overlay_027_instance->GetOverlayTransformTrackedDeviceComponent(ulOverlayHandle, punDeviceIndex, pchComponentName, unComponentNameSize); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_SetOverlayTransformCursor(vr::VROverlayHandle_t ulCursorOverlayHandle, const vr::HmdVector2_t* pvHotspot) { return fntable_Overlay_027_instance->SetOverlayTransformCursor(ulCursorOverlayHandle, pvHotspot); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_GetOverlayTransformCursor(vr::VROverlayHandle_t ulOverlayHandle, vr::HmdVector2_t* pvHotspot) { return fntable_Overlay_027_instance->GetOverlayTransformCursor(ulOverlayHandle, pvHotspot); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_SetOverlayTransformProjection(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin eTrackingOrigin, const vr::HmdMatrix34_t* pmatTrackingOriginToOverlayTransform, const vr::IVROverlay_027::VROverlayProjection_t* pProjection, vr::EVREye eEye) { return fntable_Overlay_027_instance->SetOverlayTransformProjection(ulOverlayHandle, eTrackingOrigin, pmatTrackingOriginToOverlayTransform, pProjection, eEye); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_ShowOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_027_instance->ShowOverlay(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_HideOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_027_instance->HideOverlay(ulOverlayHandle); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_IsOverlayVisible(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_027_instance->IsOverlayVisible(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_GetTransformForOverlayCoordinates(vr::VROverlayHandle_t ulOverlayHandle, vr::ETrackingUniverseOrigin eTrackingOrigin, vr::HmdVector2_t coordinatesInOverlay, vr::HmdMatrix34_t* pmatTransform) { return fntable_Overlay_027_instance->GetTransformForOverlayCoordinates(ulOverlayHandle, eTrackingOrigin, coordinatesInOverlay, pmatTransform); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_WaitFrameSync(uint32_t nTimeoutMs) { return fntable_Overlay_027_instance->WaitFrameSync(nTimeoutMs); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_PollNextOverlayEvent(vr::VROverlayHandle_t ulOverlayHandle, vr::VREvent_t* pEvent, uint32_t uncbVREvent) { return fntable_Overlay_027_instance->PollNextOverlayEvent(ulOverlayHandle, pEvent, uncbVREvent); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_GetOverlayInputMethod(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_027::VROverlayInputMethod* peInputMethod) { return fntable_Overlay_027_instance->GetOverlayInputMethod(ulOverlayHandle, peInputMethod); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_SetOverlayInputMethod(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_027::VROverlayInputMethod eInputMethod) { return fntable_Overlay_027_instance->SetOverlayInputMethod(ulOverlayHandle, eInputMethod); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_GetOverlayMouseScale(vr::VROverlayHandle_t ulOverlayHandle, vr::HmdVector2_t* pvecMouseScale) { return fntable_Overlay_027_instance->GetOverlayMouseScale(ulOverlayHandle, pvecMouseScale); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_SetOverlayMouseScale(vr::VROverlayHandle_t ulOverlayHandle, const vr::HmdVector2_t* pvecMouseScale) { return fntable_Overlay_027_instance->SetOverlayMouseScale(ulOverlayHandle, pvecMouseScale); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_ComputeOverlayIntersection(vr::VROverlayHandle_t ulOverlayHandle, const vr::IVROverlay_027::VROverlayIntersectionParams_t* pParams, vr::IVROverlay_027::VROverlayIntersectionResults_t* pResults) { return fntable_Overlay_027_instance->ComputeOverlayIntersection(ulOverlayHandle, pParams, pResults); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_IsHoverTargetOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_027_instance->IsHoverTargetOverlay(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_SetOverlayIntersectionMask(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_027::VROverlayIntersectionMaskPrimitive_t* pMaskPrimitives, uint32_t unNumMaskPrimitives, uint32_t unPrimitiveSize) { return fntable_Overlay_027_instance->SetOverlayIntersectionMask(ulOverlayHandle, pMaskPrimitives, unNumMaskPrimitives, unPrimitiveSize); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_TriggerLaserMouseHapticVibration(vr::VROverlayHandle_t ulOverlayHandle, float fDurationSeconds, float fFrequency, float fAmplitude) { return fntable_Overlay_027_instance->TriggerLaserMouseHapticVibration(ulOverlayHandle, fDurationSeconds, fFrequency, fAmplitude); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_SetOverlayCursor(vr::VROverlayHandle_t ulOverlayHandle, vr::VROverlayHandle_t ulCursorHandle) { return fntable_Overlay_027_instance->SetOverlayCursor(ulOverlayHandle, ulCursorHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_SetOverlayCursorPositionOverride(vr::VROverlayHandle_t ulOverlayHandle, const vr::HmdVector2_t* pvCursor) { return fntable_Overlay_027_instance->SetOverlayCursorPositionOverride(ulOverlayHandle, pvCursor); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_ClearOverlayCursorPositionOverride(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_027_instance->ClearOverlayCursorPositionOverride(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_SetOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle, const vr::Texture_t* pTexture) { return fntable_Overlay_027_instance->SetOverlayTexture(ulOverlayHandle, pTexture); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_ClearOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_027_instance->ClearOverlayTexture(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_SetOverlayRaw(vr::VROverlayHandle_t ulOverlayHandle, void* pvBuffer, uint32_t unWidth, uint32_t unHeight, uint32_t unBytesPerPixel) { return fntable_Overlay_027_instance->SetOverlayRaw(ulOverlayHandle, pvBuffer, unWidth, unHeight, unBytesPerPixel); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_SetOverlayFromFile(vr::VROverlayHandle_t ulOverlayHandle, const char* pchFilePath) { return fntable_Overlay_027_instance->SetOverlayFromFile(ulOverlayHandle, pchFilePath); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_GetOverlayTexture(vr::VROverlayHandle_t ulOverlayHandle, void** pNativeTextureHandle, void* pNativeTextureRef, uint32_t* pWidth, uint32_t* pHeight, uint32_t* pNativeFormat, vr::ETextureType* pAPIType, vr::EColorSpace* pColorSpace, vr::VRTextureBounds_t* pTextureBounds) { return fntable_Overlay_027_instance->GetOverlayTexture(ulOverlayHandle, pNativeTextureHandle, pNativeTextureRef, pWidth, pHeight, pNativeFormat, pAPIType, pColorSpace, pTextureBounds); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_ReleaseNativeOverlayHandle(vr::VROverlayHandle_t ulOverlayHandle, void* pNativeTextureHandle) { return fntable_Overlay_027_instance->ReleaseNativeOverlayHandle(ulOverlayHandle, pNativeTextureHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_GetOverlayTextureSize(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* pWidth, uint32_t* pHeight) { return fntable_Overlay_027_instance->GetOverlayTextureSize(ulOverlayHandle, pWidth, pHeight); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_CreateDashboardOverlay(const char* pchOverlayKey, const char* pchOverlayFriendlyName, vr::VROverlayHandle_t* pMainHandle, vr::VROverlayHandle_t* pThumbnailHandle) { return fntable_Overlay_027_instance->CreateDashboardOverlay(pchOverlayKey, pchOverlayFriendlyName, pMainHandle, pThumbnailHandle); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_IsDashboardVisible() { return fntable_Overlay_027_instance->IsDashboardVisible(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_IsActiveDashboardOverlay(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_Overlay_027_instance->IsActiveDashboardOverlay(ulOverlayHandle); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_SetDashboardOverlaySceneProcess(vr::VROverlayHandle_t ulOverlayHandle, uint32_t unProcessId) { return fntable_Overlay_027_instance->SetDashboardOverlaySceneProcess(ulOverlayHandle, unProcessId); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_GetDashboardOverlaySceneProcess(vr::VROverlayHandle_t ulOverlayHandle, uint32_t* punProcessId) { return fntable_Overlay_027_instance->GetDashboardOverlaySceneProcess(ulOverlayHandle, punProcessId); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_ShowDashboard(const char* pchOverlayToShow) { return fntable_Overlay_027_instance->ShowDashboard(pchOverlayToShow); }
static vr::TrackedDeviceIndex_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_GetPrimaryDashboardDevice() { return fntable_Overlay_027_instance->GetPrimaryDashboardDevice(); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_ShowKeyboard(vr::IVROverlay_027::EGamepadTextInputMode eInputMode, vr::IVROverlay_027::EGamepadTextInputLineMode eLineInputMode, uint32_t unFlags, const char* pchDescription, uint32_t unCharMax, const char* pchExistingText, uint64_t uUserValue) { return fntable_Overlay_027_instance->ShowKeyboard(eInputMode, eLineInputMode, unFlags, pchDescription, unCharMax, pchExistingText, uUserValue); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_ShowKeyboardForOverlay(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlay_027::EGamepadTextInputMode eInputMode, vr::IVROverlay_027::EGamepadTextInputLineMode eLineInputMode, uint32_t unFlags, const char* pchDescription, uint32_t unCharMax, const char* pchExistingText, uint64_t uUserValue) { return fntable_Overlay_027_instance->ShowKeyboardForOverlay(ulOverlayHandle, eInputMode, eLineInputMode, unFlags, pchDescription, unCharMax, pchExistingText, uUserValue); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_GetKeyboardText(char* pchText, uint32_t cchText) { return fntable_Overlay_027_instance->GetKeyboardText(pchText, cchText); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_HideKeyboard() { return fntable_Overlay_027_instance->HideKeyboard(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_SetKeyboardTransformAbsolute(vr::ETrackingUniverseOrigin eTrackingOrigin, const vr::HmdMatrix34_t* pmatTrackingOriginToKeyboardTransform) { return fntable_Overlay_027_instance->SetKeyboardTransformAbsolute(eTrackingOrigin, pmatTrackingOriginToKeyboardTransform); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_SetKeyboardPositionForOverlay(vr::VROverlayHandle_t ulOverlayHandle, vr::HmdRect2_t avoidRect) { return fntable_Overlay_027_instance->SetKeyboardPositionForOverlay(ulOverlayHandle, avoidRect); }
static vr::IVROverlay_027::VRMessageOverlayResponse OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_ShowMessageOverlay(const char* pchText, const char* pchCaption, const char* pchButton0Text, const char* pchButton1Text, const char* pchButton2Text, const char* pchButton3Text) { return fntable_Overlay_027_instance->ShowMessageOverlay(pchText, pchCaption, pchButton0Text, pchButton1Text, pchButton2Text, pchButton3Text); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Overlay_027_impl_CloseMessageOverlay() { return fntable_Overlay_027_instance->CloseMessageOverlay(); }
static void *fntable_Overlay_027_funcs[] = {
	(void*) fntable_Overlay_027_impl_FindOverlay,
	(void*) fntable_Overlay_027_impl_CreateOverlay,
	(void*) fntable_Overlay_027_impl_DestroyOverlay,
	(void*) fntable_Overlay_027_impl_GetOverlayKey,
	(void*) fntable_Overlay_027_impl_GetOverlayName,
	(void*) fntable_Overlay_027_impl_SetOverlayName,
	(void*) fntable_Overlay_027_impl_GetOverlayImageData,
	(void*) fntable_Overlay_027_impl_GetOverlayErrorNameFromEnum,
	(void*) fntable_Overlay_027_impl_SetOverlayRenderingPid,
	(void*) fntable_Overlay_027_impl_GetOverlayRenderingPid,
	(void*) fntable_Overlay_027_impl_SetOverlayFlag,
	(void*) fntable_Overlay_027_impl_GetOverlayFlag,
	(void*) fntable_Overlay_027_impl_GetOverlayFlags,
	(void*) fntable_Overlay_027_impl_SetOverlayColor,
	(void*) fntable_Overlay_027_impl_GetOverlayColor,
	(void*) fntable_Overlay_027_impl_SetOverlayAlpha,
	(void*) fntable_Overlay_027_impl_GetOverlayAlpha,
	(void*) fntable_Overlay_027_impl_SetOverlayTexelAspect,
	(void*) fntable_Overlay_027_impl_GetOverlayTexelAspect,
	(void*) fntable_Overlay_027_impl_SetOverlaySortOrder,
	(void*) fntable_Overlay_027_impl_GetOverlaySortOrder,
	(void*) fntable_Overlay_027_impl_SetOverlayWidthInMeters,
	(void*) fntable_Overlay_027_impl_GetOverlayWidthInMeters,
	(void*) fntable_Overlay_027_impl_SetOverlayCurvature,
	(void*) fntable_Overlay_027_impl_GetOverlayCurvature,
	(void*) fntable_Overlay_027_impl_SetOverlayPreCurvePitch,
	(void*) fntable_Overlay_027_impl_GetOverlayPreCurvePitch,
	(void*) fntable_Overlay_027_impl_SetOverlayTextureColorSpace,
	(void*) fntable_Overlay_027_impl_GetOverlayTextureColorSpace,
	(void*) fntable_Overlay_027_impl_SetOverlayTextureBounds,
	(void*) fntable_Overlay_027_impl_GetOverlayTextureBounds,
	(void*) fntable_Overlay_027_impl_GetOverlayTransformType,
	(void*) fntable_Overlay_027_impl_SetOverlayTransformAbsolute,
	(void*) fntable_Overlay_027_impl_GetOverlayTransformAbsolute,
	(void*) fntable_Overlay_027_impl_SetOverlayTransformTrackedDeviceRelative,
	(void*) fntable_Overlay_027_impl_GetOverlayTransformTrackedDeviceRelative,
	(void*) fntable_Overlay_027_impl_SetOverlayTransformTrackedDeviceComponent,
	(void*) fntable_Overlay_027_impl_GetOverlayTransformTrackedDeviceComponent,
	(void*) fntable_Overlay_027_impl_SetOverlayTransformCursor,
	(void*) fntable_Overlay_027_impl_GetOverlayTransformCursor,
	(void*) fntable_Overlay_027_impl_SetOverlayTransformProjection,
	(void*) fntable_Overlay_027_impl_ShowOverlay,
	(void*) fntable_Overlay_027_impl_HideOverlay,
	(void*) fntable_Overlay_027_impl_IsOverlayVisible,
	(void*) fntable_Overlay_027_impl_GetTransformForOverlayCoordinates,
	(void*) fntable_Overlay_027_impl_WaitFrameSync,
	(void*) fntable_Overlay_027_impl_PollNextOverlayEvent,
	(void*) fntable_Overlay_027_impl_GetOverlayInputMethod,
	(void*) fntable_Overlay_027_impl_SetOverlayInputMethod,
	(void*) fntable_Overlay_027_impl_GetOverlayMouseScale,
	(void*) fntable_Overlay_027_impl_SetOverlayMouseScale,
	(void*) fntable_Overlay_027_impl_ComputeOverlayIntersection,
	(void*) fntable_Overlay_027_impl_IsHoverTargetOverlay,
	(void*) fntable_Overlay_027_impl_SetOverlayIntersectionMask,
	(void*) fntable_Overlay_027_impl_TriggerLaserMouseHapticVibration,
	(void*) fntable_Overlay_027_impl_SetOverlayCursor,
	(void*) fntable_Overlay_027_impl_SetOverlayCursorPositionOverride,
	(void*) fntable_Overlay_027_impl_ClearOverlayCursorPositionOverride,
	(void*) fntable_Overlay_027_impl_SetOverlayTexture,
	(void*) fntable_Overlay_027_impl_ClearOverlayTexture,
	(void*) fntable_Overlay_027_impl_SetOverlayRaw,
	(void*) fntable_Overlay_027_impl_SetOverlayFromFile,
	(void*) fntable_Overlay_027_impl_GetOverlayTexture,
	(void*) fntable_Overlay_027_impl_ReleaseNativeOverlayHandle,
	(void*) fntable_Overlay_027_impl_GetOverlayTextureSize,
	(void*) fntable_Overlay_027_impl_CreateDashboardOverlay,
	(void*) fntable_Overlay_027_impl_IsDashboardVisible,
	(void*) fntable_Overlay_027_impl_IsActiveDashboardOverlay,
	(void*) fntable_Overlay_027_impl_SetDashboardOverlaySceneProcess,
	(void*) fntable_Overlay_027_impl_GetDashboardOverlaySceneProcess,
	(void*) fntable_Overlay_027_impl_ShowDashboard,
	(void*) fntable_Overlay_027_impl_GetPrimaryDashboardDevice,
	(void*) fntable_Overlay_027_impl_ShowKeyboard,
	(void*) fntable_Overlay_027_impl_ShowKeyboardForOverlay,
	(void*) fntable_Overlay_027_impl_GetKeyboardText,
	(void*) fntable_Overlay_027_impl_HideKeyboard,
	(void*) fntable_Overlay_027_impl_SetKeyboardTransformAbsolute,
	(void*) fntable_Overlay_027_impl_SetKeyboardPositionForOverlay,
	(void*) fntable_Overlay_027_impl_ShowMessageOverlay,
	(void*) fntable_Overlay_027_impl_CloseMessageOverlay,
};
void** CVROverlay_027::_GetStatFuncList() { fntable_Overlay_027_instance = this; return fntable_Overlay_027_funcs; }
void CVROverlay_027::Delete() { delete this; }
#include "GVRChaperoneSetup.gen.h"
// Single inst of BaseChaperoneSetup
static std::weak_ptr<BaseChaperoneSetup> _single_inst_ChaperoneSetup;
static BaseChaperoneSetup *_single_inst_ChaperoneSetup_unsafe = NULL;
std::shared_ptr<BaseChaperoneSetup> GetBaseChaperoneSetup() { return _single_inst_ChaperoneSetup.lock(); };
BaseChaperoneSetup* GetUnsafeBaseChaperoneSetup() { return _single_inst_ChaperoneSetup_unsafe; };
std::shared_ptr<BaseChaperoneSetup> GetCreateBaseChaperoneSetup() {
	std::shared_ptr<BaseChaperoneSetup> ret = _single_inst_ChaperoneSetup.lock();
	if(!ret) {
		ret = std::shared_ptr<BaseChaperoneSetup>(new BaseChaperoneSetup(), [](BaseChaperoneSetup *obj){ _single_inst_ChaperoneSetup_unsafe = NULL; delete obj; });
		_single_inst_ChaperoneSetup = ret;
		_single_inst_ChaperoneSetup_unsafe = ret.get();
	}
	return ret;
}
// Misc for CVRChaperoneSetup_004:
CVRChaperoneSetup_004::CVRChaperoneSetup_004() : base(GetCreateBaseChaperoneSetup()) {}
// Interface methods for CVRChaperoneSetup_004:
bool CVRChaperoneSetup_004::CommitWorkingCopy(vr::IVRChaperoneSetup_004::EChaperoneConfigFile configFile) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRChaperoneSetup_004)");
	return base->CommitWorkingCopy((OOVR_EChaperoneConfigFile) configFile);
}
void CVRChaperoneSetup_004::RevertWorkingCopy() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRChaperoneSetup_004)");
	return base->RevertWorkingCopy();
}
bool CVRChaperoneSetup_004::GetWorkingPlayAreaSize(float* pSizeX, float* pSizeZ) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRChaperoneSetup_004)");
	return base->GetWorkingPlayAreaSize(pSizeX, pSizeZ);
}
bool CVRChaperoneSetup_004::GetWorkingPlayAreaRect(vr::HmdQuad_t* rect) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRChaperoneSetup_004)");
	return base->GetWorkingPlayAreaRect(rect);
}
bool CVRChaperoneSetup_004::GetWorkingCollisionBoundsInfo(vr::HmdQuad_t* pQuadsBuffer, uint32_t* punQuadsCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRChaperoneSetup_004)");
	return base->GetWorkingCollisionBoundsInfo(pQuadsBuffer, punQuadsCount);
}
bool CVRChaperoneSetup_004::GetLiveCollisionBoundsInfo(vr::HmdQuad_t* pQuadsBuffer, uint32_t* punQuadsCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRChaperoneSetup_004)");
	return base->GetLiveCollisionBoundsInfo(pQuadsBuffer, punQuadsCount);
}
bool CVRChaperoneSetup_004::GetWorkingSeatedZeroPoseToRawTrackingPose(vr::HmdMatrix34_t* pmatSeatedZeroPoseToRawTrackingPose) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRChaperoneSetup_004)");
	return base->GetWorkingSeatedZeroPoseToRawTrackingPose(pmatSeatedZeroPoseToRawTrackingPose);
}
bool CVRChaperoneSetup_004::GetWorkingStandingZeroPoseToRawTrackingPose(vr::HmdMatrix34_t* pmatStandingZeroPoseToRawTrackingPose) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRChaperoneSetup_004)");
	return base->GetWorkingStandingZeroPoseToRawTrackingPose(pmatStandingZeroPoseToRawTrackingPose);
}
void CVRChaperoneSetup_004::SetWorkingPlayAreaSize(float sizeX, float sizeZ) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRChaperoneSetup_004)");
	return base->SetWorkingPlayAreaSize(sizeX, sizeZ);
}
void CVRChaperoneSetup_004::SetWorkingCollisionBoundsInfo(vr::HmdQuad_t* pQuadsBuffer, uint32_t unQuadsCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRChaperoneSetup_004)");
	return base->SetWorkingCollisionBoundsInfo(pQuadsBuffer, unQuadsCount);
}
void CVRChaperoneSetup_004::SetWorkingSeatedZeroPoseToRawTrackingPose(const vr::HmdMatrix34_t* pMatSeatedZeroPoseToRawTrackingPose) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRChaperoneSetup_004)");
	return base->SetWorkingSeatedZeroPoseToRawTrackingPose(pMatSeatedZeroPoseToRawTrackingPose);
}
void CVRChaperoneSetup_004::SetWorkingStandingZeroPoseToRawTrackingPose(const vr::HmdMatrix34_t* pMatStandingZeroPoseToRawTrackingPose) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRChaperoneSetup_004)");
	return base->SetWorkingStandingZeroPoseToRawTrackingPose(pMatStandingZeroPoseToRawTrackingPose);
}
void CVRChaperoneSetup_004::ReloadFromDisk(vr::IVRChaperoneSetup_004::EChaperoneConfigFile configFile) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRChaperoneSetup_004)");
	return base->ReloadFromDisk((OOVR_EChaperoneConfigFile) configFile);
}
bool CVRChaperoneSetup_004::GetLiveSeatedZeroPoseToRawTrackingPose(vr::HmdMatrix34_t* pmatSeatedZeroPoseToRawTrackingPose) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRChaperoneSetup_004)");
	return base->GetLiveSeatedZeroPoseToRawTrackingPose(pmatSeatedZeroPoseToRawTrackingPose);
}
// FnTable for CVRChaperoneSetup_004:
static CVRChaperoneSetup_004 *fntable_ChaperoneSetup_004_instance = NULL;
static bool OPENVR_FNTABLE_CALLTYPE fntable_ChaperoneSetup_004_impl_CommitWorkingCopy(vr::IVRChaperoneSetup_004::EChaperoneConfigFile configFile) { return fntable_ChaperoneSetup_004_instance->CommitWorkingCopy(configFile); }
static void OPENVR_FNTABLE_CALLTYPE fntable_ChaperoneSetup_004_impl_RevertWorkingCopy() { return fntable_ChaperoneSetup_004_instance->RevertWorkingCopy(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_ChaperoneSetup_004_impl_GetWorkingPlayAreaSize(float* pSizeX, float* pSizeZ) { return fntable_ChaperoneSetup_004_instance->GetWorkingPlayAreaSize(pSizeX, pSizeZ); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_ChaperoneSetup_004_impl_GetWorkingPlayAreaRect(vr::HmdQuad_t* rect) { return fntable_ChaperoneSetup_004_instance->GetWorkingPlayAreaRect(rect); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_ChaperoneSetup_004_impl_GetWorkingCollisionBoundsInfo(vr::HmdQuad_t* pQuadsBuffer, uint32_t* punQuadsCount) { return fntable_ChaperoneSetup_004_instance->GetWorkingCollisionBoundsInfo(pQuadsBuffer, punQuadsCount); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_ChaperoneSetup_004_impl_GetLiveCollisionBoundsInfo(vr::HmdQuad_t* pQuadsBuffer, uint32_t* punQuadsCount) { return fntable_ChaperoneSetup_004_instance->GetLiveCollisionBoundsInfo(pQuadsBuffer, punQuadsCount); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_ChaperoneSetup_004_impl_GetWorkingSeatedZeroPoseToRawTrackingPose(vr::HmdMatrix34_t* pmatSeatedZeroPoseToRawTrackingPose) { return fntable_ChaperoneSetup_004_instance->GetWorkingSeatedZeroPoseToRawTrackingPose(pmatSeatedZeroPoseToRawTrackingPose); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_ChaperoneSetup_004_impl_GetWorkingStandingZeroPoseToRawTrackingPose(vr::HmdMatrix34_t* pmatStandingZeroPoseToRawTrackingPose) { return fntable_ChaperoneSetup_004_instance->GetWorkingStandingZeroPoseToRawTrackingPose(pmatStandingZeroPoseToRawTrackingPose); }
static void OPENVR_FNTABLE_CALLTYPE fntable_ChaperoneSetup_004_impl_SetWorkingPlayAreaSize(float sizeX, float sizeZ) { return fntable_ChaperoneSetup_004_instance->SetWorkingPlayAreaSize(sizeX, sizeZ); }
static void OPENVR_FNTABLE_CALLTYPE fntable_ChaperoneSetup_004_impl_SetWorkingCollisionBoundsInfo(vr::HmdQuad_t* pQuadsBuffer, uint32_t unQuadsCount) { return fntable_ChaperoneSetup_004_instance->SetWorkingCollisionBoundsInfo(pQuadsBuffer, unQuadsCount); }
static void OPENVR_FNTABLE_CALLTYPE fntable_ChaperoneSetup_004_impl_SetWorkingSeatedZeroPoseToRawTrackingPose(const vr::HmdMatrix34_t* pMatSeatedZeroPoseToRawTrackingPose) { return fntable_ChaperoneSetup_004_instance->SetWorkingSeatedZeroPoseToRawTrackingPose(pMatSeatedZeroPoseToRawTrackingPose); }
static void OPENVR_FNTABLE_CALLTYPE fntable_ChaperoneSetup_004_impl_SetWorkingStandingZeroPoseToRawTrackingPose(const vr::HmdMatrix34_t* pMatStandingZeroPoseToRawTrackingPose) { return fntable_ChaperoneSetup_004_instance->SetWorkingStandingZeroPoseToRawTrackingPose(pMatStandingZeroPoseToRawTrackingPose); }
static void OPENVR_FNTABLE_CALLTYPE fntable_ChaperoneSetup_004_impl_ReloadFromDisk(vr::IVRChaperoneSetup_004::EChaperoneConfigFile configFile) { return fntable_ChaperoneSetup_004_instance->ReloadFromDisk(configFile); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_ChaperoneSetup_004_impl_GetLiveSeatedZeroPoseToRawTrackingPose(vr::HmdMatrix34_t* pmatSeatedZeroPoseToRawTrackingPose) { return fntable_ChaperoneSetup_004_instance->GetLiveSeatedZeroPoseToRawTrackingPose(pmatSeatedZeroPoseToRawTrackingPose); }
static void *fntable_ChaperoneSetup_004_funcs[] = {
	(void*) fntable_ChaperoneSetup_004_impl_CommitWorkingCopy,
	(void*) fntable_ChaperoneSetup_004_impl_RevertWorkingCopy,
	(void*) fntable_ChaperoneSetup_004_impl_GetWorkingPlayAreaSize,
	(void*) fntable_ChaperoneSetup_004_impl_GetWorkingPlayAreaRect,
	(void*) fntable_ChaperoneSetup_004_impl_GetWorkingCollisionBoundsInfo,
	(void*) fntable_ChaperoneSetup_004_impl_GetLiveCollisionBoundsInfo,
	(void*) fntable_ChaperoneSetup_004_impl_GetWorkingSeatedZeroPoseToRawTrackingPose,
	(void*) fntable_ChaperoneSetup_004_impl_GetWorkingStandingZeroPoseToRawTrackingPose,
	(void*) fntable_ChaperoneSetup_004_impl_SetWorkingPlayAreaSize,
	(void*) fntable_ChaperoneSetup_004_impl_SetWorkingCollisionBoundsInfo,
	(void*) fntable_ChaperoneSetup_004_impl_SetWorkingSeatedZeroPoseToRawTrackingPose,
	(void*) fntable_ChaperoneSetup_004_impl_SetWorkingStandingZeroPoseToRawTrackingPose,
	(void*) fntable_ChaperoneSetup_004_impl_ReloadFromDisk,
	(void*) fntable_ChaperoneSetup_004_impl_GetLiveSeatedZeroPoseToRawTrackingPose,
};
void** CVRChaperoneSetup_004::_GetStatFuncList() { fntable_ChaperoneSetup_004_instance = this; return fntable_ChaperoneSetup_004_funcs; }
void CVRChaperoneSetup_004::Delete() { delete this; }
// Misc for CVRChaperoneSetup_005:
CVRChaperoneSetup_005::CVRChaperoneSetup_005() : base(GetCreateBaseChaperoneSetup()) {}
// Interface methods for CVRChaperoneSetup_005:
bool CVRChaperoneSetup_005::CommitWorkingCopy(vr::IVRChaperoneSetup_005::EChaperoneConfigFile configFile) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRChaperoneSetup_005)");
	return base->CommitWorkingCopy((OOVR_EChaperoneConfigFile) configFile);
}
void CVRChaperoneSetup_005::RevertWorkingCopy() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRChaperoneSetup_005)");
	return base->RevertWorkingCopy();
}
bool CVRChaperoneSetup_005::GetWorkingPlayAreaSize(float* pSizeX, float* pSizeZ) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRChaperoneSetup_005)");
	return base->GetWorkingPlayAreaSize(pSizeX, pSizeZ);
}
bool CVRChaperoneSetup_005::GetWorkingPlayAreaRect(vr::HmdQuad_t* rect) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRChaperoneSetup_005)");
	return base->GetWorkingPlayAreaRect(rect);
}
bool CVRChaperoneSetup_005::GetWorkingCollisionBoundsInfo(vr::HmdQuad_t* pQuadsBuffer, uint32_t* punQuadsCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRChaperoneSetup_005)");
	return base->GetWorkingCollisionBoundsInfo(pQuadsBuffer, punQuadsCount);
}
bool CVRChaperoneSetup_005::GetLiveCollisionBoundsInfo(vr::HmdQuad_t* pQuadsBuffer, uint32_t* punQuadsCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRChaperoneSetup_005)");
	return base->GetLiveCollisionBoundsInfo(pQuadsBuffer, punQuadsCount);
}
bool CVRChaperoneSetup_005::GetWorkingSeatedZeroPoseToRawTrackingPose(vr::HmdMatrix34_t* pmatSeatedZeroPoseToRawTrackingPose) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRChaperoneSetup_005)");
	return base->GetWorkingSeatedZeroPoseToRawTrackingPose(pmatSeatedZeroPoseToRawTrackingPose);
}
bool CVRChaperoneSetup_005::GetWorkingStandingZeroPoseToRawTrackingPose(vr::HmdMatrix34_t* pmatStandingZeroPoseToRawTrackingPose) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRChaperoneSetup_005)");
	return base->GetWorkingStandingZeroPoseToRawTrackingPose(pmatStandingZeroPoseToRawTrackingPose);
}
void CVRChaperoneSetup_005::SetWorkingPlayAreaSize(float sizeX, float sizeZ) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRChaperoneSetup_005)");
	return base->SetWorkingPlayAreaSize(sizeX, sizeZ);
}
void CVRChaperoneSetup_005::SetWorkingCollisionBoundsInfo(vr::HmdQuad_t* pQuadsBuffer, uint32_t unQuadsCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRChaperoneSetup_005)");
	return base->SetWorkingCollisionBoundsInfo(pQuadsBuffer, unQuadsCount);
}
void CVRChaperoneSetup_005::SetWorkingSeatedZeroPoseToRawTrackingPose(const vr::HmdMatrix34_t* pMatSeatedZeroPoseToRawTrackingPose) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRChaperoneSetup_005)");
	return base->SetWorkingSeatedZeroPoseToRawTrackingPose(pMatSeatedZeroPoseToRawTrackingPose);
}
void CVRChaperoneSetup_005::SetWorkingStandingZeroPoseToRawTrackingPose(const vr::HmdMatrix34_t* pMatStandingZeroPoseToRawTrackingPose) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRChaperoneSetup_005)");
	return base->SetWorkingStandingZeroPoseToRawTrackingPose(pMatStandingZeroPoseToRawTrackingPose);
}
void CVRChaperoneSetup_005::ReloadFromDisk(vr::IVRChaperoneSetup_005::EChaperoneConfigFile configFile) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRChaperoneSetup_005)");
	return base->ReloadFromDisk((OOVR_EChaperoneConfigFile) configFile);
}
bool CVRChaperoneSetup_005::GetLiveSeatedZeroPoseToRawTrackingPose(vr::HmdMatrix34_t* pmatSeatedZeroPoseToRawTrackingPose) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRChaperoneSetup_005)");
	return base->GetLiveSeatedZeroPoseToRawTrackingPose(pmatSeatedZeroPoseToRawTrackingPose);
}
void CVRChaperoneSetup_005::SetWorkingCollisionBoundsTagsInfo(uint8_t* pTagsBuffer, uint32_t unTagCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRChaperoneSetup_005)");
	return base->SetWorkingCollisionBoundsTagsInfo(pTagsBuffer, unTagCount);
}
bool CVRChaperoneSetup_005::GetLiveCollisionBoundsTagsInfo(uint8_t* pTagsBuffer, uint32_t* punTagCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRChaperoneSetup_005)");
	return base->GetLiveCollisionBoundsTagsInfo(pTagsBuffer, punTagCount);
}
bool CVRChaperoneSetup_005::SetWorkingPhysicalBoundsInfo(vr::HmdQuad_t* pQuadsBuffer, uint32_t unQuadsCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRChaperoneSetup_005)");
	return base->SetWorkingPhysicalBoundsInfo(pQuadsBuffer, unQuadsCount);
}
bool CVRChaperoneSetup_005::GetLivePhysicalBoundsInfo(vr::HmdQuad_t* pQuadsBuffer, uint32_t* punQuadsCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRChaperoneSetup_005)");
	return base->GetLivePhysicalBoundsInfo(pQuadsBuffer, punQuadsCount);
}
bool CVRChaperoneSetup_005::ExportLiveToBuffer(char* pBuffer, uint32_t* pnBufferLength) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRChaperoneSetup_005)");
	return base->ExportLiveToBuffer(pBuffer, pnBufferLength);
}
bool CVRChaperoneSetup_005::ImportFromBufferToWorking(const char* pBuffer, uint32_t nImportFlags) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRChaperoneSetup_005)");
	return base->ImportFromBufferToWorking(pBuffer, nImportFlags);
}
// FnTable for CVRChaperoneSetup_005:
static CVRChaperoneSetup_005 *fntable_ChaperoneSetup_005_instance = NULL;
static bool OPENVR_FNTABLE_CALLTYPE fntable_ChaperoneSetup_005_impl_CommitWorkingCopy(vr::IVRChaperoneSetup_005::EChaperoneConfigFile configFile) { return fntable_ChaperoneSetup_005_instance->CommitWorkingCopy(configFile); }
static void OPENVR_FNTABLE_CALLTYPE fntable_ChaperoneSetup_005_impl_RevertWorkingCopy() { return fntable_ChaperoneSetup_005_instance->RevertWorkingCopy(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_ChaperoneSetup_005_impl_GetWorkingPlayAreaSize(float* pSizeX, float* pSizeZ) { return fntable_ChaperoneSetup_005_instance->GetWorkingPlayAreaSize(pSizeX, pSizeZ); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_ChaperoneSetup_005_impl_GetWorkingPlayAreaRect(vr::HmdQuad_t* rect) { return fntable_ChaperoneSetup_005_instance->GetWorkingPlayAreaRect(rect); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_ChaperoneSetup_005_impl_GetWorkingCollisionBoundsInfo(vr::HmdQuad_t* pQuadsBuffer, uint32_t* punQuadsCount) { return fntable_ChaperoneSetup_005_instance->GetWorkingCollisionBoundsInfo(pQuadsBuffer, punQuadsCount); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_ChaperoneSetup_005_impl_GetLiveCollisionBoundsInfo(vr::HmdQuad_t* pQuadsBuffer, uint32_t* punQuadsCount) { return fntable_ChaperoneSetup_005_instance->GetLiveCollisionBoundsInfo(pQuadsBuffer, punQuadsCount); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_ChaperoneSetup_005_impl_GetWorkingSeatedZeroPoseToRawTrackingPose(vr::HmdMatrix34_t* pmatSeatedZeroPoseToRawTrackingPose) { return fntable_ChaperoneSetup_005_instance->GetWorkingSeatedZeroPoseToRawTrackingPose(pmatSeatedZeroPoseToRawTrackingPose); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_ChaperoneSetup_005_impl_GetWorkingStandingZeroPoseToRawTrackingPose(vr::HmdMatrix34_t* pmatStandingZeroPoseToRawTrackingPose) { return fntable_ChaperoneSetup_005_instance->GetWorkingStandingZeroPoseToRawTrackingPose(pmatStandingZeroPoseToRawTrackingPose); }
static void OPENVR_FNTABLE_CALLTYPE fntable_ChaperoneSetup_005_impl_SetWorkingPlayAreaSize(float sizeX, float sizeZ) { return fntable_ChaperoneSetup_005_instance->SetWorkingPlayAreaSize(sizeX, sizeZ); }
static void OPENVR_FNTABLE_CALLTYPE fntable_ChaperoneSetup_005_impl_SetWorkingCollisionBoundsInfo(vr::HmdQuad_t* pQuadsBuffer, uint32_t unQuadsCount) { return fntable_ChaperoneSetup_005_instance->SetWorkingCollisionBoundsInfo(pQuadsBuffer, unQuadsCount); }
static void OPENVR_FNTABLE_CALLTYPE fntable_ChaperoneSetup_005_impl_SetWorkingSeatedZeroPoseToRawTrackingPose(const vr::HmdMatrix34_t* pMatSeatedZeroPoseToRawTrackingPose) { return fntable_ChaperoneSetup_005_instance->SetWorkingSeatedZeroPoseToRawTrackingPose(pMatSeatedZeroPoseToRawTrackingPose); }
static void OPENVR_FNTABLE_CALLTYPE fntable_ChaperoneSetup_005_impl_SetWorkingStandingZeroPoseToRawTrackingPose(const vr::HmdMatrix34_t* pMatStandingZeroPoseToRawTrackingPose) { return fntable_ChaperoneSetup_005_instance->SetWorkingStandingZeroPoseToRawTrackingPose(pMatStandingZeroPoseToRawTrackingPose); }
static void OPENVR_FNTABLE_CALLTYPE fntable_ChaperoneSetup_005_impl_ReloadFromDisk(vr::IVRChaperoneSetup_005::EChaperoneConfigFile configFile) { return fntable_ChaperoneSetup_005_instance->ReloadFromDisk(configFile); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_ChaperoneSetup_005_impl_GetLiveSeatedZeroPoseToRawTrackingPose(vr::HmdMatrix34_t* pmatSeatedZeroPoseToRawTrackingPose) { return fntable_ChaperoneSetup_005_instance->GetLiveSeatedZeroPoseToRawTrackingPose(pmatSeatedZeroPoseToRawTrackingPose); }
static void OPENVR_FNTABLE_CALLTYPE fntable_ChaperoneSetup_005_impl_SetWorkingCollisionBoundsTagsInfo(uint8_t* pTagsBuffer, uint32_t unTagCount) { return fntable_ChaperoneSetup_005_instance->SetWorkingCollisionBoundsTagsInfo(pTagsBuffer, unTagCount); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_ChaperoneSetup_005_impl_GetLiveCollisionBoundsTagsInfo(uint8_t* pTagsBuffer, uint32_t* punTagCount) { return fntable_ChaperoneSetup_005_instance->GetLiveCollisionBoundsTagsInfo(pTagsBuffer, punTagCount); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_ChaperoneSetup_005_impl_SetWorkingPhysicalBoundsInfo(vr::HmdQuad_t* pQuadsBuffer, uint32_t unQuadsCount) { return fntable_ChaperoneSetup_005_instance->SetWorkingPhysicalBoundsInfo(pQuadsBuffer, unQuadsCount); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_ChaperoneSetup_005_impl_GetLivePhysicalBoundsInfo(vr::HmdQuad_t* pQuadsBuffer, uint32_t* punQuadsCount) { return fntable_ChaperoneSetup_005_instance->GetLivePhysicalBoundsInfo(pQuadsBuffer, punQuadsCount); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_ChaperoneSetup_005_impl_ExportLiveToBuffer(char* pBuffer, uint32_t* pnBufferLength) { return fntable_ChaperoneSetup_005_instance->ExportLiveToBuffer(pBuffer, pnBufferLength); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_ChaperoneSetup_005_impl_ImportFromBufferToWorking(const char* pBuffer, uint32_t nImportFlags) { return fntable_ChaperoneSetup_005_instance->ImportFromBufferToWorking(pBuffer, nImportFlags); }
static void *fntable_ChaperoneSetup_005_funcs[] = {
	(void*) fntable_ChaperoneSetup_005_impl_CommitWorkingCopy,
	(void*) fntable_ChaperoneSetup_005_impl_RevertWorkingCopy,
	(void*) fntable_ChaperoneSetup_005_impl_GetWorkingPlayAreaSize,
	(void*) fntable_ChaperoneSetup_005_impl_GetWorkingPlayAreaRect,
	(void*) fntable_ChaperoneSetup_005_impl_GetWorkingCollisionBoundsInfo,
	(void*) fntable_ChaperoneSetup_005_impl_GetLiveCollisionBoundsInfo,
	(void*) fntable_ChaperoneSetup_005_impl_GetWorkingSeatedZeroPoseToRawTrackingPose,
	(void*) fntable_ChaperoneSetup_005_impl_GetWorkingStandingZeroPoseToRawTrackingPose,
	(void*) fntable_ChaperoneSetup_005_impl_SetWorkingPlayAreaSize,
	(void*) fntable_ChaperoneSetup_005_impl_SetWorkingCollisionBoundsInfo,
	(void*) fntable_ChaperoneSetup_005_impl_SetWorkingSeatedZeroPoseToRawTrackingPose,
	(void*) fntable_ChaperoneSetup_005_impl_SetWorkingStandingZeroPoseToRawTrackingPose,
	(void*) fntable_ChaperoneSetup_005_impl_ReloadFromDisk,
	(void*) fntable_ChaperoneSetup_005_impl_GetLiveSeatedZeroPoseToRawTrackingPose,
	(void*) fntable_ChaperoneSetup_005_impl_SetWorkingCollisionBoundsTagsInfo,
	(void*) fntable_ChaperoneSetup_005_impl_GetLiveCollisionBoundsTagsInfo,
	(void*) fntable_ChaperoneSetup_005_impl_SetWorkingPhysicalBoundsInfo,
	(void*) fntable_ChaperoneSetup_005_impl_GetLivePhysicalBoundsInfo,
	(void*) fntable_ChaperoneSetup_005_impl_ExportLiveToBuffer,
	(void*) fntable_ChaperoneSetup_005_impl_ImportFromBufferToWorking,
};
void** CVRChaperoneSetup_005::_GetStatFuncList() { fntable_ChaperoneSetup_005_instance = this; return fntable_ChaperoneSetup_005_funcs; }
void CVRChaperoneSetup_005::Delete() { delete this; }
// Misc for CVRChaperoneSetup_006:
CVRChaperoneSetup_006::CVRChaperoneSetup_006() : base(GetCreateBaseChaperoneSetup()) {}
// Interface methods for CVRChaperoneSetup_006:
bool CVRChaperoneSetup_006::CommitWorkingCopy(vr::IVRChaperoneSetup_006::EChaperoneConfigFile configFile) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRChaperoneSetup_006)");
	return base->CommitWorkingCopy((OOVR_EChaperoneConfigFile) configFile);
}
void CVRChaperoneSetup_006::RevertWorkingCopy() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRChaperoneSetup_006)");
	return base->RevertWorkingCopy();
}
bool CVRChaperoneSetup_006::GetWorkingPlayAreaSize(float* pSizeX, float* pSizeZ) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRChaperoneSetup_006)");
	return base->GetWorkingPlayAreaSize(pSizeX, pSizeZ);
}
bool CVRChaperoneSetup_006::GetWorkingPlayAreaRect(vr::HmdQuad_t* rect) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRChaperoneSetup_006)");
	return base->GetWorkingPlayAreaRect(rect);
}
bool CVRChaperoneSetup_006::GetWorkingCollisionBoundsInfo(vr::HmdQuad_t* pQuadsBuffer, uint32_t* punQuadsCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRChaperoneSetup_006)");
	return base->GetWorkingCollisionBoundsInfo(pQuadsBuffer, punQuadsCount);
}
bool CVRChaperoneSetup_006::GetLiveCollisionBoundsInfo(vr::HmdQuad_t* pQuadsBuffer, uint32_t* punQuadsCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRChaperoneSetup_006)");
	return base->GetLiveCollisionBoundsInfo(pQuadsBuffer, punQuadsCount);
}
bool CVRChaperoneSetup_006::GetWorkingSeatedZeroPoseToRawTrackingPose(vr::HmdMatrix34_t* pmatSeatedZeroPoseToRawTrackingPose) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRChaperoneSetup_006)");
	return base->GetWorkingSeatedZeroPoseToRawTrackingPose(pmatSeatedZeroPoseToRawTrackingPose);
}
bool CVRChaperoneSetup_006::GetWorkingStandingZeroPoseToRawTrackingPose(vr::HmdMatrix34_t* pmatStandingZeroPoseToRawTrackingPose) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRChaperoneSetup_006)");
	return base->GetWorkingStandingZeroPoseToRawTrackingPose(pmatStandingZeroPoseToRawTrackingPose);
}
void CVRChaperoneSetup_006::SetWorkingPlayAreaSize(float sizeX, float sizeZ) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRChaperoneSetup_006)");
	return base->SetWorkingPlayAreaSize(sizeX, sizeZ);
}
void CVRChaperoneSetup_006::SetWorkingCollisionBoundsInfo(vr::HmdQuad_t* pQuadsBuffer, uint32_t unQuadsCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRChaperoneSetup_006)");
	return base->SetWorkingCollisionBoundsInfo(pQuadsBuffer, unQuadsCount);
}
void CVRChaperoneSetup_006::SetWorkingPerimeter(vr::HmdVector2_t* pPointBuffer, uint32_t unPointCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRChaperoneSetup_006)");
	return base->SetWorkingPerimeter(pPointBuffer, unPointCount);
}
void CVRChaperoneSetup_006::SetWorkingSeatedZeroPoseToRawTrackingPose(const vr::HmdMatrix34_t* pMatSeatedZeroPoseToRawTrackingPose) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRChaperoneSetup_006)");
	return base->SetWorkingSeatedZeroPoseToRawTrackingPose(pMatSeatedZeroPoseToRawTrackingPose);
}
void CVRChaperoneSetup_006::SetWorkingStandingZeroPoseToRawTrackingPose(const vr::HmdMatrix34_t* pMatStandingZeroPoseToRawTrackingPose) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRChaperoneSetup_006)");
	return base->SetWorkingStandingZeroPoseToRawTrackingPose(pMatStandingZeroPoseToRawTrackingPose);
}
void CVRChaperoneSetup_006::ReloadFromDisk(vr::IVRChaperoneSetup_006::EChaperoneConfigFile configFile) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRChaperoneSetup_006)");
	return base->ReloadFromDisk((OOVR_EChaperoneConfigFile) configFile);
}
bool CVRChaperoneSetup_006::GetLiveSeatedZeroPoseToRawTrackingPose(vr::HmdMatrix34_t* pmatSeatedZeroPoseToRawTrackingPose) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRChaperoneSetup_006)");
	return base->GetLiveSeatedZeroPoseToRawTrackingPose(pmatSeatedZeroPoseToRawTrackingPose);
}
bool CVRChaperoneSetup_006::ExportLiveToBuffer(char* pBuffer, uint32_t* pnBufferLength) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRChaperoneSetup_006)");
	return base->ExportLiveToBuffer(pBuffer, pnBufferLength);
}
bool CVRChaperoneSetup_006::ImportFromBufferToWorking(const char* pBuffer, uint32_t nImportFlags) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRChaperoneSetup_006)");
	return base->ImportFromBufferToWorking(pBuffer, nImportFlags);
}
void CVRChaperoneSetup_006::ShowWorkingSetPreview() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRChaperoneSetup_006)");
	return base->ShowWorkingSetPreview();
}
void CVRChaperoneSetup_006::HideWorkingSetPreview() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRChaperoneSetup_006)");
	return base->HideWorkingSetPreview();
}
void CVRChaperoneSetup_006::RoomSetupStarting() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRChaperoneSetup_006)");
	return base->RoomSetupStarting();
}
// FnTable for CVRChaperoneSetup_006:
static CVRChaperoneSetup_006 *fntable_ChaperoneSetup_006_instance = NULL;
static bool OPENVR_FNTABLE_CALLTYPE fntable_ChaperoneSetup_006_impl_CommitWorkingCopy(vr::IVRChaperoneSetup_006::EChaperoneConfigFile configFile) { return fntable_ChaperoneSetup_006_instance->CommitWorkingCopy(configFile); }
static void OPENVR_FNTABLE_CALLTYPE fntable_ChaperoneSetup_006_impl_RevertWorkingCopy() { return fntable_ChaperoneSetup_006_instance->RevertWorkingCopy(); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_ChaperoneSetup_006_impl_GetWorkingPlayAreaSize(float* pSizeX, float* pSizeZ) { return fntable_ChaperoneSetup_006_instance->GetWorkingPlayAreaSize(pSizeX, pSizeZ); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_ChaperoneSetup_006_impl_GetWorkingPlayAreaRect(vr::HmdQuad_t* rect) { return fntable_ChaperoneSetup_006_instance->GetWorkingPlayAreaRect(rect); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_ChaperoneSetup_006_impl_GetWorkingCollisionBoundsInfo(vr::HmdQuad_t* pQuadsBuffer, uint32_t* punQuadsCount) { return fntable_ChaperoneSetup_006_instance->GetWorkingCollisionBoundsInfo(pQuadsBuffer, punQuadsCount); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_ChaperoneSetup_006_impl_GetLiveCollisionBoundsInfo(vr::HmdQuad_t* pQuadsBuffer, uint32_t* punQuadsCount) { return fntable_ChaperoneSetup_006_instance->GetLiveCollisionBoundsInfo(pQuadsBuffer, punQuadsCount); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_ChaperoneSetup_006_impl_GetWorkingSeatedZeroPoseToRawTrackingPose(vr::HmdMatrix34_t* pmatSeatedZeroPoseToRawTrackingPose) { return fntable_ChaperoneSetup_006_instance->GetWorkingSeatedZeroPoseToRawTrackingPose(pmatSeatedZeroPoseToRawTrackingPose); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_ChaperoneSetup_006_impl_GetWorkingStandingZeroPoseToRawTrackingPose(vr::HmdMatrix34_t* pmatStandingZeroPoseToRawTrackingPose) { return fntable_ChaperoneSetup_006_instance->GetWorkingStandingZeroPoseToRawTrackingPose(pmatStandingZeroPoseToRawTrackingPose); }
static void OPENVR_FNTABLE_CALLTYPE fntable_ChaperoneSetup_006_impl_SetWorkingPlayAreaSize(float sizeX, float sizeZ) { return fntable_ChaperoneSetup_006_instance->SetWorkingPlayAreaSize(sizeX, sizeZ); }
static void OPENVR_FNTABLE_CALLTYPE fntable_ChaperoneSetup_006_impl_SetWorkingCollisionBoundsInfo(vr::HmdQuad_t* pQuadsBuffer, uint32_t unQuadsCount) { return fntable_ChaperoneSetup_006_instance->SetWorkingCollisionBoundsInfo(pQuadsBuffer, unQuadsCount); }
static void OPENVR_FNTABLE_CALLTYPE fntable_ChaperoneSetup_006_impl_SetWorkingPerimeter(vr::HmdVector2_t* pPointBuffer, uint32_t unPointCount) { return fntable_ChaperoneSetup_006_instance->SetWorkingPerimeter(pPointBuffer, unPointCount); }
static void OPENVR_FNTABLE_CALLTYPE fntable_ChaperoneSetup_006_impl_SetWorkingSeatedZeroPoseToRawTrackingPose(const vr::HmdMatrix34_t* pMatSeatedZeroPoseToRawTrackingPose) { return fntable_ChaperoneSetup_006_instance->SetWorkingSeatedZeroPoseToRawTrackingPose(pMatSeatedZeroPoseToRawTrackingPose); }
static void OPENVR_FNTABLE_CALLTYPE fntable_ChaperoneSetup_006_impl_SetWorkingStandingZeroPoseToRawTrackingPose(const vr::HmdMatrix34_t* pMatStandingZeroPoseToRawTrackingPose) { return fntable_ChaperoneSetup_006_instance->SetWorkingStandingZeroPoseToRawTrackingPose(pMatStandingZeroPoseToRawTrackingPose); }
static void OPENVR_FNTABLE_CALLTYPE fntable_ChaperoneSetup_006_impl_ReloadFromDisk(vr::IVRChaperoneSetup_006::EChaperoneConfigFile configFile) { return fntable_ChaperoneSetup_006_instance->ReloadFromDisk(configFile); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_ChaperoneSetup_006_impl_GetLiveSeatedZeroPoseToRawTrackingPose(vr::HmdMatrix34_t* pmatSeatedZeroPoseToRawTrackingPose) { return fntable_ChaperoneSetup_006_instance->GetLiveSeatedZeroPoseToRawTrackingPose(pmatSeatedZeroPoseToRawTrackingPose); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_ChaperoneSetup_006_impl_ExportLiveToBuffer(char* pBuffer, uint32_t* pnBufferLength) { return fntable_ChaperoneSetup_006_instance->ExportLiveToBuffer(pBuffer, pnBufferLength); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_ChaperoneSetup_006_impl_ImportFromBufferToWorking(const char* pBuffer, uint32_t nImportFlags) { return fntable_ChaperoneSetup_006_instance->ImportFromBufferToWorking(pBuffer, nImportFlags); }
static void OPENVR_FNTABLE_CALLTYPE fntable_ChaperoneSetup_006_impl_ShowWorkingSetPreview() { return fntable_ChaperoneSetup_006_instance->ShowWorkingSetPreview(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_ChaperoneSetup_006_impl_HideWorkingSetPreview() { return fntable_ChaperoneSetup_006_instance->HideWorkingSetPreview(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_ChaperoneSetup_006_impl_RoomSetupStarting() { return fntable_ChaperoneSetup_006_instance->RoomSetupStarting(); }
static void *fntable_ChaperoneSetup_006_funcs[] = {
	(void*) fntable_ChaperoneSetup_006_impl_CommitWorkingCopy,
	(void*) fntable_ChaperoneSetup_006_impl_RevertWorkingCopy,
	(void*) fntable_ChaperoneSetup_006_impl_GetWorkingPlayAreaSize,
	(void*) fntable_ChaperoneSetup_006_impl_GetWorkingPlayAreaRect,
	(void*) fntable_ChaperoneSetup_006_impl_GetWorkingCollisionBoundsInfo,
	(void*) fntable_ChaperoneSetup_006_impl_GetLiveCollisionBoundsInfo,
	(void*) fntable_ChaperoneSetup_006_impl_GetWorkingSeatedZeroPoseToRawTrackingPose,
	(void*) fntable_ChaperoneSetup_006_impl_GetWorkingStandingZeroPoseToRawTrackingPose,
	(void*) fntable_ChaperoneSetup_006_impl_SetWorkingPlayAreaSize,
	(void*) fntable_ChaperoneSetup_006_impl_SetWorkingCollisionBoundsInfo,
	(void*) fntable_ChaperoneSetup_006_impl_SetWorkingPerimeter,
	(void*) fntable_ChaperoneSetup_006_impl_SetWorkingSeatedZeroPoseToRawTrackingPose,
	(void*) fntable_ChaperoneSetup_006_impl_SetWorkingStandingZeroPoseToRawTrackingPose,
	(void*) fntable_ChaperoneSetup_006_impl_ReloadFromDisk,
	(void*) fntable_ChaperoneSetup_006_impl_GetLiveSeatedZeroPoseToRawTrackingPose,
	(void*) fntable_ChaperoneSetup_006_impl_ExportLiveToBuffer,
	(void*) fntable_ChaperoneSetup_006_impl_ImportFromBufferToWorking,
	(void*) fntable_ChaperoneSetup_006_impl_ShowWorkingSetPreview,
	(void*) fntable_ChaperoneSetup_006_impl_HideWorkingSetPreview,
	(void*) fntable_ChaperoneSetup_006_impl_RoomSetupStarting,
};
void** CVRChaperoneSetup_006::_GetStatFuncList() { fntable_ChaperoneSetup_006_instance = this; return fntable_ChaperoneSetup_006_funcs; }
void CVRChaperoneSetup_006::Delete() { delete this; }
#include "GVRRenderModels.gen.h"
// Single inst of BaseRenderModels
static std::weak_ptr<BaseRenderModels> _single_inst_RenderModels;
static BaseRenderModels *_single_inst_RenderModels_unsafe = NULL;
std::shared_ptr<BaseRenderModels> GetBaseRenderModels() { return _single_inst_RenderModels.lock(); };
BaseRenderModels* GetUnsafeBaseRenderModels() { return _single_inst_RenderModels_unsafe; };
std::shared_ptr<BaseRenderModels> GetCreateBaseRenderModels() {
	std::shared_ptr<BaseRenderModels> ret = _single_inst_RenderModels.lock();
	if(!ret) {
		ret = std::shared_ptr<BaseRenderModels>(new BaseRenderModels(), [](BaseRenderModels *obj){ _single_inst_RenderModels_unsafe = NULL; delete obj; });
		_single_inst_RenderModels = ret;
		_single_inst_RenderModels_unsafe = ret.get();
	}
	return ret;
}
// Misc for CVRRenderModels_002:
CVRRenderModels_002::CVRRenderModels_002() : base(GetCreateBaseRenderModels()) {}
// Interface methods for CVRRenderModels_002:
void CVRRenderModels_002::FreeRenderModel(vr::IVRRenderModels_002::RenderModel_t* pRenderModel) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRRenderModels_002)");
	return base->FreeRenderModel((OOVR_RenderModel_t*) pRenderModel);
}
void CVRRenderModels_002::FreeTexture(vr::IVRRenderModels_002::RenderModel_TextureMap_t* pTexture) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRRenderModels_002)");
	return base->FreeTexture((OOVR_RenderModel_TextureMap_t*) pTexture);
}
uint32_t CVRRenderModels_002::GetRenderModelName(uint32_t unRenderModelIndex, char* pchRenderModelName, uint32_t unRenderModelNameLen) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRRenderModels_002)");
	return base->GetRenderModelName(unRenderModelIndex, pchRenderModelName, unRenderModelNameLen);
}
uint32_t CVRRenderModels_002::GetRenderModelCount() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRRenderModels_002)");
	return base->GetRenderModelCount();
}
uint32_t CVRRenderModels_002::GetComponentCount(const char* pchRenderModelName) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRRenderModels_002)");
	return base->GetComponentCount(pchRenderModelName);
}
uint32_t CVRRenderModels_002::GetComponentName(const char* pchRenderModelName, uint32_t unComponentIndex, char* pchComponentName, uint32_t unComponentNameLen) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRRenderModels_002)");
	return base->GetComponentName(pchRenderModelName, unComponentIndex, pchComponentName, unComponentNameLen);
}
uint64_t CVRRenderModels_002::GetComponentButtonMask(const char* pchRenderModelName, const char* pchComponentName) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRRenderModels_002)");
	return base->GetComponentButtonMask(pchRenderModelName, pchComponentName);
}
uint32_t CVRRenderModels_002::GetComponentRenderModelName(const char* pchRenderModelName, const char* pchComponentName, char* pchComponentRenderModelName, uint32_t unComponentRenderModelNameLen) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRRenderModels_002)");
	return base->GetComponentRenderModelName(pchRenderModelName, pchComponentName, pchComponentRenderModelName, unComponentRenderModelNameLen);
}
// FnTable for CVRRenderModels_002:
static CVRRenderModels_002 *fntable_RenderModels_002_instance = NULL;
static bool OPENVR_FNTABLE_CALLTYPE fntable_RenderModels_002_impl_LoadRenderModel(const char* pchRenderModelName, vr::IVRRenderModels_002::RenderModel_t** ppRenderModel) { return fntable_RenderModels_002_instance->LoadRenderModel(pchRenderModelName, ppRenderModel); }
static void OPENVR_FNTABLE_CALLTYPE fntable_RenderModels_002_impl_FreeRenderModel(vr::IVRRenderModels_002::RenderModel_t* pRenderModel) { return fntable_RenderModels_002_instance->FreeRenderModel(pRenderModel); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_RenderModels_002_impl_LoadTexture(vr::IVRRenderModels_002::TextureID_t textureId, vr::IVRRenderModels_002::RenderModel_TextureMap_t** ppTexture) { return fntable_RenderModels_002_instance->LoadTexture(textureId, ppTexture); }
static void OPENVR_FNTABLE_CALLTYPE fntable_RenderModels_002_impl_FreeTexture(vr::IVRRenderModels_002::RenderModel_TextureMap_t* pTexture) { return fntable_RenderModels_002_instance->FreeTexture(pTexture); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_RenderModels_002_impl_GetRenderModelName(uint32_t unRenderModelIndex, char* pchRenderModelName, uint32_t unRenderModelNameLen) { return fntable_RenderModels_002_instance->GetRenderModelName(unRenderModelIndex, pchRenderModelName, unRenderModelNameLen); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_RenderModels_002_impl_GetRenderModelCount() { return fntable_RenderModels_002_instance->GetRenderModelCount(); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_RenderModels_002_impl_GetComponentCount(const char* pchRenderModelName) { return fntable_RenderModels_002_instance->GetComponentCount(pchRenderModelName); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_RenderModels_002_impl_GetComponentName(const char* pchRenderModelName, uint32_t unComponentIndex, char* pchComponentName, uint32_t unComponentNameLen) { return fntable_RenderModels_002_instance->GetComponentName(pchRenderModelName, unComponentIndex, pchComponentName, unComponentNameLen); }
static uint64_t OPENVR_FNTABLE_CALLTYPE fntable_RenderModels_002_impl_GetComponentButtonMask(const char* pchRenderModelName, const char* pchComponentName) { return fntable_RenderModels_002_instance->GetComponentButtonMask(pchRenderModelName, pchComponentName); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_RenderModels_002_impl_GetComponentRenderModelName(const char* pchRenderModelName, const char* pchComponentName, char* pchComponentRenderModelName, uint32_t unComponentRenderModelNameLen) { return fntable_RenderModels_002_instance->GetComponentRenderModelName(pchRenderModelName, pchComponentName, pchComponentRenderModelName, unComponentRenderModelNameLen); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_RenderModels_002_impl_GetComponentState(const char* pchRenderModelName, const char* pchComponentName, const vr::VRControllerState_t* pControllerState, vr::IVRRenderModels_002::RenderModel_ComponentState_t* pComponentState) { return fntable_RenderModels_002_instance->GetComponentState(pchRenderModelName, pchComponentName, pControllerState, pComponentState); }
static void *fntable_RenderModels_002_funcs[] = {
	(void*) fntable_RenderModels_002_impl_LoadRenderModel,
	(void*) fntable_RenderModels_002_impl_FreeRenderModel,
	(void*) fntable_RenderModels_002_impl_LoadTexture,
	(void*) fntable_RenderModels_002_impl_FreeTexture,
	(void*) fntable_RenderModels_002_impl_GetRenderModelName,
	(void*) fntable_RenderModels_002_impl_GetRenderModelCount,
	(void*) fntable_RenderModels_002_impl_GetComponentCount,
	(void*) fntable_RenderModels_002_impl_GetComponentName,
	(void*) fntable_RenderModels_002_impl_GetComponentButtonMask,
	(void*) fntable_RenderModels_002_impl_GetComponentRenderModelName,
	(void*) fntable_RenderModels_002_impl_GetComponentState,
};
void** CVRRenderModels_002::_GetStatFuncList() { fntable_RenderModels_002_instance = this; return fntable_RenderModels_002_funcs; }
void CVRRenderModels_002::Delete() { delete this; }
// Misc for CVRRenderModels_004:
CVRRenderModels_004::CVRRenderModels_004() : base(GetCreateBaseRenderModels()) {}
// Interface methods for CVRRenderModels_004:
vr::IVRRenderModels_004::EVRRenderModelError CVRRenderModels_004::LoadRenderModel_Async(const char* pchRenderModelName, vr::IVRRenderModels_004::RenderModel_t** ppRenderModel) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRRenderModels_004)");
	return (vr::IVRRenderModels_004::EVRRenderModelError) base->LoadRenderModel_Async(pchRenderModelName, (OOVR_RenderModel_t**) ppRenderModel);
}
void CVRRenderModels_004::FreeRenderModel(vr::IVRRenderModels_004::RenderModel_t* pRenderModel) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRRenderModels_004)");
	return base->FreeRenderModel((OOVR_RenderModel_t*) pRenderModel);
}
vr::IVRRenderModels_004::EVRRenderModelError CVRRenderModels_004::LoadTexture_Async(vr::IVRRenderModels_004::TextureID_t textureId, vr::IVRRenderModels_004::RenderModel_TextureMap_t** ppTexture) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRRenderModels_004)");
	return (vr::IVRRenderModels_004::EVRRenderModelError) base->LoadTexture_Async((OOVR_TextureID_t) textureId, (OOVR_RenderModel_TextureMap_t**) ppTexture);
}
void CVRRenderModels_004::FreeTexture(vr::IVRRenderModels_004::RenderModel_TextureMap_t* pTexture) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRRenderModels_004)");
	return base->FreeTexture((OOVR_RenderModel_TextureMap_t*) pTexture);
}
vr::IVRRenderModels_004::EVRRenderModelError CVRRenderModels_004::LoadTextureD3D11_Async(vr::IVRRenderModels_004::TextureID_t textureId, void* pD3D11Device, void** ppD3D11Texture2D) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRRenderModels_004)");
	return (vr::IVRRenderModels_004::EVRRenderModelError) base->LoadTextureD3D11_Async((OOVR_TextureID_t) textureId, pD3D11Device, ppD3D11Texture2D);
}
void CVRRenderModels_004::FreeTextureD3D11(void* pD3D11Texture2D) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRRenderModels_004)");
	return base->FreeTextureD3D11(pD3D11Texture2D);
}
uint32_t CVRRenderModels_004::GetRenderModelName(uint32_t unRenderModelIndex, char* pchRenderModelName, uint32_t unRenderModelNameLen) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRRenderModels_004)");
	return base->GetRenderModelName(unRenderModelIndex, pchRenderModelName, unRenderModelNameLen);
}
uint32_t CVRRenderModels_004::GetRenderModelCount() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRRenderModels_004)");
	return base->GetRenderModelCount();
}
uint32_t CVRRenderModels_004::GetComponentCount(const char* pchRenderModelName) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRRenderModels_004)");
	return base->GetComponentCount(pchRenderModelName);
}
uint32_t CVRRenderModels_004::GetComponentName(const char* pchRenderModelName, uint32_t unComponentIndex, char* pchComponentName, uint32_t unComponentNameLen) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRRenderModels_004)");
	return base->GetComponentName(pchRenderModelName, unComponentIndex, pchComponentName, unComponentNameLen);
}
uint64_t CVRRenderModels_004::GetComponentButtonMask(const char* pchRenderModelName, const char* pchComponentName) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRRenderModels_004)");
	return base->GetComponentButtonMask(pchRenderModelName, pchComponentName);
}
uint32_t CVRRenderModels_004::GetComponentRenderModelName(const char* pchRenderModelName, const char* pchComponentName, char* pchComponentRenderModelName, uint32_t unComponentRenderModelNameLen) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRRenderModels_004)");
	return base->GetComponentRenderModelName(pchRenderModelName, pchComponentName, pchComponentRenderModelName, unComponentRenderModelNameLen);
}
bool CVRRenderModels_004::GetComponentState(const char* pchRenderModelName, const char* pchComponentName, const vr::VRControllerState_t* pControllerState, const vr::IVRRenderModels_004::RenderModel_ControllerMode_State_t* pState, vr::IVRRenderModels_004::RenderModel_ComponentState_t* pComponentState) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRRenderModels_004)");
	return base->GetComponentState(pchRenderModelName, pchComponentName, pControllerState, (const OOVR_RenderModel_ControllerMode_State_t*) pState, (OOVR_RenderModel_ComponentState_t*) pComponentState);
}
bool CVRRenderModels_004::RenderModelHasComponent(const char* pchRenderModelName, const char* pchComponentName) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRRenderModels_004)");
	return base->RenderModelHasComponent(pchRenderModelName, pchComponentName);
}
// FnTable for CVRRenderModels_004:
static CVRRenderModels_004 *fntable_RenderModels_004_instance = NULL;
static vr::IVRRenderModels_004::EVRRenderModelError OPENVR_FNTABLE_CALLTYPE fntable_RenderModels_004_impl_LoadRenderModel_Async(const char* pchRenderModelName, vr::IVRRenderModels_004::RenderModel_t** ppRenderModel) { return fntable_RenderModels_004_instance->LoadRenderModel_Async(pchRenderModelName, ppRenderModel); }
static void OPENVR_FNTABLE_CALLTYPE fntable_RenderModels_004_impl_FreeRenderModel(vr::IVRRenderModels_004::RenderModel_t* pRenderModel) { return fntable_RenderModels_004_instance->FreeRenderModel(pRenderModel); }
static vr::IVRRenderModels_004::EVRRenderModelError OPENVR_FNTABLE_CALLTYPE fntable_RenderModels_004_impl_LoadTexture_Async(vr::IVRRenderModels_004::TextureID_t textureId, vr::IVRRenderModels_004::RenderModel_TextureMap_t** ppTexture) { return fntable_RenderModels_004_instance->LoadTexture_Async(textureId, ppTexture); }
static void OPENVR_FNTABLE_CALLTYPE fntable_RenderModels_004_impl_FreeTexture(vr::IVRRenderModels_004::RenderModel_TextureMap_t* pTexture) { return fntable_RenderModels_004_instance->FreeTexture(pTexture); }
static vr::IVRRenderModels_004::EVRRenderModelError OPENVR_FNTABLE_CALLTYPE fntable_RenderModels_004_impl_LoadTextureD3D11_Async(vr::IVRRenderModels_004::TextureID_t textureId, void* pD3D11Device, void** ppD3D11Texture2D) { return fntable_RenderModels_004_instance->LoadTextureD3D11_Async(textureId, pD3D11Device, ppD3D11Texture2D); }
static void OPENVR_FNTABLE_CALLTYPE fntable_RenderModels_004_impl_FreeTextureD3D11(void* pD3D11Texture2D) { return fntable_RenderModels_004_instance->FreeTextureD3D11(pD3D11Texture2D); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_RenderModels_004_impl_GetRenderModelName(uint32_t unRenderModelIndex, char* pchRenderModelName, uint32_t unRenderModelNameLen) { return fntable_RenderModels_004_instance->GetRenderModelName(unRenderModelIndex, pchRenderModelName, unRenderModelNameLen); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_RenderModels_004_impl_GetRenderModelCount() { return fntable_RenderModels_004_instance->GetRenderModelCount(); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_RenderModels_004_impl_GetComponentCount(const char* pchRenderModelName) { return fntable_RenderModels_004_instance->GetComponentCount(pchRenderModelName); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_RenderModels_004_impl_GetComponentName(const char* pchRenderModelName, uint32_t unComponentIndex, char* pchComponentName, uint32_t unComponentNameLen) { return fntable_RenderModels_004_instance->GetComponentName(pchRenderModelName, unComponentIndex, pchComponentName, unComponentNameLen); }
static uint64_t OPENVR_FNTABLE_CALLTYPE fntable_RenderModels_004_impl_GetComponentButtonMask(const char* pchRenderModelName, const char* pchComponentName) { return fntable_RenderModels_004_instance->GetComponentButtonMask(pchRenderModelName, pchComponentName); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_RenderModels_004_impl_GetComponentRenderModelName(const char* pchRenderModelName, const char* pchComponentName, char* pchComponentRenderModelName, uint32_t unComponentRenderModelNameLen) { return fntable_RenderModels_004_instance->GetComponentRenderModelName(pchRenderModelName, pchComponentName, pchComponentRenderModelName, unComponentRenderModelNameLen); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_RenderModels_004_impl_GetComponentState(const char* pchRenderModelName, const char* pchComponentName, const vr::VRControllerState_t* pControllerState, const vr::IVRRenderModels_004::RenderModel_ControllerMode_State_t* pState, vr::IVRRenderModels_004::RenderModel_ComponentState_t* pComponentState) { return fntable_RenderModels_004_instance->GetComponentState(pchRenderModelName, pchComponentName, pControllerState, pState, pComponentState); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_RenderModels_004_impl_RenderModelHasComponent(const char* pchRenderModelName, const char* pchComponentName) { return fntable_RenderModels_004_instance->RenderModelHasComponent(pchRenderModelName, pchComponentName); }
static void *fntable_RenderModels_004_funcs[] = {
	(void*) fntable_RenderModels_004_impl_LoadRenderModel_Async,
	(void*) fntable_RenderModels_004_impl_FreeRenderModel,
	(void*) fntable_RenderModels_004_impl_LoadTexture_Async,
	(void*) fntable_RenderModels_004_impl_FreeTexture,
	(void*) fntable_RenderModels_004_impl_LoadTextureD3D11_Async,
	(void*) fntable_RenderModels_004_impl_FreeTextureD3D11,
	(void*) fntable_RenderModels_004_impl_GetRenderModelName,
	(void*) fntable_RenderModels_004_impl_GetRenderModelCount,
	(void*) fntable_RenderModels_004_impl_GetComponentCount,
	(void*) fntable_RenderModels_004_impl_GetComponentName,
	(void*) fntable_RenderModels_004_impl_GetComponentButtonMask,
	(void*) fntable_RenderModels_004_impl_GetComponentRenderModelName,
	(void*) fntable_RenderModels_004_impl_GetComponentState,
	(void*) fntable_RenderModels_004_impl_RenderModelHasComponent,
};
void** CVRRenderModels_004::_GetStatFuncList() { fntable_RenderModels_004_instance = this; return fntable_RenderModels_004_funcs; }
void CVRRenderModels_004::Delete() { delete this; }
// Misc for CVRRenderModels_005:
CVRRenderModels_005::CVRRenderModels_005() : base(GetCreateBaseRenderModels()) {}
// Interface methods for CVRRenderModels_005:
vr::IVRRenderModels_005::EVRRenderModelError CVRRenderModels_005::LoadRenderModel_Async(const char* pchRenderModelName, vr::IVRRenderModels_005::RenderModel_t** ppRenderModel) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRRenderModels_005)");
	return (vr::IVRRenderModels_005::EVRRenderModelError) base->LoadRenderModel_Async(pchRenderModelName, (OOVR_RenderModel_t**) ppRenderModel);
}
void CVRRenderModels_005::FreeRenderModel(vr::IVRRenderModels_005::RenderModel_t* pRenderModel) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRRenderModels_005)");
	return base->FreeRenderModel((OOVR_RenderModel_t*) pRenderModel);
}
vr::IVRRenderModels_005::EVRRenderModelError CVRRenderModels_005::LoadTexture_Async(vr::IVRRenderModels_005::TextureID_t textureId, vr::IVRRenderModels_005::RenderModel_TextureMap_t** ppTexture) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRRenderModels_005)");
	return (vr::IVRRenderModels_005::EVRRenderModelError) base->LoadTexture_Async((OOVR_TextureID_t) textureId, (OOVR_RenderModel_TextureMap_t**) ppTexture);
}
void CVRRenderModels_005::FreeTexture(vr::IVRRenderModels_005::RenderModel_TextureMap_t* pTexture) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRRenderModels_005)");
	return base->FreeTexture((OOVR_RenderModel_TextureMap_t*) pTexture);
}
vr::IVRRenderModels_005::EVRRenderModelError CVRRenderModels_005::LoadTextureD3D11_Async(vr::IVRRenderModels_005::TextureID_t textureId, void* pD3D11Device, void** ppD3D11Texture2D) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRRenderModels_005)");
	return (vr::IVRRenderModels_005::EVRRenderModelError) base->LoadTextureD3D11_Async((OOVR_TextureID_t) textureId, pD3D11Device, ppD3D11Texture2D);
}
vr::IVRRenderModels_005::EVRRenderModelError CVRRenderModels_005::LoadIntoTextureD3D11_Async(vr::IVRRenderModels_005::TextureID_t textureId, void* pDstTexture) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRRenderModels_005)");
	return (vr::IVRRenderModels_005::EVRRenderModelError) base->LoadIntoTextureD3D11_Async((OOVR_TextureID_t) textureId, pDstTexture);
}
void CVRRenderModels_005::FreeTextureD3D11(void* pD3D11Texture2D) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRRenderModels_005)");
	return base->FreeTextureD3D11(pD3D11Texture2D);
}
uint32_t CVRRenderModels_005::GetRenderModelName(uint32_t unRenderModelIndex, char* pchRenderModelName, uint32_t unRenderModelNameLen) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRRenderModels_005)");
	return base->GetRenderModelName(unRenderModelIndex, pchRenderModelName, unRenderModelNameLen);
}
uint32_t CVRRenderModels_005::GetRenderModelCount() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRRenderModels_005)");
	return base->GetRenderModelCount();
}
uint32_t CVRRenderModels_005::GetComponentCount(const char* pchRenderModelName) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRRenderModels_005)");
	return base->GetComponentCount(pchRenderModelName);
}
uint32_t CVRRenderModels_005::GetComponentName(const char* pchRenderModelName, uint32_t unComponentIndex, char* pchComponentName, uint32_t unComponentNameLen) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRRenderModels_005)");
	return base->GetComponentName(pchRenderModelName, unComponentIndex, pchComponentName, unComponentNameLen);
}
uint64_t CVRRenderModels_005::GetComponentButtonMask(const char* pchRenderModelName, const char* pchComponentName) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRRenderModels_005)");
	return base->GetComponentButtonMask(pchRenderModelName, pchComponentName);
}
uint32_t CVRRenderModels_005::GetComponentRenderModelName(const char* pchRenderModelName, const char* pchComponentName, char* pchComponentRenderModelName, uint32_t unComponentRenderModelNameLen) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRRenderModels_005)");
	return base->GetComponentRenderModelName(pchRenderModelName, pchComponentName, pchComponentRenderModelName, unComponentRenderModelNameLen);
}
bool CVRRenderModels_005::GetComponentState(const char* pchRenderModelName, const char* pchComponentName, const vr::VRControllerState_t* pControllerState, const vr::IVRRenderModels_005::RenderModel_ControllerMode_State_t* pState, vr::IVRRenderModels_005::RenderModel_ComponentState_t* pComponentState) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRRenderModels_005)");
	return base->GetComponentState(pchRenderModelName, pchComponentName, pControllerState, (const OOVR_RenderModel_ControllerMode_State_t*) pState, (OOVR_RenderModel_ComponentState_t*) pComponentState);
}
bool CVRRenderModels_005::RenderModelHasComponent(const char* pchRenderModelName, const char* pchComponentName) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRRenderModels_005)");
	return base->RenderModelHasComponent(pchRenderModelName, pchComponentName);
}
uint32_t CVRRenderModels_005::GetRenderModelThumbnailURL(const char* pchRenderModelName, char* pchThumbnailURL, uint32_t unThumbnailURLLen, vr::IVRRenderModels_005::EVRRenderModelError* peError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRRenderModels_005)");
	return base->GetRenderModelThumbnailURL(pchRenderModelName, pchThumbnailURL, unThumbnailURLLen, (OOVR_EVRRenderModelError*) peError);
}
uint32_t CVRRenderModels_005::GetRenderModelOriginalPath(const char* pchRenderModelName, char* pchOriginalPath, uint32_t unOriginalPathLen, vr::IVRRenderModels_005::EVRRenderModelError* peError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRRenderModels_005)");
	return base->GetRenderModelOriginalPath(pchRenderModelName, pchOriginalPath, unOriginalPathLen, (OOVR_EVRRenderModelError*) peError);
}
const char* CVRRenderModels_005::GetRenderModelErrorNameFromEnum(vr::IVRRenderModels_005::EVRRenderModelError error) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRRenderModels_005)");
	return base->GetRenderModelErrorNameFromEnum((OOVR_EVRRenderModelError) error);
}
// FnTable for CVRRenderModels_005:
static CVRRenderModels_005 *fntable_RenderModels_005_instance = NULL;
static vr::IVRRenderModels_005::EVRRenderModelError OPENVR_FNTABLE_CALLTYPE fntable_RenderModels_005_impl_LoadRenderModel_Async(const char* pchRenderModelName, vr::IVRRenderModels_005::RenderModel_t** ppRenderModel) { return fntable_RenderModels_005_instance->LoadRenderModel_Async(pchRenderModelName, ppRenderModel); }
static void OPENVR_FNTABLE_CALLTYPE fntable_RenderModels_005_impl_FreeRenderModel(vr::IVRRenderModels_005::RenderModel_t* pRenderModel) { return fntable_RenderModels_005_instance->FreeRenderModel(pRenderModel); }
static vr::IVRRenderModels_005::EVRRenderModelError OPENVR_FNTABLE_CALLTYPE fntable_RenderModels_005_impl_LoadTexture_Async(vr::IVRRenderModels_005::TextureID_t textureId, vr::IVRRenderModels_005::RenderModel_TextureMap_t** ppTexture) { return fntable_RenderModels_005_instance->LoadTexture_Async(textureId, ppTexture); }
static void OPENVR_FNTABLE_CALLTYPE fntable_RenderModels_005_impl_FreeTexture(vr::IVRRenderModels_005::RenderModel_TextureMap_t* pTexture) { return fntable_RenderModels_005_instance->FreeTexture(pTexture); }
static vr::IVRRenderModels_005::EVRRenderModelError OPENVR_FNTABLE_CALLTYPE fntable_RenderModels_005_impl_LoadTextureD3D11_Async(vr::IVRRenderModels_005::TextureID_t textureId, void* pD3D11Device, void** ppD3D11Texture2D) { return fntable_RenderModels_005_instance->LoadTextureD3D11_Async(textureId, pD3D11Device, ppD3D11Texture2D); }
static vr::IVRRenderModels_005::EVRRenderModelError OPENVR_FNTABLE_CALLTYPE fntable_RenderModels_005_impl_LoadIntoTextureD3D11_Async(vr::IVRRenderModels_005::TextureID_t textureId, void* pDstTexture) { return fntable_RenderModels_005_instance->LoadIntoTextureD3D11_Async(textureId, pDstTexture); }
static void OPENVR_FNTABLE_CALLTYPE fntable_RenderModels_005_impl_FreeTextureD3D11(void* pD3D11Texture2D) { return fntable_RenderModels_005_instance->FreeTextureD3D11(pD3D11Texture2D); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_RenderModels_005_impl_GetRenderModelName(uint32_t unRenderModelIndex, char* pchRenderModelName, uint32_t unRenderModelNameLen) { return fntable_RenderModels_005_instance->GetRenderModelName(unRenderModelIndex, pchRenderModelName, unRenderModelNameLen); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_RenderModels_005_impl_GetRenderModelCount() { return fntable_RenderModels_005_instance->GetRenderModelCount(); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_RenderModels_005_impl_GetComponentCount(const char* pchRenderModelName) { return fntable_RenderModels_005_instance->GetComponentCount(pchRenderModelName); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_RenderModels_005_impl_GetComponentName(const char* pchRenderModelName, uint32_t unComponentIndex, char* pchComponentName, uint32_t unComponentNameLen) { return fntable_RenderModels_005_instance->GetComponentName(pchRenderModelName, unComponentIndex, pchComponentName, unComponentNameLen); }
static uint64_t OPENVR_FNTABLE_CALLTYPE fntable_RenderModels_005_impl_GetComponentButtonMask(const char* pchRenderModelName, const char* pchComponentName) { return fntable_RenderModels_005_instance->GetComponentButtonMask(pchRenderModelName, pchComponentName); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_RenderModels_005_impl_GetComponentRenderModelName(const char* pchRenderModelName, const char* pchComponentName, char* pchComponentRenderModelName, uint32_t unComponentRenderModelNameLen) { return fntable_RenderModels_005_instance->GetComponentRenderModelName(pchRenderModelName, pchComponentName, pchComponentRenderModelName, unComponentRenderModelNameLen); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_RenderModels_005_impl_GetComponentState(const char* pchRenderModelName, const char* pchComponentName, const vr::VRControllerState_t* pControllerState, const vr::IVRRenderModels_005::RenderModel_ControllerMode_State_t* pState, vr::IVRRenderModels_005::RenderModel_ComponentState_t* pComponentState) { return fntable_RenderModels_005_instance->GetComponentState(pchRenderModelName, pchComponentName, pControllerState, pState, pComponentState); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_RenderModels_005_impl_RenderModelHasComponent(const char* pchRenderModelName, const char* pchComponentName) { return fntable_RenderModels_005_instance->RenderModelHasComponent(pchRenderModelName, pchComponentName); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_RenderModels_005_impl_GetRenderModelThumbnailURL(const char* pchRenderModelName, char* pchThumbnailURL, uint32_t unThumbnailURLLen, vr::IVRRenderModels_005::EVRRenderModelError* peError) { return fntable_RenderModels_005_instance->GetRenderModelThumbnailURL(pchRenderModelName, pchThumbnailURL, unThumbnailURLLen, peError); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_RenderModels_005_impl_GetRenderModelOriginalPath(const char* pchRenderModelName, char* pchOriginalPath, uint32_t unOriginalPathLen, vr::IVRRenderModels_005::EVRRenderModelError* peError) { return fntable_RenderModels_005_instance->GetRenderModelOriginalPath(pchRenderModelName, pchOriginalPath, unOriginalPathLen, peError); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_RenderModels_005_impl_GetRenderModelErrorNameFromEnum(vr::IVRRenderModels_005::EVRRenderModelError error) { return fntable_RenderModels_005_instance->GetRenderModelErrorNameFromEnum(error); }
static void *fntable_RenderModels_005_funcs[] = {
	(void*) fntable_RenderModels_005_impl_LoadRenderModel_Async,
	(void*) fntable_RenderModels_005_impl_FreeRenderModel,
	(void*) fntable_RenderModels_005_impl_LoadTexture_Async,
	(void*) fntable_RenderModels_005_impl_FreeTexture,
	(void*) fntable_RenderModels_005_impl_LoadTextureD3D11_Async,
	(void*) fntable_RenderModels_005_impl_LoadIntoTextureD3D11_Async,
	(void*) fntable_RenderModels_005_impl_FreeTextureD3D11,
	(void*) fntable_RenderModels_005_impl_GetRenderModelName,
	(void*) fntable_RenderModels_005_impl_GetRenderModelCount,
	(void*) fntable_RenderModels_005_impl_GetComponentCount,
	(void*) fntable_RenderModels_005_impl_GetComponentName,
	(void*) fntable_RenderModels_005_impl_GetComponentButtonMask,
	(void*) fntable_RenderModels_005_impl_GetComponentRenderModelName,
	(void*) fntable_RenderModels_005_impl_GetComponentState,
	(void*) fntable_RenderModels_005_impl_RenderModelHasComponent,
	(void*) fntable_RenderModels_005_impl_GetRenderModelThumbnailURL,
	(void*) fntable_RenderModels_005_impl_GetRenderModelOriginalPath,
	(void*) fntable_RenderModels_005_impl_GetRenderModelErrorNameFromEnum,
};
void** CVRRenderModels_005::_GetStatFuncList() { fntable_RenderModels_005_instance = this; return fntable_RenderModels_005_funcs; }
void CVRRenderModels_005::Delete() { delete this; }
// Misc for CVRRenderModels_006:
CVRRenderModels_006::CVRRenderModels_006() : base(GetCreateBaseRenderModels()) {}
// Interface methods for CVRRenderModels_006:
vr::IVRRenderModels_006::EVRRenderModelError CVRRenderModels_006::LoadRenderModel_Async(const char* pchRenderModelName, vr::IVRRenderModels_006::RenderModel_t** ppRenderModel) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRRenderModels_006)");
	return (vr::IVRRenderModels_006::EVRRenderModelError) base->LoadRenderModel_Async(pchRenderModelName, (OOVR_RenderModel_t**) ppRenderModel);
}
void CVRRenderModels_006::FreeRenderModel(vr::IVRRenderModels_006::RenderModel_t* pRenderModel) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRRenderModels_006)");
	return base->FreeRenderModel((OOVR_RenderModel_t*) pRenderModel);
}
vr::IVRRenderModels_006::EVRRenderModelError CVRRenderModels_006::LoadTexture_Async(vr::IVRRenderModels_006::TextureID_t textureId, vr::IVRRenderModels_006::RenderModel_TextureMap_t** ppTexture) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRRenderModels_006)");
	return (vr::IVRRenderModels_006::EVRRenderModelError) base->LoadTexture_Async((OOVR_TextureID_t) textureId, (OOVR_RenderModel_TextureMap_t**) ppTexture);
}
void CVRRenderModels_006::FreeTexture(vr::IVRRenderModels_006::RenderModel_TextureMap_t* pTexture) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRRenderModels_006)");
	return base->FreeTexture((OOVR_RenderModel_TextureMap_t*) pTexture);
}
vr::IVRRenderModels_006::EVRRenderModelError CVRRenderModels_006::LoadTextureD3D11_Async(vr::IVRRenderModels_006::TextureID_t textureId, void* pD3D11Device, void** ppD3D11Texture2D) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRRenderModels_006)");
	return (vr::IVRRenderModels_006::EVRRenderModelError) base->LoadTextureD3D11_Async((OOVR_TextureID_t) textureId, pD3D11Device, ppD3D11Texture2D);
}
vr::IVRRenderModels_006::EVRRenderModelError CVRRenderModels_006::LoadIntoTextureD3D11_Async(vr::IVRRenderModels_006::TextureID_t textureId, void* pDstTexture) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRRenderModels_006)");
	return (vr::IVRRenderModels_006::EVRRenderModelError) base->LoadIntoTextureD3D11_Async((OOVR_TextureID_t) textureId, pDstTexture);
}
void CVRRenderModels_006::FreeTextureD3D11(void* pD3D11Texture2D) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRRenderModels_006)");
	return base->FreeTextureD3D11(pD3D11Texture2D);
}
uint32_t CVRRenderModels_006::GetRenderModelName(uint32_t unRenderModelIndex, char* pchRenderModelName, uint32_t unRenderModelNameLen) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRRenderModels_006)");
	return base->GetRenderModelName(unRenderModelIndex, pchRenderModelName, unRenderModelNameLen);
}
uint32_t CVRRenderModels_006::GetRenderModelCount() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRRenderModels_006)");
	return base->GetRenderModelCount();
}
uint32_t CVRRenderModels_006::GetComponentCount(const char* pchRenderModelName) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRRenderModels_006)");
	return base->GetComponentCount(pchRenderModelName);
}
uint32_t CVRRenderModels_006::GetComponentName(const char* pchRenderModelName, uint32_t unComponentIndex, char* pchComponentName, uint32_t unComponentNameLen) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRRenderModels_006)");
	return base->GetComponentName(pchRenderModelName, unComponentIndex, pchComponentName, unComponentNameLen);
}
uint64_t CVRRenderModels_006::GetComponentButtonMask(const char* pchRenderModelName, const char* pchComponentName) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRRenderModels_006)");
	return base->GetComponentButtonMask(pchRenderModelName, pchComponentName);
}
uint32_t CVRRenderModels_006::GetComponentRenderModelName(const char* pchRenderModelName, const char* pchComponentName, char* pchComponentRenderModelName, uint32_t unComponentRenderModelNameLen) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRRenderModels_006)");
	return base->GetComponentRenderModelName(pchRenderModelName, pchComponentName, pchComponentRenderModelName, unComponentRenderModelNameLen);
}
bool CVRRenderModels_006::GetComponentStateForDevicePath(const char* pchRenderModelName, const char* pchComponentName, vr::VRInputValueHandle_t devicePath, const vr::IVRRenderModels_006::RenderModel_ControllerMode_State_t* pState, vr::RenderModel_ComponentState_t* pComponentState) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRRenderModels_006)");
	return base->GetComponentStateForDevicePath(pchRenderModelName, pchComponentName, devicePath, (const OOVR_RenderModel_ControllerMode_State_t*) pState, pComponentState);
}
bool CVRRenderModels_006::GetComponentState(const char* pchRenderModelName, const char* pchComponentName, const vr::VRControllerState_t* pControllerState, const vr::IVRRenderModels_006::RenderModel_ControllerMode_State_t* pState, vr::RenderModel_ComponentState_t* pComponentState) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRRenderModels_006)");
	return base->GetComponentState(pchRenderModelName, pchComponentName, pControllerState, (const OOVR_RenderModel_ControllerMode_State_t*) pState, pComponentState);
}
bool CVRRenderModels_006::RenderModelHasComponent(const char* pchRenderModelName, const char* pchComponentName) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRRenderModels_006)");
	return base->RenderModelHasComponent(pchRenderModelName, pchComponentName);
}
uint32_t CVRRenderModels_006::GetRenderModelThumbnailURL(const char* pchRenderModelName, char* pchThumbnailURL, uint32_t unThumbnailURLLen, vr::IVRRenderModels_006::EVRRenderModelError* peError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRRenderModels_006)");
	return base->GetRenderModelThumbnailURL(pchRenderModelName, pchThumbnailURL, unThumbnailURLLen, (OOVR_EVRRenderModelError*) peError);
}
uint32_t CVRRenderModels_006::GetRenderModelOriginalPath(const char* pchRenderModelName, char* pchOriginalPath, uint32_t unOriginalPathLen, vr::IVRRenderModels_006::EVRRenderModelError* peError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRRenderModels_006)");
	return base->GetRenderModelOriginalPath(pchRenderModelName, pchOriginalPath, unOriginalPathLen, (OOVR_EVRRenderModelError*) peError);
}
const char* CVRRenderModels_006::GetRenderModelErrorNameFromEnum(vr::IVRRenderModels_006::EVRRenderModelError error) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRRenderModels_006)");
	return base->GetRenderModelErrorNameFromEnum((OOVR_EVRRenderModelError) error);
}
// FnTable for CVRRenderModels_006:
static CVRRenderModels_006 *fntable_RenderModels_006_instance = NULL;
static vr::IVRRenderModels_006::EVRRenderModelError OPENVR_FNTABLE_CALLTYPE fntable_RenderModels_006_impl_LoadRenderModel_Async(const char* pchRenderModelName, vr::IVRRenderModels_006::RenderModel_t** ppRenderModel) { return fntable_RenderModels_006_instance->LoadRenderModel_Async(pchRenderModelName, ppRenderModel); }
static void OPENVR_FNTABLE_CALLTYPE fntable_RenderModels_006_impl_FreeRenderModel(vr::IVRRenderModels_006::RenderModel_t* pRenderModel) { return fntable_RenderModels_006_instance->FreeRenderModel(pRenderModel); }
static vr::IVRRenderModels_006::EVRRenderModelError OPENVR_FNTABLE_CALLTYPE fntable_RenderModels_006_impl_LoadTexture_Async(vr::IVRRenderModels_006::TextureID_t textureId, vr::IVRRenderModels_006::RenderModel_TextureMap_t** ppTexture) { return fntable_RenderModels_006_instance->LoadTexture_Async(textureId, ppTexture); }
static void OPENVR_FNTABLE_CALLTYPE fntable_RenderModels_006_impl_FreeTexture(vr::IVRRenderModels_006::RenderModel_TextureMap_t* pTexture) { return fntable_RenderModels_006_instance->FreeTexture(pTexture); }
static vr::IVRRenderModels_006::EVRRenderModelError OPENVR_FNTABLE_CALLTYPE fntable_RenderModels_006_impl_LoadTextureD3D11_Async(vr::IVRRenderModels_006::TextureID_t textureId, void* pD3D11Device, void** ppD3D11Texture2D) { return fntable_RenderModels_006_instance->LoadTextureD3D11_Async(textureId, pD3D11Device, ppD3D11Texture2D); }
static vr::IVRRenderModels_006::EVRRenderModelError OPENVR_FNTABLE_CALLTYPE fntable_RenderModels_006_impl_LoadIntoTextureD3D11_Async(vr::IVRRenderModels_006::TextureID_t textureId, void* pDstTexture) { return fntable_RenderModels_006_instance->LoadIntoTextureD3D11_Async(textureId, pDstTexture); }
static void OPENVR_FNTABLE_CALLTYPE fntable_RenderModels_006_impl_FreeTextureD3D11(void* pD3D11Texture2D) { return fntable_RenderModels_006_instance->FreeTextureD3D11(pD3D11Texture2D); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_RenderModels_006_impl_GetRenderModelName(uint32_t unRenderModelIndex, char* pchRenderModelName, uint32_t unRenderModelNameLen) { return fntable_RenderModels_006_instance->GetRenderModelName(unRenderModelIndex, pchRenderModelName, unRenderModelNameLen); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_RenderModels_006_impl_GetRenderModelCount() { return fntable_RenderModels_006_instance->GetRenderModelCount(); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_RenderModels_006_impl_GetComponentCount(const char* pchRenderModelName) { return fntable_RenderModels_006_instance->GetComponentCount(pchRenderModelName); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_RenderModels_006_impl_GetComponentName(const char* pchRenderModelName, uint32_t unComponentIndex, char* pchComponentName, uint32_t unComponentNameLen) { return fntable_RenderModels_006_instance->GetComponentName(pchRenderModelName, unComponentIndex, pchComponentName, unComponentNameLen); }
static uint64_t OPENVR_FNTABLE_CALLTYPE fntable_RenderModels_006_impl_GetComponentButtonMask(const char* pchRenderModelName, const char* pchComponentName) { return fntable_RenderModels_006_instance->GetComponentButtonMask(pchRenderModelName, pchComponentName); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_RenderModels_006_impl_GetComponentRenderModelName(const char* pchRenderModelName, const char* pchComponentName, char* pchComponentRenderModelName, uint32_t unComponentRenderModelNameLen) { return fntable_RenderModels_006_instance->GetComponentRenderModelName(pchRenderModelName, pchComponentName, pchComponentRenderModelName, unComponentRenderModelNameLen); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_RenderModels_006_impl_GetComponentStateForDevicePath(const char* pchRenderModelName, const char* pchComponentName, vr::VRInputValueHandle_t devicePath, const vr::IVRRenderModels_006::RenderModel_ControllerMode_State_t* pState, vr::RenderModel_ComponentState_t* pComponentState) { return fntable_RenderModels_006_instance->GetComponentStateForDevicePath(pchRenderModelName, pchComponentName, devicePath, pState, pComponentState); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_RenderModels_006_impl_GetComponentState(const char* pchRenderModelName, const char* pchComponentName, const vr::VRControllerState_t* pControllerState, const vr::IVRRenderModels_006::RenderModel_ControllerMode_State_t* pState, vr::RenderModel_ComponentState_t* pComponentState) { return fntable_RenderModels_006_instance->GetComponentState(pchRenderModelName, pchComponentName, pControllerState, pState, pComponentState); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_RenderModels_006_impl_RenderModelHasComponent(const char* pchRenderModelName, const char* pchComponentName) { return fntable_RenderModels_006_instance->RenderModelHasComponent(pchRenderModelName, pchComponentName); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_RenderModels_006_impl_GetRenderModelThumbnailURL(const char* pchRenderModelName, char* pchThumbnailURL, uint32_t unThumbnailURLLen, vr::IVRRenderModels_006::EVRRenderModelError* peError) { return fntable_RenderModels_006_instance->GetRenderModelThumbnailURL(pchRenderModelName, pchThumbnailURL, unThumbnailURLLen, peError); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_RenderModels_006_impl_GetRenderModelOriginalPath(const char* pchRenderModelName, char* pchOriginalPath, uint32_t unOriginalPathLen, vr::IVRRenderModels_006::EVRRenderModelError* peError) { return fntable_RenderModels_006_instance->GetRenderModelOriginalPath(pchRenderModelName, pchOriginalPath, unOriginalPathLen, peError); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_RenderModels_006_impl_GetRenderModelErrorNameFromEnum(vr::IVRRenderModels_006::EVRRenderModelError error) { return fntable_RenderModels_006_instance->GetRenderModelErrorNameFromEnum(error); }
static void *fntable_RenderModels_006_funcs[] = {
	(void*) fntable_RenderModels_006_impl_LoadRenderModel_Async,
	(void*) fntable_RenderModels_006_impl_FreeRenderModel,
	(void*) fntable_RenderModels_006_impl_LoadTexture_Async,
	(void*) fntable_RenderModels_006_impl_FreeTexture,
	(void*) fntable_RenderModels_006_impl_LoadTextureD3D11_Async,
	(void*) fntable_RenderModels_006_impl_LoadIntoTextureD3D11_Async,
	(void*) fntable_RenderModels_006_impl_FreeTextureD3D11,
	(void*) fntable_RenderModels_006_impl_GetRenderModelName,
	(void*) fntable_RenderModels_006_impl_GetRenderModelCount,
	(void*) fntable_RenderModels_006_impl_GetComponentCount,
	(void*) fntable_RenderModels_006_impl_GetComponentName,
	(void*) fntable_RenderModels_006_impl_GetComponentButtonMask,
	(void*) fntable_RenderModels_006_impl_GetComponentRenderModelName,
	(void*) fntable_RenderModels_006_impl_GetComponentStateForDevicePath,
	(void*) fntable_RenderModels_006_impl_GetComponentState,
	(void*) fntable_RenderModels_006_impl_RenderModelHasComponent,
	(void*) fntable_RenderModels_006_impl_GetRenderModelThumbnailURL,
	(void*) fntable_RenderModels_006_impl_GetRenderModelOriginalPath,
	(void*) fntable_RenderModels_006_impl_GetRenderModelErrorNameFromEnum,
};
void** CVRRenderModels_006::_GetStatFuncList() { fntable_RenderModels_006_instance = this; return fntable_RenderModels_006_funcs; }
void CVRRenderModels_006::Delete() { delete this; }
#include "GVRScreenshots.gen.h"
// Single inst of BaseScreenshots
static std::weak_ptr<BaseScreenshots> _single_inst_Screenshots;
static BaseScreenshots *_single_inst_Screenshots_unsafe = NULL;
std::shared_ptr<BaseScreenshots> GetBaseScreenshots() { return _single_inst_Screenshots.lock(); };
BaseScreenshots* GetUnsafeBaseScreenshots() { return _single_inst_Screenshots_unsafe; };
std::shared_ptr<BaseScreenshots> GetCreateBaseScreenshots() {
	std::shared_ptr<BaseScreenshots> ret = _single_inst_Screenshots.lock();
	if(!ret) {
		ret = std::shared_ptr<BaseScreenshots>(new BaseScreenshots(), [](BaseScreenshots *obj){ _single_inst_Screenshots_unsafe = NULL; delete obj; });
		_single_inst_Screenshots = ret;
		_single_inst_Screenshots_unsafe = ret.get();
	}
	return ret;
}
// Misc for CVRScreenshots_001:
CVRScreenshots_001::CVRScreenshots_001() : base(GetCreateBaseScreenshots()) {}
// Interface methods for CVRScreenshots_001:
vr::IVRScreenshots_001::EVRScreenshotError CVRScreenshots_001::RequestScreenshot(vr::ScreenshotHandle_t* pOutScreenshotHandle, vr::EVRScreenshotType type, const char* pchPreviewFilename, const char* pchVRFilename) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRScreenshots_001)");
	return (vr::IVRScreenshots_001::EVRScreenshotError) base->RequestScreenshot(pOutScreenshotHandle, type, pchPreviewFilename, pchVRFilename);
}
vr::IVRScreenshots_001::EVRScreenshotError CVRScreenshots_001::HookScreenshot(const vr::EVRScreenshotType* pSupportedTypes, int numTypes) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRScreenshots_001)");
	return (vr::IVRScreenshots_001::EVRScreenshotError) base->HookScreenshot(pSupportedTypes, numTypes);
}
vr::EVRScreenshotType CVRScreenshots_001::GetScreenshotPropertyType(vr::ScreenshotHandle_t screenshotHandle, vr::IVRScreenshots_001::EVRScreenshotError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRScreenshots_001)");
	return base->GetScreenshotPropertyType(screenshotHandle, (OOVR_EVRScreenshotError*) pError);
}
uint32_t CVRScreenshots_001::GetScreenshotPropertyFilename(vr::ScreenshotHandle_t screenshotHandle, vr::EVRScreenshotPropertyFilenames filenameType, char* pchFilename, uint32_t cchFilename, vr::IVRScreenshots_001::EVRScreenshotError* pError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRScreenshots_001)");
	return base->GetScreenshotPropertyFilename(screenshotHandle, filenameType, pchFilename, cchFilename, (OOVR_EVRScreenshotError*) pError);
}
vr::IVRScreenshots_001::EVRScreenshotError CVRScreenshots_001::UpdateScreenshotProgress(vr::ScreenshotHandle_t screenshotHandle, float flProgress) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRScreenshots_001)");
	return (vr::IVRScreenshots_001::EVRScreenshotError) base->UpdateScreenshotProgress(screenshotHandle, flProgress);
}
vr::IVRScreenshots_001::EVRScreenshotError CVRScreenshots_001::TakeStereoScreenshot(vr::ScreenshotHandle_t* pOutScreenshotHandle, const char* pchPreviewFilename, const char* pchVRFilename) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRScreenshots_001)");
	return (vr::IVRScreenshots_001::EVRScreenshotError) base->TakeStereoScreenshot(pOutScreenshotHandle, pchPreviewFilename, pchVRFilename);
}
vr::IVRScreenshots_001::EVRScreenshotError CVRScreenshots_001::SubmitScreenshot(vr::ScreenshotHandle_t screenshotHandle, vr::EVRScreenshotType type, const char* pchSourcePreviewFilename, const char* pchSourceVRFilename) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRScreenshots_001)");
	return (vr::IVRScreenshots_001::EVRScreenshotError) base->SubmitScreenshot(screenshotHandle, type, pchSourcePreviewFilename, pchSourceVRFilename);
}
// FnTable for CVRScreenshots_001:
static CVRScreenshots_001 *fntable_Screenshots_001_instance = NULL;
static vr::IVRScreenshots_001::EVRScreenshotError OPENVR_FNTABLE_CALLTYPE fntable_Screenshots_001_impl_RequestScreenshot(vr::ScreenshotHandle_t* pOutScreenshotHandle, vr::EVRScreenshotType type, const char* pchPreviewFilename, const char* pchVRFilename) { return fntable_Screenshots_001_instance->RequestScreenshot(pOutScreenshotHandle, type, pchPreviewFilename, pchVRFilename); }
static vr::IVRScreenshots_001::EVRScreenshotError OPENVR_FNTABLE_CALLTYPE fntable_Screenshots_001_impl_HookScreenshot(const vr::EVRScreenshotType* pSupportedTypes, int numTypes) { return fntable_Screenshots_001_instance->HookScreenshot(pSupportedTypes, numTypes); }
static vr::EVRScreenshotType OPENVR_FNTABLE_CALLTYPE fntable_Screenshots_001_impl_GetScreenshotPropertyType(vr::ScreenshotHandle_t screenshotHandle, vr::IVRScreenshots_001::EVRScreenshotError* pError) { return fntable_Screenshots_001_instance->GetScreenshotPropertyType(screenshotHandle, pError); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Screenshots_001_impl_GetScreenshotPropertyFilename(vr::ScreenshotHandle_t screenshotHandle, vr::EVRScreenshotPropertyFilenames filenameType, char* pchFilename, uint32_t cchFilename, vr::IVRScreenshots_001::EVRScreenshotError* pError) { return fntable_Screenshots_001_instance->GetScreenshotPropertyFilename(screenshotHandle, filenameType, pchFilename, cchFilename, pError); }
static vr::IVRScreenshots_001::EVRScreenshotError OPENVR_FNTABLE_CALLTYPE fntable_Screenshots_001_impl_UpdateScreenshotProgress(vr::ScreenshotHandle_t screenshotHandle, float flProgress) { return fntable_Screenshots_001_instance->UpdateScreenshotProgress(screenshotHandle, flProgress); }
static vr::IVRScreenshots_001::EVRScreenshotError OPENVR_FNTABLE_CALLTYPE fntable_Screenshots_001_impl_TakeStereoScreenshot(vr::ScreenshotHandle_t* pOutScreenshotHandle, const char* pchPreviewFilename, const char* pchVRFilename) { return fntable_Screenshots_001_instance->TakeStereoScreenshot(pOutScreenshotHandle, pchPreviewFilename, pchVRFilename); }
static vr::IVRScreenshots_001::EVRScreenshotError OPENVR_FNTABLE_CALLTYPE fntable_Screenshots_001_impl_SubmitScreenshot(vr::ScreenshotHandle_t screenshotHandle, vr::EVRScreenshotType type, const char* pchSourcePreviewFilename, const char* pchSourceVRFilename) { return fntable_Screenshots_001_instance->SubmitScreenshot(screenshotHandle, type, pchSourcePreviewFilename, pchSourceVRFilename); }
static void *fntable_Screenshots_001_funcs[] = {
	(void*) fntable_Screenshots_001_impl_RequestScreenshot,
	(void*) fntable_Screenshots_001_impl_HookScreenshot,
	(void*) fntable_Screenshots_001_impl_GetScreenshotPropertyType,
	(void*) fntable_Screenshots_001_impl_GetScreenshotPropertyFilename,
	(void*) fntable_Screenshots_001_impl_UpdateScreenshotProgress,
	(void*) fntable_Screenshots_001_impl_TakeStereoScreenshot,
	(void*) fntable_Screenshots_001_impl_SubmitScreenshot,
};
void** CVRScreenshots_001::_GetStatFuncList() { fntable_Screenshots_001_instance = this; return fntable_Screenshots_001_funcs; }
void CVRScreenshots_001::Delete() { delete this; }
#include "GVRSettings.gen.h"
// Single inst of BaseSettings
static std::weak_ptr<BaseSettings> _single_inst_Settings;
static BaseSettings *_single_inst_Settings_unsafe = NULL;
std::shared_ptr<BaseSettings> GetBaseSettings() { return _single_inst_Settings.lock(); };
BaseSettings* GetUnsafeBaseSettings() { return _single_inst_Settings_unsafe; };
std::shared_ptr<BaseSettings> GetCreateBaseSettings() {
	std::shared_ptr<BaseSettings> ret = _single_inst_Settings.lock();
	if(!ret) {
		ret = std::shared_ptr<BaseSettings>(new BaseSettings(), [](BaseSettings *obj){ _single_inst_Settings_unsafe = NULL; delete obj; });
		_single_inst_Settings = ret;
		_single_inst_Settings_unsafe = ret.get();
	}
	return ret;
}
// Misc for CVRSettings_001:
CVRSettings_001::CVRSettings_001() : base(GetCreateBaseSettings()) {}
// Interface methods for CVRSettings_001:
const char* CVRSettings_001::GetSettingsErrorNameFromEnum(vr::IVRSettings_001::EVRSettingsError eError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSettings_001)");
	return base->GetSettingsErrorNameFromEnum((OOVR_EVRSettingsError) eError);
}
bool CVRSettings_001::Sync(bool bForce, vr::IVRSettings_001::EVRSettingsError* peError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSettings_001)");
	return base->Sync(bForce, (OOVR_EVRSettingsError*) peError);
}
void CVRSettings_001::SetBool(const char* pchSection, const char* pchSettingsKey, bool bValue, vr::IVRSettings_001::EVRSettingsError* peError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSettings_001)");
	return base->SetBool(pchSection, pchSettingsKey, bValue, (OOVR_EVRSettingsError*) peError);
}
void CVRSettings_001::SetInt32(const char* pchSection, const char* pchSettingsKey, int32_t nValue, vr::IVRSettings_001::EVRSettingsError* peError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSettings_001)");
	return base->SetInt32(pchSection, pchSettingsKey, nValue, (OOVR_EVRSettingsError*) peError);
}
void CVRSettings_001::SetFloat(const char* pchSection, const char* pchSettingsKey, float flValue, vr::IVRSettings_001::EVRSettingsError* peError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSettings_001)");
	return base->SetFloat(pchSection, pchSettingsKey, flValue, (OOVR_EVRSettingsError*) peError);
}
void CVRSettings_001::SetString(const char* pchSection, const char* pchSettingsKey, const char* pchValue, vr::IVRSettings_001::EVRSettingsError* peError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSettings_001)");
	return base->SetString(pchSection, pchSettingsKey, pchValue, (OOVR_EVRSettingsError*) peError);
}
void CVRSettings_001::RemoveSection(const char* pchSection, vr::IVRSettings_001::EVRSettingsError* peError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSettings_001)");
	return base->RemoveSection(pchSection, (OOVR_EVRSettingsError*) peError);
}
void CVRSettings_001::RemoveKeyInSection(const char* pchSection, const char* pchSettingsKey, vr::IVRSettings_001::EVRSettingsError* peError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSettings_001)");
	return base->RemoveKeyInSection(pchSection, pchSettingsKey, (OOVR_EVRSettingsError*) peError);
}
// FnTable for CVRSettings_001:
static CVRSettings_001 *fntable_Settings_001_instance = NULL;
static const char* OPENVR_FNTABLE_CALLTYPE fntable_Settings_001_impl_GetSettingsErrorNameFromEnum(vr::IVRSettings_001::EVRSettingsError eError) { return fntable_Settings_001_instance->GetSettingsErrorNameFromEnum(eError); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Settings_001_impl_Sync(bool bForce, vr::IVRSettings_001::EVRSettingsError* peError) { return fntable_Settings_001_instance->Sync(bForce, peError); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Settings_001_impl_GetBool(const char* pchSection, const char* pchSettingsKey, bool bDefaultValue, vr::IVRSettings_001::EVRSettingsError* peError) { return fntable_Settings_001_instance->GetBool(pchSection, pchSettingsKey, bDefaultValue, peError); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Settings_001_impl_SetBool(const char* pchSection, const char* pchSettingsKey, bool bValue, vr::IVRSettings_001::EVRSettingsError* peError) { return fntable_Settings_001_instance->SetBool(pchSection, pchSettingsKey, bValue, peError); }
static int32_t OPENVR_FNTABLE_CALLTYPE fntable_Settings_001_impl_GetInt32(const char* pchSection, const char* pchSettingsKey, int32_t nDefaultValue, vr::IVRSettings_001::EVRSettingsError* peError) { return fntable_Settings_001_instance->GetInt32(pchSection, pchSettingsKey, nDefaultValue, peError); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Settings_001_impl_SetInt32(const char* pchSection, const char* pchSettingsKey, int32_t nValue, vr::IVRSettings_001::EVRSettingsError* peError) { return fntable_Settings_001_instance->SetInt32(pchSection, pchSettingsKey, nValue, peError); }
static float OPENVR_FNTABLE_CALLTYPE fntable_Settings_001_impl_GetFloat(const char* pchSection, const char* pchSettingsKey, float flDefaultValue, vr::IVRSettings_001::EVRSettingsError* peError) { return fntable_Settings_001_instance->GetFloat(pchSection, pchSettingsKey, flDefaultValue, peError); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Settings_001_impl_SetFloat(const char* pchSection, const char* pchSettingsKey, float flValue, vr::IVRSettings_001::EVRSettingsError* peError) { return fntable_Settings_001_instance->SetFloat(pchSection, pchSettingsKey, flValue, peError); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Settings_001_impl_GetString(const char* pchSection, const char* pchSettingsKey, char* pchValue, uint32_t unValueLen, const char* pchDefaultValue, vr::IVRSettings_001::EVRSettingsError* peError) { return fntable_Settings_001_instance->GetString(pchSection, pchSettingsKey, pchValue, unValueLen, pchDefaultValue, peError); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Settings_001_impl_SetString(const char* pchSection, const char* pchSettingsKey, const char* pchValue, vr::IVRSettings_001::EVRSettingsError* peError) { return fntable_Settings_001_instance->SetString(pchSection, pchSettingsKey, pchValue, peError); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Settings_001_impl_RemoveSection(const char* pchSection, vr::IVRSettings_001::EVRSettingsError* peError) { return fntable_Settings_001_instance->RemoveSection(pchSection, peError); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Settings_001_impl_RemoveKeyInSection(const char* pchSection, const char* pchSettingsKey, vr::IVRSettings_001::EVRSettingsError* peError) { return fntable_Settings_001_instance->RemoveKeyInSection(pchSection, pchSettingsKey, peError); }
static void *fntable_Settings_001_funcs[] = {
	(void*) fntable_Settings_001_impl_GetSettingsErrorNameFromEnum,
	(void*) fntable_Settings_001_impl_Sync,
	(void*) fntable_Settings_001_impl_GetBool,
	(void*) fntable_Settings_001_impl_SetBool,
	(void*) fntable_Settings_001_impl_GetInt32,
	(void*) fntable_Settings_001_impl_SetInt32,
	(void*) fntable_Settings_001_impl_GetFloat,
	(void*) fntable_Settings_001_impl_SetFloat,
	(void*) fntable_Settings_001_impl_GetString,
	(void*) fntable_Settings_001_impl_SetString,
	(void*) fntable_Settings_001_impl_RemoveSection,
	(void*) fntable_Settings_001_impl_RemoveKeyInSection,
};
void** CVRSettings_001::_GetStatFuncList() { fntable_Settings_001_instance = this; return fntable_Settings_001_funcs; }
void CVRSettings_001::Delete() { delete this; }
// Misc for CVRSettings_002:
CVRSettings_002::CVRSettings_002() : base(GetCreateBaseSettings()) {}
// Interface methods for CVRSettings_002:
const char* CVRSettings_002::GetSettingsErrorNameFromEnum(vr::IVRSettings_002::EVRSettingsError eError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSettings_002)");
	return base->GetSettingsErrorNameFromEnum((OOVR_EVRSettingsError) eError);
}
bool CVRSettings_002::Sync(bool bForce, vr::IVRSettings_002::EVRSettingsError* peError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSettings_002)");
	return base->Sync(bForce, (OOVR_EVRSettingsError*) peError);
}
void CVRSettings_002::SetBool(const char* pchSection, const char* pchSettingsKey, bool bValue, vr::IVRSettings_002::EVRSettingsError* peError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSettings_002)");
	return base->SetBool(pchSection, pchSettingsKey, bValue, (OOVR_EVRSettingsError*) peError);
}
void CVRSettings_002::SetInt32(const char* pchSection, const char* pchSettingsKey, int32_t nValue, vr::IVRSettings_002::EVRSettingsError* peError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSettings_002)");
	return base->SetInt32(pchSection, pchSettingsKey, nValue, (OOVR_EVRSettingsError*) peError);
}
void CVRSettings_002::SetFloat(const char* pchSection, const char* pchSettingsKey, float flValue, vr::IVRSettings_002::EVRSettingsError* peError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSettings_002)");
	return base->SetFloat(pchSection, pchSettingsKey, flValue, (OOVR_EVRSettingsError*) peError);
}
void CVRSettings_002::SetString(const char* pchSection, const char* pchSettingsKey, const char* pchValue, vr::IVRSettings_002::EVRSettingsError* peError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSettings_002)");
	return base->SetString(pchSection, pchSettingsKey, pchValue, (OOVR_EVRSettingsError*) peError);
}
bool CVRSettings_002::GetBool(const char* pchSection, const char* pchSettingsKey, vr::IVRSettings_002::EVRSettingsError* peError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSettings_002)");
	return base->GetBool(pchSection, pchSettingsKey, (OOVR_EVRSettingsError*) peError);
}
int32_t CVRSettings_002::GetInt32(const char* pchSection, const char* pchSettingsKey, vr::IVRSettings_002::EVRSettingsError* peError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSettings_002)");
	return base->GetInt32(pchSection, pchSettingsKey, (OOVR_EVRSettingsError*) peError);
}
float CVRSettings_002::GetFloat(const char* pchSection, const char* pchSettingsKey, vr::IVRSettings_002::EVRSettingsError* peError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSettings_002)");
	return base->GetFloat(pchSection, pchSettingsKey, (OOVR_EVRSettingsError*) peError);
}
void CVRSettings_002::GetString(const char* pchSection, const char* pchSettingsKey, char* pchValue, uint32_t unValueLen, vr::IVRSettings_002::EVRSettingsError* peError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSettings_002)");
	return base->GetString(pchSection, pchSettingsKey, pchValue, unValueLen, (OOVR_EVRSettingsError*) peError);
}
void CVRSettings_002::RemoveSection(const char* pchSection, vr::IVRSettings_002::EVRSettingsError* peError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSettings_002)");
	return base->RemoveSection(pchSection, (OOVR_EVRSettingsError*) peError);
}
void CVRSettings_002::RemoveKeyInSection(const char* pchSection, const char* pchSettingsKey, vr::IVRSettings_002::EVRSettingsError* peError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSettings_002)");
	return base->RemoveKeyInSection(pchSection, pchSettingsKey, (OOVR_EVRSettingsError*) peError);
}
// FnTable for CVRSettings_002:
static CVRSettings_002 *fntable_Settings_002_instance = NULL;
static const char* OPENVR_FNTABLE_CALLTYPE fntable_Settings_002_impl_GetSettingsErrorNameFromEnum(vr::IVRSettings_002::EVRSettingsError eError) { return fntable_Settings_002_instance->GetSettingsErrorNameFromEnum(eError); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Settings_002_impl_Sync(bool bForce, vr::IVRSettings_002::EVRSettingsError* peError) { return fntable_Settings_002_instance->Sync(bForce, peError); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Settings_002_impl_SetBool(const char* pchSection, const char* pchSettingsKey, bool bValue, vr::IVRSettings_002::EVRSettingsError* peError) { return fntable_Settings_002_instance->SetBool(pchSection, pchSettingsKey, bValue, peError); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Settings_002_impl_SetInt32(const char* pchSection, const char* pchSettingsKey, int32_t nValue, vr::IVRSettings_002::EVRSettingsError* peError) { return fntable_Settings_002_instance->SetInt32(pchSection, pchSettingsKey, nValue, peError); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Settings_002_impl_SetFloat(const char* pchSection, const char* pchSettingsKey, float flValue, vr::IVRSettings_002::EVRSettingsError* peError) { return fntable_Settings_002_instance->SetFloat(pchSection, pchSettingsKey, flValue, peError); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Settings_002_impl_SetString(const char* pchSection, const char* pchSettingsKey, const char* pchValue, vr::IVRSettings_002::EVRSettingsError* peError) { return fntable_Settings_002_instance->SetString(pchSection, pchSettingsKey, pchValue, peError); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Settings_002_impl_GetBool(const char* pchSection, const char* pchSettingsKey, vr::IVRSettings_002::EVRSettingsError* peError) { return fntable_Settings_002_instance->GetBool(pchSection, pchSettingsKey, peError); }
static int32_t OPENVR_FNTABLE_CALLTYPE fntable_Settings_002_impl_GetInt32(const char* pchSection, const char* pchSettingsKey, vr::IVRSettings_002::EVRSettingsError* peError) { return fntable_Settings_002_instance->GetInt32(pchSection, pchSettingsKey, peError); }
static float OPENVR_FNTABLE_CALLTYPE fntable_Settings_002_impl_GetFloat(const char* pchSection, const char* pchSettingsKey, vr::IVRSettings_002::EVRSettingsError* peError) { return fntable_Settings_002_instance->GetFloat(pchSection, pchSettingsKey, peError); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Settings_002_impl_GetString(const char* pchSection, const char* pchSettingsKey, char* pchValue, uint32_t unValueLen, vr::IVRSettings_002::EVRSettingsError* peError) { return fntable_Settings_002_instance->GetString(pchSection, pchSettingsKey, pchValue, unValueLen, peError); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Settings_002_impl_RemoveSection(const char* pchSection, vr::IVRSettings_002::EVRSettingsError* peError) { return fntable_Settings_002_instance->RemoveSection(pchSection, peError); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Settings_002_impl_RemoveKeyInSection(const char* pchSection, const char* pchSettingsKey, vr::IVRSettings_002::EVRSettingsError* peError) { return fntable_Settings_002_instance->RemoveKeyInSection(pchSection, pchSettingsKey, peError); }
static void *fntable_Settings_002_funcs[] = {
	(void*) fntable_Settings_002_impl_GetSettingsErrorNameFromEnum,
	(void*) fntable_Settings_002_impl_Sync,
	(void*) fntable_Settings_002_impl_SetBool,
	(void*) fntable_Settings_002_impl_SetInt32,
	(void*) fntable_Settings_002_impl_SetFloat,
	(void*) fntable_Settings_002_impl_SetString,
	(void*) fntable_Settings_002_impl_GetBool,
	(void*) fntable_Settings_002_impl_GetInt32,
	(void*) fntable_Settings_002_impl_GetFloat,
	(void*) fntable_Settings_002_impl_GetString,
	(void*) fntable_Settings_002_impl_RemoveSection,
	(void*) fntable_Settings_002_impl_RemoveKeyInSection,
};
void** CVRSettings_002::_GetStatFuncList() { fntable_Settings_002_instance = this; return fntable_Settings_002_funcs; }
void CVRSettings_002::Delete() { delete this; }
// Misc for CVRSettings_003:
CVRSettings_003::CVRSettings_003() : base(GetCreateBaseSettings()) {}
// Interface methods for CVRSettings_003:
const char* CVRSettings_003::GetSettingsErrorNameFromEnum(vr::IVRSettings_003::EVRSettingsError eError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSettings_003)");
	return base->GetSettingsErrorNameFromEnum((OOVR_EVRSettingsError) eError);
}
void CVRSettings_003::SetBool(const char* pchSection, const char* pchSettingsKey, bool bValue, vr::IVRSettings_003::EVRSettingsError* peError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSettings_003)");
	return base->SetBool(pchSection, pchSettingsKey, bValue, (OOVR_EVRSettingsError*) peError);
}
void CVRSettings_003::SetInt32(const char* pchSection, const char* pchSettingsKey, int32_t nValue, vr::IVRSettings_003::EVRSettingsError* peError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSettings_003)");
	return base->SetInt32(pchSection, pchSettingsKey, nValue, (OOVR_EVRSettingsError*) peError);
}
void CVRSettings_003::SetFloat(const char* pchSection, const char* pchSettingsKey, float flValue, vr::IVRSettings_003::EVRSettingsError* peError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSettings_003)");
	return base->SetFloat(pchSection, pchSettingsKey, flValue, (OOVR_EVRSettingsError*) peError);
}
void CVRSettings_003::SetString(const char* pchSection, const char* pchSettingsKey, const char* pchValue, vr::IVRSettings_003::EVRSettingsError* peError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSettings_003)");
	return base->SetString(pchSection, pchSettingsKey, pchValue, (OOVR_EVRSettingsError*) peError);
}
bool CVRSettings_003::GetBool(const char* pchSection, const char* pchSettingsKey, vr::IVRSettings_003::EVRSettingsError* peError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSettings_003)");
	return base->GetBool(pchSection, pchSettingsKey, (OOVR_EVRSettingsError*) peError);
}
int32_t CVRSettings_003::GetInt32(const char* pchSection, const char* pchSettingsKey, vr::IVRSettings_003::EVRSettingsError* peError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSettings_003)");
	return base->GetInt32(pchSection, pchSettingsKey, (OOVR_EVRSettingsError*) peError);
}
float CVRSettings_003::GetFloat(const char* pchSection, const char* pchSettingsKey, vr::IVRSettings_003::EVRSettingsError* peError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSettings_003)");
	return base->GetFloat(pchSection, pchSettingsKey, (OOVR_EVRSettingsError*) peError);
}
void CVRSettings_003::GetString(const char* pchSection, const char* pchSettingsKey, char* pchValue, uint32_t unValueLen, vr::IVRSettings_003::EVRSettingsError* peError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSettings_003)");
	return base->GetString(pchSection, pchSettingsKey, pchValue, unValueLen, (OOVR_EVRSettingsError*) peError);
}
void CVRSettings_003::RemoveSection(const char* pchSection, vr::IVRSettings_003::EVRSettingsError* peError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSettings_003)");
	return base->RemoveSection(pchSection, (OOVR_EVRSettingsError*) peError);
}
void CVRSettings_003::RemoveKeyInSection(const char* pchSection, const char* pchSettingsKey, vr::IVRSettings_003::EVRSettingsError* peError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRSettings_003)");
	return base->RemoveKeyInSection(pchSection, pchSettingsKey, (OOVR_EVRSettingsError*) peError);
}
// FnTable for CVRSettings_003:
static CVRSettings_003 *fntable_Settings_003_instance = NULL;
static const char* OPENVR_FNTABLE_CALLTYPE fntable_Settings_003_impl_GetSettingsErrorNameFromEnum(vr::IVRSettings_003::EVRSettingsError eError) { return fntable_Settings_003_instance->GetSettingsErrorNameFromEnum(eError); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Settings_003_impl_SetBool(const char* pchSection, const char* pchSettingsKey, bool bValue, vr::IVRSettings_003::EVRSettingsError* peError) { return fntable_Settings_003_instance->SetBool(pchSection, pchSettingsKey, bValue, peError); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Settings_003_impl_SetInt32(const char* pchSection, const char* pchSettingsKey, int32_t nValue, vr::IVRSettings_003::EVRSettingsError* peError) { return fntable_Settings_003_instance->SetInt32(pchSection, pchSettingsKey, nValue, peError); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Settings_003_impl_SetFloat(const char* pchSection, const char* pchSettingsKey, float flValue, vr::IVRSettings_003::EVRSettingsError* peError) { return fntable_Settings_003_instance->SetFloat(pchSection, pchSettingsKey, flValue, peError); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Settings_003_impl_SetString(const char* pchSection, const char* pchSettingsKey, const char* pchValue, vr::IVRSettings_003::EVRSettingsError* peError) { return fntable_Settings_003_instance->SetString(pchSection, pchSettingsKey, pchValue, peError); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Settings_003_impl_GetBool(const char* pchSection, const char* pchSettingsKey, vr::IVRSettings_003::EVRSettingsError* peError) { return fntable_Settings_003_instance->GetBool(pchSection, pchSettingsKey, peError); }
static int32_t OPENVR_FNTABLE_CALLTYPE fntable_Settings_003_impl_GetInt32(const char* pchSection, const char* pchSettingsKey, vr::IVRSettings_003::EVRSettingsError* peError) { return fntable_Settings_003_instance->GetInt32(pchSection, pchSettingsKey, peError); }
static float OPENVR_FNTABLE_CALLTYPE fntable_Settings_003_impl_GetFloat(const char* pchSection, const char* pchSettingsKey, vr::IVRSettings_003::EVRSettingsError* peError) { return fntable_Settings_003_instance->GetFloat(pchSection, pchSettingsKey, peError); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Settings_003_impl_GetString(const char* pchSection, const char* pchSettingsKey, char* pchValue, uint32_t unValueLen, vr::IVRSettings_003::EVRSettingsError* peError) { return fntable_Settings_003_instance->GetString(pchSection, pchSettingsKey, pchValue, unValueLen, peError); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Settings_003_impl_RemoveSection(const char* pchSection, vr::IVRSettings_003::EVRSettingsError* peError) { return fntable_Settings_003_instance->RemoveSection(pchSection, peError); }
static void OPENVR_FNTABLE_CALLTYPE fntable_Settings_003_impl_RemoveKeyInSection(const char* pchSection, const char* pchSettingsKey, vr::IVRSettings_003::EVRSettingsError* peError) { return fntable_Settings_003_instance->RemoveKeyInSection(pchSection, pchSettingsKey, peError); }
static void *fntable_Settings_003_funcs[] = {
	(void*) fntable_Settings_003_impl_GetSettingsErrorNameFromEnum,
	(void*) fntable_Settings_003_impl_SetBool,
	(void*) fntable_Settings_003_impl_SetInt32,
	(void*) fntable_Settings_003_impl_SetFloat,
	(void*) fntable_Settings_003_impl_SetString,
	(void*) fntable_Settings_003_impl_GetBool,
	(void*) fntable_Settings_003_impl_GetInt32,
	(void*) fntable_Settings_003_impl_GetFloat,
	(void*) fntable_Settings_003_impl_GetString,
	(void*) fntable_Settings_003_impl_RemoveSection,
	(void*) fntable_Settings_003_impl_RemoveKeyInSection,
};
void** CVRSettings_003::_GetStatFuncList() { fntable_Settings_003_instance = this; return fntable_Settings_003_funcs; }
void CVRSettings_003::Delete() { delete this; }
#include "GVRExtendedDisplay.gen.h"
// Single inst of BaseExtendedDisplay
static std::weak_ptr<BaseExtendedDisplay> _single_inst_ExtendedDisplay;
static BaseExtendedDisplay *_single_inst_ExtendedDisplay_unsafe = NULL;
std::shared_ptr<BaseExtendedDisplay> GetBaseExtendedDisplay() { return _single_inst_ExtendedDisplay.lock(); };
BaseExtendedDisplay* GetUnsafeBaseExtendedDisplay() { return _single_inst_ExtendedDisplay_unsafe; };
std::shared_ptr<BaseExtendedDisplay> GetCreateBaseExtendedDisplay() {
	std::shared_ptr<BaseExtendedDisplay> ret = _single_inst_ExtendedDisplay.lock();
	if(!ret) {
		ret = std::shared_ptr<BaseExtendedDisplay>(new BaseExtendedDisplay(), [](BaseExtendedDisplay *obj){ _single_inst_ExtendedDisplay_unsafe = NULL; delete obj; });
		_single_inst_ExtendedDisplay = ret;
		_single_inst_ExtendedDisplay_unsafe = ret.get();
	}
	return ret;
}
// Misc for CVRExtendedDisplay_001:
CVRExtendedDisplay_001::CVRExtendedDisplay_001() : base(GetCreateBaseExtendedDisplay()) {}
// Interface methods for CVRExtendedDisplay_001:
void CVRExtendedDisplay_001::GetWindowBounds(int32_t* pnX, int32_t* pnY, uint32_t* pnWidth, uint32_t* pnHeight) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRExtendedDisplay_001)");
	return base->GetWindowBounds(pnX, pnY, pnWidth, pnHeight);
}
void CVRExtendedDisplay_001::GetEyeOutputViewport(vr::EVREye eEye, uint32_t* pnX, uint32_t* pnY, uint32_t* pnWidth, uint32_t* pnHeight) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRExtendedDisplay_001)");
	return base->GetEyeOutputViewport(eEye, pnX, pnY, pnWidth, pnHeight);
}
void CVRExtendedDisplay_001::GetDXGIOutputInfo(int32_t* pnAdapterIndex, int32_t* pnAdapterOutputIndex) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRExtendedDisplay_001)");
	return base->GetDXGIOutputInfo(pnAdapterIndex, pnAdapterOutputIndex);
}
// FnTable for CVRExtendedDisplay_001:
static CVRExtendedDisplay_001 *fntable_ExtendedDisplay_001_instance = NULL;
static void OPENVR_FNTABLE_CALLTYPE fntable_ExtendedDisplay_001_impl_GetWindowBounds(int32_t* pnX, int32_t* pnY, uint32_t* pnWidth, uint32_t* pnHeight) { return fntable_ExtendedDisplay_001_instance->GetWindowBounds(pnX, pnY, pnWidth, pnHeight); }
static void OPENVR_FNTABLE_CALLTYPE fntable_ExtendedDisplay_001_impl_GetEyeOutputViewport(vr::EVREye eEye, uint32_t* pnX, uint32_t* pnY, uint32_t* pnWidth, uint32_t* pnHeight) { return fntable_ExtendedDisplay_001_instance->GetEyeOutputViewport(eEye, pnX, pnY, pnWidth, pnHeight); }
static void OPENVR_FNTABLE_CALLTYPE fntable_ExtendedDisplay_001_impl_GetDXGIOutputInfo(int32_t* pnAdapterIndex, int32_t* pnAdapterOutputIndex) { return fntable_ExtendedDisplay_001_instance->GetDXGIOutputInfo(pnAdapterIndex, pnAdapterOutputIndex); }
static void *fntable_ExtendedDisplay_001_funcs[] = {
	(void*) fntable_ExtendedDisplay_001_impl_GetWindowBounds,
	(void*) fntable_ExtendedDisplay_001_impl_GetEyeOutputViewport,
	(void*) fntable_ExtendedDisplay_001_impl_GetDXGIOutputInfo,
};
void** CVRExtendedDisplay_001::_GetStatFuncList() { fntable_ExtendedDisplay_001_instance = this; return fntable_ExtendedDisplay_001_funcs; }
void CVRExtendedDisplay_001::Delete() { delete this; }
#include "GVRApplications.gen.h"
// Single inst of BaseApplications
static std::weak_ptr<BaseApplications> _single_inst_Applications;
static BaseApplications *_single_inst_Applications_unsafe = NULL;
std::shared_ptr<BaseApplications> GetBaseApplications() { return _single_inst_Applications.lock(); };
BaseApplications* GetUnsafeBaseApplications() { return _single_inst_Applications_unsafe; };
std::shared_ptr<BaseApplications> GetCreateBaseApplications() {
	std::shared_ptr<BaseApplications> ret = _single_inst_Applications.lock();
	if(!ret) {
		ret = std::shared_ptr<BaseApplications>(new BaseApplications(), [](BaseApplications *obj){ _single_inst_Applications_unsafe = NULL; delete obj; });
		_single_inst_Applications = ret;
		_single_inst_Applications_unsafe = ret.get();
	}
	return ret;
}
// Misc for CVRApplications_002:
CVRApplications_002::CVRApplications_002() : base(GetCreateBaseApplications()) {}
// Interface methods for CVRApplications_002:
vr::IVRApplications_002::EVRApplicationError CVRApplications_002::AddApplicationManifest(const char* pchApplicationManifestFullPath, bool bTemporary) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_002)");
	return (vr::IVRApplications_002::EVRApplicationError) base->AddApplicationManifest(pchApplicationManifestFullPath, bTemporary);
}
vr::IVRApplications_002::EVRApplicationError CVRApplications_002::RemoveApplicationManifest(const char* pchApplicationManifestFullPath) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_002)");
	return (vr::IVRApplications_002::EVRApplicationError) base->RemoveApplicationManifest(pchApplicationManifestFullPath);
}
bool CVRApplications_002::IsApplicationInstalled(const char* pchAppKey) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_002)");
	return base->IsApplicationInstalled(pchAppKey);
}
uint32_t CVRApplications_002::GetApplicationCount() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_002)");
	return base->GetApplicationCount();
}
vr::IVRApplications_002::EVRApplicationError CVRApplications_002::GetApplicationKeyByIndex(uint32_t unApplicationIndex, char* pchAppKeyBuffer, uint32_t unAppKeyBufferLen) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_002)");
	return (vr::IVRApplications_002::EVRApplicationError) base->GetApplicationKeyByIndex(unApplicationIndex, pchAppKeyBuffer, unAppKeyBufferLen);
}
vr::IVRApplications_002::EVRApplicationError CVRApplications_002::GetApplicationKeyByProcessId(uint32_t unProcessId, char* pchAppKeyBuffer, uint32_t unAppKeyBufferLen) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_002)");
	return (vr::IVRApplications_002::EVRApplicationError) base->GetApplicationKeyByProcessId(unProcessId, pchAppKeyBuffer, unAppKeyBufferLen);
}
vr::IVRApplications_002::EVRApplicationError CVRApplications_002::LaunchApplication(const char* pchAppKey) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_002)");
	return (vr::IVRApplications_002::EVRApplicationError) base->LaunchApplication(pchAppKey);
}
vr::IVRApplications_002::EVRApplicationError CVRApplications_002::LaunchDashboardOverlay(const char* pchAppKey) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_002)");
	return (vr::IVRApplications_002::EVRApplicationError) base->LaunchDashboardOverlay(pchAppKey);
}
vr::IVRApplications_002::EVRApplicationError CVRApplications_002::IdentifyApplication(uint32_t unProcessId, const char* pchAppKey) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_002)");
	return (vr::IVRApplications_002::EVRApplicationError) base->IdentifyApplication(unProcessId, pchAppKey);
}
uint32_t CVRApplications_002::GetApplicationProcessId(const char* pchAppKey) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_002)");
	return base->GetApplicationProcessId(pchAppKey);
}
const char* CVRApplications_002::GetApplicationsErrorNameFromEnum(vr::IVRApplications_002::EVRApplicationError error) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_002)");
	return base->GetApplicationsErrorNameFromEnum((OOVR_EVRApplicationError) error);
}
uint32_t CVRApplications_002::GetApplicationPropertyString(const char* pchAppKey, vr::IVRApplications_002::EVRApplicationProperty eProperty, char* pchPropertyValueBuffer, uint32_t unPropertyValueBufferLen, vr::IVRApplications_002::EVRApplicationError* peError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_002)");
	return base->GetApplicationPropertyString(pchAppKey, (OOVR_EVRApplicationProperty) eProperty, pchPropertyValueBuffer, unPropertyValueBufferLen, (OOVR_EVRApplicationError*) peError);
}
bool CVRApplications_002::GetApplicationPropertyBool(const char* pchAppKey, vr::IVRApplications_002::EVRApplicationProperty eProperty, vr::IVRApplications_002::EVRApplicationError* peError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_002)");
	return base->GetApplicationPropertyBool(pchAppKey, (OOVR_EVRApplicationProperty) eProperty, (OOVR_EVRApplicationError*) peError);
}
vr::IVRApplications_002::EVRApplicationError CVRApplications_002::SetApplicationAutoLaunch(const char* pchAppKey, bool bAutoLaunch) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_002)");
	return (vr::IVRApplications_002::EVRApplicationError) base->SetApplicationAutoLaunch(pchAppKey, bAutoLaunch);
}
bool CVRApplications_002::GetApplicationAutoLaunch(const char* pchAppKey) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_002)");
	return base->GetApplicationAutoLaunch(pchAppKey);
}
vr::IVRApplications_002::EVRApplicationError CVRApplications_002::GetStartingApplication(char* pchAppKeyBuffer, uint32_t unAppKeyBufferLen) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_002)");
	return (vr::IVRApplications_002::EVRApplicationError) base->GetStartingApplication(pchAppKeyBuffer, unAppKeyBufferLen);
}
vr::IVRApplications_002::EVRApplicationTransitionState CVRApplications_002::GetTransitionState() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_002)");
	return (vr::IVRApplications_002::EVRApplicationTransitionState) base->GetTransitionState();
}
vr::IVRApplications_002::EVRApplicationError CVRApplications_002::PerformApplicationPrelaunchCheck(const char* pchAppKey) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_002)");
	return (vr::IVRApplications_002::EVRApplicationError) base->PerformApplicationPrelaunchCheck(pchAppKey);
}
const char* CVRApplications_002::GetApplicationsTransitionStateNameFromEnum(vr::IVRApplications_002::EVRApplicationTransitionState state) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_002)");
	return base->GetApplicationsTransitionStateNameFromEnum((OOVR_EVRApplicationTransitionState) state);
}
bool CVRApplications_002::IsQuitUserPromptRequested() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_002)");
	return base->IsQuitUserPromptRequested();
}
// FnTable for CVRApplications_002:
static CVRApplications_002 *fntable_Applications_002_instance = NULL;
static vr::IVRApplications_002::EVRApplicationError OPENVR_FNTABLE_CALLTYPE fntable_Applications_002_impl_AddApplicationManifest(const char* pchApplicationManifestFullPath, bool bTemporary) { return fntable_Applications_002_instance->AddApplicationManifest(pchApplicationManifestFullPath, bTemporary); }
static vr::IVRApplications_002::EVRApplicationError OPENVR_FNTABLE_CALLTYPE fntable_Applications_002_impl_RemoveApplicationManifest(const char* pchApplicationManifestFullPath) { return fntable_Applications_002_instance->RemoveApplicationManifest(pchApplicationManifestFullPath); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Applications_002_impl_IsApplicationInstalled(const char* pchAppKey) { return fntable_Applications_002_instance->IsApplicationInstalled(pchAppKey); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Applications_002_impl_GetApplicationCount() { return fntable_Applications_002_instance->GetApplicationCount(); }
static vr::IVRApplications_002::EVRApplicationError OPENVR_FNTABLE_CALLTYPE fntable_Applications_002_impl_GetApplicationKeyByIndex(uint32_t unApplicationIndex, char* pchAppKeyBuffer, uint32_t unAppKeyBufferLen) { return fntable_Applications_002_instance->GetApplicationKeyByIndex(unApplicationIndex, pchAppKeyBuffer, unAppKeyBufferLen); }
static vr::IVRApplications_002::EVRApplicationError OPENVR_FNTABLE_CALLTYPE fntable_Applications_002_impl_GetApplicationKeyByProcessId(uint32_t unProcessId, char* pchAppKeyBuffer, uint32_t unAppKeyBufferLen) { return fntable_Applications_002_instance->GetApplicationKeyByProcessId(unProcessId, pchAppKeyBuffer, unAppKeyBufferLen); }
static vr::IVRApplications_002::EVRApplicationError OPENVR_FNTABLE_CALLTYPE fntable_Applications_002_impl_LaunchApplication(const char* pchAppKey) { return fntable_Applications_002_instance->LaunchApplication(pchAppKey); }
static vr::IVRApplications_002::EVRApplicationError OPENVR_FNTABLE_CALLTYPE fntable_Applications_002_impl_LaunchDashboardOverlay(const char* pchAppKey) { return fntable_Applications_002_instance->LaunchDashboardOverlay(pchAppKey); }
static vr::IVRApplications_002::EVRApplicationError OPENVR_FNTABLE_CALLTYPE fntable_Applications_002_impl_IdentifyApplication(uint32_t unProcessId, const char* pchAppKey) { return fntable_Applications_002_instance->IdentifyApplication(unProcessId, pchAppKey); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Applications_002_impl_GetApplicationProcessId(const char* pchAppKey) { return fntable_Applications_002_instance->GetApplicationProcessId(pchAppKey); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_Applications_002_impl_GetApplicationsErrorNameFromEnum(vr::IVRApplications_002::EVRApplicationError error) { return fntable_Applications_002_instance->GetApplicationsErrorNameFromEnum(error); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Applications_002_impl_GetApplicationPropertyString(const char* pchAppKey, vr::IVRApplications_002::EVRApplicationProperty eProperty, char* pchPropertyValueBuffer, uint32_t unPropertyValueBufferLen, vr::IVRApplications_002::EVRApplicationError* peError) { return fntable_Applications_002_instance->GetApplicationPropertyString(pchAppKey, eProperty, pchPropertyValueBuffer, unPropertyValueBufferLen, peError); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Applications_002_impl_GetApplicationPropertyBool(const char* pchAppKey, vr::IVRApplications_002::EVRApplicationProperty eProperty, vr::IVRApplications_002::EVRApplicationError* peError) { return fntable_Applications_002_instance->GetApplicationPropertyBool(pchAppKey, eProperty, peError); }
static vr::IVRApplications_002::EVRApplicationError OPENVR_FNTABLE_CALLTYPE fntable_Applications_002_impl_SetApplicationAutoLaunch(const char* pchAppKey, bool bAutoLaunch) { return fntable_Applications_002_instance->SetApplicationAutoLaunch(pchAppKey, bAutoLaunch); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Applications_002_impl_GetApplicationAutoLaunch(const char* pchAppKey) { return fntable_Applications_002_instance->GetApplicationAutoLaunch(pchAppKey); }
static vr::IVRApplications_002::EVRApplicationError OPENVR_FNTABLE_CALLTYPE fntable_Applications_002_impl_GetStartingApplication(char* pchAppKeyBuffer, uint32_t unAppKeyBufferLen) { return fntable_Applications_002_instance->GetStartingApplication(pchAppKeyBuffer, unAppKeyBufferLen); }
static vr::IVRApplications_002::EVRApplicationTransitionState OPENVR_FNTABLE_CALLTYPE fntable_Applications_002_impl_GetTransitionState() { return fntable_Applications_002_instance->GetTransitionState(); }
static vr::IVRApplications_002::EVRApplicationError OPENVR_FNTABLE_CALLTYPE fntable_Applications_002_impl_PerformApplicationPrelaunchCheck(const char* pchAppKey) { return fntable_Applications_002_instance->PerformApplicationPrelaunchCheck(pchAppKey); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_Applications_002_impl_GetApplicationsTransitionStateNameFromEnum(vr::IVRApplications_002::EVRApplicationTransitionState state) { return fntable_Applications_002_instance->GetApplicationsTransitionStateNameFromEnum(state); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Applications_002_impl_IsQuitUserPromptRequested() { return fntable_Applications_002_instance->IsQuitUserPromptRequested(); }
static void *fntable_Applications_002_funcs[] = {
	(void*) fntable_Applications_002_impl_AddApplicationManifest,
	(void*) fntable_Applications_002_impl_RemoveApplicationManifest,
	(void*) fntable_Applications_002_impl_IsApplicationInstalled,
	(void*) fntable_Applications_002_impl_GetApplicationCount,
	(void*) fntable_Applications_002_impl_GetApplicationKeyByIndex,
	(void*) fntable_Applications_002_impl_GetApplicationKeyByProcessId,
	(void*) fntable_Applications_002_impl_LaunchApplication,
	(void*) fntable_Applications_002_impl_LaunchDashboardOverlay,
	(void*) fntable_Applications_002_impl_IdentifyApplication,
	(void*) fntable_Applications_002_impl_GetApplicationProcessId,
	(void*) fntable_Applications_002_impl_GetApplicationsErrorNameFromEnum,
	(void*) fntable_Applications_002_impl_GetApplicationPropertyString,
	(void*) fntable_Applications_002_impl_GetApplicationPropertyBool,
	(void*) fntable_Applications_002_impl_SetApplicationAutoLaunch,
	(void*) fntable_Applications_002_impl_GetApplicationAutoLaunch,
	(void*) fntable_Applications_002_impl_GetStartingApplication,
	(void*) fntable_Applications_002_impl_GetTransitionState,
	(void*) fntable_Applications_002_impl_PerformApplicationPrelaunchCheck,
	(void*) fntable_Applications_002_impl_GetApplicationsTransitionStateNameFromEnum,
	(void*) fntable_Applications_002_impl_IsQuitUserPromptRequested,
};
void** CVRApplications_002::_GetStatFuncList() { fntable_Applications_002_instance = this; return fntable_Applications_002_funcs; }
void CVRApplications_002::Delete() { delete this; }
// Misc for CVRApplications_004:
CVRApplications_004::CVRApplications_004() : base(GetCreateBaseApplications()) {}
// Interface methods for CVRApplications_004:
vr::IVRApplications_004::EVRApplicationError CVRApplications_004::AddApplicationManifest(const char* pchApplicationManifestFullPath, bool bTemporary) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_004)");
	return (vr::IVRApplications_004::EVRApplicationError) base->AddApplicationManifest(pchApplicationManifestFullPath, bTemporary);
}
vr::IVRApplications_004::EVRApplicationError CVRApplications_004::RemoveApplicationManifest(const char* pchApplicationManifestFullPath) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_004)");
	return (vr::IVRApplications_004::EVRApplicationError) base->RemoveApplicationManifest(pchApplicationManifestFullPath);
}
bool CVRApplications_004::IsApplicationInstalled(const char* pchAppKey) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_004)");
	return base->IsApplicationInstalled(pchAppKey);
}
uint32_t CVRApplications_004::GetApplicationCount() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_004)");
	return base->GetApplicationCount();
}
vr::IVRApplications_004::EVRApplicationError CVRApplications_004::GetApplicationKeyByIndex(uint32_t unApplicationIndex, char* pchAppKeyBuffer, uint32_t unAppKeyBufferLen) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_004)");
	return (vr::IVRApplications_004::EVRApplicationError) base->GetApplicationKeyByIndex(unApplicationIndex, pchAppKeyBuffer, unAppKeyBufferLen);
}
vr::IVRApplications_004::EVRApplicationError CVRApplications_004::GetApplicationKeyByProcessId(uint32_t unProcessId, char* pchAppKeyBuffer, uint32_t unAppKeyBufferLen) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_004)");
	return (vr::IVRApplications_004::EVRApplicationError) base->GetApplicationKeyByProcessId(unProcessId, pchAppKeyBuffer, unAppKeyBufferLen);
}
vr::IVRApplications_004::EVRApplicationError CVRApplications_004::LaunchApplication(const char* pchAppKey) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_004)");
	return (vr::IVRApplications_004::EVRApplicationError) base->LaunchApplication(pchAppKey);
}
vr::IVRApplications_004::EVRApplicationError CVRApplications_004::LaunchDashboardOverlay(const char* pchAppKey) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_004)");
	return (vr::IVRApplications_004::EVRApplicationError) base->LaunchDashboardOverlay(pchAppKey);
}
bool CVRApplications_004::CancelApplicationLaunch(const char* pchAppKey) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_004)");
	return base->CancelApplicationLaunch(pchAppKey);
}
vr::IVRApplications_004::EVRApplicationError CVRApplications_004::IdentifyApplication(uint32_t unProcessId, const char* pchAppKey) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_004)");
	return (vr::IVRApplications_004::EVRApplicationError) base->IdentifyApplication(unProcessId, pchAppKey);
}
uint32_t CVRApplications_004::GetApplicationProcessId(const char* pchAppKey) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_004)");
	return base->GetApplicationProcessId(pchAppKey);
}
const char* CVRApplications_004::GetApplicationsErrorNameFromEnum(vr::IVRApplications_004::EVRApplicationError error) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_004)");
	return base->GetApplicationsErrorNameFromEnum((OOVR_EVRApplicationError) error);
}
uint32_t CVRApplications_004::GetApplicationPropertyString(const char* pchAppKey, vr::IVRApplications_004::EVRApplicationProperty eProperty, char* pchPropertyValueBuffer, uint32_t unPropertyValueBufferLen, vr::IVRApplications_004::EVRApplicationError* peError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_004)");
	return base->GetApplicationPropertyString(pchAppKey, (OOVR_EVRApplicationProperty) eProperty, pchPropertyValueBuffer, unPropertyValueBufferLen, (OOVR_EVRApplicationError*) peError);
}
bool CVRApplications_004::GetApplicationPropertyBool(const char* pchAppKey, vr::IVRApplications_004::EVRApplicationProperty eProperty, vr::IVRApplications_004::EVRApplicationError* peError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_004)");
	return base->GetApplicationPropertyBool(pchAppKey, (OOVR_EVRApplicationProperty) eProperty, (OOVR_EVRApplicationError*) peError);
}
uint64_t CVRApplications_004::GetApplicationPropertyUint64(const char* pchAppKey, vr::IVRApplications_004::EVRApplicationProperty eProperty, vr::IVRApplications_004::EVRApplicationError* peError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_004)");
	return base->GetApplicationPropertyUint64(pchAppKey, (OOVR_EVRApplicationProperty) eProperty, (OOVR_EVRApplicationError*) peError);
}
vr::IVRApplications_004::EVRApplicationError CVRApplications_004::SetApplicationAutoLaunch(const char* pchAppKey, bool bAutoLaunch) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_004)");
	return (vr::IVRApplications_004::EVRApplicationError) base->SetApplicationAutoLaunch(pchAppKey, bAutoLaunch);
}
bool CVRApplications_004::GetApplicationAutoLaunch(const char* pchAppKey) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_004)");
	return base->GetApplicationAutoLaunch(pchAppKey);
}
vr::IVRApplications_004::EVRApplicationError CVRApplications_004::GetStartingApplication(char* pchAppKeyBuffer, uint32_t unAppKeyBufferLen) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_004)");
	return (vr::IVRApplications_004::EVRApplicationError) base->GetStartingApplication(pchAppKeyBuffer, unAppKeyBufferLen);
}
vr::IVRApplications_004::EVRApplicationTransitionState CVRApplications_004::GetTransitionState() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_004)");
	return (vr::IVRApplications_004::EVRApplicationTransitionState) base->GetTransitionState();
}
vr::IVRApplications_004::EVRApplicationError CVRApplications_004::PerformApplicationPrelaunchCheck(const char* pchAppKey) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_004)");
	return (vr::IVRApplications_004::EVRApplicationError) base->PerformApplicationPrelaunchCheck(pchAppKey);
}
const char* CVRApplications_004::GetApplicationsTransitionStateNameFromEnum(vr::IVRApplications_004::EVRApplicationTransitionState state) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_004)");
	return base->GetApplicationsTransitionStateNameFromEnum((OOVR_EVRApplicationTransitionState) state);
}
bool CVRApplications_004::IsQuitUserPromptRequested() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_004)");
	return base->IsQuitUserPromptRequested();
}
vr::IVRApplications_004::EVRApplicationError CVRApplications_004::LaunchInternalProcess(const char* pchBinaryPath, const char* pchArguments, const char* pchWorkingDirectory) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_004)");
	return (vr::IVRApplications_004::EVRApplicationError) base->LaunchInternalProcess(pchBinaryPath, pchArguments, pchWorkingDirectory);
}
// FnTable for CVRApplications_004:
static CVRApplications_004 *fntable_Applications_004_instance = NULL;
static vr::IVRApplications_004::EVRApplicationError OPENVR_FNTABLE_CALLTYPE fntable_Applications_004_impl_AddApplicationManifest(const char* pchApplicationManifestFullPath, bool bTemporary) { return fntable_Applications_004_instance->AddApplicationManifest(pchApplicationManifestFullPath, bTemporary); }
static vr::IVRApplications_004::EVRApplicationError OPENVR_FNTABLE_CALLTYPE fntable_Applications_004_impl_RemoveApplicationManifest(const char* pchApplicationManifestFullPath) { return fntable_Applications_004_instance->RemoveApplicationManifest(pchApplicationManifestFullPath); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Applications_004_impl_IsApplicationInstalled(const char* pchAppKey) { return fntable_Applications_004_instance->IsApplicationInstalled(pchAppKey); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Applications_004_impl_GetApplicationCount() { return fntable_Applications_004_instance->GetApplicationCount(); }
static vr::IVRApplications_004::EVRApplicationError OPENVR_FNTABLE_CALLTYPE fntable_Applications_004_impl_GetApplicationKeyByIndex(uint32_t unApplicationIndex, char* pchAppKeyBuffer, uint32_t unAppKeyBufferLen) { return fntable_Applications_004_instance->GetApplicationKeyByIndex(unApplicationIndex, pchAppKeyBuffer, unAppKeyBufferLen); }
static vr::IVRApplications_004::EVRApplicationError OPENVR_FNTABLE_CALLTYPE fntable_Applications_004_impl_GetApplicationKeyByProcessId(uint32_t unProcessId, char* pchAppKeyBuffer, uint32_t unAppKeyBufferLen) { return fntable_Applications_004_instance->GetApplicationKeyByProcessId(unProcessId, pchAppKeyBuffer, unAppKeyBufferLen); }
static vr::IVRApplications_004::EVRApplicationError OPENVR_FNTABLE_CALLTYPE fntable_Applications_004_impl_LaunchApplication(const char* pchAppKey) { return fntable_Applications_004_instance->LaunchApplication(pchAppKey); }
static vr::IVRApplications_004::EVRApplicationError OPENVR_FNTABLE_CALLTYPE fntable_Applications_004_impl_LaunchDashboardOverlay(const char* pchAppKey) { return fntable_Applications_004_instance->LaunchDashboardOverlay(pchAppKey); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Applications_004_impl_CancelApplicationLaunch(const char* pchAppKey) { return fntable_Applications_004_instance->CancelApplicationLaunch(pchAppKey); }
static vr::IVRApplications_004::EVRApplicationError OPENVR_FNTABLE_CALLTYPE fntable_Applications_004_impl_IdentifyApplication(uint32_t unProcessId, const char* pchAppKey) { return fntable_Applications_004_instance->IdentifyApplication(unProcessId, pchAppKey); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Applications_004_impl_GetApplicationProcessId(const char* pchAppKey) { return fntable_Applications_004_instance->GetApplicationProcessId(pchAppKey); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_Applications_004_impl_GetApplicationsErrorNameFromEnum(vr::IVRApplications_004::EVRApplicationError error) { return fntable_Applications_004_instance->GetApplicationsErrorNameFromEnum(error); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Applications_004_impl_GetApplicationPropertyString(const char* pchAppKey, vr::IVRApplications_004::EVRApplicationProperty eProperty, char* pchPropertyValueBuffer, uint32_t unPropertyValueBufferLen, vr::IVRApplications_004::EVRApplicationError* peError) { return fntable_Applications_004_instance->GetApplicationPropertyString(pchAppKey, eProperty, pchPropertyValueBuffer, unPropertyValueBufferLen, peError); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Applications_004_impl_GetApplicationPropertyBool(const char* pchAppKey, vr::IVRApplications_004::EVRApplicationProperty eProperty, vr::IVRApplications_004::EVRApplicationError* peError) { return fntable_Applications_004_instance->GetApplicationPropertyBool(pchAppKey, eProperty, peError); }
static uint64_t OPENVR_FNTABLE_CALLTYPE fntable_Applications_004_impl_GetApplicationPropertyUint64(const char* pchAppKey, vr::IVRApplications_004::EVRApplicationProperty eProperty, vr::IVRApplications_004::EVRApplicationError* peError) { return fntable_Applications_004_instance->GetApplicationPropertyUint64(pchAppKey, eProperty, peError); }
static vr::IVRApplications_004::EVRApplicationError OPENVR_FNTABLE_CALLTYPE fntable_Applications_004_impl_SetApplicationAutoLaunch(const char* pchAppKey, bool bAutoLaunch) { return fntable_Applications_004_instance->SetApplicationAutoLaunch(pchAppKey, bAutoLaunch); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Applications_004_impl_GetApplicationAutoLaunch(const char* pchAppKey) { return fntable_Applications_004_instance->GetApplicationAutoLaunch(pchAppKey); }
static vr::IVRApplications_004::EVRApplicationError OPENVR_FNTABLE_CALLTYPE fntable_Applications_004_impl_GetStartingApplication(char* pchAppKeyBuffer, uint32_t unAppKeyBufferLen) { return fntable_Applications_004_instance->GetStartingApplication(pchAppKeyBuffer, unAppKeyBufferLen); }
static vr::IVRApplications_004::EVRApplicationTransitionState OPENVR_FNTABLE_CALLTYPE fntable_Applications_004_impl_GetTransitionState() { return fntable_Applications_004_instance->GetTransitionState(); }
static vr::IVRApplications_004::EVRApplicationError OPENVR_FNTABLE_CALLTYPE fntable_Applications_004_impl_PerformApplicationPrelaunchCheck(const char* pchAppKey) { return fntable_Applications_004_instance->PerformApplicationPrelaunchCheck(pchAppKey); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_Applications_004_impl_GetApplicationsTransitionStateNameFromEnum(vr::IVRApplications_004::EVRApplicationTransitionState state) { return fntable_Applications_004_instance->GetApplicationsTransitionStateNameFromEnum(state); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Applications_004_impl_IsQuitUserPromptRequested() { return fntable_Applications_004_instance->IsQuitUserPromptRequested(); }
static vr::IVRApplications_004::EVRApplicationError OPENVR_FNTABLE_CALLTYPE fntable_Applications_004_impl_LaunchInternalProcess(const char* pchBinaryPath, const char* pchArguments, const char* pchWorkingDirectory) { return fntable_Applications_004_instance->LaunchInternalProcess(pchBinaryPath, pchArguments, pchWorkingDirectory); }
static void *fntable_Applications_004_funcs[] = {
	(void*) fntable_Applications_004_impl_AddApplicationManifest,
	(void*) fntable_Applications_004_impl_RemoveApplicationManifest,
	(void*) fntable_Applications_004_impl_IsApplicationInstalled,
	(void*) fntable_Applications_004_impl_GetApplicationCount,
	(void*) fntable_Applications_004_impl_GetApplicationKeyByIndex,
	(void*) fntable_Applications_004_impl_GetApplicationKeyByProcessId,
	(void*) fntable_Applications_004_impl_LaunchApplication,
	(void*) fntable_Applications_004_impl_LaunchDashboardOverlay,
	(void*) fntable_Applications_004_impl_CancelApplicationLaunch,
	(void*) fntable_Applications_004_impl_IdentifyApplication,
	(void*) fntable_Applications_004_impl_GetApplicationProcessId,
	(void*) fntable_Applications_004_impl_GetApplicationsErrorNameFromEnum,
	(void*) fntable_Applications_004_impl_GetApplicationPropertyString,
	(void*) fntable_Applications_004_impl_GetApplicationPropertyBool,
	(void*) fntable_Applications_004_impl_GetApplicationPropertyUint64,
	(void*) fntable_Applications_004_impl_SetApplicationAutoLaunch,
	(void*) fntable_Applications_004_impl_GetApplicationAutoLaunch,
	(void*) fntable_Applications_004_impl_GetStartingApplication,
	(void*) fntable_Applications_004_impl_GetTransitionState,
	(void*) fntable_Applications_004_impl_PerformApplicationPrelaunchCheck,
	(void*) fntable_Applications_004_impl_GetApplicationsTransitionStateNameFromEnum,
	(void*) fntable_Applications_004_impl_IsQuitUserPromptRequested,
	(void*) fntable_Applications_004_impl_LaunchInternalProcess,
};
void** CVRApplications_004::_GetStatFuncList() { fntable_Applications_004_instance = this; return fntable_Applications_004_funcs; }
void CVRApplications_004::Delete() { delete this; }
// Misc for CVRApplications_005:
CVRApplications_005::CVRApplications_005() : base(GetCreateBaseApplications()) {}
// Interface methods for CVRApplications_005:
vr::IVRApplications_005::EVRApplicationError CVRApplications_005::AddApplicationManifest(const char* pchApplicationManifestFullPath, bool bTemporary) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_005)");
	return (vr::IVRApplications_005::EVRApplicationError) base->AddApplicationManifest(pchApplicationManifestFullPath, bTemporary);
}
vr::IVRApplications_005::EVRApplicationError CVRApplications_005::RemoveApplicationManifest(const char* pchApplicationManifestFullPath) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_005)");
	return (vr::IVRApplications_005::EVRApplicationError) base->RemoveApplicationManifest(pchApplicationManifestFullPath);
}
bool CVRApplications_005::IsApplicationInstalled(const char* pchAppKey) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_005)");
	return base->IsApplicationInstalled(pchAppKey);
}
uint32_t CVRApplications_005::GetApplicationCount() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_005)");
	return base->GetApplicationCount();
}
vr::IVRApplications_005::EVRApplicationError CVRApplications_005::GetApplicationKeyByIndex(uint32_t unApplicationIndex, char* pchAppKeyBuffer, uint32_t unAppKeyBufferLen) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_005)");
	return (vr::IVRApplications_005::EVRApplicationError) base->GetApplicationKeyByIndex(unApplicationIndex, pchAppKeyBuffer, unAppKeyBufferLen);
}
vr::IVRApplications_005::EVRApplicationError CVRApplications_005::GetApplicationKeyByProcessId(uint32_t unProcessId, char* pchAppKeyBuffer, uint32_t unAppKeyBufferLen) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_005)");
	return (vr::IVRApplications_005::EVRApplicationError) base->GetApplicationKeyByProcessId(unProcessId, pchAppKeyBuffer, unAppKeyBufferLen);
}
vr::IVRApplications_005::EVRApplicationError CVRApplications_005::LaunchApplication(const char* pchAppKey) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_005)");
	return (vr::IVRApplications_005::EVRApplicationError) base->LaunchApplication(pchAppKey);
}
vr::IVRApplications_005::EVRApplicationError CVRApplications_005::LaunchTemplateApplication(const char* pchTemplateAppKey, const char* pchNewAppKey, const vr::IVRApplications_005::AppOverrideKeys_t* pKeys, uint32_t unKeys) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_005)");
	return (vr::IVRApplications_005::EVRApplicationError) base->LaunchTemplateApplication(pchTemplateAppKey, pchNewAppKey, (const OOVR_AppOverrideKeys_t*) pKeys, unKeys);
}
vr::IVRApplications_005::EVRApplicationError CVRApplications_005::LaunchDashboardOverlay(const char* pchAppKey) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_005)");
	return (vr::IVRApplications_005::EVRApplicationError) base->LaunchDashboardOverlay(pchAppKey);
}
bool CVRApplications_005::CancelApplicationLaunch(const char* pchAppKey) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_005)");
	return base->CancelApplicationLaunch(pchAppKey);
}
vr::IVRApplications_005::EVRApplicationError CVRApplications_005::IdentifyApplication(uint32_t unProcessId, const char* pchAppKey) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_005)");
	return (vr::IVRApplications_005::EVRApplicationError) base->IdentifyApplication(unProcessId, pchAppKey);
}
uint32_t CVRApplications_005::GetApplicationProcessId(const char* pchAppKey) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_005)");
	return base->GetApplicationProcessId(pchAppKey);
}
const char* CVRApplications_005::GetApplicationsErrorNameFromEnum(vr::IVRApplications_005::EVRApplicationError error) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_005)");
	return base->GetApplicationsErrorNameFromEnum((OOVR_EVRApplicationError) error);
}
uint32_t CVRApplications_005::GetApplicationPropertyString(const char* pchAppKey, vr::IVRApplications_005::EVRApplicationProperty eProperty, char* pchPropertyValueBuffer, uint32_t unPropertyValueBufferLen, vr::IVRApplications_005::EVRApplicationError* peError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_005)");
	return base->GetApplicationPropertyString(pchAppKey, (OOVR_EVRApplicationProperty) eProperty, pchPropertyValueBuffer, unPropertyValueBufferLen, (OOVR_EVRApplicationError*) peError);
}
bool CVRApplications_005::GetApplicationPropertyBool(const char* pchAppKey, vr::IVRApplications_005::EVRApplicationProperty eProperty, vr::IVRApplications_005::EVRApplicationError* peError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_005)");
	return base->GetApplicationPropertyBool(pchAppKey, (OOVR_EVRApplicationProperty) eProperty, (OOVR_EVRApplicationError*) peError);
}
uint64_t CVRApplications_005::GetApplicationPropertyUint64(const char* pchAppKey, vr::IVRApplications_005::EVRApplicationProperty eProperty, vr::IVRApplications_005::EVRApplicationError* peError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_005)");
	return base->GetApplicationPropertyUint64(pchAppKey, (OOVR_EVRApplicationProperty) eProperty, (OOVR_EVRApplicationError*) peError);
}
vr::IVRApplications_005::EVRApplicationError CVRApplications_005::SetApplicationAutoLaunch(const char* pchAppKey, bool bAutoLaunch) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_005)");
	return (vr::IVRApplications_005::EVRApplicationError) base->SetApplicationAutoLaunch(pchAppKey, bAutoLaunch);
}
bool CVRApplications_005::GetApplicationAutoLaunch(const char* pchAppKey) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_005)");
	return base->GetApplicationAutoLaunch(pchAppKey);
}
vr::IVRApplications_005::EVRApplicationError CVRApplications_005::GetStartingApplication(char* pchAppKeyBuffer, uint32_t unAppKeyBufferLen) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_005)");
	return (vr::IVRApplications_005::EVRApplicationError) base->GetStartingApplication(pchAppKeyBuffer, unAppKeyBufferLen);
}
vr::IVRApplications_005::EVRApplicationTransitionState CVRApplications_005::GetTransitionState() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_005)");
	return (vr::IVRApplications_005::EVRApplicationTransitionState) base->GetTransitionState();
}
vr::IVRApplications_005::EVRApplicationError CVRApplications_005::PerformApplicationPrelaunchCheck(const char* pchAppKey) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_005)");
	return (vr::IVRApplications_005::EVRApplicationError) base->PerformApplicationPrelaunchCheck(pchAppKey);
}
const char* CVRApplications_005::GetApplicationsTransitionStateNameFromEnum(vr::IVRApplications_005::EVRApplicationTransitionState state) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_005)");
	return base->GetApplicationsTransitionStateNameFromEnum((OOVR_EVRApplicationTransitionState) state);
}
bool CVRApplications_005::IsQuitUserPromptRequested() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_005)");
	return base->IsQuitUserPromptRequested();
}
vr::IVRApplications_005::EVRApplicationError CVRApplications_005::LaunchInternalProcess(const char* pchBinaryPath, const char* pchArguments, const char* pchWorkingDirectory) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_005)");
	return (vr::IVRApplications_005::EVRApplicationError) base->LaunchInternalProcess(pchBinaryPath, pchArguments, pchWorkingDirectory);
}
// FnTable for CVRApplications_005:
static CVRApplications_005 *fntable_Applications_005_instance = NULL;
static vr::IVRApplications_005::EVRApplicationError OPENVR_FNTABLE_CALLTYPE fntable_Applications_005_impl_AddApplicationManifest(const char* pchApplicationManifestFullPath, bool bTemporary) { return fntable_Applications_005_instance->AddApplicationManifest(pchApplicationManifestFullPath, bTemporary); }
static vr::IVRApplications_005::EVRApplicationError OPENVR_FNTABLE_CALLTYPE fntable_Applications_005_impl_RemoveApplicationManifest(const char* pchApplicationManifestFullPath) { return fntable_Applications_005_instance->RemoveApplicationManifest(pchApplicationManifestFullPath); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Applications_005_impl_IsApplicationInstalled(const char* pchAppKey) { return fntable_Applications_005_instance->IsApplicationInstalled(pchAppKey); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Applications_005_impl_GetApplicationCount() { return fntable_Applications_005_instance->GetApplicationCount(); }
static vr::IVRApplications_005::EVRApplicationError OPENVR_FNTABLE_CALLTYPE fntable_Applications_005_impl_GetApplicationKeyByIndex(uint32_t unApplicationIndex, char* pchAppKeyBuffer, uint32_t unAppKeyBufferLen) { return fntable_Applications_005_instance->GetApplicationKeyByIndex(unApplicationIndex, pchAppKeyBuffer, unAppKeyBufferLen); }
static vr::IVRApplications_005::EVRApplicationError OPENVR_FNTABLE_CALLTYPE fntable_Applications_005_impl_GetApplicationKeyByProcessId(uint32_t unProcessId, char* pchAppKeyBuffer, uint32_t unAppKeyBufferLen) { return fntable_Applications_005_instance->GetApplicationKeyByProcessId(unProcessId, pchAppKeyBuffer, unAppKeyBufferLen); }
static vr::IVRApplications_005::EVRApplicationError OPENVR_FNTABLE_CALLTYPE fntable_Applications_005_impl_LaunchApplication(const char* pchAppKey) { return fntable_Applications_005_instance->LaunchApplication(pchAppKey); }
static vr::IVRApplications_005::EVRApplicationError OPENVR_FNTABLE_CALLTYPE fntable_Applications_005_impl_LaunchTemplateApplication(const char* pchTemplateAppKey, const char* pchNewAppKey, const vr::IVRApplications_005::AppOverrideKeys_t* pKeys, uint32_t unKeys) { return fntable_Applications_005_instance->LaunchTemplateApplication(pchTemplateAppKey, pchNewAppKey, pKeys, unKeys); }
static vr::IVRApplications_005::EVRApplicationError OPENVR_FNTABLE_CALLTYPE fntable_Applications_005_impl_LaunchDashboardOverlay(const char* pchAppKey) { return fntable_Applications_005_instance->LaunchDashboardOverlay(pchAppKey); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Applications_005_impl_CancelApplicationLaunch(const char* pchAppKey) { return fntable_Applications_005_instance->CancelApplicationLaunch(pchAppKey); }
static vr::IVRApplications_005::EVRApplicationError OPENVR_FNTABLE_CALLTYPE fntable_Applications_005_impl_IdentifyApplication(uint32_t unProcessId, const char* pchAppKey) { return fntable_Applications_005_instance->IdentifyApplication(unProcessId, pchAppKey); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Applications_005_impl_GetApplicationProcessId(const char* pchAppKey) { return fntable_Applications_005_instance->GetApplicationProcessId(pchAppKey); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_Applications_005_impl_GetApplicationsErrorNameFromEnum(vr::IVRApplications_005::EVRApplicationError error) { return fntable_Applications_005_instance->GetApplicationsErrorNameFromEnum(error); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Applications_005_impl_GetApplicationPropertyString(const char* pchAppKey, vr::IVRApplications_005::EVRApplicationProperty eProperty, char* pchPropertyValueBuffer, uint32_t unPropertyValueBufferLen, vr::IVRApplications_005::EVRApplicationError* peError) { return fntable_Applications_005_instance->GetApplicationPropertyString(pchAppKey, eProperty, pchPropertyValueBuffer, unPropertyValueBufferLen, peError); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Applications_005_impl_GetApplicationPropertyBool(const char* pchAppKey, vr::IVRApplications_005::EVRApplicationProperty eProperty, vr::IVRApplications_005::EVRApplicationError* peError) { return fntable_Applications_005_instance->GetApplicationPropertyBool(pchAppKey, eProperty, peError); }
static uint64_t OPENVR_FNTABLE_CALLTYPE fntable_Applications_005_impl_GetApplicationPropertyUint64(const char* pchAppKey, vr::IVRApplications_005::EVRApplicationProperty eProperty, vr::IVRApplications_005::EVRApplicationError* peError) { return fntable_Applications_005_instance->GetApplicationPropertyUint64(pchAppKey, eProperty, peError); }
static vr::IVRApplications_005::EVRApplicationError OPENVR_FNTABLE_CALLTYPE fntable_Applications_005_impl_SetApplicationAutoLaunch(const char* pchAppKey, bool bAutoLaunch) { return fntable_Applications_005_instance->SetApplicationAutoLaunch(pchAppKey, bAutoLaunch); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Applications_005_impl_GetApplicationAutoLaunch(const char* pchAppKey) { return fntable_Applications_005_instance->GetApplicationAutoLaunch(pchAppKey); }
static vr::IVRApplications_005::EVRApplicationError OPENVR_FNTABLE_CALLTYPE fntable_Applications_005_impl_GetStartingApplication(char* pchAppKeyBuffer, uint32_t unAppKeyBufferLen) { return fntable_Applications_005_instance->GetStartingApplication(pchAppKeyBuffer, unAppKeyBufferLen); }
static vr::IVRApplications_005::EVRApplicationTransitionState OPENVR_FNTABLE_CALLTYPE fntable_Applications_005_impl_GetTransitionState() { return fntable_Applications_005_instance->GetTransitionState(); }
static vr::IVRApplications_005::EVRApplicationError OPENVR_FNTABLE_CALLTYPE fntable_Applications_005_impl_PerformApplicationPrelaunchCheck(const char* pchAppKey) { return fntable_Applications_005_instance->PerformApplicationPrelaunchCheck(pchAppKey); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_Applications_005_impl_GetApplicationsTransitionStateNameFromEnum(vr::IVRApplications_005::EVRApplicationTransitionState state) { return fntable_Applications_005_instance->GetApplicationsTransitionStateNameFromEnum(state); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Applications_005_impl_IsQuitUserPromptRequested() { return fntable_Applications_005_instance->IsQuitUserPromptRequested(); }
static vr::IVRApplications_005::EVRApplicationError OPENVR_FNTABLE_CALLTYPE fntable_Applications_005_impl_LaunchInternalProcess(const char* pchBinaryPath, const char* pchArguments, const char* pchWorkingDirectory) { return fntable_Applications_005_instance->LaunchInternalProcess(pchBinaryPath, pchArguments, pchWorkingDirectory); }
static void *fntable_Applications_005_funcs[] = {
	(void*) fntable_Applications_005_impl_AddApplicationManifest,
	(void*) fntable_Applications_005_impl_RemoveApplicationManifest,
	(void*) fntable_Applications_005_impl_IsApplicationInstalled,
	(void*) fntable_Applications_005_impl_GetApplicationCount,
	(void*) fntable_Applications_005_impl_GetApplicationKeyByIndex,
	(void*) fntable_Applications_005_impl_GetApplicationKeyByProcessId,
	(void*) fntable_Applications_005_impl_LaunchApplication,
	(void*) fntable_Applications_005_impl_LaunchTemplateApplication,
	(void*) fntable_Applications_005_impl_LaunchDashboardOverlay,
	(void*) fntable_Applications_005_impl_CancelApplicationLaunch,
	(void*) fntable_Applications_005_impl_IdentifyApplication,
	(void*) fntable_Applications_005_impl_GetApplicationProcessId,
	(void*) fntable_Applications_005_impl_GetApplicationsErrorNameFromEnum,
	(void*) fntable_Applications_005_impl_GetApplicationPropertyString,
	(void*) fntable_Applications_005_impl_GetApplicationPropertyBool,
	(void*) fntable_Applications_005_impl_GetApplicationPropertyUint64,
	(void*) fntable_Applications_005_impl_SetApplicationAutoLaunch,
	(void*) fntable_Applications_005_impl_GetApplicationAutoLaunch,
	(void*) fntable_Applications_005_impl_GetStartingApplication,
	(void*) fntable_Applications_005_impl_GetTransitionState,
	(void*) fntable_Applications_005_impl_PerformApplicationPrelaunchCheck,
	(void*) fntable_Applications_005_impl_GetApplicationsTransitionStateNameFromEnum,
	(void*) fntable_Applications_005_impl_IsQuitUserPromptRequested,
	(void*) fntable_Applications_005_impl_LaunchInternalProcess,
};
void** CVRApplications_005::_GetStatFuncList() { fntable_Applications_005_instance = this; return fntable_Applications_005_funcs; }
void CVRApplications_005::Delete() { delete this; }
// Misc for CVRApplications_006:
CVRApplications_006::CVRApplications_006() : base(GetCreateBaseApplications()) {}
// Interface methods for CVRApplications_006:
vr::IVRApplications_006::EVRApplicationError CVRApplications_006::AddApplicationManifest(const char* pchApplicationManifestFullPath, bool bTemporary) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_006)");
	return (vr::IVRApplications_006::EVRApplicationError) base->AddApplicationManifest(pchApplicationManifestFullPath, bTemporary);
}
vr::IVRApplications_006::EVRApplicationError CVRApplications_006::RemoveApplicationManifest(const char* pchApplicationManifestFullPath) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_006)");
	return (vr::IVRApplications_006::EVRApplicationError) base->RemoveApplicationManifest(pchApplicationManifestFullPath);
}
bool CVRApplications_006::IsApplicationInstalled(const char* pchAppKey) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_006)");
	return base->IsApplicationInstalled(pchAppKey);
}
uint32_t CVRApplications_006::GetApplicationCount() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_006)");
	return base->GetApplicationCount();
}
vr::IVRApplications_006::EVRApplicationError CVRApplications_006::GetApplicationKeyByIndex(uint32_t unApplicationIndex, char* pchAppKeyBuffer, uint32_t unAppKeyBufferLen) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_006)");
	return (vr::IVRApplications_006::EVRApplicationError) base->GetApplicationKeyByIndex(unApplicationIndex, pchAppKeyBuffer, unAppKeyBufferLen);
}
vr::IVRApplications_006::EVRApplicationError CVRApplications_006::GetApplicationKeyByProcessId(uint32_t unProcessId, char* pchAppKeyBuffer, uint32_t unAppKeyBufferLen) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_006)");
	return (vr::IVRApplications_006::EVRApplicationError) base->GetApplicationKeyByProcessId(unProcessId, pchAppKeyBuffer, unAppKeyBufferLen);
}
vr::IVRApplications_006::EVRApplicationError CVRApplications_006::LaunchApplication(const char* pchAppKey) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_006)");
	return (vr::IVRApplications_006::EVRApplicationError) base->LaunchApplication(pchAppKey);
}
vr::IVRApplications_006::EVRApplicationError CVRApplications_006::LaunchTemplateApplication(const char* pchTemplateAppKey, const char* pchNewAppKey, const vr::IVRApplications_006::AppOverrideKeys_t* pKeys, uint32_t unKeys) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_006)");
	return (vr::IVRApplications_006::EVRApplicationError) base->LaunchTemplateApplication(pchTemplateAppKey, pchNewAppKey, (const OOVR_AppOverrideKeys_t*) pKeys, unKeys);
}
vr::IVRApplications_006::EVRApplicationError CVRApplications_006::LaunchApplicationFromMimeType(const char* pchMimeType, const char* pchArgs) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_006)");
	return (vr::IVRApplications_006::EVRApplicationError) base->LaunchApplicationFromMimeType(pchMimeType, pchArgs);
}
vr::IVRApplications_006::EVRApplicationError CVRApplications_006::LaunchDashboardOverlay(const char* pchAppKey) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_006)");
	return (vr::IVRApplications_006::EVRApplicationError) base->LaunchDashboardOverlay(pchAppKey);
}
bool CVRApplications_006::CancelApplicationLaunch(const char* pchAppKey) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_006)");
	return base->CancelApplicationLaunch(pchAppKey);
}
vr::IVRApplications_006::EVRApplicationError CVRApplications_006::IdentifyApplication(uint32_t unProcessId, const char* pchAppKey) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_006)");
	return (vr::IVRApplications_006::EVRApplicationError) base->IdentifyApplication(unProcessId, pchAppKey);
}
uint32_t CVRApplications_006::GetApplicationProcessId(const char* pchAppKey) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_006)");
	return base->GetApplicationProcessId(pchAppKey);
}
const char* CVRApplications_006::GetApplicationsErrorNameFromEnum(vr::IVRApplications_006::EVRApplicationError error) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_006)");
	return base->GetApplicationsErrorNameFromEnum((OOVR_EVRApplicationError) error);
}
uint32_t CVRApplications_006::GetApplicationPropertyString(const char* pchAppKey, vr::IVRApplications_006::EVRApplicationProperty eProperty, char* pchPropertyValueBuffer, uint32_t unPropertyValueBufferLen, vr::IVRApplications_006::EVRApplicationError* peError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_006)");
	return base->GetApplicationPropertyString(pchAppKey, (OOVR_EVRApplicationProperty) eProperty, pchPropertyValueBuffer, unPropertyValueBufferLen, (OOVR_EVRApplicationError*) peError);
}
bool CVRApplications_006::GetApplicationPropertyBool(const char* pchAppKey, vr::IVRApplications_006::EVRApplicationProperty eProperty, vr::IVRApplications_006::EVRApplicationError* peError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_006)");
	return base->GetApplicationPropertyBool(pchAppKey, (OOVR_EVRApplicationProperty) eProperty, (OOVR_EVRApplicationError*) peError);
}
uint64_t CVRApplications_006::GetApplicationPropertyUint64(const char* pchAppKey, vr::IVRApplications_006::EVRApplicationProperty eProperty, vr::IVRApplications_006::EVRApplicationError* peError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_006)");
	return base->GetApplicationPropertyUint64(pchAppKey, (OOVR_EVRApplicationProperty) eProperty, (OOVR_EVRApplicationError*) peError);
}
vr::IVRApplications_006::EVRApplicationError CVRApplications_006::SetApplicationAutoLaunch(const char* pchAppKey, bool bAutoLaunch) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_006)");
	return (vr::IVRApplications_006::EVRApplicationError) base->SetApplicationAutoLaunch(pchAppKey, bAutoLaunch);
}
bool CVRApplications_006::GetApplicationAutoLaunch(const char* pchAppKey) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_006)");
	return base->GetApplicationAutoLaunch(pchAppKey);
}
vr::IVRApplications_006::EVRApplicationError CVRApplications_006::SetDefaultApplicationForMimeType(const char* pchAppKey, const char* pchMimeType) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_006)");
	return (vr::IVRApplications_006::EVRApplicationError) base->SetDefaultApplicationForMimeType(pchAppKey, pchMimeType);
}
bool CVRApplications_006::GetDefaultApplicationForMimeType(const char* pchMimeType, char* pchAppKeyBuffer, uint32_t unAppKeyBufferLen) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_006)");
	return base->GetDefaultApplicationForMimeType(pchMimeType, pchAppKeyBuffer, unAppKeyBufferLen);
}
bool CVRApplications_006::GetApplicationSupportedMimeTypes(const char* pchAppKey, char* pchMimeTypesBuffer, uint32_t unMimeTypesBuffer) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_006)");
	return base->GetApplicationSupportedMimeTypes(pchAppKey, pchMimeTypesBuffer, unMimeTypesBuffer);
}
uint32_t CVRApplications_006::GetApplicationsThatSupportMimeType(const char* pchMimeType, char* pchAppKeysThatSupportBuffer, uint32_t unAppKeysThatSupportBuffer) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_006)");
	return base->GetApplicationsThatSupportMimeType(pchMimeType, pchAppKeysThatSupportBuffer, unAppKeysThatSupportBuffer);
}
uint32_t CVRApplications_006::GetApplicationLaunchArguments(uint32_t unHandle, char* pchArgs, uint32_t unArgs) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_006)");
	return base->GetApplicationLaunchArguments(unHandle, pchArgs, unArgs);
}
vr::IVRApplications_006::EVRApplicationError CVRApplications_006::GetStartingApplication(char* pchAppKeyBuffer, uint32_t unAppKeyBufferLen) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_006)");
	return (vr::IVRApplications_006::EVRApplicationError) base->GetStartingApplication(pchAppKeyBuffer, unAppKeyBufferLen);
}
vr::IVRApplications_006::EVRApplicationTransitionState CVRApplications_006::GetTransitionState() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_006)");
	return (vr::IVRApplications_006::EVRApplicationTransitionState) base->GetTransitionState();
}
vr::IVRApplications_006::EVRApplicationError CVRApplications_006::PerformApplicationPrelaunchCheck(const char* pchAppKey) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_006)");
	return (vr::IVRApplications_006::EVRApplicationError) base->PerformApplicationPrelaunchCheck(pchAppKey);
}
const char* CVRApplications_006::GetApplicationsTransitionStateNameFromEnum(vr::IVRApplications_006::EVRApplicationTransitionState state) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_006)");
	return base->GetApplicationsTransitionStateNameFromEnum((OOVR_EVRApplicationTransitionState) state);
}
bool CVRApplications_006::IsQuitUserPromptRequested() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_006)");
	return base->IsQuitUserPromptRequested();
}
vr::IVRApplications_006::EVRApplicationError CVRApplications_006::LaunchInternalProcess(const char* pchBinaryPath, const char* pchArguments, const char* pchWorkingDirectory) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_006)");
	return (vr::IVRApplications_006::EVRApplicationError) base->LaunchInternalProcess(pchBinaryPath, pchArguments, pchWorkingDirectory);
}
uint32_t CVRApplications_006::GetCurrentSceneProcessId() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_006)");
	return base->GetCurrentSceneProcessId();
}
// FnTable for CVRApplications_006:
static CVRApplications_006 *fntable_Applications_006_instance = NULL;
static vr::IVRApplications_006::EVRApplicationError OPENVR_FNTABLE_CALLTYPE fntable_Applications_006_impl_AddApplicationManifest(const char* pchApplicationManifestFullPath, bool bTemporary) { return fntable_Applications_006_instance->AddApplicationManifest(pchApplicationManifestFullPath, bTemporary); }
static vr::IVRApplications_006::EVRApplicationError OPENVR_FNTABLE_CALLTYPE fntable_Applications_006_impl_RemoveApplicationManifest(const char* pchApplicationManifestFullPath) { return fntable_Applications_006_instance->RemoveApplicationManifest(pchApplicationManifestFullPath); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Applications_006_impl_IsApplicationInstalled(const char* pchAppKey) { return fntable_Applications_006_instance->IsApplicationInstalled(pchAppKey); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Applications_006_impl_GetApplicationCount() { return fntable_Applications_006_instance->GetApplicationCount(); }
static vr::IVRApplications_006::EVRApplicationError OPENVR_FNTABLE_CALLTYPE fntable_Applications_006_impl_GetApplicationKeyByIndex(uint32_t unApplicationIndex, char* pchAppKeyBuffer, uint32_t unAppKeyBufferLen) { return fntable_Applications_006_instance->GetApplicationKeyByIndex(unApplicationIndex, pchAppKeyBuffer, unAppKeyBufferLen); }
static vr::IVRApplications_006::EVRApplicationError OPENVR_FNTABLE_CALLTYPE fntable_Applications_006_impl_GetApplicationKeyByProcessId(uint32_t unProcessId, char* pchAppKeyBuffer, uint32_t unAppKeyBufferLen) { return fntable_Applications_006_instance->GetApplicationKeyByProcessId(unProcessId, pchAppKeyBuffer, unAppKeyBufferLen); }
static vr::IVRApplications_006::EVRApplicationError OPENVR_FNTABLE_CALLTYPE fntable_Applications_006_impl_LaunchApplication(const char* pchAppKey) { return fntable_Applications_006_instance->LaunchApplication(pchAppKey); }
static vr::IVRApplications_006::EVRApplicationError OPENVR_FNTABLE_CALLTYPE fntable_Applications_006_impl_LaunchTemplateApplication(const char* pchTemplateAppKey, const char* pchNewAppKey, const vr::IVRApplications_006::AppOverrideKeys_t* pKeys, uint32_t unKeys) { return fntable_Applications_006_instance->LaunchTemplateApplication(pchTemplateAppKey, pchNewAppKey, pKeys, unKeys); }
static vr::IVRApplications_006::EVRApplicationError OPENVR_FNTABLE_CALLTYPE fntable_Applications_006_impl_LaunchApplicationFromMimeType(const char* pchMimeType, const char* pchArgs) { return fntable_Applications_006_instance->LaunchApplicationFromMimeType(pchMimeType, pchArgs); }
static vr::IVRApplications_006::EVRApplicationError OPENVR_FNTABLE_CALLTYPE fntable_Applications_006_impl_LaunchDashboardOverlay(const char* pchAppKey) { return fntable_Applications_006_instance->LaunchDashboardOverlay(pchAppKey); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Applications_006_impl_CancelApplicationLaunch(const char* pchAppKey) { return fntable_Applications_006_instance->CancelApplicationLaunch(pchAppKey); }
static vr::IVRApplications_006::EVRApplicationError OPENVR_FNTABLE_CALLTYPE fntable_Applications_006_impl_IdentifyApplication(uint32_t unProcessId, const char* pchAppKey) { return fntable_Applications_006_instance->IdentifyApplication(unProcessId, pchAppKey); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Applications_006_impl_GetApplicationProcessId(const char* pchAppKey) { return fntable_Applications_006_instance->GetApplicationProcessId(pchAppKey); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_Applications_006_impl_GetApplicationsErrorNameFromEnum(vr::IVRApplications_006::EVRApplicationError error) { return fntable_Applications_006_instance->GetApplicationsErrorNameFromEnum(error); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Applications_006_impl_GetApplicationPropertyString(const char* pchAppKey, vr::IVRApplications_006::EVRApplicationProperty eProperty, char* pchPropertyValueBuffer, uint32_t unPropertyValueBufferLen, vr::IVRApplications_006::EVRApplicationError* peError) { return fntable_Applications_006_instance->GetApplicationPropertyString(pchAppKey, eProperty, pchPropertyValueBuffer, unPropertyValueBufferLen, peError); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Applications_006_impl_GetApplicationPropertyBool(const char* pchAppKey, vr::IVRApplications_006::EVRApplicationProperty eProperty, vr::IVRApplications_006::EVRApplicationError* peError) { return fntable_Applications_006_instance->GetApplicationPropertyBool(pchAppKey, eProperty, peError); }
static uint64_t OPENVR_FNTABLE_CALLTYPE fntable_Applications_006_impl_GetApplicationPropertyUint64(const char* pchAppKey, vr::IVRApplications_006::EVRApplicationProperty eProperty, vr::IVRApplications_006::EVRApplicationError* peError) { return fntable_Applications_006_instance->GetApplicationPropertyUint64(pchAppKey, eProperty, peError); }
static vr::IVRApplications_006::EVRApplicationError OPENVR_FNTABLE_CALLTYPE fntable_Applications_006_impl_SetApplicationAutoLaunch(const char* pchAppKey, bool bAutoLaunch) { return fntable_Applications_006_instance->SetApplicationAutoLaunch(pchAppKey, bAutoLaunch); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Applications_006_impl_GetApplicationAutoLaunch(const char* pchAppKey) { return fntable_Applications_006_instance->GetApplicationAutoLaunch(pchAppKey); }
static vr::IVRApplications_006::EVRApplicationError OPENVR_FNTABLE_CALLTYPE fntable_Applications_006_impl_SetDefaultApplicationForMimeType(const char* pchAppKey, const char* pchMimeType) { return fntable_Applications_006_instance->SetDefaultApplicationForMimeType(pchAppKey, pchMimeType); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Applications_006_impl_GetDefaultApplicationForMimeType(const char* pchMimeType, char* pchAppKeyBuffer, uint32_t unAppKeyBufferLen) { return fntable_Applications_006_instance->GetDefaultApplicationForMimeType(pchMimeType, pchAppKeyBuffer, unAppKeyBufferLen); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Applications_006_impl_GetApplicationSupportedMimeTypes(const char* pchAppKey, char* pchMimeTypesBuffer, uint32_t unMimeTypesBuffer) { return fntable_Applications_006_instance->GetApplicationSupportedMimeTypes(pchAppKey, pchMimeTypesBuffer, unMimeTypesBuffer); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Applications_006_impl_GetApplicationsThatSupportMimeType(const char* pchMimeType, char* pchAppKeysThatSupportBuffer, uint32_t unAppKeysThatSupportBuffer) { return fntable_Applications_006_instance->GetApplicationsThatSupportMimeType(pchMimeType, pchAppKeysThatSupportBuffer, unAppKeysThatSupportBuffer); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Applications_006_impl_GetApplicationLaunchArguments(uint32_t unHandle, char* pchArgs, uint32_t unArgs) { return fntable_Applications_006_instance->GetApplicationLaunchArguments(unHandle, pchArgs, unArgs); }
static vr::IVRApplications_006::EVRApplicationError OPENVR_FNTABLE_CALLTYPE fntable_Applications_006_impl_GetStartingApplication(char* pchAppKeyBuffer, uint32_t unAppKeyBufferLen) { return fntable_Applications_006_instance->GetStartingApplication(pchAppKeyBuffer, unAppKeyBufferLen); }
static vr::IVRApplications_006::EVRApplicationTransitionState OPENVR_FNTABLE_CALLTYPE fntable_Applications_006_impl_GetTransitionState() { return fntable_Applications_006_instance->GetTransitionState(); }
static vr::IVRApplications_006::EVRApplicationError OPENVR_FNTABLE_CALLTYPE fntable_Applications_006_impl_PerformApplicationPrelaunchCheck(const char* pchAppKey) { return fntable_Applications_006_instance->PerformApplicationPrelaunchCheck(pchAppKey); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_Applications_006_impl_GetApplicationsTransitionStateNameFromEnum(vr::IVRApplications_006::EVRApplicationTransitionState state) { return fntable_Applications_006_instance->GetApplicationsTransitionStateNameFromEnum(state); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Applications_006_impl_IsQuitUserPromptRequested() { return fntable_Applications_006_instance->IsQuitUserPromptRequested(); }
static vr::IVRApplications_006::EVRApplicationError OPENVR_FNTABLE_CALLTYPE fntable_Applications_006_impl_LaunchInternalProcess(const char* pchBinaryPath, const char* pchArguments, const char* pchWorkingDirectory) { return fntable_Applications_006_instance->LaunchInternalProcess(pchBinaryPath, pchArguments, pchWorkingDirectory); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Applications_006_impl_GetCurrentSceneProcessId() { return fntable_Applications_006_instance->GetCurrentSceneProcessId(); }
static void *fntable_Applications_006_funcs[] = {
	(void*) fntable_Applications_006_impl_AddApplicationManifest,
	(void*) fntable_Applications_006_impl_RemoveApplicationManifest,
	(void*) fntable_Applications_006_impl_IsApplicationInstalled,
	(void*) fntable_Applications_006_impl_GetApplicationCount,
	(void*) fntable_Applications_006_impl_GetApplicationKeyByIndex,
	(void*) fntable_Applications_006_impl_GetApplicationKeyByProcessId,
	(void*) fntable_Applications_006_impl_LaunchApplication,
	(void*) fntable_Applications_006_impl_LaunchTemplateApplication,
	(void*) fntable_Applications_006_impl_LaunchApplicationFromMimeType,
	(void*) fntable_Applications_006_impl_LaunchDashboardOverlay,
	(void*) fntable_Applications_006_impl_CancelApplicationLaunch,
	(void*) fntable_Applications_006_impl_IdentifyApplication,
	(void*) fntable_Applications_006_impl_GetApplicationProcessId,
	(void*) fntable_Applications_006_impl_GetApplicationsErrorNameFromEnum,
	(void*) fntable_Applications_006_impl_GetApplicationPropertyString,
	(void*) fntable_Applications_006_impl_GetApplicationPropertyBool,
	(void*) fntable_Applications_006_impl_GetApplicationPropertyUint64,
	(void*) fntable_Applications_006_impl_SetApplicationAutoLaunch,
	(void*) fntable_Applications_006_impl_GetApplicationAutoLaunch,
	(void*) fntable_Applications_006_impl_SetDefaultApplicationForMimeType,
	(void*) fntable_Applications_006_impl_GetDefaultApplicationForMimeType,
	(void*) fntable_Applications_006_impl_GetApplicationSupportedMimeTypes,
	(void*) fntable_Applications_006_impl_GetApplicationsThatSupportMimeType,
	(void*) fntable_Applications_006_impl_GetApplicationLaunchArguments,
	(void*) fntable_Applications_006_impl_GetStartingApplication,
	(void*) fntable_Applications_006_impl_GetTransitionState,
	(void*) fntable_Applications_006_impl_PerformApplicationPrelaunchCheck,
	(void*) fntable_Applications_006_impl_GetApplicationsTransitionStateNameFromEnum,
	(void*) fntable_Applications_006_impl_IsQuitUserPromptRequested,
	(void*) fntable_Applications_006_impl_LaunchInternalProcess,
	(void*) fntable_Applications_006_impl_GetCurrentSceneProcessId,
};
void** CVRApplications_006::_GetStatFuncList() { fntable_Applications_006_instance = this; return fntable_Applications_006_funcs; }
void CVRApplications_006::Delete() { delete this; }
// Misc for CVRApplications_007:
CVRApplications_007::CVRApplications_007() : base(GetCreateBaseApplications()) {}
// Interface methods for CVRApplications_007:
vr::IVRApplications_007::EVRApplicationError CVRApplications_007::AddApplicationManifest(const char* pchApplicationManifestFullPath, bool bTemporary) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_007)");
	return (vr::IVRApplications_007::EVRApplicationError) base->AddApplicationManifest(pchApplicationManifestFullPath, bTemporary);
}
vr::IVRApplications_007::EVRApplicationError CVRApplications_007::RemoveApplicationManifest(const char* pchApplicationManifestFullPath) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_007)");
	return (vr::IVRApplications_007::EVRApplicationError) base->RemoveApplicationManifest(pchApplicationManifestFullPath);
}
bool CVRApplications_007::IsApplicationInstalled(const char* pchAppKey) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_007)");
	return base->IsApplicationInstalled(pchAppKey);
}
uint32_t CVRApplications_007::GetApplicationCount() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_007)");
	return base->GetApplicationCount();
}
vr::IVRApplications_007::EVRApplicationError CVRApplications_007::GetApplicationKeyByIndex(uint32_t unApplicationIndex, char* pchAppKeyBuffer, uint32_t unAppKeyBufferLen) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_007)");
	return (vr::IVRApplications_007::EVRApplicationError) base->GetApplicationKeyByIndex(unApplicationIndex, pchAppKeyBuffer, unAppKeyBufferLen);
}
vr::IVRApplications_007::EVRApplicationError CVRApplications_007::GetApplicationKeyByProcessId(uint32_t unProcessId, char* pchAppKeyBuffer, uint32_t unAppKeyBufferLen) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_007)");
	return (vr::IVRApplications_007::EVRApplicationError) base->GetApplicationKeyByProcessId(unProcessId, pchAppKeyBuffer, unAppKeyBufferLen);
}
vr::IVRApplications_007::EVRApplicationError CVRApplications_007::LaunchApplication(const char* pchAppKey) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_007)");
	return (vr::IVRApplications_007::EVRApplicationError) base->LaunchApplication(pchAppKey);
}
vr::IVRApplications_007::EVRApplicationError CVRApplications_007::LaunchTemplateApplication(const char* pchTemplateAppKey, const char* pchNewAppKey, const vr::IVRApplications_007::AppOverrideKeys_t* pKeys, uint32_t unKeys) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_007)");
	return (vr::IVRApplications_007::EVRApplicationError) base->LaunchTemplateApplication(pchTemplateAppKey, pchNewAppKey, (const OOVR_AppOverrideKeys_t*) pKeys, unKeys);
}
vr::IVRApplications_007::EVRApplicationError CVRApplications_007::LaunchApplicationFromMimeType(const char* pchMimeType, const char* pchArgs) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_007)");
	return (vr::IVRApplications_007::EVRApplicationError) base->LaunchApplicationFromMimeType(pchMimeType, pchArgs);
}
vr::IVRApplications_007::EVRApplicationError CVRApplications_007::LaunchDashboardOverlay(const char* pchAppKey) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_007)");
	return (vr::IVRApplications_007::EVRApplicationError) base->LaunchDashboardOverlay(pchAppKey);
}
bool CVRApplications_007::CancelApplicationLaunch(const char* pchAppKey) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_007)");
	return base->CancelApplicationLaunch(pchAppKey);
}
vr::IVRApplications_007::EVRApplicationError CVRApplications_007::IdentifyApplication(uint32_t unProcessId, const char* pchAppKey) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_007)");
	return (vr::IVRApplications_007::EVRApplicationError) base->IdentifyApplication(unProcessId, pchAppKey);
}
uint32_t CVRApplications_007::GetApplicationProcessId(const char* pchAppKey) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_007)");
	return base->GetApplicationProcessId(pchAppKey);
}
const char* CVRApplications_007::GetApplicationsErrorNameFromEnum(vr::IVRApplications_007::EVRApplicationError error) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_007)");
	return base->GetApplicationsErrorNameFromEnum((OOVR_EVRApplicationError) error);
}
uint32_t CVRApplications_007::GetApplicationPropertyString(const char* pchAppKey, vr::IVRApplications_007::EVRApplicationProperty eProperty, char* pchPropertyValueBuffer, uint32_t unPropertyValueBufferLen, vr::IVRApplications_007::EVRApplicationError* peError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_007)");
	return base->GetApplicationPropertyString(pchAppKey, (OOVR_EVRApplicationProperty) eProperty, pchPropertyValueBuffer, unPropertyValueBufferLen, (OOVR_EVRApplicationError*) peError);
}
bool CVRApplications_007::GetApplicationPropertyBool(const char* pchAppKey, vr::IVRApplications_007::EVRApplicationProperty eProperty, vr::IVRApplications_007::EVRApplicationError* peError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_007)");
	return base->GetApplicationPropertyBool(pchAppKey, (OOVR_EVRApplicationProperty) eProperty, (OOVR_EVRApplicationError*) peError);
}
uint64_t CVRApplications_007::GetApplicationPropertyUint64(const char* pchAppKey, vr::IVRApplications_007::EVRApplicationProperty eProperty, vr::IVRApplications_007::EVRApplicationError* peError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_007)");
	return base->GetApplicationPropertyUint64(pchAppKey, (OOVR_EVRApplicationProperty) eProperty, (OOVR_EVRApplicationError*) peError);
}
vr::IVRApplications_007::EVRApplicationError CVRApplications_007::SetApplicationAutoLaunch(const char* pchAppKey, bool bAutoLaunch) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_007)");
	return (vr::IVRApplications_007::EVRApplicationError) base->SetApplicationAutoLaunch(pchAppKey, bAutoLaunch);
}
bool CVRApplications_007::GetApplicationAutoLaunch(const char* pchAppKey) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_007)");
	return base->GetApplicationAutoLaunch(pchAppKey);
}
vr::IVRApplications_007::EVRApplicationError CVRApplications_007::SetDefaultApplicationForMimeType(const char* pchAppKey, const char* pchMimeType) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_007)");
	return (vr::IVRApplications_007::EVRApplicationError) base->SetDefaultApplicationForMimeType(pchAppKey, pchMimeType);
}
bool CVRApplications_007::GetDefaultApplicationForMimeType(const char* pchMimeType, char* pchAppKeyBuffer, uint32_t unAppKeyBufferLen) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_007)");
	return base->GetDefaultApplicationForMimeType(pchMimeType, pchAppKeyBuffer, unAppKeyBufferLen);
}
bool CVRApplications_007::GetApplicationSupportedMimeTypes(const char* pchAppKey, char* pchMimeTypesBuffer, uint32_t unMimeTypesBuffer) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_007)");
	return base->GetApplicationSupportedMimeTypes(pchAppKey, pchMimeTypesBuffer, unMimeTypesBuffer);
}
uint32_t CVRApplications_007::GetApplicationsThatSupportMimeType(const char* pchMimeType, char* pchAppKeysThatSupportBuffer, uint32_t unAppKeysThatSupportBuffer) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_007)");
	return base->GetApplicationsThatSupportMimeType(pchMimeType, pchAppKeysThatSupportBuffer, unAppKeysThatSupportBuffer);
}
uint32_t CVRApplications_007::GetApplicationLaunchArguments(uint32_t unHandle, char* pchArgs, uint32_t unArgs) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_007)");
	return base->GetApplicationLaunchArguments(unHandle, pchArgs, unArgs);
}
vr::IVRApplications_007::EVRApplicationError CVRApplications_007::GetStartingApplication(char* pchAppKeyBuffer, uint32_t unAppKeyBufferLen) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_007)");
	return (vr::IVRApplications_007::EVRApplicationError) base->GetStartingApplication(pchAppKeyBuffer, unAppKeyBufferLen);
}
vr::IVRApplications_007::EVRSceneApplicationState CVRApplications_007::GetSceneApplicationState() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_007)");
	return (vr::IVRApplications_007::EVRSceneApplicationState) base->GetSceneApplicationState();
}
vr::IVRApplications_007::EVRApplicationError CVRApplications_007::PerformApplicationPrelaunchCheck(const char* pchAppKey) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_007)");
	return (vr::IVRApplications_007::EVRApplicationError) base->PerformApplicationPrelaunchCheck(pchAppKey);
}
const char* CVRApplications_007::GetSceneApplicationStateNameFromEnum(vr::IVRApplications_007::EVRSceneApplicationState state) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_007)");
	return base->GetSceneApplicationStateNameFromEnum((OOVR_EVRSceneApplicationState) state);
}
vr::IVRApplications_007::EVRApplicationError CVRApplications_007::LaunchInternalProcess(const char* pchBinaryPath, const char* pchArguments, const char* pchWorkingDirectory) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_007)");
	return (vr::IVRApplications_007::EVRApplicationError) base->LaunchInternalProcess(pchBinaryPath, pchArguments, pchWorkingDirectory);
}
uint32_t CVRApplications_007::GetCurrentSceneProcessId() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRApplications_007)");
	return base->GetCurrentSceneProcessId();
}
// FnTable for CVRApplications_007:
static CVRApplications_007 *fntable_Applications_007_instance = NULL;
static vr::IVRApplications_007::EVRApplicationError OPENVR_FNTABLE_CALLTYPE fntable_Applications_007_impl_AddApplicationManifest(const char* pchApplicationManifestFullPath, bool bTemporary) { return fntable_Applications_007_instance->AddApplicationManifest(pchApplicationManifestFullPath, bTemporary); }
static vr::IVRApplications_007::EVRApplicationError OPENVR_FNTABLE_CALLTYPE fntable_Applications_007_impl_RemoveApplicationManifest(const char* pchApplicationManifestFullPath) { return fntable_Applications_007_instance->RemoveApplicationManifest(pchApplicationManifestFullPath); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Applications_007_impl_IsApplicationInstalled(const char* pchAppKey) { return fntable_Applications_007_instance->IsApplicationInstalled(pchAppKey); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Applications_007_impl_GetApplicationCount() { return fntable_Applications_007_instance->GetApplicationCount(); }
static vr::IVRApplications_007::EVRApplicationError OPENVR_FNTABLE_CALLTYPE fntable_Applications_007_impl_GetApplicationKeyByIndex(uint32_t unApplicationIndex, char* pchAppKeyBuffer, uint32_t unAppKeyBufferLen) { return fntable_Applications_007_instance->GetApplicationKeyByIndex(unApplicationIndex, pchAppKeyBuffer, unAppKeyBufferLen); }
static vr::IVRApplications_007::EVRApplicationError OPENVR_FNTABLE_CALLTYPE fntable_Applications_007_impl_GetApplicationKeyByProcessId(uint32_t unProcessId, char* pchAppKeyBuffer, uint32_t unAppKeyBufferLen) { return fntable_Applications_007_instance->GetApplicationKeyByProcessId(unProcessId, pchAppKeyBuffer, unAppKeyBufferLen); }
static vr::IVRApplications_007::EVRApplicationError OPENVR_FNTABLE_CALLTYPE fntable_Applications_007_impl_LaunchApplication(const char* pchAppKey) { return fntable_Applications_007_instance->LaunchApplication(pchAppKey); }
static vr::IVRApplications_007::EVRApplicationError OPENVR_FNTABLE_CALLTYPE fntable_Applications_007_impl_LaunchTemplateApplication(const char* pchTemplateAppKey, const char* pchNewAppKey, const vr::IVRApplications_007::AppOverrideKeys_t* pKeys, uint32_t unKeys) { return fntable_Applications_007_instance->LaunchTemplateApplication(pchTemplateAppKey, pchNewAppKey, pKeys, unKeys); }
static vr::IVRApplications_007::EVRApplicationError OPENVR_FNTABLE_CALLTYPE fntable_Applications_007_impl_LaunchApplicationFromMimeType(const char* pchMimeType, const char* pchArgs) { return fntable_Applications_007_instance->LaunchApplicationFromMimeType(pchMimeType, pchArgs); }
static vr::IVRApplications_007::EVRApplicationError OPENVR_FNTABLE_CALLTYPE fntable_Applications_007_impl_LaunchDashboardOverlay(const char* pchAppKey) { return fntable_Applications_007_instance->LaunchDashboardOverlay(pchAppKey); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Applications_007_impl_CancelApplicationLaunch(const char* pchAppKey) { return fntable_Applications_007_instance->CancelApplicationLaunch(pchAppKey); }
static vr::IVRApplications_007::EVRApplicationError OPENVR_FNTABLE_CALLTYPE fntable_Applications_007_impl_IdentifyApplication(uint32_t unProcessId, const char* pchAppKey) { return fntable_Applications_007_instance->IdentifyApplication(unProcessId, pchAppKey); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Applications_007_impl_GetApplicationProcessId(const char* pchAppKey) { return fntable_Applications_007_instance->GetApplicationProcessId(pchAppKey); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_Applications_007_impl_GetApplicationsErrorNameFromEnum(vr::IVRApplications_007::EVRApplicationError error) { return fntable_Applications_007_instance->GetApplicationsErrorNameFromEnum(error); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Applications_007_impl_GetApplicationPropertyString(const char* pchAppKey, vr::IVRApplications_007::EVRApplicationProperty eProperty, char* pchPropertyValueBuffer, uint32_t unPropertyValueBufferLen, vr::IVRApplications_007::EVRApplicationError* peError) { return fntable_Applications_007_instance->GetApplicationPropertyString(pchAppKey, eProperty, pchPropertyValueBuffer, unPropertyValueBufferLen, peError); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Applications_007_impl_GetApplicationPropertyBool(const char* pchAppKey, vr::IVRApplications_007::EVRApplicationProperty eProperty, vr::IVRApplications_007::EVRApplicationError* peError) { return fntable_Applications_007_instance->GetApplicationPropertyBool(pchAppKey, eProperty, peError); }
static uint64_t OPENVR_FNTABLE_CALLTYPE fntable_Applications_007_impl_GetApplicationPropertyUint64(const char* pchAppKey, vr::IVRApplications_007::EVRApplicationProperty eProperty, vr::IVRApplications_007::EVRApplicationError* peError) { return fntable_Applications_007_instance->GetApplicationPropertyUint64(pchAppKey, eProperty, peError); }
static vr::IVRApplications_007::EVRApplicationError OPENVR_FNTABLE_CALLTYPE fntable_Applications_007_impl_SetApplicationAutoLaunch(const char* pchAppKey, bool bAutoLaunch) { return fntable_Applications_007_instance->SetApplicationAutoLaunch(pchAppKey, bAutoLaunch); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Applications_007_impl_GetApplicationAutoLaunch(const char* pchAppKey) { return fntable_Applications_007_instance->GetApplicationAutoLaunch(pchAppKey); }
static vr::IVRApplications_007::EVRApplicationError OPENVR_FNTABLE_CALLTYPE fntable_Applications_007_impl_SetDefaultApplicationForMimeType(const char* pchAppKey, const char* pchMimeType) { return fntable_Applications_007_instance->SetDefaultApplicationForMimeType(pchAppKey, pchMimeType); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Applications_007_impl_GetDefaultApplicationForMimeType(const char* pchMimeType, char* pchAppKeyBuffer, uint32_t unAppKeyBufferLen) { return fntable_Applications_007_instance->GetDefaultApplicationForMimeType(pchMimeType, pchAppKeyBuffer, unAppKeyBufferLen); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Applications_007_impl_GetApplicationSupportedMimeTypes(const char* pchAppKey, char* pchMimeTypesBuffer, uint32_t unMimeTypesBuffer) { return fntable_Applications_007_instance->GetApplicationSupportedMimeTypes(pchAppKey, pchMimeTypesBuffer, unMimeTypesBuffer); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Applications_007_impl_GetApplicationsThatSupportMimeType(const char* pchMimeType, char* pchAppKeysThatSupportBuffer, uint32_t unAppKeysThatSupportBuffer) { return fntable_Applications_007_instance->GetApplicationsThatSupportMimeType(pchMimeType, pchAppKeysThatSupportBuffer, unAppKeysThatSupportBuffer); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Applications_007_impl_GetApplicationLaunchArguments(uint32_t unHandle, char* pchArgs, uint32_t unArgs) { return fntable_Applications_007_instance->GetApplicationLaunchArguments(unHandle, pchArgs, unArgs); }
static vr::IVRApplications_007::EVRApplicationError OPENVR_FNTABLE_CALLTYPE fntable_Applications_007_impl_GetStartingApplication(char* pchAppKeyBuffer, uint32_t unAppKeyBufferLen) { return fntable_Applications_007_instance->GetStartingApplication(pchAppKeyBuffer, unAppKeyBufferLen); }
static vr::IVRApplications_007::EVRSceneApplicationState OPENVR_FNTABLE_CALLTYPE fntable_Applications_007_impl_GetSceneApplicationState() { return fntable_Applications_007_instance->GetSceneApplicationState(); }
static vr::IVRApplications_007::EVRApplicationError OPENVR_FNTABLE_CALLTYPE fntable_Applications_007_impl_PerformApplicationPrelaunchCheck(const char* pchAppKey) { return fntable_Applications_007_instance->PerformApplicationPrelaunchCheck(pchAppKey); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_Applications_007_impl_GetSceneApplicationStateNameFromEnum(vr::IVRApplications_007::EVRSceneApplicationState state) { return fntable_Applications_007_instance->GetSceneApplicationStateNameFromEnum(state); }
static vr::IVRApplications_007::EVRApplicationError OPENVR_FNTABLE_CALLTYPE fntable_Applications_007_impl_LaunchInternalProcess(const char* pchBinaryPath, const char* pchArguments, const char* pchWorkingDirectory) { return fntable_Applications_007_instance->LaunchInternalProcess(pchBinaryPath, pchArguments, pchWorkingDirectory); }
static uint32_t OPENVR_FNTABLE_CALLTYPE fntable_Applications_007_impl_GetCurrentSceneProcessId() { return fntable_Applications_007_instance->GetCurrentSceneProcessId(); }
static void *fntable_Applications_007_funcs[] = {
	(void*) fntable_Applications_007_impl_AddApplicationManifest,
	(void*) fntable_Applications_007_impl_RemoveApplicationManifest,
	(void*) fntable_Applications_007_impl_IsApplicationInstalled,
	(void*) fntable_Applications_007_impl_GetApplicationCount,
	(void*) fntable_Applications_007_impl_GetApplicationKeyByIndex,
	(void*) fntable_Applications_007_impl_GetApplicationKeyByProcessId,
	(void*) fntable_Applications_007_impl_LaunchApplication,
	(void*) fntable_Applications_007_impl_LaunchTemplateApplication,
	(void*) fntable_Applications_007_impl_LaunchApplicationFromMimeType,
	(void*) fntable_Applications_007_impl_LaunchDashboardOverlay,
	(void*) fntable_Applications_007_impl_CancelApplicationLaunch,
	(void*) fntable_Applications_007_impl_IdentifyApplication,
	(void*) fntable_Applications_007_impl_GetApplicationProcessId,
	(void*) fntable_Applications_007_impl_GetApplicationsErrorNameFromEnum,
	(void*) fntable_Applications_007_impl_GetApplicationPropertyString,
	(void*) fntable_Applications_007_impl_GetApplicationPropertyBool,
	(void*) fntable_Applications_007_impl_GetApplicationPropertyUint64,
	(void*) fntable_Applications_007_impl_SetApplicationAutoLaunch,
	(void*) fntable_Applications_007_impl_GetApplicationAutoLaunch,
	(void*) fntable_Applications_007_impl_SetDefaultApplicationForMimeType,
	(void*) fntable_Applications_007_impl_GetDefaultApplicationForMimeType,
	(void*) fntable_Applications_007_impl_GetApplicationSupportedMimeTypes,
	(void*) fntable_Applications_007_impl_GetApplicationsThatSupportMimeType,
	(void*) fntable_Applications_007_impl_GetApplicationLaunchArguments,
	(void*) fntable_Applications_007_impl_GetStartingApplication,
	(void*) fntable_Applications_007_impl_GetSceneApplicationState,
	(void*) fntable_Applications_007_impl_PerformApplicationPrelaunchCheck,
	(void*) fntable_Applications_007_impl_GetSceneApplicationStateNameFromEnum,
	(void*) fntable_Applications_007_impl_LaunchInternalProcess,
	(void*) fntable_Applications_007_impl_GetCurrentSceneProcessId,
};
void** CVRApplications_007::_GetStatFuncList() { fntable_Applications_007_instance = this; return fntable_Applications_007_funcs; }
void CVRApplications_007::Delete() { delete this; }
#include "GVRInput.gen.h"
// Single inst of BaseInput
static std::weak_ptr<BaseInput> _single_inst_Input;
static BaseInput *_single_inst_Input_unsafe = NULL;
std::shared_ptr<BaseInput> GetBaseInput() { return _single_inst_Input.lock(); };
BaseInput* GetUnsafeBaseInput() { return _single_inst_Input_unsafe; };
std::shared_ptr<BaseInput> GetCreateBaseInput() {
	std::shared_ptr<BaseInput> ret = _single_inst_Input.lock();
	if(!ret) {
		ret = std::shared_ptr<BaseInput>(new BaseInput(), [](BaseInput *obj){ _single_inst_Input_unsafe = NULL; delete obj; });
		_single_inst_Input = ret;
		_single_inst_Input_unsafe = ret.get();
	}
	return ret;
}
// Misc for CVRInput_004:
CVRInput_004::CVRInput_004() : base(GetCreateBaseInput()) {}
// Interface methods for CVRInput_004:
vr::EVRInputError CVRInput_004::SetActionManifestPath(const char* pchActionManifestPath) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_004)");
	return base->SetActionManifestPath(pchActionManifestPath);
}
vr::EVRInputError CVRInput_004::GetActionSetHandle(const char* pchActionSetName, vr::VRActionSetHandle_t* pHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_004)");
	return base->GetActionSetHandle(pchActionSetName, pHandle);
}
vr::EVRInputError CVRInput_004::GetActionHandle(const char* pchActionName, vr::VRActionHandle_t* pHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_004)");
	return base->GetActionHandle(pchActionName, pHandle);
}
vr::EVRInputError CVRInput_004::GetInputSourceHandle(const char* pchInputSourcePath, vr::VRInputValueHandle_t* pHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_004)");
	return base->GetInputSourceHandle(pchInputSourcePath, pHandle);
}
vr::EVRInputError CVRInput_004::UpdateActionState(vr::IVRInput_004::VRActiveActionSet_t* pSets, uint32_t unSizeOfVRSelectedActionSet_t, uint32_t unSetCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_004)");
	return base->UpdateActionState((OOVR_VRActiveActionSet_t*) pSets, unSizeOfVRSelectedActionSet_t, unSetCount);
}
vr::EVRInputError CVRInput_004::GetDigitalActionData(vr::VRActionHandle_t action, vr::IVRInput_004::InputDigitalActionData_t* pActionData, uint32_t unActionDataSize, vr::VRInputValueHandle_t ulRestrictToDevice) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_004)");
	return base->GetDigitalActionData(action, (OOVR_InputDigitalActionData_t*) pActionData, unActionDataSize, ulRestrictToDevice);
}
vr::EVRInputError CVRInput_004::GetAnalogActionData(vr::VRActionHandle_t action, vr::IVRInput_004::InputAnalogActionData_t* pActionData, uint32_t unActionDataSize, vr::VRInputValueHandle_t ulRestrictToDevice) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_004)");
	return base->GetAnalogActionData(action, (OOVR_InputAnalogActionData_t*) pActionData, unActionDataSize, ulRestrictToDevice);
}
vr::EVRInputError CVRInput_004::GetPoseActionData(vr::VRActionHandle_t action, vr::ETrackingUniverseOrigin eOrigin, float fPredictedSecondsFromNow, vr::IVRInput_004::InputPoseActionData_t* pActionData, uint32_t unActionDataSize, vr::VRInputValueHandle_t ulRestrictToDevice) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_004)");
	return base->GetPoseActionData(action, eOrigin, fPredictedSecondsFromNow, (OOVR_InputPoseActionData_t*) pActionData, unActionDataSize, ulRestrictToDevice);
}
vr::EVRInputError CVRInput_004::GetSkeletalBoneData(vr::VRActionHandle_t action, vr::IVRInput_004::EVRSkeletalTransformSpace eTransformSpace, vr::EVRSkeletalMotionRange eMotionRange, vr::VRBoneTransform_t* pTransformArray, uint32_t unTransformArrayCount, vr::VRInputValueHandle_t ulRestrictToDevice) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_004)");
	return base->GetSkeletalBoneData(action, (OOVR_EVRSkeletalTransformSpace) eTransformSpace, eMotionRange, pTransformArray, unTransformArrayCount, ulRestrictToDevice);
}
vr::EVRInputError CVRInput_004::GetSkeletalBoneDataCompressed(vr::VRActionHandle_t action, vr::IVRInput_004::EVRSkeletalTransformSpace eTransformSpace, vr::EVRSkeletalMotionRange eMotionRange, void* pvCompressedData, uint32_t unCompressedSize, uint32_t* punRequiredCompressedSize, vr::VRInputValueHandle_t ulRestrictToDevice) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_004)");
	return base->GetSkeletalBoneDataCompressed(action, (OOVR_EVRSkeletalTransformSpace) eTransformSpace, eMotionRange, pvCompressedData, unCompressedSize, punRequiredCompressedSize, ulRestrictToDevice);
}
vr::EVRInputError CVRInput_004::DecompressSkeletalBoneData(void* pvCompressedBuffer, uint32_t unCompressedBufferSize, vr::IVRInput_004::EVRSkeletalTransformSpace* peTransformSpace, vr::VRBoneTransform_t* pTransformArray, uint32_t unTransformArrayCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_004)");
	return base->DecompressSkeletalBoneData(pvCompressedBuffer, unCompressedBufferSize, (OOVR_EVRSkeletalTransformSpace*) peTransformSpace, pTransformArray, unTransformArrayCount);
}
vr::EVRInputError CVRInput_004::TriggerHapticVibrationAction(vr::VRActionHandle_t action, float fStartSecondsFromNow, float fDurationSeconds, float fFrequency, float fAmplitude, vr::VRInputValueHandle_t ulRestrictToDevice) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_004)");
	return base->TriggerHapticVibrationAction(action, fStartSecondsFromNow, fDurationSeconds, fFrequency, fAmplitude, ulRestrictToDevice);
}
vr::EVRInputError CVRInput_004::GetActionOrigins(vr::VRActionSetHandle_t actionSetHandle, vr::VRActionHandle_t digitalActionHandle, vr::VRInputValueHandle_t* originsOut, uint32_t originOutCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_004)");
	return base->GetActionOrigins(actionSetHandle, digitalActionHandle, originsOut, originOutCount);
}
vr::EVRInputError CVRInput_004::GetOriginLocalizedName(vr::VRInputValueHandle_t origin, char* pchNameArray, uint32_t unNameArraySize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_004)");
	return base->GetOriginLocalizedName(origin, pchNameArray, unNameArraySize);
}
vr::EVRInputError CVRInput_004::GetOriginTrackedDeviceInfo(vr::VRInputValueHandle_t origin, vr::IVRInput_004::InputOriginInfo_t* pOriginInfo, uint32_t unOriginInfoSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_004)");
	return base->GetOriginTrackedDeviceInfo(origin, (OOVR_InputOriginInfo_t*) pOriginInfo, unOriginInfoSize);
}
vr::EVRInputError CVRInput_004::ShowActionOrigins(vr::VRActionSetHandle_t actionSetHandle, vr::VRActionHandle_t ulActionHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_004)");
	return base->ShowActionOrigins(actionSetHandle, ulActionHandle);
}
vr::EVRInputError CVRInput_004::ShowBindingsForActionSet(vr::IVRInput_004::VRActiveActionSet_t* pSets, uint32_t unSizeOfVRSelectedActionSet_t, uint32_t unSetCount, vr::VRInputValueHandle_t originToHighlight) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_004)");
	return base->ShowBindingsForActionSet((OOVR_VRActiveActionSet_t*) pSets, unSizeOfVRSelectedActionSet_t, unSetCount, originToHighlight);
}
// FnTable for CVRInput_004:
static CVRInput_004 *fntable_Input_004_instance = NULL;
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_004_impl_SetActionManifestPath(const char* pchActionManifestPath) { return fntable_Input_004_instance->SetActionManifestPath(pchActionManifestPath); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_004_impl_GetActionSetHandle(const char* pchActionSetName, vr::VRActionSetHandle_t* pHandle) { return fntable_Input_004_instance->GetActionSetHandle(pchActionSetName, pHandle); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_004_impl_GetActionHandle(const char* pchActionName, vr::VRActionHandle_t* pHandle) { return fntable_Input_004_instance->GetActionHandle(pchActionName, pHandle); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_004_impl_GetInputSourceHandle(const char* pchInputSourcePath, vr::VRInputValueHandle_t* pHandle) { return fntable_Input_004_instance->GetInputSourceHandle(pchInputSourcePath, pHandle); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_004_impl_UpdateActionState(vr::IVRInput_004::VRActiveActionSet_t* pSets, uint32_t unSizeOfVRSelectedActionSet_t, uint32_t unSetCount) { return fntable_Input_004_instance->UpdateActionState(pSets, unSizeOfVRSelectedActionSet_t, unSetCount); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_004_impl_GetDigitalActionData(vr::VRActionHandle_t action, vr::IVRInput_004::InputDigitalActionData_t* pActionData, uint32_t unActionDataSize, vr::VRInputValueHandle_t ulRestrictToDevice) { return fntable_Input_004_instance->GetDigitalActionData(action, pActionData, unActionDataSize, ulRestrictToDevice); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_004_impl_GetAnalogActionData(vr::VRActionHandle_t action, vr::IVRInput_004::InputAnalogActionData_t* pActionData, uint32_t unActionDataSize, vr::VRInputValueHandle_t ulRestrictToDevice) { return fntable_Input_004_instance->GetAnalogActionData(action, pActionData, unActionDataSize, ulRestrictToDevice); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_004_impl_GetPoseActionData(vr::VRActionHandle_t action, vr::ETrackingUniverseOrigin eOrigin, float fPredictedSecondsFromNow, vr::IVRInput_004::InputPoseActionData_t* pActionData, uint32_t unActionDataSize, vr::VRInputValueHandle_t ulRestrictToDevice) { return fntable_Input_004_instance->GetPoseActionData(action, eOrigin, fPredictedSecondsFromNow, pActionData, unActionDataSize, ulRestrictToDevice); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_004_impl_GetSkeletalActionData(vr::VRActionHandle_t action, vr::IVRInput_004::InputSkeletalActionData_t* pActionData, uint32_t unActionDataSize, vr::VRInputValueHandle_t ulRestrictToDevice) { return fntable_Input_004_instance->GetSkeletalActionData(action, pActionData, unActionDataSize, ulRestrictToDevice); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_004_impl_GetSkeletalBoneData(vr::VRActionHandle_t action, vr::IVRInput_004::EVRSkeletalTransformSpace eTransformSpace, vr::EVRSkeletalMotionRange eMotionRange, vr::VRBoneTransform_t* pTransformArray, uint32_t unTransformArrayCount, vr::VRInputValueHandle_t ulRestrictToDevice) { return fntable_Input_004_instance->GetSkeletalBoneData(action, eTransformSpace, eMotionRange, pTransformArray, unTransformArrayCount, ulRestrictToDevice); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_004_impl_GetSkeletalBoneDataCompressed(vr::VRActionHandle_t action, vr::IVRInput_004::EVRSkeletalTransformSpace eTransformSpace, vr::EVRSkeletalMotionRange eMotionRange, void* pvCompressedData, uint32_t unCompressedSize, uint32_t* punRequiredCompressedSize, vr::VRInputValueHandle_t ulRestrictToDevice) { return fntable_Input_004_instance->GetSkeletalBoneDataCompressed(action, eTransformSpace, eMotionRange, pvCompressedData, unCompressedSize, punRequiredCompressedSize, ulRestrictToDevice); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_004_impl_DecompressSkeletalBoneData(void* pvCompressedBuffer, uint32_t unCompressedBufferSize, vr::IVRInput_004::EVRSkeletalTransformSpace* peTransformSpace, vr::VRBoneTransform_t* pTransformArray, uint32_t unTransformArrayCount) { return fntable_Input_004_instance->DecompressSkeletalBoneData(pvCompressedBuffer, unCompressedBufferSize, peTransformSpace, pTransformArray, unTransformArrayCount); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_004_impl_TriggerHapticVibrationAction(vr::VRActionHandle_t action, float fStartSecondsFromNow, float fDurationSeconds, float fFrequency, float fAmplitude, vr::VRInputValueHandle_t ulRestrictToDevice) { return fntable_Input_004_instance->TriggerHapticVibrationAction(action, fStartSecondsFromNow, fDurationSeconds, fFrequency, fAmplitude, ulRestrictToDevice); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_004_impl_GetActionOrigins(vr::VRActionSetHandle_t actionSetHandle, vr::VRActionHandle_t digitalActionHandle, vr::VRInputValueHandle_t* originsOut, uint32_t originOutCount) { return fntable_Input_004_instance->GetActionOrigins(actionSetHandle, digitalActionHandle, originsOut, originOutCount); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_004_impl_GetOriginLocalizedName(vr::VRInputValueHandle_t origin, char* pchNameArray, uint32_t unNameArraySize) { return fntable_Input_004_instance->GetOriginLocalizedName(origin, pchNameArray, unNameArraySize); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_004_impl_GetOriginTrackedDeviceInfo(vr::VRInputValueHandle_t origin, vr::IVRInput_004::InputOriginInfo_t* pOriginInfo, uint32_t unOriginInfoSize) { return fntable_Input_004_instance->GetOriginTrackedDeviceInfo(origin, pOriginInfo, unOriginInfoSize); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_004_impl_ShowActionOrigins(vr::VRActionSetHandle_t actionSetHandle, vr::VRActionHandle_t ulActionHandle) { return fntable_Input_004_instance->ShowActionOrigins(actionSetHandle, ulActionHandle); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_004_impl_ShowBindingsForActionSet(vr::IVRInput_004::VRActiveActionSet_t* pSets, uint32_t unSizeOfVRSelectedActionSet_t, uint32_t unSetCount, vr::VRInputValueHandle_t originToHighlight) { return fntable_Input_004_instance->ShowBindingsForActionSet(pSets, unSizeOfVRSelectedActionSet_t, unSetCount, originToHighlight); }
static void *fntable_Input_004_funcs[] = {
	(void*) fntable_Input_004_impl_SetActionManifestPath,
	(void*) fntable_Input_004_impl_GetActionSetHandle,
	(void*) fntable_Input_004_impl_GetActionHandle,
	(void*) fntable_Input_004_impl_GetInputSourceHandle,
	(void*) fntable_Input_004_impl_UpdateActionState,
	(void*) fntable_Input_004_impl_GetDigitalActionData,
	(void*) fntable_Input_004_impl_GetAnalogActionData,
	(void*) fntable_Input_004_impl_GetPoseActionData,
	(void*) fntable_Input_004_impl_GetSkeletalActionData,
	(void*) fntable_Input_004_impl_GetSkeletalBoneData,
	(void*) fntable_Input_004_impl_GetSkeletalBoneDataCompressed,
	(void*) fntable_Input_004_impl_DecompressSkeletalBoneData,
	(void*) fntable_Input_004_impl_TriggerHapticVibrationAction,
	(void*) fntable_Input_004_impl_GetActionOrigins,
	(void*) fntable_Input_004_impl_GetOriginLocalizedName,
	(void*) fntable_Input_004_impl_GetOriginTrackedDeviceInfo,
	(void*) fntable_Input_004_impl_ShowActionOrigins,
	(void*) fntable_Input_004_impl_ShowBindingsForActionSet,
};
void** CVRInput_004::_GetStatFuncList() { fntable_Input_004_instance = this; return fntable_Input_004_funcs; }
void CVRInput_004::Delete() { delete this; }
// Misc for CVRInput_005:
CVRInput_005::CVRInput_005() : base(GetCreateBaseInput()) {}
// Interface methods for CVRInput_005:
vr::EVRInputError CVRInput_005::SetActionManifestPath(const char* pchActionManifestPath) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_005)");
	return base->SetActionManifestPath(pchActionManifestPath);
}
vr::EVRInputError CVRInput_005::GetActionSetHandle(const char* pchActionSetName, vr::VRActionSetHandle_t* pHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_005)");
	return base->GetActionSetHandle(pchActionSetName, pHandle);
}
vr::EVRInputError CVRInput_005::GetActionHandle(const char* pchActionName, vr::VRActionHandle_t* pHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_005)");
	return base->GetActionHandle(pchActionName, pHandle);
}
vr::EVRInputError CVRInput_005::GetInputSourceHandle(const char* pchInputSourcePath, vr::VRInputValueHandle_t* pHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_005)");
	return base->GetInputSourceHandle(pchInputSourcePath, pHandle);
}
vr::EVRInputError CVRInput_005::UpdateActionState(vr::IVRInput_005::VRActiveActionSet_t* pSets, uint32_t unSizeOfVRSelectedActionSet_t, uint32_t unSetCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_005)");
	return base->UpdateActionState((OOVR_VRActiveActionSet_t*) pSets, unSizeOfVRSelectedActionSet_t, unSetCount);
}
vr::EVRInputError CVRInput_005::GetDigitalActionData(vr::VRActionHandle_t action, vr::IVRInput_005::InputDigitalActionData_t* pActionData, uint32_t unActionDataSize, vr::VRInputValueHandle_t ulRestrictToDevice) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_005)");
	return base->GetDigitalActionData(action, (OOVR_InputDigitalActionData_t*) pActionData, unActionDataSize, ulRestrictToDevice);
}
vr::EVRInputError CVRInput_005::GetAnalogActionData(vr::VRActionHandle_t action, vr::IVRInput_005::InputAnalogActionData_t* pActionData, uint32_t unActionDataSize, vr::VRInputValueHandle_t ulRestrictToDevice) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_005)");
	return base->GetAnalogActionData(action, (OOVR_InputAnalogActionData_t*) pActionData, unActionDataSize, ulRestrictToDevice);
}
vr::EVRInputError CVRInput_005::GetPoseActionData(vr::VRActionHandle_t action, vr::ETrackingUniverseOrigin eOrigin, float fPredictedSecondsFromNow, vr::IVRInput_005::InputPoseActionData_t* pActionData, uint32_t unActionDataSize, vr::VRInputValueHandle_t ulRestrictToDevice) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_005)");
	return base->GetPoseActionData(action, eOrigin, fPredictedSecondsFromNow, (OOVR_InputPoseActionData_t*) pActionData, unActionDataSize, ulRestrictToDevice);
}
vr::EVRInputError CVRInput_005::GetSkeletalActionData(vr::VRActionHandle_t action, vr::IVRInput_005::InputSkeletalActionData_t* pActionData, uint32_t unActionDataSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_005)");
	return base->GetSkeletalActionData(action, (OOVR_InputSkeletalActionData_t*) pActionData, unActionDataSize);
}
vr::EVRInputError CVRInput_005::GetBoneCount(vr::VRActionHandle_t action, uint32_t* pBoneCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_005)");
	return base->GetBoneCount(action, pBoneCount);
}
vr::EVRInputError CVRInput_005::GetBoneHierarchy(vr::VRActionHandle_t action, vr::BoneIndex_t* pParentIndices, uint32_t unIndexArayCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_005)");
	return base->GetBoneHierarchy(action, pParentIndices, unIndexArayCount);
}
vr::EVRInputError CVRInput_005::GetBoneName(vr::VRActionHandle_t action, vr::BoneIndex_t nBoneIndex, char* pchBoneName, uint32_t unNameBufferSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_005)");
	return base->GetBoneName(action, nBoneIndex, pchBoneName, unNameBufferSize);
}
vr::EVRInputError CVRInput_005::GetSkeletalReferenceTransforms(vr::VRActionHandle_t action, vr::IVRInput_005::EVRSkeletalTransformSpace eTransformSpace, vr::IVRInput_005::EVRSkeletalReferencePose eReferencePose, vr::VRBoneTransform_t* pTransformArray, uint32_t unTransformArrayCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_005)");
	return base->GetSkeletalReferenceTransforms(action, (OOVR_EVRSkeletalTransformSpace) eTransformSpace, (OOVR_EVRSkeletalReferencePose) eReferencePose, pTransformArray, unTransformArrayCount);
}
vr::EVRInputError CVRInput_005::GetSkeletalTrackingLevel(vr::VRActionHandle_t action, vr::IVRInput_005::EVRSkeletalTrackingLevel* pSkeletalTrackingLevel) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_005)");
	return base->GetSkeletalTrackingLevel(action, (OOVR_EVRSkeletalTrackingLevel*) pSkeletalTrackingLevel);
}
vr::EVRInputError CVRInput_005::GetSkeletalBoneData(vr::VRActionHandle_t action, vr::IVRInput_005::EVRSkeletalTransformSpace eTransformSpace, vr::EVRSkeletalMotionRange eMotionRange, vr::VRBoneTransform_t* pTransformArray, uint32_t unTransformArrayCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_005)");
	return base->GetSkeletalBoneData(action, (OOVR_EVRSkeletalTransformSpace) eTransformSpace, eMotionRange, pTransformArray, unTransformArrayCount);
}
vr::EVRInputError CVRInput_005::GetSkeletalSummaryData(vr::VRActionHandle_t action, vr::IVRInput_005::VRSkeletalSummaryData_t* pSkeletalSummaryData) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_005)");
	return base->GetSkeletalSummaryData(action, (OOVR_VRSkeletalSummaryData_t*) pSkeletalSummaryData);
}
vr::EVRInputError CVRInput_005::GetSkeletalBoneDataCompressed(vr::VRActionHandle_t action, vr::EVRSkeletalMotionRange eMotionRange, void* pvCompressedData, uint32_t unCompressedSize, uint32_t* punRequiredCompressedSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_005)");
	return base->GetSkeletalBoneDataCompressed(action, eMotionRange, pvCompressedData, unCompressedSize, punRequiredCompressedSize);
}
vr::EVRInputError CVRInput_005::DecompressSkeletalBoneData(const void* pvCompressedBuffer, uint32_t unCompressedBufferSize, vr::IVRInput_005::EVRSkeletalTransformSpace eTransformSpace, vr::VRBoneTransform_t* pTransformArray, uint32_t unTransformArrayCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_005)");
	return base->DecompressSkeletalBoneData(pvCompressedBuffer, unCompressedBufferSize, (OOVR_EVRSkeletalTransformSpace) eTransformSpace, pTransformArray, unTransformArrayCount);
}
vr::EVRInputError CVRInput_005::TriggerHapticVibrationAction(vr::VRActionHandle_t action, float fStartSecondsFromNow, float fDurationSeconds, float fFrequency, float fAmplitude, vr::VRInputValueHandle_t ulRestrictToDevice) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_005)");
	return base->TriggerHapticVibrationAction(action, fStartSecondsFromNow, fDurationSeconds, fFrequency, fAmplitude, ulRestrictToDevice);
}
vr::EVRInputError CVRInput_005::GetActionOrigins(vr::VRActionSetHandle_t actionSetHandle, vr::VRActionHandle_t digitalActionHandle, vr::VRInputValueHandle_t* originsOut, uint32_t originOutCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_005)");
	return base->GetActionOrigins(actionSetHandle, digitalActionHandle, originsOut, originOutCount);
}
vr::EVRInputError CVRInput_005::GetOriginLocalizedName(vr::VRInputValueHandle_t origin, char* pchNameArray, uint32_t unNameArraySize, int32_t unStringSectionsToInclude) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_005)");
	return base->GetOriginLocalizedName(origin, pchNameArray, unNameArraySize, unStringSectionsToInclude);
}
vr::EVRInputError CVRInput_005::GetOriginTrackedDeviceInfo(vr::VRInputValueHandle_t origin, vr::IVRInput_005::InputOriginInfo_t* pOriginInfo, uint32_t unOriginInfoSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_005)");
	return base->GetOriginTrackedDeviceInfo(origin, (OOVR_InputOriginInfo_t*) pOriginInfo, unOriginInfoSize);
}
vr::EVRInputError CVRInput_005::ShowActionOrigins(vr::VRActionSetHandle_t actionSetHandle, vr::VRActionHandle_t ulActionHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_005)");
	return base->ShowActionOrigins(actionSetHandle, ulActionHandle);
}
vr::EVRInputError CVRInput_005::ShowBindingsForActionSet(vr::IVRInput_005::VRActiveActionSet_t* pSets, uint32_t unSizeOfVRSelectedActionSet_t, uint32_t unSetCount, vr::VRInputValueHandle_t originToHighlight) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_005)");
	return base->ShowBindingsForActionSet((OOVR_VRActiveActionSet_t*) pSets, unSizeOfVRSelectedActionSet_t, unSetCount, originToHighlight);
}
// FnTable for CVRInput_005:
static CVRInput_005 *fntable_Input_005_instance = NULL;
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_005_impl_SetActionManifestPath(const char* pchActionManifestPath) { return fntable_Input_005_instance->SetActionManifestPath(pchActionManifestPath); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_005_impl_GetActionSetHandle(const char* pchActionSetName, vr::VRActionSetHandle_t* pHandle) { return fntable_Input_005_instance->GetActionSetHandle(pchActionSetName, pHandle); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_005_impl_GetActionHandle(const char* pchActionName, vr::VRActionHandle_t* pHandle) { return fntable_Input_005_instance->GetActionHandle(pchActionName, pHandle); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_005_impl_GetInputSourceHandle(const char* pchInputSourcePath, vr::VRInputValueHandle_t* pHandle) { return fntable_Input_005_instance->GetInputSourceHandle(pchInputSourcePath, pHandle); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_005_impl_UpdateActionState(vr::IVRInput_005::VRActiveActionSet_t* pSets, uint32_t unSizeOfVRSelectedActionSet_t, uint32_t unSetCount) { return fntable_Input_005_instance->UpdateActionState(pSets, unSizeOfVRSelectedActionSet_t, unSetCount); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_005_impl_GetDigitalActionData(vr::VRActionHandle_t action, vr::IVRInput_005::InputDigitalActionData_t* pActionData, uint32_t unActionDataSize, vr::VRInputValueHandle_t ulRestrictToDevice) { return fntable_Input_005_instance->GetDigitalActionData(action, pActionData, unActionDataSize, ulRestrictToDevice); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_005_impl_GetAnalogActionData(vr::VRActionHandle_t action, vr::IVRInput_005::InputAnalogActionData_t* pActionData, uint32_t unActionDataSize, vr::VRInputValueHandle_t ulRestrictToDevice) { return fntable_Input_005_instance->GetAnalogActionData(action, pActionData, unActionDataSize, ulRestrictToDevice); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_005_impl_GetPoseActionData(vr::VRActionHandle_t action, vr::ETrackingUniverseOrigin eOrigin, float fPredictedSecondsFromNow, vr::IVRInput_005::InputPoseActionData_t* pActionData, uint32_t unActionDataSize, vr::VRInputValueHandle_t ulRestrictToDevice) { return fntable_Input_005_instance->GetPoseActionData(action, eOrigin, fPredictedSecondsFromNow, pActionData, unActionDataSize, ulRestrictToDevice); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_005_impl_GetSkeletalActionData(vr::VRActionHandle_t action, vr::IVRInput_005::InputSkeletalActionData_t* pActionData, uint32_t unActionDataSize) { return fntable_Input_005_instance->GetSkeletalActionData(action, pActionData, unActionDataSize); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_005_impl_GetBoneCount(vr::VRActionHandle_t action, uint32_t* pBoneCount) { return fntable_Input_005_instance->GetBoneCount(action, pBoneCount); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_005_impl_GetBoneHierarchy(vr::VRActionHandle_t action, vr::BoneIndex_t* pParentIndices, uint32_t unIndexArayCount) { return fntable_Input_005_instance->GetBoneHierarchy(action, pParentIndices, unIndexArayCount); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_005_impl_GetBoneName(vr::VRActionHandle_t action, vr::BoneIndex_t nBoneIndex, char* pchBoneName, uint32_t unNameBufferSize) { return fntable_Input_005_instance->GetBoneName(action, nBoneIndex, pchBoneName, unNameBufferSize); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_005_impl_GetSkeletalReferenceTransforms(vr::VRActionHandle_t action, vr::IVRInput_005::EVRSkeletalTransformSpace eTransformSpace, vr::IVRInput_005::EVRSkeletalReferencePose eReferencePose, vr::VRBoneTransform_t* pTransformArray, uint32_t unTransformArrayCount) { return fntable_Input_005_instance->GetSkeletalReferenceTransforms(action, eTransformSpace, eReferencePose, pTransformArray, unTransformArrayCount); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_005_impl_GetSkeletalTrackingLevel(vr::VRActionHandle_t action, vr::IVRInput_005::EVRSkeletalTrackingLevel* pSkeletalTrackingLevel) { return fntable_Input_005_instance->GetSkeletalTrackingLevel(action, pSkeletalTrackingLevel); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_005_impl_GetSkeletalBoneData(vr::VRActionHandle_t action, vr::IVRInput_005::EVRSkeletalTransformSpace eTransformSpace, vr::EVRSkeletalMotionRange eMotionRange, vr::VRBoneTransform_t* pTransformArray, uint32_t unTransformArrayCount) { return fntable_Input_005_instance->GetSkeletalBoneData(action, eTransformSpace, eMotionRange, pTransformArray, unTransformArrayCount); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_005_impl_GetSkeletalSummaryData(vr::VRActionHandle_t action, vr::IVRInput_005::VRSkeletalSummaryData_t* pSkeletalSummaryData) { return fntable_Input_005_instance->GetSkeletalSummaryData(action, pSkeletalSummaryData); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_005_impl_GetSkeletalBoneDataCompressed(vr::VRActionHandle_t action, vr::EVRSkeletalMotionRange eMotionRange, void* pvCompressedData, uint32_t unCompressedSize, uint32_t* punRequiredCompressedSize) { return fntable_Input_005_instance->GetSkeletalBoneDataCompressed(action, eMotionRange, pvCompressedData, unCompressedSize, punRequiredCompressedSize); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_005_impl_DecompressSkeletalBoneData(const void* pvCompressedBuffer, uint32_t unCompressedBufferSize, vr::IVRInput_005::EVRSkeletalTransformSpace eTransformSpace, vr::VRBoneTransform_t* pTransformArray, uint32_t unTransformArrayCount) { return fntable_Input_005_instance->DecompressSkeletalBoneData(pvCompressedBuffer, unCompressedBufferSize, eTransformSpace, pTransformArray, unTransformArrayCount); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_005_impl_TriggerHapticVibrationAction(vr::VRActionHandle_t action, float fStartSecondsFromNow, float fDurationSeconds, float fFrequency, float fAmplitude, vr::VRInputValueHandle_t ulRestrictToDevice) { return fntable_Input_005_instance->TriggerHapticVibrationAction(action, fStartSecondsFromNow, fDurationSeconds, fFrequency, fAmplitude, ulRestrictToDevice); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_005_impl_GetActionOrigins(vr::VRActionSetHandle_t actionSetHandle, vr::VRActionHandle_t digitalActionHandle, vr::VRInputValueHandle_t* originsOut, uint32_t originOutCount) { return fntable_Input_005_instance->GetActionOrigins(actionSetHandle, digitalActionHandle, originsOut, originOutCount); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_005_impl_GetOriginLocalizedName(vr::VRInputValueHandle_t origin, char* pchNameArray, uint32_t unNameArraySize, int32_t unStringSectionsToInclude) { return fntable_Input_005_instance->GetOriginLocalizedName(origin, pchNameArray, unNameArraySize, unStringSectionsToInclude); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_005_impl_GetOriginTrackedDeviceInfo(vr::VRInputValueHandle_t origin, vr::IVRInput_005::InputOriginInfo_t* pOriginInfo, uint32_t unOriginInfoSize) { return fntable_Input_005_instance->GetOriginTrackedDeviceInfo(origin, pOriginInfo, unOriginInfoSize); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_005_impl_ShowActionOrigins(vr::VRActionSetHandle_t actionSetHandle, vr::VRActionHandle_t ulActionHandle) { return fntable_Input_005_instance->ShowActionOrigins(actionSetHandle, ulActionHandle); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_005_impl_ShowBindingsForActionSet(vr::IVRInput_005::VRActiveActionSet_t* pSets, uint32_t unSizeOfVRSelectedActionSet_t, uint32_t unSetCount, vr::VRInputValueHandle_t originToHighlight) { return fntable_Input_005_instance->ShowBindingsForActionSet(pSets, unSizeOfVRSelectedActionSet_t, unSetCount, originToHighlight); }
static void *fntable_Input_005_funcs[] = {
	(void*) fntable_Input_005_impl_SetActionManifestPath,
	(void*) fntable_Input_005_impl_GetActionSetHandle,
	(void*) fntable_Input_005_impl_GetActionHandle,
	(void*) fntable_Input_005_impl_GetInputSourceHandle,
	(void*) fntable_Input_005_impl_UpdateActionState,
	(void*) fntable_Input_005_impl_GetDigitalActionData,
	(void*) fntable_Input_005_impl_GetAnalogActionData,
	(void*) fntable_Input_005_impl_GetPoseActionData,
	(void*) fntable_Input_005_impl_GetSkeletalActionData,
	(void*) fntable_Input_005_impl_GetBoneCount,
	(void*) fntable_Input_005_impl_GetBoneHierarchy,
	(void*) fntable_Input_005_impl_GetBoneName,
	(void*) fntable_Input_005_impl_GetSkeletalReferenceTransforms,
	(void*) fntable_Input_005_impl_GetSkeletalTrackingLevel,
	(void*) fntable_Input_005_impl_GetSkeletalBoneData,
	(void*) fntable_Input_005_impl_GetSkeletalSummaryData,
	(void*) fntable_Input_005_impl_GetSkeletalBoneDataCompressed,
	(void*) fntable_Input_005_impl_DecompressSkeletalBoneData,
	(void*) fntable_Input_005_impl_TriggerHapticVibrationAction,
	(void*) fntable_Input_005_impl_GetActionOrigins,
	(void*) fntable_Input_005_impl_GetOriginLocalizedName,
	(void*) fntable_Input_005_impl_GetOriginTrackedDeviceInfo,
	(void*) fntable_Input_005_impl_ShowActionOrigins,
	(void*) fntable_Input_005_impl_ShowBindingsForActionSet,
};
void** CVRInput_005::_GetStatFuncList() { fntable_Input_005_instance = this; return fntable_Input_005_funcs; }
void CVRInput_005::Delete() { delete this; }
// Misc for CVRInput_006:
CVRInput_006::CVRInput_006() : base(GetCreateBaseInput()) {}
// Interface methods for CVRInput_006:
vr::EVRInputError CVRInput_006::SetActionManifestPath(const char* pchActionManifestPath) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_006)");
	return base->SetActionManifestPath(pchActionManifestPath);
}
vr::EVRInputError CVRInput_006::GetActionSetHandle(const char* pchActionSetName, vr::VRActionSetHandle_t* pHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_006)");
	return base->GetActionSetHandle(pchActionSetName, pHandle);
}
vr::EVRInputError CVRInput_006::GetActionHandle(const char* pchActionName, vr::VRActionHandle_t* pHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_006)");
	return base->GetActionHandle(pchActionName, pHandle);
}
vr::EVRInputError CVRInput_006::GetInputSourceHandle(const char* pchInputSourcePath, vr::VRInputValueHandle_t* pHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_006)");
	return base->GetInputSourceHandle(pchInputSourcePath, pHandle);
}
vr::EVRInputError CVRInput_006::UpdateActionState(vr::IVRInput_006::VRActiveActionSet_t* pSets, uint32_t unSizeOfVRSelectedActionSet_t, uint32_t unSetCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_006)");
	return base->UpdateActionState((OOVR_VRActiveActionSet_t*) pSets, unSizeOfVRSelectedActionSet_t, unSetCount);
}
vr::EVRInputError CVRInput_006::GetDigitalActionData(vr::VRActionHandle_t action, vr::IVRInput_006::InputDigitalActionData_t* pActionData, uint32_t unActionDataSize, vr::VRInputValueHandle_t ulRestrictToDevice) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_006)");
	return base->GetDigitalActionData(action, (OOVR_InputDigitalActionData_t*) pActionData, unActionDataSize, ulRestrictToDevice);
}
vr::EVRInputError CVRInput_006::GetAnalogActionData(vr::VRActionHandle_t action, vr::IVRInput_006::InputAnalogActionData_t* pActionData, uint32_t unActionDataSize, vr::VRInputValueHandle_t ulRestrictToDevice) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_006)");
	return base->GetAnalogActionData(action, (OOVR_InputAnalogActionData_t*) pActionData, unActionDataSize, ulRestrictToDevice);
}
vr::EVRInputError CVRInput_006::GetPoseActionDataRelativeToNow(vr::VRActionHandle_t action, vr::ETrackingUniverseOrigin eOrigin, float fPredictedSecondsFromNow, vr::IVRInput_006::InputPoseActionData_t* pActionData, uint32_t unActionDataSize, vr::VRInputValueHandle_t ulRestrictToDevice) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_006)");
	return base->GetPoseActionDataRelativeToNow(action, eOrigin, fPredictedSecondsFromNow, (OOVR_InputPoseActionData_t*) pActionData, unActionDataSize, ulRestrictToDevice);
}
vr::EVRInputError CVRInput_006::GetPoseActionDataForNextFrame(vr::VRActionHandle_t action, vr::ETrackingUniverseOrigin eOrigin, vr::IVRInput_006::InputPoseActionData_t* pActionData, uint32_t unActionDataSize, vr::VRInputValueHandle_t ulRestrictToDevice) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_006)");
	return base->GetPoseActionDataForNextFrame(action, eOrigin, (OOVR_InputPoseActionData_t*) pActionData, unActionDataSize, ulRestrictToDevice);
}
vr::EVRInputError CVRInput_006::GetSkeletalActionData(vr::VRActionHandle_t action, vr::IVRInput_006::InputSkeletalActionData_t* pActionData, uint32_t unActionDataSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_006)");
	return base->GetSkeletalActionData(action, (OOVR_InputSkeletalActionData_t*) pActionData, unActionDataSize);
}
vr::EVRInputError CVRInput_006::GetBoneCount(vr::VRActionHandle_t action, uint32_t* pBoneCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_006)");
	return base->GetBoneCount(action, pBoneCount);
}
vr::EVRInputError CVRInput_006::GetBoneHierarchy(vr::VRActionHandle_t action, vr::BoneIndex_t* pParentIndices, uint32_t unIndexArayCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_006)");
	return base->GetBoneHierarchy(action, pParentIndices, unIndexArayCount);
}
vr::EVRInputError CVRInput_006::GetBoneName(vr::VRActionHandle_t action, vr::BoneIndex_t nBoneIndex, char* pchBoneName, uint32_t unNameBufferSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_006)");
	return base->GetBoneName(action, nBoneIndex, pchBoneName, unNameBufferSize);
}
vr::EVRInputError CVRInput_006::GetSkeletalReferenceTransforms(vr::VRActionHandle_t action, vr::IVRInput_006::EVRSkeletalTransformSpace eTransformSpace, vr::IVRInput_006::EVRSkeletalReferencePose eReferencePose, vr::VRBoneTransform_t* pTransformArray, uint32_t unTransformArrayCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_006)");
	return base->GetSkeletalReferenceTransforms(action, (OOVR_EVRSkeletalTransformSpace) eTransformSpace, (OOVR_EVRSkeletalReferencePose) eReferencePose, pTransformArray, unTransformArrayCount);
}
vr::EVRInputError CVRInput_006::GetSkeletalTrackingLevel(vr::VRActionHandle_t action, vr::EVRSkeletalTrackingLevel* pSkeletalTrackingLevel) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_006)");
	return base->GetSkeletalTrackingLevel(action, pSkeletalTrackingLevel);
}
vr::EVRInputError CVRInput_006::GetSkeletalBoneData(vr::VRActionHandle_t action, vr::IVRInput_006::EVRSkeletalTransformSpace eTransformSpace, vr::EVRSkeletalMotionRange eMotionRange, vr::VRBoneTransform_t* pTransformArray, uint32_t unTransformArrayCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_006)");
	return base->GetSkeletalBoneData(action, (OOVR_EVRSkeletalTransformSpace) eTransformSpace, eMotionRange, pTransformArray, unTransformArrayCount);
}
vr::EVRInputError CVRInput_006::GetSkeletalSummaryData(vr::VRActionHandle_t action, vr::IVRInput_006::EVRSummaryType eSummaryType, vr::IVRInput_006::VRSkeletalSummaryData_t* pSkeletalSummaryData) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_006)");
	return base->GetSkeletalSummaryData(action, (OOVR_EVRSummaryType) eSummaryType, (OOVR_VRSkeletalSummaryData_t*) pSkeletalSummaryData);
}
vr::EVRInputError CVRInput_006::GetSkeletalBoneDataCompressed(vr::VRActionHandle_t action, vr::EVRSkeletalMotionRange eMotionRange, void* pvCompressedData, uint32_t unCompressedSize, uint32_t* punRequiredCompressedSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_006)");
	return base->GetSkeletalBoneDataCompressed(action, eMotionRange, pvCompressedData, unCompressedSize, punRequiredCompressedSize);
}
vr::EVRInputError CVRInput_006::DecompressSkeletalBoneData(const void* pvCompressedBuffer, uint32_t unCompressedBufferSize, vr::IVRInput_006::EVRSkeletalTransformSpace eTransformSpace, vr::VRBoneTransform_t* pTransformArray, uint32_t unTransformArrayCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_006)");
	return base->DecompressSkeletalBoneData(pvCompressedBuffer, unCompressedBufferSize, (OOVR_EVRSkeletalTransformSpace) eTransformSpace, pTransformArray, unTransformArrayCount);
}
vr::EVRInputError CVRInput_006::TriggerHapticVibrationAction(vr::VRActionHandle_t action, float fStartSecondsFromNow, float fDurationSeconds, float fFrequency, float fAmplitude, vr::VRInputValueHandle_t ulRestrictToDevice) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_006)");
	return base->TriggerHapticVibrationAction(action, fStartSecondsFromNow, fDurationSeconds, fFrequency, fAmplitude, ulRestrictToDevice);
}
vr::EVRInputError CVRInput_006::GetActionOrigins(vr::VRActionSetHandle_t actionSetHandle, vr::VRActionHandle_t digitalActionHandle, vr::VRInputValueHandle_t* originsOut, uint32_t originOutCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_006)");
	return base->GetActionOrigins(actionSetHandle, digitalActionHandle, originsOut, originOutCount);
}
vr::EVRInputError CVRInput_006::GetOriginLocalizedName(vr::VRInputValueHandle_t origin, char* pchNameArray, uint32_t unNameArraySize, int32_t unStringSectionsToInclude) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_006)");
	return base->GetOriginLocalizedName(origin, pchNameArray, unNameArraySize, unStringSectionsToInclude);
}
vr::EVRInputError CVRInput_006::GetOriginTrackedDeviceInfo(vr::VRInputValueHandle_t origin, vr::IVRInput_006::InputOriginInfo_t* pOriginInfo, uint32_t unOriginInfoSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_006)");
	return base->GetOriginTrackedDeviceInfo(origin, (OOVR_InputOriginInfo_t*) pOriginInfo, unOriginInfoSize);
}
vr::EVRInputError CVRInput_006::ShowActionOrigins(vr::VRActionSetHandle_t actionSetHandle, vr::VRActionHandle_t ulActionHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_006)");
	return base->ShowActionOrigins(actionSetHandle, ulActionHandle);
}
vr::EVRInputError CVRInput_006::ShowBindingsForActionSet(vr::IVRInput_006::VRActiveActionSet_t* pSets, uint32_t unSizeOfVRSelectedActionSet_t, uint32_t unSetCount, vr::VRInputValueHandle_t originToHighlight) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_006)");
	return base->ShowBindingsForActionSet((OOVR_VRActiveActionSet_t*) pSets, unSizeOfVRSelectedActionSet_t, unSetCount, originToHighlight);
}
bool CVRInput_006::IsUsingLegacyInput() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_006)");
	return base->IsUsingLegacyInput();
}
// FnTable for CVRInput_006:
static CVRInput_006 *fntable_Input_006_instance = NULL;
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_006_impl_SetActionManifestPath(const char* pchActionManifestPath) { return fntable_Input_006_instance->SetActionManifestPath(pchActionManifestPath); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_006_impl_GetActionSetHandle(const char* pchActionSetName, vr::VRActionSetHandle_t* pHandle) { return fntable_Input_006_instance->GetActionSetHandle(pchActionSetName, pHandle); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_006_impl_GetActionHandle(const char* pchActionName, vr::VRActionHandle_t* pHandle) { return fntable_Input_006_instance->GetActionHandle(pchActionName, pHandle); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_006_impl_GetInputSourceHandle(const char* pchInputSourcePath, vr::VRInputValueHandle_t* pHandle) { return fntable_Input_006_instance->GetInputSourceHandle(pchInputSourcePath, pHandle); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_006_impl_UpdateActionState(vr::IVRInput_006::VRActiveActionSet_t* pSets, uint32_t unSizeOfVRSelectedActionSet_t, uint32_t unSetCount) { return fntable_Input_006_instance->UpdateActionState(pSets, unSizeOfVRSelectedActionSet_t, unSetCount); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_006_impl_GetDigitalActionData(vr::VRActionHandle_t action, vr::IVRInput_006::InputDigitalActionData_t* pActionData, uint32_t unActionDataSize, vr::VRInputValueHandle_t ulRestrictToDevice) { return fntable_Input_006_instance->GetDigitalActionData(action, pActionData, unActionDataSize, ulRestrictToDevice); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_006_impl_GetAnalogActionData(vr::VRActionHandle_t action, vr::IVRInput_006::InputAnalogActionData_t* pActionData, uint32_t unActionDataSize, vr::VRInputValueHandle_t ulRestrictToDevice) { return fntable_Input_006_instance->GetAnalogActionData(action, pActionData, unActionDataSize, ulRestrictToDevice); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_006_impl_GetPoseActionDataRelativeToNow(vr::VRActionHandle_t action, vr::ETrackingUniverseOrigin eOrigin, float fPredictedSecondsFromNow, vr::IVRInput_006::InputPoseActionData_t* pActionData, uint32_t unActionDataSize, vr::VRInputValueHandle_t ulRestrictToDevice) { return fntable_Input_006_instance->GetPoseActionDataRelativeToNow(action, eOrigin, fPredictedSecondsFromNow, pActionData, unActionDataSize, ulRestrictToDevice); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_006_impl_GetPoseActionDataForNextFrame(vr::VRActionHandle_t action, vr::ETrackingUniverseOrigin eOrigin, vr::IVRInput_006::InputPoseActionData_t* pActionData, uint32_t unActionDataSize, vr::VRInputValueHandle_t ulRestrictToDevice) { return fntable_Input_006_instance->GetPoseActionDataForNextFrame(action, eOrigin, pActionData, unActionDataSize, ulRestrictToDevice); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_006_impl_GetSkeletalActionData(vr::VRActionHandle_t action, vr::IVRInput_006::InputSkeletalActionData_t* pActionData, uint32_t unActionDataSize) { return fntable_Input_006_instance->GetSkeletalActionData(action, pActionData, unActionDataSize); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_006_impl_GetBoneCount(vr::VRActionHandle_t action, uint32_t* pBoneCount) { return fntable_Input_006_instance->GetBoneCount(action, pBoneCount); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_006_impl_GetBoneHierarchy(vr::VRActionHandle_t action, vr::BoneIndex_t* pParentIndices, uint32_t unIndexArayCount) { return fntable_Input_006_instance->GetBoneHierarchy(action, pParentIndices, unIndexArayCount); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_006_impl_GetBoneName(vr::VRActionHandle_t action, vr::BoneIndex_t nBoneIndex, char* pchBoneName, uint32_t unNameBufferSize) { return fntable_Input_006_instance->GetBoneName(action, nBoneIndex, pchBoneName, unNameBufferSize); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_006_impl_GetSkeletalReferenceTransforms(vr::VRActionHandle_t action, vr::IVRInput_006::EVRSkeletalTransformSpace eTransformSpace, vr::IVRInput_006::EVRSkeletalReferencePose eReferencePose, vr::VRBoneTransform_t* pTransformArray, uint32_t unTransformArrayCount) { return fntable_Input_006_instance->GetSkeletalReferenceTransforms(action, eTransformSpace, eReferencePose, pTransformArray, unTransformArrayCount); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_006_impl_GetSkeletalTrackingLevel(vr::VRActionHandle_t action, vr::EVRSkeletalTrackingLevel* pSkeletalTrackingLevel) { return fntable_Input_006_instance->GetSkeletalTrackingLevel(action, pSkeletalTrackingLevel); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_006_impl_GetSkeletalBoneData(vr::VRActionHandle_t action, vr::IVRInput_006::EVRSkeletalTransformSpace eTransformSpace, vr::EVRSkeletalMotionRange eMotionRange, vr::VRBoneTransform_t* pTransformArray, uint32_t unTransformArrayCount) { return fntable_Input_006_instance->GetSkeletalBoneData(action, eTransformSpace, eMotionRange, pTransformArray, unTransformArrayCount); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_006_impl_GetSkeletalSummaryData(vr::VRActionHandle_t action, vr::IVRInput_006::EVRSummaryType eSummaryType, vr::IVRInput_006::VRSkeletalSummaryData_t* pSkeletalSummaryData) { return fntable_Input_006_instance->GetSkeletalSummaryData(action, eSummaryType, pSkeletalSummaryData); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_006_impl_GetSkeletalBoneDataCompressed(vr::VRActionHandle_t action, vr::EVRSkeletalMotionRange eMotionRange, void* pvCompressedData, uint32_t unCompressedSize, uint32_t* punRequiredCompressedSize) { return fntable_Input_006_instance->GetSkeletalBoneDataCompressed(action, eMotionRange, pvCompressedData, unCompressedSize, punRequiredCompressedSize); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_006_impl_DecompressSkeletalBoneData(const void* pvCompressedBuffer, uint32_t unCompressedBufferSize, vr::IVRInput_006::EVRSkeletalTransformSpace eTransformSpace, vr::VRBoneTransform_t* pTransformArray, uint32_t unTransformArrayCount) { return fntable_Input_006_instance->DecompressSkeletalBoneData(pvCompressedBuffer, unCompressedBufferSize, eTransformSpace, pTransformArray, unTransformArrayCount); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_006_impl_TriggerHapticVibrationAction(vr::VRActionHandle_t action, float fStartSecondsFromNow, float fDurationSeconds, float fFrequency, float fAmplitude, vr::VRInputValueHandle_t ulRestrictToDevice) { return fntable_Input_006_instance->TriggerHapticVibrationAction(action, fStartSecondsFromNow, fDurationSeconds, fFrequency, fAmplitude, ulRestrictToDevice); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_006_impl_GetActionOrigins(vr::VRActionSetHandle_t actionSetHandle, vr::VRActionHandle_t digitalActionHandle, vr::VRInputValueHandle_t* originsOut, uint32_t originOutCount) { return fntable_Input_006_instance->GetActionOrigins(actionSetHandle, digitalActionHandle, originsOut, originOutCount); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_006_impl_GetOriginLocalizedName(vr::VRInputValueHandle_t origin, char* pchNameArray, uint32_t unNameArraySize, int32_t unStringSectionsToInclude) { return fntable_Input_006_instance->GetOriginLocalizedName(origin, pchNameArray, unNameArraySize, unStringSectionsToInclude); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_006_impl_GetOriginTrackedDeviceInfo(vr::VRInputValueHandle_t origin, vr::IVRInput_006::InputOriginInfo_t* pOriginInfo, uint32_t unOriginInfoSize) { return fntable_Input_006_instance->GetOriginTrackedDeviceInfo(origin, pOriginInfo, unOriginInfoSize); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_006_impl_ShowActionOrigins(vr::VRActionSetHandle_t actionSetHandle, vr::VRActionHandle_t ulActionHandle) { return fntable_Input_006_instance->ShowActionOrigins(actionSetHandle, ulActionHandle); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_006_impl_ShowBindingsForActionSet(vr::IVRInput_006::VRActiveActionSet_t* pSets, uint32_t unSizeOfVRSelectedActionSet_t, uint32_t unSetCount, vr::VRInputValueHandle_t originToHighlight) { return fntable_Input_006_instance->ShowBindingsForActionSet(pSets, unSizeOfVRSelectedActionSet_t, unSetCount, originToHighlight); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Input_006_impl_IsUsingLegacyInput() { return fntable_Input_006_instance->IsUsingLegacyInput(); }
static void *fntable_Input_006_funcs[] = {
	(void*) fntable_Input_006_impl_SetActionManifestPath,
	(void*) fntable_Input_006_impl_GetActionSetHandle,
	(void*) fntable_Input_006_impl_GetActionHandle,
	(void*) fntable_Input_006_impl_GetInputSourceHandle,
	(void*) fntable_Input_006_impl_UpdateActionState,
	(void*) fntable_Input_006_impl_GetDigitalActionData,
	(void*) fntable_Input_006_impl_GetAnalogActionData,
	(void*) fntable_Input_006_impl_GetPoseActionDataRelativeToNow,
	(void*) fntable_Input_006_impl_GetPoseActionDataForNextFrame,
	(void*) fntable_Input_006_impl_GetSkeletalActionData,
	(void*) fntable_Input_006_impl_GetBoneCount,
	(void*) fntable_Input_006_impl_GetBoneHierarchy,
	(void*) fntable_Input_006_impl_GetBoneName,
	(void*) fntable_Input_006_impl_GetSkeletalReferenceTransforms,
	(void*) fntable_Input_006_impl_GetSkeletalTrackingLevel,
	(void*) fntable_Input_006_impl_GetSkeletalBoneData,
	(void*) fntable_Input_006_impl_GetSkeletalSummaryData,
	(void*) fntable_Input_006_impl_GetSkeletalBoneDataCompressed,
	(void*) fntable_Input_006_impl_DecompressSkeletalBoneData,
	(void*) fntable_Input_006_impl_TriggerHapticVibrationAction,
	(void*) fntable_Input_006_impl_GetActionOrigins,
	(void*) fntable_Input_006_impl_GetOriginLocalizedName,
	(void*) fntable_Input_006_impl_GetOriginTrackedDeviceInfo,
	(void*) fntable_Input_006_impl_ShowActionOrigins,
	(void*) fntable_Input_006_impl_ShowBindingsForActionSet,
	(void*) fntable_Input_006_impl_IsUsingLegacyInput,
};
void** CVRInput_006::_GetStatFuncList() { fntable_Input_006_instance = this; return fntable_Input_006_funcs; }
void CVRInput_006::Delete() { delete this; }
// Misc for CVRInput_007:
CVRInput_007::CVRInput_007() : base(GetCreateBaseInput()) {}
// Interface methods for CVRInput_007:
vr::EVRInputError CVRInput_007::SetActionManifestPath(const char* pchActionManifestPath) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_007)");
	return base->SetActionManifestPath(pchActionManifestPath);
}
vr::EVRInputError CVRInput_007::GetActionSetHandle(const char* pchActionSetName, vr::VRActionSetHandle_t* pHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_007)");
	return base->GetActionSetHandle(pchActionSetName, pHandle);
}
vr::EVRInputError CVRInput_007::GetActionHandle(const char* pchActionName, vr::VRActionHandle_t* pHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_007)");
	return base->GetActionHandle(pchActionName, pHandle);
}
vr::EVRInputError CVRInput_007::GetInputSourceHandle(const char* pchInputSourcePath, vr::VRInputValueHandle_t* pHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_007)");
	return base->GetInputSourceHandle(pchInputSourcePath, pHandle);
}
vr::EVRInputError CVRInput_007::UpdateActionState(vr::IVRInput_007::VRActiveActionSet_t* pSets, uint32_t unSizeOfVRSelectedActionSet_t, uint32_t unSetCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_007)");
	return base->UpdateActionState((OOVR_VRActiveActionSet_t*) pSets, unSizeOfVRSelectedActionSet_t, unSetCount);
}
vr::EVRInputError CVRInput_007::GetDigitalActionData(vr::VRActionHandle_t action, vr::IVRInput_007::InputDigitalActionData_t* pActionData, uint32_t unActionDataSize, vr::VRInputValueHandle_t ulRestrictToDevice) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_007)");
	return base->GetDigitalActionData(action, (OOVR_InputDigitalActionData_t*) pActionData, unActionDataSize, ulRestrictToDevice);
}
vr::EVRInputError CVRInput_007::GetAnalogActionData(vr::VRActionHandle_t action, vr::IVRInput_007::InputAnalogActionData_t* pActionData, uint32_t unActionDataSize, vr::VRInputValueHandle_t ulRestrictToDevice) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_007)");
	return base->GetAnalogActionData(action, (OOVR_InputAnalogActionData_t*) pActionData, unActionDataSize, ulRestrictToDevice);
}
vr::EVRInputError CVRInput_007::GetPoseActionDataRelativeToNow(vr::VRActionHandle_t action, vr::ETrackingUniverseOrigin eOrigin, float fPredictedSecondsFromNow, vr::IVRInput_007::InputPoseActionData_t* pActionData, uint32_t unActionDataSize, vr::VRInputValueHandle_t ulRestrictToDevice) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_007)");
	return base->GetPoseActionDataRelativeToNow(action, eOrigin, fPredictedSecondsFromNow, (OOVR_InputPoseActionData_t*) pActionData, unActionDataSize, ulRestrictToDevice);
}
vr::EVRInputError CVRInput_007::GetPoseActionDataForNextFrame(vr::VRActionHandle_t action, vr::ETrackingUniverseOrigin eOrigin, vr::IVRInput_007::InputPoseActionData_t* pActionData, uint32_t unActionDataSize, vr::VRInputValueHandle_t ulRestrictToDevice) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_007)");
	return base->GetPoseActionDataForNextFrame(action, eOrigin, (OOVR_InputPoseActionData_t*) pActionData, unActionDataSize, ulRestrictToDevice);
}
vr::EVRInputError CVRInput_007::GetSkeletalActionData(vr::VRActionHandle_t action, vr::IVRInput_007::InputSkeletalActionData_t* pActionData, uint32_t unActionDataSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_007)");
	return base->GetSkeletalActionData(action, (OOVR_InputSkeletalActionData_t*) pActionData, unActionDataSize);
}
vr::EVRInputError CVRInput_007::GetBoneCount(vr::VRActionHandle_t action, uint32_t* pBoneCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_007)");
	return base->GetBoneCount(action, pBoneCount);
}
vr::EVRInputError CVRInput_007::GetBoneHierarchy(vr::VRActionHandle_t action, vr::BoneIndex_t* pParentIndices, uint32_t unIndexArayCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_007)");
	return base->GetBoneHierarchy(action, pParentIndices, unIndexArayCount);
}
vr::EVRInputError CVRInput_007::GetBoneName(vr::VRActionHandle_t action, vr::BoneIndex_t nBoneIndex, char* pchBoneName, uint32_t unNameBufferSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_007)");
	return base->GetBoneName(action, nBoneIndex, pchBoneName, unNameBufferSize);
}
vr::EVRInputError CVRInput_007::GetSkeletalReferenceTransforms(vr::VRActionHandle_t action, vr::IVRInput_007::EVRSkeletalTransformSpace eTransformSpace, vr::IVRInput_007::EVRSkeletalReferencePose eReferencePose, vr::VRBoneTransform_t* pTransformArray, uint32_t unTransformArrayCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_007)");
	return base->GetSkeletalReferenceTransforms(action, (OOVR_EVRSkeletalTransformSpace) eTransformSpace, (OOVR_EVRSkeletalReferencePose) eReferencePose, pTransformArray, unTransformArrayCount);
}
vr::EVRInputError CVRInput_007::GetSkeletalTrackingLevel(vr::VRActionHandle_t action, vr::EVRSkeletalTrackingLevel* pSkeletalTrackingLevel) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_007)");
	return base->GetSkeletalTrackingLevel(action, pSkeletalTrackingLevel);
}
vr::EVRInputError CVRInput_007::GetSkeletalBoneData(vr::VRActionHandle_t action, vr::IVRInput_007::EVRSkeletalTransformSpace eTransformSpace, vr::EVRSkeletalMotionRange eMotionRange, vr::VRBoneTransform_t* pTransformArray, uint32_t unTransformArrayCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_007)");
	return base->GetSkeletalBoneData(action, (OOVR_EVRSkeletalTransformSpace) eTransformSpace, eMotionRange, pTransformArray, unTransformArrayCount);
}
vr::EVRInputError CVRInput_007::GetSkeletalSummaryData(vr::VRActionHandle_t action, vr::IVRInput_007::EVRSummaryType eSummaryType, vr::IVRInput_007::VRSkeletalSummaryData_t* pSkeletalSummaryData) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_007)");
	return base->GetSkeletalSummaryData(action, (OOVR_EVRSummaryType) eSummaryType, (OOVR_VRSkeletalSummaryData_t*) pSkeletalSummaryData);
}
vr::EVRInputError CVRInput_007::GetSkeletalBoneDataCompressed(vr::VRActionHandle_t action, vr::EVRSkeletalMotionRange eMotionRange, void* pvCompressedData, uint32_t unCompressedSize, uint32_t* punRequiredCompressedSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_007)");
	return base->GetSkeletalBoneDataCompressed(action, eMotionRange, pvCompressedData, unCompressedSize, punRequiredCompressedSize);
}
vr::EVRInputError CVRInput_007::DecompressSkeletalBoneData(const void* pvCompressedBuffer, uint32_t unCompressedBufferSize, vr::IVRInput_007::EVRSkeletalTransformSpace eTransformSpace, vr::VRBoneTransform_t* pTransformArray, uint32_t unTransformArrayCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_007)");
	return base->DecompressSkeletalBoneData(pvCompressedBuffer, unCompressedBufferSize, (OOVR_EVRSkeletalTransformSpace) eTransformSpace, pTransformArray, unTransformArrayCount);
}
vr::EVRInputError CVRInput_007::TriggerHapticVibrationAction(vr::VRActionHandle_t action, float fStartSecondsFromNow, float fDurationSeconds, float fFrequency, float fAmplitude, vr::VRInputValueHandle_t ulRestrictToDevice) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_007)");
	return base->TriggerHapticVibrationAction(action, fStartSecondsFromNow, fDurationSeconds, fFrequency, fAmplitude, ulRestrictToDevice);
}
vr::EVRInputError CVRInput_007::GetActionOrigins(vr::VRActionSetHandle_t actionSetHandle, vr::VRActionHandle_t digitalActionHandle, vr::VRInputValueHandle_t* originsOut, uint32_t originOutCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_007)");
	return base->GetActionOrigins(actionSetHandle, digitalActionHandle, originsOut, originOutCount);
}
vr::EVRInputError CVRInput_007::GetOriginLocalizedName(vr::VRInputValueHandle_t origin, char* pchNameArray, uint32_t unNameArraySize, int32_t unStringSectionsToInclude) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_007)");
	return base->GetOriginLocalizedName(origin, pchNameArray, unNameArraySize, unStringSectionsToInclude);
}
vr::EVRInputError CVRInput_007::GetOriginTrackedDeviceInfo(vr::VRInputValueHandle_t origin, vr::IVRInput_007::InputOriginInfo_t* pOriginInfo, uint32_t unOriginInfoSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_007)");
	return base->GetOriginTrackedDeviceInfo(origin, (OOVR_InputOriginInfo_t*) pOriginInfo, unOriginInfoSize);
}
vr::EVRInputError CVRInput_007::GetActionBindingInfo(vr::VRActionHandle_t action, vr::IVRInput_007::InputBindingInfo_t* pOriginInfo, uint32_t unBindingInfoSize, uint32_t unBindingInfoCount, uint32_t* punReturnedBindingInfoCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_007)");
	return base->GetActionBindingInfo(action, (OOVR_InputBindingInfo_t*) pOriginInfo, unBindingInfoSize, unBindingInfoCount, punReturnedBindingInfoCount);
}
vr::EVRInputError CVRInput_007::ShowActionOrigins(vr::VRActionSetHandle_t actionSetHandle, vr::VRActionHandle_t ulActionHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_007)");
	return base->ShowActionOrigins(actionSetHandle, ulActionHandle);
}
vr::EVRInputError CVRInput_007::ShowBindingsForActionSet(vr::IVRInput_007::VRActiveActionSet_t* pSets, uint32_t unSizeOfVRSelectedActionSet_t, uint32_t unSetCount, vr::VRInputValueHandle_t originToHighlight) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_007)");
	return base->ShowBindingsForActionSet((OOVR_VRActiveActionSet_t*) pSets, unSizeOfVRSelectedActionSet_t, unSetCount, originToHighlight);
}
bool CVRInput_007::IsUsingLegacyInput() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_007)");
	return base->IsUsingLegacyInput();
}
vr::EVRInputError CVRInput_007::OpenBindingUI(const char* pchAppKey, vr::VRActionSetHandle_t ulActionSetHandle, vr::VRInputValueHandle_t ulDeviceHandle, bool bShowOnDesktop) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_007)");
	return base->OpenBindingUI(pchAppKey, ulActionSetHandle, ulDeviceHandle, bShowOnDesktop);
}
// FnTable for CVRInput_007:
static CVRInput_007 *fntable_Input_007_instance = NULL;
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_007_impl_SetActionManifestPath(const char* pchActionManifestPath) { return fntable_Input_007_instance->SetActionManifestPath(pchActionManifestPath); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_007_impl_GetActionSetHandle(const char* pchActionSetName, vr::VRActionSetHandle_t* pHandle) { return fntable_Input_007_instance->GetActionSetHandle(pchActionSetName, pHandle); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_007_impl_GetActionHandle(const char* pchActionName, vr::VRActionHandle_t* pHandle) { return fntable_Input_007_instance->GetActionHandle(pchActionName, pHandle); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_007_impl_GetInputSourceHandle(const char* pchInputSourcePath, vr::VRInputValueHandle_t* pHandle) { return fntable_Input_007_instance->GetInputSourceHandle(pchInputSourcePath, pHandle); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_007_impl_UpdateActionState(vr::IVRInput_007::VRActiveActionSet_t* pSets, uint32_t unSizeOfVRSelectedActionSet_t, uint32_t unSetCount) { return fntable_Input_007_instance->UpdateActionState(pSets, unSizeOfVRSelectedActionSet_t, unSetCount); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_007_impl_GetDigitalActionData(vr::VRActionHandle_t action, vr::IVRInput_007::InputDigitalActionData_t* pActionData, uint32_t unActionDataSize, vr::VRInputValueHandle_t ulRestrictToDevice) { return fntable_Input_007_instance->GetDigitalActionData(action, pActionData, unActionDataSize, ulRestrictToDevice); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_007_impl_GetAnalogActionData(vr::VRActionHandle_t action, vr::IVRInput_007::InputAnalogActionData_t* pActionData, uint32_t unActionDataSize, vr::VRInputValueHandle_t ulRestrictToDevice) { return fntable_Input_007_instance->GetAnalogActionData(action, pActionData, unActionDataSize, ulRestrictToDevice); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_007_impl_GetPoseActionDataRelativeToNow(vr::VRActionHandle_t action, vr::ETrackingUniverseOrigin eOrigin, float fPredictedSecondsFromNow, vr::IVRInput_007::InputPoseActionData_t* pActionData, uint32_t unActionDataSize, vr::VRInputValueHandle_t ulRestrictToDevice) { return fntable_Input_007_instance->GetPoseActionDataRelativeToNow(action, eOrigin, fPredictedSecondsFromNow, pActionData, unActionDataSize, ulRestrictToDevice); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_007_impl_GetPoseActionDataForNextFrame(vr::VRActionHandle_t action, vr::ETrackingUniverseOrigin eOrigin, vr::IVRInput_007::InputPoseActionData_t* pActionData, uint32_t unActionDataSize, vr::VRInputValueHandle_t ulRestrictToDevice) { return fntable_Input_007_instance->GetPoseActionDataForNextFrame(action, eOrigin, pActionData, unActionDataSize, ulRestrictToDevice); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_007_impl_GetSkeletalActionData(vr::VRActionHandle_t action, vr::IVRInput_007::InputSkeletalActionData_t* pActionData, uint32_t unActionDataSize) { return fntable_Input_007_instance->GetSkeletalActionData(action, pActionData, unActionDataSize); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_007_impl_GetBoneCount(vr::VRActionHandle_t action, uint32_t* pBoneCount) { return fntable_Input_007_instance->GetBoneCount(action, pBoneCount); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_007_impl_GetBoneHierarchy(vr::VRActionHandle_t action, vr::BoneIndex_t* pParentIndices, uint32_t unIndexArayCount) { return fntable_Input_007_instance->GetBoneHierarchy(action, pParentIndices, unIndexArayCount); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_007_impl_GetBoneName(vr::VRActionHandle_t action, vr::BoneIndex_t nBoneIndex, char* pchBoneName, uint32_t unNameBufferSize) { return fntable_Input_007_instance->GetBoneName(action, nBoneIndex, pchBoneName, unNameBufferSize); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_007_impl_GetSkeletalReferenceTransforms(vr::VRActionHandle_t action, vr::IVRInput_007::EVRSkeletalTransformSpace eTransformSpace, vr::IVRInput_007::EVRSkeletalReferencePose eReferencePose, vr::VRBoneTransform_t* pTransformArray, uint32_t unTransformArrayCount) { return fntable_Input_007_instance->GetSkeletalReferenceTransforms(action, eTransformSpace, eReferencePose, pTransformArray, unTransformArrayCount); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_007_impl_GetSkeletalTrackingLevel(vr::VRActionHandle_t action, vr::EVRSkeletalTrackingLevel* pSkeletalTrackingLevel) { return fntable_Input_007_instance->GetSkeletalTrackingLevel(action, pSkeletalTrackingLevel); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_007_impl_GetSkeletalBoneData(vr::VRActionHandle_t action, vr::IVRInput_007::EVRSkeletalTransformSpace eTransformSpace, vr::EVRSkeletalMotionRange eMotionRange, vr::VRBoneTransform_t* pTransformArray, uint32_t unTransformArrayCount) { return fntable_Input_007_instance->GetSkeletalBoneData(action, eTransformSpace, eMotionRange, pTransformArray, unTransformArrayCount); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_007_impl_GetSkeletalSummaryData(vr::VRActionHandle_t action, vr::IVRInput_007::EVRSummaryType eSummaryType, vr::IVRInput_007::VRSkeletalSummaryData_t* pSkeletalSummaryData) { return fntable_Input_007_instance->GetSkeletalSummaryData(action, eSummaryType, pSkeletalSummaryData); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_007_impl_GetSkeletalBoneDataCompressed(vr::VRActionHandle_t action, vr::EVRSkeletalMotionRange eMotionRange, void* pvCompressedData, uint32_t unCompressedSize, uint32_t* punRequiredCompressedSize) { return fntable_Input_007_instance->GetSkeletalBoneDataCompressed(action, eMotionRange, pvCompressedData, unCompressedSize, punRequiredCompressedSize); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_007_impl_DecompressSkeletalBoneData(const void* pvCompressedBuffer, uint32_t unCompressedBufferSize, vr::IVRInput_007::EVRSkeletalTransformSpace eTransformSpace, vr::VRBoneTransform_t* pTransformArray, uint32_t unTransformArrayCount) { return fntable_Input_007_instance->DecompressSkeletalBoneData(pvCompressedBuffer, unCompressedBufferSize, eTransformSpace, pTransformArray, unTransformArrayCount); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_007_impl_TriggerHapticVibrationAction(vr::VRActionHandle_t action, float fStartSecondsFromNow, float fDurationSeconds, float fFrequency, float fAmplitude, vr::VRInputValueHandle_t ulRestrictToDevice) { return fntable_Input_007_instance->TriggerHapticVibrationAction(action, fStartSecondsFromNow, fDurationSeconds, fFrequency, fAmplitude, ulRestrictToDevice); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_007_impl_GetActionOrigins(vr::VRActionSetHandle_t actionSetHandle, vr::VRActionHandle_t digitalActionHandle, vr::VRInputValueHandle_t* originsOut, uint32_t originOutCount) { return fntable_Input_007_instance->GetActionOrigins(actionSetHandle, digitalActionHandle, originsOut, originOutCount); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_007_impl_GetOriginLocalizedName(vr::VRInputValueHandle_t origin, char* pchNameArray, uint32_t unNameArraySize, int32_t unStringSectionsToInclude) { return fntable_Input_007_instance->GetOriginLocalizedName(origin, pchNameArray, unNameArraySize, unStringSectionsToInclude); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_007_impl_GetOriginTrackedDeviceInfo(vr::VRInputValueHandle_t origin, vr::IVRInput_007::InputOriginInfo_t* pOriginInfo, uint32_t unOriginInfoSize) { return fntable_Input_007_instance->GetOriginTrackedDeviceInfo(origin, pOriginInfo, unOriginInfoSize); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_007_impl_GetActionBindingInfo(vr::VRActionHandle_t action, vr::IVRInput_007::InputBindingInfo_t* pOriginInfo, uint32_t unBindingInfoSize, uint32_t unBindingInfoCount, uint32_t* punReturnedBindingInfoCount) { return fntable_Input_007_instance->GetActionBindingInfo(action, pOriginInfo, unBindingInfoSize, unBindingInfoCount, punReturnedBindingInfoCount); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_007_impl_ShowActionOrigins(vr::VRActionSetHandle_t actionSetHandle, vr::VRActionHandle_t ulActionHandle) { return fntable_Input_007_instance->ShowActionOrigins(actionSetHandle, ulActionHandle); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_007_impl_ShowBindingsForActionSet(vr::IVRInput_007::VRActiveActionSet_t* pSets, uint32_t unSizeOfVRSelectedActionSet_t, uint32_t unSetCount, vr::VRInputValueHandle_t originToHighlight) { return fntable_Input_007_instance->ShowBindingsForActionSet(pSets, unSizeOfVRSelectedActionSet_t, unSetCount, originToHighlight); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Input_007_impl_IsUsingLegacyInput() { return fntable_Input_007_instance->IsUsingLegacyInput(); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_007_impl_OpenBindingUI(const char* pchAppKey, vr::VRActionSetHandle_t ulActionSetHandle, vr::VRInputValueHandle_t ulDeviceHandle, bool bShowOnDesktop) { return fntable_Input_007_instance->OpenBindingUI(pchAppKey, ulActionSetHandle, ulDeviceHandle, bShowOnDesktop); }
static void *fntable_Input_007_funcs[] = {
	(void*) fntable_Input_007_impl_SetActionManifestPath,
	(void*) fntable_Input_007_impl_GetActionSetHandle,
	(void*) fntable_Input_007_impl_GetActionHandle,
	(void*) fntable_Input_007_impl_GetInputSourceHandle,
	(void*) fntable_Input_007_impl_UpdateActionState,
	(void*) fntable_Input_007_impl_GetDigitalActionData,
	(void*) fntable_Input_007_impl_GetAnalogActionData,
	(void*) fntable_Input_007_impl_GetPoseActionDataRelativeToNow,
	(void*) fntable_Input_007_impl_GetPoseActionDataForNextFrame,
	(void*) fntable_Input_007_impl_GetSkeletalActionData,
	(void*) fntable_Input_007_impl_GetBoneCount,
	(void*) fntable_Input_007_impl_GetBoneHierarchy,
	(void*) fntable_Input_007_impl_GetBoneName,
	(void*) fntable_Input_007_impl_GetSkeletalReferenceTransforms,
	(void*) fntable_Input_007_impl_GetSkeletalTrackingLevel,
	(void*) fntable_Input_007_impl_GetSkeletalBoneData,
	(void*) fntable_Input_007_impl_GetSkeletalSummaryData,
	(void*) fntable_Input_007_impl_GetSkeletalBoneDataCompressed,
	(void*) fntable_Input_007_impl_DecompressSkeletalBoneData,
	(void*) fntable_Input_007_impl_TriggerHapticVibrationAction,
	(void*) fntable_Input_007_impl_GetActionOrigins,
	(void*) fntable_Input_007_impl_GetOriginLocalizedName,
	(void*) fntable_Input_007_impl_GetOriginTrackedDeviceInfo,
	(void*) fntable_Input_007_impl_GetActionBindingInfo,
	(void*) fntable_Input_007_impl_ShowActionOrigins,
	(void*) fntable_Input_007_impl_ShowBindingsForActionSet,
	(void*) fntable_Input_007_impl_IsUsingLegacyInput,
	(void*) fntable_Input_007_impl_OpenBindingUI,
};
void** CVRInput_007::_GetStatFuncList() { fntable_Input_007_instance = this; return fntable_Input_007_funcs; }
void CVRInput_007::Delete() { delete this; }
// Misc for CVRInput_010:
CVRInput_010::CVRInput_010() : base(GetCreateBaseInput()) {}
// Interface methods for CVRInput_010:
vr::EVRInputError CVRInput_010::SetActionManifestPath(const char* pchActionManifestPath) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_010)");
	return base->SetActionManifestPath(pchActionManifestPath);
}
vr::EVRInputError CVRInput_010::GetActionSetHandle(const char* pchActionSetName, vr::VRActionSetHandle_t* pHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_010)");
	return base->GetActionSetHandle(pchActionSetName, pHandle);
}
vr::EVRInputError CVRInput_010::GetActionHandle(const char* pchActionName, vr::VRActionHandle_t* pHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_010)");
	return base->GetActionHandle(pchActionName, pHandle);
}
vr::EVRInputError CVRInput_010::GetInputSourceHandle(const char* pchInputSourcePath, vr::VRInputValueHandle_t* pHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_010)");
	return base->GetInputSourceHandle(pchInputSourcePath, pHandle);
}
vr::EVRInputError CVRInput_010::UpdateActionState(vr::IVRInput_010::VRActiveActionSet_t* pSets, uint32_t unSizeOfVRSelectedActionSet_t, uint32_t unSetCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_010)");
	return base->UpdateActionState((OOVR_VRActiveActionSet_t*) pSets, unSizeOfVRSelectedActionSet_t, unSetCount);
}
vr::EVRInputError CVRInput_010::GetDigitalActionData(vr::VRActionHandle_t action, vr::IVRInput_010::InputDigitalActionData_t* pActionData, uint32_t unActionDataSize, vr::VRInputValueHandle_t ulRestrictToDevice) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_010)");
	return base->GetDigitalActionData(action, (OOVR_InputDigitalActionData_t*) pActionData, unActionDataSize, ulRestrictToDevice);
}
vr::EVRInputError CVRInput_010::GetAnalogActionData(vr::VRActionHandle_t action, vr::IVRInput_010::InputAnalogActionData_t* pActionData, uint32_t unActionDataSize, vr::VRInputValueHandle_t ulRestrictToDevice) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_010)");
	return base->GetAnalogActionData(action, (OOVR_InputAnalogActionData_t*) pActionData, unActionDataSize, ulRestrictToDevice);
}
vr::EVRInputError CVRInput_010::GetPoseActionDataRelativeToNow(vr::VRActionHandle_t action, vr::ETrackingUniverseOrigin eOrigin, float fPredictedSecondsFromNow, vr::IVRInput_010::InputPoseActionData_t* pActionData, uint32_t unActionDataSize, vr::VRInputValueHandle_t ulRestrictToDevice) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_010)");
	return base->GetPoseActionDataRelativeToNow(action, eOrigin, fPredictedSecondsFromNow, (OOVR_InputPoseActionData_t*) pActionData, unActionDataSize, ulRestrictToDevice);
}
vr::EVRInputError CVRInput_010::GetPoseActionDataForNextFrame(vr::VRActionHandle_t action, vr::ETrackingUniverseOrigin eOrigin, vr::IVRInput_010::InputPoseActionData_t* pActionData, uint32_t unActionDataSize, vr::VRInputValueHandle_t ulRestrictToDevice) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_010)");
	return base->GetPoseActionDataForNextFrame(action, eOrigin, (OOVR_InputPoseActionData_t*) pActionData, unActionDataSize, ulRestrictToDevice);
}
vr::EVRInputError CVRInput_010::GetSkeletalActionData(vr::VRActionHandle_t action, vr::IVRInput_010::InputSkeletalActionData_t* pActionData, uint32_t unActionDataSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_010)");
	return base->GetSkeletalActionData(action, (OOVR_InputSkeletalActionData_t*) pActionData, unActionDataSize);
}
vr::EVRInputError CVRInput_010::GetDominantHand(vr::ETrackedControllerRole* peDominantHand) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_010)");
	return base->GetDominantHand(peDominantHand);
}
vr::EVRInputError CVRInput_010::SetDominantHand(vr::ETrackedControllerRole eDominantHand) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_010)");
	return base->SetDominantHand(eDominantHand);
}
vr::EVRInputError CVRInput_010::GetBoneCount(vr::VRActionHandle_t action, uint32_t* pBoneCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_010)");
	return base->GetBoneCount(action, pBoneCount);
}
vr::EVRInputError CVRInput_010::GetBoneHierarchy(vr::VRActionHandle_t action, vr::BoneIndex_t* pParentIndices, uint32_t unIndexArayCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_010)");
	return base->GetBoneHierarchy(action, pParentIndices, unIndexArayCount);
}
vr::EVRInputError CVRInput_010::GetBoneName(vr::VRActionHandle_t action, vr::BoneIndex_t nBoneIndex, char* pchBoneName, uint32_t unNameBufferSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_010)");
	return base->GetBoneName(action, nBoneIndex, pchBoneName, unNameBufferSize);
}
vr::EVRInputError CVRInput_010::GetSkeletalReferenceTransforms(vr::VRActionHandle_t action, vr::IVRInput_010::EVRSkeletalTransformSpace eTransformSpace, vr::IVRInput_010::EVRSkeletalReferencePose eReferencePose, vr::VRBoneTransform_t* pTransformArray, uint32_t unTransformArrayCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_010)");
	return base->GetSkeletalReferenceTransforms(action, (OOVR_EVRSkeletalTransformSpace) eTransformSpace, (OOVR_EVRSkeletalReferencePose) eReferencePose, pTransformArray, unTransformArrayCount);
}
vr::EVRInputError CVRInput_010::GetSkeletalTrackingLevel(vr::VRActionHandle_t action, vr::EVRSkeletalTrackingLevel* pSkeletalTrackingLevel) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_010)");
	return base->GetSkeletalTrackingLevel(action, pSkeletalTrackingLevel);
}
vr::EVRInputError CVRInput_010::GetSkeletalBoneData(vr::VRActionHandle_t action, vr::IVRInput_010::EVRSkeletalTransformSpace eTransformSpace, vr::EVRSkeletalMotionRange eMotionRange, vr::VRBoneTransform_t* pTransformArray, uint32_t unTransformArrayCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_010)");
	return base->GetSkeletalBoneData(action, (OOVR_EVRSkeletalTransformSpace) eTransformSpace, eMotionRange, pTransformArray, unTransformArrayCount);
}
vr::EVRInputError CVRInput_010::GetSkeletalSummaryData(vr::VRActionHandle_t action, vr::IVRInput_010::EVRSummaryType eSummaryType, vr::IVRInput_010::VRSkeletalSummaryData_t* pSkeletalSummaryData) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_010)");
	return base->GetSkeletalSummaryData(action, (OOVR_EVRSummaryType) eSummaryType, (OOVR_VRSkeletalSummaryData_t*) pSkeletalSummaryData);
}
vr::EVRInputError CVRInput_010::GetSkeletalBoneDataCompressed(vr::VRActionHandle_t action, vr::EVRSkeletalMotionRange eMotionRange, void* pvCompressedData, uint32_t unCompressedSize, uint32_t* punRequiredCompressedSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_010)");
	return base->GetSkeletalBoneDataCompressed(action, eMotionRange, pvCompressedData, unCompressedSize, punRequiredCompressedSize);
}
vr::EVRInputError CVRInput_010::DecompressSkeletalBoneData(const void* pvCompressedBuffer, uint32_t unCompressedBufferSize, vr::IVRInput_010::EVRSkeletalTransformSpace eTransformSpace, vr::VRBoneTransform_t* pTransformArray, uint32_t unTransformArrayCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_010)");
	return base->DecompressSkeletalBoneData(pvCompressedBuffer, unCompressedBufferSize, (OOVR_EVRSkeletalTransformSpace) eTransformSpace, pTransformArray, unTransformArrayCount);
}
vr::EVRInputError CVRInput_010::TriggerHapticVibrationAction(vr::VRActionHandle_t action, float fStartSecondsFromNow, float fDurationSeconds, float fFrequency, float fAmplitude, vr::VRInputValueHandle_t ulRestrictToDevice) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_010)");
	return base->TriggerHapticVibrationAction(action, fStartSecondsFromNow, fDurationSeconds, fFrequency, fAmplitude, ulRestrictToDevice);
}
vr::EVRInputError CVRInput_010::GetActionOrigins(vr::VRActionSetHandle_t actionSetHandle, vr::VRActionHandle_t digitalActionHandle, vr::VRInputValueHandle_t* originsOut, uint32_t originOutCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_010)");
	return base->GetActionOrigins(actionSetHandle, digitalActionHandle, originsOut, originOutCount);
}
vr::EVRInputError CVRInput_010::GetOriginLocalizedName(vr::VRInputValueHandle_t origin, char* pchNameArray, uint32_t unNameArraySize, int32_t unStringSectionsToInclude) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_010)");
	return base->GetOriginLocalizedName(origin, pchNameArray, unNameArraySize, unStringSectionsToInclude);
}
vr::EVRInputError CVRInput_010::GetOriginTrackedDeviceInfo(vr::VRInputValueHandle_t origin, vr::IVRInput_010::InputOriginInfo_t* pOriginInfo, uint32_t unOriginInfoSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_010)");
	return base->GetOriginTrackedDeviceInfo(origin, (OOVR_InputOriginInfo_t*) pOriginInfo, unOriginInfoSize);
}
vr::EVRInputError CVRInput_010::GetActionBindingInfo(vr::VRActionHandle_t action, vr::IVRInput_010::InputBindingInfo_t* pOriginInfo, uint32_t unBindingInfoSize, uint32_t unBindingInfoCount, uint32_t* punReturnedBindingInfoCount) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_010)");
	return base->GetActionBindingInfo(action, (OOVR_InputBindingInfo_t*) pOriginInfo, unBindingInfoSize, unBindingInfoCount, punReturnedBindingInfoCount);
}
vr::EVRInputError CVRInput_010::ShowActionOrigins(vr::VRActionSetHandle_t actionSetHandle, vr::VRActionHandle_t ulActionHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_010)");
	return base->ShowActionOrigins(actionSetHandle, ulActionHandle);
}
vr::EVRInputError CVRInput_010::ShowBindingsForActionSet(vr::IVRInput_010::VRActiveActionSet_t* pSets, uint32_t unSizeOfVRSelectedActionSet_t, uint32_t unSetCount, vr::VRInputValueHandle_t originToHighlight) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_010)");
	return base->ShowBindingsForActionSet((OOVR_VRActiveActionSet_t*) pSets, unSizeOfVRSelectedActionSet_t, unSetCount, originToHighlight);
}
vr::EVRInputError CVRInput_010::GetComponentStateForBinding(const char* pchRenderModelName, const char* pchComponentName, const vr::IVRInput_010::InputBindingInfo_t* pOriginInfo, uint32_t unBindingInfoSize, uint32_t unBindingInfoCount, vr::RenderModel_ComponentState_t* pComponentState) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_010)");
	return base->GetComponentStateForBinding(pchRenderModelName, pchComponentName, (const OOVR_InputBindingInfo_t*) pOriginInfo, unBindingInfoSize, unBindingInfoCount, pComponentState);
}
bool CVRInput_010::IsUsingLegacyInput() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_010)");
	return base->IsUsingLegacyInput();
}
vr::EVRInputError CVRInput_010::OpenBindingUI(const char* pchAppKey, vr::VRActionSetHandle_t ulActionSetHandle, vr::VRInputValueHandle_t ulDeviceHandle, bool bShowOnDesktop) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_010)");
	return base->OpenBindingUI(pchAppKey, ulActionSetHandle, ulDeviceHandle, bShowOnDesktop);
}
vr::EVRInputError CVRInput_010::GetBindingVariant(vr::VRInputValueHandle_t ulDevicePath, char* pchVariantArray, uint32_t unVariantArraySize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInput_010)");
	return base->GetBindingVariant(ulDevicePath, pchVariantArray, unVariantArraySize);
}
// FnTable for CVRInput_010:
static CVRInput_010 *fntable_Input_010_instance = NULL;
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_010_impl_SetActionManifestPath(const char* pchActionManifestPath) { return fntable_Input_010_instance->SetActionManifestPath(pchActionManifestPath); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_010_impl_GetActionSetHandle(const char* pchActionSetName, vr::VRActionSetHandle_t* pHandle) { return fntable_Input_010_instance->GetActionSetHandle(pchActionSetName, pHandle); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_010_impl_GetActionHandle(const char* pchActionName, vr::VRActionHandle_t* pHandle) { return fntable_Input_010_instance->GetActionHandle(pchActionName, pHandle); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_010_impl_GetInputSourceHandle(const char* pchInputSourcePath, vr::VRInputValueHandle_t* pHandle) { return fntable_Input_010_instance->GetInputSourceHandle(pchInputSourcePath, pHandle); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_010_impl_UpdateActionState(vr::IVRInput_010::VRActiveActionSet_t* pSets, uint32_t unSizeOfVRSelectedActionSet_t, uint32_t unSetCount) { return fntable_Input_010_instance->UpdateActionState(pSets, unSizeOfVRSelectedActionSet_t, unSetCount); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_010_impl_GetDigitalActionData(vr::VRActionHandle_t action, vr::IVRInput_010::InputDigitalActionData_t* pActionData, uint32_t unActionDataSize, vr::VRInputValueHandle_t ulRestrictToDevice) { return fntable_Input_010_instance->GetDigitalActionData(action, pActionData, unActionDataSize, ulRestrictToDevice); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_010_impl_GetAnalogActionData(vr::VRActionHandle_t action, vr::IVRInput_010::InputAnalogActionData_t* pActionData, uint32_t unActionDataSize, vr::VRInputValueHandle_t ulRestrictToDevice) { return fntable_Input_010_instance->GetAnalogActionData(action, pActionData, unActionDataSize, ulRestrictToDevice); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_010_impl_GetPoseActionDataRelativeToNow(vr::VRActionHandle_t action, vr::ETrackingUniverseOrigin eOrigin, float fPredictedSecondsFromNow, vr::IVRInput_010::InputPoseActionData_t* pActionData, uint32_t unActionDataSize, vr::VRInputValueHandle_t ulRestrictToDevice) { return fntable_Input_010_instance->GetPoseActionDataRelativeToNow(action, eOrigin, fPredictedSecondsFromNow, pActionData, unActionDataSize, ulRestrictToDevice); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_010_impl_GetPoseActionDataForNextFrame(vr::VRActionHandle_t action, vr::ETrackingUniverseOrigin eOrigin, vr::IVRInput_010::InputPoseActionData_t* pActionData, uint32_t unActionDataSize, vr::VRInputValueHandle_t ulRestrictToDevice) { return fntable_Input_010_instance->GetPoseActionDataForNextFrame(action, eOrigin, pActionData, unActionDataSize, ulRestrictToDevice); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_010_impl_GetSkeletalActionData(vr::VRActionHandle_t action, vr::IVRInput_010::InputSkeletalActionData_t* pActionData, uint32_t unActionDataSize) { return fntable_Input_010_instance->GetSkeletalActionData(action, pActionData, unActionDataSize); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_010_impl_GetDominantHand(vr::ETrackedControllerRole* peDominantHand) { return fntable_Input_010_instance->GetDominantHand(peDominantHand); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_010_impl_SetDominantHand(vr::ETrackedControllerRole eDominantHand) { return fntable_Input_010_instance->SetDominantHand(eDominantHand); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_010_impl_GetBoneCount(vr::VRActionHandle_t action, uint32_t* pBoneCount) { return fntable_Input_010_instance->GetBoneCount(action, pBoneCount); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_010_impl_GetBoneHierarchy(vr::VRActionHandle_t action, vr::BoneIndex_t* pParentIndices, uint32_t unIndexArayCount) { return fntable_Input_010_instance->GetBoneHierarchy(action, pParentIndices, unIndexArayCount); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_010_impl_GetBoneName(vr::VRActionHandle_t action, vr::BoneIndex_t nBoneIndex, char* pchBoneName, uint32_t unNameBufferSize) { return fntable_Input_010_instance->GetBoneName(action, nBoneIndex, pchBoneName, unNameBufferSize); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_010_impl_GetSkeletalReferenceTransforms(vr::VRActionHandle_t action, vr::IVRInput_010::EVRSkeletalTransformSpace eTransformSpace, vr::IVRInput_010::EVRSkeletalReferencePose eReferencePose, vr::VRBoneTransform_t* pTransformArray, uint32_t unTransformArrayCount) { return fntable_Input_010_instance->GetSkeletalReferenceTransforms(action, eTransformSpace, eReferencePose, pTransformArray, unTransformArrayCount); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_010_impl_GetSkeletalTrackingLevel(vr::VRActionHandle_t action, vr::EVRSkeletalTrackingLevel* pSkeletalTrackingLevel) { return fntable_Input_010_instance->GetSkeletalTrackingLevel(action, pSkeletalTrackingLevel); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_010_impl_GetSkeletalBoneData(vr::VRActionHandle_t action, vr::IVRInput_010::EVRSkeletalTransformSpace eTransformSpace, vr::EVRSkeletalMotionRange eMotionRange, vr::VRBoneTransform_t* pTransformArray, uint32_t unTransformArrayCount) { return fntable_Input_010_instance->GetSkeletalBoneData(action, eTransformSpace, eMotionRange, pTransformArray, unTransformArrayCount); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_010_impl_GetSkeletalSummaryData(vr::VRActionHandle_t action, vr::IVRInput_010::EVRSummaryType eSummaryType, vr::IVRInput_010::VRSkeletalSummaryData_t* pSkeletalSummaryData) { return fntable_Input_010_instance->GetSkeletalSummaryData(action, eSummaryType, pSkeletalSummaryData); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_010_impl_GetSkeletalBoneDataCompressed(vr::VRActionHandle_t action, vr::EVRSkeletalMotionRange eMotionRange, void* pvCompressedData, uint32_t unCompressedSize, uint32_t* punRequiredCompressedSize) { return fntable_Input_010_instance->GetSkeletalBoneDataCompressed(action, eMotionRange, pvCompressedData, unCompressedSize, punRequiredCompressedSize); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_010_impl_DecompressSkeletalBoneData(const void* pvCompressedBuffer, uint32_t unCompressedBufferSize, vr::IVRInput_010::EVRSkeletalTransformSpace eTransformSpace, vr::VRBoneTransform_t* pTransformArray, uint32_t unTransformArrayCount) { return fntable_Input_010_instance->DecompressSkeletalBoneData(pvCompressedBuffer, unCompressedBufferSize, eTransformSpace, pTransformArray, unTransformArrayCount); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_010_impl_TriggerHapticVibrationAction(vr::VRActionHandle_t action, float fStartSecondsFromNow, float fDurationSeconds, float fFrequency, float fAmplitude, vr::VRInputValueHandle_t ulRestrictToDevice) { return fntable_Input_010_instance->TriggerHapticVibrationAction(action, fStartSecondsFromNow, fDurationSeconds, fFrequency, fAmplitude, ulRestrictToDevice); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_010_impl_GetActionOrigins(vr::VRActionSetHandle_t actionSetHandle, vr::VRActionHandle_t digitalActionHandle, vr::VRInputValueHandle_t* originsOut, uint32_t originOutCount) { return fntable_Input_010_instance->GetActionOrigins(actionSetHandle, digitalActionHandle, originsOut, originOutCount); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_010_impl_GetOriginLocalizedName(vr::VRInputValueHandle_t origin, char* pchNameArray, uint32_t unNameArraySize, int32_t unStringSectionsToInclude) { return fntable_Input_010_instance->GetOriginLocalizedName(origin, pchNameArray, unNameArraySize, unStringSectionsToInclude); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_010_impl_GetOriginTrackedDeviceInfo(vr::VRInputValueHandle_t origin, vr::IVRInput_010::InputOriginInfo_t* pOriginInfo, uint32_t unOriginInfoSize) { return fntable_Input_010_instance->GetOriginTrackedDeviceInfo(origin, pOriginInfo, unOriginInfoSize); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_010_impl_GetActionBindingInfo(vr::VRActionHandle_t action, vr::IVRInput_010::InputBindingInfo_t* pOriginInfo, uint32_t unBindingInfoSize, uint32_t unBindingInfoCount, uint32_t* punReturnedBindingInfoCount) { return fntable_Input_010_instance->GetActionBindingInfo(action, pOriginInfo, unBindingInfoSize, unBindingInfoCount, punReturnedBindingInfoCount); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_010_impl_ShowActionOrigins(vr::VRActionSetHandle_t actionSetHandle, vr::VRActionHandle_t ulActionHandle) { return fntable_Input_010_instance->ShowActionOrigins(actionSetHandle, ulActionHandle); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_010_impl_ShowBindingsForActionSet(vr::IVRInput_010::VRActiveActionSet_t* pSets, uint32_t unSizeOfVRSelectedActionSet_t, uint32_t unSetCount, vr::VRInputValueHandle_t originToHighlight) { return fntable_Input_010_instance->ShowBindingsForActionSet(pSets, unSizeOfVRSelectedActionSet_t, unSetCount, originToHighlight); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_010_impl_GetComponentStateForBinding(const char* pchRenderModelName, const char* pchComponentName, const vr::IVRInput_010::InputBindingInfo_t* pOriginInfo, uint32_t unBindingInfoSize, uint32_t unBindingInfoCount, vr::RenderModel_ComponentState_t* pComponentState) { return fntable_Input_010_instance->GetComponentStateForBinding(pchRenderModelName, pchComponentName, pOriginInfo, unBindingInfoSize, unBindingInfoCount, pComponentState); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_Input_010_impl_IsUsingLegacyInput() { return fntable_Input_010_instance->IsUsingLegacyInput(); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_010_impl_OpenBindingUI(const char* pchAppKey, vr::VRActionSetHandle_t ulActionSetHandle, vr::VRInputValueHandle_t ulDeviceHandle, bool bShowOnDesktop) { return fntable_Input_010_instance->OpenBindingUI(pchAppKey, ulActionSetHandle, ulDeviceHandle, bShowOnDesktop); }
static vr::EVRInputError OPENVR_FNTABLE_CALLTYPE fntable_Input_010_impl_GetBindingVariant(vr::VRInputValueHandle_t ulDevicePath, char* pchVariantArray, uint32_t unVariantArraySize) { return fntable_Input_010_instance->GetBindingVariant(ulDevicePath, pchVariantArray, unVariantArraySize); }
static void *fntable_Input_010_funcs[] = {
	(void*) fntable_Input_010_impl_SetActionManifestPath,
	(void*) fntable_Input_010_impl_GetActionSetHandle,
	(void*) fntable_Input_010_impl_GetActionHandle,
	(void*) fntable_Input_010_impl_GetInputSourceHandle,
	(void*) fntable_Input_010_impl_UpdateActionState,
	(void*) fntable_Input_010_impl_GetDigitalActionData,
	(void*) fntable_Input_010_impl_GetAnalogActionData,
	(void*) fntable_Input_010_impl_GetPoseActionDataRelativeToNow,
	(void*) fntable_Input_010_impl_GetPoseActionDataForNextFrame,
	(void*) fntable_Input_010_impl_GetSkeletalActionData,
	(void*) fntable_Input_010_impl_GetDominantHand,
	(void*) fntable_Input_010_impl_SetDominantHand,
	(void*) fntable_Input_010_impl_GetBoneCount,
	(void*) fntable_Input_010_impl_GetBoneHierarchy,
	(void*) fntable_Input_010_impl_GetBoneName,
	(void*) fntable_Input_010_impl_GetSkeletalReferenceTransforms,
	(void*) fntable_Input_010_impl_GetSkeletalTrackingLevel,
	(void*) fntable_Input_010_impl_GetSkeletalBoneData,
	(void*) fntable_Input_010_impl_GetSkeletalSummaryData,
	(void*) fntable_Input_010_impl_GetSkeletalBoneDataCompressed,
	(void*) fntable_Input_010_impl_DecompressSkeletalBoneData,
	(void*) fntable_Input_010_impl_TriggerHapticVibrationAction,
	(void*) fntable_Input_010_impl_GetActionOrigins,
	(void*) fntable_Input_010_impl_GetOriginLocalizedName,
	(void*) fntable_Input_010_impl_GetOriginTrackedDeviceInfo,
	(void*) fntable_Input_010_impl_GetActionBindingInfo,
	(void*) fntable_Input_010_impl_ShowActionOrigins,
	(void*) fntable_Input_010_impl_ShowBindingsForActionSet,
	(void*) fntable_Input_010_impl_GetComponentStateForBinding,
	(void*) fntable_Input_010_impl_IsUsingLegacyInput,
	(void*) fntable_Input_010_impl_OpenBindingUI,
	(void*) fntable_Input_010_impl_GetBindingVariant,
};
void** CVRInput_010::_GetStatFuncList() { fntable_Input_010_instance = this; return fntable_Input_010_funcs; }
void CVRInput_010::Delete() { delete this; }
#include "GVRInputInternal.gen.h"
// Single inst of BaseInputInternal
static std::weak_ptr<BaseInputInternal> _single_inst_InputInternal;
static BaseInputInternal *_single_inst_InputInternal_unsafe = NULL;
std::shared_ptr<BaseInputInternal> GetBaseInputInternal() { return _single_inst_InputInternal.lock(); };
BaseInputInternal* GetUnsafeBaseInputInternal() { return _single_inst_InputInternal_unsafe; };
std::shared_ptr<BaseInputInternal> GetCreateBaseInputInternal() {
	std::shared_ptr<BaseInputInternal> ret = _single_inst_InputInternal.lock();
	if(!ret) {
		ret = std::shared_ptr<BaseInputInternal>(new BaseInputInternal(), [](BaseInputInternal *obj){ _single_inst_InputInternal_unsafe = NULL; delete obj; });
		_single_inst_InputInternal = ret;
		_single_inst_InputInternal_unsafe = ret.get();
	}
	return ret;
}
// Misc for CVRInputInternal_002:
CVRInputInternal_002::CVRInputInternal_002() : base(GetCreateBaseInputInternal()) {}
// Interface methods for CVRInputInternal_002:
void CVRInputInternal_002::UknFunc001() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInputInternal_002)");
	return base->UknFunc001();
}
void CVRInputInternal_002::UknFunc002() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInputInternal_002)");
	return base->UknFunc002();
}
void CVRInputInternal_002::UknFunc003() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInputInternal_002)");
	return base->UknFunc003();
}
void CVRInputInternal_002::UknFunc004() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInputInternal_002)");
	return base->UknFunc004();
}
void CVRInputInternal_002::UknFunc005() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInputInternal_002)");
	return base->UknFunc005();
}
void CVRInputInternal_002::UknFunc006() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInputInternal_002)");
	return base->UknFunc006();
}
void CVRInputInternal_002::UknFunc007() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInputInternal_002)");
	return base->UknFunc007();
}
void CVRInputInternal_002::UknFunc008() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInputInternal_002)");
	return base->UknFunc008();
}
void CVRInputInternal_002::UknFunc009() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInputInternal_002)");
	return base->UknFunc009();
}
void CVRInputInternal_002::UknFunc010() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInputInternal_002)");
	return base->UknFunc010();
}
void CVRInputInternal_002::UknFunc011() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInputInternal_002)");
	return base->UknFunc011();
}
void CVRInputInternal_002::UknFunc012() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInputInternal_002)");
	return base->UknFunc012();
}
void CVRInputInternal_002::UknFunc013() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInputInternal_002)");
	return base->UknFunc013();
}
void CVRInputInternal_002::UknFunc014() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInputInternal_002)");
	return base->UknFunc014();
}
void CVRInputInternal_002::UknFunc015() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInputInternal_002)");
	return base->UknFunc015();
}
void CVRInputInternal_002::UknFunc016() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInputInternal_002)");
	return base->UknFunc016();
}
void CVRInputInternal_002::UknFunc017() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInputInternal_002)");
	return base->UknFunc017();
}
void CVRInputInternal_002::UknFunc018() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInputInternal_002)");
	return base->UknFunc018();
}
void CVRInputInternal_002::UknFunc019() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInputInternal_002)");
	return base->UknFunc019();
}
void CVRInputInternal_002::UknFunc020() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRInputInternal_002)");
	return base->UknFunc020();
}
// FnTable for CVRInputInternal_002:
static CVRInputInternal_002 *fntable_InputInternal_002_instance = NULL;
static void OPENVR_FNTABLE_CALLTYPE fntable_InputInternal_002_impl_UknFunc001() { return fntable_InputInternal_002_instance->UknFunc001(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_InputInternal_002_impl_UknFunc002() { return fntable_InputInternal_002_instance->UknFunc002(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_InputInternal_002_impl_UknFunc003() { return fntable_InputInternal_002_instance->UknFunc003(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_InputInternal_002_impl_UknFunc004() { return fntable_InputInternal_002_instance->UknFunc004(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_InputInternal_002_impl_UknFunc005() { return fntable_InputInternal_002_instance->UknFunc005(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_InputInternal_002_impl_UknFunc006() { return fntable_InputInternal_002_instance->UknFunc006(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_InputInternal_002_impl_UknFunc007() { return fntable_InputInternal_002_instance->UknFunc007(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_InputInternal_002_impl_UknFunc008() { return fntable_InputInternal_002_instance->UknFunc008(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_InputInternal_002_impl_UknFunc009() { return fntable_InputInternal_002_instance->UknFunc009(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_InputInternal_002_impl_UknFunc010() { return fntable_InputInternal_002_instance->UknFunc010(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_InputInternal_002_impl_UknFunc011() { return fntable_InputInternal_002_instance->UknFunc011(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_InputInternal_002_impl_UknFunc012() { return fntable_InputInternal_002_instance->UknFunc012(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_InputInternal_002_impl_UknFunc013() { return fntable_InputInternal_002_instance->UknFunc013(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_InputInternal_002_impl_UknFunc014() { return fntable_InputInternal_002_instance->UknFunc014(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_InputInternal_002_impl_UknFunc015() { return fntable_InputInternal_002_instance->UknFunc015(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_InputInternal_002_impl_UknFunc016() { return fntable_InputInternal_002_instance->UknFunc016(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_InputInternal_002_impl_UknFunc017() { return fntable_InputInternal_002_instance->UknFunc017(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_InputInternal_002_impl_UknFunc018() { return fntable_InputInternal_002_instance->UknFunc018(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_InputInternal_002_impl_UknFunc019() { return fntable_InputInternal_002_instance->UknFunc019(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_InputInternal_002_impl_UknFunc020() { return fntable_InputInternal_002_instance->UknFunc020(); }
static void *fntable_InputInternal_002_funcs[] = {
	(void*) fntable_InputInternal_002_impl_UknFunc001,
	(void*) fntable_InputInternal_002_impl_UknFunc002,
	(void*) fntable_InputInternal_002_impl_UknFunc003,
	(void*) fntable_InputInternal_002_impl_UknFunc004,
	(void*) fntable_InputInternal_002_impl_UknFunc005,
	(void*) fntable_InputInternal_002_impl_UknFunc006,
	(void*) fntable_InputInternal_002_impl_UknFunc007,
	(void*) fntable_InputInternal_002_impl_UknFunc008,
	(void*) fntable_InputInternal_002_impl_UknFunc009,
	(void*) fntable_InputInternal_002_impl_UknFunc010,
	(void*) fntable_InputInternal_002_impl_UknFunc011,
	(void*) fntable_InputInternal_002_impl_UknFunc012,
	(void*) fntable_InputInternal_002_impl_UknFunc013,
	(void*) fntable_InputInternal_002_impl_UknFunc014,
	(void*) fntable_InputInternal_002_impl_UknFunc015,
	(void*) fntable_InputInternal_002_impl_UknFunc016,
	(void*) fntable_InputInternal_002_impl_UknFunc017,
	(void*) fntable_InputInternal_002_impl_UknFunc018,
	(void*) fntable_InputInternal_002_impl_UknFunc019,
	(void*) fntable_InputInternal_002_impl_UknFunc020,
};
void** CVRInputInternal_002::_GetStatFuncList() { fntable_InputInternal_002_instance = this; return fntable_InputInternal_002_funcs; }
void CVRInputInternal_002::Delete() { delete this; }
#include "GVRClientCore.gen.h"
// Single inst of BaseClientCore
static std::weak_ptr<BaseClientCore> _single_inst_ClientCore;
static BaseClientCore *_single_inst_ClientCore_unsafe = NULL;
std::shared_ptr<BaseClientCore> GetBaseClientCore() { return _single_inst_ClientCore.lock(); };
BaseClientCore* GetUnsafeBaseClientCore() { return _single_inst_ClientCore_unsafe; };
std::shared_ptr<BaseClientCore> GetCreateBaseClientCore() {
	std::shared_ptr<BaseClientCore> ret = _single_inst_ClientCore.lock();
	if(!ret) {
		ret = std::shared_ptr<BaseClientCore>(new BaseClientCore(), [](BaseClientCore *obj){ _single_inst_ClientCore_unsafe = NULL; delete obj; });
		_single_inst_ClientCore = ret;
		_single_inst_ClientCore_unsafe = ret.get();
	}
	return ret;
}
// Misc for CVRClientCore_003:
CVRClientCore_003::CVRClientCore_003() : base(GetCreateBaseClientCore()) {}
// Interface methods for CVRClientCore_003:
vr::EVRInitError CVRClientCore_003::Init(vr::EVRApplicationType eApplicationType, const char* pStartupInfo) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRClientCore_003)");
	return base->Init(eApplicationType, pStartupInfo);
}
void CVRClientCore_003::Cleanup() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRClientCore_003)");
	return base->Cleanup();
}
vr::EVRInitError CVRClientCore_003::IsInterfaceVersionValid(const char* pchInterfaceVersion) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRClientCore_003)");
	return base->IsInterfaceVersionValid(pchInterfaceVersion);
}
void* CVRClientCore_003::GetGenericInterface(const char* pchNameAndVersion, vr::EVRInitError* peError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRClientCore_003)");
	return base->GetGenericInterface(pchNameAndVersion, peError);
}
bool CVRClientCore_003::BIsHmdPresent() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRClientCore_003)");
	return base->BIsHmdPresent();
}
const char* CVRClientCore_003::GetEnglishStringForHmdError(vr::EVRInitError eError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRClientCore_003)");
	return base->GetEnglishStringForHmdError(eError);
}
const char* CVRClientCore_003::GetIDForVRInitError(vr::EVRInitError eError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRClientCore_003)");
	return base->GetIDForVRInitError(eError);
}
// FnTable for CVRClientCore_003:
static CVRClientCore_003 *fntable_ClientCore_003_instance = NULL;
static vr::EVRInitError OPENVR_FNTABLE_CALLTYPE fntable_ClientCore_003_impl_Init(vr::EVRApplicationType eApplicationType, const char* pStartupInfo) { return fntable_ClientCore_003_instance->Init(eApplicationType, pStartupInfo); }
static void OPENVR_FNTABLE_CALLTYPE fntable_ClientCore_003_impl_Cleanup() { return fntable_ClientCore_003_instance->Cleanup(); }
static vr::EVRInitError OPENVR_FNTABLE_CALLTYPE fntable_ClientCore_003_impl_IsInterfaceVersionValid(const char* pchInterfaceVersion) { return fntable_ClientCore_003_instance->IsInterfaceVersionValid(pchInterfaceVersion); }
static void* OPENVR_FNTABLE_CALLTYPE fntable_ClientCore_003_impl_GetGenericInterface(const char* pchNameAndVersion, vr::EVRInitError* peError) { return fntable_ClientCore_003_instance->GetGenericInterface(pchNameAndVersion, peError); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_ClientCore_003_impl_BIsHmdPresent() { return fntable_ClientCore_003_instance->BIsHmdPresent(); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_ClientCore_003_impl_GetEnglishStringForHmdError(vr::EVRInitError eError) { return fntable_ClientCore_003_instance->GetEnglishStringForHmdError(eError); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_ClientCore_003_impl_GetIDForVRInitError(vr::EVRInitError eError) { return fntable_ClientCore_003_instance->GetIDForVRInitError(eError); }
static void *fntable_ClientCore_003_funcs[] = {
	(void*) fntable_ClientCore_003_impl_Init,
	(void*) fntable_ClientCore_003_impl_Cleanup,
	(void*) fntable_ClientCore_003_impl_IsInterfaceVersionValid,
	(void*) fntable_ClientCore_003_impl_GetGenericInterface,
	(void*) fntable_ClientCore_003_impl_BIsHmdPresent,
	(void*) fntable_ClientCore_003_impl_GetEnglishStringForHmdError,
	(void*) fntable_ClientCore_003_impl_GetIDForVRInitError,
};
void** CVRClientCore_003::_GetStatFuncList() { fntable_ClientCore_003_instance = this; return fntable_ClientCore_003_funcs; }
void CVRClientCore_003::Delete() { delete this; }
// Misc for CVRClientCore_002:
CVRClientCore_002::CVRClientCore_002() : base(GetCreateBaseClientCore()) {}
// Interface methods for CVRClientCore_002:
void CVRClientCore_002::Cleanup() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRClientCore_002)");
	return base->Cleanup();
}
vr::EVRInitError CVRClientCore_002::IsInterfaceVersionValid(const char* pchInterfaceVersion) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRClientCore_002)");
	return base->IsInterfaceVersionValid(pchInterfaceVersion);
}
void* CVRClientCore_002::GetGenericInterface(const char* pchNameAndVersion, vr::EVRInitError* peError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRClientCore_002)");
	return base->GetGenericInterface(pchNameAndVersion, peError);
}
bool CVRClientCore_002::BIsHmdPresent() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRClientCore_002)");
	return base->BIsHmdPresent();
}
const char* CVRClientCore_002::GetEnglishStringForHmdError(vr::EVRInitError eError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRClientCore_002)");
	return base->GetEnglishStringForHmdError(eError);
}
const char* CVRClientCore_002::GetIDForVRInitError(vr::EVRInitError eError) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRClientCore_002)");
	return base->GetIDForVRInitError(eError);
}
// FnTable for CVRClientCore_002:
static CVRClientCore_002 *fntable_ClientCore_002_instance = NULL;
static vr::EVRInitError OPENVR_FNTABLE_CALLTYPE fntable_ClientCore_002_impl_Init(vr::EVRApplicationType eApplicationType) { return fntable_ClientCore_002_instance->Init(eApplicationType); }
static void OPENVR_FNTABLE_CALLTYPE fntable_ClientCore_002_impl_Cleanup() { return fntable_ClientCore_002_instance->Cleanup(); }
static vr::EVRInitError OPENVR_FNTABLE_CALLTYPE fntable_ClientCore_002_impl_IsInterfaceVersionValid(const char* pchInterfaceVersion) { return fntable_ClientCore_002_instance->IsInterfaceVersionValid(pchInterfaceVersion); }
static void* OPENVR_FNTABLE_CALLTYPE fntable_ClientCore_002_impl_GetGenericInterface(const char* pchNameAndVersion, vr::EVRInitError* peError) { return fntable_ClientCore_002_instance->GetGenericInterface(pchNameAndVersion, peError); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_ClientCore_002_impl_BIsHmdPresent() { return fntable_ClientCore_002_instance->BIsHmdPresent(); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_ClientCore_002_impl_GetEnglishStringForHmdError(vr::EVRInitError eError) { return fntable_ClientCore_002_instance->GetEnglishStringForHmdError(eError); }
static const char* OPENVR_FNTABLE_CALLTYPE fntable_ClientCore_002_impl_GetIDForVRInitError(vr::EVRInitError eError) { return fntable_ClientCore_002_instance->GetIDForVRInitError(eError); }
static void *fntable_ClientCore_002_funcs[] = {
	(void*) fntable_ClientCore_002_impl_Init,
	(void*) fntable_ClientCore_002_impl_Cleanup,
	(void*) fntable_ClientCore_002_impl_IsInterfaceVersionValid,
	(void*) fntable_ClientCore_002_impl_GetGenericInterface,
	(void*) fntable_ClientCore_002_impl_BIsHmdPresent,
	(void*) fntable_ClientCore_002_impl_GetEnglishStringForHmdError,
	(void*) fntable_ClientCore_002_impl_GetIDForVRInitError,
};
void** CVRClientCore_002::_GetStatFuncList() { fntable_ClientCore_002_instance = this; return fntable_ClientCore_002_funcs; }
void CVRClientCore_002::Delete() { delete this; }
#include "GVROverlayView.gen.h"
// Single inst of BaseOverlayView
static std::weak_ptr<BaseOverlayView> _single_inst_OverlayView;
static BaseOverlayView *_single_inst_OverlayView_unsafe = NULL;
std::shared_ptr<BaseOverlayView> GetBaseOverlayView() { return _single_inst_OverlayView.lock(); };
BaseOverlayView* GetUnsafeBaseOverlayView() { return _single_inst_OverlayView_unsafe; };
std::shared_ptr<BaseOverlayView> GetCreateBaseOverlayView() {
	std::shared_ptr<BaseOverlayView> ret = _single_inst_OverlayView.lock();
	if(!ret) {
		ret = std::shared_ptr<BaseOverlayView>(new BaseOverlayView(), [](BaseOverlayView *obj){ _single_inst_OverlayView_unsafe = NULL; delete obj; });
		_single_inst_OverlayView = ret;
		_single_inst_OverlayView_unsafe = ret.get();
	}
	return ret;
}
// Misc for CVROverlayView_003:
CVROverlayView_003::CVROverlayView_003() : base(GetCreateBaseOverlayView()) {}
// Interface methods for CVROverlayView_003:
vr::EVROverlayError CVROverlayView_003::AcquireOverlayView(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlayView_003::VRNativeDevice_t* pNativeDevice, vr::IVROverlayView_003::VROverlayView_t* pOverlayView, uint32_t unOverlayViewSize) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlayView_003)");
	return base->AcquireOverlayView(ulOverlayHandle, (OOVR_VRNativeDevice_t*) pNativeDevice, (OOVR_VROverlayView_t*) pOverlayView, unOverlayViewSize);
}
vr::EVROverlayError CVROverlayView_003::ReleaseOverlayView(vr::IVROverlayView_003::VROverlayView_t* pOverlayView) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlayView_003)");
	return base->ReleaseOverlayView((OOVR_VROverlayView_t*) pOverlayView);
}
void CVROverlayView_003::PostOverlayEvent(vr::VROverlayHandle_t ulOverlayHandle, const vr::VREvent_t* pvrEvent) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlayView_003)");
	return base->PostOverlayEvent(ulOverlayHandle, pvrEvent);
}
bool CVROverlayView_003::IsViewingPermitted(vr::VROverlayHandle_t ulOverlayHandle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVROverlayView_003)");
	return base->IsViewingPermitted(ulOverlayHandle);
}
// FnTable for CVROverlayView_003:
static CVROverlayView_003 *fntable_OverlayView_003_instance = NULL;
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_OverlayView_003_impl_AcquireOverlayView(vr::VROverlayHandle_t ulOverlayHandle, vr::IVROverlayView_003::VRNativeDevice_t* pNativeDevice, vr::IVROverlayView_003::VROverlayView_t* pOverlayView, uint32_t unOverlayViewSize) { return fntable_OverlayView_003_instance->AcquireOverlayView(ulOverlayHandle, pNativeDevice, pOverlayView, unOverlayViewSize); }
static vr::EVROverlayError OPENVR_FNTABLE_CALLTYPE fntable_OverlayView_003_impl_ReleaseOverlayView(vr::IVROverlayView_003::VROverlayView_t* pOverlayView) { return fntable_OverlayView_003_instance->ReleaseOverlayView(pOverlayView); }
static void OPENVR_FNTABLE_CALLTYPE fntable_OverlayView_003_impl_PostOverlayEvent(vr::VROverlayHandle_t ulOverlayHandle, const vr::VREvent_t* pvrEvent) { return fntable_OverlayView_003_instance->PostOverlayEvent(ulOverlayHandle, pvrEvent); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_OverlayView_003_impl_IsViewingPermitted(vr::VROverlayHandle_t ulOverlayHandle) { return fntable_OverlayView_003_instance->IsViewingPermitted(ulOverlayHandle); }
static void *fntable_OverlayView_003_funcs[] = {
	(void*) fntable_OverlayView_003_impl_AcquireOverlayView,
	(void*) fntable_OverlayView_003_impl_ReleaseOverlayView,
	(void*) fntable_OverlayView_003_impl_PostOverlayEvent,
	(void*) fntable_OverlayView_003_impl_IsViewingPermitted,
};
void** CVROverlayView_003::_GetStatFuncList() { fntable_OverlayView_003_instance = this; return fntable_OverlayView_003_funcs; }
void CVROverlayView_003::Delete() { delete this; }
#include "GVRMailbox.gen.h"
// Single inst of BaseMailbox
static std::weak_ptr<BaseMailbox> _single_inst_Mailbox;
static BaseMailbox *_single_inst_Mailbox_unsafe = NULL;
std::shared_ptr<BaseMailbox> GetBaseMailbox() { return _single_inst_Mailbox.lock(); };
BaseMailbox* GetUnsafeBaseMailbox() { return _single_inst_Mailbox_unsafe; };
std::shared_ptr<BaseMailbox> GetCreateBaseMailbox() {
	std::shared_ptr<BaseMailbox> ret = _single_inst_Mailbox.lock();
	if(!ret) {
		ret = std::shared_ptr<BaseMailbox>(new BaseMailbox(), [](BaseMailbox *obj){ _single_inst_Mailbox_unsafe = NULL; delete obj; });
		_single_inst_Mailbox = ret;
		_single_inst_Mailbox_unsafe = ret.get();
	}
	return ret;
}
// Misc for CVRMailbox_001:
CVRMailbox_001::CVRMailbox_001() : base(GetCreateBaseMailbox()) {}
// Interface methods for CVRMailbox_001:
vr::IVRMailbox_001::vrmb_typeb CVRMailbox_001::RegisterMailbox(const char* name, vr::IVRMailbox_001::mbox_handle* handle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRMailbox_001)");
	return (vr::IVRMailbox_001::vrmb_typeb) base->RegisterMailbox(name, (OOVR_mbox_handle*) handle);
}
vr::IVRMailbox_001::vrmb_typeb CVRMailbox_001::UnregisterMailbox(vr::IVRMailbox_001::mbox_handle handle) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRMailbox_001)");
	return (vr::IVRMailbox_001::vrmb_typeb) base->UnregisterMailbox((OOVR_mbox_handle) handle);
}
vr::IVRMailbox_001::vrmb_typeb CVRMailbox_001::SendMessage(vr::IVRMailbox_001::mbox_handle handle, const char* type, const char* message) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRMailbox_001)");
	return (vr::IVRMailbox_001::vrmb_typeb) base->SendMessage((OOVR_mbox_handle) handle, type, message);
}
vr::IVRMailbox_001::vrmb_typeb CVRMailbox_001::ReadMessage(vr::IVRMailbox_001::mbox_handle mbox, char* outBuf, uint32_t outBufLen, uint32_t* msgLen) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRMailbox_001)");
	return (vr::IVRMailbox_001::vrmb_typeb) base->ReadMessage((OOVR_mbox_handle) mbox, outBuf, outBufLen, msgLen);
}
// FnTable for CVRMailbox_001:
static CVRMailbox_001 *fntable_Mailbox_001_instance = NULL;
static vr::IVRMailbox_001::vrmb_typeb OPENVR_FNTABLE_CALLTYPE fntable_Mailbox_001_impl_RegisterMailbox(const char* name, vr::IVRMailbox_001::mbox_handle* handle) { return fntable_Mailbox_001_instance->RegisterMailbox(name, handle); }
static vr::IVRMailbox_001::vrmb_typeb OPENVR_FNTABLE_CALLTYPE fntable_Mailbox_001_impl_UnregisterMailbox(vr::IVRMailbox_001::mbox_handle handle) { return fntable_Mailbox_001_instance->UnregisterMailbox(handle); }
static vr::IVRMailbox_001::vrmb_typeb OPENVR_FNTABLE_CALLTYPE fntable_Mailbox_001_impl_SendMessage(vr::IVRMailbox_001::mbox_handle handle, const char* type, const char* message) { return fntable_Mailbox_001_instance->SendMessage(handle, type, message); }
static vr::IVRMailbox_001::vrmb_typeb OPENVR_FNTABLE_CALLTYPE fntable_Mailbox_001_impl_ReadMessage(vr::IVRMailbox_001::mbox_handle mbox, char* outBuf, uint32_t outBufLen, uint32_t* msgLen) { return fntable_Mailbox_001_instance->ReadMessage(mbox, outBuf, outBufLen, msgLen); }
static void *fntable_Mailbox_001_funcs[] = {
	(void*) fntable_Mailbox_001_impl_RegisterMailbox,
	(void*) fntable_Mailbox_001_impl_UnregisterMailbox,
	(void*) fntable_Mailbox_001_impl_SendMessage,
	(void*) fntable_Mailbox_001_impl_ReadMessage,
};
void** CVRMailbox_001::_GetStatFuncList() { fntable_Mailbox_001_instance = this; return fntable_Mailbox_001_funcs; }
void CVRMailbox_001::Delete() { delete this; }
#include "GVRControlPanel.gen.h"
// Single inst of BaseControlPanel
static std::weak_ptr<BaseControlPanel> _single_inst_ControlPanel;
static BaseControlPanel *_single_inst_ControlPanel_unsafe = NULL;
std::shared_ptr<BaseControlPanel> GetBaseControlPanel() { return _single_inst_ControlPanel.lock(); };
BaseControlPanel* GetUnsafeBaseControlPanel() { return _single_inst_ControlPanel_unsafe; };
std::shared_ptr<BaseControlPanel> GetCreateBaseControlPanel() {
	std::shared_ptr<BaseControlPanel> ret = _single_inst_ControlPanel.lock();
	if(!ret) {
		ret = std::shared_ptr<BaseControlPanel>(new BaseControlPanel(), [](BaseControlPanel *obj){ _single_inst_ControlPanel_unsafe = NULL; delete obj; });
		_single_inst_ControlPanel = ret;
		_single_inst_ControlPanel_unsafe = ret.get();
	}
	return ret;
}
// Misc for CVRControlPanel_006:
CVRControlPanel_006::CVRControlPanel_006() : base(GetCreateBaseControlPanel()) {}
// Interface methods for CVRControlPanel_006:
void CVRControlPanel_006::UknFunc00() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRControlPanel_006)");
	return base->UknFunc00();
}
void CVRControlPanel_006::UknFunc01() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRControlPanel_006)");
	return base->UknFunc01();
}
void CVRControlPanel_006::UknFunc02() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRControlPanel_006)");
	return base->UknFunc02();
}
void CVRControlPanel_006::UknFunc03() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRControlPanel_006)");
	return base->UknFunc03();
}
void CVRControlPanel_006::UknFunc04() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRControlPanel_006)");
	return base->UknFunc04();
}
void CVRControlPanel_006::UknFunc05() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRControlPanel_006)");
	return base->UknFunc05();
}
void CVRControlPanel_006::UknFunc06() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRControlPanel_006)");
	return base->UknFunc06();
}
void CVRControlPanel_006::UknFunc07() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRControlPanel_006)");
	return base->UknFunc07();
}
void CVRControlPanel_006::UknFunc08() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRControlPanel_006)");
	return base->UknFunc08();
}
void CVRControlPanel_006::UknFunc09() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRControlPanel_006)");
	return base->UknFunc09();
}
void CVRControlPanel_006::UknFunc10() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRControlPanel_006)");
	return base->UknFunc10();
}
void CVRControlPanel_006::UknFunc11() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRControlPanel_006)");
	return base->UknFunc11();
}
void CVRControlPanel_006::UknFunc12() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRControlPanel_006)");
	return base->UknFunc12();
}
void CVRControlPanel_006::UknFunc13() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRControlPanel_006)");
	return base->UknFunc13();
}
void CVRControlPanel_006::UknFunc14() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRControlPanel_006)");
	return base->UknFunc14();
}
void CVRControlPanel_006::SetDashBoardUserToggleEnabled(bool status) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRControlPanel_006)");
	return base->SetDashBoardUserToggleEnabled(status);
}
void CVRControlPanel_006::UknFunc16() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRControlPanel_006)");
	return base->UknFunc16();
}
void CVRControlPanel_006::UknFunc17() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRControlPanel_006)");
	return base->UknFunc17();
}
void CVRControlPanel_006::UknFunc18() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRControlPanel_006)");
	return base->UknFunc18();
}
void CVRControlPanel_006::UknFunc19() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRControlPanel_006)");
	return base->UknFunc19();
}
void CVRControlPanel_006::UknFunc20() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRControlPanel_006)");
	return base->UknFunc20();
}
void CVRControlPanel_006::UknFunc21() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRControlPanel_006)");
	return base->UknFunc21();
}
void CVRControlPanel_006::UknFunc22() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRControlPanel_006)");
	return base->UknFunc22();
}
void CVRControlPanel_006::UknFunc23() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRControlPanel_006)");
	return base->UknFunc23();
}
void CVRControlPanel_006::UknFunc24() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRControlPanel_006)");
	return base->UknFunc24();
}
void CVRControlPanel_006::UknFunc25() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRControlPanel_006)");
	return base->UknFunc25();
}
vr::IVRControlPanel_006::EVR_ControlPanel_Error CVRControlPanel_006::RegisterExternalWebRoot() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRControlPanel_006)");
	return (vr::IVRControlPanel_006::EVR_ControlPanel_Error) base->RegisterExternalWebRoot();
}
void CVRControlPanel_006::UknFunc27() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRControlPanel_006)");
	return base->UknFunc27();
}
void CVRControlPanel_006::UknFunc28() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRControlPanel_006)");
	return base->UknFunc28();
}
void CVRControlPanel_006::UknFunc29() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRControlPanel_006)");
	return base->UknFunc29();
}
// FnTable for CVRControlPanel_006:
static CVRControlPanel_006 *fntable_ControlPanel_006_instance = NULL;
static void OPENVR_FNTABLE_CALLTYPE fntable_ControlPanel_006_impl_UknFunc00() { return fntable_ControlPanel_006_instance->UknFunc00(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_ControlPanel_006_impl_UknFunc01() { return fntable_ControlPanel_006_instance->UknFunc01(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_ControlPanel_006_impl_UknFunc02() { return fntable_ControlPanel_006_instance->UknFunc02(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_ControlPanel_006_impl_UknFunc03() { return fntable_ControlPanel_006_instance->UknFunc03(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_ControlPanel_006_impl_UknFunc04() { return fntable_ControlPanel_006_instance->UknFunc04(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_ControlPanel_006_impl_UknFunc05() { return fntable_ControlPanel_006_instance->UknFunc05(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_ControlPanel_006_impl_UknFunc06() { return fntable_ControlPanel_006_instance->UknFunc06(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_ControlPanel_006_impl_UknFunc07() { return fntable_ControlPanel_006_instance->UknFunc07(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_ControlPanel_006_impl_UknFunc08() { return fntable_ControlPanel_006_instance->UknFunc08(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_ControlPanel_006_impl_UknFunc09() { return fntable_ControlPanel_006_instance->UknFunc09(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_ControlPanel_006_impl_UknFunc10() { return fntable_ControlPanel_006_instance->UknFunc10(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_ControlPanel_006_impl_UknFunc11() { return fntable_ControlPanel_006_instance->UknFunc11(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_ControlPanel_006_impl_UknFunc12() { return fntable_ControlPanel_006_instance->UknFunc12(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_ControlPanel_006_impl_UknFunc13() { return fntable_ControlPanel_006_instance->UknFunc13(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_ControlPanel_006_impl_UknFunc14() { return fntable_ControlPanel_006_instance->UknFunc14(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_ControlPanel_006_impl_SetDashBoardUserToggleEnabled(bool status) { return fntable_ControlPanel_006_instance->SetDashBoardUserToggleEnabled(status); }
static void OPENVR_FNTABLE_CALLTYPE fntable_ControlPanel_006_impl_UknFunc16() { return fntable_ControlPanel_006_instance->UknFunc16(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_ControlPanel_006_impl_UknFunc17() { return fntable_ControlPanel_006_instance->UknFunc17(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_ControlPanel_006_impl_UknFunc18() { return fntable_ControlPanel_006_instance->UknFunc18(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_ControlPanel_006_impl_UknFunc19() { return fntable_ControlPanel_006_instance->UknFunc19(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_ControlPanel_006_impl_UknFunc20() { return fntable_ControlPanel_006_instance->UknFunc20(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_ControlPanel_006_impl_UknFunc21() { return fntable_ControlPanel_006_instance->UknFunc21(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_ControlPanel_006_impl_UknFunc22() { return fntable_ControlPanel_006_instance->UknFunc22(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_ControlPanel_006_impl_UknFunc23() { return fntable_ControlPanel_006_instance->UknFunc23(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_ControlPanel_006_impl_UknFunc24() { return fntable_ControlPanel_006_instance->UknFunc24(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_ControlPanel_006_impl_UknFunc25() { return fntable_ControlPanel_006_instance->UknFunc25(); }
static vr::IVRControlPanel_006::EVR_ControlPanel_Error OPENVR_FNTABLE_CALLTYPE fntable_ControlPanel_006_impl_RegisterExternalWebRoot() { return fntable_ControlPanel_006_instance->RegisterExternalWebRoot(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_ControlPanel_006_impl_UknFunc27() { return fntable_ControlPanel_006_instance->UknFunc27(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_ControlPanel_006_impl_UknFunc28() { return fntable_ControlPanel_006_instance->UknFunc28(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_ControlPanel_006_impl_UknFunc29() { return fntable_ControlPanel_006_instance->UknFunc29(); }
static void *fntable_ControlPanel_006_funcs[] = {
	(void*) fntable_ControlPanel_006_impl_UknFunc00,
	(void*) fntable_ControlPanel_006_impl_UknFunc01,
	(void*) fntable_ControlPanel_006_impl_UknFunc02,
	(void*) fntable_ControlPanel_006_impl_UknFunc03,
	(void*) fntable_ControlPanel_006_impl_UknFunc04,
	(void*) fntable_ControlPanel_006_impl_UknFunc05,
	(void*) fntable_ControlPanel_006_impl_UknFunc06,
	(void*) fntable_ControlPanel_006_impl_UknFunc07,
	(void*) fntable_ControlPanel_006_impl_UknFunc08,
	(void*) fntable_ControlPanel_006_impl_UknFunc09,
	(void*) fntable_ControlPanel_006_impl_UknFunc10,
	(void*) fntable_ControlPanel_006_impl_UknFunc11,
	(void*) fntable_ControlPanel_006_impl_UknFunc12,
	(void*) fntable_ControlPanel_006_impl_UknFunc13,
	(void*) fntable_ControlPanel_006_impl_UknFunc14,
	(void*) fntable_ControlPanel_006_impl_SetDashBoardUserToggleEnabled,
	(void*) fntable_ControlPanel_006_impl_UknFunc16,
	(void*) fntable_ControlPanel_006_impl_UknFunc17,
	(void*) fntable_ControlPanel_006_impl_UknFunc18,
	(void*) fntable_ControlPanel_006_impl_UknFunc19,
	(void*) fntable_ControlPanel_006_impl_UknFunc20,
	(void*) fntable_ControlPanel_006_impl_UknFunc21,
	(void*) fntable_ControlPanel_006_impl_UknFunc22,
	(void*) fntable_ControlPanel_006_impl_UknFunc23,
	(void*) fntable_ControlPanel_006_impl_UknFunc24,
	(void*) fntable_ControlPanel_006_impl_UknFunc25,
	(void*) fntable_ControlPanel_006_impl_RegisterExternalWebRoot,
	(void*) fntable_ControlPanel_006_impl_UknFunc27,
	(void*) fntable_ControlPanel_006_impl_UknFunc28,
	(void*) fntable_ControlPanel_006_impl_UknFunc29,
};
void** CVRControlPanel_006::_GetStatFuncList() { fntable_ControlPanel_006_instance = this; return fntable_ControlPanel_006_funcs; }
void CVRControlPanel_006::Delete() { delete this; }
#include "GVRHeadsetView.gen.h"
// Single inst of BaseHeadsetView
static std::weak_ptr<BaseHeadsetView> _single_inst_HeadsetView;
static BaseHeadsetView *_single_inst_HeadsetView_unsafe = NULL;
std::shared_ptr<BaseHeadsetView> GetBaseHeadsetView() { return _single_inst_HeadsetView.lock(); };
BaseHeadsetView* GetUnsafeBaseHeadsetView() { return _single_inst_HeadsetView_unsafe; };
std::shared_ptr<BaseHeadsetView> GetCreateBaseHeadsetView() {
	std::shared_ptr<BaseHeadsetView> ret = _single_inst_HeadsetView.lock();
	if(!ret) {
		ret = std::shared_ptr<BaseHeadsetView>(new BaseHeadsetView(), [](BaseHeadsetView *obj){ _single_inst_HeadsetView_unsafe = NULL; delete obj; });
		_single_inst_HeadsetView = ret;
		_single_inst_HeadsetView_unsafe = ret.get();
	}
	return ret;
}
// Misc for CVRHeadsetView_001:
CVRHeadsetView_001::CVRHeadsetView_001() : base(GetCreateBaseHeadsetView()) {}
// Interface methods for CVRHeadsetView_001:
void CVRHeadsetView_001::SetHeadsetViewSize(uint32_t nWidth, uint32_t nHeight) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRHeadsetView_001)");
	return base->SetHeadsetViewSize(nWidth, nHeight);
}
void CVRHeadsetView_001::GetHeadsetViewSize(uint32_t* pnWidth, uint32_t* pnHeight) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRHeadsetView_001)");
	return base->GetHeadsetViewSize(pnWidth, pnHeight);
}
void CVRHeadsetView_001::SetHeadsetViewMode(vr::IVRHeadsetView_001::HeadsetViewMode_t eHeadsetViewMode) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRHeadsetView_001)");
	return base->SetHeadsetViewMode((OOVR_HeadsetViewMode_t) eHeadsetViewMode);
}
vr::IVRHeadsetView_001::HeadsetViewMode_t CVRHeadsetView_001::GetHeadsetViewMode() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRHeadsetView_001)");
	return (vr::IVRHeadsetView_001::HeadsetViewMode_t) base->GetHeadsetViewMode();
}
void CVRHeadsetView_001::SetHeadsetViewCropped(bool bCropped) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRHeadsetView_001)");
	return base->SetHeadsetViewCropped(bCropped);
}
bool CVRHeadsetView_001::GetHeadsetViewCropped() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRHeadsetView_001)");
	return base->GetHeadsetViewCropped();
}
float CVRHeadsetView_001::GetHeadsetViewAspectRatio() {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRHeadsetView_001)");
	return base->GetHeadsetViewAspectRatio();
}
void CVRHeadsetView_001::SetHeadsetViewBlendRange(float flStartPct, float flEndPct) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRHeadsetView_001)");
	return base->SetHeadsetViewBlendRange(flStartPct, flEndPct);
}
void CVRHeadsetView_001::GetHeadsetViewBlendRange(float* pStartPct, float* pEndPct) {
	if (oovr_global_configuration.LogAllOpenVRCalls())
		OOVR_LOG("Entered function (from interface vr::IVRHeadsetView_001)");
	return base->GetHeadsetViewBlendRange(pStartPct, pEndPct);
}
// FnTable for CVRHeadsetView_001:
static CVRHeadsetView_001 *fntable_HeadsetView_001_instance = NULL;
static void OPENVR_FNTABLE_CALLTYPE fntable_HeadsetView_001_impl_SetHeadsetViewSize(uint32_t nWidth, uint32_t nHeight) { return fntable_HeadsetView_001_instance->SetHeadsetViewSize(nWidth, nHeight); }
static void OPENVR_FNTABLE_CALLTYPE fntable_HeadsetView_001_impl_GetHeadsetViewSize(uint32_t* pnWidth, uint32_t* pnHeight) { return fntable_HeadsetView_001_instance->GetHeadsetViewSize(pnWidth, pnHeight); }
static void OPENVR_FNTABLE_CALLTYPE fntable_HeadsetView_001_impl_SetHeadsetViewMode(vr::IVRHeadsetView_001::HeadsetViewMode_t eHeadsetViewMode) { return fntable_HeadsetView_001_instance->SetHeadsetViewMode(eHeadsetViewMode); }
static vr::IVRHeadsetView_001::HeadsetViewMode_t OPENVR_FNTABLE_CALLTYPE fntable_HeadsetView_001_impl_GetHeadsetViewMode() { return fntable_HeadsetView_001_instance->GetHeadsetViewMode(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_HeadsetView_001_impl_SetHeadsetViewCropped(bool bCropped) { return fntable_HeadsetView_001_instance->SetHeadsetViewCropped(bCropped); }
static bool OPENVR_FNTABLE_CALLTYPE fntable_HeadsetView_001_impl_GetHeadsetViewCropped() { return fntable_HeadsetView_001_instance->GetHeadsetViewCropped(); }
static float OPENVR_FNTABLE_CALLTYPE fntable_HeadsetView_001_impl_GetHeadsetViewAspectRatio() { return fntable_HeadsetView_001_instance->GetHeadsetViewAspectRatio(); }
static void OPENVR_FNTABLE_CALLTYPE fntable_HeadsetView_001_impl_SetHeadsetViewBlendRange(float flStartPct, float flEndPct) { return fntable_HeadsetView_001_instance->SetHeadsetViewBlendRange(flStartPct, flEndPct); }
static void OPENVR_FNTABLE_CALLTYPE fntable_HeadsetView_001_impl_GetHeadsetViewBlendRange(float* pStartPct, float* pEndPct) { return fntable_HeadsetView_001_instance->GetHeadsetViewBlendRange(pStartPct, pEndPct); }
static void *fntable_HeadsetView_001_funcs[] = {
	(void*) fntable_HeadsetView_001_impl_SetHeadsetViewSize,
	(void*) fntable_HeadsetView_001_impl_GetHeadsetViewSize,
	(void*) fntable_HeadsetView_001_impl_SetHeadsetViewMode,
	(void*) fntable_HeadsetView_001_impl_GetHeadsetViewMode,
	(void*) fntable_HeadsetView_001_impl_SetHeadsetViewCropped,
	(void*) fntable_HeadsetView_001_impl_GetHeadsetViewCropped,
	(void*) fntable_HeadsetView_001_impl_GetHeadsetViewAspectRatio,
	(void*) fntable_HeadsetView_001_impl_SetHeadsetViewBlendRange,
	(void*) fntable_HeadsetView_001_impl_GetHeadsetViewBlendRange,
};
void** CVRHeadsetView_001::_GetStatFuncList() { fntable_HeadsetView_001_instance = this; return fntable_HeadsetView_001_funcs; }
void CVRHeadsetView_001::Delete() { delete this; }
// Get interface by name
void *CreateInterfaceByName(const char *name) {
	if(strcmp(vr::IVRCompositor_009::IVRCompositor_Version, name) == 0) return new CVRCompositor_009();
	if(strcmp(vr::IVRCompositor_012::IVRCompositor_Version, name) == 0) return new CVRCompositor_012();
	if(strcmp(vr::IVRCompositor_013::IVRCompositor_Version, name) == 0) return new CVRCompositor_013();
	if(strcmp(vr::IVRCompositor_014::IVRCompositor_Version, name) == 0) return new CVRCompositor_014();
	if(strcmp(vr::IVRCompositor_015::IVRCompositor_Version, name) == 0) return new CVRCompositor_015();
	if(strcmp(vr::IVRCompositor_016::IVRCompositor_Version, name) == 0) return new CVRCompositor_016();
	if(strcmp(vr::IVRCompositor_017::IVRCompositor_Version, name) == 0) return new CVRCompositor_017();
	if(strcmp(vr::IVRCompositor_018::IVRCompositor_Version, name) == 0) return new CVRCompositor_018();
	if(strcmp(vr::IVRCompositor_019::IVRCompositor_Version, name) == 0) return new CVRCompositor_019();
	if(strcmp(vr::IVRCompositor_020::IVRCompositor_Version, name) == 0) return new CVRCompositor_020();
	if(strcmp(vr::IVRCompositor_021::IVRCompositor_Version, name) == 0) return new CVRCompositor_021();
	if(strcmp(vr::IVRCompositor_022::IVRCompositor_Version, name) == 0) return new CVRCompositor_022();
	if(strcmp(vr::IVRCompositor_024::IVRCompositor_Version, name) == 0) return new CVRCompositor_024();
	if(strcmp(vr::IVRCompositor_026::IVRCompositor_Version, name) == 0) return new CVRCompositor_026();
	if(strcmp(vr::IVRCompositor_027::IVRCompositor_Version, name) == 0) return new CVRCompositor_027();
	if(strcmp(vr::IVRCompositor_028::IVRCompositor_Version, name) == 0) return new CVRCompositor_028();
	if(strcmp(vr::IVRSystem_009::IVRSystem_Version, name) == 0) return new CVRSystem_009();
	if(strcmp(vr::IVRSystem_011::IVRSystem_Version, name) == 0) return new CVRSystem_011();
	if(strcmp(vr::IVRSystem_012::IVRSystem_Version, name) == 0) return new CVRSystem_012();
	if(strcmp(vr::IVRSystem_014::IVRSystem_Version, name) == 0) return new CVRSystem_014();
	if(strcmp(vr::IVRSystem_015::IVRSystem_Version, name) == 0) return new CVRSystem_015();
	if(strcmp(vr::IVRSystem_016::IVRSystem_Version, name) == 0) return new CVRSystem_016();
	if(strcmp(vr::IVRSystem_017::IVRSystem_Version, name) == 0) return new CVRSystem_017();
	if(strcmp(vr::IVRSystem_019::IVRSystem_Version, name) == 0) return new CVRSystem_019();
	if(strcmp(vr::IVRSystem_020::IVRSystem_Version, name) == 0) return new CVRSystem_020();
	if(strcmp(vr::IVRSystem_021::IVRSystem_Version, name) == 0) return new CVRSystem_021();
	if(strcmp(vr::IVRSystem_022::IVRSystem_Version, name) == 0) return new CVRSystem_022();
	if(strcmp(vr::IVRChaperone_003::IVRChaperone_Version, name) == 0) return new CVRChaperone_003();
	if(strcmp(vr::IVRChaperone_004::IVRChaperone_Version, name) == 0) return new CVRChaperone_004();
	if(strcmp(vr::IVROverlay_007::IVROverlay_Version, name) == 0) return new CVROverlay_007();
	if(strcmp(vr::IVROverlay_010::IVROverlay_Version, name) == 0) return new CVROverlay_010();
	if(strcmp(vr::IVROverlay_011::IVROverlay_Version, name) == 0) return new CVROverlay_011();
	if(strcmp(vr::IVROverlay_013::IVROverlay_Version, name) == 0) return new CVROverlay_013();
	if(strcmp(vr::IVROverlay_014::IVROverlay_Version, name) == 0) return new CVROverlay_014();
	if(strcmp(vr::IVROverlay_016::IVROverlay_Version, name) == 0) return new CVROverlay_016();
	if(strcmp(vr::IVROverlay_017::IVROverlay_Version, name) == 0) return new CVROverlay_017();
	if(strcmp(vr::IVROverlay_018::IVROverlay_Version, name) == 0) return new CVROverlay_018();
	if(strcmp(vr::IVROverlay_019::IVROverlay_Version, name) == 0) return new CVROverlay_019();
	if(strcmp(vr::IVROverlay_020::IVROverlay_Version, name) == 0) return new CVROverlay_020();
	if(strcmp(vr::IVROverlay_021::IVROverlay_Version, name) == 0) return new CVROverlay_021();
	if(strcmp(vr::IVROverlay_022::IVROverlay_Version, name) == 0) return new CVROverlay_022();
	if(strcmp(vr::IVROverlay_024::IVROverlay_Version, name) == 0) return new CVROverlay_024();
	if(strcmp(vr::IVROverlay_025::IVROverlay_Version, name) == 0) return new CVROverlay_025();
	if(strcmp(vr::IVROverlay_026::IVROverlay_Version, name) == 0) return new CVROverlay_026();
	if(strcmp(vr::IVROverlay_027::IVROverlay_Version, name) == 0) return new CVROverlay_027();
	if(strcmp(vr::IVRChaperoneSetup_004::IVRChaperoneSetup_Version, name) == 0) return new CVRChaperoneSetup_004();
	if(strcmp(vr::IVRChaperoneSetup_005::IVRChaperoneSetup_Version, name) == 0) return new CVRChaperoneSetup_005();
	if(strcmp(vr::IVRChaperoneSetup_006::IVRChaperoneSetup_Version, name) == 0) return new CVRChaperoneSetup_006();
	if(strcmp(vr::IVRRenderModels_002::IVRRenderModels_Version, name) == 0) return new CVRRenderModels_002();
	if(strcmp(vr::IVRRenderModels_004::IVRRenderModels_Version, name) == 0) return new CVRRenderModels_004();
	if(strcmp(vr::IVRRenderModels_005::IVRRenderModels_Version, name) == 0) return new CVRRenderModels_005();
	if(strcmp(vr::IVRRenderModels_006::IVRRenderModels_Version, name) == 0) return new CVRRenderModels_006();
	if(strcmp(vr::IVRScreenshots_001::IVRScreenshots_Version, name) == 0) return new CVRScreenshots_001();
	if(strcmp(vr::IVRSettings_001::IVRSettings_Version, name) == 0) return new CVRSettings_001();
	if(strcmp(vr::IVRSettings_002::IVRSettings_Version, name) == 0) return new CVRSettings_002();
	if(strcmp(vr::IVRSettings_003::IVRSettings_Version, name) == 0) return new CVRSettings_003();
	if(strcmp(vr::IVRExtendedDisplay_001::IVRExtendedDisplay_Version, name) == 0) return new CVRExtendedDisplay_001();
	if(strcmp(vr::IVRApplications_002::IVRApplications_Version, name) == 0) return new CVRApplications_002();
	if(strcmp(vr::IVRApplications_004::IVRApplications_Version, name) == 0) return new CVRApplications_004();
	if(strcmp(vr::IVRApplications_005::IVRApplications_Version, name) == 0) return new CVRApplications_005();
	if(strcmp(vr::IVRApplications_006::IVRApplications_Version, name) == 0) return new CVRApplications_006();
	if(strcmp(vr::IVRApplications_007::IVRApplications_Version, name) == 0) return new CVRApplications_007();
	if(strcmp(vr::IVRInput_004::IVRInput_Version, name) == 0) return new CVRInput_004();
	if(strcmp(vr::IVRInput_005::IVRInput_Version, name) == 0) return new CVRInput_005();
	if(strcmp(vr::IVRInput_006::IVRInput_Version, name) == 0) return new CVRInput_006();
	if(strcmp(vr::IVRInput_007::IVRInput_Version, name) == 0) return new CVRInput_007();
	if(strcmp(vr::IVRInput_010::IVRInput_Version, name) == 0) return new CVRInput_010();
	if(strcmp(vr::IVRInputInternal_002::IVRInputInternal_Version, name) == 0) return new CVRInputInternal_002();
	if(strcmp(vr::IVRClientCore_003::IVRClientCore_Version, name) == 0) return new CVRClientCore_003();
	if(strcmp(vr::IVRClientCore_002::IVRClientCore_Version, name) == 0) return new CVRClientCore_002();
	if(strcmp(vr::IVROverlayView_003::IVROverlayView_Version, name) == 0) return new CVROverlayView_003();
	if(strcmp(vr::IVRMailbox_001::IVRMailbox_Version, name) == 0) return new CVRMailbox_001();
	if(strcmp(vr::IVRControlPanel_006::IVRControlPanel_Version, name) == 0) return new CVRControlPanel_006();
	if(strcmp(vr::IVRHeadsetView_001::IVRHeadsetView_Version, name) == 0) return new CVRHeadsetView_001();
	return NULL;
}
// Get flags by name
uint64_t GetInterfaceFlagsByName(const char *name, const char *flag, bool *success) {
	if(success) *success = true;
	if(strcmp(vr::IVRApplications_002::IVRApplications_Version, name) == 0) {
		if(strcmp("APPTYPE", flag) == 0) return (~(1ull << vr::VRApplication_Bootstrapper));
	}
	if(strcmp(vr::IVRApplications_004::IVRApplications_Version, name) == 0) {
		if(strcmp("APPTYPE", flag) == 0) return (~(1ull << vr::VRApplication_Bootstrapper));
	}
	if(strcmp(vr::IVRApplications_005::IVRApplications_Version, name) == 0) {
		if(strcmp("APPTYPE", flag) == 0) return (~(1ull << vr::VRApplication_Bootstrapper));
	}
	if(strcmp(vr::IVRApplications_006::IVRApplications_Version, name) == 0) {
		if(strcmp("APPTYPE", flag) == 0) return (~(1ull << vr::VRApplication_Bootstrapper));
	}
	if(strcmp(vr::IVRApplications_007::IVRApplications_Version, name) == 0) {
		if(strcmp("APPTYPE", flag) == 0) return (~(1ull << vr::VRApplication_Bootstrapper));
	}
	if(success) *success = false;
	return 0;
}
